C*PPDRIV -- PGPLOT PPM drivers
C+
      SUBROUTINE PPDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      INTEGER IFUNC, NBUF, LCHR, MODE
      REAL    RBUF(*)
      CHARACTER*(*) CHR
*
* PGPLOT driver for Portable Pixel Map (PPM) files with 'true color'
* capability.
*
* Supported device: PPM (P6) file format
*
* Device type codes: /PPM or /VPPM
*
* Default device name: pgplot.ppm.
*
* If you have more than one image to plot (i.e. use PGPAGE) with this
* device, subsequent pages will be named: pgplot2.ppm, pgplot3.ppm,
* etc, disrespective of the device name you specified.
* You can however bypass this by specifying a device name including a
* number sign (#), which will henceforth be replaced by the pagenumber.
* Example: page#.ppm will produce files page1.ppm, page2.ppm, etc.
*
* Default view surface dimensions are:
* - PPM  : 850 x 680 pixels 
* - VPPM : 680 x 850 pixels 
* Default width and height can be overriden by specifying environment
* variables
* PGPLOT_PPM_WIDTH  (default 850)
* PGPLOT_PPM_HEIGHT (default 680)
* The nominal scale is 85 pixels per inch.
*
* Color capability:
*   Indices 0 to 255 are supported. 
*   Default colors for indices 0 to 15 are implemented.
*   Color representation can be changed with PGSCR; color changes
*   affect subsequently drawn pixels only, not previously drawn
*   pixels. Thus the image is not limited to 256 different colors.
*
* Obtaining hardcopy: Use a PPM viewer or converter.
*=
*  9-Aug-1993 - Created by Remko Scharroo
*  6-Jul-1994 - Adapted to new PGPLOT version 4.9h
*  4-Aug-1994 - Use FASTIO.
*  9-Aug-1994 - New scheme for line plotting
* 16-Aug-1994 - Provide multi-image plotting.
* 16-Nov-1994 - Revised (T. Pearson).
* 28-Dec-1995 - Prevent concurrent access [TJP].
* 29-Apr-1996 - Use GRCTOI to decode environment variables [TJP].
*-----------------------------------------------------------------------
      CHARACTER*(*) LTYPE, PTYPE, DEFNAM
      INTEGER DWD, DHT
      PARAMETER (
     1 LTYPE= 'PPM   (Portable Pixel Map file, landscape orientation)',
     2 PTYPE= 'VPPM  (Portable Pixel Map file, portrait orientation)')
      PARAMETER (DEFNAM='pgplot.ppm')
      PARAMETER (DWD=850, DHT=680)

      REAL XRES, YRES
      PARAMETER (XRES=85., YRES=XRES)
C
      INTEGER UNIT, IC, CVAL, CTABLE(3,0:255), IER, I, L, LL, NPICT
      INTEGER BX, BY, IX0, IY0, IX1, IY1, R, G, B, STATE, USERH, USERW
      INTEGER CDEFLT(3,0:15), JUNK
      INTEGER GRGMEM, GRFMEM, GROFIL, GRCFIL, GRCTOI
      CHARACTER*80 MSG, INSTR, FILENM
C
C Note: for 64-bit operating systems, change the following 
C declaration to INTEGER*8:
C
      INTEGER*8 PIXMAP
C
      SAVE    UNIT, IC, CVAL, CTABLE, BX, BY, PIXMAP, NPICT, CDEFLT
      SAVE    STATE
      DATA CDEFLT /000,000,000, 255,255,255, 255,000,000, 000,255,000,
     1             000,000,255, 000,255,255, 255,000,255, 255,255,000,
     2             255,128,000, 128,255,000, 000,255,128, 000,128,255,
     3             128,000,255, 255,000,128, 085,085,085, 170,170,170/
      DATA    STATE /0/
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260,270,280,290), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in PPM device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 IF (MODE.EQ.1) THEN
         CHR = LTYPE
         LCHR = LEN(LTYPE)
      ELSE IF (MODE.EQ.2) THEN
         CHR = PTYPE
         LCHR = LEN(PTYPE)
      ELSE
         CALL GRWARN('Requested MODE not implemented in PPM driver')
      ENDIF
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = -1 
      RBUF(3) = 0
      RBUF(4) = -1 
      RBUF(5) = 0
      RBUF(6) = 255
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = XRES
      RBUF(2) = YRES 
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, supports rectangle fill, pixel 
C     primitives, and query color rep.)
C
   40 CHR = 'HNNNNRPNYN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = BX-1 
      RBUF(3) = 0
      RBUF(4) = BY-1 
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C     -- check for concurrent access
      IF (STATE.EQ.1) THEN
         CALL GRWARN('a PGPLOT PPM file is already open')
         RBUF(1) = 0
         RBUF(2) = 0
         RETURN
      END IF
C     -- dimensions of plot buffer
      USERW = 0
      USERH = 0
      CALL GRGENV('PPM_WIDTH', INSTR, L)
      LL = 1
      IF (L.GT.0) USERW = GRCTOI(INSTR(:L),LL)
      CALL GRGENV('PPM_HEIGHT', INSTR, L)
      LL = 1
      IF (L.GT.0) USERH = GRCTOI(INSTR(:L),LL)
      IF (MODE.EQ.1) THEN
*     -- Landscape
         BX = DWD
         IF (USERW.GE.8) BX = USERW
         BY = DHT
         IF (USERH.GE.8) BY = USERH
      ELSE
*     -- Portrait
         BX = DHT
         IF (USERH.GE.8) BX = USERH
         BY = DWD
         IF (USERW.GE.8) BY = USERW
      END IF
      NPICT=1
*     -- Initialize color table
      DO 95 I=0,15
         CTABLE(1,I) = CDEFLT(1,I)
         CTABLE(2,I) = CDEFLT(2,I)
         CTABLE(3,I) = CDEFLT(3,I)
 95   CONTINUE
      DO 96 I=16,255
         CTABLE(1,I) = 128
         CTABLE(2,I) = 128
         CTABLE(3,I) = 128
 96   CONTINUE       
*
      FILENM = CHR(:LCHR)
      CALL GRPP10 (FILENM, NPICT, MSG)
      UNIT = GROFIL (MSG)
      RBUF(1) = UNIT
      IF (UNIT.LT.0) THEN
          CALL GRWARN('Cannot open output file for PPM plot')
          RBUF(2) = 0
      ELSE
          RBUF(2) = 1
          STATE = 1
      END IF
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      STATE = 0
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
      BX = NINT(RBUF(1))+1
      BY = NINT(RBUF(2))+1
C     -- allocate buffer with 4 bytes per pixel
      IER = GRGMEM(4*BX*BY, PIXMAP)
      IF (IER.NE.1) THEN
         CALL GRGMSG(IER)
         CALL GRWARN('Failed to allocate plot buffer.')
         BX = 0
         BY = 0
         PIXMAP = 0
      END IF
C     -- initialize to zero (background color)
      IF (PIXMAP.NE.0) 
     :     CALL GRPP03(1, 1, BX, BY, 0, BX, BY, %VAL(PIXMAP))
C     -- open new file if necessary
      IF (NPICT.GT.1) THEN
          CALL GRPP10 (FILENM, NPICT, MSG)
          UNIT = GROFIL (MSG)
          IF (UNIT.LT.0) 
     :        CALL GRWARN('Cannot open output file for PPM plot')
C         -- no way to return error status!
      END IF
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      IX0=NINT(RBUF(1))+1
      IX1=NINT(RBUF(3))+1
      IY0=BY-NINT(RBUF(2))
      IY1=BY-NINT(RBUF(4))
      IF (PIXMAP.NE.0) 
     :     CALL GRPP01(IX0, IY0, IX1, IY1, CVAL, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      IX0=NINT(RBUF(1))+1
      IY0=BY-NINT(RBUF(2))
      IF (PIXMAP.NE.0) 
     :     CALL GRPP01(IX0, IY0, IX0, IY0, CVAL, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      IF (PIXMAP.NE.0) THEN
         CALL GRPP02(UNIT, BX, BY, %VAL(PIXMAP))
         IF (UNIT.GE.0) JUNK = GRCFIL(UNIT)
         NPICT = NPICT+1
         IER = GRFMEM(4*BX*BY, PIXMAP)
         IF (IER.NE.1) THEN
            CALL GRGMSG(IER)
            CALL GRWARN('Failed to deallocate plot buffer.')
         END IF
      END IF
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = NINT(RBUF(1))
      IF (IC.LT.0 .OR. IC.GT.255) IC = 1
      R = CTABLE(1,IC)
      G = CTABLE(2,IC)
      B = CTABLE(3,IC)
      CVAL = R + 256*(G + 256*B)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Not used.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      I = NINT(RBUF(1))
      IF (I.GE.0 .AND. I.LE.255) THEN
         CTABLE(1, I) = NINT(RBUF(2)*255)
         CTABLE(2, I) = NINT(RBUF(3)*255)
         CTABLE(3, I) = NINT(RBUF(4)*255)
      END IF
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle fill ------------------------------------------
C
  240 CONTINUE
      IX0=NINT(RBUF(1))+1
      IX1=NINT(RBUF(3))+1
      IY1=BY-NINT(RBUF(2))
      IY0=BY-NINT(RBUF(4))
      IF (PIXMAP.NE.0) 
     :     CALL GRPP03(IX0, IY0, IX1, IY1, CVAL, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=25, Not implemented -----------------------------------------
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels ------------------------------------------
C
  260 CONTINUE
      IF (PIXMAP.NE.0)
     :     CALL GRPP04(NBUF, RBUF, BX, BY, %VAL(PIXMAP), CTABLE)
      RETURN
C
C--- IFUNC=27, Not implemented -----------------------------------------
C
  270 CONTINUE
      RETURN
C
C--- IFUNC=28, Not implemented -----------------------------------------
C
  280 CONTINUE
      RETURN
C
C--- IFUNC=29, Query color representation. -----------------------------
C
  290 CONTINUE
      I = RBUF(1)
      RBUF(2) = CTABLE(1,I)/255.0
      RBUF(3) = CTABLE(2,I)/255.0
      RBUF(4) = CTABLE(3,I)/255.0
      NBUF = 4
      RETURN
C-----------------------------------------------------------------------
      END

**GRPP01 -- PGPLOT PPM driver, draw line
*+
      SUBROUTINE GRPP01 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY, PIXMAP(BX,BY)
*
* Draw a straight-line segment from absolute pixel coordinates
* (IX0, IY0) to (IX1, IY1).
*
* Arguments:
*  IX0, IY0        (input): Starting point of line.
*  IX1, IY1        (input): End point of line.
*  ICOL            (input): Color value.
*  BX, BY          (input): dimensions of PIXMAP.
*  PIXMAP   (input/output): The image data buffer.
*-
*  9-Aug-1994 - Recreated by Remko Scharroo from GRGI01 by Ge van Geldorp
*               Improved algorithm.
*-----------------------------------------------------------------------
      INTEGER IX, IY, IS
      REAL    D
C
      IF (IX0.EQ.IX1 .AND. IY0.EQ.IY1) THEN
         PIXMAP(IX0,IY0)=ICOL
      ELSE IF (ABS(IY1-IY0).GT.ABS(IX1-IX0)) THEN
         D=(IX1-IX0)/REAL(IY1-IY0)
         IS=1
         IF (IY1.LT.IY0) IS=-1
         DO 10 IY=IY0,IY1,IS
            IX=NINT(IX0+(IY-IY0)*D)
            PIXMAP(IX,IY)=ICOL
 10      CONTINUE
      ELSE
         D=(IY1-IY0)/REAL(IX1-IX0)
         IS=1
         IF (IX1.LT.IX0) IS=-1
         DO 20 IX=IX0,IX1,IS
            IY=NINT(IY0+(IX-IX0)*D)
            PIXMAP(IX,IY)=ICOL
 20      CONTINUE
      ENDIF
      END

**GRPP02 -- PGPLOT PPM driver, write PPM image
*+
      SUBROUTINE GRPP02 (UNIT, BX, BY, PIXMAP)
      INTEGER UNIT, BX, BY, PIXMAP(*)
*
* This routine copies the image buffer to an output buffer. A PPM image
* header and the output buffer are written to UNIT.
*
* Arguments:
*  UNIT    (input): Output unit
*  BX, BY  (input): Image size
*  PIXMAP  (input): Image data
*-
* 10-Aug-1993 - Created by Remko Scharroo
* 16-Nov-1994 - Rewritten by T. Pearson
*-----------------------------------------------------------------------
*       BUFSIZ must be a multiple of 3 (and not larger than 500 for
*       portability to AIX)
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=498)
      INTEGER I, N, IER, IBUF, L1, L2
      INTEGER GRTRIM, GRWFCH
      CHARACTER*128 HEAD
      CHARACTER*20 USER
      CHARACTER*20 TODAY
      CHARACTER*(BUFSIZ) BUF
      LOGICAL BAD
*
*     Write the header (magic number = P6)
*
      CALL GRUSER(USER,L1)
      CALL GRDATE(TODAY,L2)
      WRITE (HEAD, 1000) USER(:L1), TODAY(:L2),CHAR(10),
     :                   BX, BY, CHAR(10), 255, CHAR(10)
 1000 FORMAT ('P6 # PGPLOT PPM image ',A,1X,A,A1, I5,1X,I5,A1, I3,A1)
      N = GRTRIM(HEAD)
      IER = GRWFCH(UNIT, HEAD(1:N))
      IF (IER.NE.N) CALL GRWARN('Failed writing PPM header')
*
*     Write the pixel data as R,G,B components
*
      N=BX*BY
      IBUF=0
      BAD = .FALSE.
      DO 10 I=1,N
         BUF(IBUF+1:IBUF+1) = CHAR(MOD(PIXMAP(I),256))
         BUF(IBUF+2:IBUF+2) = CHAR(MOD(PIXMAP(I)/256,256))
         BUF(IBUF+3:IBUF+3) = CHAR(PIXMAP(I)/(256*256))
         IBUF = IBUF+3
         IF (IBUF.GE.BUFSIZ) THEN
            IER = GRWFCH(UNIT, BUF)
            IF (IER.NE.IBUF) BAD = .TRUE.
            IBUF = 0
         END IF
 10   CONTINUE
      IF (IBUF.GT.0) THEN
         IER = GRWFCH(UNIT, BUF(:IBUF))
         IF (IER.NE.IBUF) BAD = .TRUE.
         IBUF = 0
      END IF
      IF (BAD) CALL GRWARN('Failed writing PPM data')
      END

**GRPP03 -- PGPLOT PPM driver, fill rectangle
*+
      SUBROUTINE GRPP03 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY, PIXMAP(BX,BY)
*
* Arguments:
*  IX0, IY0        (input): Lower left corner.
*  IX1, IY1        (input): Upper right corner.
*  ICOL            (input): Color value.
*  BX, BY          (input): dimensions of PIXMAP.
*  PIXMAP   (input/output): The image data buffer.
*-----------------------------------------------------------------------
      INTEGER IX, IY
C
      DO 20 IY=IY0,IY1
         DO 10 IX=IX0,IX1
            PIXMAP(IX,IY) = ICOL
 10      CONTINUE
 20   CONTINUE
      END

**GRPP04 -- PGPLOT PPM driver, fill image line
*+
      SUBROUTINE GRPP04(NBUF,RBUF,BX,BY,PIXMAP,CTABLE)
      INTEGER I,J,NBUF,BX,BY,N,IC
      REAL RBUF(NBUF)
      INTEGER PIXMAP(BX,BY)
      INTEGER CTABLE(3,0:255)
      INTEGER R, G, B
*-
      I = NINT(RBUF(1))+1
      J = BY-NINT(RBUF(2))
      DO 10 N=3,NBUF
         IC=RBUF(N)
         R = CTABLE(1,IC)
         G = CTABLE(2,IC)
         B = CTABLE(3,IC)
         PIXMAP(I+N-3,J) = R + 256*(G + 256*B)
 10   CONTINUE
      END

**GRPP10 -- Replace # in filename by picture number
*
      SUBROUTINE GRPP10 (NAME1, NP, NAME2)
      CHARACTER*(*) NAME1
      CHARACTER*(*) NAME2
      CHARACTER*80  TMP
      INTEGER GRTRIM
      INTEGER NP, IDX, L, LN

      LN = GRTRIM(NAME1)
      IDX = INDEX(NAME1,'#')
      IF (IDX.GT.0) THEN
C        -- if the supplied name contains a #-character, replace
C           it with the page number
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE IF (NP.EQ.1) THEN
C        -- if this is the first page, use the supplied name
         NAME2 = NAME1
         RETURN
      ELSE IF (LN+2.LE.LEN(NAME1)) THEN
C        -- append an underscore and the page number to the supplied
C           name
         NAME1(LN+1:LN+2) = '_#'
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE
C        -- last resort: invent a new name
         CALL GRFAO('pgplot#.ppm', L, TMP, NP, 0, 0, 0)
      END IF
      CALL GRWARN ('Writing new PPM image as: '//TMP(:L))
      NAME2 = TMP(:L)
      END

C*GIDRIV -- PGPLOT GIF drivers
C+
      SUBROUTINE GIDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      INTEGER IFUNC, NBUF, LCHR, MODE
      REAL    RBUF(*)
      CHARACTER*(*) CHR
*
* PGPLOT driver for Graphics Interchange Format (GIF) files.
*
************************************************************************
*                           CAUTION                                    *
*                                                                      *
* The GIF specification incorporates the Lempel-Zev-Welch (LZW)        *
* compression technology which is the subject of a patent awarded to   *
* Unisys. Use of this technology, and in particular creation of GIF    *
* format files using this PGPLOT device driver, may require a license  *
* from Unisys.                                                         *
************************************************************************
*
* Supported device: GIF87a file format
*
* Device type codes: /GIF or /VGIF
*
* Default device name: pgplot.gif.
*
* If you have more than one image to plot (i.e. use PGPAGE) with this
* device, subsequent pages will be named: pgplot2.gif, pgplot3.gif,
* etc, disrespective of the device name you specified.
* You can however bypass this by specifying a device name including a
* number sign (#), which will henceforth be replaced by the pagenumber.
* Example: page#.gif will produce files page1.gif, page2.gif, ...,
* page234.gif, etc.
*
* Default view surface dimensions are:
* - GIF  : 850 x 680 pixels (translates to 10.0 x  8.0 inch).
* - VGIF : 680 x 850 pixels (translates to  8.0 x 10.0 inch).
* with an assumed scale of 85 pixels/inch.
* Default width and height can be overridden by specifying environment
* variables
* PGPLOT_GIF_WIDTH  (default 850)
* PGPLOT_GIF_HEIGHT (default 680)
*
* Color capability:
* Indices 0 to 255 are supported. Each of these indices can be assigned
* one color. Default colors for indices 0 to 15 are implemented.
*
* Obtaining hardcopy: Use a GIF viewer or converter.
*=
*  1-Aug-1994 - Created by Remko Scharroo
*  9-Aug-1994 - New scheme for line plotting
* 16-Aug-1994 - Provide multi-image plotting.
*  8-Sep-1994 - Add opcode 29 [TJP].
*  5-Nov-1994 - Adjust size of bitmap if necessary [TJP].
* 18-Jan-1995 - Attempt to prevent integer overflow on systems where
*               BYTE is signed [TJP].
* 28-Dec-1995 - prevent concurrent access [TJP].
* 29-Apr-1996 - use GRCTOI to decode environment variables [TJP].
*  2-Sep-1997 - correct a byte overflow problem
*-----------------------------------------------------------------------
      CHARACTER*(*) LTYPE, PTYPE, DEFNAM
      INTEGER DWD, DHT, BX, BY
      PARAMETER (LTYPE=
     1'GIF   (Graphics Interchange Format file, landscape orientation)',
     2 PTYPE=
     3'VGIF  (Graphics Interchange Format file, portrait orientation)')
      PARAMETER (DEFNAM='pgplot.gif')
      PARAMETER (DWD=850, DHT=680)

      REAL XRES, YRES
      PARAMETER (XRES=85., YRES=XRES)
C
      INTEGER UNIT, IC, NPICT, MAXIDX, STATE
      INTEGER CTABLE(3,0:255), CDEFLT(3,0:15)
      INTEGER IER, I, L, LL, IX0, IY0, IX1, IY1, USERW, USERH, JUNK
      INTEGER GRGMEM, GRFMEM, GROFIL, GRCFIL, GRCTOI
      CHARACTER*80 MSG, INSTR, FILENM
C
C Note: for 64-bit operating systems, change the following 
C declaration to INTEGER*8:
C
      INTEGER*8 PIXMAP, WORK
C
      SAVE UNIT, IC, CTABLE, NPICT, MAXIDX, BX, BY, PIXMAP, FILENM
      SAVE CDEFLT, STATE
      DATA CDEFLT /000,000,000, 255,255,255, 255,000,000, 000,255,000,
     1             000,000,255, 000,255,255, 255,000,255, 255,255,000,
     2             255,128,000, 128,255,000, 000,255,128, 000,128,255,
     3             128,000,255, 255,000,128, 085,085,085, 170,170,170/
      DATA STATE /0/
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260,270,280,290), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in GIF device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 IF (MODE.EQ.1) THEN
         CHR = LTYPE
         LCHR = LEN(LTYPE)
      ELSE IF (MODE.EQ.2) THEN
         CHR = PTYPE
         LCHR = LEN(PTYPE)
      ELSE
         CALL GRWARN('Requested MODE not implemented in GIF driver')
      END IF
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C     (Maximum size is set by GIF format to 2**16 pixels)
   20 RBUF(1) = 0
      RBUF(2) = 65536 
      RBUF(3) = 0
      RBUF(4) = 65536
      RBUF(5) = 0
      RBUF(6) = 255
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = XRES
      RBUF(2) = YRES 
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, supports rectangle fill, pixel 
C     primitives, and query color rep.)
C
   40 CHR = 'HNNNNRPNYN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = BX-1 
      RBUF(3) = 0
      RBUF(4) = BY-1
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C     -- check for concurrent access
      IF (STATE.EQ.1) THEN
         CALL GRWARN('a PGPLOT GIF file is already open')
         RBUF(1) = 0
         RBUF(2) = 0
         RETURN
      END IF
C     -- dimensions of plot buffer
      USERW = 0
      USERH = 0
      CALL GRGENV('GIF_WIDTH', INSTR, L)
      LL = 1
      IF (L.GT.0) USERW = GRCTOI(INSTR(:L),LL)
      CALL GRGENV('GIF_HEIGHT', INSTR, L)
      LL = 1
      IF (L.GT.0) USERH = GRCTOI(INSTR(:L),LL)
      IF (MODE.EQ.1) THEN
*     -- Landscape
         BX = DWD
         IF (USERW.GE.8) BX = USERW
         BY = DHT
         IF (USERH.GE.8) BY = USERH
      ELSE
*     -- Portrait
         BX = DHT
         IF (USERH.GE.8) BX = USERH
         BY = DWD
         IF (USERW.GE.8) BY = USERW
      END IF
      NPICT=1
      MAXIDX=0
*     -- Initialize color table
      DO 95 I=0,15
         CTABLE(1,I) = CDEFLT(1,I)
         CTABLE(2,I) = CDEFLT(2,I)
         CTABLE(3,I) = CDEFLT(3,I)
 95   CONTINUE
      DO 96 I=16,255
         CTABLE(1,I) = 128
         CTABLE(2,I) = 128
         CTABLE(3,I) = 128
 96   CONTINUE       
*
      FILENM = CHR(:LCHR)
      CALL GRGI10 (FILENM, NPICT, MSG)
      UNIT = GROFIL (MSG)
      RBUF(1) = UNIT
      IF (UNIT.LT.0) THEN
         CALL GRWARN('Cannot open output file for GIF plot')
         RBUF(2) = 0
      ELSE
         RBUF(2) = 1
         STATE = 1
      END IF
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      STATE = 0
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
      BX = NINT(RBUF(1))+1
      BY = NINT(RBUF(2))+1
      IER = GRGMEM(BX*BY, PIXMAP)
      IF (IER.NE.1) THEN
         CALL GRGMSG(IER)
         CALL GRWARN('Failed to allocate plot buffer.')
         BX = 0
         BY = 0
         PIXMAP = 0
      END IF
C     -- initialize to zero (background color)
      IF (PIXMAP.NE.0) 
     :     CALL GRGI03(1, 1, BX, BY, 0, BX, BY, %VAL(PIXMAP))
      IF (NPICT.GT.1) THEN
         CALL GRGI10 (FILENM, NPICT, MSG)
         UNIT = GROFIL(MSG)
         IF (UNIT.LT.0) THEN
            CALL GRWARN('Cannot open output file for GIF plot')
         END IF
      END IF
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      IX0=NINT(RBUF(1))+1
      IX1=NINT(RBUF(3))+1
      IY0=BY-NINT(RBUF(2))
      IY1=BY-NINT(RBUF(4))
      IF (PIXMAP.NE.0)
     :     CALL GRGI01(IX0, IY0, IX1, IY1, IC, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      IX0=NINT(RBUF(1))+1
      IY0=BY-NINT(RBUF(2))
      IF (PIXMAP.NE.0)
     :     CALL GRGI01(IX0, IY0, IX0, IY0, IC, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      IF (UNIT.GE.0) THEN
         IER = GRGMEM(2*256*4098, WORK)
         IF (IER.NE.1) THEN
            CALL GRGMSG(IER)
            CALL GRWARN('Failed to allocate work array.')
         ELSE
            CALL GRGI06(UNIT, BX, BY, CTABLE, %VAL(PIXMAP), MAXIDX,
     :                  %VAL(WORK))
         END IF
         JUNK = GRCFIL(UNIT)
         IER = GRFMEM(2*256*4098, WORK)
      END IF
      NPICT = NPICT+1
      IER = GRFMEM(BX*BY, PIXMAP)
      IF (IER.NE.1) THEN
         CALL GRGMSG(IER)
         CALL GRWARN('Failed to deallocate plot buffer.')
      END IF
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      MAXIDX = MAX(MAXIDX, IC)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Not used.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      I = RBUF(1)
      CTABLE(1, I) = NINT(RBUF(2)*255)
      CTABLE(2, I) = NINT(RBUF(3)*255)
      CTABLE(3, I) = NINT(RBUF(4)*255)
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle fill ------------------------------------------
C
  240 CONTINUE
      IX0=NINT(RBUF(1))+1
      IX1=NINT(RBUF(3))+1
      IY1=BY-NINT(RBUF(2))
      IY0=BY-NINT(RBUF(4))
      IF (PIXMAP.NE.0) 
     :     CALL GRGI03(IX0, IY0, IX1, IY1, IC, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=25, Not implemented -----------------------------------------
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels ------------------------------------------
C
  260 CONTINUE
      CALL GRGI04(NBUF, RBUF, BX, BY, %VAL(PIXMAP), MAXIDX)
      RETURN
C
C--- IFUNC=27, Not implemented -----------------------------------------
C
  270 CONTINUE
      RETURN
C
C--- IFUNC=28, Not implemented -----------------------------------------
C
  280 CONTINUE
      RETURN
C
C--- IFUNC=29, Query color representation. -----------------------------
C
  290 CONTINUE
      I = RBUF(1)
      RBUF(2) = CTABLE(1,I)/255.0
      RBUF(3) = CTABLE(2,I)/255.0
      RBUF(4) = CTABLE(3,I)/255.0
      NBUF = 4
      RETURN
C-----------------------------------------------------------------------
      END

**GRGI01 -- PGPLOT GIF driver, draw line
*+
      SUBROUTINE GRGI01 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY
      BYTE PIXMAP(BX,BY)
*
* Draw a straight-line segment from absolute pixel coordinates
* (IX0, IY0) to (IX1, IY1).
*
* Arguments:
*  ICOL            (input): Color index
*  PIXMAP   (input/output): The image data buffer.
*-----------------------------------------------------------------------
      INTEGER IX, IY, IS
      REAL    D
      BYTE    VAL
*
      IF (ICOL.GT.127) THEN
         VAL = ICOL-256
      ELSE
         VAL = ICOL
      END IF
      IF (IX0.EQ.IX1 .AND. IY0.EQ.IY1) THEN
         PIXMAP(IX0,IY0)=VAL
      ELSE IF (ABS(IY1-IY0).GT.ABS(IX1-IX0)) THEN
         D=(IX1-IX0)/REAL(IY1-IY0)
         IS=1
         IF (IY1.LT.IY0) IS=-1
         DO 10 IY=IY0,IY1,IS
            IX=NINT(IX0+(IY-IY0)*D)
            PIXMAP(IX,IY)=VAL
 10      CONTINUE
      ELSE
         D=(IY1-IY0)/REAL(IX1-IX0)
         IS=1
         IF (IX1.LT.IX0) IS=-1
         DO 20 IX=IX0,IX1,IS
            IY=NINT(IY0+(IX-IX0)*D)
            PIXMAP(IX,IY)=VAL
 20      CONTINUE
      END IF
      END

**GRGI03 -- PGPLOT GIF driver, fill rectangle
*+
      SUBROUTINE GRGI03 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY
      BYTE PIXMAP(BX,BY)
*
* Arguments:
*  IX0, IY0        (input): Lower left corner.
*  IX1, IY1        (input): Upper right corner.
*  ICOL            (input): Color value.
*  BX, BY          (input): dimensions of PIXMAP.
*  PIXMAP   (input/output): The image data buffer.
*-----------------------------------------------------------------------
      INTEGER IX, IY
      BYTE VAL
C
      IF (ICOL.GT.127) THEN
         VAL = ICOL-256
      ELSE
         VAL = ICOL
      END IF
      DO 20 IY=IY0,IY1
         DO 10 IX=IX0,IX1
            PIXMAP(IX,IY) = VAL
 10      CONTINUE
 20   CONTINUE
      END

**GRGI04 -- PGPLOT GIF driver, fill image line
*+
      SUBROUTINE GRGI04(NBUF,RBUF,BX,BY,PIXMAP,MAXIDX)
      INTEGER I,J,NBUF,BX,BY,N,IC,MAXIDX
      REAL RBUF(NBUF)
      BYTE PIXMAP(BX,BY)
*-
      I = NINT(RBUF(1))+1
      J = BY-NINT(RBUF(2))
      DO 10 N=3,NBUF
         IC=RBUF(N)
         MAXIDX=MAX(MAXIDX,IC)
         IF (IC.GT.127) IC = IC-256
         PIXMAP(I+N-3,J)=IC
 10   CONTINUE
      END

**GRGI06 -- PGPLOT GIF driver, write GIF image
*+
      SUBROUTINE GRGI06 (UNIT, BX, BY, CTABLE, PIXMAP, MAXIDX, CODE)
      INTEGER UNIT, BX, BY, MAXIDX
      INTEGER CTABLE(3,0:255)
      BYTE PIXMAP(BX * BY)
      INTEGER*2 CODE(0:4097,0:255)
*
* Write GIF image to UNIT.
*
* Arguments:
* UNIT   (input): Output unit
* BX,BY  (input): `Screen' size
* CTABLE  (input): Color map
* PIXMAP (input): Image data
* MAXIDX (input): maximum color index used.
*--
* 16-Nov-94: fixed bug (BYTE is signed)
*-----------------------------------------------------------------------
      CHARACTER GIF1*6, GIF2*7, GIF3*3, GIF4*10
      CHARACTER*2 GRGI09
      INTEGER BMAX, BMULT, BREST, BOUT
      INTEGER PIXEL, I, J, K, M, CLEAR, EOI, TABLE, IN, TOTAL, PRE, EXT
      INTEGER OLDPRE, BITS
      INTEGER GRWFCH, GRWFIL
      BYTE BLKOUT(0:254)
      COMMON /GRGICO/ BMAX, BMULT, BREST, BOUT, BLKOUT

      BITS = 1
 10   IF (MAXIDX .LT. 2**BITS) GOTO 20
      BITS = BITS + 1
      GOTO 10
 20   CONTINUE
*
* Write Header.
*
      GIF1 = 'GIF87a'
      I = GRWFCH(UNIT, GIF1)
      IF (I.NE.6) CALL GRWARN ('Error writing GIF header')
*
* Write Logical Screen Descriptor (screen width, screen height,
* color data, background color index [0], pixel aspect ratio [0]).
*
      GIF2(1:2) = GRGI09(BX)
      GIF2(3:4) = GRGI09(BY)
      GIF2(5:5) = CHAR(128 + 17 * (BITS - 1))
      GIF2(6:6) = CHAR(0)
      GIF2(7:7) = CHAR(0)
      I = GRWFCH(UNIT, GIF2)
*
* Write Global Color Table.
*
      DO 30 J=0,2**BITS-1
         GIF3(1:1) = CHAR(CTABLE(1,J))
         GIF3(2:2) = CHAR(CTABLE(2,J))
         GIF3(3:3) = CHAR(CTABLE(3,J))
         I = GRWFCH(UNIT, GIF3)
 30   CONTINUE
*
      PIXEL = MAX(BITS, 2)
*
* Write Image Descriptor.
*
      GIF4(1:1) = ','
      GIF4(2:3) = GRGI09(0)
      GIF4(4:5) = GRGI09(0)
      GIF4(6:7) = GRGI09(BX)
      GIF4(8:9) = GRGI09(BY)
      GIF4(10:10) = CHAR(0)
      I = GRWFCH(UNIT, GIF4)
*
* Write Table Based Image Data, in sub-blocks of up to 255 bytes.
*
      I = GRWFCH(UNIT, CHAR(PIXEL))
C
C LZW-compression; initialize counters; define clear code and EOI code.
C Start packing variable-size codes into 8-bit bytes.
C Push a clear code first.
C `Read' first character.
C
      DO 100 M=0,255
         DO 100 K=0,4095
  100       CODE(K,M)=0
      CLEAR=2**PIXEL
      EOI=CLEAR + 1
      BREST=0
      BOUT=0
      BMULT=1
      BMAX=CLEAR*2
      CALL GRGI07(UNIT, CLEAR)
      IN=1
      TOTAL=BX*BY
      PRE=PIXMAP(IN)
      IF (PRE.LT.0) PRE = PRE+256
*
* Start new data stream at line 310:
* 2**n-1  (n+1)-bit codes
* 2*2**n  (n+2)-bit codes
* 4*2**n  (n+3)-bit codes
*    .         .      .
*   1024     11-bit codes
*   2048     12-bit codes (incl. one clear code)
*
  310 TABLE=EOI
      BMAX=CLEAR*2
*
* `Read' next character; check if combination prefix&extension occurred earlier
*
  320 IF (IN.GE.TOTAL) GOTO 350
      IN=IN+1
      EXT=PIXMAP(IN)
      IF (EXT.LT.0) EXT = EXT+256
      OLDPRE=PRE
      PRE=CODE(PRE,EXT)
      IF (PRE.GT.0) GOTO 320
*
* If no earlier occurrence add combination to table
*
      TABLE=TABLE+1
      CALL GRGI07(UNIT, OLDPRE)
      CODE(OLDPRE,EXT)=TABLE
      PRE=EXT
      IF (TABLE.EQ.BMAX) BMAX=BMAX*2
      IF (TABLE.LT.4095) GOTO 320
      CALL GRGI07(UNIT, CLEAR)
      DO 330 M=0,255
         DO 330 K=0,4095
  330       CODE(K,M)=0
      GOTO 310
*
* Last character
*
  350 CALL GRGI07(UNIT, PRE)
      CALL GRGI07(UNIT, EOI)
      IF (BMULT.GT.1) CALL GRGI08(UNIT, BREST)
      IF (BOUT.GT.0) THEN
         IF (BOUT.GT.127) THEN
            BLKOUT(0) = BOUT-256
         ELSE
            BLKOUT(0) = BOUT
         END IF
         I = GRWFIL (UNIT, BOUT+1, BLKOUT(0))
         BOUT = 0
      END IF
      BLKOUT(0) = 0
      I = GRWFIL (UNIT, 1, BLKOUT(0))
*
* Write GIF Trailer.
*
      I = GRWFCH (UNIT, ';')
      END

**GRGI07 -- Compile GIF output code
*
      SUBROUTINE GRGI07(UNIT, INCODE)
      INTEGER UNIT, INCODE
      INTEGER BMAX, BMULT, BREST, BOUT
      BYTE BLKOUT(0:254)
      COMMON /GRGICO/ BMAX, BMULT, BREST, BOUT, BLKOUT
C
      BREST = BREST + BMULT * INCODE
      BMULT = BMULT * BMAX
C
   10 IF (BMULT .LT. 256) RETURN
      CALL GRGI08(UNIT, BREST)
      BREST = BREST / 256
      BMULT = BMULT / 256
      GOTO 10
C
      END

**GRGI08 -- Compile and write GIF output buffer
*
      SUBROUTINE GRGI08(UNIT, INCODE)
      INTEGER UNIT, INCODE, I, J, GRWFIL
      INTEGER BMAX, BMULT, BREST, BOUT
      BYTE BLKOUT(0:254)
      COMMON /GRGICO/ BMAX, BMULT, BREST, BOUT, BLKOUT
C
      BOUT = BOUT + 1
      J = MOD(INCODE,256)
      IF (J.GT.127) J = J-256
      BLKOUT(BOUT) = J
      IF (BOUT .LT. 254) RETURN
C!        changed 1997-Sep-2
      BLKOUT(0) = 254-256
      I = GRWFIL(UNIT, 255, BLKOUT(0))
      BOUT = 0
      END

**GRGI09 -- Encode integer in 2-char string
*
      CHARACTER*2 FUNCTION GRGI09(I)
      INTEGER I
      INTEGER I1, I2
*
      I1 = MOD(I,256)
      I2 = MOD(I/256,256)
      GRGI09(1:1) = CHAR(I1)
      GRGI09(2:2) = CHAR(I2)
      END

**GRGI10 -- Replace # in filename by picture number
*
      SUBROUTINE GRGI10 (NAME1, NP, NAME2)
      CHARACTER*(*) NAME1
      CHARACTER*(*) NAME2
      CHARACTER*80  TMP
      INTEGER GRTRIM
      INTEGER NP, IDX, L, LN

      LN = GRTRIM(NAME1)
      IDX = INDEX(NAME1,'#')
      IF (IDX.GT.0) THEN
C        -- if the supplied name contains a #-character, replace
C           it with the page number
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE IF (NP.EQ.1) THEN
C        -- if this is the first page, use the supplied name
         NAME2 = NAME1
         RETURN
      ELSE IF (LN+2.LE.LEN(NAME1)) THEN
C        -- append an underscore and the page number to the supplied
C           name
         NAME1(LN+1:LN+2) = '_#'
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE
C        -- last resort: invent a new name
         CALL GRFAO('pgplot#.gif', L, TMP, NP, 0, 0, 0)
      END IF
      CALL GRWARN ('Writing new GIF image as: '//TMP(:L))
      NAME2 = TMP(:L)
      END

C*PGQVP -- inquire viewport size and position
C%void cpgqvp(int units, float *x1, float *x2, float *y1, float *y2);
C+
      SUBROUTINE PGQVP (UNITS, X1, X2, Y1, Y2)
      INTEGER UNITS
      REAL    X1, X2, Y1, Y2
C
C Inquiry routine to determine the current viewport setting.
C The values returned may be normalized device coordinates, inches, mm,
C or pixels, depending on the value of the input parameter CFLAG.
C
C Arguments:
C  UNITS  (input)  : used to specify the units of the output parameters:
C                    UNITS = 0 : normalized device coordinates
C                    UNITS = 1 : inches
C                    UNITS = 2 : millimeters
C                    UNITS = 3 : pixels
C                    Other values give an error message, and are
C                    treated as 0.
C  X1     (output) : the x-coordinate of the bottom left corner of the
C                    viewport.
C  X2     (output) : the x-coordinate of the top right corner of the
C                    viewport.
C  Y1     (output) : the y-coordinate of the bottom left corner of the
C                    viewport.
C  Y2     (output) : the y-coordinate of the top right corner of the
C                    viewport.
C--
C 26-Sep-1985 - new routine (TJP).
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      REAL SX, SY
C
      IF (UNITS.EQ.0) THEN
          SX = PGXSZ(PGID)
          SY = PGYSZ(PGID)
      ELSE IF (UNITS.EQ.1) THEN
          SX = PGXPIN(PGID)
          SY = PGYPIN(PGID)
      ELSE IF (UNITS.EQ.2) THEN
          SX = (PGXPIN(PGID)/25.4)
          SY = (PGYPIN(PGID)/25.4)
      ELSE IF (UNITS.EQ.3) THEN
          SX = 1.0
          SY = 1.0
      ELSE
          CALL GRWARN(
     1        'Illegal value for parameter UNITS in routine PGQVP')
          SX = PGXSZ(PGID)
          SY = PGYSZ(PGID)
      END IF
      X1 = PGXVP(PGID)/SX
      X2 = (PGXVP(PGID)+PGXLEN(PGID))/SX
      Y1 = PGYVP(PGID)/SY
      Y2 = (PGYVP(PGID)+PGYLEN(PGID))/SY
      END

C*PGSTBG -- set text background color index
C%void cpgstbg(int tbci);
C+
      SUBROUTINE PGSTBG (TBCI)
      INTEGER  TBCI
C
C Set the Text Background Color Index for subsequent text. By default
C text does not obscure underlying graphics. If the text background
C color index is positive, however, text is opaque: the bounding box
C of the text is filled with the color specified by PGSTBG before
C drawing the text characters in the current color index set by PGSCI.
C Use color index 0 to erase underlying graphics before drawing text.
C
C Argument:
C  TBCI   (input)  : the color index to be used for the background
C                    for subsequent text plotting:
C                      TBCI < 0  => transparent (default)
C                      TBCI >= 0 => text will be drawn on an opaque
C                    background with color index TBCI.
C--
C 16-Oct-1993 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSTBG')) RETURN
      IF (TBCI.LT.0) THEN
          PGTBCI(PGID) = -1
      ELSE
          PGTBCI(PGID) = TBCI
      END IF
      END

C*PGIDEN -- write username, date, and time at bottom of plot
C%void cpgiden(void);
C+
      SUBROUTINE PGIDEN
C
C Write username, date, and time at bottom of plot.
C
C Arguments: none.
C--
C  9-Feb-1988
C 10-Sep-1990 : adjust position of text [TJP]
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      INTEGER L, M, CF, CI, LW
      CHARACTER*64 TEXT
      REAL D, CH
C
      CALL PGBBUF
C
C Get information for annotation.
C
      CALL GRUSER(TEXT, L)
      TEXT(L+1:) = ' '
      CALL GRDATE(TEXT(L+2:), M)
      L = L+1+M
C
C Save current attributes.
C
      CALL PGQCF(CF)
      CALL PGQCI(CI)
      CALL PGQLW(LW)
      CALL PGQCH(CH)
C
C Change attributes and write text.
C
      CALL PGSCF(1)
      CALL PGSCI(1)
      CALL PGSLW(1)
      CALL PGSCH(0.6)
      CALL GRLEN(TEXT(1:L),D)
      CALL GRTEXT(.FALSE., 0.0, .TRUE., PGXSZ(PGID)-D-2.0,
     1            2.0+PGYSZ(PGID)/130.0, TEXT(1:L))
C
C Restore attributes.
C
      CALL PGSCF(CF)
      CALL PGSCI(CI)
      CALL PGSLW(LW)
      CALL PGSCH(CH)
      CALL PGEBUF
C
      END

C*PGQTXT -- find bounding box of text string
C%void cpgqtxt(float x, float y, float angle, float fjust, \
C% const char *text, float *xbox, float *ybox);
C+
      SUBROUTINE PGQTXT (X, Y, ANGLE, FJUST, TEXT, XBOX, YBOX)
      REAL X, Y, ANGLE, FJUST
      CHARACTER*(*) TEXT
      REAL XBOX(4), YBOX(4)
C
C This routine returns a bounding box for a text string. Instead
C of drawing the string as routine PGPTXT does, it returns in XBOX
C and YBOX the coordinates of the corners of a rectangle parallel
C to the string baseline that just encloses the string. The four
C corners are in the order: lower left, upper left, upper right,
C lower right (where left and right refer to the first and last
C characters in the string).
C
C If the string is blank or contains no drawable characters, all
C four elements of XBOX and YBOX are assigned the starting point
C of the string, (X,Y).
C
C Arguments:
C  X, Y, ANGLE, FJUST, TEXT (input) : these arguments are the same as
C                    the corrresponding arguments in PGPTXT.
C  XBOX, YBOX (output) : arrays of dimension 4; on output, they
C                    contain the world coordinates of the bounding
C                    box in (XBOX(1), YBOX(1)), ..., (XBOX(4), YBOX(4)).
C--
C 12-Sep-1993 - new routine [TJP].
C  8-Nov-1994 - return something for blank string [TJP].
C 14-Jan-1997 - additional explanation [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
      INTEGER I, L, GRTRIM
      REAL D, XP, YP, XPBOX(4), YPBOX(4), XOFFS, YOFFS
C
      IF (PGNOTO('PGQTXT')) RETURN
C
      L = GRTRIM(TEXT)
      IF (L.LE.0) THEN
         DO 15 I=1,4
            XBOX(I) = X
            YBOX(I) = Y
 15      CONTINUE
      ELSE
         D = 0.0
         IF (FJUST.NE.0.0) CALL GRLEN(TEXT(1:L),D)
         XOFFS = PGXORG(PGID) - D*FJUST*COS(ANGLE/57.29578)
         YOFFS = PGYORG(PGID) - D*FJUST*SIN(ANGLE/57.29578)
         XP = X*PGXSCL(PGID) + XOFFS
         YP = Y*PGYSCL(PGID) + YOFFS
         CALL GRQTXT(ANGLE, XP, YP, TEXT(1:L), XPBOX, YPBOX)
         DO 25 I=1,4
            XBOX(I) = (XPBOX(I) - PGXORG(PGID))/PGXSCL(PGID)
            YBOX(I) = (YPBOX(I) - PGYORG(PGID))/PGYSCL(PGID)
 25      CONTINUE
      END IF
      END

C*GRQM00 -- PGPLOT QMS/QUIC driver

      SUBROUTINE    QMDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      INTEGER       IFUNC, NBUF, LCHR, MODE
      REAL          RBUF(*)
      CHARACTER*(*) CHR
C-----------------------------------------------------------------------
C PGPLOT driver for QUIC devices (QMS and Talaris 800/1200/1500/2400)
C-----------------------------------------------------------------------
C Version 0.1  - 1987 Oct 22 - Patrick P. Murphy, NRAO/VLA [PPM]
C Version 0.2  - 1987 Oct 28 - [PPM] Fix backwards and scale bugs
C Version 1.0  - 1987 Nov 03 - [PPM] Don't form feed if nothing drawn.
C Version 1.1  - 1987 Nov 03 - [PPM] No formfeed at very end of file
C Version 2.0  - 1987 Nov 18 - [PPM] Get scaling done right.
C Version 2.1  - 1991 Jun 28 - [TJP] Standardization.
C Version 2.2  - 1991 Nov  6 - [TJP] Standardization.
C Version 3.0  - 1994 Feb 25 - [TJP] Combine portrait and landscape
C                                    modes in one file.
C-----------------------------------------------------------------------
C
C Supported device: Any QMS or Talaris printer that accepts the QUIC 
C                   page description language.  4-bit mode is used.
C
C Device type code: /QMS (landscape mode 1)
C                   /VQMS (portrait mode 2)
C
C Default file name: PGPLOT.QMPLOT.
C
C Default view surface dimensions:
C      10.25 inches horizontal x  7.75 inches vertical (landscape mode), 
C       7.75 inches horizontal x 10.25 inches vertical (portrait mode),
C      margins of 0.5 inches on top and left of page.
C
C Resolution: The driver uses coordinate increments of 1/1000 inch.
C             The true resolution is device-dependent; at time of
C             writing, it is typically 300 dots per inch.
C
C Color capability: Color indices 0 (erase), and 1 (black) are 
C                   supported.  Requests for other color indices are
C                   converted to 1.  It is not possible to change color
C                   representation. 
C
C Input capability: None.
C
C File format: Ascii, variable length records (max 130 bytes); carriage
C              return ("LIST") carriage control.  This length can be
C              easily changed if needed.
C
C Obtaining hardcopy:  send the file to an appropriate printer.
C-----------------------------------------------------------------------
C
      CHARACTER*(*) DEVTPL, DEVTPP, DEFNAM
      PARAMETER    (DEFNAM='PGPLOT.QMPLOT')
      PARAMETER (DEVTPL='QMS   (QUIC/QMS file, landscape orientation)')
      PARAMETER (DEVTPP='VQMS  (QUIC/QMS file, portrait orientation)')
C
      CHARACTER*130 BUFFER
      CHARACTER*16  HEXSTR
      CHARACTER*10  MSG
      CHARACTER*40  TEMP
      INTEGER       UNIT, IER, BUFLEN, MAXLEN, I0, J0, I1, J1, NPTS, IC,
     :              ISTYLE, LINWID, GROPTX
      REAL          QXSIZE, QYSIZE, QXSCAL, QYSCAL
      LOGICAL       NOTHIN, ENDFIL
C
C ---- Change MAXLEN if you want a shorter or longer max output line 
C ---- length.  Also change the declared length of BUFFER too!  The
C ---- Q*SIZE parameters are the physical size of the plot (used more
C ---- than once here) in resolution units (1/1000 inch).  The Q*SCAL 
C ---- parameters are PGPLOT-modifiable scale factors.
C
      PARAMETER    (MAXLEN = 130,
     :              QXSIZE = 10250.0,
     :              QYSIZE = 7750.00)
C
      SAVE UNIT, IC, BUFFER, BUFLEN, NPTS, QXSCAL, QYSCAL, NOTHIN,
     :     ENDFIL
C
      DATA HEXSTR /'0123456789ABCDEF'/
C
C=======================================================================
C
C ---- Do the best one can in F77 for a "case" statement. --------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
C
C ---- Unknown opcode/function; most likely a logic error somewhere ----
C
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in QMS'//
     :            ' device driver:'//MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 IF (MODE.EQ.1) THEN
          CHR = DEVTPL
          LCHR = LEN(DEVTPL)
      ELSE IF (MODE.EQ.2) THEN
          CHR = DEVTPP
          LCHR = LEN(DEVTPP)
      ELSE
          CALL GRWARN('Internal error in QMDRIV')
      END IF
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C               Units are in device co-ordinates (1/1000 inches)
C
   20 IF (MODE.EQ.1) THEN
          RBUF(2) = QXSIZE
          RBUF(4) = QYSIZE
      ELSE
          RBUF(2) = QYSIZE
          RBUF(4) = QXSIZE
      END IF
      RBUF(1) = 0.0
      RBUF(3) = 0.0
      RBUF(5) = 0.0
      RBUF(6) = 1.0
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C    (Nominal values)
C
   30 RBUF(1) = 1000.0
      RBUF(2) = 1000.0
C
C      (multiple strokes are spaced by 3.333 pixels, or 1/300 inch)
C
      RBUF(3) = 3.333
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (Hardcopy, No cursor, Dashed lines, Area fill, Thick lines) 
C
   40 CHR = 'HNDATNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR  = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C    (in device coordinates).
C
   60 IF (MODE.EQ.1) THEN
          RBUF(2) = QXSIZE
          RBUF(4) = QYSIZE
      ELSE
          RBUF(2) = QYSIZE
          RBUF(4) = QXSIZE
      END IF
      RBUF(1) = 0.0
      RBUF(3) = 0.0
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C    Currently scale factor for "obsolete" character set of old GRPCKG
C    routines (not used by PGPLOT routines).  Value copied from IMAGEN
C    driver -- I assume this is a good value (PPM 871026).
C
   70 RBUF(1) = 8.0
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C    Future option, nothing done yet.  (Multiple devices open at one 
C    time will be allowed later; this opcode will select active device).
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C
C     -- Get a Unit number.  
C
      CALL GRGLUN(UNIT)
C
C     -- Open the file.
C
      NBUF = 2
      RBUF(1) = UNIT
      IER = GROPTX(UNIT, CHR(1:LCHR), DEFNAM, 1)
      IF (IER.NE.0) THEN
          TEMP = CHR(1:LCHR)
          CALL GRWARN('Cannot open output file for QMS'//
     :                ' plot: '//TEMP)
          RBUF(2) = 0
          CALL GRFLUN(UNIT)
          RETURN
      ELSE
          INQUIRE (UNIT=UNIT, NAME=CHR)
          LCHR = LEN(CHR)
   91     IF (CHR(LCHR:LCHR).EQ.' ') THEN
              LCHR = LCHR-1
              GOTO 91
          END IF
          RBUF(2) = 1
      END IF
C
C     -- initialization
C
      IC = 1
      BUFFER = ' '
      BUFLEN = 0
      NPTS = 0
      QXSCAL = 1.0
      QYSCAL = 1.0
      NOTHIN = .TRUE.
C
C     -- Initialize QUIC, get into free format, out of other possible 
C     -- modes (vector graphics, word processing), reset interpretation:
C     -- Set landscape/portrait mode, set margins, enter vector
C        graphics mode
C
      BUFLEN = 1
      CALL GRQM00 (UNIT, BUFFER, BUFLEN)
      BUFFER = '^PY^-'
      BUFLEN = 5
      CALL GRQM00 (UNIT, BUFFER, BUFLEN)
      BUFFER(1:38)  = '^F^IGE^G^IWE^G^IP0000^G^ISYNTAX00000^G'
      IF (MODE.EQ.1) THEN
          BUFFER(39:80) = '^IOL^G^IMH0050010750^G^IMV0050008250^G^IGV'
      ELSE
          BUFFER(39:80) = '^IOP^G^IMH0050008250^G^IMV0050010750^G^IGV'
      END IF
      BUFLEN = 80
      CALL GRQM00 (UNIT, BUFFER, BUFLEN)
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      IF (NOTHIN) THEN
C
C        -- Nothing was plotted so no need to keep the file around.
C
         CLOSE (UNIT)
C
      ELSE
C
C        -- see if the last call was end picture; if so, remove formfeed
C           (this assumes the printer/queue combination will supply the
C            form feeds; if not, comment out this next line).
C
         IF (ENDFIL) BUFLEN = BUFLEN - 2
C
C        -- Flush out anything left in the buffer
C
         IF (BUFLEN .GT. 0) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
C
C        -- Don't need to formfeed; end picture will do that.
C
         BUFFER = '^IGE^G^O^-'
         BUFLEN = 10
         CALL GRQM00 (UNIT, BUFFER, BUFLEN)
         BUFFER = '^PN^-'
         BUFLEN = 5
         CALL GRQM00 (UNIT, BUFFER, BUFLEN)
         CLOSE (UNIT, STATUS='KEEP')
      ENDIF
C
C     -- Return UNIT to free pool.
C
      CALL GRFLUN(UNIT)
      RETURN
C
C--- IFUNC=11, Begin picture and possibly rescale -----------------------
C
  110 CONTINUE
      ENDFIL = .FALSE.
      IF (MODE.EQ.1) THEN
          QXSCAL = MIN (1., RBUF(1) / QXSIZE)
          QYSCAL = MIN (1., RBUF(2) / QYSIZE)
      ELSE
          QXSCAL = MIN (1., RBUF(2) / QXSIZE)
          QYSCAL = MIN (1., RBUF(1) / QYSIZE)
      END IF
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C    When I copied the Imagen driver, I got output backwards in the
C    X direction (mirrored).  Hence I mirror it back now.
C
  120 CONTINUE
      IF (NOTHIN) NOTHIN = .FALSE.
      IF (IC.EQ.0) RETURN
      IF (MODE.EQ.1) THEN
          I0 = NINT((QXSIZE - RBUF(1)) * QXSCAL)
          J0 = NINT(RBUF(2) * QYSCAL)
          I1 = NINT((QXSIZE - RBUF(3)) * QXSCAL)
          J1 = NINT(RBUF(4) * QYSCAL)
      ELSE
          I0 = NINT(RBUF(1) * QYSCAL)
          J0 = NINT((QXSIZE - RBUF(2)) * QXSCAL)
          I1 = NINT(RBUF(3) * QYSCAL)
          J1 = NINT((QXSIZE - RBUF(4)) * QXSCAL)
      END IF
  125 CONTINUE
      IF (BUFLEN+13 .GE. MAXLEN) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
      BUFFER(BUFLEN+1:BUFLEN+2) = '^U'
      WRITE (BUFFER(BUFLEN+3:BUFLEN+13), '(I5.5,1H:,I5.5)') I0, J0
      BUFLEN = BUFLEN + 13
      IF (BUFLEN+13 .GE. MAXLEN) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
      BUFFER(BUFLEN+1:BUFLEN+2) = '^D'
      WRITE (BUFFER(BUFLEN+3:BUFLEN+13), '(I5.5,1H:,I5.5)') I1, J1
      BUFLEN = BUFLEN + 13
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C    QUIC takes care of dot size by the ^PW (pen width) command so we 
C    don't have to worry about it here.  Just draw to same point and
C    let the "draw line" code handle it.
C
  130 CONTINUE
      IF (NOTHIN) NOTHIN = .FALSE.
      IF (IC.EQ.0) RETURN
      IF (MODE.EQ.1) THEN
          I0 = NINT((QXSIZE - RBUF(1)) * QXSCAL)
          J0 = NINT(RBUF(2) * QYSCAL)
      ELSE
          I0 = NINT(RBUF(1) * QYSCAL)
          J0 = NINT((QXSIZE - RBUF(2)) * QXSCAL)
      END IF
      I1 = I0
      J1 = J0
      GOTO 125
C
C--- IFUNC=14, End picture ---------------------------------------------
C    This means do a form feed.  QUIC allows form feeds within vector
C    graphics mode so just put it in the stream.
C    Changed 871103 [PPM] so that no formfeed done if "NOTHIN" is true.
C    That means there is nothing on the paper.
C    Changed again (same date, person): set flag for end workstation
C
  140 CONTINUE
      ENDFIL = .TRUE.
      IF (.NOT. NOTHIN) THEN
         IF (BUFLEN+2 .GE. MAXLEN) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
         BUFFER(BUFLEN+1:BUFLEN+2) = '^,'
         BUFLEN = BUFLEN + 2
      ENDIF
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      IF (IC.LT.0 .OR. IC.GT.1) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    Hardcopy so ignore it
C
  160 CONTINUE
C     CALL GRQM00 (UNIT, BUFFER, BUFLEN) Not needed!
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C           Not implemented, hardcopy device.  Return error code.
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen so ignore it).
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C
  190 CONTINUE
      ISTYLE = NINT(RBUF(1))
      IF (ISTYLE .LT. 1) ISTYLE = 1
      IF (ISTYLE .GT. 5) ISTYLE = 5
C
C     -- Convert PGPLOT line styles 1 thru 5 to QUIC equivalents
C
      GOTO (191,192,193,194,195) ISTYLE
C
C     Select ISTYLE in CASE:
C     Full line
  191    ISTYLE = 0
         GOTO 196
C     Long dashes
  192    ISTYLE = 1
         GOTO 196
C     Dash-dot
  193    ISTYLE = 7
         GOTO 196
C     Dotted
  194    ISTYLE = 2
         GOTO 196
C     Dash-dot-dot-dot
  195    ISTYLE = 9
         GOTO 196
C     End SELECT/CASE on ISTYLE
  196 CONTINUE
C
C     -- I use HEXSTR here for system-independence and also in case the
C     -- PGPLOT package ever adds more line styles.
C
      IF (BUFLEN+3 .GE. MAXLEN) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
      BUFFER(BUFLEN+1:BUFLEN+2) = '^V'
      ISTYLE = ISTYLE + 1
      BUFFER(BUFLEN+3:BUFLEN+3) = HEXSTR(ISTYLE:ISTYLE)
      BUFLEN = BUFLEN + 3
      RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      IF (IC .EQ. 0) RETURN
C
C     -- Use NPTS as our indicator of whether this is first time or not
C
      IF (NPTS.EQ.0) THEN
C
C        -- First time so set number of points in polygon
C
         NPTS = RBUF(1)
         IF (BUFLEN+8 .GE. MAXLEN) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
C
C        -- Use black fill, no border (in case PGPLOT doesn't go back to
C           the last point) --------------------------------------------
C
         BUFFER (BUFLEN+1:BUFLEN+8) = '^PF020^U'
         BUFLEN = BUFLEN + 8
      ELSE
C
C        -- Second or other time so bump NPTS and draw to next vertex
C
         IF (NOTHIN) NOTHIN = .FALSE.
         NPTS = NPTS - 1
         IF (MODE.EQ.1) THEN
             I0 = NINT((QXSIZE - RBUF(1)) * QXSCAL)
             J0 = NINT(RBUF(2) * QYSCAL)
         ELSE
             I0 = NINT(RBUF(1) * QYSCAL)
             J0 = NINT((QXSIZE - RBUF(2)) * QXSCAL)
         END IF
         IF (BUFLEN+13 .GE. MAXLEN) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
         WRITE (BUFFER(BUFLEN+1:BUFLEN+11), '(I5.5,1H:,I5.5)') I0, J0
         BUFFER(BUFLEN+12:BUFLEN+13) = '^D'
         BUFLEN = BUFLEN + 13
         IF (NPTS .EQ. 0) THEN
C
C           -- get rid of last ^D and give the Polygon fill command
C
            BUFLEN = BUFLEN - 2
            BUFFER(BUFLEN+1:BUFLEN+2) = '  '
            IF (BUFLEN+3 .GE. MAXLEN) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
            BUFFER(BUFLEN+1:BUFLEN+3) = '^PS'
            BUFLEN = BUFLEN + 3
         END IF
      END IF
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C    (Not implemented: ignored.  Will we ever get color laser printers?)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C
  220 CONTINUE
C
C     -- QUIC pen width is in dots (1/300 inch) so convert from 1/200's.
C
      LINWID = NINT(RBUF(1) * 1.5)
      IF (LINWID .LT. 1) LINWID = 1
      IF (LINWID .GT. 31) LINWID = 31
      IF (BUFLEN+5 .GE. MAXLEN) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
      BUFFER(BUFLEN+1:BUFLEN+3) = '^PW'
      WRITE (BUFFER(BUFLEN+4:BUFLEN+5), '(I2.2)') LINWID
      BUFLEN = BUFLEN + 5
      RETURN
C
C--- IFUNC=23, Escape --------------------------------------------------
C    Note that the NOTHIN flag which indicates if there is anything 
C    written on the paper is set here regardless of the content of
C    the escape characters.
C
  230 CONTINUE
      IF (NOTHIN) NOTHIN = .FALSE.
      IF (LCHR .GT. MAXLEN) THEN
         WRITE (MSG(1:4), '(I4)') MAXLEN
         CALL GRWARN('Sorry, maximum line size ('//MSG(1:4)//
     :               ') exceeded for device type QMS')
         NBUF = -1
      ELSE
C
C        -- WARNING!  Anyone using the escape mechanism to send stuff
C           to the QMS had better remember (a) the QMS is ASSUMED by 
C           the driver to be in vector graphics mode, and (b) you better
C           darn well put it back in the same vector mode!!!  If not, 
C           well, you get what you deserve then.
C
         IF (BUFLEN+LCHR .GE. MAXLEN) CALL GRQM00 (UNIT, BUFFER, BUFLEN)
         BUFFER(BUFLEN+1:BUFLEN+LCHR) = CHR(1:LCHR)
         BUFLEN = BUFLEN + LCHR
      ENDIF
C
      RETURN
C-----------------------------------------------------------------------
      END

C*GRQM00 -- PGPLOT QMS/QUIC driver, flush buffer
C+
      SUBROUTINE GRQM00 (LUN, BUF, SIZ)
      CHARACTER*(*) BUF
      INTEGER LUN, SIZ
C--
      WRITE (LUN, '(A)') BUF(1:SIZ)
      BUF(1:LEN(BUF)) = ' '
      SIZ = 0
      END

C*GRSIZE -- inquire device size and resolution
C+
      SUBROUTINE GRSIZE (IDENT,XSZDEF,YSZDEF,XSZMAX,YSZMAX,
     1                   XPERIN,YPERIN)
C
C GRPCKG : obtain device parameters (user-callable routine).
C--
C (1-Feb-1983)
C  5-Aug-1986 - add GREXEC support [AFT].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER IDENT
      REAL XSZDEF, YSZDEF, XSZMAX, YSZMAX, XPERIN, YPERIN
      INTEGER NBUF,LCHR
      REAL    RBUF(6)
      CHARACTER CHR
C
      CALL GRSLCT(IDENT)
      CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR)
      XSZDEF = RBUF(2)
      YSZDEF = RBUF(4)
      CALL GREXEC(GRGTYP, 2,RBUF,NBUF,CHR,LCHR)
      XSZMAX = RBUF(2)
      YSZMAX = RBUF(4)
      XPERIN = GRPXPI(GRCIDE)
      YPERIN = GRPYPI(GRCIDE)
C
      END

      Program create_doc
      Implicit None
      Integer I,J,K,numsub,Unitnm(0:200),Sizehd(0:200),End(0:200),start,loc,M,
     +        locarr(50),starto,headar(50),ndum,match
      Character Line*100,header(100)*200,Asizeh(0:200)*3,lineout*200
	 
C Declarations needed to get arguments from MPW command line.
C Argument 0 is always create_doc and is ignored.  Arguments 2 and up are the
C actual files that will be searched to build the documentation. Argument
C 1 is the directory containing the files.
       
      include 'Types.f'
	
      STRUCTURE /Args/
		record /StringPtr/ arg(0:7)
      END STRUCTURE

      integer*4	ArgC
      pointer		/Args/ ArgV
	
      integer*4	JARGC			! ArgC = JArgC()
      EXTERNAL	JARGC			!  # of arguments+1
      integer*4	JARGV			! ArgV = JArgV()
      EXTERNAL 	JARGV			!  pointer to an array of string pointers
      record		/StringPtr/ P
      integer*4	p

      Data UnitNm/201*0/
      Open(Unit=1,File='pgplot.doc',Status='Unknown',Err=2000,
     +     carriagecontrol='Fortran')
      Open(Unit=2,File='pgplot.html',Status='Unknown',Err=3000,
     +     carriagecontrol='Fortran')

c        1         2         3         4         5         6         7
c2345678901234567890123456789012345678901234567890123456789012345678901234567890
      Write(1,'(''PGPLOT GRAPHICS SUBROUTINE LIBRARY Version 5.0'',//,
     +''PGPLOT is a Fortran subroutine package for drawing graphs on a variety'',/,
     +"of display devices. For more details, see the manual ``PGPLOT Graphics",/,
     +"Subroutine Library'''' available from T. J. Pearson",/,
     +''(tjp@astro.caltech.edu).'',//,
     +''INDEX OF ROUTINES'',/)')
	  
	  Write(2,'("<HTML>",/,
     +"<HEAD><TITLE>PGPLOT Subroutine Descriptions</TITLE></HEAD>",/,
     +"<BODY>",//,
     +"<H1>PGPLOT Subroutine Descriptions</H1>",//,
     +"<H2>Introduction</H2>",//,
     +"This appendix includes a list of all the PGPLOT subroutines,",/,
     +"and then gives detailed instructions for the use of each routine in",/,
     +"Fortran programs. The subroutine descriptions are in alphabetical order.",//,
     +"<H2>Arguments</H2>",//,
     +"The subroutine descriptions indicate the data type of each",/,
     +"argument. When arguments are described as ``input'''', they may be",/,
     +"replaced with constants or expressions in the <CODE>CALL</CODE>",/,
     +"statement, but make sure that the constant or expression has the",/,
     +"correct data type.",//,
     +"<DL><DT><CODE>INTEGER</CODE> arguments:",/,
     +"<DD>these should be declared",/,
     +"<CODE>INTEGER</CODE> or <CODE>INTEGER*4</CODE> in the calling program,",/,
     +"not <CODE>INTEGER*2</CODE>.",/)')
      Write(2,'("<DT><CODE>REAL</CODE> arguments:",/,
     +"<DD>these should be declared",/,
     +"<CODE>REAL</CODE> or <CODE>REAL*4</CODE> in the calling program, not",/,
     +"<CODE>REAL*8</CODE> or <CODE>DOUBLE PRECISION</CODE>.",//,
     +"<DT><CODE>LOGICAL</CODE> arguments:",/,
     +"<DD>these should be declared",/,
     +"<CODE>LOGICAL</CODE> or <CODE>LOGICAL*4</CODE> in the calling program.",//,
     +"<DT><CODE>CHARACTER</CODE> arguments:",/,
     +"<DD> any valid Fortran",/,
     +"<CODE>CHARACTER</CODE> variable may be used (declared",/,
     +"<CODE>CHARACTER*n</CODE> for some integer <CODE>n</CODE>).",//,
     +"</DL>",//,
     +"<H2>Index of Routines</H2>",//,
     +"<EM>Version 5.0</EM><P>",///,
     +"<UL>")')

C  Get the number of arguments and actual arguments

      ArgC = JARGC()
      ArgV = JARGV()
	
C	Test each file to see if it is used in pgplot.doc.  Files which
C   will be used to create the documentation have 'C*PG'.  Store the argument
C   number in Unitnm(numsub) and increment numsub.  This first do loop creates the
C   index.
      numsub = 0
      do i=2,ArgC-1
	     Open(10,file=ArgV^.arg(1).P^//ArgV^.arg(i).P^,Status='OLD')
5           Read(10,'(A100)',End=10) line
			If (line(1:4) .eq. 'C*PG') Then
			   numsub = numsub + 1
			   Unitnm(numsub) = i
C  Trim is a Language Systems function which removes the trailing spaces from
C  the argument and returns a String*255 data type.
			   sizehd(numsub) = len(trim(line(3:)))
			   header(numsub)(1:sizehd(numsub)) = line(3:sizehd(numsub)+2)
			   Write(Asizeh(numsub),'(I3)') sizehd(numsub)
 			   Write(1,'(T1,A'//Asizeh(numsub)//')') 
     +               header(numsub)(1:sizehd(numsub))
C The variable End(numsub) stores the location for the end of the subroutine
C name, while sizehd(numsub) stores the length of the header line.
               End(numsub) = index(header(numsub),' ') - 1
			   line = '<LI><A HREF=""#'//header(numsub)(1:end(numsub))//
     +                '"">'//header(numsub)(1:end(numsub))//'</A>'//
     +              header(numsub)(end(numsub)+1:sizehd(numsub))
			   Sizehd(0) = len(Trim(line))
			   Write(Asizeh(0),'(I3)') sizehd(0)
 	           Write(2,'(T1,A'//Asizeh(0)//')')line(1:sizehd(0))
			End If
			Go to 5
10       Continue
		 Close(10)
      enddo
	  Write(2,'(T1,''</UL>'')')

C  This second do loop creates the actual documentation.  First write the
C  header, then look for C+ and copy all the lines between C+ and C- to
C  pgplot.doc and pgplot.html.
	  Do 30 J = 1,numsub
	     Write(1,'(//,''----------------------------------------------'',
     +   ''--------------------------'')')
	     Write(1,'(T1,A8,A'//Asizeh(j)//')')
     +         'Module: ',header(J)(1:sizehd(j))
	     Write(1,'(''----------------------------------------------'',
     +   ''--------------------------'',/)')
	     line = '<H2><A NAME=""'//header(J)(1:end(J))//
     +          '"">'//header(J)(1:end(J))//'</A>'//
     +          header(J)(end(J)+1:sizehd(J))//'</H2>'
         Write(2,'(/,T1,''<HR>'')')
		 sizehd(0) = len(trim(line))
		 Write(asizeh(0),'(I3)') sizehd(0)
	     Write(2,'(T1,A'//Asizeh(0)//')')line(1:sizehd(0))
		 Write(2,'(T1,''<PRE>'')')
	     if (Unitnm(J-1) .ne. Unitnm(J)) then
            Open(10,file=ArgV^.arg(1).P^//ArgV^.arg(Unitnm(J)).P^,
     +      Status='OLD')
         End If		   
20       Continue
            Read(10,'(A100)',End=30) line
		 If (line(1:2) .ne. 'C+') Go to 20
25       Read(10,'(A100)',End=30) line
            If (line(1:3) .ne. 'C--') Then
			   sizehd(0) = len(trim(line))
	           If (line(1:1) .eq. ' ') Then
	   		      Write(Asizeh(0),'(I3)') sizehd(0) 
			      Write(1,'(T1,A'//Asizeh(0)//')') line(1:sizehd(0))
			      Write(2,'(T1,A'//Asizeh(0)//')') line(1:sizehd(0))
	              Go to 25
			   Else
			      Write(Asizeh(0),'(I3)') max(0,sizehd(0)-2)
			      Write(1,'(T1,A'//Asizeh(0)//')') line(3:sizehd(0))
			   End If
	           lineout = ''
			   starto = 1
			   I = 3
50             Continue
			      If (line(I:I) .eq. '<') Then
				     lineout(starto:starto+3) = '&lt;'
					 I = I + 1
					 starto = starto + 4
				  Else if (line(I:I) .eq. '>') then
				  	 lineout(starto:starto+3) = '&gt;'
					 I = I + 1
					 starto = starto + 4
				  Else if (line(I:I) .eq. '&') Then
				     lineout(starto:starto+4) = '&amp;'
					 I = I + 1
					 starto = starto + 5
				  Else If (line(I:I) .eq. 'P')  Then
				     If ((I .lt. sizehd(0)) .and. (line(I+1:I+1) .eq. 'G')) Then
					    match = 0
					    Do 55 K = 1, numsub
						   If (((sizehd(0) - I+1) .ge. end(K))
     +                       .and. (line(I+2:I-1+end(K)) .eq. header(K)(3:end(K))))Then
	                         match = Match + 1
							 headar(match) = K
						   End If
55                      Continue
                        If (match .ge. 1) Then
						   ndum = headar(1)
						   If (match .gt. 1) Then
							  Do 56 K = 1, Match - 1 
							     If (end(headar(K+1)) .gt. end(ndum)) Then
								    ndum = headar(K+1)
								 End If
56                            Continue
                           End If
						   lineout(starto:starto+15+2*end(ndum)) = '<A href=""#'//
     +                         header(ndum)(1:end(ndum))//'"">'//
     +                         header(ndum)(1:end(ndum))//'</A>'
	                       starto = starto + 16 + 2*end(ndum)
						   I = I + end(ndum)
	                    Else 
				           lineout(starto:starto) = line(I:I)
						   I = I + 1
					       starto = starto + 1
						End If
					 Else
				        lineout(starto:starto) = line(I:I)
						I = I + 1
					    starto = starto + 1
					 End If
				  Else
				     lineout(starto:starto) = line(I:I)
					 I = I + 1
					 starto = starto + 1
				  End If
               If (I .le. sizehd(0)) Go to 50
C  Write out line to pgplot.html.
			   sizehd(0) = len(trim(lineout))
			   Write(Asizeh(0),'(I3)') sizehd(0)
			   Write(2,'(T1,A'//Asizeh(0)//')')lineout(1:sizehd(0))
			   Go to 25
			Else
		       Write(2,'(T1,''</PRE>'')')
			End If
30    Continue

      Write(2,'(T1,''<HR>'',/,''</BODY></HTML>'')')
	  close(2)
	  Close(1)

      Call F_endMPW(0)
2000  Continue
      Write(*,*) ' Error: Could not open pgplot.doc.'
      Call F_EndMPW(1)
3000  Continue
      Write(*,*) ' Error: Could not open pgplot.html.'
      Call F_EndMPW(1)
      End
	  
	  Subroutine Sortar(Int1,Int2,N)
	  Implicit None
	  Integer Int1(*),Int2(*),N,I,ndum
	  Logical sorted
	  
5	  sorted = .True.
 	  I = 1
10       If (I .lt. N) Then
	        If (Int1(I+1) .lt. Int1(I)) Then
	   	       sorted = .False.
		       ndum = int1(I)
			   int1(I) = Int1(I+1)
			   int1(I+1) = ndum
		       ndum = int2(I)
			   int2(I) = Int2(I+1)
			   int2(I+1) = ndum
		    End If
			I = I + 1
			Go to 10
		 End If
	  If (.not. sorted) Go to 5
	  Return
	  End
	  

C*PGCONF -- fill between two contours
C%void cpgconf(const float *a, int idim, int jdim, int i1, int i2, \
C% int j1, int j2, float c1, float c2, const float *tr);
C+
      SUBROUTINE PGCONF (A, IDIM, JDIM, I1, I2, J1, J2, C1, C2, TR)
      INTEGER IDIM, JDIM, I1, I2, J1, J2
      REAL    A(IDIM,JDIM), C1, C2, TR(6)
C
C Shade the region between two contour levels of a function defined on
C the nodes of a rectangular grid. The routine uses the current fill
C attributes, hatching style (if appropriate), and color index.
C
C If you want to both shade between contours and draw the contour
C lines, call this routine first (once for each pair of levels) and 
C then CALL PGCONT (or PGCONS) to draw the contour lines on top of the
C shading.
C
C Note 1: This routine is not very efficient: it generates a polygon
C fill command for each cell of the mesh that intersects the desired
C area, rather than consolidating adjacent cells into a single polygon.
C
C Note 2: If both contours intersect all four edges of a particular
C mesh cell, the program behaves badly and may consider some parts
C of the cell to lie in more than one contour range.
C
C Note 3: If a contour crosses all four edges of a cell, this
C routine may not generate the same contours as PGCONT or PGCONS
C (these two routines may not agree either). Such cases are always
C ambiguous and the routines use different approaches to resolving
C the ambiguity.
C
C Arguments:
C  A      (input)  : data array.
C  IDIM   (input)  : first dimension of A.
C  JDIM   (input)  : second dimension of A.
C  I1,I2  (input)  : range of first index to be contoured (inclusive).
C  J1,J2  (input)  : range of second index to be contoured (inclusive).
C  C1, C2 (input)  : contour levels; note that C1 must be less than C2.
C  TR     (input)  : array defining a transformation between the I,J
C                    grid of the array and the world coordinates. The
C                    world coordinates of the array point A(I,J) are
C                    given by:
C                      X = TR(1) + TR(2)*I + TR(3)*J
C                      Y = TR(4) + TR(5)*I + TR(6)*J
C                    Usually TR(3) and TR(5) are zero - unless the
C                    coordinate transformation involves a rotation
C                    or shear.
C--
C 03-Oct-1996 - new routine [TJP].
C-----------------------------------------------------------------------
      INTEGER  I, J, IC, NPT, LEV
      LOGICAL  PGNOTO
      REAL     DVAL(5), X(8), Y(8), DELTA, XX, YY, C, R
      INTEGER  IDELT(6)
      DATA     IDELT/0,-1,-1,0,0,-1/
C
C Check arguments.
C
      IF (PGNOTO('PGCONF')) RETURN
      IF (I1.LT.1 .OR. I2.GT.IDIM .OR. I1.GE.I2 .OR.
     :    J1.LT.1 .OR. J2.GT.JDIM .OR. J1.GE.J2) RETURN
      IF (C1.GE.C2) RETURN
      CALL PGBBUF
C
      DO 140 J=J1+1,J2
         DO 130 I=I1+1,I2
            DVAL(1) = A(I-1,J)
            DVAL(2) = A(I-1,J-1)
            DVAL(3) = A(I,J-1)
            DVAL(4) = A(I,J)
            DVAL(5) = DVAL(1)
C
            NPT = 0
            DO 120 IC=1,4
               IF (DVAL(IC).GE.C1 .AND. DVAL(IC).LT.C2) THEN
                  NPT = NPT+1
                  XX = I+IDELT(IC+1)
                  YY = J+IDELT(IC)
                  X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY
                  Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY
               END IF
               R = DVAL(IC+1)-DVAL(IC)
               IF (R.EQ.0.0) GOTO 120
               DO 110 LEV=1,2
                  IF (R.GT.0.0) THEN
                     C = C1
                     IF (LEV.EQ.2) C = C2
                  ELSE
                     C = C2
                     IF (LEV.EQ.2) C = C1
                  END IF
                  DELTA = (C-DVAL(IC))/R
                  IF (DELTA.GT.0.0 .AND. DELTA.LT.1.0) THEN
                     IF (IC.EQ.1 .OR. IC.EQ.3) THEN
                        XX = I+IDELT(IC+1)
                        YY = REAL(J+IDELT(IC)) + 
     :                       DELTA*REAL(IDELT(IC+1)-IDELT(IC))
                     ELSE
                        XX = REAL(I+IDELT(IC+1)) +
     :                       DELTA*REAL(IDELT(IC+2)-IDELT(IC+1))
                        YY = J+IDELT(IC)
                     END IF
                     NPT = NPT+1
                     X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY
                     Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY
                  END IF
 110           CONTINUE
 120        CONTINUE
            IF (NPT.GE.3) CALL PGPOLY(NPT, X, Y)
 130     CONTINUE
 140  CONTINUE
      CALL PGEBUF
      END

C*PGSFS -- set fill-area style
C%void cpgsfs(int fs);
C+
      SUBROUTINE PGSFS (FS)
      INTEGER  FS
C
C Set the Fill-Area Style attribute for subsequent area-fill by
C PGPOLY, PGRECT, or PGCIRC.  Four different styles are available: 
C solid (fill polygon with solid color of the current color-index), 
C outline (draw outline of polygon only, using current line attributes),
C hatched (shade interior of polygon with parallel lines, using
C current line attributes), or cross-hatched. The orientation and
C spacing of hatch lines can be specified with routine PGSHS (set
C hatch style).
C
C Argument:
C  FS     (input)  : the fill-area style to be used for subsequent
C                    plotting:
C                      FS = 1 => solid (default)
C                      FS = 2 => outline
C                      FS = 3 => hatched
C                      FS = 4 => cross-hatched
C                    Other values give an error message and are
C                    treated as 2.
C--
C 21-Oct-1985 - new routine [TJP].
C 17-Dec-1990 - pass to GR level [TJP].
C  6-Mar-1995 - add styles 3 and 4 [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSFS')) RETURN
      IF (FS.LT.1 .OR. FS.GT.4) THEN
          CALL GRWARN('illegal fill-area style requested')
          PGFAS(PGID) = 2
      ELSE
          PGFAS(PGID) = FS
      END IF
      END

C*VADRIV -- PGPLOT Canon Printer driver (portrait mode)

      SUBROUTINE VADRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      INTEGER   IFUNC, NBUF, LCHR
      REAL      RBUF(*)
      CHARACTER CHR*(*)
C
C PGPLOT driver for Canon Laser printer - portrait mode.
C
C Supported device:  Canon LBP-8/A2 Laser printer.
C   Conforms to ISO646,2022,2375 and 6429 specifications.
C   VDM (graphics) conforms to proposed American National
C   Standard VDM mode.
C
C Device type code:  /VCAnon (Portrait mode only).
C
C Default file name:  PGPLOT.CAN
C
C Default view surface dimensions:  19 by 24 cm.
C
C Resolution:  300 pixels per inch in both directions.
C
C Color capability:  Color indices 0 (erase) and 1 (black) are
C   supported.  Note, hardware polygon fill is used and colors
C   0-11 control the fill pattern.
C
C Input capability:  None.
C
C File format:  Variable length records with Carriage control
C   of LIST.
C
C Obtaining hardcopy:  If printer is connected to a terminal
C   line (RS-232 option) then printing the file on the corresponding
C   queue should suffice.  If the printer is connected using
C   the Centronics interface, which appears the to VAX as an
C   LP device, then it is important to ensure that (1) all 8 bit
C   characters are passed to the printer (2) lines longer than
C   132 bytes are not truncated, and (3) no extra formatting
C   commands (e.g. form-feeds) are sent to the printer.
C   This can be done with the VMS command:
C   $ SET PRINT/PASSALL/LOWER/CR <device>
C   Note, some interface boards have a option to append a carriage
C   return after a formfeed or LF character, it is suggested
C   that this be disabled.
C   The file should be printed with the /PASSALL qualifier i.e.,
C   $ PRINT/PASSALL <filename>
C   Note, SET PRINT/PASSALL and PRINT/PASSALL do not do the
C   same things and hence PASSALL is required in both locations.
C
C 27-Jan-1988 - Version can be sent over BITNET (I hope) [AFT].
C 27-Sep-1986 - Add color index 0 (erase) [AFT].
C  5-Aug-1986 - [AFT].
C 13-Nov-1991 - [MCS] Having corrected unit scale factor to be one dot
C               instead of 0.8mm in GRVA03, changed viewport dimensions
C               to appear the same as before.
C 14-Nov-1991 - [MCS] 11 colour indexes are already implemented as fill
C               patterns - however device info on this said there were
C               only 0 and 1 - corrected IFUNC 2 now reports 11 colours
C 15-Nov-1991 - [MCS] Converted to portrait mode - /vcanon.
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE
      PARAMETER (TYPE='VCANON (Canon LBP-8/A2 Laser printer, portrait)')
      INTEGER    IS2,    IVESC
      PARAMETER (IS2=30, IVESC=125)
C- The maximum physical size of the plot in units of 1/300 inch.
      INTEGER    MXLEN,      MXWID
      PARAMETER (MXLEN=2362, MXWID=3366)
C- Default size of plot.
      INTEGER    IDEFL,      IDEFW
      PARAMETER (IDEFL=2244, IDEFW=2835)
C
      CHARACTER CBUF*256
      CHARACTER MSG*10
      CHARACTER CDASH(5),CFILL(0:11)
      INTEGER   I0, J0, I1, J1, IER
      INTEGER   LUN, ICOL, NPTS, LBUF, LASX, LASY
      SAVE      LUN, ICOL, NPTS, LBUF, LASX, LASY
C---
C- Patterns defined with 2 and " appear the same on our Canon
C- so only one is used.  Pattern 0 causes the polygon not to
C- be filled.  Pattern ) erases interior of polygon is the
C- last character in list as all colors > max are set to
C- this pattern.
      DATA CFILL/')','1','(','''','&','%',
     :           '$','2','#','!','0',')'/
      DATA CDASH/'0','1','3','"','4'/
C---
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     :     110,120,130,140,150,160,900,180,190,200,
     :     210) IFUNC
 900  WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in CA device driver: '//MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC= 1, Return device name. -------------------------------------
 10   CHR=TYPE
      LCHR=LEN(TYPE)
      RETURN
C
C--- IFUNC= 2, Return Physical min and max for plot device. ------------
 20   RBUF(1)=0
      RBUF(2)=MXLEN
      RBUF(3)=0
      RBUF(4)=MXWID
      RBUF(5)=0
      RBUF(6)=11
      NBUF=6
      RETURN
C
C--- IFUNC= 3, Return device resolution. -------------------------------
 30   RBUF(1)=300.0
      RBUF(2)=300.0
      RBUF(3)=1
      NBUF=3
      RETURN
C
C--- IFUNC= 4, Return misc device info. --------------------------------
 40   CHR='HNNANNNNNN'
      LCHR=10
      RETURN
C     
C---  IFUNC= 5, Return default file name. -------------------------------
 50   CHR='PGPLOT.CAN'
      LCHR=10
      RETURN
C
C--- IFUNC= 6, Return default physical size of plot. -------------------
 60   RBUF(1)=0
      RBUF(2)=IDEFL
      RBUF(3)=0
      RBUF(4)=IDEFW
      RETURN
C
C--- IFUNC= 7, Return misc defaults. -----------------------------------
 70   RBUF(1)=1
      NBUF=1
      RETURN
C
C--- IFUNC= 8, Select plot. --------------------------------------------
 80   RETURN
C
C--- IFUNC= 9, Open workstation. ---------------------------------------
 90   CALL GRGLUN (LUN)
      OPEN (UNIT=LUN, FILE=CHR(:LCHR), STATUS='NEW',
     :     FORM='FORMATTED',
     :     RECL=512, IOSTAT=IER)
      IF (IER.EQ.0) THEN
         RBUF(2)=1
      ELSE
         RBUF(2) = IER
      ENDIF
      RBUF(1)=LUN
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
 100  CLOSE(UNIT=LUN)
      CALL GRFLUN (LUN)
      RETURN
C
C--- IFUNC=11, Begin Picture. ------------------------------------------
 110  CALL GRVA03(LUN,1)
C
C [MCS] - By default the Y-axis goes down the page - use the Picture
C area command to reverse this. '(',X0,Y0,X1,Y1,IS2
C
      LBUF=1
      CBUF(LBUF:LBUF)='('
      CALL GRVA04(0,CBUF,LBUF)
      CALL GRVA04(0,CBUF,LBUF)
      CALL GRVA04(MXWID,CBUF,LBUF)
      CALL GRVA04(MXLEN,CBUF,LBUF)
      LBUF=LBUF+1
      CBUF(LBUF:LBUF)=CHAR(IS2)
C- Use the origin transfer command to ensure that the picture is
C- centered on the page.
      I0=(MXLEN-NINT(RBUF(1)))/2
      J0=(MXWID-NINT(RBUF(2)))/2
      CBUF(LBUF+1:LBUF+2)=CHAR(IVESC)//'"'
      LBUF=LBUF+2
      CALL GRVA04(I0,CBUF,LBUF)
      CALL GRVA04(J0,CBUF,LBUF)
      LBUF=LBUF+1
      CBUF(LBUF:LBUF)=CHAR(IS2)
      WRITE(LUN,11) CBUF(:LBUF)
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
 120  I0=NINT(RBUF(1))
      J0=NINT(RBUF(2))
      I1=NINT(RBUF(3))
      J1=NINT(RBUF(4))
      CALL GRVA01(LUN,I0,J0,I1,J1)
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
 130  I0=NINT(RBUF(1))
      J0=NINT(RBUF(2))
      CALL GRVA01(LUN,I0,J0,I0,J0)
      RETURN
C
C--- IFUNC=14, End Picture. --------------------------------------------
 140  CALL GRVA03(LUN,2)
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C- Save pen number (up to 11) for possible use in pattern interior.
 150  ICOL=MAX(0,MIN(NINT(RBUF(1)),11))
      RBUF(1)=MAX(0,MIN(ICOL,1))
      IF(ICOL.EQ.0) THEN
         CBUF(1:4)=CHAR(IVESC)//'G2'//CHAR(IS2)
      ELSE
         CBUF(1:4)=CHAR(IVESC)//'G0'//CHAR(IS2)
      END IF
      WRITE(LUN,11) CBUF(:4)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
 160  RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
 180  RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C- Currently turned off, since pattern is reset at beginning of
C- every new line segment.  Note, if GRVA01 was modified to
C- properly use polylines then dash pattern may work better.
 190  CBUF(1:4)='E1'//CDASH(NINT(RBUF(1)))//CHAR(IS2)
      WRITE(LUN,11) CBUF(:4)
      RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
 200  IF(NPTS.EQ.0) THEN
         NPTS=RBUF(1)
         CBUF(1:5)='I'//CFILL(ICOL)//'0'//CHAR(IS2)//'2'
         LBUF=5
         LASX=0
         LASY=0
      ELSE
         NPTS=NPTS-1
         I0=NINT(RBUF(1))
         J0=NINT(RBUF(2))
         CALL GRVA04(I0-LASX,CBUF,LBUF)
         CALL GRVA04(J0-LASY,CBUF,LBUF)
         LASX=I0
         LASY=J0
         IF(NPTS.EQ.0) THEN
            LBUF=LBUF+1
            CBUF(LBUF:LBUF)=CHAR(IS2)
            WRITE(LUN,11) CBUF(:LBUF)
 11         FORMAT(A)
            LBUF=0
         END IF
      END IF
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C- (not possible but can be called).
 210  RETURN
C-----------------------------------------------------------------------
      END

C*GRVA01 -- PGPLOT Canon Printer driver, line segment

      SUBROUTINE GRVA01 (LUN,I0,J0,I1,J1)
C-----------------------------------------------------------------------
C Canon device driver support routine.  Draws a line segment.
C Current routine plots end line segment as a separate polyline.
C This can be improved.
C
C I0,J0         I  I    The coordinate of the start point.
C I1,J1         I  I    The coordinate of the end point.
C
C 26-JUN-86 - [AFT]
C-----------------------------------------------------------------------
      INTEGER    IS2
      PARAMETER (IS2=30)
      INTEGER   LUN, I0, J0, I1, J1
      INTEGER   LBUF, IX, IY
      CHARACTER CBUF*64
C---
      CBUF(1:1)='1'
      LBUF=1
      CALL GRVA04(I0,CBUF,LBUF)
      CALL GRVA04(J0,CBUF,LBUF)
      IX=I1-I0
      IY=J1-J0
      CALL GRVA04(IX,CBUF,LBUF)
      CALL GRVA04(IY,CBUF,LBUF)
      LBUF=LBUF+1
      CBUF(LBUF:LBUF)=CHAR(IS2)
      WRITE(LUN,11) CBUF(1:LBUF)
 11   FORMAT(A)
      RETURN
      END

C*GRVA03 -- PGPLOT Canon Printer driver, begin/end

      SUBROUTINE GRVA03(LUN,ICMD)
C-----------------------------------------------------------------------
C Canon device driver support routine.  Outputs to LUN the string
C that begins a new picture (ICMD=1) or ends the current picture (ICMD=2).
C
C- LUN          I  I    Logical unit of output file.
C- ICMD         I  I    =1 to begin plot, =2 to terminate plot.
C
C 26-Jun-1986 - [AFT]
C 18-Jan-1988 - Change close brace to CHAR(125) [AFT]
C 13-Nov-1991 - [MCS, Jodrell Bank, England] Noticed aliasing when
C               modified PGGRAY stipple pattern to be sinusoidal.
C               Error traced to scale factor set at 0.8mm
C               instead of 1 dot => 1/300 = 0.84667mm corrected by
C               specifying scale factor in integral dots.
C-----------------------------------------------------------------------
      INTEGER    IESC,    IS2
      PARAMETER (IESC=27, IS2=30)
      INTEGER   LUN,ICMD
      CHARACTER CBUF*32
C---
 11   FORMAT(A)
C---
      IF(ICMD.EQ.1) THEN
C- Go to ISO mode (ignored if in ISO mode already), Hard reset,
C- and then go to ISO again (in case dip switches set to Diablo).
         CBUF( 1: 4)=CHAR(IESC)//';'//CHAR(IESC)//'c'
         CBUF( 5: 6)=CHAR(IESC)//';'
C- Enable full paint mode.
         CBUF( 7:10)=CHAR(155)//'2&z'
C- Go to vector mode.
         CBUF(11:13)=CHAR(155)//'&'//CHAR(125)
C- Begin picture
         CBUF(14:21)='#PGPLOT'//CHAR(IS2)
C- Scaling mode 1 pixel, Begin picture body.
         CBUF(22:28)='!0#1'//CHAR(IS2)//'$'//CHAR(IS2)
         WRITE(LUN,11) CBUF(1:28)
      ELSE IF(ICMD.EQ.2) THEN
C- End picture, Return to text (0,0)
         CBUF(1:7)='%'//CHAR(IS2)//CHAR(125)//'p00'//CHAR(IS2)
         WRITE(LUN,11) CBUF(1: 7)
      END IF
      RETURN
      END

C*GRVA04 -- PGPLOT Canon Printer driver, convert integer

      SUBROUTINE GRVA04(NUM,CBUF,LBUF)
C-----------------------------------------------------------------------
C Canon device driver support routine.  Converts an integer into
C the form used by the Canon Laser printer.
C
C- NUM          I   I   Integer to be converted.
C- CBUF         I/O C*  Buffer string
C- LBUF         I/O I   Number of characters used in CBUF.
C
C 26-Jun-86 - [AFT]
C-----------------------------------------------------------------------
      CHARACTER CBUF*(*)
      INTEGER   NUM, LBUF
      INTEGER   ITMP, IS, IC
      CHARACTER CTMP*5
C---
      ITMP=NUM
C- Bit 4(=16) is set for positive numbers and clear for negative.
      IS=16
      IF(ITMP.LT.0) THEN
         IS=0
         ITMP=-ITMP
      END IF
C- Bits 6+7(=64,128) clear and Bit 5(=32) set, flags that this
C- is the last byte in the number.
      CTMP(5:5)=CHAR(32+IS+IAND(ITMP,15))
      ITMP=ITMP/16
      IC=1
      IF(ITMP.EQ.0) THEN
C- Numbers in the range -15 to +15 can be sent in one byte.
         CBUF(LBUF+1:LBUF+1)=CTMP(5:5)
      ELSE
C- Larger numbers require more bytes and are recorded 6 bits
C- per byte with bit 7=(128) clear and bit 6(=64) set.
 150     CTMP(5-IC:5-IC)=CHAR(64+IAND(ITMP,63))
         IC=IC+1
         ITMP=ITMP/64
         IF(ITMP.NE.0) GOTO 150
         CBUF(LBUF+1:LBUF+IC)=CTMP(6-IC:5)
      END IF
      LBUF=LBUF+IC
      RETURN
      END

C*PGNCUR -- mark a set of points using the cursor
C%void cpgncur(int maxpt, int *npt, float *x, float *y, int symbol);
C+
      SUBROUTINE PGNCUR (MAXPT, NPT, X, Y, SYMBOL)
      INTEGER MAXPT, NPT
      REAL    X(*), Y(*)
      INTEGER SYMBOL
C
C Interactive routine for user to enter data points by use of
C the cursor.  Routine allows user to Add and Delete points.  The
C points are returned in order of increasing x-coordinate, not in the
C order they were entered.
C
C Arguments:
C  MAXPT  (input)  : maximum number of points that may be accepted.
C  NPT    (in/out) : number of points entered; should be zero on
C                    first call.
C  X      (in/out) : array of x-coordinates.
C  Y      (in/out) : array of y-coordinates.
C  SYMBOL (input)  : code number of symbol to use for marking
C                    entered points (see PGPT).
C
C Note (1): The dimension of arrays X and Y must be greater than or
C equal to MAXPT.
C
C Note (2): On return from the program, cursor points are returned in
C increasing order of X. Routine may be (re-)called with points
C already defined in X,Y (number in NPT), and they will be plotted
C first, before editing.
C
C Note (3): User commands: the user types single-character commands
C after positioning the cursor: the following are accepted:
C A (Add)    - add point at current cursor location.
C D (Delete) - delete nearest point to cursor.
C X (eXit)   - leave subroutine.
C--
C 27-Nov-1983
C  9-Jul-1983 - modified to use GRSCI instead of GRSETLI [TJP].
C 13-Dec-1990 - changed warnings to messages [TJP].
C  2-Aug-1995 - [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      CHARACTER*1 LETTER
      LOGICAL  PGNOTO
      INTEGER  PGCURS, I, J, SAVCOL
      REAL     DELTA, XP, YP, XPHYS, YPHYS
      REAL     XMIN, XIP, YIP
      REAL     XBLC, XTRC, YBLC, YTRC
C
C Check that PGPLOT is in the correct state.
C
      IF (PGNOTO('PGNCUR')) RETURN
C
C Save current color.
C
      CALL GRQCI(SAVCOL)
C
C Put current points on screen.
C
      IF (NPT.NE.0) CALL PGPT(NPT,X,Y,SYMBOL)
C
C Start with the cursor in the middle of the viewport.
C
      CALL PGQWIN(XBLC, XTRC, YBLC, YTRC)
      XP = 0.5*(XBLC+XTRC)
      YP = 0.5*(YBLC+YTRC)
C
C Loop over cursor inputs.
C
  100 IF (PGCURS(XP,YP,LETTER).NE.1) RETURN
      IF (LETTER.EQ.CHAR(0)) RETURN
      CALL GRTOUP(LETTER,LETTER)
C
C A (ADD) command:
C
      IF (LETTER .EQ. 'A') THEN
          IF (NPT.GE.MAXPT) THEN
              CALL GRMSG('ADD ignored (too many points).')
              GOTO 100
          END IF
C         ! Find what current points new point is between.
          DO 120 J=1,NPT
              IF (XP.LT.X(J)) GOTO 122
  120     CONTINUE
          J = NPT + 1
C         ! New point is beyond last current
  122     CONTINUE
C         ! J is vector location where new point should be included.
          DO 140 I=NPT,J,-1
              X(I+1) = X(I)
              Y(I+1) = Y(I)
  140     CONTINUE
          NPT = NPT + 1
C         ! Add new point to point array.
          X(J) = XP
          Y(J) = YP
          CALL PGPT(1,X(J),Y(J),SYMBOL)
          CALL GRTERM
C
C D (DELETE) command:
C
      ELSE IF (LETTER.EQ.'D') THEN
          IF (NPT.LE.0) THEN
              CALL GRMSG('DELETE ignored (there are no points left).')
              GOTO 100
          END IF
          XMIN = 1.E+08
C         ! Look for point closest in radius.
C         ! Convert cursor points to physical.
          XPHYS = PGXORG(PGID) + XP*PGXSCL(PGID)
          YPHYS = PGYORG(PGID) + YP*PGYSCL(PGID)
          DO 220 I=1,NPT
C             ! Convert array points to physical.
              XIP = PGXORG(PGID) + X(I)*PGXSCL(PGID)
              YIP = PGYORG(PGID) + Y(I)*PGYSCL(PGID)
              DELTA = SQRT( (XIP-XPHYS)**2 + (YIP-YPHYS)**2 )
              IF (DELTA.LT.XMIN) THEN
                 XMIN = DELTA
                 J = I
              END IF
  220     CONTINUE
C         ! Remove point from screen by writing in background color.
          CALL GRSCI(0)
          CALL PGPT(1,X(J),Y(J),SYMBOL)
          CALL GRSCI(SAVCOL)
          CALL GRTERM
C         ! Remove point from cursor array.
          NPT = NPT-1
          DO 240 I=J,NPT
              X(I) = X(I+1)
              Y(I) = Y(I+1)
  240     CONTINUE
C
C X (EXIT) command:
C
      ELSE IF (LETTER.EQ.'X') THEN
          CALL GRETXT
          RETURN
C
C Illegal command:
C
      ELSE
          CALL GRMSG('Commands are A (add), D (delete), X (exit).')
      END IF
C
      GOTO 100
      END

C*GRSETS -- change size of view surface
C+
      SUBROUTINE GRSETS (IDENT,XSIZE,YSIZE)
C
C GRPCKG : change size of plotting area. The requested dimensions
C will be reduced to the absolute maximum of the plot device if
C necessary.
C
C Arguments:
C
C IDENT (input, integer): plot identifier from GROPEN.
C XSIZE (input, real): new x dimension of plot area (absolute
C               units); if less than zero, the default dimension
C               will be used.
C YSIZE (input, real): new y dimension of plot area (absolute
C               units); if less than zero, the default dimension
C               will be used.
C--
C (1-Feb-1983)
C  5-Aug-1986 - add GREXEC support [AFT].
C  5-Jan-1993 - set GRADJU [TJP].
C------------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  I, IDENT, J, IX, IY, NBUF,LCHR
      REAL     RBUF(6)
      CHARACTER CHR
      REAL     XSIZE,YSIZE
C
      CALL GRSLCT(IDENT)
C     write (*,*) 'GRSETS: old size', GRXMXA(IDENT), GRYMXA(IDENT)
      CALL GRPAGE
      IF ((XSIZE .LT. 0.0) .OR. (YSIZE .LT. 0.0)) THEN
          CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR)
          GRXMXA(IDENT) = RBUF(2)
          GRYMXA(IDENT) = RBUF(4)
      ELSE
          I = NINT(XSIZE)
          J = NINT(YSIZE)
          CALL GREXEC(GRGTYP, 2,RBUF,NBUF,CHR,LCHR)
          IX=RBUF(2)
          IY=RBUF(4)
          IF (IX.GT.0) I = MIN(I,IX)
          IF (IY.GT.0) J = MIN(J,IY)
          GRXMXA(IDENT) = I
          GRYMXA(IDENT) = J
      END IF
C     write (*,*) 'GRSETS: new size', GRXMXA(IDENT), GRYMXA(IDENT)
      GRXMIN(IDENT) = 0
      GRXMAX(IDENT) = GRXMXA(IDENT)
      GRYMIN(IDENT) = 0
      GRYMAX(IDENT) = GRYMXA(IDENT)
      GRADJU(IDENT) = .TRUE.
C
      END

C*PGNCURSE -- non-standard alias for PGNCUR
C+
      SUBROUTINE PGNCURSE (MAXPT, NPT, X, Y, SYMBOL)
      INTEGER MAXPT, NPT
      REAL    X(*), Y(*)
      INTEGER SYMBOL
C
C See description of PGNCUR.
C--
      CALL PGNCUR (MAXPT, NPT, X, Y, SYMBOL)
      END

C*GRDOT1 -- draw dots
C+
      SUBROUTINE GRDOT1(POINTS, X, Y)
      INTEGER POINTS
      REAL X(POINTS), Y(POINTS)
C
C GRPCKG (internal routine): Draw a set of dots.
C
C Arguments:
C
C POINTS (input, integer): the number of coordinate pairs.
C X, Y (input, real arrays, dimensioned POINTS or greater): the
C       X and Y world coordinates of the points.
C--
C 14-Mar-1997 - new routine to optimize drawing many dots [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  I, NBUF, LCHR
      REAL     RBUF(2), XP, YP
      CHARACTER CHR
      EQUIVALENCE (XP, RBUF(1)), (YP, RBUF(2))
C
C Begin picture if necessary.
C
      IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
C
C Loop for points: driver support.
C
      IF (GRWIDT(GRCIDE).LE.1) THEN
         NBUF = 2
         LCHR = 0
         DO 10 I=1,POINTS
C        -- Convert to device coordinates
            XP = X(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
            YP = Y(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
C           -- Clip against viewport
            IF (XP .GE. GRXMIN(GRCIDE) .AND.
     :          XP .LE. GRXMAX(GRCIDE) .AND.
     :          YP .GE. GRYMIN(GRCIDE) .AND.
     :          YP .LE. GRYMAX(GRCIDE)) THEN
               CALL GREXEC(GRGTYP,13,RBUF,NBUF,CHR,LCHR)
            END IF
 10      CONTINUE
C
C Thick line emulation required.
C
      ELSE
         DO 20 I=1,POINTS
C        -- Convert to device coordinates
            XP = X(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
            YP = Y(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
C           -- Clip against viewport
            IF (XP .GE. GRXMIN(GRCIDE) .AND.
     :          XP .LE. GRXMAX(GRCIDE) .AND.
     :          YP .GE. GRYMIN(GRCIDE) .AND.
     :          YP .LE. GRYMAX(GRCIDE)) THEN
               CALL GRLIN3(XP, YP, XP, YP)
            END IF
 20      CONTINUE
      END IF
C
C New pen position.
C
      GRXPRE(GRCIDE) = XP
      GRYPRE(GRCIDE) = YP
C
      END

C*GRGMSG -- print system message (VMS)
C+
      SUBROUTINE GRGMSG (STATUS)
      INTEGER STATUS
C
C This routine obtains the text of the VMS system message corresponding
C to code STATUS, and displays it using routine GRWARN.
C
C Argument:
C  STATUS (input): 32-bit system message code.
C--
C 18-Feb-1988
C-----------------------------------------------------------------------
      CHARACTER*80 BUFFER
      INTEGER  LENGTH, MSGLEN
C
      CALL SYS$GETMSG(%VAL(STATUS),MSGLEN,BUFFER,%VAL(1),)
      LENGTH = INDEX(BUFFER(1:MSGLEN),'!')
      IF (LENGTH.GT.1) MSGLEN = LENGTH-1
      CALL GRWARN(BUFFER(1:MSGLEN))
      END

*     This program demonstrates animation and 3D geometry in PGPLOT. It 
*     requires a fast, interactive display, e.g., /XWIN. Do not
*     specify a hardcopy device. The speed of the animation is limited by
*     the cpu speed of the host computer.
*     
*     Thanks to Dr Martin Weisser:
*     Date: Sun, 18 May 1997 16:14:01 CET
*     From: weisser@chclu.chemie.uni-konstanz.de


      PROGRAM PGDEM17
C-----------------------------------------------------------------------
C     Demonstration program for PGPLOT.
C-----------------------------------------------------------------------
      INTEGER PGOPEN
C
      WRITE (*,*) 'PGPLOT: Demonstration of animation and 3D geometry'
      WRITE (*,*) 'Select a fast, interactive device, e.g., /XWINDOW'
      IF (PGOPEN('?') .LE. 0) STOP
      CALL POLY3D
      CALL PGCLOS
C-----------------------------------------------------------------------
      END

      SUBROUTINE POLY3D
C     
      INTEGER NFRAMS
C     
      INTEGER NTOT, NLIN, IPOS, IFIRST          
      REAL T, T1, T2, T3, PI, W, W1, TET, TET1, ROT, ROT1
C     
      PARAMETER (NTOT=34)
      PARAMETER (T=1.618)
      PARAMETER (T1=1.0+T)
      PARAMETER (T2=-T)
      PARAMETER (T3=-T1)
      PARAMETER (W=0.60*T)
      PARAMETER (W1=-W)
      PARAMETER (TET=0.37)
      PARAMETER (TET1=-TET)
      PARAMETER (ROT=0.13)
      PARAMETER (ROT1=-ROT)
      PARAMETER (NLIN=49)
C     
      INTEGER I, J, L, III, ILINE, NTOTM6
      INTEGER ICDFOR, ICCFOR, ICTFOR, ICLFOR
      INTEGER ICDBCK, ICCBCK, ICTBCK, ICLBCK
      INTEGER ITYPE(NTOT), IARRAY(NLIN), JARRAY(NLIN), LITYPE(NLIN)
      REAL RQ, ZZ
      REAL THAXI1, PHAXI1, ALFA1, THAXI2, PHAXI2, ALFA2
      REAL THAXI3, PHAXI3, ALFA3, THAXI4, PHAXI4, ALFA4 
      REAL XOFF, YOFF, ZOFF
      REAL XARRAY(NTOT), YARRAY(NTOT), ZARRAY(NTOT), DISTAN(NLIN)
      REAL POLYS(3,NTOT), X(2), Y(2), C(3), CROT(3), RPOL(3,3)
      PARAMETER (PI=3.14159265359)
C     
C     Cartesian coordinates of the polygons 
C     
      DATA POLYS/ T, T, T,       T, T,T2,
     D     T,T2, T,       T,T2,T2,
     D     T2, T, T,      T2, T,T2,
     D     T2,T2, T,      T2,T2,T2,
     D     T1,1.0,0.0,    T1,-1.0,0.0,
     D     T3,1.0,0.0,    T3,-1.0,0.0,
     D     0.0,T1,1.0,    0.0,T1,-1.0,
     D     0.0,T3,1.0,    0.0,T3,-1.0,
     D     1.0,0.0,T1,    -1.0,0.0,T1,
     D     1.0,0.0,T3,   -1.0,0.0,T3, 
     C     W,    W,    W,     W,    W,   W1,
     C     W,   W1,    W,     W,   W1,   W1,
     C     W1,    W,    W,    W1,   W1,    W,
     C     W1,    W,   W1,    W1,   W1,   W1,                
     T     TET,  TET,  TET, TET1, TET1,  TET,
     T     TET1,  TET, TET1,  TET, TET1, TET1, 
     L     ROT,  0.0,  0.0, ROT1,  0.0,  0.0/
C     
      DATA ITYPE/1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     C     2,2,2,2,2,2,2,2,
     T     3,3,3,3,
     L     4,4/
C     
C     Initialize the plot (no labels).
C     
      CALL PGENV(-3.2,3.2,-3.2,3.2,1,-2)
C     
C     Switch from page to page without typing return.  
C     
      CALL PGASK(.FALSE.)
C     
C     Rotation axis of the polygons 
C     
      THAXI1 = PI/4.0
      PHAXI1 = PI/4.5
      ALFA1  = 0.0
      THAXI2 = PI/6.0
      PHAXI2 = 0.0
      ALFA2  = 0.02
      THAXI3 = PI/2.0
      PHAXI3 = -PI/3.0
      ALFA3  = 0.0
      THAXI4 = -0.03
      PHAXI4 = PI/7.0
      ALFA4  = 0.9
C     
      XOFF=0.0
      YOFF=0.0
      ZOFF=0.0
      NTOTM6=NTOT-6
C     
C     Colors  
C     
      ICDFOR = 3
      ICDBCK = 10
C     
      ICCFOR = 8
      ICCBCK = 2
C     
      ICTFOR = 5
      ICTBCK = 4
C     
      ICLFOR = 1
      ICLBCK = 7
C     
      IPOS=1
C     
      WRITE(*,*)' Rotation with increasing velocity'
C     
      NFRAMS=3500 
C     
      DO 12 I=1,NTOT
         XARRAY(I) = POLYS(1,I)
         YARRAY(I) = POLYS(2,I)
         ZARRAY(I) = POLYS(3,I)
 12   CONTINUE
C     
      DO 30 L=1,NFRAMS
C     
         CALL PGBBUF
         CALL PGERAS
C     
         CALL SORTPP(NTOT,ITYPE,ZARRAY,YARRAY,XARRAY)
C     
         IFIRST=0
         DO 13 I=1,NTOT
            IF((ZARRAY(I).GE.0.0).AND.(IFIRST.EQ.0)) THEN
               IFIRST = 1
               IPOS = I
            END IF
 13      CONTINUE
C     
         IF(L.EQ.2800) CALL OFFSET (XOFF,YOFF,ZOFF)
         IF (MOD(L,500).EQ.0) THEN 
            CALL CHNAX(THAXI3,PHAXI3,THAXI2,PHAXI2,THAXI1,PHAXI1)
         END IF
C     
         DO 33 I=1,IPOS-1
            IF (ITYPE(I).EQ.1) THEN 
               CALL PGSCI(ICDBCK)
               CALL PGSLW(18)
            ELSE IF (ITYPE(I).EQ.2) THEN 
               CALL PGSCI(ICCBCK)
               CALL PGSLW(17)
            ELSE IF (ITYPE(I).EQ.3) THEN
               CALL PGSCI(ICTBCK)
               CALL PGSLW(15)
            ELSE 
               CALL PGSCI(ICLBCK)
               CALL PGSLW(14)
            END IF
            ZZ = ZARRAY(I)
            CALL PGPT(1,XARRAY(I)+0.2*ZZ,YARRAY(I)+0.3*ZZ,9)
 33      CONTINUE
C     
         DO 44 I=IPOS,NTOT
            IF (ITYPE(I).EQ.1) THEN 
               CALL PGSCI(ICDFOR)
               CALL PGSLW(18)
            ELSE IF (ITYPE(I).EQ.2) THEN 
               CALL PGSCI(ICCFOR)
               CALL PGSLW(17)
            ELSE IF (ITYPE(I).EQ.3) THEN
               CALL PGSCI(ICTFOR)
               CALL PGSLW(15)
            ELSE 
               CALL PGSCI(ICLFOR)
               CALL PGSLW(14)
            END IF
            ZZ = ZARRAY(I)
            CALL PGPT(1,XARRAY(I)+0.2*ZZ,YARRAY(I)+0.3*ZZ,9)
 44      CONTINUE
C     
         ILINE=0
C     
         DO 2000 I=2,NTOT
            DO 1000 J=1,I-1
               IF (ITYPE(I).EQ.ITYPE(J)) THEN
                  RQ = 0.0
                  RQ = RQ + ( (XARRAY(I)-XARRAY(J))**2+
     #                 (YARRAY(I)-YARRAY(J))**2+
     #                 (ZARRAY(I)-ZARRAY(J))**2  )
C     
                  IF ( ((RQ-0.0676)  .LT.0.001).OR.
     #                 ((RQ-1.095199).LT.0.001).OR.          
     #                 ((RQ-3.769809).LT.0.001).OR.
     #                 ((RQ-4.000000).LT.0.001)     ) THEN 
                     ILINE = ILINE + 1
                     DISTAN(ILINE) = ZARRAY(I)+ZARRAY(J)
                     IF(DISTAN(ILINE).LT.0.0) THEN 
                        LITYPE(ILINE) = -ITYPE(I)
                     ELSE  
                        LITYPE(ILINE) =  ITYPE(I)
                     END IF 
                     IARRAY(ILINE) = I
                     JARRAY(ILINE) = J
                  END IF
               END IF
 1000       CONTINUE
 2000    CONTINUE
C     
         CALL SORTLI(ILINE,DISTAN,IARRAY,JARRAY,LITYPE)
C     
         DO 3000 III=1,ILINE
            I=IARRAY(III)
            J=JARRAY(III)               
            ZZ = ZARRAY(I)
            X(1) = XARRAY(I)+0.2*ZZ
            Y(1) = YARRAY(I)+0.3*ZZ
            ZZ = ZARRAY(J)
            X(2) = XARRAY(J)+0.2*ZZ
            Y(2) = YARRAY(J)+0.3*ZZ
            IF (LITYPE(III).GT.0) THEN
               IF(LITYPE(III).EQ.1) THEN  
                  CALL PGSLW(10)
                  CALL PGSCI(ICDFOR)
               ELSE IF (LITYPE(III).EQ.2) THEN          
                  CALL PGSLW(8)
                  CALL PGSCI(ICCFOR)
               ELSE IF (LITYPE(III).EQ.3) THEN
                  CALL PGSLW(6)
                  CALL PGSCI(ICTFOR)
               ELSE
                  CALL PGSLW(4)
                  CALL PGSCI(ICLFOR)
               END IF
            ELSE
               IF(LITYPE(III).EQ.-1) THEN  
                  CALL PGSLW(7)
                  CALL PGSCI(ICDBCK)
               ELSE IF (LITYPE(III).EQ.-2) THEN          
                  CALL PGSLW(4)
                  CALL PGSCI(ICCBCK)
               ELSE IF (LITYPE(III).EQ.-3) THEN
                  CALL PGSLW(3)
                  CALL PGSCI(ICTBCK)
               ELSE
                  CALL PGSLW(2)
                  CALL PGSCI(ICLBCK)
               END IF
            END IF
            CALL PGLINE(2,X,Y)
 3000    CONTINUE
C     
         DO 45 I=NTOTM6,NTOT
            IF (ITYPE(I).EQ.1) THEN 
               CALL PGSCI(ICDFOR)
               CALL PGSLW(19)
               ZZ = ZARRAY(I)
               CALL PGPT(1,XARRAY(I)+0.2*ZZ,YARRAY(I)+0.3*ZZ,9)
            END IF 
 45      CONTINUE          
C     
         DO 4000 III=1,NTOT
            IF (ITYPE(III).EQ.1) THEN 
               CALL POLMAT(RPOL,THAXI1,PHAXI1,ALFA1)
            ELSE IF (ITYPE(III).EQ.2) THEN 
               CALL POLMAT(RPOL,THAXI2,PHAXI2,ALFA2)
            ELSE IF (ITYPE(III).EQ.3) THEN 
               CALL POLMAT(RPOL,THAXI3,PHAXI3,ALFA3)
            ELSE
               CALL POLMAT(RPOL,THAXI4,PHAXI4,ALFA4)
            END IF
            C(1)=XARRAY(III)
            C(2)=YARRAY(III)
            C(3)=ZARRAY(III)
            CALL MMULT (C,RPOL,CROT)
            XARRAY(III)=CROT(1)+XOFF
            YARRAY(III)=CROT(2)+YOFF
            ZARRAY(III)=CROT(3)+ZOFF
 4000    CONTINUE
C     
         ALFA1 = ALFA1+1.5E-5*(1.0+2.0*L/4000.)
         ALFA2 = ALFA2-2.0E-5*(1.0+4.0*L/4000.)
         ALFA3 = ALFA3-4.0E-5*(1.0+3.0*L/4000.)
C     
         CALL PGEBUF
C     
 30   CONTINUE
C     
C-----------------------------------------------------------------------
      END

      SUBROUTINE MMULT (VECTOR,RMATRX,ROTVEC)
C     
C     Matrix multiplication 
C     
      REAL VECTOR(3)
      REAL ROTVEC(3)
      REAL RMATRX(3,3)
C     
      ROTVEC(1)=RMATRX(1,1)*VECTOR(1)+RMATRX(1,2)*VECTOR(2)+
     #          RMATRX(1,3)*VECTOR(3)
      ROTVEC(2)=RMATRX(2,1)*VECTOR(1)+RMATRX(2,2)*VECTOR(2)+
     #          RMATRX(2,3)*VECTOR(3)
      ROTVEC(3)=RMATRX(3,1)*VECTOR(1)+RMATRX(3,2)*VECTOR(2)+
     #          RMATRX(3,3)*VECTOR(3)
C     
      RETURN
      END        

      SUBROUTINE POLMAT(RPOL,THAXI,PHAXI,ALFA)
C     
      REAL THAXI,PHAXI,ALFA
      REAL RPOL(3,3)
      REAL SINT,SINTQ,SINP,SINPQ,SINA
      REAL COST,COSTQ,COSP,COSPQ,COSA,EMCOSA
C     
      SINT = SIN(THAXI)
      COST = COS(THAXI)
      SINP = SIN(PHAXI)
      COSP = COS(PHAXI)
      SINA = SIN(ALFA)
      COSA = COS(ALFA)
      EMCOSA = 1.0-COSA
C     
      SINTQ = SINT*SINT
      COSTQ = COST*COST
      SINPQ = SINP*SINP
      COSPQ = COSP*COSP
C     
      RPOL(1,1) =  COSA+COSPQ*SINTQ*EMCOSA
      RPOL(2,1) =  COST*SINA+SINP*COSP*SINTQ*EMCOSA
      RPOL(3,1) = -SINP*SINT*SINA+SINT*COST*COSP*EMCOSA
      RPOL(1,2) = -COST*SINA+SINP*COSP*SINTQ*EMCOSA
      RPOL(2,2) =  COSA+SINPQ*SINTQ*EMCOSA
      RPOL(2,3) = -COSP*SINT*SINA+SINP*SINT*COST*EMCOSA
      RPOL(1,3) =  SINP*SINT*SINA+SINT*COST*COSP*EMCOSA
      RPOL(3,2) =  COSP*SINT*SINA+COST*SINT*SINP*EMCOSA
      RPOL(3,3) =  COSA+COSTQ*EMCOSA
C     
      RETURN 
      END

      SUBROUTINE SORTPP(N,ITYPE,RA1,RA2,RA3)
C     
      REAL RA1, RA2, RA3, RRA1, RRA2, RRA3
      INTEGER ITYPE(*), L, N, IR, I, J, IRRA1
      DIMENSION RA1(*), RA2(*), RA3(*)
      L=N/2+1
      IR=N
 10   CONTINUE
      IF(L.GT.1)THEN
         L=L-1
         RRA1=RA1(L)
         IRRA1=ITYPE(L)
         RRA2=RA2(L)
         RRA3=RA3(L)
      ELSE
         RRA1=RA1(IR)
         IRRA1=ITYPE(IR)
         RRA2=RA2(IR)
         RRA3=RA3(IR)
         RA1(IR)=RA1(1)
         ITYPE(IR)=ITYPE(1)
         RA2(IR)=RA2(1)
         RA3(IR)=RA3(1)
         IR=IR-1
         IF(IR.EQ.1)THEN
            RA1(1)=RRA1
            ITYPE(1)=IRRA1
            RA2(1)=RRA2
            RA3(1)=RRA3
            RETURN
         ENDIF
      ENDIF
      I=L
      J=L+L
 20   IF(J.LE.IR)THEN
         IF(J.LT.IR)THEN
            IF(RA1(J).LT.RA1(J+1))J=J+1
         ENDIF
         IF(RRA1.LT.RA1(J))THEN
            RA1(I)=RA1(J)
            ITYPE(I)=ITYPE(J)
            RA2(I)=RA2(J)
            RA3(I)=RA3(J)
            I=J
            J=J+J
         ELSE
            J=IR+1
         ENDIF
         GO TO 20
      ENDIF
      RA1(I)=RRA1
      ITYPE(I)=IRRA1
      RA2(I)=RRA2
      RA3(I)=RRA3
      GO TO 10
      END
C     
      SUBROUTINE SORTLI(N,RA1,IA1,IA2,IA3)
C     
      REAL RA1, RRA1
      INTEGER L, N, IR, I, J, IRA1, IRA2, IRA3, IA1, IA2, IA3
      DIMENSION RA1(*), IA1(*), IA2(*) , IA3(*)
      L=N/2+1
      IR=N
 10   CONTINUE
      IF(L.GT.1)THEN
         L=L-1
         RRA1=RA1(L)
         IRA1=IA1(L)
         IRA2=IA2(L)
         IRA3=IA3(L)
      ELSE
         RRA1=RA1(IR)
         IRA1=IA1(IR)
         IRA2=IA2(IR)
         IRA3=IA3(IR)
         RA1(IR)=RA1(1)
         IA1(IR)=IA1(1)
         IA2(IR)=IA2(1)
         IA3(IR)=IA3(1)
         IR=IR-1
         IF(IR.EQ.1)THEN
            RA1(1)=RRA1
            IA1(1)=IRA1
            IA2(1)=IRA2
            IA3(1)=IRA3
            RETURN
         ENDIF
      ENDIF
      I=L
      J=L+L
 20   IF(J.LE.IR)THEN
         IF(J.LT.IR)THEN
            IF(RA1(J).LT.RA1(J+1))J=J+1
         ENDIF
         IF(RRA1.LT.RA1(J))THEN
            RA1(I)=RA1(J)
            IA1(I)=IA1(J)
            IA2(I)=IA2(J)
            IA3(I)=IA3(J)
            I=J
            J=J+J
         ELSE
            J=IR+1
         ENDIF
         GO TO 20
      ENDIF
      RA1(I)=RRA1
      IA1(I)=IRA1
      IA2(I)=IRA2
      IA3(I)=IRA3
      GO TO 10
      END

      SUBROUTINE OFFSET (XOFF,YOFF,ZOFF)
C
      REAL XOFF,YOFF,ZOFF
C
      WRITE(*,*)' Rotation with shifting'
      XOFF=-0.0002
      YOFF=+0.0004
      ZOFF=-0.0002
      RETURN
      END

      SUBROUTINE CHNAX
     #     (THAXI3,PHAXI3,THAXI2,PHAXI2,THAXI1,PHAXI1)
C     
      REAL THAXI1,PHAXI1,PHAXI2,THAXI2,PHAXI3,THAXI3,PI
      PARAMETER (PI=3.14159265359)
C     
      THAXI3 = THAXI3 - PI*0.32
      PHAXI3 = PHAXI3 + PI*0.28
      THAXI2 = THAXI2 + PI*0.18
      PHAXI2 = PHAXI2 - PI*0.14
      THAXI1 = THAXI1 - PI*0.12
      PHAXI1 = PHAXI1 + PI*0.08
C     
      RETURN
      END

C*VTDRIV -- PGPLOT Regis (VT125) driver
C+
      SUBROUTINE VTDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Regis devices.
C
C Version 1.1 - 1987 Aug 17 - add cursor (TJP).
C Version 1.3 - 1988 Mar 23 - add rectangle fill.
C Version 1.4 - 1991 Nov  6 - standardization (TJP).
C Version 1.5 - 1993 May 26 - more standardization (TJP).
C Version 1.6 - 1993 Jun  4 - add SAVE statements, use GRxTER routines (AFT)
C
C Supported devices: Digital Equipment Corporation VT125, VT240, or
C VT241 terminal; other REGIS devices may also work.
C
C Device type code: /VT125.
C
C Default file name: TT:PGPLOT.VTPLOT. This usually means the
C terminal you are logged in to (logical name TT), but the plot can be
C sent to another terminal by giving the device name, eg, TTC0:/VT, or
C it can be saved in a file by specifying a file name, eg,
C CITSCR:[TJP]XPLOT/VT (in this case a disk name must be included as
C part of the file name).
C
C Default view surface dimensions: Depends on monitor.
C
C Resolution: The default view surface is 768 (horizontal) x
C 460 (vertical) pixels.  On most Regis devices, the resolution is
C degraded in the vertical direction giving only 230 distinguishable
C raster lines. (There are actually 240 raster lines, but 10 are reserved
C for a line of text.)
C
C Color capability:  Color indices 0--3 are supported. By default,
C color index 0 is black (the background color). Color indices 1--3
C are white, red, and green on color monitors, or white, dark grey, and
C light grey on monochrome monitors.  The color representation of all
C the color indices can be changed, although only a finite number of
C different colors can be obtained (see the manual for the terminal).
C
C Input capability: The graphics cursor is a blinking
C diamond-crosshair. The user positions the cursor using the arrow keys
C and PF1--PF4 keys on his keyboard  [Note: NOT the keyboard of
C the terminal on which he is plotting, if that is different.]
C The arrow keys move the cursor in the appropriate direction; the size
C of the step for each keystroke is controlled by the PF1--PF4 keys: PF1
C -> 1 pixel, PF2 -> 4 pixels, PF3 -> 16 pixels, PF4 -> 64 pixels. [The
C VT240 terminal has a built-in capability to position the cursor, but
C PGPLOT does not use this as it is not available on the VT125.] The
C user indicates that the cursor has been positioned by typing any
C character other than an arrow or PF1-PF4 key [control characters, eg,
C control-C, and other special characters should be avoided, as they
C may be intercepted by the operating system].
C
C File format: A REGIS plot file is formatted in records of 80
C characters or less, and has no carriage-control attributes. The
C records are grouped into ``buffers,'' each of which begins with
C <esc>Pp to put the terminal into graphics mode and ends with <esc>\
C to put it back into text mode.  The terminal is in graphics mode only
C while a buffer is being transmitted, so a user's program can write to
C the terminal at any time (in text mode) without worrying if it might
C be in graphics mode. Everything between the escape sequences is
C REGIS: see the VT125 or VT240 manual for an explanation.  PGPLOT
C attempts to minimize the number of characters in the REGIS commands,
C but REGIS is not a very efficient format. It does have the great
C advantage, though, that it can easily be examined with an editor.
C The file may also contain characters outside the <esc>Pp ... <esc>\
C delimiters, eg, escape sequences to erase the text screen and home
C the cursor.
C
C The following escape sequences are used:
C
C [2J Erase entire screen (text)
C [H  Move cursor to home position
C Pp  Enter REGIS graphics mode
C \   Leave REGIS graphics mode
C
C PGPLOT uses a very limited subset of the REGIS commands supported
C by the VT125 and VT240. The following list summarizes the REGIS
C commands presently used.
C
C Initialization: the following standard commands are used to initialize
C the device every time a new frame is started; most of these restore a
C VT125 or VT240 to its default state, but the screen addressing mode is
C nonstandard.
C
C ;                         resynchronize
C W(R)                      replace mode writing
C W(I3)                     color index 1
C W(F3)                     both bit planes
C W(M1)                     unit multiplier
C W(N0)                     negative off
C W(P1)                     pattern 1
C W(P(M2))                  pattern multiplier 2
C W(S0)                     shading off
C S(E)                      erase screen
C S(G1)                     select graphics plane [Rainbow REGIS]
C S(A[0,479][767,0])        screen addressing, origin at bottom left
C S(I0)                     background dark
C S(S1)                     scale 1
C S(M0(L0)(AL0))            output map section 0 (black)
C S(M1(L30)(AH120L50S100))  output map section 1 (red/dim grey)
C S(M2(L59)(AH240L50S100))  output map section 2 (green/light grey)
C S(M3(L100)(AL100))        output map section 3 (white)
C
C Drawing lines: the P and V commands are used with absolute
C coordinates, relative coordinates, and pixel vectors. The (B)
C S), (E), and (W) modifiers are not used. Coordinates
C which do not change are omitted.
C
C P[x,y]                    move to position, eg P[499,0]
C V[x,y]                    draw vector to position, eg
C                           V[][767][,479][0][,0]
C
C Line attributes: the line style and line color attributes are
C specified with W commands, eg
C
C W(P2)                     line style 2
C W(I2)                     intensity (color index) 2
C
C and S commands are used to change the output map.  The PGPLOT color
C indices 0, 1, 2, 3 correspond to output map sections 0, 3, 1, 2.
C
C Obtaining hardcopy: A hardcopy of the plot can be obtained
C using a printer attached to the VT125/VT240 terminal (see the
C instruction manual for the terminal). A plot stored in disk file
C can be displayed by issuing a TYPE command (eg, TYPE PGPLOT.VTPLOT)
C on a VT125 or VT240.
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE, DEFNAM
      PARAMETER (TYPE='VT125 (DEC VT125 and other REGIS terminals)')
      PARAMETER (DEFNAM='PGPLOT.VTPLOT')
C
      CHARACTER*(*) VTINIT
      PARAMETER (VTINIT=';W(RI3F3M1N0P1P(M2)S0)S(E)'//
     1                  'S(G1A[0,479][767,0]I0S1)'//
     2                  'S(M0(L0)(AL0))'//
     3                  'S(M3(L100)(AL100))'//
     4                  'S(M1(L30)(AH120L50S100))'//
     5                  'S(M2(L59)(AH240L50S100))')
      CHARACTER*(*) CURSOR, VTERAS, VTHOME
      PARAMETER (CURSOR='[24;1f')
      PARAMETER (VTERAS='[2J')
      PARAMETER (VTHOME='[H')
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=500)
C
      INTEGER  IER, I0, J0, I1, J1, L, LASTI, LASTJ, UNIT
      SAVE LASTI, LASTJ, UNIT
      INTEGER  CI, NPTS, L1, L2, BUFLEV
      SAVE NPTS, BUFLEV
      INTEGER  MONO, IR, IG, IB, ICH, ICX, ICY, LTMP
      INTEGER  VTCODE(0:3)
      SAVE     VTCODE
      INTEGER  GROTER
      LOGICAL  APPEND
      SAVE     APPEND
      REAL     CH, CL, CS
      CHARACTER*(BUFSIZ) BUFFER
      SAVE BUFFER
      CHARACTER*80  CTEMP
      CHARACTER*64  INSTR
      CHARACTER*20  INSTR1,INSTR2
      CHARACTER*2   PIX(0:22)
      SAVE PIX
      DATA PIX    /'V5','V4','V3',7*'  ','V6',' ','V2',7*' ','V7',
     1             'V0','V1'/
      DATA VTCODE / 0, 3, 1, 2 /
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,110,120,
     :     130,140,150,160,170,180,190,200,210,220,230,240), IFUNC
  900 WRITE (CTEMP,901) IFUNC
  901 FORMAT('VTDRIV:  Unimplemented function:',I10)
      CALL GRWARN(CTEMP)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 767
      RBUF(3) = 0
      RBUF(4) = 479
      RBUF(5) = 0
      RBUF(6) = 3
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
   30 RBUF(1) = 100.0
      RBUF(2) = 100.0
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Interactive, Cursor, No dashed lines, No area fill,
C    No thick lines, Rectangle fill)
C
   40 CHR = 'ICNNNRNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CALL GRTRML(CHR, LCHR)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 767
      RBUF(3) = 0
      RBUF(4) = 459
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 1
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
      APPEND = RBUF(3).NE.0.0
      RBUF(1) = UNIT
      IER = GROTER(CHR, LCHR)
      IF (IER.LT.0) THEN
          LTMP = MIN(LEN(CTEMP), 34+LCHR)
          CTEMP = 'Unable to access graphics device: '//CHR(:LCHR)
          CALL GRWARN(CTEMP(1:LTMP))
          RBUF(2) = 0
      ELSE
          UNIT = IER
          RBUF(1) = IER
          RBUF(2) = 1
          NBUF = 2
      END IF
      BUFLEV = 0
      LASTI = -1
      LASTJ = -1
      NPTS = 0
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
C     -- reposition cursor
      LTMP = 1 + LEN(CURSOR)
      CALL GRWTER(UNIT, CHAR(27)//CURSOR, LTMP)
      CALL GRCTER(UNIT)
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
C     -- erase alpha screen and home cursor
      LTMP = 2 + LEN(VTERAS) + LEN(VTHOME)
      CALL GRWTER(UNIT, CHAR(27)//VTERAS//CHAR(27)//VTHOME, LTMP)
C     -- erase and initialize graphics screen
      IF (.NOT.APPEND) CALL GRVT02(VTINIT, BUFFER, BUFLEV, UNIT)
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
      IF (I0.NE.LASTI .OR. J0.NE.LASTJ) THEN
          CALL GRFAO('P[#,#]',L,INSTR,I0,J0,0,0)
          CALL GRVT02(INSTR(1:L), BUFFER, BUFLEV, UNIT)
          CALL GRVT02('V[]', BUFFER, BUFLEV, UNIT)
      END IF
      IF (I1.EQ.I0 .AND. J1.EQ.J0) THEN
          CONTINUE
      ELSE IF (ABS(I1-I0).LE.1 .AND. ABS(J1-J0).LE.1) THEN
          L = 10*(I1-I0+1) + (J1-J0+1)
          CALL GRVT02(PIX(L), BUFFER, BUFLEV, UNIT)
      ELSE
          IF (I1.EQ.I0) THEN
              INSTR1 = 'V['
              L1 = 2
          ELSE IF (ABS(I1-I0).GE.100) THEN
              CALL GRFAO('V[#',L1,INSTR1,I1,0,0,0)
          ELSE IF (I1.GT.I0) THEN
              CALL GRFAO('V[+#',L1,INSTR1,I1-I0,0,0,0)
          ELSE
              CALL GRFAO('V[#',L1,INSTR1,I1-I0,0,0,0)
          END IF
          IF (J1.EQ.J0) THEN
              INSTR2 = ']'
              L2 = 1
          ELSE IF (ABS(J1-J0).GE.100) THEN
              CALL GRFAO(',#]',L2,INSTR2,J1,0,0,0)
          ELSE IF (J1.GT.J0) THEN
              CALL GRFAO(',+#]',L2,INSTR2,J1-J0,0,0,0)
          ELSE
              CALL GRFAO(',#]',L2,INSTR2,J1-J0,0,0,0)
          END IF
          CALL GRVT02(INSTR1(1:L1)//INSTR2(1:L2),
     1                BUFFER, BUFLEV, UNIT)
      END IF
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      I1 = NINT(RBUF(1))
      J1 = NINT(RBUF(2))
      IF (I1.NE.LASTI .OR. J1.NE.LASTJ) THEN
          CALL GRFAO('P[#,#]V[]',L,INSTR,I1,J1,0,0)
          CALL GRVT02(INSTR(1:L), BUFFER, BUFLEV, UNIT)
      END IF
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
C     -- flush
      CALL GRVT03(BUFFER, UNIT, BUFLEV)
C     -- home cursor
      LTMP = 1 + LEN(VTHOME)
      CALL GRWTER(UNIT, CHAR(27)//VTHOME, LTMP)
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C
  150 CONTINUE
      CI = NINT(RBUF(1))
      IF (CI.GT.3 .OR. CI.LT.0) CI = 1
      CALL GRFAO('W(I#)',L,INSTR,VTCODE(CI),0,0,0)
      CALL GRVT02(INSTR(1:L), BUFFER, BUFLEV, UNIT)
      LASTI = -1
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
C     -- flush buffer
      CALL GRVT03(BUFFER, UNIT, BUFLEV)
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C           RBUF(1)   in/out : cursor x coordinate.
C           RBUF(2)   in/out : cursor y coordinate.
C           CHR(1:1)  output : keystroke.
C
  170 CONTINUE
C     -- flush buffer
      CALL GRVT03(BUFFER, UNIT, BUFLEV)
      ICX = NINT(RBUF(1))
      ICY = NINT(RBUF(2))
  171 ICX = MAX(0,MIN(767,ICX))
      ICY = MAX(0,MIN(459,ICY))
C     -- position graphics cursor
      WRITE (INSTR,111) CHAR(27),ICX,ICY
  111 FORMAT(A,'PpP[', I4 ,',', I4 ,']')
      LTMP = 15
      CALL GRWTER(UNIT, INSTR, LTMP)
      CALL GRGETC(ICH)
C
      IF (ICH.LT.0) THEN
          CALL GRMCUR(ICH, ICX, ICY)
          GOTO 171
      END IF
C     -- back to text mode
      CALL GRWTER(UNIT,CHAR(27)//CHAR(92),2)
      RBUF(1) = ICX
      RBUF(2) = ICY
      CHR = CHAR(ICH)
      LASTI = -1
      NBUF = 2
      LCHR = 1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C
  180 CONTINUE
C     -- flush
      CALL GRVT03(BUFFER, UNIT, BUFLEV)
C     -- erase alpha screen and home cursor
      LTMP = 2 + LEN(VTERAS) + LEN(VTHOME)
      CALL GRWTER(UNIT, CHAR(27)//VTERAS//CHAR(27)//VTHOME, LTMP)
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called.)
C
  190 GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called.)
C
  200 GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      CI = RBUF(1)
      MONO = NINT(30.*RBUF(2) + 59.*RBUF(3) + 11.*RBUF(4))
C     -- convertRGB to hue, lightness, saturation
      CALL GRXHLS(RBUF(2),RBUF(3),RBUF(4),CH,CL,CS)
      IR = NINT(CH)
      IG = NINT(100.*CL)
      IB = NINT(100.*CS)
      CALL GRFAO('S(M#(L#)',L,INSTR, VTCODE(CI), MONO, 0, 0)
      CALL GRVT02(INSTR(1:L), BUFFER, BUFLEV, UNIT)
      CALL GRFAO('(AH#L#S#))',L,INSTR, IR, IG, IB, 0)
      CALL GRVT02(INSTR(1:L), BUFFER, BUFLEV, UNIT)
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called.)
C
  220 GOTO 900
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
C     -- flush
      CALL GRVT03(BUFFER, UNIT, BUFLEV)
C     -- write string
      CALL GRWTER(UNIT, CHR, LCHR)
      LASTI = -1
      RETURN
C
C--- IFUNC=24, Rectangle fill. -----------------------------------------
C
  240 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
C     -- move to top left and turn shading on
      CALL GRFAO('W(S1[,#])P[#,#]V[]', L, INSTR, J0, I0, J1, 0)
      CALL GRVT02(INSTR(1:L), BUFFER, BUFLEV, UNIT)
C     -- draw to top right and turn shading off
      CALL GRFAO('V[#,#]W(S0)', L, INSTR, I1, J1, 0, 0)
      CALL GRVT02(INSTR(1:L), BUFFER, BUFLEV, UNIT)
      LASTI = -1
      RETURN
C-----------------------------------------------------------------------
      END
C*GRVT02 -- PGPLOT Regis (VT125) driver, transfer data to buffer
C+
      SUBROUTINE GRVT02 (INSTR, BUFFER, HWM, UNIT)
      INTEGER   HWM, UNIT
      CHARACTER*(*) INSTR, BUFFER
C
C Arguments:
C  INSTR  (input)  : text of instruction (bytes).
C  BUFFER (in/out) : output buffer.
C  HWM    (in/out) : number of bytes used in BUFFER.
C  UNIT   (input)  : channel number for output (when buffer is full).
C
C Subroutines called:
C   GRVT03
C-----------------------------------------------------------------------
      INTEGER BUFSIZ, N
C-----------------------------------------------------------------------
      BUFSIZ = LEN(BUFFER)
      N = LEN(INSTR)
      IF (HWM+N.GE.BUFSIZ) CALL GRVT03(BUFFER, UNIT, HWM)
      BUFFER(HWM+1:HWM+N) = INSTR(1:N)
      HWM = HWM+N
C-----------------------------------------------------------------------
      END
C*GRVT03 -- PGPLOT Regis (VT125) driver, copy buffer to device
C+
      SUBROUTINE GRVT03 (BUFFER, UNIT, N)
      CHARACTER*(*) BUFFER
      INTEGER UNIT, N
C
C Arguments:
C   BUFFER (input) address of buffer to be output
C   UNIT   (input) channel number for output
C   N      (input) number of bytes to transfer
C          (output) set to zero
C-----------------------------------------------------------------------
C Note: CHAR(27) = escape, CHAR(92) = backslash.
C-----------------------------------------------------------------------
      INTEGER   LTMP
C---
      IF (N.GE.1) THEN
         LTMP = 3
         CALL GRWTER(UNIT, CHAR(27)//'Pp', LTMP)
         CALL GRWTER(UNIT, BUFFER, N)
         LTMP = 2
         CALL GRWTER(UNIT, CHAR(27)//CHAR(92), LTMP)
      END IF
      N = 0
C-----------------------------------------------------------------------
      END

C*PGSLW -- set line width
C%void cpgslw(int lw);
C+
      SUBROUTINE PGSLW (LW)
      INTEGER  LW
C
C Set the line-width attribute. This attribute affects lines, graph
C markers, and text. The line width is specified in units of 1/200 
C (0.005) inch (about 0.13 mm) and must be an integer in the range
C 1-201. On some devices, thick lines are generated by tracing each
C line with multiple strokes offset in the direction perpendicular to
C the line.
C
C Argument:
C  LW     (input)  : width of line, in units of 0.005 inch (0.13 mm)
C                    in range 1-201.
C--
C  8-Aug-1985 - new routine, equivalent to GRSLW [TJP].
C  1-Feb-1995 - change comment [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSLW')) RETURN
      CALL GRSLW(LW)
      END

C*GRINIT -- initialize GRPCKG
C+
      SUBROUTINE GRINIT
C
C Initialize GRPCKG and read font file. Called by GROPEN, but may be 
C called explicitly if needed.
C--
C 29-Apr-1996 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER   I
      LOGICAL   INIT
      SAVE      INIT
      DATA      INIT / .TRUE. /
C
      IF (INIT) THEN
         DO 10 I=1,GRIMAX
            GRSTAT(I) = 0
 10      CONTINUE
         CALL GRSY00
         INIT = .FALSE.
      END IF
      RETURN
      END

C*GRITOC - convert integer to character string
C+
      INTEGER FUNCTION GRITOC(INT, STR)
      INTEGER INT
      CHARACTER*(*) STR
C
C Convert integer INT into (decimal) character string in STR.
C-----------------------------------------------------------------------
      CHARACTER*10 DIGITS
      INTEGER D, I, INTVAL, J, L
      CHARACTER K
      DATA DIGITS /'0123456789'/
C
      INTVAL = ABS(INT)
      I = 0
C
C Generate digits in reverse order.
C
  10  CONTINUE
          I = I+1
          D = 1 + MOD(INTVAL, 10)
          STR(I:I) = DIGITS(D:D)
          INTVAL = INTVAL/10
          IF (I.LT.LEN(STR) .AND. INTVAL.NE.0) GOTO 10
C
C Add minus sign if necessary.
C
      IF (INT.LT.0 .AND. I.LT.LEN(STR)) THEN
          I = I+1
          STR(I:I) = '-'
      END IF
      GRITOC = I
C
C Reverse string in place.
C
      L = I/2
      DO 20 J=1,L
          K = STR(I:I)
          STR(I:I) = STR(J:J)
          STR(J:J) = K
          I = I-1
   20 CONTINUE
C-----------------------------------------------------------------------
      END

C*PGHIST -- histogram of unbinned data
C%void cpghist(int n, const float *data, float datmin, float datmax, \
C% int nbin, int pgflag);
C+
      SUBROUTINE PGHIST(N, DATA, DATMIN, DATMAX, NBIN, PGFLAG)
      INTEGER N
      REAL    DATA(*)
      REAL    DATMIN, DATMAX
      INTEGER NBIN, PGFLAG
C
C Draw a histogram of N values of a variable in array
C DATA(1...N) in the range DATMIN to DATMAX using NBIN bins.  Note
C that array elements which fall exactly on the boundary between
C two bins will be counted in the higher bin rather than the
C lower one; and array elements whose value is less than DATMIN or
C greater than or equal to DATMAX will not be counted at all.
C
C Arguments:
C  N      (input)  : the number of data values.
C  DATA   (input)  : the data values. Note: the dimension of array
C                    DATA must be greater than or equal to N. The
C                    first N elements of the array are used.
C  DATMIN (input)  : the minimum data value for the histogram.
C  DATMAX (input)  : the maximum data value for the histogram.
C  NBIN   (input)  : the number of bins to use: the range DATMIN to
C                    DATMAX is divided into NBIN equal bins and
C                    the number of DATA values in each bin is
C                    determined by PGHIST.  NBIN may not exceed 200.
C  PGFLAG (input)  : if PGFLAG = 1, the histogram is plotted in the
C                    current window and viewport; if PGFLAG = 0,
C                    PGENV is called automatically by PGHIST to start
C                    a new plot (the x-limits of the window will be
C                    DATMIN and DATMAX; the y-limits will be chosen
C                    automatically.
C                    IF PGFLAG = 2,3 the histogram will be in the same
C                    window and viewport but with a filled area style.
C                    If pgflag=4,5 as for pgflag = 0,1, but simple
C                    line drawn as for PGBIN
C
C--
C Side effects:
C
C The pen position is changed to (DATMAX,0.0) in world coordinates.
C--
C  6-Sep-83:
C 11-Feb-92: fill options added.
C-----------------------------------------------------------------------
      INTEGER  MAXBIN
      PARAMETER (MAXBIN=200)
      INTEGER  I, IBIN, NUM(MAXBIN), NUMMAX, JUNK
      REAL     BINSIZ, PGRND
      REAL     CUR, PREV, XLO, XHI, YLO, YHI
      LOGICAL  PGNOTO
C
      IF (N.LT.1 .OR. DATMAX.LE.DATMIN .OR. NBIN.LT.1 .OR.
     1    NBIN.GT.MAXBIN) THEN
          CALL GRWARN('PGHIST: invalid arguments')
          RETURN
      END IF
      IF (PGNOTO('PGHIST')) RETURN
      CALL PGBBUF
C
C How many values in each bin?
C
      DO 10 IBIN=1,NBIN
          NUM(IBIN) = 0
   10 CONTINUE
      DO 20 I=1,N
          IBIN = (DATA(I)-DATMIN)/(DATMAX-DATMIN)*NBIN+1
          IF (IBIN.GE.1 .AND. IBIN.LE.NBIN) NUM(IBIN) = NUM(IBIN)+1
   20 CONTINUE
      NUMMAX = 0
      DO 30 IBIN=1,NBIN
          NUMMAX = MAX(NUMMAX,NUM(IBIN))
   30 CONTINUE
      BINSIZ = (DATMAX-DATMIN)/NBIN
C
C Boundaries of plot.
C
      XLO = DATMIN
      XHI = DATMAX
      YLO = 0.0
      YHI = PGRND(1.01*NUMMAX,JUNK)
C
C Define environment if necessary.
C
      IF (MOD(PGFLAG,2).EQ.0) THEN
         CALL PGENV(XLO,XHI,YLO,YHI,0,0)
      END IF
C
C Draw Histogram.
C
      IF (PGFLAG/2.EQ.0) THEN
         PREV = 0.0
         XHI=DATMIN
         CALL GRMOVA(DATMIN,0.0)
         DO 40 IBIN=1,NBIN
            CUR = NUM(IBIN)
            XLO=XHI
            XHI = DATMIN + IBIN*BINSIZ
            IF (CUR.EQ.0.0) THEN
               CONTINUE
            ELSE IF (CUR.LE.PREV) THEN
               CALL GRMOVA(XLO,CUR)
               CALL GRLINA(XHI,CUR)
            ELSE
               CALL GRMOVA(XLO,PREV)
               CALL GRLINA(XLO,CUR)
               CALL GRLINA(XHI,CUR)
            END IF
            CALL GRLINA(XHI,0.0)
            PREV = CUR
 40      CONTINUE
      ELSE IF (PGFLAG/2.EQ.1) THEN
         PREV = 0.0
         XHI = DATMIN
         DO 50 IBIN=1,NBIN
            CUR = NUM(IBIN)
            XLO=XHI
            XHI = DATMIN + IBIN*BINSIZ
            IF (CUR.EQ.0.0) THEN
               CONTINUE
            ELSE
               CALL PGRECT(XLO,XHI,0.0,CUR)
            END IF
 50      CONTINUE
      ELSE IF (PGFLAG/2.EQ.2) THEN
         PREV = 0.0
         CALL GRMOVA(DATMIN,0.0)
         XHI=DATMIN
         DO 60 IBIN=1,NBIN
            CUR = NUM(IBIN)
            XLO = XHI
            XHI = DATMIN + IBIN*BINSIZ
            IF (CUR.EQ.0.0 .AND. PREV.EQ.0.0) THEN
               CALL GRMOVA(XHI,0.0)
            ELSE 
               CALL GRLINA(XLO,CUR)
               IF(CUR.NE.0.0) THEN
                  CALL GRLINA(XHI,CUR)
               ELSE
                  CALL GRMOVA(XHI,CUR)
               ENDIF
            END IF
            PREV = CUR
 60      CONTINUE
      END IF
C     
      CALL PGEBUF
      END

C*PGENV -- set window and viewport and draw labeled frame
C%void cpgenv(float xmin, float xmax, float ymin, float ymax, \
C% int just, int axis);
C+
      SUBROUTINE PGENV (XMIN, XMAX, YMIN, YMAX, JUST, AXIS)
      REAL XMIN, XMAX, YMIN, YMAX
      INTEGER JUST, AXIS
C
C Set PGPLOT "Plotter Environment".  PGENV establishes the scaling
C for subsequent calls to PGPT, PGLINE, etc.  The plotter is
C advanced to a new page or panel, clearing the screen if necessary.
C If the "prompt state" is ON (see PGASK), confirmation
C is requested from the user before clearing the screen.
C If requested, a box, axes, labels, etc. are drawn according to
C the setting of argument AXIS.
C
C Arguments:
C  XMIN   (input)  : the world x-coordinate at the bottom left corner
C                    of the viewport.
C  XMAX   (input)  : the world x-coordinate at the top right corner
C                    of the viewport (note XMAX may be less than XMIN).
C  YMIN   (input)  : the world y-coordinate at the bottom left corner
C                    of the viewport.
C  YMAX   (input)  : the world y-coordinate at the top right corner
C                    of the viewport (note YMAX may be less than YMIN).
C  JUST   (input)  : if JUST=1, the scales of the x and y axes (in
C                    world coordinates per inch) will be equal,
C                    otherwise they will be scaled independently.
C  AXIS   (input)  : controls the plotting of axes, tick marks, etc:
C      AXIS = -2 : draw no box, axes or labels;
C      AXIS = -1 : draw box only;
C      AXIS =  0 : draw box and label it with coordinates;
C      AXIS =  1 : same as AXIS=0, but also draw the
C                  coordinate axes (X=0, Y=0);
C      AXIS =  2 : same as AXIS=1, but also draw grid lines
C                  at major increments of the coordinates;
C      AXIS = 10 : draw box and label X-axis logarithmically;
C      AXIS = 20 : draw box and label Y-axis logarithmically;
C      AXIS = 30 : draw box and label both axes logarithmically.
C
C For other axis options, use routine PGBOX. PGENV can be persuaded to
C call PGBOX with additional axis options by defining an environment
C parameter PGPLOT_ENVOPT containing the required option codes. 
C Examples:
C   PGPLOT_ENVOPT=P      ! draw Projecting tick marks
C   PGPLOT_ENVOPT=I      ! Invert the tick marks
C   PGPLOT_ENVOPT=IV     ! Invert tick marks and label y Vertically
C--
C  1-May-1983
C 25-Sep-1985 [TJP] - change to use PGWNAD.
C 23-Nov-1985 [TJP] - add PGPLOT_ENVOPT option.
C 31-Dec-1985 [TJP] - remove automatic PGBEG call.
C 29-Aug-1989 [TJP] - remove common block; no longer needed.
C-----------------------------------------------------------------------
      INTEGER      L
      LOGICAL      PGNOTO
      CHARACTER*10 XOPTS, YOPTS, ENVOPT, TEMP
C
      IF (PGNOTO('PGENV')) RETURN
C
C Start a new picture: move to a new panel or page as necessary.
C
      CALL PGPAGE
C
C Redefine the standard viewport.
C
      CALL PGVSTD
C
C If invalid arguments are specified, issue warning and leave window
C unchanged.
C
      IF (XMIN.EQ.XMAX) THEN
          CALL GRWARN('invalid x limits in PGENV: XMIN = XMAX.')
          RETURN
      ELSE IF (YMIN.EQ.YMAX) THEN
          CALL GRWARN('invalid y limits in PGENV: YMIN = YMAX.')
          RETURN
      END IF
C
C Call PGSWIN to define the window.
C If equal-scales requested, adjust viewport.
C
      IF (JUST.EQ.1) THEN
          CALL PGWNAD(XMIN,XMAX,YMIN,YMAX)
      ELSE
          CALL PGSWIN(XMIN,XMAX,YMIN,YMAX)
      END IF
C
C Call PGBOX to draw and label frame around viewport.
C
      YOPTS = '*'
      IF (AXIS.EQ.-2) THEN
          XOPTS = ' '
      ELSE IF (AXIS.EQ.-1) THEN
          XOPTS = 'BC'
      ELSE IF (AXIS.EQ.0) THEN
          XOPTS = 'BCNST'
      ELSE IF (AXIS.EQ.1) THEN
          XOPTS = 'ABCNST'
      ELSE IF (AXIS.EQ.2) THEN
          XOPTS = 'ABCGNST'
      ELSE IF (AXIS.EQ.10) THEN
          XOPTS = 'BCNSTL'
          YOPTS = 'BCNST'
      ELSE IF (AXIS.EQ.20) THEN
          XOPTS = 'BCNST'
          YOPTS = 'BCNSTL'
      ELSE IF (AXIS.EQ.30) THEN
          XOPTS = 'BCNSTL'
          YOPTS = 'BCNSTL'
      ELSE
          CALL GRWARN('PGENV: illegal AXIS argument.')
          XOPTS = 'BCNST'
      END IF
      IF (YOPTS.EQ.'*') YOPTS = XOPTS
C
C Additional PGBOX options from PGPLOT_ENVOPT.
C
      CALL GRGENV('ENVOPT', ENVOPT, L)
      IF (L.GT.0 .AND. AXIS.GE.0) THEN
          TEMP = XOPTS
          XOPTS = ENVOPT(1:L)//TEMP
          TEMP = YOPTS
          YOPTS = ENVOPT(1:L)//TEMP
      END IF
      CALL PGBOX(XOPTS, 0.0, 0, YOPTS, 0.0, 0)
C
      END

C*PGPT1 -- draw one graph marker
C%void cpgpt1(float xpt, float ypt, int symbol);
C+
      SUBROUTINE PGPT1 (XPT, YPT, SYMBOL)
      REAL XPT, YPT
      INTEGER SYMBOL
C
C Primitive routine to draw a single Graph Marker at a specified point.
C The marker is drawn using the current values of attributes
C color-index, line-width, and character-height (character-font applies
C if the symbol number is >31).  If the point to be marked lies outside
C the window, no marker is drawn.  The "pen position" is changed to
C (XPT,YPT) in world coordinates.
C
C To draw several markers with coordinates specified by X and Y
C arrays, use routine PGPT.
C
C Arguments:
C  XPT    (input)  : world x-coordinate of the point.
C  YPT    (input)  : world y-coordinate of the point.
C  SYMBOL (input)  : code number of the symbol to be drawn:
C                    -1, -2  : a single dot (diameter = current
C                              line width).
C                    -3..-31 : a regular polygon with ABS(SYMBOL)
C                              edges (style set by current fill style).
C                    0..31   : standard marker symbols.
C                    32..127 : ASCII characters (in current font).
C                              e.g. to use letter F as a marker, let
C                              SYMBOL = ICHAR('F'). 
C                    > 127  :  a Hershey symbol number.
C--
C  4-Feb-1997 - new routine [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
      REAL XPTS(1), YPTS(1)
C
      IF (PGNOTO('PGPT1')) RETURN
      XPTS(1) = XPT
      YPTS(1) = YPT
      CALL PGPT(1, XPTS, YPTS, SYMBOL)
      END

c        1         2         3         4         5         6         7
c2345678901234567890123456789012345678901234567890123456789012345678901234567890
      Program crgrexc
      Implicit None
      Integer I,Ndev,options(99),start
      Character Line*80,driver(99)*6
      
      Open(Unit=10,File='drivers.list',Status='OLD',Err=1000)
      Open(Unit=11,File='grexec.f',Status='Unknown',Err=3000)
      
      Ndev = 0
10    Read(10,'(A80)',End=2000)Line
      If (Line(1:1) .eq. '!') go to 10
         Ndev = Ndev + 1
         Driver(Ndev) = line(3:8)
         Read(line(10:10),'(I1)') options(Ndev)
         Go to 10
      Continue
2000  If (Ndev .eq. 0) Then
         Write(*,'('' Error:  No drivers were selected.  Select drivers '')')
         Write(*,'('' by removing ! at beginning of line.'')')
	     Call F_EndMPW(1)
	  Else If (Ndev .le. 99) Then 
         Write(11,'(''C*GREXEC -- PGPLOT device handler dispatch routine'')')
         Write(11,'(''C+'')')
         Write(11,'(
     +    ''      SUBROUTINE GREXEC(IDEV,IFUNC,RBUF,NBUF,CHR,LCHR)'')')
         Write(11,'(''      INTEGER IDEV, IFUNC, NBUF, LCHR'')')
         Write(11,'(''      REAL    RBUF(*)'')')
         Write(11,'(''      CHARACTER*(*) CHR'')')
         Write(11,'(''C---'')')
         Write(11,'(''      INTEGER NDEV'')')
         Write(11,'(''      PARAMETER (NDEV='',I3,'')'') ') Ndev
         Write(11,'(''      CHARACTER*10 MSG'')')
         Write(11,'(''C---'')')
         Line(1:14)='(''      GOTO('
         I = 0
         Start = 11
20          I = I + 1
            If (I .lt. Ndev) Then
               If (Start .lt. 60) Then
                  Start = Start + 3
               Else
                  line(start+3:start+5) = ''')'
                  Write(11,line(1:Start+5))
                  Line(1:14)='(''     +     '
                  Start = 14
               End If
               Write(Line(start:start+2),'(i2,'','')') I
               Go to 20
            Else
               Start = Start + 3
               Write(Line(start:start+7),'(i2,'') Idev'')') I
               Line(start+8:start+11) = ''')'
               Write(11,line(1:start+11))
            End if
c        1         2         3         4         5         6         7
c2345678901234567890123456789012345678901234567890123456789012345678901234567890
      Else
         Write(*,*) 'Error: Ndev > 99.  Increase Ndev and check program.'
         Call F_EndMPW(1)
      End If
      Write(11,'(''      IF (IDEV.EQ.0) THEN'')')
      Write(11,'(''          RBUF(1) = NDEV'')')
      Write(11,'(''          NBUF = 1'')')
      Write(11,'(''      ELSE'')')
      Write(11,*)'         WRITE (MSG,''(I10)'') IDEV'
      Write(11,*)'         CALL GRWARN(''Unknown device',
     +           ' code in GREXEC: ''//MSG)'
      Write(11,'(''      END IF'')')
      Write(11,'(''      RETURN'')')
      Write(11,'(''C---'')')
	  Do 30 I = 1, Ndev
	     If (Options(i) .eq. 0) Then 
	        Write(11,'(I2,''    CALL '',A6,
     +           ''(IFUNC,RBUF,NBUF,CHR,LCHR)'')')I,Driver(I)
	     Else
	        Write(11,'(I2,''    CALL '',A6,
     +           ''(IFUNC,RBUF,NBUF,CHR,LCHR,'',I2,'')'')')
     +           I,Driver(I),Options(i)
		 End If
		 Write(11,'(''      RETURN'')')
30    Continue
      Write(11,'(''C'')')
      Write(11,'(''      END'')')
      Write(*,*) 'Finished creating grexec.f'
	  Call F_EndMPW(0)

1000  Continue
      Write(*,*)' Error: Could not open drivers.list in current directory.'
      Write(*,*)' Copy drivers.list from drivers directory to here.'
      Call F_EndMPW(1)
            
3000  Continue
      Write(*,*) ' Error: Could not open grexec.f.'
      Call F_EndMPW(1)
      End

C*GRTERM -- flush buffer to output device
C+
      SUBROUTINE GRTERM
C
C GRPCKG: flush the buffer associated with the current plot. GRTERM
C should be called only when it is necessary to make sure that all the
C graphics created up to this point in the program are visible on the
C device, e.g., before beginning a dialog with the user. GRTERM has no
C effect on hardcopy devices.
C
C Arguments: none.
C--
C  6-Oct-1983
C 29-Jan-1985 - add HP2648 device [KS/TJP].
C 31-Dec-1985 - do not send CAN code to true Tek [TJP/PCP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 11-Jun-1987 - remove built-in devices [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER NBUF,LCHR
      REAL    RBUF(6)
      CHARACTER CHR
C
      IF (GRCIDE.GE.1) THEN
          CALL GREXEC(GRGTYP,16,RBUF,NBUF,CHR,LCHR)
      END IF
      END

      PROGRAM PGDE11
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT: travelling sine wave.
C
C This program illustrates how animated displays can be generated with
C PGPLOT, although PGPLOT is not optimized for such use.
C
C To create an animated display:
C
C  (1) Do not call PGPAGE (or PGENV, which calls PGPAGE) between frames;
C  (2) Enclose all the calls required to generate each frame between
C      PGBBUF and PGEBUF calls;
C  (3) Either: erase the entire previous frame by calling PGERAS before
C      drawing the next frame; or: erase the parts of the frame that
C      have changed by overwriting with the background color (color
C      index 0).
C
C This program demonstrated both approaches. Using PGERAS is usually
C slower, because more has to be redrawn in each frame. Erasing selected
C parts of the display can be faster, but it may be difficult to avoid
C erasing parts that should remain visible.
C
C This program requires an interactive display that supports writing
C in color index 0.
C-----------------------------------------------------------------------
C Parameters:
C   NT is the number of frames in the animation.
      INTEGER N,NT
      REAL PI,A,B
      PARAMETER (N = 50)
      PARAMETER (NT = 100)
      PARAMETER (PI=3.14159265359)
      PARAMETER (A = 2.0*PI/N)
      PARAMETER (B = 2.0*PI/NT)
C Variables:
      REAL X(0:N), Y(0:N)
      INTEGER I, T, L
      CHARACTER*8 STR
      INTEGER PGBEG
C-----------------------------------------------------------------------

      WRITE (*,*) 'Demonstration of animation with PGPLOT'
      WRITE (*,*) 'This program requires an interactive display that'
      WRITE (*,*) 'supports writing in color index 0.'

      IF (PGBEG(0,'?',1,1) .NE. 1) STOP

      CALL PGQINF('HARDCOPY', STR, L)
      IF (STR(:L).NE.'NO') WRITE (*,*)
     :     'Warning: device is not interactive'

      WRITE (*,*) '1: erasing the entire screen between frames'

      CALL PGPAGE
      CALL PGVSTD
      CALL PGWNAD(-A, A*(N+1), -1.1, 1.1)
      
      DO 200 T=0,NT
        CALL PGBBUF
        CALL PGERAS
        CALL PGSCI(1)
        CALL PGBOX('bcnst', 0.0, 0, 'bcnst', 0.0, 0)
        DO 100 I=0,N
          X(I) = I*A 
          Y(I) = SIN(I*A-T*B)  
  100   CONTINUE
        CALL PGSCI(3)
        CALL PGLINE(N+1,X,Y)
        WRITE (STR,'(I8)') T
        CALL PGMTXT('T', 2.0, 0.0, 0.0, STR)
        CALL PGEBUF
  200 CONTINUE

      CALL PGPAGE
      WRITE (*,*) '2: erasing only the line between frames'

      CALL PGVSTD
      CALL PGWNAD(-A, A*(N+1), -1.1, 1.1)
      CALL PGBBUF
      CALL PGSCI(1)
      CALL PGBOX('bcnst', 0.0, 0, 'bcnst', 0.0, 0)
      DO 300 I=0,N
         X(I) = I*A 
         Y(I) = SIN(I*A)  
 300  CONTINUE
      CALL PGEBUF
   
      DO 500 T=0,NT
        CALL PGBBUF
        CALL PGSCI(0)
        CALL PGLINE(N+1,X,Y)
        CALL PGSCI(3)
        DO 400 I=0,N
          X(I) = I*A 
          Y(I) = SIN(I*A-T*B)  
  400   CONTINUE
        CALL PGLINE(N+1,X,Y)
        CALL PGEBUF
  500 CONTINUE

      CALL PGEND
      END

C*PGSHS -- set hatching style
C%void cpgshs(float angle, float sepn, float phase);
C+
      SUBROUTINE PGSHS (ANGLE, SEPN, PHASE)
      REAL ANGLE, SEPN, PHASE
C
C Set the style to be used for hatching (fill area with fill-style 3).
C The default style is ANGLE=45.0, SEPN=1.0, PHASE=0.0.
C
C Arguments:
C  ANGLE  (input)  : the angle the hatch lines make with the
C                    horizontal, in degrees, increasing 
C                    counterclockwise (this is an angle on the
C                    view surface, not in world-coordinate space).
C  SEPN   (input)  : the spacing of the hatch lines. The unit spacing
C                    is 1 percent of the smaller of the height or
C                    width of the view surface. This should not be
C                    zero.
C  PHASE  (input)  : a real number between 0 and 1; the hatch lines
C                    are displaced by this fraction of SEPN from a
C                    fixed reference.  Adjacent regions hatched with the
C                    same PHASE have contiguous hatch lines. To hatch
C                    a region with alternating lines of two colors,
C                    fill the area twice, with PHASE=0.0 for one color
C                    and PHASE=0.5 for the other color.
C--
C 26-Feb-1995 - new routine [TJP].
C 12-Feb-1996 - check for zero spacing [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSHS')) RETURN
      PGHSA(PGID) = ANGLE
      IF (SEPN.EQ.0.0) THEN
         CALL GRWARN('PGSHS: zero hatch line spacing requested')
         PGHSS(PGID) = 1.0
      ELSE
         PGHSS(PGID) = SEPN
      END IF
      IF (PHASE.LT.0.0 .OR. PHASE.GT.1.0) THEN
         CALL GRWARN('PGSHS: hatching phase must be in (0.0,1.0)')
      END IF
      PGHSP(PGID) = PHASE
C
      END

C*PGSAH -- set arrow-head style
C%void cpgsah(int fs, float angle, float barb);
C+
      SUBROUTINE PGSAH (FS, ANGLE, BARB)
      INTEGER  FS
      REAL ANGLE, BARB
C
C Set the style to be used for arrowheads drawn with routine PGARRO.
C
C Argument:
C  FS     (input)  : FS = 1 => filled; FS = 2 => outline.
C                    Other values are treated as 2. Default 1.
C  ANGLE  (input)  : the acute angle of the arrow point, in degrees;
C                    angles in the range 20.0 to 90.0 give reasonable
C                    results. Default 45.0.
C  BARB   (input)  : the fraction of the triangular arrow-head that
C                    is cut away from the back. 0.0 gives a triangular
C                    wedge arrow-head; 1.0 gives an open >. Values 0.3
C                    to 0.7 give reasonable results. Default 0.3.
C--
C 13-Oct-1992 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
C
      PGAHS(PGID) = FS
      IF (PGAHS(PGID).NE.1) PGAHS(PGID) = 2
      PGAHA(PGID) = ANGLE
      PGAHV(PGID) = BARB
C
      END

C*LADRIV -- PGPLOT Driver for SIXEL code
C+ (tested on DEC LA50, should in practice work on a LA100 or LN03)
      SUBROUTINE LADRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
      BYTE ESC/27/,FF/12/
      LOGICAL ALLERR
C
C PGPLOT driver for LA50 (SIXEL) device.
C
C Version 1.0  - 1988 Dec - B. H. Toby
C=======================================================================
C
C Supported device: DEC LA50
C
C Device type code: /LA50
C
C Default device name: LA50:PGPLOT.LAPLOT
C
C Default view surface dimensions: 9.5 in (horizontal) by  6 in (vertical).
C Maximum view surface dimensions: (none) (horizontal) by 7.9 in (vertical).
C Note: the 11 inch limit is software imposed.
C
C Resolution: 72 (x) x 144 (y) pixels/inch.
C
C Color capability: Color indices 0 (erase, white) and 1 (black) are
C supported. It is not possible to change color representation.
C
C Input capability: None.
C
C File format: Variable-length records, maximum 80 bytes, with
C "list" carriage-control.
C
C Obtaining hardcopy:
C   if the LA50 is connected to the user's VT2xx or VT3xx terminal
C    then the printer can be accessed by sending the file
C      directly to the terminal: use PGPLOT device TT:/LA50
C    or DEFINE PGPLOT_LA50 TT: (be sure to do a SET TERM/FORM if
C    page spacing is important)
C   if the LA50 is attached to a different terminal port, e.g. TXZ99:,
C    which preferably has been set spooled, use PGPLOT device TXZ99:/LA50
C    or DEFINE PGPLOT_LA50 TXZ99: (be sure that TXZ99 has been set
C    /FORM if page spacing is important)
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE, DEFNAM
      PARAMETER (TYPE='LA50 (DEC LA50 printer)')
      PARAMETER (DEFNAM='PGPLOT_LA50:PGPLOT.LAPLOT')
C
      INTEGER UNIT, IER, IC, BX, BY, NPICT
      INTEGER GRGMEM, GRFMEM
      CHARACTER*10 MSG
C define pointers for dynamically allocated arrays (used with same names)
      INTEGER BITMAP,buf
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in '//TYPE//' device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = -1
      RBUF(3) = 0
      RBUF(4) = 1140
      RBUF(5) = 0
      RBUF(6) = 1
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = 72.0
      RBUF(2) = 144.0
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    no thick lines)
C
   40 CHR = 'HNNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM) + 1
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 720    !   10 inch
      RBUF(3) = 0
      RBUF(4) = 1008    !   7 inch
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
      ALLERR = .TRUE.
      CALL GRGLUN(UNIT)
      RBUF(1) = UNIT
      NPICT = 0
      IC = 1
      OPEN (UNIT=UNIT, FILE=CHR(:LCHR), CARRIAGECONTROL='LIST',
     1      DEFAULTFILE=DEFNAM, STATUS='NEW',
     3      FORM='FORMATTED', RECORDTYPE='VARIABLE', IOSTAT=IER)
      IF (IER.NE.0) THEN
          CALL GRWARN('Cannot open output file for '//TYPE//' plot: '//
     1                CHR(:LCHR))
          RBUF(2) = 0
          CALL GRFLUN(UNIT)
          RETURN
      ENDIF
     
      INQUIRE (UNIT=UNIT, NAME=CHR)
      LCHR = LEN(CHR)
   91 IF (CHR(LCHR:LCHR).EQ.' ') THEN
          LCHR = LCHR-1
          GOTO 91
      END IF
      RBUF(2) = 1
      RETURN
     
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      CLOSE (UNIT=UNIT, STATUS='KEEP')
      CALL GRFLUN(UNIT)
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
C Allocate space based on the actual size of the plot, since there is no
C way to signal an error, if it is not possible to allocate the space
C set a flag which prevents plotting
C
C dynamically allocate memory for the plot bitmap
C     -- dimensions of plot buffer
      BX = 2. + (RBUF(1)+5.)/6.    ! (six bits encoded in each byte)
      BY = 2. + RBUF(2)
      IER = GRGMEM(BX*BY, BITMAP)
      IF (IER.NE.1) then
        CALL GRGMSG(IER)
        CALL GRWARN('Failed to allocate plot bitmap.')
        GOTO 92
      ENDIF
C allocate space for a buffer
      IER = GRGMEM(BY, BUF)
      IF (IER.NE.1) then
        CALL GRGMSG(IER)
        CALL GRWARN('Failed to allocate plot buffer.')
        IER = GRFMEM(BX*BY, BITMAP)
        IF (IER.NE.1) CALL GRWARN('Failed to deallocate plot bitmap.')
        GOTO 92
      ENDIF
     
      ALLERR = .FALSE.
      IC = 1
      NPICT = NPICT+1
C%    type *,'Begin picture',NPICT
C initialize the buffer
      CALL GRLA03(BX*BY, %val(BITMAP))
      RETURN
C error in space allocation
92    CALL GRWARN('Plot type has been set to /NULL.')
      CLOSE (UNIT=UNIT, STATUS='DELETE')
      CALL GRFLUN(UNIT)
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      IF (ALLERR) RETURN
C note: the following routine is shared with the PRINTRONIX driver
      CALL GRLA02(1, RBUF, IC, BX, BY, %val(BITMAP))
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      IF (ALLERR) RETURN
C note: the following routine is shared with the PRINTRONIX driver
      CALL GRLA02(0, RBUF, IC, BX, BY, %val(BITMAP))
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
C%    type *,'End picture  ',NPICT
C
      IF (ALLERR) RETURN
C Assume the LA50 is attached to a terminal, if so send the terminal
C into CONTROLLER mode while sending the plot. The extra escape sequences
C should not cause any problems if the LA50 is directly connected.
C Put terminal into controller mode, then enter graphics mode.
      IF (NPICT.EQ.1) THEN
        WRITE (UNIT,'(5a)') ESC,'[5i',ESC,'Pq'
      ELSE
C     if this is not the first plot, insert a form feed to advance the page
        WRITE (UNIT,'(5a)') ESC,'[5i',FF,ESC,'Pq'
      ENDIF
      CALL GRLA01(UNIT, BX, BY, %val(BITMAP),%val(BUF))
C leave graphics mode; put terminal into normal mode
      WRITE (UNIT,'(4a)') ESC,CHAR(92),ESC,'[4i'
C deallocate space for bitmap and buffer
      IER = GRFMEM(BX*BY, BITMAP)
      IF (IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRWARN('Failed to deallocate plot bitmap.')
      END IF
      IER = GRFMEM(BY, BUF)
      IF (IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRWARN('Failed to deallocate plot buffer.')
      END IF
      ALLERR = .true.
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      IF (IC.LT.0 .OR. IC.GT.1) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Not used.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C    (Not implemented: ignored)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C-----------------------------------------------------------------------
      END
     
C*GRLA01 -- PGPLOT LA50 driver, copy bitmap to output file
C+
      SUBROUTINE GRLA01 (UNIT, BX, BY, BITMAP, BUF)
      INTEGER UNIT, BX, BY
      BYTE BITMAP(BX,BY), BUF(BY)
C
C Arguments:
C  UNIT   (input)  Fortran unit number for output
C  BX, BY (input)  dimensions of BITMAP
C  BITMAP (input)  the bitmap array
C  BUF    (temp.)  buffer used to compress line of print
C-----------------------------------------------------------------------
      INTEGER I, J, K, JMAX, M, ndup, jj, XMAX
C
C Create SIXEL code and write bitmap to LA50, line by line.
C
C   The x-axis is the direction that paper advances, each line
C   that is sent contains six rows of bits
C
C find last non-zero line
      DO K=BX,1,-1
      XMAX = K
        DO J=1,by
          if (BITMAP(K,J) .ne. '00'X) goto 1
      ENDDO
      ENDDO
C  process each line
1     DO K=1,XMAX
C    copy each column of the bitmap to the buffer, reversing the order
C    also find the last non-zero array element
        JMAX = 1
        jj = 0
        DO J=by,1,-1
          jj = jj + 1
          BUF(jj) = BITMAP(K,J)
          IF (BUF(jj) .NE.'00'X) JMAX = jj
        END DO
C compress the line and send it to the printer
        M = 0
        ndup = 1
        do 10 i=1,JMAX
C   can the current character be compressed with the next?
        if (i .ne. JMAX) THEN
C   if the next character the same as current increment the counter and go on
          IF (BUF(i) .eq. BUF(i+1)) then
             ndup = ndup + 1
             goto 10
          ENDIF
        ENDIF
C   The next character is different from current or this is the last character.
C     How many characters are repeated?
       if (ndup .le. 4) then
C       if less than five, don't bother to compress
         do j = 1,ndup
           M = M + 1
           BUF(M) = BUF(i)+63
         enddo
         ndup = 1
         goto 10
       elseif (ndup .le. 9) then
         BUF(M+1) = 33
         encode(1,31,BUF(M+2)) ndup
31         format(i1)
         M = M + 2 + 1
       elseif (ndup .le. 99) then
         BUF(M+1) = 33
         encode(2,32,BUF(M+2)) ndup
32         format(i2)
         M = M + 2 + 2
       elseif (ndup .le. 999) then
         BUF(M+1) = 33
         encode(3,33,BUF(M+2)) ndup
33         format(i3)
         M = M + 2 + 3
       else
         BUF(M+1) = 33
         encode(4,34,BUF(M+2)) ndup
34         format(i4)
         M = M + 2 +  4
       endif
       BUF(M) = BUF(i)+63
       ndup = 1
10     continue
     
      WRITE (UNIT,'(80a1)') (BUF(j),j=1,M),'-'
      END DO
      END
     
C*GRLA02 -- PGPLOT Printronix driver, draw line
C+
      SUBROUTINE GRLA02 (LINE,RBUF,ICOL, BX, BY, BITMAP)
      INTEGER LINE
      REAL RBUF(4)
      INTEGER ICOL, BX, BY
      BYTE BITMAP(BX,BY)
C
C Draw a straight-line segment from absolute pixel coordinates
C (RBUF(1),RBUF(2)) to (RBUF(3),RBUF(4)).  The line either overwrites
C (sets to black) or erases (sets to white) the previous contents
C of the bitmap, depending on the current color index. Setting bits
C is accomplished with a VMS BISB2 instruction, expressed in
C Fortran as .OR.; clearing bits is accomplished with a VMS BICB2
C instruction, expressed in Fortran as .AND..NOT.. The line is
C generated with a Simple Digital Differential Analyser (ref:
C Newman & Sproull).
C
C Arguments:
C
C LINE            I I      =0 for dot, =1 for line.
C RBUF(1),RBUF(2) I R      Starting point of line.
C RBUF(3),RBUF(4) I R      End point of line.
C ICOL            I I      =0 for erase, =1 for write.
C BITMAP        I/O B      (address of) the frame buffer.
C
C-----------------------------------------------------------------------
      BYTE    QMASK(0:5)
      INTEGER LENGTH, KX, KY, K
      REAL    D, XINC, YINC, XP, YP
      DATA    QMASK /'01'x,'02'x,'04'x,'08'x,'10'x,'20'x/
C
      IF (LINE.GT.0) THEN
          D = MAX(ABS(RBUF(3)-RBUF(1)), ABS(RBUF(4)-RBUF(2)))
          LENGTH = D
          IF (LENGTH.EQ.0) THEN
              XINC = 0.
              YINC = 0.
          ELSE
              XINC = (RBUF(3)-RBUF(1))/D
              YINC = (RBUF(4)-RBUF(2))/D
          END IF
      ELSE
          LENGTH = 0
          XINC = 0.
          YINC = 0.
      END IF
      XP = RBUF(1)+0.5
      YP = RBUF(2)+0.5
      IF (ICOL.NE.0) THEN
          DO K=0,LENGTH
              KX = XP
              KY = (BY-1)-INT(YP)
              BITMAP(KX/6+1,KY+1) = BITMAP(KX/6+1,KY+1) .OR.
     1                              QMASK(MOD(KX,6))
              XP = XP + XINC
              YP = YP + YINC
          END DO
      ELSE
          DO K=0,LENGTH
              KX = XP
              KY = (BY-1)-INT(YP)
              BITMAP(KX/6+1,KY+1) = BITMAP(KX/6+1,KY+1) .AND.
     1                              (.NOT.QMASK(MOD(KX,6)))
              XP = XP + XINC
              YP = YP + YINC
          END DO
      END IF
      END

C*GRLA03 -- zero fill buffer
C+
      SUBROUTINE GRLA03 (BUFSIZ,BUFFER)
C
C Arguments:
C
C BUFFER (byte array, input): (address of) the buffer.
C BUFSIZ (integer, input): number of bytes in BUFFER.
C-----------------------------------------------------------------------
      INTEGER  BUFSIZ, I
      BYTE     BUFFER(BUFSIZ), FILL
      DATA     FILL /0/
C
      DO 10 I=1,BUFSIZ
          BUFFER(I) = FILL
   10 CONTINUE
      END

	SUBROUTINE GODRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
C- GRPCKG driver for GOC(Sigma) terminal.
C---
C Supported device:  Sigma, T5670 terminal.
C
C Device type code: /GOC
C
C Default file name: TT(logical name, usually equivalent to the
C   logged in terminal).
C
C Default view surface dimensions:  38 cm display.
C
C Resolution: The full view surface is 768 by 512 pixels.
C
C Color capability: Color indices 0 (erase) and 1 are supported.
C
C Input capability: Cursor is a cross-hair and can be moved using
C   the joystick or the cursor keys to the left of the keyboard.
C   Terminate cursor motion and send the cursor position to the
C   program by typing any printable character on the keyboard.
C
C File format:  It is not possible to send GOC plots to a disk file.
C
C Obtaining hardcopy: A hardcopy of the plot may be obtained using
C   a Tekronix hardcopy unit attached to the terminal.
C
C  5-Aug-1986 - [AFT].
C-----------------------------------------------------------------------
	CHARACTER  GOCERA*(*)
	PARAMETER (GOCERA='BH'//CHAR(12)//'+-*/')
	INTEGER   IFUNC,NBUF,LCHR,I0,J0,I1,J1
	REAL      RBUF(6)
	CHARACTER CHR*(*)
	INTEGER   GRGE00
        CHARACTER GOCSTR*2, GOCERG*2
	DATA GOCERG/'DA'/
C
	INTEGER LUN,MXCNT,ICNT,IBADR,ICOL
	SAVE    LUN,MXCNT,ICNT,IBADR,ICOL
	LOGICAL   APPEND
	SAVE      APPEND
C---
	GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     &       110,120,130,140,150,160,170,180) IFUNC
	GOTO 999
C---
C- IFUNC= 1, Return device name.
10	CHR='GOC'
	LCHR=LEN(CHR)
	RETURN
C---
C- IFUNC= 2, Return Physical min and max for plot device.
20	RBUF(1)=0
	RBUF(2)=768
	RBUF(3)=0
	RBUF(4)=511
	RBUF(5)=0
	RBUF(6)=1
	NBUF=6
	RETURN
C---
C- IFUNC= 3, Return device(X and Y) resolution in pixels per inch as
C- formatted numbers in CHR.
30	RBUF(1)=76.8
	RBUF(2)=76.8
	RBUF(3)=1
	NBUF=3
	RETURN
C---
C- IFUNC= 4, Return misc device info.
40	CHR='ICNNNNNNNN'
	LCHR=10
	RETURN
C---
C- IFUNC= 5, Return default file name.
50	CHR='TT'
	LCHR=LEN(CHR)
	NBUF=1
	RETURN
C---
C- IFUNC= 6, Return default physical size of plot.
60	RBUF(1)=0
	RBUF(2)=768
	RBUF(3)=0
	RBUF(4)=511
	RETURN
C---
C- IFUNC= 7, Return misc defaults.
70	RBUF(1)=2
	NBUF=1
	RETURN
C---
C- IFUNC= 8, Set active plot.
80	CALL INGO03(LUN)
	RETURN
C---
C- IFUNC= 9, Open workstation.
90	APPEND=RBUF(3).NE.0.0
	RBUF(2)=GRGE00('Q1 ',LUN,CHR,LCHR)
	RBUF(1)=LUN
	IF(RBUF(2).EQ.1) THEN
	  CALL INGO03(LUN)
	  MXCNT=130
	  CALL GRGMEM(MXCNT,IBADR)
	END IF
	RETURN
C---
C- IFUNC=10, Close workstation.
100	CALL GRFMEM(MXCNT,IBADR)
	RETURN
C---
C- IFUNC=11, Begin Picture.
110	CALL GRGO10
	IF(.NOT.APPEND) THEN
	  CALL GRGO02(%REF(GOCERG),LEN(GOCERG),%val(IBADR),ICNT,MXCNT)
	END IF
	APPEND=.FALSE.
	RETURN
C---
C- IFUNC=12, Draw line.
120	I0=NINT(RBUF(1))
	J0=NINT(RBUF(2))
	I1=NINT(RBUF(3))
	J1=NINT(RBUF(4))
	CALL GRGO01(I0,J0,I1,J1,%val(IBADR),ICNT,MXCNT)
	RETURN
C---
C- IFUNC=13, Draw dot.
130	I0=NINT(RBUF(1))
	J0=NINT(RBUF(2))
	CALL GRGO01(I0,J0,I0,J0,%val(IBADR),ICNT,MXCNT)
	RETURN
C---
C- IFUNC=14, End Picture.
140	RETURN
C---
C- IFUNC=15, Select pen.
150	RBUF(1) = MAX(0,MIN(NINT(RBUF(1)),1))
	ICOL=RBUF(1)
	IF(ICOL.EQ.0) THEN
	    GOCSTR='FB'
	ELSE
	    GOCSTR='FA'
	END IF
	CALL GRGO02(%REF(GOCSTR),LEN(GOCSTR),%VAL(IBADR),ICNT,MXCNT)
	RETURN
C---
C- IFUNC=16, Flush buffer.
160	CALL GRGO03(%val(IBADR),ICNT)
	RETURN
C---
C- IFUNC=17, Make cursor visible and read position.
170	I0=RBUF(1)
	J0=RBUF(2)
	CALL GRGO11(LUN,I0,J0,CHR)
	RBUF(1)=I0
	RBUF(2)=J0
	NBUF=2
	LCHR=1
	RETURN
C---
C- IFUNC=18, Erase alpha screen.
180	CALL GRGO03(%val(IBADR),ICNT)
	CALL GRGO02(%REF(GOCERA),LEN(GOCERA),%VAL(IBADR),ICNT,MXCNT)
	CALL GRGO03(%val(IBADR),ICNT)
	CALL INGO01
	RETURN
C---
C- Flag function not implemented.
999	NBUF=-1
	RETURN
C---
	END
     
	SUBROUTINE GRGO01(X0,Y0,X1,Y1,IBUF,ICNT,MXCNT)
C-----------------------------------------------------------------------
C GRPCKG(GOC) : draw a line from(X0,Y0) to(X1,Y1)
C
C( 4-Feb-1986 KS / AAO)
C-----------------------------------------------------------------------
	INTEGER   X0, Y0, X1, Y1, IBUF, ICNT, MXCNT
	INTEGER   IGNORE, PTR
	CHARACTER STRING*22
	INTEGER   LSTI,LSTJ
	SAVE      LSTI,LSTJ
C---
	IF(X0.NE.LSTI .OR. Y0.NE.LSTJ) THEN
	    STRING(1:2) = 'GI'          ! Pen up
            WRITE(STRING(3:8),'(2I3.3)',IOSTAT=IGNORE) X0+100,Y0+100
            STRING(9:10) = 'GJ'	       ! Pen down
	    PTR=11
	ELSE
	    PTR=1
	END IF
	WRITE(STRING(PTR:PTR+5),'(2I3.3)',IOSTAT=IGNORE)
     1						X1+100, Y1+100
	CALL GRGO02(%REF(STRING),PTR+5,IBUF,ICNT,MXCNT)
	LSTI = X1
	LSTJ = Y1
	RETURN
C---
	ENTRY INGO01
	LSTI=-1
	LSTJ=-1
	RETURN
C---
	END
C*********
	SUBROUTINE GRGO02(INSTR,N,QBUF,ICNT,MXCNT)
C-----------------------------------------------------------------------
C GRPCKG(GOC) : transfer N bytes to output QBUF
C from INSTR(1...N).  QBUF has to be passed since it is a
C dynamic array.  N should be less than 32, and the routine
C always ensures that at least 32 bytes are left spare in the
C buffer.
C
C( 4-Feb-1986 KS / AAO)
C-----------------------------------------------------------------------
C
	INTEGER N,ICNT,MXCNT
	BYTE    INSTR(N)
	BYTE    QBUF(*)
C---
	INTEGER   I
	CHARACTER INIT*6
	DATA INIT/'+-*/GJ'/
C
	IF(ICNT.EQ.0) THEN
	    DO I=1,LEN(INIT)
		QBUF(I) = ICHAR(INIT(I:I))
	    END DO
	    ICNT = LEN(INIT)
	END IF
	DO I=1,N
	    ICNT = ICNT+1
	    QBUF(ICNT) = INSTR(I)
	END DO
	IF(ICNT+32 .GE. MXCNT) CALL GRGO03(QBUF,ICNT)
	RETURN
	END
C*********
	SUBROUTINE GRGO03(QBUF,ICNT)
C-----------------------------------------------------------------------
C GRPCKG(GOC): flush buffer contents.  QBUF is passed as
C an argument because it is a dynamic array.
C
C( 4-Feb-1986 KS / AAO )
C-----------------------------------------------------------------------
	INCLUDE '($IODEF)'
	INCLUDE '($SSDEF)'
	INTEGER   SYS$QIOW
C
	INTEGER   ICNT,INLUN
	BYTE      QBUF(*)
C
	INTEGER   WRITE
	PARAMETER(WRITE=IO$_WRITEVBLK+IO$M_NOFORMAT+IO$M_CANCTRLO)
	INTEGER   RESULT, N
	INTEGER   IOSB(2)
	INTEGER*2 STBC(2), STATUS, COUNT
	INTEGER   LUN
	SAVE      LUN
C---
	EQUIVALENCE(STBC, IOSB(1)),(STATUS, STBC(1)),(COUNT, STBC(2))
C
C	Insert 'return to alpha mode' code into end of buffer.
C
	N = ICNT
	IF(N.LT.1) RETURN
	QBUF(N+1)=ICHAR('B')
	QBUF(N+2)=ICHAR('H')
	N=N+2
	CALL INGO01
	ICNT = 0
C
C	Now flush buffer
C
	RESULT = SYS$QIOW(,%VAL(LUN),%VAL(WRITE),IOSB,,
     1			  ,QBUF,%VAL(N),,,,)
	IF(RESULT.NE.SS$_NORMAL) THEN
	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW failure writing to GOC terminal')
	END IF
	IF((STATUS.NE.SS$_NORMAL) .AND.
     1	   (STATUS.NE.SS$_CONTROLO) .AND.
     2	   (STATUS.NE.SS$_CONTROLY) .AND.
     3	   (STATUS.NE.SS$_CONTROLC)) THEN
	    RESULT = STATUS
	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW failure writing to GOC terminal')
	END IF
	RETURN
C---
	ENTRY INGO03(INLUN)
	LUN=INLUN
	RETURN
C---
	END
C*********
	SUBROUTINE GRGO10
C--------------------------------------------------------------------
C GRPCKG(GOC) Initialise the terminal.  Note that the display
C is NOT erased.
C
C Initialisation sequence contains -
C
C Graphics flag sequence
C Allow any length graphics sequences
C Graphics cursor off
C Graphics display on
C Alpha display on
C Disable cursor prompt character.
C Set full screen cursor
C Recognise Graphics flag sequence any time in alpha mode
C Return to alpha mode   (appended by GRGO03)
C
C Note the way the GOC modes are controlled.  Assuming that the GOC is in
C reset or alpha mode initially, the initialisation sequence will leave it
C in alpha mode.  Outside the writing of GRPCKG buffers to the GOC, it is
C left in alpha mode.  Whenever a new buffer is started, it begins with
C the graphics flag sequence and a pen down code(inserted by GRGO02).
C Before a buffer is output, it is always terminated by a 'return to alpha
C mode' command(inserted by GRGO03).  Routines - such as GRCURS - that
C have to write directly to the GOC should always flush out the buffer
C first(using GRTERM) and make sure that they leave the GOC in alpha mode.
C
C( 4-Feb-1986 KS / AAO )
C--------------------------------------------------------------------
	CHARACTER  CR, LF
	PARAMETER (CR=CHAR(13),LF=CHAR(10))
C
	INTEGER   ICNT
	CHARACTER GCINIT*27
	DATA GCINIT/'  +-*/DD000CBGAAAHE999CK1GH'/
C---
	GCINIT(1:2)=CR//LF
	ICNT=LEN(GCINIT)
	CALL GRGO03(%ref(GCINIT),ICNT)
C
 	END
C*********
	SUBROUTINE GRGO11(LUN,IX,IY,CH)
C
C	GOC terminals: method is similar to that for Tektronix,
C	except that the control strings and reply are ASCII formatted
C	strings.
C
	INCLUDE  '($IODEF)'
	INCLUDE  '($SSDEF)'
	INTEGER    RPR
	PARAMETER (RPR=IO$_READPROMPT+IO$M_NOFORMAT+
     1			IO$M_PURGE+IO$M_NOECHO+IO$M_TIMED)
	CHARACTER  CR
	PARAMETER (CR=CHAR(13))
	INTEGER    WRT
	PARAMETER (WRT=IO$_WRITEVBLK+IO$M_NOFORMAT)
C
	INTEGER   LUN, IX, IY
	CHARACTER CH
	INTEGER   IOSB(2),RESULT,IER, SYS$QIOW
        CHARACTER GCREP*9, GCROMP*20, GCEND*11
	DATA      GCROMP/'+-*/GICECAxxxyyyCFHF'/
	DATA      GCEND/'+-*/CECBGJBH'/
C---
	WRITE(GCROMP(11:16),'(I3.3,I3.3)',IOSTAT=IER)
     1						IX+100,IY+100
	IX=LEN(GCROMP)
	RESULT = SYS$QIOW(,%VAL(LUN),%VAL(RPR),IOSB,
     1		,,%REF(GCREP),%VAL(9),%VAL(60),,
     2		%REF(GCROMP),%VAL(LEN(GCROMP)))
	IF(RESULT.NE.SS$_NORMAL) THEN
	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW error reading from GOC terminal')
	END IF
	IF(GCREP(8:8).EQ.CR) THEN
	    CH = CHAR(0)
	    READ(GCREP,'(I3,1X,I3)',IOSTAT=IER) IX,IY
	ELSE
	    CH = GCREP(1:1)
	    READ(GCREP,'(1X,I3,1X,I3)',IOSTAT=IER) IX,IY
	END IF
	RESULT = SYS$QIOW(,%VAL(LUN),%VAL(WRT),IOSB,
     1			,,%REF(GCEND),%VAL(LEN(GCEND)),,,,)
	IF(RESULT.NE.SS$_NORMAL) THEN
	    CALL GRGMSG(RESULT)
	    CALL GRQUIT('SYS$QIOW error writing to GOC terminal')
	END IF
	CALL INGO01
	RETURN
	END

C*GRVECT -- draw line segments or dots
C+
      SUBROUTINE GRVECT (IDENT,MODE,ABSXY,POINTS,X,Y)
C
C GRPCKG: Draw a line or a set of dots. This routine can be used to
C draw a single line-segment, a continuous series of line segments, or
C one or more single dots (pixels).
C
C Arguments:
C
C IDENT (input, integer): the plot identifier, as returned by GROPEN.
C MODE (input, integer): if MODE=1, a series of line segments is drawn,
C       starting at the current position, moving to X(1),Y(1), ... and
C       ending at X(POINTS),Y(POINTS).
C       If MODE=2, the first vector is blanked, so the line starts at
C       X(1),Y(1).
C       If MODE=3, a single dot is placed at each coordinate pair, with
C       no connecting lines.
C ABSXY (input, logical): if TRUE, the coordinates are absolute device
C       coordinates; if FALSE, they are world coordinates and the
C       scaling transformation is applied.
C POINTS (input, integer): the number of coordinate pairs.
C X, Y (input, real arrays, dimensioned POINTS or greater): the
C       X and Y coordinates of the points.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INTEGER  IDENT, MODE, POINTS
      LOGICAL  ABSXY
      REAL     X(POINTS), Y(POINTS)
C
      CALL GRSLCT(IDENT)
      IF (MODE.LE.0 .OR. MODE.GT.3) THEN
          CALL GRWARN('GRVECT - invalid MODE parameter.')
      ELSE IF (POINTS.GT.0) THEN
          CALL GRVCT0(MODE, ABSXY, POINTS, X, Y)
      END IF
C
      END

C*PGQCIR -- inquire color index range
C%void cpgqcir(int *icilo, int *icihi);
C+
      SUBROUTINE PGQCIR(ICILO, ICIHI)
      INTEGER   ICILO, ICIHI
C
C Query the color index range to be used for producing images with
C PGGRAY or PGIMAG, as set by routine PGSCIR or by device default.
C
C Arguments:
C  ICILO  (output) : the lowest color index to use for images
C  ICIHI  (output) : the highest color index to use for images
C--
C 1994-Mar-17 : new routine [AFT/TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
C---
      ICILO = PGMNCI(PGID)
      ICIHI = PGMXCI(PGID)
C
      END

C*PGPOLY -- draw a polygon, using fill-area attributes
C%void cpgpoly(int n, const float *xpts, const float *ypts);
C+
      SUBROUTINE PGPOLY (N, XPTS, YPTS)
      INTEGER N
      REAL XPTS(*), YPTS(*)
C
C Fill-area primitive routine: shade the interior of a closed
C polygon in the current window.  The action of this routine depends
C on the setting of the Fill-Area Style attribute (see PGSFS).
C The polygon is clipped at the edge of the
C window. The pen position is changed to (XPTS(1),YPTS(1)) in world
C coordinates (if N > 1).  If the polygon is not convex, a point is
C assumed to lie inside the polygon if a straight line drawn to
C infinity intersects and odd number of the polygon's edges.
C
C Arguments:
C  N      (input)  : number of points defining the polygon; the
C                    line consists of N straight-line segments,
C                    joining points 1 to 2, 2 to 3,... N-1 to N, N to 1.
C                    N should be greater than 2 (if it is 2 or less,
C                    nothing will be drawn).
C  XPTS   (input)  : world x-coordinates of the vertices.
C  YPTS   (input)  : world y-coordinates of the vertices.
C                    Note: the dimension of arrays XPTS and YPTS must be
C                    greater than or equal to N.
C--
C 21-Nov-1983 - [TJP].
C 16-Jul-1984 - revised to shade polygon with GRFA [TJP].
C 21-Oct-1985 - test PGFAS [TJP].
C 25-Nov-1994 - implement clipping [TJP].
C 13-Jan-1994 - fix bug in clipping [TJP].
C  6-Mar-1995 - add support for fill styles 3 and 4 [TJP].
C 12-Sep-1995 - fix another bug in clipping [TJP].
C-----------------------------------------------------------------------
      INTEGER MAXOUT
      PARAMETER (MAXOUT=1000)
      LOGICAL CLIP
      INTEGER I, N1, N2, N3, N4
      REAL    QX(MAXOUT), QY(MAXOUT), RX(MAXOUT), RY(MAXOUT)
      REAL    XL, XH, YL, YH
      LOGICAL PGNOTO
      INCLUDE 'pgplot.inc'
C
      IF (PGNOTO('PGPOLY')) RETURN
      IF (N.LT.1) RETURN
C
C Outline style, or polygon of less than 3 vertices.
C
      IF (PGFAS(PGID).EQ.2 .OR. N.LT.3) THEN
         CALL PGBBUF
         CALL GRMOVA(XPTS(N),YPTS(N))
         DO 10 I=1,N
            CALL GRLINA(XPTS(I),YPTS(I))
 10      CONTINUE
C
C Hatched style.
C
      ELSE IF (PGFAS(PGID).EQ.3) THEN
         CALL PGBBUF
         CALL PGHTCH(N, XPTS, YPTS, 0.0)
      ELSE IF (PGFAS(PGID).EQ.4) THEN
         CALL PGBBUF
         CALL PGHTCH(N, XPTS, YPTS, 0.0)
         CALL PGHTCH(N, XPTS, YPTS, 90.0)
      ELSE
C     
C Test whether polygon lies completely in the window.
C     
         CLIP = .FALSE.
         XL = MIN(PGXBLC(PGID),PGXTRC(PGID))
         XH = MAX(PGXBLC(PGID),PGXTRC(PGID))
         YL = MIN(PGYBLC(PGID),PGYTRC(PGID))
         YH = MAX(PGYBLC(PGID),PGYTRC(PGID))
         DO 20 I=1,N
            IF (XPTS(I).LT.XL .OR. XPTS(I).GT.XH .OR.
     :           YPTS(I).LT.YL .OR. YPTS(I).GT.YH) THEN
               CLIP = .TRUE.
               GOTO 30
            END IF
 20      CONTINUE
 30      CONTINUE
C     
C Filled style, no clipping required.
C     
         CALL PGBBUF
         IF (.NOT.CLIP) THEN
            CALL GRFA(N,XPTS,YPTS)
C     
C Filled style, clipping required: the vertices of the clipped
C polygon are put in temporary arrays QX,QY, RX, RY.
C     
         ELSE
            CALL GRPOCL(N,  XPTS, YPTS, 1, XL, MAXOUT, N1, QX, QY)
            IF (N1.GT.MAXOUT) GOTO 40
            IF (N1.LT.3) GOTO 50
            CALL GRPOCL(N1, QX,   QY,   2, XH, MAXOUT, N2, RX, RY)
            IF (N2.GT.MAXOUT) GOTO 40
            IF (N2.LT.3) GOTO 50
            CALL GRPOCL(N2, RX,   RY,   3, YL, MAXOUT, N3, QX, QY)
            IF (N3.GT.MAXOUT) GOTO 40
            IF (N3.LT.3) GOTO 50
            CALL GRPOCL(N3, QX,   QY,   4, YH, MAXOUT, N4, RX, RY)
            IF (N4.GT.MAXOUT) GOTO 40
            IF (N4.GT.0) CALL GRFA(N4,RX,RY)
            GOTO 50
 40         CALL GRWARN('PGPOLY: polygon is too complex')
 50         CONTINUE
         END IF
      END IF
C
C Set the current pen position.
C
      CALL GRMOVA(XPTS(1),YPTS(1))
      CALL PGEBUF
C
      END

C*GRSYDS -- decode character string into list of symbol numbers
C+
      SUBROUTINE GRSYDS (SYMBOL, NSYMBS, TEXT, FONT)
      INTEGER SYMBOL(*), NSYMBS, FONT
      CHARACTER*(*) TEXT
C
C Given a character string, this routine returns a list of symbol
C numbers to be used to plot it. It is responsible for interpreting
C all escape sequences.  Negative `symbol numbers' are inserted in the
C list to represent pen movement. The following escape sequences are
C defined (the letter following the \ may be either upper or lower 
C case):
C
C \u       :      up one level (returns -1)
C \d       :      down one level (returns -2)
C \b       :      backspace (returns -3)
C \A       :      (upper case only) Angstrom symbol, roman font
C \x       :      multiplication sign
C \.       :      centered dot
C \\       :      \, returns the code for backslash
C \gx      :      greek letter corresponding to roman letter x
C \fn      :      switch to Normal font
C \fr      :      switch to Roman font
C \fi      :      switch to Italic font
C \fs      :      switch to Script font
C \mn or \mnn :   graph marker number n or nn (1 or 2 digits)
C \(nnn)   :      Hershey symbol number nnn (any number of digits)
C
C Arguments:
C  SYMBOL (output) : receives the list of symbol numers.
C  NSYMBS (output) : receives the actual number of symbols specified
C                    by the string; it is assumed that the dimension of
C                    SYMBOL is big enough (not less than LEN(TEXT)).
C  TEXT   (input)  : the text string to be decoded.
C  FONT   (input)  : the font number (1..4) to be used for decoding the
C                    string (this can be overridden by an escape
C                    sequence within the string).
C--
C  3-May-1983 - [TJP].
C 13-Jun-1984 - add \A [TJP].
C 15-Dec-1988 - standardize [TJP].
C 29-Nov-1990 - add \m escapes [TJP].
C 27-Nov-1991 - add \x escape [TJP].
C 27-Jul-1995 - extend for 256-character set [TJP]
C  7-Nov-1995 - add \. escape [TJP].
C-----------------------------------------------------------------------
      CHARACTER*8  FONTS
      CHARACTER*48 GREEK
      PARAMETER (FONTS = 'nrisNRIS')
      PARAMETER (GREEK = 'ABGDEZYHIKLMNCOPRSTUFXQW' //
     1                   'abgdezyhiklmncoprstufxqw' )
      INTEGER  CH, IG, J, LENTXT, IFONT, MARK
C
C Initialize parameters.
C
      IFONT = FONT
      LENTXT = LEN(TEXT)
      NSYMBS = 0
      J = 0
C
C Get next character; treat non-printing characters as spaces.
C
  100 J = J+1
      IF (J.GT.LENTXT) RETURN
      CH = ICHAR(TEXT(J:J))
      IF (CH.LT.0)   CH = 32
      IF (CH.GT.303) CH = 32
C
C Test for escape sequence (\)
C
      IF (CH.EQ.92) THEN
          IF ((LENTXT-J).GE.1) THEN
            IF (TEXT(J+1:J+1).EQ.CHAR(92)) THEN
                J = J+1
            ELSE IF (TEXT(J+1:J+1).EQ.'u' .OR.
     1                     TEXT(J+1:J+1).EQ.'U') THEN
                NSYMBS = NSYMBS + 1
                SYMBOL(NSYMBS) = -1
                J = J+1
                GOTO 100
            ELSE IF (TEXT(J+1:J+1).EQ.'d' .OR.
     1                     TEXT(J+1:J+1).EQ.'D') THEN
                NSYMBS = NSYMBS + 1
                SYMBOL(NSYMBS) = -2
                J = J+1
                GOTO 100
            ELSE IF (TEXT(J+1:J+1).EQ.'b' .OR.
     1                     TEXT(J+1:J+1).EQ.'B') THEN
                NSYMBS = NSYMBS + 1
                SYMBOL(NSYMBS) = -3
                J = J+1
                GOTO 100
            ELSE IF (TEXT(J+1:J+1).EQ.'A') THEN
                NSYMBS = NSYMBS + 1
                SYMBOL(NSYMBS) = 2078
                J = J+1
                GOTO 100
            ELSE IF (TEXT(J+1:J+1).EQ.'x') THEN
                NSYMBS = NSYMBS + 1
                SYMBOL(NSYMBS) = 2235
                IF (IFONT.EQ.1) SYMBOL(NSYMBS) = 727
                J = J+1
                GOTO 100
            ELSE IF (TEXT(J+1:J+1).EQ.'.') THEN
                NSYMBS = NSYMBS + 1
                SYMBOL(NSYMBS) = 2236
                IF (IFONT.EQ.1) SYMBOL(NSYMBS) = 729
                J = J+1
                GOTO 100
            ELSE IF (TEXT(J+1:J+1).EQ.'(') THEN
                NSYMBS = NSYMBS + 1
                SYMBOL(NSYMBS) = 0
                J = J+2
C               -- DO WHILE ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9')
   90           IF ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9') THEN
                  SYMBOL(NSYMBS) = SYMBOL(NSYMBS)*10 +
     1                      ICHAR(TEXT(J:J)) - ICHAR('0')
                   J = J+1
                GOTO 90
                END IF
C               -- end DO WHILE
                IF (TEXT(J:J).NE.')') J = J-1
                GOTO 100
            ELSE IF (TEXT(J+1:J+1).EQ.'m' .OR.
     1               TEXT(J+1:J+1).EQ.'M') THEN
                MARK = 0
                J = J+2
                IF ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9') THEN
                    MARK = MARK*10 + ICHAR(TEXT(J:J)) - ICHAR('0')
                    J = J+1
                END IF
                IF ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9') THEN
                    MARK = MARK*10 + ICHAR(TEXT(J:J)) - ICHAR('0')
                    J = J+1
                END IF
                J = J-1
                NSYMBS = NSYMBS + 1
                CALL GRSYMK(MARK, IFONT, SYMBOL(NSYMBS))
                GOTO 100
            ELSE IF (TEXT(J+1:J+1).EQ.'f' .OR.
     1               TEXT(J+1:J+1).EQ.'F') THEN
                IFONT = INDEX(FONTS, TEXT(J+2:J+2))
                IF (IFONT.GT.4) IFONT = IFONT-4
                IF (IFONT.EQ.0) IFONT = 1
                J = J+2
                GOTO 100
            ELSE IF (TEXT(J+1:J+1).EQ.'g' .OR.
     1               TEXT(J+1:J+1).EQ.'G') THEN
                IG = INDEX(GREEK, TEXT(J+2:J+2))
                NSYMBS = NSYMBS + 1
                CALL GRSYMK(255+IG, IFONT, SYMBOL(NSYMBS))
                J = J+2
                GOTO 100
            END IF
          END IF
      END IF
C
C Decode character.
C
      NSYMBS = NSYMBS + 1
      CALL GRSYMK(CH, IFONT, SYMBOL(NSYMBS))
      GOTO 100
      END

C*MFDRIV -- PGPLOT Graphics MetaFile driver
C+
      SUBROUTINE MFDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Graphics MetaFile device.
C
C Version 1.0 - 1989 May 09 - S. C. Allendorf
C                             First attempt at recreating the old
C                             MetaFile device.  Code based on original
C                             version written by Tim Pearson.
C Version 1.1 - 1989 May 20 - S. C. Allendorf
C                             Make driver conform as closely as possible
C                             to the standard without breaking GMFPLOT
C                             and/or PGPLOT.  Deviations from the 
C                             standard are marked with 
C                             *** DEVIATION ***.  GMFPLOT and/or PGPLOT 
C                             would need to be changed to correct these
C                             parts.
C=======================================================================
C
C Supported device: The MetaFile device can be used to a store graphic 
C image in a device-independent disk file.
C
C Device type code: /FILE.
C
C Default device name: PGPLOT.GMF.
C
C Default view surface dimensions: Undefined (nominally 8 inches
C square).
C
C Resolution: Undefined.
C
C Color capability: Color indices 0-255 are accepted and the
C representation of all colors may be changed.  The actual colors used
C depend upon the output device chosen when the file is rendered.
C
C Input capability: None.
C
C File format: The metafile generated follow the "GSPC Metafile 
C Proposal" described in Computer Graphics (A.C.M.), Volume 13, number 3
C (August 1979).
C
C Obtaining hardcopy: Use the translator program GMFPLOT.
C-----------------------------------------------------------------------
      LOGICAL    CONT
      INTEGER*2  BUFFER(360), COMBUF(5), I0, I1, IB, IC, IG, IR, J0, J1
      INTEGER*2  LASTI, LASTJ, NPICT, NPTS
      INTEGER*4  HW, IER, LUN, REMCAL
      REAL*4     RATIO, SCALE, XMAX, YMAX
      CHARACTER  MSG*10
      CHARACTER*(*) DEFNAM, TYPE
      PARAMETER  (DEFNAM = 'PGPLOT.GMF')
      PARAMETER  (TYPE = 'FILE  (PGPLOT graphics metafile)')
C-----------------------------------------------------------------------
C                                      Branch on opcode.
      GOTO ( 10,  20,  30,  40,  50,  60,  70,  80,  90, 100,
     1      110, 120, 130, 140, 150, 160, 170, 180, 190, 200,
     2      210, 220, 230, 240, 250, 260), IFUNC
C                                      Signal an error.
  900 WRITE (MSG, '(I10)') IFUNC
      CALL GRWARN ('Unimplemented function in MetaFile device driver:' 
     1             // MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CONTINUE
      CHR = TYPE
      NBUF = 0
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 CONTINUE
      RBUF(1) = 0.0
      RBUF(2) = 32767.0
      RBUF(3) = 0.0
      RBUF(4) = 32767.0
      RBUF(5) = 0.0
      RBUF(6) = 255.0
      NBUF = 6
      LCHR = 0
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 CONTINUE
      RBUF(1) = 4096.0
      RBUF(2) = 4096.0
      RBUF(3) = 1.0
      NBUF = 3
      LCHR = 0
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, No cursor, Dashed lines, Area fill,
C    Thick lines, Rectangle fill, No line of pixels)
C
   40 CONTINUE
      CHR = 'HNDATRNNNN'
      NBUF = 0
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CONTINUE
      CHR = DEFNAM
      NBUF = 0
      LCHR = LEN (DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 CONTINUE
      RBUF(1) = 0.0
      RBUF(2) = 32767.0
      RBUF(3) = 0.0
      RBUF(4) = 32767.0
      NBUF = 4
      LCHR = 0
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 CONTINUE
      RBUF(1) = 20.0
      NBUF = 1
      LCHR = 0
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C                                      Assume success.
      RBUF(2) = 1.0
C                                      Obtain a logical unit number.
      CALL GRGLUN (LUN)
C                                      Check for an error.
      IF (LUN .EQ. -1) THEN
         CALL GRWARN ('Cannot allocate a logical unit.')
         RBUF(2) = 0.0
         RETURN
      ELSE
         RBUF(1) = LUN
      END IF
C                                      Open the output file.
      OPEN (UNIT = LUN, FILE = CHR(:LCHR), CARRIAGECONTROL = 'NONE',
     1      DEFAULTFILE = DEFNAM, DISPOSE = 'DELETE', STATUS = 'NEW',
     2      RECL = 180, FORM = 'UNFORMATTED', RECORDTYPE = 'FIXED', 
     3      IOSTAT = IER)
C                                      Check for an error and cleanup if
C                                      one occurred.
      IF (IER .NE. 0) THEN
         CALL GRWARN ('Cannot open output file for MetaFile plot: ' //
     1                CHR(:LCHR))
         CALL GRFLUN (LUN)
         RBUF(2) = 0
         RETURN
      ELSE
C                                      Get the full file specification
C                                      and calculate the length of the 
C                                      string
         INQUIRE (UNIT = LUN, NAME = CHR)
         LCHR = LEN (CHR)
   95    IF (CHR (LCHR:LCHR) .EQ. ' ') THEN
            LCHR = LCHR - 1
            GOTO 95
         END IF
      END IF
C                                      Initialize the page counter.
      NPICT = 0
C                                      Initialize the high water mark.
      HW = 0
C                                      Send the BEGIN_METAFILE command,
C                                      requesting 15-bit precision.
      COMBUF(1) = '8001'X
      COMBUF(2) = '0001'X
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      RETURN
C
C--- IFUNC = 10, Close workstation -------------------------------------
C
  100 CONTINUE
C                                      Send the END_METAFILE command.
      CALL GRMF01 (1, '8100'X, BUFFER, LUN, HW)
C                                      Flush the buffer.
      CALL GRMF02 (LUN, HW, BUFFER)
C                                      Close the file.
      CLOSE (LUN, DISPOSE = 'KEEP')
C                                      Deallocate the logical unit.
      CALL GRFLUN (LUN)
C
      RETURN
C
C--- IFUNC = 11, Begin picture -----------------------------------------
C
  110 CONTINUE
C                                      Increment the page number.
      NPICT = NPICT + 1
C                                      *** DEVIATION ***
C                                      The MetaFile standard defines 
C                                      the initial pen position to be at
C                                      (0, 0).  This causes problems for
C                                      PGPLOT.
C
C                                      Set the last position to unknown.
      LASTI = -1
      LASTJ = -1
C                                      Check to see if this is the first 
C                                      picture.
      IF (NPICT .EQ. 1) THEN
C                                      Initialize the requested size and
C                                      and scale factor.
         XMAX = INT (RBUF(1) + 0.5)
         YMAX = INT (RBUF(2) + 0.5)
         SCALE = 1.0
C                                      See if the user has requested a
C                                      specific size.
         IF (XMAX .NE. 32767.0 .OR. YMAX .NE. 32767.0) THEN
C                                      Calculate the the maximum 
C                                      coordinates and the scale factor.
            COMBUF(2) = 32767
            COMBUF(3) = 32767
            RATIO = (YMAX + 1.0) / (XMAX + 1.0)
            IF (RATIO .LT. 1.0) THEN
               SCALE = 32767.0 / XMAX
               XMAX = 32767.0
               YMAX = INT (32768.0 * RATIO - 0.5)
               COMBUF(3) = YMAX
            ELSE IF (RATIO .GT. 1.0) THEN
               SCALE = 32767.0 / YMAX
               XMAX = INT (32768.0 / RATIO - 0.5)
               YMAX = 32767.0
               COMBUF(2) = XMAX
            ELSE
               SCALE = 32767.0 / XMAX
               XMAX = 32767.0
               YMAX = 32767.0
            END IF
C                                      Send DEFINE_NDC_SPACE command 
C                                      along with X, Y, and Z ranges if
C                                      the user hasn't requested a
C                                      square plot.
            IF (RATIO .NE. 1.0) THEN
               COMBUF(1) = '8203'X
               COMBUF(4) = 0
               CALL GRMF01 (4, COMBUF, BUFFER, LUN, HW)
            END IF
         END IF
      END IF
C                                      Flush buffer to get to a record
C                                      boundary.
      CALL GRMF02 (LUN, HW, BUFFER)
C                                      Send BEGIN_PICTURE command with
C                                      the picture number.
      COMBUF(1) = '9001'X
      COMBUF(2) = NPICT
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      RETURN
C
C--- IFUNC = 12, Draw line ---------------------------------------------
C
  120 CONTINUE
C                                      Scale and convert to integer.
      I0 = INT (MIN (RBUF(1) * SCALE + 0.5, XMAX))
      J0 = INT (MIN (RBUF(2) * SCALE + 0.5, YMAX))
      I1 = INT (MIN (RBUF(3) * SCALE + 0.5, XMAX))
      J1 = INT (MIN (RBUF(4) * SCALE + 0.5, YMAX))
C                                      See if this is a continuation.
      CONT = (LASTI .EQ. I0) .AND. (LASTJ .EQ. J0)
C                                      Draw the line.
      CALL GRMF00 (I0, J0, I1, J1, CONT, BUFFER, LUN, HW)
C                                      Update the last position
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC = 13, Draw dot ----------------------------------------------
C
  130 CONTINUE
C                                      Convert to integer.
      I0 = INT (MIN (RBUF(1) * SCALE + 0.5, XMAX))
      J0 = INT (MIN (RBUF(2) * SCALE + 0.5, YMAX))
C                                      Draw the dot.
      CALL GRMF00 (I0, J0, I0, J0, .FALSE., BUFFER, LUN ,HW)
C                                      Update the last position.
      LASTI = I0
      LASTJ = J0
      RETURN
C
C--- IFUNC = 14, End picture -------------------------------------------
C
  140 CONTINUE
C                                      Send a END_PICTURE command.
      CALL GRMF01 (1, '9100'X, BUFFER, LUN, HW)
      RETURN
C
C--- IFUNC = 15, Select color index ------------------------------------
C
  150 CONTINUE
C                                      Save the requested color index.
      IC = RBUF(1)
C                                      *** DEVIATION ***
C                                      The MetaFile standard defines 
C                                      indices 0-7 and they are 
C                                      different than those defined by 
C                                      PGPLOT.
C
C                                      Send the SET_COLOR command along 
C                                      with the color index.
      COMBUF(1) = 'C101'X
      COMBUF(2) = IC
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      RETURN
C
C--- IFUNC = 16, Flush buffer. -----------------------------------------
C    (Not implemented: ignored.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC = 17, Read cursor. ------------------------------------------
C    (Not implemented: should not be called.)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC = 18, Erase alpha screen. -----------------------------------
C    (Not implemented: ignored.)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC = 19, Set line style. ---------------------------------------
C
  190 CONTINUE
C                                      Convert to an integer.
      IC = RBUF(1)
C                                      Send SET_LINESTYLE command along
C                                      width the requested linestyle.
      COMBUF(1) = 'C301'X
      COMBUF(2) = IC
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      RETURN
C
C--- IFUNC = 20, Polygon fill. -----------------------------------------
C
  200 CONTINUE
      IF (REMCAL .EQ. 0) THEN
C                                      First time, send DRAW_POLYGON and
C                                      the number of points.
         NPTS = RBUF(1)
         REMCAL = NPTS
         COMBUF(1) = 'A701'X
         COMBUF(2) = NPTS
         CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      ELSE
C                                      Second and succeeding calls,
C                                      MOVE to first point, DRAW to the
C                                      rest, and decrement the counter.
         COMBUF(1) = INT (MIN (RBUF(1) * SCALE + 0.5, XMAX))
         COMBUF(2) = INT (MIN (RBUF(2) * SCALE + 0.5, YMAX))
         IF (REMCAL .NE. NPTS) COMBUF(2) = IBSET (COMBUF(2), 15)
         CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
         REMCAL = REMCAL - 1
C                                      *** DEVIATION ***
C                                      The MetaFile standard defines 
C                                      the pen position after a polygon
C                                      draw to be at the first point.
C                                      This causes problems for PGPLOT.
C
C                                      Set the pen position to unknown.
         IF (REMCAL .EQ. 0) LASTI = -1
      END IF
      RETURN
C
C--- IFUNC = 21, Set color representation. -----------------------------
C
  210 CONTINUE
C                                      *** DEVIATION ***
C                                      The MetaFile standard defines 
C                                      indices 0-7 and does not allow 
C                                      them to be changed.
C
C                                      Convert input to integer
      IC = RBUF(1)
      IR = INT (MIN (32767.0, MAX (RBUF(2) * 32767.0, 0.0)))
      IG = INT (MIN (32767.0, MAX (RBUF(3) * 32767.0, 0.0)))
      IB = INT (MIN (32767.0, MAX (RBUF(4) * 32767.0, 0.0)))
C                                      Send DEFINE_COLOR_INDEX command
C                                      along with the index to be 
C                                      defined and its definition.
      COMBUF(1) = 'C004'X
      COMBUF(2) = IC
      COMBUF(3) = IR
      COMBUF(4) = IG
      COMBUF(5) = IB
      CALL GRMF01 (5, COMBUF, BUFFER, LUN, HW)
      RETURN
C
C--- IFUNC = 22, Set line width. ---------------------------------------
C
  220 CONTINUE
C                                      *** DEVIATION ***
C                                      The MetaFile standard defines 
C                                      linewidths differently than
C                                      PGPLOT.
C
C                                      Convert to an integer.
      IC = RBUF(1)
C                                      Send SET_LINEWIDTH command along
C                                      with the requested line width.
      COMBUF(1) = 'C401'X
      COMBUF(2) = IC
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      RETURN
C
C--- IFUNC = 23, Escape ------------------------------------------------
C    (Not implemented: ignored.)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC = 24, Rectangle fill. ---------------------------------------
C
  240 CONTINUE
C                                      Scale and convert to integer.
      I0 = INT (MIN (RBUF(1) * SCALE + 0.5, XMAX))
      J0 = INT (MIN (RBUF(2) * SCALE + 0.5, YMAX))
      I1 = INT (MIN (RBUF(3) * SCALE + 0.5, XMAX))
      J1 = INT (MIN (RBUF(4) * SCALE + 0.5, YMAX))
C                                      Simulate a hardware area fill.
      COMBUF(1) = 'A701'X
      COMBUF(2) = 4
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      COMBUF(1) = I0
      COMBUF(2) = J0
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      COMBUF(1) = I1
      COMBUF(2) = IBSET (J0, 15)
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      COMBUF(1) = I1
      COMBUF(2) = IBSET (J1, 15)
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
      COMBUF(1) = I0
      COMBUF(2) = IBSET (J1, 15)
      CALL GRMF01 (2, COMBUF, BUFFER, LUN, HW)
C                                      *** DEVIATION ***
C                                      The MetaFile standard defines 
C                                      the pen position after a polygon
C                                      draw to be at the first point.
C                                      This causes problems for PGPLOT.
C
C                                      Set the pen position to unknown.
      LASTI = -1
      RETURN
C
C--- IFUNC = 25, -------------------------------------------------------
C    (Not implemented: should not be called.)
C
  250 CONTINUE
      GOTO 900
C
C--- IFUNC = 26, Line of pixels. ---------------------------------------
C    (Not implemented: should not be called.)
C
  260 CONTINUE
      GOTO 900
C-----------------------------------------------------------------------
      END

C*GRMF00 -- PGPLOT MetaFile driver, draw a line segment
C+
      SUBROUTINE GRMF00 (I0, J0, I1, J1, CONT, BUFFER, LUN, HW)
      LOGICAL    CONT
      INTEGER*2  BUFFER(360), I0, I1, J0, J1
      INTEGER*4  HW, LUN
C-----------------------------------------------------------------------
C Draw a line. This requires a MOVE command (unless the starting point 
C is the same point as the end point of the last line) followed by a 
C DRAW command.
C
C Arguments:
C
C  I0, J0 (input)         The absolute device coordinates of the 
C                            starting point of the line
C  I1, J1 (input)         The absolute device coordinates of the ending
C                            point of the line
C  CONT   (input)         Flag denoting whether the line is a 
C                            continuation
C  BUFFER (input/output)  The buffer
C-----------------------------------------------------------------------
      INTEGER*2  OUTPUT(4)
      INTEGER*4  K
C-----------------------------------------------------------------------
C                                      Initialize the counter.
      K = 0
C                                      See if we need to MOVE first.
      IF (.NOT. CONT) THEN
C                                      Increment the counter.
         K = 2
C                                      Output the coordinates.
         OUTPUT(1) = I0
         OUTPUT(2) = J0
      END IF
C                                      Send the x coordinate.
      OUTPUT(K + 1) = I1
C                                      Mark the y coordinate as a DRAW
C                                      command and output it.
      OUTPUT(K + 2) = IBSET (J1, 15)
C                                      Increment the counter.
      K = K + 2
C                                      Transfer the coordinates to the
C                                      buffer.
      CALL GRMF01 (K, OUTPUT, BUFFER, LUN, HW)
C-----------------------------------------------------------------------
      RETURN
      END

C*GRMF01 -- PGPLOT MetaFile driver, transfer chunks to output buffer
C+
      SUBROUTINE GRMF01 (N, CHUNKS, BUFFER, LUN, HW)
      INTEGER*4  HW, LUN, N
      INTEGER*2  CHUNKS(N), BUFFER(360)
C
C Transfer metafile chunks to output buffer. If the command would
C overflow, it is flushed to the output device using routine GRMF02.
C
C Arguments:
C
C  N      (input)         The number of chunks to transfer
C  CHUNKS (input)         The chunks to transfer
C  BUFFER (input/output)  The buffer
C  LUN    (input)         Fortran unit number for output
C  HW     (input/output)  Number of elements used in BUFFER
C-----------------------------------------------------------------------
      INTEGER*4  I
C-----------------------------------------------------------------------
C                                      Flush the buffer if the command
C                                      would overflow it.
      IF (HW + N .GT. 360) CALL GRMF02 (LUN, HW, BUFFER)
C                                      Transfer the chunks to the
C                                      buffer.
      DO 10 I = 1, N
C                                      Increment the high water mark.
         HW = HW + 1
C                                      Move the chunk to the buffer.
         BUFFER(HW) = CHUNKS(I)
   10 CONTINUE
C-----------------------------------------------------------------------
      RETURN
      END

C*GRMF02 -- PGPLOT MetaFile driver, flush metafile buffer contents
C+
      SUBROUTINE GRMF02 (LUN, HW, BUFFER)
      INTEGER*2  BUFFER(360)
      INTEGER*4  HW, LUN
C
C Flush metafile buffer contents. If the buffer is not full, it is 
C padded with NO_OPERATION commands.
C
C Arguments:
C
C  LUN    (input)         Fortran unit number for output
C  HW     (input/output)  Number of elements used in BUFFER
C  BUFFER (input/output)  The buffer
C-----------------------------------------------------------------------
      INTEGER*4  I
C-----------------------------------------------------------------------
C                                      See if the buffer has anything in
C                                      it.
      IF (HW .GT. 0) THEN
C                                      Fill buffer with NO_OPERATION
C                                      commands.
         DO 10 I = HW + 1 ,360
            BUFFER(I) = '8400'X
   10    CONTINUE
C                                      Write out the buffer.
         WRITE (LUN) BUFFER
C                                      Reset the high water mark.
         HW = 0
      END IF
C-----------------------------------------------------------------------
      RETURN
      END

C*GRUSER -- get user name (VMS)
C+
      SUBROUTINE GRUSER(STRING, L)
      CHARACTER*(*) STRING
      INTEGER L
C
C Return the name of the user running the program.
C
C Arguments:
C  STRING : receives user name, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in STRING, excluding
C           trailing blanks.
C--
C 19-Jan-1988
C-----------------------------------------------------------------------
      INTEGER LIB$GETJPI
      INTEGER I, IER, LENGTH
      EXTERNAL JPI$_USERNAME
C
      STRING = ' '
      IER = LIB$GETJPI(%LOC(JPI$_USERNAME),,,,STRING,LENGTH)
      L = MIN(LENGTH, LEN(STRING))
      IF (L.LT.1 .OR. STRING.EQ.' ') THEN
          L = 0
          STRING = ' '
      ELSE
          DO 10 I=L,1,-1
              L = I
              IF (STRING(I:I).NE.' ') GOTO 20
   10     CONTINUE
          L = 0
   20     CONTINUE
      END IF
      END

C*GRIMG1 -- image of a 2D data array (image-primitive devices)
C+
      SUBROUTINE GRIMG1 (A, IDIM, JDIM, I1, I2, J1, J2,
     1                   A1, A2, PA, MININD, MAXIND, MODE)
      INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE
      REAL    A(IDIM,JDIM), A1, A2, PA(6)
C
C (This routine is called by GRIMG0.)
C--
C 7-Sep-1994  New routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER NBUF, LCHR
      REAL    RBUF(21), FAC, AV, SFAC, SFACL
      CHARACTER*1 CHR
      INTEGER  I, J, II, NXP, NYP, IV
      INTRINSIC NINT, LOG
      PARAMETER (SFAC=65000.0)
C-----------------------------------------------------------------------
C Size of image.
C
      NXP = I2 - I1 + 1
      NYP = J2 - J1 + 1
      RBUF(1) = 0.0
      RBUF(2) = NXP
      RBUF(3) = NYP
C
C Clipping rectangle.
C
      RBUF(4) = GRXMIN(GRCIDE)
      RBUF(5) = GRXMAX(GRCIDE)
      RBUF(6) = GRYMIN(GRCIDE)
      RBUF(7) = GRYMAX(GRCIDE)
C
C Image transformation matrix.
C
      FAC = PA(2)*PA(6) - PA(3)*PA(5)
      RBUF(8)  =  PA(6)/FAC
      RBUF(9)  = (-PA(5))/FAC
      RBUF(10) = (-PA(3))/FAC
      RBUF(11) =  PA(2)/FAC
      RBUF(12) = (PA(3)*PA(4) - PA(1)*PA(6))/FAC - (I1-0.5)
      RBUF(13) = (PA(5)*PA(1) - PA(4)*PA(2))/FAC - (J1-0.5)
C
C Send setup info to driver.
C
      IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
      CALL GRTERM
      NBUF = 13
      LCHR = 0
      CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
C
C Convert image array to color indices and send to driver.
C
      SFACL = LOG(1.0+SFAC)
      II = 0
      DO 20 J = J1,J2
          DO 10 I = I1,I2
              AV = A(I,J)
              IF (A2.GT.A1) THEN
                  AV = MIN(A2, MAX(A1,AV))
              ELSE
                  AV = MIN(A1, MAX(A2,AV))
              END IF
              IF (MODE.EQ.0) THEN
                IV = NINT((MININD*(A2-AV) + MAXIND*(AV-A1))/(A2-A1))
              ELSE IF (MODE.EQ.1) THEN
                IV = MININD + NINT((MAXIND-MININD)*
     :               LOG(1.0+SFAC*ABS((AV-A1)/(A2-A1)))/SFACL)
              ELSE IF (MODE.EQ.2) THEN
                IV = MININD + NINT((MAXIND-MININD)*
     :                             SQRT(ABS((AV-A1)/(A2-A1))))
              ELSE
                IV = MININD
              END IF
              II = II + 1
              RBUF(II+1) = IV
              IF (II.EQ.20) THEN
                  NBUF = II + 1
                  RBUF(1) = II
                  CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
                  II = 0
              END IF
   10     CONTINUE
   20 CONTINUE
      IF (II.GT.0) THEN
          NBUF = II + 1
          RBUF(1) = II
          CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
          II = 0
      END IF
C
C Send termination code to driver.
C
      NBUF = 1
      RBUF(1) = -1
      CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
C-----------------------------------------------------------------------
      END

C*PGSCI -- set color index
C%void cpgsci(int ci);
C+
      SUBROUTINE PGSCI (CI)
      INTEGER  CI
C
C Set the Color Index for subsequent plotting, if the output device
C permits this. The default color index is 1, usually white on a black
C background for video displays or black on a white background for
C printer plots. The color index is an integer in the range 0 to a
C device-dependent maximum. Color index 0 corresponds to the background
C color; lines may be "erased" by overwriting them with color index 0
C (if the device permits this).
C
C If the requested color index is not available on the selected device,
C color index 1 will be substituted.
C
C The assignment of colors to color indices can be changed with
C subroutine PGSCR (set color representation).  Color indices 0-15
C have predefined color representations (see the PGPLOT manual), but
C these may be changed with PGSCR.  Color indices above 15  have no
C predefined representations: if these indices are used, PGSCR must
C be called to define the representation.
C
C Argument:
C  CI     (input)  : the color index to be used for subsequent plotting
C                    on the current device (in range 0-max). If the
C                    index exceeds the device-dependent maximum, the
C                    default color index (1) is used.
C--
C 26-Sep-1985 - new routine [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSCI')) RETURN
      CALL GRSCI(CI)
      END

      REAL FUNCTION PGHIS1 (X, NELMX, CENTER, IXV)
      LOGICAL CENTER
      INTEGER NELMX, IXV
      REAL X(NELMX)
C
C PGPLOT Internal routine used by PGHI2D.  Calculates the X-value for
C the left hand edge of a given element of the array being plotted.
C
C Arguments -
C
C X (input, real array): abscissae of bins
C NELMX (input, integer): number of bins
C CENTER (Input, logical): if .true., X values denote the center of
C       the bin; if .false., the X values denote the lower edge (in X)
C       of the bin.
C IXV (input, integer): the bin number in question.  Note IXV may be
C       outside the range 1..NELMX, in which case an interpolated
C       value is returned.
C
C 21-Feb-1984 - Keith Shortridge.
C  6-Sep-1989 - Changes for standard Fortran-77 [TJP].
C-----------------------------------------------------------------------
      REAL XN
      INTRINSIC REAL
C
      IF (CENTER) THEN
          IF ((IXV.GT.1).AND.(IXV.LE.NELMX)) THEN
            XN = ( X(IXV-1) + X(IXV) ) * .5
          ELSE IF (IXV.LE.1) THEN
            XN = X(1) - .5 * (X(2) - X(1)) * REAL(3 - 2 * IXV)
          ELSE IF (IXV.GT.NELMX) THEN
            XN = X(NELMX) +.5*(X(NELMX)-X(NELMX-1))*
     1           REAL((IXV-NELMX)*2-1)
          END IF
      ELSE
          IF ((IXV.GE.1).AND.(IXV.LE.NELMX)) THEN
            XN = X(IXV)
          ELSE IF (IXV.LT.1) THEN
            XN = X(1) - ( X(2) - X(1) ) * REAL( 1 - IXV )
          ELSE IF (IXV.GT.NELMX) THEN
            XN = X(NELMX) + ( X(NELMX) - X(NELMX-1)) *
     1           REAL(IXV - NELMX)
          END IF
      END IF
C
      PGHIS1 = XN
      END

C
      LOGICAL FUNCTION PGNOTO (RTN)
      CHARACTER*(*) RTN
C
C PGPLOT (internal routine): Test whether a PGPLOT device is open and
C print a message if not. Usage:
C     LOGICAL PGNOTO
C     IF (PGNOTO('routine')) RETURN
C
C Arguments:
C
C RTN (input, character): routine name to be include in message.
C
C Returns:
C     .TRUE. if PGPLOT is not open.
C--
C 11-Nov-1994
C 21-Dec-1995 - revised for multiple devices.
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      CHARACTER*80 TEXT
C
      CALL PGINIT
      PGNOTO = .FALSE.
      IF (PGID.LT.1 .OR. PGID.GT.PGMAXD) THEN
         PGNOTO = .TRUE.
         TEXT = RTN//': no graphics device has been selected'
         CALL GRWARN(TEXT)
      ELSE IF (PGDEVS(PGID).NE.1) THEN
         PGNOTO = .TRUE.
         TEXT = RTN//': selected graphics device is not open'
         CALL GRWARN(TEXT)
      END IF
      RETURN
      END

C*GRPAGE -- end picture
C+
      SUBROUTINE GRPAGE
C
C GRPCKG: Advance the plotting area to a new page. For video devices,
C this amounts to erasing the screen; for hardcopy devices, the plot
C buffer is written to the output file followed by a form-feed to
C advance the paper to the start of the next page.
C
C Arguments: none.
C--
C  3-Jun-1983 - [TJP].
C 18-Feb-1984 - remove unnecessary 'T' initialization of VT125, and add
C               S(G1) for Rainbow REGIS [TJP].
C  1-Jun-1984 - add type GMFILE [TJP].
C  2-Jul-1984 - change initialization of VT125 for color [TJP].
C 13-Jul-1984 - move initialization of VT125 and Grinnell to GROPEN
C               [TJP].
C 19-Oct-1984 - add VV device [TJP].
C 29-Jan-1985 - add HP2648 terminal [KS/TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 21-Feb-1987 - fix GREXEC end picture sequence [AFT].
C 11-Jun-1987 - remove built-in devices [TJP].
C 11-Feb-1992 - update veiew surface size: it may have changed! [TJP].
C  5-Jan-1993 - but only if GRSETS has not been called! [TJP]
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
C
      INTEGER NBUF,LCHR
      REAL    RBUF(6)
C
      CHARACTER CHR
C
C Flush the buffer.
C
      CALL GRTERM
C
C Erase the text screen (if there is one).
C
      CALL GRETXT
C
C End picture.
C
      CALL GREPIC
C
C Update the view surface size: it may have changed (on windowing 
C devices)
C
      IF (.NOT.GRADJU(GRCIDE)) THEN
          CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR)
          GRXMXA(GRCIDE) = RBUF(2)
          GRYMXA(GRCIDE) = RBUF(4)
      END IF
C
      END

C*GRQTXT -- get text bounding box
C+
      SUBROUTINE GRQTXT (ORIENT,X0,Y0,STRING, XBOX, YBOX)
C
C GRPCKG: get the bounding box of a string drawn by GRTEXT.
C--
C 12-Sep-1993 - [TJP].
C  8-Nov-1994 - return something even if string is blank [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      LOGICAL UNUSED, VISBLE, PLOT
      INTEGER XYGRID(300)
      INTEGER LIST(256)
      CHARACTER*(*) STRING
      REAL XBOX(4), YBOX(4)
      REAL ANGLE, FACTOR, FNTBAS, FNTFAC, COSA, SINA, DX, DY, XORG, YORG
      REAL ORIENT, RATIO, X0, Y0, RLX, RLY
      REAL XG, YG, XGMIN, XGMAX, YGMIN, YGMAX
      INTEGER I, IFNTLV,NLIST,LX,LY, K, LXLAST,LYLAST
      INTRINSIC ABS, COS, LEN, MAX, MIN, SIN
C
C Default return values.
C
      DO 10 I=1,4
         XBOX(I) = X0
         YBOX(I) = Y0
 10   CONTINUE
C
C Check that there is something to be plotted.
C
      IF (LEN(STRING).LE.0) RETURN
C
C Check that a device is selected.
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRQTXT - no graphics device is active.')
          RETURN
      END IF
C
      XORG = GRXPRE(GRCIDE)
      YORG = GRYPRE(GRCIDE)
C
C Compute scaling and orientation.
C
      ANGLE = ORIENT*(3.14159265359/180.)
      FACTOR = GRCFAC(GRCIDE)/2.5
      RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE)
      COSA = FACTOR * COS(ANGLE)
      SINA = FACTOR * SIN(ANGLE)
      XORG = X0
      YORG = Y0
C
C Convert the string to a list of symbol numbers; to prevent overflow
C of array LIST, the length of STRING is limited to 256 characters.
C
      CALL GRSYDS(LIST,NLIST,STRING(1:MIN(256,LEN(STRING))),
     1             GRCFNT(GRCIDE))
C
C Run through the string of characters, getting bounding box
C in character coordinates. (XG, YG) is the starting point
C of the current character. The x/y limits of the bbox are
C XGMIN...XGMAX, YGMIN...YGMAX.
C
      FNTBAS = 0.0
      FNTFAC = 1.0
      IFNTLV = 0
      DX = 0.0
      DY = 0.0
      XG = 0.0
      YG = 0.0
      XGMIN = 1E30
      XGMAX = -1E30
      YGMIN = 1E30
      YGMAX = -1E30
      PLOT  = .FALSE.
      DO 380 I=1,NLIST
          IF (LIST(I).LT.0) THEN
              IF (LIST(I).EQ.-1) THEN
C                 ! up
                  IFNTLV = IFNTLV+1
                  FNTBAS = FNTBAS + 16.0*FNTFAC
                  FNTFAC = 0.75**ABS(IFNTLV)
              ELSE IF (LIST(I).EQ.-2) THEN
C                 ! down
                  IFNTLV = IFNTLV-1
                  FNTFAC = 0.75**ABS(IFNTLV)
                  FNTBAS = FNTBAS - 16.0*FNTFAC
              ELSE IF (LIST(I).EQ.-3) THEN
C                 ! backspace
                  XG = XG - DX*FNTFAC
              END IF
              GOTO 380
          END IF
          CALL GRSYXD(LIST(I),XYGRID,UNUSED)
          VISBLE = .FALSE.
          DX = XYGRID(5)-XYGRID(4)
          K = 4
          LXLAST = -64
          LYLAST = -64
  320     K = K+2
          LX = XYGRID(K)
          LY = XYGRID(K+1)
          IF (LY.EQ.-64) GOTO 330
          IF (LX.EQ.-64) THEN
              VISBLE = .FALSE.
          ELSE
              RLX = (LX - XYGRID(4))*FNTFAC
              RLY = (LY - XYGRID(2))*FNTFAC + FNTBAS
              IF ((LX.NE.LXLAST) .OR. (LY.NE.LYLAST)) THEN
                  XGMIN = MIN(XGMIN,XG+RLX)
                  XGMAX = MAX(XGMAX,XG+RLX)
                  YGMIN = MIN(YGMIN,RLY)
                  YGMAX = MAX(YGMAX,RLY)
                  PLOT = .TRUE.
              END IF
              VISBLE = .TRUE.
              LXLAST = LX
              LYLAST = LY
          END IF
          GOTO 320
  330     XG = XG + DX*FNTFAC
  380 CONTINUE
C
C Check whether anything was plotted.
C
      IF (.NOT.PLOT) RETURN
C
C Expand the box a bit to allow for line-width.
C
      XGMIN = XGMIN - 5.0
      XGMAX = XGMAX + 5.0
      YGMIN = YGMIN - 4.0
      YGMAX = YGMAX + 4.0
C
C Convert bounding box to device coordinates.
C
C     WRITE (*,*) XGMIN, XGMAX, YGMIN, YGMAX
      XBOX(1) = XORG + (COSA*XGMIN - SINA*YGMIN)*RATIO
      YBOX(1) = YORG + (SINA*XGMIN + COSA*YGMIN)
      XBOX(2) = XORG + (COSA*XGMIN - SINA*YGMAX)*RATIO
      YBOX(2) = YORG + (SINA*XGMIN + COSA*YGMAX)
      XBOX(3) = XORG + (COSA*XGMAX - SINA*YGMAX)*RATIO
      YBOX(3) = YORG + (SINA*XGMAX + COSA*YGMAX)
      XBOX(4) = XORG + (COSA*XGMAX - SINA*YGMIN)*RATIO
      YBOX(4) = YORG + (SINA*XGMAX + COSA*YGMIN)
C
      END

C*PGIMAG -- color image from a 2D data array
C%void cpgimag(const float *a, int idim, int jdim, int i1, int i2, \
C% int j1, int j2, float a1, float a2, const float *tr);
C+
      SUBROUTINE PGIMAG (A, IDIM, JDIM, I1, I2, J1, J2,
     1                   A1, A2, TR)
      INTEGER IDIM, JDIM, I1, I2, J1, J2
      REAL    A(IDIM,JDIM), A1, A2, TR(6)
C
C Draw a color image of an array in current window. The subsection
C of the array A defined by indices (I1:I2, J1:J2) is mapped onto
C the view surface world-coordinate system by the transformation
C matrix TR. The resulting quadrilateral region is clipped at the edge
C of the window. Each element of the array is represented in the image
C by a small quadrilateral, which is filled with a color specified by
C the corresponding array value.
C
C The subroutine uses color indices in the range C1 to C2, which can
C be specified by calling PGSCIR before PGIMAG. The default values
C for C1 and C2 are device-dependent; these values can be determined by
C calling PGQCIR. Note that color representations should be assigned to
C color indices C1 to C2 by calling PGSCR before calling PGIMAG. On some
C devices (but not all), the color representation can be changed after
C the call to PGIMAG by calling PGSCR again.
C
C Array values in the range A1 to A2 are mapped on to the range of
C color indices C1 to C2, with array values <= A1 being given color
C index C1 and values >= A2 being given color index C2. The mapping
C function for intermediate array values can be specified by
C calling routine PGSITF before PGIMAG; the default is linear.
C
C On devices which have no available color indices (C1 > C2),
C PGIMAG will return without doing anything. On devices with only
C one color index (C1=C2), all array values map to the same color
C which is rather uninteresting. An image is always "opaque",
C i.e., it obscures all graphical elements previously drawn in
C the region.
C
C The transformation matrix TR is used to calculate the world
C coordinates of the center of the "cell" that represents each
C array element. The world coordinates of the center of the cell
C corresponding to array element A(I,J) are given by:
C
C          X = TR(1) + TR(2)*I + TR(3)*J
C          Y = TR(4) + TR(5)*I + TR(6)*J
C
C Usually TR(3) and TR(5) are zero -- unless the coordinate
C transformation involves a rotation or shear.  The corners of the
C quadrilateral region that is shaded by PGIMAG are given by
C applying this transformation to (I1-0.5,J1-0.5), (I2+0.5, J2+0.5).
C
C Arguments:
C  A      (input)  : the array to be plotted.
C  IDIM   (input)  : the first dimension of array A.
C  JDIM   (input)  : the second dimension of array A.
C  I1, I2 (input)  : the inclusive range of the first index
C                    (I) to be plotted.
C  J1, J2 (input)  : the inclusive range of the second
C                    index (J) to be plotted.
C  A1     (input)  : the array value which is to appear with shade C1.
C  A2     (input)  : the array value which is to appear with shade C2.
C  TR     (input)  : transformation matrix between array grid and
C                    world coordinates.
C--
C 15-Sep-1994: new routine [TJP].
C 21-Jun-1995: minor change to header comments [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      REAL PA(6)
      LOGICAL PGNOTO
C
C Check inputs.
C
      IF (PGNOTO('PGIMAG')) RETURN
      IF (I1.LT.1 .OR. I2.GT.IDIM .OR. I1.GT.I2 .OR.
     1    J1.LT.1 .OR. J2.GT.JDIM .OR. J1.GT.J2) THEN
          CALL GRWARN('PGIMAG: invalid range I1:I2, J1:J2')
      ELSE IF (A1.EQ.A2) THEN
          CALL GRWARN('PGIMAG: foreground level = background level')
      ELSE IF (PGMNCI(PGID).GT.PGMXCI(PGID)) THEN
          CALL GRWARN('PGIMAG: not enough colors available')
      ELSE
C
C Call lower-level routine to do the work.
C
          CALL PGBBUF
          PA(1) = TR(1)*PGXSCL(PGID) + PGXORG(PGID)
          PA(2) = TR(2)*PGXSCL(PGID)
          PA(3) = TR(3)*PGXSCL(PGID)
          PA(4) = TR(4)*PGYSCL(PGID) + PGYORG(PGID)
          PA(5) = TR(5)*PGYSCL(PGID)
          PA(6) = TR(6)*PGYSCL(PGID)
          CALL GRIMG0(A, IDIM, JDIM, I1, I2, J1, J2, A1, A2, PA,
     :                PGMNCI(PGID), PGMXCI(PGID), PGITF(PGID))
          CALL PGEBUF
      END IF
C-----------------------------------------------------------------------
      END

C*GRIMG2 -- image of a 2D data array (pixel-primitive devices)
C+
      SUBROUTINE GRIMG2 (A, IDIM, JDIM, I1, I2, J1, J2,
     1                   A1, A2, PA, MININD, MAXIND, MODE)
      INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE
      REAL    A(IDIM,JDIM)
      REAL    A1, A2
      REAL    PA(6)
C
C (This routine is called by GRIMG0.)
C--
C 7-Sep-1994  New routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  I,IV,IX,IX1,IX2,IY,IY1,IY2,J, NPIX, LCHR
      REAL     DEN, AV, SFAC, SFACL
      REAL     XXAA,XXBB,YYAA,YYBB,XYAA,XYBB,YXAA,YXBB,XYAAIY,YXAAIY
      REAL     BUFFER(1026)
      CHARACTER*1 CHR
      INTRINSIC NINT, LOG
      PARAMETER (SFAC=65000.0)
C-----------------------------------------------------------------------
C
C Location of current window in device coordinates.
C
      IX1 = NINT(GRXMIN(GRCIDE))+1
      IX2 = NINT(GRXMAX(GRCIDE))-1
      IY1 = NINT(GRYMIN(GRCIDE))+1
      IY2 = NINT(GRYMAX(GRCIDE))-1
C
C Transformation from array coordinates to device coordinates.
C
      DEN = PA(2)*PA(6)-PA(3)*PA(5)
      XXAA = (-PA(6))*PA(1)/DEN
      XXBB = PA(6)/DEN
      XYAA = (-PA(3))*PA(4)/DEN
      XYBB = PA(3)/DEN
      YYAA = (-PA(2))*PA(4)/DEN
      YYBB = PA(2)/DEN
      YXAA = (-PA(5))*PA(1)/DEN
      YXBB = PA(5)/DEN
C
C Start a new page if necessary.
C
      IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
C
C Run through every device pixel (IX, IY) in the current window and
C determine which array pixel (I,J) it falls in.
C
      SFACL = LOG(1.0+SFAC)
      DO 120 IY=IY1,IY2
          XYAAIY = XXAA-XYAA-XYBB*IY
          YXAAIY = YYAA+YYBB*IY-YXAA
          NPIX = 0
          BUFFER(2) = IY
          DO 110 IX=IX1,IX2
            I = NINT(XYAAIY+XXBB*IX)
            IF (I.LT.I1.OR.I.GT.I2) GOTO 110
            J = NINT(YXAAIY-YXBB*IX)
            IF (J.LT.J1.OR.J.GT.J2) GOTO 110
C
C           -- determine color index IV of this pixel
C
            AV = A(I,J)
            IF (A2.GT.A1) THEN
                AV = MIN(A2, MAX(A1,AV))
            ELSE
                AV = MIN(A1, MAX(A2,AV))
            END IF
            IF (MODE.EQ.0) THEN
                IV = NINT((MININD*(A2-AV) + MAXIND*(AV-A1))/(A2-A1))
            ELSE IF (MODE.EQ.1) THEN
                IV = MININD + NINT((MAXIND-MININD)*
     :               LOG(1.0+SFAC*ABS((AV-A1)/(A2-A1)))/SFACL)
            ELSE IF (MODE.EQ.2) THEN
                IV = MININD + NINT((MAXIND-MININD)*
     :                             SQRT(ABS((AV-A1)/(A2-A1))))
            ELSE
                IV = MININD
            END IF
C
            IF (NPIX.LE.1024) THEN
C               -- drop pixels if buffer too small (to be fixed!)
                NPIX = NPIX+1
                IF (NPIX.EQ.1) BUFFER(1) = IX
                BUFFER(NPIX+2) = IV
            END IF
  110     CONTINUE
          IF (NPIX.GT.0) CALL 
     :                   GREXEC(GRGTYP, 26, BUFFER, NPIX+2, CHR, LCHR)
  120 CONTINUE
C-----------------------------------------------------------------------
      END

C*PGSITF -- set image transfer function
C%void cpgsitf(int itf);
C+
      SUBROUTINE PGSITF (ITF)
      INTEGER  ITF
C
C Set the Image Transfer Function for subsequent images drawn by
C PGIMAG, PGGRAY, or PGWEDG. The Image Transfer Function is used
C to map array values into the available range of color indices
C specified with routine PGSCIR or (for PGGRAY on some devices)
C into dot density.
C
C Argument:
C  ITF    (input)  : type of transfer function:
C                      ITF = 0 : linear
C                      ITF = 1 : logarithmic
C                      ITF = 2 : square-root
C--
C 15-Sep-1994 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSITF')) RETURN
      IF (ITF.LT.0 .OR. ITF.GT.2) THEN
          PGITF(PGID) = 0
          CALL GRWARN('PGSITF: argument must be 0, 1, or 2')
      ELSE
          PGITF(PGID) = ITF
      END IF
      END

C*PGPT -- draw several graph markers
C%void cpgpt(int n, const float *xpts, const float *ypts, int symbol);
C+
      SUBROUTINE PGPT (N, XPTS, YPTS, SYMBOL)
      INTEGER N
      REAL XPTS(*), YPTS(*)
      INTEGER SYMBOL
C
C Primitive routine to draw Graph Markers (polymarker). The markers
C are drawn using the current values of attributes color-index,
C line-width, and character-height (character-font applies if the symbol
C number is >31).  If the point to be marked lies outside the window,
C no marker is drawn.  The "pen position" is changed to
C (XPTS(N),YPTS(N)) in world coordinates (if N > 0).
C
C Arguments:
C  N      (input)  : number of points to mark.
C  XPTS   (input)  : world x-coordinates of the points.
C  YPTS   (input)  : world y-coordinates of the points.
C  SYMBOL (input)  : code number of the symbol to be drawn at each 
C                    point:
C                    -1, -2  : a single dot (diameter = current
C                              line width).
C                    -3..-31 : a regular polygon with ABS(SYMBOL)
C                              edges (style set by current fill style).
C                    0..31   : standard marker symbols.
C                    32..127 : ASCII characters (in current font).
C                              e.g. to use letter F as a marker, let
C                              SYMBOL = ICHAR('F'). 
C                    > 127  :  a Hershey symbol number.
C
C Note: the dimension of arrays X and Y must be greater than or equal
C to N. If N is 1, X and Y may be scalars (constants or variables). If
C N is less than 1, nothing is drawn.
C--
C 27-Nov-1986
C 17-Dec-1990 - add polygons [PAH].
C 14-Mar-1997 - optimization: use GRDOT1 [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (N.LT.1) RETURN
      IF (PGNOTO('PGPT')) RETURN
C
      CALL PGBBUF
      IF (SYMBOL.GE.0 .OR. SYMBOL.LE.-3) THEN
          CALL GRMKER(SYMBOL,.FALSE.,N,XPTS,YPTS)
      ELSE
          CALL GRDOT1(N,XPTS,YPTS)
      END IF
      CALL PGEBUF
      END

C*LXDRIV -- PGPLOT driver for LaTeX Picture Environment
C+
      SUBROUTINE LXDRIV(OPCODE,RBUF,NBUF,CHR,LCHR)
      INTEGER OPCODE, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C Supported device:
C  This driver creates a text file containing commands for drawing
C  in the LaTeX picture environment, bracketted by \begin{picture} 
C  and \end{picture}. The file can be included in a LaTeX document.
C
C  If you have the option of including a PostScript file in your
C  LaTeX document, then that will usually give much better results
C  than using this driver, which has very limited capabilities.
C
C Device type code:
C  /LATEX
C
C Default file name:
C  pgplot.tex
C
C Default view surface dimensions:
C  The default picture size is 6 inches by 6 inches (which corresponds 
C  to 1728x1728 units where a unit is 0.25pt = 1/288 inch). The picture
C  size can be changed by using PGPAP in the PGPLOT program.
C
C Resolution:
C  The driver rounds coordinates to multiples of 0.25pt (1/288 inch).
C
C Limitations:
C  The LaTeX picture environment has a very limited set of primitives.
C  In particular, diagonal lines must be composed out of dots. This
C  can lead to very large files. For some graphs (especially with a 
C  lot of shaded areas), the capacity of many LaTeX systems can easily
C  be exceeded.
C
C Author:
C  Written by Grant McIntosh  95/02/14 (gmcint@relay.drev.dnd.ca).
C
C  Revised by T. Pearson 95/06/19.
C  Revised to allow picture size to be adjusted by PGPAP: TJP 97/5/16.
C-----------------------------------------------------------------------
      INTEGER LUN, IXO, IYO, IXPS, IYPS, I, J
      INTEGER INCR, NINC, IER, ISIGN, LENGTH, BX, BY, STATE
      INTEGER GROPTX
      REAL X1, Y1, X2, Y2, DELX, DELY, SLOPE
      CHARACTER*128 MSG
      CHARACTER*(*) DEVNAM
      PARAMETER (DEVNAM='LATEX (LaTeX picture environment)')
      CHARACTER*1   BS
      SAVE LUN, BS, BX, BY, STATE
C-----------------------------------------------------------------------
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140)OPCODE
      NBUF=-1
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC = 1, Return device name -------------------------------------
   10 CHR=DEVNAM
      LCHR=LEN(DEVNAM)
      BS=CHAR(92)
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
   20 RBUF(1)=0
      RBUF(2)=32767
      RBUF(3)=0
      RBUF(4)=32767
      RBUF(5)=0
      RBUF(6)=1
      NBUF=6
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC = 3, Return device resolution -------------------------------
   30 RBUF(1)=72./0.25
      RBUF(2)=72./0.25
      RBUF(3)=1.
      NBUF=3
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC = 4, Return misc device info --------------------------------
   40 CHR='HNNNNNNNNN'
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC = 5, Return default file name -------------------------------
   50 CHR='pgplot.tex'
      LCHR=10
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC = 6, Return default physical size of plot -------------------
   60 RBUF(1)=0
      RBUF(2)=BX
      RBUF(3)=0
      RBUF(4)=BY
      NBUF=4
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC = 7, Return misc defaults -----------------------------------
   70 RBUF(1)=1
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC = 8, Select plot --------------------------------------------
 80   RETURN
C-----------------------------------------------------------------------
C--- IFUNC = 9, Open workstation ---------------------------------------
 90   CONTINUE
      NBUF=2
C     -- check for concurrent access
      IF (STATE.EQ.1) THEN
         CALL GRWARN('a PGPLOT LaTeX file is already open')
         RBUF(1) = 0
         RBUF(2) = 0
         RETURN
      END IF
      CALL GRGLUN(LUN)
      IER = GROPTX(LUN, CHR(1:LCHR), 'pgplot.tex', 1)
      IF (IER.NE.0) THEN
         MSG = 'Cannot open output file for LaTeX picture: '//
     :         CHR(:LCHR)
         CALL GRWARN(MSG)
         RBUF(1)=0
         RBUF(2)=0
         CALL GRFLUN(LUN)
      ELSE
         RBUF(2)=1
         RBUF(1)=LUN
         STATE=1
         BX=1728
         BY=1728
      END IF
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC=10, Close workstation ---------------------------------------
 100  CLOSE(UNIT=LUN)
      CALL GRFLUN(LUN)
      STATE=0
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC=11, Begin picture -------------------------------------------
  110 CONTINUE
      BX = NINT(RBUF(1))
      BY = NINT(RBUF(2))
      WRITE(LUN,'(A)') BS//'setlength{'//BS//'unitlength}{0.25pt}'
      WRITE(LUN,'(A)') BS//'linethickness{1pt}'
      WRITE(LUN,'(A,I6,A,I6,A)')
     :     BS//'begin{picture}(',BX,',',BY,')(0,0)'
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC=12, Draw line -----------------------------------------------
  120 X1=RBUF(1)
      Y1=RBUF(2)
      X2=RBUF(3)
      Y2=RBUF(4)
      IXO=X1
      IYO=Y1
      IXPS=X2
      IYPS=Y2
C vertical lines
      IF(IXPS.EQ.IXO) THEN
         LENGTH=ABS(IYPS-IYO)
         ISIGN=1
         IF(LENGTH.NE.0) ISIGN=(IYPS-IYO)/LENGTH
         WRITE(LUN,5000) BS,IXO,IYO,BS,ISIGN,LENGTH
 5000    FORMAT(A1,'put(',I4,',',I4,'){',A1,'line(0,',I4,'){',I4,'}}')
         RETURN
      ENDIF
C horizontal lines
      IF(IYPS.EQ.IYO) THEN
         LENGTH=ABS(IXPS-IXO)
         ISIGN=1
         IF(LENGTH.NE.0) ISIGN=(IXPS-IXO)/LENGTH
         WRITE(LUN,5100) BS,IXO,IYO,BS,ISIGN,LENGTH
 5100    FORMAT(A1,'put(',I4,',',I4,'){',A1,'line(',I4,',0){',I4,'}}')
         RETURN
      ENDIF
C other lines
      SLOPE=FLOAT(IYPS-IYO)/FLOAT(IXPS-IXO)
      INCR=1
      IF(IXPS.LT.IXO) INCR=-1
      NINC=MAX(1,ABS(IXPS-IXO))
      DELX=INCR
      DELY=SLOPE*INCR
  125 CONTINUE
      IF(ABS(DELY).GT.1) THEN
         NINC=NINC*2
         DELX=DELX/2.
         DELY=SLOPE*DELX
         GOTO 125
      ENDIF
      WRITE(LUN,5200) BS,IXO,IYO,DELX,DELY,NINC,BS
 5200 FORMAT(A1,'multiput(',I4,',',I4,')(',F8.3,',',F8.3,'){',I4,
     *     '}{',A1,'circle*{1}}')
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC=13, Draw dot ------------------------------------------------
  130 I=NINT(RBUF(1))
      J=NINT(RBUF(2))
      WRITE(LUN,5300) BS,I,J,BS
 5300 FORMAT(A1,'put(',I4,',',I4,'){',A1,'circle*{1}}')
      RETURN
C-----------------------------------------------------------------------
C--- IFUNC=14, End picture ---------------------------------------------
  140 WRITE(LUN,'(A)') BS//'end{picture}'
      RETURN
C-----------------------------------------------------------------------
      END

C*GRPXPX -- Perform pixel operations using pixel primitive
C+
      SUBROUTINE GRPXPX (IA, IDIM, JDIM, I1, I2, J1, J2, X, Y)
      INTEGER IDIM, JDIM, I1, I2, J1, J2
      INTEGER IA(IDIM,JDIM)
      REAL    X, Y
C
C Arguments:
C  IA     (input)  : the array to be plotted.
C  IDIM   (input)  : the first dimension of array A.
C  JDIM   (input)  : the second dimension of array A.
C  I1, I2 (input)  : the inclusive range of the first index
C                    (I) to be plotted.
C  J1, J2 (input)  : the inclusive range of the second
C                    index (J) to be plotted.
C  X, Y   (input)  : the lower left corner of the output region
C                    (device coordinates)
C--
C 16-Jan-1991 - [GvG]
*  4-Aug-1993 - Debugged by Remko Scharroo
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER     NSIZE
      PARAMETER   (NSIZE = 1280)
      REAL        RBUF(NSIZE + 2)
      REAL        WIDTH
      INTEGER     IC1, IC2
      INTEGER     I, J, L
      INTEGER     NBUF, LCHR
      CHARACTER*1 CHR

      IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
C
C Get allowable color range and pixel width
C
      CALL GRQCOL(IC1, IC2)
      CALL GREXEC(GRGTYP, 3, RBUF, NBUF, CHR, LCHR)
      WIDTH = RBUF(3)
      DO 30 J = J1, J2
C
C Compute Y coordinate for this line
C
         RBUF(2) = Y + (J - J1) * WIDTH
         I = I1
  10        L = 1
C
C Compute left X coordinate for this line segment
C
            RBUF(1) = X + (I - I1) * WIDTH
C
C Check color index
C
  20           IF (IA(I, J) .LT. IC1 .OR. IC2 .LT. IA(I, J)) THEN
                  RBUF(L + 2) = 1
               ELSE
                  RBUF(L + 2) = IA(I, J)
               ENDIF
               L = L + 1
               I = I + 1
C
C Still room in segment and something left?
C
            IF (L .LE. NSIZE .AND. I .LE. I2) GOTO 20
C
C Output segment
C
*           NBUF = L + 2 ! wrong ! should be: (RS)
            NBUF = L + 1
            CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
C
C Something left?
C
         IF (I .LE. I2) GOTO 10
  30  CONTINUE

      END

C
      SUBROUTINE PGSIZE (WIDTH, HEIGHT, SHIFTX, SHIFTY, DUMMY)
C
C PGPLOT (obsolete routine; use PGVSIZ in preference): Change the
C size and position of the viewport.
C
C Arguments:
C
C WIDTH (input, real) : width of viewport in inches.
C HEIGHT (input, real) : height of viewport in inches.
C SHIFTX (input, real) : horizontal offset of bottom left corner
C       from blc of page or panel, in inches.
C SHIFTY (input, real) : vertical offset of bottom left corner
C       from blc of page or panel, in inches.
C DUMMY (input, real) : reserved for future use (must be 0.0).
C--
C 13-Dec-1990  Make errors non-fatal [TJP].
C-----------------------------------------------------------------------
      REAL     WIDTH,HEIGHT,SHIFTX,SHIFTY,DUMMY
C
      IF (WIDTH.LE.0.0 .OR. HEIGHT.LE.0.0 .OR. DUMMY.NE.0.0) THEN
          CALL GRWARN('PGSIZE ignored: invalid arguments')
          RETURN
      END IF
C
      CALL PGVSIZ(SHIFTX, SHIFTX+WIDTH, SHIFTY, SHIFTY+HEIGHT)
      END

      PROGRAM PGDEM3
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT vector field plot.
C-----------------------------------------------------------------------
      INTEGER PGOPEN
      WRITE (*,'(A)') ' Demonstration of routine PGVECT'
C
C Call PGBEG to initiate PGPLOT and open the output device; PGBEG
C will prompt the user to supply the device name and type.
C
      IF (PGOPEN('?') .LE. 0) STOP
      CALL PGEX35
      CALL PGEND
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX35
C-----------------------------------------------------------------------
C Program to demonstrate the use of PGVECT along with
C PGCONB by illustrating the flow around a cylinder with circulation.
C
C          NX      total # of axial stations
C          NY      total # of grid pts in y (or r) direction
C-----------------------------------------------------------------------
      INTEGER MAXX, MAXY
      PARAMETER (MAXX=101,MAXY=201)
      INTEGER NX, NY, I, J, NC
      REAL PI, A, GAMMA, VINF, XMAX, XMIN, YMAX, YMIN, DX, DY
      REAL CPMIN, R2, BLANK
      REAL CP(MAXX,MAXY),X(MAXX),Y(MAXY),U(MAXX,MAXY),V(MAXX,MAXY),
     1   PSI(MAXX,MAXY)
      REAL TR(6),C(10)
      PARAMETER (PI=3.14159265359)
      DATA BLANK/-1.E10/
C
C compute the flow about a cylinder with circulation
C
C define various quantities
C
C number of points in the x and y directions
      NX = 31
      NY = 31
C cylinder radius
      A = 1.
C circulation strength
      GAMMA = 2.
C freestream velocity
      VINF = 1.
C max and min x and y
      XMAX = 3.*A
      XMIN = -3.*A
      YMAX = 3.*A
      YMIN = -3.*A
C point spacing
      DX = (XMAX-XMIN)/(NX-1)
      DY = (YMAX-YMIN)/(NY-1)
C compute the stream function, Cp, and u and v velocities
      CPMIN =1.E10
      DO 20 I=1,NX
         X(I) = XMIN+DX*(I-1)
         DO 10 J=1,NY
            Y(J) = YMIN+DY*(J-1)
            R2 = X(I)**2+Y(J)**2
            IF (R2.GT.0.) THEN
               PSI(I,J) = VINF*Y(J)*(1.-A**2/R2)
     1            +GAMMA/(2.*PI)*0.5*ALOG(R2/A)
               U(I,J) = VINF*(1.+A**2/R2-2.*A**2*X(I)**2/R2**2)
     1            +GAMMA/(2.*PI)*Y(J)/R2
               V(I,J) = VINF*X(I)*(-2.*A**2*Y(J)/R2**2)
     1            +GAMMA/(2.*PI)*X(I)/R2
               CP(I,J) = 1.-(U(I,J)**2+V(I,J)**2)/VINF**2
            ELSE
               PSI(I,J) = 0.
               U(I,J) = 0.
               V(I,J) = 0.
               CP(I,J) = 0.
            END IF
            IF (R2.LT.A**2) THEN
               U(I,J) = BLANK
               V(I,J) = BLANK
            ELSE
               CPMIN = MIN(CPMIN,CP(I,J))
            END IF
   10    CONTINUE
   20 CONTINUE
C
C grid to world transformation
C
      TR(1)=X(1)-DX
      TR(2)=DX
      TR(3)=0.0
      TR(4)=Y(1)-DY
      TR(5)=0.0
      TR(6)=DY
C
      CALL PGENV (X(1),X(NX),Y(1),Y(NY),1,0)
      CALL PGIDEN
      CALL PGLAB ('X','Y','Flow About a Cylinder with Circulation')
C
C contour plot of the stream function (streamlines)
C
      NC=5
      C(1)=1.
      C(2)=.5
      C(3)=0.
      C(4)=-.5
      C(5)=-1.
      CALL PGCONT (PSI,MAXX,MAXY,1,NX,1,NY,C,NC,TR)
C
C draw cylinder
C
      CALL PGBBUF
      CALL PGSCI (0)
      CALL PGSFS (1)
      CALL PGCIRC (0.,0.,A*1.1)
      CALL PGSFS (2)
      CALL PGSCI (14)
      CALL PGCIRC (0.0, 0., A)
      CALL PGSCI (1)
      CALL PGEBUF
C
C vector plot
C
      CALL PGSAH (2, 45.0, 0.7)
      CALL PGSCH (0.3)
      CALL PGVECT (U,V,MAXX,MAXY,2,NX-1,2,NY-1,0.0,0,TR,-1.E10)
      CALL PGSCH(1.0)
C
C finished
C
      RETURN
C----------------------------------------------------------------------
      END

C*GRPXRE -- Emulate pixel operations using rectangles
C+
      SUBROUTINE GRPXRE (IA, IDIM, JDIM, I1, I2, J1, J2, 
     1                   X1, X2, Y1, Y2)
      INTEGER IDIM, JDIM, I1, I2, J1, J2
      INTEGER IA(IDIM,JDIM)
      REAL    X1, X2, Y1, Y2
C
C Arguments:
C  IA     (input)  : the array to be plotted.
C  IDIM   (input)  : the first dimension of array A.
C  JDIM   (input)  : the second dimension of array A.
C  I1, I2 (input)  : the inclusive range of the first index
C                    (I) to be plotted.
C  J1, J2 (input)  : the inclusive range of the second
C                    index (J) to be plotted.
C  X1, X2 (input)  : the horizontal range of the output region
C  Y1, Y2 (input)  : the vertical range of the output region
C--
C 18-Jan-1991 - [GvG]
C-----------------------------------------------------------------------
      REAL YB, YT
      INTEGER I, J, ICOL, LSTCOL
C
C Save color attribute
C
      CALL GRQCI(ICOL)
      LSTCOL = ICOL
      DO 20 J = J1, J2
C
C Compute Y range for this index
C
         YB = Y1 + ((Y2 - Y1) * (J - J1)) / (J2 - J1 + 1)
         YT = Y1 + ((Y2 - Y1) * (J - J1 + 1)) / (J2 - J1 + 1)
         DO 10 I = I1, I2
C
C Need to change color?
C
            IF (IA(I, J) .NE. LSTCOL) THEN
               CALL GRSCI(IA(I, J))
               LSTCOL = IA(I, J)
            ENDIF
C
C Output rectangle
C
            CALL GRREC0(X1 + ((X2 - X1) * (I - I1)) / (I2 - I1 + 1), YB,
     1                  X1 + ((X2 - X1) * (I - I1 + 1)) / (I2 - I1 + 1),
     2                  YT)

  10     CONTINUE
  20  CONTINUE
C
C Restore color attribute
C
      CALL GRSCI(ICOL)
      END

C*PXDRIV -- PGPLOT Printronix driver
C+
      SUBROUTINE PXDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Printronix device.
C
C Version 1.0  - 1987 Jun 8 - T. J. Pearson.
C Version 1.1  - 1987 Aug 31 - truncate output lines as necessary.
C=======================================================================
C
C Supported device: Printronix P300 or P600 dot-matrix printer.
C
C Device type code: /PRINTRONIX.
C
C Default device name: PGPLOT.PRPLOT.
C
C Default view surface dimensions: 13.2in (horizontal) by 10.25in
C (vertical).
C
C Resolution: 60 (x) x 72 (y) pixels/inch.
C
C Color capability: Color indices 0 (erase, white) and 1 (black) are
C supported. It is not possible to change color representation.
C
C Input capability: None.
C
C File format: Variable-length records, maximum 135 bytes, with
C embedded carriage-control characters. A full-page plot occupies
C 200 512-byte blocks.
C
C Obtaining hardcopy: Use the command PRINT/PASSALL.
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE, DEFNAM
      PARAMETER (TYPE='PRINTRONIX (Printronix P300/P600 printer)')
      PARAMETER (DEFNAM='PGPLOT.PRPLOT')
      BYTE FF
      PARAMETER (FF=12)
C
      INTEGER UNIT, IER, IC, BX, BY, NPICT
      INTEGER GRGMEM, GRFMEM
      CHARACTER*10 MSG
      INTEGER BITMAP
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in '//TYPE//' device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 791
      RBUF(3) = 0
      RBUF(4) = -1
      RBUF(5) = 0
      RBUF(6) = 1
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = 60.0
      RBUF(2) = 72.0
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    no thick lines)
C
   40 CHR = 'HNNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 791
      RBUF(3) = 0
      RBUF(4) = 737
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C     -- dimensions of plot buffer
      BX = 132 ! 792/6
      BY = 738
      CALL GRGLUN(UNIT)
      RBUF(1) = UNIT
      NPICT = 0
      OPEN (UNIT=UNIT, FILE=CHR(:LCHR), CARRIAGECONTROL='NONE',
     1      DEFAULTFILE=DEFNAM, DISPOSE='DELETE', STATUS='NEW',
     2      RECL=128,
     3      FORM='UNFORMATTED', RECORDTYPE='VARIABLE', IOSTAT=IER)
      IF (IER.NE.0) THEN
          CALL GRWARN('Cannot open output file for '//TYPE//' plot: '//
     1                CHR(:LCHR))
          RBUF(2) = 0
          CALL GRFLUN(UNIT)
      ELSE
          INQUIRE (UNIT=UNIT, NAME=CHR)
          LCHR = LEN(CHR)
   91     IF (CHR(LCHR:LCHR).EQ.' ') THEN
              LCHR = LCHR-1
              GOTO 91
          END IF
          RBUF(2) = 1
      END IF
      IER = GRGMEM(BX*BY, BITMAP)
      IF (IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRWARN('Failed to allocate plot buffer.')
          RBUF(2) = IER
          CLOSE (UNIT=UNIT, DISPOSE='DELETE')
          CALL GRFLUN(UNIT)
      END IF
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      CLOSE (UNIT=UNIT, DISPOSE='KEEP')
      CALL GRFLUN(UNIT)
      IER = GRFMEM(BX*BY, BITMAP)
      IF (IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRWARN('Failed to deallocate plot buffer.')
      END IF
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
      NPICT = NPICT+1
C%    type *,'Begin picture',NPICT
      IF (NPICT.GT.1) WRITE (UNIT=UNIT) FF
      CALL GRPX03(BX*BY, %val(BITMAP), 'C0'X)
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      CALL GRPX01(1, RBUF, IC, BX, BY, %val(BITMAP))
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      CALL GRPX01(0, RBUF, IC, BX, BY, %val(BITMAP))
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
C%    type *,'End picture  ',NPICT
      CALL GRPX02(UNIT, BX, BY, %val(BITMAP))
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      IF (IC.LT.0 .OR. IC.GT.1) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Not used.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C    (Not implemented: ignored)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C-----------------------------------------------------------------------
      END

C*GRPX01 -- PGPLOT Printronix driver, draw line
C+
      SUBROUTINE GRPX01 (LINE,RBUF,ICOL, BX, BY, BITMAP)
      INTEGER LINE
      REAL RBUF(4)
      INTEGER ICOL, BX, BY
      BYTE BITMAP(BX,BY)
C
C Draw a straight-line segment from absolute pixel coordinates
C (RBUF(1),RBUF(2)) to (RBUF(3),RBUF(4)).  The line either overwrites
C (sets to black) or erases (sets to white) the previous contents
C of the bitmap, depending on the current color index. Setting bits
C is accomplished with a VMS BISB2 instruction, expressed in
C Fortran as .OR.; clearing bits is accomplished with a VMS BICB2
C instruction, expressed in Fortran as .AND..NOT.. The line is
C generated with a Simple Digital Differential Analyser (ref:
C Newman & Sproull). 
C
C Arguments:
C
C LINE            I I      =0 for dot, =1 for line.
C RBUF(1),RBUF(2) I R      Starting point of line.
C RBUF(3),RBUF(4) I R      End point of line.
C ICOL            I I      =0 for erase, =1 for write.
C BITMAP        I/O B      (address of) the frame buffer.
C
C-----------------------------------------------------------------------
      BYTE    QMASK(0:5)
      INTEGER LENGTH, KX, KY, K
      REAL    D, XINC, YINC, XP, YP
      DATA    QMASK /'01'x,'02'x,'04'x,'08'x,'10'x,'20'x/
C
      IF (LINE.GT.0) THEN
          D = MAX(ABS(RBUF(3)-RBUF(1)), ABS(RBUF(4)-RBUF(2)))
          LENGTH = D
          IF (LENGTH.EQ.0) THEN
              XINC = 0.
              YINC = 0.
          ELSE
              XINC = (RBUF(3)-RBUF(1))/D
              YINC = (RBUF(4)-RBUF(2))/D
          END IF
      ELSE
          LENGTH = 0
          XINC = 0.
          YINC = 0.
      END IF
      XP = RBUF(1)+0.5
      YP = RBUF(2)+0.5
      IF (ICOL.NE.0) THEN
          DO K=0,LENGTH
              KX = XP
              KY = (BY-1)-INT(YP)
              BITMAP(KX/6+1,KY+1) = BITMAP(KX/6+1,KY+1) .OR. 
     1                              QMASK(MOD(KX,6))
              XP = XP + XINC
              YP = YP + YINC
          END DO
      ELSE
          DO K=0,LENGTH
              KX = XP
              KY = (BY-1)-INT(YP)
              BITMAP(KX/6+1,KY+1) = BITMAP(KX/6+1,KY+1) .AND.
     1                              (.NOT.QMASK(MOD(KX,6)))
              XP = XP + XINC
              YP = YP + YINC
          END DO
      END IF
      END

C*GRPX02 -- PGPLOT Printronix driver, copy bitmap to output file
C+
      SUBROUTINE GRPX02 (UNIT, BX, BY, BITMAP)
      INTEGER UNIT, BX, BY
      BYTE BITMAP(BX,BY)
C
C Arguments:
C  UNIT   (input)  Fortran unit number for output
C  BX, BY (input)  dimensions of BITMAP
C  BITMAP (input)  the bitmap array
C-----------------------------------------------------------------------
      BYTE SUFFIX(3)
      DATA SUFFIX/ 5, 13, 10/
      INTEGER I, J, K
C
C Write bitmap.
C
      DO J=1,BY
          DO K=BX,2,-1
              IF (BITMAP(K,J).NE.'C0'X) GOTO 10
          END DO
   10     WRITE (UNIT=UNIT) (BITMAP(I,J),I=1,K),SUFFIX
      END DO
C
C Write blank plot lines to fill up page
C
      END

C*GRPX03 -- PGPLOT Printronix driver, fill buffer with a specified character
C+
      SUBROUTINE GRPX03 (BUFSIZ,BUFFER,FILL)
C
C GRPCKG (internal routine): fill a buffer with a given character.
C
C Arguments:
C
C BUFFER (byte array, input): (address of) the buffer.
C BUFSIZ (integer, input): number of bytes in BUFFER.
C FILL (integer, input): the fill character. BUFSIZ bytes starting at
C       address BUFFER are set to contents of FILL.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INTEGER  BUFSIZ, I
      BYTE     FILL
      BYTE     BUFFER(BUFSIZ)
C
      DO 10 I=1,BUFSIZ
          BUFFER(I) = FILL
   10 CONTINUE
      END

	SUBROUTINE VBDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
	INTEGER   IFUNC, NBUF, LCHR
	REAL      RBUF(*)
	CHARACTER CHR*(*)
C
C PGPLOT driver for Canon Laser printer.  PORTRAIT MODE.
C
C Supported device:  Canon LBP-8/A2 Laser printer.
C   Conforms to ISO646,2022,2375 and 6429 specifications.
C   VDM (graphics) conforms to proposed American National
C   Standard VDM mode.
C
C Device type code:  /VBCanon (portrait mode only).
C
C Default file name:  PGPLOT.CAN
C
C Default view surface dimensions:  24 cm by 19 cm.
C
C Resolution:  300 pixels per inch in both directions.
C
C Color capability:  Color indices 0 (erase) and 1 (black) are
C   supported.  Note, hardware polygon fill is used and colors
C   0-11 control the fill pattern.
C
C Input capability:  None.
C
C File format:  Variable length records with Carriage control
C   of LIST.
C
C Obtaining hardcopy:  If printer is connected to a terminal
C   line (RS-232 option) then printing the file on the corresponding
C   queue should suffice.  If the printer is connected using
C   the Centronics interface, which appears the to VAX as an
C   LP device, then it is important to ensure that (1) all 8 bit
C   characters are passed to the printer (2) lines longer than
C   132 bytes are not truncated, and (3) no extra formatting
C   commands (e.g. form-feeds) are sent to the printer.
C   This can be done with the VMS command:
C   $ SET PRINT/PASSALL/LOWER/CR <device>
C   Note, some interface boards have a option to append a carriage
C   return after a formfeed or LF character, it is suggested
C   that this be disabled.
C   The file should be printed with the /PASSALL qualifier i.e.,
C   $ PRINT/PASSALL <filename>
C   Note, SET PRINT/PASSALL and PRINT/PASSALL do not do the
C   same things and hence PASSALL is required in both locations.
C
C 27-Jan-1988 - Version can be sent over BITNET (I hope) [AFT].
C 27-Sep-1986 - Add color index 0 (erase) [AFT].
C  5-Aug-1986 - [AFT].
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE
      PARAMETER (TYPE=
     :     'VBCANON (Canon laser printer, bitmap mode, portrait)')
	INTEGER    IS2,    IVESC
	PARAMETER (IS2=30, IVESC=125)
C- The maximum physical size of the plot in units of .08mm.
	INTEGER    MXLEN,      MXWID
	PARAMETER (MXLEN=2470, MXWID=3580)
C- Default size of plot.
	INTEGER    IDEFL,      IDEFW
	PARAMETER (IDEFL=2375, IDEFW=3000)
C
	INTEGER   GRGE00
	CHARACTER CBUF*256
	CHARACTER MSG*10
	CHARACTER CDASH(5),CFILL(0:11)
	INTEGER   I0, J0, I1, J1
	INTEGER   LUN, ICOL, NPTS, LBUF, LASX, LASY, IMAXL, IMAXW
	SAVE      LUN, ICOL, NPTS, LBUF, LASX, LASY, IMAXL, IMAXW
C---
C- Patterns defined with 2 and " appear the same on our Canon
C- so only one is used.  Pattern 0 causes the polygon not to
C- be filled.  Pattern ) erases interior of polygon is the
C- last character in list as all colors > max are set to
C- this pattern.
	DATA CFILL/')','1','(','''','&','%',
     &		'$','2','#','!','0',')'/
	DATA CDASH/'0','1','3','"','4'/
C---
	GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     &       110,120,130,140,150,160,900,180,190,200,
     &       210) IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in CA device driver: '//MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC= 1, Return device name. -------------------------------------
10	CHR=TYPE
	LCHR=LEN(TYPE)
	RETURN
C
C--- IFUNC= 2, Return Physical min and max for plot device. ------------
20	RBUF(1)=0
	RBUF(2)=MXLEN
	RBUF(3)=0
	RBUF(4)=MXWID
	RBUF(5)=0
	RBUF(6)=1
	NBUF=6
	RETURN
C
C--- IFUNC= 3, Return device resolution. -------------------------------
30	RBUF(1)=300.0
	RBUF(2)=300.0
	RBUF(3)=1
	NBUF=3
	RETURN
C
C--- IFUNC= 4, Return misc device info. --------------------------------
40	CHR='HNNANNNNNN'
	LCHR=10
	RETURN
C
C--- IFUNC= 5, Return default file name. -------------------------------
50	CHR='PGPLOT.CAN'
	LCHR=10
	RETURN
C
C--- IFUNC= 6, Return default physical size of plot. -------------------
60	RBUF(1)=0
	RBUF(2)=IDEFL
	RBUF(3)=0
	RBUF(4)=IDEFW
	RETURN
C
C--- IFUNC= 7, Return misc defaults. -----------------------------------
70	RBUF(1)=1
	NBUF=1
	RETURN
C
C--- IFUNC= 8, Select plot. --------------------------------------------
80	RETURN
C
C--- IFUNC= 9, Open workstation. ---------------------------------------
90	RBUF(2)=GRGE00('FFL',LUN,CHR,LCHR)
	RBUF(1)=LUN
	RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
100	CLOSE(UNIT=LUN)
	CALL GRFLUN(LUN)
	RETURN
C
C--- IFUNC=11, Begin Picture. ------------------------------------------
110	CALL GRCA03(LUN,1)
C- Use the origin transfer command to ensure that the picture is
C- centered on the page.
	IMAXW=NINT(RBUF(2))
	I0=(MXWID-IMAXW)/2
	IMAXL=NINT(RBUF(1))
	J0=(MXLEN-IMAXL)/2
	CBUF(1:2)=CHAR(IVESC)//'"'
	LBUF=2
	CALL GRCA04(J0,CBUF,LBUF)
	CALL GRCA04(I0,CBUF,LBUF)
	LBUF=LBUF+1
	CBUF(LBUF:LBUF)=CHAR(IS2)
	WRITE(LUN,11) CBUF(:LBUF)
	RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
120	I0=IMAXW-NINT(RBUF(2))
	J0=NINT(RBUF(1))
	I1=IMAXW-NINT(RBUF(4))
	J1=NINT(RBUF(3))
	CALL GRCA01(LUN,I0,J0,I1,J1)
	RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
130	I0=IMAXW-NINT(RBUF(2))
	J0=NINT(RBUF(1))
	CALL GRCA01(LUN,I0,J0,I0,J0)
	RETURN
C
C--- IFUNC=14, End Picture. --------------------------------------------
140	CALL GRCA03(LUN,2)
	RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C- Save pen number (up to 11) for possible use in pattern interior.
150	ICOL=MAX(0,MIN(NINT(RBUF(1)),11))
	RBUF(1)=MAX(0,MIN(ICOL,1))
	IF(ICOL.EQ.0) THEN
	  CBUF(1:4)=CHAR(IVESC)//'G2'//CHAR(IS2)
	ELSE
	  CBUF(1:4)=CHAR(IVESC)//'G0'//CHAR(IS2)
	END IF
	WRITE(LUN,11) CBUF(:4)
	RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
160	RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
180	RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C- Currently turned off, since pattern is reset at beginning of
C- every new line segment.  Note, if GRCA01 was modified to
C- properly use polylines then dash pattern may work better.
190	CBUF(1:4)='E1'//CDASH(NINT(RBUF(1)))//CHAR(IS2)
	WRITE(LUN,11) CBUF(:4)
	RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
200	IF(NPTS.EQ.0) THEN
	    NPTS=RBUF(1)
	    CBUF(1:5)='I'//CFILL(ICOL)//'0'//CHAR(IS2)//'2'
	    LBUF=5
	    LASX=0
	    LASY=0
	ELSE
	    NPTS=NPTS-1
	    I0=IMAXW-NINT(RBUF(2))
	    J0=NINT(RBUF(1))
	    CALL GRCA04(J0-LASY,CBUF,LBUF)
	    CALL GRCA04(I0-LASX,CBUF,LBUF)
	    LASX=I0
	    LASY=J0
	    IF(NPTS.EQ.0) THEN
		LBUF=LBUF+1
		CBUF(LBUF:LBUF)=CHAR(IS2)
		WRITE(LUN,11) CBUF(:LBUF)
11		FORMAT(A)
		LBUF=0
	    END IF
	END IF
	RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C- (not possible but can be called).
210	RETURN
C-----------------------------------------------------------------------
	END

C*PGQFS -- inquire fill-area style
C%void cpgqfs(int *fs);
C+
      SUBROUTINE PGQFS (FS)
      INTEGER  FS
C
C Query the current Fill-Area Style attribute (set by routine
C PGSFS).
C
C Argument:
C  FS     (output) : the current fill-area style:
C                      FS = 1 => solid (default)
C                      FS = 2 => outline
C                      FS = 3 => hatched
C                      FS = 4 => cross-hatched
C--
C  5-Nov-1985 - new routine [TJP].
C  6-Mar-1995 - add styles 3 and 4 [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGQFS')) THEN
          FS = 1
      ELSE
          FS = PGFAS(PGID)
      END IF
      END

C*PPDRIV -- PGPLOT PPM drivers
C+
      SUBROUTINE PPDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      INTEGER IFUNC, NBUF, LCHR, MODE
      REAL    RBUF(*)
      CHARACTER*(*) CHR
*
* PGPLOT driver for Portable Pixel Map (PPM) files with 'true color'
* capability.
*
* Supported device: PPM (P6) file format
*
* Device type codes: /PPM or /VPPM
*
* Default device name: pgplot.ppm.
*
* If you have more than one image to plot (i.e. use PGPAGE) with this
* device, subsequent pages will be named: pgplot2.ppm, pgplot3.ppm,
* etc, disrespective of the device name you specified.
* You can however bypass this by specifying a device name including a
* number sign (#), which will henceforth be replaced by the pagenumber.
* Example: page#.ppm will produce files page1.ppm, page2.ppm, etc.
*
* Default view surface dimensions are:
* - PPM  : 850 x 680 pixels 
* - VPPM : 680 x 850 pixels 
* Default width and height can be overriden by specifying environment
* variables
* PGPLOT_PPM_WIDTH  (default 850)
* PGPLOT_PPM_HEIGHT (default 680)
* The nominal scale is 85 pixels per inch.
*
* Color capability:
*   Indices 0 to 255 are supported. 
*   Default colors for indices 0 to 15 are implemented.
*   Color representation can be changed with PGSCR; color changes
*   affect subsequently drawn pixels only, not previously drawn
*   pixels. Thus the image is not limited to 256 different colors.
*
* Obtaining hardcopy: Use a PPM viewer or converter.
*=
*  9-Aug-1993 - Created by Remko Scharroo
*  6-Jul-1994 - Adapted to new PGPLOT version 4.9h
*  4-Aug-1994 - Use FASTIO.
*  9-Aug-1994 - New scheme for line plotting
* 16-Aug-1994 - Provide multi-image plotting.
* 16-Nov-1994 - Revised (T. Pearson).
* 28-Dec-1995 - Prevent concurrent access [TJP].
* 29-Apr-1996 - Use GRCTOI to decode environment variables [TJP].
*-----------------------------------------------------------------------
      CHARACTER*(*) LTYPE, PTYPE, DEFNAM
      INTEGER DWD, DHT
      PARAMETER (
     1 LTYPE= 'PPM   (Portable Pixel Map file, landscape orientation)',
     2 PTYPE= 'VPPM  (Portable Pixel Map file, portrait orientation)')
      PARAMETER (DEFNAM='pgplot.ppm')
      PARAMETER (DWD=850, DHT=680)

      REAL XRES, YRES
      PARAMETER (XRES=85., YRES=XRES)
C
      INTEGER UNIT, IC, CVAL, CTABLE(3,0:255), IER, I, L, LL, NPICT
      INTEGER BX, BY, IX0, IY0, IX1, IY1, R, G, B, STATE, USERH, USERW
      INTEGER CDEFLT(3,0:15), JUNK
      INTEGER GRGMEM, GRFMEM, GROFIL, GRCFIL, GRCTOI
      CHARACTER*80 MSG, INSTR, FILENM
C
C Note: for 64-bit operating systems, change the following 
C declaration to INTEGER*8:
C
      INTEGER PIXMAP
C
      SAVE    UNIT, IC, CVAL, CTABLE, BX, BY, PIXMAP, NPICT, CDEFLT
      SAVE    STATE
      DATA CDEFLT /000,000,000, 255,255,255, 255,000,000, 000,255,000,
     1             000,000,255, 000,255,255, 255,000,255, 255,255,000,
     2             255,128,000, 128,255,000, 000,255,128, 000,128,255,
     3             128,000,255, 255,000,128, 085,085,085, 170,170,170/
      DATA    STATE /0/
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260,270,280,290), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in PPM device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 IF (MODE.EQ.1) THEN
         CHR = LTYPE
         LCHR = LEN(LTYPE)
      ELSE IF (MODE.EQ.2) THEN
         CHR = PTYPE
         LCHR = LEN(PTYPE)
      ELSE
         CALL GRWARN('Requested MODE not implemented in PPM driver')
      ENDIF
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = -1 
      RBUF(3) = 0
      RBUF(4) = -1 
      RBUF(5) = 0
      RBUF(6) = 255
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = XRES
      RBUF(2) = YRES 
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, supports rectangle fill, pixel 
C     primitives, and query color rep.)
C
   40 CHR = 'HNNNNRPNYN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = BX-1 
      RBUF(3) = 0
      RBUF(4) = BY-1 
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C     -- check for concurrent access
      IF (STATE.EQ.1) THEN
         CALL GRWARN('a PGPLOT PPM file is already open')
         RBUF(1) = 0
         RBUF(2) = 0
         RETURN
      END IF
C     -- dimensions of plot buffer
      USERW = 0
      USERH = 0
      CALL GRGENV('PPM_WIDTH', INSTR, L)
      LL = 1
      IF (L.GT.0) USERW = GRCTOI(INSTR(:L),LL)
      CALL GRGENV('PPM_HEIGHT', INSTR, L)
      LL = 1
      IF (L.GT.0) USERH = GRCTOI(INSTR(:L),LL)
      IF (MODE.EQ.1) THEN
*     -- Landscape
         BX = DWD
         IF (USERW.GE.8) BX = USERW
         BY = DHT
         IF (USERH.GE.8) BY = USERH
      ELSE
*     -- Portrait
         BX = DHT
         IF (USERH.GE.8) BX = USERH
         BY = DWD
         IF (USERW.GE.8) BY = USERW
      END IF
      NPICT=1
*     -- Initialize color table
      DO 95 I=0,15
         CTABLE(1,I) = CDEFLT(1,I)
         CTABLE(2,I) = CDEFLT(2,I)
         CTABLE(3,I) = CDEFLT(3,I)
 95   CONTINUE
      DO 96 I=16,255
         CTABLE(1,I) = 128
         CTABLE(2,I) = 128
         CTABLE(3,I) = 128
 96   CONTINUE       
*
      FILENM = CHR(:LCHR)
      CALL GRPP10 (FILENM, NPICT, MSG)
      UNIT = GROFIL (MSG)
      RBUF(1) = UNIT
      IF (UNIT.LT.0) THEN
          CALL GRWARN('Cannot open output file for PPM plot')
          RBUF(2) = 0
      ELSE
          RBUF(2) = 1
          STATE = 1
      END IF
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      STATE = 0
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
      BX = NINT(RBUF(1))+1
      BY = NINT(RBUF(2))+1
C     -- allocate buffer with 4 bytes per pixel
      IER = GRGMEM(4*BX*BY, PIXMAP)
      IF (IER.NE.1) THEN
         CALL GRGMSG(IER)
         CALL GRWARN('Failed to allocate plot buffer.')
         BX = 0
         BY = 0
         PIXMAP = 0
      END IF
C     -- initialize to zero (background color)
      IF (PIXMAP.NE.0) 
     :     CALL GRPP03(1, 1, BX, BY, 0, BX, BY, %VAL(PIXMAP))
C     -- open new file if necessary
      IF (NPICT.GT.1) THEN
          CALL GRPP10 (FILENM, NPICT, MSG)
          UNIT = GROFIL (MSG)
          IF (UNIT.LT.0) 
     :        CALL GRWARN('Cannot open output file for PPM plot')
C         -- no way to return error status!
      END IF
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      IX0=NINT(RBUF(1))+1
      IX1=NINT(RBUF(3))+1
      IY0=BY-NINT(RBUF(2))
      IY1=BY-NINT(RBUF(4))
      IF (PIXMAP.NE.0) 
     :     CALL GRPP01(IX0, IY0, IX1, IY1, CVAL, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      IX0=NINT(RBUF(1))+1
      IY0=BY-NINT(RBUF(2))
      IF (PIXMAP.NE.0) 
     :     CALL GRPP01(IX0, IY0, IX0, IY0, CVAL, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      IF (PIXMAP.NE.0) THEN
         CALL GRPP02(UNIT, BX, BY, %VAL(PIXMAP))
         IF (UNIT.GE.0) JUNK = GRCFIL(UNIT)
         NPICT = NPICT+1
         IER = GRFMEM(4*BX*BY, PIXMAP)
         IF (IER.NE.1) THEN
            CALL GRGMSG(IER)
            CALL GRWARN('Failed to deallocate plot buffer.')
         END IF
      END IF
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = NINT(RBUF(1))
      IF (IC.LT.0 .OR. IC.GT.255) IC = 1
      R = CTABLE(1,IC)
      G = CTABLE(2,IC)
      B = CTABLE(3,IC)
      CVAL = R + 256*(G + 256*B)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Not used.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      I = NINT(RBUF(1))
      IF (I.GE.0 .AND. I.LE.255) THEN
         CTABLE(1, I) = NINT(RBUF(2)*255)
         CTABLE(2, I) = NINT(RBUF(3)*255)
         CTABLE(3, I) = NINT(RBUF(4)*255)
      END IF
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle fill ------------------------------------------
C
  240 CONTINUE
      IX0=NINT(RBUF(1))+1
      IX1=NINT(RBUF(3))+1
      IY1=BY-NINT(RBUF(2))
      IY0=BY-NINT(RBUF(4))
      IF (PIXMAP.NE.0) 
     :     CALL GRPP03(IX0, IY0, IX1, IY1, CVAL, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=25, Not implemented -----------------------------------------
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels ------------------------------------------
C
  260 CONTINUE
      IF (PIXMAP.NE.0)
     :     CALL GRPP04(NBUF, RBUF, BX, BY, %VAL(PIXMAP), CTABLE)
      RETURN
C
C--- IFUNC=27, Not implemented -----------------------------------------
C
  270 CONTINUE
      RETURN
C
C--- IFUNC=28, Not implemented -----------------------------------------
C
  280 CONTINUE
      RETURN
C
C--- IFUNC=29, Query color representation. -----------------------------
C
  290 CONTINUE
      I = RBUF(1)
      RBUF(2) = CTABLE(1,I)/255.0
      RBUF(3) = CTABLE(2,I)/255.0
      RBUF(4) = CTABLE(3,I)/255.0
      NBUF = 4
      RETURN
C-----------------------------------------------------------------------
      END

**GRPP01 -- PGPLOT PPM driver, draw line
*+
      SUBROUTINE GRPP01 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY, PIXMAP(BX,BY)
*
* Draw a straight-line segment from absolute pixel coordinates
* (IX0, IY0) to (IX1, IY1).
*
* Arguments:
*  IX0, IY0        (input): Starting point of line.
*  IX1, IY1        (input): End point of line.
*  ICOL            (input): Color value.
*  BX, BY          (input): dimensions of PIXMAP.
*  PIXMAP   (input/output): The image data buffer.
*-
*  9-Aug-1994 - Recreated by Remko Scharroo from GRGI01 by Ge van Geldorp
*               Improved algorithm.
*-----------------------------------------------------------------------
      INTEGER IX, IY, IS
      REAL    D
C
      IF (IX0.EQ.IX1 .AND. IY0.EQ.IY1) THEN
         PIXMAP(IX0,IY0)=ICOL
      ELSE IF (ABS(IY1-IY0).GT.ABS(IX1-IX0)) THEN
         D=(IX1-IX0)/REAL(IY1-IY0)
         IS=1
         IF (IY1.LT.IY0) IS=-1
         DO 10 IY=IY0,IY1,IS
            IX=NINT(IX0+(IY-IY0)*D)
            PIXMAP(IX,IY)=ICOL
 10      CONTINUE
      ELSE
         D=(IY1-IY0)/REAL(IX1-IX0)
         IS=1
         IF (IX1.LT.IX0) IS=-1
         DO 20 IX=IX0,IX1,IS
            IY=NINT(IY0+(IX-IX0)*D)
            PIXMAP(IX,IY)=ICOL
 20      CONTINUE
      ENDIF
      END

**GRPP02 -- PGPLOT PPM driver, write PPM image
*+
      SUBROUTINE GRPP02 (UNIT, BX, BY, PIXMAP)
      INTEGER UNIT, BX, BY, PIXMAP(*)
*
* This routine copies the image buffer to an output buffer. A PPM image
* header and the output buffer are written to UNIT.
*
* Arguments:
*  UNIT    (input): Output unit
*  BX, BY  (input): Image size
*  PIXMAP  (input): Image data
*-
* 10-Aug-1993 - Created by Remko Scharroo
* 16-Nov-1994 - Rewritten by T. Pearson
*-----------------------------------------------------------------------
*       BUFSIZ must be a multiple of 3 (and not larger than 500 for
*       portability to AIX)
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=498)
      INTEGER I, N, IER, IBUF, L1, L2
      INTEGER GRTRIM, GRWFCH
      CHARACTER*128 HEAD
      CHARACTER*20 USER
      CHARACTER*20 TODAY
      CHARACTER*(BUFSIZ) BUF
      LOGICAL BAD
*
*     Write the header (magic number = P6)
*
      CALL GRUSER(USER,L1)
      CALL GRDATE(TODAY,L2)
      WRITE (HEAD, 1000) USER(:L1), TODAY(:L2),CHAR(10),
     :                   BX, BY, CHAR(10), 255, CHAR(10)
 1000 FORMAT ('P6 # PGPLOT PPM image ',A,1X,A,A1, I5,1X,I5,A1, I3,A1)
      N = GRTRIM(HEAD)
      IER = GRWFCH(UNIT, HEAD(1:N))
      IF (IER.NE.N) CALL GRWARN('Failed writing PPM header')
*
*     Write the pixel data as R,G,B components
*
      N=BX*BY
      IBUF=0
      BAD = .FALSE.
      DO 10 I=1,N
         BUF(IBUF+1:IBUF+1) = CHAR(MOD(PIXMAP(I),256))
         BUF(IBUF+2:IBUF+2) = CHAR(MOD(PIXMAP(I)/256,256))
         BUF(IBUF+3:IBUF+3) = CHAR(PIXMAP(I)/(256*256))
         IBUF = IBUF+3
         IF (IBUF.GE.BUFSIZ) THEN
            IER = GRWFCH(UNIT, BUF)
            IF (IER.NE.IBUF) BAD = .TRUE.
            IBUF = 0
         END IF
 10   CONTINUE
      IF (IBUF.GT.0) THEN
         IER = GRWFCH(UNIT, BUF(:IBUF))
         IF (IER.NE.IBUF) BAD = .TRUE.
         IBUF = 0
      END IF
      IF (BAD) CALL GRWARN('Failed writing PPM data')
      END

**GRPP03 -- PGPLOT PPM driver, fill rectangle
*+
      SUBROUTINE GRPP03 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY, PIXMAP(BX,BY)
*
* Arguments:
*  IX0, IY0        (input): Lower left corner.
*  IX1, IY1        (input): Upper right corner.
*  ICOL            (input): Color value.
*  BX, BY          (input): dimensions of PIXMAP.
*  PIXMAP   (input/output): The image data buffer.
*-----------------------------------------------------------------------
      INTEGER IX, IY
C
      DO 20 IY=IY0,IY1
         DO 10 IX=IX0,IX1
            PIXMAP(IX,IY) = ICOL
 10      CONTINUE
 20   CONTINUE
      END

**GRPP04 -- PGPLOT PPM driver, fill image line
*+
      SUBROUTINE GRPP04(NBUF,RBUF,BX,BY,PIXMAP,CTABLE)
      INTEGER I,J,NBUF,BX,BY,N,IC
      REAL RBUF(NBUF)
      INTEGER PIXMAP(BX,BY)
      INTEGER CTABLE(3,0:255)
      INTEGER R, G, B
*-
      I = NINT(RBUF(1))+1
      J = BY-NINT(RBUF(2))
      DO 10 N=3,NBUF
         IC=RBUF(N)
         R = CTABLE(1,IC)
         G = CTABLE(2,IC)
         B = CTABLE(3,IC)
         PIXMAP(I+N-3,J) = R + 256*(G + 256*B)
 10   CONTINUE
      END

**GRPP10 -- Replace # in filename by picture number
*
      SUBROUTINE GRPP10 (NAME1, NP, NAME2)
      CHARACTER*(*) NAME1
      CHARACTER*(*) NAME2
      CHARACTER*80  TMP
      INTEGER GRTRIM
      INTEGER NP, IDX, L, LN

      LN = GRTRIM(NAME1)
      IDX = INDEX(NAME1,'#')
      IF (IDX.GT.0) THEN
C        -- if the supplied name contains a #-character, replace
C           it with the page number
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE IF (NP.EQ.1) THEN
C        -- if this is the first page, use the supplied name
         NAME2 = NAME1
         RETURN
      ELSE IF (LN+2.LE.LEN(NAME1)) THEN
C        -- append an underscore and the page number to the supplied
C           name
         NAME1(LN+1:LN+2) = '_#'
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE
C        -- last resort: invent a new name
         CALL GRFAO('pgplot#.ppm', L, TMP, NP, 0, 0, 0)
      END IF
      CALL GRWARN ('Writing new PPM image as: '//TMP(:L))
      NAME2 = TMP(:L)
      END

C*********
      SUBROUTINE GRCTER(ICHAN)
      INTEGER   ICHAN
C---
C Close a previously opened channel.
C---
C ICHAN     I    The channel number to be closed
C---
      CALL SYS$DASSGN(%val(ICHAN))
      RETURN
      END
      INTEGER FUNCTION GROTER(CDEV, LDEV)
      CHARACTER CDEV*(*)
      INTEGER   LDEV
C---
C Open a channel to the device specified by CDEV.
C---
C CDEV      I    The name of the device to be opened
C LDEV      I    Number of valid characters in device
C GROTER      O  The open channel number (-1 indicates an error)
C---
      INTEGER ICHAN
C---
      CALL SYS$ASSIGN(CDEV(:LDEV),ICHAN,,)
      GROTER=ICHAN
      RETURN
      END
C*********
      SUBROUTINE GRWTER(ICHAN, CBUF, LBUF)
      CHARACTER CBUF*(*)
      INTEGER   ICHAN, LBUF
C---
C Write LBUF bytes from CBUF to the channel ICHAN.  Data is written
C with no formatting.
C---
C ICHAN     I    The channel number
C CBUF      I    Character array of data to be written
C LBUF      I/O  The number of bytes to write, set to zero on return
C---
      INCLUDE '($IODEF)'
C---
      CALL SYS$QIOW(,%val(ICHAN),
     :   %val(IO$_WRITEVBLK.OR.IO$M_NOFORMAT),,,,
     :      %ref(CBUF),%val(LBUF),,,,)
      LBUF=0
      RETURN
      END
C*********
      SUBROUTINE GRPTER(ICHAN, PROMPT, LPROM, CBUF, LBUF)
      CHARACTER PROMPT*(*), CBUF*(*)
      INTEGER   ICHAN, LPROM, LBUF
C---
C revised 3-Jun-1997: use NOFILTR to pass DEL etc.
C 12-Mar-1998: change timeout behavior (M.Zolliker)
C---
      INCLUDE '($SSDEF)'
      INCLUDE '($IODEF)'
      INTEGER   IREAD1,IREAD
      PARAMETER (IREAD1= IO$M_PURGE + IO$M_NOFORMAT + IO$M_NOFILTR +
     :           IO$M_NOECHO + IO$_READPROMPT)
      PARAMETER (IREAD= IO$M_NOFORMAT + IO$M_NOFILTR +
     :           IO$M_NOECHO + IO$M_TIMED + IO$_TTYREADALL)
      INTEGER   ITIME
      PARAMETER (ITIME=5)
C IOSB(1): status
C IOSB(2): character count
      INTEGER*2 IOSB(4)
C---
C wait indefinitely for the first character
      CALL SYS$QIOW(,%VAL(ICHAN),%VAL(IREAD1),IOSB,,,
     :     %REF(CBUF),%VAL(1),,,
     :     %REF(PROMPT),%VAL(LPROM))
      IF (IOSB(1) .EQ. SS$_NORMAL) THEN
C wait 4-5 sec. for each of the following characters
        CALL SYS$QIOW(,%VAL(ICHAN),%VAL(IREAD),IOSB,,,
     :     %REF(CBUF(2:)),%VAL(LBUF-1),%VAL(ITIME),,
     :     %REF(PROMPT),%VAL(LPROM))
        IOSB(2)=IOSB(2)+1
      ENDIF
      LBUF=IOSB(2)
      RETURN
      END
C*********
      SUBROUTINE GRRTER(ICHAN, CBUF, LBUF)
      CHARACTER CBUF*(*)
      INTEGER   ICHAN, LBUF
C---
C Read LBUF bytes from device assigned to channel ICHAN to CBUF.
C Previous unread data is purged.  Data is read without format
C or echo.
C---
C ICHAN     I    The channel number
C CBUF        O  Character array of data read
C LBUF      I/O  The number of bytes to write, set to zero on return
C---
      INCLUDE '($IODEF)'
      INTEGER   IREAD
      PARAMETER (IREAD= IO$_TTYREADALL + IO$M_PURGE + IO$M_NOFORMAT +
     :           IO$M_NOECHO + IO$M_TIMED)
      INTEGER   ITIME
      PARAMETER (ITIME=60)
      INTEGER IQUAD0(2)
      DATA IQUAD0/0,0/
C---
      CALL SYS$QIOW(,%val(ICHAN),%val(IREAD),,,,
     :      %ref(CBUF),%val(LBUF),%val(ITIME),IQUAD0,,)
      RETURN
      END

C*PGBOX -- draw labeled frame around viewport
C%void cpgbox(const char *xopt, float xtick, int nxsub, \
C% const char *yopt, float ytick, int nysub);
C+
      SUBROUTINE PGBOX (XOPT, XTICK, NXSUB, YOPT, YTICK, NYSUB)
      CHARACTER*(*) XOPT, YOPT
      REAL XTICK, YTICK
      INTEGER NXSUB, NYSUB
C
C Annotate the viewport with frame, axes, numeric labels, etc.
C PGBOX is called by on the user's behalf by PGENV, but may also be
C called explicitly.
C
C Arguments:
C  XOPT   (input)  : string of options for X (horizontal) axis of
C                    plot. Options are single letters, and may be in
C                    any order (see below).
C  XTICK  (input)  : world coordinate interval between major tick marks
C                    on X axis. If XTICK=0.0, the interval is chosen by
C                    PGBOX, so that there will be at least 3 major tick
C                    marks along the axis.
C  NXSUB  (input)  : the number of subintervals to divide the major
C                    coordinate interval into. If XTICK=0.0 or NXSUB=0,
C                    the number is chosen by PGBOX.
C  YOPT   (input)  : string of options for Y (vertical) axis of plot.
C                    Coding is the same as for XOPT.
C  YTICK  (input)  : like XTICK for the Y axis.
C  NYSUB  (input)  : like NXSUB for the Y axis.
C
C Options (for parameters XOPT and YOPT):
C  A : draw Axis (X axis is horizontal line Y=0, Y axis is vertical
C      line X=0).
C  B : draw bottom (X) or left (Y) edge of frame.
C  C : draw top (X) or right (Y) edge of frame.
C  G : draw Grid of vertical (X) or horizontal (Y) lines.
C  I : Invert the tick marks; ie draw them outside the viewport
C      instead of inside.
C  L : label axis Logarithmically (see below).
C  N : write Numeric labels in the conventional location below the
C      viewport (X) or to the left of the viewport (Y).
C  P : extend ("Project") major tick marks outside the box (ignored if
C      option I is specified).
C  M : write numeric labels in the unconventional location above the
C      viewport (X) or to the right of the viewport (Y).
C  T : draw major Tick marks at the major coordinate interval.
C  S : draw minor tick marks (Subticks).
C  V : orient numeric labels Vertically. This is only applicable to Y.
C      The default is to write Y-labels parallel to the axis.
C  1 : force decimal labelling, instead of automatic choice (see PGNUMB).
C  2 : force exponential labelling, instead of automatic.
C
C To get a complete frame, specify BC in both XOPT and YOPT.
C Tick marks, if requested, are drawn on the axes or frame
C or both, depending which are requested. If none of ABC is specified,
C tick marks will not be drawn. When PGENV calls PGBOX, it sets both
C XOPT and YOPT according to the value of its parameter AXIS:
C -1: 'BC', 0: 'BCNST', 1: 'ABCNST', 2: 'ABCGNST'.
C
C For a logarithmic axis, the major tick interval is always 1.0. The
C numeric label is 10**(x) where x is the world coordinate at the
C tick mark. If subticks are requested, 8 subticks are drawn between
C each major tick at equal logarithmic intervals.
C
C To label an axis with time (days, hours, minutes, seconds) or
C angle (degrees, arcmin, arcsec), use routine PGTBOX.
C--
C 19-Oct-1983
C 23-Sep-1984 - fix bug in labelling reversed logarithmic axes.
C  6-May-1985 - improve behavior for pen plotters [TJP].
C 23-Nov-1985 - add 'P' option [TJP].
C 14-Jan-1986 - use new routine PGBOX1 to fix problem of missing
C               labels at end of axis [TJP].
C  8-Apr-1987 - improve automatic choice of tick interval; improve
C               erroneous rounding of tick interval to 1 digit [TJP].
C 23-Apr-1987 - fix bug: limit max number of ticks to ~10 [TJP].
C  7-Nov-1987 - yet another change to algorithm for choosing tick
C               interval; maximum tick interval is now 0.2*range of
C               axis, which may round up to 0.5 [TJP].
C 15-Dec-1988 - correct declaration of MAJOR [TJP].
C  6-Sep-1989 - use Fortran generic intrinsic functions [TJP].
C 18-Oct-1990 - correctly initialize UTAB(1) [AFT].
C 19-Oct-1990 - do all plotting in world coordinates [TJP].
C  6-Nov-1991 - label logarithmic subticks when necessary [TJP].
C  4-Jul-1994 - add '1' and '2' options [TJP].
C 20-Apr-1995 - adjust position of labels slightly, and move out
C               when ticks are inverted [TJP].
C 26-Feb-1997 - use new routine pgclp [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      CHARACTER*20  CLBL
      CHARACTER*64  OPT
      LOGICAL  XOPTA, XOPTB, XOPTC, XOPTG, XOPTN, XOPTM, XOPTT, XOPTS
      LOGICAL  YOPTA, YOPTB, YOPTC, YOPTG, YOPTN, YOPTM, YOPTT, YOPTS
      LOGICAL  XOPTI, YOPTI, YOPTV, XOPTL, YOPTL, XOPTP, YOPTP, RANGE
      LOGICAL  IRANGE, MAJOR, XOPTLS, YOPTLS, PGNOTO
      REAL     TAB(9), UTAB(9)
      INTEGER  I, I1, I2, J, NC, NP, NV, KI, CLIP
      INTEGER  NSUBX, NSUBY, JMAX, XNFORM, YNFORM
      REAL     TIKL, TIKL1, TIKL2, XC, YC
      REAL     XINT, XINT2, XVAL, YINT, YINT2, YVAL
      REAL     PGRND
      REAL     A, B, C
      REAL     XNDSP, XMDSP, YNDSP, YMDSP, YNVDSP, YMVDSP
      REAL     XBLC, XTRC, YBLC, YTRC
      INTRINSIC ABS, INDEX, INT, LOG10, MAX, MIN, MOD, NINT, SIGN, REAL
C
C Table of logarithms 1..9
C
      DATA TAB / 0.00000, 0.30103, 0.47712, 0.60206, 0.69897,
     1           0.77815, 0.84510, 0.90309, 0.95424 /
C
      RANGE(A,B,C) = (A.LT.B.AND.B.LT.C) .OR. (C.LT.B.AND.B.LT.A)
      IRANGE(A,B,C) = (A.LE.B.AND.B.LE.C) .OR. (C.LE.B.AND.B.LE.A)
C
      IF (PGNOTO('PGBOX')) RETURN
      CALL PGBBUF
      CALL PGQWIN(XBLC, XTRC, YBLC, YTRC)
C
C Decode options.
C
      CALL GRTOUP(OPT,XOPT)
      XOPTA = INDEX(OPT,'A').NE.0 .AND. RANGE(YBLC,0.0,YTRC)
      XOPTB = INDEX(OPT,'B').NE.0
      XOPTC = INDEX(OPT,'C').NE.0
      XOPTG = INDEX(OPT,'G').NE.0
      XOPTI = INDEX(OPT,'I').NE.0
      XOPTL = INDEX(OPT,'L').NE.0
      XOPTM = INDEX(OPT,'M').NE.0
      XOPTN = INDEX(OPT,'N').NE.0
      XOPTS = INDEX(OPT,'S').NE.0
      XOPTT = INDEX(OPT,'T').NE.0
      XOPTP = INDEX(OPT,'P').NE.0 .AND. (.NOT.XOPTI)
      XNFORM = 0
      IF (INDEX(OPT,'1').NE.0) XNFORM = 1
      IF (INDEX(OPT,'2').NE.0) XNFORM = 2
      CALL GRTOUP(OPT,YOPT)
      YOPTA = INDEX(OPT,'A').NE.0 .AND. RANGE(XBLC,0.0,XTRC)
      YOPTB = INDEX(OPT,'B').NE.0
      YOPTC = INDEX(OPT,'C').NE.0
      YOPTG = INDEX(OPT,'G').NE.0
      YOPTI = INDEX(OPT,'I').NE.0
      YOPTL = INDEX(OPT,'L').NE.0
      YOPTN = INDEX(OPT,'N').NE.0
      YOPTM = INDEX(OPT,'M').NE.0
      YOPTS = INDEX(OPT,'S').NE.0
      YOPTT = INDEX(OPT,'T').NE.0
      YOPTV = INDEX(OPT,'V').NE.0
      YOPTP = INDEX(OPT,'P').NE.0 .AND. (.NOT.YOPTI)
      YNFORM = 0
      IF (INDEX(OPT,'1').NE.0) YNFORM = 1
      IF (INDEX(OPT,'2').NE.0) YNFORM = 2
C
C Displacement of labels from edge of box
C (for X bottom/top, Y left/right, and Y left/right with V option).
C
      XNDSP = 1.2
      XMDSP = 0.7
      YNDSP = 0.7
      YMDSP = 1.2
      YNVDSP = 0.7
      YMVDSP = 0.7
      IF (XOPTI) THEN
         XNDSP = XNDSP + 0.3
         XMDSP = XMDSP + 0.3
      END IF
      IF (YOPTI) THEN
         YNDSP = YNDSP + 0.3
         YMDSP = YMDSP + 0.3
         YNVDSP = YNVDSP + 0.3
         YMVDSP = YMVDSP + 0.3
      END IF
C
C Disable clipping.
C
      CALL PGQCLP(CLIP)
      CALL PGSCLP(0)
C
C Draw box.
C
      IF (XOPTB) THEN
          CALL GRMOVA(XBLC, YBLC)
          CALL GRLINA(XTRC, YBLC)
      END IF
      IF (YOPTC) THEN
          CALL GRMOVA(XTRC, YBLC)
          CALL GRLINA(XTRC, YTRC)
      END IF
      IF (XOPTC) THEN
          CALL GRMOVA(XTRC, YTRC)
          CALL GRLINA(XBLC, YTRC)
      END IF
      IF (YOPTB) THEN
          CALL GRMOVA(XBLC, YTRC)
          CALL GRLINA(XBLC, YBLC)
      END IF
C
C Draw axes if required.
C
      IF (XOPTA.AND..NOT.XOPTG) THEN
          CALL GRMOVA(XBLC, 0.0)
          CALL GRLINA(XTRC, 0.0)
      END IF
      IF (YOPTA.AND..NOT.YOPTG) THEN
          CALL GRMOVA(0.0, YBLC)
          CALL GRLINA(0.0, YTRC)
      END IF
C
C Length of X tick marks.
C
      TIKL1 = PGXSP(PGID)*0.6*(YTRC-YBLC)/PGYLEN(PGID)
      IF (XOPTI) TIKL1 = -TIKL1
      TIKL2 = TIKL1*0.5
C
C Choose X tick intervals. Major interval = XINT,
C minor interval = XINT2 = XINT/NSUBX.
C
      UTAB(1) = 0.0
      IF (XOPTL) THEN
          XINT = SIGN(1.0,XTRC-XBLC)
          NSUBX = 1
          DO 10 J=2,9
              UTAB(J) = TAB(J)
              IF (XINT.LT.0.0) UTAB(J) = 1.0-TAB(J)
   10     CONTINUE
      ELSE IF (XTICK.EQ.0.0) THEN
          XINT = MAX(0.05, MIN(7.0*PGXSP(PGID)/PGXLEN(PGID), 0.20))
     1           *(XTRC-XBLC)
          XINT = PGRND(XINT,NSUBX)
      ELSE
          XINT = SIGN(XTICK,XTRC-XBLC)
          NSUBX = MAX(NXSUB,1)
      END IF
      IF (.NOT.XOPTS) NSUBX = 1
      NP = INT(LOG10(ABS(XINT)))-4
      NV = NINT(XINT/10.**NP)
      XINT2 = XINT/NSUBX
      XOPTLS = XOPTL .AND. XOPTS .AND. (ABS(XTRC-XBLC).LT.2.0)
C
C Draw X grid.
C
      IF (XOPTG) THEN
          CALL PGBOX1(XBLC, XTRC, XINT, I1, I2)
          DO 20 I=I1,I2
              CALL GRMOVA(REAL(I)*XINT, YBLC)
              CALL GRLINA(REAL(I)*XINT, YTRC)
   20     CONTINUE
      END IF
C
C Draw X ticks.
C
      IF (XOPTT.OR.XOPTS) THEN
          CALL PGBOX1(XBLC, XTRC, XINT2, I1, I2)
          JMAX = 1
          IF (XOPTL.AND.XOPTS) JMAX=9
C
C         Bottom ticks.
C
          IF (XOPTB) THEN
            DO 40 I=I1-1,I2
            DO 30 J=1,JMAX
                MAJOR = (MOD(I,NSUBX).EQ.0).AND.XOPTT.AND.J.EQ.1
                TIKL = TIKL2
                IF (MAJOR) TIKL = TIKL1
                XVAL = (I+UTAB(J))*XINT2
                IF (IRANGE(XBLC,XVAL,XTRC)) THEN
                    IF (XOPTP.AND.MAJOR) THEN
                        CALL GRMOVA(XVAL, YBLC-TIKL2)
                    ELSE
                        CALL GRMOVA(XVAL, YBLC)
                    END IF
                    CALL GRLINA(XVAL, YBLC+TIKL)
                END IF
   30        CONTINUE
   40       CONTINUE
          END IF
C
C         Axis ticks.
C
          IF (XOPTA) THEN
            DO 60 I=I1-1,I2
            DO 50 J=1,JMAX
                MAJOR = (MOD(I,NSUBX).EQ.0).AND.XOPTT.AND.J.EQ.1
                TIKL = TIKL2
                IF (MAJOR) TIKL = TIKL1
                XVAL = (I+UTAB(J))*XINT2
                IF (IRANGE(XBLC,XVAL,XTRC)) THEN
                    CALL GRMOVA(XVAL, -TIKL)
                    CALL GRLINA(XVAL, TIKL)
                END IF
   50       CONTINUE
   60       CONTINUE
          END IF
C
C         Top ticks.
C
          IF (XOPTC) THEN
            DO 80 I=I1-1,I2
            DO 70 J=1,JMAX
                MAJOR = (MOD(I,NSUBX).EQ.0).AND.XOPTT.AND.J.EQ.1
                TIKL = TIKL2
                IF (MAJOR) TIKL = TIKL1
                XVAL = (I+UTAB(J))*XINT2
                IF (IRANGE(XBLC,XVAL,XTRC)) THEN
                    CALL GRMOVA(XVAL, YTRC-TIKL)
                    CALL GRLINA(XVAL, YTRC)
                END IF
   70       CONTINUE
   80       CONTINUE
          END IF
      END IF
C
C Write X labels.
C
      IF (XOPTN .OR. XOPTM) THEN
          CALL PGBOX1(XBLC, XTRC, XINT, I1, I2)
          DO 90 I=I1,I2
              XC = (I*XINT-XBLC)/(XTRC-XBLC)
              IF (XOPTL) THEN
                  CALL PGNUMB(1,NINT(I*XINT),XNFORM,CLBL,NC)
              ELSE
                  CALL PGNUMB(I*NV,NP,XNFORM,CLBL,NC)
              END IF
              IF (XOPTN) CALL PGMTXT('B', XNDSP, XC, 0.5, CLBL(1:NC))
              IF (XOPTM) CALL PGMTXT('T', XMDSP, XC, 0.5, CLBL(1:NC))
   90     CONTINUE
      END IF
C
C Extra X labels for log axes.
C
      IF (XOPTLS) THEN
          CALL PGBOX1(XBLC, XTRC, XINT2, I1, I2)
          DO 401 I=I1-1,I2
             DO 301 J=2,5,3
                XVAL = (I+UTAB(J))*XINT2
                XC = (XVAL-XBLC)/(XTRC-XBLC)
                KI = I
                IF (XTRC.LT.XBLC) KI = KI+1
                IF (IRANGE(XBLC,XVAL,XTRC)) THEN
                    CALL PGNUMB(J,NINT(KI*XINT2),XNFORM,CLBL,NC)
                    IF (XOPTN) 
     1                CALL PGMTXT('B', XNDSP, XC, 0.5, CLBL(1:NC))
                    IF (XOPTM) 
     1                CALL PGMTXT('T', XMDSP, XC, 0.5, CLBL(1:NC))
                END IF
  301       CONTINUE
  401     CONTINUE
      END IF
C
C Length of Y tick marks.
C
      TIKL1 = PGXSP(PGID)*0.6*(XTRC-XBLC)/PGXLEN(PGID)
      IF (YOPTI) TIKL1 = -TIKL1
      TIKL2 = TIKL1*0.5
C
C Choose Y tick intervals. Major interval = YINT,
C minor interval = YINT2 = YINT/NSUBY.
C
      UTAB(1) = 0.0
      IF (YOPTL) THEN
          YINT = SIGN(1.0,YTRC-YBLC)
          NSUBY = 1
          DO 100 J=2,9
              UTAB(J) = TAB(J)
              IF (YINT.LT.0.0) UTAB(J) = 1.0-TAB(J)
  100     CONTINUE
      ELSE IF (YTICK.EQ.0.0) THEN
          YINT = MAX(0.05, MIN(7.0*PGXSP(PGID)/PGYLEN(PGID), 0.20))
     1           *(YTRC-YBLC)
          YINT = PGRND(YINT,NSUBY)
      ELSE
          YINT  = SIGN(YTICK,YTRC-YBLC)
          NSUBY = MAX(NYSUB,1)
      END IF
      IF (.NOT.YOPTS) NSUBY = 1
      NP = INT(LOG10(ABS(YINT)))-4
      NV = NINT(YINT/10.**NP)
      YINT2 = YINT/NSUBY
      YOPTLS = YOPTL .AND. YOPTS .AND. (ABS(YTRC-YBLC).LT.2.0)
C
C Draw Y grid.
C
      IF (YOPTG) THEN
          CALL PGBOX1(YBLC, YTRC, YINT, I1, I2)
          DO 110 I=I1,I2
              CALL GRMOVA(XBLC, REAL(I)*YINT)
              CALL GRLINA(XTRC, REAL(I)*YINT)
  110     CONTINUE
      END IF
C
C Draw Y ticks.
C
      IF (YOPTT.OR.YOPTS) THEN
          CALL PGBOX1(YBLC, YTRC, YINT2, I1, I2)
          JMAX = 1
          IF (YOPTL.AND.YOPTS) JMAX = 9
C
C               Left ticks.
C
            IF (YOPTB) THEN
            DO 130 I=I1-1,I2
            DO 120 J=1,JMAX
                MAJOR = (MOD(I,NSUBY).EQ.0).AND.YOPTT.AND.J.EQ.1
                TIKL = TIKL2
                IF (MAJOR) TIKL = TIKL1
                YVAL = (I+UTAB(J))*YINT2
                IF (IRANGE(YBLC,YVAL,YTRC)) THEN
                    IF (YOPTP.AND.MAJOR) THEN
                        CALL GRMOVA(XBLC-TIKL2, YVAL)
                    ELSE
                        CALL GRMOVA(XBLC, YVAL)
                    END IF
                    CALL GRLINA(XBLC+TIKL, YVAL)
                END IF
  120       CONTINUE
  130       CONTINUE
            END IF
C
C               Axis ticks.
C
            IF (YOPTA) THEN
            DO 150 I=I1-1,I2
            DO 140 J=1,JMAX
                MAJOR = (MOD(I,NSUBY).EQ.0).AND.YOPTT.AND.J.EQ.1
                TIKL = TIKL2
                IF (MAJOR) TIKL = TIKL1
                YVAL = (I+UTAB(J))*YINT2
                IF (IRANGE(YBLC,YVAL,YTRC)) THEN
                    CALL GRMOVA(-TIKL, YVAL)
                    CALL GRLINA(TIKL, YVAL)
                END IF
  140       CONTINUE
  150       CONTINUE
            END IF
C
C               Right ticks.
C
            IF (YOPTC) THEN
            DO 170 I=I1-1,I2
            DO 160 J=1,JMAX
                MAJOR = (MOD(I,NSUBY).EQ.0).AND.YOPTT.AND.J.EQ.1
                TIKL = TIKL2
                IF (MAJOR) TIKL = TIKL1
                YVAL = (I+UTAB(J))*YINT2
                IF (IRANGE(YBLC,YVAL,YTRC)) THEN
                    CALL GRMOVA(XTRC-TIKL, YVAL)
                    CALL GRLINA(XTRC, YVAL)
                END IF
  160       CONTINUE
  170       CONTINUE
            END IF
        END IF
C
C Write Y labels.
C
      IF (YOPTN.OR.YOPTM) THEN
          CALL PGBOX1(YBLC, YTRC, YINT, I1, I2)
          DO 180 I=I1,I2
              YC = (I*YINT-YBLC)/(YTRC-YBLC)
              IF (YOPTL) THEN
                  CALL PGNUMB(1,NINT(I*YINT),YNFORM,CLBL,NC)
              ELSE
                  CALL PGNUMB(I*NV,NP,YNFORM,CLBL,NC)
              END IF
              IF (YOPTV) THEN
                  IF (YOPTN) CALL PGMTXT('LV',YNVDSP,YC,1.0,CLBL(1:NC))
                  IF (YOPTM) CALL PGMTXT('RV',YMVDSP,YC,0.0,CLBL(1:NC))
              ELSE
                  IF (YOPTN) CALL PGMTXT('L',YNDSP,YC,0.5,CLBL(1:NC))
                  IF (YOPTM) CALL PGMTXT('R',YMDSP,YC,0.5,CLBL(1:NC))
              END IF
  180     CONTINUE
      END IF
C
C Extra Y labels for log axes.
C
      IF (YOPTLS) THEN
          CALL PGBOX1(YBLC, YTRC, YINT2, I1, I2)
          DO 402 I=I1-1,I2
            DO 302 J=2,5,3
                YVAL = (I+UTAB(J))*YINT2
                YC = (YVAL-YBLC)/(YTRC-YBLC)
                KI = I
                IF (YBLC.GT.YTRC) KI = KI+1
                IF (IRANGE(YBLC,YVAL,YTRC)) THEN
                    CALL PGNUMB(J,NINT(KI*YINT2),YNFORM,CLBL,NC)
                    IF (YOPTV) THEN
                    IF (YOPTN) 
     1                CALL PGMTXT('LV', YNVDSP, YC, 1.0, CLBL(1:NC))
                    IF (YOPTM) 
     1                CALL PGMTXT('RV', YMVDSP, YC, 0.0, CLBL(1:NC))
                    ELSE
                    IF (YOPTN) 
     1                CALL PGMTXT('L', YNDSP, YC, 0.5, CLBL(1:NC))
                    IF (YOPTM) 
     1                CALL PGMTXT('R', YMDSP, YC, 0.5, CLBL(1:NC))
                    END IF
                END IF
  302       CONTINUE
  402     CONTINUE
      END IF
C
C Enable clipping.
C
      CALL PGSCLP(CLIP)
C
      CALL PGEBUF
      END

C*PGCURS -- read cursor position
C%int cpgcurs(float *x, float *y, char *ch_scalar);
C+
      INTEGER FUNCTION PGCURS (X, Y, CH)
      REAL X, Y
      CHARACTER*(*) CH
C
C Read the cursor position and a character typed by the user.
C The position is returned in world coordinates.  PGCURS positions
C the cursor at the position specified, allows the user to move the
C cursor using the joystick or arrow keys or whatever is available on
C the device. When he has positioned the cursor, the user types a
C single character on the keyboard; PGCURS then returns this
C character and the new cursor position (in world coordinates).
C
C Returns:
C  PGCURS         : 1 if the call was successful; 0 if the device
C                    has no cursor or some other error occurs.
C Arguments:
C  X      (in/out) : the world x-coordinate of the cursor.
C  Y      (in/out) : the world y-coordinate of the cursor.
C  CH     (output) : the character typed by the user; if the device has
C                    no cursor or if some other error occurs, the value
C                    CHAR(0) [ASCII NUL character] is returned.
C
C Note: The cursor coordinates (X,Y) may be changed by PGCURS even if
C the device has no cursor or if the user does not move the cursor.
C Under these circumstances, the position returned in (X,Y) is that of
C the pixel nearest to the requested position.
C--
C  7-Sep-1994 - changed to use PGBAND [TJP].
C-----------------------------------------------------------------------
      INTEGER PGBAND
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGCURS')) THEN
         CH = CHAR(0)
         PGCURS = 0
      ELSE
         PGCURS = PGBAND(0, 1, 0.0, 0.0, X, Y, CH)
      END IF
      END

      PROGRAM PGDE14
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT: text input with PGRSTR.
C
C This program illustrates how an interactive program can be written
C using PGPLOT. The program displays a number of active fields. Select
C one of these fields using the cursor (e.g., click the mouse) to 
C activate it; then use the keyboard keys to edit the string displayed
C in the field. Two of the fields have immediate action: 'DRAW' draws
C a simple picture using the parameters specified in the input fields;
C 'EXIT' terminates the program.
C
C A version of the subroutine used here, PGRSTR, may be included in a
C future release of the PGPLOT library.
C-----------------------------------------------------------------------
      INTEGER NBOX
      PARAMETER (NBOX=5)
      REAL BOX(4,NBOX), X, Y, XX, YY, A, D, XV(100), YV(100)
      INTEGER IVAL(NBOX)
      INTEGER PGOPEN, LSTR, I, JUNK, PGCURS, J, NV, BC, FC, CTOI
      INTEGER II, JJ
      CHARACTER CH
      CHARACTER*30 LABEL(NBOX), VALUE(NBOX), RESULT(NBOX)
C
      DATA BOX /0.44, 0.8, 0.79, 0.83,
     :          0.44, 0.8, 0.69, 0.73,
     :          0.44, 0.8, 0.59, 0.63,
     :          0.44, 0.7, 0.29, 0.33,
     :          0.44, 0.7, 0.19, 0.23/

      DATA LABEL /'Number of vertices:',
     :            'Background Color:',
     :            'Foreground Color:',
     :            ' ',
     :            ' '/
      DATA VALUE /'13',
     :            '0',
     :            '1',
     :            'DRAW', 
     :            'EXIT'/
C-----------------------------------------------------------------------
      WRITE (*,*) 'This program requires an interactive device.'
      WRITE (*,*) 'It presents a menu with editable fields which can be'
      WRITE (*,*) 'used to set parameters controlling a graph displayed'
      WRITE (*,*) 'beside the menu. To edit a field, first select it'
      WRITE (*,*) 'with the cursor (e.g., click mouse button) then use'
      WRITE (*,*) 'keyboard keys and DEL or ^U. TAB or CR terminates'
      WRITE (*,*) 'editing Click on DRAW to display the graph or EXIT'
      WRITE (*,*) 'to terminate the program.'
      WRITE (*,*)
C
C Open device for graphics.
C
      IF (PGOPEN('?') .LE. 0) STOP
      CALL PGPAP(10.0,0.5)
      IVAL(1) = 13
      IVAL(2) = 0
      IVAL(3) = 1
C
C Clear the screen. Draw a frame at the physical extremities of the
C plot, using full-screen viewport and standard window.
C
      CALL PGPAGE
      CALL PGSVP(0.0,1.0,0.0,1.0)
      CALL PGSWIN(0.0,2.0,0.0,1.0)
      CALL PGSCR(0, 0.4, 0.4, 0.4)
C
C Display fields
C
 5    WRITE(VALUE(1), '(I6)') IVAL(1)
      WRITE(VALUE(2), '(I6)') IVAL(2)
      WRITE(VALUE(3), '(I6)') IVAL(3)
      CALL PGSAVE
      CALL PGBBUF
      CALL PGERAS
      CALL PGSCI(1)
      CALL PGSLW(1)
      CALL PGSFS(1)
      CALL PGSCH(1.2)
      DO 10 I=1,NBOX
         RESULT(I) = VALUE(I)
         X = BOX(1,I) - 0.04
         Y = BOX(3,I) + 0.01
         CALL PGSCI(1)
         CALL PGPTXT(X, Y, 0.0, 1.0, LABEL(I))
         CALL PGRECT(BOX(1,I), BOX(2,I), BOX(3,I), BOX(4,I))
         X = BOX(1,I) + 0.01
         CALL PGSCI(2)
         CALL PGPTXT(X, Y, 0.0, 0.0, VALUE(I))
 10   CONTINUE
C
C Draw picture
C
      NV = MIN(100,IVAL(1))
      BC = IVAL(2)
      FC = IVAL(3)
      CALL PGSCI(BC)
      CALL PGSFS(1)
      CALL PGRECT(1.05,1.95,0.05,0.95)
      CALL PGSCI(FC)
      CALL PGSFS(2)
      CALL PGRECT(1.05,1.95,0.05,0.95)
      IF (NV.GT.3) THEN
         D = 360.0/NV
         A = -D
         DO 120 II=1,NV
            A = A+D
            XV(II) = 1.5 + 0.4*COS(A/57.29577951)
            YV(II) = 0.5 + 0.4*SIN(A/57.29577951)
 120     CONTINUE
C     
         DO 140 II=1,NV-1
            DO 130 JJ=II+1,NV
               CALL PGMOVE(XV(II),YV(II))
               CALL PGDRAW(XV(JJ),YV(JJ))
 130        CONTINUE
 140     CONTINUE
      END IF
      CALL PGEBUF
      CALL PGUNSA
C
C Cursor loop: user selects a box
C
      CALL PGSLW(2)
      CALL PGSFS(2)
      XX = 0.5
      YY = 0.5
      DO 60 J=1,1000
         JUNK = PGCURS(XX, YY, CH)
         IF (ICHAR(CH).EQ.0) GOTO 50
C
C Find which box and highlight it
C
         DO 30 I=1,NBOX
            IF (BOX(1,I).LE.XX .AND. BOX(2,I).GE.XX .AND.
     :          BOX(3,I).LE.YY .AND. BOX(4,I).GE.YY) THEN
               CALL PGSCI(2)
               CALL PGSLW(2)
               CALL PGSCH(1.2)
               CALL PGRECT(BOX(1,I), BOX(2,I), BOX(3,I), BOX(4,I))
               CALL PGSLW(1)
               IF (I.EQ.5) THEN
C                 -- EXIT box
                  GOTO 50
               ELSE IF (I.EQ.4) THEN
C                 -- DRAW box
                  GOTO 5
               ELSE
C
C Read value
C   
                  IF (RESULT(I).EQ.' ') THEN
                     LSTR = 0
                  ELSE
                     DO 11 II=LEN(RESULT(I)),1,-1
                        LSTR = II
                        IF (RESULT(I)(II:II).NE.' ') GOTO 12
 11                  CONTINUE
                     LSTR = 0
 12                  CONTINUE
                  END IF
                  X = BOX(1,I) + 0.01
                  Y = BOX(3,I) + 0.01
                  CALL PGRSTR(X, Y, 0.0, 0.0, RESULT(I), LSTR, 1)
                  II = 1
                  IVAL(I) = CTOI(RESULT(I)(1:LSTR), II)
               END IF
               CALL PGSLW(2)
               CALL PGSCI(1)
               CALL PGRECT(BOX(1,I), BOX(2,I), BOX(3,I), BOX(4,I))
               CALL PGSLW(1)
            END IF 
 30      CONTINUE
 60   CONTINUE
C
C Close the device and exit.
C
 50   CONTINUE
      CALL PGCLOS
      END


      SUBROUTINE PGRSTR(X, Y, ANGLE, FJUST, TEXT, LSTR, BCI)
      REAL X, Y, ANGLE, FJUST
      CHARACTER*(*) TEXT
      INTEGER LSTR, BCI
C-----------------------------------------------------------------------
      CHARACTER CH
      INTEGER JUNK, PGBAND, CI
      REAL XCUR, YCUR, XBOX(4), YBOX(4)
C
      CALL PGQCI(CI)
C
 10   CONTINUE
C     -- Draw current string
          IF (LSTR.GT.0) THEN
             CALL PGPTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR))
             CALL PGQTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR), XBOX, YBOX)
             XCUR = XBOX(4)
             YCUR = YBOX(4)
          ELSE
             XCUR = X
             YCUR = Y
          END IF
C         -- Read a character
          JUNK = PGBAND(0, 1, XCUR, YCUR, XCUR, YCUR, CH)
C         -- Erase old string
          CALL PGSCI(BCI)
          IF (LSTR.GT.0) 
     :         CALL PGPTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR))
          CALL PGSCI(CI)
C         -- Avoid problem with PGPLOT escape character
          IF (CH.EQ.CHAR(92)) CH = '*'
C         -- Backspace (ctrl H) or delete removes last character
          IF (ICHAR(CH).EQ.8 .OR. ICHAR(CH).EQ.127) THEN
             IF (LSTR.GT.0) TEXT(LSTR:LSTR) = ' '
             IF (LSTR.GT.0) LSTR = LSTR-1
C         -- Ctrl U removes entire string
          ELSE IF (ICHAR(CH).EQ.21) THEN
             TEXT(1:LSTR) = ' '
             LSTR = 0
C         -- Any other non-printing character terminates input
          ELSE IF (ICHAR(CH).LT.32) THEN
             IF (LSTR.GT.0)
     :            CALL PGPTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR))
             GOTO 20
C         -- Otherwise, add character to string if there is room
          ELSE IF (LSTR.LT.LEN(TEXT)) THEN
             LSTR = LSTR+1
             TEXT(LSTR:LSTR) = CH
          END IF
      GOTO 10
C
 20   RETURN
      END

      INTEGER FUNCTION CTOI (S, I)
      CHARACTER*(*) S
      INTEGER I
C
C Attempt to read an integer from a character string, and return
C the result. No attempt is made to avoid integer overflow. A valid 
C integer is any sequence of decimal digits.
C
C Returns:
C  CTOI            : the value of the integer; if the first character
C                    read is not a decimal digit, the value returned
C                    is zero.
C Arguments:
C  S      (input)  : character string to be parsed.
C  I      (in/out) : on input, I is the index of the first character
C                    in S to be examined; on output, either it points
C                    to the next character after a valid integer, or
C                    it is equal to LEN(S)+1.
C-----------------------------------------------------------------------
      INTEGER K
      CHARACTER*1 DIGITS(0:9)
      DATA  DIGITS/'0','1','2','3','4','5','6','7','8','9'/
C
      CTOI = 0
   10 IF (I.GT.LEN(S)) RETURN
      IF (S(I:I).EQ.' ') THEN
         I = I+1
         GOTO 10
      END IF
      DO 20 K=0,9
          IF (S(I:I).EQ.DIGITS(K)) GOTO 30
   20 CONTINUE
      RETURN
   30 CTOI = CTOI*10 + K
      I = I+1
      GOTO 10
      END

C*GROPTX -- open input/output text file [Unix]
C+
      INTEGER FUNCTION GROPTX (UNIT, NAME, DEFNAM, MODE)
      INTEGER UNIT, MODE
      CHARACTER*(*) NAME, DEFNAM
C
C Input:
C  UNIT : Fortran unit number to use
C  NAME : name of file to create
C  DEFNAM : default file name (used to fill in missing fields for VMS)
C  MODE : 0 to open for reading, 1 to open for writing.
C
C Returns:
C  0 => success; any other value => error.
C-----------------------------------------------------------------------
      INTEGER IER
      IF (MODE.EQ.1) THEN
          OPEN (UNIT=UNIT, FILE=NAME, STATUS='UNKNOWN', IOSTAT=IER)
      ELSE
          OPEN (UNIT=UNIT, FILE=NAME, STATUS='OLD', IOSTAT=IER)
      END IF
      GROPTX = IER
C-----------------------------------------------------------------------
      END

C*PGERR1 -- horizontal or vertical error bar
C%void cpgerr1(int dir, float x, float y, float e, float t);
C+
      SUBROUTINE PGERR1 (DIR, X, Y, E, T)
      INTEGER DIR
      REAL X, Y, E
      REAL T
C
C Plot a single error bar in the direction specified by DIR.
C This routine draws an error bar only; to mark the data point at
C the start of the error bar, an additional call to PGPT is required.
C To plot many error bars, use PGERRB.
C
C Arguments:
C  DIR    (input)  : direction to plot the error bar relative to
C                    the data point. 
C                    One-sided error bar:
C                      DIR is 1 for +X (X to X+E);
C                             2 for +Y (Y to Y+E);
C                             3 for -X (X to X-E);
C                             4 for -Y (Y to Y-E).
C                    Two-sided error bar:
C                      DIR is 5 for +/-X (X-E to X+E); 
C                             6 for +/-Y (Y-E to Y+E).
C  X      (input)  : world x-coordinate of the data.
C  Y      (input)  : world y-coordinate of the data.
C  E      (input)  : value of error bar distance to be added to the
C                    data position in world coordinates.
C  T      (input)  : length of terminals to be drawn at the ends
C                    of the error bar, as a multiple of the default
C                    length; if T = 0.0, no terminals will be drawn.
C--
C 31-Mar-1997 - new routine [TJP].
C-----------------------------------------------------------------------
      LOGICAL  PGNOTO
      REAL     XTIK, YTIK, XX, YY
C
      IF (PGNOTO('PGERR1')) RETURN
      IF (DIR.LT.1 .OR. DIR.GT.6) RETURN
      CALL PGBBUF
C
C Determine terminal length.
C
      CALL PGTIKL(T, XTIK, YTIK)
C
C Draw terminal at starting point if required.
C
      IF (DIR.EQ.5) THEN
         XX = X-E
         YY = Y
      ELSE IF (DIR.EQ.6) THEN
         XX = X
         YY = Y-E
      ELSE
         XX = X
         YY = Y
      END IF
      IF (T.NE.0.0) THEN
         IF (DIR.EQ.5) THEN
            CALL GRMOVA(XX,YY-YTIK)
            CALL GRLINA(XX,YY+YTIK)
         ELSE IF (DIR.EQ.6) THEN
            CALL GRMOVA(XX-XTIK,YY)
            CALL GRLINA(XX+XTIK,YY)
         END IF
      END IF
C
C Draw the error bar itself.
C
      CALL GRMOVA(XX,YY)
      IF (DIR.EQ.1 .OR. DIR.EQ.5) THEN
         XX = X+E
         YY = Y
      ELSE IF (DIR.EQ.2 .OR. DIR.EQ.6) THEN
         XX = X
         YY = Y+E
      ELSE IF (DIR.EQ.3) THEN
         XX = X-E
         YY = Y
      ELSE IF (DIR.EQ.4) THEN
         XX = X
         YY = Y-E
      END IF
      CALL GRLINA(XX,YY)
C
C Draw terminal at end point.
C
      IF (T.NE.0.0) THEN
         IF (MOD(DIR,2).EQ.1) THEN
            CALL GRMOVA(XX,YY-YTIK)
            CALL GRLINA(XX,YY+YTIK)
         ELSE
            CALL GRMOVA(XX-XTIK,YY)
            CALL GRLINA(XX+XTIK,YY)
         END IF
      END IF
C
      CALL PGEBUF
      END

C*GRLGTR -- translate logical name (dummy version)
C+
      SUBROUTINE GRLGTR (NAME)
      CHARACTER*(*) NAME
C
C Recursive translation of a logical name.
C This is used in the parsing of device specifications in the
C VMS implementation of PGPLOT. In other implementations, it may
C be replaced by a null routine.
C
C Argument:
C  NAME (input/output): initially contains the name to be
C       inspected.  If an equivalence is found it will be replaced
C       with the new name. If not, the old name will be left there.
C--
C 19-Dec-1994
C-----------------------------------------------------------------------
      END

C*PGLABEL -- non-standard alias for PGLAB
C+
      SUBROUTINE PGLABEL (XLBL, YLBL, TOPLBL)
      CHARACTER*(*) XLBL, YLBL, TOPLBL
C
C See description of PGLAB.
C--
      CALL PGLAB (XLBL, YLBL, TOPLBL)
      END

      include 'flib.fi'
C*GRDATE -- get date and time as character string (MS-DOS)
C+
      SUBROUTINE GRDATE(CDATE, LDATE)
      include 'flib.fd'
      CHARACTER CDATE*(17)
      INTEGER   LDATE
C
C Return the current date and time, in format 'dd-Mmm-yyyy hh:mm'.
C To receive the whole string, the CDATE should be declared
C CHARACTER*17.
C
C Arguments:
C  CDATE : receives date and time, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in STRING, excluding
C           trailing blanks. This will always be 17, unless the length
C           of the string supplied is shorter.
C--
C 1989-Mar-17 - [AFT]
C 12/1993 C. T. Dum MS Power Station F32 Version
C-----------------------------------------------------------------------
      CHARACTER CMON(12)*3
      INTEGER*2 IHR, IMIN, ISEC, I100TH
      INTEGER*2 IYR, IMON, IDAY
      DATA CMON/'Jan','Feb','Mar','Apr','May','Jun',
     :          'Jul','Aug','Sep','Oct','Nov','Dec'/
C---
      CALL GETTIM(IHR, IMIN, ISEC, I100TH)
      CALL GETDAT(IYR, IMON, IDAY)
      WRITE(CDATE,111) IDAY,CMON(IMON),IYR,IHR,IMIN
  111 FORMAT(I2,'-',A3,'-',I4,' ',I2,':',I2)
      LDATE=17
      RETURN
      END

C*GRFLUN -- free a Fortran logical unit number (MS-DOS)
C+
      SUBROUTINE GRFLUN(LUN)
      INTEGER LUN
C
C Free a Fortran logical unit number allocated by GRGLUN. [This version
C is pretty stupid; GRGLUN allocates units starting at 81, and GRFLUN
C does not free units.]
C
C Arguments:
C  LUN    : the logical unit number to free.
C--
C 25-Nov-1988
C-----------------------------------------------------------------------
      RETURN
      END
C*GRGCOM -- read with prompt from user's terminal (MS-DOS)
C+
      INTEGER FUNCTION GRGCOM(CREAD, CPROM, LREAD)
      CHARACTER CREAD*(*), CPROM*(*)
      INTEGER   LREAD
C
C Issue prompt and read a line from the user's terminal; in VMS,
C this is equivalent to LIB$GET_COMMAND.
C
C Arguments:
C  CREAD : (output) receives the string read from the terminal.
C  CPROM : (input) prompt string.
C  LREAD : (output) length of CREAD.
C
C Returns:
C  GRGCOM : 1 if successful, 0 if an error occurs (e.g., end of file).
C--
C 1989-Mar-29
ctd 3/95:len_trim (MS Fortran)
C-----------------------------------------------------------------------
      INTEGER IER
C---
   11 FORMAT(A)
C---
      GRGCOM = 0
      LREAD = 0
      WRITE (*, 101, IOSTAT=IER) CPROM
  101 FORMAT(1X,A,\)
      IF (IER.EQ.0) READ (*, 11, IOSTAT=IER) CREAD
      IF (IER.EQ.0) GRGCOM = 1
      LREAD = LEN_TRIM(CREAD)
      RETURN
      END
C*GRGENV -- get value of PGPLOT environment parameter (MS-DOS)
C+
      SUBROUTINE GRGENV(CNAME, CVALUE, LVALUE)
      include 'flib.fd'
      CHARACTER CNAME*(*), CVALUE*(*)
      INTEGER   LVALUE
C
C Return the value of a PGPLOT environment parameter.
C
C Arguments:
C CNAME   : (input) the name of the parameter to evaluate.
C CVALUE  : receives the value of the parameter, truncated or extended
C           with blanks as necessary. If the parameter is undefined,
C           a blank string is returned.
C LVALUE  : receives the number of characters in CVALUE, excluding
C           trailing blanks. If the parameter is undefined, zero is
C           returned.
C--
C 1990-Mar-19 - [AFT]
C 12/93;3/95 CTD F32
C-----------------------------------------------------------------------
C
      CHARACTER*80 CTMP,CTEMP
      INTEGER LTMP
      CTMP = 'PGPLOT_'//CNAME
      LTMP = INDEX(CTMP,' ')
      LVALUE=GETENVQQ(CTMP(:LTMP-1),CTEMP)
      IF(LVALUE.NE.0)THEN
       CVALUE = CTEMP(:LVALUE)
      ELSE
       CVALUE = ' '
      ENDIF
      RETURN
      END
C*GRGLUN -- get a Fortran logical unit number (MS-DOS)
C+
      SUBROUTINE GRGLUN(LUN)
      INTEGER LUN
C
C Get an unused Fortran logical unit number.
C Returns a Logical Unit Number that is not currently opened.
C After GRGLUN is called, the unit should be opened to reserve
C the unit number for future calls.  Once a unit is closed, it
C becomes free and another call to GRGLUN could return the same
C number.  Also, GRGLUN will not return a number in the range 1-9
C as older software will often use these units without warning.
C
C Arguments:
C  LUN    : receives the logical unit number, or -1 on error.
C--
C 12-Feb-1989 [AFT/TJP].
C-----------------------------------------------------------------------
      INTEGER I
      LOGICAL QOPEN
C---
      DO 10 I=99,10,-1
          INQUIRE (UNIT=I,  OPENED=QOPEN)
          IF (.NOT.QOPEN) THEN
              LUN = I
              RETURN
          END IF
   10 CONTINUE
      CALL GRWARN('GRGLUN: out of units.')
      LUN = -1
      RETURN
      END
C*GRLGTR -- translate logical name (MS-DOS)
C+
      SUBROUTINE GRLGTR (CNAME)
      CHARACTER CNAME*(*)
C
C Recursive translation of a logical name.
C Up to 20 levels of equivalencing can be handled.
C This is used in the parsing of device specifications in the
C VMS implementation of PGPLOT. In other implementations, it may
C be replaced by a null routine.
C
C Argument:
C  CNAME (input/output): initially contains the name to be
C       inspected.  If an equivalence is found it will be replaced
C       with the new name. If not, the old name will be left there. The
C       escape sequence at the beginning of process-permanent file
C       names is deleted and the '_' character at the beginning of
C       device names is left in place.
C--
C 18-Feb-1988
C-----------------------------------------------------------------------
      RETURN
      END

C*GROPTX -- open output text file [MS-DOS]
C+
      INTEGER FUNCTION GROPTX (UNIT, NAME, DEFNAM, MODE)
      INTEGER UNIT,MODE
      CHARACTER*(*) NAME,DEFNAM
C
C Input:
C  UNIT : Fortran unit number to use
C  NAME : name of file to create
C  DEFNAM : default file name (used to fill in missing fields for VMS)
C
C Returns:
C  0 => success; any other value => error.
C-----------------------------------------------------------------------
      INTEGER IER
      OPEN (UNIT=UNIT, FILE=NAME, STATUS='UNKNOWN', IOSTAT=IER)
      GROPTX = IER
      RETURN 
C-----------------------------------------------------------------------
      END
C*GRTRML -- get name of user's terminal (MS-DOS)
C+
      SUBROUTINE GRTRML(CTERM, LTERM)
      CHARACTER CTERM*(*)
      INTEGER   LTERM
C
C Return the device name of the user's terminal, if any.
C
C Arguments:
C  CTERM : receives the terminal name, truncated or extended with
C           blanks as necessary.
C  LTERM : receives the number of characters in CTERM, excluding
C           trailing blanks. If there is not attached terminal,
C           zero is returned.
C--
C 1989-Nov-08
C-----------------------------------------------------------------------
      CTERM = 'CON'
      LTERM = 3
      RETURN
      END
C*GRTTER -- test whether device is user's terminal (MS-DOS)
C+
      SUBROUTINE GRTTER(CDEV, QSAME)
      CHARACTER CDEV*(*)
      LOGICAL   QSAME
C
C Return a logical flag indicating whether the supplied device
C name is a name for the user's controlling terminal or not.
C (Some PGPLOT programs wish to take special action if they are
C plotting on the user's terminal.)
C
C Arguments:
C  CDEV : (input) the device name to be tested.
C  QSAME   : (output) .TRUE. is CDEV contains a valid name for the
C           user's terminal; .FALSE. otherwise.
C--
C 18-Feb-1988
C-----------------------------------------------------------------------
      CHARACTER CTERM*64
      INTEGER   LTERM
C
      CALL GRTRML(CTERM, LTERM)
      QSAME = (CDEV.EQ.CTERM(:LTERM))
      RETURN
      END

C*GRUSER -- get user name (MS-DOS)
C+
      SUBROUTINE GRUSER(CUSER, LUSER)
      CHARACTER CUSER*(*)
      INTEGER   LUSER
C
C Return the name of the user running the program.
C
C Arguments:
C  CUSER  : receives user name, truncated or extended with
C           blanks as necessary.
C  LUSER  : receives the number of characters in VALUE, excluding
C           trailing blanks.
C--
C 1989-Mar-19 - [AFT]
C-----------------------------------------------------------------------
C
      CALL GRGENV('USER', CUSER, LUSER)
      RETURN
      END

C*GRSLS -- set line style
C+
      SUBROUTINE GRSLS (IS)
      INTEGER IS
C
C GRPCKG: Set the line style for subsequent plotting on the current
C device. The different line styles are generated in hardware on
C some devices and by GRPCKG software for the other devices. Five
C different line styles are available, with the following codes:
C 1 (full line), 2 (dashed), 3 (dot-dash-dot-dash), 4 (dotted),
C 5 (dash-dot-dot-dot). The default is 1 (normal full line). Line
C style is ignored when drawing characters, which are always drawn with
C a full line.
C
C Argument:
C
C IS (input, integer): the line-style code for subsequent plotting on
C       the current device (in range 1-5).
C--
C  9-Feb-1983 - [TJP].
C  3-Jun-1984 - add GMFILE device [TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 21-Feb-1987 - If needed, calls begin picture [AFT].
C 19-Jan-1987 - fix bug in GREXEC call [TJP].
C 16-May-1989 - fix bug for hardware line dash [TJP].
C  1-Sep-1994 - do not call driver to get size and capabilities [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER I, L, IDASH, NBUF,LCHR
      REAL    RBUF(6),TMP
      CHARACTER*10 CHR
      REAL PATERN(8,5)
C
      DATA PATERN/ 8*10.0,
     1             8*10.0,
     2             8.0, 6.0, 1.0, 6.0, 8.0, 6.0, 1.0, 6.0,
     3             1.0, 6.0, 1.0, 6.0, 1.0, 6.0, 1.0, 6.0,
     4             8.0, 6.0, 1.0, 6.0, 1.0, 6.0, 1.0, 6.0 /
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRSLS - no graphics device is active.')
          RETURN
      END IF
C
      I = IS
      IF (I.LT.1 .OR. I.GT.5) THEN
          CALL GRWARN('GRSLS - invalid line-style requested.')
          I = 1
      END IF
C
C Inquire if hardware dash is available.
C
      IDASH=0
      IF(GRGCAP(GRCIDE)(3:3).EQ.'D') IDASH=1
C
C Set up for hardware dash.
C
      IF(IDASH.NE.0) THEN
          GRDASH(GRCIDE) = .FALSE.
          IF (GRPLTD(GRCIDE)) THEN
              RBUF(1)=I
              NBUF=1
              CALL GREXEC(GRGTYP,19,RBUF,NBUF,CHR,LCHR)
          END IF
C
C Set up for software dash.
C
      ELSE
          IF (I.EQ.1) THEN
              GRDASH(GRCIDE) = .FALSE.
          ELSE
              GRDASH(GRCIDE) = .TRUE.
              GRIPAT(GRCIDE) = 1
              GRPOFF(GRCIDE) = 0.0
              TMP = GRYMXA(GRCIDE)/1000.
              DO 10 L=1,8
                  GRPATN(GRCIDE,L) = PATERN(L,I)*TMP
   10         CONTINUE
          END IF
      END IF
      GRSTYL(GRCIDE) = I
      END

C*GRFLUN -- free a Fortran logical unit number (MS-DOS)
C+
      SUBROUTINE GRFLUN(LUN)
      INTEGER LUN
C
C Free a Fortran logical unit number allocated by GRGLUN. [This version
C is pretty stupid; GRGLUN allocates units starting at 81, and GRFLUN
C does not free units.]
C
C Arguments:
C  LUN    : the logical unit number to free.
C--
C 25-Nov-1988
C-----------------------------------------------------------------------
      RETURN
      END

C*GRSETPEN -- *obsolete routine*
C+
      SUBROUTINE GRSETPEN
C
C GRPCKG: Set the pen number for subsequent plotting.  Obsolete
C routine: ignored.
C-----------------------------------------------------------------------
      CALL GRWARN('GRSETPEN is an obsolete routine.')
      END

C*PGOPEN -- open a graphics device
C%int cpgopen(const char *device);
C+
      INTEGER FUNCTION PGOPEN (DEVICE)
      CHARACTER*(*) DEVICE
C
C Open a graphics device for PGPLOT output. If the device is
C opened successfully, it becomes the selected device to which
C graphics output is directed until another device is selected
C with PGSLCT or the device is closed with PGCLOS.
C
C The value returned by PGOPEN should be tested to ensure that
C the device was opened successfully, e.g.,
C
C       ISTAT = PGOPEN('plot.ps/PS')
C       IF (ISTAT .LE. 0 ) STOP
C
C Note that PGOPEN must be declared INTEGER in the calling program.
C
C The DEVICE argument is a character constant or variable; its value
C should be one of the following:
C
C (1) A complete device specification of the form 'device/type' or
C     'file/type', where 'type' is one of the allowed PGPLOT device
C     types (installation-dependent) and 'device' or 'file' is the 
C     name of a graphics device or disk file appropriate for this type.
C     The 'device' or 'file' may contain '/' characters; the final
C     '/' delimits the 'type'. If necessary to avoid ambiguity,
C     the 'device' part of the string may be enclosed in double
C     quotation marks.
C (2) A device specification of the form '/type', where 'type' is one
C     of the allowed PGPLOT device types. PGPLOT supplies a default
C     file or device name appropriate for this device type.
C (3) A device specification with '/type' omitted; in this case
C     the type is taken from the environment variable PGPLOT_TYPE,
C     if defined (e.g., setenv PGPLOT_TYPE PS). Because of possible
C     confusion with '/' in file-names, omitting the device type
C     in this way is not recommended.
C (4) A blank string (' '); in this case, PGOPEN will use the value
C     of environment variable PGPLOT_DEV as the device specification,
C     or '/NULL' if the environment variable is undefined.
C (5) A single question mark, with optional trailing spaces ('?'); in
C     this case, PGPLOT will prompt the user to supply the device
C     specification, with a prompt string of the form
C         'Graphics device/type (? to see list, default XXX):'
C     where 'XXX' is the default (value of environment variable
C     PGPLOT_DEV).
C (6) A non-blank string in which the first character is a question
C     mark (e.g., '?Device: '); in this case, PGPLOT will prompt the
C     user to supply the device specification, using the supplied
C     string as the prompt (without the leading question mark but
C     including any trailing spaces).
C
C In cases (5) and (6), the device specification is read from the
C standard input. The user should respond to the prompt with a device
C specification of the form (1), (2), or (3). If the user types a 
C question-mark in response to the prompt, a list of available device
C types is displayed and the prompt is re-issued. If the user supplies
C an invalid device specification, the prompt is re-issued. If the user
C responds with an end-of-file character, e.g., ctrl-D in UNIX, program
C execution is aborted; this  avoids the possibility of an infinite
C prompting loop.  A programmer should avoid use of PGPLOT-prompting
C if this behavior is not desirable.
C
C The device type is case-insensitive (e.g., '/ps' and '/PS' are 
C equivalent). The device or file name may be case-sensitive in some
C operating systems.
C
C Examples of valid DEVICE arguments:
C
C (1)  'plot.ps/ps', 'dir/plot.ps/ps', '"dir/plot.ps"/ps', 
C      'user:[tjp.plots]plot.ps/PS'
C (2)  '/ps'      (PGPLOT interprets this as 'pgplot.ps/ps')
C (3)  'plot.ps'  (if PGPLOT_TYPE is defined as 'ps', PGPLOT
C                  interprets this as 'plot.ps/ps')
C (4)  '   '      (if PGPLOT_DEV is defined)
C (5)  '?  '
C (6)  '?Device specification for PGPLOT: '
C
C [This routine was added to PGPLOT in Version 5.1.0. Older programs
C use PGBEG instead.]
C
C Returns:
C  PGOPEN          : returns either a positive value, the
C                    identifier of the graphics device for use with
C                    PGSLCT, or a 0 or negative value indicating an
C                    error. In the event of error a message is
C                    written on the standard error unit.
C Arguments:
C  DEVICE  (input) : the 'device specification' for the plot device
C                    (see above).
C--
C 22-Dec-1995 - new routine [TJP].
C 14-May-1996 - device '? ' should not give a blank prompt [TJP].
C-----------------------------------------------------------------------
      INCLUDE       'pgplot.inc'
      INTEGER       DEFTYP,GRDTYP,GROPEN,L,LR,IC1, LPROMP
      INTEGER       GRGCOM, IER, LDEFDE, UNIT, ISTAT
      REAL          DUMMY,DUMMY2,XCSZ, XSZ, YSZ
      CHARACTER*128 DEFDEV, PROMPT
      CHARACTER*20  DEFSTR
      CHARACTER*256 REQ
      LOGICAL JUNK
C
C Initialize PGPLOT if necessary.
C
      CALL PGINIT
C
C Get the default device/type (environment variable PGPLOT_DEV).
C
      CALL GRGENV('DEV', DEFDEV, LDEFDE)
      IF (LDEFDE.EQ.0) THEN
         DEFDEV = '/NULL'
         LDEFDE = 5
      END IF
C
C Open the plot file; default type is given by environment variable
C PGPLOT_TYPE.
C
      CALL GRGENV('TYPE', DEFSTR, L)
      IF (L.EQ.0) THEN
          DEFTYP = 0
      ELSE
          CALL GRTOUP(DEFSTR, DEFSTR)
          DEFTYP = GRDTYP(DEFSTR(1:L))
      END IF
      IF (DEVICE.EQ.' ') THEN
C        -- Blank device string: use default device and type.
         ISTAT = GROPEN(DEFTYP,UNIT,DEFDEV(1:LDEFDE),PGID)
      ELSE IF (DEVICE(1:1).EQ.'?') THEN
         IF (DEVICE.EQ.'?') THEN
C           -- Device string is a ingle question mark: prompt user
C           -- for device/type
            PROMPT = 'Graphics device/type (? to see list, default '
     :           //DEFDEV(1:LDEFDE)//'): '
            LPROMP = LDEFDE + 48
         ELSE
C           -- Device string starts with a question mark: use it
C           -- as a prompt
            PROMPT = DEVICE(2:)
            LPROMP = LEN(DEVICE)-1
         END IF
   10    IER = GRGCOM(REQ, PROMPT(1:LPROMP), LR)
         IF (IER.NE.1) THEN
            CALL GRWARN('Error reading device specification')
            PGOPEN = -1
            RETURN
         END IF
         IF (LR.LT.1 .OR. REQ.EQ.' ') THEN
            REQ = DEFDEV(1:LDEFDE)
         ELSE IF (REQ(1:1).EQ.'?') THEN
            CALL PGLDEV
            GOTO 10
         END IF
         ISTAT = GROPEN(DEFTYP,UNIT,REQ,PGID)
         IF (ISTAT.NE.1) GOTO 10
      ELSE
          ISTAT = GROPEN(DEFTYP,UNIT,DEVICE,PGID)
      END IF
C
C Failed to open plot file?
C
      IF (ISTAT.NE.1) THEN
         PGOPEN = - 1
         RETURN
      END IF
C
C Success: determine device characteristics.
C
      IF (PGID.LT.0 .OR. PGID.GT.PGMAXD) CALL
     1       GRWARN('Something terribly wrong in PGOPEN')
      PGDEVS(PGID) = 1
      PGADVS(PGID) = 0
      PGPFIX(PGID) = .FALSE.
      CALL GRSIZE(PGID,XSZ,YSZ,DUMMY,DUMMY2,
     1            PGXPIN(PGID),PGYPIN(PGID))
      CALL GRCHSZ(PGID,XCSZ,DUMMY,PGXSP(PGID),PGYSP(PGID))
      PGROWS(PGID)= .TRUE.
      PGNX(PGID)  = 1
      PGNY(PGID)  = 1
      PGXSZ(PGID) = XSZ
      PGYSZ(PGID) = YSZ
      PGNXC(PGID) = 1
      PGNYC(PGID) = 1
      CALL GRQTYP(DEFSTR,JUNK)
C
C Set the prompt state to ON, so that terminal devices pause between
C pages; this can be changed with PGASK.
C
      CALL PGASK(.TRUE.)
C
C If environment variable PGPLOT_BUFFER is defined (any value),
C start buffering output.
C
      PGBLEV(PGID) = 0
      CALL GRGENV('BUFFER', DEFSTR, L)
      IF (L.GT.0) CALL PGBBUF
C
C Set background and foreground colors if requested.
C
      CALL GRGENV('BACKGROUND', DEFSTR, L)
      IF (L.GT.0) CALL PGSCRN(0, DEFSTR(1:L), IER)
      CALL GRGENV('FOREGROUND', DEFSTR, L)
      IF (L.GT.0) CALL PGSCRN(1, DEFSTR(1:L), IER)
C
C Set default attributes.
C
      CALL PGSCI(1)
      CALL PGSLS(1)
      CALL PGSLW(1)
      CALL PGSCH(1.0)
      CALL PGSCF(1)
      CALL PGSFS(1)
      CALL PGSAH(1, 45.0, 0.3)
      CALL PGSTBG(-1)
      CALL PGSHS(45.0, 1.0, 0.0)
      CALL PGSCLP(1)
C
C Set the default range of color indices available for images (16 to
C device maximum, if device maximum >= 16; otherwise not possible).
C Select linear transfer function.
C
      CALL GRQCOL(IC1, PGMXCI(PGID))
      PGMNCI(PGID) = 16
      IF (PGMXCI(PGID).LT.16) PGMXCI(PGID) = 0
      PGITF(PGID) = 0
C
C Set the default window (unit square).
C
      PGXBLC(PGID) = 0.0
      PGXTRC(PGID) = 1.0
      PGYBLC(PGID) = 0.0
      PGYTRC(PGID) = 1.0
C
C Set the default viewport.
C
      CALL PGVSTD
C
      PGOPEN = PGID
      RETURN
      END

C*GRGFIL -- find data file -- PC version
C+
      SUBROUTINE GRGFIL(TYPE, NAME)
      CHARACTER*(*) TYPE, NAME
C
C This routine encsapsulates the algorithm for finding the PGPLOT
C run-time data files.
C
C 1. The binary font file: try the following in order:
C     file specified by PGPLOT_FONT
C     file "grfont.dat" in directory specified by PGPLOT_DIR
C                       (with or without '\' appended)
C     file "grfont.dat" in directory C:\PGPLOT\
C
C 2. The color-name database: try the following in order:
C     file specified by PGPLOT_RGB
C     file "rgb.txt" in directory specified by PGPLOT_DIR
C                       (with or without '\' appended)
C     file "rgb.txt" in directory C:\PGPLOT\
C
C Arguments:
C  TYPE (input)  : either 'FONT' or 'RGB' to request the corresponding
C                  file.
C  NAME (output) : receives the file name.
C--
C  2-Dec-1994 - new routine [TJP].
C 30-Apr-1996 - PC version, default C:\PGPLOT\, '\' [PAS]
C-----------------------------------------------------------------------
      CHARACTER*(*) DEFDIR, DEFFNT, DEFRGB
      PARAMETER  (DEFDIR='C:\PGPLOT\')
      PARAMETER  (DEFFNT='grfont.dat')
      PARAMETER  (DEFRGB='rgb.txt')
      CHARACTER*255 FF
      CHARACTER*16 DEFLT
      INTEGER I, L, LD
      LOGICAL TEST, DEBUG
C
C Is debug output requested?
C
      CALL GRGENV('DEBUG', FF, L)
      DEBUG = L.GT.0
C
C Which file?
C
      IF (TYPE.EQ.'FONT') THEN
         DEFLT = DEFFNT
         LD = LEN(DEFFNT)
      ELSE IF (TYPE.EQ.'RGB') THEN
         DEFLT = DEFRGB
         LD = LEN(DEFRGB)
      ELSE
         CALL GRWARN('Internal error in routine GRGFIL')
      END IF
C
C Try each possibility in turn.
C
      DO 10 I=1,4
         IF (I.EQ.1) THEN
            CALL GRGENV(TYPE, FF, L)
         ELSE IF (I.EQ.2) THEN
            CALL GRGENV('DIR', FF, L)
            IF (L.GT.0) THEN
               FF(L+1:) = DEFLT
               L = L+LD
            END IF
         ELSE IF (I.EQ.3) THEN
            CALL GRGENV('DIR', FF, L)
            IF (L.GT.0) THEN
               FF(L+1:L+1) = '\'
               FF(L+2:) = DEFLT
               L = L+1+LD
            END IF
         ELSE IF (I.EQ.4) THEN
            FF = DEFDIR//DEFLT
            L = LEN(DEFDIR)+LD
         END IF
         IF (L.GT.0) THEN
            IF (DEBUG) THEN
               CALL GRWARN('Looking for '//FF(:L))
            END IF
            INQUIRE (FILE=FF(:L), EXIST=TEST)
            IF (TEST) THEN
               NAME = FF(:L)
               RETURN
            ELSE IF (DEBUG) THEN
               CALL GRWARN('WARNING: file not found')
            END IF
         END IF
 10   CONTINUE
C
C Failed to find the file.
C
      NAME = DEFLT
C-----------------------------------------------------------------------
      END

C*PGQITF -- inquire image transfer function
C%void cpgqitf(int *itf);
C+
      SUBROUTINE PGQITF (ITF)
      INTEGER  ITF
C
C Return the Image Transfer Function as set by default or by a previous
C call to PGSITF. The Image Transfer Function is used by routines
C PGIMAG, PGGRAY, and PGWEDG.
C
C Argument:
C  ITF    (output) : type of transfer function (see PGSITF)
C--
C 15-Sep-1994 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGQITF')) THEN
          ITF = 0
      ELSE
          ITF = PGITF(PGID)
      END IF
      END

C*GRQCAP -- inquire device capabilities
C+
      SUBROUTINE GRQCAP (STRING)
      CHARACTER*(*) STRING
C
C GRPCKG: obtain the "device capabilities" string from the device
C driver for the current device.
C
C Arguments:
C
C STRING (output, CHARACTER*(*)): receives the device capabilities
C       string.
C--
C 26-Nov-92: new routine [TJP].
C  1-Sep-94: get from common instead of driver [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRQCAP - no graphics device is active.')
          STRING = 'NNNNNNNNNN'
      ELSE
          STRING = GRGCAP(GRCIDE)
      END IF
C
      END

!C*GIDRIV -- PGPLOT GIF drivers
!C+
      SUBROUTINE GIDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      IMPLICIT NONE
      INTEGER  IFUNC, NBUF, LCHR, MODE
      REAL     RBUF(*)
      CHARACTER*(*) CHR
!
! PGPLOT driver for Graphics Interchange Format (GIF) files.
!
!***********************************************************************
!                           CAUTION                                    *
!                                                                      *
! The GIF specification incorporates the Lempel-Zev-Welch (LZW)        *
! compression technology which is the subject of a patent awarded to   *
! Unisys. Use of this technology, and in particular creation of GIF    *
! format files using this PGPLOT device driver, may require a license  *
! from Unisys.                                                         *
!***********************************************************************
!
! Supported device: GIF87a file format
!
! Device type codes: /GIF or /VGIF
!
! Default device name: pgplot.gif.
!
! If you have more than one image to plot (i.e. use PGPAGE) with this
! device, subsequent pages will be named: pgplot2.gif, pgplot3.gif,
! etc, disrespective of the device name you specified.
! You can however bypass this by specifying a device name including a
! number sign (#), which will henceforth be replaced by the pagenumber.
! Example: page#.gif will produce files page1.gif, page2.gif, ...,
! page234.gif, etc.
!
! Default view surface dimensions are:
! - GIF  : 1200 x  900 pixels (translates to 8.0 x 6.0 inch).
! - VGIF :  900 x 1200 pixels (translates to 6.0 x 8.0 inch).
! with an assumed scale of 150 pixels/inch.
! Default width and height can be overridden by specifying environment
! variables
! PGPLOT_GIF_WIDTH  (default 1200)
! PGPLOT_GIF_HEIGHT (default 900)
!
! Color capability:
! Indices 0 to 255 are supported. Each of these indices can be assigned
! one color. Default colors for indices 0 to 15 are implemented.
!
! Obtaining hardcopy: Use a GIF viewer or converter.
!=
!  1-Aug-1994 - Created by Remko Scharroo
!  9-Aug-1994 - New scheme for line plotting
! 16-Aug-1994 - Provide multi-image plotting.
!  8-Sep-1994 - Add opcode 29 [TJP].
!  5-Nov-1994 - Adjust size of bitmap if necessary [TJP].
! 18-Jan-1995 - Attempt to prevent integer overflow on systems where
!               BYTE is signed [TJP].
! 28-Dec-1995 - prevent concurrent access [TJP].
! 10-Jul-1996 - Fortran (F90) version; make PIXMAP and WORK allocatable 
!               arrays; remove all pass-by-value; test ALLOCATED(PIXMAP);
!               direct-access binary file output; higher resolution [PAS]
! 24-Apr-1998 - CASE structure instead of computed GOTO; "!" comments [PAS]
! 28-Aug-1998 - FORM='BINARY' in OPEN statements (Digital Visual Fortran 5.0) 
!               *** Note: Not standard F90; remove if troublesome. [BRupp]
! 26-Dec-2000 - treat signed bytes differently (Digital Fortran 6.0) [PAS]
!-----------------------------------------------------------------------
      CHARACTER*(*) LTYPE, PTYPE, DEFNAM
      INTEGER DWD, DHT, BX, BY
      PARAMETER (LTYPE=                                                 &
     &'GIF   (Graphics Interchange Format file, landscape orientation)',&
     & PTYPE=                                                           &
     &'VGIF  (Graphics Interchange Format file, portrait orientation)') 
      PARAMETER (DEFNAM='pgplot.gif')
      PARAMETER (DWD=1200, DHT=900)
      REAL      XRES, YRES
      PARAMETER (XRES=150., YRES=XRES)
!
      INTEGER   UNIT, IC, NPICT, MAXIDX, STATE
      INTEGER   CTABLE(3,0:255), CDEFLT(3,0:15)
      INTEGER   IER, I, L, IOS, IX0, IY0, IX1, IY1
      INTEGER   GRTRIM
      CHARACTER*80 MSG, INSTR, FILENM
!
! Note: for 64-bit operating systems, change the following 
! declaration to INTEGER*8:
!
      INTEGER(1),ALLOCATABLE :: PIXMAP(:,:)
      INTEGER(2),ALLOCATABLE :: WORK(:,:)
!
      SAVE UNIT, IC, CTABLE, NPICT, MAXIDX, BX, BY, PIXMAP, FILENM
      SAVE CDEFLT, STATE
      DATA CDEFLT /000,000,000, 255,255,255, 255,000,000, 000,255,000,  &
     &             000,000,255, 000,255,255, 255,000,255, 255,255,000,  &
     &             255,128,000, 128,255,000, 000,255,128, 000,128,255,  &
     &             128,000,255, 255,000,128, 085,085,085, 170,170,170/
      DATA STATE /0/
!-----------------------------------------------------------------------
!
      SELECT CASE(IFUNC)
!
!--- IFUNC = 1, Return device name -------------------------------------
      CASE (1)
         SELECT CASE(MODE)
         CASE (1)
            CHR = LTYPE
            LCHR = LEN(LTYPE)
         CASE (2)
            CHR = PTYPE
            LCHR = LEN(PTYPE)
         CASE DEFAULT
            CALL GRWARN('Requested MODE not implemented in GIF driver')
         END SELECT
!
!--- IFUNC = 2, Return physical min and max for plot device, and range
!               of color indices ---------------------------------------
!     (Maximum size is set by GIF format to 2**16 pixels)
      CASE (2)
         RBUF(1) = 0
         RBUF(2) = 65536 
         RBUF(3) = 0
         RBUF(4) = 65536
         RBUF(5) = 0
         RBUF(6) = 255
         NBUF = 6
!
!--- IFUNC = 3, Return device resolution -------------------------------
      CASE (3)
         RBUF(1) = XRES
         RBUF(2) = YRES 
         RBUF(3) = 1
         NBUF = 3
!
!--- IFUNC = 4, Return misc device info --------------------------------
!    (This device is Hardcopy, supports rectangle fill, pixel 
!     primitives, and query color rep.)
      CASE (4)
         CHR = 'HNNNNRPNYN'
         LCHR = 10
!
!--- IFUNC = 5, Return default file name -------------------------------
      CASE (5)
         CHR = DEFNAM
         LCHR = LEN(DEFNAM)
!
!--- IFUNC = 6, Return default physical size of plot -------------------
      CASE (6)
         RBUF(1) = 0
         RBUF(2) = BX-1 
         RBUF(3) = 0
         RBUF(4) = BY-1
         NBUF = 4
!
!--- IFUNC = 7, Return misc defaults -----------------------------------
      CASE (7)
         RBUF(1) = 1
         NBUF=1
!
!--- IFUNC = 8, Select plot --------------------------------------------
      CASE (8)
!
!--- IFUNC = 9, Open workstation ---------------------------------------
      CASE (9)
!        -- check for concurrent access
         IF (STATE.EQ.1) THEN
            CALL GRWARN('a PGPLOT GIF file is already open')
            RBUF(1) = 0
            RBUF(2) = 0
            RETURN
         END IF
!        -- dimensions of plot buffer
         IF (MODE.EQ.1) THEN
!        -- Landscape
            BX = DWD
            BY = DHT
            CALL GRGENV('GIF_WIDTH', INSTR, L)
            IF (L.GT.0) READ(INSTR(:L),'(BN,I10)',IOSTAT=IOS) BX
            CALL GRGENV('GIF_HEIGHT', INSTR, L)
            IF (L.GT.0) READ(INSTR(:L),'(BN,I10)',IOSTAT=IOS) BY
         ELSE
!        -- Portrait
            BX = DHT
            BY = DWD
            CALL GRGENV('GIF_WIDTH', INSTR, L)
            IF (L.GT.0) READ(INSTR(:L),'(BN,I10)',IOSTAT=IOS) BY
            CALL GRGENV('GIF_HEIGHT', INSTR, L)
            IF (L.GT.0) READ(INSTR(:L),'(BN,I10)',IOSTAT=IOS) BX
         END IF
         NPICT=1
         MAXIDX=0
!        -- Initialize color table
         DO I=0,15
            CTABLE(1,I) = CDEFLT(1,I)
            CTABLE(2,I) = CDEFLT(2,I)
            CTABLE(3,I) = CDEFLT(3,I)
         END DO
         DO I=16,255
            CTABLE(1,I) = 128
            CTABLE(2,I) = 128
            CTABLE(3,I) = 128
         END DO
!
         FILENM = CHR(:LCHR)
         CALL GRGI10 (FILENM, NPICT, CHR)
         LCHR = GRTRIM(CHR)
         CALL GRGLUN(UNIT)
         NBUF = 2
         RBUF(1) = UNIT
         OPEN (UNIT,FILE=CHR(1:LCHR),STATUS='UNKNOWN',ACCESS='DIRECT',  &
     &         RECL=255, FORM='BINARY', IOSTAT=IER)
         IF (IER.NE.0) THEN
            MSG = 'Cannot open output file for GIF plot: '//CHR(:LCHR)
            CALL GRWARN(MSG)
            RBUF(2) = 0
            STATE = 0
            CALL GRFLUN(UNIT)
         ELSE
            RBUF(2) = 1
            STATE = 1
         END IF
!
!--- IFUNC=10, Close workstation ---------------------------------------
      CASE (10)
         STATE = 0
!
!--- IFUNC=11, Begin picture -------------------------------------------
      CASE (11)
         BX = NINT(RBUF(1))+1
         BY = NINT(RBUF(2))+1
         ALLOCATE (PIXMAP(BX,BY), STAT=IER)
         IF (IER.NE.0) THEN
            CALL GRWARN('Failed to allocate plot buffer.')
            BX = 0
            BY = 0
         ELSE
!        -- initialize to zero (background color)
            CALL GRGI03(1, 1, BX, BY, 0, BX, BY, PIXMAP)
            IF (NPICT.GT.1) THEN
               CALL GRGI10 (FILENM, NPICT, MSG)
               CALL GRGLUN(UNIT)
               OPEN (UNIT, FILE=MSG, STATUS='UNKNOWN', ACCESS='DIRECT', &
     &               RECL=255, FORM='BINARY', IOSTAT=IER)
               IF (IER.NE.0)                                            &
     &            CALL GRWARN('Cannot open output file for GIF plot')
            END IF
         END IF
!
!--- IFUNC=12, Draw line -----------------------------------------------
      CASE (12)
         IX0=NINT(RBUF(1))+1
         IX1=NINT(RBUF(3))+1
         IY0=BY-NINT(RBUF(2))
         IY1=BY-NINT(RBUF(4))
         IF (ALLOCATED(PIXMAP))                                         &
     &        CALL GRGI01(IX0, IY0, IX1, IY1, IC, BX, BY, PIXMAP)
!
!--- IFUNC=13, Draw dot ------------------------------------------------
      CASE (13)
         IX0=NINT(RBUF(1))+1
         IY0=BY-NINT(RBUF(2))
         IF (ALLOCATED(PIXMAP))                                         &
     &        CALL GRGI01(IX0, IY0, IX0, IY0, IC, BX, BY, PIXMAP)
!
!--- IFUNC=14, End picture ---------------------------------------------
      CASE (14)
         IF (UNIT.GE.0) THEN
            ALLOCATE (WORK(4098,256), STAT=IER)
            IF (IER.NE.0) THEN
               CALL GRWARN('Failed to allocate work array.')
            ELSE
               CALL GRGI06(UNIT, BX, BY, CTABLE, PIXMAP, MAXIDX, WORK)
            END IF
            CLOSE (UNIT)
            CALL GRFLUN(UNIT)
            DEALLOCATE (WORK, STAT=IER)
         END IF
         NPICT = NPICT+1
         DEALLOCATE (PIXMAP, STAT=IER)
         IF (IER.NE.0) THEN
            CALL GRWARN('Failed to deallocate plot buffer.')
         END IF
!
!--- IFUNC=15, Select color index --------------------------------------
      CASE (15)
         IC = RBUF(1)
         MAXIDX = MAX(MAXIDX, IC)
!
!--- IFUNC=16, Flush buffer. -------------------------------------------
!    (Not used.)
      CASE (16)
!
!--- IFUNC=18, Erase alpha screen. -------------------------------------
!    (Not implemented: no alpha screen)
      CASE (18)
!
!--- IFUNC=21, Set color representation. -------------------------------
      CASE (21)
         I = RBUF(1)
         CTABLE(1, I) = NINT(RBUF(2)*255)
         CTABLE(2, I) = NINT(RBUF(3)*255)
         CTABLE(3, I) = NINT(RBUF(4)*255)
!
!--- IFUNC=23, Escape --------------------------------------------------
!    (Not implemented: ignored)
      CASE (23)
!
!--- IFUNC=24, Rectangle fill ------------------------------------------
      CASE (24)
         IX0=NINT(RBUF(1))+1
         IX1=NINT(RBUF(3))+1
         IY1=BY-NINT(RBUF(2))
         IY0=BY-NINT(RBUF(4))
         IF (ALLOCATED(PIXMAP))                                         &
     &        CALL GRGI03(IX0, IY0, IX1, IY1, IC, BX, BY, PIXMAP)
!
!--- IFUNC=25, Not implemented -----------------------------------------
      CASE (25)
!
!--- IFUNC=26, Line of pixels ------------------------------------------
      CASE (26)
         CALL GRGI04(NBUF, RBUF, BX, BY, PIXMAP, MAXIDX)
!
!--- IFUNC=27, Not implemented -----------------------------------------
      CASE (27)
!
!--- IFUNC=28, Not implemented -----------------------------------------
      CASE (28)
!
!--- IFUNC=29, Query color representation. -----------------------------
      CASE (29)
         I = RBUF(1)
         RBUF(2) = CTABLE(1,I)/255.0
         RBUF(3) = CTABLE(2,I)/255.0
         RBUF(4) = CTABLE(3,I)/255.0
         NBUF = 4
!
!--- Unimplemented Function
      CASE DEFAULT
         WRITE (MSG, '(I10)') IFUNC
         CALL GRWARN('Unimplemented function in GIF device driver:'//   &
     &               MSG)
         NBUF = -1
      END SELECT
      RETURN
!-----------------------------------------------------------------------
      END
!
!*GRGI01 -- PGPLOT GIF driver, draw line
!+
      SUBROUTINE GRGI01 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY
      INTEGER(1) :: PIXMAP(BX,BY)
!
! Draw a straight-line segment from absolute pixel coordinates
! (IX0, IY0) to (IX1, IY1).
!
! Arguments:
!  ICOL            (input): Color index
!  PIXMAP   (input/output): The image data buffer.
!-----------------------------------------------------------------------
      INTEGER IX, IY, IS
      REAL    D
      INTEGER (1) :: VAL
!
      IF (ICOL.GT.127) THEN
         VAL = ICOL - 256
      ELSE
         VAL = ICOL
      END IF
      IF (IX0.EQ.IX1 .AND. IY0.EQ.IY1) THEN
         PIXMAP(IX0,IY0) = VAL
      ELSE IF (ABS(IY1-IY0) .GT. ABS(IX1-IX0)) THEN
         D  = FLOAT(IX1-IX0) / FLOAT(IY1-IY0)
         IS = 1
         IF (IY1 .LT. IY0) IS = -1
         DO IY=IY0,IY1,IS
            IX = NINT(IX0 + (IY-IY0)*D)
            PIXMAP(IX,IY) = VAL
	   END DO
      ELSE
         D  = FLOAT(IY1-IY0) / FLOAT(IX1-IX0)
         IS = 1
         IF (IX1 .LT. IX0) IS = -1
         DO IX=IX0,IX1,IS
            IY = NINT(IY0 + (IX-IX0)*D)
            PIXMAP(IX,IY) = VAL
	   END DO
      END IF
      END
!
!*GRGI03 -- PGPLOT GIF driver, fill rectangle
!+
      SUBROUTINE GRGI03 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY
      INTEGER(1) :: PIXMAP(BX,BY)
!
! Arguments:
!  IX0, IY0        (input): Lower left corner.
!  IX1, IY1        (input): Upper right corner.
!  ICOL            (input): Color value.
!  BX, BY          (input): dimensions of PIXMAP.
!  PIXMAP   (input/output): The image data buffer.
!-----------------------------------------------------------------------
      INTEGER IX, IY
      INTEGER(1) :: VAL
!
      IF (ICOL.GT.127) THEN
         VAL = ICOL - 256
      ELSE
         VAL = ICOL
      END IF
      DO IY=IY0,IY1
         DO IX=IX0,IX1
            PIXMAP(IX,IY) = VAL
            END DO
	END DO
	RETURN
      END
!
!*GRGI04 -- PGPLOT GIF driver, fill image line
!+
      SUBROUTINE GRGI04(NBUF,RBUF,BX,BY,PIXMAP,MAXIDX)
      INTEGER I,J,NBUF,BX,BY,N,IC,MAXIDX
      REAL    RBUF(NBUF)
      INTEGER(1) :: PIXMAP(BX,BY)
!-
      I = NINT(RBUF(1)) + 1
      J = BY-NINT(RBUF(2))
      DO N=3,NBUF
         IC     = RBUF(N)
         MAXIDX = MAX(MAXIDX, IC)
         IF (IC .GT. 127) IC = IC - 256
         PIXMAP(I+N-3,J) = IC
	END DO
	RETURN
      END
!
!*GRGI06 -- PGPLOT GIF driver, write GIF image
!+
      SUBROUTINE GRGI06 (UNIT, BX, BY, CTABLE, PIXMAP, MAXIDX, CODE)
      INTEGER   UNIT, BX, BY, MAXIDX
      INTEGER   CTABLE(3,0:255)
      INTEGER(1) :: PIXMAP(BX*BY)
      INTEGER*2 CODE(0:4097,0:255)
!
! Write GIF image to UNIT.
!
! Arguments:
! UNIT   (input): Output unit
! BX,BY  (input): `Screen' size
! CTABLE  (input): Color map
! PIXMAP (input): Image data
! MAXIDX (input): maximum color index used.
!--
! 16-Nov-94: fixed bug (BYTE is signed)
! 09-Jul-96: revised to use Fortran90 constructs and I/O [PAS]
! 26-Dec-00: treat signed bytes differently for Fortran v.6 [PAS]
!-----------------------------------------------------------------------
      CHARACTER GIF1*6
      INTEGER*4 BWIDTH, BSHIFT, BREST, BOUT, BREC
      INTEGER PIXEL, I, J, K, M, CLEAR, EOI, TABLE, IN, TOTAL, PRE, EXT
      INTEGER OLDPRE, BITS
      INTEGER (1) :: BLKOUT(0:266)
      COMMON  /GRGICO/ BWIDTH, BSHIFT, BREST, BOUT, BREC, BLKOUT
!
      BITS = 1
      DO WHILE (2**BITS .LE. MAXIDX)
         BITS = BITS + 1
      END DO
      PIXEL = MAX(BITS, 2)
      CLEAR = 2**PIXEL
      EOI   = CLEAR + 1
!
! Write Header.
!
! Write Logical Screen Descriptor (screen width, screen height,
! color data, background color index [0], pixel aspect ratio [0]).
      GIF1 = 'GIF87a'
      DO I=1,6
         BLKOUT(I-1) = ICHAR(GIF1(I:I))
      END DO
	CALL GRGI09(BX, BLKOUT(6))
	CALL GRGI09(BY, BLKOUT(8))
	I = ISHFT(BITS-1, 4)
      BLKOUT(10) = IOR(IOR(128, I), BITS-1)
      BLKOUT(11) = 0
      BLKOUT(12) = 0
      BOUT = 12
      BREC = 1
!
! Write Global Color Table.
      DO J=0,2**BITS-1
         BLKOUT(BOUT+1) = CTABLE(1,J)
         BLKOUT(BOUT+2) = CTABLE(2,J)
         BLKOUT(BOUT+3) = CTABLE(3,J)
         BOUT = BOUT + 3
         IF (BOUT .GE. 254) THEN
            WRITE (UNIT,REC=BREC) (BLKOUT(I),I=0,254)
            BOUT = BOUT - 255
            DO I=0,BOUT
               BLKOUT(I) = BLKOUT(I+255)
            END DO
            BREC = BREC + 1
         END IF
      END DO
!
! Write Image Descriptor.
      BLKOUT(BOUT+1) = ICHAR(',')
      BLKOUT(BOUT+2) = 0
      BLKOUT(BOUT+3) = 0
      BLKOUT(BOUT+4) = 0
      BLKOUT(BOUT+5) = 0
      CALL GRGI09(BX, BLKOUT(BOUT+6))
      CALL GRGI09(BY, BLKOUT(BOUT+8))
      BLKOUT(BOUT+10) = 0
      BLKOUT(BOUT+11) = PIXEL
      BOUT = BOUT + 11
      IF (BOUT .EQ. 253) THEN
!        This is a nasty surprise - make a dummy 1-byte sub-block
         BLKOUT(254) = 1
         BLKOUT(255) = CLEAR
         BOUT = 255
      END IF
!     Check if record already longer than 255 bytes
      IF (BOUT .GE. 254) THEN
         WRITE (UNIT,REC=BREC) (BLKOUT(I),I=0,254)
         BOUT = BOUT - 255
         DO I=0,BOUT
            BLKOUT(I) = BLKOUT(I+255)
         END DO
         BREC = BREC + 1
      END IF
!
! Write Table Based Image Data, in sub-blocks of up to 255 bytes.
!     How many bytes left for a sub-block in this direct-access record?
      BOUT = BOUT + 1
      BLKOUT(BOUT) = 254 - BOUT
!
! LZW-compression; initialize counters
! Start packing variable-size codes into 8-bit bytes.
!
      BREST  = 0
      BSHIFT = 0
! `Read' first character.
      IN    = 1
      TOTAL = BX * BY
      PRE   = PIXMAP(IN)
      IF (PRE .LT. 0) PRE = PRE + 256
!
      TABLE  = 4095
      BWIDTH = PIXEL + 1
!                          
      DO WHILE (IN .LT. TOTAL)
         IF (TABLE .GE. 4095) THEN
!           Start new data stream; if n=PIXEL, then
!           2**n-1  (n+1)-bit codes
!           2*2**n  (n+2)-bit codes
!           4*2**n  (n+3)-bit codes
!              .         .      .
!             1024     11-bit codes
!             2048     12-bit codes (incl. one clear code)
!
!           push a clear code first
            CALL GRGI07(UNIT, CLEAR)
            DO M=0,255
               DO K=0,4095
                  CODE(K,M) = 0
               END DO
            END DO  
!           Initialize last used table entry and code width in bits
            TABLE  = EOI
            BWIDTH = PIXEL + 1                    
         END IF
!
! `Read' next character; check if combination prefix/extension occurred earlier
         IN     = IN + 1 
         EXT    = PIXMAP(IN)
         IF (EXT .LT. 0) EXT = EXT + 256
         OLDPRE = PRE
         PRE    = CODE(PRE, EXT)
!
         IF (PRE .EQ. 0) THEN
!           If no earlier occurrence add combination to table
            CALL GRGI07(UNIT, OLDPRE)
            TABLE = TABLE + 1
            CODE(OLDPRE,EXT) = TABLE
            PRE = EXT
!           May need to increase width of code entry by one bit
            IF (ISHFT(TABLE,-BWIDTH) .NE. 0) BWIDTH = BWIDTH + 1
         END IF
      END DO
!
! Last character
!
      CALL GRGI07(UNIT, PRE)
      CALL GRGI07(UNIT, EOI)
      IF (BSHIFT .GT. 0) CALL GRGI08(UNIT, BREST)
      IF (BOUT .GT. 0) THEN
         BLKOUT(0) = BOUT
         BOUT = BOUT + 1
      END IF
      BLKOUT(BOUT) = 0
	IF (BOUT .EQ. 254) THEN
	   WRITE (UNIT, REC=BREC) (BLKOUT(I),I=0,254)
	   BOUT = -1  
	   BREC = BREC + 1
	END IF
!
! Write GIF Trailer.
!
      BLKOUT(BOUT+1) = ICHAR(';')
      DO I=BOUT+2,254
!        Zero fill the final direct-access record
         BLKOUT(I) = 0
      END DO
      WRITE (UNIT,REC=BREC) (BLKOUT(I),I=0,254)
      RETURN
      END
!
!*GRGI07 -- Compress GIF output codes into 8-bit bytes
!
      SUBROUTINE GRGI07(UNIT, INCODE)
      INTEGER UNIT, INCODE
      INTEGER*4 BWIDTH, BSHIFT, BREST, BOUT, BREC
      INTEGER(1) :: BLKOUT(0:266)
      COMMON  /GRGICO/ BWIDTH, BSHIFT, BREST, BOUT, BREC, BLKOUT
!
      BREST  = IOR(BREST, ISHFT(INCODE, BSHIFT))
      BSHIFT = BSHIFT + BWIDTH
!
      DO WHILE (BSHIFT .GE. 8)
!        Send low byte to buffer, and delete it
         CALL GRGI08(UNIT, BREST)
         BREST  = ISHFT(BREST, -8)
         BSHIFT = BSHIFT - 8
      END DO
!
      RETURN
      END
!
!*GRGI08 -- Accumulate bytes and write GIF output sub-block
!
      SUBROUTINE GRGI08(UNIT, INCODE)
      INTEGER UNIT, INCODE, I
      INTEGER*4 BWIDTH, BSHIFT, BREST, BOUT, BREC
      INTEGER(1) :: BLKOUT(0:266)
      COMMON  /GRGICO/ BWIDTH, BSHIFT, BREST, BOUT, BREC, BLKOUT
!
      BOUT = BOUT + 1
      BLKOUT(BOUT) = IAND(INCODE, 255)
      IF (BOUT .GE. 254) THEN
         WRITE (UNIT,REC=BREC) (BLKOUT(I),I=0,254)
         BOUT = 0
         BLKOUT(0) = 254
         BREC = BREC + 1
      END IF
      RETURN
      END
!
!*GRGI09 -- Encode integer into 2 bytes
!
      SUBROUTINE GRGI09(IN, IOUT)
      INTEGER IN
      INTEGER(1) :: IOUT(2)
!
      IOUT(1) = IAND(IN, 255)
      IOUT(2) = ISHFT(IN, -8)
      RETURN
      END
!
!*GRGI10 -- Replace # in filename by picture number
!
      SUBROUTINE GRGI10 (NAME1, NP, NAME2)
      CHARACTER*(*) NAME1
      CHARACTER*(*) NAME2
      CHARACTER*80  TMP
      INTEGER GRTRIM
      INTEGER NP, IDX, L, LN
!
      LN  = GRTRIM(NAME1)
      IDX = INDEX(NAME1,'#')
      IF (IDX .GT. 0) THEN
!        -- if the supplied name contains a #-character, replace
!           it with the page number
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE IF (NP .EQ. 1) THEN
!        -- if this is the first page, use the supplied name
         NAME2 = NAME1
         RETURN
      ELSE IF (LN+2 .LE. LEN(NAME1)) THEN
!        -- append an underscore and the page number to the supplied
!           name
         NAME1(LN+1:LN+2) = '_#'
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE
!        -- last resort: invent a new name
         CALL GRFAO('pgplot#.gif', L, TMP, NP, 0, 0, 0)
      END IF
      CALL GRWARN ('Writing new GIF image as: '//TMP(:L))
      NAME2 = TMP(:L)
      RETURN
      END

C*GRBPIC -- begin picture
C+
      SUBROUTINE GRBPIC
C
C GRPCKG (internal routine). Send a "begin picture" command to the
C device driver, and send commands to set deferred attributes (color,
C line width, etc.)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL RBUF(2)
      INTEGER NBUF, LCHR
      CHARACTER*20 CHR
C
      GRPLTD(GRCIDE) = .TRUE.
      IF (GRGTYP.GT.0) THEN
C         -- begin picture
          RBUF(1) = GRXMXA(GRCIDE)
          RBUF(2) = GRYMXA(GRCIDE)
          NBUF = 2
          CALL GREXEC(GRGTYP,11,RBUF,NBUF,CHR,LCHR)
C         -- set color index
          RBUF(1) = GRCCOL(GRCIDE)
          NBUF = 1
          CALL GREXEC(GRGTYP,15,RBUF,NBUF,CHR,LCHR)
C         -- set line width
          IF (GRGCAP(GRCIDE)(5:5).EQ.'T') THEN
              RBUF(1) = ABS(GRWIDT(GRCIDE))
              NBUF = 1
              CALL GREXEC(GRGTYP,22,RBUF,NBUF,CHR,LCHR)
          END IF
C         -- set hardware dashing
          IF (GRGCAP(GRCIDE)(3:3).EQ.'D') THEN
              RBUF(1) = GRSTYL(GRCIDE)
              NBUF = 1
              CALL GREXEC(GRGTYP,19,RBUF,NBUF,CHR,LCHR)
          END IF
      END IF
C
      END

C*HGDRIV -- PGPLOT HPGL-2 driver
C+
      SUBROUTINE HGDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C-----------------------------------------------------------------------
C PGPLOT driver for HPGL-2 device.
C-----------------------------------------------------------------------
C Version 0.0  - 1990 Oct 18 - C. J. Lonsdale.
C-----------------------------------------------------------------------
C
C This driver should work with any HP-GL/2 device, but has been tested
C only with a Laserjet III printer.  It takes advantage of the "PE" mode
C compressed data format.  In the Laserjet III used for testing, there
C were two problems with using the PE format, both of which required
C inelegant workarounds in the code.  First, the PE mode is designed
C to be used with relative addressing, but when PGPLOT tries to draw long
C dashed/dotted lines there seems to be a systematic rounding error
C internal to the printer which grows as n instead of sqrt(n), so that
C serious cumulative positional errors can result.  Attempts to work
C around this by periodically inserting an absolute positioning command
C revealed a second problem, namely that the "=" absolute positioning
C flag in PE mode does not work.  It was thus necessary to periodically
C exit from PE mode, do absolute positioning in normal mode, then return
C to PE mode.  The file size overhead of this workaround is miminal (maybe
C 5%).  The printer rounding errors were ignored in the polygon fill
C opcode, because in general the vectors will be of pseudo-random length
C and direction, so errors will grow only as sqrt(n).
C
C Supported device: Any HPGL-2 device (presently tested only on HP laserjet 3)
C
C Device type code: /HPGL2
C
C Default device name: PGPLOT.HGPLOT.
C
C Default view surface dimensions: 8.0in (horizontal) by 10.0in
C (vertical).
C
C Resolution: 1016 (x) x 1016 (y) pixels/inch.
C
C Color capability: Color indices 0 (erase, white) and 1 (black) are
C supported. 7 other shades of grey are available for lines and
C area fill patterns.
C It is not possible to change color representation.
C
C Input capability: None.
C
C File format: Ascii
C
C Obtaining hardcopy: Extremely system dependent
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE, DEFNAM
      PARAMETER (TYPE='HPGL2 (Hewlett-Packard graphics)')
      PARAMETER (DEFNAM='PGPLOT.HGPLOT')
      CHARACTER*1 FF, EC
      PARAMETER (FF=CHAR(12))
      PARAMETER (EC=CHAR(27))
C
      LOGICAL START, PEON
      INTEGER GROPTX
      INTEGER UNIT, IER, IC, NPTS, PCT, NREL
      INTEGER I0, J0, I1, J1, L, L1, L2, LASTI, LASTJ, LOBUF
      REAL LW
      CHARACTER*80 INSTR, MSG, DUMMY, DUMMY1, DUMMY2
      CHARACTER*132 OBUF
      SAVE UNIT, IC, LASTI, LASTJ, LOBUF, OBUF, PEON, NREL
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in '//TYPE//' device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 8128
      RBUF(3) = 0
      RBUF(4) = 10160
      RBUF(5) = 0
      RBUF(6) = 9
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = 1016.0
      RBUF(2) = 1016.0
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, Area fill,
C    Thick lines)
C
   40 CHR = 'HNNATNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 8128
      RBUF(3) = 0
      RBUF(4) = 10160
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
      CALL GRGLUN(UNIT)
      NBUF = 2
      RBUF(1) = UNIT
      IER = GROPTX(UNIT, CHR(1:LCHR), DEFNAM, 1)
      IF (IER.NE.0) THEN
          DUMMY = CHR(:LCHR)
          CALL GRWARN('Cannot open output file for '//TYPE//' plot: '//
     1                DUMMY(:LCHR))
          RBUF(2) = 0
          CALL GRFLUN(UNIT)
          RETURN
      ELSE
          INQUIRE (UNIT=UNIT, NAME=CHR)
          LCHR = LEN(CHR)
   91     IF (CHR(LCHR:LCHR).EQ.' ') THEN
              LCHR = LCHR-1
              GOTO 91
          END IF

          RBUF(2) = 1
      END IF
      CALL GRHG02(UNIT,EC//'E')
      PEON = .FALSE.
      NREL = 0
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      CLOSE(UNIT)
      CALL GRFLUN(UNIT)
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
C Enter HPGL, black pen, thick lines have rounded ends and joins
  110 CONTINUE
      CALL GRHG02(UNIT,EC//'%0BINSP1LA1,4,2,4PA1,1')
      LASTI = 1
      LASTJ = 1
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
C simple pen-down move
      IF (I0.EQ.LASTI .AND. J0.EQ.LASTJ) THEN

          CALL GRHGEC((I1-I0), (J1-J0), INSTR, L)

C pen up to start of line, then pen down to end of line
      ELSE
          CALL GRHGEC((I0-LASTI), (J0-LASTJ), DUMMY1, L1)
          CALL GRHGEC((I1-I0), (J1-J0), DUMMY2, L2)
          INSTR = '<'//DUMMY1(1:L1)//DUMMY2(1:L2)
          L = 1 + L1 + L2

C Make sure we are doing this in PE mode
      END IF
      IF(.NOT. PEON) THEN
          INSTR = 'PE7'//INSTR
          L = L + 3
          PEON = .TRUE.
          NREL = 0
      ENDIF
      LASTI = I1
      LASTJ = J1
C Insert absolute position once in a while to keep LJIII in line
      NREL = NREL + 1
      IF(NREL .GE. 30) THEN
          CALL GRFAO(';PUPA#,#PE7',L1,DUMMY1,LASTI,LASTJ,0,0)
          INSTR = INSTR(1:L)//DUMMY1(1:L1)
          L = L + L1
          NREL = 0
      ENDIF
      GOTO 800
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      I1 = NINT(RBUF(1))
      J1 = NINT(RBUF(2))
C pen up move to position, then pen down
      CALL GRHGEC((I1-LASTI), (J1-LASTJ), DUMMY1, L1) 
      CALL GRHGEC(0, 0, DUMMY2, L2)

      INSTR = '<'//DUMMY1(1:L1)//DUMMY2(1:L2)
      L = 1 + L1 + L2
      IF(.NOT. PEON) THEN
          INSTR = 'PE7'//INSTR
          L = L + 3
          PEON = .TRUE.
          NREL = 0
      ENDIF
      LASTI = I1
      LASTJ = J1
C LJIII obedience code as in line draw opcode
      NREL = NREL + 1
      IF(NREL .GE. 30) THEN
          CALL GRFAO(';PUPA#,#PE7',L1,DUMMY1,LASTI,LASTJ,0,0)
          INSTR = INSTR(1:L)//DUMMY1(1:L1)
          L = L + L1
          NREL = 0
      ENDIF
      GOTO 800
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      IF (LOBUF.NE.0) THEN
          CALL GRHG02(UNIT, OBUF(1:LOBUF))
          LOBUF = 0
      END IF
      CALL GRHG02(UNIT, ';'//EC//'E')
      PEON = .FALSE.
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
C white ... disable transparency mode.
      IF (IC.EQ.0) THEN
          INSTR = ';TR0SP0FT10,0SV0'
          L = 16
C Some shade of grey, enable transparency
C Had to disable greys ... bad effects on line drawing CJL 3/6/92
      ELSE
          PCT = 100
C         IF(IC.EQ.1) PCT = 100
C         IF(IC.EQ.2) PCT = 1
C         IF(IC.EQ.3) PCT = 5
C         IF(IC.EQ.4) PCT = 15
C         IF(IC.EQ.5) PCT = 25
C         IF(IC.EQ.6) PCT = 40
C         IF(IC.EQ.7) PCT = 70
C         IF(IC.EQ.8) PCT = 85
          CALL GRFAO(';TR1SP1FT10,#SV1,#',L,INSTR,PCT,PCT,0,0)
      END IF
      PEON = .FALSE.
      GOTO 800
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      IF (LOBUF.NE.0) THEN
          CALL GRHG02(UNIT, OBUF(1:LOBUF))
          LOBUF = 0
      END IF
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      IF (NPTS.EQ.0) THEN
          NPTS = RBUF(1)
          START = .TRUE.
          RETURN
      ELSE
          NPTS = NPTS-1
          I0 = NINT(RBUF(1))
          J0 = NINT(RBUF(2))
C enter PE mode at first vertex
          IF (START) THEN
              CALL GRFAO(';PUPA#,#PMPE7', L, INSTR, I0, J0, 0, 0)
              START = .FALSE.
              LASTI = I0
              LASTJ = J0
C last point, exit PE mode, polygon mode, and issue polygon fill.  Then
C reset the position to be safe.
          ELSE IF (NPTS.EQ.0) THEN
              CALL GRHGEC((I0-LASTI),(J0-LASTJ),DUMMY1,L1)
              INSTR = DUMMY1(1:L1)//';PM2FPPUPA1,1'
              L = L1 + 13
              LASTI = 1
              LASTJ = 1
              PEON = .FALSE.
              NREL = 0
C Just another point
          ELSE
              CALL GRHGEC((I0-LASTI),(J0-LASTJ),INSTR,L)
              LASTI = I0
              LASTJ = J0
          END IF

          GOTO 800
      ENDIF
C
C--- IFUNC=21, Set color representation. -------------------------------
C    (Not implemented: ignored)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C
  220 CONTINUE
C Fudged this ... lines looked too thick, maybe its the res. enhancement.
      LW = RBUF(1) * 0.127 - 0.05
      IF(LW .EQ. 0.0) LW = 0.025
      WRITE(DUMMY,'(F5.3)') LW
      INSTR = ';PW'//DUMMY
      L = 8
      PEON = .FALSE.
      GOTO 800
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C-----------------------------------------------------------------------
C Buffer output if possible.  Same as PS driver.
C
  800 IF ( (LOBUF+L+1). GT. 132) THEN
          CALL GRHG02(UNIT, OBUF(1:LOBUF))
          OBUF(1:L) = INSTR(1:L)
          LOBUF = L
      ELSE
          OBUF(LOBUF+1:LOBUF+L) = INSTR(1:L)
          LOBUF = LOBUF+L
      END IF
      RETURN
C-----------------------------------------------------------------------
      END

C*GRHGEC -- PGPLOT HPGL2 driver, convert integers to coded ascii
C+
      SUBROUTINE GRHGEC(X,Y,OUTSTR,L)
C
C Support routine for HPGL2 driver:  converts integer coordinates
C X and Y to base 32 in the ascii format suitable for PE command.
C Output is a string, number of characters encoded returned in L.
C----------------------------------------------------------------
      INTEGER X, Y, L
      CHARACTER*(*) OUTSTR
C
      INTEGER XREM, YREM
C
C Set the sign bit
C
      X = X * 2
      IF(X .LT. 0) X = 1 - X
      Y = Y * 2
      IF(Y .LT. 0) Y = 1 - Y
C
C Loop through base-32 digits, treat last one with extra bit in 
C ascii character.  Goes from least to most significant.
C
      L = 0
      OUTSTR = ' '
   10 CONTINUE
          XREM = MOD(X,32)
          X = X / 32
          L = L + 1
          IF(X .EQ. 0) GO TO 20
          OUTSTR(L:L) = CHAR(63+XREM)
      GO TO 10
   20 OUTSTR(L:L) = CHAR(95+XREM)
C
C Do Y coordinate same way as X above
C
   30 CONTINUE
          YREM = MOD(Y,32)
          Y = Y / 32
          L = L + 1
          IF(Y .EQ. 0) GO TO 40
          OUTSTR(L:L) = CHAR(63+YREM)
      GO TO 30
   40 OUTSTR(L:L) = CHAR(95+YREM)
C
      RETURN
      END


C*GRHG02 -- PGPLOT HPGL driver, copy buffer to file
C+
      SUBROUTINE GRHG02 (UNIT, S)
C
C Support routine for PSdriver: write character string S on
C specified Fortran unit.
C-----------------------------------------------------------------------
      INTEGER UNIT
      CHARACTER*(*) S
C
      WRITE (UNIT, '(A)') S
C-----------------------------------------------------------------------
      END

C  If you have a power mac version of LS fortran uncomment the
C next 5 lines and comment out "!!MP InLines.f"
C!!IFC NOT LSPOWERF
C!!MP 68KInlines
C!!ELSEC
C!!MP PPCInlines
C!!ENDC
C  If you have a 68K mac version of LS fortran comment out the 
C 5 lines above and uncomment the next line.
!!MP InLines.f


C*GRGENV -- get value of PGPLOT environment parameter (MAC)
C+
      SUBROUTINE GRGENV(NAME, VALUE, L)
      CHARACTER*(*) NAME, VALUE
      INTEGER L
C
C Return the value of a PGPLOT environment parameter. In Sun/Convex-UNIX,
C environment parameters are UNIX environment variables; e.g. parameter
C ENVOPT is environment variable PGPLOT_ENVOPT. Translation is not
C recursive and is case-sensitive.
C
C Arguments:
C  NAME   : (input) the name of the parameter to evaluate.
C  VALUE  : receives the value of the parameter, truncated or extended
C           with blanks as necessary. If the parameter is undefined,
C           a blank string is returned.
C  L      : receives the number of characters in VALUE, excluding
C           trailing blanks. If the parameter is undefined, zero is
C           returned.
C
C On Macintosh, the environment variables are stored in file.  This subroutine
C first looks for the file PGPLOTENVNAMES, in the application directory.
C If it can't be found, a standard file dialog box will be displayed,
C so that you can find the file.  Once it is found, the name and location are 
C stored so that you will not be prompted again.
C--
C 19-Jan-1988
C 25-Sep-1995  Modified to work on mac with MPW Fortran 2.1.  All environment 
C              parameters are stored in the file.  The file can have any name 
C              but best thing to do is to put a file called pgplotenvnames
C              in the application directory. See Tech. Note 35 for more information
C              about Macintosh file system.
C 17-Jan-1996  Modified by Mike Burnett (mnb@ornl.gov) to search for the 
C              pgplotenvnames file in the preferences folder before putting
C              up dialog box.
C-----------------------------------------------------------------------       
      INTEGER LIN, LUN,LStart,VolRefNum, JVRefNum, myresult
      CHARACTER*32 TEST, Line*120, FilNam*120
      INTEGER*4 myDirID
      External JVRefNum
      Save FileName,VolRefNum
          

      include 'Folders.f'
          
C
      TEST = 'PGPLOT_'//NAME
      LIN = INDEX(TEST, ' ')-1
      Value = ' '
      L = 0
      Call GrgLun(LUN)

C  If volume reference number has been set, switch to that volume.  The
C  first time grgenv is called, volrefnum will not be set and the currect
C  directory is the application directory.  The volume reference number will
C  be set after pgplotenvnames is found.
      If (VolRefNum .lt. 0) Then
         Call  F_SETVOLUME(VolRefNum)
      End If

C  Try to open FilNam.  The first time that Grgenv is called Filnam will
C  be empty and the open will fail.  So try to open pgplotenvnames in the
C  current directory.  If that fails put up a standard file dialog box to
C  find pgplotenvnames.  If FilNam has been set then after assigning a 
C  unit number to the file reset the volume reference number to the application
C  directory.  
      Open(Unit = lun,File=FilNam,Status='OLD',Err = 10,Readonly)
      Call F_SETVOLUME(JVREFNUM(-1))
      Go to 1
          
10    Open(Unit = lun,File='pgplotenvnames',Status='OLD',Err = 15,Readonly)
      FilNam = 'pgplotenvnames'
      VolRefNum = JVREFNUM(Lun)
      Go to 1
      
15    myresult = FindFolder(kOnSystemDisk,kPreferencesFolderType,
     &           kDontCreateFolder,%REF (myVRefNum),%REF (myDirID))
      if (myresult.ne.0) go to 20
      myresult = HSetVol(NIL,myVRefNum,myDirID)
      if (myresult.ne.0) go to 20
      Open(Unit=lun,File='pgplotenvnames',Status='OLD',Err=20,Readonly)
      FilNam = 'pgplotenvnames'
      VolRefNum = JVREFNUM(Lun)
      Call F_SETVOLUME(JVREFNUM(-1))
      Go to 1

C Put up standard file dialog box.  Once found store the file name and volume
C reference number.
20    Call F_SETVOLUME(JVREFNUM(-1))  
      CALL GRWARN('Could not find file PGPLOTENVNAMES in current directory.')
      CALL GRWARN('A dialog box will come up allowing you to find the file with the')
      CALL GRWARN('environment variables. Hit return for the dialog box to appear.')
      Pause
      Open(Unit=lun,File=*,STATUS='OLD',err=100,Readonly)
      Inquire(Unit=LUN,Name=FilNam)
      VolRefNum = JVREFNUM(Lun)

C File has been found, so search for environmental variable and extract value.
1     Continue
             Read(Lun,'(A512)',End=2) Line 
             If (Test(:Lin) .EQ. Line(:Lin)) Then
                Lstart = index(Line,"'")+1
                L = index(Line(Lstart:),"'")-1
                Value = Line(LStart:LStart+L-1)
                        Close(Lun)
                Go to 2
             End If
          Go to 1
2     Close(LUN)
      Return
             

C     Could not find PGPLOTENVNAMES.
100   Close(LUN)
      CALL GRWARN('Cancelled dialog box to find PGPLOTENVNAMES')
      Return
      END

      SUBROUTINE EPDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
C GRPCKG driver for EPSON FX100 dot matrix printer.
C
C    Apr-1987 - Floating-point input version Apr 1987 [PSB].
C 16-Jan-1988 - Compile with /WARN=(DECLARE) switch [AFT].
C---
      CHARACTER ESC, DUAL
      PARAMETER (ESC=CHAR(27))
      PARAMETER (DUAL=CHAR(1))
      REAL       PL,    PL1
      PARAMETER (PL=765,PL1=PL-1)
      REAL      RBUF(6)
      INTEGER   IFUNC, NBUF, LCHR
      CHARACTER CHR*(*)
C
      INTEGER   GRGMEM, GRFMEM, GRTRIM
      INTEGER   XYMAP, LENOLD, IST, IXDIM, IYDIM, LENBUF
      INTEGER   I, J, N, ICOL, LUN
      INTEGER*2 BUF(0:1632)
      CHARACTER NN*2
      SAVE LUN,XYMAP,ICOL,IXDIM,IYDIM,LENOLD,LENBUF
      DATA LENOLD/0/
C---
      GOTO (100,200,300,400,500,600,700,800,900,1000,
     :      1100,1200,1300,1400,1500) IFUNC
      GOTO 999
C
C       1: Return device name:
100   CHR = 'EPSON (Epson dot matrix printer)'
      LCHR = GRTRIM(CHR)
      RETURN
C
C       2: Return physical min & max for device:
200   RBUF(1) = 0
      RBUF(2) = 1631  
C                     ! dual-density 120/"
      RBUF(3) = 0
      RBUF(4) = -1
C                     ! as long as a box of paper...
      RBUF(5) = 0
C                     ! min colour
      RBUF(6) = 1
C                     ! max colour
      NBUF = 6
      RETURN
C
C       3: Return device resolution:
300   RBUF(1) = 120.0
C                     ! horiz dots per inch
      RBUF(2) = 72.0
C                     ! veric dots per inch
      RBUF(3) = 1.0
C                     ! thick lines
      RETURN
C
C       4: Return misc info:
C H= Hardcopy device
C N= No cursor
C N= No hard dash
C N= No area fill
C N= No hard thick lines
400   CHR(1:10) = 'HNNNNNNNNN'
      RETURN
C
C       5: Return default file name:
500   CHR = 'PGPLOT.EPS'
      LCHR = LEN(CHR)
      RETURN
C
C       6: Return default size of plot:
600   RBUF(1) = 0
      RBUF(2) = 1631
      RBUF(3) = 0
      RBUF(4) = PL1
C                     ! 72 ./" -> 11" PAGE.
      RETURN
C
C       7: Return misc defaults:
700   RBUF(1) = 1.
      ICOL = 1
      RETURN
C
C       8: Select Plot:
800   RETURN
C
C       9: Open device:
900   CALL GRGLUN(LUN)
      OPEN(LUN,FILE=CHR(:LCHR),STATUS='NEW',
     1  RECORDTYPE='VARIABLE',RECL=4000)
      RBUF(1) = LUN
      RBUF(2) = 1
      RETURN
C
C       10: Close device:
1000  CLOSE(UNIT=LUN)
      CALL GRFLUN(LUN)
      IF(LENOLD.GT.0) THEN
          IST = GRFMEM(LENOLD,XYMAP)
          IF(IST.NE.1) STOP 'error freeing memory in EPDRIV'
          LENOLD=0
      ENDIF
      RETURN
C
C       11: Initialise plot:
1100  IXDIM = RBUF(1) + 1
      IYDIM = RBUF(2)/9 + 1
      LENBUF = IXDIM*IYDIM*2
C                       ! length of buffer in bytes
      IF(LENBUF.NE.LENOLD) THEN
          IF(LENOLD.GT.0) THEN
            IST = GRFMEM(LENOLD,XYMAP)
            IF(IST.NE.1) STOP 'error freeing memory in EPDRIV'
            LENOLD=0
          ENDIF
          IST = GRGMEM(LENBUF,XYMAP)
          IF(IST.NE.1) STOP 'error allocating memory in EPDRIV'
          LENOLD = LENBUF
      ENDIF
      CALL GREP03(LENBUF,%VAL(XYMAP))
      RETURN
C
C       12: Draw a line:
1200  CALL GREP01(RBUF,ICOL,IXDIM-1,IYDIM-1,%VAL(XYMAP))
      RETURN
C
C       13: Draw a dot:
1300  CALL GREP02(RBUF,ICOL,IXDIM-1,IYDIM-1,%VAL(XYMAP))
      RETURN
C
C       14: Close plot:
1400  CONTINUE
C
C       Initialise printer:
      WRITE(LUN,1411) ESC,'A',CHAR(9)
C                    ! 9 dots per line;
1411  FORMAT(1X,3A1)
      DO 1460 J=0,IYDIM-1
          CALL GREP04(%VAL(XYMAP+IXDIM*J*2),IXDIM,BUF)
C
C         Find last non-zero dot position:
          DO 1430 I=IXDIM-1,0,-1
            N = I + 1
            IF(BUF(I).NE.0) GOTO 1440
1430      CONTINUE
1440      CONTINUE
          NN(1:1) = CHAR(N.AND.255)
          NN(2:2) = CHAR(N/256)
          BUF(N) = '0A0D'X
C                  ! CR LF
          WRITE(LUN,1441) ESC,';',DUAL,NN,(BUF(I),I=0,N)
1441      FORMAT(1X,3A1,A2,1632A2)
1460  CONTINUE
C
C       Reset printer to normal:
      WRITE(LUN,1461)ESC,'2',CHAR(13)
C                  ! 1/6 line spacing
1461  FORMAT(1X,3A1)
      RETURN
C
C       15: Set colour:
1500  ICOL = MAX(MIN(NINT(RBUF(1)),1),0)
C                  ! only black or white.
      RBUF(1) = ICOL
      RETURN
C---
C--- Flag function not implemented.
999   NBUF=-1
      RETURN
      END

      SUBROUTINE GREP01(RBUF,ICOL,IXDIM,IYDIM,XYMAP)
C- Draw a line on Epson:
      REAL      RBUF(6)
      INTEGER   ICOL, IXDIM, IYDIM
      INTEGER*2 XYMAP(0:IXDIM,0:IYDIM)
C
      REAL      XL, YL, D, XP, YP, XINC, YINC
      INTEGER   L, LENGTH, IX, IY, IYBIT
      INTEGER*2 BITS(0:8)
      DATA BITS/128,64,32,16,8,4,2,1,-32768/
C---
      XL = RBUF(3) - RBUF(1)
      YL = RBUF(4) - RBUF(2)
      D = MAX(ABS(XL),ABS(YL),1.0)
      LENGTH = NINT(D)
      XP = RBUF(1)
      YP = RBUF(2)
      XINC = XL/D
      YINC = YL/D
      DO 180 L = 0,LENGTH
          IX = NINT(XP)
          IY = IYDIM*9 - NINT(YP)
          IYBIT = MOD(IY,9)
          IF(ICOL.GT.0) THEN
            XYMAP(IX,IY/9) = 
     :      XYMAP(IX,IY/9).OR.BITS(IYBIT)
          ELSE
            XYMAP(IX,IY/9) = 
     :      XYMAP(IX,IY/9).AND.(.NOT.BITS(IYBIT))
          ENDIF
          XP = XP + XINC
          YP = YP + YINC
180   CONTINUE
      RETURN
      END

      SUBROUTINE GREP02(RBUF,ICOL,IXDIM,IYDIM,XYMAP)
C
C- Draw a dot:
      REAL      RBUF(6)
      INTEGER   ICOL, IXDIM, IYDIM
      INTEGER*2 XYMAP(0:IXDIM,0:IYDIM)
C
      INTEGER   IY, IYBIT
      INTEGER*2 BITS(0:8)
      DATA BITS/128,64,32,16,8,4,2,1,-32768/
C---
      IY = IYDIM*9 - NINT(RBUF(2))
      IYBIT = MOD(IY,9)
      XYMAP(NINT(RBUF(1)),IY/9) = 
     :XYMAP(NINT(RBUF(1)),IY/9).OR.BITS(IYBIT)
      RETURN
      END

      SUBROUTINE GREP03(LENBUF,XYMAP)
C- Erase bitmap
      INTEGER   LENBUF, XYMAP(*)
      INTEGER   I
C---
      DO 180 I=1,LENBUF/4
          XYMAP(I) = 0
180   CONTINUE
      RETURN
      END

      SUBROUTINE GREP04(XYMAP,IXDIM,BUF)
C- Copy a line of output to buf
      INTEGER   IXDIM
      INTEGER*2 XYMAP(IXDIM), BUF(IXDIM)
      INTEGER   I
C---
      DO 180 I=1,IXDIM
          BUF(I) = XYMAP(I)
180   CONTINUE
      RETURN
      END

C*GRTXY0 -- convert world coordinates to device coordinates
C+
      SUBROUTINE GRTXY0 (ABSXY,X,Y,XT,YT)
C
C GRPCKG (internal routine): Convert scaled position to absolute
C position.
C
C Arguments:
C
C ABSXY (input, logical): if FALSE, convert world coordinates to
C       absolute device coordinates; if TRUE, return the input
C       coordinates unchanged.
C X, Y (input, real): input coordinates (absolute or world, depending
C       on setting of ABSXY).
C XT, YT (output, real): output absolute device coordinates.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      LOGICAL  ABSXY
      REAL     X, Y, XT, YT
C
      IF (ABSXY) THEN
          XT = X
          YT = Y
      ELSE
          XT = X * GRXSCL(GRCIDE) + GRXORG(GRCIDE)
          YT = Y * GRYSCL(GRCIDE) + GRYORG(GRCIDE)
      END IF
C
      END

      PROGRAM EXPGMF
C-----------------------------------------------------------------------
C This is a simple program to examine the pictures contained in a
C PGPLOT metafile, displaying them one at a time on a selected PGPLOT
C device. Options are provided for converting color pictures to
C monochrome or grey scale.
C-----------------------------------------------------------------------
      CHARACTER*80 FILE
      CHARACTER*8 OPT
      INTEGER I, ISTAT, NPICT, PGOPEN
C
      FILE = 'pgplot.pgmf'
C
C Scan the metafile to find number of pictures
C
      CALL PGEXMF(FILE, NPICT, ISTAT)
      WRITE (*,*) 'Number of pictures in metafile:', NPICT
C
C Open output graphics device
C
      ISTAT = PGOPEN('?')
      IF (ISTAT.LT.1) STOP
      CALL PGASK(.FALSE.)
C
C Display requested picture(s)
C
      WRITE (*,*) 'Options (M for monochrome, G for grey scale):'
      READ (*, '(A)') OPT
 10   WRITE (*,*) 'Enter number of picture to display: '
      READ (*,*, END=20) I
      IF (I.LT.1) GOTO 20
      IF (I.GT.NPICT) GOTO 10
      CALL PGPAGE
      CALL PGSVP(0.0, 1.0, 0.0, 1.0)
      CALL PGRDMF(FILE, OPT, I, ISTAT)
      GOTO 10
C
C Close output graphics device
C
 20   CALL PGCLOS
C-----------------------------------------------------------------------
      END

C*PGRDMF -- read and display a picture from a PGPLOT metafile
C%void cpgrdmf(char *file, char *opt, int npict, int *istat);
C+
      SUBROUTINE PGRDMF (FILE, OPT, NPICT, ISTAT)
      CHARACTER*(*) FILE, OPT
      INTEGER NPICT, ISTAT
C
C This routine reads a PGPLOT metafile from a disk file and displays
C it in the current viewport.
C
C Arguments:
C  FILE   (input)  : name of metafile to read
C  OPT    (input)  : string of single-character options (see below)
C  NPICT  (input)  : sequence number of picture to display
C  ISTAT  (output) : receives 0 if file is read successfully; >0 if
C                    an error occurs (e.g., file not found, wrong
C                    format)
C
C Options:
C  M : display in monochrome, using color indices 0 and 1;
C      all color information in the metafile will be ignored.
C  G : display in grey scale: colors in the metafile will be
C      converted to shades of grey.
C  D : debug: report unrecognized entries in the metafile.
C--
C 3-Jun-1997 - new routine (TJP).
C-----------------------------------------------------------------------
      INTEGER MAXPOL
      PARAMETER (MAXPOL=1000)
      INTEGER UNIT, IER, I, N1, N2, N3, N4, NPTS, NFND, LW, N, CI
      INTEGER GROPTX, GRCTOI
      LOGICAL MONO, GREY, DEBUG
      REAL    X, Y, X1, Y1, X2, Y2, SCALE, POLX(MAXPOL), POLY(MAXPOL)
      REAL    SHADE
      CHARACTER REC*80, OP
C
      MONO = INDEX(OPT,'M').NE.0 .OR. INDEX(OPT,'m').NE.0
      GREY = INDEX(OPT,'G').NE.0 .OR. INDEX(OPT,'g').NE.0
      DEBUG = INDEX(OPT,'D').NE.0 .OR. INDEX(OPT,'d').NE.0
C
C Open file and check that it is a PGPLOT metafile
C
      CALL GRGLUN(UNIT)
      IER = GROPTX(UNIT, FILE, 'pgplot.pgmf', 0)
      IF (IER.NE.0) THEN
         ISTAT = 1
         CALL GRWARN('Cannot open PGPLOT metafile:')
         CALL GRWARN(FILE(1:LEN(FILE)))
         CALL GRFLUN(UNIT)
         RETURN
      END IF
      READ (UNIT, '(A)', IOSTAT=IER) REC
      IF (IER.NE.0 .OR. REC(1:5).NE.'%PGMF') THEN
         ISTAT = 2
         CALL GRWARN('File is not a PGPLOT metafile:')
         CALL GRWARN(FILE(1:LEN(FILE)))
         CLOSE (UNIT=UNIT)
         CALL GRFLUN(UNIT)
         RETURN
      END IF
C
C Skip to start of requested picture
C
      N = 0
 50   READ (UNIT, '(A)', IOSTAT=IER) REC
      IF (IER.NE.0) THEN
         ISTAT = 3
         CALL GRWARN('Requested picture not found in PGPLOT metafile:')
         CALL GRWARN(FILE(1:LEN(FILE)))
         CLOSE (UNIT=UNIT)
         CALL GRFLUN(UNIT)
         RETURN
      END IF
      IF (REC(1:1).NE.'B') GOTO 50
      N = N+1
      IF (N.LT.NPICT) GOTO 50
C
C Display this picture
C
      CALL PGBBUF
      CALL PGSAVE
 100  CONTINUE
         OP = REC(1:1)
         I = 2
         N1 = GRCTOI(REC, I)
         I = I+1
         N2 = GRCTOI(REC, I)
         I = I+1
         N3 = GRCTOI(REC, I)
         I = I+1
         N4 = GRCTOI(REC, I)
         IF (OP.EQ.'L') THEN
C           -- line segment
            X = X + REAL(N1)
            Y = Y + REAL(N2)
            CALL PGDRAW(X, Y)
         ELSE IF (OP.EQ.'M') THEN
C           -- move pen
            X = REAL(N1)
            Y = REAL(N2)
            CALL PGMOVE(X, Y)
         ELSE IF (OP.EQ.'D') THEN
C           -- dot
            X = REAL(N1)
            Y = REAL(N2)
            CALL PGPT1(X, Y, -1)
         ELSE IF (OP.EQ.'S') THEN
C           -- marker
            X = REAL(N2)
            Y = REAL(N3)
            CALL PGPT1(X, Y, N1)
         ELSE IF (OP.EQ.'I') THEN
C           -- set color index
            IF (MONO) THEN
               CI = 1
               IF (N1.EQ.0) CI = 0
            ELSE
               CI = N1
            END IF
            CALL PGSCI(CI)
         ELSE IF (OP.EQ.'W') THEN
C           -- set line width
C              (N1 is width in PGMF units; convert to unit 1/200 inch)
            LW = NINT(200.0*N1/SCALE)
            IF (LW.LT.1) LW = 1
            CALL PGSLW(LW)
         ELSE IF (OP.EQ.'Y') THEN
C           -- begin polygon
            NPTS = N1
            NFND = 0
         ELSE IF (OP.EQ.'X') THEN
C           -- polygon vertex
            NFND = NFND +1
            IF (NFND.LE.MAXPOL) THEN
               POLX(NFND) = REAL(N1)
               POLY(NFND) = REAL(N2)
            END IF
            IF (NFND.EQ.NPTS) THEN
               CALL PGPOLY(MIN(NPTS,MAXPOL), POLX, POLY)
               NPTS = 0
            END IF
         ELSE IF (OP.EQ.'R') THEN
C           -- rectangle
            CALL PGRECT(REAL(N1), REAL(N3), REAL(N2), REAL(N4))
         ELSE IF (OP.EQ.'C') THEN
C           -- set color representation
            IF (MONO) THEN
               CONTINUE
            ELSE IF (GREY) THEN
               SHADE = (0.30*N2 + 0.59*N3 + 0.11*N4)/255.0
               CALL PGSCR(N1, SHADE, SHADE, SHADE)
            ELSE
               CALL PGSCR(N1, 
     :           REAL(N2)/255.0, REAL(N3)/255.0, REAL(N4)/255.0)
            END IF
         ELSE IF (OP.EQ.'B') THEN
C           -- begin picture
            CALL PGWNAD(0.0, REAL(N2), 0.0, REAL(N3))
            X = 0.0
            Y = 0.0
C           -- find device scale (PGMF units per inch)
            CALL PGQVP(1, X1, X2, Y1, Y2)
            SCALE = REAL(N2)/(X2-X1)
         ELSE IF (OP.EQ.'E') THEN
C           -- end picture
            GOTO 200
         ELSE IF (REC(1:1).EQ.'%') THEN
C           -- comment
            CONTINUE
         ELSE
            IF (DEBUG) THEN
               CALL GRWARN('Bad entry in metafile: '//REC(1:16))
            END IF
         END IF
         READ (UNIT, '(A)', IOSTAT=IER) REC
         IF (IER.NE.0) GOTO 200
      GOTO 100
 200  CONTINUE
      CALL PGUNSA
      CALL PGEBUF
      CLOSE (UNIT=UNIT)
      CALL GRFLUN(UNIT)
      RETURN
      END

C*PGEXMF -- determine properties of PGPLOT metafile
C%void cpgexmf(char *file, int *npict, int *istat);
C+
      SUBROUTINE PGEXMF (FILE, NPICT, ISTAT)
      CHARACTER*(*) FILE
      INTEGER NPICT, ISTAT
C
C Arguments:
C  FILE   (input)  : name of metafile to read
C  NPICT  (output) : number of pictures in metafile
C  ISTAT  (output) : receives 0 if file is read successfully; 1 if
C                    an error occurs (e.g., file not found, wrong
C                    format)
C--
C 3-Jun-1997 - new routine (TJP).
C-----------------------------------------------------------------------
      INTEGER UNIT, IER
      INTEGER GROPTX
      CHARACTER REC*80
C
      CALL GRGLUN(UNIT)
      IER = GROPTX(UNIT, FILE, 'pgplot.pgmf', 0)
      IF (IER.NE.0) THEN
         ISTAT = 1
         CALL GRWARN('Cannot open PGPLOT metafile:')
         CALL GRWARN(FILE(1:LEN(FILE)))
         CALL GRFLUN(UNIT)
         RETURN
      END IF
      READ (UNIT, '(A)', IOSTAT=IER) REC
      IF (IER.NE.0 .OR. REC(1:5).NE.'%PGMF') THEN
         ISTAT = 2
         CALL GRWARN('File is not a PGPLOT metafile:')
         CALL GRWARN(FILE(1:LEN(FILE)))
         CLOSE (UNIT=UNIT)
         CALL GRFLUN(UNIT)
         RETURN
      END IF
      NPICT = 0
 100  CONTINUE
         READ (UNIT, '(A)', IOSTAT=IER) REC
         IF (IER.NE.0) GOTO 200
         IF (REC(1:1).EQ.'B') THEN
            NPICT = NPICT+1
         END IF
      GOTO 100
 200  CONTINUE
      CLOSE (UNIT=UNIT)
      CALL GRFLUN(UNIT)
      RETURN
      END

C*HIDRIV -- PGPLOT HIDMP plotter driver
C+
      SUBROUTINE HIDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Houston Instruments HIDMP pen plotter.
C
C Version 1.0  - 1987 May 26 - T. J. Pearson.
C version 2.0  - 1992 Apr  7 - standard Fortran (TJP).
C-----------------------------------------------------------------------
      CHARACTER*(*) DEVICE
      CHARACTER*(*) DEFNAM
      PARAMETER (DEVICE='HIDMP (Houston Instruments pen plotter)')
      PARAMETER (DEFNAM='pgplot.hiplot')
      CHARACTER*80 MSG
      CHARACTER*64 INSTR
      INTEGER      IER, I0, J0, I1, J1, L, LASTI, LASTJ, UNIT
      INTEGER      GROPTX
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
      GOTO 900
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CHR = DEVICE
      LCHR = LEN(DEVICE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 4799
      RBUF(3) = 0
      RBUF(4) = 7199
      RBUF(5) = 1
      RBUF(6) = 1
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
   30 RBUF(1) = 200.0
      RBUF(2) = 200.0
      RBUF(3) = 2
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill, 
C    No thick lines)
C
   40 CHR = 'HNNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 2099
      RBUF(3) = 0
      RBUF(4) = 1599
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 3
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
      CALL GRGLUN(UNIT)
      NBUF = 2
      RBUF(1) = UNIT
      IER = GROPTX(UNIT, CHR(1:LCHR), DEFNAM, 1)
      IF (IER.NE.0) THEN
          MSG = 'Cannot open plot file: '//CHR(:LCHR)
          CALL GRWARN(MSG)
          RBUF(2) = 0
          CALL GRFLUN(UNIT)
          RETURN
      ELSE
          INQUIRE (UNIT=UNIT, NAME=CHR)
          LCHR = LEN(CHR)
   91     IF (CHR(LCHR:LCHR).EQ.' ') THEN
              LCHR = LCHR-1
              GOTO 91
          END IF
          RBUF(2) = 1
      END IF
      LASTI = -1
      LASTJ = -1
      WRITE (UNIT, '(A)') ';:H EC5 A '
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
      WRITE (UNIT, '(A)') 'H EL @ '
      CLOSE (UNIT)
      CALL GRFLUN(UNIT)
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
      WRITE (UNIT, '(A)') 'EL '
      WRITE (UNIT, '(A)') ';:H EC5 A '
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
  121 CONTINUE
      IF ( (I0.NE.LASTI) .OR. (J0.NE.LASTJ) ) THEN
          CALL GRFAO('U #,# D #,# ', L, INSTR, I0, J0, I1, J1)
      ELSE
          CALL GRFAO('#,# ', L, INSTR, I1, J1, 0, 0)
      END IF
      WRITE (UNIT,'(A)') INSTR(1:L)
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      I1 = NINT(RBUF(1))
      J1 = NINT(RBUF(2))
      I0 = I1
      J0 = J1
      GOTO 121
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C    (Not implemented.)
C
  150 CONTINUE
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Null operation: buffering is not implemented.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called.)
C
  170 GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Null operation: there is no alpha screen.)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called.)
C
  190 GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called.)
C
  200 GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C    (Not implemented)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called.)
C
  220 GOTO 900
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
      WRITE (UNIT, '(A)') CHR(:LCHR)
      LASTI = -1
      RETURN
C-----------------------------------------------------------------------
C Error: unimplemented function.
C
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in HI device driver: '//MSG)
      NBUF = -1
      RETURN
C-----------------------------------------------------------------------
      END

C*PGTICK -- draw a single tick mark on an axis
C%void cpgtick(float x1, float y1, float x2, float y2, float v, \
C% float tikl, float tikr, float disp, float orient, const char *str);
C+
      SUBROUTINE PGTICK (X1, Y1, X2, Y2, V, TIKL, TIKR, DISP, 
     :                   ORIENT, STR)
      REAL X1, Y1, X2, Y2, V, TIKL, TIKR, DISP, ORIENT
      CHARACTER*(*) STR
C
C Draw and label single tick mark on a graph axis. The tick mark is
C a short line perpendicular to the direction of the axis (which is not
C drawn by this routine). The optional text label is drawn with its
C baseline parallel to the axis and reading in the same direction as
C the axis (from point 1 to point 2). Current line and text attributes
C are used.
C
C Arguments:
C  X1, Y1 (input)  : world coordinates of one endpoint of the axis.
C  X2, Y2 (input)  : world coordinates of the other endpoint of the axis.
C  V      (input)  : draw the tick mark at fraction V (0<=V<=1) along
C                    the line from (X1,Y1) to (X2,Y2).
C  TIKL   (input)  : length of tick mark drawn to left of axis
C                    (as seen looking from first endpoint to second), in
C                    units of the character height.
C  TIKR   (input)  : length of major tick marks drawn to right of axis,
C                    in units of the character height.
C  DISP   (input)  : displacement of label text to
C                    right of axis, in units of the character height.
C  ORIENT (input)  : orientation of label text, in degrees; angle between
C                    baseline of text and direction of axis (0-360°).
C  STR    (input)  : text of label (may be blank).
C--
C 25-Mar-1997 - new routine [TJP].
C-----------------------------------------------------------------------
      REAL X, Y, XV1, XV2, YV1, YV2, XW1, XW2, YW1, YW2
      REAL XPMM, YPMM, LENMM, ANGLE, XCH, YCH
      REAL TIKX, TIKY, FJUST, D, OR
C
C Check arguments.
C
      IF (X1.EQ.X2 .AND. Y1.EQ.Y2) RETURN
C
C Get current character height (mm) [note: XCH = YCH].
C
      CALL PGQCS(2, XCH, YCH)
C
C Get x and y scales (units per mm).
C
      CALL PGQVP(2, XV1, XV2, YV1, YV2)
      CALL PGQWIN(XW1, XW2, YW1, YW2)
      XPMM  = (XW2-XW1)/(XV2-XV1)
      YPMM  = (YW2-YW1)/(YV2-YV1)
C
C Length of axis in mm.
C
      LENMM = SQRT(((X2-X1)/XPMM)**2 + ((Y2-Y1)/YPMM)**2)
C
C Angle of axis to horizontal (device coordinates).
C
      ANGLE = ATAN2((Y2-Y1)/YPMM, (X2-X1)/XPMM)*57.29577951
C
C (x,y) displacement for 1 character height perpendicular to axis.
C
      TIKX = (Y1-Y2)*XCH*XPMM/(LENMM*YPMM)
      TIKY = (X2-X1)*XCH*YPMM/(LENMM*XPMM)
C
C Draw the tick mark at point (X,Y) on the axis.
C
      X = X1 + V*(X2-X1)
      Y = Y1 + V*(Y2-Y1)
      CALL PGMOVE(X - TIKR*TIKX, Y - TIKR*TIKY)
      CALL PGDRAW(X + TIKL*TIKX, Y + TIKL*TIKY)
C
C Label the tick mark.
C
      D = DISP
      IF (STR.EQ.' ') RETURN
      OR = MOD(ORIENT, 360.0)
      IF (OR.LT.0.0) OR=OR+360.0
      IF (OR.GT.45.0 .AND. OR.LE.135.0) THEN
         FJUST = 0.0
         IF (D.LT.0.0) FJUST = 1.0
      ELSE IF (OR.GT.135.0 .AND. OR.LE.225.0) THEN
         FJUST = 0.5
         IF (D.LT.0.0) D = D-1.0
      ELSE IF (OR.GT.225.0 .AND. OR.LE.315.0) THEN
         ANGLE = ANGLE+90.0
         FJUST = 1.0
         IF (D.LT.0.0) FJUST = 0.0
      ELSE
         FJUST = 0.5
         IF (D.GT.0.0) D = D+1.0
      END IF            
      CALL PGPTXT(X-D*TIKX, Y-D*TIKY, ANGLE-OR, FJUST, STR)
      END

C.PGTIKL -- length of error bar terminal
C
      SUBROUTINE PGTIKL (T, XL, YL)
      REAL T, XL, YL
C
C Return the length of the terminal of an error bar, in world
C coordinates.
C
C Arguments:
C  T      (input)  : terminal multiplier
C  XL     (output) : terminal lnegth in world x-coordinates
C  YL     (output) : terminal lnegth in world y-coordinates
C--
C 31-Mar-1997 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
C
      XL = T*PGXSP(PGID)*0.15/PGXSCL(PGID)
      YL = T*PGXSP(PGID)*0.15/PGYSCL(PGID)
C
      END

C*PGMTEXT -- non-standard alias for PGMTXT
C+
      SUBROUTINE PGMTEXT (SIDE, DISP, COORD, FJUST, TEXT)
      CHARACTER*(*) SIDE, TEXT
      REAL DISP, COORD, FJUST
C
C See description of PGMTXT.
C--
      CALL PGMTXT (SIDE, DISP, COORD, FJUST, TEXT)
      END

C*GRGENV -- get value of PGPLOT environment parameter (VMS)
C+
      SUBROUTINE GRGENV(NAME, VALUE, L)
      CHARACTER*(*) NAME, VALUE
      INTEGER L
C
C Return the value of a PGPLOT environment parameter. In VMS,
C environment parameters are VMS logical names; e.g. parameter
C ENVOPT is logical name PGPLOT_ENVOPT. Translation is not
C recursive and is case-sensitive.
C [For historical compatibility, if name PGPLOT_XX is not found,
C this routine will also look for PLT$XX.]
C
C Arguments:
C  NAME   : (input) the name of the parameter to evaluate.
C  VALUE  : receives the value of the parameter, truncated or extended
C           with blanks as necessary. If the parameter is undefined,
C           a blank string is returned.
C  L      : receives the number of characters in VALUE, excluding
C           trailing blanks. If the parameter is undefined, zero is
C           returned.
C--
C 19-Jan-1988
C-----------------------------------------------------------------------
      INTEGER I, LIN, IER, LIB$SYS_TRNLOG
      CHARACTER*32 TEST
C
      TEST = 'PGPLOT_'//NAME
      LIN = INDEX(TEST, ' ')-1
      IER = LIB$SYS_TRNLOG(TEST(:LIN),L,VALUE)
      IF (IER.NE.1) THEN
          TEST = 'PLT$'//NAME
          LIN = INDEX(TEST, ' ')-1
          IER = LIB$SYS_TRNLOG(TEST(:LIN),L,VALUE)
      END IF
      IF (IER.NE.1 .OR. L.LT.1 .OR. VALUE.EQ.' ') THEN
          L = 0
          VALUE = ' '
      ELSE
          DO 10 I=L,1,-1
              L = I
              IF (VALUE(I:I).NE.' ') GOTO 20
   10     CONTINUE
          L = 0
   20     CONTINUE
      END IF
      END

C*GRGE02
C+
      SUBROUTINE GRGE02(STR, N, QBUF,ICNT,MXCNT)
C
C GRPCKG (internal routine for general driver): transfer N bytes to
C the output buffer, flushing the buffer as necessary with the
C GRGE03 routine.  Based on early versions of GRxx02 routines.
C This version does not used any common blocks.
C ***NOTE*** INIT03 must be called before any calls to GRGE02 to
C set the LUN/Channel to which the buffer should be dumped.
C
C Arguments:
C
C STR(N)      I   Byte  Characters to be written.
C N           I   I     The number of bytes to transfer.
C QBUF        I/O Byte  The output buffer.
C ICNT        I/O I     Current number of bytes used in QBUF.
C MXCNT       I/O I     Maximum number of bytes that can be stored
C                       in QBUF.
C
C  5-Aug-1986 - [AFT].
C-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER  ICNT,MXCNT,I,N
      BYTE QBUF(N), STR(N)
C---
      DO I=1,N
          IF (ICNT.GE.MXCNT) CALL GRGE03(QBUF,ICNT)
          ICNT = ICNT+1
          QBUF(ICNT) = STR(I)
      END DO
      RETURN
      END

C*GRRECT -- fill a rectangle
C+
      SUBROUTINE GRRECT (X0,Y0,X1,Y1)
      REAL X0, Y0, X1, Y1
C
C GRPCKG: Fill a rectangle with solid color.  The rectangle
C is defined by the (x,y) world coordinates of its lower left and upper 
C right corners; the edges are parallel to the coordinate axes.
C
C Arguments:
C
C X0, Y0 (input, real): world coordinates of one corner of the 
C       rectangle.
C X1, Y1 (input, real): world coordinates of the opposite corner of the 
C       rectangle.
C--
C 23-Mar-1988 - [TJP].
C 18-Jan-1991 - Code moved from GRRECT to GRREC0 so that it can also be
C               used by GRPXRE
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL    XLL, YLL, XUR, YUR
      REAL    XMIN, YMIN, XMAX, YMAX
C
      IF (GRCIDE.LT.1) RETURN
C
C Convert to device coordinates and clip.
C
      CALL GRTXY0(.FALSE.,X0,Y0,XLL,YLL)
      CALL GRTXY0(.FALSE.,X1,Y1,XUR,YUR)
      XMIN = MIN(XLL,XUR)
      XMAX = MAX(XLL,XUR)
      YMIN = MIN(YLL,YUR)
      YMAX = MAX(YLL,YUR)
C
C Do the real work
C
      CALL GRREC0(XMIN,YMIN,XMAX,YMAX)
      END

C*PGRNGE -- choose axis limits
C%void cpgrnge(float x1, float x2, float *xlo, float *xhi);
C+
      SUBROUTINE PGRNGE (X1, X2, XLO, XHI)
      REAL X1, X2, XLO, XHI
C
C Choose plotting limits XLO and XHI which encompass the data
C range X1 to X2.
C
C Arguments:
C  X1, X2 (input)  : the data range (X1<X2), ie, the min and max values
C                    to be plotted.
C  XLO, XHI (output) : suitable values to use as the extremes of a graph
C                    axis (XLO <= X1, XHI >= X2).
C--
C 10-Nov-1985 - new routine [TJP].
C-----------------------------------------------------------------------
      XLO = X1 - 0.1*(X2-X1)
      XHI = X2 + 0.1*(X2-X1)
      IF (XLO.LT.0.0 .AND. X1.GE.0.0) XLO = 0.0
      IF (XHI.GT.0.0 .AND. X2.LE.0.0) XHI = 0.0
      END

C*PGVECT -- vector map of a 2D data array, with blanking
C%void cpgvect(const float *a, const float *b, int idim, int jdim, \
C% int i1, int i2, int j1, int j2, float c, int nc, \
C% const float *tr, float blank);
C+
      SUBROUTINE PGVECT (A, B, IDIM, JDIM, I1, I2, J1, J2, C, NC, TR,
     1                   BLANK)
      INTEGER IDIM, JDIM, I1, I2, J1, J2, NC
      REAL    A(IDIM,JDIM), B(IDIM, JDIM), TR(6), BLANK, C
C
C Draw a vector map of two arrays.  This routine is similar to
C PGCONB in that array elements that have the "magic value" defined by
C the argument BLANK are ignored, making gaps in the vector map.  The
C routine may be useful for data measured on most but not all of the
C points of a grid. Vectors are displayed as arrows; the style of the
C arrowhead can be set with routine PGSAH, and the the size of the
C arrowhead is determined by the current character size, set by PGSCH.
C
C Arguments:
C  A      (input)  : horizontal component data array.
C  B      (input)  : vertical component data array.
C  IDIM   (input)  : first dimension of A and B.
C  JDIM   (input)  : second dimension of A and B.
C  I1,I2  (input)  : range of first index to be mapped (inclusive).
C  J1,J2  (input)  : range of second index to be mapped (inclusive).
C  C      (input)  : scale factor for vector lengths, if 0.0, C will be
C                    set so that the longest vector is equal to the
C                    smaller of TR(2)+TR(3) and TR(5)+TR(6).
C  NC     (input)  : vector positioning code.
C                    <0 vector head positioned on coordinates
C                    >0 vector base positioned on coordinates
C                    =0 vector centered on the coordinates
C  TR     (input)  : array defining a transformation between the I,J
C                    grid of the array and the world coordinates. The
C                    world coordinates of the array point A(I,J) are
C                    given by:
C                      X = TR(1) + TR(2)*I + TR(3)*J
C                      Y = TR(4) + TR(5)*I + TR(6)*J
C                    Usually TR(3) and TR(5) are zero - unless the
C                    coordinate transformation involves a rotation
C                    or shear.
C  BLANK   (input) : elements of arrays A or B that are exactly equal to
C                    this value are ignored (blanked).
C--
C  4-Sep-1992: derived from PGCONB [J. Crane].
C 26-Nov-1992: revised to use PGARRO [TJP].
C 25-Mar-1994: correct error for NC not =0 [G. Gonczi].
C  5-Oct-1996: correct error in computing max vector length [TJP;
C              thanks to David Singleton].
C-----------------------------------------------------------------------
      INTEGER  I, J
      REAL X, Y, X1, Y1, X2, Y2
      REAL CC
      INTRINSIC SQRT, MAX, MIN
C
C Define grid to world transformation
C
      X(I,J) = TR(1) + TR(2)*I + TR(3)*J
      Y(I,J) = TR(4) + TR(5)*I + TR(6)*J
C
C Check arguments.
C
      IF (I1.LT.1 .OR. I2.GT.IDIM .OR. I1.GE.I2 .OR.
     1    J1.LT.1 .OR. J2.GT.JDIM .OR. J1.GE.J2) THEN
C        CALL GRWARN('PGVECT: invalid range I1:I2, J1:J2')
         RETURN
      END IF
C
C Check for scale factor C.
C
      CC = C
      IF (CC.EQ.0.0) THEN
         DO 20 J=J1,J2
            DO 10 I=I1,I2
               IF (A(I,J).NE.BLANK .AND. B(I,J).NE.BLANK)
     1              CC = MAX(CC,SQRT(A(I,J)**2+B(I,J)**2))
 10         CONTINUE
 20      CONTINUE
         IF (CC.EQ.0.0) RETURN
         CC = SQRT(MIN(TR(2)**2+TR(3)**2,TR(5)**2+TR(6)**2))/CC
      END IF
C
      CALL PGBBUF
C
      DO 40 J=J1,J2
         DO 30 I=I1,I2
C
C Ignore vector if element of A and B are both equal to BLANK
C
            IF (.NOT.(A(I,J).EQ.BLANK .AND. B(I,J).EQ.BLANK)) THEN
 
C
C Define the vector starting and end points according to NC.
C
               IF (NC.LT.0) THEN
                  X2 = X(I,J)
                  Y2 = Y(I,J)
                  X1 = X2 - A(I,J)*CC
                  Y1 = Y2 - B(I,J)*CC
               ELSE IF (NC.EQ.0) THEN
                  X2 = X(I,J) + 0.5*A(I,J)*CC
                  Y2 = Y(I,J) + 0.5*B(I,J)*CC
                  X1 = X2 - A(I,J)*CC
                  Y1 = Y2 - B(I,J)*CC
               ELSE
                  X1 = X(I,J)
                  Y1 = Y(I,J)
                  X2 = X1 + A(I,J)*CC
                  Y2 = Y1 + B(I,J)*CC
               END IF
C     
C Draw vector.
C
               CALL PGARRO(X1, Y1, X2, Y2)
            END IF
 30      CONTINUE
 40   CONTINUE
C
      CALL PGEBUF
      END

C
C.PGNPL -- Work out how many numerals there are in an integer
C.
      SUBROUTINE PGNPL (NMAX, N, NPL)
C
      INTEGER NMAX, N, NPL
C
C     Work out how many numerals there are in an integer for use with 
C     format statements.   
C     e.g.  N=280 => NPL=3,   N=-3 => NPL=2
C
C     Input:
C       NMAX   :   If > 0, issue a warning that N is going to
C                  exceed the format statement field size if NPL 
C                  exceeds NMAX
C       N      :   Integer of interest
C     Output:
C       NPL    :   Number of numerals
C
C-
C  20-Apr-1991 -- new routine (Neil Killeen)
C-------------------------------------------------------------------------
      IF (N.EQ.0) THEN
        NPL = 1
      ELSE
        NPL = INT(LOG10(REAL(ABS(N)))) + 1
      END IF
      IF (N.LT.0) NPL = NPL + 1
C
      IF (NMAX.GT.0 .AND. NPL.GT.NMAX) 
     *  CALL GRWARN ('PGNPL: output conversion error likely; '
     *               //'number too big for format')
C
      RETURN
      END

C*GRINQLI -- *obsolete routine*
C+
      SUBROUTINE GRINQLI (INTEN)
C
C GRPCKG: obtain the line intensity of the current graphics device.
C Obsolete routine.
C Argument:
C
C INTEN (integer, output): always returns 1.
C--
C (1-Feb-1983; revised 16-Aug-1987).
C-----------------------------------------------------------------------
      INTEGER  INTEN
C
      INTEN = 1
      END

C*PKDRIV -- PGPLOT Peritek VCK-Q 1024 driver
C+
      SUBROUTINE PKDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Peritek Corp. VCH-Q display
C
C Version .96  - 1989 Mar 30 - Christopher K. Lee / T. J. Pearson.
C Version .97  - 1989 Jul 14 - color/monochrome monitors.
C
C
C Supported device: Peritek Corp. VCK-Q frame-buffer video 
C interface with HD63484 ACRTC, using a custom VMS device driver.
C (Peritek Corp., 5550 Redwood Rd., Oakland, CA 94619, 415-531-6500)
C
C Device type code: /PK.
C
C Default device name: PKA0:
C
C Default view surface dimensions: Depends on monitor.
C
C Resolution: The full view surface is 1024 x 1024 pixels. 
C
C Color capability: Color indices 0-255 are supported. The
C representation of all color indices can be changed. Define
C PGPLOT_MONITOR = MONOCHROME to use a monochrome monitor: colors
C are then converted to shades of gray.
C
C Input capability: The graphics cursor is a white cross-hair. The 
C user positions the cursor using the arrow keys and PF1-PF4 keys on
C his terminal keyboard (SYS$COMMAND). The arrow keys move the cursor in
C the appropriate direction; the size of the step for each keystroke is
C controlled by the PF1-PF4 keys: PF1 -> 1 pixel, PF2 -> 4 pixels,
C PF3 -> 16 pixels, PF4 -> 64 pixels. The user indicates that the
C cursor has been positioned by typing any character other than an
C arrow or PF1-PF4 key [control characters, eg, ctrl-C, and other
C special characters should be avoided, as they may be intercepted by
C the operating system]. 
C
C File format: It is not possible to send Peritek VCK-Q plots to a 
C disk file.
C
C Obtaining hardcopy: Not possible.
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE
      PARAMETER (TYPE='PK    (Peritek Image Display)')
      INTEGER UNIT, I, IER, I0, I1, J0, J1, IX, IY, ICH, L
      LOGICAL APPEND, MONO
      CHARACTER*10 MSG
      INTEGER*2 IC, IR, IG, IB, LOC(2), KWORD
      INTEGER GRPK00, SYS$DASSGN
      BYTE PXLINE(1024), KBYTE
      EQUIVALENCE (KBYTE, KWORD)
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in PK device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 1023
      RBUF(3) = 0
      RBUF(4) = 1023
      RBUF(5) = 0
      RBUF(6) = 255
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = 100.
      RBUF(2) = 100.
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Interactive, Cursor, No dashed lines, No area fill,
C    no thick lines, no rectangle fill, pixel)
C
   40 CHR = 'ICNNNNPNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = 'PKA0:'
      LCHR = 5
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 1023
      RBUF(3) = 0
      RBUF(4) = 1023
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C     -- Monochrome monitor?
      CALL GRGENV('MONITOR', MSG, L)
      MONO = (MSG(1:1).EQ.'M' .OR. MSG(1:1).EQ.'m') 
C     -- Append flag?
      APPEND = RBUF(3).NE.0.0
C     -- Open device
      IER = GRPK00(CHR, LCHR, UNIT)
      RBUF(1) = UNIT
      RBUF(2) = IER
      NBUF = 2
      IF (IER.NE.1) RETURN
      IC = 1
C     -- skip initialization if "APPEND" requested
      IF (APPEND) RETURN
      CALL GRPK03(UNIT,MONO)
C     CALL GRPK04(2,UNIT)
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      IER = SYS$DASSGN(%val(UNIT))
      IF (IER.NE.1) THEN
          CALL GRWARN('Error closing graphics device.')
          CALL GRGMSG(IER)
      END IF
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
      IF (.NOT.APPEND) CALL GRPK04(2, UNIT)
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
      CALL GRPK01(I0, J0, I1, J1, IC, UNIT)
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      I0 = NINT(RBUF(1))                  
      J0 = NINT(RBUF(2))
      CALL GRPK07(I0, J0, IC, UNIT)
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
C     IF (RBUF(1).NE.0.) CALL GRPK04(2,UNIT)
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      IF (IC.LT.0 .OR. IC.GT.255) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      RETURN
C                               
C--- IFUNC=17, Read cursor. --------------------------------------------
C           RBUF(1)   in/out : cursor x coordinate.
C           RBUF(2)   in/out : cursor y coordinate.
C           CHR(1:1)  output : keystroke.
C
  170 CONTINUE
      IX = NINT(RBUF(1))
      IY = NINT(RBUF(2))
      CALL GRPK05(IX, IY, ICH, IER, UNIT)
      IF (IER.EQ.1) THEN
          RBUF(1) = IX
          RBUF(2) = IY
          CHR = CHAR(ICH)       
      ELSE
          CHR = CHAR(0)
      END IF
      NBUF = 2
      LCHR = 1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C
  180 CONTINUE
      CALL GRPK04(1,UNIT)
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE 
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      ICH = RBUF(1)
      IR = MIN(255.,MAX(RBUF(2)*255.,0.))
      IG = MIN(255.,MAX(RBUF(3)*255.,0.))
      IB = MIN(255.,MAX(RBUF(4)*255.,0.))
      CALL GRPK08 (ICH,IR,IG,IB,UNIT,MONO)
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      RETURN
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle fill ------------------------------------------
C    (Not implemented: ignored)
C
  240 CONTINUE
      RETURN
C
C--- IFUNC=25, ---------------------------------------------------------
C    (Not implemented: ignored)
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels ------------------------------------------
C
  260 CONTINUE
      LOC(2) = NINT(RBUF(1))
      LOC(1) = NINT(RBUF(2))
      DO 261 I=1,NBUF-2
          KWORD = RBUF(I+2)
          PXLINE(I) = KBYTE
  261 CONTINUE
      CALL GRPK02(4, NBUF-2, PXLINE, LOC, UNIT)
      RETURN
C-----------------------------------------------------------------------
      END

C*GRPK00 -- PGPLOT Peritek VCK-Q driver, open device
C+    
      INTEGER FUNCTION GRPK00 (GRFILE, GRFNLN, GRUNIT)
      CHARACTER*(*) GRFILE
      INTEGER GRFNLN, GRUNIT
C
C Returns:
C   GRPK00         : 1 if the device was opened successfully. Any 
C                    other value indicates that an error occurred.
C                    Usually the value is the VMS error code.
C 
C Arguments:
C   GRFILE (in/out) : requested device name (input); actual
C                     device assigned (output).
C   GRFNLN (in/out) : length of device name.
C   GRUNIT (output) : channel assigned by VMS.
C
C Subroutines called:
C   GRWARN
C   GRGMSG
C   VMS system services
C-----------------------------------------------------------------------
      INTEGER  DVI$_DEVCLASS, DVI$_DEVNAM
      PARAMETER (DVI$_DEVCLASS=4)
      PARAMETER (DVI$_DEVNAM=32)     
      INTEGER  DEVCLASS, ITMLIST(7), IOSB(2)
      INTEGER  IER, L, SYS$ASSIGN
      INTEGER  SYS$GETDVI, SYS$DASSGN, SYS$WAITFR
C    
C Assign an i/o channel.
C
      L = GRFNLN
      IER = SYS$ASSIGN(GRFILE(1:L), GRUNIT,,)
      IF (IER.NE.1) GOTO 100
C
C Check that device has correct characteristics, and obtain true
C device name.
C
      ITMLIST(1) = DVI$_DEVCLASS*2**16 + 4
      ITMLIST(2) = %LOC(DEVCLASS)
      ITMLIST(3) = 0
      ITMLIST(4) = DVI$_DEVNAM*2**16 + LEN(GRFILE)
      ITMLIST(5) = %LOC(GRFILE)
      ITMLIST(6) = %LOC(GRFNLN)
      ITMLIST(7) = 0
      IER = SYS$GETDVI(%VAL(0),,GRFILE(1:GRFNLN), ITMLIST,IOSB,,,)
      IF (.NOT.IER) GOTO 100
      IER = SYS$WAITFR(%VAL(0))
      IF (.NOT.IER) GOTO 100
      IF (.NOT.IOSB(1)) THEN
          IER = IOSB(1)
          GOTO 100
      END IF
      IF (DEVCLASS.NE.32 .AND. DEVCLASS.NE.96) THEN
          CALL GRWARN( GRFILE(1:GRFNLN)//
     2            ' is the wrong sort of device for plot type PK')
          GRPK00 = 32767      ! indicate error
          IER = SYS$DASSGN(%VAL(GRUNIT))
          RETURN
      END IF
C
C Successful completion.
C
      GRPK00 = 1
      RETURN
C
C Error exit.
C
  100 CALL GRWARN('Cannot open graphics device '//GRFILE(1:L))
      CALL GRGMSG(IER)
      GRPK00 = IER
C-----------------------------------------------------------------------
      END

C*GRPK01 -- PGPLOT Peritek VCK-Q driver, draw line segment
C+
      SUBROUTINE GRPK01 (ELEM1,LINE1,ELEM2,LINE2,CI,UNIT)
      INTEGER*2      ELEM1, ELEM2, LINE1, LINE2, CI
      INTEGER*4      UNIT
C
C ELEM1   I*4      start element 
C LINE1   I*4      start line
C ELEM2   I*4      stop element 
C LINE2   I*4      stop line
C CI      I*2      color index to be used
C UNIT    I*4      unit number for output
C
C Note: the arguments are specified as integer*2, but (on the VAX at
C least) integer*4 values may be used. The values should be in the
C range defined by the hardware: (0...1023).
C
C (20-Oct-1987)
C-----------------------------------------------------------------------
      INTEGER*2     DATA
      INTEGER*2     I1, J1, I2, J2
      INTEGER*2     BUF(11),LOC(2)
C
      DATA = CI
      I1 = ELEM1
      J1 = LINE1
      I2 = ELEM2
      J2 = LINE2
      BUF(1)= '4000'O            ! Write Parameter register 0 or COL0
      BUF(2)= DATA + ISHFT(DATA,8)
      BUF(3)= '4001'O            ! Write Parameter register 1 or COL1
      BUF(4)= BUF(2)
      BUF(5)= '100000'O          ! AMOVE
      BUF(6)= I1
      BUF(7)= J1
      BUF(8)= '104000'O          ! ALINE
      BUF(9)= I2    
      BUF(10)= J2
      BUF(11)= '146000'O          ! DOT
      CALL GRPK02(1,11,BUF,LOC,UNIT)
C
      END

C*GRPK02 -- PGPLOT Peritek VCK-Q driver, input/output data
C+
      SUBROUTINE GRPK02 (INOUT,N,BUFFER,LOC,UNIT)
      INTEGER INOUT, N, UNIT, LOC
      BYTE BUFFER(*)
C
C Arguments:
C
C INOUT (input) : 0 => read from frame buffer,
C                 1 => write to graphics chip,
C                 2 => erase alpha screen,
C                 3 => erase primary screen
C                 4 => write to frame buffer
C N (integer, input): the number of bytes or words to transfer.
C BUFFER (byte array, dimension at least N, input): the data
C      bytes to be put in the output buffer.
C LOC (integer*2 array): Line # and element # to read from/write to
C UNIT (input): channel number for output
C
C (20-Oct-1987)
C-----------------------------------------------------------------------
      INCLUDE '($IODEF)'
C
      INTEGER SYS$QIOW, RESULT, IOSB(2)
      INTEGER*2 STBC(2), STATUS, COUNT
      EQUIVALENCE (STBC, IOSB(1)), (STATUS, STBC(1)), (COUNT, STBC(2))
C
      IF (N.LT.1) RETURN
      IF (INOUT.EQ.0) THEN
C       Read from Frame Buffer
          RESULT = SYS$QIOW(,%VAL(UNIT),
     1                 %VAL(IO$_READVBLK),IOSB,,,
     2                 %VAL(2),BUFFER,%VAL(N),%VAL(LOC),,)
      ELSE IF (INOUT.EQ.1) THEN
C       Write to ACRTC FIFO register list
          RESULT = SYS$QIOW(,%VAL(UNIT),
     1                 %VAL(IO$_WRITEVBLK),IOSB,,,
     2                 %VAL(2),BUFFER,%VAL(N),,,)
      ELSE IF (INOUT.EQ.2) THEN
C       Clear Alpha 0 Screen
          RESULT = SYS$QIOW(,%VAL(UNIT),
     1                 %VAL(IO$_MODIFY),IOSB,,,
     2                 %VAL(1),,,,,)
      ELSE IF (INOUT.EQ.3) THEN
C       Clear Primary Screen
          RESULT = SYS$QIOW(,%VAL(UNIT),
     1                 %VAL(IO$_MODIFY),IOSB,,,
     2                 %VAL(2),,,,,)
      ELSE IF (INOUT.EQ.4) THEN
C       Write to Frame Buffer
          RESULT = SYS$QIOW(,%VAL(UNIT),
     1                 %VAL(IO$_WRITEVBLK),IOSB,,,
     2                 %VAL(4),BUFFER,%VAL(N),%VAL(LOC),,)
      END IF
      IF (RESULT.NE.1) THEN
          CALL GRGMSG(RESULT)
          CALL GRQUIT('PK02A: SYS$QIO failure writing to TV')
      END IF
      IF (STATUS.NE.1) THEN
          RESULT = STATUS
          CALL GRGMSG(RESULT)
          CALL GRQUIT('PK02B: SYS$QIO failure writing to TV')
      END IF
      END

C*GRPK03 -- PGPLOT Peritek VCK-Q driver, initialize color display
C+
      SUBROUTINE GRPK03 (UNIT,MONO)
      INTEGER UNIT
      LOGICAL MONO
C
C Initialize the color tables to standard values.
C
C (14-Jul-1989)
C-----------------------------------------------------------------------
      INTEGER*2      I, GCTABL(3,16)
      DATA GCTABL /000,000,000, 255,255,255, 255,000,000, 000,255,000,
     1             000,000,255, 000,255,255, 255,000,255, 255,255,000,
     2             255,128,000, 128,255,000, 000,255,128, 000,128,255,
     3             128,000,255, 255,000,128, 085,085,085, 170,170,170/
C
      DO 20 I=1,16
          CALL GRPK08(I-1, GCTABL(1,I), GCTABL(2,I), GCTABL(3,I), UNIT,
     1                MONO)
   20 CONTINUE
      END

C*GRPK04 -- PGPLOT Peritek VCK-Q driver, clear screens
C+
      SUBROUTINE GRPK04 (ISCR,UNIT)
      INTEGER ISCR,UNIT
C
C Arguments:
C   ISCR     (input) : 1 = clear alpha screen, 2 = clear primary screen
C   UNIT     (input) : channel number for output
C-----------------------------------------------------------------------
      INTEGER*2      BUF(4),LOC(2)
C-----------------------------------------------------------------------
      IF (ISCR.EQ.1) THEN
        CALL GRPK02(2,4,BUF,LOC,UNIT)
      ELSE IF (ISCR.EQ.2) THEN
        CALL GRPK02(3,4,BUF,LOC,UNIT)
      END IF
      END

C*GRPK05 -- PGPLOT Peritek VCK-Q driver, cursor routine
C+
      SUBROUTINE GRPK05 (IX, IY, IC, IER, UNIT)
      INTEGER IX, IY, IC, IER, UNIT
C
C Arguments:
C   IX, IY (in/out) : initial/final coordinates of cursor (device 
C                     coordinates).
C   IC     (output) : character code.
C   IER    (output) : error status (1 => OK).
C   UNIT   (input)  : channel for output to device.
C
C The Peritek device has no hardware cursor. The cursor has to be
C emulated by writing into the image array, and to delete it the 
C former contents must be restored. The cursor is a 5x5 pixel array;
C to avoid edge effects, it cannot be moved within 2 pixels of the 
C edge of the screen.
C
C The cursor is moved by using the arrow keys on the
C terminal; the cursor "speed" (step size) is controlled by the
C PF1 (smallest step) to PF4 (largest step) keys.
C
C The user indicates that the cursor has been positioned by
C typing any character on his keyboard (SYS$COMMAND), with the
C following exceptions: control characters (^C, ^O, ^Q, ^R, ^S,
C ^T, ^U, ^X, ^Y, DEL) are intercepted by the operating system
C and cannot be used; NUL, ESC (^[) and escape sequences (e.g., 
C arrow keys) are ignored.
C 
C (20-Oct-1987)
C-----------------------------------------------------------------------
C CURSIZ is the size of the cursor array: must be odd
      INTEGER        CURSIZ, CURCEN
      PARAMETER      (CURSIZ=15, CURCEN=(CURSIZ+1)/2)
      INTEGER*2      IXG,IYG, LOC2(2)
      INTEGER        GRGETC, SYS$ASSIGN, SYS$DASSGN
      INTEGER        STEP, ICHAN, I, J
      DATA           STEP/4/      ! initial step size
      BYTE           CU1(CURSIZ,CURSIZ), CU2(CURSIZ,CURSIZ)
C-----------------------------------------------------------------------
      IER = SYS$ASSIGN('SYS$COMMAND',ICHAN,,)
      IF (IER.NE.1) RETURN
      IX = MAX(CURCEN-1,MIN(IX,1023-CURCEN+1))
      IY = MAX(CURCEN-1,MIN(IY,1023-CURCEN+1))
   10 IXG = IX
      IYG = IY
C     -- Make cursor visible
      LOC2(2) = IXG-CURCEN+1
      DO J=1,CURSIZ
          LOC2(1) = IYG-CURCEN+J
          CALL GRPK02(0,CURSIZ,CU1(1,J),LOC2,UNIT)
      END DO
      DO I=1,CURSIZ
         DO J=1,CURSIZ
           CU2(I,J) = CU1(I,J)
         END DO      
      END DO
      DO I=1,CURSIZ
          CU2(I,CURCEN) = 1
          CU2(CURCEN,I) = 1
          CU2(I,I) = 0
          CU2(I,CURSIZ+1-I) = 0
      END DO
      DO J=1,CURSIZ
          LOC2(1) = IYG-CURCEN+J
          CALL GRPK02(4,CURSIZ,CU2(1,J),LOC2,UNIT)
      END DO
      IC = GRGETC(ICHAN)
      IF (IC.EQ.-1) THEN
          IY = MIN(1023-CURCEN+1,IY+STEP)
      ELSE IF (IC.EQ.-2) THEN
          IY = MAX(CURCEN-1,IY-STEP)
      ELSE IF (IC.EQ.-3) THEN
          IX = MIN(1023-CURCEN+1,IX+STEP)
      ELSE IF (IC.EQ.-4) THEN
          IX = MAX(CURCEN-1,IX-STEP)
      ELSE IF (IC.EQ.-11) THEN
          STEP = 1
      ELSE IF (IC.EQ.-12) THEN
          STEP = 4
      ELSE IF (IC.EQ.-13) THEN
          STEP = 16
      ELSE IF (IC.EQ.-14) THEN
          STEP = 64
      END IF
C     --- Erase cursor by restoring former image contents
      DO J=1,CURSIZ
          LOC2(1) = IYG-CURCEN+J
          CALL GRPK02(4,CURSIZ,CU1(1,J),LOC2,UNIT)
      END DO
      IF (IC.LE.0 .OR. IC.GT.255) GOTO 10
      IER = SYS$DASSGN(%VAL(ICHAN))
C-----------------------------------------------------------------------
      END                        

C*GRPK07 -- PGPLOT Peritek VCK-Q driver, draw a dot
C+
      SUBROUTINE GRPK07 (ELEM1,LINE1,CI,UNIT)
      INTEGER*2      ELEM1, LINE1, CI
      INTEGER*4      UNIT
C
C ELEM1   I*4      dot element 
C LINE1   I*4      dot line
C CI      I*2      color index to be used
C UNIT    I*4      unit number for output
C
C Note: the arguments are specified as integer*2, but (on the VAX at
C least) integer*4 values may be used. The values should be in the
C range defined by the hardware: (0...1023).
C
C (20-Oct-1987)
C-----------------------------------------------------------------------
      INTEGER*2           DATA
      INTEGER*2     I0, J0, BUF(8), LOC(2)
C
      DATA = CI
      I0 = ELEM1
      J0 = LINE1
      BUF(1)= '4000'O            ! Write Parameter Register 0 or COL0
      BUF(2)= DATA + ISHFT(DATA,8)
      BUF(3)= '4001'O            ! Write Parameter Register 1 or COL1
      BUF(4)= BUF(2)
      BUF(5)= '100000'O          ! AMOVE
      BUF(6)= I0
      BUF(7)= J0
      BUF(8)= '146000'O          ! DOT
      CALL GRPK02(1,8,BUF,LOC,UNIT)
C
      END

C*GRPK08 -- PGPLOT Peritek VCK-Q driver, set color representation
C+
      SUBROUTINE GRPK08 (CIN,R,G,B,UNIT,MONO)
      INTEGER*2 CIN, R, G, B
      INTEGER UNIT
      LOGICAL MONO
C
C Arguments:
C   CIN      I*2     LUT index 0 to 255
C   R,G,B    I*2     Color component 0 to 255
C   UNIT     I*4     Channel number for output
C   MONO     L*4     If .TRUE., convert color to gray shade.
C
C (14-Jul-1989)
C-----------------------------------------------------------------------
      INTEGER*2      MCLR(2), DATA
C
      MCLR(1)=0
      IF (MONO) THEN
          DATA = NINT(0.30*R+0.59*G+0.11*B)
          MCLR(2)=7
          CALL GRPK09(1,DATA,1,CIN,MCLR,UNIT)
      ELSE
          DATA = R
          MCLR(2)=1
          CALL GRPK09(1,DATA,1,CIN,MCLR,UNIT)
          DATA = G
          MCLR(2)=2
          CALL GRPK09(1,DATA,1,CIN,MCLR,UNIT)
          DATA = B
          MCLR(2)=4
          CALL GRPK09(1,DATA,1,CIN,MCLR,UNIT)
      END IF
C
      END

C*GRPK09 -- PGPLOT Peritek VCK-Q driver, input/output CMM data
C+
      SUBROUTINE GRPK09 (INOUT,BUFFER,N,ELEM,MCLR,UNIT)
      INTEGER INOUT, N, ELEM, UNIT, MCLR
      BYTE BUFFER(*)
C
C Arguments:
C
C INOUT (input) : 1 => write, 0 => read
C N (input) : # bytes to transfer
C ELEM (input) : element to write to.
C BUFFER (byte array, dimension at least N, input): the data
C      bytes to be put in the output buffer.
C MCLR (integer*2 array): which map # and which color to modify
C      bit set 0=red, 1=green, 2=blue.
C UNIT (input): channel number for output
C
C (20-Oct-1987)
C-----------------------------------------------------------------------
      INCLUDE '($IODEF)'
C
      INTEGER SYS$QIOW, RESULT, IOSB(2), LOC
      INTEGER*2 STBC(2), STATUS, COUNT, WORD(2)
      EQUIVALENCE (STBC, IOSB(1)), (STATUS, STBC(1)), (COUNT, STBC(2))
      EQUIVALENCE (LOC,WORD(1))
C
      IF (N.LT.1) RETURN
      IF (INOUT.EQ.1) THEN
          WORD(1)=N
          WORD(2)=ELEM
          RESULT = SYS$QIOW(,%VAL(UNIT),
     1                 %VAL(IO$_WRITEVBLK),IOSB,,,
     2                 %VAL(3),BUFFER,%VAL(LOC),%VAL(MCLR),,)
      ELSE                 
          STATUS = 1
          RESULT = 1
      END IF
      IF (RESULT.NE.1) THEN
          CALL GRGMSG(RESULT)
          CALL GRQUIT('PK09A: SYS$QIO failure writing to TV')
      END IF
      IF (STATUS.NE.1) THEN
          RESULT = STATUS
          CALL GRGMSG(RESULT)
          CALL GRQUIT('PK09B: SYS$QIO failure writing to TV')
      END IF
      END

C*PGBIN -- histogram of binned data
C%void cpgbin(int nbin, const float *x, const float *data, \
C% Logical center);
C+
      SUBROUTINE PGBIN (NBIN, X, DATA, CENTER)
      INTEGER NBIN
      REAL X(*), DATA(*)
      LOGICAL CENTER
C
C Plot a histogram of NBIN values with X(1..NBIN) values along
C the ordinate, and DATA(1...NBIN) along the abscissa. Bin width is
C spacing between X values.
C
C Arguments:
C  NBIN   (input)  : number of values.
C  X      (input)  : abscissae of bins.
C  DATA   (input)  : data values of bins.
C  CENTER (input)  : if .TRUE., the X values denote the center of the
C                    bin; if .FALSE., the X values denote the lower
C                    edge (in X) of the bin.
C--
C 19-Aug-92: change argument check (TJP).
C-----------------------------------------------------------------------
      LOGICAL  PGNOTO
      INTEGER  IBIN
      REAL     TX(4), TY(4)
C
C Check arguments.
C
      IF (NBIN.LT.2) RETURN
      IF (PGNOTO('PGBIN')) RETURN
      CALL PGBBUF
C
C Draw Histogram. Centered an uncentered bins are treated separately.
C
      IF (CENTER) THEN
C         !set up initial point.
          TX(2) = (3.*X(1) - X(2))/2.
          TY(2) = DATA(1)
          TX(3) = (X(1) + X(2))/2.
          TY(3) = TY(2)
          CALL GRVCT0(2, .FALSE., 2, TX(2), TY(2))
C         !draw initial horizontal line
C         !now loop over bins
          DO 10 IBIN=2,NBIN-1
              TX(1) = TX(3)
              TX(2) = TX(1)
              TX(3) = ( X(IBIN) + X(IBIN+1) ) / 2.
              TY(1) = TY(3)
              TY(2) = DATA(IBIN)
              TY(3) = TY(2)
              CALL GRVCT0(2, .FALSE., 3, TX, TY)
   10     CONTINUE
C         !now draw last segment.
          TX(1) = TX(3)
          TX(2) = TX(1)
          TX(3) = (3.*X(NBIN) - X(NBIN-1) )/2.
          TY(1) = TY(3)
          TY(2) = DATA(NBIN)
          TY(3) = TY(2)
          CALL GRVCT0(2, .FALSE., 3, TX, TY)
C
C               Uncentered bins
C
      ELSE
C         !set up first line.
          TX(2) = X(1)
          TY(2) = DATA(1)
          TX(3) = X(2)
          TY(3) = TY(2)
          CALL GRVCT0(2, .FALSE., 2, TX(2), TY(2))
          DO 20 IBIN=2,NBIN
              TX(1) = TX(3)
              TX(2) = TX(1)
              IF (IBIN.EQ.NBIN) THEN
                  TX(3) = 2.*X(NBIN) - X(NBIN-1)
              ELSE
                  TX(3) = X(IBIN+1)
              END IF
              TY(1) = TY(3)
C             !get height for last segment.
              TY(2) = DATA(IBIN)
              TY(3) = TY(2)
              CALL GRVCT0(2, .FALSE., 3, TX, TY)
   20     CONTINUE
      END IF
C
      CALL PGEBUF
      END

      PROGRAM PGDEM7
C
C Demonstration program for 3D surface plotting routine FREDDY.
C
      INTEGER PGBEG
      REAL A(51,51), R, SIZE
      INTEGER I, J
C
      IF (PGBEG(0, '?', 1, 1) .NE. 1) THEN
         STOP
      END IF
C
C Calculate a sample data array.
C
      DO 20 I=1,51
         DO 10 J=1,51
            R = (I-26)**2 + (J-26)**2
            R = 0.5*SQRT(R)
            IF (R.GT.0.0) THEN
               A(I,J) = SIN(R)/R
            ELSE
               A(I,J) = 1.0
            END IF
 10      CONTINUE
 20   CONTINUE
C
C FREDDY assumes the window is square of size SIZE.
C
      SIZE = 1.0
      CALL PGENV(0., SIZE, 0., SIZE, 1, -2)
      CALL FREDDY(A,51,51, SIZE, 25.0)
      CALL PGEND
      END
C-----------------------------------------------------------------------
      SUBROUTINE FREDDY(ARRAY,KX,NY,SIZE,ANGLE)
      INTEGER KX, NY
      REAL ARRAY(KX,NY), SIZE, ANGLE
C
C Draws isometric plot of array
C
      REAL FMAX,FMIN,DELTAX,DELTAY,DELTAV,SINE,PEAK,X,DX,HEIGHT
      INTEGER I,J,KI,KJ,NX,MX,MY,STEP,LEFT,RIGHT,IT,MN,INCX
      LOGICAL VISBLE
      COMMON /FREDCM/ DELTAX,X,STEP,LEFT,RIGHT,IT,NX,VISBLE
C
      MN = KX*NY
      NX = KX
C     Check array size:
      IF(NX.LT.2 .OR. NY.LT.2) RETURN
      FMAX = ARRAY(1,1)
      FMIN = FMAX
      DO 20 J=1,NY
          DO 10 I=1,NX
              FMIN = AMIN1(ARRAY(I,J),FMIN)
              FMAX = AMAX1(ARRAY(I,J),FMAX)
   10     CONTINUE
   20 CONTINUE
      DELTAX = SIZE/(NX+NY)
      SINE = SIN(ANGLE/58.)
      DELTAY = DELTAX*SINE
      HEIGHT = SIZE*(1.-ABS(SINE))
      DELTAV = HEIGHT
      FMAX = FMAX-FMIN
      IF(FMAX.LT.0.0001) FMAX = DELTAV
      DELTAV = DELTAV/FMAX
      MX = NX+1
      MY = NY+1
      STEP = MX
C
C Start PGPLOT buffering.
C
      CALL PGBBUF
C
C Work our way down the Y axis, then up the X axis,
C calculating the Y plotter coordinates for each
C column of the plot, doing the hidden-line suppression
C at the same time.
C
      DO 50 J=1,NY
          KJ = MY-J
          KI = 1
C               ( KI,KJ are coordinates of bottom of column)
          ARRAY(KI,KJ) = DELTAY*(KI+KJ) + DELTAV*(ARRAY(KI,KJ)-FMIN)
   30     PEAK = ARRAY(KI,KJ)
   40     KI = KI+1
          KJ = KJ+1
          IF(KI.GT.NX .OR. KJ.GT.NY) GOTO 50
          ARRAY(KI,KJ) = DELTAY*(KI+KJ) + DELTAV*(ARRAY(KI,KJ)-FMIN)
          IF(ARRAY(KI,KJ).GT.PEAK) GOTO 30
          IF(ARRAY(KI,KJ).LE.PEAK) ARRAY(KI,KJ) = -ABS(ARRAY(KI,KJ))
          GOTO 40
   50 CONTINUE
C
C Now to work our way up the X axis
C
      DO 80 I=2,NX
          KI = I
          KJ = 1
          ARRAY(KI,KJ) = DELTAY*(KI+KJ)+DELTAV*(ARRAY(KI,KJ)-FMIN)
   60     PEAK = ARRAY(KI,KJ)
   70     KI = KI+1
          KJ = KJ+1
          IF(KI.GT.NX .OR. KJ.GT.NY) GOTO 80
          ARRAY(KI,KJ) = DELTAY*(KI+KJ)+DELTAV*(ARRAY(KI,KJ)-FMIN)
          IF(ARRAY(KI,KJ).GT.PEAK) GOTO 60
          IF(ARRAY(KI,KJ).LE.PEAK) ARRAY(KI,KJ) = -ABS(ARRAY(KI,KJ))
          GOTO 70
   80 CONTINUE
C
C Draw a line along the bottom of the vertical faces
C
      CALL PGMOVE(DELTAX*(NX+NY-2), DELTAY*(MX))
      CALL PGDRAW(DELTAX*(NY-1),    DELTAY*2)
      CALL PGDRAW(0.0,              DELTAY*MY)
C
C Array is now ready for plotting.  If a point is
C positive, then it is to be plotted at that Y
C coordinate; if it is negative, then it is
C invisible, but at minus that Y coordinate (the point
C where the line heading towards it disappears has to
C be determined by finding the intersection of it and
C the cresting line).
C
C Plot rows:
C
      DO 110 J=1,NY,2
          KJ = MY-J
          DX = DELTAX*(J-2)
          X = DX+DELTAX
          CALL PGMOVE(X,DELTAY*(KJ+1))
          CALL PGDRAW(X,ARRAY(1,KJ))
          VISBLE = .TRUE.
          DO 90 I=2,NX
              RIGHT = I+NX*(KJ-1)
              LEFT = RIGHT-1
              IT = RIGHT
              X = DX+DELTAX*I
              CALL FREDGO(ARRAY,MN)
   90     CONTINUE
C
C Now at far end of row so come back
C
          KJ = KJ-1
          IF(KJ.LE.0) GOTO 170
          VISBLE = ARRAY(NX,KJ).GE.0.0
          DX = DELTAX*(NX+J)
          IF(VISBLE) CALL PGMOVE(DX-DELTAX,ARRAY(NX,KJ))
          DELTAX = -DELTAX
          DO 100 I=2,NX
              KI = MX-I
              LEFT = KI+NX*(KJ-1)
              RIGHT = LEFT+1
              IT = LEFT
              X = DX+DELTAX*I
              CALL FREDGO(ARRAY,MN)
  100     CONTINUE
C
          X = DX+DELTAX*NX
          IF(.NOT.VISBLE) CALL PGMOVE(X,ARRAY(1,KJ))
          CALL PGDRAW(X,DELTAY*(KJ+1))
C               (set DELTAX positive for return trip)
          DELTAX = -DELTAX
  110 CONTINUE
C
C Now do the columns:
C as we fell out of the last DO-loop we do the
C columns in ascending-X order
C
      INCX = 1
      KI = 1
C               (set DELTAX -ve since scanning R to L)
  120 DX = DELTAX*(KI+NY-1)
      DELTAX = -DELTAX
      X = DX+DELTAX
      CALL PGMOVE(X,ARRAY(1,1))
  130 VISBLE = .TRUE.
      DO 140 J=2,NY
          LEFT = KI+NX*(J-1)
          RIGHT = LEFT-NX
          IT = LEFT
          X = DX+DELTAX*J
          CALL FREDGO(ARRAY,MN)
  140 CONTINUE
C
C At far end, increment X and check still inside array
C
      KI = KI+INCX
      IF(KI.LE.0 .OR. KI.GT.NX) GOTO 180
      VISBLE = ARRAY(KI,NY).GE.0.0
      DELTAX = -DELTAX
      DX = DELTAX*(KI-2)
      X = DX+DELTAX
      IF(VISBLE) CALL PGMOVE(X,ARRAY(KI,NY))
      DO 150 J=2,NY
          KJ = MY-J
          RIGHT = KI+NX*(KJ-1)
          LEFT = RIGHT+NX
          IT = RIGHT
          X = DX+DELTAX*J
          CALL FREDGO(ARRAY,MN)
  150 CONTINUE
C
      X = DX+DELTAX*NY
      IF(.NOT.VISBLE) CALL PGMOVE(X,ARRAY(KI,1))
      IF(KI.EQ.1) GOTO 180
      CALL PGDRAW(X,DELTAY*(KI+1))
      KI = KI+INCX
      IF(KI.GT.NX) GOTO 180
      IF(KI.EQ.1) GOTO 120
  160 DELTAX = -DELTAX
      DX = DELTAX*(1-KI-NY)
      X = DX+DELTAX
      CALL PGMOVE(X,DELTAY*(KI+1))
      CALL PGDRAW(X,ARRAY(KI,1))
      GOTO 130
C
C Do columns backwards because ended rows at far end of X
C
  170 KI = NX
      INCX = -1
      DX = DELTAX*(KI+NY)
      GOTO 160
C
C
  180 CALL PGEBUF
      END
C-----------------------------------------------------------------------
      SUBROUTINE FREDGO(ARRAY,MN)
      INTEGER MN
      REAL ARRAY(MN)
C
      INTEGER STEP,LEFT,RIGHT,IT,NX
      LOGICAL VISBLE
      REAL AL,AR,BL,EM,XX,X,Y,DELTAX
      COMMON /FREDCM/ DELTAX,X,STEP,LEFT,RIGHT,IT,NX,VISBLE
C
C Test visibility
C
      IF(ARRAY(IT).LT.0.0) GOTO 80
C
C This point is visible - was last?
C
      IF(VISBLE) GOTO 50
C
C No: calculate point where this line vanishes
C
   10 IF(LEFT.LE.NX .OR. MOD(LEFT-1,NX).EQ.0 .OR.
     1     RIGHT.LE.NX .OR. MOD(RIGHT-1,NX).EQ.0) GOTO 100
      AL = ABS(ARRAY(LEFT))
      AR = ABS(ARRAY(RIGHT))
      IF(ARRAY(LEFT).LT.0.0) GOTO 70
C               Right-hand point is crested
   20 RIGHT = RIGHT-STEP
      IF(ARRAY(RIGHT).LT.0.0) GOTO 20
C               Left-hand end of cresting line is either
C               RIGHT+NX or RIGHT-1
      LEFT = RIGHT+NX
      IF(ARRAY(LEFT).LT.0.0) LEFT = RIGHT-1
C
C               RIGHT and LEFT index into the endpoints of the
C               cresting line
   30 BL = ABS(ARRAY(LEFT))
      EM = ABS(ARRAY(RIGHT))-BL
      XX = EM-AR+AL
      IF(ABS(XX).LT.0.0001) GOTO 60
      XX = (AL-BL)/XX
   40 Y = EM*XX+BL
      IF(DELTAX.GT.0.0) XX = 1.0-XX
      XX = X-XX*DELTAX
      IF(VISBLE) GOTO 90
C               Drawing a line from an invisible point
C               to a visible one
      CALL PGMOVE(XX,Y)
      VISBLE = .TRUE.
   50 CALL PGDRAW(X,ARRAY(IT))
      RETURN
C
   60 XX = 0.5
      GOTO 40
C
C Left-hand point crested
C
   70 LEFT = LEFT-STEP
      IF(ARRAY(LEFT).LT.0.0) GOTO 70
C
C Right-hand end of cresting line is either LEFT+1 or LEFT-NX
C
      RIGHT = LEFT+1
      IF(ARRAY(RIGHT).LT.0.0) RIGHT = LEFT-NX
      GOTO 30
C
C This point is invisible; if last one was too, then forget it;
C else draw a line towards it
C
   80 IF(.NOT.VISBLE) RETURN
      GOTO 10
C
   90 CALL PGDRAW(XX,Y)
  100 VISBLE = .FALSE.
      RETURN
      END

C*PGTEXT -- write text (horizontal, left-justified)
C%void cpgtext(float x, float y, const char *text);
C+
      SUBROUTINE PGTEXT (X, Y, TEXT)
      REAL X, Y
      CHARACTER*(*) TEXT
C
C Write text. The bottom left corner of the first character is placed
C at the specified position, and the text is written horizontally.
C This is a simplified interface to the primitive routine PGPTXT.
C For non-horizontal text, use PGPTXT.
C
C Arguments:
C  X      (input)  : world x-coordinate of start of string.
C  Y      (input)  : world y-coordinate of start of string.
C  TEXT   (input)  : the character string to be plotted.
C--
C (2-May-1983)
C-----------------------------------------------------------------------
      CALL PGPTXT(X, Y, 0.0, 0.0, TEXT)
      END

C*GRMOVR -- move pen (relative, world coordinates)
C+
      SUBROUTINE GRMOVR (DX,DY)
C
C GRPCKG: move the pen through a specified displacement.
C
C Arguments:
C
C DX, DY (real, input): the displacement in world coordinates: the pen
C       position is incremented by DX in x and DY in y.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL     DX,DY
C
      IF (GRCIDE.GE.1) THEN
          GRXPRE(GRCIDE) = GRXPRE(GRCIDE) + DX*GRXSCL(GRCIDE)
          GRYPRE(GRCIDE) = GRYPRE(GRCIDE) + DY*GRYSCL(GRCIDE)
      END IF
      END

C*GRVCT0 -- draw line segments or dots
C+
      SUBROUTINE GRVCT0 (MODE,ABSXY,POINTS,X,Y)
C
C GRPCKG (internal routine): Draw a line or a set of dots. This
C is the same as GRVECT, but without device selection. It can be used to
C draw a single line-segment, a continuous series of line segments, or
C one or more single dots (pixels).
C
C Arguments:
C
C MODE (input, integer): if MODE=1, a series of line segments is drawn,
C       starting at the current position, moving to X(1),Y(1), ... and
C       ending at X(POINTS),Y(POINTS).
C       If MODE=2, the first vector is blanked, so the line starts at
C       X(1),Y(1).
C       If MODE=3, a single dot is placed at each coordinate pair, with
C       no connecting lines.
C ABSXY (input, logical): if TRUE, the coordinates are absolute device
C       coordinates; if FALSE, they are world coordinates and the
C       scaling transformation is applied.
C POINTS (input, integer): the number of coordinate pairs.
C X, Y (input, real arrays, dimensioned POINTS or greater): the
C       X and Y coordinates of the points.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  I, MODE, POINTS
      LOGICAL  ABSXY
      REAL     X(POINTS), Y(POINTS), XCUR, YCUR
C
      IF (MODE.EQ.1) THEN
          CALL GRTXY0(ABSXY, X(1), Y(1), XCUR, YCUR)
          CALL GRLIN0(XCUR, YCUR)
      ELSE IF (MODE.EQ.2) THEN
          CALL GRTXY0(ABSXY, X(1), Y(1), GRXPRE(GRCIDE), GRYPRE(GRCIDE))
      END IF
      IF (MODE.EQ.1 .OR. MODE.EQ.2) THEN
          DO 10 I=2,POINTS
              CALL GRTXY0(ABSXY, X(I), Y(I), XCUR, YCUR)
              CALL GRLIN0(XCUR, YCUR)
   10     CONTINUE
      ELSE IF (MODE.EQ.3) THEN
          DO 20 I=1,POINTS
              CALL GRTXY0(ABSXY, X(I), Y(I), XCUR, YCUR)
              CALL GRDOT0(XCUR, YCUR)
   20     CONTINUE
      END IF
C
      END

C*GRPOCL -- polygon clip
C+
      SUBROUTINE GRPOCL (N,PX,PY, EDGE, VAL, MAXOUT, NOUT, QX, QY)
      INTEGER N, NOUT, EDGE, MAXOUT
      REAL    PX(*), PY(*), QX(*), QY(*)
      REAL    VAL
C
C Clip a polygon against a rectangle: Sutherland-Hodgman algorithm.
C this routine must be called four times to clip against each of the
C edges of the rectangle in turn.      
C
C Arguments:
C
C N (input, integer): the number of vertices of the polygon (at least
C       3).
C PX, PY (input, real arrays, dimension at least N): world coordinates
C       of the N vertices of the input polygon.
C EDGE (input, integer):
C     1: clip against left edge,   X > XMIN=VAL
C     2: clip against right edge,  X < XMAX=VAL
C     3: clip against bottom edge, Y > YMIN=VAL
C     4: clip against top edge,    Y < YMIN=VAL
C VAL  (input, real): coordinate value of current edge.
C MAXOUT (input, integer): maximum number of vertices allowed in
C     output polygon (dimension of QX, QY).
C NOUT (output, integer): the number of vertices in the clipped polygon.
C QX, QY (output, real arrays, dimension at least MAXOUT): world
C       coordinates of the NOUT vertices of the output polygon.
C--
C 19-Sep-1994 - [TJP].
C 27-Feb-1996 - fix bug: overflow if coordinates are large [TJP].
C 11-Jul-1996 - fix bug: left and bottom edges disappeared when precisely
C               on edge [Remko Scharroo]
C-----------------------------------------------------------------------
      INTEGER I
      REAL FX, FY, SX, SY
C
      NOUT = 0
      DO 100 I=1,N
         IF (I.EQ.1) THEN
C           -- save first point
            FX = PX(I)
            FY = PY(I)
         ELSE IF ((EDGE.EQ.1 .OR.EDGE.EQ.2) .AND.
     :            (SIGN(1.0,PX(I)-VAL).NE.SIGN(1.0,SX-VAL))) THEN
C           -- SP intersects this edge: output vertex at intersection
            NOUT = NOUT+1
            IF (NOUT.LE.MAXOUT) THEN
               QX(NOUT) = VAL
               QY(NOUT) = SY + (PY(I)-SY)*((VAL-SX)/(PX(I)-SX))
            END IF
         ELSE IF ((EDGE.EQ.3 .OR.EDGE.EQ.4) .AND.
     :            (SIGN(1.0,PY(I)-VAL).NE.SIGN(1.0,SY-VAL))) THEN
C           -- SP intersects this edge: output vertex at intersection
            NOUT = NOUT+1
            IF (NOUT.LE.MAXOUT) THEN
               QX(NOUT) = SX + (PX(I)-SX)*((VAL-SY)/(PY(I)-SY))
               QY(NOUT) = VAL
            END IF
         END IF
         SX = PX(I)
         SY = PY(I)
         IF ((EDGE.EQ.1.AND.SX.GE.VAL) .OR.
     :       (EDGE.EQ.2.AND.SX.LE.VAL) .OR.
     :       (EDGE.EQ.3.AND.SY.GE.VAL) .OR.
     :       (EDGE.EQ.4.AND.SY.LE.VAL)) THEN
C           -- output visible vertex S
            NOUT = NOUT + 1
            IF (NOUT.LE.MAXOUT) THEN
                QX(NOUT) = SX
                QY(NOUT) = SY
            END IF
         END IF
 100  CONTINUE
C      -- Does SF intersect edge?
      IF ((EDGE.EQ.1 .OR. EDGE.EQ.2) .AND.
     :    (SIGN(1.0,SX-VAL).NE.SIGN(1.0,FX-VAL))) THEN
         NOUT = NOUT+1
         IF (NOUT.LE.MAXOUT) THEN
            QX(NOUT) = VAL
            QY(NOUT) = SY + (FY-SY)*((VAL-SX)/(FX-SX))
         END IF
      ELSE IF ((EDGE.EQ.3 .OR. EDGE.EQ.4) .AND.
     :         (SIGN(1.0,SY-VAL).NE.SIGN(1.0,FY-VAL))) THEN
         NOUT = NOUT+1
         IF (NOUT.LE.MAXOUT) THEN
            QY(NOUT) = VAL
            QX(NOUT) = SX + (FX-SX)*((VAL-SY)/(FY-SY))
         END IF
      END IF
C
      END

C*GRGRAY -- gray-scale map of a 2D data array
C+
      SUBROUTINE GRGRAY (A, IDIM, JDIM, I1, I2, J1, J2,
     1                   FG, BG, PA, MININD, MAXIND, MODE)
      INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE
      REAL    A(IDIM,JDIM)
      REAL    FG, BG
      REAL    PA(6)
C
C This is a device-dependent support routine for PGGRAY.
C
C Draw gray-scale map of an array in current window. Array
C values between FG and BG are shaded in gray levels determined
C by linear interpolation. FG may be either less than or greater
C than BG.  Array values outside the range FG to BG are
C shaded black or white as appropriate.
C
C GRGRAY uses GRIMG0 on devices with enough color indices available.
C Note that it changes the color table to gray-scale.
C Otherwise in does a random dither with GRIMG3.
C
C Arguments:
C  A      (input)  : the array to be plotted.
C  IDIM   (input)  : the first dimension of array A.
C  JDIM   (input)  : the second dimension of array A.
C  I1, I2 (input)  : the inclusive range of the first index
C                    (I) to be plotted.
C  J1, J2 (input)  : the inclusive range of the second
C                    index (J) to be plotted.
C  FG     (input)  : the array value which is to appear in
C                    foreground color.
C  BG     (input)  : the array value which is to appear in
C                    background color.
C  PA     (input)  : transformation matrix between array grid and
C                    device coordinates (see GRCONT).
C  MODE   (input)  : transfer function.
C--
C 12-Dec-1986 - Speed up plotting [J. Biretta].
C  3-Apr-1987 - Add special code for /PS, /VPS, /GR.
C  2-Sep-1987 - Adapted from PGGRAY [TJP].
C  1-Dec-1988 - Put random-number generator inline [TJP].
C  3-Apr-1989 - Use "line of pixels" primitive where available [TJP].
C  6-Sep-1989 - Changes for standard Fortran-77 [TJP].
C 19-Jan-1990 - Add special code for /CPS, /VCPS [DLM]
C  3-Sep-1992 - Add special code for NULL device [TJP].
C 25-Nov-1992 - Add special code for /NEXT [AFT].
C 17-Mar-1994 - Scale in device coordinates [TJP].
C 31-Aug-1994 - use GRIMG0 when appropriate [TJP].
C  7-Sep-1994 - speed up random dither [TJP].
C  8-Feb-1995 - use color ramp based on color indices 0 and 1 [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER I
      REAL    A0, A1, CR0, CG0, CB0, CR1, CG1, CB1
      INTRINSIC REAL
C-----------------------------------------------------------------------
C
C N.B. Arguments are assumed to be valid (checked by PGGRAY).
C
C Use GRIMG0 if this an appropriate device; first initialize the
C color table to a linear ramp between the colors assigned to color
C indices 0 and 1.
C
      IF (GRGCAP(GRCIDE)(7:7).NE.'N' .AND. MAXIND-MININD .GT. 15) THEN
         CALL GRQCR(0, CR0, CG0, CB0)
         CALL GRQCR(1, CR1, CG1, CB1)
         DO 5 I=MININD,MAXIND
            A0 = REAL(I-MININD)/REAL(MAXIND-MININD)
            A1 = 1.0 - A0
            CALL GRSCR(I, A0*CR0+A1*CR1, A0*CG0+A1*CG1, A0*CB0+A1*CB1)
 5       CONTINUE
         CALL GRIMG0(A, IDIM, JDIM, I1, I2, J1, J2,
     :               FG, BG, PA, MININD, MAXIND, MODE)
         RETURN
C
C Otherwise use random dither in current color index.
C
      ELSE
         CALL GRIMG3(A, IDIM, JDIM, I1, I2, J1, J2,
     :               FG, BG, PA, MODE)
      END IF
C-----------------------------------------------------------------------
      END

C*PGQINF -- inquire PGPLOT general information
C%void cpgqinf(const char *item, char *value, int *value_length);
C+
      SUBROUTINE PGQINF (ITEM, VALUE, LENGTH)
      CHARACTER*(*) ITEM, VALUE
      INTEGER LENGTH
C
C This routine can be used to obtain miscellaneous information about
C the PGPLOT environment. Input is a character string defining the
C information required, and output is a character string containing the
C requested information.
C
C The following item codes are accepted (note that the strings must
C match exactly, except for case, but only the first 8 characters are
C significant). For items marked *, PGPLOT must be in the OPEN state
C for the inquiry to succeed. If the inquiry is unsuccessful, either
C because the item code is not recognized or because the information
C is not available, a question mark ('?') is returned.
C
C   'VERSION'     - version of PGPLOT software in use.
C   'STATE'       - status of PGPLOT ('OPEN' if a graphics device
C                   is open for output, 'CLOSED' otherwise).
C   'USER'        - the username associated with the calling program.
C   'NOW'         - current date and time (e.g., '17-FEB-1986 10:04').
C   'DEVICE'    * - current PGPLOT device or file.
C   'FILE'      * - current PGPLOT device or file.
C   'TYPE'      * - device-type of the current PGPLOT device.
C   'DEV/TYPE'  * - current PGPLOT device and type, in a form which
C                   is acceptable as an argument for PGBEG.
C   'HARDCOPY'  * - is the current device a hardcopy device? ('YES' or
C                   'NO').
C   'TERMINAL'  * - is the current device the user's interactive
C                   terminal? ('YES' or 'NO').
C   'CURSOR'    * - does the current device have a graphics cursor?
C                   ('YES' or 'NO').
C   'SCROLL'    * - does current device have rectangle-scroll
C                   capability ('YES' or 'NO'); see PGSCRL.
C
C Arguments:
C  ITEM  (input)  : character string defining the information to
C                   be returned; see above for a list of possible
C                   values.
C  VALUE (output) : returns a character-string containing the
C                   requested information, truncated to the length 
C                   of the supplied string or padded on the right with 
C                   spaces if necessary.
C  LENGTH (output): the number of characters returned in VALUE
C                   (excluding trailing blanks).
C--
C 18-Feb-1988 - [TJP].
C 30-Aug-1988 - remove pseudo logical use of IER.
C 12-Mar-1992 - change comments for clarity.
C 17-Apr-1995 - clean up some zero-length string problems [TJP].
C  7-Jul-1995 - get cursor information directly from driver [TJP].
C 24-Feb-1997 - add SCROLL request.
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      INTEGER IER, L1, GRTRIM
      LOGICAL INTER, SAME
      CHARACTER*8 TEST
      CHARACTER*64 DEV1
C
C Initialize PGPLOT if necessary.
C
      CALL PGINIT
C
      CALL GRTOUP(TEST,ITEM)
      IF (TEST.EQ.'USER') THEN
          CALL GRUSER(VALUE, LENGTH)
          IER = 1
      ELSE IF (TEST.EQ.'NOW') THEN
          CALL GRDATE(VALUE, LENGTH)
          IER = 1
      ELSE IF (TEST.EQ.'VERSION') THEN
          VALUE = 'v5.2.2'
          LENGTH = 6
          IER = 1
      ELSE IF (TEST.EQ.'STATE') THEN
          IF (PGID.LT.1 .OR. PGID.GT.PGMAXD) THEN
             VALUE = 'CLOSED'
             LENGTH = 6
          ELSE IF (PGDEVS(PGID).EQ.0) THEN
             VALUE = 'CLOSED'
             LENGTH = 6
          ELSE
             VALUE = 'OPEN'
             LENGTH = 4
          END IF
          IER = 1
      ELSE IF (PGID.LT.1 .OR. PGID.GT.PGMAXD) THEN
          IER = 0
      ELSE IF (PGDEVS(PGID).EQ.0) THEN
          IER = 0
      ELSE IF (TEST.EQ.'DEV/TYPE') THEN
          CALL GRQDT(VALUE)
          LENGTH = GRTRIM(VALUE)
          IER = 0
          IF (LENGTH.GT.0) IER = 1
      ELSE IF (TEST.EQ.'DEVICE' .OR. TEST.EQ.'FILE') THEN
          CALL GRQDEV(VALUE, LENGTH)
          IER = 1
      ELSE IF (TEST.EQ.'TERMINAL') THEN
          CALL GRQDEV(DEV1, L1)
          IF (L1.GE.1) THEN
             CALL GRTTER(DEV1(1:L1), SAME)
          ELSE
             SAME = .FALSE.
          END IF
          IF (SAME) THEN
              VALUE = 'YES'
              LENGTH = 3
          ELSE
              VALUE = 'NO'
              LENGTH = 2
          END IF
          IER = 1
      ELSE IF (TEST.EQ.'TYPE') THEN
          CALL GRQTYP(VALUE,INTER)
          LENGTH = GRTRIM(VALUE)
          IER = 0
          IF (LENGTH.GT.0) IER = 1
      ELSE IF (TEST.EQ.'HARDCOPY') THEN
          CALL GRQTYP(VALUE,INTER)
          IF (INTER) THEN
              VALUE = 'NO'
              LENGTH = 2
          ELSE
              VALUE = 'YES'
              LENGTH = 3
          END IF
          IER = 1
      ELSE IF (TEST.EQ.'CURSOR') THEN
          CALL GRQCAP(DEV1)
          IF (DEV1(2:2).EQ.'N') THEN
              VALUE = 'NO'
              LENGTH = 2
          ELSE
              VALUE = 'YES'
              LENGTH = 3
          END IF
          IER = 1
      ELSE IF (TEST.EQ.'SCROLL') THEN
          CALL GRQCAP(DEV1)
          IF (DEV1(11:11).NE.'S') THEN
              VALUE = 'NO'
              LENGTH = 2
          ELSE
              VALUE = 'YES'
              LENGTH = 3
          END IF
          IER = 1
      ELSE
          IER = 0
      END IF
      IF (IER.NE.1) THEN
         VALUE = '?'
         LENGTH = 1
      ELSE IF (LENGTH.LT.1) THEN
         LENGTH = 1
         VALUE = ' '
      END IF
      END

C*GRGCOM -- read with prompt from user's terminal (NAGWare f95)
C+
      INTEGER FUNCTION GRGCOM(STRING, PROMPT, L)
      CHARACTER*(*) STRING, PROMPT
      INTEGER L
C
C Issue prompt and read a line from the user's terminal; in VMS,
C this is equivalent to LIB$GET_COMMAND.
C
C Arguments:
C  STRING : (output) receives the string read from the terminal.
C  PROMPT : (input) prompt string.
C  L      : (output) length of STRING.
C
C Returns:
C  GRGCOM : 1 if successful, 0 if an error occurs (e.g., end of file).
C--
C 25-Mar-1998
C-----------------------------------------------------------------------
      INTEGER IER
C
      GRGCOM = 0
      L = 0
      IER = 0
      WRITE (*, '(1X,A)', ADVANCE="NO", IOSTAT=IER) PROMPT
      IF (IER.EQ.0) READ (*, '(A)', IOSTAT=IER) STRING
      IF (IER.EQ.0) GRGCOM = 1
      L = LEN(STRING)
   10 IF (STRING(L:L).NE.' ') GOTO 20
          L = L-1
          GOTO 10
   20 CONTINUE
      END

*HJDRIV -- PGPLOT Hewlett Packard [Desk/Laser] Jet driver
C+
      SUBROUTINE HJDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Hewlett Packard Desk/Laserjet device.
C
C Version 1.0  - 1989 Apr 09 - S. C. Allendorf
C                              Combined all drivers into one driver that
C                              uses a logical name to choose the format.
C Version 1.1  - 1989 Sept - B. H. Toby
C                              (1) adapt for PC version of PGPLOT
C                              (2) use alternate logical name definitions
C                              (3) support for DeskJet/ " Plus/ " 500
C                              (4) reduce page size to 10.25 to fix PGIDENT
C
C Version 1.2  - 1991 Aug - B. H. Toby
C                              Clean up and add code for GRIFB1 since the
C                              subroutine is not in GRPCKG as of PGPLOT V4.9d
C
C   IBM PC / HP DeskJet printer usage
C       Default file name is LPT1 (parallel port#1)
C       Setup the port using MODE LPTn:,,P         (parallel)
C                         or MODE COMn:96,N,8,1,P  (serial)
C   Use COMn/HJ or LPTn/HJ to send output directly to a device
C       or FILE.EXT/HJ or d:\path\file.ext/HJ to send the output
C      to a file
C   Files can be written to disk and then copied to the printer.
C     However, there is a problem in treating plot files, since they
C     may contain ^Z (end-of-file) and other control characters. Use
C              COPY file.ext /B   LPT1:
C     to print the file.
C   Note that logical name PGPLOT_xx under VMS corresponds to MS-DOS
C       environment variable PG_xxx
C Ported back to VAX/VMS, lines of code changed are indicated by a "C!" flag.
C=======================================================================
C
C Supported device: Hewlett Packard LaserJet, LaserJet+, or LaserJet II.
C                   DeskJet, DeskJet Plus, DeskJet 500
C
C Device type code: /HJ
C
C Default device name: PGPLOT.HJPLT.
C
C Default view surface dimensions: Depends on which driver settings are
C chosen, via logical names PGPLOT_HJ_MODE, PGPLOT_HJ_MAR, PGPLOT_HJ_SIZE
C and PGPLOT_HJ_PAGE.
C
C Resolution: Depends on which driver settings are chosen, via
C logical names PGPLOT_HJ_MODE or PGPLOT_HJ_RES.
C
C Color capability: Color indices 0 (erase, white) and 1 (black) are
C supported. It is not possible to change color representation.
C
C Input capability: None.
C
C File format: See the LaserJet & DeskJet Printer Technical Reference Manuals
C for details of the file format.
C
C Obtaining hardcopy: Use the command PRINT/PASSALL.
C
C Logical Name Usage:
C ------- ---- ------
C
C   PGPLOT_HJ_MODE: use $ DEFINE PGPLOT_HJ_MODE HJnn
C
C     where nn is a number 1 - NDEV inclusive.  You may also use one of the
C     equivalent names listed below.
C       Thus  $ DEFINE PGPLOT_HJ_MODE HJ01
C        and  $ DEFINE PGPLOT_HJ_MODE LHOR  are equivalent (etc.)
C     The equivalent names are an attempt to make the driver names make
C     sense.  They are decoded as follows:
C
C        1st character: P for protrait orientation or
C                       L for landscape orientation.
C        2nd character: H for high resolution (300 dpi) or
C                       M for medium resolution (150 dpi) or
C                       L for low resolution (100 dpi).
C        3rd character: B for a straight bitmap dump (subroutine GRHJ01) or
C                       O for an optimized bitmap dump (subroutine GRHJ02).
C        4th character: R for a rectangular view surface or
C                       S for a square view surface.
C
C     A few notes are in order.  First, not all of the possible combinations
C     above are supported (currently).  The driver that goes by the name of
C     PHOT is a driver that puts out bitmaps suitable for inclusion in TeX
C     output if you are using the Arbortext DVIHP program.  The only drivers
C     that will work with unexpanded LaserJet are HJ08 and HJ09.  The other
C     seven drivers require a LaserJet Plus or LaserJet II.  Finally, do NOT
C     attempt to send grayscale plots to the drivers that use the optimized
C     bitmap dumps.  Terrible things will happen.
C
C       Driver  Equiv         Size (H x V)          Resolution
C       ------  -----     ---------------------    ----------
C        HJ01   LHOR        10.25 by  8.00 inches   300 DPI
C        HJ02   PHOR         8.00 by 10.25 inches   300 DPI
C        HJ03   PHOT         8.00 by 10.25 inches   300 DPI
C        HJ04   LHBR         6.54 by  4.91 inches   300 DPI
C        HJ05   PHBS         5.65 by  5.65 inches   300 DPI
C        HJ06   LMBR        10.25 by  8.00 inches   150 DPI
C        HJ07   PMBR         8.00 by 10.25 inches   150 DPI
C        HJ08   PMBS         4.48 by  4.48 inches   150 DPI
C        HJ09   PLBS         6.00 by  6.00 inches   100 DPI
C
C  The following logical names will override the PGPLOT_HJ_MODE settings,
C  if used.
C
C   PGPLOT_HJ_RES: use $ DEFINE PGPLOT_HJ_RES x  where x is H, M, L or V
C          H or HIGH     for 300 bpi
C          M or MEDIUM   for 150 bpi
C          L or LOW      for 100 bpi
C          V or VERYLOW  for  75 bpi
C
C   PGPLOT_HJ_MAR: use $ DEFINE PGPLOT_HJ_MAR  "xx.xx,yy.yy"
C       where "xx.xx" and "yy.yy" are the vertical and horizontal
C       margin dimensions in inches. The number of characters, including
C       spaces preceeding and following the comma, should not exceed five.
C         $ DEFINE PGPLOT_HJ_MAR  "1.0,1.0" is valid
C         $ DEFINE PGPLOT_HJ_MAR  " 1.0 ,1.0" is valid
C         but $ DEFINE PGPLOT_HJ_MAR  " 1.00 ,1.0" is not valid
C
C   PGPLOT_HJ_SIZE: use $ DEFINE PGPLOT_HJ_SIZE  "xx.xx,yy.yy"
C       where "xx.xx" and "yy.yy" are the vertical and horizontal
C       plot dimensions in inches. The number of characters, including
C       spaces preceeding and following the comma, should not exceed five.
C         $ DEFINE PGPLOT_HJ_SIZE  "10.,8." is valid
C         $ DEFINE PGPLOT_HJ_SIZE  "10.0 , 8.0 " is valid
C         but $ DEFINE PGPLOT_HJ_SIZE  " 10.0 ,8.0" is not valid
C
C   PGPLOT_HJ_TEX: use $ DEFINE PGPLOT_HJ_TEX  T
C         if PGPLOT_HJ_TEX is defined with any value, TeX mode (see above)
C         will be used.
C
C   PGPLOT_HJ_NOFF: use $ DEFINE PGPLOT_HJ_NOFF  T
C         if PGPLOT_HJ_NOFF is defined with any value, the form feed
C         needed to eject the final page will be omitted. This is useful
C         for spooled printers -- it prevents wasted (blank) pages.
C
C   PGPLOT_HJ_PAGE: use $ DEFINE PGPLOT_HJ_PAGE x  where x is L or P
C     Use L (or LANDSCAPE) for Landscape mode
C     Use P (or PORTRAIT) for Portrait mode
C
C   PGPLOT_HJ_OPT: use $ DEFINE PGPLOT_HJ_OPT x  where x is O or C
C     Use O (or OPTIMIZE) so that bitmap will be "optimized"
C     Use C (or COMPRESS) so that bitmap will be "compressed"
C
C       "Optimized" mode minimizes the memory usage for the LaserJet devices.
C       This sometimes leads to a larger file than if optimization is not
C       used. Optimized mode may not be used with the DeskJet devices.
C
C       "Compressed" mode decreases the size of the bitmap file for later
C       model HP devices, particularly the DeskJet devices.
C
C-----------------------------------------------------------------------
C
C This driver was originally written by S. C. Allendorf and modified
C by B. H. Toby. Any bugs are likely due to my (BHT) kludges. Send
C improvements and fixes to this driver to sca@iowa.physics.uiowa.edu
C (Internet) or IOWA::SCA (SPAN) and to TOBY@PETVAX.LRSM.UPENN.EDU.
C
C-----------------------------------------------------------------------
C                                       This is the number of currently
C                                       installed device types.
      INTEGER*4  NDEV
      PARAMETER  (NDEV = 9)
C
      LOGICAL    INIT  /.TRUE./
      INTEGER*4  BX, BY, DEVICE, I, IC, IER
      INTEGER*4  LUN, NPICT
      REAL*4     XBUF(4)
      REAL*4     XMAX, YMAX
      CHARACTER  ALTTYP(NDEV)*3, MODE*30, MSG*10
      CHARACTER  TYPE(NDEV)*4
      INTEGER    GRTRIM
C! VAX/VMS
      INTEGER*4  GRFMEM, GRGMEM
      CHARACTER  DEFNAM*12
      PARAMETER  (DEFNAM = 'PGPLOT.HJPLT')
      BYTE       ESC, FF
      INTEGER*4  BUFFER
C! PC:
C!      CHARACTER  DEFNAM*4
C!      PARAMETER  (DEFNAM = 'LPT1')
C!      INTEGER*1  ESC, FF
C!      INTEGER*1  BUFFER[ALLOCATABLE, HUGE] (:,:)
C
      PARAMETER  (ESC = 27)
      PARAMETER  (FF = 12)
C actual settings
      LOGICAL    TEX,NOFF
      REAL*4     T1,T2
      REAL*4     dev_VC, dev_HC
      REAL*4     dev_resol,dev_maxX,dev_maxY
      LOGICAL    dev_bitmap_L, dev_port_L, dev_cmprs_L
      CHARACTER  dev_name*80
 
C                                       These are the NDEV sets of
C                                       device characteristics.
      LOGICAL    BITMAP(NDEV)
     1              /.FALSE., .FALSE., .FALSE.,  .TRUE.,  .TRUE.,
     2                .TRUE.,  .TRUE.,  .TRUE.,  .TRUE./
      LOGICAL    PORTRAIT(NDEV)
     1              /.FALSE.,  .TRUE.,  .TRUE., .FALSE.,  .TRUE.,
     2               .FALSE.,  .TRUE.,  .TRUE.,  .TRUE./
      REAL*4  HC(NDEV)
     1              /     0.,      0.,      0.,    1.58,    1.22,
     2                    0.,      0.,    1.80,    1.05/
      REAL*4  VC(NDEV)
     1              /     0.,      0.,      0.,    1.96,    2.42,
     2                    0.,      0.,    3.00,    2.23/
      REAL*4     XPAGMX(NDEV)
     1              /  10.25,    8.00,    8.00,    6.54,    5.65,
     2                 10.25,    8.00,    4.48,    6.00/
      REAL*4     YPAGMX(NDEV)
     1              /   8.00,   10.25,   10.25,    4.91,    5.65,
     2                  8.00,   10.25,    4.48,    6.00/
      INTEGER*2  RESOL(NDEV)
     1              /    300,     300,     300,     300,     300,
     2                   150,     150,     150,     100/
C Names for PGPLOT_HJ_MODE
      DATA TYPE     / 'LHOR',  'PHOR',  'PHOT',  'LHBR',  'PHBS',
     1                'LMBR',  'PMBR',  'PMBS',  'PLBS'/
C These names are around only for (pre)historical reasons.
      DATA ALTTYP   /  'HPN',   'HPV',   'TEX',   'HPR',   'HPE',
     1                 'HPF',   'HPT',   'HPH',   'HPM'/
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C                                       First time, translate logical
C                                       name PGPLOT_HJ_MODE and set
C                                       device accordingly.
      IF (INIT) THEN
         CALL GRGENV ('HJ_MODE', MODE, I)
         DO 1 I = 1, NDEV
            WRITE (MSG, '(A2, I2.2)') 'HJ', I
            IF (MODE(1:4) .EQ. TYPE(I) .OR.
     1          MODE(1:3) .EQ. ALTTYP(I) .OR.
     2          MODE(1:4) .EQ. MSG(1:4)) THEN
               DEVICE = I
               GOTO 2
            END IF
    1    CONTINUE
C                                       If no match, choose LMBR
         DEVICE = 6
    2    INIT = .FALSE.
C                                       See if user has chosen the
C                                       TeX plotfile format.
         TEX = .FALSE.
         IF (DEVICE .EQ. 3) TEX = .TRUE.
         dev_cmprs_L = .FALSE.
C-----------------------------------------------------------------------
C set actual device settings from table entries
C  dev_VC and dev_HC are margin settings in inches: for non-optimized bitmaps
         dev_VC = VC(DEVICE)
         dev_HC = HC(DEVICE)
C  dev_resol  is the resolution in dots per inch
         dev_resol = RESOL(DEVICE)
C  dev_maxX and dev_maxY are the X and Y plot limits in inches
         dev_maxX = Xpagmx(DEVICE)
         dev_maxY = Ypagmx(DEVICE)
C  if dev_bitmap_L is false then the file can be optimized
         dev_bitmap_L = BITMAP(DEVICE)
C  if dev_port_L is false then a landscape orientation is used
         dev_port_L = PORTRAIT(DEVICE)
C  if TEX is true then much of the device control code is omitted so that
C    the file can be included by the TeX post-processor
C-----------------------------------------------------------------------
C Override the device settings according to logical variables:
C   PGPLOT_HJ_RES  can be H or HIGH     for 300 bpi
C                         M or MEDIUM   for 150 bpi
C                         L or LOW      for 100 bpi
C                         V or VERYLOW  for  75 bpi
          CALL GRGENV ('HJ_RES', MODE, I)
          IF (mode(1:1) .eq. 'H')  then
            dev_resol = 300
          ELSEIF (mode(1:1) .eq. 'M')  then
            dev_resol = 150
          ELSEIF (mode(1:1) .eq. 'L')  then
            dev_resol = 100
          ELSEIF (mode(1:1) .eq. 'V')  then
            dev_resol =  75
C!          ELSE
C!   for PC, set resolution to 150 dpi or less unless it has been
C!   specifically set to 300
C!            dev_resol = min(150.,dev_resol)
          ENDIF
C   PGPLOT_HJ_MAR  contains the vertical and horizontal margins in inches
          CALL GRGENV ('HJ_MAR', MODE, I)
          IF (i .gt. 0 .and. mode(:I) .ne. ' ') THEN
            read(mode(:I),'(2f6.0)',err=34) t1,t2
            dev_VC = t1
            dev_HC = t2
          ENDIF
C   PGPLOT_HJ_SIZE if defined contains the X and Y page size in inches
34        CALL GRGENV ('HJ_SIZE', MODE, I)
          IF (i .gt. 0 .and. mode(:I) .ne. ' ') THEN
            read(mode(:I),'(2f6.0)',err=35) t1,t2
            dev_maxX = t1
            dev_maxY = t2
          ENDIF
C   PGPLOT_HJ_TEX  can have any value, if defined will set TeX mode
35        CALL GRGENV ('HJ_TEX', MODE, I)
          IF (i .gt. 0 .and. mode .ne. ' ') then
            TEX = .TRUE.
          ENDIF
C   PGPLOT_HJ_NOFF can have any value, if defined will skip the final
C   form feed -- this prevents wasted (blank) pages from spooled jobs
          NOFF = .false.
          CALL GRGENV ('HJ_NOFF', MODE, I)
          IF ((i .gt. 0 .and. mode .ne. ' ') .or. TEX) then
            NOFF = .true.
          ENDIF
C If PGPLOT_HJ_PAGE is set to L (or LANDSCAPE) for Landscape mode
C                   is set to P (or PORTRAIT) for Portrait mode
          CALL GRGENV ('HJ_PAGE', MODE, I)
          IF (mode(1:1) .eq. 'L' .or. mode(1:1) .eq. 'l')
     1        dev_port_L = .false.
          IF (mode(1:1) .eq. 'P' .or. mode(1:1) .eq. 'p')
     1        dev_port_L = .true.
C If PGPLOT_HJ_OPT  is set to O (or OPTIMIZE) the bitmap will be optimized
C                   is set to C (or COMPRESS) the bitmap will be compressed
          CALL GRGENV ('HJ_OPT', MODE, I)
          IF (mode(1:1) .eq. 'O' .or. mode(1:1) .eq. 'o')
     1                dev_bitmap_L = .FALSE.
          IF (mode(1:1) .eq. 'C' .or. mode(1:1) .eq. 'c')
     1                dev_cmprs_L = .TRUE.
C Define the device name to include the settings: name will be of form
C                /HJ -string
C    where the string will be "obrT  x.x  y.y" where
C  o   P for Portrait orientation, L for landscape, blank otherwise
C  b   O for optimized bitmaps, C for compressed bitmaps, B otherwise
C  r   is the resolution in dots per inch: 300 - H; 150 - M; 100 - L; 75 - V
C  T   for TeX mode, blank otherwise
C  x.x  is the size of the page in the x direction
C  y.y  is the size of the page in the y direction
          mode = 'L B'
          IF (dev_port_L) mode(1:1) = 'P'
          IF (.not. dev_bitmap_L) mode(2:2) = 'O'
          IF (dev_cmprs_L) mode(2:2) = 'C'
          IF (dev_resol .eq. 300) then
            mode(3:3) = 'H'
          ELSEIF (dev_resol .eq. 150) then
            mode(3:3) = 'M'
          ELSEIF (dev_resol .eq. 100) then
            mode(3:3) = 'L'
          ELSEIF (dev_resol .eq. 75) then
            mode(3:3) = 'V'
          ELSE
            mode(3:3) = '?'
          ENDIF
          IF (TEX) mode(4:4) = 'T'
          IF (dev_maxX .gt. 10) then
            WRITE (mode(5:),'(f3.0)') dev_maxX
          ELSE
            WRITE (mode(5:),'(f3.1)') dev_maxX
          ENDIF
          IF (dev_maxY .gt. 10) then
            WRITE (mode(9:),'(f3.0)') dev_maxY
          ELSE
            WRITE (mode(9:),'(f3.1)') dev_maxY
          ENDIF
         DEV_NAME = 'HJ (Hewlett-Packard Deskjet/Laserjet) ' // mode
        ENDIF
C-----------------------------------------------------------------------
C                                       Branch on opcode.
      GOTO ( 10,  20,  30,  40,  50,  60,  70,  80,  90, 100,
     1      110, 120, 130, 140, 150, 160, 170, 180, 190, 200,
     2      210, 220, 230, 240, 250, 260), IFUNC
C                                       Signal an error.
  900 WRITE (MSG, '(I10)') IFUNC
      CALL GRWARN ('Unimplemented function in HJ "Jet" device driver:'
     1             // MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CONTINUE
      CHR = dev_name
      NBUF = 0
      LCHR = GRTRIM(dev_name)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 CONTINUE
      RBUF(1) = 0.0
C  convert dev_maxX and dev_maxY from inches to pixels
      RBUF(2) = dev_maxX * dev_resol - 1
      RBUF(3) = 0.0
      RBUF(4) = dev_maxY * dev_resol - 1
      RBUF(5) = 0.0
      RBUF(6) = 1.0
      NBUF = 6
      LCHR = 0
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 CONTINUE
      RBUF(1) = dev_resol
      RBUF(2) = dev_resol
      RBUF(3) = 1.0
      NBUF = 3
      LCHR = 0
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    no thick lines)
C
   40 CONTINUE
      CHR = 'HNNNNNNNNN'
      NBUF = 0
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CONTINUE
      CHR = DEFNAM
      NBUF = 0
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 CONTINUE
      RBUF(1) = 0.0
C  convert dev_maxX and dev_maxY from inches to pixels
      RBUF(2) = dev_maxX * dev_resol - 1
      RBUF(3) = 0.0
      RBUF(4) = dev_maxY * dev_resol - 1
      NBUF = 4
      LCHR = 0
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 CONTINUE
      IF (dev_resol .EQ. 300.0) THEN
         RBUF(1) = 3.0
      ELSE IF (dev_resol .EQ. 150.0) THEN
         RBUF(1) = 2.0
      ELSE
         RBUF(1) = 1.0
      END IF
      NBUF = 1
      LCHR = 0
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C                                       Assume success.
      RBUF(2) = 1.0
C                                       Obtain a logical unit number.
      CALL GRGLUN (LUN)
C                                       Check for an error.
      IF (LUN .EQ. -1) THEN
          CALL GRWARN ('Cannot allocate a logical unit.')
          RBUF(2) = 0
          RETURN
      ELSE
         RBUF(1) = LUN
      END IF
C                                       Open the output file.
      OPEN (UNIT = LUN, FILE = CHR(:LCHR), CARRIAGECONTROL = 'NONE',
     1      DEFAULTFILE = DEFNAM, STATUS = 'NEW',
     2      RECL = 128, FORM = 'UNFORMATTED', RECORDTYPE = 'VARIABLE',
     3      IOSTAT = IER)
C!      OPEN (UNIT = LUN, FILE = CHR(:LCHR), STATUS = 'UNKNOWN',
C!     2      FORM = 'BINARY',
C!     3      IOSTAT = IER)
C                                       Check for an error and cleanup if
C                                       one occurred.
      IF (IER .NE. 0) THEN
          CALL GRWARN ('Cannot open output file for HP "Jet: plot: ' //
     1                 CHR(:LCHR))
C!          CALL GRWARN ('Cannot open output file for HP "Jet" plot: ')
C!          CALL GRWARN (CHR(:LCHR))
          RBUF(2) = 0
          CALL GRFLUN (LUN)
          RETURN
      ELSE
C                                       Get the full file specification
C                                       and calculate the length of the
C                                       string
          INQUIRE (UNIT = LUN, NAME = CHR)
          LCHR = LEN (CHR)
   91     IF (CHR (LCHR:LCHR) .EQ. ' ') THEN
              LCHR = LCHR - 1
              GOTO 91
          END IF
      END IF
C                                       Initialize the plot file.
 
      IF (.NOT. TEX) THEN
C                                       Choose portrait orientation
         WRITE (LUN) ESC, '&l0O'
C                                       Set horizontal and vertical
C                                       spacing
         IF (dev_bitmap_L) THEN
            WRITE (LUN) ESC, '&l6C'
            WRITE (LUN) ESC, '&k10H'
         ELSE
            WRITE (LUN) ESC, '&k.4H'
            WRITE (LUN) ESC, '&l.16C'
         END IF
         WRITE (LUN) ESC, '&l2E'
      END IF
C                                       Set the graphics resolution
      WRITE (MSG, '(I3.3)') INT (dev_resol)
      WRITE (LUN) ESC, '*t', MSG(1:3), 'R'
C                                       Initialize the page counter.
      NPICT = 0
      RETURN
C
C--- IFUNC = 10, Close workstation -------------------------------------
C
  100 CONTINUE
      IF (dev_bitmap_L) THEN
         WRITE (LUN) ESC, '&l8C'
      ELSEIF (.NOT. TEX) THEN
         WRITE (LUN) ESC, '&l6D'
         WRITE (LUN) ESC, '&k10H'
         WRITE (LUN) ESC, '&l2E'
      END IF
C eject the page
      IF (.not. NOFF) WRITE (LUN) FF
C                                       Close the file.
      CLOSE (LUN, STATUS = 'KEEP')
C                                       Deallocate the logical unit.
      CALL GRFLUN (LUN)
C
      RETURN
C
C--- IFUNC = 11, Begin picture -----------------------------------------
C
  110 CONTINUE
C                                       Set the bitmap size.
      XMAX = RBUF(1)
      YMAX = RBUF(2)
C                                       Calculate the dimensions of the
C                                       plot buffer.
      IF (dev_port_L) THEN
         BX = INT (XMAX) / 8 + 1
         BY = INT (YMAX) + 1
      ELSE
         BX = INT (YMAX) / 8 + 1
         BY = INT (XMAX) + 1
      END IF
C                                       Allocate a plot buffer.
C                                       Check for error and clean up
C                                       if one was found.
C! VAX
      IER = GRGMEM (BX * BY, BUFFER)
      IF (IER .NE. 1) THEN
          CALL GRGMSG (IER)
C! PC
C!      ALLOCATE (BUFFER(BX,BY), STAT = IER)
C!      IF (IER .NE. 0) THEN
          CALL GRQUIT ('Failed to allocate a plot buffer.')
      END IF
C                                       Increment the page number.
      NPICT = NPICT + 1
C                                       Eject the page from the printer.
      IF (NPICT .GT. 1) WRITE (LUN) FF
C                                       Set the cursor position and
C                                       start graphics mode.
      IF (dev_bitmap_L) THEN
         WRITE (MSG(1:4), '(I4.4)') nint(dev_HC*720.)
         WRITE (MSG(5:8), '(I4.4)') nint(dev_VC*720.)
         WRITE (LUN) ESC, '&a', MSG(1:4), 'h', MSG(5:8), 'V'
      END IF
C                                       Zero out the plot buffer.
      CALL GRHJ05 (BX * BY, %VAL(BUFFER))
      RETURN
C
C--- IFUNC = 12, Draw line ---------------------------------------------
C
  120 CONTINUE
C                                       Apply any needed tranformation.
      IF (dev_port_L) THEN
         DO 125 I = 1, 4
            XBUF(I) = RBUF(I)
  125    CONTINUE
      ELSE
         XBUF(1) = RBUF(2)
         XBUF(2) = XMAX - RBUF(1)
         XBUF(3) = RBUF(4)
         XBUF(4) = XMAX - RBUF(3)
      END IF
C                                       Draw the point into the bitmap.
      CALL GRHJ00 (1, XBUF, IC, BX, BY, %VAL (BUFFER))
C!      CALL GRHJ00 (1, XBUF, IC, BX, BY, BUFFER)
      RETURN
C
C--- IFUNC = 13, Draw dot ----------------------------------------------
C
  130 CONTINUE
C                                       Apply any needed tranformation.
      IF (dev_port_L) THEN
         DO 135 I = 1, 2
            XBUF(I) = RBUF(I)
  135    CONTINUE
      ELSE
         XBUF(1) = RBUF(2)
         XBUF(2) = XMAX - RBUF(1)
      END IF
C                                       Draw the point into the bitmap.
      CALL GRHJ00 (0, XBUF, IC, BX, BY, %VAL(BUFFER))
C!      CALL GRHJ00 (0, XBUF, IC, BX, BY, BUFFER)
      RETURN
C
C--- IFUNC = 14, End picture -------------------------------------------
C
  140 CONTINUE
C                                       Write out the bitmap.
      IF (dev_bitmap_L .and. dev_cmprs_L) THEN
         CALL GRHJ04 (LUN, BX, BY, %VAL(BUFFER))
C!         CALL GRHJ04 (LUN, BX, BY, BUFFER)
      ELSEIF (dev_bitmap_L) THEN
         CALL GRHJ01 (LUN, BX, BY, %VAL (BUFFER))
C!         CALL GRHJ01 (LUN, BX, BY, BUFFER)
      ELSE
         CALL GRHJ02 (LUN, BX, BY, %VAL (BUFFER), TEX)
C!         CALL GRHJ02 (LUN, BX, BY, BUFFER, TEX)
      END IF
C                                       Deallocate the plot buffer.
C                                       Check for an error.
C! VAX
      IER = GRFMEM (BX * BY, BUFFER)
      IF (IER .NE. 1) THEN
          CALL GRGMSG (IER)
C! PC
C!      DEALLOCATE (BUFFER, STAT=IER)
C!      IF (IER .NE. 0) THEN
          CALL GRWARN ('Failed to deallocate plot buffer.')
      END IF
      RETURN
C
C--- IFUNC = 15, Select color index ------------------------------------
C
  150 CONTINUE
C                                       Save the requested color index.
      IC = RBUF(1)
C                                       If out of range set to black.
      IF (IC .LT. 0 .OR. IC .GT. 1) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC = 16, Flush buffer. -----------------------------------------
C    (Not implemented: ignored.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC = 17, Read cursor. ------------------------------------------
C    (Not implemented: should not be called.)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC = 18, Erase alpha screen. -----------------------------------
C    (Not implemented: ignored.)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC = 19, Set line style. ---------------------------------------
C    (Not implemented: should not be called.)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC = 20, Polygon fill. -----------------------------------------
C    (Not implemented: should not be called.)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC = 21, Set color representation. -----------------------------
C    (Not implemented: ignored.)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC = 22, Set line width. ---------------------------------------
C    (Not implemented: should not be called.)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC = 23, Escape ------------------------------------------------
C    (Not implemented: ignored.)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC = 24, Rectangle fill. ---------------------------------------
C    (Not implemented: should not be called.)
C
  240 CONTINUE
      GOTO 900
C
C--- IFUNC = 25, -------------------------------------------------------
C    (Not implemented: should not be called.)
C
  250 CONTINUE
      GOTO 900
C
C--- IFUNC = 26, Line of pixels. ---------------------------------------
C    (Not implemented: should not be called.)
C
  260 CONTINUE
      GOTO 900
C-----------------------------------------------------------------------
      END
 
C*GRHJ00 -- PGPLOT Hewlett Packard LaserJet driver, draw line
C+
      SUBROUTINE GRHJ00 (LINE, RBUF, ICOL, BX, BY, BITMAP)
      INTEGER*4  BX, BY, ICOL, LINE
      BYTE       BITMAP(BX, BY)
C!      INTEGER*1    BITMAP(BX, BY)
      REAL*4     RBUF(4)
C
C Draw a straight line segment from absolute pixel coordinates (RBUF(1),
C RBUF(2)) to (RBUF(3), RBUF(4)).  The line either overwrites (sets to
C black) or erases (sets to white) the previous contents of the bitmap,
C depending on the current color index. Setting bits is accomplished
C with a VMS BISB2 instruction, expressed in Fortran as .OR.; clearing
C bits is accomplished with a VMS BICB2 instruction, expressed in
C Fortran as .AND. .NOT.. The line is generated with a Simple Digital
C Differential Analyser (ref: Newman & Sproull).
C
C Arguments:
C
C LINE            I I      =0 for dot, =1 for line.
C RBUF(1),RBUF(2) I R      Starting point of line.
C RBUF(3),RBUF(4) I R      Ending point of line.
C ICOL            I I      =0 for erase, =1 for write.
C BITMAP        I/O B      (address of) the frame buffer.
C
C-----------------------------------------------------------------------
      BYTE       QMASK(0 : 7)
C!      INTEGER*1    QMASK(0 : 7)
      INTEGER*4  K, KX, KY, LENGTH
      REAL*4     D, XINC, XP, YINC, YP
      DATA       QMASK /'80'X, '40'X, '20'X, '10'X,
     1                  '08'X, '04'X, '02'X, '01'X/
C!      DATA       QMASK /16#80, 16#40, 16#20, 16#10,
C!     1                  16#08, 16#04, 16#02, 16#01/
C-----------------------------------------------------------------------
      IF (LINE .GT. 0) THEN
         D = MAX (ABS (RBUF(3) - RBUF(1)), ABS (RBUF(4) - RBUF(2)))
         LENGTH = D
         IF (LENGTH .EQ. 0) THEN
            XINC = 0.0
            YINC = 0.0
         ELSE
            XINC = (RBUF(3) - RBUF(1)) / D
            YINC = (RBUF(4) - RBUF(2)) / D
         END IF
      ELSE
         LENGTH = 0
         XINC = 0.0
         YINC = 0.0
      END IF
      XP = RBUF(1) + 0.5
      YP = RBUF(2) + 0.5
      IF (ICOL .NE. 0) THEN
         DO K = 0, LENGTH
            KX = XP
            KY = (BY - 1) - INT (YP)
            BITMAP(KX / 8 + 1, KY + 1) = BITMAP(KX / 8 + 1, KY + 1) .OR.
     1                                         QMASK(MOD (KX, 8))
            XP = XP + XINC
            YP = YP + YINC
         END DO
      ELSE
         DO K = 0,LENGTH
            KX = XP
            KY = (BY - 1) - INT (YP)
            BITMAP(KX / 8 + 1, KY + 1) = BITMAP(KX / 8 + 1, KY + 1)
     1                                  .AND. (.NOT. QMASK(MOD (KX, 8)))
            XP = XP + XINC
            YP = YP + YINC
         END DO
      END IF
C-----------------------------------------------------------------------
      RETURN
      END
 
C*GRHJ01 -- PGPLOT LaserJet driver, copy bitmap to output file
C+
      SUBROUTINE GRHJ01 (LUN, BX, BY, BITMAP)
      INTEGER  BX, BY, LUN
      BYTE     BITMAP(BX, BY)
C!      INTEGER*1  BITMAP(BX, BY)
C
C Arguments:
C
C  LUN    (input)  Fortran unit number for output
C  BX, BY (input)  dimensions of BITMAP
C  BITMAP (input)  the bitmap array
C-----------------------------------------------------------------------
      BYTE      ESC
C!      INTEGER*1   ESC
      INTEGER   I, J, K
      CHARACTER KSTR*3
      PARAMETER (ESC = 27)
C-----------------------------------------------------------------------
C                                       Start graphics mode
      WRITE (LUN) ESC, '*r1A'
C                                       Loop through bitmap
      DO J = 1, BY
C                                       Search for last non-NUL
         DO K = BX, 2, -1
            IF (BITMAP(K, J) .NE. 0) GO TO 10
         END DO
C                                       Guarantee that we know what K
C                                       is after loop.
C                                       (Remember FORTRAN IV!?)
         K = 1
C                                       Encode length of line
   10    WRITE (KSTR, '(I3.3)') K
C                                       Write out the raster line
         WRITE (LUN) ESC, '*b', KSTR, 'W', (BITMAP(I, J), I = 1, K)
      END DO
C                                       Turn off graphics mode.
      WRITE (LUN) ESC, '*rB'
C-----------------------------------------------------------------------
      RETURN
      END
 
C*GRHJ02 -- PGPLOT LaserJet+ driver, dump bitmap to device
C+
      SUBROUTINE GRHJ02 (LUN, BX, BY, BITMAP, TEX)
      LOGICAL TEX
      INTEGER LUN, BX, BY
      BYTE BITMAP(BX, BY)
C!      INTEGER*1 BITMAP(BX, BY)
C
C Output raster for this page.  This routine has been optimised to
C minimize the memory usage in the LaserJet.  This sometimes leads to a
C larger file than if a straight bitmap approach had been used.
C
C NOTE:  This subroutine is a kludge to make a 512K LaserJet produce
C        full page plots at 300dpi.  It will not always produce the plot
C        on one page.  If you overrun the memory restrictions, two pages
C        will be printed, each containing parts of the plot.  One must
C        then resort to cut and paste techniques to restore the plot.
C        Most simple line graphs do not come close to the memory limit,
C        but sometimes a messy contour plot will.  DON'T EVEN THINK
C        ABOUT SENDING A GREYSCALE TO THIS SUBROUTINE!
C
C Arguments:
C
C LUN             I I      Logical unit number of output file
C BX, BY          I I      Dimensions of frame buffer
C BITMAP        I/O B      (address of) the frame buffer.
C
C Version 1.0  03-Sep-1986  S. C. Allendorf
C Version 2.0  08-Dec-1986  S. C. Allendorf  Use relative positioning
C Version 2.1  28-Dec-1986  S. C. Allendorf  Optimize positioning code
C Version 3.0  02-Jan-1987  S. C. Allendorf  Add code for rules
C VERSION 3.1  10-FEB-1988  S. C. Allendorf  Attempt to speed up code
C-----------------------------------------------------------------------
      BYTE       ESC, N0
C!      INTEGER*1  ESC, N0
      LOGICAL    NOBIT
      INTEGER*4  CNUM, CONUM, CURCOL, CURROW, FB(35), FB2(25), I, IPOS
      INTEGER*4  IYOFF, J, K, L, M, N, NB(35), NBNUM, NBTOT, NBNUM2
      INTEGER*4  NB2(25), RNUM, RONUM, GRHJ03
      CHARACTER  ALLONE*300, COL*5, NBYTE*4, NULLS*(10), ROW*5, X*300
      PARAMETER  (N0 = 0)
      PARAMETER  (ESC = 27)
C-----------------------------------------------------------------------
C                                       Define some useful constants
      IF (TEX) THEN
         IYOFF = 0
      ELSE
         IYOFF = 75
      END IF
      DO J = 1, 10
         NULLS(J:J) = CHAR (0)
      END DO
      DO J = 1, 300
         ALLONE(J:J) = CHAR (255)
      END DO
C                                       Initialize some variables
      CURCOL = 0
      CURROW = 0
C                                       Position the cursor
      IF (.NOT. TEX) THEN
         WRITE (LUN) ESC, '*p0y0X'
      END IF
C                                       Set up vertical rule height
      WRITE (LUN) ESC, '*c1B'
C                                       Write out each line on page
      DO K = 1, BY
C                                       Copy raster to buffer and find
C                                       the beginning and end of the
C                                       bitmap line
         NOBIT = .TRUE.
         NBTOT = 0
         FB(1) = BX
         DO J = 1, BX
            X(J:J) = CHAR (BITMAP(J,K))
            IF (X(J:J) .NE. NULLS(1:1)) THEN
               NOBIT = .FALSE.
               NBTOT = J
               FB(1) = MIN (FB(1), J)
            END IF
         END DO
C                                       Break line into pieces
         IF (.NOT. NOBIT) THEN
            L = 1
            GO TO 20
   10       NB(L) = FB(L) + IPOS - 2
            L = L + 1
C                                       Search for first non-null
            DO J = NB(L-1) + 11, NBTOT
               IF (X(J:J) .NE. NULLS(1:1)) THEN
                  FB(L) = J
                  GO TO 20
               END IF
            END DO
C                                       Search for a string of nulls
   20       IPOS = INDEX (X(FB(L):NBTOT), NULLS)
            IF (IPOS .EQ. 0) THEN
               NB(L) = NBTOT
               GO TO 30
            ELSE
               GO TO 10
            END IF
C                                       Loop through each substring
   30       DO J = 1, L
C                                       Search for rules
               M = 1
               FB2(1) = FB(J)
               GO TO 50
   40          IF (IPOS .NE. 1) THEN
                  NB2(M) = 0
                  DO I = FB2(M), FB2(M) + IPOS - 2
                     IF (X(I:I) .NE. NULLS(1:1)) THEN
                        NB2(M) = MAX (FB2(M), I)
                     END IF
                  END DO
                  M = M + 1
                  FB2(M) = FB2(M-1) + IPOS - 1
                  IF (NB2(M-1) .EQ. 0) THEN
                     FB2(M-1) = FB2(M)
                     M = M - 1
                  END IF
               END IF
C                                       Search for first non-<XFF>
               DO N = FB2(M) + 25, NB(J)
                  IF (X(N:N) .NE. ALLONE(1:1)) THEN
                     NB2(M) = N - 1
                     M = M + 1
                     FB2(M) = N
                     GO TO 50
                  END IF
               END DO
               NB2(M) = NB(J)
               GO TO 60
C                                       Search for a string of <XFF>s
   50          IPOS = INDEX (X(FB2(M):NB(J)), ALLONE(1:25))
               IF (IPOS .EQ. 0) THEN
                  NB2(M) = NB(J)
                  GO TO 60
               ELSE
                  GO TO 40
               END IF
C                                       Print each of the substrings
   60          DO I = 1, M
C                                       Get the number of bytes
                  NBNUM = NB2(I) - FB2(I) + 1
                  WRITE (NBYTE, 1000) NBNUM
                  NBNUM2 = GRHJ03 (NBNUM)
C                                       Calculate the row and column
                  RONUM = K + IYOFF
                  CONUM = (FB2(I) - 1) * 8
C                                       Determine the positioning
C                                       sequence and write it out
                  IF (RONUM .NE. CURROW .AND. CONUM .NE. CURCOL) THEN
                     RNUM = RONUM - CURROW
                     CNUM = CONUM - CURCOL
                     WRITE (ROW, 1010) RNUM
                     WRITE (COL, 1010) CNUM
                     RNUM = GRHJ03 (ABS (RNUM)) + 1
                     CNUM = GRHJ03 (ABS (CNUM)) + 1
                     WRITE (LUN) ESC, '*p', ROW(6-RNUM:5), 'y',
     +                                              COL(6-CNUM:5), 'X'
                  ELSE IF (RONUM .NE. CURROW) THEN
                     RNUM = RONUM - CURROW
                     WRITE (ROW, 1010) RNUM
                     RNUM = GRHJ03 (ABS (RNUM)) + 1
                     WRITE (LUN) ESC, '*p', ROW(6-RNUM:5), 'Y'
                  ELSE IF (CONUM .NE. CURCOL) THEN
                     CNUM = CONUM - CURCOL
                     WRITE (COL, 1010) CNUM
                     CNUM = GRHJ03 (ABS (CNUM)) + 1
                     WRITE (LUN) ESC, '*p', COL(6-CNUM:5), 'X'
                  END IF
C                                       Check for all bits set in
C                                       substring
                  IF ((INDEX (X(FB2(I):NB2(I)), ALLONE(1:NBNUM)) .EQ. 1)
     +                 .AND. NBNUM .GE. 5) THEN
                     NBNUM = NBNUM * 8
                     WRITE (NBYTE, 1000) NBNUM
                     NBNUM2 = GRHJ03 (NBNUM)
                     WRITE (LUN) ESC, '*c', NBYTE(5-NBNUM2:4), 'A'
                     WRITE (LUN) ESC, '*c0P'
                     CURROW = RONUM
                     CURCOL = CONUM
                  ELSE
C                                       Write out raster line
                     WRITE (LUN) ESC, '*r1A'
                     WRITE (LUN) ESC, '*b', NBYTE(5-NBNUM2:4), 'W',
     +                                                X(FB2(I):NB2(I))
                     WRITE (LUN) ESC, '*rB'
                     CURROW = RONUM + 1
                     CURCOL = CONUM
                  END IF
               END DO
            END DO
         END IF
      END DO
C-----------------------------------------------------------------------
 1000 FORMAT (I4.4)
 1010 FORMAT (SP,I5)
      RETURN
      END
 
C*GRHJ03 -- PGPLOT LaserJet+ driver, calculate length of an integer
C+
      INTEGER FUNCTION GRHJ03 (I)
      INTEGER I
C
C This function calculates the number of digits in a supplied integer.
C
C Arguments:
C
C I               I I      Integer value of number
C GRHJ03          O I      Length of printed representation of I
C
C Version 1.0  10-Feb-1988  S. C. Allendorf
C-----------------------------------------------------------------------
      IF (I .GE. 10) THEN
         IF (I .GE. 100) THEN
            IF (I .GE. 1000) THEN
               GRHJ03 = 4
            ELSE
               GRHJ03 = 3
            END IF
         ELSE
            GRHJ03 = 2
         END IF
      ELSE
         GRHJ03 = 1
      END IF
C-----------------------------------------------------------------------
      RETURN
      END
 
C*GRHJ04 -- PGPLOT LaserJet driver, copy bitmap to output file with
C                compression -- for DESKJET PLUS and possibly other printers
C+
      SUBROUTINE GRHJ04 (LUN, BX, BY, BITMAP)
      INTEGER  BX, BY, LUN
      BYTE     BITMAP(BX, BY)
C!      INTEGER*1  BITMAP(BX, BY)
C
C Arguments:
C
C  LUN    (input)  Fortran unit number for output
C  BX, BY (input)  dimensions of BITMAP
C  BITMAP (input)  the bitmap array
C-----------------------------------------------------------------------
      BYTE      ESC
C!      INTEGER*1   ESC
      INTEGER   K1, J, K, BXMAX,BXMIN
      CHARACTER KSTR*3
      PARAMETER (ESC = 27)
      CHARACTER*10 BUFF1
C!      integer*1 BUFF2(400)
      byte BUFF2(400)
        integer lbuf1,lbuf2,tbuf
        byte tbufb(2)
        equivalence (tbuf,tbufb)
C-----------------------------------------------------------------------
C                                       Start graphics mode
      WRITE (LUN) ESC, '*r1A'
C                                       Loop through bitmap
      DO J = 1, BY
C                                       Search for last non-NUL
         DO K = BX, 2, -1
            IF (BITMAP(K, J) .NE. 0) GO TO 10
         END DO
C                                       Guarantee that we know what K
C                                       is after loop.
C                                       (Remember FORTRAN IV!?)
         K = 1
10       BXMAX = K
         BXMIN = 1
         K = 1
         BUFF1(1:1) = CHAR(27)
         BUFF1(2:5) = '*b2m'
         lbuf1 = 5
C If there are less than 4 bytes don't bother with an offset
         IF (BXMAX .LE. 4) GOTO 25
C Count the number of Zero bits at beginning of line
         DO K = BXMIN,BXMAX-1
           IF (BITMAP(K, J) .NE. 0) GO TO 20
         ENDDO
         K = BXMAX
20       IF (K .GT. 4) THEN
            K1 = (K-1)*8
            BXMIN = K
            IF (K1 .LE. 9) THEN
              LBUF1 = 7
              WRITE (BUFF1(6:LBUF1),'(I1.1,A1)') K1,'x'
            ELSEIF (K1 .LE. 99) THEN
              LBUF1 = 8
              WRITE (BUFF1(6:LBUF1),'(I2.2,A1)') K1,'x'
            ELSEIF (K1 .LE. 999) THEN
              LBUF1 = 9
              WRITE (BUFF1(6:LBUF1),'(I3.3,A1)') K1,'x'
            ELSE
              LBUF1 = 10
              WRITE (BUFF1(6:LBUF1),'(I4.4,A1)') K1,'x'
            ENDIF
          ENDIF
 
25        WRITE (LUN) BUFF1(1:LBUF1)
 
          lbuf2 = 1
 
30        CONTINUE
          DO K = BXMIN,BXMAX
            IF (K .GE. BXMAX-2) THEN
C we are at the end of the bit-map,
C    N.B. BXMAX - BXMIN will be less than 128
              buff2(lbuf2) = BXMAX - BXMIN
              lbuf2 = lbuf2 + 1
              DO K1=BXMIN,BXMAX
                 buff2(lbuf2) = BITMAP(K1, J)
                 lbuf2 = lbuf2 + 1
              ENDDO
              GOTO 100
            ELSEIF (K - BXMIN .GE. 125) THEN
C we have 126 non-repeated characters
              buff2(lbuf2) = K - BXMIN
              lbuf2 = lbuf2 + 1
              DO K1=BXMIN,K
                 buff2(lbuf2) = BITMAP(K1, J)
                 lbuf2 = lbuf2 + 1
              ENDDO
              BXMIN = K+1
              IF (BXMIN .GT. BXMAX) GOTO 100
              GOTO 30
            ELSEIF (BITMAP(K, J) .EQ. BITMAP(K+1, J) .AND.
     1          BITMAP(K, J) .EQ. BITMAP(K+2, J)) THEN
C we have 2 or more repeated characters
              IF (K .gt. BXMIN) THEN
C write out non-repeated characters, if any
                buff2(lbuf2) = K - BXMIN - 1
                lbuf2 = lbuf2 + 1
                DO K1=BXMIN,K-1
                   buff2(lbuf2) = BITMAP(K1, J)
                   lbuf2 = lbuf2 + 1
                ENDDO
              ENDIF
C count the number of repeated characters, up to 127
              DO K1=K+3,MIN(BXMAX,K+127)
                IF (BITMAP(K, J) .NE. BITMAP(K1, J)) GOTO 40
              ENDDO
              K1 = BXMAX + 1
C write out repeated characters
40            CONTINUE
C! VAX version:
              Tbuf  = 257 - K1 + K
              buff2(lbuf2) = tbufb(1)
C PC version:
C!              buff2(lbuf2) = 257 - (K1 - K)
              lbuf2 = lbuf2 + 1
              buff2(lbuf2) = BITMAP(K, J)
              lbuf2 = lbuf2 + 1
              BXMIN = K1
              IF (BXMIN .GT. BXMAX) GOTO 100
              GOTO 30
            ENDIF
          ENDDO
100      WRITE (KSTR, '(I3.3)') lbuf2-1
          IF (lbuf2 .LE. 10) THEN
           WRITE (LUN) KSTR(3:3), 'W', (BUFF2(k1),k1=1,lbuf2-1)
          ELSEIF (lbuf2 .LE. 100) THEN
           WRITE (LUN) KSTR(2:3), 'W', (BUFF2(k1),k1=1,lbuf2-1)
          ELSE
           WRITE (LUN) KSTR(1:3), 'W', (BUFF2(k1),k1=1,lbuf2-1)
          ENDIF
C                                       Write out the raster line
      END DO
C                                       Turn off graphics mode.
      WRITE (LUN) ESC, '*rB'
C-----------------------------------------------------------------------
      RETURN
      END

C*GRHJ05 -- zero fill buffer
C+
      SUBROUTINE GRHJ05 (BUFSIZ,BUFFER)
C
C Arguments:
C
C BUFFER (byte array, input): (address of) the buffer.
C BUFSIZ (integer, input): number of bytes in BUFFER.
C-----------------------------------------------------------------------
      INTEGER  BUFSIZ, I
      BYTE     BUFFER(BUFSIZ), FILL
      DATA     FILL/0/
C
      DO 10 I=1,BUFSIZ
          BUFFER(I) = FILL
   10 CONTINUE
      END

C*GRLGTR -- translate logical name (VMS)
C+
      SUBROUTINE GRLGTR (NAME)
      CHARACTER*(*) NAME
C
C This is used in the parsing of device specifications in the
C VMS implementation of PGPLOT. In other implementations, it may
C be replaced by a null routine.
C
C Argument:
C  NAME (input/output): initially contains the name to be
C       inspected.  If an equivalence is found it will be replaced
C       with the new name. If not, the old name will be left there.
C--
C (1-Feb-1983)
C 10-Apr-1996: remove uppercasing; logical names may be case-sensitive.
C 13-Sep-1996: new version using $TRNLNM; not recursive.
C-----------------------------------------------------------------------
      INCLUDE '($LNMDEF)'
      INCLUDE '($SYSSRVNAM)'
      STRUCTURE /LIST/
         INTEGER*2 BUF_LEN/255/
         INTEGER*2 ITEM_CODE/LNM$_STRING/
         INTEGER*4 TRANS_LOG
         INTEGER*4 TRANS_LEN
         INTEGER*4 END_ENTRY/0/
      END STRUCTURE
      
      CHARACTER*255 EQV_BUFFER
      INTEGER*2 W_NAMELEN
      INTEGER L, GRTRIM, ISTAT
      RECORD /LIST/ ITEM_LIST

      ITEM_LIST.TRANS_LOG = %LOC(EQV_BUFFER)
      ITEM_LIST.TRANS_LEN = %LOC(W_NAMELEN)
      
      L = GRTRIM(NAME)
      ISTAT = SYS$TRNLNM(LNM$M_CASE_BLIND, 
     :     'LNM$FILE_DEV',
     :     NAME(1:L),
     :     ,
     :     ITEM_LIST)
      IF (ISTAT) NAME = EQV_BUFFER(:W_NAMELEN)
      RETURN
      END

C*GRTRML -- get name of user's terminal (VMS)
C+
      SUBROUTINE GRTRML(STRING, L)
      CHARACTER*(*) STRING
      INTEGER L
C
C Return the device name of the user's terminal, if any. In VMS, the
C name of the terminal is found by translating and expanding the
C logical name TT.
C
C Arguments:
C  STRING : receives the terminal name, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in STRING, excluding
C           trailing blanks. If there is not attached terminal, 
C           zero is returned.
C--
C 19-Jan-1988
C-----------------------------------------------------------------------
      INTEGER LIB$GETDVI
      INTEGER I, IER
      EXTERNAL DVI$_FULLDEVNAM
C
      STRING = ' '
      IER = LIB$GETDVI(%LOC(DVI$_FULLDEVNAM), , 'TT:', ,
     1                 STRING, L)
      IF (IER.NE.1 .OR. L.LT.1 .OR. STRING.EQ.' ') THEN
          L = 0
          STRING = ' '
      ELSE
          DO 10 I=L,1,-1
              L = I
              IF (STRING(I:I).NE.' ') GOTO 20
   10     CONTINUE
          L = 0
   20     CONTINUE
      END IF
      END

C*GIDRIV -- PGPLOT GIF drivers
C+
      SUBROUTINE GIDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      INTEGER IFUNC, NBUF, LCHR, MODE
      REAL    RBUF(*)
      CHARACTER*(*) CHR
*
* PGPLOT driver for Graphics Interchange Format (GIF) files.
*
************************************************************************
*                           CAUTION                                    *
*                                                                      *
* The GIF specification incorporates the Lempel-Zev-Welch (LZW)        *
* compression technology which is the subject of a patent awarded to   *
* Unisys. Use of this technology, and in particular creation of GIF    *
* format files using this PGPLOT device driver, may require a license  *
* from Unisys.                                                         *
************************************************************************
*
* Supported device: GIF87a file format
*
* Device type codes: /GIF or /VGIF
*
* Default device name: pgplot.gif.
*
* If you have more than one image to plot (i.e. use PGPAGE) with this
* device, subsequent pages will be named: pgplot2.gif, pgplot3.gif,
* etc, disrespective of the device name you specified.
* You can however bypass this by specifying a device name including a
* number sign (#), which will henceforth be replaced by the pagenumber.
* Example: page#.gif will produce files page1.gif, page2.gif, ...,
* page234.gif, etc.
*
* Default view surface dimensions are:
* - GIF  : 850 x 680 pixels (translates to 10.0 x  8.0 inch).
* - VGIF : 680 x 850 pixels (translates to  8.0 x 10.0 inch).
* with an assumed scale of 85 pixels/inch.
* Default width and height can be overridden by specifying environment
* variables
* PGPLOT_GIF_WIDTH  (default 850)
* PGPLOT_GIF_HEIGHT (default 680)
*
* Color capability:
* Indices 0 to 255 are supported. Each of these indices can be assigned
* one color. Default colors for indices 0 to 15 are implemented.
*
* Obtaining hardcopy: Use a GIF viewer or converter.
*=
*  1-Aug-1994 - Created by Remko Scharroo
*  9-Aug-1994 - New scheme for line plotting
* 16-Aug-1994 - Provide multi-image plotting.
*  8-Sep-1994 - Add opcode 29 [TJP].
*  5-Nov-1994 - Adjust size of bitmap if necessary [TJP].
* 18-Jan-1995 - Attempt to prevent integer overflow on systems where
*               BYTE is signed [TJP].
* 28-Dec-1995 - prevent concurrent access [TJP].
* 29-Apr-1996 - use GRCTOI to decode environment variables [TJP].
*  2-Sep-1997 - correct a byte overflow problem
*-----------------------------------------------------------------------
      CHARACTER*(*) LTYPE, PTYPE, DEFNAM
      INTEGER DWD, DHT, BX, BY
      PARAMETER (LTYPE=
     1'GIF   (Graphics Interchange Format file, landscape orientation)',
     2 PTYPE=
     3'VGIF  (Graphics Interchange Format file, portrait orientation)')
      PARAMETER (DEFNAM='pgplot.gif')
      PARAMETER (DWD=850, DHT=680)

      REAL XRES, YRES
      PARAMETER (XRES=85., YRES=XRES)
C
      INTEGER UNIT, IC, NPICT, MAXIDX, STATE
      INTEGER CTABLE(3,0:255), CDEFLT(3,0:15)
      INTEGER IER, I, L, LL, IX0, IY0, IX1, IY1, USERW, USERH, JUNK
      INTEGER GRGMEM, GRFMEM, GROFIL, GRCFIL, GRCTOI
      CHARACTER*80 MSG, INSTR, FILENM
C
C Note: for 64-bit operating systems, change the following 
C declaration to INTEGER*8:
C
      INTEGER PIXMAP, WORK
C
      SAVE UNIT, IC, CTABLE, NPICT, MAXIDX, BX, BY, PIXMAP, FILENM
      SAVE CDEFLT, STATE
      DATA CDEFLT /000,000,000, 255,255,255, 255,000,000, 000,255,000,
     1             000,000,255, 000,255,255, 255,000,255, 255,255,000,
     2             255,128,000, 128,255,000, 000,255,128, 000,128,255,
     3             128,000,255, 255,000,128, 085,085,085, 170,170,170/
      DATA STATE /0/
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260,270,280,290), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in GIF device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 IF (MODE.EQ.1) THEN
         CHR = LTYPE
         LCHR = LEN(LTYPE)
      ELSE IF (MODE.EQ.2) THEN
         CHR = PTYPE
         LCHR = LEN(PTYPE)
      ELSE
         CALL GRWARN('Requested MODE not implemented in GIF driver')
      END IF
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C     (Maximum size is set by GIF format to 2**16 pixels)
   20 RBUF(1) = 0
      RBUF(2) = 65536 
      RBUF(3) = 0
      RBUF(4) = 65536
      RBUF(5) = 0
      RBUF(6) = 255
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = XRES
      RBUF(2) = YRES 
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, supports rectangle fill, pixel 
C     primitives, and query color rep.)
C
   40 CHR = 'HNNNNRPNYN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = BX-1 
      RBUF(3) = 0
      RBUF(4) = BY-1
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C     -- check for concurrent access
      IF (STATE.EQ.1) THEN
         CALL GRWARN('a PGPLOT GIF file is already open')
         RBUF(1) = 0
         RBUF(2) = 0
         RETURN
      END IF
C     -- dimensions of plot buffer
      USERW = 0
      USERH = 0
      CALL GRGENV('GIF_WIDTH', INSTR, L)
      LL = 1
      IF (L.GT.0) USERW = GRCTOI(INSTR(:L),LL)
      CALL GRGENV('GIF_HEIGHT', INSTR, L)
      LL = 1
      IF (L.GT.0) USERH = GRCTOI(INSTR(:L),LL)
      IF (MODE.EQ.1) THEN
*     -- Landscape
         BX = DWD
         IF (USERW.GE.8) BX = USERW
         BY = DHT
         IF (USERH.GE.8) BY = USERH
      ELSE
*     -- Portrait
         BX = DHT
         IF (USERH.GE.8) BX = USERH
         BY = DWD
         IF (USERW.GE.8) BY = USERW
      END IF
      NPICT=1
      MAXIDX=0
*     -- Initialize color table
      DO 95 I=0,15
         CTABLE(1,I) = CDEFLT(1,I)
         CTABLE(2,I) = CDEFLT(2,I)
         CTABLE(3,I) = CDEFLT(3,I)
 95   CONTINUE
      DO 96 I=16,255
         CTABLE(1,I) = 128
         CTABLE(2,I) = 128
         CTABLE(3,I) = 128
 96   CONTINUE       
*
      FILENM = CHR(:LCHR)
      CALL GRGI10 (FILENM, NPICT, MSG)
      UNIT = GROFIL (MSG)
      RBUF(1) = UNIT
      IF (UNIT.LT.0) THEN
         CALL GRWARN('Cannot open output file for GIF plot')
         RBUF(2) = 0
      ELSE
         RBUF(2) = 1
         STATE = 1
      END IF
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      STATE = 0
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
      BX = NINT(RBUF(1))+1
      BY = NINT(RBUF(2))+1
      IER = GRGMEM(BX*BY, PIXMAP)
      IF (IER.NE.1) THEN
         CALL GRGMSG(IER)
         CALL GRWARN('Failed to allocate plot buffer.')
         BX = 0
         BY = 0
         PIXMAP = 0
      END IF
C     -- initialize to zero (background color)
      IF (PIXMAP.NE.0) 
     :     CALL GRGI03(1, 1, BX, BY, 0, BX, BY, %VAL(PIXMAP))
      IF (NPICT.GT.1) THEN
         CALL GRGI10 (FILENM, NPICT, MSG)
         UNIT = GROFIL(MSG)
         IF (UNIT.LT.0) THEN
            CALL GRWARN('Cannot open output file for GIF plot')
         END IF
      END IF
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      IX0=NINT(RBUF(1))+1
      IX1=NINT(RBUF(3))+1
      IY0=BY-NINT(RBUF(2))
      IY1=BY-NINT(RBUF(4))
      IF (PIXMAP.NE.0)
     :     CALL GRGI01(IX0, IY0, IX1, IY1, IC, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      IX0=NINT(RBUF(1))+1
      IY0=BY-NINT(RBUF(2))
      IF (PIXMAP.NE.0)
     :     CALL GRGI01(IX0, IY0, IX0, IY0, IC, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      IF (UNIT.GE.0) THEN
         IER = GRGMEM(2*256*4098, WORK)
         IF (IER.NE.1) THEN
            CALL GRGMSG(IER)
            CALL GRWARN('Failed to allocate work array.')
         ELSE
            CALL GRGI06(UNIT, BX, BY, CTABLE, %VAL(PIXMAP), MAXIDX,
     :                  %VAL(WORK))
         END IF
         JUNK = GRCFIL(UNIT)
         IER = GRFMEM(2*256*4098, WORK)
      END IF
      NPICT = NPICT+1
      IER = GRFMEM(BX*BY, PIXMAP)
      IF (IER.NE.1) THEN
         CALL GRGMSG(IER)
         CALL GRWARN('Failed to deallocate plot buffer.')
      END IF
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      MAXIDX = MAX(MAXIDX, IC)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Not used.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      I = RBUF(1)
      CTABLE(1, I) = NINT(RBUF(2)*255)
      CTABLE(2, I) = NINT(RBUF(3)*255)
      CTABLE(3, I) = NINT(RBUF(4)*255)
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle fill ------------------------------------------
C
  240 CONTINUE
      IX0=NINT(RBUF(1))+1
      IX1=NINT(RBUF(3))+1
      IY1=BY-NINT(RBUF(2))
      IY0=BY-NINT(RBUF(4))
      IF (PIXMAP.NE.0) 
     :     CALL GRGI03(IX0, IY0, IX1, IY1, IC, BX, BY, %VAL(PIXMAP))
      RETURN
C
C--- IFUNC=25, Not implemented -----------------------------------------
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels ------------------------------------------
C
  260 CONTINUE
      CALL GRGI04(NBUF, RBUF, BX, BY, %VAL(PIXMAP), MAXIDX)
      RETURN
C
C--- IFUNC=27, Not implemented -----------------------------------------
C
  270 CONTINUE
      RETURN
C
C--- IFUNC=28, Not implemented -----------------------------------------
C
  280 CONTINUE
      RETURN
C
C--- IFUNC=29, Query color representation. -----------------------------
C
  290 CONTINUE
      I = RBUF(1)
      RBUF(2) = CTABLE(1,I)/255.0
      RBUF(3) = CTABLE(2,I)/255.0
      RBUF(4) = CTABLE(3,I)/255.0
      NBUF = 4
      RETURN
C-----------------------------------------------------------------------
      END

**GRGI01 -- PGPLOT GIF driver, draw line
*+
      SUBROUTINE GRGI01 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY
      BYTE PIXMAP(BX,BY)
*
* Draw a straight-line segment from absolute pixel coordinates
* (IX0, IY0) to (IX1, IY1).
*
* Arguments:
*  ICOL            (input): Color index
*  PIXMAP   (input/output): The image data buffer.
*-----------------------------------------------------------------------
      INTEGER IX, IY, IS
      REAL    D
      BYTE    VAL
*
      IF (ICOL.GT.127) THEN
         VAL = ICOL-256
      ELSE
         VAL = ICOL
      END IF
      IF (IX0.EQ.IX1 .AND. IY0.EQ.IY1) THEN
         PIXMAP(IX0,IY0)=VAL
      ELSE IF (ABS(IY1-IY0).GT.ABS(IX1-IX0)) THEN
         D=(IX1-IX0)/REAL(IY1-IY0)
         IS=1
         IF (IY1.LT.IY0) IS=-1
         DO 10 IY=IY0,IY1,IS
            IX=NINT(IX0+(IY-IY0)*D)
            PIXMAP(IX,IY)=VAL
 10      CONTINUE
      ELSE
         D=(IY1-IY0)/REAL(IX1-IX0)
         IS=1
         IF (IX1.LT.IX0) IS=-1
         DO 20 IX=IX0,IX1,IS
            IY=NINT(IY0+(IX-IX0)*D)
            PIXMAP(IX,IY)=VAL
 20      CONTINUE
      END IF
      END

**GRGI03 -- PGPLOT GIF driver, fill rectangle
*+
      SUBROUTINE GRGI03 (IX0, IY0, IX1, IY1, ICOL, BX, BY, PIXMAP)
      INTEGER IX0, IY0, IX1, IY1
      INTEGER ICOL, BX, BY
      BYTE PIXMAP(BX,BY)
*
* Arguments:
*  IX0, IY0        (input): Lower left corner.
*  IX1, IY1        (input): Upper right corner.
*  ICOL            (input): Color value.
*  BX, BY          (input): dimensions of PIXMAP.
*  PIXMAP   (input/output): The image data buffer.
*-----------------------------------------------------------------------
      INTEGER IX, IY
      BYTE VAL
C
      IF (ICOL.GT.127) THEN
         VAL = ICOL-256
      ELSE
         VAL = ICOL
      END IF
      DO 20 IY=IY0,IY1
         DO 10 IX=IX0,IX1
            PIXMAP(IX,IY) = VAL
 10      CONTINUE
 20   CONTINUE
      END

**GRGI04 -- PGPLOT GIF driver, fill image line
*+
      SUBROUTINE GRGI04(NBUF,RBUF,BX,BY,PIXMAP,MAXIDX)
      INTEGER I,J,NBUF,BX,BY,N,IC,MAXIDX
      REAL RBUF(NBUF)
      BYTE PIXMAP(BX,BY)
*-
      I = NINT(RBUF(1))+1
      J = BY-NINT(RBUF(2))
      DO 10 N=3,NBUF
         IC=RBUF(N)
         MAXIDX=MAX(MAXIDX,IC)
         IF (IC.GT.127) IC = IC-256
         PIXMAP(I+N-3,J)=IC
 10   CONTINUE
      END

**GRGI06 -- PGPLOT GIF driver, write GIF image
*+
      SUBROUTINE GRGI06 (UNIT, BX, BY, CTABLE, PIXMAP, MAXIDX, CODE)
      INTEGER UNIT, BX, BY, MAXIDX
      INTEGER CTABLE(3,0:255)
      BYTE PIXMAP(BX * BY)
      INTEGER*2 CODE(0:4097,0:255)
*
* Write GIF image to UNIT.
*
* Arguments:
* UNIT   (input): Output unit
* BX,BY  (input): `Screen' size
* CTABLE  (input): Color map
* PIXMAP (input): Image data
* MAXIDX (input): maximum color index used.
*--
* 16-Nov-94: fixed bug (BYTE is signed)
*-----------------------------------------------------------------------
      CHARACTER GIF1*6, GIF2*7, GIF3*3, GIF4*10
      CHARACTER*2 GRGI09
      INTEGER BMAX, BMULT, BREST, BOUT
      INTEGER PIXEL, I, J, K, M, CLEAR, EOI, TABLE, IN, TOTAL, PRE, EXT
      INTEGER OLDPRE, BITS
      INTEGER GRWFCH, GRWFIL
      BYTE BLKOUT(0:254)
      COMMON /GRGICO/ BMAX, BMULT, BREST, BOUT, BLKOUT

      BITS = 1
 10   IF (MAXIDX .LT. 2**BITS) GOTO 20
      BITS = BITS + 1
      GOTO 10
 20   CONTINUE
*
* Write Header.
*
      GIF1 = 'GIF87a'
      I = GRWFCH(UNIT, GIF1)
      IF (I.NE.6) CALL GRWARN ('Error writing GIF header')
*
* Write Logical Screen Descriptor (screen width, screen height,
* color data, background color index [0], pixel aspect ratio [0]).
*
      GIF2(1:2) = GRGI09(BX)
      GIF2(3:4) = GRGI09(BY)
      GIF2(5:5) = CHAR(128 + 17 * (BITS - 1))
      GIF2(6:6) = CHAR(0)
      GIF2(7:7) = CHAR(0)
      I = GRWFCH(UNIT, GIF2)
*
* Write Global Color Table.
*
      DO 30 J=0,2**BITS-1
         GIF3(1:1) = CHAR(CTABLE(1,J))
         GIF3(2:2) = CHAR(CTABLE(2,J))
         GIF3(3:3) = CHAR(CTABLE(3,J))
         I = GRWFCH(UNIT, GIF3)
 30   CONTINUE
*
      PIXEL = MAX(BITS, 2)
*
* Write Image Descriptor.
*
      GIF4(1:1) = ','
      GIF4(2:3) = GRGI09(0)
      GIF4(4:5) = GRGI09(0)
      GIF4(6:7) = GRGI09(BX)
      GIF4(8:9) = GRGI09(BY)
      GIF4(10:10) = CHAR(0)
      I = GRWFCH(UNIT, GIF4)
*
* Write Table Based Image Data, in sub-blocks of up to 255 bytes.
*
      I = GRWFCH(UNIT, CHAR(PIXEL))
C
C LZW-compression; initialize counters; define clear code and EOI code.
C Start packing variable-size codes into 8-bit bytes.
C Push a clear code first.
C `Read' first character.
C
      DO 100 M=0,255
         DO 100 K=0,4095
  100       CODE(K,M)=0
      CLEAR=2**PIXEL
      EOI=CLEAR + 1
      BREST=0
      BOUT=0
      BMULT=1
      BMAX=CLEAR*2
      CALL GRGI07(UNIT, CLEAR)
      IN=1
      TOTAL=BX*BY
      PRE=PIXMAP(IN)
      IF (PRE.LT.0) PRE = PRE+256
*
* Start new data stream at line 310:
* 2**n-1  (n+1)-bit codes
* 2*2**n  (n+2)-bit codes
* 4*2**n  (n+3)-bit codes
*    .         .      .
*   1024     11-bit codes
*   2048     12-bit codes (incl. one clear code)
*
  310 TABLE=EOI
      BMAX=CLEAR*2
*
* `Read' next character; check if combination prefix&extension occurred earlier
*
  320 IF (IN.GE.TOTAL) GOTO 350
      IN=IN+1
      EXT=PIXMAP(IN)
      IF (EXT.LT.0) EXT = EXT+256
      OLDPRE=PRE
      PRE=CODE(PRE,EXT)
      IF (PRE.GT.0) GOTO 320
*
* If no earlier occurrence add combination to table
*
      TABLE=TABLE+1
      CALL GRGI07(UNIT, OLDPRE)
      CODE(OLDPRE,EXT)=TABLE
      PRE=EXT
      IF (TABLE.EQ.BMAX) BMAX=BMAX*2
      IF (TABLE.LT.4095) GOTO 320
      CALL GRGI07(UNIT, CLEAR)
      DO 330 M=0,255
         DO 330 K=0,4095
  330       CODE(K,M)=0
      GOTO 310
*
* Last character
*
  350 CALL GRGI07(UNIT, PRE)
      CALL GRGI07(UNIT, EOI)
      IF (BMULT.GT.1) CALL GRGI08(UNIT, BREST)
      IF (BOUT.GT.0) THEN
         IF (BOUT.GT.127) THEN
            BLKOUT(0) = BOUT-256
         ELSE
            BLKOUT(0) = BOUT
         END IF
         I = GRWFIL (UNIT, BOUT+1, BLKOUT(0))
         BOUT = 0
      END IF
      BLKOUT(0) = 0
      I = GRWFIL (UNIT, 1, BLKOUT(0))
*
* Write GIF Trailer.
*
      I = GRWFCH (UNIT, ';')
      END

**GRGI07 -- Compile GIF output code
*
      SUBROUTINE GRGI07(UNIT, INCODE)
      INTEGER UNIT, INCODE
      INTEGER BMAX, BMULT, BREST, BOUT
      BYTE BLKOUT(0:254)
      COMMON /GRGICO/ BMAX, BMULT, BREST, BOUT, BLKOUT
C
      BREST = BREST + BMULT * INCODE
      BMULT = BMULT * BMAX
C
   10 IF (BMULT .LT. 256) RETURN
      CALL GRGI08(UNIT, BREST)
      BREST = BREST / 256
      BMULT = BMULT / 256
      GOTO 10
C
      END

**GRGI08 -- Compile and write GIF output buffer
*
      SUBROUTINE GRGI08(UNIT, INCODE)
      INTEGER UNIT, INCODE, I, J, GRWFIL
      INTEGER BMAX, BMULT, BREST, BOUT
      BYTE BLKOUT(0:254)
      COMMON /GRGICO/ BMAX, BMULT, BREST, BOUT, BLKOUT
C
      BOUT = BOUT + 1
      J = MOD(INCODE,256)
      IF (J.GT.127) J = J-256
      BLKOUT(BOUT) = J
      IF (BOUT .LT. 254) RETURN
C!        changed 1997-Sep-2
      BLKOUT(0) = 254-256
      I = GRWFIL(UNIT, 255, BLKOUT(0))
      BOUT = 0
      END

**GRGI09 -- Encode integer in 2-char string
*
      CHARACTER*2 FUNCTION GRGI09(I)
      INTEGER I
      INTEGER I1, I2
*
      I1 = MOD(I,256)
      I2 = MOD(I/256,256)
      GRGI09(1:1) = CHAR(I1)
      GRGI09(2:2) = CHAR(I2)
      END

**GRGI10 -- Replace # in filename by picture number
*
      SUBROUTINE GRGI10 (NAME1, NP, NAME2)
      CHARACTER*(*) NAME1
      CHARACTER*(*) NAME2
      CHARACTER*80  TMP
      INTEGER GRTRIM
      INTEGER NP, IDX, L, LN

      LN = GRTRIM(NAME1)
      IDX = INDEX(NAME1,'#')
      IF (IDX.GT.0) THEN
C        -- if the supplied name contains a #-character, replace
C           it with the page number
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE IF (NP.EQ.1) THEN
C        -- if this is the first page, use the supplied name
         NAME2 = NAME1
         RETURN
      ELSE IF (LN+2.LE.LEN(NAME1)) THEN
C        -- append an underscore and the page number to the supplied
C           name
         NAME1(LN+1:LN+2) = '_#'
         CALL GRFAO(NAME1, L, TMP, NP, 0, 0, 0)
      ELSE
C        -- last resort: invent a new name
         CALL GRFAO('pgplot#.gif', L, TMP, NP, 0, 0, 0)
      END IF
      CALL GRWARN ('Writing new GIF image as: '//TMP(:L))
      NAME2 = TMP(:L)
      END

C*PGQNDT -- inquire number of available device types
C%void cpgqndt(int *n);
C+
      SUBROUTINE PGQNDT(N)
      INTEGER N
C
C Return the number of available device types. This routine is
C usually used in conjunction with PGQDT to get a list of the
C available device types.
C
C Arguments:
C  N      (output) : the number of available device types.
C--
C 17-Mar-1997 - new routine [TJP].
C-----------------------------------------------------------------------
      INTEGER NBUF, LCHR
      REAL RBUF(2)
      CHARACTER CHR
C
C Initialize PGPLOT if necessary.
C
      CALL PGINIT
C
C Find number of device types.
C
      CALL GREXEC(0, 0, RBUF, NBUF, CHR, LCHR)
      N = NINT(RBUF(1))
C
      END

C*PGSCF -- set character font
C%void cpgscf(int font);
C+
      SUBROUTINE PGSCF (FONT)
      INTEGER  FONT
C
C Set the Character Font for subsequent text plotting. Four different
C fonts are available:
C   1: (default) a simple single-stroke font ("normal" font)
C   2: roman font
C   3: italic font
C   4: script font
C This call determines which font is in effect at the beginning of
C each text string. The font can be changed (temporarily) within a text
C string by using the escape sequences \fn, \fr, \fi, and \fs for fonts
C 1, 2, 3, and 4, respectively.
C
C Argument:
C  FONT   (input)  : the font number to be used for subsequent text
C                    plotting (in range 1-4).
C--
C 26-Sep-1985 - new routine [TJP].
C 25-OCT-1993 - changed name of argument [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSCF')) RETURN
      CALL GRSFNT(FONT)
      END

C
      SUBROUTINE PGVW
C
C PGPLOT (internal routine): set the GRPCKG scaling transformation
C and window appropriate for the current window and viewport. This
C routine is called whenever the viewport or window is changed.
C
C Arguments: none
C
C (11-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
C
C Scale plotter in world coordinates.
C
      PGXSCL(PGID) = PGXLEN(PGID)/ABS(PGXTRC(PGID)-PGXBLC(PGID))
      PGYSCL(PGID) = PGYLEN(PGID)/ABS(PGYTRC(PGID)-PGYBLC(PGID))
      IF (PGXBLC(PGID).GT.PGXTRC(PGID)) THEN
          PGXSCL(PGID) = -PGXSCL(PGID)
      END IF
      IF (PGYBLC(PGID).GT.PGYTRC(PGID)) THEN
          PGYSCL(PGID) = -PGYSCL(PGID)
      END IF
      PGXORG(PGID) = PGXOFF(PGID)-PGXBLC(PGID)*PGXSCL(PGID)
      PGYORG(PGID) = PGYOFF(PGID)-PGYBLC(PGID)*PGYSCL(PGID)
      CALL GRTRN0(PGXORG(PGID),PGYORG(PGID),
     1            PGXSCL(PGID),PGYSCL(PGID))
C
C Window plotter in viewport.
C
      CALL GRAREA(PGID,PGXOFF(PGID),PGYOFF(PGID),
     1            PGXLEN(PGID),PGYLEN(PGID))
      END

C*PGQCF -- inquire character font
C%void cpgqcf(int *font);
C+
      SUBROUTINE PGQCF (FONT)
      INTEGER  FONT
C
C Query the current Character Font (set by routine PGSCF).
C
C Argument:
C  FONT   (output)   : the current font number (in range 1-4).
C--
C  5-Nov-1985 - new routine [TJP].
C 25-OCT-1993 - changed name of argument [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGQCF')) THEN
         FONT = 1
      ELSE
         CALL GRQFNT(FONT)
      END IF
      END

C*GRLIN3 -- draw a thick line (multiple strokes)
C+
      SUBROUTINE GRLIN3 (X0,Y0,X1,Y1)
C
C GRPCKG: draw a heavy line from (X0,Y0) to (X1,Y1) by making multiple
C strokes.  In order to simulate a thick pen, the line drawn has
C circular, rather than square, end points.  If this is not done,
C thick letters and other figures have an abnormal and unpleasant
C appearance.
C
C Vocabulary:
C
C LINEWT: the number of strokes required to draw the line; if
C       this is odd, one stroke will lie along the requested vector.
C       The nominal line thickness is (LINEWT-1)*0.005 in.
C RSQURD: the square of the semi-line thickness.
C (DX,DY): the vector length of the line.
C (VX,VY): a vector of length 1 pixel in the direction of the line.
C (VY,-VX): a vector of length 1 pixel perpendicular to (VX,VY).
C OFF: the offset parallel to (VY,-VX) of the K'th stroke.
C (VXK,VYK): the vector increment of the K'th stroke to allow for the
C       semi-circular terminal on the line.
C (PXK,PYK): the vector offset of the K'th stroke perpendicular to the
C       line vector.
C--
C (1-Feb-1983)
C 23-Nov-1994 - change algorithm so that the unit of line-width is
C               0.005 inch instead of 1 pixel [TJP].
C March 1995 - added ABS to prevent domain error in SQRT (CTD)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  K,LINEWT
      REAL     DX,DY, HK, OFF, PXK,PYK, RSQURD, VLEN,VX,VY,VXK,VYK
      REAL     X0,X1,Y0,Y1
      REAL     XS0,XS1, YS0,YS1, SPIX,SPIY
      LOGICAL  VIS
C
C Determine number of strokes and line thickness.
C
      LINEWT = GRWIDT(GRCIDE)
      RSQURD = ((LINEWT-1)**2)*0.25
C
C Determine the vectors (VX,VY), (VY,-VX). If the line-length is zero,
C pretend it is a very short horizontal line.
C
      DX = X1 - X0
      DY = Y1 - Y0
      VLEN = SQRT(DX**2 + DY**2)
      SPIX = GRPXPI(GRCIDE)*0.005
      SPIY = GRPYPI(GRCIDE)*0.005
C
      IF (VLEN .EQ. 0.0) THEN
          VX = SPIX
          VY = 0.0
      ELSE
          VX = DX/VLEN*SPIX
          VY = DY/VLEN*SPIY
      END IF
C
C Draw LINEWT strokes. We have to clip again in case thickening the
C line has taken us outside the window.
C
      OFF = (LINEWT-1)*0.5
      DO 10 K=1,LINEWT
          PXK = VY*OFF
          PYK = -(VX*OFF)
          HK  = SQRT(ABS(RSQURD - OFF**2))
          VXK = VX*HK
          VYK = VY*HK
          XS1 = X1+PXK+VXK
          YS1 = Y1+PYK+VYK
          XS0 = X0+PXK-VXK
          YS0 = Y0+PYK-VYK
          CALL GRCLPL(XS1,YS1,XS0,YS0,VIS)
          IF (VIS) CALL GRLIN2(XS1, YS1, XS0, YS0)
          OFF = OFF - 1.0
   10 CONTINUE
      END

C*GRLDEV -- list supported device types
C+
      SUBROUTINE GRLDEV
C
C Support routine for PGLDEV.
C
C Arguments: none
C--
C  5-Aug-1986 [AFT]
C 13-Dec-1990 Change warnings to messages [TJP].
C 18-Jan-1993 Display one per line [TJP].
C 13-Jan-1995 Change message [TJP].
C 10-Nov-1995 Ignore device types of zero length [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER I,NDEV,NBUF,LCHR
      REAL    RBUF(6)
      CHARACTER*72 CHR
      CHARACTER*72 TEXT
C---
      CALL GRMSG('Device types available:')
C--- First obtain number of devices.
      CALL GREXEC(0,0,RBUF,NBUF,CHR,LCHR)
      NDEV=NINT(RBUF(1))
C
      DO 10 I=1,NDEV
         CALL GREXEC(I, 1,RBUF,NBUF,CHR,LCHR)
         IF (LCHR.GT.0) THEN
            TEXT(1:1) = '/'
            TEXT(2:) = CHR(:LCHR)
            CALL GRMSG(TEXT)
         END IF
 10   CONTINUE
C
      END

C*GRDATE -- get date and time as character string (MS-DOS)
C+
      SUBROUTINE GRDATE(CDATE, LDATE)
      CHARACTER CDATE*(17)
      INTEGER   LDATE
C
C Return the current date and time, in format 'dd-Mmm-yyyy hh:mm'.
C To receive the whole string, the CDATE should be declared
C CHARACTER*17.
C
C ArguMents:
C  CDATE : receives date and time, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in STRING, excluding
C           trailing blanks. This will always be 17, unless the length
C           of the string supplied is shorter.
C--
C 1989-Mar-17 - [AFT]
C-----------------------------------------------------------------------
C
C 1995-Mar-21 [mlm]  Modified for Salford FTN77
C
      EXTERNAL EDATE@,TIME@
      CHARACTER*8 EDATE@,TIME@
      CDATE = EDATE@()//' '//TIME@()
      LDATE=17
      RETURN
      END

C*PGASK -- control new page prompting
C%void cpgask(Logical flag);
C+
      SUBROUTINE PGASK (FLAG)
      LOGICAL FLAG
C
C Change the ``prompt state'' of PGPLOT. If the prompt state is
C ON, PGPAGE will type ``Type RETURN for next page:'' and will wait
C for the user to type a carriage-return before starting a new page.
C The initial prompt state (after the device has been opened) is ON
C for interactive devices. Prompt state is always OFF for
C non-interactive devices.
C
C Arguments:
C  FLAG   (input)  : if .TRUE., and if the device is an interactive
C                    device, the prompt state will be set to ON. If
C                    .FALSE., the prompt state will be set to OFF.
C--
C-----------------------------------------------------------------------
      INCLUDE     'pgplot.inc'
      LOGICAL     PGNOTO
      CHARACTER*1 TYPE
C
      IF (PGNOTO('PGASK')) RETURN
C
      IF (FLAG) THEN
          CALL GRQTYP(TYPE,PGPRMP(PGID))
      ELSE
          PGPRMP(PGID) = .FALSE.
      END IF
      END

C*PGLDEV -- list available device types on standard output
C%void cpgldev(void);
C+
      SUBROUTINE PGLDEV
C
C Writes (to standard output) a list of all device types available in
C the current PGPLOT installation.
C
C Arguments: none.
C--
C 5-Aug-1986 - [AFT].
C 1-Aug-1988 - add version number [TJP].
C 24-Apr-1989 - add copyright notice [TJP].
C 13-Dec-1990 - changed warnings to messages [TJP].
C 26-Feb-1997 - revised description [TJP].
C 18-Mar-1997 - revised [TJP].
C-----------------------------------------------------------------------
      CHARACTER*16 GVER
      INTEGER L
      CHARACTER*10 T
      CHARACTER*64 D
      INTEGER I, N, TLEN, DLEN, INTER
C
C Initialize PGPLOT if necessary.
C
      CALL PGINIT
C
C Report version and copyright.
C
      CALL PGQINF('VERSION', GVER, L)
      CALL GRMSG('PGPLOT '//GVER(:L)//
     1           ' Copyright 1997 California Institute of Technology')
C
C Find number of device types.
C
      CALL PGQNDT(N)
C
C Loop through device-type list (twice).

      CALL GRMSG('Interactive devices:')
      DO 10 I=1,N
         CALL PGQDT(I, T, TLEN, D, DLEN, INTER)
         IF (TLEN.GT.0 .AND. INTER.EQ.1)
     :        CALL GRMSG('   '//T//' '//D(1:DLEN))
 10   CONTINUE
      CALL GRMSG('Non-interactive file formats:')
      DO 20 I=1,N
         CALL PGQDT(I, T, TLEN, D, DLEN, INTER)
         IF (TLEN.GT.0 .AND. INTER.EQ.0)
     :        CALL GRMSG('   '//T//' '//D(1:DLEN))
 20   CONTINUE
C
      END

C*WSDRIV -- PGPLOT driver for VAX workstations running VWS software
C+
      SUBROUTINE WSDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for VAX workstations.
C
C Version 1.0 - 1988 Feb 3  - T. J. Pearson (after an original by
C                             John Biretta).
C
C Version 1.1 - 1988 Mar 14 - S. C. Allendorf 
C                             Make work for 4 plane devices and some
C                             other minor changes/bugs.
C
C Version 1.1001 - 1988 Mar 17 - S. L. Morris
C                             Number of color entries corrected for 8 
C                             plane system.
C
C Version 1.2 - 1988 Mar 18 - S. C. Allendorf
C                             Change PAUSE to LIB$GET_COMMAND and change
C                             cursor routines.
C
C Version 2.0 - 1988 Mar 23 - S. C. Allendorf
C                             Add hardware area and rectangle fills
C                             (OPCODE = 24).  General cleanup.
C
C Version 3.0 - 1988 Apr 1  - S. C. Allendorf
C                             Use absolute device coordinates and add
C                             keypad cursor control.
C
C Version 3.1 - 1988 Nov 24 - S. C. Allendorf
C                             Change cursor so that it can be seen 
C                             against all choices of background colors.
C
C Version 3.2 - 1989 Jan 6  - S. C. Allendorf
C                             Disable display list entries to gain a 
C                             little more speed (30% in a test program).
C
C Version 3.3 - 1989 Jan 8  - S. C. Allendorf
C                             Remove all magic numbers from the code and
C                             query the hardware to get them.
C
C Version 4.0 - 1989 Apr 5  - S. C. Allendorf
C                             Add support for line of pixels and correct
C                             error in device selection support.
C
C Version 4.1 - 1989 Jun 07 - S. C. Allendorf
C                             Fix varying resolution support and other
C                             minor changes.  General cleanup.
C
C Version 4.2 - 1990 May 30 - S. C. Allendorf
C                             Fix cursor routine to function properly
C                             in a workstation environment.
C
C Version 4.3 - 1993 Apr 23 - T. J. Pearson
C                             This driver crashes when used with UISX.
C                             Changed so that it only crashes if the
C                             caller tries to use it.
C=======================================================================
C
C Supported device: This driver should work with all VAX/VMS 
C workstations running VWS software; it requires the UISSHR
C shareable image provided by DEC.
C
C Device type code: /WS.
C
C Default device name: PGPLOT.  Output is always directed to device 
C SYS$WORKSTATION; the "device name" provided by the user is used to 
C label the PGPLOT window.
C
C Default view surface dimensions: Depends on monitor.
C
C Resolution: Depends on monitor.
C
C Color capability: VAX workstations can have 1, 4, or 8 bitplanes.
C On 1-plane devices, there are only two colors (background = white,
C color index 1 = black). On 4-plane devices, color indices 0-11
C are available (4 indices are reserved for text windows and pointers).
C On 8-plane systems, color indices 0-249 are available (6 indices
C are reserved for text windows and pointers).
C
C Input capability: The cursor is controlled by the mouse or the keypad
C available on the controlling (DEC-like) keyboard. The user positions 
C the cursor, and then types any key on the controlling keyboard.
C
C File format: It is not possible (at present) to send workstation
C plots to a disk file.
C
C Obtaining hardcopy: Not possible (at present).
C-----------------------------------------------------------------------
C
C PGPLOT can be used in three modes on VAX Workstations. 
C 
C (1) Tektronix emulation. If you run a process in a Tektronix emulation
C window, you can use device specification "/TEK" to tell PGPLOT to
C plot in Tektronix mode within the same window. If you run in a VT220
C window, you can tell PGPLOT to create a new Tektronix window and plot
C in it by giving a device specification "TK:/TEK". (TK: is the VMS
C device name of the Tektronix emulator.) This has one problem: the
C window will be deleted as soon as your program calls PGEND or exits;
C you may need to add a user-prompt in your program before the call of
C PGEND. 
C 
C (2) UIS mode. In UIS mode, PGPLOT calls the UIS subroutines for
C creating graphics on the workstation. This has some advantages over
C Tektronix emulation; e.g., it is faster, can use colors, and can
C erase. The number of colors available depends on the VAXstation
C model. Use device specification "/WS" to tell PGPLOT to create a new
C window and plot using UIS calls. Again, the window is deleted on
C program exit. PGPLOT executes a LIB$GET_COMMAND statement before
C exiting, however, so that you can view the picture before it
C disappears. Type <RETURN> at the prompt when you are ready to
C continue. This also makes it impossible to overlay a plot created by
C one program on a plot created by another. (The /APPEND qualifier
C which allows this for other devices has no effect on device /WS.)
C PGPLOT uses a window which is nominally 11 inches wide by 8.5 inches
C tall, i.e., the same size as you would get in a hardcopy. If you
C prefer a vertical orientation, execute the following command before
C running the program: 
C 
C $ DEFINE PGPLOT_WS_ASPECT PORTRAIT 
C 
C Substitute LANDSCAPE for PORTRAIT to revert to horizontal
C orientation. 
C 
C The PGPLOT cursor is controlled by the mouse or the keypad on the
C controlling keyboard. Type any keyboard key to notify PGPLOT when you
C have positioned the cursor. The mouse buttons are ignored (at 
C present).
C
C (3) DECWindows mode. In DECWindows mode, PGPLOT calls the XLIB
C functions for creating graphics on the workstation.
C-----------------------------------------------------------------------
      LOGICAL    CHEAP, INIT, LANDSCAPE, MONO
      BYTE       KBYTE, PIXEL(1024)
      INTEGER*2  CROSS(32), KWORD
      INTEGER*4  HEIGHT, IC, ICH, IER, IMAX, IMIN, I0, I1, JMAX, JMIN
      INTEGER*4  J0, J1, KBID, L, GRFMEM, GRGMEM, LMESS, MAXCOL
      INTEGER*4  NPTS, REMCAL, RESCOL, SMG$CREATE_VIRTUAL_KEYBOARD
      INTEGER*4  SMG$DELETE_VIRTUAL_KEYBOARD, SMG$READ_KEYSTROKE
      INTEGER*4  SMG$SET_KEYPAD_MODE, STEP, UISDC$SET_POINTER_POSITION
      INTEGER*4  UIS$CREATE_COLOR_MAP, UIS$CREATE_DISPLAY
      INTEGER*4  UIS$CREATE_WINDOW, UIS$PRESENT, VCMID, VDID, WDID
      INTEGER*4  WIDTH, XBUF, YBUF
      REAL*4     CTABLE(3, 16), PIXEL_X, PIXEL_Y, RESOL(2), SCALE, XHGHT
      REAL*4     XWDTH
      CHARACTER  ASPECT*20, MESS*4, MSG*10, NAME*3
      EQUIVALENCE (KBYTE, KWORD)
      DATA NAME /'WS '/
      DATA INIT, STEP /.TRUE., 4/
C                                       Set up the cursor bitmap
      DATA CROSS /6 * 256, 256, 65534, 256, 6 * 256, 0,
     +            6 * 256,   0, 64638,   0, 6 * 256, 0/
C                                       Initialize the color table
      DATA CTABLE /0.0,0.0,0.0, 1.0,1.0,1.0, 1.0,0.0,0.0, 0.0,1.0,0.0,
     1             0.0,0.0,1.0, 0.0,1.0,1.0, 1.0,0.0,1.0, 1.0,1.0,0.0,
     2             1.0,0.5,0.0, 0.5,1.0,0.0, 0.0,1.0,0.5, 0.0,0.5,1.0,
     3             0.5,0.0,1.0, 1.0,0.0,0.5, 0.333,0.333,0.333, 
     5             0.667,0.667,0.667/
C                                       These avoid using the includes
      PARAMETER  PATT$C_FOREGROUND = 2
      PARAMETER  SMG$K_TRM_PF1 = 256
      PARAMETER  SMG$K_TRM_PF2 = 257
      PARAMETER  SMG$K_TRM_PF3 = 258
      PARAMETER  SMG$K_TRM_PF4 = 259
      PARAMETER  SMG$K_TRM_KP1 = 261
      PARAMETER  SMG$K_TRM_KP2 = 262
      PARAMETER  SMG$K_TRM_KP3 = 263
      PARAMETER  SMG$K_TRM_KP4 = 264
      PARAMETER  SMG$K_TRM_KP5 = 265
      PARAMETER  SMG$K_TRM_KP6 = 266
      PARAMETER  SMG$K_TRM_KP7 = 267
      PARAMETER  SMG$K_TRM_KP8 = 268
      PARAMETER  SMG$K_TRM_KP9 = 269
      PARAMETER  SMG$K_TRM_UP = 274
      PARAMETER  SMG$K_TRM_DOWN = 275
      PARAMETER  SMG$K_TRM_LEFT = 276
      PARAMETER  SMG$K_TRM_RIGHT = 277
      PARAMETER  SS$_NORMAL = 1
      PARAMETER  UIS$C_MODE_COPY = 2
C-----------------------------------------------------------------------
C                                       On first call, find out what 
C                                       sort of workstation we have.
C
      IF (INIT .AND. IFUNC.NE.1) THEN
         INIT = .FALSE.
C                                       Check for the UIS library.
         IER = UIS$PRESENT ()
C                                       Only do the following if we
C                                       actually have a UIS workstation.
         IF (IER .EQ. SS$_NORMAL) THEN
C                                       Get the number of planes.
C                                       NOTE: This may only work for
C                                       monochrome and color displays.
C                                       The code may not work for
C                                       intensity displays.
            CALL UIS$GET_HW_COLOR_INFO ('SYS$WORKSTATION', , MAXCOL,
     1                                  , , , , , , RESCOL)
C                                       Find the display resolution.
            CALL UIS$GET_DISPLAY_SIZE ('SYS$WORKSTATION', XWDTH, XHGHT,
     1                                 PIXEL_X, PIXEL_Y)
            RESOL(1) = PIXEL_X * 2.54
            RESOL(2) = PIXEL_Y * 2.54
C                                       Calculate a scale factor to 
C                                       handle display devices with
C                                       different resolutions.
            SCALE = 77.446785 / MAX (RESOL(1), RESOL(2))
C                                       Calculate the size of the border
C                                       around the plot.
            IMIN = NINT (0.25 * RESOL(1) * SCALE)
            JMIN = NINT (0.25 * RESOL(2) * SCALE)
C                                       See what orientation we want.
            CALL GRGENV ('WS_ASPECT', ASPECT, L)
            IF (ASPECT(1:1) .EQ. 'P') THEN
C                                       Portrait mode (pixels).
               WIDTH = NINT (8.113636 * RESOL(1) * SCALE)
               HEIGHT = NINT (10.5 * RESOL(2) * SCALE)
               LANDSCAPE = .FALSE.
            ELSE
C                                       Landscape mode (pixels).
               WIDTH = NINT (11.0 * RESOL(1) * SCALE)
               HEIGHT = NINT (8.5 * RESOL(2) * SCALE)
               LANDSCAPE = .TRUE.
            END IF
C                                       Set the other border.
            IMAX = WIDTH - IMIN - 1
            JMAX = HEIGHT - JMIN - 1
C                                       Calculate the size of the window
C                                       in centimeters.
            XWDTH = FLOAT (WIDTH) / PIXEL_X
            XHGHT = FLOAT (HEIGHT) / PIXEL_Y
         ELSE
C                                       Deal with error on the open
C                                       workstation call.
            MAXCOL = 1
            RESCOL = 0
         END IF
C                                       Set the machine characteristics.
         IF (MAXCOL .EQ. 256) THEN
            NAME = 'WS8'
            MONO = .FALSE.
            CHEAP = .FALSE.
         ELSE IF (MAXCOL .EQ. 16) THEN
            NAME = 'WS4'
            MONO = .FALSE.
            CHEAP = .TRUE.
         ELSE IF (MAXCOL .EQ. 2) THEN
            NAME = 'WS1'
            MONO = .TRUE.
            CHEAP = .TRUE.
         ELSE
            NAME = 'WS0'
            MONO = .TRUE.
            CHEAP = .TRUE.
         END IF
C                                       Set maximum color index.
         MAXCOL = MAXCOL - RESCOL - 1
      END IF
C                                       Branch on opcode.
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260), IFUNC
  900 WRITE (MSG, '(I10)') IFUNC
      CALL GRWARN ('Unimplemented function in VAX/WS device driver:'
     1              // MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CHR = NAME // '   (VAX UIS workstation)'
      LCHR =  27
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0.0
      RBUF(2) = FLOAT (IMAX - IMIN)
      RBUF(3) = 0.0
      RBUF(4) = FLOAT (JMAX - JMIN)
      RBUF(5) = 0.0
      RBUF(6) = FLOAT (MAXCOL)
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = RESOL(1)
      RBUF(2) = RESOL(2)
      RBUF(3) = 1.0
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Interactive, Cursor, No dashed lines, Area fill,
C    No thick lines, Rectangle fill, Line of pixels.)
C
   40 CONTINUE
      IF (CHEAP) THEN
         CHR = 'ICNANRNNNN'
      ELSE
         CHR = 'ICNANRPNNN'
      END IF
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = 'PGPLOT'
      LCHR = 6
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0.0
      RBUF(2) = FLOAT (IMAX - IMIN)
      RBUF(3) = 0.0
      RBUF(4) = FLOAT (JMAX - JMIN)
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1.0
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C                                       Return an error if UIS software 
C                                       is missing.
      IER = UIS$PRESENT ()
      IF (IER .NE. SS$_NORMAL) THEN
         CALL GRGMSG (IER)
         CALL GRWARN ('UIS is not installed on this system.')
         RBUF(2) = IER
         RETURN
      END IF
C                                       Open device.  First allocate a
C                                       color map.
      VCMID = UIS$CREATE_COLOR_MAP (MAXCOL + 1)
C                                       Create a display.
      VDID = UIS$CREATE_DISPLAY (0.0, 0.0, FLOAT (IMAX + IMIN), 
     1                         FLOAT (JMAX + JMIN), XWDTH, XHGHT, VCMID)
C                                       Disable display list entries
C                                       (~30% speed improvement).
      CALL UIS$DISABLE_DISPLAY_LIST (VDID)
C                                       Open a window.
      WDID = UIS$CREATE_WINDOW (VDID, 'SYS$WORKSTATION', CHR(:LCHR),
     1              0.0, 0.0, FLOAT (IMAX + IMIN), FLOAT (JMAX + JMIN),
     2              XWDTH, XHGHT)
C                                       Initialize device.  First
C                                       set the color registers.
      IF (MONO) THEN
C                                       Background (CI = 0) white, 
C                                       write (CI = 1) in black
         CALL UIS$SET_COLOR (VDID, 0, 1.0, 1.0, 1.0)
         CALL UIS$SET_COLOR (VDID, 1, 0.0, 0.0, 0.0)
      ELSE 
C                                       Define color indices 0-15;
C                                       background (CI = 0) black,
C                                       write (CI = 1) in white.
         DO 95 IC = 0, MIN (15, MAXCOL)
            CALL UIS$SET_COLOR (VDID, IC, CTABLE(1, IC + 1), 
     1                          CTABLE(2, IC + 1), CTABLE(3, IC + 1))
   95    CONTINUE
      END IF
C                                       Set the background color.
      CALL UIS$SET_BACKGROUND_INDEX (VDID, 0, 1, 0)
C                                       For some reason, this does not
C                                       work on monochrome systems.
      IF (.NOT. MONO) THEN
         CALL UIS$SET_WRITING_MODE (VDID, 1, 1, UIS$C_MODE_COPY)
      END IF
C                                       Set the font for fill patterns.
      CALL UIS$SET_FONT (VDID, 1, 1, 'UIS$FILL_PATTERNS')
C                                       Successful-- return wd_id.
      RBUF(1) = WDID
      RBUF(2) = 1.0
      NBUF = 2
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      CALL GRGCOM (MESS, CHAR (7)//'Type <RETURN> to continue: ', LMESS)
C                                       Clean up resources.
      CALL UIS$DELETE_WINDOW (WDID)
      CALL UIS$DELETE_DISPLAY (VDID)
      CALL UIS$DELETE_COLOR_MAP (VCMID)
C                                       Reset the initialization
C                                       variable.
      INIT = .TRUE.
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
C                                       Clear the screen.
      CALL UISDC$ERASE (WDID)
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      I0 = INT (RBUF(1) + 0.5) + IMIN
      J0 = INT (RBUF(2) + 0.5) + JMIN
      I1 = INT (RBUF(3) + 0.5) + IMIN
      J1 = INT (RBUF(4) + 0.5) + JMIN
      CALL UISDC$PLOT (WDID, 1, I0, J0, I1, J1)
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      I0 = INT (RBUF(1) + 0.5) + IMIN
      J0 = INT (RBUF(2) + 0.5) + JMIN
      CALL UISDC$PLOT (WDID, 1, I0, J0)
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      CALL UIS$SET_WRITING_INDEX (VDID, 1, 1, IC)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C           RBUF(1)   in/out : cursor x coordinate.
C           RBUF(2)   in/out : cursor y coordinate.
C           CHR(1:1)  output : keystroke.
C
  170 CONTINUE
C                                       Create a virtual keyboard for 
C                                       cursor control.
      IER = SMG$CREATE_VIRTUAL_KEYBOARD (KBID, 'SYS$COMMAND')
      IF (IER .NE. SS$_NORMAL) THEN
         CALL GRGMSG (IER)
         CALL GRQUIT ('Failed to create a virtual keyboard.')
      END IF
C                                       Set the keyboard to keypad mode.
      IER = SMG$SET_KEYPAD_MODE (KBID, 1)
      IF (IER .NE. SS$_NORMAL) THEN
         CALL GRGMSG (IER)
         CALL GRQUIT ('Failed to set keypad mode.')
      END IF
C                                       Set cursor pattern to a cross.
      CALL UISDC$SET_POINTER_PATTERN (WDID, CROSS, 2, 8, 8, IMIN, JMIN, 
     1        IMAX, JMAX)
C                                       Convert input coordinates.
      I0 = INT (RBUF(1) + 0.5) + IMIN
      J0 = INT (RBUF(2) + 0.5) + JMIN
C                                       Set cursor to correct spot (if
C                                       it is in the PGPLOT window).
  175 IF (I0 .GE. IMIN .AND. I0 .LE. IMAX .AND.
     1    J0 .GE. JMIN .AND. J0 .LE. JMAX) THEN
         CALL UIS$POP_VIEWPORT (WDID)
         IER = UISDC$SET_POINTER_POSITION (WDID, I0, J0)
         IF (IER .NE. SS$_NORMAL) THEN
            CALL GRGMSG (IER)
            CALL GRQUIT ('Failed to set the pointer position.')
         END IF
      END IF
C                                       Wait for a keystroke.
      IER = SMG$READ_KEYSTROKE (KBID, ICH)
C                                       Read cursor location (this
C                                       covers the case where the user
C                                       moved the cursor with the 
C                                       mouse).
      CALL UISDC$GET_POINTER_POSITION (WDID, I0, J0)
C                                       Catch error returns.
      IF (IER .NE. SS$_NORMAL) ICH = 0
C                                       Handle the keypad keys.
      IF (ICH .EQ. SMG$K_TRM_UP .OR. ICH .EQ. SMG$K_TRM_KP8) THEN
         J0 = MIN (JMAX, J0 + STEP)
      ELSE IF (ICH .EQ. SMG$K_TRM_DOWN .OR. ICH .EQ. SMG$K_TRM_KP2) THEN
         J0 = MAX (JMIN, J0 - STEP)
      ELSE IF (ICH .EQ. SMG$K_TRM_LEFT .OR. ICH .EQ. SMG$K_TRM_KP4) THEN
         I0 = MAX (IMIN, I0 - STEP)
      ELSE IF (ICH .EQ. SMG$K_TRM_RIGHT .OR. 
     1         ICH .EQ. SMG$K_TRM_KP6) THEN
         I0 = MIN (IMAX, I0 + STEP)
      ELSE IF (ICH .EQ. SMG$K_TRM_KP7) THEN
         I0 = MAX (IMIN, I0 - STEP)
         J0 = MIN (JMAX, J0 + STEP)
      ELSE IF (ICH .EQ. SMG$K_TRM_KP9) THEN
         I0 = MIN (IMAX, I0 + STEP)
         J0 = MIN (JMAX, J0 + STEP)
      ELSE IF (ICH .EQ. SMG$K_TRM_KP3) THEN
         I0 = MIN (IMAX, I0 + STEP)
         J0 = MAX (JMIN, J0 - STEP)
      ELSE IF (ICH .EQ. SMG$K_TRM_KP1) THEN
         I0 = MAX (IMIN, I0 - STEP)
         J0 = MAX (JMIN, J0 - STEP)
      ELSE IF (ICH .EQ. SMG$K_TRM_KP5) THEN
         I0 = WIDTH / 2
         J0 = HEIGHT / 2
      ELSE IF (ICH .EQ. SMG$K_TRM_PF1) THEN
         STEP = 1
      ELSE IF (ICH .EQ. SMG$K_TRM_PF2) THEN
         STEP = 4
      ELSE IF (ICH .EQ. SMG$K_TRM_PF3) THEN
         STEP = 16
      ELSE IF (ICH .EQ. SMG$K_TRM_PF4) THEN
         STEP = 64
      END IF
C                                       Toss out unacceptable 
C                                       characters.
      IF (ICH .LT. 0 .OR. ICH .GT. 255) GOTO 175
C                                       Make sure the pointer is in the
C                                       PGPLOT window.
      IF (I0 .LT. IMIN .OR. I0 .GT. IMAX) GOTO 175
      IF (J0 .LT. JMIN .OR. J0 .GT. JMAX) GOTO 175
C                                       Delete the virtual keyboard.
      IER = SMG$DELETE_VIRTUAL_KEYBOARD (KBID)
      IF (IER .NE. SS$_NORMAL) THEN
         CALL GRGMSG (IER)
         CALL GRWARN ('Failed to delete virtual keyboard.')
      END IF
C                                       Return the cursor to normal.
      CALL UISDC$SET_POINTER_PATTERN (WDID, , , , , IMIN, JMIN, 
     1        IMAX, JMAX)
C                                       Set the return values.
      CHR(1:1) = CHAR (ICH)
      RBUF(1) = FLOAT (I0 - IMIN)
      RBUF(2) = FLOAT (J0 - JMIN)
      NBUF = 2
      LCHR = 1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      IF (REMCAL .EQ. 0) THEN
C                                       First time, set number of points
C                                       in polygon and allocate the 
C                                       memory for the arrays.
         NPTS = RBUF(1)
         REMCAL = NPTS
         IER = GRGMEM (4 * NPTS, XBUF)
         IF (IER .NE. SS$_NORMAL) THEN
            CALL GRGMSG (IER)
            CALL GRQUIT ('Failed to allocate temporary buffer.')
         END IF
         IER = GRGMEM (4 * NPTS, YBUF)
         IF (IER .NE. SS$_NORMAL) THEN
            CALL GRGMSG (IER)
            CALL GRQUIT ('Failed to allocate temporary buffer.')
         END IF
      ELSE
C                                       Second and succeeding calls,
C                                       change counter and load arrays.
         REMCAL = REMCAL - 1
         I0 = INT (RBUF(1) + 0.5) + IMIN
         J0 = INT (RBUF(2) + 0.5) + JMIN
         CALL GRWS00 (NPTS, %VAL (XBUF), %VAL (YBUF), REMCAL, I0, J0)
C                                       If last call, fill the area and
C                                       deallocate the memory.
         IF (REMCAL .EQ. 0) THEN
            CALL UIS$SET_FILL_PATTERN (VDID, 1, 1, PATT$C_FOREGROUND)
            CALL UISDC$PLOT_ARRAY (WDID, 1, NPTS, %VAL (XBUF), 
     1                                            %VAL (YBUF))
            CALL UIS$SET_FILL_PATTERN (VDID, 1, 1)
            IER = GRFMEM (4 * NPTS, XBUF)
            IF (IER .NE. SS$_NORMAL) THEN
               CALL GRGMSG (IER)
               CALL GRWARN ('Failed to deallocate temporary buffer.')
            END IF
            IER = GRFMEM (4 * NPTS, YBUF)
            IF (IER .NE. SS$_NORMAL) THEN
               CALL GRGMSG (IER)
               CALL GRWARN ('Failed to deallocate temporary buffer.')
            END IF
         END IF 
      END IF
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
C                                       Ignore for a monochrome device.
      IF (.NOT. MONO) THEN
         IC = RBUF(1)
         CALL UIS$SET_COLOR (VDID, IC, RBUF(2), RBUF(3), RBUF(4))
      END IF
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle Fill. -----------------------------------------
C
  240 CONTINUE
      CALL UIS$SET_FILL_PATTERN (VDID, 1, 1, PATT$C_FOREGROUND)
      I0 = INT (RBUF(1) + 0.5) + IMIN
      J0 = INT (RBUF(2) + 0.5) + JMIN
      I1 = INT (RBUF(3) + 0.5) + IMIN
      J1 = INT (RBUF(4) + 0.5) + JMIN
      CALL UISDC$PLOT (WDID, 1, I0, J0, I1, J0, I1, J1, I0, J1)
      CALL UIS$SET_FILL_PATTERN (VDID, 1, 1)
      RETURN
C
C--- IFUNC=25, ---------------------------------------------------------
C    (Not implemented: ignored)
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels ------------------------------------------
C
  260 CONTINUE
      IF (CHEAP) THEN
          GOTO 900
      ELSE
         I0 = INT (RBUF(1) + 0.5) + IMIN
         J0 = INT (RBUF(2) + 0.5) + JMIN
         I1 = I0 + NBUF - 3
         DO 265 IC = 1, NBUF - 2
            KWORD = INT (RBUF(IC + 2) + 0.5)
            PIXEL(IC) = KBYTE
  265    CONTINUE
         CALL UISDC$IMAGE (WDID, 1, I0, J0, I1, J0, 
     1                                  NBUF - 2, 1, 8, PIXEL)
      END IF
      RETURN
C-----------------------------------------------------------------------
      END
 
C*GRWS00 -- PGPLOT WS driver, load polygon arrays
C+
      SUBROUTINE GRWS00 (N0, XBUF, YBUF, N, X, Y)
      INTEGER N, N0, X, XBUF(N0), Y, YBUF(N0)
C--
      XBUF(N0 - N) = X
      YBUF(N0 - N) = Y
      RETURN
      END

C*PGEND -- close all open graphics devices
C%void cpgend(void);
C+
      SUBROUTINE PGEND
C
C Close and release any open graphics devices. All devices must be
C closed by calling either PGCLOS (for each device) or PGEND before
C the program terminates. If a device is not closed properly, some
C or all of the graphical output may be lost.
C
C Arguments: none
C--
C 22-Dec-1995 [TJP] - revised to call PGCLOS for each open device.
C 25-Feb-1997 [TJP] - revised description.
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      INTEGER I
C
      DO 10 I=1,PGMAXD
         IF (PGDEVS(I).EQ.1) THEN
            CALL PGSLCT(I)
            CALL PGCLOS
         END IF
 10   CONTINUE
      END

C*GRMOVA -- move pen (absolute, world coordinates)
C+
      SUBROUTINE GRMOVA (X,Y)
C
C GRPCKG: move the pen to a specified location.
C
C Arguments:
C
C X, Y (real, input): world coordinates of the new pen position.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL     X,Y
C
      IF (GRCIDE.GE.1) THEN
C         WRITE (*,'(A,2F10.5)') 'GRMOVA', X, Y
          GRXPRE(GRCIDE) = X * GRXSCL(GRCIDE) + GRXORG(GRCIDE)
          GRYPRE(GRCIDE) = Y * GRYSCL(GRCIDE) + GRYORG(GRCIDE)
      END IF
      END

C*PGMTXT -- write text at position relative to viewport
C%void cpgmtxt(const char *side, float disp, float coord, \
C% float fjust, const char *text);
C+
      SUBROUTINE PGMTXT (SIDE, DISP, COORD, FJUST, TEXT)
      CHARACTER*(*) SIDE, TEXT
      REAL DISP, COORD, FJUST
C
C Write text at a position specified relative to the viewport (outside
C or inside).  This routine is useful for annotating graphs. It is used
C by routine PGLAB.  The text is written using the current values of
C attributes color-index, line-width, character-height, and
C character-font.
C
C Arguments:
C  SIDE   (input)  : must include one of the characters 'B', 'L', 'T',
C                    or 'R' signifying the Bottom, Left, Top, or Right
C                    margin of the viewport. If it includes 'LV' or
C                    'RV', the string is written perpendicular to the
C                    frame rather than parallel to it.
C  DISP   (input)  : the displacement of the character string from the
C                    specified edge of the viewport, measured outwards
C                    from the viewport in units of the character
C                    height. Use a negative value to write inside the
C                    viewport, a positive value to write outside.
C  COORD  (input)  : the location of the character string along the
C                    specified edge of the viewport, as a fraction of
C                    the length of the edge.
C  FJUST  (input)  : controls justification of the string parallel to
C                    the specified edge of the viewport. If
C                    FJUST = 0.0, the left-hand end of the string will
C                    be placed at COORD; if JUST = 0.5, the center of
C                    the string will be placed at COORD; if JUST = 1.0,
C                    the right-hand end of the string will be placed at
C                    at COORD. Other values between 0 and 1 give inter-
C                    mediate placing, but they are not very useful.
C  TEXT   (input) :  the text string to be plotted. Trailing spaces are
C                    ignored when justifying the string, but leading
C                    spaces are significant.
C
C--
C 18-Apr-1983
C 15-Aug-1987 - fix BBUF/EBUF error.
C 27-Aug-1987 - fix justification error if XPERIN.ne.YPERIN.
C 05-Sep-1989 - change so that DISP has some effect for 'RV' and 
C               'LV' options [nebk]
C 16-Oct-1993 - erase background of opaque text.
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
      REAL ANGLE, D, X, Y, RATIO, XBOX(4), YBOX(4)
      INTEGER CI, I, L, GRTRIM
      CHARACTER*20 TEST
C
      IF (PGNOTO('PGMTXT')) RETURN
C
      L = GRTRIM(TEXT)
      IF (L.LT.1) RETURN
      D = 0.0
      IF (FJUST.NE.0.0) CALL GRLEN(TEXT(1:L),D)
      D = D*FJUST
      RATIO = PGYPIN(PGID)/PGXPIN(PGID)
      CALL GRTOUP(TEST,SIDE)
      IF (INDEX(TEST,'B').NE.0) THEN
          ANGLE = 0.0
          X = PGXOFF(PGID) + COORD*PGXLEN(PGID) - D
          Y = PGYOFF(PGID) - PGYSP(PGID)*DISP
      ELSE IF (INDEX(TEST,'LV').NE.0) THEN
          ANGLE = 0.0
          X = PGXOFF(PGID) - PGYSP(PGID)*DISP - D
          Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - 0.3*PGYSP(PGID)
      ELSE IF (INDEX(TEST,'L').NE.0) THEN
          ANGLE = 90.0
          X = PGXOFF(PGID) - PGYSP(PGID)*DISP
          Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - D*RATIO
      ELSE IF (INDEX(TEST,'T').NE.0) THEN
          ANGLE = 0.0
          X = PGXOFF(PGID) + COORD*PGXLEN(PGID) - D
          Y = PGYOFF(PGID) + PGYLEN(PGID) + PGYSP(PGID)*DISP
      ELSE IF (INDEX(TEST,'RV').NE.0) THEN
          ANGLE = 0.0
          X = PGXOFF(PGID) + PGXLEN(PGID) + PGYSP(PGID)*DISP - D
          Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - 0.3*PGYSP(PGID)
      ELSE IF (INDEX(TEST,'R').NE.0) THEN
          ANGLE = 90.0
          X = PGXOFF(PGID) + PGXLEN(PGID) + PGYSP(PGID)*DISP
          Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - D*RATIO
      ELSE
          CALL GRWARN('Invalid "SIDE" argument in PGMTXT.')
          RETURN
      END IF
      CALL PGBBUF
      IF (PGTBCI(PGID).GE.0) THEN
          CALL GRQTXT (ANGLE, X, Y, TEXT(1:L), XBOX, YBOX)
          DO 25 I=1,4
              XBOX(I) = (XBOX(I)-PGXORG(PGID))/PGXSCL(PGID)
              YBOX(I) = (YBOX(I)-PGYORG(PGID))/PGYSCL(PGID)
   25     CONTINUE
          CALL PGQCI(CI)
          CALL PGSCI(PGTBCI(PGID))
          CALL GRFA(4, XBOX, YBOX)
          CALL PGSCI(CI)
      END IF
      CALL GRTEXT(.FALSE.,ANGLE,.TRUE., X, Y, TEXT(1:L))
      CALL PGEBUF
      END

C*GRCLOS -- close graphics device
C+
      SUBROUTINE GRCLOS
C
C GRPCKG: Close the open plot on the current device. Any pending output
C is sent to the device, the device is released for other users or the
C disk file is closed, and no further plotting is allowed on the device
C without a new call to GROPEN.
C
C Arguments: none.
C--
C  1-Jun-1984 - [TJP].
C 17-Jul-1984 - ignore call if plot is not open [TJP].
C  1-Oct-1984 - reset color to default (1) and position text cursor
C               at bottom of VT screen [TJP].
C 19-Oct-1984 - add VV device [TJP].
C 22-Dec-1984 - use GRBUFL and GRIOTA parameters [TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 21-Feb-1987 - modify END_PICTURE sequence [AFT].
C 11-Jun-1987 - remove built-ins [TJP].
C 31-Aug-1987 - do not eject blank page [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL    RBUF(6)
      INTEGER NBUF,LCHR
      CHARACTER CHR
C
C Check a plot is open.
C
      IF (GRCIDE.LT.1) RETURN
C
C Reset color to default (1). This is useful
C for VT240 terminals, which use the color tables for text.
C
      CALL GRSCI(1)
C
C Flush buffer.
C
      CALL GRTERM
C
C End picture.
C
      CALL GREPIC
C
C This plot identifier is no longer in use.
C Set state to "workstation closed".
C
      GRSTAT(GRCIDE) = 0
      GRCIDE = 0
C
C Close workstation.
C
      CALL GREXEC(GRGTYP,10,RBUF,NBUF,CHR,LCHR)
C
      END

C*PGCIRC -- draw a circle, using fill-area attributes
C%void cpgcirc(float xcent, float ycent, float radius);
C+
      SUBROUTINE PGCIRC (XCENT, YCENT, RADIUS)
      REAL XCENT, YCENT, RADIUS
C
C Draw a circle. The action of this routine depends
C on the setting of the Fill-Area Style attribute. If Fill-Area Style
C is SOLID (the default), the interior of the circle is solid-filled
C using the current Color Index. If Fill-Area Style is HOLLOW, the
C outline of the circle is drawn using the current line attributes
C (color index, line-style, and line-width).
C
C Arguments:
C  XCENT  (input)  : world x-coordinate of the center of the circle.
C  YCENT  (input)  : world y-coordinate of the center of the circle.
C  RADIUS (input)  : radius of circle (world coordinates).
C--
C 26-Nov-1992 - [TJP].
C 20-Sep-1994 - adjust number of points according to size [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      INTEGER MAXPTS
      PARAMETER (MAXPTS=72)
C
      INTEGER NPTS,I,RADPIX
      REAL ANGLE
      REAL X(MAXPTS),Y(MAXPTS)
C
      RADPIX = NINT(RADIUS*MAX(PGXSCL(PGID), PGYSCL(PGID)))
      NPTS = MAX(8, MIN(MAXPTS, RADPIX))
      DO 10 I=1,NPTS
         ANGLE = I*360.0/REAL(NPTS)/57.3
         X(I) = XCENT + RADIUS*COS(ANGLE)
         Y(I) = YCENT + RADIUS*SIN(ANGLE)
   10 CONTINUE
      CALL PGPOLY (NPTS,X,Y)
C     write (*,*) 'PGCIRC', NPTS
C-----------------------------------------------------------------------
      END

C*PGPANL -- switch to a different panel on the view surface
C%void cpgpanl(int nxc, int nyc);
C+
      SUBROUTINE PGPANL(IX, IY)
      INTEGER IX, IY
C
C Start plotting in a different panel. If the view surface has been
C divided into panels by PGBEG or PGSUBP, this routine can be used to
C move to a different panel. Note that PGPLOT does not remember what
C viewport and window were in use in each panel; these should be reset
C if necessary after calling PGPANL. Nor does PGPLOT clear the panel:
C call PGERAS after calling PGPANL to do this.
C
C Arguments:
C  IX     (input)  : the horizontal index of the panel (in the range
C                    1 <= IX <= number of panels in horizontal
C                    direction).
C  IY     (input)  : the vertical index of the panel (in the range
C                    1 <= IY <= number of panels in horizontal
C                    direction).
C--
C  1-Dec-1994 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE      'pgplot.inc'
      LOGICAL PGNOTO
C
C Check that a device is open.
C
      IF (PGNOTO('PGPANL')) RETURN
C
C Check arguments.
C
      IF (IX.LT.1 .OR. IX.GT.PGNX(PGID) .OR.
     :    IY.LT.1 .OR. IY.GT.PGNY(PGID)) THEN
         CALL GRWARN('PGPANL: the requested panel does not exist')
C
C Adjust the viewport to the new panel and window the plot
C in the new viewport.
C
      ELSE
         PGNXC(PGID)  = IX
         PGNYC(PGID)  = IY
         PGXOFF(PGID) = PGXVP(PGID) + (IX-1)*PGXSZ(PGID)
         PGYOFF(PGID) = PGYVP(PGID) + (PGNY(PGID)-IY)*PGYSZ(PGID)
         CALL PGVW
      END IF
C
      END

C*GRTRIM -- length of string excluding trailing blanks
C+
      INTEGER FUNCTION GRTRIM(S)
      CHARACTER*(*) S
C
C Find the length of a character string excluding trailing blanks.
C A blank string returns a value of 0.
C
C Argument:
C  S      (input)  : character string.
C
C Returns:
C  GRTRIM          : number of characters in S, excluding trailing
C                    blanks, in range 0...LEN(S). A blank string
C                    returns a value of 0.
C
C Subroutines required:
C  None
C
C Fortran 77 extensions:
C  None
C
C History:
C  1987 Nov 12 - TJP.
C-----------------------------------------------------------------------
      INTEGER  I
C
      IF (S.EQ.' ') THEN
          GRTRIM = 0
      ELSE
          DO 10 I=LEN(S),1,-1
              GRTRIM = I
              IF (S(I:I).NE.' ') GOTO 20
   10     CONTINUE
          GRTRIM = 0
   20     CONTINUE
      END IF
      END

C*GRCLPL -- clip line against clipping rectangle
C+
      SUBROUTINE GRCLPL (X0,Y0,X1,Y1,VIS)
C
C GRPCKG (internal routine): Change the end-points of the line (X0,Y0)
C (X1,Y1) to clip the line at the window boundary.  The algorithm is
C that of Cohen and Sutherland (ref: Newman & Sproull).
C
C Arguments:
C
C X0, Y0 (input/output, real): device coordinates of starting point
C       of line.
C X1, Y1 (input/output, real): device coordinates of end point of line.
C VIS (output, logical): .TRUE. if line lies wholly or partially
C       within the clipping rectangle; .FALSE. if it lies entirely
C       outside the rectangle.
C--
C 13-Jul-1984 - [TJP].
C 20-Jun-1985 - [TJP] - revise clipping algorithm.
C 28-Jun-1991 - [TJP] - use IAND().
C 12-Jun-1992 - [TJP] - clip exactly on the boundary.
C
C Caution: IAND is a non-standard intrinsic function to do bitwise AND
C of two integers. If it is not supported by your Fortran compiler, you
C will need to modify this routine or supply an IAND function.
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      LOGICAL  VIS
      INTEGER  C0,C1,C
      REAL     XMIN,XMAX,YMIN,YMAX
      REAL     X,Y, X0,Y0, X1,Y1
      INTEGER IAND
C
      XMIN = GRXMIN(GRCIDE)
      YMIN = GRYMIN(GRCIDE)
      XMAX = GRXMAX(GRCIDE)
      YMAX = GRYMAX(GRCIDE)
      CALL GRCLIP(X0,Y0,XMIN,XMAX,YMIN,YMAX,C0)
      CALL GRCLIP(X1,Y1,XMIN,XMAX,YMIN,YMAX,C1)
   10 IF (C0.NE.0 .OR. C1.NE.0) THEN
          IF (IAND(C0,C1).NE.0) THEN
C             ! line is invisible
              VIS = .FALSE.
              RETURN
          END IF
          C = C0
          IF (C.EQ.0) C = C1
          IF (IAND(C,1).NE.0) THEN
C             ! crosses XMIN
              Y = Y0 + (Y1-Y0)*(XMIN-X0)/(X1-X0)
              X = XMIN
          ELSE IF (IAND(C,2).NE.0) THEN
C             ! crosses XMAX
              Y = Y0 + (Y1-Y0)*(XMAX-X0)/(X1-X0)
              X = XMAX
          ELSE IF (IAND(C,4).NE.0) THEN
C             ! crosses YMIN
              X = X0 + (X1-X0)*(YMIN-Y0)/(Y1-Y0)
              Y = YMIN
          ELSE IF (IAND(C,8).NE.0) THEN
C             ! crosses YMAX
              X = X0 + (X1-X0)*(YMAX-Y0)/(Y1-Y0)
              Y = YMAX
          END IF
          IF (C.EQ.C0) THEN
              X0 = X
              Y0 = Y
              CALL GRCLIP(X,Y,XMIN,XMAX,YMIN,YMAX,C0)
          ELSE
              X1 = X
              Y1 = Y
              CALL GRCLIP(X,Y,XMIN,XMAX,YMIN,YMAX,C1)
          END IF
      GOTO 10
      END IF
      VIS = .TRUE.
      END

      SUBROUTINE BCDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      INTEGER   IFUNC, NBUF, LCHR
      REAL      RBUF(*)
      CHARACTER CHR*(*)
C
C PGPLOT driver for Canon Laser printer.
C---
C This driver produces a bitmap that then can be printed on the
C Canon.  The default size is 1556 blocks and takes 5 min
C (parallel) or 15 min (serial 9600 baud) to print.  Thus for
C simple line graphs CADRIVER produces much smaller files
C (typically <100 blocks) that that plot in <30 sec.  However, for
C complex graphs, for example those obtained with PGGRAY, BCDRIVER
C will produce the smaller file and plot faster.  Therefore, it is
C suggested that sites with Canon laser printers should support
C both drivers.
C---
C Supported device:  Canon LBP-8/A2 Laser printer.
C   Conforms to ISO646,2022,2375 and 6429 specifications.
C   VDM (graphics) conforms to proposed American National
C   Standard VDM mode.
C
C Device type code:  /BCanon (landscape mode only).
C
C Default file name:  PGPLOT.CAN
C
C Default view surface dimensions:  24 cm by 19 cm.
C Resolution:  300 pixels per inch in both directions.
C
C Color capability:  Color indices 0 (erase) and 1 (black) are
C   supported.  Note, hardware polygon fill is used and colors
C   0-11 control the fill pattern.
C
C Input capability:  None.
C
C File format:  Variable length records with Carriage control
C   of LIST.
C
C Obtaining hardcopy:  If printer is connected to a terminal
C   line (RS-232 option) then printing the file on the corresponding
C   queue should suffice.  If the printer is connected using
C   the Centronics interface that appears the to VAX as an
C   LP device then it is important to ensure that (1) all 8 bit
C   characters are passed to the printer (2) lines longer than
C   132 bytes are not truncated, and (3) no extra formatting
C   commands (e.g. form-feeds) are sent to the printer.
C   This can be done with the VMS command:
C   $ SET PRINT/PASSALL/LOWER/CR <device>
C   Note, some interface boards have a option to append a carriage
C   return after a formfeed or LF character, it is necessary
C   that this be disabled.
C   The file should be printed with the /PASSALL qualifier i.e.,
C   $ PRINT/PASSALL <filename>
C   Note, SET PRINT/PASSALL and PRINT/PASSALL do not do the
C   same things and hence PASSALL is required in both locations.
C---
C 13-Mar-1987 - [AFT].
C  4-MAR-1988 - Tidy code [AFT]
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE
      PARAMETER (TYPE=
     :     'BCANON (Canon laser printer, bitmap mode, landscape)')
      CHARACTER MSG*10
      INTEGER   GRGMEM, GRFMEM
      INTEGER   LUN, IXDIM, IYDIM, LENBUF, IBADR, IER
      INTEGER   ICOL, IREC, LENOLD
      SAVE      LUN, IXDIM, IYDIM, LENBUF, IBADR, IER
      SAVE      ICOL, IREC, LENOLD
      DATA LENOLD/0/
C---
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     >       110,120,130,140,150,160,900,180) IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in BC device driver: '//MSG)
      NBUF=-1
      RETURN
C
C--- IFUNC= 1, Return device name. -------------------------------------
   10 CHR=TYPE
      LCHR=LEN(TYPE)
      RETURN
C
C--- IFUNC= 2, Return Physical min and max for plot device. ------------
   20 RBUF(1)=0
      RBUF(2)=3320
      RBUF(3)=0
      RBUF(4)=2335
      RBUF(5)=0
      RBUF(6)=1
      NBUF=6
      RETURN
C
C--- IFUNC= 3, Return device resolution. -------------------------------
   30 RBUF(1)=300.0
      RBUF(2)=300.0
      RBUF(3)=1
      NBUF=3
      LCHR=LEN(CHR)
      RETURN
C
C--- IFUNC= 4, Return misc device info. --------------------------------
C H= Hardcopy
C N= No cursor
C N= No hard dash
C N= No area fill
C N= No hard thick lines
   40 CHR='HNNNNNNNNN'
      LCHR=10
      RETURN
C
C--- IFUNC= 5, Return default file name. -------------------------------
   50 CHR='PGPLOT.CAN'
      LCHR=LEN(CHR)
      RETURN
C
C--- IFUNC= 6, Return default physical size of plot. -------------------
   60 RBUF(1)=0
      RBUF(2)=2834
      RBUF(3)=0
      RBUF(4)=2244
      RETURN
C
C--- IFUNC= 7, Return misc defaults. -----------------------------------
   70 RBUF(1)=1
      NBUF=1
      RETURN
C
C--- IFUNC= 8, Select plot. --------------------------------------------
   80 RETURN
C
C--- IFUNC= 9, Open workstation. ---------------------------------------
   90 CALL GRGLUN(LUN)
      OPEN(UNIT=LUN,FILE=CHR(:LCHR),STATUS='NEW',ACCESS='DIRECT',
     >    RECL=128,IOSTAT=IER)
      IF(IER.NE.0) THEN
         CALL GRWARN('Cannot open graphics device '//CHR(:LCHR))
         RBUF(1)=LUN
         RBUF(2)=0
         CALL GRFLUN(LUN)
      ELSE
         RBUF(1)=0
         RBUF(2)=1
      END IF
      IREC=0
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
  100 CLOSE(UNIT=LUN)
      CALL GRFLUN(LUN)
      IF(LENOLD.GT.0) THEN
         IER=GRFMEM(LENBUF, IBADR)
         IF(IER.NE.1) THEN
            CALL GRGMSG(IER)
            CALL GRWARN('Failed to deallocate plot buffer.')
            RETURN
         END IF
         LENOLD=0
      END IF
      RETURN
C
C--- IFUNC=11, Begin Picture. ------------------------------------------
C- Note, IXMIN=0 and IXMAX=RBUF(1) so, IXDIM=IXMAX-IXMIN+1=RBUF(1)+1
  110 IXDIM=RBUF(1)+1
      IYDIM=INT(RBUF(2)/8.)+1
      LENBUF=IXDIM*IYDIM
      IF(LENBUF.NE.LENOLD) THEN
         IF(LENOLD.GT.0) THEN
            IER=GRFMEM(LENOLD, IBADR)
            IF(IER.NE.1) THEN
               CALL GRGMSG(IER)
               CALL GRWARN('Failed to deallocate plot buffer.')
               RETURN
            END IF
         END IF
         IER=GRGMEM(LENBUF, IBADR)
         IF(IER.NE.1) THEN
            CALL GRGMSG(IER)
            CALL GRWARN('Failed to allocate plot buffer.')
            RETURN
         END IF
         CALL GRBC05(LENBUF,%val(IBADR))
         LENOLD=LENBUF
      END IF
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
  120 CALL GRBC01(1,RBUF,ICOL,IYDIM,%val(IBADR))
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
  130 CALL GRBC01(0,RBUF,ICOL,IYDIM,%val(IBADR))
      RETURN
C
C--- IFUNC=14, End Picture. --------------------------------------------
  140 CALL GRBC04(LUN,IREC,%val(IBADR),IXDIM,IYDIM)
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C- Save pen number (up to 11) for possible use in pattern interior.
  150 ICOL=MAX(0,MIN(NINT(RBUF(1)),11))
      RBUF(1)=MAX(0,MIN(ICOL,1))
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
  160 RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
  180 RETURN
C-----------------------------------------------------------------------
      END

      SUBROUTINE GRBC01(LINE,RBUF,ICOL,IXDIM,QXYBUF)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, Bitmap Canon): draw a (visible)
C straight line segment from absolute pixel coordinates
C (RBUF(1),RBUF(2)) to (RBUF(3),RBUF(4)).  The line either overwrites
C (sets to black) or erases (sets to white) the previous contents
C of the bitmap, depending on the current color index. Setting bits
C is accomplished with a VMS BISB2 instruction, expressed in
C Fortran as .OR.; clearing bits is accomplished with a VMS BICB2
C instruction, expressed in Fortran as .AND..NOT.. The line is
C generated with a Simple Digital Differential Analyser (ref:
C Newman & Sproull). This routine is called by basic plotting
C routines GRDOT0 and GRLIN2.
C
C Arguments:
C
C LINE            I   I  =0 for dot, =1 for line.
C RBUF(1),RBUF(2) I   R  Starting point of line.
C RBUF(3),RBUF(4) I   R  End point of line.
C IXDIM           I   I  First array dimension of the frame buffer
C                        -considered as a two-dimensional byte array.
C QXYBUF          I/O B  (address of) the frame buffer.
C
C 13-Mar-1987 - Copied from GRVE01 routine for use with GEDRIVER [AFT].
C-----------------------------------------------------------------------
      BYTE    QXYBUF(0:*), QMASK(0:7)
      REAL    RBUF(4)
      INTEGER LINE, ICOL, IXDIM, LENGTH, KX, KY, K
      REAL    D, XINC, YINC, XP, YP
      DATA    QMASK /'80'x,'40'x,'20'x,'10'x,'08'x,'04'x,'02'x,'01'x/
C
      IF(LINE.GT.0) THEN
        LENGTH=NINT(MAX(ABS(RBUF(3)-RBUF(1)),ABS(RBUF(4)-RBUF(2))))
        D=MAX(1,LENGTH)
        XINC=(RBUF(3)-RBUF(1))/D
        YINC=(RBUF(4)-RBUF(2))/D
      ELSE
         LENGTH=0
         XINC=0.
         YINC=0.
      END IF
      XP=RBUF(1)
      YP=RBUF(2)
      IF (ICOL.GT.0) THEN
         DO K=0,LENGTH
            KX=NINT(XP)
            KY=NINT(YP)
            QXYBUF(KX*IXDIM+KY/8)=
     >       QXYBUF(KX*IXDIM+KY/8).OR.QMASK(MOD(KY,8))
            XP=XP+XINC
            YP=YP+YINC
         END DO
      ELSE
         DO K=0,LENGTH
            KX=NINT(XP)
            KY=NINT(YP)
            QXYBUF(KX*IXDIM+KY/8)=
     >       QXYBUF(KX*IXDIM+KY/8).AND.(.NOT.QMASK(MOD(KY,8)))
            XP=XP+XINC
            YP=YP+YINC
         END DO
      END IF
      RETURN
      END

      SUBROUTINE GRBC04(LUN,IREC,QBUF,IXDIM,IYDIM)
C-----------------------------------------------------------------------
C GRPCKG internal routine for Canon laser printer.
C Dumps bitmap to file, clearing bitmap.
C-----------------------------------------------------------------------
      INTEGER    IESC,    ICSI
      PARAMETER (IESC=27, ICSI=155)
      INTEGER   LUN, IREC, IXDIM, IYDIM
      BYTE      QBUF(*)
      INTEGER   LENBUF, ITMP, I, JC
      CHARACTER CREC*512, CTMP*16
      BYTE      QREC(512)
      EQUIVALENCE (QREC,CREC)
C---
      JC=0
C- First record, reset printer, set to ISO mode.
      CREC(JC+1:JC+6)=CHAR(IESC)//';'//CHAR(IESC)//'c'//
     :    CHAR(IESC)//';'
      JC=JC+6
      LENBUF=IXDIM*IYDIM
C- Work out absolute vertical position.
      ITMP=1+(3320-IXDIM)/100
      ITMP=MIN(ITMP,5)
      IF(ITMP.GT.1) THEN
         CREC(JC+1:JC+1)=CHAR(ICSI)
         JC=JC+1
         WRITE(CTMP,101) ITMP
  101    FORMAT(I16)
         DO I=1,LEN(CTMP)
            IF(CTMP(I:I).NE.' ') THEN
               JC=JC+1
               CREC(JC:JC)=CTMP(I:I)
            END IF
         END DO
         CREC(JC+1:JC+1)='d'
         JC=JC+1
      END IF
C- Work out absolute horizontal position.
      ITMP=1+(2400-IYDIM*8)/60
      ITMP=MIN(ITMP,4)
      IF(ITMP.GT.1) THEN
         CREC(JC+1:JC+1)=CHAR(ICSI)
         JC=JC+1
         WRITE(CTMP,101) ITMP
         DO I=1,LEN(CTMP)
            IF(CTMP(I:I).NE.' ') THEN
               JC=JC+1
               CREC(JC:JC)=CTMP(I:I)
            END IF
         END DO
         CREC(JC+1:JC+1)='`'
         JC=JC+1
      END IF
C- Drawing box command.
      CREC(JC+1:JC+1)=CHAR(ICSI)
      JC=JC+1
      WRITE(CTMP,101) LENBUF
      DO I=1,LEN(CTMP)
         IF(CTMP(I:I).NE.' ') THEN
            JC=JC+1
            CREC(JC:JC)=CTMP(I:I)
         END IF
      END DO
      JC=JC+1
      CREC(JC:JC)=';'
      WRITE(CTMP,101) IYDIM
      DO I=1,LEN(CTMP)
         IF(CTMP(I:I).NE.' ') THEN
            JC=JC+1
            CREC(JC:JC)=CTMP(I:I)
         END IF
      END DO
      CREC(JC+1:JC+6)=';300.r'
      JC=JC+6
C- Send binary data.
      DO I=1,LENBUF
         JC=JC+1
         QREC(JC)=QBUF(I)
         QBUF(I)=0
         IF(JC.EQ.512) THEN
            IREC=IREC+1
            WRITE(LUN,REC=IREC) QREC
            JC=0
         END IF
      END DO
C- Dump last record, if necessary.
      IF(JC.NE.0) THEN
         DO I=JC+1,512
            QREC(I)=0
         END DO
         IREC=IREC+1
         WRITE(LUN,REC=IREC) QREC
      END IF
      RETURN
      END

C*GRBC05 -- zero fill buffer
C+
      SUBROUTINE GRBC05 (BUFSIZ,BUFFER)
C
C GRPCKG (internal routine): fill a buffer with a given character.
C
C Arguments:
C
C BUFFER (byte array, input): (address of) the buffer.
C BUFSIZ (integer, input): number of bytes in BUFFER.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INTEGER  BUFSIZ, I
      BYTE     BUFFER(BUFSIZ), FILL
      DATA     FILL /0/
C
      DO 10 I=1,BUFSIZ
          BUFFER(I) = FILL
   10 CONTINUE
      END

C*GRSCR -- set color representation
C+
      SUBROUTINE GRSCR (CI, CR, CG, CB)
      INTEGER  CI
      REAL     CR, CG, CB
C
C GRPCKG: SET COLOUR REPRESENTATION -- define the colour to be
C associated with a colour index.  Ignored for devices which do not
C support variable colour or intensity.  On monochrome output
C devices (e.g. VT125 terminals with monochrome monitors), the
C monochrome intensity is computed from the specified Red, Green, Blue
C intensities as 0.30*R + 0.59*G + 0.11*B, as in US color television
C systems, NTSC encoding.  Note that most devices do not have an
C infinite range of colours or monochrome intensities available;
C the nearest available colour is used.
C
C Arguments:
C
C CI (integer, input): colour index. If the colour index is outside the
C       range available on the device, the call is ignored. Colour
C       index 0 applies to the background colour.
C CR, CG, CB (real, input): red, green, and blue intensities,
C       in range 0.0 to 1.0.
C--
C 20-Feb-1984 - [TJP].
C  5-Jun-1984 - add GMFILE device [TJP].
C  2-Jul-1984 - add REGIS device [TJP].
C  2-Oct-1984 - change use of map tables in Regis [TJP].
C 11-Nov-1984 - add code for /TK [TJP].
C  1-Sep-1986 - add GREXEC support [AFT].
C 21-Feb-1987 - If needed, calls begin picture [AFT].
C 31-Aug-1994 - suppress call of begin picture [TJP].
C  1-Sep-1994 - use common data [TJP].
C 26-Jul-1995 - fix bug: some drivers would ignore a change to the
C               current color [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER   NBUF, LCHR
      REAL      RBUF(6)
      CHARACTER CHR
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRSCR - Specified workstation is not open.')
      ELSE IF (CR.LT.0.0 .OR. CG.LT.0.0 .OR. CB.LT.0.0 .OR.
     1    CR.GT.1.0 .OR. CG.GT.1.0 .OR. CB.GT.1.0) THEN
          CALL GRWARN('GRSCR - Colour is outside range [0,1].')
      ELSE IF (CI.GE.GRMNCI(GRCIDE) .AND. CI.LE.GRMXCI(GRCIDE)) THEN
C         IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
          RBUF(1)=CI
          RBUF(2)=CR
          RBUF(3)=CG
          RBUF(4)=CB
          NBUF=4
          CALL GREXEC(GRGTYP,21,RBUF,NBUF,CHR,LCHR)
C         -- If this is the current color, reselect it in the driver.
          IF (CI.EQ.GRCCOL(GRCIDE)) THEN
             RBUF(1) = CI
             CALL GREXEC(GRGTYP,15,RBUF,NBUF,CHR,LCHR)
          END IF
      END IF
C
      END

C*LVDRIV -- PGPLOT driver for Digital LN03 printer (portrait mode)

      SUBROUTINE LVDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C-----------------------------------------------------------------------
C PGPLOT driver for Digital LN03 Laser Printer (PORTRAIT orientation)
C File : LVDRIVER.FOR
C-----------------------------------------------------------------------
C Version 1.0  - 1989 Nov. Sid Penstone, Queen's University
C Last Revision Dec.1.1989: Removed call to dot routine, now do it as
C a zero length vector
C-----------------------------------------------------------------------
C      This routine has been written specifically for the LN03-PLUS
C      Laser Printer
C
C      NAME: '/LVN03'
C
C
C       In all case, the initialization sequences are written out,
C      whether or not the plotter is connected as a terminal,
C      or driven from an intermediate file.
C
C      If there is more than one plot and the plot is on a terminal,
C      the page is ejected before the next one
C      
C      ref. Digital LN03 Programmer Reference Manual, P/N EK-OLN03-002
C
C      PHYICAL SIZE IS 7" BY 9"
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE
      PARAMETER (TYPE='LVN03 (Digital LN03 Laser Printer, portrait)')
C
      INTEGER MARGIN, NXPIX, NYPIX, NSIXROWS, NSIXCOLS
      PARAMETER(MARGIN=150)
      PARAMETER(NXPIX=2400)
      PARAMETER(NYPIX=3000)
      PARAMETER(NSIXROWS=(NYPIX/6)+2)
      PARAMETER(NSIXCOLS=NXPIX)
      CHARACTER*10 MSG
      INTEGER WIDTH,XLEFT,XRIGHT,YBOT,YTOP,INTENS, XMAX, YMAX, XMIN
      INTEGER UNIT, IER
      INTEGER I0, J0, I1, J1
      INTEGER IK1, IK2, IK3, IK4, IK5, PLOTNO
      CHARACTER*1 ESC
      DATA XLEFT,XRIGHT,YTOP,YBOT/0,NXPIX,0,NYPIX/
      DATA ESC /27/
      DATA WIDTH /2/
      LOGICAL ACTIVE(0:NSIXROWS)
C Data for the allocation routines
      INTEGER GRGMEM, GRFMEM
      INTEGER BUFLEN, IPOINTS, IERR
      LOGICAL ALLOC
      SAVE BUFLEN, IPOINTS, ALLOC
      DATA ALLOC /.FALSE./
      DATA IPOINTS /-1/
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
      GOTO 900
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
 10   CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
 20   RBUF(1) = 0
      RBUF(2) = NXPIX - 2*MARGIN
      RBUF(3) = 0
      RBUF(4) = NYPIX - 2*MARGIN
      RBUF(5) = 0
      RBUF(6) = 1
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
 30   RBUF(1) = 300.0
      RBUF(2) = 300.0
      RBUF(3) = WIDTH
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    No thick lines)
C
 40   CHR = 'HNNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
 50   CHR = 'PGPLOT.LN3'
      LCHR = 11
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
 60   RBUF(1) = 0
      RBUF(2) = NXPIX-2*MARGIN
      RBUF(3) = 0
      RBUF(4) = NYPIX-2*MARGIN
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
 70   RBUF(1) = 10
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
 80   CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
 90   CONTINUE
C Try to open the graphics device
      CALL GRGLUN(UNIT)
      OPEN (UNIT=UNIT,FILE=CHR(:LCHR),STATUS='NEW',
     1     FORM='FORMATTED', CARRIAGECONTROL='LIST',
     1     RECL=512,IOSTAT=IER)
      IF (IER.NE.0) THEN
         CALL ERRSNS(IK1,IK2,IK3,IK4,IK5)
         CALL GRWARN('Cannot open graphics device '
     1        //CHR(1:LCHR))
         IF (IK2.NE.0 .AND. IK2.NE.1) CALL GRGMSG(IK2)
         IF (IK5.NE.0 .AND. IK5.NE.1) CALL GRGMSG(IK5)
         RBUF(2) = 0 
         RETURN
      ENDIF
      RBUF(1) = UNIT
      RBUF(2) = 1
      NBUF = 2
C Now allocate the bitmap buffers (Assume integer*2)
      IF (.NOT. ALLOC) THEN
         BUFLEN = NSIXROWS * NSIXCOLS
         IERR = GRGMEM(2*BUFLEN, IPOINTS)
         IF (IERR .NE. 1 ) THEN
            CALL GRGMSG(IERR)
            CALL GRWARN('Memory allocation failure')
            RETURN
         ENDIF
         ALLOC = .TRUE.
      ENDIF
C Clear the row flags (and the bit map)
      CALL LN03_CLEAR(%VAL(IPOINTS),BUFLEN,ACTIVE,NSIXROWS)
C
C always write the preamble
C this resets the plotter
      WRITE (UNIT, '(A)') ESC//'c'
C this sets it for portrait, origin at corner 
      WRITE (UNIT, '(A)') ESC//'[?20 J'
      PLOTNO = 0
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
 100  CONTINUE
C always turn it off
      CLOSE (UNIT)
      CALL GRFLUN(UNIT)
C Deallocate the buffer
      IF (ALLOC .OR. IPOINTS .GE. 0) THEN
         IERR = GRFMEM(2*BUFLEN, IPOINTS)
         IF (IERR .NE. 1 ) THEN
            CALL GRGMSG(IERR)
            CALL GRWARN('Deallocation failure')
            RETURN
         ENDIF
         ALLOC = .FALSE.
         IPOINTS = -1
      ENDIF
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
 110  CONTINUE
C WE COULD GET THE VALUE OF XMAX AND YMAX HERE
      YMAX = YBOT - 2*MARGIN
      XMIN = XLEFT + MARGIN
      XMAX = XRIGHT - MARGIN
      PLOTNO = PLOTNO + 1
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
 120  CONTINUE
      I0 = XMIN + NINT(RBUF(1)) 
      J0 = YMAX  - NINT(RBUF(2))
      I1 = XMIN + NINT(RBUF(3))
      J1 = YMAX  - NINT(RBUF(4))
      CALL LN03_VECTOR(I0,J0,I1,J1,WIDTH,XLEFT,XRIGHT,
     1     YTOP,YBOT,%val(IPOINTS),ACTIVE,NSIXROWS,NSIXCOLS,INTENS)
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
 130  CONTINUE
      I0 = XLEFT + NINT(RBUF(1))
      J0 = YBOT  - NINT(RBUF(2))
      CALL LN03_VECTOR(I0,J0,I0,J0,WIDTH,XLEFT,XRIGHT,
     1     YTOP,YBOT,%VAL(IPOINTS),ACTIVE,NSIXROWS,NSIXCOLS,INTENS)
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
 140  CONTINUE
      CALL LN03_DUMP(UNIT,XLEFT,XMAX+WIDTH,YTOP+MARGIN,YMAX+WIDTH,
     1     %val(IPOINTS),ACTIVE,NSIXROWS,NSIXCOLS)
      IF(ALLOC) THEN
         CALL LN03_CLEAR(%VAL(IPOINTS),BUFLEN,ACTIVE,NSIXROWS)
      ENDIF
C  Eject the paper with a form feed
C     WRITE (UNIT, '(A)') CHAR(12)
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C
 150  INTENS = NINT(RBUF(1))
      IF (INTENS .GT.1 ) INTENS = 1 
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Null operation: buffering is not implemented.)
C
 160  CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called.)
C
 170  GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Null operation: there is no alpha screen.)
C
 180  CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called.)
C
 190  GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called.)
C
 200  GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
 210  RETURN
C      Other colors are not implemented
C
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called.)
C
 220  GOTO 900
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
 230  CONTINUE
      WRITE (UNIT, '(A)') CHR(:LCHR)
      RETURN
C-----------------------------------------------------------------------
C Error: unimplemented function.
C
 900  WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in LN03 device driver: '//MSG)
      NBUF = -1
      RETURN
C-----------------------------------------------------------------------
      END

C*GROPTX -- open text file for input or output (VMS)
C+
      INTEGER FUNCTION GROPTX (UNIT, NAME, DEFNAM, MODE)
      INTEGER UNIT, MODE
      CHARACTER*(*) NAME, DEFNAM
C
C Input:
C  UNIT : Fortran unit number to use
C  NAME : name of file to create
C  DEFNAM : default file name (used to fill in missing fields for VMS)
C  MODE : 0 for input, 1 for output
C
C Returns:
C  0 => success; any other value => error.
C-----------------------------------------------------------------------
      INTEGER IER
      IF (MODE.EQ.1) THEN
          OPEN (UNIT=UNIT,
     1      FILE=NAME,
     2      STATUS='NEW',
     3      CARRIAGECONTROL='LIST',
     4      DEFAULTFILE=DEFNAM,
     5      RECL=2048,
     6      IOSTAT=IER)
      ELSE
          OPEN (UNIT=UNIT,
     1      FILE=NAME,
     2      STATUS='OLD',
     3      READONLY,
     6      IOSTAT=IER)
      END IF
      GROPTX = IER
C-----------------------------------------------------------------------
      END

C Date:     3-FEB-1988 15:08:50 GMT
C From:     AFT@AST-STAR.CAM.AC.UK
C To:       TJP@CITPHOBO
C Subject:  ARDRIVER.FOR

        SUBROUTINE ARDRIV(IFUNC, RBUF, NBUF, CHR, LCHR)
        INTEGER   IFUNC, NBUF, LCHR
        REAL      RBUF(*)
        CHARACTER CHR*(*)
C
C PGPLOT driver for Args image device.
C---
C Supported device:  Sigma Args, 7000 series.
C
C Device type code:  /ARgs.
C
C Default device name:  ARGS_DEVICE (a logical name).
C
C Default view surface dimensions:  Depends on monitor.
C
C Resolution:  The full view surface is 512 by 512 pixels.
C
C Color capability: Color indices 0-255 are supported.  The default
C   representation is listed in Chapter 5 of the PGPLOT manual.  The
C   representation of all color indices can be changed.
C
C Input capability:  A cursor routine is provided that works on
C   Starlink Args devices.  It is possible to move the cursor with
C   either the tracker ball or by using the arrow keys on the terminal
C   (SYS$COMMAND); the PF1 to PF4 keys can be used to control the rate
C   at which the arrow keys move the cursor.  Terminate the cursor (in
C   all cases) by typing any printable character on the keyboard.
C
C File format:  It is not possible to send ARGS plots to a disk file.
C
C Obtaining hardcopy:  Not possible.
C---
C 17-Jan-1988 - No longer requires GESUPPORT routines [AFT].
C 21-Sep-1986 - [AFT].
C 15-Oct-1986 - Modified to work on a Q-bus [AFT].
C 16-Jan-1988 - [AFT]
C-----------------------------------------------------------------------
        INCLUDE '($IODEF)'
        INCLUDE '($PRDEF)'
        INCLUDE '($SSDEF)'
        INCLUDE '($SYIDEF)'
C
        CHARACTER MSG*10
        INTEGER   GRAR00, SYS$DASSGN, GRGMEM, IER
        INTEGER   IOCODE, I, I0, J0, I1, J1, ICPU
        INTEGER*2 ITMP(10), ILEV, IOSB(4)
        INTEGER   IREM, IWRT, IRD, ICHAN, MXCNT, ICNT, IBADR, ICOL
        SAVE      IREM, IWRT, IRD, ICHAN, MXCNT, ICNT, IBADR, ICOL
        INTEGER   MICRO, ITYPE
        SAVE      MICRO, ITYPE
        LOGICAL   APPEND
        SAVE      APPEND
C---
        GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     &       110,120,130,140,150,160,170,180,900,900,
     &       210,900,230) IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in AR device driver: '//MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC= 1, Return device name. -------------------------------------
10      CHR='ARGS'
        LCHR=LEN(CHR)
        RETURN
C
C--- IFUNC= 2, Return Physical min and max for plot device. ------------
20      RBUF(1)=0
        RBUF(2)=511
        RBUF(3)=0
        RBUF(4)=511
        RBUF(5)=0
        RBUF(6)=255
        NBUF=6
        RETURN
C
C--- IFUNC= 3, Return device resolution. -------------------------------
30      RBUF(1)=50.0
        RBUF(2)=50.0
        RBUF(3)=1
        NBUF=3
        RETURN
C
C--- IFUNC= 4, Return misc device info. --------------------------------
C I= Interactive device
C C= Cursor
C N= No hard dash
C A= No area fill (not implemented)
C N= No hard thick lines
40      CHR='ICNNNNNNNN'
        LCHR=10
        RETURN
C
C--- IFUNC= 5, Return default file name. -------------------------------
50      CHR='ARGS_DEVICE'
        LCHR=LEN(CHR)
        NBUF=1
        RETURN
C
C--- IFUNC= 6, Return default physical size of plot. -------------------
60      RBUF(1)=0
        RBUF(2)=511
        RBUF(3)=0
        RBUF(4)=511
        RETURN
C
C--- IFUNC= 7, Return misc defaults. -----------------------------------
70      RBUF(1)=1
        NBUF=1
        RETURN
C
C--- IFUNC= 8, Select plot. --------------------------------------------
80      CALL INAR03(ICHAN,IWRT)
        RETURN
C
C--- IFUNC= 9, Open workstation. ---------------------------------------
90      APPEND=RBUF(3).NE.0.0
        RBUF(2)=GRAR00(ICHAN,CHR,LCHR)
        RBUF(1)=ICHAN
C---
C- Allocate a buffer.  Note, there could be a hardware interface
C- bug for the ID driver which will cause the QIO to fail if the
C- buffer starts on the last two words of a page.  Since the address
C- returned by GRGMEM begins on a quadword boundary, this
C- condition can never arise.  However, some care is required
C- to make sure that the QIO to the Args only uses the buffer
C- allocated with GRGMEM.
C---
        MXCNT=8192
        IER=GRGMEM(MXCNT,IBADR)
        IF(IER .NE. SS$_NORMAL) THEN
            CALL GRGMSG(IER)
            CALL GRWARN('Unable to allocate virtual memory.')
            RBUF(2)=0
            CALL SYS$DASSGN(%val(ICHAN))
            RETURN
        END IF
C---
C- If device opened remotely, set remote flag.  Note, current
C- driver does not support remote access.
C---
        IF(NINT(RBUF(2)).EQ.1) THEN
            IREM=0
        ELSE IF(NINT(RBUF(2)).EQ.3) THEN
            IREM=1
            RBUF(2)=1
        ELSE
C- Error condition.
            RETURN
        END IF
C---
C- The QIO function is different for Unibus and Q-bus machines so
C- detect CPU type.
C---
        CALL LIB$GETSYI(SYI$_CPU,ICPU)
        IF(ICPU.EQ.PR$_SID_TYPUV1 .OR. ICPU.EQ.PR$_SID_TYPUV2) THEN
            MICRO=1
            ITYPE=1
            IWRT=IO$_WRITEVBLK
            IRD =IO$_READVBLK
        ELSE
            MICRO=0
            ITYPE=2
            IWRT=IO$_WRITEVBLK
            IRD =IO$_READVBLK
        END IF
C---
C- Init the buffer routine.
C---
        CALL INAR03(ICHAN,IWRT)
        CALL INAR01
C---
C- Cancel any outstanding I/O requests
C---
        CALL SYS$CANCEL(%val(ICHAN))
        CALL SYS$WAITFR()
C---
C- Reset interface.
C---
        IF(MICRO.EQ.0) THEN
            I=1
            IOCODE=IOR(IWRT,I*'0040'x)
            CALL SYS$QIOW(,%val(ICHAN),%val(IOCODE),IOSB,,,
     &              I,%val(I),,,,)
        ELSE
            I=2
            IOCODE=IOR(IWRT,'2800'x)
            CALL SYS$QIOW(,%val(ICHAN),%val(IOCODE),IOSB,,,
     &              %val(I),,,,,)
        END IF
C---
C- Load default lookup table (if not appending).
C---
        IF(.NOT.APPEND) CALL GRAR10(%val(IBADR),ICNT,MXCNT)
        RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
100     CALL SYS$DASSGN(%val(ICHAN))
        CALL GRFMEM(MXCNT,IBADR)
        RETURN
C
C--- IFUNC=11, Begin Picture. ------------------------------------------
110     CALL INAR01
        IF(.NOT.APPEND) THEN
          ITMP(1)='3501'x
          ITMP(2)='FFFF'x
          ITMP(3)='0003'x
          ITMP(4)='0003'x
          ITMP(5)='0003'x
          ITMP(6)='3501'x
          ITMP(7)='FFFF'x
          CALL GRAR02(ITMP,14,%val(IBADR),ICNT,MXCNT)
          CALL GRAR03(%val(IBADR),ICNT)
        END IF
        APPEND=.FALSE.
        RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
120     I0=NINT(RBUF(1))
        J0=NINT(RBUF(2))
        I1=NINT(RBUF(3))
        J1=NINT(RBUF(4))
        CALL GRAR01(I0,J0,I1,J1,%val(IBADR),ICNT,MXCNT)
        RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
130     I0=NINT(RBUF(1))
        J0=NINT(RBUF(2))
        CALL GRAR01(I0,J0,I0,J0,%val(IBADR),ICNT,MXCNT)
        RETURN
C
C--- IFUNC=14, End Picture. --------------------------------------------
140     RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
150     ICOL=MAX(0,MIN(NINT(RBUF(1)),255))
        ITMP(1)='2901'x
        ITMP(2)=ICOL
        CALL GRAR02(ITMP,4,%val(IBADR),ICNT,MXCNT)
        RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
160     CALL GRAR03(%val(IBADR),ICNT)
        RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
170     I0=RBUF(1)
        J0=RBUF(2)
        CALL GRAR11(ICHAN,I0,J0,CHR,%val(IBADR),ICNT,MXCNT)
        RBUF(1)=I0
        RBUF(2)=J0
        NBUF=2
        LCHR=1
        RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
180     RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
210     ITMP(1)=IOR('1800'x,0)
        ITMP(2)=NINT(RBUF(1))
        ILEV=IAND(255,INT(RBUF(2)*255.999))
        ITMP(3)=ILEV
        ILEV=IAND(255,INT(RBUF(3)*255.999))
        ITMP(3)=ISHFT(ILEV,8)+ITMP(3)
        ILEV=IAND(255,INT(RBUF(4)*255.999))
        ITMP(4)='FF00'x+ILEV
        CALL GRAR02(ITMP, 8, %val(IBADR), ICNT, MXCNT)
        RETURN
C
C--- IFUNC=23, Escape. -------------------------------------------------
C- Send CHR array directly to Args (user better know what he is doing!)
230     CALL GRAR02(%ref(CHR),LCHR,%val(IBADR),ICNT,MXCNT)
        RETURN
C-----------------------------------------------------------------------
        END
     
        INTEGER FUNCTION GRAR00(LUN,CHR,LCHR)
C-----------------------------------------------------------------------
C GRPCKG (Args internal routine): Opens a QIO channel to the Args.
C
C GRAR00 (returns integer): 0 if the channel could not be opened
C   1 if the channel was opened successfully on a local device,
C   3 for a successful open of a channel over a network,
C   (the remote status of the
C   device must be flagged since, the QIO functions codes are
C   different when writting to a physical device or to the
C   network).
C
C 16-Jan-1988 - Modified from GESUPPORT routine [AFT].
C-----------------------------------------------------------------------
        INCLUDE  '($IODEF)'
        INCLUDE  '($SSDEF)'
        INTEGER   DVI$_DEVCLASS, DVI$_DEVNAM
        PARAMETER (DVI$_DEVCLASS=4)
        PARAMETER (DVI$_DEVNAM=32)
        INTEGER   LUN,LCHR
        CHARACTER CHR*(*)
        INTEGER   IER, ITEMP
        INTEGER   DEVCLASS, ITMLIST(7), MOSB(2), ISTAT, LENGTH
        INTEGER   SYS$ASSIGN, SYS$QIOW
        INTEGER   SYS$GETDVI, SYS$DASSGN, SYS$WAITFR
        INTEGER*2 IOSB(4)
        LOGICAL   WRONG
C---
C- Assign an i/o channel
C---
        IER=SYS$ASSIGN(CHR(:LCHR), LUN,,)
        IF(IER.NE.SS$_NORMAL .AND. IER.NE.SS$_REMOTE) GOTO 900
        IF(IER.EQ.SS$_REMOTE) THEN
C---
C- Cannot check device characteristics easily if network device being used
C- so just check whether we opened the device successfully and return
C- Read back the status from assign to plotting device over network
C---
            IER=SYS$QIOW(,%VAL(LUN),%VAL(IO$_READVBLK),
     :                   IOSB,,,ISTAT,LENGTH,,,,)
            IF(IOSB(1) .NE. SS$_NORMAL) THEN
                CALL GRWARN ('Unable to read status from ASSIGN to' //
     :                      ' graphics device on remote node')
                WRITE(6,*) IOSB(2), ' bytes read'
                ITEMP=IOSB(1)
                CALL GRGMSG(ITEMP)
                GRAR00=0
                RETURN
            END IF
            IF(ISTAT .NE. SS$_NORMAL) THEN
                IER=ISTAT
                GOTO 900
            ELSE
                GRAR00=3
                RETURN
            END IF
        END IF
C---
C- Check that device has correct characteristics,
C- and obtain true device name.
C---
        ITMLIST(1)=DVI$_DEVCLASS*2**16+4
        ITMLIST(2)=%LOC(DEVCLASS)
        ITMLIST(3)=0
        ITMLIST(4)=DVI$_DEVNAM*2**16+LEN(CHR)
        ITMLIST(5)=%LOC(CHR)
        ITMLIST(6)=%LOC(LCHR)
        ITMLIST(7)=0
        IER=SYS$GETDVI(%VAL(0),,CHR(:LCHR),
     1                 ITMLIST,MOSB,,,)
        IF(.NOT.IER) GOTO 900
        IER=SYS$WAITFR(%VAL(0))
        IF(.NOT.IER) GOTO 900
        IF(.NOT.MOSB(1)) THEN
            IER=MOSB(1)
            GOTO 900
        END IF
        WRONG=DEVCLASS.NE.96
        IF(WRONG) THEN
            CALL GRWARN( CHR(:LCHR)//
     2            ' is the wrong sort of device for plot type.')
            IER=SYS$DASSGN(%VAL(LUN))
            GOTO 990
        END IF
C---
C- Successful completion
C---
        GRAR00=1
        RETURN
C---
C- Error exit
C---
900     CALL GRWARN('Cannot open graphics device '//CHR(:LCHR))
        CALL GRGMSG(IER)
990     GRAR00=0
        END
C*********
        SUBROUTINE GRAR01(I0,J0,I1,J1,IBUF,ICNT,MXCNT)
C-----------------------------------------------------------------------
C GRPCKG(internal routine, ARGS): draw a line segment.
C
C Arguments:
C
C I0,J0(integer*2, input): the column and row numbers of the starting
C       point.
C I1,J1(integer*2, input): the column and row numbers of the end point.
C
C Note: the arguments are specified as integer*2, but(on the VAX at
C least) integer*4 values may be used. The values should be in the
C range defined by the hardware:(0...511).
C
C 11-Apr-1983
C  7-Nov-1984 - KS/AAO) Some optimisation based on last position added.
C-----------------------------------------------------------------------
        INTEGER   I0, J0, I1, J1, ICNT, MXCNT
        INTEGER*2 IBUF
        INTEGER*2 CLIP511
        INTEGER   IPTR,X
        INTEGER*2 IC0, JC0, IC1, JC1, ITMP(4)
        INTEGER*2 LASTI, LASTJ
        SAVE      LASTI, LASTJ
C
        CLIP511(X)=X .AND. '1FF'x
C
        IC0=CLIP511(I0)
        JC0=CLIP511(J0)
        IC1=CLIP511(I1)
        JC1=CLIP511(J1)
C
        IF(IC0.NE.LASTI .OR. JC0.NE.LASTJ) THEN
            ITMP(1)=IOR(IC0,'C000'x)
            ITMP(2)=IOR(JC0,'A000'x)
            IPTR=3
        ELSE
            IPTR=1
        END IF
        ITMP(IPTR)  =IOR(IC1,'C000'x)
        ITMP(IPTR+1)=IOR(JC1,'E000'x)
        LASTI=IC1
        LASTJ=JC1
        CALL GRAR02(ITMP,2*(IPTR+1),IBUF,ICNT,MXCNT)
        RETURN
C
        ENTRY INAR01
        LASTI=-1
        LASTJ=-1
        RETURN
        END
C*********
        SUBROUTINE GRAR02(STR, N, QBUF, ICNT, MXCNT)
C-----------------------------------------------------------------------
C GRPCKG (Args internal routine): Transfer N bytes to
C the output buffer, flushing the buffer as necessary with the
C GRAR03 routine.  If the N bytes will not fit into the current
C buffer, then the buffer is first dumped.  This is to to cause
C STR to be transferred as a complete unit.
C Based on early versions of GRxx02 routines, this version does not
C use any common blocks.
C ***NOTE*** INAR03 must be called before any calls to GRAR02 to
C set the LUN/Channel to which the buffer should be dumped.
C
C Arguments:
C
C STR(N)        I Byte  Characters to be written.
C N             I I     The number of bytes to transfer.
C QBUF          I/O Byte The output buffer.
C ICNT          I/O I   Current number of bytes used in QBUF.
C MXCNT         I/O I   Maximum number of bytes that can be stored
C                       -in QBUF.
C
C 16-Jan-1988 - Based on GESUPPORT routine [AFT].
C-----------------------------------------------------------------------
        INTEGER  ICNT,MXCNT,I,N
        BYTE QBUF(N), STR(N)
C---
        IF(ICNT+N.GE.MXCNT) CALL GRAR03(QBUF,ICNT)
        DO 100 I=1,N
            ICNT=ICNT+1
            QBUF(ICNT)=STR(I)
100     CONTINUE
        RETURN
        END
C*********
        SUBROUTINE GRAR03(QBUF,ICNT)
C-----------------------------------------------------------------------
C GRPCKG (Args internal routine): Write ICNT bytes in QBUF to the device
C Reset ICNT to zero.
C ***NOTE*** INAR03 must be called before any calls to GRAR02 to
C set the correct Channel number.
C This subroutine contains the entry point INAR03 that defines
C the variables ICHAN and IFUNC.
C
C Arguments:
C
C QBUF          I/O Byte The output buffer.
C ICNT          I/O I   Current number of bytes used in QBUF.
C
C 16-Jan-1988 - Modified from GESUPPORT routines [AFT].
C-----------------------------------------------------------------------
        INCLUDE '($SSDEF)'
        INTEGER   SYS$QIOW
        INTEGER   ICNT
        BYTE      QBUF(*)
        INTEGER   RESULT, N
        INTEGER*2 IOSB(4)
        INTEGER   INCHAN,INFUNC
        INTEGER   ICHAN,IFUNC
        SAVE      ICHAN,IFUNC
C
        N=ICNT
        ICNT=0
        IF(N.LT.1) RETURN
C---
        RESULT=SYS$QIOW(,%val(ICHAN),%val(IFUNC),IOSB,,,
     1          QBUF(N+1),%val(4),
     2          QBUF,%val(N/2),%val(8),)
C---
        IF(RESULT.NE.SS$_NORMAL) THEN
            CALL GRGMSG(RESULT)
            CALL GRWARN('SYS$QIOW error writing to device.')
        END IF
        IF(IOSB(1).NE.SS$_NORMAL) THEN
            CALL GRGMSG(IOSB(1))
            CALL GRWARN('SYS$QIOW (IOSB) status writing to device.')
        END IF
        RETURN
C---
        ENTRY INAR03(INCHAN,INFUNC)
C- Save info needed to dump buffer.
        ICHAN=INCHAN
        IFUNC=INFUNC
        RETURN
        END
     
        SUBROUTINE GRAR10(IBUF,ICNT,MXCNT)
C-----------------------------------------------------------------------
C GRPCKG(internal routine, ARGS): advance the plotting area to a
C new page. This routine is called for ARGS devices by GRPAGE to
C reinitialize the display.
C
C 11-Apr-1983
C  7-Nov-1984 - Colour table code modified [KS/AAO].
C 21-Sep-1986 - Modified for use with GEDRIVER [AFT].
C-----------------------------------------------------------------------
        INTEGER   MXCOL
        PARAMETER (MXCOL=16)
C
        INTEGER   ICNT, MXCNT
        INTEGER*2 IBUF
C
        INTEGER   IPTR, ICLR
        INTEGER*2 ITMP(257)
C
        INTEGER*2 IRED(MXCOL), IBLUE(MXCOL), IGREEN(MXCOL)
        DATA IRED  /  0,255,255,  0,  0,  0,255,255,
     &              255,127,  0,  0,127,255, 85,170/
        DATA IGREEN/  0,255,  0,255,  0,255,  0,255,
     &              127,255,255,127,  0,  0, 85,170/
        DATA IBLUE /  0,255,  0,  0,255,255,255,  0,
     &                0,  0,127,255,255,127, 85,170/
C
C   Reset GSW to drawing mode,size and direction all zero, autoincrement on,
C   background overlay off, backwash off, cursor scroll disabled
C
        ITMP(1)='0E00'x         ! Load status word
        ITMP(2)='2000'x
C
C   Reset Z status register to 32 bits and 0 offset.
C
        ITMP(3)='0700'x
        ITMP(4)='1F00'x
        CALL GRAR02(ITMP,8,IBUF,ICNT,MXCNT)
C
C   Reset VSR to display graphics and overlay
C
        ITMP(1)='2401'x
        ITMP(2)='01C0'x
        ITMP(3)=0
        ITMP(4)='0007'x
        CALL GRAR02(ITMP,8,IBUF,ICNT,MXCNT)
C
C   Set origin to 0,0
C
        ITMP(1)='1000'x         ! X Origin to 0
        ITMP(2)=0
        ITMP(3)='1100'x         ! Y Origin to 0
        ITMP(4)=0
C
C   Put pen at origin
C
        ITMP(5)='C000'x
        ITMP(6)='A000'x
C
C   Unzoom
C
        ITMP(7)='5000'x
        ITMP(8)=0
        CALL GRAR02(ITMP,16,IBUF,ICNT,MXCNT)
C
C   No scroll
C
        ITMP(1)='3901'x
        ITMP(2)='FFFF'x
        ITMP(3)=0
        ITMP(4)='3B01'x
        ITMP(5)='FFFF'x
        ITMP(6)=0
        CALL GRAR02(ITMP,12,IBUF,ICNT,MXCNT)
C
C   Set write enable for lower 8 bit planes only
C
        ITMP(1)='2D01'x
        ITMP(2)='00FF'x
C
C   Turn on all planes
C
        ITMP(3)='2B01'x
        ITMP(4)='FFFF'x
        CALL GRAR02(ITMP,8,IBUF,ICNT,MXCNT)
C
C   Turn off lamps
C
        ITMP(1)='3C40'x
        ITMP(2)='3C45'x
        ITMP(3)=0
        CALL GRAR02(ITMP,6,IBUF,ICNT,MXCNT)
C
C   Set colour table
C
        IPTR=2
        DO ICLR=1,MXCOL
            IPTR=IPTR+2
            ITMP(IPTR-1)=IOR(ISHFT(IGREEN(ICLR),8),IRED(ICLR))
            ITMP(IPTR)  =IOR('FF00'x,IBLUE(ICLR))
        END DO
        ITMP(1)=IOR('1800'x,MXCOL-1)
        ITMP(2)=0
        CALL GRAR02(ITMP,2*IPTR,IBUF,ICNT,MXCNT)
C
C  Flush ARGS Buffer
C
        CALL GRAR03(IBUF,ICNT)
C
        RETURN
        END
     
      SUBROUTINE GRAR11(ICHAN, IX, IY, CHR, IBUF, ICNT, MXCNT)
      INTEGER   ICHAN, IX, IY, IBUF, ICNT, MXCNT
      CHARACTER CHR
C
C Arguments
C ICHAN  (input)  QIO channel assigned to Args
C IX,IY  (in/out) The cursor position
C CHR    (output) The keyboard character pressed
C IBUF   (input)  Address of a buffer area
C ICNT   (in/out) Number of bytes in use in buffer
C MXCNT  (input)  Maximum size of buffer in bytes
C---
C Read the cursor position on the Args.  The cursor can be moved
C by either rolling the tracker ball.
C The cursor can also be moved by using the cursor keys on the
C terminal associated with SYS$COMMAND in which case the cursor
C "speed" (step size) is controlled by the PF1 (smallest step) to
C PF4 (largest step) keys. The numeric keys on the keypad can be
C used in place of the arrow keys, with the addition of diagonal
C motion:
C         UP
C      7  8  9
C LEFT 4     6 RIGHT
C      1  2  3
C        DOWN
C---
C- 19-Jan-1988 - Modified to track VTDRIVER [AFT].
C---
      INTEGER   SMG$CREATE_VIRTUAL_KEYBOARD, SMG$READ_KEYSTROKE
      INTEGER   IXWAS, IYWAS, ISTEP, IER, IVAL, IXINC, IYINC
      INTEGER   SWITCH, IDSMG
      INTEGER*2 ITMP(10)
      LOGICAL   QKEY
C---
      IER=SMG$CREATE_VIRTUAL_KEYBOARD(IDSMG,'SYS$COMMAND')
      IF(IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRQUIT('Fatal error.')
      END IF
      ITMP(1)='3C40'x
      CALL GRAR02(ITMP,2,IBUF,ICNT,MXCNT)
      CALL GRAR03(IBUF,ICNT)
      CALL GRAR21(IX,IY,.TRUE.,.FALSE.,IBUF,ICNT,MXCNT)
      IXWAS=IX
      IYWAS=IY
      QKEY=.FALSE.
      ISTEP=2
      DO WHILE (.NOT.QKEY)
C- See if user has typed something at keyboard.
          IER=SMG$READ_KEYSTROKE(IDSMG,IVAL,,0)
          IF(IER.NE.1) IVAL=0
          IF(IVAL.EQ.259) THEN
C- PF4=large step
              ISTEP=64
          ELSE IF(IVAL.EQ.258) THEN
              ISTEP=8
          ELSE IF(IVAL.EQ.257) THEN
              ISTEP=4
          ELSE IF(IVAL.EQ.256) THEN
C- PF1=small step
              ISTEP=1
          ELSE IF(IVAL.EQ.49 .OR. IVAL.EQ.261) THEN
C- key 1 or KP1
              IX=IX-ISTEP
              IY=IY-ISTEP
          ELSE IF(IVAL.EQ.50 .OR. IVAL.EQ.262 .OR. IVAL.EQ.275) THEN
C- key 2, KP2 or DOWN
              IY=IY-ISTEP
          ELSE IF(IVAL.EQ.51 .OR. IVAL.EQ.263) THEN
C- key 3 or KP3
              IX=IX+ISTEP
              IY=IY-ISTEP
          ELSE IF(IVAL.EQ.52 .OR. IVAL.EQ.264 .OR. IVAL.EQ.276) THEN
C- key 4, KP4 or LEFT
              IX=IX-ISTEP
          ELSE IF(IVAL.EQ.54 .OR. IVAL.EQ.266 .OR. IVAL.EQ.277) THEN
C- key 6, KP6 or RIGHT
              IX=IX+ISTEP
          ELSE IF(IVAL.EQ.55 .OR. IVAL.EQ.267) THEN
C- key 7 or KP7
              IX=IX-ISTEP
              IY=IY+ISTEP
          ELSE IF(IVAL.EQ.56 .OR. IVAL.EQ.268 .OR. IVAL.EQ.274) THEN
C- key 8, KP8 or UP
              IY=IY+ISTEP
          ELSE IF(IVAL.EQ.57 .OR. IVAL.EQ.269) THEN
C- key 9 or KP9
              IX=IX+ISTEP
              IY=IY+ISTEP
          ELSE IF((IVAL.GT.0 .AND. IVAL.LT.48) .OR.
     &          (IVAL.GT.57 .AND. IVAL.LT.255)) THEN
              QKEY=.TRUE.
          END IF
          CALL GRAR22(ICHAN,IXINC,IYINC,SWITCH,IBUF,ICNT)
          IX=IX+IXINC
          IY=IY+IYINC
          IY=MAX(IY,0)
          IY=MIN(IY,511)
          IX=MAX(IX,0)
          IX=MIN(IX,511)
          CALL GRAR21(IX,IY,.FALSE.,.FALSE.,IBUF,ICNT,MXCNT)
          IF(IX.NE.IXWAS.OR.IY.NE.IYWAS) THEN
              IXWAS=IX
              IYWAS=IY
          ELSE
              CALL LIB$WAIT(0.05)
          END IF
      END DO
      CHR=CHAR(IVAL)
      CALL GRAR21(IX,IY,.FALSE.,.TRUE.,IBUF,ICNT,MXCNT)
C---
C- Free resources.
      CALL SMG$DELETE_VIRTUAL_KEYBOARD(IDSMG)
      RETURN
      END
     
        SUBROUTINE GRAR21(IX,IY,ON,OFF,IBUF,ICNT,MXCNT)
C-----------------------------------------------------------------------
C GRPCKG (Internal routine, ARGS) Control position of ARGS cursor
C
C Arguments:
C
C IX,IY  (Integer, input) Position to which cursor is to be moved.
C ON     (Logical, input) True if cursor is to be switched on.
C OFF    (Logical, input) True if cursor is to be switched off.
C
C If ON and OFF are both false, the cursor is positioned, but
C is switched neither on nor off.  If both are true, it is switched
C on and then off.
C
C (08-Nov-1984 KS / AAO)
C-----------------------------------------------------------------------
        LOGICAL ON,OFF
        INTEGER IX,IY,IBUF,ICNT,MXCNT
C
        INTEGER*2 CURON(4),CUROFF(4),CURPOS(4)
        INTEGER NWORDS
        DATA CURON /'2401'X,'01F8'X,'0008'X,'0000'X/
        DATA CUROFF/'2401'X,'01C0'X,'0000'X,'0000'X/
        DATA CURPOS/'1700'X,'0000'X,'2700'X,'0000'X/
C
        CURPOS(2)=IX
        CURPOS(4)=IY
        CALL GRAR02(CURPOS,8,IBUF,ICNT,MXCNT)
        NWORDS=4
        IF(ON) THEN
            CALL GRAR02(CURON,8,IBUF,ICNT,MXCNT)
            NWORDS=NWORDS+4
        END IF
        IF(OFF) THEN
            CALL GRAR02(CUROFF,8,IBUF,ICNT,MXCNT)
            NWORDS=NWORDS+4
        END IF
        CALL GRAR03(IBUF,ICNT)
C
        END
     
        SUBROUTINE GRAR22(ICHAN,IX,IY,SWITCH,IBUF,ICNT)
C--------------------------------------------------------------------
C GRPCKG  (Internal routine, ARGS) Read trackerball values
C
C Arguments -
C
C IX,IY  (Integer, output) Change in trackerball position in X and Y
C                          since this routine was last called.
C SWITCH (Integer, output) Switch status word.  Bits 3 through 6
C                          indicate switch operations since last
C                          read.
C
C Note: the trackerball must have been reset at some point before
C the first call to this routine.
C
C 13-Dec-1984 - [KS/AAO]
C 21-Mar-1987 - Should now work on micro-VAX [PWH/AFT]
C----------------------------------------------------------------------
        INCLUDE '($PRDEF)'
        INCLUDE '($SYIDEF)'
C
        INTEGER   ICHAN, IX, IY, SWITCH, IBUF, ICNT
C
        INCLUDE '($IODEF)'
C
        INTEGER   ICPU, IOSTAT, IER, SYS$QIOW
        INTEGER*2 IOSB(4), SBUFF(7)
        INTEGER*2 READC(5)
        DATA READC/0,0,0,0,'3C44'X/
C
C- Read trackerball.
C
        CALL GRAR03(IBUF,ICNT)
        CALL LIB$GETSYI(SYI$_CPU,ICPU)
        IF(ICPU.EQ.PR$_SID_TYPUV1 .OR. ICPU.EQ.PR$_SID_TYPUV2) THEN
C---
C- On Micro-VAX (Q-bus).
            IER=SYS$QIOW(,%val(ICHAN),%val(IO$_WRITEVBLK),IOSB,,,
     &                  READC(5), %val(2), %val(5),,,)
            IER=SYS$QIOW(,%val(ICHAN),%val(IO$_READVBLK),IOSB,,,
     &                  SBUFF(5), %val(6), %val(5),,,)
        ELSE
C---
C- On Unibus.
            IER=SYS$QIOW(,%val(ICHAN),%val(IO$_READVBLK),IOSB,,,
     &                  READC, %val(5),SBUFF,%val(7),,)
        END IF
        IOSTAT=IOSB(1)
        IF(.NOT.IER) IOSTAT=IER
        IF(.NOT.IOSTAT) THEN
            CALL GRGMSG(IOSTAT)
            CALL GRQUIT('SYS$QIOW failure reading from ARGS')
        END IF
C
        IX=SBUFF(5)
        IY=SBUFF(6)
        SWITCH=SBUFF(7)
C
        END

C*GRGTC0 -- obtain character digitization
C+
      SUBROUTINE GRGTC0 (CHAR,CENTER,POINTS,X,Y,MORE)
C
C GRPCKG (internal routine): obtain character digitization.
C
C (10-Feb-1983)
C-----------------------------------------------------------------------
      EXTERNAL GRDAT2
      LOGICAL CENTER
      INTEGER POINTS, CHAR
      REAL X(1)
      REAL Y(1)
      LOGICAL MORE
C
      INTEGER CINDX1, CINDX2
      INTEGER CTD1, CTD2
      PARAMETER (CTD1 = 30, CTD2 = 128)
      INTEGER CHTBL(CTD1, CTD2)
      COMMON /GRCS02/ CINDX1, CINDX2, CHTBL
C
      INTEGER I
      INTEGER COORDS
      LOGICAL TAILED
C-----------------------------------------------------------------------
      IF (CINDX2.LE.0) CINDX2 = CHAR + 1
C
C Get the next segment of the character.
C
      POINTS = CHTBL(CINDX1, CINDX2)
      IF(POINTS .EQ. 0) GO TO 240
      DO 220 I = 1, POINTS
          CINDX1 = CINDX1 + 1
          COORDS = CHTBL(CINDX1, CINDX2)
          TAILED = COORDS .LT. 0
          IF(TAILED) COORDS = IABS(COORDS)
          X(I) = FLOAT(COORDS / 10)
          Y(I) = FLOAT(MOD(COORDS, 10))
          IF(TAILED) Y(I) = - Y(I)
          IF(.NOT. CENTER) GO TO 220
          X(I) = X(I) - 3.0
          Y(I) = Y(I) - 4.0
  220     CONTINUE
  240 CONTINUE
C
C Set status and return.
C
      IF(CINDX1 .EQ. CTD1) GO TO 320
      CINDX1 = CINDX1 + 1
      IF(CHTBL(CINDX1, CINDX2) .EQ. 0) GO TO 320
      MORE = .TRUE.
      RETURN
  320 MORE = .FALSE.
      CINDX1 = 1
      CINDX2 = 0
      RETURN
      END

C*PGTBOX -- draw frame and write (DD) HH MM SS.S labelling
C%void cpgtbox(const char *xopt, float xtick, int nxsub, \
C% const char *yopt, float ytick, int nysub);
C+
      SUBROUTINE PGTBOX (XOPT, XTICK, NXSUB, YOPT, YTICK, NYSUB)
C
      REAL XTICK, YTICK
      INTEGER NXSUB, NYSUB
      CHARACTER XOPT*(*), YOPT*(*)
C
C Draw a box and optionally label one or both axes with (DD) HH MM SS 
C style numeric labels (useful for time or RA - DEC plots).   If this 
C style of labelling is desired, then PGSWIN should have been called
C previously with the extrema in SECONDS of time.
C
C In the seconds field, you can have at most 3 places after the decimal
C point, so that 1 ms is the smallest time interval you can time label.
C
C Large numbers are coped with by fields of 6 characters long.  Thus 
C you could have times with days or hours as big as 999999.  However, 
C in practice, you might have trouble with labels overwriting  themselves
C with such large numbers unless you a) use a small time INTERVAL, 
C b) use a small character size or c) choose your own sparse ticks in 
C the call to PGTBOX.  
C
C PGTBOX will attempt, when choosing its own ticks, not to overwrite
C the labels, but this algorithm is not very bright and may fail.
C
C Note that small intervals but large absolute times such as
C TMIN = 200000.0 s and TMAX=200000.1 s will cause the algorithm
C to fail.  This is inherent in PGPLOT's use of single precision
C and cannot be avoided.  In such cases, you should use relative
C times if possible.
C
C PGTBOX's labelling philosophy is that the left-most or bottom tick of
C the axis contains a full label.  Thereafter, only changing fields are
C labelled.  Negative fields are given a '-' label, positive fields
C have none.   Axes that have the DD (or HH if the day field is not
C used) field on each major tick carry the sign on each field.  If the
C axis crosses zero, the zero tick will carry a full label and sign.
C
C This labelling style can cause a little confusion with some special
C cases, but as long as you know its philosophy, the truth can be divined.
C Consider an axis with TMIN=20s, TMAX=-20s.   The labels will look like
C
C        +----------+----------+----------+----------+
C     0h0m20s      10s      -0h0m0s      10s        20s
C
C Knowing that the left field always has a full label and that
C positive fields are unsigned, informs that time is decreasing
C from left to right, not vice versa.   This can become very 
C unclear if you have used the 'F' option, but that is your problem !
C
C Exceptions to this labelling philosophy are when the finest time
C increment being displayed is hours (with option 'Y') or days.  
C Then all fields carry a label.  For example,
C
C        +----------+----------+----------+----------+
C      -10h        -8h        -6h        -4h        -2h
C
C
C PGTBOX can be used in place of PGBOX; it calls PGBOX and only invokes 
C time labelling if requested. Other options are passed intact to PGBOX.
C
C Inputs:
C  XOPT   :  X-options for PGTBOX.  Same as for PGBOX plus 
C
C             'Z' for (DD) HH MM SS.S time labelling
C             'Y' means don't include the day field so that labels
C                 are HH MM SS.S rather than DD HH MM SS.S   The hours
C                 will accumulate beyond 24 if necessary in this case.
C             'X' label the HH field as modulo 24.  Thus, a label
C                 such as 25h 10m would come out as 1h 10m
C             'H' means superscript numbers with d, h, m, & s  symbols
C             'D' means superscript numbers with    o, ', & '' symbols 
C             'F' causes the first label (left- or bottom-most) to
C                 be omitted. Useful for sub-panels that abut each other.
C                 Care is needed because first label carries sign as well.
C             'O' means omit leading zeros in numbers < 10
C                 E.g.  3h 3m 1.2s rather than 03h 03m 01.2s  Useful
C                 to help save space on X-axes. The day field does not 
C                 use this facility.
C
C  YOPT   :  Y-options for PGTBOX.  See above.
C  XTICK  :  X-axis major tick increment.  0.0 for default. 
C  YTICK  :  Y-axis major tick increment.  0.0 for default. 
C            If the 'Z' option is used then XTICK and/or YTICK must
C            be in seconds.
C  NXSUB  :  Number of intervals for minor ticks on X-axis. 0 for default
C  NYSUB  :  Number of intervals for minor ticks on Y-axis. 0 for default
C
C  The regular XOPT and YOPT axis options for PGBOX are
C
C  A : draw Axis (X axis is horizontal line Y=0, Y axis is vertical
C      line X=0).
C  B : draw bottom (X) or left (Y) edge of frame.
C  C : draw top (X) or right (Y) edge of frame.
C  G : draw Grid of vertical (X) or horizontal (Y) lines.
C  I : Invert the tick marks; ie draw them outside the viewport
C      instead of inside.
C  L : label axis Logarithmically (see below).
C  N : write Numeric labels in the conventional location below the
C      viewport (X) or to the left of the viewport (Y).
C  P : extend ("Project") major tick marks outside the box (ignored if
C      option I is specified).
C  M : write numeric labels in the unconventional location above the
C      viewport (X) or to the right of the viewport (Y).
C  T : draw major Tick marks at the major coordinate interval.
C  S : draw minor tick marks (Subticks).
C  V : orient numeric labels Vertically. This is only applicable to Y.
C      The default is to write Y-labels parallel to the axis.
C  1 : force decimal labelling, instead of automatic choice (see PGNUMB).
C  2 : force exponential labelling, instead of automatic.
C
C      The default is to write Y-labels parallel to the axis
C  
C
C        ******************        EXCEPTIONS       *******************
C
C        Note that 
C          1) PGBOX option 'L' (log labels) is ignored with option 'Z'
C          2) The 'O' option will be ignored for the 'V' option as it 
C             makes it impossible to align the labels nicely
C          3) Option 'Y' is forced with option 'D'
C
C        ***************************************************************
C
C
C--
C 05-Sep-1988 - new routine (Neil Killeen)
C 20-Apr-1991 - add support for new DD (day) field and implement
C               labelling on any axis (bottom,top,left,right) [nebk]
C 10-Jun-1993 - add option 'O' for leading zeros, correctly deal with 
C               user ticks, fully support 'V' and 'NM' options, modify
C               slightly meaning of 'F' option [nebk]
C 16-Jan-1995 - add option 'X' [nebk]
C 16-Aug-1996 - Bring axis labelling displacements more in line with 
C               those of pgbox.f [nebk]
C-----------------------------------------------------------------------
      REAL XTICKD, YTICKD, XMIN, XMAX, YMIN, YMAX
      INTEGER IPT, TSCALX, TSCALY, NXSUBD, NYSUBD
      CHARACTER XXOPT*15, YYOPT*15, SUPTYP*4
      LOGICAL XTIME, YTIME, FIRST, DODAYX, DODAYY, DO2, DOPARA, MOD24
C------------------------------------------------------------------------
C
C  Copy inputs
C
      XTICKD = XTICK
      YTICKD = YTICK
      NXSUBD = NXSUB
      NYSUBD = NYSUB
C
C  Get window in world coordinates
C 
      CALL PGQWIN (XMIN, XMAX, YMIN, YMAX)
C
C  X-axis first
C
      CALL GRTOUP (XXOPT, XOPT)
      XTIME = .FALSE.
      IF (INDEX(XXOPT,'Z').NE.0) THEN
C
C  Work out units for labelling and find the tick increments.
C
        IF (ABS(XMAX-XMIN).LT.0.001) THEN
          CALL GRWARN ('PGTBOX: X-axis time interval too small '//
     *                 '(< 1 ms) for time labels')
        ELSE
          XTIME = .TRUE.
          DODAYX = .TRUE.
          IF (INDEX(XXOPT,'Y').NE.0 .OR. INDEX(XXOPT,'D').NE.0) 
     *        DODAYX = .FALSE.
C
          DOPARA = .TRUE.
          CALL PGTBX1 ('X', DODAYX, DOPARA, XMIN, XMAX, XTICKD, 
     *                 NXSUBD, TSCALX)
        END IF
      END IF
C
C  Same again for Y-axis
C
      CALL GRTOUP (YYOPT, YOPT)
      YTIME = .FALSE.
      IF (INDEX(YYOPT,'Z').NE.0) THEN
        IF (ABS(YMAX-YMIN).LT.0.001) THEN
          CALL GRWARN ('PGTBOX: Y-axis time interval too small '//
     *                 '(< 1ms) for time labels')
        ELSE
          YTIME = .TRUE.
          DODAYY = .TRUE.
          IF (INDEX(YYOPT,'Y').NE.0 .OR. INDEX(YYOPT,'D').NE.0)
     *        DODAYY = .FALSE.
C
          DOPARA = .TRUE.
          IF (INDEX(YYOPT,'V').NE.0) DOPARA = .FALSE.
C
          CALL PGTBX1 ('Y', DODAYY, DOPARA, YMIN, YMAX, YTICKD, 
     *                 NYSUBD, TSCALY)
        END IF
      END IF
C
C  Parse options list.  For call to PGBOX when doing time labelling, we 
C  don't want L (log), N or M (write numeric labels). 
C
      IF (XTIME) THEN
        IPT = INDEX(XXOPT,'L')
        IF (IPT.NE.0) XXOPT(IPT:IPT) = ' '
        IPT = INDEX(XXOPT,'N')
        IF (IPT.NE.0) XXOPT(IPT:IPT) = ' '
        IPT = INDEX(XXOPT,'M')
        IF (IPT.NE.0) XXOPT(IPT:IPT) = ' '
      END IF
C
      IF (YTIME) THEN
        IPT = INDEX(YYOPT,'L')
        IF (IPT.NE.0) YYOPT(IPT:IPT) = ' '
        IPT = INDEX(YYOPT,'N')
        IF (IPT.NE.0) YYOPT(IPT:IPT) = ' '
        IPT = INDEX(YYOPT,'M')
        IF (IPT.NE.0) YYOPT(IPT:IPT) = ' '
      END IF
C
C  Draw box and ticks
C
      CALL PGBOX (XXOPT, XTICKD, NXSUBD, YYOPT, YTICKD, NYSUBD)
C
C  Add (DD) HH MM SS labels if desired.  Go back to the original user
C  specified options list.
C
      XXOPT = ' '
      CALL GRTOUP (XXOPT, XOPT)
      IF (XTIME .AND. (INDEX(XXOPT,'N').NE.0 .OR.
     *                 INDEX(XXOPT,'M').NE.0)) THEN
        FIRST = .TRUE.
        IF (INDEX(XXOPT,'F').NE.0) FIRST = .FALSE.
C
        SUPTYP = 'NONE'
        IF (INDEX(XXOPT,'D').NE.0) SUPTYP = ' DMS'
        IF (INDEX(XXOPT,'H').NE.0) SUPTYP = 'DHMS'
C
        DO2 = .TRUE.
        IF (INDEX(XXOPT,'O').NE.0) DO2 = .FALSE.
C
        DOPARA = .TRUE.
C
        MOD24 = .FALSE.
        IF (INDEX(XXOPT,'X').NE.0) MOD24 = .TRUE.
C
        IF (INDEX(XXOPT,'N').NE.0)
     *    CALL PGTBX4 (DODAYX, SUPTYP, 'X', .TRUE., FIRST, 
     *      XMIN, XMAX, TSCALX, XTICKD, DO2, DOPARA, MOD24)
C
        IF (INDEX(XXOPT,'M').NE.0)
     *    CALL PGTBX4 (DODAYX, SUPTYP, 'X', .FALSE., FIRST, 
     *       XMIN, XMAX, TSCALX, XTICKD, DO2, DOPARA, MOD24)
      END IF
C
      YYOPT = ' '
      CALL GRTOUP (YYOPT, YOPT)
      IF (YTIME .AND. (INDEX(YYOPT,'N').NE.0 .OR.
     *                 INDEX(YYOPT,'M').NE.0)) THEN
        FIRST = .TRUE.
        IF (INDEX(YYOPT,'F').NE.0) FIRST = .FALSE.
C
        SUPTYP = 'NONE'
        IF (INDEX(YYOPT,'D').NE.0) SUPTYP = ' DMS'
        IF (INDEX(YYOPT,'H').NE.0) SUPTYP = 'DHMS'
C
        DOPARA = .TRUE.
        IF (INDEX(YYOPT,'V').NE.0) DOPARA = .FALSE.
C
        DO2 = .TRUE.
        IF (DOPARA .AND. INDEX(YYOPT,'O').NE.0) DO2 = .FALSE.
C
        MOD24 = .FALSE.
        IF (INDEX(YYOPT,'X').NE.0) MOD24 = .TRUE.
C
        IF (INDEX(YYOPT,'N').NE.0)
     *    CALL PGTBX4 (DODAYY, SUPTYP, 'Y', .TRUE., FIRST, 
     *       YMIN, YMAX, TSCALY, YTICKD, DO2, DOPARA, MOD24)
C
        IF (INDEX(YYOPT,'M').NE.0)
     *    CALL PGTBX4 (DODAYY, SUPTYP, 'Y', .FALSE., FIRST, 
     *       YMIN, YMAX, TSCALY, YTICKD, DO2, DOPARA, MOD24)
C
      END IF
C
      RETURN
      END
C PGTBX1 -- support routine for PGTBOX
C
      SUBROUTINE PGTBX1 (AXIS, DODAY, DOPARA, TMIN, TMAX, TICK, 
     *                   NSUB, TSCALE)
C
      REAL TMIN, TMAX, TICK
      INTEGER NSUB, TSCALE
      LOGICAL DODAY, DOPARA
      CHARACTER AXIS*1
C
C Work out what the finest units the time labels will be in and
C return the tick increments if the user does not set them.
C
C This is a support routine for PGTBOX and should not 
C be called by the user.
C
C Input:
C  AXIS   :  'X' or 'Y' for use in determining if labels overwrite
C  TMIN   :  Start time in seconds 
C  TMAX   :  End   time in seconds
C  DOPARA :  True if label to be parallel to axis, else perpendicular
C Input/output:
C  DODAY  :  Write labels as DD HH MM SS.S else HH MM SS.S with
C            hours ranging above 24.  Useful for declination labels
C  TICK   :  Major tick interval in seconds.  If 0.0 on input, will 
C            be set here.
C  NSUB   :  Number of minor ticks between major ticks. If 0 on input
C            will be set here.
C Outputs:
C  TSCALE :  Determines finest unit of labelling 
C            (1 => ss, 60 => mm, 3600 => hh, 3600*24 => dd)
C
C 05-Sep-1988 - new routine (Neil Killeen)
C 08-Apr-1991 - correctly work out HH MM SS when the time > 60 h [nebk]
C 20-Apr-1991 - revise to add support for new DD (day) field and
C               do lots of work on tick algorithm [nebk]
C 10-Jun-1993 - deal with user given ticks & rename from PGTIME [nebk/jm]
C-----------------------------------------------------------------------
      INTEGER NLIST1, NLIST2, NLIST3, NLIST4, NTICMX
      PARAMETER (NLIST1 = 19, NLIST2 = 10, NLIST3 = 6, NLIST4 = 8,
     *           NTICMX = 8)
C
      REAL TICKS1(NLIST1), TICKS2(NLIST2), TICKS3(NLIST3), 
     *TICKS4(NLIST4), TOCK, TOCK2, TINT, TINTS, TMINS, TMAXS
      INTEGER NSUBS1(NLIST1), NSUBS2(NLIST2), NSUBS3(NLIST3), 
     *NSUBS4(NLIST4), NPL, NTICK, ITICK, STRLEN
      CHARACTER STR*15
C
      SAVE TICKS1, TICKS2, TICKS3, TICKS4
      SAVE NSUBS1, NSUBS2, NSUBS3, NSUBS4
C
      DATA TICKS1 /0.001,  0.002,                 0.005,
     *             0.01,   0.02,                  0.05,  
     *             0.1,    0.2,                   0.5,  
     *             1.0,    2.0,   3.0,    4.0,    5.0,
     *             6.0,   10.0,  15.0,   20.0,   30.0/
      DATA NSUBS1 / 4,      4,                     2,    
     *              4,      4,                     2,    
     *              4,      4,                     2,    
     *              4,      4,     3,      4,      5,
     *              3,      2,     3,      2,      3/
C
      DATA TICKS2 /1.0,    2.0,   3.0,    4.0,    5.0,
     *             6.0,   10.0,  15.0,   20.0,   30.0/
      DATA NSUBS2 / 4,      4,     3,      4,      5,
     *              3,      2,     3,      2,      3/
C
      DATA TICKS3 /1.0,    2.0,   3.0,    4.0,    6.0,   12.0/
      DATA NSUBS3 / 4,      4,     3,      4,      3,      2/
C
      DATA TICKS4 /1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 8.0, 9.0/
      DATA NSUBS4 / 4,   4,   3,   4,   5,   3,   4,   3 /
C----------------------------------------------------------------------
C
C  Turn off DD (day) field if it has been unnecessarily asked for
C
      IF ((ABS(TMIN).LT.24.0*3600.0) .AND. (ABS(TMAX).LT.24.0*3600.0))
     *   DODAY = .FALSE.
C
C  If a tick size is provided, use it to determine TSCALE
C
      TINT = ABS(TMAX - TMIN)
      TICK = ABS(TICK)
      IF (TICK.NE.0.0) THEN
        IF (TICK.GE.TINT) THEN
          CALL GRWARN ('PGTBX1: user given tick bigger than time '
     *                 //'interval; will auto-tick')
          TICK = 0.0
        ELSE IF (TICK.LT.0.001) THEN
          CALL GRWARN ('PGTBX1: user given tick too small (< 1 ms); '
     *                 //'will auto-tick')
          TICK = 0.0
        ELSE 
          IF (MOD(TICK, 60.0) .NE. 0.0) THEN
            TSCALE = 1
          ELSE IF (MOD(TICK, 3600.0).NE.0.0) THEN
            TSCALE = 60
          ELSE IF (.NOT.DODAY) THEN
            TSCALE = 3600
          ELSE IF (MOD(TICK,(24.0*3600.0)).NE.0.0) THEN
            TSCALE = 3600
          ELSE
            TSCALE = 24 * 3600
          ENDIF
C
C  Make a simple default for the number of minor ticks and bug out
C
          IF (NSUB.EQ.0) NSUB = 2
          RETURN
        END IF
      END IF
C
C  Work out label units depending on time interval if user 
C  wants auto-ticking
C
      IF (TINT.LE.5*60) THEN
        TSCALE = 1
      ELSE IF (TINT.LE.5*3600) THEN
        TSCALE = 60
      ELSE 
        IF (.NOT.DODAY) THEN
          TSCALE = 3600
        ELSE
          IF (TINT.LE.5*24*3600) THEN
            TSCALE = 3600
          ELSE
            TSCALE = 3600*24
          END IF
        END IF
      END IF
C
CCCCC
C  Divide interval into NTICK major ticks and NSUB minor intervals
C  The tick choosing algorithm is not very robust, so watch out
C  if you fiddle anything. 
CCCCC
C
      TINTS = TINT / TSCALE
      IF (TSCALE.EQ.1) THEN
C
C  Time in seconds.  If the time interval is very small, may need to 
C  label with up to 3 decimal places.  Have less ticks to help prevent
C  label overwrite. STR is a dummy tick label to assess label 
C  overwrite potential
C
        IF (DOPARA) THEN
          IF (TINTS.LE.0.01) THEN
            NTICK = 4
            STR = '60.423'
            STRLEN = 6
          ELSE IF (TINTS.LE.0.1) THEN
            NTICK = 5
            STR = '60.42'
            STRLEN = 5
          ELSE IF (TINTS.LE.1.0) THEN
            NTICK = 6
            STR = '60.4'
            STRLEN = 4
          ELSE
            NTICK = 6
            STR = '60s'
            STRLEN = 3
          END IF
        ELSE
          NTICK = 6
          STR = ' '
          STRLEN = 1
        END IF
        TOCK = TINTS / NTICK
C
C  Select nearest tick to TOCK from list.
C
        CALL PGTBX2 (TOCK, NLIST1, TICKS1, NSUBS1, TICK, NSUB, ITICK)
C
C  Check label overwrite and/or too many ticks.
C
        CALL PGTBX3 (DODAY, 0, TSCALE, TINTS, NTICMX, NLIST1, TICKS1,
     *               NSUBS1, ITICK, AXIS, DOPARA, STR(1:STRLEN),
     *               TICK, NSUB)
      ELSE IF (TSCALE.EQ.60) THEN
C
C  Time in minutes 
C
        NTICK = 6
        TOCK = TINTS / NTICK
C
C  Select nearest tick from list
C
        CALL PGTBX2 (TOCK, NLIST2, TICKS2, NSUBS2, TICK, NSUB, ITICK)
C
C  Check label overwrite and/or too many ticks.
C
        IF (DOPARA) THEN
          STR = '42m'
          STRLEN = 3
        ELSE
          STR = ' '
          STRLEN = 1
        END IF
        CALL PGTBX3 (DODAY, 0, TSCALE, TINTS, NTICMX, NLIST2, TICKS2,
     *               NSUBS2, ITICK, AXIS, DOPARA, STR(1:STRLEN),
     *               TICK, NSUB)
      ELSE 
        IF (TSCALE.EQ.3600 .AND. DODAY) THEN
C
C  Time in hours with the day field 
C
          NTICK = 6
          TOCK = TINTS / NTICK
C
C  Select nearest tick from list
C
          CALL PGTBX2 (TOCK, NLIST3, TICKS3, NSUBS3, TICK, NSUB, ITICK)
C
C   Check label overwrite and/or too many ticks.
C
          IF (DOPARA) THEN
            STR = '42h'
            STRLEN = 3
          ELSE
            STR = ' '
            STRLEN = 1
          END IF
          CALL PGTBX3 (DODAY, 0, TSCALE, TINTS, NTICMX, NLIST3, TICKS3,
     *                 NSUBS3, ITICK, AXIS, DOPARA, STR(1:STRLEN),
     *                 TICK, NSUB)
        ELSE
C
C  Time in hours with no day field or time in days. Have less
C  ticks for big numbers or the parallel labels will overwrite.

          IF (DOPARA) THEN
            TMINS = ABS(TMIN) / TSCALE
            TMAXS = ABS(TMAX) / TSCALE            
            CALL PGNPL (-1, NINT(MAX(TINTS,TMINS,TMAXS)), NPL)
            IF (NPL.LE.3) THEN
              NTICK = 6
            ELSE IF (NPL.EQ.4) THEN
              NTICK = 5
            ELSE
              NTICK = 4
            END IF
            STR = '345678912'
            STR(NPL+1:) = 'd'
            STRLEN = NPL + 1
          ELSE
            STR = ' '
            STRLEN = 1
            NTICK = 6
          END IF
          TOCK = TINTS / NTICK
C
C   Select nearest tick from list; 1 choose nearest nice integer 
C   scaled by the appropriate power of 10
C
          CALL PGNPL (-1, NINT(TOCK), NPL)
          TOCK2 = TOCK / 10**(NPL-1)
C
          CALL PGTBX2 (TOCK2, NLIST4, TICKS4, NSUBS4, TICK, NSUB, ITICK)
          TICK = TICK * 10**(NPL-1)
C
C  Check label overwrite and/or too many ticks.
C
          CALL PGTBX3 (DODAY, NPL, TSCALE, TINTS, NTICMX, NLIST4, 
     *                 TICKS4, NSUBS4, ITICK, AXIS, DOPARA,
     *                 STR(1:STRLEN), TICK, NSUB)
        END IF
      END IF
C
C  Convert tick to seconds
C
      TICK = TICK * TSCALE
C
      RETURN
      END
C PGTBX2 -- support routine for PGTBOX
C
      SUBROUTINE PGTBX2 (TOCK, NTICKS, TICKS, NSUBS, TICK, NSUB, ITICK)
C
      INTEGER NTICKS, NSUBS(NTICKS), NSUB, ITICK
      REAL TOCK, TICKS(NTICKS), TICK
C
C Find the nearest tick in a list to a given value.
C
C This is a support routine for PGTBOX and should not be called
C by the user.
C
C Input:
C  TOCK   :  Try to find the nearest tick in the list to TOCK
C  NTICKS :  Number of ticks in list
C  TICKS  :  List of ticks
C  NSUBS  :  List of number of minor ticks between ticks to go with TICKS
C Output:
C  TICK   :  The selected tick
C  ITICK  :  The index of the selected tick from the list TICKS
C Input/output
C  NSUB   :  Number of minor ticks between major ticks. If 0 on input
C            will be set here.
C
C 10-Jun-1993 - new routine [nebk]
C-----------------------------------------------------------------------
      INTEGER I, NSUBD
      REAL DMIN, DIFF
C----------------------------------------------------------------------
      NSUBD = NSUB
      DMIN = 1.0E30
      DO 100 I = 1, NTICKS
        DIFF = ABS(TOCK - TICKS(I))
        IF (DIFF.LT.DMIN) THEN
          TICK = TICKS(I)
          IF (NSUBD.EQ.0) NSUB = NSUBS(I)
          ITICK = I
C
          DMIN = DIFF
        END IF
 100  CONTINUE
C
      RETURN
      END
C PGTBX3 -- support routine for PGTBOX
C
      SUBROUTINE PGTBX3 (DODAY, NPL, TSCALE, TINTS, NTICMX, NTICKS,
     *                   TICKS, NSUBS, ITICK, AXIS, DOPARA, STR,
     *                   TICK, NSUB)
C
      INTEGER TSCALE, NTICMX, NTICKS, ITICK, NSUB, NSUBS(NTICKS), NPL
      REAL TINTS, TICKS(NTICKS), TICK
      CHARACTER AXIS*1, STR*(*)
      LOGICAL DODAY, DOPARA
C
C Try to see if label overwrite is going to occur with this tick 
C selection, or if there are going to be more than a reasonable
C number of ticks in the displayed time range.  If so, choose, 
C if available, the next tick (bigger separation) up in the list.
C If the overwrite requires that we would need to go up to the bext
C TSCALE, give up.  They will need to choose a smaller character size
C
C This is a support routine for PGTBOX and should not 
C be called by the user.
C
C Input:
C  DODAY  :  True if day field being used
C  NPL    :  Number of characters needed to format TICK on input
C  TSCALE :  Dictates what the finest units of the labelling are.
C            1 = sec, 60 = min, 3600 = hr, 24*3600 = days
C  TINTS  :  Absolute time interval in units of TSCALE
C  NTICMX :  Max. reasonable number of ticks to allow in the time range
C  NTICKS :  Number of ticks in list of ticks to choose from
C  TICKS  :  List of ticks from which the current tick was chosen
C  NSUBS  :  List of number of minor ticks/major tick to choose NSUB from
C  ITICK  :  Index of chosen tick in list TICKS
C  AXIS   :  'X' or 'Y' axis
C  DOPARA :  Labels parallel or perpendicualr to axis
C  STR    :  A typical formatted string used for checking overwrite
C Input/output:
C  TICK   :  Current major tick interval in units of TSCALE. May be 
C            made larger if possible if overwrite likely.
C  NSUB   :  Number of minor ticks between major ticks. 
C
C 10-Jun-1993 - new routine [nebk]
C-----------------------------------------------------------------------
      INTEGER NTICK
      REAL LENS, LENX, LENY
C----------------------------------------------------------------------
      CALL PGLEN (4, STR, LENX, LENY)
      LENS = LENX
      IF ( (DOPARA .AND. AXIS.EQ.'Y') .OR.
     *     (.NOT.DOPARA .AND. AXIS.EQ.'X') ) LENS = LENY
C
      IF (TSCALE.EQ.1 .OR. TSCALE.EQ.60 .OR.
     *    (TSCALE.EQ.3600 .AND. DODAY)) THEN
C
C  Time in seconds or minutes, or in hours with a day field
C
        NTICK = INT(TINTS / TICK)
        IF ( (ITICK.LT.NTICKS)  .AND. 
     *       ((DOPARA .AND. (LENS/TSCALE).GT.0.9*TICK) .OR. 
     *       (NTICK.GT.NTICMX)) ) THEN
          IF (TICKS(ITICK+1).LT.TINTS) THEN
            NSUB = NSUBS(ITICK+1)
            TICK = TICKS(ITICK+1)
          END IF
        END IF
      ELSE
C
C  Time in hours and no day field or time in days
C
        NTICK = INT(TINTS / TICK)
        IF ( (DOPARA .AND. (LENS/TSCALE).GT.0.9*TICK) .OR. 
     *       (NTICK.GT.NTICMX) ) THEN
          IF (ITICK.LT.NTICKS) THEN
            IF (TICKS(ITICK+1)*10**(NPL-1).LT.TINTS) THEN
              NSUB = NSUBS(ITICK+1)
              TICK = TICKS(ITICK+1) * 10**(NPL-1)
            END IF
          ELSE
            IF (TICKS(1)*10**NPL.LT.TINTS) THEN
              NSUB = NSUBS(1)
              TICK = TICKS(1) * 10**NPL
            END IF
          END IF
        END IF
      END IF
C
      RETURN
      END
C PGTBX4 -- support routine for PGTBOX
C
      SUBROUTINE PGTBX4 (DODAY, SUPTYP, AXIS, CONVTL, FIRST, TMIN,
     *                   TMAX, TSCALE, TICK, DO2, DOPARA, MOD24)
C
      REAL TMIN, TMAX, TICK
      INTEGER TSCALE
      CHARACTER AXIS*(*), SUPTYP*(*)
      LOGICAL FIRST, DODAY, CONVTL, DO2, DOPARA, MOD24
C
C Label an axis in (DD) HH MM SS.S style.    This is the main 
C workhorse of the PGTBOX routines.
C
C This is a support subroutine for PGTBOX and should not be 
C called by the user. 
C
C Inputs:
C  DODAY  :  Write labels as DD HH MM SS.S else HH MM SS.S with
C            hours ranging above 24.  Useful for declination labels
C  SUPTYP :  If 'DHMS' then superscript the fields with d, h, m, & s
C            If ' DMS' then superscript the fields with    o, '  & '' 
C              Good for declination plots.  You should obviously not 
C              ask for the day field for this to do anything sensible. 
C            If '    ' then no superscripting is done.
C  AXIS   :  'X' for x-axis, 'Y' for y-axis
C  CONVTL :  If .true., write the labels in the conventional axis 
C            locations (bottom and left for 'X' and 'Y').  Otherwise
C            write them on the top and right axes ('X' and 'Y')
C  FIRST  :  If .false. then omit the first label.
C  TMIN   :  Start time (seconds)
C  TMAX   :  End time (seconds)
C  TSCALE :  Determines finest units of axis
C              1 => ss, 60 => mm, 3600 => hh, 3600*24 => dd
C  TICK   :  Major tick interval in seconds
C  DO2    :  If .true., write labels less than 10 with a leading zero.
C  DOPARA :  Y axis label parallel to axis, else perpendicular
C  MOD24  :  HH field labelled as modulo 24
C
C 05-Sep-1988 - new routine (Neil Killeen)
C 20-Apr-1991 - add support for new DD (day) field [nebk]
C 10-Jun-1993 - complete rewrite & rename from PGTLAB. Fixes user given 
C               ticks bug too [nebk]
C 15-Jan-1995 - Add argument MOD24
C-----------------------------------------------------------------------
      INTEGER MAXTIK
      LOGICAL T, F
      PARAMETER (MAXTIK = 1000, T = .TRUE., F = .FALSE.)
C
      REAL SS(MAXTIK), TFRAC(MAXTIK)
      INTEGER DD(MAXTIK), HH(MAXTIK), MM(MAXTIK)
      CHARACTER*1 ASIGN(MAXTIK), ASIGNL
C
      REAL TIME, XLEN, YLEN, COORD, FJUST, RVAL, SSL, DISP,
     *XLEN2, YLEN2
      INTEGER IS, SD, NT, IZERO, IPOS, INEG, IT, I, J, K, SPREC,
     *JST(2), JEND(2), TLEN, LAST, IVAL(3), IVALO(3), IVALZ(3),
     *IVALF(3), IVALL(3), NPASS, INC, DDL, HHL, MML
      CHARACTER SIGNF*1, TEXT*80, AXLOC*2
      LOGICAL WRIT(4)
C-----------------------------------------------------------------------
      CALL PGBBUF
C
C  Direction signs
C
      SD = 1
      IF (TMAX.LT.TMIN) SD = -1
      IS = 1
      IF (TMIN.LT.0.0) IS = -1
C
C  Find first tick.  Return if none.
C
      NT = TMIN / TICK
      IF (IS*SD.EQ.1 .AND. ABS(TMIN).GT.ABS(NT)*TICK) NT = NT + SD
      TIME = NT * TICK
      IF ( (SD.EQ. 1.AND.(TIME.LT.TMIN.OR.TIME.GT.TMAX)) .OR.
     *     (SD.EQ.-1.AND.(TIME.GT.TMIN.OR.TIME.LT.TMAX)) ) RETURN
C
C  Now step through time range in TICK increments and convert
C  times in seconds at each tick to  +/- (DD) HH MM SS.S
C
      IZERO = 0
      IT = 1
 100  IF ( (SD.EQ.1  .AND. TIME.GT.(TMAX+1.0E-5)) .OR.
     *     (SD.EQ.-1 .AND. TIME.LT.(TMAX-1.0E-5)) ) GOTO 200
        IF (IT.GT.MAXTIK) THEN
          CALL GRWARN ('PGTBX4: storage exhausted -- you have'
     *                 //'asked for far too many ticks')
          GOTO 200
        END IF
C
C  Convert to (DD) HH MM SS.S and find fraction of window that this
C  tick falls at
C
        CALL PGTBX5 (DODAY, TIME, ASIGN(IT), DD(IT), HH(IT),
     *               MM(IT), SS(IT))
        TFRAC(IT) = (TIME - TMIN) / (TMAX - TMIN)
C
C  Note zero tick
C
        IF (NT.EQ.0) IZERO = IT
C
C  Increment time
C
        NT = NT + SD
        TIME = NT * TICK
        IT = IT + 1
C
        GOTO 100
 200  CONTINUE
      IT = IT - 1
C
C   Work out the precision with which to write fractional seconds 
C   labels into the SS.S field.   All other fields have integer labels.
C
      SPREC = 0
      IF (TSCALE.EQ.1) THEN
        IF (TICK.LT.0.01) THEN
          SPREC = 3
        ELSE IF (TICK.LT.0.1) THEN
          SPREC = 2
        ELSE IF (TICK.LT.1.0) THEN
          SPREC = 1
        END IF
      END IF
C
C  Label special case of first tick.  Prepare fields and label
C
      CALL PGTBX6 (DODAY, MOD24, TSCALE, DD(1), HH(1), MM(1), 
     *             SS(1), IVALF, RVAL, WRIT)
      SIGNF = 'H'
      IF (DODAY) SIGNF = 'D'
      CALL PGTBX7 (SUPTYP, SIGNF, ASIGN(1), IVALF, RVAL, WRIT,
     *             SPREC, DO2, TEXT, TLEN, LAST)
C
C   Set label displacements from axes.  This is messy for labels oriented
C   perpendicularly on the right hand axis as we need to know how long
C   the longest string we are going to write is before we write any 
C   labels as they are right justified.
C
      IF (AXIS.EQ.'X') THEN
        IF (CONVTL) THEN
          AXLOC = 'B'
          IF (SUPTYP.NE.'NONE') THEN
            DISP = 1.4
          ELSE
            DISP = 1.2
          END IF
        ELSE
          AXLOC = 'T'
          DISP = 0.7
        END IF
      ELSE IF (AXIS.EQ.'Y') THEN
        IF (CONVTL) THEN
          AXLOC = 'LV'
          IF (DOPARA) AXLOC = 'L'
          DISP = 0.7
        ELSE
          IF (DOPARA) THEN
            AXLOC = 'R'
            IF (SUPTYP.NE.'NONE') THEN
              DISP = 1.7
            ELSE
              DISP = 1.9
            END IF
          ELSE
C
C  Work out number of characters in first label
C
            AXLOC = 'RV'
            IF (ASIGN(1).NE.'-' .AND. TMIN*TMAX.LT.0.0) THEN
              CALL PGLEN (2, ' -'//TEXT(1:TLEN), XLEN, YLEN)
            ELSE
              CALL PGLEN (2, ' '//TEXT(1:TLEN), XLEN, YLEN)
            END IF
            CALL PGQCS (2, XLEN2, YLEN2)
            DISP = (XLEN/XLEN2)
          END IF
        END IF
      END IF
C
C  Now write the label to the plot.  The X-axis label for the first tick is
C  centred such that the last field of the label is centred on the tick
C
      IF (FIRST) THEN
        CALL PGLEN (5, TEXT(LAST:TLEN), XLEN, YLEN)
C
        IF (AXIS.EQ.'X') THEN
          COORD = TFRAC(1) + XLEN / 2.0
          FJUST = 1.0
        ELSE IF (AXIS.EQ.'Y') THEN
          IF (DOPARA) THEN
            COORD = TFRAC(1) + YLEN / 2.0
            FJUST = 1.0
          ELSE
            FJUST = 1.0
            COORD = TFRAC(1)
          END IF
        END IF
        CALL PGMTXT (AXLOC, DISP, COORD, FJUST, TEXT(1:TLEN))
      END IF
      IF (IT.EQ.1) RETURN
C
C   Designate which field out of DD or HH will carry the sign, depending
C   on whether you want the day field or not for the rest of the ticks
C
      SIGNF = 'H'
      IF (DODAY) SIGNF = 'D'
C
C  Set up labelling justifications for the rest of the labels
C
      IF (AXIS.EQ.'X') THEN
        FJUST = 0.5
      ELSE IF (AXIS.EQ.'Y') THEN
        IF (DOPARA) THEN
          FJUST = 0.5
        ELSE
          FJUST = 1.0
        END IF
      END IF
C
C  Note zero crossings; IPOS is the first positive tick and
C  INEG is the first negative tick on either side of 0
C
      IPOS = 0
      INEG = 0
C
      IF (IZERO.NE.0) THEN
        J = IZERO - 1
        IF (J.GE.1) THEN
          IF (ASIGN(J).EQ.'-') THEN
            INEG = J
          ELSE IF (ASIGN(J).EQ.' ') THEN
            IPOS = J
          END IF
        END IF
        J = IZERO + 1
        IF (J.LE.IT) THEN
          IF (ASIGN(J).EQ.'-') THEN
            INEG = J
          ELSE IF (ASIGN(J).EQ.' ') THEN
            IPOS = J
          END IF
        END IF
      END IF
C
C  Now label special case of zero tick. It carries the sign change
C  when going from positive to negative time, left to right.
C
      IF (IZERO.NE.0 .AND. IZERO.NE.1) THEN
        CALL PGTBX6 (DODAY, MOD24, TSCALE, DD(IZERO), HH(IZERO), 
     *               MM(IZERO), SS(IZERO), IVALZ, RVAL, WRIT)
C
        IF (ASIGN(IZERO-1).EQ.' ') ASIGN(IZERO) = '-'
        CALL PGTBX7 (SUPTYP, SIGNF, ASIGN(IZERO), IVALZ, RVAL, WRIT,
     *               SPREC, DO2, TEXT, TLEN, LAST)
C
        COORD = TFRAC(IZERO)
        CALL PGMTXT (AXLOC, DISP, COORD, FJUST, TEXT(1:TLEN))
      END IF
C
C   We may need an extra "virtual" tick if there is no zero crossing
C   and SD=-1 & IS=1 or SD=1 & IS=-1.  It is used to work out which
C   fields to label on the right most tick which is labelled first.
C
      IF (IZERO.EQ.0) THEN
        IF (SD*IS.EQ.-1) THEN 
          IF ( (SD.EQ.-1 .AND. TIME.LE.0.0) .OR.
     *         (SD.EQ. 1 .AND. TIME.GE.0.0) ) TIME = 0.0
          CALL PGTBX5 (DODAY, TIME, ASIGNL, DDL, HHL, MML, SSL)
          CALL PGTBX6 (DODAY, MOD24, TSCALE, DDL, HHL, MML, SSL,
     *                 IVALL, RVAL, WRIT)
        END IF
      END IF
C
C  We want to label in the direction(s) away from zero, so we may  need
C  two passes. Determine the start and end ticks for each required pass.
C
      JST(2) = 0
      JEND(2) = 0
      NPASS = 1
      IF (IZERO.EQ.0) THEN
        IF (IS*SD.EQ.1) THEN
          JST(1) = 1
          JEND(1) = IT
        ELSE
          JST(1) = IT
          JEND(1) = 1
        END IF
      ELSE
        IF (INEG.EQ.0 .OR. IPOS.EQ.0) THEN
          JST(1) = IZERO
          JEND(1) = IT
          IF (IZERO.EQ.IT) JEND(1) = 1
        ELSE
          NPASS = 2
          JST(1) = IZERO
          JEND(1) = 1
          JST(2) = IZERO
          JEND(2) = IT
        END IF
      END IF
C
C  Now label the rest of the ticks.  Always label away from 0
C
      DO 400 I = 1, NPASS
C
C  Initialize previous tick values.  Use virtual tick if labelling
C  left to right without a zero (one pass)
C
        DO 250 K = 1, 3
          IVALO(K) = IVALZ(K)
          IF (IZERO.EQ.0) THEN
            IVALO(K) = IVALL(K)
            IF (JST(I).EQ.1) IVALO(K) = IVALF(K)
          END IF
  250   CONTINUE
C
        INC = 1
        IF (JEND(I).LT.JST(I)) INC = -1
        DO 300 J = JST(I), JEND(I), INC
C
C  First and zero tick already labelled
C
          IF (J.NE.1 .AND. J.NE.IZERO) THEN
C
C  Prepare fields
C
            CALL PGTBX6 (DODAY, MOD24, TSCALE, DD(J), HH(J), MM(J),
     *                   SS(J), IVAL, RVAL, WRIT)
C
C  Don't write unchanging fields
C
            DO 275 K = 1, 3
              IF (IVAL(K).EQ.IVALO(K)) WRIT(K) = F
 275        CONTINUE
C
C  Prepare label
C
            CALL PGTBX7 (SUPTYP, SIGNF, ASIGN(J), IVAL, RVAL, WRIT,
     *                   SPREC, DO2, TEXT, TLEN, LAST)
C
C  Write label
C
            COORD = TFRAC(J)
            CALL PGMTXT (AXLOC, DISP, COORD, FJUST, TEXT(1:TLEN))
C
C  Update old values
C
            DO 280 K = 1, 3
              IVALO(K) = IVAL(K)
  280       CONTINUE
          END IF
 300    CONTINUE
 400  CONTINUE
      CALL PGEBUF
C 
      RETURN
      END
C PGTBX5 -- support routine for PGTBOX
C
      SUBROUTINE PGTBX5 (DODAY, TSEC, ASIGN, D, H, M, S)
C      
      REAL S, TSEC
      INTEGER  D, H, M
      LOGICAL DODAY
      CHARACTER*1 ASIGN
C
C  Convert time in seconds to (DD) HH MM SS.S
C
C Input
C  DODAY  :  Use day field if true, else hours accumulates beyond 24
C  TSEC   :  Time in seconds (signed)
C Output
C  ASIGN  :  Sign, ' ' or '-'
C  D,H,M  :  DD, HH, MM (unsigned)
C  S      :  SS.S       (unsigned)
C
C 10-Jun-1993 - new routine [nebk]
C-----------------------------------------------------------------------
      INTEGER IT
C----------------------------------------------------------------------
      ASIGN = ' '
      IF (TSEC.LT.0.0) ASIGN = '-'
C
      S = MOD(ABS(TSEC),60.0)
C
      IT = NINT(ABS(TSEC)-S) / 60
      M = MOD(IT,60)
C
      IT = (IT - M) / 60
      IF (DODAY) THEN
        H = MOD(IT,24)
        D = (IT-H) / 24
      ELSE
        H = IT
        D = 0
      END IF
C
      RETURN
      END
C PGTBX6 -- support routine for PGTBOX
C
      SUBROUTINE PGTBX6 (DODAY, MOD24, TSCALE, DD, HH, MM, SS, IVAL, 
     *                   RVAL, WRIT)
C
      INTEGER TSCALE, IVAL(3), DD, HH, MM
      REAL SS, RVAL
      LOGICAL WRIT(4), DODAY, MOD24
C
C   Find out which of the DD HH MM SS.S fields we want to write
C   into the label according to TSCALE and make a round off
C   error check.
C
C  Input:
C    DODAY  :  Use day field if true else hours accrue beyond 24
C    MOD24  :  HH field labelled as modulo 24
C    TSCALE :  Dictates which fields appear in labels
C    DD     :  Day of time  (will be 0 if DODAY=F and HH will compensate)
C    HH     :  Hour of time
C    MM     :  Minute of time
C    SS     :  Second of time
C  Output:
C    IVAL(3):  DD HH MM to write into label
C    RVAL   :  SS.S to write into label
C    WRIT(4):  T or F if DD,HH,MM,SS are to be written into the label
C              or not.  IVAL and RVAL fields are set explicitly to
C              zero if the corresponding WRIT field is false.
C              This really is overkill.
C
C  10-Jun-1993 - New routine [nebk]
C  16-Jan-1995 - Add argument MOD24
C-----------------------------------------------------------------------
      LOGICAL T, F
      PARAMETER (T = .TRUE., F = .FALSE.)
      INTEGER WM
C-----------------------------------------------------------------------
      IVAL(1) = DD
      IVAL(2) = HH
      IVAL(3) = MM
      RVAL    = SS
C
C  SS should be 0.0; round off may get us 59.999 or the like but
C  not 60.001 (see PGTBX5)
C
      IF (TSCALE.GT.1) THEN
        WM = NINT(SS/60.0)
        IVAL(3) = IVAL(3) + WM
        IF (IVAL(3).EQ.60) THEN
          IVAL(3) = 0
          IVAL(2) = IVAL(2) + 1
          IF (DODAY .AND. IVAL(2).EQ.24) THEN
            IVAL(2) = 0
            IVAL(1) = IVAL(1) + 1
          END IF
        END IF
      END IF
C
C Make HH field modulo 24 if desired
C
      IF (MOD24) IVAL(2) = MOD(IVAL(2),24)
C
      IF (TSCALE.EQ.1) THEN
C
C  Label contains (DD) HH MM SS.S
C
        WRIT(1) = DODAY
        WRIT(2) = T
        WRIT(3) = T
        WRIT(4) = T
      ELSE IF (TSCALE.EQ.60) THEN
C
C  Label contains (DD) HH MM
C
        WRIT(1) = DODAY
        WRIT(2) = T
        WRIT(3) = T
C        
        RVAL    = 0.0
        WRIT(4) = F
      ELSE IF (TSCALE.EQ.3600) THEN
C
C  Label contains (DD) HH
C
        WRIT(1) = DODAY
        WRIT(2) = T
C
        IVAL(3) = 0
        WRIT(3) = F
C  
        RVAL    = 0.0
        WRIT(4) = F
      ELSE IF (TSCALE.EQ.3600*24) THEN
C
C  Label contains DD
C
        WRIT(1) = T
C
        IVAL(2) = 0
        WRIT(2) = F
C
        IVAL(3) = 0
        WRIT(3) = F
C
        RVAL    = 0.0
        WRIT(4) = F
      END IF
C
      RETURN
      END
      SUBROUTINE PGTBX7 (SUPTYP, SIGNF, ASIGN, IVAL, RVAL, WRIT,
     *                   SPREC, DO2, TEXT, TLEN, LAST)
C
      REAL RVAL
      INTEGER IVAL(3), TLEN, SPREC, LAST
      CHARACTER ASIGN*1, TEXT*(*), SIGNF*1, SUPTYP*4
      LOGICAL WRIT(4), DO2
C
C Write (DD) HH MM SS.S time labels into a string
C
C This is a support routine for PGTBOX and should not be
C called by the user
C
C Inputs
C  SUPTYP :  '    ', 'DHMS', or ' DMS' for no superscript labelling,
C            d,h,m,s   or   o,','' superscripting
C  SIGNF  :  Tells which field the sign is associated with.  
C            One of 'D', 'H', 'M', or 'S'    
C  ASIGN  :  ' ' or '-' for positive or negative times
C  IVAL(3):  Day, hour, minutes of time
C  RVAL   :  Seconds of time
C  WRIT(4):  If .true. then write DD, HH, MM, SS  into label
C  SPREC  :  Number of places after the decimal to write seconds 
C            string to.  Must be in the range 0-3
C  DO2    :  If true, add a leading zero to numbers < 10
C Outputs
C  TEXT   :  Label
C  TLEN   :  Length of label
C  LAST   :  Is the location of the start character of the last 
C            field written into TEXT
C
C  05-Sep-1989 -- New routine (Neil Killeen)
C  20-Apr-1991 -- Complete rewrite; support for new DD (day) field and 
C                 superscripted labels [nebk]
C  14-May-1991 -- Removed BSL as a parameter (Char(92)) and made it
C                 a variable to appease Cray compiler [mjs/nebk]
C  10-Jun-1993 -- Rename from PGTLB1, add code to label superscript 
C                 seconds above the '.' and add DO2 option [nebk/jm]
C-----------------------------------------------------------------------
      INTEGER FLEN, FST, FMAX, TRLEN(3), SUPPNT, TMPNT, TLEN2, 
     *IR1, IR2, IP
      CHARACTER FIELD*30, FRMAT2(3)*2, SUPER(4,3)*11, TMP*100, 
     *BSL*1, FRMAT*30
C
      SAVE FRMAT2
      SAVE TRLEN
C
      DATA FRMAT2 /'I1', 'I2', 'I3'/
      DATA TRLEN /5, 11, 5/
C-----------------------------------------------------------------------
C
C   Initialize
C
      BSL = CHAR(92)
      TLEN = 0
      TEXT = ' '
C
C   Assign superscripting strings.  Use CHAR(92) for backslash as the
C   latter must be escaped on SUNs thus requiring preprocessing.  The
C   concatenator operator precludes the use of a data statement
C
      SUPER(1,1) = BSL//'ud'//BSL//'d'
      SUPER(2,1) = BSL//'uh'//BSL//'d'
      SUPER(3,1) = BSL//'um'//BSL//'d'
      SUPER(4,1) = BSL//'us'//BSL//'d'
C
      SUPER(1,2) = BSL//'u'//BSL//'(2199)'//BSL//'d'
      SUPER(2,2) = BSL//'u'//BSL//'(2729)'//BSL//'d'
      SUPER(3,2) = BSL//'u'//BSL//'(2727)'//BSL//'d'
      SUPER(4,2) = BSL//'u'//BSL//'(2728)'//BSL//'d'
C      
      SUPER(1,3) = BSL//'u'//' '//BSL//'d'
      SUPER(2,3) = BSL//'u'//' '//BSL//'d'
      SUPER(3,3) = BSL//'u'//' '//BSL//'d'
      SUPER(4,3) = BSL//'u'//' '//BSL//'d'
C
C   Point at correct superscript strings
C
      IF (SUPTYP.EQ.'DHMS') THEN
        SUPPNT = 1
      ELSE IF (SUPTYP.EQ.' DMS') THEN
        SUPPNT = 2
      ELSE
        SUPPNT = 3
      END IF
C
CCCC
C   Days field
CCCC
C
      IF (WRIT(1)) THEN
        LAST = TLEN + 1
C
C   Write into temporary field
C
        FIELD = ' '
        CALL PGNPL (0, IVAL(1), FLEN)
        WRITE (FIELD, '(I6)') IVAL(1)
        FMAX = 6
        FST = FMAX - FLEN + 1
C
C   Write output text string with desired superscripting
C
        TMPNT = 2
        IF (SIGNF.EQ.'D' .AND. ASIGN.NE.' ') TMPNT = 1
C
        TMP = ASIGN//FIELD(FST:FMAX)//SUPER(1,SUPPNT)
        TLEN2 = (2 - TMPNT) + FLEN + TRLEN(SUPPNT)
C
        TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1)
        TLEN = TLEN + TLEN2
      END IF
C
CCCC 
C   Hours field
CCCC
C
      IF (WRIT(2)) THEN
        LAST = TLEN + 1
C
C   Write into temporary field
C
        FIELD = ' '
        CALL PGNPL (0, IVAL(2), FLEN)
        WRITE (FIELD, '(I6)') IVAL(2)
        FMAX = 6
        FST = FMAX - FLEN + 1
C
        IF (DO2 .AND. FLEN.EQ.1) THEN
          FLEN = FLEN + 1
          FST = FST - 1
          FIELD(FST:FST) = '0'
        END IF
C
C   Write output text string with desired superscripting
C
        TMPNT = 2
        IF (SIGNF.EQ.'H' .AND. ASIGN.NE.' ') TMPNT = 1
C
        TMP = ASIGN//FIELD(FST:FMAX)//SUPER(2,SUPPNT)
        TLEN2 = (2 - TMPNT) + FLEN + TRLEN(SUPPNT)
C
        TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1)
        TLEN = TLEN + TLEN2
      END IF
C
CCCC
C   Minutes field
CCCC
C
      IF (WRIT(3)) THEN
        LAST = TLEN + 1
C
C   Write into temporary field with desired superscripting
C
        FIELD = ' '
        WRITE (FIELD, '(I2, A)') IVAL(3), 
     *                           SUPER(3,SUPPNT)(1:TRLEN(SUPPNT))
        FMAX = 2 + TRLEN(SUPPNT)
C
        FST = 1
        IF (FIELD(FST:FST).EQ.' ') THEN
          IF (DO2) THEN
            FIELD(FST:FST) = '0'
          ELSE
            FST = FST + 1
          END IF
        END IF
        FLEN = FMAX - FST + 1
C
C   Write output text string
C
        TMPNT = 2
        IF (SIGNF.EQ.'M' .AND. ASIGN.NE.' ') TMPNT = 1
C
        TMP = ASIGN//FIELD(FST:FMAX)
        TLEN2 = (2 - TMPNT) + FLEN
C
        TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1)
        TLEN = TLEN + TLEN2
      END IF
C
CCCC
C   Seconds field
CCCC
C
      IF (WRIT(4)) THEN
        LAST = TLEN + 1
C
C   Write into temporary field
C 
        FIELD = ' '
        FST = 1
        IF (SPREC.GE.1) THEN
C
C   Fractional label.  Upto 3 places after the decimal point allowed
C   Muck around to get the superscript on top of the decimal point
C
          IR1 = INT(RVAL)
          IR2 = NINT((RVAL - IR1) * 10**SPREC)
          FRMAT = '(I2, A1, A, '//FRMAT2(SPREC)//')'
          WRITE (FIELD, FRMAT(1:15)) 
     *                       IR1, '.',
     *                       BSL//'b'//SUPER(4,SUPPNT)(1:TRLEN(SUPPNT)),
     *                       IR2
          IP = 5 + TRLEN(SUPPNT) + 1
          IF (FIELD(IP:IP).EQ.' ') FIELD(IP:IP) = '0'
          IF (FIELD(IP+1:IP+1).EQ.' ') FIELD(IP+1:IP+1) = '0'
          FMAX = 1 + 2 + SPREC
        ELSE
C
C   Integer label.  
C
          WRITE (FIELD, '(I2,A)') NINT(RVAL), 
     *                            SUPER(4,SUPPNT)(1:TRLEN(SUPPNT))
          FMAX = 0
        END IF
        FMAX = FMAX + 2 + TRLEN(SUPPNT)
C
        IF (FIELD(FST:FST).EQ.' ') THEN
          IF (DO2) THEN
            FIELD(FST:FST) = '0'
          ELSE
            FST = FST + 1
          END IF
        END IF
        FLEN = FMAX - FST + 1
C
C   Write output text string
C
        TMPNT = 2
        IF (SIGNF.EQ.'S' .AND. ASIGN.NE.' ') TMPNT = 1
        TMP = ASIGN//FIELD(FST:FMAX)
        TLEN2 = (3 - TMPNT) + FLEN
C
        TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1)
        TLEN = TLEN + TLEN2
      END IF
C  
C   A trailing blank will occur if no superscripting wanted
C
      IF (TLEN.GE.5 .AND. TEXT(TLEN-4:TLEN).EQ.BSL//'u'//' '//BSL//'d')
     *   TLEN = TLEN - 5
C      
      RETURN
      END

C*GRSY00 -- initialize font definition
C+
      SUBROUTINE GRSY00
C
C This routine must be called once in order to initialize the tables
C defining the symbol numbers to be used for ASCII characters in each
C font, and to read the character digitization from a file.
C
C Arguments: none.
C
C Implicit input:
C  The file with name specified in environment variable PGPLOT_FONT
C  is read, if it is available.
C  This is a binary file containing two arrays INDEX and BUFFER.
C  The digitization of each symbol occupies a number of words in
C  the INTEGER*2 array BUFFER; the start of the digitization
C  for symbol number N is in BUFFER(INDEX(N)), where INDEX is an
C  integer array of 3000 elements. Not all symbols 1...3000 have
C  a representation; if INDEX(N) = 0, the symbol is undefined.
C
*  PGPLOT uses the Hershey symbols for two `primitive' operations:
*  graph markers and text.  The Hershey symbol set includes several
*  hundred different symbols in a digitized form that allows them to
*  be drawn with a series of vectors (polylines).
*
*  The digital representation of all the symbols is stored in common
*  block /GRSYMB/.  This is read from a disk file at run time. The
*  name of the disk file is specified in environment variable
*  PGPLOT_FONT.
*
* Modules:
*
* GRSY00 -- initialize font definition
* GRSYDS -- decode character string into list of symbol numbers
* GRSYMK -- convert marker number into symbol number
* GRSYXD -- obtain the polyline representation of a given symbol
*
* PGPLOT calls these routines as follows:
*
* Routine          Called by
*
* GRSY00          GROPEN
* GRSYDS          GRTEXT, GRLEN
* GRSYMK          GRMKER,
* GRSYXD          GRTEXT, GRLEN, GRMKER
***********************************************************************
C--
C (2-Jan-1984)
C 22-Jul-1984 - revise to use DATA statements [TJP].
C  5-Jan-1985 - make missing font file non-fatal [TJP].
C  9-Feb-1988 - change default file name to Unix name; overridden
C               by environment variable PGPLOT_FONT [TJP].
C 29-Nov-1990 - move font assignment to GRSYMK.
C  7-Nov-1994 - look for font file in PGPLOT_DIR if PGPLOT_FONT is
C               undefined [TJP].
C-----------------------------------------------------------------------
      CHARACTER*(*) DEFNAM
      PARAMETER  (DEFNAM='grfont.dat')
      INTEGER*2  BUFFER(27000)
      INTEGER    FNTFIL, IER, INDEX(3000), NC1, NC2, NC3
      INTEGER    L, GRTRIM
      COMMON     /GRSYMB/ NC1, NC2, INDEX, BUFFER
      CHARACTER*128 FF
C
C Read the font file. If an I/O error occurs, it is ignored; the
C effect will be that all symbols will be undefined (treated as
C blank spaces).
C
      CALL GRGFIL('FONT', FF)
      L = GRTRIM(FF)
      IF (L.LT.1) L = 1
      CALL GRGLUN(FNTFIL)
      OPEN (UNIT=FNTFIL, FILE=FF(1:L), FORM='UNFORMATTED',
     2      STATUS='OLD', IOSTAT=IER)
      IF (IER.EQ.0) READ (UNIT=FNTFIL, IOSTAT=IER)
     1            NC1,NC2,NC3,INDEX,BUFFER
      IF (IER.EQ.0) CLOSE (UNIT=FNTFIL, IOSTAT=IER)
      CALL GRFLUN(FNTFIL)
      IF (IER.NE.0) THEN
          CALL GRWARN('Unable to read font file: '//FF(:L))
          CALL GRWARN('Use environment variable PGPLOT_FONT to specify '
     :          //'the location of the PGPLOT grfont.dat file.')
      END IF
      RETURN
      END

C*GRLIN1 -- draw a dashed line
C+
      SUBROUTINE GRLIN1 (X0,Y0,X1,Y1,RESET)
C
C GRPCKG : dashed line. Generate a visible dashed line between points
C (X0,Y0) and (X1,Y1) according to the dash pattern stored in common.
C If RESET = .TRUE., the pattern will start from the beginning.
C Otherwise, it will continue from its last position.
C     DASHED LINE PATTERN ARRAY CONTAINING LENGTHS OF
C          MARKS AND SPACES IN UNIT CUBE: GRPATN(*)
C     OFFSET IN CURRENT PATTERN SEGMENT: GRPOFF
C     CURRENT PATTERN SEGMENT NUMBER: GRIPAT
C     NUMBER OF PATTERN SEGMENTS: 8
C--
C (1-Feb-1983)
C  6-Sep-1989 - Changes for standard Fortran-77 [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
C
      REAL ADJUST, ARG1, ARG2, ALFARG
      REAL SCALE, SEGLEN, X1, X0, Y1, Y0, DS, DSOLD
      REAL ALPHA1, ALPHA2, XP, YP, XQ, YQ
      LOGICAL RESET
      INTEGER THICK
      INTRINSIC ABS, MIN, MOD, REAL, SQRT
C
      ADJUST(ARG1,ARG2,ALFARG) = ALFARG*(ARG2 - ARG1) + ARG1
C
      THICK = GRWIDT(GRCIDE)
      SCALE = SQRT(REAL(ABS(THICK)))
      IF (RESET) THEN
          GRPOFF(GRCIDE) = 0.0
          GRIPAT(GRCIDE) = 1
      END IF
      SEGLEN = SQRT((X1-X0)**2 + (Y1-Y0)**2)
      IF (SEGLEN .EQ. 0.0) RETURN
      DS = 0.0
C
C       Repeat until (ALPHA2 .GE. 1.0)
C
C       Line segments matching the pattern segments are determined
C       by finding values (ALPHA1,ALPHA2) defining the start and end
C       of the segment in the parametric equation (1-ALPHA)*P1 + ALPHA*P2
C       defining the line.  DS measures the progress along the line
C       segment and defines the starting ALPHA1.  The ending ALPHA2
C       is computed from the end of the current pattern mark or space
C       or the segment end, whichever comes first.
C
   10 DSOLD = DS
      ALPHA1 = DS/SEGLEN
      ALPHA2 = MIN(1.0,(DS+SCALE*GRPATN(GRCIDE,GRIPAT(GRCIDE))-
     1           GRPOFF(GRCIDE))/SEGLEN)
      IF (MOD(GRIPAT(GRCIDE),2) .NE. 0) THEN
          XP = ADJUST(X0,X1,ALPHA1)
          YP = ADJUST(Y0,Y1,ALPHA1)
          XQ = ADJUST(X0,X1,ALPHA2)
          YQ = ADJUST(Y0,Y1,ALPHA2)
          IF (THICK.GT.1) THEN
              CALL GRLIN3(XP,YP,XQ,YQ)
          ELSE
              CALL GRLIN2(XP,YP,XQ,YQ)
          END IF
      END IF
      DS = ALPHA2*SEGLEN
      IF (ALPHA2 .GE. 1.0) THEN
          GRPOFF(GRCIDE) = GRPOFF(GRCIDE) + DS - DSOLD
          RETURN
      END IF
      GRIPAT(GRCIDE) = MOD(GRIPAT(GRCIDE),8) + 1
      GRPOFF(GRCIDE) = 0.0
      GO TO 10
      END

C*GRQPOS -- return current pen position (absolute, world coordinates)
C+
      SUBROUTINE GRQPOS(X,Y)
C
C GRQPOS: returns the current pen position in absolute, world
C coordinates.
C
C Arguments:
C
C X, Y (real, output): world coordinates of the pen position.
C--
C  1-Mar-1991 - new routine  [JM].
C-----------------------------------------------------------------------
      REAL     X,Y
      INCLUDE 'grpckg1.inc'
C
      IF (GRCIDE.GE.1) THEN
          X = (GRXPRE(GRCIDE) - GRXORG(GRCIDE)) / GRXSCL(GRCIDE)
          Y = (GRYPRE(GRCIDE) - GRYORG(GRCIDE)) / GRYSCL(GRCIDE)
      END IF
      END

      SUBROUTINE PGCNSC (Z, MX, MY, IA, IB, JA, JB, Z0, PLOT)
      INTEGER MX, MY, IA, IB, JA, JB
      REAL Z(MX,*)
      REAL Z0
      EXTERNAL PLOT
C
C PGPLOT (internal routine): Draw a single contour.  This routine is
C called by PGCONT, but may be called directly by the user.
C
C Arguments:
C
C Z (real array dimension MX,MY, input): the array of function values.
C MX,MY (integer, input): actual declared dimension of Z(*,*).
C IA,IB (integer, input): inclusive range of the first index of Z to be
C       contoured.
C JA,JB (integer, input): inclusive range of the second index of Z to
C       be contoured.
C Z0 (real, input): the contour level sought.
C PLOT (the name of a subroutine declared EXTERNAL in the calling
C       routine): this routine is called by PGCNSC to do all graphical
C       output. The calling sequence is CALL PLOT(K,X,Y,Z) where Z is
C       the contour level, (X,Y) are the coordinates of a point (in the
C       inclusive range I1<X<I2, J1<Y<J2, and if K is 0, the routine is
C       to move then pen to (X,Y); if K is 1, it is to draw a line from
C       the current position to (X,Y).
C
C NOTE:  the intervals (IA,IB) and (JA,JB) must not exceed the
C dimensions of an internal array. These are currently set at 100.
C--
C 17-Sep-1989 - Completely rewritten [TJP]. The algorithm is my own,
C               but it is probably not original. It could probably be
C               coded more briefly, if not as clearly.
C  1-May-1994 - Modified to draw contours anticlockwise about maxima,
C               to prevent contours at different levels from
C               crossing in degenerate cells [TJP].
C-----------------------------------------------------------------------
      INTEGER UP, DOWN, LEFT, RIGHT
      PARAMETER (UP=1, DOWN=2, LEFT=3, RIGHT=4)
      INTEGER  MAXEMX, MAXEMY
      PARAMETER (MAXEMX=100, MAXEMY=100)
C
      LOGICAL FLAGS(MAXEMX,MAXEMY,2), RANGE
      INTEGER I, J, II, JJ, DIR
      REAL Z1, Z2, Z3, P, P1, P2
C
C The statement function RANGE decides whether a contour at level P
C crosses the line between two gridpoints with values P1 and P2. It is
C important that a contour cannot cross a line with equal endpoints.
C
      RANGE (P,P1,P2) = (P.GT.MIN(P1,P2)) .AND. (P.LE.MAX(P1,P2))
     1                  .AND. (P1.NE.P2)
C
C Check for errors.
C
      IF ( (IB-IA+1) .GT. MAXEMX .OR.  (JB-JA+1) .GT. MAXEMY ) THEN
          CALL GRWARN('PGCNSC - array index range exceeds'//
     1                ' built-in limit of 100')
          RETURN
      END IF
C
C Initialize the flags. The first flag for a gridpoint is set if
C the contour crosses the line segment to the right of the gridpoint
C (joining [I,J] to [I+1,J]); the second flag is set if if it crosses
C the line segment above the gridpoint (joining [I,J] to [I,J+1]).
C The top and right edges require special treatment. (For purposes
C of description only, we assume I increases horizontally to the right
C and J increases vertically upwards.)
C
      DO 20 I=IA,IB
          II = I-IA+1
          DO 10 J=JA,JB
              JJ = J-JA+1
              Z1 = Z(I,J)
              FLAGS(II,JJ,1) = .FALSE.
              FLAGS(II,JJ,2) = .FALSE.
              IF (I.LT.IB) THEN
                Z2 = Z(I+1,J)
                IF (RANGE(Z0,Z1,Z2)) FLAGS(II,JJ,1) = .TRUE.
              END IF
              IF (J.LT.JB) THEN
                Z3 = Z(I,J+1)
                IF (RANGE(Z0,Z1,Z3)) FLAGS(II,JJ,2) = .TRUE.
              END IF
   10     CONTINUE
   20 CONTINUE
C
C Search the edges of the array for the start of an unclosed contour.
C Note that (if the algorithm is implemented correctly) all unclosed
C contours must begin and end at the edge of the array. When one is
C found, call PGCN01 to draw the contour, telling it the correct
C starting direction so that it follows the contour into the array
C instead of out of it. A contour is only started if the higher
C ground lies to the left: this is to enforce the direction convention
C that contours are drawn anticlockwise around maxima. If the high
C ground lies to the right, we will find the other end of the contour
C and start there.
C
C Bottom edge.
C
      J = JA
      JJ = J-JA+1
      DO 26 I=IA,IB-1
          II = I-IA+1
          IF (FLAGS(II,JJ,1) .AND. (Z(I,J).GT.Z(I+1,J)))
     1          CALL PGCN01(Z, MX, MY, IA, IB, JA, JB,
     2                      Z0, PLOT, FLAGS, I, J, UP)
   26 CONTINUE
C
C Right edge.
C
      I = IB
      II = I-IA+1
      DO 27 J=JA,JB-1
          JJ = J-JA+1
          IF (FLAGS(II,JJ,2) .AND. (Z(I,J).GT.Z(I,J+1)))
     1          CALL PGCN01(Z, MX, MY, IA, IB, JA, JB,
     2                      Z0, PLOT, FLAGS, I, J, LEFT)
   27 CONTINUE
C
C Top edge.
C
      J = JB
      JJ = J-JA+1
      DO 28 I=IB-1,IA,-1
          II = I-IA+1
          IF (FLAGS(II,JJ,1) .AND. (Z(I+1,J).GT.Z(I,J)))
     1          CALL PGCN01(Z, MX, MY, IA, IB, JA, JB,
     2                      Z0, PLOT, FLAGS, I, J, DOWN)
   28 CONTINUE
C
C Left edge.
C
      I = IA
      II = I-IA+1
      DO 29 J=JB-1,JA,-1
          JJ = J-JA+1
          IF (FLAGS(II,JJ,2)  .AND. (Z(I,J+1).GT.Z(I,J)))
     1          CALL PGCN01(Z, MX, MY, IA, IB, JA, JB,
     2                      Z0, PLOT, FLAGS, I, J, RIGHT)
   29 CONTINUE
C
C Now search the interior of the array for a crossing point, which will
C lie on a closed contour (because all unclosed contours have been
C eliminated). It is sufficient to search just the horizontal crossings
C (or the vertical ones); any closed contour must cross a horizontal
C and a vertical gridline. PGCN01 assumes that when it cannot proceed
C any further, it has reached the end of a closed contour. Thus all
C unclosed contours must be eliminated first.
C
      DO 40 I=IA+1,IB-1
          II = I-IA+1
          DO 30 J=JA+1,JB-1
              JJ = J-JA+1
              IF (FLAGS(II,JJ,1)) THEN
                  DIR = UP
                  IF (Z(I+1,J).GT. Z(I,J)) DIR = DOWN
                  CALL PGCN01(Z, MX, MY, IA, IB, JA, JB,
     1                        Z0, PLOT, FLAGS, I, J, DIR)

              END IF
   30     CONTINUE
   40 CONTINUE
C
C We didn't find any more crossing points: we're finished.
C
      RETURN
      END

C*GRDATE -- get date and time as character string (Mac)
C+
      SUBROUTINE GRDATE(STRING, L)
      CHARACTER*(*) STRING
      INTEGER L
C
C Return the current date and time, in format 'dd-Mmm-yyyy hh:mm'.
C To receive the whole string, the STRING should be declared
C CHARACTER*17.
C
C Arguments:
C  STRING : receives date and time, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in STRING, excluding
C           trailing blanks. This will always be 17, unless the length
C           of the string supplied is shorter.
C--
C 19-Jan-1988
C 21-Jan-1995 Modified to work on mac with MPW Fortran 2.1
C-----------------------------------------------------------------------
      Character CDate*9, CTime*8
C
C     The Date subroutine  returns the current date in this form: DD-MMM-yy.
C     So we if yy is between 00 and 50, we assume that the first two digits are 20.
C     if yy is between 51 to 99, we assume that the first two digits are 19.
C     The Time subroutine returns the current time in this form: HH:MM:SS

      Call Date(CDate)
      Call Time(CTime)
      If ((CDate(8:9) .ge. '00') .and. (CDate(8:9) .le. '50')) Then
        String = CDate(1:7)//'20'//CDate(8:9)//' '//CTime(1:5)
      Else
        String = CDate(1:7)//'19'//CDate(8:9)//' '//CTime(1:5)
      End If
      L = MIN(17,LEN(STRING))
	  Return
      END

C*GRQLS -- inquire current line-style
C+
      SUBROUTINE GRQLS (ISTYLE)
      INTEGER  ISTYLE
C
C GRPCKG: obtain the line-style of the current graphics device.
C
C Argument:
C  ISTYLE (output): receives the current line-style code.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRQLS - no graphics device is active.')
          ISTYLE = 1
      ELSE
          ISTYLE = GRSTYL(GRCIDE)
      END IF
      END

C*TXDRIV -- driver for TeX PK Font output
C+
      SUBROUTINE TXDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      IMPLICIT NONE
      SAVE
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C                                                            
C PGPLOT driver for PGPLOT TeX PK Font Output files 
C (produces output files 'pgplot.300pk' and 'pgplot.tfm'),
C {the 300 is dots/per inch and might be different if a 
C different resolution is used}).
C                                                           
C Device type code: /TX
C                                                              
C Supported device: PK Font files for TeX on a Vax or on MIPS.
C                                                          
C Default file names: 'pgplot.RESpk', 'pgplot.tfm'  where the 
C "res" is a default value of 300 but may be set to something
C else.  If "res"=300, then the default file names would be
C 'pgplot.300pk' and 'pgplot.tfm'.
C If more than 15 font characters are produced, then the file
C names become 'pgplot_2.300pk' and 'pgplot_2.tfm'  ,etcetera
C for each set of 15 characters output (i.e.- for each PK
C font produced).
C                                                             
C Default view surface dimensions: 2.8 inches x 2.8 inches
C (but may be overridden by the logicals  PGPLOT_TX_YINCHES,
C and PGPLOT_TX_XINCHES        
C      { $DEFINE PGPLOT_TX_XINCHES "5.0"   
C        $DEFINE PGPLOT_TX_YINCHES "4.5"
C   would provide a "view" surface of 5.0 inches horizontally
C       by 4.5 inches vertically.}).
C       { setenv PGPLOT_TX_XINCHES "5.0"
C         setenv PGPLOT_TX_YINCHES "4.5"
C         would be the equivalent UNIX command.  Everywhere
C         you see the command $DEFINE...   use the command 
C         setenv...  under UNIX}.
C                                                       
C    Driver        Size (H x V) inches
C    ------        ------------
C     TX01          2.80 x 2.80
C                                                                    
C                                                                
C                                                              
C                      
C Resolution: 300 dots per inch Horizontal and Vertical
C             (made be overridden by the logicals
C              PGPLOT_TX_XRESOL and PGPLOT_TX_YRESOL
C             { $DEFINE PGPLOT_TX_XRESOL "78.0" 
C               $DEFINE PGPLOT_TX_YRESOL "78.0"
C              will produce a font at 78 dots per inch
C              resolution.  This would be good for a
C              Vaxstation 2000 workstation.}).
C              The default 300 dots per inch is good for a
C              laser printer such as a QMS1200 LaserGrafix 
C              or an HP2000 LaserJet.
C--
C
C+
C                                                 
C Color capability: Color indices 0 (erase, white)
C and 1 (black) are supported. It is not possible to
C change color representation.
C                                                 
C Output Orientation: Portrait.  (Can be overridden by the
C                      logical PGPLOT_TX_ORIENT 
C               { $DEFINE PGPLOT_TX_ORIENT "LANDSCAPE"}).
C                                                    
C Input capability: None.
C                                                         
C File formats: TeX PK Font file format, and TeX
C               TFM file format.  The files are output as
C               FORTRAN, DIRECT ACCESS, UNFORMATTED, 
C               512 BYTE RECORDS so that we can have
C               compatability with the VAX and our
C               UNIX machine.  {A raw bitmap copy is
C               also possible if you define the logical
C               PGPLOT_TX_BITFILE .  
C               $ DEFINE PGPLOT_TX_BITFILE "MINIMAL"
C               will produce a file copy of the portion
C               of the bitmap which is within the minimal
C               bounding box of the character.
C               $ DEFINE PGPLOT_TX_BITFILE "ALL" will produce
C               a file copy of the complete bitmap of the
C               graphics character.}
C                                                       
C Obtaining hardcopy: Use the command DUMP to view the
C               output files, or run TeX and include the
C               character of this new font and DVI the output
C               and print the resulting  binary file to the
C               correct printer (with PASSALL, NOFEED, or
C               whatever is required for printing binary
C               output to your specific printer). Also, the
C               PKTYPE and TFTOPL TeX debugging programs will
C               allow you to view your output font
C               characteristics.
C                                                             
C ----------------------------------------------------------------------
C                                                        
C----------------------------------------------------------------------
C
C+
C TeX Example:  Assume you have produced a graph into a
C PK Font and that the output file names are 'pgplot.300pk' 
C and 'pgplot.tfm' then the following lines in your TeX code
C would include the graph corresponding to the letter "A"
C of the TeX PK font "PGPLOT" in the middle of your paper:
C                                                                 
C            \font\myfntname=pgplot
C              This is sentence one of the TeX file.
C              Now I will include the character.
C            \centerline{\myfntname A }
C              This is the last sentence.
C            \bye
C                                                         
C   Of course, you must tell TeX and the DVI driver where
C   to find your fonts.  On our VAX, we have defined a
C   search list so that if you define the logical
C   TEX_USER_FONTS to be your directory where you keep your
C   fonts, then TeX and the DVI driver will find the
C   'pgplot.tfm' file and the 'pgplot.300pk' file.  So, 
C   $DEFINE TEX_USER_FONTS  SYS$USERDISK:[USERNAME.FONTS]
C   would cause TeX and the DVI driver to search the normal
C   search path and also the directory 
C   SYS$USERDISK:[USERNAME.FONTS] for any fonts that you
C   specified in your TeX file.  {Here is an exception for
C   the UNIX. Our UNIX TeX and DVI programs will look in your
C   current directory automatically for the fonts and then
C   will check the system library if it cannot find the
C   fonts in your directory.  So you CANNOT  setenv 
C   TEX_USER_FONTS on our UNIX system...}.
C                                                    
C   Notes:
C     You must change the resolution for different output
C   devices (our DVI driver, DVIHP, for our HP2000 LaserJet
C   would use a resolution of 300 dots per inch; while our
C   DVI driver for the Vaxstation 2000 workstation would
C   need a resolution of 78 dots per inch.  The 'pgplot.tfm'
C   file would of course be the same in both cases, but the  
C   DVI drivers would look for 'pgplot.300pk' and 'pgplot.78pk'
C   respectively).  If you produce an image which is too large
C   (by defining logicals PGPLOT_TX_XINCHES and PGPLOT_TX_YINCHES)
C   then some DVI drivers will leave the page blank where the
C   graph of the character belongs (can sometimes use \hsize and
C   \vsize to help with this).  Finally,  if your device driver
C   only works with PXL files (like our PRINTRONIX DVI driver),
C   then you may want to run the   PKTOPX  program to convert
C   the PK Font into a PXL Font which your device driver needs.
C  -----------------------------------------------------------------------
C-------------------------------------------------------------------------
C
C+
C                                                                 
C                                                                
C  The above example for LaTeX would be: 
C                                                     
C           This is the first sentence.
C           Now I will include the character as a figure.
C           \begin{figure}
C           \newfont{\myfntname}{pgplot}
C           \centerline{\myfntname A}
C           \caption{Letter A of PGPLOT font}
C           \end{figure}
C           This is the last sentence.
C                                                    
C  And you would need to define TEX_USER_FONTS on the Vax
C  as before {but again, not under UNIX}.
C  ---------------------------------------------------------------------
C                                                   
C Version 1.2 - 24-SEP-1989 - Bob Forrest, Electrical Engineering Dept.
C     Texas A&M University; College Station,Texas 77843
C                 bitnet: FORREST@TAMVXEE
C               internet: forrest@ee.tamu.edu  
C ----------------------------------------------------------------------
C----------------------------------------------------------------------
C               
C ***  Note: SAVE statement is required in this routine, TXDRIV, and
C ***  in routines GRTX11 and GRTX12.  The values of some of
C ***  the variables in each of these 3 routines are required
C ***  upon entry to remain the same as the last time the routine was
C ***  executed.
C 
C *** PORTABILITY NOTES: ...search for the word "portability"
C ***                               or the word "PORTABILITY"  
C     -- ... -- 
C Note: {The Vax uses bytes with values from -128 to 127. I therefore
C use integers for my calculations, and then output the resulting
C values as a byte by calling two routines which buffer the output
C up until 512 bytes have been buffered and then writes this 1 record,
C resets the buffer count and starts buffering again,   and also the
C routine recieves the integer value in the range 0 to 255, 
C then converts the value to the byte value from -128 to 127 and
C then buffers the byte value for the write to the file.
C The routines GRTX11 does this for the PK file, and GRTX12 does
C this for the TFM file.  Routines GRTX11 and GRTX12 will definitely
C haved to be modified if bytes are read and written as NON-SIGNED
C quantities on a different computer.}
C Note: {The routine GRTX05 uses an assignment statement SOLBLK='FF'X
C to set a parameter to have all ones in its bit positions -
C and SOLWHT='00'X to set a parameter to have all zeros in its bit positions--
C this may need to be changed in porting the code to other machines.
C The variables BITMAP and BUFFER are byte variables and thus
C use non-standard FORTRAN language in setting and comparing
C values  throughout this driver code. Anywhere that byte variables
C are used is a suspect in porting this code to other machines.}
C *** I believe that TeX, etc., uses ASCII internally so that
C *** the way I have coded the letters will work correctly.
C *** However, if porting to other machines, keep in mind that
C *** I have hard-coded the character representations as ASCII values
C *** specific to a VAX.
C *** Note:  I wrote most of the comments as I was writing these routines.
C ***        There had to be some rewrites on some of the routines,
C ***        such as changing BENCOD from a byte array to an integer
C ***        array, and rewriting the RUN CODING routine.  I tried to
C ***        go back and modify the comments that
C ***        I could think of being incorrect.  However, I was admittedly
C ***        pressed for time, and may have missed some of the comments,
C ***        I did not go back over the source code line for line.
C=======================================================================
C-----------------------------------------------------------------------
C *** NDEV is an integer parameter containing the number of currently
C *** supported default device configurations (1, the rest have to be
C *** gotten by using logicals (or "environment variables"). 
C *** LNWFIL is a logical variable which determines whether a
C *** a new PK font file and TFM file are to be opened while
C *** closing the current PK and TFM files.
C *** INIT is a logical variable which is used to set up the initial
C *** variables the first time this routine is invoked. INIT is used
C *** as a flag, the first time we initialize the variables, the next
C *** time we do not.
C *** PORTRAIT is a logical array which is used to tell whether the 
C *** output is to be assumed to be in PORTRAIT mode or LANDSCAPE mode.
C *** BITMAP is an integer which is used to hold an address pointing
C *** to a dynamically allocated memory array.  In later 
C *** routines, BITMAP is a two dimensional array which contains
C *** a bitmap of the current graph.
C *** BX is an integer giving the x-direction dimension of the array BITMAP.
C *** BY is an integer giving the y-direction dimension of the array BITMAP.
C *** DEVICE is an integer pointing to the current default device selected
C *** (some of the setup may still be overridden by logicals however).
C *** IC is an integer variable containing the color index (1=black,0=white)
C *** to be used on calls to GRTX00 to draw dots, lines, or to clear dots,lines.
C *** ITMPVR is a temporary integer variable used only intermediately in
C *** calculations.
C *** GRGMEM is an integer function used to allocate contiguous bytes
C *** of memory dynamically at run time.
C *** GRFMEM is an integer function used free contiguous bytes of
C *** memory back up.
C *** LUN is an integer array containing the logical unit numbers of
C *** the PK file (LUN(1)) and the TFM file (LUN(2)).
C *** NPICT is an integer used to reference the current picture frame
C *** being drawn?????.
C *** PKOUT is an integer variable containing the count on the
C *** number of PK Font files up through the current one, that
C *** have (or are) being written.
C *** CURCHA is an integer variable containing the ASCII value in
C *** base10 for the current character being encoded as a PK 
C *** Font character.
C *** IER is an integer array used to obtain the function return values
C *** for the GRGMEM and GRFMEM functions.
C *** BC is an integer used to contain the ASCII value for the beginning
C *** character of the PK Font.
C *** NPKBYT is an integer variable used to keep a running total on 
C *** the number of bytes written to the PK file.
C *** MAXX is a real variable which contains the default maximum
C *** horizontal device coordinate. [0,MAXX(DEVICE)] is the allowed 
C *** default range.
C *** MAXY is a real variable which contains the default maximum
C *** vertical device coordinate. [0,MAXY(DEVICE)] is the allowed 
C *** default range.
C *** RESOLX is a real variable which contains the default resolution in
C *** dots per inch in the horizontal direction.
C *** RESOLY is a real variable which contains the default resolution in
C *** dots per inch in the vertical direction.
C *** XMAX is a real variable which contains the actual chosen maximum
C *** horizontal device coordinate (MAXX unless user specifies different).
C *** YMAX is a real variable which contains the actual chosen maximum
C *** vertical device coordinate (MAXY unless user specifies different).
C *** TMPRES is a real variable used only for temporary calculations.
C *** TMPMXX is a real variable used only for temporary calculations.
C *** TMPMXY is a real variable used only for temporary calculations.
C *** DEFNAM is a character variable used to contain the default
C *** file name prefix.
C *** MODE is a temporary character variable used for checking the 
C *** values of logical variabels (or "environment variables").
C *** MSG is a temporary character variable used in string operations.
C *** PKFILE is a character variable used to contain the PK file name.
C *** TFMFIL is a character variable used to contain the TFM file name.
C *** DEFPK is a character variable used to contain the default PK
C *** file name.
C *** TFMDEF is a character variable used to contain the default TFM
C *** file name.
C *** CTMPST is a temporary character variable used in string operations.
C *** BITFIL is a character variable used to contain the BITMAP file
C *** name.
C *** DEFBIT is a character variable used to contain the default BITMAP
C *** file name.
C *** CHINFO is an integer array used to contain information about each PK
C *** font character.  CHINFO is output as part of the TFM file.  
C *** WIDTH is an integer array used to contain information about each PK
C *** font character. WIDTH is a table containing the width of each
C *** of the PK font characters. WIDTH is output to the TFM file.
C *** HEIGHT is an integer array used to contain information about each PK
C *** font character.  HEIGHT is a table containing the height of each
C *** of the PK font characters. HEIGHT is output to the TFM file.
C *** IXBXLL, IYBXLL is the lower left corner of the minimal bounding
C *** box of the graphics character (which is found in the RUN CODE routine).
C *** IXBXUR, IYBXUR is the upper right corner of the minimal bounding
C *** box of the graphics character (which is found in the RUN CODE routine).
C *** CHBITD is a character variable used to contain the requested
C *** type of BITMAP DUMP if one is requested -- possible values
C *** are 'MINIMAL' and 'ALL'.
C *** LBUSED is a logical used to determine whether the BITMAP has been
C *** written to or not (in case PGPAGE or PGADVANCE are called before
C *** actually drawing anything in the BITMAP array).
C-----------------------------------------------------------------------
C                                       This is the number of currently
C                                       installed devices.
      INTEGER*4  NDEV
      PARAMETER  (NDEV = 1)
C
      LOGICAL    LBITFO, LNEWFL, INIT, PORTRAIT(NDEV), LBUSED
      INTEGER*4  BITMAP, BX,BY,DEVICE,I,J,K,IC,ITMPVR
      INTEGER*4  PKOUT,CURCHA,JTMP1,JTMP2,NPICT,LUN(2),SS_NORMAL
C
      INTEGER*4  GRFMEM, GRGMEM
C 
      INTEGER*4  IER, BC, NPKBYT,IXBXLL,IYBXLL,IXBXUR,IYBXUR
      REAL*4     MAXX(NDEV),MAXY(NDEV),RESOLX(NDEV),RESOLY(NDEV) 
      REAL*4     XBUF(4), XMAX, YMAX , TMPRES, TMPMXX, TMPMXY
      CHARACTER  DEFNAM*6,MODE*20,MSG*10,CHBITD*7
      CHARACTER  PKFILE*80,TFMFIL*80,DEFPK*80,DEFTFM*80,CTMPST*80
      CHARACTER  BITFIL*80,DEFBIT*80,CHTMPS*80
      BYTE BYTVAL
C *** PARAMETER  (DEFNAM = 'PGPLOT')
C *** Use lower case instead for unix...
      PARAMETER  (DEFNAM = 'pgplot')
      PARAMETER  (SS_NORMAL = 1)
      PARAMETER  (BC=65)
C ***    BC could be chosen to be a different value here (and it
C ***    would be changed throught the TeX PK font driver routines).
C ***    Note:  0<=BC<256 is required.  BC is the beginning ASCII
C ***    value of the PK font,  A=65base10.  If you want some other
C ***    character as first, then change the value of BC.
C ***    These TeX PK Font driver routines were designed to only
C ***    have 15 characters per font, but the driver is capable of
C ***    producing several fonts.  The Characters codes reset to
C ***    begin with BC for each font.
      INTEGER CHINFO(BC:BC+14,4),WIDTH(0:15,4),HEIGHT(0:15,4),IWHITE
      PARAMETER(IWHITE='00'X)
C                                      Set up initialization for first call.
      DATA INIT  /.TRUE./
C                                      Set the default color to black(=1).
      DATA IC /1/
C                                      Set the bitmap to not used.
      DATA LBUSED /.FALSE./  
C                                      These are the NDEV sets of 
C                                      device characteristics.
      DATA PORTRAIT /.TRUE./
      DATA MAXX     / 855.0/
      DATA MAXY     / 855.0/
      DATA RESOLX   / 300.0/
      DATA RESOLY   / 300.0/
C-----------------------------------------------------------------------
      IF (INIT) THEN
         DEVICE=1
C ***       Check the logicals (or "Environment variables") beginning
C ***       with "PGPLOT_" for overriding the defaults listed above.
         CALL GRGENV ('TX_XRESOL', MODE, I)
         READ(UNIT=MODE,FMT=*,ERR=1,END=1) TMPRES
           IF(TMPRES.LE.0.0 .AND. MODE.NE.' ')
     2         CALL GRWARN('PGPLOT_TX_XRESOL '
     3         //'has been defined to be < 0.0 dots per inch. '
     4         //' **** IGNORING and continuing... *** ')
           IF(TMPRES.GT.0.0) RESOLX(DEVICE)=TMPRES
1        CALL GRGENV ('TX_YRESOL', MODE, I)
         READ(UNIT=MODE,FMT=*,ERR=2,END=2) TMPRES
           IF(TMPRES.LE.0.0 .AND. MODE.NE.' ')
     2         CALL GRWARN('PGPLOT_TX_YRESOL '
     3         //'has been defined to be <= 0.0 dots per inch. '
     4         //' **** IGNORING and continuing... *** ')
           IF(TMPRES.GT.0.0) RESOLY(DEVICE)=TMPRES
2        CALL GRGENV ('TX_XINCHES', MODE, I)
         READ(UNIT=MODE,FMT=*,ERR=3,END=3) TMPMXX
           IF(TMPMXX.GT.22.0) THEN
              CALL GRWARN('******-- PGPLOT_TX_XINCHES > 22.0 **** --- '
     2              //' This may not work correctly. The design '
     3              //'size specified in the PGPLOT TX Driver '
     4              //' (TeX PK Font output) allows a range from '
     5              //' a little less than 1/11 of an inch to '
     6              //' a little more thant 22 inches. '
     7              //' You will probably have to modify the '
     8              //'source code in order to produce output '
     9              //'larger than 22 inches. ')
           ENDIF
           IF(TMPMXX.LT.1.0/11.0 .AND. TMPMXX.GT.0.0) THEN
              CALL GRWARN('******-- PGPLOT_TX_XINCHES < 1.0/11.0 **** -'
     2              //'--  This may not work correctly. The design '
     3              //'size specified allows a range from '
     4              //' a little less than 1/11 of an inch to a '
     5              //' a little more than 22 inches. '
     6              //' You will probably have to modify the '
     7              //'source code in order to produce output '
     8              //'less than 1/11 inches. ')
           ENDIF
           IF(TMPMXX.LE.0.0 .AND. MODE.NE.' ')
     2          CALL GRWARN('PGPLOT_TX_XINCHES '
     3         //'has been defined to be <= 0.0 inches '
     4         //' **** IGNORING and continuing... *** ')
           IF(TMPMXX.GT.0.0) MAXX(DEVICE)=TMPMXX*RESOLX(DEVICE)
3        CALL GRGENV ('TX_YINCHES', MODE, I)
         READ(UNIT=MODE,FMT=*,ERR=4,END=4) TMPMXY
           IF(TMPMXY.GT.22.0) THEN
              CALL GRWARN('******-- PGPLOT_TX_YINCHES > 22.0 **** --- '
     2              //' This may not work correctly. The design '
     3              //'size specified allows a range from '
     4              //' a little less than 1/11 of an inch to a '
     5              //' a little more than 22 inches. '
     6              //' You will probably have to modify the '
     7              //'source code in order to produce output '
     8              //'greater than 22 inches. ')
           ENDIF
           IF(TMPMXY.GT.0.0 .AND. TMPMXY.LT.1.0/11.0) THEN
              CALL GRWARN('******-- PGPLOT_TX_YINCHES < 1.0/11.0 **** -'
     2              //'--  This may not work correctly. The design '
     3              //'size specified allows a range from '
     4              //' a little less than 1/11 of an inch to a '
     5              //' a little more than 22 inches. '
     6              //' You will probably have to modify the '
     7              //'source code in order to produce output '
     8              //'less than 1/11 inches. ')
           ENDIF
           IF(TMPMXY.LE.0.0 .AND. MODE.NE.' ') 
     2         CALL GRWARN('PGPLOT_TX_YINCHES '
     3         //'has been defined to be <= 0.0 inches '
     4         //' **** IGNORING and continuing... *** ')
           IF(TMPMXY.GT.0.0) MAXY(DEVICE)=TMPMXY*RESOLY(DEVICE)
4        CALL GRGENV ('TX_ORIENT', MODE, I)
           IF(MODE(1:8).EQ.'PORTRAIT') THEN
              PORTRAIT(DEVICE)=.TRUE.
              CALL GRWARN('PGPLOT_TX_ORIENT ''''PORTRAIT'''' has '
     2          //'been specified.')
           ENDIF
           IF(MODE(1:9).EQ.'LANDSCAPE') THEN
              PORTRAIT(DEVICE)=.FALSE.
              CALL GRWARN('PGPLOT_TX_ORIENT ''''LANDSCAPE'''' has '
     2          //'been specified.')
           ENDIF
         CALL GRGENV ('TX_BITFILE', MODE, I)
         LBITFO=.FALSE.
         CHBITD=' '
         IF(MODE(1:7).EQ.'MINIMUM' .OR. MODE(1:3).EQ.'ALL')THEN
              LBITFO=.TRUE.
              CHBITD=MODE
         ENDIF
C ***     Set INIT to be .FALSE. so that the above checks on 
C ***     environment variables will only occur the first time
C ***     that TXDRIV is called.
         INIT = .FALSE.
      ENDIF
C                                       Branch on opcode.
      GOTO ( 10,  20,  30,  40,  50,  60,  70,  80,  90, 100,
     1      110, 120, 130, 140, 150, 160, 170, 180, 190, 200,
     2      210, 220, 230, 240, 250, 260), IFUNC
C                                       Signal an error.
  900 WRITE (MSG, '(I10)') IFUNC
      CALL GRWARN ('Unimplemented function in TeX PK Font' 
     1             //' device driver: '// MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CONTINUE
C ***      This is the name seen when a "?" is entered by the user for
C ***      the desired output device for PGPLOT.
      CHR='TX (TeX PK Font generation)'
      LCHR=LEN(CHR)
      NBUF = 0
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 CONTINUE
C ***     Negative one implies that the physical maximums are unlimited for
C ***     this device.   PGPLOT requires the minimums to be ZERO.
      RBUF(1) = 0.0
      RBUF(2) = -1
      RBUF(3) = 0.0
      RBUF(4) = -1
      RBUF(5) = 0.0
      RBUF(6) = 1.0
      NBUF = 6
      LCHR = 0
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 CONTINUE
C ***     This give the device resolution in dots per inch in the 
C ***     horizontal and vertical directions.
      RBUF(1) = RESOLX(DEVICE)
      RBUF(2) = RESOLY(DEVICE)
      RBUF(3) = 1.0
      NBUF = 3
      LCHR = 0
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    no thick lines)
C
   40 CONTINUE
      CHR = 'HNNNNNNNNN'
      NBUF = 0
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CONTINUE
C ***    This returns the default prefix for the filenames of  TXDRIV.
      CHR = DEFNAM
      NBUF = 0
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 CONTINUE
C ***   These defaults are in device coordinate values.
      RBUF(1) = 0.0
      RBUF(2) = MAXX(DEVICE)
      RBUF(3) = 0.0
      RBUF(4) = MAXY(DEVICE)
      NBUF = 4
      LCHR = 0
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 CONTINUE
C ***   Has to do with character fonts that PGPLOT reads in.
      IF (RESOLX(DEVICE) .GE. 300.0) THEN
         RBUF(1) = 3.0
      ELSE IF (RESOLX(DEVICE) .GE. 150.0) THEN
         RBUF(1) = 2.0
      ELSE 
         RBUF(1) = 1.0
      END IF
      NBUF = 1
      LCHR = 0
      RETURN
C
C--- IFUNC = 8, Select plot  --------------------------------------------
C                    This will be a possible future enhancement to 
C                    have several devices open at one time...
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C                                       Assume success.
      RBUF(2) = 1.0
C
C
C *** Set up the default file name for the TeX PK Font file.
      ITMPVR=INT(RESOLX(DEVICE))
      WRITE(UNIT=MSG,FMT='(I10)') ITMPVR
      DO 91, I=10,1, -1
        IF(MSG(1:1).EQ.' ') THEN
            MSG(1:1)=MSG(2:2)
            MSG(2:2)=MSG(3:3)
            MSG(3:3)=MSG(4:4)
            MSG(4:4)=MSG(5:5)
            MSG(5:5)=MSG(6:6)
            MSG(6:6)=MSG(7:7)
            MSG(7:7)=MSG(8:8)
            MSG(8:8)=MSG(9:9)
            MSG(9:9)=MSG(10:10)
         ELSE
            GOTO 92
         ENDIF
91    CONTINUE
92    CONTINUE
      DEFPK=DEFNAM//'.'//MSG(1:I)//'pk'
C ***
C ***
C ***
C *** Set up the default file name for the TeX TFM file.
      DEFTFM=DEFNAM//'.tfm'
C *** Set up the default file name for the raw unformatted BITMAP file.
      DEFBIT=DEFNAM//'.bitmap'
C ***
C ***
C ***  Remove the '.' and any remaining characters after the '.'
C ***  from the file name.  We will append the resolution and PK to
C ***  the PK Font output file, and  TFM to the TFM file, and
C ***  BITMAP to the raw unformatted bitmap file.
C  
C *** Store CHR(1:LCHR) in a temporary string, CTMPST to work with.
      CTMPST=CHR(1:LCHR)
      DO 94, K=LCHR,1, -1
C ***                                Check for ending period on Vax.
         IF(CTMPST(K:K).EQ.'.') THEN
            DO 93, J=K,LCHR
               CTMPST(J:J)=' '
93          CONTINUE
            GOTO 95
C ***                                 Check for logical name on Vax.
         ELSE IF(CTMPST(K:K).EQ.':') THEN
            GOTO 95
C ***                                 Check for end of directory name on Vax.
         ELSE IF(CTMPST(K:K).EQ.']') THEN
            GOTO 95
C ***                                 Check for end of directory name on Unix.
         ELSE IF(CTMPST(K:K).EQ.'/') THEN
            GOTO 95
         ENDIF
94    CONTINUE
95    CONTINUE
C *** 
C *** Now, find the end of the string.
      DO 96, K=LCHR,1, -1
         IF(CTMPST(K:K).NE.' ') GOTO 97
96    CONTINUE
97    CONTINUE
      IF(K.GT.0) THEN
C ***     Set up the requested file names (otherwise, we will set it to the
C ***     DEFAULT NAMES.
          PKFILE=CTMPST(1:K)//'.'//MSG(1:I)//'pk'
          TFMFIL=CTMPST(1:K)//'.tfm'
          BITFIL=CTMPST(1:K)//'.bitmap'
      ELSE              
          PKFILE=DEFPK
          TFMFIL=DEFTFM
          BITFIL=DEFBIT
      ENDIF
C *** ----------------------------------------------------------
C                                       Obtain a logical unit number
C                                       for TeX PK Font file.
      CALL GRGLUN (LUN(1))
C                                       Check for an error.
      IF (LUN(1) .EQ. -1) THEN
          CALL GRWARN ('Cannot allocate a logical unit for PK File.')
          RBUF(2) = 0
          RETURN
      ELSE
C                                        Need to return the logical unit
C                                        number of the file.
         RBUF(1) = LUN(1)
      END IF
C ***
C
C                                                   OPEN the files.
C     *VMS         We will write out 512 bytes at a time. RMS will take 
C                  care of us when we read the file back in for DVIing it
C                  If you have problems, change ACCESS='DIRECT' to
C                  ACCESS='SEQUENTIAL' and add RECORDTYPE=FIXED and
C                  modify write statements in GRTX11 and GRTX12 to
C                  be writes to sequential files. Also, consider
C                  using the rewind statement if you do a sequential file.
      OPEN(UNIT=LUN(1),FILE=PKFILE,ACCESS='DIRECT',
     2     FORM='UNFORMATTED',STATUS='NEW',IOSTAT=IER,
     3     DISP='DELETE',
     4     RECL=128)
C
C ***      *UNIX    Want to open up a file to put "bytes on a disk --
C ***               with NO segmented record information... 512 bytes
C ***               will be written out at a time.  128*4=512 
C ***      OPEN(UNIT=LUN(1),FILE=PKFILE,ACCESS='DIRECT',
C ***     2     FORM='UNFORMATTED',STATUS='NEW',IOSTAT=IER,
C ***     3     RECL=128)
C     
C
C                                       Check for an error and cleanup if
C                                       one occurred.
      IF (IER .NE. 0) THEN
          CALL GRWARN ('Cannot open output file for TeX PK '
     2                 //'Font.')
          RBUF(2) = 0
          CALL GRFLUN (LUN(1))
          RETURN
      ELSE
C                                       Get the full file specification
C                                       and calculate the length of the 
C                                       string
          INQUIRE (UNIT = LUN(1), NAME = CHR)
          LCHR = LEN (CHR)
98        CONTINUE
          IF (CHR (LCHR:LCHR) .EQ. ' ') THEN
              LCHR = LCHR - 1
              GOTO 98
          END IF
      END IF
C ***                                   Initialize some indirect 
C ***                                   file pointer information.
      CALL GRTX14
C ***
C
C                                             
C
C                                        Obtain a logical unit number
C                                        for TeX TFM file.
      CALL GRGLUN (LUN(2))
C                                       Check for an error.
      IF (LUN(2) .EQ. -1) THEN
          CALL GRWARN ('Cannot allocate a logical unit for TFM file.')
          CLOSE(UNIT=LUN(1))
          CALL GRFLUN (LUN(1))
          RBUF(2) = 0
          RETURN
      END IF
C
      IF (LUN(2) .EQ. LUN(1)) THEN
         CALL GRWARN('ERROR IN PGPLOT LIBRARY GRGLUN FUNCTION. '
     2            //'IDENTICAL UNIT NUMBERS WERE RETURNED TO '
     3            //'TXDRIV ROUTINE.')
         CALL GRQUIT('EXITING BACK TO OPERATING SYSTEM FROM TXDRIV.')
         STOP
      ENDIF
C

C     *VMS         We will write out 512 bytes at a time. RMS will take 
C                  care of us when we read the file back in for DVIing it
C                  If you have problems, change ACCESS='DIRECT' to
C                  ACCESS='SEQUENTIAL' and add RECORDTYPE=FIXED and
C                  modify write statements in GRTX11 and GRTX12 to
C                  be writes to sequential files. Also,
C                  consider using the rewind statement if you do sequential
C                  files.
      OPEN(UNIT=LUN(2),FILE=TFMFIL,ACCESS='DIRECT',
     2     FORM='UNFORMATTED',STATUS='NEW',IOSTAT=IER,
     3     DISP='DELETE',
     4     RECL=128)
C
C ***      *UNIX    Want to open up a file to put "bytes on a disk --
C ***               with NO segmented record information... 512 bytes
C ***               will be written out at a time.  128*4=512 
C ***      OPEN(UNIT=LUN(2),FILE=TFMFIL,ACCESS='DIRECT',
C ***     2     FORM='UNFORMATTED',STATUS='NEW',IOSTAT=IER,
C ***     3     RECL=128)
C
C                                       Check for an error and cleanup if
C                                       one occurred.
      IF (IER .NE. 0) THEN
          CALL GRWARN('Cannot open output file for TeX TFM.')
          RBUF(2) = 0
          CLOSE(UNIT=LUN(1))
          CALL GRFLUN (LUN(1))
          CALL GRFLUN (LUN(2))
          RETURN
      ENDIF
C ***                                   Initialize some indirect 
C ***                                   file pointer information.
      CALL GRTX15
C ***
C 
C                                       Initialize the plot file.
C
C *** Set the character number to 1.
      CURCHA=1
C *** Set the PK Font file to 1.
      PKOUT=1
C *** Set the number of bytes written to the PK file to 0.
      NPKBYT=0
C *** Write the preamble to the PK Font file UNIT=LUN(1).
      CALL GRTX04 (RESOLX,RESOLY,NDEV,DEVICE,LUN,NPKBYT)
C *** Set up the TFM file arrays  CHINFO, WIDTH, HEIGHT.
C *** The CHINFO table will remain as set up.  The WIDTH and HEIGHT
C *** tables will be modified for each of the PK Font characters
C *** as the character is written to the PK file. 
      DO 99, I=0,14
C ***    The width table index is in the first byte.
         CHINFO(BC+I,1)=I+1
C ***    The height table index is in the first nybble of the 
C ***    of the second byte, while the depth table index is in the 
C ***    second nybble of the second byte. 
         CHINFO(BC+I,2)=16*(I+1)
C ***    The italic table index is in the first six bits of the 
C ***    third byte, while the tag index is in the last two bits
C ***    of the third byte. (Tag=0 means remainder byte 4 is unused).
         CHINFO(BC+I,3)=0
C ***    This is the remainder byte.  It is unused for our purposes.
         CHINFO(BC+I,4)=0
C ***    Initialize the width table to zero.  The width table will be
C ***    modified as each character is written to the PK file.
         WIDTH(I,1)=0
         WIDTH(I,2)=0
         WIDTH(I,3)=0
         WIDTH(I,4)=0
C ***    Initialize the height table to zero. The height table will be
C ***    modified as each character is written to the PK file.
         HEIGHT(I,1)=0
         HEIGHT(I,2)=0
         HEIGHT(I,3)=0
         HEIGHT(I,4)=0
99    CONTINUE
C ***
C ***
C ***      
C
C                                       Initialize the page counter.
      NPICT = 0
      RETURN
C
C--- IFUNC = 10, Close workstation -------------------------------------
C
  100 CONTINUE
C                                       Write out the postamble to
C                                       the TeX PK file and TeX TFM 
C                                       file and close the files.
C
               LNEWFL=.FALSE.
               CALL GRTX03 (LUN,PKFILE,TFMFIL,
     2                 CURCHA,PKOUT,RESOLX,RESOLY,XMAX,YMAX,
     3                 NDEV,DEVICE,LNEWFL,NPKBYT,CHINFO,
     4                 WIDTH,HEIGHT,BC)

C
      RETURN
C
C--- IFUNC = 11, Begin picture -----------------------------------------
C
  110 CONTINUE
C                                       Set the bitmap size.
      XMAX = RBUF(1)
      YMAX = RBUF(2)
C                                       Calculate the dimensions of the
C                                       plot BITMAP.
      IF (PORTRAIT(DEVICE)) THEN
         BX = INT (XMAX) / 8 + 1
         BY = INT (YMAX) + 1
      ELSE
         BX = INT (YMAX) / 8 + 1
         BY = INT (XMAX) + 1
      END IF
C                                       Allocate a 2-D array in memory 
C                                       for the BITMAP plot by obtaining
C                                       BX*BY contiguous bytes of memory.      
      IER = GRGMEM (BX * BY, BITMAP)
C                                       Check for error and clean up
C                                       if one was found.
      IF (IER .NE. SS_NORMAL) THEN
          CALL GRGMSG (IER)
          CALL GRQUIT ('Failed to allocate a memory for plot BITMAP.')
      END IF
C                                       Increment the page number.
      NPICT = NPICT + 1
C                                       start graphics mode.
C                                       Zero out the plot BITMAP memory array.
      BYTVAL='00'X
      CALL GRTX13 (BX*BY, %VAL(BITMAP),BYTVAL)
C                                       Set up BITMAP as not used.
      LBUSED=.FALSE.
      RETURN
C
C--- IFUNC = 12, Draw line ---------------------------------------------
C
  120 CONTINUE
C                                       Apply any needed tranformation.
      IF (PORTRAIT(DEVICE)) THEN
         DO 125 I = 1, 4
            XBUF(I) = RBUF(I)
  125    CONTINUE
      ELSE      
         XBUF(1) = RBUF(2)
         XBUF(2) = XMAX - RBUF(1)
         XBUF(3) = RBUF(4)
         XBUF(4) = XMAX - RBUF(3)
      END IF
C                                       Draw the point into the bitmap.
      CALL GRTX00 (1, XBUF, IC, BX, BY, %VAL (BITMAP))
C                                       If point "drawn" was not an 
C                                       erasure (white), then set 
C                                       BITMAP as having been used.
      IF(IC.NE.IWHITE) LBUSED=.TRUE.
      RETURN
C
C--- IFUNC = 13, Draw dot ----------------------------------------------
C
  130 CONTINUE
C                                       Apply any needed tranformation.
      IF (PORTRAIT(DEVICE)) THEN
         DO 135 I = 1, 2
            XBUF(I) = RBUF(I)
  135    CONTINUE
      ELSE
         XBUF(1) = RBUF(2)
         XBUF(2) = XMAX - RBUF(1)
      END IF
C                                       Draw the point into the bitmap.
      CALL GRTX00 (0, XBUF, IC, BX, BY, %VAL(BITMAP))
C                                       If point "drawn" was not an 
C                                       erasure (white), then set 
C                                       BITMAP as having been used.
      IF(IC.NE.IWHITE) LBUSED=.TRUE.
      RETURN
C

C--- IFUNC = 14, End picture -------------------------------------------
C
  140 CONTINUE
C                                       Need to write out the Font character.
C ***    Encode the current PK Font character and write it out.
C *** ------------------------------------
         DO 141, JTMP2=LEN(PKFILE),2,-1
           IF(PKFILE(JTMP2:JTMP2).NE.' ') GOTO 142
141      CONTINUE
142      CONTINUE
C ***    PORTABILITY NOTE: Might want to use   JTMP1=ICHAR('A')+CURCHA-1
C ***    or something equivalent if on an EBCDIC machine... ?
C ***    I think (but I'm not sure) that TeX, etcetera, use ASCII internally.
C ***    I coded this as VaX specific.
         JTMP1=BC+CURCHA-1
C        IF(ICHAR('A').NE.65) CALL GRWARN('Next message is not correct.'
C    2     //'it assumes that the ASCII value of A was 65base10.')
C
C ----------------
C *** *UNIX impossible string concatenation bug workaround. Also works
C ***       under *VMS .
         CHTMPS=PKFILE
         CALL GRWARN('Starting to process the image '
     2            //'to produce the PK Font    '''//CHTMPS(1:JTMP2)
     3            //'''    letter   '''//CHAR(JTMP1)//'''   from '
     4            //'your BITMAP...')
C -----------------
C
C ***    Test to se if BITMAP has been drawn to (used).
         IF(.NOT. LBUSED) THEN
            CALL GRWARN('Blank page was submitted for making '
     2              //'a character out of. -- ignoring this '
     3              //'blank character and continuing.')
            GOTO 149
         ENDIF
C ----------------
C *** Time to process the bitmap into a PK Font character.
C
         CALL GRTX02 (BX,BY,%VAL(BITMAP),CURCHA,
     2                RESOLX,RESOLY,XMAX,YMAX,NDEV,
     3                DEVICE,LUN,NPKBYT,CHINFO,
     4                WIDTH,HEIGHT,BC,IXBXLL,IYBXLL,IXBXUR,IYBXUR)
C ----------------
C ***    PORTABILITY NOTE: Might want to use   JTMP1=ICHAR('A')+CURCHA-1
C ***    or something equivalent if on an EBCDIC machine... ?
C ***    I think (but I'm not sure) that TeX, etcetera, use ASCII internally.
C ***    I coded this as VaX specific.
C        IF(ICHAR('A').NE.65) CALL GRWARN('Next message is not correct.'
C    2     //'it assumes that the ASCII value of A was 65base10.')
C
C ----------------
C ***    Increment the character count.
C ----------------
C *** *UNIX impossible string concatenation bug workaround. Also works
C ***       under *VMS .
         CHTMPS=PKFILE
         CALL GRWARN('Finished processing '
     2            //'the PK Font    '''//CHTMPS(1:JTMP2)
     3            //'''    letter   '''//CHAR(JTMP1)//'''   from '
     4            //'your BITMAP...')
C -----------------
         CURCHA=CURCHA+1
         IF(CURCHA.GE.16) THEN
C ***       Need to start a new PK Font. We may only have up to
C ***       15 characters per Font.
            LNEWFL=.TRUE.
            CALL GRTX03 (LUN,PKFILE,TFMFIL,
     2             CURCHA,PKOUT,RESOLX,RESOLY,XMAX,YMAX,
     3             NDEV,DEVICE,LNEWFL,NPKBYT,CHINFO,
     4             WIDTH,HEIGHT,BC)
C ***       Set the current character to the first one in the Font.
            CURCHA=1
C ***       Increment the number of Fonts produced.
            PKOUT=PKOUT+1                           
C ***       Reset the TFM arrays CHINFO, WIDTH, HEIGHT for the new Font.
C ***       The CHINFO table will remain as set up.  The WIDTH and HEIGHT
C ***       tables will be modified for each of the PK Font characters
C ***       as the character is written to the PK file. 
            DO 143, I=0,14
C ***         The width table index is in the first byte.
              CHINFO(BC+I,1)=I+1
C ***         The height table index is in the first nybble of the 
C ***         of the second byte, while the depth table index is in the 
C ***         second nybble of the second byte. 
              CHINFO(BC+I,2)=16*(I+1)
C ***         The italic table index is in the first six bits of the 
C ***         third byte, while the tag index is in the last two bits
C ***         of the third byte. (Tag=0 means remainder byte 4 is unused).
              CHINFO(BC+I,3)=0
C ***         This is the remainder byte.  It is unused for our purposes.
              CHINFO(BC+I,4)=0
C ***         Initialize the width table to zero.  The width table will be
C ***         modified as each character is written to the PK file.
              WIDTH(I,1)=0
              WIDTH(I,2)=0
              WIDTH(I,3)=0
              WIDTH(I,4)=0
C ***         Initialize the height table to zero. The height table will be
C ***         modified as each character is written to the PK file.
              HEIGHT(I,1)=0
              HEIGHT(I,2)=0
              HEIGHT(I,3)=0
              HEIGHT(I,4)=0
143         CONTINUE
C ***
C ***
C ***
          ENDIF
C ***
C ***
         IF(LBITFO.EQ..TRUE.) THEN
C ***       Dump the bitmap out to a file.
            CALL GRWARN('Writing out a copy of BITMAP '
     2              //'as you requested by PGPLOT_TX_BITFILE '
     3              //' logical.')
            CALL GRTX01 (BX, BY, %VAL (BITMAP),BITFIL,
     2              CHBITD,IXBXLL,IYBXLL,IXBXUR,IYBXUR,
     3              LUN,PKOUT,CURCHA)
         ENDIF
C
149      CONTINUE
C                                       Deallocate the memory for the 
C                                       BITMAP plot array.
        IER = GRFMEM (BX * BY, BITMAP)
C                                       Check for an error.
         IF (IER .NE. SS_NORMAL) THEN
           CALL GRGMSG (IER)
           CALL GRWARN('Failed to deallocate memory for plot BITMAP.')
         END IF
      RETURN
C
C--- IFUNC = 15, Select color index ------------------------------------
C
  150 CONTINUE
C                                       Save the requested color index.
      IC = RBUF(1)
C                                       If out of range set to black.
      IF (IC .LT. 0 .OR. IC .GT. 1) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC = 16, Flush buffer. -----------------------------------------
C    (Not implemented: ignored.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC = 17, Read cursor. ------------------------------------------
C    (Not implemented: should not be called.)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC = 18, Erase alpha screen. -----------------------------------
C    (Not implemented: ignored.)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC = 19, Set line style. ---------------------------------------
C    (Not implemented: should not be called.)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC = 20, Polygon fill. -----------------------------------------
C    (Not implemented: should not be called.)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC = 21, Set color representation. -----------------------------
C    (Not implemented: ignored.)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC = 22, Set line width. ---------------------------------------
C    (Not implemented: should not be called.)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC = 23, Escape ------------------------------------------------
C    (Not implemented: ignored.)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC = 24, Rectangle fill. ---------------------------------------
C    (Not implemented: should not be called.)
C
  240 CONTINUE
      GOTO 900
C
C--- IFUNC = 25, -------------------------------------------------------
C    (Not implemented: should not be called.)
C
  250 CONTINUE
      GOTO 900
C
C--- IFUNC = 26, Line of pixels. ---------------------------------------
C    (Not implemented: should not be called.)
C
  260 CONTINUE
      GOTO 900
C-----------------------------------------------------------------------
      END
C<FF>
C *GRTX00 -- PGPLOT TeX PK Font Driver, draw line in BITMAP
C
      SUBROUTINE GRTX00 (LINE,RBUF,ICOLOR,IBXDIM,
     2                  IBYDIM,BITMAP)
      IMPLICIT NONE
      INTEGER*4  IBXDIM,IBYDIM,ICOLOR,LINE
      BYTE       BITMAP(0:IBXDIM-1,0:IBYDIM-1)
      REAL*4     RBUF(4)
C
C Draw a straight line segment from absolute pixel coordinates (RBUF(1),
C RBUF(2)) to (RBUF(3), RBUF(4)).  The line either overwrites (sets to
C black) or erases (sets to white) the previous contents of the bitmap,
C depending on the current color index. Setting bits is accomplished
C with Non-standard Fortran as .OR.; clearing
C bits is accomplished with Non-standard Fortran as .AND. .NOT..
C
C Arguments:
C
C LINE            I I      =0 for dot, =1 for line.
C RBUF(1),RBUF(2) I R      Starting point of line.
C RBUF(3),RBUF(4) I R      Ending point of line.
C ICOLOR          I I      =0 for erase, =1 for write (black point).
C BITMAP        I/O B      (address of) the frame buffer.
C
C-----------------------------------------------------------------------
      BYTE       QMASK(0 : 7)
      INTEGER*4  K,KX,KY,LENGTH
      REAL*4     D,XINC,XP,YINC,YP
      QMASK(0)='80'X
      QMASK(1)='40'X
      QMASK(2)='20'X
      QMASK(3)='10'X
      QMASK(4)='08'X
      QMASK(5)='04'X
      QMASK(6)='02'X
      QMASK(7)='01'X
C-----------------------------------------------------------------------
      IF (LINE .GT. 0) THEN
         D = MAX (ABS (RBUF(3) - RBUF(1)), ABS (RBUF(4) - RBUF(2)))
         LENGTH = D
         IF (LENGTH .EQ. 0) THEN
            XINC = 0.0
            YINC = 0.0
         ELSE
            XINC = (RBUF(3) - RBUF(1)) / D
            YINC = (RBUF(4) - RBUF(2)) / D
         END IF
      ELSE
         LENGTH = 0
         XINC = 0.0
         YINC = 0.0
      END IF
C *** Round to nearest integer in device coordinates.
      XP = RBUF(1) + 0.5
      YP = RBUF(2) + 0.5
      IF (ICOLOR .NE. 0) THEN
         DO 100, K = 0, LENGTH
            KX = XP
            KY = YP
            BITMAP(KX/8,KY)=BITMAP(KX/8,KY) .OR.
     1                      QMASK(MOD (KX, 8))
            XP = XP + XINC
            YP = YP + YINC
100      CONTINUE
      ELSE
         DO 200, K=0,LENGTH
            KX = XP
            KY = YP
            BITMAP(KX/8,KY) = BITMAP(KX/8,KY) 
     1                 .AND. (.NOT. QMASK(MOD (KX, 8)))
            XP = XP + XINC
            YP = YP + YINC
200      CONTINUE
      END IF
C-----------------------------------------------------------------------
      RETURN
      END
C<FF>
C *GRTX01 -- PGPLOT Bitmap File Output driver, copy bitmap to output file
C
      SUBROUTINE GRTX01 (IBXDIM,IBYDIM,BITMAP,BITFIL,
     2                   CHBITD,IXBXLL,IYBXLL,IXBXUR,IYBXUR,
     3                   LUN,PKOUT,CURCHA)
      IMPLICIT NONE
      INTEGER  IBXDIM,IBYDIM,IBTLUN,IRECLB,LUN(2),PKOUT,CURCHA
      INTEGER  IXBXLL,IYBXLL,IXBXUR,IYBXUR
      BYTE     BITMAP(0:IBXDIM-1,0:IBYDIM-1)
      CHARACTER*(*) BITFIL,CHBITD
C
C Arguments:
C
C  BITLFIL         the BITMAP file name (or the default BITMAP file name).
C  IBXDIM,IBYDIM (input)  dimensions of BITMAP
C  BITMAP        (input)  the bitmap array
C  IXBXLL,IYBXLL (input)  the pixel numbers of the lower left corner of
C                         the minimal bounding box of the graphics character
C  IXBXUR,IYBXUR (input)  the pixle numbers of the upper right corner of
C                         the minimal bounding box of the graphics character
C                         NOTE: IXBXLL<IXBXUR and IYBXLL<IYBXUR .
C  LUN           (input)  contains a list of the device numbers already
C                         allocated to enable error checking.
C-----------------------------------------------------------------------
      INTEGER  I,J,IER,ITEMPV,IRECRD,ILENGT
      CHARACTER*10 MSG
C-----------------------------------------------------------------------
C                                       Set up initial record to first record.
       IRECRD=1
C                                       Set up the file name for output.
         WRITE(UNIT=MSG,FMT='(I5)') (PKOUT-1)*15+CURCHA
C ***    We will used J to keep track of the length of MSG for the
C ***    file name below.
         DO 10, J=5,1,-1
           IF(MSG(1:1).EQ.' ') THEN
              MSG(1:1)=MSG(2:2)
              MSG(2:2)=MSG(3:3)
              MSG(3:3)=MSG(4:4)
              MSG(4:4)=MSG(5:5)
              MSG(5:5)=' '
           ELSE
              GOTO 11
           ENDIF
10       CONTINUE
11       CONTINUE
       
C ***
         ILENGT=LEN(BITFIL)
         DO 20, I=ILENGT,1,-1
            IF(BITFIL(I:I).EQ.'.') GOTO 21
20      CONTINUE
21      CONTINUE
         IF(I.GT.0) THEN 
            BITFIL=BITFIL(1:I-1)//'_'//MSG(1:J)//BITFIL(I:ILENGT)
         ELSE
             CALL GRWARN('PROGRAMMING ERROR IN BITFIL FILE NAME '
     2                //'IN ROUTINE GRTX01. ERROR WAS MADE '
     3                //'BY AUTHOR OF TXDRIVER ROUTINE.')
             CALL GRWARN('TRY ANOTHER NAME FOR YOUR FILE NAME.')
             CALL GRQUIT('EXITING BACK TO OPERATING SYSTEM FROM '
     2               //'ROUTINE GRTX01.')
             STOP
         ENDIF
C                Finished with I,J,and ILENGT...
C *** -----------------------

C                                       Allocate file.
       CALL GRGLUN(IBTLUN)
       IF(IBTLUN.EQ.-1) THEN
         CALL GRWARN ('Cannot allocate a logical unit for the'
     2                //' BITMAP copy to a file.')
         RETURN
       ELSE IF (IBTLUN.EQ.LUN(1) .OR. IBTLUN.EQ.LUN(2))THEN
         CALL GRWARN('ERROR IN PGPLOT ROUTINE GRGLUN.  IDENTICAL '
     2            //'FORTRAN UNIT NUMBERS WERE RETURNED.')
         CALL GRQUIT('EXITING BACK TO OPERATING SYSTEM '
     2            //'FROM ROUTINE GRTX01.')
       ELSE
         IF(CHBITD(1:7).NE.'MINIMAL') THEN
C ------------------------------------------------------------------
           IRECLB=IBXDIM/4
           IF(FLOAT(IRECLB).LT.(FLOAT(IBXDIM)/4.0))IRECLB=IRECLB+1
C     *VMS         We will write out IRECLB*4 bytes at a time to the file.
           OPEN(UNIT=IBTLUN,FILE=BITFIL,ACCESS='DIRECT',
     2          FORM='UNFORMATTED',STATUS='NEW',
     3          IOSTAT=IER,
     4          DISP='DELETE',RECL=IRECLB)
C ***      *UNIX    
C ***           OPEN(UNIT=IBTLUN,FILE=BITFIL,ACCESS='DIRECT',
C ***     2          FORM='UNFORMATTED',STATUS='NEW',
C ***     3          IOSTAT=IER,RECL=IRECLB)
           IF(IER.NE.0) THEN
              CALL GRWARN('Cannot open the file for the BITMAP'
     2                  //' copy to a file.')
              CALL GRFLUN(IBTLUN)
              RETURN
           ENDIF
C 
C                                       Loop through bitmap
C                                       starting at top left and working
C                                       down while outputing one horizontal 
C                                       row for every write statement.
        DO 100, J=IBYDIM-1,0,-1
C                                       Write out the bitmap row (raster line)
           WRITE(IBTLUN,REC=IRECRD,ERR=600)
     2         (BITMAP(I,J),I=0,IBXDIM-1)
           IRECRD=IRECRD+1
100     CONTINUE
C                                       Close the Bitmap output file.
C ***   *VMS
        CLOSE(UNIT=IBTLUN,DISP='KEEP',ERR=500)
C ***   *UNIX
C ***        CLOSE(UNIT=IBTLUN,ERR=500)
C ***
C -------------------------------------------------------------------
      ELSE
C -------------------------------------------------------------------
           ITEMPV=(IXBXUR/8 - IXBXLL/8 + 1 ) 
           IRECLB=ITEMPV/4
           IF(FLOAT(ITEMPV/4).LT.(FLOAT(ITEMPV)/4.0))IRECLB=IRECLB+1
C                                                   OPEN the files.
C     *VMS         We will write out ireclb*4 bytes at a time to
C                  the file.
           OPEN(UNIT=IBTLUN,FILE=BITFIL,ACCESS='DIRECT',
     2          FORM='UNFORMATTED',STATUS='NEW',
     3          IOSTAT=IER,
     4          DISP='DELETE',RECL=IRECLB)
C ***      *UNIX    
C ***           OPEN(UNIT=IBTLUN,FILE=BITFIL,ACCESS='DIRECT',
C ***     2          FORM='UNFORMATTED',STATUS='NEW',
C ***     3          IOSTAT=IER,RECL=IRECLB)
           IF(IER.NE.0) THEN
              CALL GRWARN('Cannot open the file for the BITMAP'
     2                  //' copy to a file.')
              CALL GRFLUN(IBTLUN)
              RETURN
           ENDIF
C 
C                                       Loop through the bitmap
C                                       starting at top left of the 
C                                       minimal bounding box of the graphics
C                                       character and working down to the
C                                       bottom right of the minimal bounding
C                                       box of the graphics character
C                                       while outputing one horizontal 
C                                       row for every write statement.
        DO 200, J=IYBXUR,IYBXLL,-1
C                                       Write out the bitmap row (raster line)
           WRITE(IBTLUN,REC=IRECRD,ERR=600)
     2        (BITMAP(I,J),I=IXBXLL/8,IXBXUR/8)
           IRECRD=IRECRD+1
200     CONTINUE
C                                       Close the Bitmap output file.
C ***   *VMS
         CLOSE(UNIT=IBTLUN,DISP='KEEP',ERR=500)
C ***   *UNIX
C ***         CLOSE(UNIT=IBTLUN,ERR=500)
C
C-----------------------------------------------------------------------
       ENDIF
C                                       Free the logical unit back up.
300   CONTINUE
      CALL GRFLUN(IBTLUN)
      ENDIF
      RETURN
500   CONTINUE
      CALL GRWARN('ERROR CLOSING FILE CONTAINING COPY OF THE '
     2         //' BITMAP')
      CALL GRQUIT('EXITING BACK TO OPERATING SYSTEM FROM GRTX01')
      STOP
600   CONTINUE
      CALL GRWARN('ERROR WRITING OUT COPY OF THE BITMAP TO A FILE.')
      CALL GRWARN('EXITING BACK TO OPERATING SYSTEM FROM GRTX01')
      STOP
      END
C<FF>
C *GRTX02 -- PGPLOT Encode current PK Font character and store it.
C
      SUBROUTINE GRTX02 (IBXDIM,IBYDIM,BITMAP,CURCHA,
     2           RESOLX,RESOLY,XMAX,YMAX,NDEV,DEVICE,
     3           LUN,NPKBYT,CHINFO,WIDTH,HEIGHT,BC,
     4           IXBXLL,IYBXLL,IXBXUR,IYBXUR)
C-----------------------------------------------------------------------
C ***
      IMPLICIT NONE
      INTEGER IBXDIM,IBYDIM,NDEV,DEVICE,CURCHA,I
      INTEGER LUN(2),NPKBYT,BC,NC,IRCIND,IRPIND
      REAL RESOLX(NDEV),RESOLY(NDEV),XMAX,YMAX
      BYTE BITMAP(0:IBXDIM-1,0:IBYDIM-1)
      INTEGER WIDTH(0:15,4),HEIGHT(0:15,4),CHINFO(BC:BC+14,4)
C
      INTEGER GRFMEM, GRGMEM
C
      INTEGER IRUNCD,IRPEAT,BENCOD,IRCDIM,IRPDIM,IBEDIM
      INTEGER IXBXLL,IYBXLL,IXBXUR,IYBXUR,IER,SS_NORMAL 
      INTEGER IBOXDX,IBOXDY,IDYNF(0:14),IDYNFO,IDYNFV
      LOGICAL LIBLAK,LTX05E
C ***      PARAMETER(SS_NORMAL = 1)
      SS_NORMAL=1       
C *** -------------------------------------------------------------
C *** Get the RUN CODE count values of the BITMAP for later ENCODING.
C *** First, we need to allocate an array for containing the
C *** run code count values {IRUNCD(IRCDIM))}, and an array
C *** for containing the repeat counts {IRPEAT(IRPDIM)}.
C *** Instead of guessing that the worst case should be no
C *** worse than the image changing every other pixel for
C *** run code counts, and then allocating that much virtual memory,
C *** we first do all of the RUN-CODE calculations without storing
C *** the RUN-CODE results, then we allocate the exact amount of
C *** of space required for doing the RUN-CODING and then 
C *** reenter the GRTX05 routine and store the RUN CODE counts
C *** as they are calculated the second time. The logical variable
C *** LTX05E is used inside of the GRTX05 routine to determine which
C *** pass we are on (LTX05E=.FALSE. for the first pass, and
C *** LTX05E=.TRUE. for the second pass).
C *** PORTABILITY NOTE: {4 bytes in an integer assumed!. The arrays
C *** IRUNCD, IRPEAT and BENCOD are 4 byte integers.}
C *** 
C *** Set the dimension of IRUNCD to be 2 and 
C *** the dimension of IRPEAT to be 2 initially.(We need to
C *** have values for IRUNCD and IRPEAT to be dimensioned inside
C *** the GRTX05 routine).
      IRCDIM=2
      IRPDIM=2
C
      IER = GRGMEM (IRCDIM*4,IRUNCD)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('Failed to allocate a TeX PK Font IRUNCD '
     2              //' RUN CODE count array the 8 bytes.')
      END IF
C
      IER = GRGMEM (IRPDIM*4,IRPEAT)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('Failed to allocate a TeX PK Font IRPEAT'
     2              //' repeat count RUN CODE array 8 bytes.')
      END IF
C *** Call the RUN CODEing routine, GRTX05 to determine the size
C *** needed for allocating virtual memory to contain the RUN CODE 
C *** counts.  IRCIND and IRPIND will contain the needed dimension 
C *** values upon return from routine GRTX05.
      LTX05E=.FALSE.
      IRCIND=0
      IRPIND=0
      CALL GRTX05 (BITMAP,IBXDIM,IBYDIM,%VAL(IRUNCD),
     2             IRCDIM,%VAL(IRPEAT),IRPDIM,LIBLAK,
     3             IXBXLL,IYBXLL,IXBXUR,IYBXUR,
     4             LTX05E,IRCIND,IRPIND)
C *** Calculate the width of the minimal bounding box for the character.
      IBOXDX=IXBXUR-IXBXLL+1
      IBOXDY=IYBXUR-IYBXLL+1
C *** Now Deallocate the 8 bytes of Virtual memory contained in
C *** the IRCUND and IRPEAT arrays and allocate the amount of
C *** virtual memory that we really need for calculating the
C *** RUN CODE counts.
C
      IER=GRFMEM (IRPDIM*4,IRPEAT)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('FAILED TO DEALLOCATE IRPEAT ARRAY'
     2           //' MEMORY 8 bytes.')
      ENDIF
C
      IER=GRFMEM (IRCDIM*4,IRUNCD)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('FAILED TO DEALLOCATE IRUNCD ARRAY'
     2           //' MEMORY 8 bytes.')
      ENDIF
C ***
C *** Now allocate the actual virtual memory space that we need.
      IRCDIM=IRCIND-1
      IRPDIM=IRPIND-1
C *** Add test for 0 allocation...
      IF(IRCDIM.EQ.0) THEN 
         CALL GRQUIT('ERROR in RUN CODING the IMAGE. The size '
     2       //'of the RUN-CODed image is ZERO.  Routine GRTX02.')
      ENDIF
C
      IF(IRPDIM.EQ.0) THEN
         IRPDIM=1
         CALL GRWARN('There were no repeat counts for the '
     2       //'current graphics character.')
      ENDIF
C
      IER = GRGMEM (IRCDIM*4,IRUNCD)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('Failed to allocate a TeX PK Font IRUNCD '
     2              //' RUN CODE count array.')
      END IF
C
      IER = GRGMEM (IRPDIM*4,IRPEAT)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('Failed to allocate a TeX PK Font IRPEAT'
     2              //' repeat count RUN CODE array.')
      END IF
C ***
C *** Now call GRTX05 and calculate -- and this time STORE -- the actual
C *** RUN CODE counts.
      LTX05E=.TRUE.
      IRCIND=0
      IRPIND=0
      CALL GRTX05 (BITMAP,IBXDIM,IBYDIM,%VAL(IRUNCD),
     2             IRCDIM,%VAL(IRPEAT),IRPDIM,LIBLAK,
     3             IXBXLL,IYBXLL,IXBXUR,IYBXUR,
     4             LTX05E,IRCIND,IRPIND)
C ***
C ***
C *** -------------------------------------------------------------
C *** Get the dyn_f value for the current RUN CODE counts for
C *** optimal encoding. 
      CALL GRWARN('Calculating the optimal dyn_f value '
     2           //'for PK ENCODE-ing the character.')
      CALL GRTX06(%VAL(IRUNCD),IRCDIM,IBOXDX,
     2            IBOXDY,IDYNF,%VAL(IRPEAT),
     3            IRPDIM,BITMAP,IBXDIM,IBYDIM)
C *** Determine what the optimal dyn_f value is.
      IDYNFO=14
      IDYNFV=IDYNF(14)
      DO 100, I=0,14
         IF(IDYNF(I).LT.IDYNFV) THEN
           IDYNFO=I
           IDYNFV=IDYNF(I)
         ENDIF
100   CONTINUE
C *** The optimal value of dyn_f is contained in IDYNFO.
C *** The number of nybbles required for encoding is contained in IDYNFV.
C *** -------------------------------------------------------------
C *** ENCODE the RUN CODE counts using the optimal dyn_f.
C *** First, we need to allocate enough space for the optimal
C *** encoding. IDYNFV contains the number of nybbles required.
C *** 
      IBEDIM=0
      IF(MOD(IDYNFV,2).EQ.1) IBEDIM=1
      IBEDIM=IBEDIM+INT(IDYNFV/2)
C *** Add a test for Zero allocation...
      IF(IBEDIM.EQ.0) THEN
         CALL GRQUIT('ERROR.  The specified allocation for '
     2        //'Encoding the RUN-CODE is ZERO
     3        // for the BENCOD array in Routine GRTX02.')
      ENDIF
C                            
      IER = GRGMEM (IBEDIM*4,BENCOD)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('Failed to allocate a TeX PK Font BENCOD'
     2              //' ENCODEing array for RUN COUNT.')
      END IF
      IF(IDYNFO.EQ.14) THEN
          CALL GRWARN('PK ENCODE-ing the character using '
     2               //'the optimal dyn_f=14 -- ')
          CALL GRWARN('which means '
     2           //'''raw compressed bitmapping''...')
C ***     We should encode using raw compressed bitmapping...
          CALL GRTX07(BITMAP,IBXDIM,IBYDIM,%VAL(BENCOD),
     2             IBEDIM,IXBXLL,IYBXLL,IXBXUR,IYBXUR)
      ELSE
C ***     We should encode using the packed number encoding
C ***     with the optimal value of dyn_f, IDYNFO.
          CALL GRWARN('PK ENCODE-ing the character using '
     2       //'the optimal dyn_f value...')
          CALL GRTX08(%VAL(IRUNCD),IRCDIM,IDYNFO,
     2                %VAL(IRPEAT),IRPDIM,
     3                %VAL(BENCOD),IBEDIM)
      ENDIF
C ***
C *** -------------------------------------------------------------
C *** Write out the current PK character.
      CALL GRWARN('Writing out the current PK character...')
      NC=CURCHA-1
      CALL GRTX09 (IBEDIM,BC,NC,XMAX,RESOLX,NDEV,DEVICE,
     2             IXBXLL,IXBXUR,IYBXLL,IYBXUR,IDYNFO,
     3             LIBLAK,NPKBYT,LUN,%VAL(BENCOD),HEIGHT,
     4             WIDTH,YMAX,RESOLY)
C *** -------------------------------------------------------------
C *** Free the memory back up ...
C
      IER=GRFMEM (IBEDIM*4,BENCOD)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('FAILED TO DEALLOCATE BENCOD ARRAY MEMORY.')
      ENDIF
C
      IER=GRFMEM (IRPDIM*4,IRPEAT)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('FAILED TO DEALLOCATE IRPEAT ARRAY MEMORY.')
      ENDIF
C
      IER=GRFMEM (IRCDIM*4,IRUNCD)
      IF(IER.NE.SS_NORMAL) THEN
        CALL GRGMSG(IER)
        CALL GRQUIT('FAILED TO DEALLOCATE IRUNCD ARRAY MEMORY.')
      ENDIF
C ***
C-----------------------------------------------------------------------
      RETURN
      END
C<FF>
C *GRTX03 -- PGPLOT Close the current Font, and possibly start new one.
C
      SUBROUTINE GRTX03 (LUN,PKFILE,TFMFIL,
     2                   CURCHA,PKOUT,RESOLX,RESOLY,XMAX,
     3                   YMAX,NDEV,DEVICE,LNEWFL,NPKBYT,
     4                   CHINFO,WIDTH,HEIGHT,BC)
C----------------------------------------------------------------------
C ***
C ***
C *** If LNEWFL=.TRUE. then close the current PK Font and start a 
C *** new one.  IF LNEWFL=.FALSE. then just close the current PK Font
C *** file.  In either case, write out the Postambles to PK file
C *** and to TFM file.  IF LNEWFL=.TRUE., then we need to also call
C *** GRTX04  to write the Preamble to the new PK file.
C ***
C *** ------------------------------------------------------------------
C-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER LUN(2),I,J,NPKBYT,NC,CURCHA,PKOUT,NDEV
      INTEGER DEVICE,BC,ILENGT,IER 
      INTEGER BYTOUT,CHINFO(BC:BC+14,4),WIDTH(0:15,4)
      INTEGER HEIGHT(0:15,4),JTMP1,JTMP2
      LOGICAL LNEWFL
      REAL RESOLX(NDEV),RESOLY(NDEV),XMAX,YMAX
      CHARACTER*(*) PKFILE,TFMFIL
      CHARACTER MSG*5,CHTMPS*80
C *** -----------------------------------------------------------
C *** Write the postamble to PK file.
      CALL GRWARN('Writing out the postamble and for the '
     2          //'PK file...')
C ***
C *** The opcode for the PK postamble is 245 base10.
      BYTOUT=245
      CALL GRTX11(LUN(1),BYTOUT)
      NPKBYT=NPKBYT+1
C *** Now we need enough no-operation codes to finish filling this block.
C *** So, we need to get to a multiple of 512.
C *** The preamble required 33 bytes. We have written NPKBYT bytes
C *** of character information thus far (includes the preamble
C *** and postamble opcode).  The postamble requires 1 byte plus enough
C *** bytes to finish filling the 512 byte record block on a Vax.
C *** We need to have NPKBYT a multiple of 512 after we are finished.
C *** We will finish filling the block with no-op's (that is, no-operation
C *** opcodes).  Note: All the PK format requires is a multiple of 4 (not
C *** 512).  I chose 512 just to finish filling the current record and block
C *** on the Vax.
      DO 100, I= 1, 512
         IF(MOD(NPKBYT,512).EQ.0) GOTO 120
         NPKBYT=NPKBYT+1
         BYTOUT=246
         CALL GRTX11(LUN(1),BYTOUT)
100   CONTINUE 
120   CONTINUE
C *** Now we are ready to close the PK file.
      CALL GRWARN('Closing the current PK file...')
C *** *VMS
      CLOSE(UNIT=LUN(1),ERR=130,DISP='KEEP')
C *** *UNIX
C ***      CLOSE(UNIT=LUN(1),ERR=130)
C
      GOTO 140
C *** ----------
130   CONTINUE
      CALL GRWARN('ERROR CLOSING PK FILE IN ROUTINE GRTX03')
      CALL GRQUIT('EXITING BACK TO OPERATING SYSTEM. GRTX03')
      STOP
C *** -------------------------------------------------------
140   CONTINUE
C *** Write the whole TFM file.
C ***
C *** The number of character which have been stored in the PK Font 
C *** is given by CURCHA-1.  NC=0 is for the first character (ascii
C *** code BC. So, NC= (CURCHA-1) -1.
      NC=CURCHA-2
C *** Routine GRTX10 writes the TFM file.
      CALL GRWARN('Writing out the TeX Font Metric (TFM) '
     2          //' file...')
      CALL GRTX10 (NC, LUN(2),CHINFO,WIDTH,HEIGHT,BC)
C *** Now we are ready to close the TFM file.
      CALL GRWARN('Closing the current TFM file...')
C 
C *** *VMS
       CLOSE(UNIT=LUN(2),ERR=145,DISP='KEEP')
C *** *UNIX
C ***       CLOSE(UNIT=LUN(2),ERR=145)
C
      GOTO 146
C *** ------------
145   CONTINUE
      CALL GRWARN('ERROR CLOSING THE TFM FILE.')
      CALL GRQUIT('EXITING BACK TO OPERATING SYSTEM FROM GRTX03')
      STOP
C *** ------------
146   CONTINUE
      DO 150, JTMP2=LEN(PKFILE),2,-1
         IF(PKFILE(JTMP2:JTMP2).NE.' ') GOTO 151
150   CONTINUE
151   CONTINUE
C ***    PORTABILITY NOTE: Might want to use   JTMP1=ICHAR('A')+CURCHA-1
C ***    or something equivalent if on an EBCDIC machine... ?
C ***    I think (but I'm not sure) that TeX, etcetera, use ASCII internally.
C ***    I coded this as VaX specific.
      JTMP1=BC+CURCHA-2
C        IF(ICHAR('A').NE.65) CALL GRWARN('Next message is not correct.'
C    2     //'it assumes that the ASCII value of A was 65base10.')
C ---------------------------
C *** *UNIX  impossible string concatenation bug workaround. Also works
C ***        under *VMS .
      CHTMPS=PKFILE
      CALL GRWARN('Finished the PK Font    '''//CHTMPS(1:JTMP2)
     2        //'''   with letter  '''//CHAR(JTMP1)//''' . ')
C -------------------------
C
C ***
C *** Now we need to check if we are to open a new PK Font.
      IF(LNEWFL.EQ..TRUE.) THEN
C ***    We need to open a new PK Font.
C ***
C ***    We need to determine the new file names for the next font
C ***    because we are out of space on the current font.
         WRITE(UNIT=MSG,FMT='(I5)') PKOUT
C ***    We will used J to keep track of the length of MSG for the
C ***    two file names below.
         DO 200, J=5,1,-1
           IF(MSG(1:1).EQ.' ') THEN
              MSG(1:1)=MSG(2:2)
              MSG(2:2)=MSG(3:3)
              MSG(3:3)=MSG(4:4)
              MSG(4:4)=MSG(5:5)
              MSG(5:5)=' '
           ELSE
              GOTO 201
           ENDIF
200      CONTINUE
201      CONTINUE
       
C ***
         ILENGT=LEN(PKFILE)
         DO 400, I=ILENGT,1,-1
            IF(PKFILE(I:I).EQ.'.') GOTO 401
400      CONTINUE
401      CONTINUE
         IF(I.GT.0) THEN 
            PKFILE=PKFILE(1:I-1)//'_'//MSG(1:J)//PKFILE(I:ILENGT)
         ELSE
             CALL GRWARN('PROGRAMMING ERROR IN PKFILE FILE NAME '
     2                //'IN ROUTINE GRTX03. ERROR WAS MADE '
     3                //'BY AUTHOR OF TXDRIVER ROUTINE.')
             CALL GRWARN('TRY ANOTHER NAME FOR YOUR FILE NAME.')
             CALL GRQUIT('EXITING BACK TO OPERATING SYSTEM FROM '
     2               //'ROUTINE GRTX03.')
             STOP
         ENDIF
C ***
         ILENGT=LEN(TFMFIL)
         DO 600, I=ILENGT,1,-1
            IF(TFMFIL(I:I).EQ.'.') GOTO 601
600      CONTINUE
601      CONTINUE
         IF(I.GT.0)THEN 
            TFMFIL=TFMFIL(1:I-1)//'_'//MSG(1:J)//TFMFIL(I:ILENGT)
         ELSE
             CALL GRWARN('PROGRAMMING ERROR IN TFMFILE FILE NAME '
     2                //'IN ROUTINE GRTX03. ERROR WAS MADE '
     3                //'BY AUTHOR OF TXDRIVER ROUTINE.')
             CALL GRWARN('TRY ANOTHER NAME FOR YOUR FILE NAME.')
             CALL GRQUIT('EXITING BACK TO OPERATING SYSTEM FROM '
     2               //'ROUTINE GRTX03.')
             STOP
         ENDIF
C ***
C ***    Finished with Variable J now.  Can set it's value to
C ***    anything.
C ***   
C ***    Open the PK file first.
         CALL GRWARN('Opening a new PK file...')
C     *VMS         We will write out 512 bytes at a time. RMS will take 
C                  care of us when we read the file back in for DVIing it
C                  If you have problems, change ACCESS='DIRECT' to
C                  ACCESS='SEQUENTIAL' and add RECORDTYPE=FIXED and
C                  modify write statements in GRTX11 and GRTX12 to
C                  be writes to sequential files.  Also, consider
C                  using the rewind statement if you use sequential files. 
         OPEN(UNIT=LUN(1),FILE=PKFILE,ACCESS='DIRECT',
     2     FORM='UNFORMATTED',STATUS='NEW',IOSTAT=IER,
     3     DISP='DELETE',RECL=128)
C
C ***      *UNIX    Want to open up a file to put "bytes on a disk --
C ***               with NO segmented record information... 512 bytes
C ***               will be written out at a time.  128*4=512 
C ***         OPEN(UNIT=LUN(1),FILE=PKFILE,ACCESS='DIRECT',
C ***     2     FORM='UNFORMATTED',STATUS='NEW',IOSTAT=IER,
C ***     3     RECL=128)
C                                       Check for an error and cleanup if
C                                       one occurred.
         IF (IER .NE. 0) THEN
           CALL GRWARN ('Cannot open output PK file for new '
     1                 //'TeX PK Font.')
           CALL GRQUIT('Failed to open next Tex PK file.')
         ENDIF
C
C ***                                   Initialize some indirect 
C ***                                   file pointer information.
      CALL GRTX14
C ***
C ***    Open the TFM file second.
      CALL GRWARN('Opening a new TFM file...') 
C     *VMS         We will write out 512 bytes at a time. RMS will take 
C                  care of us when we read the file back in for DVIing it
C                  If you have problems, change ACCESS='DIRECT' to
C                  ACCESS='SEQUENTIAL' and add RECORDTYPE=FIXED and
C                  modify write statements in GRTX11 and GRTX12 to
C                  be writes to sequential files.  Also, consider using
C                  the rewind statement if you use sequential files. 
      OPEN(UNIT=LUN(2),FILE=TFMFIL,ACCESS='DIRECT',
     2     FORM='UNFORMATTED',STATUS='NEW',IOSTAT=IER,
     3     DISP='DELETE',RECL=128)
C
C ***      *UNIX    Want to open up a file to put "bytes on a disk --
C ***               with NO segmented record information... 512 bytes
C ***               will be written out at a time.  128*4=512 
C ***      OPEN(UNIT=LUN(2),FILE=TFMFIL,ACCESS='DIRECT',
C ***     2     FORM='UNFORMATTED',STATUS='NEW',IOSTAT=IER,
C ***     3     RECL=128)
C                                       Check for an error and cleanup if
C                                       one occurred.
         IF (IER .NE. 0) THEN
           CALL GRWARN ('Cannot open output TFM file for new '
     1                 //'TeX PK Font.')
           CALL GRQUIT('Failed to open next Tex TFM file.')
         ENDIF
C ***                                   Initialize some indirect 
C ***                                   file pointer information.
      CALL GRTX15
C ***
C ***
C
C ***    
C ***    We need to write the preamble to the PK file.
         CALL GRTX04 (RESOLX,RESOLY,NDEV,DEVICE,LUN,NPKBYT)
      ENDIF
C *** Finished.  We can return now.
C-----------------------------------------------------------------------
      RETURN
      END
C<FF>
C *GRTX04 -- PGPLOT Write the preamble for PK file.
C
      SUBROUTINE GRTX04 (RESOLX,RESOLY,NDEV,DEVICE,
     2                   LUN,NPKBYT)
C-----------------------------------------------------------------------
C *** GRTX04  
      IMPLICIT NONE
      INTEGER BYTOUT
      INTEGER VM1,VM2,VM3,VM4,VP0,VP1,VP2,VP3,NPKBYT
      INTEGER LUN(2),NDEV,DEVICE
      REAL RVPPP,RHPPP,RESOLX(NDEV),RESOLY(NDEV)
      DOUBLE PRECISION VALUE
C *** Write the preamble opcode.
      BYTOUT=247
      CALL GRTX11(LUN(1),BYTOUT)
C *** Write out the identification byte of the file.
      BYTOUT=89
      CALL GRTX11(LUN(1),BYTOUT)
C *** Write out the comment of where this file came from.
C *** The string will be "PGPLOT PK Font",which has ASCII Hex values of
C *** "P"=50,"G"=47,"P"=50,"L"=4C,"O"=4F,"T"=54," "=20,
C *** "P"=50,"K"=4B," "=20,"F"=46,"o"=6f,"n"=6E,"t"=74
C *** This requires 14 bytes.
      BYTOUT=14
      CALL GRTX11(LUN(1),BYTOUT)
C *** Now the string...
      BYTOUT =  5*16 +  0
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  4*16 +  7
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  5*16 +  0
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  4*16 + 12
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  4*16 + 15
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  5*16 +  4
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  2*16 +  0
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  5*16 +  0
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  4*16 + 11
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  2*16 +  0
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  4*16 +  6
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  6*16 + 15
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  6*16 + 14
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  7*16 +  4
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C ***
C *** Now write out the design size of the file in 1/20 points (a Fix_word).
C *** This is to be in 4 bytes.  The implied decimal is between byte
C *** 19 and 20 (0 is the first byte).  This is encoded as coefficients
C *** of the power of 16.  See PKtoPX.Web, or other WEB files for 
C *** the documentation of this. 
C *** The design size is 100.0 Tex Points, which is 06400000 as a Fix_word,
C *** 100.0base10=6*16+4 base10=64.0base16 =06400000 Fix_word.  100.0 TeX
C *** points is approximately 1.3837 inches. (This will allow output 
C *** characters from 0.0864813 inches to 22.1382 inches in size.)
C *** This value should be changed if a different range is desired.
      BYTOUT=6
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT=4*16
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT=0
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT=0
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Now, write out the 4 byte checksum, which must be the same in the
C *** TFM file and the PK file.  I chose my birthdate 09 28 1963 as the
C *** Hex value.
      BYTOUT =  0*16 +  9
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  2*16 +  8
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  1*16 +  9
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT =  6*16 +  3
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Now, write out the 4 byte horizontal ratio of pixels per TeX point,
C *** (this is a measure of the dots per inch).  The variable RESOLX(DEVICE)
C *** contains the dots per inch value.  There are horizontally:
C *** RESOLX(DEVICE) {pixels/inch}, 2.54 {cm./inch}, 
C *** 7227.0/254.0 {TeX points/cm.}. So the base10 value of pixels/TeX point is:
      RHPPP=RESOLX(DEVICE)/2.54*254.0/7227
C *** Now, I must convert this into its base 16 value to place the value
C *** multiplied by 2**16 into the 4 bytes.
      VALUE=RHPPP
      VP3=INT(VALUE/(16.0**3))
      VALUE=VALUE-VP3*16.0**3
      VP2=INT(VALUE/(16.0**2))
      VALUE=VALUE-VP2*16.0**2
      VP1=INT(VALUE/(16.0**1))
      VALUE=VALUE-VP1*16.0**1
      VP0=INT(VALUE)
      VALUE=VALUE-VP0
      VM1=INT(VALUE/(16.0**(-1)))
      VALUE=VALUE-VM1*16.0**(-1)
      VM2=INT(VALUE/(16.0**(-2)))
      VALUE=VALUE-VM2*16.0**(-2)
      VM3=INT(VALUE/(16.0**(-3)))
      VALUE=VALUE-VM3*16.0**(-3)
      VM4=INT(VALUE/(16.0**(-4)))
C ***
      BYTOUT = VP3*16 + VP2
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT = VP1*16 + VP0
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT = VM1*16 + VM2
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT = VM3*16 + VM4
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Now, write out the 4 byte vertical ratio of pixels per TeX point,
C *** (this is a measure of the dots per inch).  The variable RESOLY(DEVICE)
C *** contains the dots per inch value.  There are vertically:
C *** RESOLY(DEVICE) {pixels/inch}, 2.54 {cm./inch}, 
C *** 7227.0/254.0 {TeX points/cm.}. So the base10 value of pixels/TeX point is:
      RVPPP=RESOLY(DEVICE)/2.54*254.0/7227
C *** Now, I must convert this into its base 16 value to place the value
C *** multiplied by 2**16 into the 4 bytes.
      VALUE=RVPPP
      VP3=INT(VALUE/(16.0**3))
      VALUE=VALUE-VP3*16.0**3
      VP2=INT(VALUE/(16.0**2))
      VALUE=VALUE-VP2*16.0**2
      VP1=INT(VALUE/(16.0**1))
      VALUE=VALUE-VP1*16.0**1
      VP0=INT(VALUE)
      VALUE=VALUE-VP0
      VM1=INT(VALUE/(16.0**(-1)))
      VALUE=VALUE-VM1*16.0**(-1)
      VM2=INT(VALUE/(16.0**(-2)))
      VALUE=VALUE-VM2*16.0**(-2)
      VM3=INT(VALUE/(16.0**(-3)))
      VALUE=VALUE-VM3*16.0**(-3)
      VM4=INT(VALUE/(16.0**(-4)))
C ***
      BYTOUT = VP3*16 + VP2
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT = VP1*16 + VP0
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT = VM1*16 + VM2
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT = VM3*16 + VM4
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** There were 33 bytes written to the Preamble for the PK Font.
      NPKBYT=33
C ***
C *** And that finishes the Preamble for the PK font.
C-----------------------------------------------------------------------
      RETURN
      END
C<FF>
C *GRTX05 -- PGPLOT Calculate RUN CODE count for PK Font character.
C
      SUBROUTINE GRTX05( BITMAP, IBXDIM, IBYDIM,
     2                   IRUNCD, IRCDIM, IRPEAT,
     3                   IRPDIM, LIBLAK, IXBXLL,
     4                   IYBXLL, IXBXUR, IYBXUR,
     5                   LTX05E,IRCIND,IRPIND)
C-----------------------------------------------------------------------
C ***
C *** --------------------------------------------------------------
C *** This routine is used to produce RUN CODE for the character
C *** contained in the 2-dimensional byte array BITMAP.
C *** The algorithm is described in PKtoPX.WEB.  The PK Font format
C *** was written by Tomas Rokicki in August of 1985. Rokicki was a
C *** former Texas A&M student.  TeX uses this  PK font 
C *** format for technical typesetting.  To get the documentation,
C *** WEAVE the PKTOPX.WEB file. TeX the resulting PKTOPX.TEX file.
C *** Then run the DVI translator to produce the binary file for
C *** printing out to your desired printer.
C ***
C *** BITMAP is a BYTE input array of size IBXDIM x IBYDIM.
C *** IRUNCD is an integer output array of size IRCDIM which will
C *** contain the RUN CODE for the character. 
C *** IRPEAT is an integer output array of size IRPDIM which is used 
C *** to index the Repeat Counts within the IRUNCD array.
C *** The logical variable LTX05E is used to indicate whether this is
C *** the first or second invokation of the routine GRTX05.
C *** The first invokation calculates the minimum bounding box of the
C *** graphics character.
C *** IRCIND and IRPEAT are used in the first invokation of routine GRTX05
C *** to return the dimensions of IRUNCD and IRPEAT needed to 
C *** store the RUN CODE counts.
C *** On the second invokation of routine GRTX05, IRCIND and IRPIND are
C *** just used for indexing into the IRUNCD and IRPEAT arrays for
C *** storing RUN CODE information.
C ***
C ***
C *** ---------------------------------------------------------------
C ***
      IMPLICIT NONE
      INTEGER IBXDIM,IBYDIM,IRCDIM,IRPDIM,
     2        IRUNCD(IRCDIM), IRPEAT(IRPDIM), IRCIND, IRPIND,
     3        ICOL, IROW, ITMPRO, ITMPCO, IRPCNT, IRCSUM,
     4        IXBXLL, IYBXLL, IXBXUR, IYBXUR, I, J, K
      INTEGER WHITE,IPERCR,IPERCL,IXBBLL,IXBBUR
      BYTE BITMAP(0:IBXDIM-1,0:IBYDIM-1),SOLBLK,SOLWHT
      LOGICAL LSOLID,LBLACK,LIBLAK,LTX05E
      CHARACTER*3 MSG
C *** PORTABILITY NOTES:
C *** Note: {Vax byte variables are from -128 to 127.  
C *** ??Parameter statement might need to be modified for SOLBLK=255
C *** base10=FFbase16.
C *** Assumption is that SOLBLK will be converted correctly by the compiler
C *** to the signed quantity on the vax.  I definitely want the 
C *** result to be all ones in the bit positions. The parameter SOLWHT
C *** is to have all zeros in the bit positions.}
C ***      PARAMETER (WHITE=0, SOLBLK='FF'X,SOLWHT='00'X)
      WHITE=0
      SOLBLK='FF'X
      SOLWHT='00'X
C ***
C ***
C *** IRCIND is an integer used as an index into the IRUNCD array.
C *** IRPIND is an integer used as an index into the IRPEAT array.
C *** ICOL is an integer used to keep up with the current X (column) position 
C *** within the BITMAP array.
C *** IROW is an integer used to keep up with the current Y (row) position
C *** within the BITMAP array.
C *** ITMPRO is an integer used to keep up with the temporary X (column) 
C *** position within the BITMAP array.
C *** ITMPCO is an integer used to keep up with the temporary Y (row)
C *** position within the BITMAP array.
C *** IRPCNT is an integer used to keep up with the Repeat Count of the
C *** consecutive rows within the BITMAP array (that is, identical 
C *** consecutive rows).
C *** IRCSUM is an integer used to keep up a running sum of the number of
C *** consecutive pixels which are of the same color
C *** (only black and white colors are allowed --- no shades).
C *** IXBXLL is an integer used to contain the Lower Left X coordinate
C *** of the minimum bounding box of the character (so that all black
C *** pixels are just contained within the box).
C *** IYBXLL is an integer used to contain the Lower Left Y coordinate
C *** of the minimum bounding box of the character (so that all black
C *** pixels are just contained within the box).
C *** IXBXUR is an integer used to contain the Upper Right X coordinate
C *** of the minimum bounding box of the character (so that all black
C *** pixels are just contained within the box).
C *** IYBXUR is an integer used to contain the Upper Right Y coordinate
C *** of the minimum bounding box of the character (so that all black
C *** pixels are just contained within the box).
C *** I,J, K are temporary variables used for counting and DO Loop indices.
C *** LSOLID is a logical variable used to denote that the row in
C *** question is a Solid color (either solid white, or solid black).
C *** I used LSOLID as an aid in debugging. It is not very useful otherwise.
C *** LBLACK is a logical variable used to contain the current pixel color
C *** (.TRUE. represents black, while .FALSE. represents white).
C *** LIBLAK is a logical variable used to contain the first pixel color
C *** of the miniumum bounded box, which is needed later in an upper routine.
C ***
C *** ---------------------------------------------------------------
C *** ---------------------------------------------------------------
C ***
C ***
C ***
C ***
C ***
C ***
      IF(LTX05E.EQ..FALSE.) THEN
         CALL GRWARN('There will be 3 passes (scans) over the '
     2            //'graphics character...')
C ***    Find the minimum bounding box for the character. 
C ***    PGPLOT assumes that lower left corner of character is (0,0).
C ***    IXBXLL,IXBXUR,IYBXLL,IYBXUR  are in PGPLOT coordinates
C ***    in which (0,0) is lower left.
         CALL GRWARN('Starting scan number 1 --- Finding the minimal '
     2             //'bounding box around the graphics character.')
C ***    Initialize the last written percentage of the image remaining to be 
C ***    scanned to be 100%.
         IPERCL=100
C ***    Set up initial bounds for box to be outisde the bitmap area...
C ***    loop below will override these.
         IXBBUR=-1
         IXBXUR=-1
         IYBXUR=-1
         IXBBLL=(IBXDIM-1) + 1
         IXBXLL=(IBXDIM*8-1) + 1
         IYBXLL=(IBYDIM-1) + 1
         CALL GRWARN('Percentage of image scan remaining:')
         CALL GRWARN('      100% scan remaining ')
         DO 100, J=IBYDIM-1,0,-1
           DO 90, I=0, IBXDIM-1      
C ***      Write out a message about what percentage of the image remains
C ***      to be processed.
           IPERCR=INT(FLOAT(J)/FLOAT(IBYDIM-1)*100.0)
           IF (IPERCR.LT.(IPERCL-15)) THEN
              IPERCL=IPERCR
              WRITE(UNIT=MSG,FMT='(I3)') IPERCL
              CALL GRWARN('     '//MSG(1:3)//'% scan remaining ')
           ENDIF
C ***   
C ***   
           IF(BITMAP(I,J).NE.SOLWHT) THEN
C ***          We have a black pixel somewhere in that byte.
               IF(I.LE.IXBBLL) THEN 
                  IXBBLL = I
                  DO 50, K= IXBBLL*8,IXBBLL*8+7
                  IF(((BITMAP(K/8,J).AND.2**(7-MOD(K,8))).NE.WHITE)
     2              .AND.(K.LE.IXBXLL)) IXBXLL=K
50                CONTINUE 
               ENDIF
               IF(I.GE.IXBBUR) THEN
                  IXBBUR = I
                  DO 80, K=IXBBUR*8,IXBBUR*8+7
                  IF(((BITMAP(K/8,J).AND.2**(7-MOD(K,8))).NE.WHITE)
     2              .AND.(K.GE.IXBXUR)) IXBXUR=K
80                CONTINUE 
               ENDIF
               IF(J.LE.IYBXLL) IYBXLL = J
               IF(J.GE.IYBXUR) IYBXUR = J
             ENDIF
90         CONTINUE
100      CONTINUE
C ***   
C ***    Minimum bounding box has been found to be Lower_Left=(IXBXLL,IYBXLL)
C ***    Upper_Right=(IXBXUR,IYBXUR).  So, 0<=IXBXLL<=IXBXUR<=(IBXDIM-1)*8
C ***    and 0<=IYBXLL<=IYBXUR<=(IBYDIM-1).
C ***   
C ***    Add error checking...
         IF(IXBXUR.EQ.-1)  CALL GRQUIT('ERROR FINDING MINIMAL BOUNDING'
     2              //'BOX AROUND CHARACHTER.  THE IMAGE WAS OF SOLID'
     3              //'COLOR WHITE.   ROUTINE GRTX05.')
         IF(IYBXUR.EQ.-1)  CALL GRQUIT('ERROR FINDING MINIMAL BOUNDING'
     2              //'BOX AROUND CHARACHTER.  THE IMAGE WAS OF SOLID'
     3              //'COLOR WHITE.   ROUTINE GRTX05.')
         IF(IXBXLL.EQ.(IBXDIM*8-1) + 1)  CALL GRQUIT('ERROR FINDING '
     2              //'MINIMAL BOUNDING BOX AROUND CHARACHTER. '
     3              //'THE IMAGE WAS OF SOLID COLOR WHITE. '
     4              //'ROUTINE GRTX05.')
         IF(IYBXLL.EQ.(IBYDIM-1) + 1)  CALL GRQUIT('ERROR FINDING '
     2              //'MINIMAL BOUNDING BOX AROUND CHARACHTER. '
     3              //'THE IMAGE WAS OF SOLID COLOR WHITE. '
     4              //'ROUTINE GRTX05.')
         IF(IXBXLL.GT.IXBXUR) CALL GRQUIT('ERROR IN MINIMAL BOUNDING '
     2             //'BOX CALCULATIONS.  Lower row bounds exceeds '
     3             //'upper row bounds.  Routine GRTX05.')
         IF(IYBXLL.GT.IYBXUR) CALL GRQUIT('ERROR IN MINIMAL BOUNDING '
     2             //'BOX CALCULATIONS.  Lower column bounds exceeds '
     3             //'upper column bounds.  Routine GRTX05.')
         IF(IXBXLL.EQ.IXBXUR) CALL GRWARN('Lower bounds = Upper bounds '
     2             //'for minimal bounding box of character. '
     3             //' Routine GRTX05.')
         IF(IYBXLL.EQ.IYBXUR) CALL GRWARN('Lower bounds = Upper bounds '
     2             //'for minimal bounding box of character. '
     3             //' Routine GRTX05.')
      ENDIF
C *** ------------------------------------------------------------------
C *** ------------------------------------------------------------------
C *** 
      IF(LTX05E.EQ..FALSE.) THEN
         CALL GRWARN ('Minimal bounding box completed.')
         CALL GRWARN ('Starting scan number 2 -- determining '
     2         //'the amount of virtual memory needed for '
     3         //'RUN CODING the graphics character.')
      ELSE
         CALL GRWARN ('Starting scan number 3 -- calculating '
     2         //'and storing RUN CODE counts for  later encoding.')
C ***    Initialize the first repeat count index to be zero in case there
C ***    are not repeated non-solid rows in the graphics character.
C ***    Note:  IRPEAT must be dimensioned at least 1 in the calling routine.
         IRPEAT(1)=0
      ENDIF
C ***
C *** Set up the arrays to be indexed into their first element
      IRCIND=1
      IRPIND=1
C *** Set up the current position as the Upper Left corner of the
C *** minimum bounding box.
      ICOL=IXBXLL
      IROW=IYBXUR
C *** Set up the temporary position as the current position.
      ITMPRO=IROW
      ITMPCO=ICOL
C *** Initialize the Repeat count as 0 and the Run Code sum as 0.
      IRPCNT=0
      IRCSUM=0
C *** Set up the logical variables as all .FALSE.
      LSOLID=.FALSE.
      LBLACK=.FALSE.
      LIBLAK=.FALSE.
C *** Initialize the last written percentage of the image remaining to be 
C *** scanned to be 100%.
      IPERCL=100
C ***
C ***
C *** -----------------------------------------------------------------
C ***
C *** Determine what the color the initial pixel value is.
      IF((BITMAP(ICOL/8,IROW).AND.2**(7-MOD(ICOL,8))).NE.WHITE)THEN
        LBLACK=.TRUE.
        LIBLAK=.TRUE.
      ELSE
        LBLACK=.FALSE.
        LIBLAK=.FALSE.
      ENDIF 
      CALL GRWARN('Percentage of image scan remaining:')
      CALL GRWARN('     100% remaining ')
C ***
C ***
C *** ------------------------------------------------------------------
C *** BEGINNING_OF_ROW:
C ***
2000  CONTINUE
C ***
C ***
C ***
C ***   Write out a message about what percentage of the image remains
C ***   to be processed.
        IPERCR=INT(FLOAT(IROW-IYBXLL+1)/FLOAT(IYBXUR-IYBXLL+1)*100.0)
        IF (IPERCR.LT.(IPERCL-15)) THEN
           IPERCL=IPERCR
           WRITE(UNIT=MSG,FMT='(I3)') IPERCL
           CALL GRWARN('     '//MSG(1:3)//'% remaining ')
        ENDIF
C ***
C ***
C *** Let us check and see if the row is a solid of the current color.
C *** We will check the "leftover" bits on the left and right of the
C *** character first, then if they pass, we will check the bytes in between.
C *** Initialize LSOLID=.FALSE. so that "jump_out" to label 6000 will
C *** be correct if we do not have a solid row.
      LSOLID=.FALSE.
      ITMPRO=IROW
      ITMPCO=IXBXLL-1
2200  ITMPCO=ITMPCO+1
C *** If we are on an a byte boundary, we have finished checking the
C *** left "leftover" bits. Go check the right "leftover" bits.
      IF(MOD(ITMPCO,8).EQ.0) GOTO 2210
C *** See if the current pixel is the correct color for solid color row.
      IF(LBLACK.EQ..TRUE.) THEN
          IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2    .NE.WHITE) THEN
            GOTO 2200
          ELSE
            GOTO 6000
          ENDIF
      ELSE
          IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2    .EQ.WHITE) THEN
            GOTO 2200
          ELSE
            GOTO 6000
          ENDIF
      ENDIF
C ***
C ***
C ***
2210  CONTINUE
C ***
C *** Checking the right "leftover" bits now for solid color row.
      J=IROW
      I=IXBXUR+1
2220  I=I-1
C *** If we are on an a byte boundary, we have finished checking the
C *** right "leftover" bits. Go check the bytes in between.
      IF(MOD(I,8).EQ.7) GOTO 2240
C *** See if the current pixel is the correct color for solid color row.
      IF(LBLACK.EQ..TRUE.) THEN
          IF((BITMAP(I/8,J).AND.2**(7-MOD(I,8)))
     2    .NE.WHITE) THEN
            GOTO 2220
          ELSE       
            GOTO 6000
          ENDIF
      ELSE
          IF((BITMAP(I/8,J).AND.2**(7-MOD(I,8)))
     2    .EQ.WHITE) THEN
            GOTO 2220
          ELSE
            GOTO 6000
          ENDIF
      ENDIF
C ***
C ***
C ***
C ***
C ***
2240  CONTINUE
C ***
C *** Both the left and right "leftover" bits checked out to be solid 
C *** color of the current color type.  Now need to check the
C *** bytes in between to see if they are also solid color of the 
C *** current type.
      DO 2250, K=ITMPCO,I,8
        IF(LBLACK.EQ..TRUE.) THEN
            IF(BITMAP(K/8,J).NE.SOLBLK) GOTO 6000
        ELSE
            IF(BITMAP(K/8,J).NE.SOLWHT) GOTO 6000
        ENDIF
2250  CONTINUE
C ***
C *** We have a row which is of solid color.
      LSOLID=.TRUE.
C ***
C ***
C ***
C ***
C ***
C *** ---------------------------------------------------------------
C ***
C ***
C *** Calculate the # of consecutive rows which are repeats of the current
C *** row.  Set IRPCNT=#repeated_consecutive_rows.
C ***
      IRPCNT=0
2400  J=IROW-IRPCNT-1
C *** Need to make sure that we do not go out of the bounding box.
      IF(J.LT.IYBXLL) GOTO 8000
C *** Do a loop comparing the bytes across two rows.  Since the bits
C *** outside of the minimum bounding box are white (0), we do not
C *** have to worry about them -- they will compare okay.
C *** There are 8 bits to a byte, so there are 8 pixels to a byte.
C *** We can step by 8 pixels to do our check.
      DO 2420, I=IXBXLL, IXBXUR, 8
         IF(BITMAP(I/8,IROW).NE.BITMAP(I/8,J)) GOTO 2450
2420  CONTINUE
C *** We have found another repeated consecutive row.
      IRPCNT=IRPCNT+1
C *** Go back and check if the next row down is also a repeated row.
      GOTO 2400
C ***
C ***
C ***
C ***
2450  CONTINUE
C *** We have found all of the consecutive repeated rows.
C ***
C *** ------------------------------------------------------------------
C ***
C *** Need to determine whether a transition occurs at the first 
C *** pixel of the first non-repeated solid row.
      ITMPRO=IROW-IRPCNT-1
      ITMPCO=IXBXLL
        IF(LBLACK.EQ..TRUE.) THEN
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .NE.WHITE) GOTO 2800
        ELSE
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .EQ.WHITE) GOTO 2800
        ENDIF
C ***
C *** ----------------------------------------------------------------
C *** 
2500  CONTINUE
C ***
C ***
C *** We now have a solid (possibly repeated) row for which the
C *** first non-solid row has a transition at the first pixel of
C *** the minimum bounded box.
C ***
C *** Get the sum of the solid row pixels including the repeated solid
C *** row pixels.
      IRCSUM=IRCSUM+(IXBXUR-IXBXLL+1)*(1+IRPCNT)
C ***
C *** Store this sum for later Encoding.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C ***
C *** Update the current position.
      IROW=IROW-IRPCNT-1
      ICOL=IXBXLL
C ***
C *** Change current  color.
      LBLACK=.NOT.LBLACK
C *** 
C *** Reset the counters.
      IRCSUM=0
      IRPCNT=0
C ***
C *** We are now at the beginning of a new row.  GOTO BEGINING_OF_ROW.
      GOTO 2000
C ***
C *** -----------------------------------------------------------------
C ***
2800  CONTINUE
C ***
C ***
C *** We have a solid (possibly with repeat solid rows), which
C *** does not have a transition at the first non-solid row
C *** first pixel of the minimum bounding box.
C ***
C *** Get the sum of the pixels for the solid and solid repeated rows.
      IRCSUM=IRCSUM+(IXBXUR-IXBXLL+1)*(1+IRPCNT)
C ***
C *** Update the position to the beginning of the first non-solid row.
      IROW=IROW-IRPCNT-1
      ICOL=IXBXLL
C *** Find the transition point, (ITMPRO,ITMPCO).
      ITMPRO=IROW
      DO 2810, ITMPCO=IXBXLL+1,IXBXUR
        IF(LBLACK.EQ..TRUE.) THEN
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .EQ.WHITE) GOTO 2820
        ELSE
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .NE.WHITE) GOTO 2820
        ENDIF
2810  CONTINUE
C ***
2820  CONTINUE
C *** We now have ITMPRO, ITMPCO where the transition occurs.
C *** Add the number of pixels on the current row until the transition
C *** occurs to the previous calculated value for the solid (possibly
C *** repeated) rows.
      IRCSUM=IRCSUM+(ITMPCO-ICOL)
C *** Store this run code sum.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C *** Update the current position to be the point of transition.
      IROW=ITMPRO
      ICOL=ITMPCO
C *** Change the current color.
      LBLACK=.NOT.LBLACK
C *** Reset the counters.
      IRPCNT=0
      IRCSUM=0
C ***
C ***
C *** --------------------------------------------------------------
C ***
3000  CONTINUE
C ***
C *** MIDDLE_REPEAT:
C ***
C ***   We are now in the middle of a new row. There may or may not
C ***   be repeated consecutive rows below the current one.
C ***   Also, the remaining part of the current row may be solid.
C ***
C *** ---------------------------------------------------------------
C ***
C ***   Write out a message about what percentage of the image remains
C ***   to be processed.
        IPERCR=INT(FLOAT(IROW-IYBXLL+1)/FLOAT(IYBXUR-IYBXLL+1)*100.0)
        IF (IPERCR.LT.(IPERCL-15)) THEN
           IPERCL=IPERCR
           WRITE(UNIT=MSG,FMT='(I3)') IPERCL
           CALL GRWARN('     '//MSG(1:3)//'% remaining ')
        ENDIF
C ***
C ***
C *** ---------------------------------------------------------------
C ***
C *** Calculate the # of consecutive rows which are repeats of the current
C *** row.  Set IRPCNT=#repeated_consecutive_rows.
C ***
      IRPCNT=0
3100  J=IROW-IRPCNT-1
C *** Need to make sure that we do not go out of the bounding box.
      IF(J.LT.IYBXLL) GOTO 3200
C *** Do a loop comparing the bytes across two rows.  Since the bits
C *** outside of the minimum bounding box are white (0), we do not
C *** have to worry about them -- they will compare okay.
C *** There are 8 bits to a byte, so there are 8 pixels to a byte.
C *** We can step by 8 pixels to do our check.
      DO 3120, I=IXBXLL, IXBXUR, 8
         IF(BITMAP(I/8,IROW).NE.BITMAP(I/8,J)) GOTO 3150
3120  CONTINUE
C *** We have found another repeated consecutive row.
      IRPCNT=IRPCNT+1
C *** Go back and check if the next row down is also a repeated row.
      GOTO 3100
C ***
C ***
C ***
C ***
3150  CONTINUE
C *** We have found all of the consecutive repeated rows.
C ***
C *** ------------------------------------------------------------------
C ***
3200  CONTINUE
C ***
      IF(IRPCNT.GT.0) THEN
C ***    Store the repeat count for later Encoding.
         IF(LTX05E.EQ..TRUE.) IRPEAT(IRPIND)=IRCIND
         IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRPCNT
         IRPIND=IRPIND+1
         IRCIND=IRCIND+1
C ***    Update the current position to be the the row of the last
C ***    repeat count, and remain in the same column.
         IROW=IROW-IRPCNT
      ENDIF
C ***
C ***
C *** --------------------------------------------------------------------
C ***
4000  CONTINUE
C ***
C ***    MIDDLE_NO_REPEAT:
C ***
C ***
C ***   We are now located in the middle of a row, for which there
C ***   are definitely not any repeated rows immediately below.
C ***   There may, however, be that the remainder of the row is solid.
C ***
C ***
C ***  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C ***  Check for a transition on the current row.
C ***
C *** Find the transition point, (ITMPRO,ITMPCO).
      ITMPRO=IROW
      DO 4110, ITMPCO=ICOL,IXBXUR
        IF(LBLACK.EQ..TRUE.) THEN
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .EQ.WHITE) GOTO 4120
        ELSE
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .NE.WHITE) GOTO 4120
        ENDIF
4110  CONTINUE
C *** We did not have a transition on the current row.
C *** Goto NO_TRANS_CURRENT_ROW.
      GOTO 4500
C ***
4120  CONTINUE
C *** We did have a transition on the current row.
C ***
C *** Calculate the sum of pixels up to the transition.
      IRCSUM=IRCSUM+(ITMPCO-ICOL)
C *** Store out the resulting pixel RUN CODE sum count.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C *** Update the current position to be the point of transition.
      IROW=ITMPRO
      ICOL=ITMPCO
C *** Change the current color.
      LBLACK=.NOT.LBLACK
C *** Reset the counters.
      IRPCNT=0
      IRCSUM=0
C ***
C *** We are still in the middle of a row, for which there is no
C *** repeat count, and for which the remainder of the row may
C *** be of solid color.  GOTO MIDDLE_NO_REPEAT.
      GOTO 4000
C ***
C *** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C ***
4500  CONTINUE
C ***
C ***
C ***  We are now in the middle of a row for which
C *** there are no repeat counts, but the remainder of the row
C *** is of solid color.
C *** 
C *** Need check if we are on the last row of the minimal bounding
C *** box for the character.
      IF(IROW.EQ.IYBXLL) GOTO 8100
C ***
C *** Need to check for a transition at the first pixel of the
C *** next row of the minimal bounding box of the character.
        ITMPRO=IROW-1
        ITMPCO=IXBXLL
        IF(LBLACK.EQ..TRUE.) THEN
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .NE.WHITE) GOTO 4700
        ELSE
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .EQ.WHITE) GOTO 4700
        ENDIF
C ***
C *** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C *** 
C *** We are on the middle of a row for which there are no
C *** repeated rows immediately following, and for which the
C *** remainder of the row is of solid color and for which
C *** the first pixel on the next row of the minimal bounding
C *** box of the character changes color (a transition occurs).
C ***
C *** Need to calculate the remaining pixels out to the end of the
C *** current row.
      IRCSUM=IRCSUM+(IXBXUR-ICOL+1)
C *** Store this for later Encoding.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C *** Update the current position to be the first pixel on the next line.
      ICOL=IXBXLL
      IROW=IROW-1
C *** Change colors.
      LBLACK=.NOT.LBLACK
C *** Reset the counters.
      IRCSUM=0
      IRPCNT=0
C ***
C *** We are now at the beginning of a new row.
C *** GOTO BEGINNING_OF_ROW.
      GOTO 2000
C ***
C *** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C ***
4700  CONTINUE
C ***
C *** We are now in the middle of a row for which there are definitely
C *** no repeated rows immediately following, and for which the 
C *** remainder of the row is of solid color, and for which the first
C *** pixel of the next row of the minimal bounding box for the 
C *** character does not change color (no transition).
C ***
C *** Add up the pixels remaining on the end of the current row.
      IRCSUM=IRCSUM+(IXBXUR-ICOL+1)
C *** Update the current position to be the first pixel on the 
C *** next row.
      IROW=IROW-1
      ICOL=IXBXLL
C ***
C *** 
C *** ----------------------------------------------------------
C ***
C *** Need to check and see if the current row is of solid color
C *** or not.
C *** We will check the "leftover" bits on the left and right of the
C *** character first, then if they pass, we will check the bytes in between.
C *** Initialize LSOLID=.FALSE. so that "jump_out" to label 5000 will
C *** be correct if we do not have a solid row.
      LSOLID=.FALSE.
      ITMPRO=IROW
      ITMPCO=IXBXLL-1
4705  ITMPCO=ITMPCO+1
C *** If we are on an a byte boundary, we have finished checking the
C *** left "leftover" bits. Go check the right "leftover" bits.
      IF(MOD(ITMPCO,8).EQ.0) GOTO 4710
C *** See if the current pixel is the correct color for solid color row.
      IF(LBLACK.EQ..TRUE.) THEN
          IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2    .NE.WHITE) THEN
            GOTO 4705
          ELSE
            GOTO 5000
          ENDIF
      ELSE
          IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2    .EQ.WHITE) THEN
            GOTO 4705
          ELSE
            GOTO 5000
          ENDIF
      ENDIF
C ***
C ***
C ***
4710  CONTINUE
C ***
C *** Checking the right "leftover" bits now for solid color row.
      J=IROW
      I=IXBXUR+1
4720  I=I-1
C *** If we are on an a byte boundary, we have finished checking the
C *** right "leftover" bits. Go check the bytes in between.
      IF(MOD(I,8).EQ.7) GOTO 4740
C *** See if the current pixel is the correct color for solid color row.
      IF(LBLACK.EQ..TRUE.) THEN
          IF((BITMAP(I/8,J).AND.2**(7-MOD(I,8)))
     2    .NE.WHITE) THEN
            GOTO 4720
          ELSE       
            GOTO 5000
          ENDIF
      ELSE
          IF((BITMAP(I/8,J).AND.2**(7-MOD(I,8)))
     2    .EQ.WHITE) THEN
            GOTO 4720
          ELSE
            GOTO 5000
          ENDIF
      ENDIF
C ***
C ***
C ***
C ***
C ***
4740  CONTINUE
C ***
C *** Both the left and right "leftover" bits checked out to be solid 
C *** color of the current color type.  Now need to check the
C *** bytes in between to see if they are also solid color of the 
C *** current type.  If it is not solid, we will go to the label 
C *** 5000 for processing, otherwise we will continue processing
C *** below.
      DO 4750, K=ITMPCO,I,8
        IF(LBLACK.EQ..TRUE.) THEN
            IF(BITMAP(K/8,J).NE.SOLBLK) GOTO 5000
        ELSE
            IF(BITMAP(K/8,J).NE.SOLWHT) GOTO 5000
        ENDIF
4750  CONTINUE
C ***
C *** We have a row which is of solid color.
      LSOLID=.TRUE.
C ***
C ***
C ***
C ***
C ***
C *** ---------------------------------------------------------------
C ***
C ***
C *** Calculate the # of consecutive rows which are repeats of the current
C *** row.  Set IRPCNT=#repeated_consecutive_rows.
C ***
      IRPCNT=0
4800  J=IROW-IRPCNT-1
C *** Need to make sure that we do not go out of the bounding box.
      IF(J.LT.IYBXLL) GOTO 8200
C *** Do a loop comparing the bytes across two rows.  Since the bits
C *** outside of the minimum bounding box are white (0), we do not
C *** have to worry about them -- they will compare okay.
C *** There are 8 bits to a byte, so there are 8 pixels to a byte.
C *** We can step by 8 pixels to do our check.
      DO 4820, I=IXBXLL, IXBXUR, 8
         IF(BITMAP(I/8,IROW).NE.BITMAP(I/8,J)) GOTO 4850
4820  CONTINUE
C *** We have found another repeated consecutive row.
      IRPCNT=IRPCNT+1
C *** Go back and check if the next row down is also a repeated row.
      GOTO 4800
C ***
C ***
C ***
C ***
4850  CONTINUE
C *** We have found all of the consecutive repeated rows.
C ***
C *** ------------------------------------------------------------------
C *** Add up the sum of pixels on the (possibly repeated) solid rows
C *** and add this result to any earlier sum (for the row which
C *** had the last part of it solid).
      IRCSUM=IRCSUM+ (IXBXUR-IXBXLL+1)*(IRPCNT+1)
C *** Update the cursor position to be the first pixel on the next 
C *** non-solid row below.
      IROW=IROW-IRPCNT-1
      ICOL=IXBXLL
C *** ------------------------------------------------------------------
C ***
C *** Need to determine whether a transition occurs at the first 
C *** pixel of the first non-repeated solid row. If a transition does
C *** not occur, goto label 4900, otherwise continue below.
      ITMPRO=IROW
      ITMPCO=IXBXLL
        IF(LBLACK.EQ..TRUE.) THEN
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .NE.WHITE) GOTO 4900
        ELSE
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .EQ.WHITE) GOTO 4900
        ENDIF
C ***
C *** ----------------------------------------------------------------
C *** 
C *** There is a transition at the first pixel of the minimum bounding
C *** box for this first non-solid row.
C ***
C *** Write out the RUN CODE sum count for later Encoding.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C *** Change color.
      LBLACK=.NOT.LBLACK
C *** Reset counters.
      IRPCNT=0
      IRCSUM=0
C ***
C *** We are now on the beginning of a new row.
C *** GOTO BEGINNING_OR_ROW.  
      GOTO 2000
C ***
C *** ------------------------------------------------------------------------
C ***
4900  CONTINUE
C ***
C *** There is not a transition at the first pixel of the minimum bounding
C *** box for this first non-solid row.  We are located at this first pixel
C *** of this non-solid row.
C *** Find the location of the transition on this current row.
C *** Find the transition point, (ITMPRO,ITMPCO).
      ITMPRO=IROW
      DO 4910, ITMPCO=IXBXLL+1,IXBXUR
        IF(LBLACK.EQ..TRUE.) THEN
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .EQ.WHITE) GOTO 4920
        ELSE
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .NE.WHITE) GOTO 4920
        ENDIF
4910  CONTINUE
C ***
4920  CONTINUE
C *** We now have ITMPRO, ITMPCO where the transition occurs.
C *** Calculate the sum of the pixels up to the transition on this row,
C *** and add this result to the earlier sum of solid (possibly repeated)
C *** rows and the row which had the remaining end pixels to be of solid
C *** color.
      IRCSUM=IRCSUM+(ITMPCO-IXBXLL)
C *** Write out this RUN CODE sum count for later Encoding.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C *** Update position to the transition location.
C *** IROW=ITMPRO  We are still on the same row.
      ICOL=ITMPCO
C *** Change colors.
      LBLACK=.NOT.LBLACK
C *** Reset counters.
      IRPCNT=0
      IRCSUM=0
C ***
C *** We are now in the middle of a row, which may have possible repeats
C *** and which may have the remainder of the row being a solid color
C *** of the current type.  GOTO MIDDLE_REPEAT.
      GOTO 3000
C ***
C *** -------------------------------------------------------------------
C ***
5000  CONTINUE
C ***
C ***   We are on a row, for which the previous row had the remaining
C ***   pixels on that row to be of solid color.  We did not have 
C ***   a transition at the first pixel of this row, and this row
C ***   is not of solid color.  We are located at the first pixel
C ***   on this non-solid row.
C ***
C *** Locate the transition on this current row.
C *** Find the transition point, (ITMPRO,ITMPCO).
      ITMPRO=IROW
      DO 5010, ITMPCO=IXBXLL+1,IXBXUR
        IF(LBLACK.EQ..TRUE.) THEN
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .EQ.WHITE) GOTO 5020
        ELSE
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .NE.WHITE) GOTO 5020
        ENDIF
5010  CONTINUE
C ***
5020  CONTINUE
C *** We now have ITMPRO, ITMPCO where the transition occurs.
C *** Add up the sum of the pixels up to the transition with the
C *** earlier sum for the previous row which had the pixels at the end
C *** to be of solid color.
      IRCSUM=IRCSUM + (ITMPCO-IXBXLL)
C *** Store this RUN CODE sum count for later Encoding.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C *** Update the current position to be the point of transition.
C *** IROW=ITMPRO   It is on the same row.
      ICOL=ITMPCO
C *** Change colors.
      LBLACK=.NOT.LBLACK
C *** Reset counters.
      IRCSUM=0
      IRPCNT=0
C ***
C *** We are now in the middle of a row, for which there may be
C *** possible repeats, and for which the remainder of this row
C *** may be of solid color.  GOTO MIDDLE_REPEAT.
      GOTO 3000
C ***
C *** --------------------------------------------------------------------
C ***
6000  CONTINUE
C ***
C ***  NOT SOLID BEGINNING_OF_ROW PROCESSING CONTINUED
C ***
C *** 
C *** ---------------------------------------------------------------
C ***
C ***
C *** Calculate the # of consecutive rows which are repeats of the current
C *** row.  Set IRPCNT=#repeated_consecutive_rows.
C ***
      IRPCNT=0
6100  J=IROW-IRPCNT-1
C *** Need to make sure that we do not go out of the bounding box.
      IF(J.LT.IYBXLL) GOTO 6200
C *** Do a loop comparing the bytes across two rows.  Since the bits
C *** outside of the minimum bounding box are white (0), we do not
C *** have to worry about them -- they will compare okay.
C *** There are 8 bits to a byte, so there are 8 pixels to a byte.
C *** We can step by 8 pixels to do our check.
      DO 6120, I=IXBXLL, IXBXUR, 8
         IF(BITMAP(I/8,IROW).NE.BITMAP(I/8,J)) GOTO 6150
6120  CONTINUE
C *** We have found another repeated consecutive row.
      IRPCNT=IRPCNT+1
C *** Go back and check if the next row down is also a repeated row.
      GOTO 6100
C ***
C ***
C ***
C ***
6150  CONTINUE
C *** We have found all of the consecutive repeated rows.
C ***
C *** ------------------------------------------------------------------
6200  CONTINUE
C ***
      IF(IRPCNT.GT.0) THEN
C ***    Store the repeat count for later Encoding
C ***    and update the current position to be the last repeated row,
C ***    and reset the repeat counter.
         IF(LTX05E.EQ..TRUE.) IRPEAT(IRPIND)=IRCIND
         IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRPCNT
         IRPIND=IRPIND+1
         IRCIND=IRCIND+1
         IROW=IROW-IRPCNT
         IRPCNT=0
      ENDIF
C ***
C *** Locate the transition on this current row.
C *** Find the transition point, (ITMPRO,ITMPCO).
      ITMPRO=IROW
      DO 6210, ITMPCO=IXBXLL+1,IXBXUR
        IF(LBLACK.EQ..TRUE.) THEN
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .EQ.WHITE) GOTO 6220
        ELSE
            IF((BITMAP(ITMPCO/8,ITMPRO).AND.2**(7-MOD(ITMPCO,8)))
     2      .NE.WHITE) GOTO 6220
        ENDIF
6210  CONTINUE
C ***
6220  CONTINUE
C *** We now have ITMPRO, ITMPCO where the transition occurs.
C *** Add up the sum of the pixels up to the transition.
      IRCSUM=IRCSUM + (ITMPCO-IXBXLL)
C *** Store this RUN CODE sum count for later Encoding.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C *** Update the current position to be the point of transition.
C *** IROW=ITMPRO   It is on the same row.
      ICOL=ITMPCO
C *** Change colors.
      LBLACK=.NOT.LBLACK
C *** Reset counters.
      IRCSUM=0
      IRPCNT=0
C ***
C ***  We are now in the middle of a row for which there are
C ***  no repeated rows immediately following, and for which the
C ***  remainder of the row may be of solid color.
C ***  GOTO MIDDLE_NO_REPEAT.
       GOTO 4000
C ***
C *** -----------------------------------------------------------------
C ***
8000  CONTINUE 
C ***
C ***  LAST ROW OF CHARACTER PROCESSING for BEGINNING_OF_ROW SOLID last row.
C ***
C ***  Add up the pixels of all of the solid (possibly repeated) rows
C ***  immediately above this last row which is solid.
       IRCSUM=IRCSUM+(IXBXUR-IXBXLL+1)*(IRPCNT+1)
C ***  Store this RUN CODE sum count for later Encoding.
       IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
       IRCIND=IRCIND+1
C ***  Update position, change color, reset counters, and exit.
       IROW=IROW-IRPCNT-1
       ICOL=IXBXLL
       ITMPRO=IROW
       ITMPCO=ICOL
       LBLACK=.NOT.LBLACK
       IRCSUM=0
       IRPCNT=0
       GOTO 9000
C ***
C *** ----------------------------------------------------------------------
C ***
8100  CONTINUE
C ***
C ***
C ***
C *** LAST ROW OF CHARACTER PROCESSING for a row which has the last pixels
C *** on the row of solid color, but the whole row is not solid.
C ***
C *** Sum up the pixels remaining on this row.
      IRCSUM=IRCSUM+(IXBXUR-ICOL+1)
C *** Store this RUN CODE sum count for later Encoding.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C *** Update position, change color, reset counters, and exit.
      IROW=IROW-1
      ICOL=IXBXLL
      ITMPRO=IROW
      ITMPCO=ICOL
      LBLACK=.NOT.LBLACK
      IRPCNT=0
      IRCSUM=0
      GOTO 9000
C ***
C *** ------------------------------------------------------------------
C ***
8200  CONTINUE 
C ***
C ***
C ***  LAST ROW OF CHARACTER PROCESSING for a row which is solid
C ***  and may have had repeated solid rows above it and which
C ***  definitely had a row above it for which the last pixels on 
C ***  the end of the row were of solid color of the current color.
C ***
C *** Add up all of the pixels on the solid and solid repeated rows
C *** and add the earlier pixel count for the partially solid row.
      IRCSUM=IRCSUM + (IXBXUR-IXBXLL+1)*(IRPCNT+1) 
C *** Store this RUN CODE sum count for later Encoding.
      IF(LTX05E.EQ..TRUE.) IRUNCD(IRCIND)=IRCSUM
      IRCIND=IRCIND+1
C *** Update the position, change color, reset counters, and exit.
      IROW=IROW-IRPCNT-1
      ICOL=IXBXLL
      ITMPRO=IROW
      ITMPCO=ICOL
      LBLACK=.NOT.LBLACK
      IRPCNT=0
      IRCSUM=0
      GOTO 9000
C ***
C *** --------------------------------------------------------------------
C *** -------------------------------------------------------------------
C ***
9000  CONTINUE
C ***
C ***
C *** Finished. Exiting.
C ***
C ***
C ***
C *** 
C------------------------------------------------------------------------
      RETURN
      END
C<FF>
C *GRTX06 -- PGPLOT Calculate optimal value of dyn_f.
C
      SUBROUTINE GRTX06 (IRUNCD,IRCDIM,IBOXDX,IBOXDY,IDYNF,
     2                   IRPEAT,IRPDIM,BITMAP,IBXDIM,IBYDIM)
C-----------------------------------------------------------------
C ***
C *** -------------------------------------------------------------
C *** This routine is used to find the optimal value of dyn_f
C *** for encoding the RUN CODE for the current PK Font character.
C *** Documentation for the algorithm is found in the files PKtoPX.WEB,
C *** PXtoPK.WEB, PKtype.WEB, and GFtoPK.WEB.  To obtain this 
C *** documentation, WEAVE the WEB file, then TeX the output, then
C *** use a dvi-translator the translate the DVI file into a binary
C *** file suitable for output to your specific printer.
C *** The PK format was designed by Tomas Rokicki in August, 1985.
C *** Rokicki was a former Texas A&M Univerisity student.
C ***
C *** IRUNCD is an integer input array of dimension IRCDIM which contains
C *** the RUN CODE for the current character.
C *** IRCDIM is an integer input giving the dimension of the IRUNCD array.
C *** IBOXDX is an integer input giving the X-direction size of the minimum
C *** bounding box of the character.
C *** IBOXDY is an integer input giving the Y-direction size of the minimum
C *** bounding box of the character.
C *** IDYNF is an integer output array of dimension 15 giving the
C *** calculated value of dyn_f=(0,13) and the BITMAP encoding (14)
C *** upon return from this routine. 
C *** BITMAP is a byte array of size IBXDIM x IBYDIM containing the
C *** Bitmap of the character.
C *** IBXDIM is an integer giving the X-dimension of the array BITMAP.
C *** IBYDIM is an integer giving the Y-dimension of the array BITMAP.
C *** IRPIND is an integer used to index into the IRPEAT array.
C *** IRPEAT is an integer array of size IRPDIM which contains indexes
C *** into the IRUNCD array pointing to Repeat codes in the RUN CODE
C *** for the character.
C *** IRPDIM is an integer giving the dimension of the array IRPEAT.
C *** I, J  are temporary integer variables used for counting and
C *** for DO-loop indices.
C ***
C *** ----------------------------------------------------------------
C ***
C ***
C ***
C ***
      IMPLICIT NONE
      INTEGER IRCDIM, IRPDIM, IBXDIM, IBYDIM, IBOXDX, I, J
      INTEGER IBOXDY, IRUNCD(IRCDIM), IRPEAT(IRPDIM), IRPIND
      BYTE BITMAP(0:IBXDIM-1,0:IBYDIM-1)
      INTEGER IDYNF(0:14),IVALUE(0:13,3)
C ***
C *** --------------------------------------------------------------
C *** Store data values used for comparisons below.
      DO 50, I=0,13
C ***   One nybble values are
C ***   values from 1 to dyn_f.  IVALUE(I,1) contains dyn_f=I.
        IVALUE(I,1)=I
C ***   Two nybble values are
C ***   values from dyn_f+1 to (13-dynf)*16+dynf .
        IVALUE(I,2)=(13-I)*16+I
C ***   Three nybble and larger #nybbles are
C ***   values from (13-dyn_f)*16+dyn_f up.
        IVALUE(I,3)=16-((13-I)*16+I+1)
50    CONTINUE
C ***
C *** --------------------------------------------------------------
C ***
C *** Initialize the IDYNF array to zero (will be used to keep running
C *** sums.
      DO 60, I=0,14
         IDYNF(I)=0
60    CONTINUE
C ***
C ***
C ***
C *** ----------------------------------------------------------------
C ***
C *** First, calculate the length required for the bitmap packing.
C *** In bitmap packing, the minimal bounded box pixels are all
C *** concatenated into one long string by concatenating rows, then
C *** the bitmap string is packed 8 bits into a byte, each pixel
C *** representing one bit in a byte.
C ***
C *** Note: 7/8=0 in integer arithmetic is used to round up the
C *** extra bits over a byte at the end of the bitmapping up to
C *** an even byte boundary.  Also, there are 2 nybbles per byte.
C *** So, IDYNF(14) will be the count in nybbles require for compressed
C *** raw bitmapping.
      IDYNF(14)= (IBOXDX*IBOXDY+7)/8*2
C ***
C ***
C *** -----------------------------------------------------------------
C *** 
C *** Now calculate the length required for ENCODing the minimum bounded
C *** box RUN CODE for different values of dyn_f=[0,13].
C ***
      DO 3000, J=0,13
C *** Calculate the length required for dyn_f=J ENCODing.
      IRPIND=1
      DO 1000, I=1,IRCDIM
C ***    Check and see if the current RUN CODE value is a repeat code.
         IF(IRPIND.LE.IRPDIM) THEN
           IF(I.EQ.IRPEAT(IRPIND)) THEN
C ***        It is a repeat value.
C ***        Increment the Repeat Code index to point to the next repeat value.
             IRPIND=IRPIND+1.
C ***        We use the nybble value 14 to signify a repeat count value > 1,
C ***        and use the nybble value 15 to signify a repeat count value = 1,
C ***        then follows immediately the packed number representation
C ***        of the repeat value.  For the signaling nybble (14, or 15),
C ***        we require 1 nybble.
             IDYNF(J)=IDYNF(J)+1
C ***        If the repeat count is 1, then only the nybble value 15 is
C ***        required.  We do not have to encode the packed number also.
             IF(IRUNCD(I).EQ.1) GOTO 1000
C ***
C ***        Now, we will calculate the number of nybbles required for the
C ***        packed number representation of the repeat count value below
C ***        (where all packed number representation nybble requirements
C ***        are determined --- repeat counts, white counts, or black counts).
           ENDIF
         ENDIF
C ***
C ***     Calculate the number of nybbles required for the packed number
C ***     representation.
C ***
C ***     First, check for the one nybble packed number representation of
C ***     the value.
          IF(IRUNCD(I).LE.IVALUE(J,1)) THEN
C ***        Note: The special case J=0 will not occur. A value of
C ***        zero for IRUNCD(I) signifies the end of the RUN CODE array
C ***        and was checked for above.
             IDYNF(J)=IDYNF(J)+1
             GOTO 1000
          ENDIF
C ***
C ***     Second, check for the two nybble packed number representation of
C ***     the value.
          IF(IRUNCD(I).LE.IVALUE(J,2)) THEN
C ***        Note: J=13 will have been caught in the 1 nybble case above
C ***        so we do not have to worry about that special case.
             IDYNF(J)=IDYNF(J)+2
             GOTO 1000
          ENDIF
C ***
C ***     Lastly, calculate the number of nybbles required for the
C ***     large (3 or more) nybble representation of the value.
          IDYNF(J)=IDYNF(J)+(INT((LOG(
     2             FLOAT(IRUNCD(I)+IVALUE(J,3)))
     2             /LOG(16.0) + 1 ))*2 -1)
C ***
1000  CONTINUE
2000  CONTINUE
3000  CONTINUE       
C ***
C ***
C *** -------------------------------------------------------------
C *** Finished.  Return with the results.
C ***
      RETURN
      END
C<FF>
C *GRTX07 -- PGPLOT Compress the raw bitmap and DUMP encode.
C
      SUBROUTINE GRTX07 (BITMAP,IBXDIM,IBYDIM,BENCOD,IBEDIM,
     2                   IXBXLL,IYBXLL,IXBXUR,IYBXUR)
C-------------------------------------------------------------------
C ***
C ***
C *** ----------------------------------------------------------------
C *** This routine is used to encode the BITMAP into a PK Font
C *** by concatenating all of the rows inside of the character
C *** into a single row, and storing each pixel as a 1-to-1 mapping
C *** into the output array bits.  One pixel is one bit in one of
C *** the output array bytes.
C ***
C *** BITMAP is the byte input array of dimension IBXDIM x IBYDIM
C *** containing the input PK Font character.
C *** IBXDIM is an integer providing the X-dimension of the BITMAP array.
C *** IBYDIM is an integer providing the Y-dimension of the BITMAP array.
C *** BENCOD is the integer array of dimension IBEDIM, which upon output
C *** will contain the ENCODEd BITMAP.
C *** IBEDIM is an integer providing the dimension of BENCOD.
C *** IXBXLL is an integer specifying the X-coordinate in pixel units
C *** of the lower left corner of the minimum bounding box of the 
C *** PK Font character.
C *** IYBXLL is an integer specifying the Y-coordinate in pixel units
C *** of the lower left corner of the minimum bounding box of the 
C *** PK Font character.
C *** IXBXUR is an integer specifying the X-coordinate in pixel units
C *** of the upper right corner of the minimum bounding box of the 
C *** PK Font character.
C *** IYBXUR is an integer specifying the Y-coordinate in pixel units
C *** of the  upper right of the minimum bounding box of the 
C *** PK Font character.
C *** IBEIND is an integer variable, which upon output will contain
C *** the number of bytes used of the array BECOD. IBEIND is used
c *** as an index into the IBEIND array.
C *** I, J are temporary integer variables used for counting and
C *** and for DO-loop indices.
C ***
C ***
C *** ----------------------------------------------------------------
C ***
      IMPLICIT NONE
      INTEGER IBXDIM, IBYDIM, IBEDIM, IXBXLL, IYBXLL
      INTEGER IXBXUR, IYBXUR, IBEIND, I, J
      BYTE BITMAP(0:IBXDIM-1,0:IBYDIM-1)
      INTEGER BENCOD(0:IBEDIM-1)
C ***
C ***
C *** ----------------------------------------------------------------
C ***
C ***
C ***      Initialize the variables.
C ***  
      IBEIND=0 
      DO 100, I=0, IBEDIM-1
         BENCOD(I)=0
100   CONTINUE     
C ***
C ***
C *** ----------------------------------------------------------------
C ***
C ***
C ***   Do the encoding by "ORing" the current output byte (BENCOD(IBEIND/8))
C ***   with the value of the current input pixel (the IF statement) -- will 
C ***   be the value 0 or non-zero --  and then multiplying the 
C ***   value of the current pixel with the current output bit
C ***   position (assignment statement) -- which will be 2**7,...,2*0 according
C ***   to where you are within the current output byte}.
C ***   Note: it has been assumed that the bits are arranged from
C ***   left to right inside a byte as bit 7 (2**7), bit 6 (2**6),
C ***   ..., bit 1 (2**1), bit 0 (2**0), and that we traverse the
C ***   bitmap from left to right in increasing byte order ----
C ***   If this is not true, then this routine must be modified. 
C ***   I used BENCOD as an integer and '+' to implement the ".OR."ing.
        DO 300, J=IYBXUR, IYBXLL, -1
          DO 200, I=IXBXLL, IXBXUR
            IF((BITMAP(I/8,J).AND.(2**(7-MOD(I,8)))).NE.0)THEN
              BENCOD(IBEIND/8)=BENCOD(IBEIND/8) + 
     2        (2**(7-MOD(IBEIND,8)))
            ENDIF
            IBEIND=IBEIND+1
200      CONTINUE
300    CONTINUE
C ***
C ***
C ***
C ***
C *** -------------------------------------------------------------------
C *** Note: We do not have to worry about finishing packing the last
C *** byte, since we zeroed out the array initially.  The last byte will
C *** have zeros as the last bits.
C ***
C *** ------------------------------------------------------------------
C ***
C *** Now, we let's do a sanity check to make sure that I did not have
C *** a programming error which went out of bounds on the BENCOD array.
C ***
      IF(IBEIND.GT.IBEDIM*8) THEN
         CALL GRWARN('Exceeded the array dimension bounds of'
     2     //' the array BENCOD.')
         CALL GRWARN('This routine was calculating the '
     2     //'ENCODEing of the BITMAP.')
         CALL GRWARN('This should never happen. This is a' 
     2     //' programming error in this routine.')
      ENDIF
C ***
C ***
C *** ----------------------------------------------------------------
C ***
C *** Finished.  Let's return.
C ***
C ***
      RETURN
      END
C<FF>
C *GRTX08 -- PGPLOT ENCODE the RUN CODE count using optimal dyn_f.
C
      SUBROUTINE GRTX08(IRUNCD,IRCDIM,IDYNF,IRPEAT,IRPDIM,
     2                   BENCOD,IBEDIM)
C-----------------------------------------------------------------
C ***
C *** -------------------------------------------------------------
C *** This routine is used to encode the current PK Font character
C *** using the optimal dyn_f value which was calculated earlier.
C *** Documentation for the algorithm is found in the files PKtoPX.WEB,
C *** PXtoPK.WEB, PKtype.WEB, and GFtoPK.WEB.  To obtain this 
C *** documentation, WEAVE the WEB file, then TeX the output, then
C *** use a dvi-translator the translate the DVI file into a binary
C *** file suitable for output to your specific printer.
C *** The PK format was designed by Tomas Rokicki in August, 1985.
C *** Rokicki was a former Texas A&M Univerisity student.
C ***
C *** IRUNCD is an integer input array of dimension IRCDIM which contains
C *** the RUN CODE for the current character.
C *** IRCDIM is an integer input giving the dimension of the IRUNCD array.
C *** IDYNF is an integer containing the optimal value of dyn_f which 
C *** was calculated earlier. dynf=[0,13].
C *** IRPIND is an integer used to index into the IRPEAT array.
C *** IRPEAT is an integer array of size IRPDIM which contains indexes
C *** into the IRUNCD array pointing to Repeat codes in the RUN CODE
C *** for the character.
C *** IRPDIM is an integer giving the dimension of the array IRPEAT.
C *** BENCOD is an integer array of dimension IBEDIM which upon output
C *** is to contain the ENCODEd value of the RUN CODE for the current
C *** PK Font character.
C *** IBEDIM is an integer giving the dimension of the array BENCOD.
C *** IBEIND is an integer used to index into the array BENCOD
C *** by indexing using  IBEIND/2.
C *** ITMPL is used as a temporary integer variable for the number of
C *** nybbles required in part of the Large Packed number representation 
C *** calcluations.
C *** ITMP1 is a temporary integer variable used in calculations
C *** for the Large Packed number representation, and the 2 nybble
C *** representation of the ENCODEd RUN CODE for the current Font character.
C *** ITMP2 is a temporary integer variable used in calculations
C *** for the Large Packed number representation, and the 2 nybble
C *** representation of the ENCODEd RUN CODE for the current Font character. 
C *** I, K are temporary integer variables used for counting and
C *** do-loop indices.
C *** ----------------------------------------------------------------
C ***
C ***
C ***
C ***
      IMPLICIT NONE
      INTEGER IRCDIM, IRPDIM, IBEDIM, IDYNF, I, K
      INTEGER IRUNCD(IRCDIM), IRPEAT(IRPDIM), IRPIND, IBEIND
      INTEGER ITMPL, ITMP1, ITMP2, I1NYBL, I2NYBL, ILNYBL
      INTEGER BENCOD(0:IBEDIM-1)
C ***
C *** --------------------------------------------------------------
C *** Calculate data values used for comparisons below.
C ***   One nybble values are
C ***   values from 1 to dyn_f.  I1NYBL contains dyn_f=IDYNF.
        I1NYBL=IDYNF
C ***   Two nybble values are
C ***   values from dyn_f+1 to (13-dynf)*16+dynf .
        I2NYBL=(13-IDYNF)*16+IDYNF
C ***   Three nybble and larger #nybbles are
C ***   values from (13-dyn_f)*16+dyn_f up.
        ILNYBL=16-((13-IDYNF)*16+IDYNF+1)
C ***
C *** --------------------------------------------------------------
C ***
C *** Initialize the BENCOD array to zero.
      DO 60, I=0,IBEDIM-1
         BENCOD(I)=0
60    CONTINUE
C ***
C ***
C ***
C *** ----------------------------------------------------------------
C *** 
C *** Now calculate the ENCODEd RUN CODE for the minimum bounded
C *** box using the optimal value dyn_f.
C ***
      IBEIND=0
      IRPIND=1
      DO 1000, I=1,IRCDIM
        IF(IRPIND.LE.IRPDIM) THEN
C ***      Check and see if the current RUN CODE value is a repeat code.
           IF(I.EQ.IRPEAT(IRPIND)) THEN
C ***        It is a repeat value.
C ***        Increment the Repeat Code index to point to the next repeat value.
             IRPIND=IRPIND+1.
C ***        We use the nybble value 14 to signify a repeat count value > 1,
C ***        and use the nybble value 15 to signify a repeat count value = 1,
C ***        then follows immediately the packed number representation
C ***        of the repeat value.  For the signaling nybble (14, or 15),
C ***        we require 1 nybble.
C ***        If the repeat count is 1, then only the nybble value 15 is
C ***        required.  We do not have to encode the packed number also.
             IF(IRUNCD(I).EQ.1) THEN
               BENCOD(IBEIND/2)=BENCOD(IBEIND/2) + 
     2              (15*16*MOD(IBEIND+1,2) + 15*MOD(IBEIND,2))
               IBEIND=IBEIND+1
               GOTO 1000
             ELSE
C ***          However, if the repeat count was greater than 1, we have
C ***          to encode the nybble value 14 and then follow with the
C ***          packed number representation of the Repeat Count.
               BENCOD(IBEIND/2)=BENCOD(IBEIND/2) + 
     2              (14*16*MOD(IBEIND+1,2) + 14*MOD(IBEIND,2))
               IBEIND=IBEIND+1
             ENDIF
C ***
C ***        Now, we will calculate the packed number representation
C ***        of the repeat count value below (where all packed number
C ***        representations are determined --- repeat counts,
C ***        white pixel counts, or black pixel counts).
           ENDIF
         ENDIF
C ***
C ***     Calculate the number of nybbles required for the packed number
C ***     representation and ENCODE the RUN CODE in packed format.
C ***
C ***     First, check for the one nybble packed number representation of
C ***     the value.
          IF(IRUNCD(I).LE.I1NYBL) THEN
C ***        Note: The special case J=0 will not occur. A value of
C ***        zero for IRUNCD(I) signifies the end of the RUN CODE array
C ***        and was checked for above.
               BENCOD(IBEIND/2)=BENCOD(IBEIND/2) +
     2              (IRUNCD(I)*16*MOD(IBEIND+1,2) 
     3               + IRUNCD(I)*MOD(IBEIND,2))
               IBEIND=IBEIND+1
             GOTO 1000
          ENDIF
C ***
C ***     Second, check for the two nybble packed number representation of
C ***     the value.
          IF(IRUNCD(I).LE.I2NYBL) THEN
C ***        Note: J=13 will have been caught in the 1 nybble case above
C ***        so we do not have to worry about that special case.
             ITMP1=INT((IRUNCD(I)-1-IDYNF)/16) + 1 + IDYNF
             ITMP2=IRUNCD(I)-(ITMP1-IDYNF-1)*16 - IDYNF - 1
             BENCOD(IBEIND/2)=BENCOD(IBEIND/2) +
     2                         (ITMP1*16*MOD(IBEIND+1,2) 
     3                          + ITMP1*MOD(IBEIND,2))
             IBEIND=IBEIND+1
             BENCOD(IBEIND/2)=BENCOD(IBEIND/2) +
     2                         (ITMP2*16*MOD(IBEIND+1,2) 
     3                          + ITMP2*MOD(IBEIND,2))
             IBEIND=IBEIND+1
             GOTO 1000
          ENDIF
C ***
C ***     Lastly, calculate the number of nybbles required to be zero
C ***     for the large (3 or more) nybble representation of the value.
C ***     Then encode that value as a large packed number.
          ITMPL=INT(LOG(FLOAT(IRUNCD(I)+ILNYBL))/LOG(16.0)+1)-1
          DO 500, K=1,ITMPL
C ***          Place ITMPL zeroed nybbles into the BENCOD array.
               IBEIND=IBEIND+1
500       CONTINUE
C ***     Now, pack the value as a large packed number into array BENCOD.
C ***     Values greater than -ILNYBL=((13-dyn_f)*16+dyn_f)) are
C ***     large run counts.
          ITMP1=IRUNCD(I) + ILNYBL
          DO 600, K=1,ITMPL+1
             ITMP2=INT(ITMP1/(16**(ITMPL-K+1)))
             BENCOD(IBEIND/2)=BENCOD(IBEIND/2) + 
     2                         (ITMP2*16*MOD(IBEIND+1,2) 
     3                          + ITMP2*MOD(IBEIND,2))
             IBEIND=IBEIND+1
             ITMP1=ITMP1-ITMP2*16**(ITMPL-K+1)
600       CONTINUE
C ***
C ***  ----------------------------------------------------------------
C ***                                         
1000  CONTINUE
2000  CONTINUE
C *** Note: We do not need to finish packing the last nybble of a byte
C *** because the byte was zeroed out at the start of this routine.
C *** Let us now perform a sanity check to make sure that we did not
C *** go out of bounds on the array BENCOD (if we did, it is a programming
C *** error --- this should not ever happen).
      IF(IBEIND-1.GE.IBEDIM*2) THEN
        CALL GRWARN ('Exceeded array dimensions in the TeX PK'
     2  //' Font RUN CODE ENCODEr routine.')
        CALL GRWARN ('Byte Array BENCOD bounds was exceeded.'
     2  //'  This is a programming error in that routine.') 
        CALL GRWARN ('That should never occur.')
      ENDIF
C ***
C ***
C ***
C ***
C *** -------------------------------------------------------------
C *** Finished.  Return with the results.
C ***
      RETURN
      END
C<FF>
C *GRTX09 -- PGPLOT Write out the current PK Font character to PK file.
C
      SUBROUTINE GRTX09 (IBEDIM,BC,NC,XMAX,RESOLX,NDEV,DEVICE,
     2                   IXBXLL,IXBXUR,IYBXLL,IYBXUR,IDYNFO,
     3                  LIBLAK,NPKBYT,LUN,BENCOD,HEIGHT,
     4                  WIDTH,YMAX,RESOLY)
C-----------------------------------------------------------------------
C ***
C *** 
      IMPLICIT NONE
      INTEGER IBEDIM,BC,NC,NDEV,DEVICE,NPKBYT,LUN(2)
      INTEGER IXBXLL,IXBXUR,IYBXLL,IYBXUR,IDYNFO,FLAG
      INTEGER DM,DX,DY,W,H,HOFF,VOFF,PL(3),CC,I,ITMPVL
      INTEGER ITMPV1,ITMPV2,ITMPV3,ITMPV4,ITMP32,ITMP16
      DOUBLE PRECISION TFM,TFMW,TFMH,TMPVAR
      REAL XMAX,RESOLX(NDEV),YMAX,RESOLY(NDEV)
      LOGICAL LIBLAK
      INTEGER BENCOD(IBEDIM),HEIGHT(0:15,4),WIDTH(0:15,4)
      INTEGER BYTOUT
C ***
C-------------------------------------------------------------------------
C *** First, we need to calculate the Character Preamble paramaters
C *** for the PK file for the short, short extended, and long formats.
C *** The packet lengths are:
      PL(1)=8+IBEDIM
      PL(2)=13+IBEDIM
      PL(3)=28+IBEDIM
C *** The Character code is:
      CC=BC+NC
C *** The width values are:
      W=IXBXUR-IXBXLL+1
C *** The height values are:
      H=IYBXUR-IYBXLL+1
C *** The TFM value will be computed from:
C      TFM=XMAX/RESOLX(DEVICE)/1.3837
      TFM=W/RESOLX(DEVICE)/1.3837
C *** {We will also calculate the char_info width and height table 
C ***  values for the character here, WIDTH, HEIGHT in design size units}.
      TFMW=W/RESOLX(DEVICE)/1.3837
C      TFMW=XMAX/RESOLX(DEVICE)/1.3837
      TFMH=H/RESOLY(DEVICE)/1.3837
C      TFMH=YMAX/RESOLY(DEVICE)/1.3837
C *** The DX ( or DM) values are:
C      DM=XMAX
      DM=W
      DX=DM*65536
C *** The DY values are 0.
      DY=0
C *** The horizontal offset values are:
C      HOFF=-IXBXLL
      HOFF=0
C *** The vertical offset values are:
C      VOFF=IYBXUR
      VOFF=H
C ***
C ***
C *** ------------------------------------------------------------------
C ***
C *** Now, we will determine which format of the preamble will be used --
C *** the long, the short, or the short extended.
C ***
C ***
C *** We will use the short form if possible.  SHORT_FORM: label 500.
      IF( (PL(1).LT.1024) .AND. (CC.LT.256) .AND. 
     2    (TFM.LT.16) .AND. (DM.LT.256) .AND. (W.LT.256)
     3    .AND. (H.LT.256) .AND. (HOFF.GT.-129)
     4    .AND. (HOFF.LT.128) .AND. (VOFF.GT.-129) 
     5    .AND. (VOFF.LT.128))  GOTO 500
C ***
C ***
C *** The short form was not possible.  We will try to use the 
C *** short extended form.  SHORT_EXT: label 2000.
      IF( (PL(2).LT.196608) .AND. (CC.LT.256) .AND. 
     2    (TFM.LT.16) .AND. (DM.LT.65536) .AND. (W.LT.65536)
     3    .AND. (H.LT.65536) .AND. (HOFF.GT.-32769) 
     4    .AND. (HOFF.LT.32768) .AND. (VOFF.GT.-32769) 
     5    .AND. (VOFF.LT.32768))  GOTO 2000
C ***
C ***
C *** The short form, and the short extended forms were not possible.
C *** The Long form had better work!. LONG_FORM: label 3500.
      IF( (PL(3).LT.2.147836*10**9) .AND.
     2   (CC.LT.2.147836*10**9) .AND. 
     3    (TFM.LT.2048) .AND. (DM.LT.32768) .AND.
     4    (W.LT.2.147836*10**9) .AND. (H.LT.2.147836*10**9)
     5    .AND. (HOFF.GT.-2.147836*10**9)
     6    .AND. (HOFF.LT.2.147836*10**9) .AND.
     7    (VOFF.GT.-2.147836*10**9) 
     8    .AND. (VOFF.LT.2.147836*10**9))  GOTO 3500
C ***
C *** ---------------------------------------------------------------
C *** This file can not be output to a PK file.  There is something wrong.
C ***
      CALL GRWARN ('The PK file cannot be output to.')
      CALL GRQUIT ('Character Preamble Format for the '
     2           //'character is too large.')
C ***
C -----------------------------------------------------------------------
C ***
C ***
C ***
C ***
C ***
C ***
C ***
C ***
C ***
C ***
C --------------------------------------------------------------------------
500   CONTINUE
C ***
C *** SHORT_FORMAT:
C ***
C ***
C *** -----------------
C *** First, we write out the Flag (1 byte).
      FLAG=0
      FLAG=FLAG+IDYNFO*16
      IF((LIBLAK.EQ..TRUE.) .AND. (IDYNFO.LT.14)) 
     2    FLAG=FLAG + 2**3
      ITMPVL=INT(PL(1)/256.0)
      FLAG=FLAG+ITMPVL
      BYTOUT=FLAG
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Second, we write out the Packet_Length (1 byte).
      BYTOUT=PL(1)-ITMPVL*256
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Third, we write out the Character_Code (1 byte).
      BYTOUT=CC
      CALL GRTX11(LUN(1),BYTOUT)
C *** 
C *** Fourth, we write out the TFM_width (3 bytes).
      TMPVAR=TFM
      ITMPVL=INT(TMPVAR/16.0**(-1))
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
      TMPVAR=TMPVAR-ITMPVL*16.0**(-1)
      ITMPVL=INT(TMPVAR/16.0**(-3))
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
      TMPVAR=TMPVAR-ITMPVL*16.0**(-3)
      ITMPVL=INT(TMPVAR/16.0**(-5))
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Fifth, we write out the horizontal escapement (DM is 1 byte).
      BYTOUT=DM
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Sixth, we write out the Width of the bitmap (1 byte).
      BYTOUT=W
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Seventh, we write out the Height of the bitmap (1 byte).
      BYTOUT=H
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Eighth, we write out the Horizontal offset (signed 1 byte)
C *** Since it is signed, we must take care of this.
      IF (HOFF.LT.0) THEN
         BYTOUT=HOFF+256
      ELSE
         BYTOUT=HOFF
      ENDIF
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C ***         
C *** Ninth, we write out the Vertical offset (signed 1 byte)
C *** Since it is signed, we must take care of this.
      IF (VOFF.LT.0) THEN
         BYTOUT=VOFF+256
      ELSE
         BYTOUT=VOFF
      ENDIF
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** We just wrote out 11 bytes to the PK file.
      NPKBYT=NPKBYT+11
C *** Finished with the character Preamble, time to write out the character
C *** to the PK file.
C ***
C ***
C *** Write out the encoded character.
      GOTO 5000
C --------------------------------------------------------------------------
2000  CONTINUE
C ***
C *** SHORT_EXT:
C ***
C *** -----------------
C *** First, we write out the Flag (1 byte).
      FLAG=0
      FLAG=FLAG+IDYNFO*16
      IF((LIBLAK.EQ..TRUE.) .AND. (IDYNFO.LT.14)) 
     2    FLAG=FLAG + 2**3
      FLAG=FLAG+2**2
      ITMPVL=INT(PL(2)/65536.0)
      FLAG=FLAG+ITMPVL
      BYTOUT=FLAG
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Second, we write out the Packet_Length (2 byte).
      ITMPVL=PL(2)-ITMPVL*65536
      ITMPV2=INT(ITMPVL/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPV1=ITMPVL-ITMPV2*256
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C ***      
C ***
C *** Third, we write out the Character_Code (1 byte).
      BYTOUT=CC
      CALL GRTX11(LUN(1),BYTOUT)
C *** 
C *** Fourth, we write out the TFM_width (3 bytes).
      TMPVAR=TFM
      ITMPVL=INT(TMPVAR/16.0**(-1))
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
      TMPVAR=TMPVAR-ITMPVL*16.0**(-1)
      ITMPVL=INT(TMPVAR/16.0**(-3))
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
      TMPVAR=TMPVAR-ITMPVL*16.0**(-3)
      ITMPVL=INT(TMPVAR/16.0**(-5))
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C ***
C *** Fifth, we write out the horizontal escapement (DM is 2 byteS).
      ITMPV2=INT(DM/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPV1=DM-ITMPV2*256
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Sixth, we write out the Width of the bitmap (2 bytes).
      ITMPV2=INT(W/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPV1=W-ITMPV2*256
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Seventh, we write out the Height of the bitmap (2 bytes).
      ITMPV2=INT(H/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPV1=H-ITMPV2*256
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Eighth, we write out the Horizontal offset (signed 2 bytes)
      IF (HOFF.LT.0) THEN
         ITMPVL=HOFF+65536
      ELSE
         ITMPVL=HOFF
      ENDIF
      ITMPV2=INT(ITMPVL/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPV1=ITMPVL-ITMPV2*256
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C ***         
C *** Ninth, we write out the Vertical offset (signed 2 bytes).
      IF (VOFF.LT.0) THEN
         ITMPVL=VOFF+65536
      ELSE
         ITMPVL=VOFF
      ENDIF
         ITMPV2=INT(ITMPVL/256.0)
         BYTOUT=ITMPV2
         CALL GRTX11(LUN(1),BYTOUT)
         ITMPV1=ITMPVL-ITMPV2*256
         BYTOUT=ITMPV1
         CALL GRTX11(LUN(1),BYTOUT)
C ***
C ***
C *** We just wrote out 17 bytes to the PK file.
      NPKBYT=NPKBYT+17
C *** Finished with the character Preamble, time to write out the character
C *** to the PK file.
C ***
C ***
C ***
C ***
C *** Write out the encoded character.
      GOTO 5000
C --------------------------------------------------------------------------
3500  CONTINUE
C ***
C *** LONG_FORMAT:
C ***
C *** Note: All of these 4 byte quantites are "signed", but only
C ***      HOFF and VOFF can actually be negative.  We did a check
C ***      on all of the other variables at the start of this routine.
C ***      We only have to worry about HOFF and VOFF being signed quantities.
C *** -----------------
C *** First, we write out the Flag (1 byte).
      FLAG=0
      FLAG=FLAG+IDYNFO*16
      IF((LIBLAK.EQ..TRUE.) .AND. (IDYNFO.LT.14)) 
     2    FLAG=FLAG + 2**3
      FLAG=FLAG+7
      BYTOUT=FLAG
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Second, we write out the Packet_Length (4 bytes).
      ITMPVL=PL(3)
      ITMPV4=INT(ITMPVL/16777216.0)
      BYTOUT=ITMPV4
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV4*16777216
      ITMPV3=INT(ITMPVL/65536.0)
      BYTOUT=ITMPV3
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV3*65536
      ITMPV2=INT(ITMPVL/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV2*256
      ITMPV1=ITMPVL
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Third, we write out the Character_Code (1 byte).
      ITMPVL=CC
      ITMPV4=INT(ITMPVL/16777216.0)
      BYTOUT=ITMPV4
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV4*16777216
      ITMPV3=INT(ITMPVL/65536.0)
      BYTOUT=ITMPV3
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV3*65536
      ITMPV2=INT(ITMPVL/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV2*256
      ITMPV1=ITMPVL
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C *** 
C *** Fourth, we write out the TFM_width (4 bytes).
      TMPVAR=TFM
      ITMPVL=INT(TMPVAR/16.0**1)
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
      TMPVAR=TMPVAR-ITMPVL*16.0**1
      ITMPVL=INT(TMPVAR/16.0**(-1))
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
      TMPVAR=TMPVAR-ITMPVL*16.0**(-1)
      ITMPVL=INT(TMPVAR/16.0**(-3))
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
      TMPVAR=TMPVAR-ITMPVL*16.0**(-3)
      ITMPVL=INT(TMPVAR/16.0**(-5))
      BYTOUT=ITMPVL
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Fifth, we write out the horizontal escapement (DX is 4 bytes).
C ***
      ITMPVL=DX
      ITMPV4=INT(ITMPVL/16777216.0)
      BYTOUT=ITMPV4
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV4*16777216
      ITMPV3=INT(ITMPVL/65536.0)
      BYTOUT=ITMPV3
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV3*65536
      ITMPV2=INT(ITMPVL/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV2*256
      ITMPV1=ITMPVL
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C *** Sixth, we write out the Vertical escapement (4 bytes). DY=0.
      DO 3600, I=1, 4
         BYTOUT=0
         CALL GRTX11(LUN(1),BYTOUT)
3600  CONTINUE
C *** Seventh, we write out the Width of the bitmap (4 bytes).
      ITMPVL=W
      ITMPV4=INT(ITMPVL/16777216.0)
      BYTOUT=ITMPV4
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV4*16777216
      ITMPV3=INT(ITMPVL/65536.0)
      BYTOUT=ITMPV3
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV3*65536
      ITMPV2=INT(ITMPVL/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV2*256
      ITMPV1=ITMPVL
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Eighth, we write out the Height of the bitmap (4 bytes).
      ITMPVL=H
      ITMPV4=INT(ITMPVL/16777216.0)
      BYTOUT=ITMPV4
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV4*16777216
      ITMPV3=INT(ITMPVL/65536.0)
      BYTOUT=ITMPV3
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV3*65536
      ITMPV2=INT(ITMPVL/256.0)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      ITMPVL=ITMPVL-ITMPV2*256
      ITMPV1=ITMPVL
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** Ninth, we write out the Horizontal offset (signed 4 bytes).
C *** This will be a negative quantity. But officially can be signed.
C *** The result is NOT just two's complement as in the case with 2 byte
C *** and 1 byte signed quantities.  The first two bytes take care of
C *** whether the quantity is signed or not, while the last two bytes
C *** are positive.
      ITMP32=HOFF
      ITMP16=INT(ITMP32/65536.0)
      IF(ITMP16.LT.0) ITMP16=ITMP16+65536
      ITMPV4=INT(ITMP16/256.0)
      ITMPV3=ITMP16-ITMPV4*256
      ITMP16=ITMP32-ITMP16*65536
      ITMPV2=INT(ITMP16/256.0)
      ITMPV1=ITMP16-ITMPV2*256
      BYTOUT=ITMPV4
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT=ITMPV3
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C ***         
C *** Tenth, we write out the Vertical offset (signed 4 bytes).
C *** This will be a positive quantity.  But officially can be signed.
C *** The result is NOT just two's complement as in the case with 2 byte
C *** and 1 byte signed quantities.  The first two bytes take care of
C *** whether the quantity is signed or not, while the last two bytes
C *** are positive.
      ITMP32=VOFF
      ITMP16=INT(ITMP32/65536.0)
      IF(ITMP16.LT.0) ITMP16=ITMP16+65536
      ITMPV4=INT(ITMP16/256.0)
      ITMPV3=ITMP16-ITMPV4*256
      ITMP16=ITMP32-ITMP16*65536
      ITMPV2=INT(ITMP16/256.0)
      ITMPV1=ITMP16-ITMPV2*256
      BYTOUT=ITMPV4
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT=ITMPV3
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT=ITMPV2
      CALL GRTX11(LUN(1),BYTOUT)
      BYTOUT=ITMPV1
      CALL GRTX11(LUN(1),BYTOUT)
C ***
C *** We just wrote out 37 bytes to the PK file.
      NPKBYT=NPKBYT+37
C *** Finished with the character Preamble, time to write out the character
C *** to the PK file.
C ***
C ***
C ***
C *** Write out the encoded character.
      GOTO 5000
C -------------------------------------------------------------------------
5000  CONTINUE
C ***
C *** CHAR_WRITE:
C ***
C ***
C ***
C *** Write out the encode character information to the PK file.
      DO 5100, I=1,IBEDIM
        CALL GRTX11(LUN(1),BENCOD(I))
5100  CONTINUE
C *** We just wrote out IBEDIM bytes to the PK file.
      NPKBYT=NPKBYT+IBEDIM
C ***
C *** We need to finish up some bookkeeping, and calculate the TFM file
C *** WIDTH and HEIGHT lookup values for this character.
C *** We calculate TFMW and TFMH at the start of this routine, we now
C *** just need to put them into a Fix_word representation (like the
C *** PK files TFM width calculation for the large format of character
C *** preamble.
C *** First do the TFM WIDTH value calculation and store it for 
C *** this character.
      TMPVAR=TFMW
      ITMPVL=INT(TMPVAR/16.0**1)
      WIDTH(NC+1,1)=ITMPVL
      TMPVAR=TMPVAR-ITMPVL*16.0**1
      ITMPVL=INT(TMPVAR/16.0**(-1))
      WIDTH(NC+1,2)=ITMPVL
      TMPVAR=TMPVAR-ITMPVL*16.0**(-1)
      ITMPVL=INT(TMPVAR/16.0**(-3))
      WIDTH(NC+1,3)=ITMPVL
      TMPVAR=TMPVAR-ITMPVL*16.0**(-3)
      ITMPVL=INT(TMPVAR/16.0**(-5))
      WIDTH(NC+1,4)=ITMPVL
C *** 
C *** Second, do the HEIGHT calculation and store it.
      TMPVAR=TFMH
      ITMPVL=INT(TMPVAR/16.0**1)
      HEIGHT(NC+1,1)=ITMPVL
      TMPVAR=TMPVAR-ITMPVL*16.0**1
      ITMPVL=INT(TMPVAR/16.0**(-1))
      HEIGHT(NC+1,2)=ITMPVL
      TMPVAR=TMPVAR-ITMPVL*16.0**(-1)
      ITMPVL=INT(TMPVAR/16.0**(-3))
      HEIGHT(NC+1,3)=ITMPVL
      TMPVAR=TMPVAR-ITMPVL*16.0**(-3)
      ITMPVL=INT(TMPVAR/16.0**(-5))
      HEIGHT(NC+1,4)=ITMPVL
C ***
C *** Finished.  Let's return and do the next character if there are
C *** any more.
C ------------------------------------------------------------------------
      RETURN
      END
C<FF>
C *GRTX10 -- PGPLOT Output the TFM file.
C
      SUBROUTINE GRTX10(NC,ITFMUN,CHINFO,WIDTH,HEIGHT,BC)
C *** -------------------------------------------------------------------
C *** We have limited the dimensions to support only 15 characters
C *** per Font.  ASCII codes "A" through a possible maximum of "O"
C *** are assumed.  TFM file limit of 16 different character
C *** HEIGHT table lookup values was the reason for this choice of
C *** limiting the Font to a maximum of 15 characters.  Each of the
C *** 15 characters will have exactly 1 entry in the character WIDTH
C *** and HEIGHT lookup tables for simplicity.
C ***
C----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER LF,BC,NC,I,J,ITFMUN
C ***     BC is the decimal value representing ASCII "A".
C ***     ECMAX is to be the 15th character after the starting
C ***     character (denoted by the value of BC).
      INTEGER BYTOUT, HEADER(0:16,4),CHINFO(BC:BC+14,4),
     2     WIDTH(0:15,4),HEIGHT(0:15,4)
C ***
C *** ===========================================================
C *** Have finished writing out the PK Font file.  Now, write out 
C *** the TFM (TeX Font Metric) File.  The TFM file should be
C *** "SEQUENTIAL, FIXED-LENGTH 512 BYTES, NO CARRIAGE_CONTROL"
C *** to match the other TFM files on the VAX.  
C *** TFM files require the most significant byte to appear in the 
C *** file before the less significant byte.  VMS RMS will take 
C *** care of the order of reading and writing the bits in a byte.
C *** So, as long as bytes are written out by this program in the 
C *** correct order, the bits will be okay. 
C ***
C ***
C *** Write out the total length of the TFM file in words (1 word=4 bytes).
C *** High byte, low byte integer as is required throught the TFM file.
C *** LF comes from 6 words (LF,LH,BC,EC,NW,NH,ND,NI,NL,NK,NE,NP values)
C *** plus 17 header words, plus NC+1 char_info words, plus 
C *** NC+2 width table words, plus NC+2 height table words, 
C *** plus 1 depth word, plus 1 italic word, plus 7 parameter words.
      LF=37+3*NC
      BYTOUT = INT(LF/256.0)
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = LF - INT(LF/256.0)*256
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the length of the header data in words (1 word=4 bytes).
C *** High byte, low byte integer format.
      BYTOUT=0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT=17
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the ASCII value to be used for the first Font character.
C *** Value < 256 require by TFM file.  High byte, low byte integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = BC
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the ASCII value to be used for the last Font character.
C *** BC <= Value <= BC+14 = ECMAX required by program dimensions and 
C *** algorithm used.  TFM requires Value < 256.  
C *** High byte, low byte integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = BC + NC
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the number of words in the character WIDTH lookup table.
C *** (One for each character was used for simplicity. Maximum of 15 
C *** characters). High byte, low byte integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = NC + 2
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the number of words in the character HEIGHT lookup table.
C *** (One for each character was used for simplicity. Maximum of 15 
C *** characters). High byte, low byte integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = NC + 2
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the number of words in the character DEPTH lookup table.
C *** (Only the value 0).  Hight byte, low byte integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 1
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write the number of words in the character ITALIC correction lookup
C *** table. (Only the value 0). High byte, low byte integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 1
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the number of words in the character LIG/KERN lookup table.
C *** (No values. This table is ommitted). High byte, low byte integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the number of words in the character KERN lookup table.
C *** (No values. This table is ommitted). High byte, low byte integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the number of words in the extensible character lookup table.
C *** (No values. This table is ommitted). High byte, low byte integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C *** Write out the number of Font PARAMater words. High byte, low byte
C *** integer format.
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 7
      CALL GRTX12(ITFMUN,BYTOUT)
C ***
C ***
C *** ------------------------------------------------------------------
C *** 
C *** Write out the HEADER information of the TFM file.
C ***
C *** ------------------------------------------------------------------
C *** 
C *** Store the 32 bit check sum, HEADER[0], that TeX will copy into the
C *** DVI output file whenever it uses the font.  This same checksum
C *** should be in the FONT PK file as well. 
C *** I arbitrarily chose HEADER[0]=09281963  as the 32 bit Hex value.
C *** (my birthdate is easy to remember...).
      HEADER(0,1) = 9
      HEADER(0,2) = 2*16 + 8
      HEADER(0,3) = 1*16 + 9
      HEADER(0,4) = 6*16 + 3
C ***
C *** Store HEADER[1], a Fix_word containing the design size of the 
C *** Font in TeX point units. (7227 TeX points = 254 cm.).
C *** Note: This number must be at least 1.0.
C *** [Fix_word is a 32-bit representation of a binary fraction.
C *** Of the 32 bits in a Fix_word, exactly 12 are to the left of the
C *** binary point.  Thus, 2048-2**-20 >= Fixed_word >= -2048 ].
C *** I chosed 100.00 TeX points as the Font design size.  Since many of
C *** the fields in the TFM file must be expressed within 16 absolute
C *** design-size units in value, 100.0 TeX points approximately = 1.38 
C *** inches will allow up to approximately 22 inch output to be used.
C *** HEADER[1]=100.0base10=64.0base16 = 06400000 .
      HEADER(1,1) = 0*16 + 6
      HEADER(1,2) = 4*16 + 0
      HEADER(1,3) = 0
      HEADER(1,4) = 0
C ***
C *** Store HEADER[2]...HEADER[11].
C *** These 40 bytes identify the character coding scheme. The first byte
C *** gives the number of bytes that are used to contain the identifying
C *** string.  We will use 7 bytes to contain the string "GRAPHIC".
C *** ASCII codes in Hex are "G"=47,"R"=52","A"=41,"P"=50,"H"=48,
C *** "I"=49,"C"=43. So, in Hex, HEADER[2]=07475241, HEADER[3]=50484943,
C *** HEADER[4]=00000000, HEADER[5]=00000000, HEADER[6]=00000000,
C *** HEADER[7]=00000000, HEADER[8]=00000000, HEADER[9]=00000000,
C *** HEADER[10]=00000000, HEADER[11]=00000000.
C *** Storing thoses values, we have:
      HEADER(2,1) = 0*16 + 7
      HEADER(2,2) = 4*16 + 7
      HEADER(2,3) = 5*16 + 2
      HEADER(2,4) = 4*16 + 1
      HEADER(3,1) = 5*16 + 0
      HEADER(3,2) = 4*16 + 8
      HEADER(3,3) = 4*16 + 9
      HEADER(3,4) = 4*16 + 3
C *** Storing HEADER[4]...HEADER[11] = 00000000, we have:
      DO 20, J=1,4
        DO 10, I=4,11
          HEADER(I,J)=0
10      CONTINUE
20    CONTINUE
C ***
C *** Store HEADER[12]...HEADER[16]. 
C *** These 20 bytes contain the Font family name in BCPL format.
C *** This filed is know as the "Font identifier". I chose the 18 characters
C *** "PGPLOT BITMAP DATA" for the Font name.  ASCII values in HEX are:
C *** "P"=50,"G"=47,"P"=50,"L"=4C,"O"=4F,"T"=54," "=20,"B"=42,"I"=49,
C *** "T"=54,"M"=4D,"A"=41,"P"=50," "=20,"D"=44,"A"=41,"T"=54,"A"=41. 
C *** So, HEADER[12]=12504750, HEADER[13]=4C4F5420, HEADER[14]=4249544D,
C *** HEADER[15]=41502044, HEADER[16]=41544100.
C *** Storing these values, we have:
      HEADER(12,1) =  1*16 +  2
      HEADER(12,2) =  5*16 +  0
      HEADER(12,3) =  4*16 +  7
      HEADER(12,4) =  5*16 +  0
      HEADER(13,1) =  4*16 + 12
      HEADER(13,2) =  4*16 + 15
      HEADER(13,3) =  5*16 +  4
      HEADER(13,4) =  2*16 +  0
      HEADER(14,1) =  4*16 +  2
      HEADER(14,2) =  4*16 +  9
      HEADER(14,3) =  5*16 +  4
      HEADER(14,4) =  4*16 + 13
      HEADER(15,1) =  4*16 +  1
      HEADER(15,2) =  5*16 +  0
      HEADER(15,3) =  2*16 +  0
      HEADER(15,4) =  4*16 +  4
      HEADER(16,1) =  4*16 +  1
      HEADER(16,2) =  5*16 +  4
      HEADER(16,3) =  4*16 +  1
      HEADER(16,4) =  0
C *** Note: I'm not sure what HEADER[17] accomplishes. I have NOT used it.
C *** If it is to be used, then the Dimension of HEADER must be increased,
C *** and the value written to the TFM file describing the length of
C *** the HEADER array must be increased.
C ***
C *** Now write out the store HEADER array to the TFM file.
      DO 40, I = 0,16
        DO 30, J=1,4
          CALL GRTX12(ITFMUN,HEADER(I,J))
30      CONTINUE
40    CONTINUE
C ***
C ***
C *** Now write the previously stored char_info array, CHINFO, to the TFM file.
      DO 60, I =BC, BC+NC
        DO 50, J=1,4
          CALL GRTX12(ITFMUN,CHINFO(I,J))
50      CONTINUE
60    CONTINUE
C ***
C ***
C *** Now write the previously store character width lookup array, WIDTH,
C *** to the TFM file.
      DO 80, I = 0, NC+1
        DO 70, J=1,4
           CALL GRTX12(ITFMUN,WIDTH(I,J))
70      CONTINUE
80    CONTINUE
C ***
C ***
C *** Now write the previosly stored character height lookup array, HEIGHT,
C *** to the TFM file.
      DO 100, I= 0, NC+1
        DO 90, J=1,4
           CALL GRTX12(ITFMUN,HEIGHT(I,J))
90      CONTINUE
100   CONTINUE
C ***
C ***
C *** Now write the character depth lookup array. 
C *** Note: WIDTH[0]=HEIGHT[0]=DEPTH[0]=ITALIC[0]=0 is required by TFM
C *** file specifications.
      DO 110, I=1,4
        BYTOUT = 0
        CALL GRTX12(ITFMUN,BYTOUT)
110   CONTINUE
C ***
C *** Now write the character italic lookup array. 
C *** Note: WIDTH[0]=HEIGHT[0]=DEPTH[0]=ITALIC[0]=0 is required by TFM
C *** file specifications.
      DO 111, I=1,4
        BYTOUT = 0
        CALL GRTX12(ITFMUN,BYTOUT)
111   CONTINUE
C ***
C *** Character LIG/KERN lookup table would have normally been written out here.
C *** However, there are no entries in our table. I ommitted this table.
C ***
C ***
C *** Character KERN lookup table would have normally been written out here.
C *** However, there are no entries in our table. I ommitted this table.
C ***
C ***
C *** Extensible character lookup table would have normally been written out
C *** here. However, there are no entries in our table. I ommitted this table.
C ***
C ***
C *** Now, write out the character PARAM array of Fix_words.
C *** PARAM[1]=italic_slant = 00000000  (0.0) is the amount of italic slant.
C *** PARAM[2]=space = 00001000 (0.001 design-size units = 1.0 TeX points 
C ***                  which approximately=0.0138 inches) is the normal
C ***                  spacing between words in the text I arbitrarily chose.
C *** PARAM[3]=space_stretch = 00000000 (0.0) is the glue stretching
C ***                  between words of the text.
C *** PARAM[4]=space_shrink = 00000000 (0.0) is the glue shrinking 
C ***                  between words of the text.
C *** PARAM[5]=x_height = 00000000 (0.0) is the height of letters for
C ***                  which accents don't have to be raised.
C *** PARAM[6]=quad= 00001000 (0.001 design-size units = 1.0 TeX points
C ***                  which approximately=0.0138 inches) is the size
C ***                  I chose for one "em" in this Font. This was an 
C ***                  arbitrary choice. I do not believe this parameter
C ***                  will be used--- but just in case...
C *** PARAM[7]=extra_space = 00000000 (0.0) is the amount added to
C ***                  PARAM[2] at the ends of sentences.
C *** 
C *** Writing out these values for the PARAM array,
C *** for PARAM[1] we have:
      DO 120, I = 1,4
        BYTOUT = 0
        CALL GRTX12(ITFMUN,BYTOUT)
120   CONTINUE
C *** for PARAM[2] we have:
      BYTOUT = 0 
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 1*16 + 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
C *** for PARAM[3] we have:
      DO 130, I = 1,4
        BYTOUT = 0
        CALL GRTX12(ITFMUN,BYTOUT)
130   CONTINUE
C *** for PARAM[4] we have:
      DO 140, I = 1,4
        BYTOUT = 0
        CALL GRTX12(ITFMUN,BYTOUT)
140   CONTINUE
C *** for PARAM[5] we have:
      DO 150, I = 1,4
        BYTOUT = 0
        CALL GRTX12(ITFMUN,BYTOUT)
150   CONTINUE
C *** for PARAM[6] we have:
      BYTOUT = 0 
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 1*16 + 0
      CALL GRTX12(ITFMUN,BYTOUT)
      BYTOUT = 0
      CALL GRTX12(ITFMUN,BYTOUT)
C *** for PARAM[7] we have:
      DO 160, I = 1,4
        BYTOUT = 0
        CALL GRTX12(ITFMUN,BYTOUT)
160   CONTINUE
C ***
C ***
C ***
C *** ===================================================================
C *** Finish writing the 512 byte record block on the Vax with 0's.
C *** Note: TFM files do not require this...I just wanted to fill the
C *** record (and block) on out, and I chose 0 to do this.
      DO 500, I=LF*4+1,512
         BYTOUT=0
         CALL GRTX12(ITFMUN,BYTOUT)
500   CONTINUE
C ***
      RETURN
      END
C<FF>
C *GRTX11 -- PGPLOT  buffering of PK file byte writes until 512 bytes buffered.
C
      SUBROUTINE GRTX11 (ILUNIT,BYTOUT)
C *** ------------------------------------------------------------------
C ***  PK file writes...
C *** ----------------------------------------------------------------
C *** The purpose of this file is to provide buffering of the writes
C *** to the output PK file until 512 bytes can be written out together
C *** as one record.
C *** ILUNIT is the unit number of the output file.
C *** BYTOUT is the byte sent to be buffered up for the record write.
C *** This routine requires the SAVE statement. The variables
C *** BUFFER and IBFIND must retain their values upon successive 
C *** calls!.
C *** PORTABILITY NOTES:  
C *** This routine is system dependent. On a vax, a byte ranges from
C *** -128 to 127  in decimal representation (For a Vax byte, 
C *** -128base10 is FF in hex) (For a Vax byte, 127base10 is 7F in hex).
C *** So {[0,255]base10 integer } gets mapped to {[0,FF]base16 byte},
C *** which is interpreted as:
C ***  {[0,127]base10 integer } getting mapped to {[0,127]base10 byte}
C ***  while {[128,255]base10 integer} getting mapped 
C ***  to {[-128,-1]base10 byte}.
C ***  Also, you may have to change the write statement below.
C ***  in *UNIX we are after "bytes on the disk" without any record
C ***  attributes in the middle of the record.  Under *VMS I expect
C ***  RMS to take care of so that we get "bytes on the disk" appearance.
C ***  Routine GRTX12 also has this write statement that may need to
C ***  be modified.
C----------------------------------------------------------------------
C ***
      IMPLICIT NONE
      SAVE
      INTEGER ILUNIT, IBFIND, I, BYTOUT, CONVBY,IRECRD
      BYTE BUFFER(512)
C *** ------------------------------------------------------------
C *** Initialize some values to be set before the first time this
C *** routine is entered.  After the routine is entered, the values
C *** will be changed and will retain their new "changed" values
C *** upon successive calls to this routine.
C ***
      DATA BUFFER /512*0/
      DATA IBFIND /1/
      DATA IRECRD /1/
C ***
C *** ------------------------------------------------------------
C *** Convert the desired output value, BYTOUT, from its integer
C *** form to the Vax_specific_required_signed_output form for
C *** outputing a byte value, CONVBY. PORTABILITY NOTE:
C *** This will very likely be different on different machines.
C *** If the byte quantity is NOT signed on your machine, then
C *** you should change the line CONVBY=BYTOUT-256 to
C *** CONVBY=BYTOUT  below!!!!.          
C ***
      IF(BYTOUT.GT.127) THEN
         CONVBY=BYTOUT-256
      ELSE
         CONVBY=BYTOUT
      ENDIF
C ***
C *** Store the current byte that is to be output to the file.
      BUFFER(IBFIND)=CONVBY
      IF(MOD(IBFIND,512).EQ.0) THEN
C ***    We have buffered up 512 bytes. Time to write out a record
C ***    to the PK file and reset the buffer index IBFIND.
C ***    *VMS
C ***    If you have problems, you may want to try to change
C ***    this to a sequential write on the VAX. Routine GRTX12
C ***    also has a write statement like the one below.  
         WRITE(UNIT=ILUNIT,REC=IRECRD,ERR=1000) (BUFFER(I),I=1,512)
         IRECRD=IRECRD+1
         IBFIND=0
      ENDIF
C *** 
C *** Increment the buffer index to the next element of the buffer.
      IBFIND=IBFIND+1
C ***
C *** ---------------------------------------------------------------
C *** Return to the calling routine.
C ***
C-----------------------------------------------------------------------
      RETURN
1000  CONTINUE
      CALL GRWARN('ERROR writing to the PK Font file.')
      CALL GRQUIT('EXITING to operating system. Routine GRTX11.')
      STOP
C ***     -----------------------
      ENTRY GRTX14
C *** This part of GRTX11,GRTX14 is to reinitialze the file pointers
C *** to the beginning of a new file.
      DO 1500, I=1,512
         BUFFER(I)=0
1500  CONTINUE
      IBFIND=1
      IRECRD=1
      RETURN
      END
C<FF>
C *GRTX12 -- PGPLOT  buffering of TFM file byte writes until 512 bytes buffered.
C
      SUBROUTINE GRTX12 (ILUNIT,BYTOUT)
C *** ------------------------------------------------------------------
C ***  TFM file writes...
C *** ----------------------------------------------------------------
C *** The purpose of this file is to provide buffering of the writes
C *** to the output TFM file until 512 bytes can be written out together
C *** as one record.
C *** ILUNIT is the unit number of the output file.
C *** BYTOUT is the byte sent to be buffered up for the record write.
C *** This routine requires the SAVE statement. The variables
C *** BUFFER and IBFIND must retain their values upon successive 
C *** calls!.
C *** PORTABILITY NOTES:
C *** This routine is system dependent. On a vax, a byte ranges from
C *** -128 to 127  in decimal representation (For a Vax byte, 
C *** -128base10 is FF in hex) (For a Vax byte, 127base10 is 7F in hex).
C *** So {[0,255]base10 integer } gets mapped to {[0,FF]base16 byte},
C *** which is interpreted as:
C ***  {[0,127]base10 integer } getting mapped to {[0,127]base10 byte}
C ***  while {[128,255]base10 integer} getting mapped 
C ***  to {[-128,-1]base10 byte}.
C ***  Also, in *UNIX we want "bytes on the disk" with no interspersed
C ***  record information. Under *VMS I beileve that RMS will give us
C ***  the appearance of "bytes on the disk".  You may have to 
C ***  change this routine and routines GRTX11 in order to get
C ***  a stream of bytes on the disk without any record control information
C ***  interspersed in your file.
C----------------------------------------------------------------------
C ***
      IMPLICIT NONE
      SAVE
      INTEGER ILUNIT, IBFIND, I, BYTOUT, CONVBY,IRECRD
      BYTE BUFFER(512)
C *** ------------------------------------------------------------
C *** Initialize some values to be set before the first time this
C *** routine is entered.  After the routine is entered, the values
C *** will be changed and will retain their new "changed" values
C *** upon successive calls to this routine.
C ***
      DATA BUFFER /512*0/
      DATA IBFIND /1/
      DATA IRECRD /1/
C ***
C *** ------------------------------------------------------------
C *** Convert the desired output value, BYTOUT, from its integer
C *** form to the Vax_specific_required_signed_output form for
C *** outputing a byte value, CONVBY. PORTABILITY NOTE:
C *** This will very likely be different on different machines.
C *** If the byte quantity is NOT signed on your machine, then
C *** you should change the line CONVBY=BYTOUT-256 to
C *** CONVBY=BYTOUT  below!!!!.          
C ***
      IF(BYTOUT.GT.127) THEN
         CONVBY=BYTOUT-256
      ELSE
         CONVBY=BYTOUT
      ENDIF
C ***
C *** Store the current byte that is to be output to the file.
      BUFFER(IBFIND)=CONVBY
      IF(MOD(IBFIND,512).EQ.0) THEN
C ***    We have buffered up 512 bytes. Time to write out a record
C ***    to the TFM file and reset the buffer index IBFIND.
C ***    Under *VMS you may have to change this to a sequential
C ***    write.  It seems to work okay for our DVI driver as direct
C ***    access.  However, the original PK and TFM font files we have
C ***    look like sequential access.  This line also appears in
C ***    routine GRTX11.
         WRITE(UNIT=ILUNIT,REC=IRECRD,ERR=1000) (BUFFER(I),I=1,512)
         IRECRD=IRECRD+1
         IBFIND=0
      ENDIF
C *** 
C *** Increment the buffer index to the next element of the buffer.
      IBFIND=IBFIND+1
C ***
C *** ---------------------------------------------------------------
C *** Return to the calling routine.
C ***
C-----------------------------------------------------------------------
      RETURN
1000  CONTINUE
      CALL GRWARN('ERROR writing to the TFM Font file.')
      CALL GRQUIT('EXITING to operating system. Routine GRTX12.')
      STOP
C ***     -----------------------
      ENTRY GRTX15
C *** This part of GRTX12,GRTX15 is to reinitialze the file pointers
C *** to the beginning of a new file.
      DO 1500, I=1,512
         BUFFER(I)=0
1500  CONTINUE
      IBFIND=1
      IRECRD=1
      RETURN      
      END
C<FF>
C *GRTX13 -- TXDRIV routine to zero out the BITMAP array.
C
      SUBROUTINE GRTX13 ( ISIZE , BITMAP, BYTVAL)
C ***    called by "CALL GRTX13 (BX*BY, %VAL(BITMAP),'00'X)"
      IMPLICIT NONE
      INTEGER ISIZE, I
      BYTE BITMAP(ISIZE),BYTVAL
C     --------------------------
      DO 100, I=1, ISIZE
          BITMAP(I)=BYTVAL
100   CONTINUE
      RETURN
      END

C*********
c     INTERFACE TO CHARACTER FUNCTION GETENV [C]
c    +   (CBUF[REFERENCE])
C---
C Allow MS-Fortran to call the GETENV function built into the
C Fortran 5.0 library.
C---
c     CHARACTER*1 CBUF
c     END
C*********
C*GRGENV -- get value of PGPLOT environment parameter (MS-DOS)
C+
      SUBROUTINE GRGENV(CNAME, CVALUE, LVALUE)
      CHARACTER CNAME*(*), CVALUE*(*)
      INTEGER   LVALUE
      INTEGER*2 NONBLK
C
C Return the value of a PGPLOT environment parameter.
C
C Arguments:
C CNAME   : (input) the name of the parameter to evaluate.
C CVALUE  : receives the value of the parameter, truncated or extended
C           with blanks as necessary. If the parameter is undefined,
C           a blank string is returned.
C LVALUE  : receives the number of characters in CVALUE, excluding
C           trailing blanks. If the parameter is undefined, zero is
C           returned.
C--
C 1990-Mar-19 - [AFT]
C 1995-Mar-21   [mlm]
C     MODIFIED MARCH 1995 TO INTERFACE WITH SALFORD SOFTWARE FTN77
C
C
C-----------------------------------------------------------------------
      CHARACTER GETENV*64
C
      CHARACTER CTMP*64
      INTEGER   I, LTMP
C
C     ENVIRONMENT PREFIX CHANGED TO 'PG'  (mlm)
C
      CTMP = 'PG'//CNAME
      LTMP = INDEX(CTMP,' ')
      IF(LTMP.NE.0) THEN
          LTMP=LTMP-1
          ELSE
          LTMP=LEN(CTMP)
      ENDIF
C
C     GET ENVIRONMENT USING SALFORD ROUTINE
C
      CALL DOSPARAM@(CTMP(1:LTMP),CVALUE)
C
C     CHECK IF STRING IS EMPTY; IN CASE, RETURN L = 0
C     SALFORD ROUTINE NONBLK RETURNS POSITION OF FIRST NONBLANK CHARACTER
C     IN THE STRING, 0 IF ALL BLANK
C
      IF (NONBLK(CVALUE) .EQ. 0) THEN
         LVALUE = 0
         ELSE
      LVALUE = LEN(CVALUE)
      ENDIF
      RETURN
      END

C*PGSAVE -- save PGPLOT attributes
C%void cpgsave(void);
C+
      SUBROUTINE PGSAVE
C
C This routine saves the current PGPLOT attributes in a private storage
C area. They can be restored by calling PGUNSA (unsave). Attributes
C saved are: character font, character height, color index, fill-area
C style, line style, line width, pen position, arrow-head style, 
C hatching style, and clipping state. Color representation is not saved.
C
C Calls to PGSAVE and PGUNSA should always be paired. Up to 20 copies
C of the attributes may be saved. PGUNSA always retrieves the last-saved
C values (last-in first-out stack).
C
C Note that when multiple devices are in use, PGUNSA retrieves the
C values saved by the last PGSAVE call, even if they were for a
C different device.
C
C Arguments: none
C--
C 20-Apr-1992 - new routine [TJP].
C 27-Nov-1992 - add arrowhead style [TJP].
C  6-Oct-1993 - add text opacity [TJP].
C 28-Feb-1994 - correct bug (variable not saved) [TJP].
C 26-Feb-1995 - add hatching attributes.
C 19-Jun-1996 - correction in header comments [TJP].
C 26-Feb-1997 - add clipping state [TJP].
C-----------------------------------------------------------------------
      INTEGER MAXS
      PARAMETER (MAXS=20)
C
      INTEGER LEV
      INTEGER CF(MAXS), CI(MAXS), FS(MAXS), LS(MAXS), LW(MAXS)
      INTEGER AHFS(MAXS), TBG(MAXS), CLP(MAXS)
      REAL    CH(MAXS), POS(2,MAXS)
      REAL    AHANG(MAXS), AHBARB(MAXS), HSA(MAXS), HSS(MAXS), HSP(MAXS)
      SAVE    LEV, CF, CI, FS, LS, LW, AHFS, TBG, CH, POS
      SAVE    AHANG, AHBARB, HSA, HSS, HSP, CLP
      DATA    LEV /0/
C
      IF (LEV.GE.MAXS) THEN
          CALL GRWARN('Too many unmatched calls to PGSAVE')
      ELSE
          LEV = LEV+1
          CALL PGQCF(CF(LEV))
          CALL PGQCH(CH(LEV))
          CALL PGQCI(CI(LEV))
          CALL PGQFS(FS(LEV))
          CALL PGQLS(LS(LEV))
          CALL PGQLW(LW(LEV))
C          CALL PGQVP(0, VP(1,LEV), VP(2,LEV), VP(3,LEV), VP(4,LEV))
C          CALL PGQWIN(WIN(1,LEV), WIN(2,LEV), WIN(3,LEV), WIN(4,LEV))
          CALL PGQPOS(POS(1,LEV), POS(2,LEV))
          CALL PGQAH(AHFS(LEV), AHANG(LEV), AHBARB(LEV))
          CALL PGQTBG(TBG(LEV))
          CALL PGQHS(HSA(LEV), HSS(LEV), HSP(LEV))
          CALL PGQCLP(CLP(LEV))
      END IF
      RETURN     
C
C*PGUNSA -- restore PGPLOT attributes
C%void cpgunsa(void);
C+
      ENTRY PGUNSA
C
C This routine restores the PGPLOT attributes saved in the last call to
C PGSAVE. Usage: CALL PGUNSA (no arguments). See PGSAVE.
C
C Arguments: none
C-----------------------------------------------------------------------
      IF (LEV.LE.0) THEN
          CALL GRWARN('PGUNSA: nothing has been saved')
      ELSE
          CALL PGSCF(CF(LEV))
          CALL PGSCH(CH(LEV))
          CALL PGSCI(CI(LEV))
          CALL PGSFS(FS(LEV))
          CALL PGSLS(LS(LEV))
          CALL PGSLW(LW(LEV))
C          CALL PGSVP(VP(1,LEV), VP(2,LEV), VP(3,LEV), VP(4,LEV))
C          CALL PGSWIN(WIN(1,LEV), WIN(2,LEV), WIN(3,LEV), WIN(4,LEV))
          CALL PGMOVE(POS(1,LEV), POS(2,LEV))
          CALL PGSAH(AHFS(LEV), AHANG(LEV), AHBARB(LEV))
          CALL PGSTBG(TBG(LEV))
          CALL PGSHS(HSA(LEV), HSS(LEV), HSP(LEV))
          CALL PGSCLP(CLP(LEV))
          LEV = LEV-1
      END IF
      RETURN     
      END

C*GRUSER -- get user name (Alliant-UNIX)
C+
      SUBROUTINE GRUSER(STRING, L)
      CHARACTER*(*) STRING
      INTEGER L
C
C Return the name of the user running the program.
C
C Arguments:
C  STRING : receives user name, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in VALUE, excluding
C           trailing blanks.
C--
C 19-Jan-1988
C 23-Oct-1989 ALF. Change to Alliant use of GETLOG.
C-----------------------------------------------------------------------
      INTEGER I
      CHARACTER*31 GETLOG
C
      STRING = GETLOG()
      IF (STRING.EQ.' ') THEN
          L = 0
      ELSE
          DO 10 I=LEN(STRING),1,-1
              L = I
              IF (STRING(I:I).NE.' ') GOTO 20
   10     CONTINUE
          L = 0
   20     CONTINUE
      END IF
      END

C*GRTTER -- test whether device is user's terminal (MS-DOS)
C+
      SUBROUTINE GRTTER(CDEV, QSAME)
      CHARACTER CDEV*(*)
      LOGICAL   QSAME
C
C Return a logical flag indicating whether the supplied device
C name is a name for the user's controlling terminal or not.
C (Some PGPLOT programs wish to take special action if they are
C plotting on the user's terminal.)
C
C Arguments:
C  CDEV : (input) the device name to be tested.
C  QSAME   : (output) .TRUE. is CDEV contains a valid name for the
C           user's terminal; .FALSE. otherwise.
C--
C 18-Feb-1988
C-----------------------------------------------------------------------
      CHARACTER CTERM*64
      INTEGER   LTERM
C
      CALL GRTRML(CTERM, LTERM)
      QSAME = (CDEV.EQ.CTERM(:LTERM))
      END

C Fortran callable memory allocator (OpenVMS)
C
C Called as :
C	ier = grgmem (size,pointer)
C
C where : size is an integer size of memory to allocate
C	  pointer is an integer to return the pointer into

      INTEGER FUNCTION GRGMEM(SIZE, POINTER)
      INTEGER SIZE, POINTER
      INTEGER LIB$GET_VM
      GRGMEM = LIB$GET_VM(SIZE, POINTER)
      END

C Fortran callable memory deallocator
C
C Called as :
C	ier = grfmem (size,pointer)
C
C where : size is an integer size of memory to deallocate (not used)
C	  pointer is an integer that contains the pointer

      INTEGER FUNCTION GRFMEM(SIZE, POINTER)
      INTEGER SIZE, POINTER
      INTEGER LIB$FREE_VM
      GRFMEM = LIB$FREE_VM(SIZE, POINTER)
      END

C*GRCTOI -- convert character string to integer
C+
      INTEGER FUNCTION GRCTOI (S, I)
      CHARACTER*(*) S
      INTEGER I
C
C GRCTOI: attempt to read an integer from a character string, and return
C the result. No attempt is made to avoid integer overflow. A valid 
C integer is any sequence of decimal digits.
C
C Returns:
C  GRCTOI           : the value of the integer; if the first character
C                    read is not a decimal digit, the value returned
C                    is zero.
C Arguments:
C  S      (input)  : character string to be parsed.
C  I      (in/out) : on input, I is the index of the first character
C                    in S to be examined; on output, either it points
C                    to the next character after a valid integer, or
C                    it is equal to LEN(S)+1.
C
C--
C  1985 Oct  8 - New routine, based on CTOI (T. J. Pearson).
C  1997 Jun  3 - allow leading + or - sign (TJP).
C-----------------------------------------------------------------------
      INTEGER K, SIGN, X
      CHARACTER*1 DIGITS(0:9)
      DATA  DIGITS/'0','1','2','3','4','5','6','7','8','9'/
C
      X = 0
      SIGN = +1
      IF (I.GT.LEN(S)) GOTO 30
      IF (S(I:I).EQ.'+') THEN
         I = I+1
      ELSE IF (S(I:I).EQ.'-') THEN
         I = I+1
         SIGN = -1
      END IF
 10   IF (I.GT.LEN(S)) GOTO 30
      DO 20 K=0,9
         IF (S(I:I).EQ.DIGITS(K)) THEN
            X = X*10 + K
            I = I+1
            GOTO 10
         END IF
 20   CONTINUE
 30   GRCTOI = X*SIGN
      RETURN
      END

C*PGNUMB -- convert a number into a plottable character string
C%void cpgnumb(int mm, int pp, int form, char *string, \
C% int *string_length);
C+
      SUBROUTINE PGNUMB (MM, PP, FORM, STRING, NC)
      INTEGER MM, PP, FORM
      CHARACTER*(*) STRING
      INTEGER NC
C
C This routine converts a number into a decimal character
C representation. To avoid problems of floating-point roundoff, the
C number must be provided as an integer (MM) multiplied by a power of 10
C (10**PP).  The output string retains only significant digits of MM,
C and will be in either integer format (123), decimal format (0.0123),
C or exponential format (1.23x10**5). Standard escape sequences \u, \d 
C raise the exponent and \x is used for the multiplication sign.
C This routine is used by PGBOX to create numeric labels for a plot.
C
C Formatting rules:
C   (a) Decimal notation (FORM=1):
C       - Trailing zeros to the right of the decimal sign are
C         omitted
C       - The decimal sign is omitted if there are no digits
C         to the right of it
C       - When the decimal sign is placed before the first digit
C         of the number, a zero is placed before the decimal sign
C       - The decimal sign is a period (.)
C       - No spaces are placed between digits (ie digits are not
C         grouped in threes as they should be)
C       - A leading minus (-) is added if the number is negative
C   (b) Exponential notation (FORM=2):
C       - The exponent is adjusted to put just one (non-zero)
C         digit before the decimal sign
C       - The mantissa is formatted as in (a), unless its value is
C         1 in which case it and the multiplication sign are omitted
C       - If the power of 10 is not zero and the mantissa is not
C         zero, an exponent of the form \x10\u[-]nnn is appended,
C         where \x is a multiplication sign (cross), \u is an escape
C         sequence to raise the exponent, and as many digits nnn
C         are used as needed
C   (c) Automatic choice (FORM=0):
C         Decimal notation is used if the absolute value of the
C         number is less than 10000 or greater than or equal to
C         0.01. Otherwise exponential notation is used.
C
C Arguments:
C  MM     (input)
C  PP     (input)  : the value to be formatted is MM*10**PP.
C  FORM   (input)  : controls how the number is formatted:
C                    FORM = 0 -- use either decimal or exponential
C                    FORM = 1 -- use decimal notation
C                    FORM = 2 -- use exponential notation
C  STRING (output) : the formatted character string, left justified.
C                    If the length of STRING is insufficient, a single
C                    asterisk is returned, and NC=1.
C  NC     (output) : the number of characters used in STRING:
C                    the string to be printed is STRING(1:NC).
C--
C 23-Nov-1983
C  9-Feb-1988 [TJP] - Use temporary variable to avoid illegal character
C                     assignments; remove non-standard DO loops.
C 15-Dec-1988 [TJP] - More corrections of the same sort.
C 27-Nov-1991 [TJP] - Change code for multiplication sign.
C 23-Jun-1994 [TJP] - Partial implementation of FORM=1 and 2.
C-----------------------------------------------------------------------
      CHARACTER*1 BSLASH
      CHARACTER*2 TIMES, UP, DOWN
      CHARACTER*20 WORK, WEXP, TEMP
      INTEGER M, P, ND, I, J, K, NBP
      LOGICAL MINUS
C
C Define backslash (escape) character and escape sequences.
C
      BSLASH = CHAR(92)
      TIMES  = BSLASH//'x'
      UP     = BSLASH//'u'
      DOWN   = BSLASH//'d'
C
C Zero is always printed as "0".
C
      IF (MM.EQ.0) THEN
          STRING = '0'
          NC = 1
          RETURN
      END IF
C
C If negative, make a note of that fact.
C
      MINUS = MM.LT.0
      M = ABS(MM)
      P = PP
C
C Convert M to a left-justified digit string in WORK. As M is a
C positive integer, it cannot use more than 10 digits (2147483647).
C
      J = 10
   10 IF (M.NE.0) THEN
          K = MOD(M,10)
          M = M/10
          WORK(J:J) = CHAR(ICHAR('0')+K)
          J = J-1
       GOTO 10
      END IF
      TEMP = WORK(J+1:)
      WORK = TEMP
      ND = 10-J
C
C Remove right-hand zeros, and increment P for each one removed.
C ND is the final number of significant digits in WORK, and P the
C power of 10 to be applied. Number of digits before decimal point
C is NBP.
C
   20 IF (WORK(ND:ND).EQ.'0') THEN
          ND = ND-1
          P = P+1
       GOTO 20
      END IF
      NBP = ND+MIN(P,0)
C
C Integral numbers of 4 or less digits are formatted as such.
C
      IF ((P.GE.0) .AND. ((FORM.EQ.0 .AND. P+ND.LE.4) .OR.
     :                    (FORM.EQ.1 .AND. P+ND.LE.10))) THEN
          DO 30 I=1,P
              ND = ND+1
              WORK(ND:ND) = '0'
   30     CONTINUE
          P = 0
C
C If NBP is 4 or less, simply insert a decimal point in the right place.
C
      ELSE IF (FORM.NE.2.AND.NBP.GE.1.AND.NBP.LE.4.AND.NBP.LT.ND) THEN
          TEMP = WORK(NBP+1:ND)
          WORK(NBP+2:ND+1) = TEMP
          WORK(NBP+1:NBP+1) = '.'
          ND = ND+1
          P = 0
C
C Otherwise insert a decimal point after the first digit, and adjust P.
C
      ELSE
          P = P + ND - 1
          IF (FORM.NE.2 .AND. P.EQ.-1) THEN
              TEMP = WORK
              WORK = '0'//TEMP
              ND = ND+1
              P = 0
          ELSE IF (FORM.NE.2 .AND. P.EQ.-2) THEN
              TEMP = WORK
              WORK = '00'//TEMP
              ND = ND+2
              P = 0
          END IF
          IF (ND.GT.1) THEN
              TEMP = WORK(2:ND)
              WORK(3:ND+1) = TEMP
              WORK(2:2) = '.'
              ND = ND + 1
          END IF
      END IF
C
C Add exponent if necessary.
C
      IF (P.NE.0) THEN
          WORK(ND+1:ND+6) = TIMES//'10'//UP
          ND = ND+6
          IF (P.LT.0) THEN
              P = -P
              ND = ND+1
              WORK(ND:ND) = '-'
          END IF
          J = 10
   40     IF (P.NE.0) THEN
              K = MOD(P,10)
              P = P/10
              WEXP(J:J) = CHAR(ICHAR('0')+K)
              J = J-1
           GOTO 40
          END IF
          WORK(ND+1:) = WEXP(J+1:10)
          ND = ND+10-J
          IF (WORK(1:3).EQ.'1'//TIMES) THEN
              TEMP = WORK(4:)
              WORK = TEMP
              ND = ND-3
          END IF
          WORK(ND+1:ND+2) = DOWN
          ND = ND+2
      END IF
C
C Add minus sign if necessary and move result to output.
C
      IF (MINUS) THEN
         TEMP = WORK(1:ND)
         STRING = '-'//TEMP
         NC = ND+1
      ELSE
         STRING = WORK(1:ND)
         NC = ND
      END IF
C
C Check result fits.
C
      IF (NC.GT.LEN(STRING)) THEN
          STRING = '*'
          NC = 1
      END IF
      END

C*GRSCI -- set color index
C+
      SUBROUTINE GRSCI (IC)
C
C GRPCKG: Set the color index for subsequent plotting. Calls to GRSCI
C are ignored for monochrome devices. The default color index is 1,
C usually white on a black background for video displays or black on a
C white background for printer plots. The color index is an integer in
C the range 0 to a device-dependent maximum. Color index 0 corresponds
C to the background color; lines may be "erased" by overwriting them
C with color index 0.
C
C Color indices 0-7 are predefined as follows: 0 = black (background
C color), 1 = white (default), 2 = red, 3 = green, 4 = blue, 5 = cyan
C (blue + green), 6 = magenta (red + blue), 7 = yellow (red + green).
C The assignment of colors to color indices can be changed with
C subroutine GRSCR (set color representation).
C
C Argument:
C
C IC (integer, input): the color index to be used for subsequent
C       plotting on the current device (in range 0-255). If the
C       index exceeds the device-dependent maximum, the result is
C       device-dependent.
C--
C 11-Apr-1983 - [TJP].
C  3-Jun-1984 - add GMFILE device [TJP].
C 13-Jun-1984 - add code for TK4100 devices [TJP].
C  2-Jul-1984 - add code for RETRO and VT125 (REGIS) devices [TJP].
C  2-Oct-1984 - change REGIS to improve VT240 behavior [TJP].
C 22-Dec-1984 - add PRTX, TRILOG, VERS and VV devices [TJP].
C 29-Jan-1985 - add HP2648 device [KS/TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 21-Feb-1987 - delays setting color if picture not open [AFT].
C 11-Jun-1987 - remove built-in devices [TJP].
C 31-May-1989 - add check for valid color index [TJP].
C  1-Sep-1994 - use common data [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  IC, COLOR, IC1, IC2, NBUF,LCHR
      REAL     RBUF(6)
      CHARACTER*1 CHR
C
C Error if no workstation is open.
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRSCI - no graphics device is active.')
          RETURN
      END IF
C
C Use color index 1 if out of range.
C
      IC1 = GRMNCI(GRCIDE)
      IC2 = GRMXCI(GRCIDE)
      COLOR = IC
      IF (COLOR.LT.IC1 .OR. COLOR.GT.IC2) COLOR = 1
C
C If no change to color index is requested, take no action.
C
      IF (COLOR.EQ.GRCCOL(GRCIDE)) RETURN
C
C If the workstation is in "picture open" state, send command to
C driver.
C
      IF (GRPLTD(GRCIDE)) THEN
          RBUF(1) = COLOR
          CALL GREXEC(GRGTYP,15,RBUF,NBUF,CHR,LCHR)
      END IF
C
C Set the current color index.
C
      GRCCOL(GRCIDE)=COLOR
C
      END

C*GRFLUN -- free a Fortran logical unit number (VMS)
C+
      SUBROUTINE GRFLUN(LUN)
      INTEGER LUN
C
C Free a Fortran logical unit number allocated by GRGLUN. 
C
C Arguments:
C  LUN    : the logical unit number to free.
C--
C 25-Nov-1988
C-----------------------------------------------------------------------
      INTEGER LIB$FREE_LUN, JUNK
C
      JUNK = LIB$FREE_LUN(LUN)
      RETURN
      END

      PROGRAM PACK
C-----------------------------------------------------------------------
C Convert unpacked (ASCII) representation of GRFONT into packed
C (binary) representation used by PGPLOT.
C
C This version ignores characters in the input file with Hershey
C numbers 1000-1999 ("indexical" fonts) and 3000-3999 ("triplex"
C and "gothic" fonts).
C
C The binary file contains one record, and is a direct copy of the
C internal data structure used in PGPLOT. The format of the internal
C data structure (and the binary file) are private to PGPLOT: i.e.,
C they may be changed in a future release.
C
C NC1	Integer*4	Smallest Hershey number defined in file (1)
C NC2	Integer*4	Largest Hershey number defined in file (3000)
C NC3	Integer*4	Number of words of buffer space used
C INDEX Integer*4 array (dimension 3000)
C			Element NC of INDEX contains either 0 if
C			NC is not a defined Hershey character, or the
C			index in array BUFFER at which the digitization
C                       of character number NC begins
C BUFFER Integer*2 array (dimension 27000)
C			Coordinate pairs defining each character are
C			packed two to a word in this array.
C
C Note: the array sizes are fixed by dimension statements in PGPLOT.
C New characters cannot be added if they would increase the size of
C the arrays.  Array INDEX is not very efficiently used as only about
C 1000 of the possible 3000 characters are defined.
C-----------------------------------------------------------------------
      INTEGER MAXCHR, MAXBUF
      PARAMETER (MAXCHR=3000)
      PARAMETER (MAXBUF=27000)
C
      INTEGER   INDEX(MAXCHR)
      INTEGER*2 BUFFER(MAXBUF)
      INTEGER   I, LENGTH, LOC, NC, NC1, NC2, NCHAR, XYGRID(400)
C-----------------------------------------------------------------------
 1000 FORMAT (7(2X,2I4))
 2000 FORMAT (' Characters defined: ', I5/
     1        ' Array cells used:   ', I5)
 3000 FORMAT (' ++ERROR++ Buffer is too small: ',I7)
C-----------------------------------------------------------------------
C
C Initialize index.
C
      DO 1 I=1,MAXCHR
          INDEX(I) = 0
    1 CONTINUE
      LOC = 0
      NCHAR = 0
C
C Open stdin.
C
C Read input file.
C
   10 CONTINUE
C         -- read next character
          READ (*,1000,END=20) NC,LENGTH,(XYGRID(I),I=1,5)
          READ (*,1000) (XYGRID(I),I=6,LENGTH)
C         -- skip if Hershey number is outside required range
          IF (NC.LT.1 .OR. (NC.GT.999.AND.NC.LT.2000) .OR.
     1        NC.GT.2999) GOTO 10
C         -- store in index and buffer
          NCHAR = NCHAR+1
          LOC = LOC+1
          IF (LOC.GT.MAXBUF) GOTO 500
          INDEX(NC) = LOC
          BUFFER(LOC) = XYGRID(1)
          DO 15 I=2,LENGTH,2
              LOC = LOC + 1
              IF (LOC.GT.MAXBUF) GOTO 500
              BUFFER(LOC) = 128*(XYGRID(I)+64) + XYGRID(I+1) + 64
   15     CONTINUE
      GOTO 10
   20 CONTINUE
C
C Write output file.
C
      OPEN (UNIT=2, STATUS='NEW', FORM='UNFORMATTED', FILE='grfont.dat')
      NC1 = 1
      NC2 = 3000
      WRITE (2) NC1,NC2,LOC,INDEX,BUFFER
      CLOSE (UNIT=2)
C
C Write summary.
C
      WRITE (6,2000) NCHAR, LOC
      STOP
C
C Error exit.
C
  500 WRITE (6,3000) MAXBUF
C-----------------------------------------------------------------------
      END

C*PGRECT -- draw a rectangle, using fill-area attributes
C%void cpgrect(float x1, float x2, float y1, float y2);
C+
      SUBROUTINE PGRECT (X1, X2, Y1, Y2)
      REAL X1, X2, Y1, Y2
C
C This routine can be used instead of PGPOLY for the special case of
C drawing a rectangle aligned with the coordinate axes; only two
C vertices need be specified instead of four.  On most devices, it is
C faster to use PGRECT than PGPOLY for drawing rectangles.  The
C rectangle has vertices at (X1,Y1), (X1,Y2), (X2,Y2), and (X2,Y1).
C
C Arguments:
C  X1, X2 (input) : the horizontal range of the rectangle.
C  Y1, Y2 (input) : the vertical range of the rectangle.
C--
C 21-Nov-1986 - [TJP].
C 22-Mar-1988 - use GRRECT for fill [TJP].
C  6-Mar-1995 - add hatching (by calling PGHTCH) [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      REAL XP(4), YP(4)
C
      CALL PGBBUF
C
C Outline only.
C
      IF (PGFAS(PGID).EQ.2) THEN
         CALL GRMOVA(X1,Y1)
         CALL GRLINA(X1,Y2)
         CALL GRLINA(X2,Y2)
         CALL GRLINA(X2,Y1)
         CALL GRLINA(X1,Y1)
C
C Hatching.
C
      ELSE IF (PGFAS(PGID).EQ.3 .OR. PGFAS(PGID).EQ.4) THEN
         XP(1) = X1
         XP(2) = X1
         XP(3) = X2
         XP(4) = X2
         YP(1) = Y1
         YP(2) = Y2
         YP(3) = Y2
         YP(4) = Y1
         CALL PGHTCH(4, XP, YP, 0.0)
         IF (PGFAS(PGID).EQ.4) CALL PGHTCH(4, XP, YP, 90.0)
C
C Solid fill.
C
      ELSE
          CALL GRRECT(X1,Y1,X2,Y2)
          CALL GRMOVA(X1,Y1)
      END IF
      CALL PGEBUF
      END

C*PGCONL -- label contour map of a 2D data array 
C%void cpgconl(const float *a, int idim, int jdim, int i1, int i2, \
C% int j1, int j2, float c, const float *tr, const char *label, \
C% int intval, int minint);
C+
      SUBROUTINE PGCONL (A, IDIM, JDIM, I1, I2, J1, J2, C, TR,
     1                   LABEL, INTVAL, MININT)
      INTEGER IDIM, JDIM, I1, J1, I2, J2, INTVAL, MININT
      REAL A(IDIM,JDIM), C, TR(6)
      CHARACTER*(*) LABEL
C
C Label a contour map drawn with routine PGCONT. Routine PGCONT should
C be called first to draw the contour lines, then this routine should be
C called to add the labels. Labels are written at intervals along the
C contour lines, centered on the contour lines with lettering aligned
C in the up-hill direction. Labels are opaque, so a part of the under-
C lying contour line is obscured by the label. Labels use the current
C attributes (character height, line width, color index, character
C font).
C
C The first 9 arguments are the same as those supplied to PGCONT, and
C should normally be identical to those used with PGCONT. Note that
C only one contour level can be specified; tolabel more contours, call
C PGCONL for each level.
C
C The Label is supplied as a character string in argument LABEL.
C
C The spacing of labels along the contour is specified by parameters
C INTVAL and MININT. The routine follows the contour through the
C array, counting the number of cells that the contour crosses. The
C first label will be written in the MININT'th cell, and additional
C labels will be written every INTVAL cells thereafter. A contour
C that crosses less than MININT cells will not be labelled. Some
C experimentation may be needed to get satisfactory results; a good
C place to start is INTVAL=20, MININT=10.
C
C Arguments:
C  A      (input) : data array.
C  IDIM   (input) : first dimension of A.
C  JDIM   (input) : second dimension of A.
C  I1, I2 (input) : range of first index to be contoured (inclusive).
C  J1, J2 (input) : range of second index to be contoured (inclusive).
C  C      (input) : the level of the contour to be labelled (one of the
C                   values given to PGCONT).
C  TR     (input) : array defining a transformation between the I,J
C                   grid of the array and the world coordinates.
C                   The world coordinates of the array point A(I,J)
C                   are given by:
C                     X = TR(1) + TR(2)*I + TR(3)*J
C                     Y = TR(4) + TR(5)*I + TR(6)*J
C                   Usually TR(3) and TR(5) are zero - unless the
C                   coordinate transformation involves a rotation or
C                   shear.
C  LABEL  (input) : character strings to be used to label the specified
C                   contour. Leading and trailing blank spaces are
C                   ignored.
C  INTVAL (input) : spacing along the contour between labels, in
C                   grid cells.
C  MININT (input) : contours that cross less than MININT cells
C                   will not be labelled.
C--
C  5-May-1994 - New routine; this routine is virtually identical to
C               PGCONT, but calls PGCONX with a different external
C               routine [TJP].
C  4-Feb-1997 - PGCONX requires an array argument, not scalar [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      INTEGER  I
      LOGICAL  PGNOTO
      REAL     CL(1)
      EXTERNAL PGCL
C
      IF (PGNOTO('PGCONL')) RETURN
C
C Save TRANS matrix and other parameters.
C
      DO 10 I=1,6
          TRANS(I) = TR(I)
   10 CONTINUE
      PGCINT = INTVAL
      PGCMIN = MININT
      PGCLAB = LABEL
C
C Use PGCONX with external function PGCL.
C
      CL(1) = C
      CALL PGCONX (A, IDIM, JDIM, I1, I2, J1, J2, CL, 1, PGCL)
C
      END

C*PGDRIV -- PGPLOT metafile driver
C+
      SUBROUTINE PGDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for PGPLOT metafile (private format).
C
C-----------------------------------------------------------------------
      INTEGER DWD, DHT, DRES
      CHARACTER*(*) TYPE, DEFNAM
      PARAMETER (TYPE= 'PGMF   (PGPLOT metafile)')
      PARAMETER (DEFNAM='pgplot.pgmf')
      PARAMETER (DWD=6400, DHT=4800, DRES=1000)
C
      INTEGER WIDTH, HEIGHT
      SAVE    WIDTH, HEIGHT
      INTEGER NSYM, MFAC
      INTEGER  IER, I0, J0, I1, J1, L, LL, LASTI, LASTJ, UNIT, I
      SAVE                                 LASTI, LASTJ, UNIT
      INTEGER  CI, LW, LS, NPTS, NPAGE, IOERR, LFNAME
      SAVE         LW, LS, NPTS, NPAGE, IOERR, LFNAME
      INTEGER  STATE, INPIC
      SAVE     STATE, INPIC
      INTEGER  GROPTX, GRCTOI
      LOGICAL  STDOUT
      SAVE     STDOUT
      INTEGER  RVALUE(0:255), GVALUE(0:255), BVALUE(0:255)
      SAVE     RVALUE,        GVALUE,        BVALUE
      INTEGER  OP(0:255)
      SAVE     OP
      CHARACTER*120 INSTR, MSG
      CHARACTER*255 FNAME
      SAVE          FNAME
      REAL          RINIT(0:15), GINIT(0:15), BINIT(0:15)
      SAVE          RINIT,       GINIT,       BINIT
      DATA RINIT 
     1     / 1.00, 0.00, 1.00, 0.00, 0.00, 0.00, 1.00, 1.00,
     2       1.00, 0.50, 0.00, 0.00, 0.50, 1.00, 0.33, 0.67/
      DATA GINIT
     1     / 1.00, 0.00, 0.00, 1.00, 0.00, 1.00, 0.00, 1.00,
     2       0.50, 1.00, 1.00, 0.50, 0.00, 0.00, 0.33, 0.67/
      DATA BINIT
     1     / 1.00, 0.00, 0.00, 0.00, 1.00, 1.00, 1.00, 0.00,
     2       0.00, 0.00, 0.50, 1.00, 1.00, 0.50, 0.33, 0.67/
      DATA STATE/0/
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,900,180,900,200,
     2     210,220,230,240,900,260,900,280,290), IFUNC
      GOTO 900
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = -1
      RBUF(3) = 0
      RBUF(4) = -1
      RBUF(5) = 0
      RBUF(6) = 255
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
   30 RBUF(1) = REAL(DRES)
      RBUF(2) = REAL(DRES)
      RBUF(3) = 5
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C
   40 CONTINUE
      CHR = 'HNNATRQNYM'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 RBUF(1) = 0
      RBUF(3) = 0
      RBUF(2) = WIDTH
      RBUF(4) = HEIGHT
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 8
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
C     -- check for concurrent access
      IF (STATE.EQ.1) THEN
         CALL GRWARN('a PGPLOT metafile is already open')
         RBUF(1) = 0
         RBUF(2) = 0
         RETURN
      END IF
      DO 91 CI=0,15
         RVALUE(CI) = NINT(255*RINIT(CI))
         GVALUE(CI) = NINT(255*GINIT(CI))
         BVALUE(CI) = NINT(255*BINIT(CI))
 91   CONTINUE
      DO 93 CI=16,255
         RVALUE(CI) = 0
         GVALUE(CI) = 0
         BVALUE(CI) = 0
 93   CONTINUE
C     -- Device dimensions
      WIDTH = DWD
      HEIGHT = DHT
      CALL GRGENV('PGMF_WIDTH', INSTR, L)
      LL = 1
      IF (L.GT.0) WIDTH = GRCTOI(INSTR(:L),LL)
      CALL GRGENV('PGMF_HEIGHT', INSTR, L)
      LL = 1
      IF (L.GT.0) HEIGHT = GRCTOI(INSTR(:L),LL)
      STDOUT =CHR(1:LCHR).EQ.'-'
      IF (STDOUT) THEN
         UNIT = 6
C        -- machine-dependent!
      ELSE
         CALL GRGLUN(UNIT)
      END IF
      NBUF = 2
      RBUF(1) = UNIT
      IF (.NOT.STDOUT) THEN
         IER = GROPTX(UNIT, CHR(1:LCHR), DEFNAM, 1)
         IF (IER.NE.0) THEN
            MSG = 'Cannot open output file for PGPLOT metafile: '//
     1           CHR(:LCHR)
            CALL GRWARN(MSG)
            RBUF(2) = 0
            CALL GRFLUN(UNIT)
            RETURN
         ELSE
            INQUIRE (UNIT=UNIT, NAME=CHR)
            LCHR = LEN(CHR)
 94         IF (CHR(LCHR:LCHR).EQ.' ') THEN
               LCHR = LCHR-1
               GOTO 94
            END IF
            RBUF(2) = 1
            FNAME = CHR(:LCHR)
            LFNAME = LCHR
         END IF
      ELSE
         RBUF(2) = 1
         FNAME = '-'
         LFNAME= 1
      END IF
      STATE = 1
      IOERR = 0
      LASTI = -1
      LASTJ = -1
      LW = 1
      LS = 1
      NPTS = 0
      INPIC = 0
      NPAGE = 0
      CALL GRPG02(IOERR, UNIT, '%PGMF (PGPLOT metafile)')
      CALL GRUSER(INSTR, L)
      IF (L.GT.0) CALL GRPG02(IOERR, UNIT, '% Creator: '//INSTR(1:L))
      CALL GRDATE(INSTR, L)
      IF (L.GT.0) CALL GRPG02(IOERR, UNIT, '% Date: '//INSTR(1:L))
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
      IF (.NOT.STDOUT) THEN
         CLOSE (UNIT, IOSTAT=IOERR)
         IF (IOERR.NE.0) THEN
           CALL GRWARN('Error closing PGPLOT metafile '//FNAME(:LFNAME))
         END IF
         CALL GRFLUN(UNIT)
      END IF
      STATE = 0
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
 110  CONTINUE
      WIDTH = RBUF(1)
      HEIGHT = RBUF(2)
      NPAGE = NPAGE+1
      INPIC = 1
      CALL GRFAO('B# # # #', L, INSTR, NPAGE, WIDTH, HEIGHT, DRES)
      CALL GRPG02(IOERR, UNIT, INSTR(:L))
      DO 111 I=0,255
         OP(I) = 0
 111  CONTINUE
      CALL GRFAO('C# # # #', L, INSTR, 0, RVALUE(0), GVALUE(0),
     :        BVALUE(0))
      CALL GRPG02(IOERR, UNIT, INSTR(1:L))
      OP(0) = 1
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
      IF (I0.EQ.LASTI .AND. J0.EQ.LASTJ) THEN
C        -- suppress zero-length continuation segment
         IF (I0.EQ.I1 .AND. J0.EQ.J1) RETURN
         CALL GRFAO('L# #', L, INSTR, (I1-I0), (J1-J0), 0, 0)
         CALL GRPG02(IOERR, UNIT, INSTR(:L))
      ELSE
         CALL GRFAO('M# #', L, INSTR, I0, J0, 0, 0)
         CALL GRPG02(IOERR, UNIT, INSTR(:L))
         CALL GRFAO('L# #', L, INSTR, (I1-I0), (J1-J0), 0, 0)
         CALL GRPG02(IOERR, UNIT, INSTR(:L))
      END IF
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      I1 = NINT(RBUF(1))
      J1 = NINT(RBUF(2))
      CALL GRFAO('D# #', L, INSTR, I1, J1, 0, 0)
      CALL GRPG02(IOERR, UNIT, INSTR(:L))
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
      CALL GRPG02(IOERR, UNIT, 'E')
      INPIC = 0
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C
  150 CONTINUE
      CI = NINT(RBUF(1))
      IF (INPIC.EQ.1) THEN
         IF (OP(CI).EQ.0) THEN
            CALL GRFAO('C# # # #', L, INSTR, CI, RVALUE(CI),
     :           GVALUE(CI), BVALUE(CI))
            CALL GRPG02(IOERR, UNIT, INSTR(1:L))
            OP(CI) = 1
         END IF
         CALL GRFAO('I#', L, INSTR, CI, 0, 0, 0)
         CALL GRPG02(IOERR, UNIT, INSTR(:L))
         LASTI = -1
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Null operation: there is no alpha screen.)
C
 180  CONTINUE
      RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
 200  CONTINUE
      IF (NPTS.EQ.0) THEN
          NPTS = RBUF(1)
          CALL GRFAO('Y#', L, INSTR, NPTS, 0, 0, 0)
      ELSE
          NPTS = NPTS-1
          I0 = NINT(RBUF(1))
          J0 = NINT(RBUF(2))
          CALL GRFAO('X# #', L, INSTR, I0, J0, 0, 0)
      END IF
      CALL GRPG02(IOERR, UNIT, INSTR(1:L))
      LASTI = -1
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      CI = RBUF(1)
      RVALUE(CI) = NINT(255*RBUF(2))
      GVALUE(CI) = NINT(255*RBUF(3))
      BVALUE(CI) = NINT(255*RBUF(4))
      OP(CI) = 0
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Convert requested line width, unit 1/200 inch, to device units)
C
  220 CONTINUE
      LW = NINT(DRES*RBUF(1)/200.0)
      CALL GRFAO('W#', L, INSTR, LW, 0, 0, 0)
      CALL GRPG02(IOERR, UNIT, INSTR(1:L))
      LASTI = -1
      RETURN
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
      CALL GRPG02(IOERR, UNIT, CHR(:LCHR))
      LASTI = -1
      RETURN
C
C--- IFUNC=24, Rectangle fill. -----------------------------------------
C
  240 CONTINUE
      CALL GRFAO('R# # # #', L, INSTR, NINT(RBUF(1)), NINT(RBUF(2)),
     :           NINT(RBUF(3)), NINT(RBUF(4)))
      CALL GRPG02(IOERR, UNIT, INSTR(1:L))
      LASTI = -1
      RETURN
C
C--- IFUNC=26, Image.---------------------------------------------------
C
  260 CONTINUE
C     Not yet implemented
      RETURN
C
C--- IFUNC=28, Marker.--------------------------------------------------
C
  280 CONTINUE
      NSYM = NINT(RBUF(1))
      I1 = NINT(RBUF(2))
      J1 = NINT(RBUF(3))
      MFAC = NINT(1000.0*RBUF(4))
      CALL GRFAO('S# # # #', L, INSTR, NSYM, I1, J1, MFAC)
      CALL GRPG02(IOERR, UNIT, INSTR(1:L))
      LASTI = -1
      RETURN
C
C--- IFUNC=29, Query color representation.------------------------------
C
 290  CONTINUE
      CI = NINT(RBUF(1))
      NBUF = 4
      RBUF(2) = RVALUE(CI)/255.0
      RBUF(3) = GVALUE(CI)/255.0
      RBUF(4) = BVALUE(CI)/255.0
      RETURN
C
C-----------------------------------------------------------------------
C Error: unimplemented function.
C
  900 WRITE (MSG,
     1  '(''Unimplemented function in PG device driver: '',I10)') IFUNC
      CALL GRWARN(MSG)
      NBUF = -1
      RETURN
C-----------------------------------------------------------------------
      END

C*GRPG02 -- PGPLOT metafile driver, copy buffer to file
C+
      SUBROUTINE GRPG02 (IER, UNIT, S)
C
C Support routine for PGdriver: write character string S on
C specified Fortran unit.
C
C Error handling: if IER is not 0 on input, the routine returns
C immediately. Otherwise IER receives the I/O status from the Fortran
C write (0 => success).
C-----------------------------------------------------------------------
      INTEGER IER, UNIT
      CHARACTER*(*) S
C
      IF (IER.EQ.0) THEN
          WRITE (UNIT, '(A)', IOSTAT=IER) S
          IF (IER.NE.0) CALL 
     1        GRWARN('++WARNING++ Error writing PGPLOT metafile')
      END IF
C-----------------------------------------------------------------------
      END

      PROGRAM PGDE12
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT: use of PGPAP to change the
C size of the view surface.
C
C
C Note that PGPAP must be called either immediately after PGOPEN or
C immediately before PGPAGE, and it affects all subsequent pages until
C the next call to PGPAP. (In the following code, PGENV calls PGPAGE.)
C-----------------------------------------------------------------------
      INTEGER PGOPEN

      WRITE (*,*) 'Demonstration of routine PGPAP to change the size of'
      WRITE (*,*) 'the view surface'
      WRITE (*,*)

      IF (PGOPEN('?') .LE. 0) STOP

      WRITE (*,*) 'First page: size is 7 x 3.5 inch'

      CALL PGPAP(7.0,0.5)
      CALL PGENV(0.0,1.0,0.0,2.0,0,0)
      CALL PGLAB('x','y','1')

      WRITE (*,*) 'Second page: size to 6 x 6 inch'

      CALL PGPAP(6.0,1.0)
      CALL PGENV(0.0,1.0,0.0,2.0,0,0)
      CALL PGLAB('x','y','2')

      WRITE (*,*) 'Third page: same size as second'

      CALL PGENV(0.0,1.0,0.0,2.0,0,0)
      CALL PGLAB('x','y','3')

      CALL PGCLOS
      END

C*PGDRAW -- draw a line from the current pen position to a point
C%void cpgdraw(float x, float y);
C+
      SUBROUTINE PGDRAW (X, Y)
      REAL X, Y
C
C Draw a line from the current pen position to the point
C with world-coordinates (X,Y). The line is clipped at the edge of the
C current window. The new pen position is (X,Y) in world coordinates.
C
C Arguments:
C  X      (input)  : world x-coordinate of the end point of the line.
C  Y      (input)  : world y-coordinate of the end point of the line.
C--
C 27-Nov-1986
C-----------------------------------------------------------------------
      CALL PGBBUF
      CALL GRLINA(X,Y)
      CALL PGEBUF
      END

C*GRQUIT -- report a fatal error and abort execution (MS-DOS)
C+
      SUBROUTINE GRQUIT (CTEXT)
      CHARACTER CTEXT*(*)
C
C Report a fatal error (via GRWARN) and exit with fatal status; a
C traceback is generated unless the program is linked /NOTRACE.
C
C Argument:
C  CTEXT (input): text of message to be sent to GRWARN.
C--
C 18-Feb-1988
C-----------------------------------------------------------------------
      CALL GRWARN(CTEXT)
      STOP 'Fatal error in PGPLOT library'
      END

C*PGPOINT -- non-standard alias for PGPT
C+
      SUBROUTINE PGPOINT (N, XPTS, YPTS, SYMBOL)
      INTEGER N
      REAL XPTS(*), YPTS(*)
      INTEGER SYMBOL
C
C See description of PGPT.
C--
      CALL PGPT (N, XPTS, YPTS, SYMBOL)
      END

C*GRSLW -- set line width
C+
      SUBROUTINE GRSLW (IW)
      INTEGER IW
C
C GRPCKG: Set the line width for subsequent plotting on the current
C device. If the hardware does not support thick lines, they are
C simulated by tracing each line with multiple strokes offset in the
C direction perpendicular to the line. The line width is specified by
C the number of strokes to be used, which must be in the range 1-201.
C The actual line width obtained depends on the device resolution.
C If the hardware does support thick lines, the width of the line
C is approximately 0.005 inches times the value of argument IW.
C
C Argument:
C
C IW (integer, input): the number of strokes to be used for subsequent
C       plotting on the current device (in range 1-201).
C--
C  1-Feb-1983 [TJP].
C  3-Jun-1984 [TJP] - add GMFILE device.
C 28-Aug-1984 [TJP] - correct bug in GMFILE: redundant SET_LINEWIDTH
C                     commands were not being filtered out.
C 26-May-1987 [TJP] - add GREXEC support.
C 11-Jun-1987 [TJP] - remove built-in devices.
C 31-May-1989 [TJP] - increase maximum width from 21 to 201.
C  1-Sep-1994 [TJP] 
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER I, ITHICK
      REAL    RBUF(1)
      INTEGER NBUF,LCHR
      CHARACTER*32 CHR
C
C Check that graphics is active.
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRSLW - no graphics device is active.')
          RETURN
      END IF
C
C Check that requested line-width is valid.
C
      I = IW
      IF (I.LT.1 .OR. I.GT.201) THEN
          CALL GRWARN('GRSLW - invalid line-width requested.')
          I = 1
      END IF
C
C Ignore the request if the linewidth is unchanged.
C
      IF (I.EQ.ABS(GRWIDT(GRCIDE))) RETURN
C
C Inquire if hardware supports thick lines.
C
      ITHICK = 0
      IF (GRGCAP(GRCIDE)(5:5).EQ.'T') ITHICK = 1
C
C For devices with hardware support of thick lines, send the
C appropriate commands to the device driver, and give the "current
C linewidth" parameter a negative value to suppress software linewidth
C emulation.
C
      IF (ITHICK.EQ.1 .AND. GRPLTD(GRCIDE)) THEN
          RBUF(1) = I
          CALL GREXEC(GRGTYP,22,RBUF,NBUF,CHR,LCHR)
      END IF
C
C Save the current linewidth.
C
      GRWIDT(GRCIDE) = I
      IF (ITHICK.EQ.1) GRWIDT(GRCIDE) = -I
C
      END

C*PGQVSZ -- inquire size of view surface
C%void cpgqvsz(int units, float *x1, float *x2, float *y1, float *y2);
C+
      SUBROUTINE PGQVSZ (UNITS, X1, X2, Y1, Y2)
      INTEGER UNITS
      REAL X1, X2, Y1, Y2
C
C This routine returns the dimensions of the view surface (the maximum
C plottable area) of the currently selected graphics device, in 
C a variety of units. The size of the view surface is device-dependent
C and is established when the graphics device is opened. On some 
C devices, it can be changed by calling PGPAP before starting a new
C page with PGPAGE. On some devices, the size can be changed (e.g.,
C by a workstation window manager) outside PGPLOT, and PGPLOT detects
C the change when PGPAGE is used. Call this routine after PGPAGE to 
C find the current size.
C
C Note 1: the width and the height of the view surface in normalized
C device coordinates are both always equal to 1.0.
C
C Note 2: when the device is divided into panels (see PGSUBP), the
C view surface is a single panel.
C
C Arguments:
C  UNITS  (input)  : 0,1,2,3 for output in normalized device coords, 
C                    inches, mm, or device units (pixels)
C  X1     (output) : always returns 0.0
C  X2     (output) : width of view surface
C  Y1     (output) : always returns 0.0
C  Y2     (output) : height of view surface
C--
C 28-Aug-1992 - new routine [Neil Killeen].
C  2-Dec-1992 - changed to avoid resetting the viewport [TJP].
C 26-Feb-1997 - revised description [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
      REAL SX, SY
C
      IF (PGNOTO('PGQVSZ')) THEN
         X1 = 0.0
         X2 = 0.0
         Y1 = 0.0
         Y2 = 0.0
         RETURN
      END IF
C
      IF (UNITS.EQ.0) THEN
          SX = PGXSZ(PGID)
          SY = PGYSZ(PGID)
      ELSE IF (UNITS.EQ.1) THEN
          SX = PGXPIN(PGID)
          SY = PGYPIN(PGID)
      ELSE IF (UNITS.EQ.2) THEN
          SX = (PGXPIN(PGID)/25.4)
          SY = (PGYPIN(PGID)/25.4)
      ELSE IF (UNITS.EQ.3) THEN
          SX = 1.0
          SY = 1.0
      ELSE
          CALL GRWARN(
     1        'Illegal value for parameter UNITS in routine PGQVSZ')
          SX = PGXSZ(PGID)
          SY = PGYSZ(PGID)
      END IF
      X1 = 0.0
      X2 = PGXSZ(PGID)/SX
      Y1 = 0.0
      Y2 = PGYSZ(PGID)/SY
      END

C*GRFA -- fill area (polygon)
C+
      SUBROUTINE GRFA (N,PX,PY)
      INTEGER N
      REAL PX(*), PY(*)
C
C GRPCKG: FILL AREA: fill a polygon with solid color.  The polygon
C is defined by the (x,y) world coordinates of its N vertices.  If
C this is not a function supported by the device, shading is
C accomplished by drawing horizontal lines spaced by 1 pixel.  By
C selecting color index 0, the interior of the polygon can be erased
C on devices which permit it.  The polygon need not be convex, but if
C it is re-entrant (i.e., edges intersect other than at the vertices),
C it may not be obvious which regions are "inside" the polygon.  The
C following rule is applied: for a given point, create a straight line
C starting at the point and going to infinity. If the number of
C intersections between the straight line and the polygon is odd, the
C point is within the polygon; otherwise it is outside. If the
C straight line passes a polygon vertex tangentially, the
C intersection  count is not affected. The only attribute which applies
C to FILL AREA is color index: line-width and line-style are ignored.
C There is a limitation on the complexity of the polygon: GFA will
C fail if any horizontal line intersects more than 32 edges of the
C polygon.
C
C Arguments:
C
C N (input, integer): the number of vertices of the polygon (at least
C       3).
C PX, PY (input, real arrays, dimension at least N): world coordinates
C       of the N vertices of the polygon.
C--
C 16-Jul-1984 - [TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 21-Feb-1987 - If needed, calls begin picture [AFT].
C  7-Sep-1994 - avoid driver call for capabilities [TJP].
C  1-May-1995 - fixed bug for re-entrant polygons, and optimized code
C               [A.F.Carman].
C 18-Oct-1995 - fixed bug: emulated fill failed for reversed y-axis
C               [S.C.Allendorf/TJP].
C  4-Dec-1995 - remove use of real variable as do-loop variable [TJP].
C 20-Mar-1996 - use another do loop 40 to avoid gaps between adjacent
C               polygons [RS]
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER MAXSEC
      PARAMETER (MAXSEC=32)
      INTEGER I, J, NSECT, LW, LS, NBUF, LCHR, LINE
      REAL    RBUF(6)
      CHARACTER*32 CHR
      REAL    X(MAXSEC), Y, YMIN, YMAX, DY, YD, TEMP, S1, S2, T1, T2
      LOGICAL FORWD
C
      IF (GRCIDE.LT.1) RETURN
      IF (N.LT.3) THEN
          CALL GRWARN('GRFA - polygon has < 3 vertices.')
          RETURN
      END IF
C
C Devices with polygon fill capability.
C
      IF(GRGCAP(GRCIDE)(4:4).EQ.'A') THEN
         IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
         RBUF(1) = N
         CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
         DO 10 I=1,N
            RBUF(1) = PX(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
            RBUF(2) = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
            CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
 10      CONTINUE
         RETURN
      END IF
C
C For other devices fill area is simulated.
C
C Save attributes.
C
      CALL GRQLS(LS)
      CALL GRQLW(LW)
      CALL GRSLS(1)
      CALL GRSLW(1)
C
C Find range of raster-lines to be shaded.
C
      YMIN = PY(1)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
      YMAX = YMIN
      DO 20 I=2,N
         YD = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
         YMIN = MIN(YMIN,YD)
         YMAX = MAX(YMAX,YD)
 20   CONTINUE
      CALL GREXEC(GRGTYP, 3,RBUF,NBUF,CHR,LCHR)
      DY = ABS(RBUF(3))
C
C Find intersections of edges with current raster line.
C
      FORWD = .TRUE.
      S1 = PX(N)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
      T1 = PY(N)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
C
      DO 40 LINE = NINT(YMIN/DY),NINT(YMAX/DY)
         Y = LINE * DY
         NSECT = 0
         DO 30 I=1,N
            S2 = PX(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
            T2 = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
            IF ((T1.LT.Y .AND. Y.LE.T2).OR.
     :          (T1.GE.Y .AND. Y.GT.T2)) THEN
               NSECT = NSECT+1
               IF (NSECT.GT.MAXSEC) THEN
                  CALL GRWARN('GRFA - polygon is too complex.')
                  RETURN
               END IF
               X(NSECT)=(S1+(S2-S1)*((Y-T1)/(T2-T1)))
            END IF
            S1 = S2
            T1 = T2
 30      CONTINUE
C
C Sort the intersections into increasing x order.
C
         DO 34 I=2,NSECT
            DO 32 J=1,I
               IF (X(J).GT.X(I)) THEN
                  TEMP = X(J)
                  X(J) = X(I)
                  X(I) = TEMP
               END IF
 32         CONTINUE
 34      CONTINUE
C
C Draw the horizontal line-segments.
C
         GRYPRE(GRCIDE) = Y
         IF (FORWD) THEN
            DO 36 I=1,NSECT-1,2
               GRXPRE(GRCIDE) = X(I)
               CALL GRLIN0(X(I+1),Y)
 36         CONTINUE
            FORWD = .FALSE.
         ELSE
            DO 38 I=NSECT,2,-2
               GRXPRE(GRCIDE) = X(I)
               CALL GRLIN0(X(I-1),Y)
 38         CONTINUE
            FORWD = .TRUE.
         END IF
 40   CONTINUE
C
C Restore attributes.
C
      CALL GRSLS(LS)
      CALL GRSLW(LW)
      END

      include 'flib.fi'
      INCLUDE 'FGRAPH.FI'
      SUBROUTINE GRMS1C( IX, IY, CHR, VID)
      INCLUDE 'FGRAPH.FD'
      RECORD /xycoord/ XY
      RECORD /VIDEOCONFIG/ VID
      INTEGER*2 IX, IY
      CHARACTER*(*) CHR
C*  cursor key input
      INTEGER*4 IMSIZE,INC,CNT(2),IERR
      INTEGER*2 X0, Y0, X1, Y1, DUMMY, ACTION,
     c IHR,IMIN,ISEC,ITICK
      INTEGER*1 SCAN, ICHR, BUFFER[ALLOCATABLE] (:)
      DATA ACTION/ $GPSET /
C OVERKILL ON IMAGESIZE IN CASE THERE ARE BYTE ALLIGNMENT ISSUES
      IMSIZE = IMAGESIZE( 0,0,25,25 )
      ALLOCATE( BUFFER( IMSIZE ), STAT = IERR )
      IF( IERR .NE. 0 ) THEN
           DUMMY = SETVIDEOMODE( $DEFAULTMODE )
           STOP 'Error: insufficient memory'
      ENDIF
C COUNTER AND INCREMENT TO ADD CURSOR ACCELERATION
      CNT(1) = 0
      INC = 1
      ICHR = 0
      DO WHILE(ICHR .EQ. 0)
         IX = MAX0( IX, 0)
         IY = MAX0( IY, 0)
         IX = MIN0( IX, (VID.NUMXPIXELS - 1))
         IY = MIN0( IY, (VID.NUMYPIXELS - 1))
         X0 = MAX0( (IX - 10), 0 )
         Y0 = MAX0( (IY - 10), 0 )
         X1 = MIN0( (IX + 10), (VID.NUMXPIXELS - 1))
         Y1 = MIN0( (IY + 10), (VID.NUMYPIXELS - 1))
C SAVE IMAGE BELOW WHERE CURSOR WILL BE
         CALL GETIMAGE( X0, Y0, X1, Y1, BUFFER )
C NOW DRAW CURSOR
         CALL MOVETO( X0, IY, XY)
         DUMMY = LINETO( X1, IY)
         CALL MOVETO( IX, Y0, XY)
         DUMMY = LINETO( IX, Y1)
         CALL GETCH(ICHR,SCAN)
C RESTORE IMAGE
         CALL PUTIMAGE( X0, Y0, BUFFER, ACTION )
C CALCULATE TIME PAST AND ACCELERATE IF NECESSARY
         CALL GETTIM(IHR,IMIN,ISEC,ITICK)
         CNT(2) = ITICK + 100*ISEC + 6000*IMIN
         IF ((CNT(2)-CNT(1)) .LT. 25) THEN
          INC = MIN0((INC + 1),30)
         ELSE
          INC = 1
         ENDIF
         CNT(1) = CNT(2)
         IF(SCAN .EQ. #48) THEN
         IY = IY - INC
         ELSE IF (SCAN .EQ. #50) THEN
         IY = IY + INC
         ELSE IF(SCAN .EQ. #4D) THEN
         IX = IX + INC
         ELSE IF(SCAN .EQ. #4B) THEN
         IX = IX - INC
         ENDIF
      ENDDO
      DEALLOCATE( BUFFER )
      CHR =CHAR(ICHR)
      RETURN
      END
C------
      SUBROUTINE GETCH(CHR,SCAN)
      include 'flib.fd'
      integer*1 chr,scan 
ctd 12/93  read keyboard, cursors
      character*1 result
      chr=#00
      scan=#00
      result=getcharqq()
      chr=ichar(result)
      if(chr.eq.#00)then
       result=getcharqq()
       scan=ichar(result)
      endif
      return
      end

C*PGQPOS -- inquire current pen position
C%void cpgqpos(float *x, float *y);
C+
      SUBROUTINE PGQPOS (X, Y)
      REAL X, Y
C
C Query the current "pen" position in world C coordinates (X,Y).
C
C Arguments:
C  X      (output)  : world x-coordinate of the pen position.
C  Y      (output)  : world y-coordinate of the pen position.
C--
C  1-Mar-1991 - new routine [JM].
C-----------------------------------------------------------------------
      CALL GRQPOS(X,Y)
      END

C PGINIT -- initialize PGPLOT (internal routine)
C
      SUBROUTINE PGINIT
C
C Initialize PGPLOT. This routine should be called once during program
C execution, before any other PGPLOT routines.
C--
C Last modified: 1996 Apr 30 [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      INTEGER CALLED, I
      SAVE CALLED
      DATA CALLED /0/
C
      IF (CALLED.EQ.0) THEN
         PGID = 0
         DO 10 I=1,PGMAXD
            PGDEVS(I) = 0
 10      CONTINUE
         CALL GRINIT
         CALLED = 1
      END IF
C
      RETURN
      END

C*PGMOVE -- move pen (change current pen position)
C%void cpgmove(float x, float y);
C+
      SUBROUTINE PGMOVE (X, Y)
      REAL X, Y
C
C Primitive routine to move the "pen" to the point with world
C coordinates (X,Y). No line is drawn.
C
C Arguments:
C  X      (input)  : world x-coordinate of the new pen position.
C  Y      (input)  : world y-coordinate of the new pen position.
C--
C (29-Dec-1983)
C-----------------------------------------------------------------------
      CALL GRMOVA(X,Y)
      END

C*GRTRML -- get name of user's terminal (MS-DOS)
C+
      SUBROUTINE GRTRML(CTERM, LTERM)
      CHARACTER CTERM*(*)
      INTEGER   LTERM
C
C Return the device name of the user's terminal, if any.
C
C Arguments:
C  CTERM : receives the terminal name, truncated or extended with
C           blanks as necessary.
C  LTERM : receives the number of characters in CTERM, excluding
C           trailing blanks. If there is not attached terminal,
C           zero is returned.
C--
C 1989-Nov-08
C-----------------------------------------------------------------------
      CTERM = 'CON'
      LTERM = 3
      RETURN
      END

C*PGQDT -- inquire name of nth available device type
C%void cpgqdt(int n, char *type, int *type_length, char *descr, \
C% int *descr_length, int *inter);
C+
      SUBROUTINE PGQDT(N, TYPE, TLEN, DESCR, DLEN, INTER)
      INTEGER N
      CHARACTER*(*) TYPE, DESCR
      INTEGER TLEN, DLEN, INTER
C
C Return the name of the Nth available device type as a character
C string. The number of available types can be determined by calling
C PGQNDT. If the value of N supplied is outside the range from 1 to
C the number of available types, the routine returns DLEN=TLEN=0.
C
C Arguments:
C  N      (input)  : the number of the device type (1..maximum).
C  TYPE   (output) : receives the character device-type code of the
C                    Nth device type. The argument supplied should be
C                    large enough for at least 8 characters. The first
C                    character in the string is a '/' character.
C  TLEN   (output) : receives the number of characters in TYPE,
C                    excluding trailing blanks.
C  DESCR  (output) : receives a description of the device type. The
C                    argument supplied should be large enough for at
C                    least 64 characters.
C  DLEN   (output) : receives the number of characters in DESCR,
C                    excluding trailing blanks.
C  INTER  (output) : receives 1 if the device type is an interactive
C                    one, 0 otherwise.
C--
C 17-Mar-1997 - new routine [TJP].
C-----------------------------------------------------------------------
      INTEGER NDEV, NBUF, LCHR, L1, L2
      REAL RBUF
      CHARACTER*80 CHR
C
C Initialize PGPLOT if necessary.
C
      CALL PGINIT
C
      TYPE = 'error'
      TLEN = 0
      DESCR = ' '
      DLEN = 0
      INTER = 1
      CALL PGQNDT(NDEV)
      IF (N.GE.1 .AND. N.LE.NDEV) THEN
         NBUF = 0
         CALL GREXEC(N, 1, RBUF, NBUF, CHR, LCHR)
         IF (LCHR.GT.0) THEN
            L1 = INDEX(CHR(1:LCHR), ' ')
            IF (L1.GT.1) THEN
               TYPE(1:1) = '/'
               IF (LEN(TYPE).GT.1) TYPE(2:) = CHR(1:L1-1)
               TLEN = MIN(L1,LEN(TYPE))
            END IF
            L2 = INDEX(CHR(1:LCHR), '(')
            IF (L2.GT.0) DESCR = CHR(L2:LCHR)
            DLEN = MIN(LCHR-L2+1,LEN(DESCR))
            CALL GREXEC(N, 4, RBUF, NBUF, CHR, LCHR)
            IF (CHR(1:1).EQ.'H') INTER = 0
         END IF
      END IF
C
      END

C*PGQID -- inquire current device identifier
C%void cpgqid(int *id);
C+
      SUBROUTINE PGQID (ID)
      INTEGER  ID
C
C This subroutine returns the identifier of the currently
C selected device, or 0 if no device is selected.  The identifier is
C assigned when PGOPEN is called to open the device, and may be used
C as an argument to PGSLCT.  Each open device has a different
C identifier.
C
C [This routine was added to PGPLOT in Version 5.1.0.]
C
C Argument:
C  ID     (output) : the identifier of the current device, or 0 if
C                    no device is currently selected.
C--
C 22-Dec-1995 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
C
      ID = PGID
      END

C*PGERRB -- horizontal or vertical error bar
C%void cpgerrb(int dir, int n, const float *x, const float *y, \
C% const float *e, float t);
C+
      SUBROUTINE PGERRB (DIR, N, X, Y, E, T)
      INTEGER DIR, N
      REAL X(*), Y(*), E(*)
      REAL T
C
C Plot error bars in the direction specified by DIR.
C This routine draws an error bar only; to mark the data point at
C the start of the error bar, an additional call to PGPT is required.
C
C Arguments:
C  DIR    (input)  : direction to plot the error bar relative to
C                    the data point. 
C                    One-sided error bar:
C                      DIR is 1 for +X (X to X+E);
C                             2 for +Y (Y to Y+E);
C                             3 for -X (X to X-E);
C                             4 for -Y (Y to Y-E).
C                    Two-sided error bar:
C                      DIR is 5 for +/-X (X-E to X+E); 
C                             6 for +/-Y (Y-E to Y+E).
C  N      (input)  : number of error bars to plot.
C  X      (input)  : world x-coordinates of the data.
C  Y      (input)  : world y-coordinates of the data.
C  E      (input)  : value of error bar distance to be added to the
C                    data position in world coordinates.
C  T      (input)  : length of terminals to be drawn at the ends
C                    of the error bar, as a multiple of the default
C                    length; if T = 0.0, no terminals will be drawn.
C
C Note: the dimension of arrays X, Y, and E must be greater
C than or equal to N. If N is 1, X, Y, and E may be scalar
C variables, or expressions.
C--
C  1-Mar-1991 - new routine [JM].
C 20-Apr-1992 - correct bug [ALF, TJP].
C 28-Mar-1995 - add options DIR = 5 or 6 [TJP].
C 31-Mar-1997 - use pgtikl [TJP].
C-----------------------------------------------------------------------
      INTEGER  I
      LOGICAL  PGNOTO
      REAL     XTIK, YTIK, XX, YY
C
      IF (PGNOTO('PGERRB')) RETURN
      IF (N.LT.1) RETURN
      IF (DIR.LT.1 .OR. DIR.GT.6) RETURN
      CALL PGBBUF
C
C Determine terminal length.
C
      CALL PGTIKL(T, XTIK, YTIK)
C
C Loop through points.
C
      DO 10 I=1,N
C
C Draw terminal at starting point if required.
C
         IF (DIR.EQ.5) THEN
            XX = X(I)-E(I)
            YY = Y(I)
         ELSE IF (DIR.EQ.6) THEN
            XX = X(I)
            YY = Y(I)-E(I)
         ELSE
            XX = X(I)
            YY = Y(I)
         END IF
         IF (T.NE.0.0) THEN
            IF (DIR.EQ.5) THEN
               CALL GRMOVA(XX,YY-YTIK)
               CALL GRLINA(XX,YY+YTIK)
            ELSE IF (DIR.EQ.6) THEN
               CALL GRMOVA(XX-XTIK,YY)
               CALL GRLINA(XX+XTIK,YY)
            END IF
         END IF
C
C Draw the error bar itself.
C
         CALL GRMOVA(XX,YY)
         IF (DIR.EQ.1 .OR. DIR.EQ.5) THEN
            XX = X(I)+E(I)
            YY = Y(I)
         ELSE IF (DIR.EQ.2 .OR. DIR.EQ.6) THEN
            XX = X(I)
            YY = Y(I)+E(I)
         ELSE IF (DIR.EQ.3) THEN
            XX = X(I)-E(I)
            YY = Y(I)
         ELSE IF (DIR.EQ.4) THEN
            XX = X(I)
            YY = Y(I)-E(I)
         END IF
         CALL GRLINA(XX,YY)
C
C Draw terminal at end point.
C
         IF (T.NE.0.0) THEN
            IF (MOD(DIR,2).EQ.1) THEN
               CALL GRMOVA(XX,YY-YTIK)
               CALL GRLINA(XX,YY+YTIK)
            ELSE
               CALL GRMOVA(XX-XTIK,YY)
               CALL GRLINA(XX+XTIK,YY)
            END IF
         END IF
C
 10   CONTINUE
      CALL PGEBUF
      END

C*PGQHS -- inquire hatching style
C%void cpgqhs(float *angle, float *sepn, float* phase);
C+
      SUBROUTINE PGQHS (ANGLE, SEPN, PHASE)
      REAL ANGLE, SEPN, PHASE
C
C Query the style to be used hatching (fill area with fill-style 3).
C
C Arguments:
C  ANGLE  (output) : the angle the hatch lines make with the
C                    horizontal, in degrees, increasing 
C                    counterclockwise (this is an angle on the
C                    view surface, not in world-coordinate space).
C  SEPN   (output) : the spacing of the hatch lines. The unit spacing
C                    is 1 percent of the smaller of the height or
C                    width of the view surface.
C  PHASE  (output) : a real number between 0 and 1; the hatch lines
C                    are displaced by this fraction of SEPN from a
C                    fixed reference.  Adjacent regions hatched with the
C                    same PHASE have contiguous hatch lines.
C--
C 26-Feb-1995 - new routine [TJP].
C 19-Jun-1995 - correct synopsis [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
C
      ANGLE = PGHSA(PGID)
      SEPN  = PGHSS(PGID)
      PHASE = PGHSP(PGID)
C
      END

C*PGBAND -- read cursor position, with anchor
C%int cpgband(int mode, int posn, float xref, float yref, float *x,\
C%            float *y, char *ch_scalar);
C+
      INTEGER FUNCTION PGBAND (MODE, POSN, XREF, YREF, X, Y, CH)
      INTEGER MODE, POSN
      REAL XREF, YREF, X, Y
      CHARACTER*(*) CH
C
C Read the cursor position and a character typed by the user.
C The position is returned in world coordinates.  PGBAND positions
C the cursor at the position specified (if POSN=1), allows the user to
C move the cursor using the mouse or arrow keys or whatever is available
C on the device. When he has positioned the cursor, the user types a
C single character on the keyboard; PGBAND then returns this
C character and the new cursor position (in world coordinates).
C
C Some interactive devices offer a selection of cursor types,
C implemented as thin lines that move with the cursor, but without
C erasing underlying graphics. Of these types, some extend between
C a stationary anchor-point at XREF,YREF, and the position of the
C cursor, while others simply follow the cursor without changing shape
C or size. The cursor type is specified with one of the following MODE
C values. Cursor types that are not supported by a given device, are
C treated as MODE=0.
C
C -- If MODE=0, the anchor point is ignored and the routine behaves
C like PGCURS.
C -- If MODE=1, a straight line is drawn joining the anchor point 
C and the cursor position.
C -- If MODE=2, a hollow rectangle is extended as the cursor is moved,
C with one vertex at the anchor point and the opposite vertex at the
C current cursor position; the edges of the rectangle are horizontal
C and vertical.
C -- If MODE=3, two horizontal lines are extended across the width of
C the display, one drawn through the anchor point and the other
C through the moving cursor position. This could be used to select
C a Y-axis range when one end of the range is known.
C -- If MODE=4, two vertical lines are extended over the height of
C the display, one drawn through the anchor point and the other
C through the moving cursor position. This could be used to select an
C X-axis range when one end of the range is known.
C -- If MODE=5, a horizontal line is extended through the cursor
C position over the width of the display. This could be used to select
C an X-axis value such as the start of an X-axis range. The anchor point
C is ignored.
C -- If MODE=6, a vertical line is extended through the cursor
C position over the height of the display. This could be used to select
C a Y-axis value such as the start of a Y-axis range. The anchor point
C is ignored.
C -- If MODE=7, a cross-hair, centered on the cursor, is extended over
C the width and height of the display. The anchor point is ignored.
C
C Returns:
C  PGBAND          : 1 if the call was successful; 0 if the device
C                    has no cursor or some other error occurs.
C Arguments:
C  MODE   (input)  : display mode (0, 1, ..7: see above).
C  POSN   (input)  : if POSN=1, PGBAND attempts to place the cursor
C                    at point (X,Y); if POSN=0, it leaves the cursor
C                    at its current position. (On some devices this
C                    request may be ignored.)
C  XREF   (input)  : the world x-coordinate of the anchor point.
C  YREF   (input)  : the world y-coordinate of the anchor point.
C  X      (in/out) : the world x-coordinate of the cursor.
C  Y      (in/out) : the world y-coordinate of the cursor.
C  CH     (output) : the character typed by the user; if the device has
C                    no cursor or if some other error occurs, the value
C                    CHAR(0) [ASCII NUL character] is returned.
C
C Note: The cursor coordinates (X,Y) may be changed by PGBAND even if
C the device has no cursor or if the user does not move the cursor.
C Under these circumstances, the position returned in (X,Y) is that of
C the pixel nearest to the requested position.
C--
C 7-Sep-1994 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE      'pgplot.inc'
      INTEGER      GRCURS, I, J, IREF, JREF
      LOGICAL      PGNOTO
C
      IF (PGNOTO('PGBAND')) THEN
          CH = CHAR(0)
          PGBAND = 0
          RETURN
      END IF
      IF (MODE.LT.0 .OR. MODE.GT.7) CALL GRWARN(
     :     'Invalid MODE argument in PGBAND')
      IF (POSN.LT.0 .OR. POSN.GT.1) CALL GRWARN(
     :     'Invalid POSN argument in PGBAND')
C
      I = NINT(PGXORG(PGID) + X*PGXSCL(PGID))
      J = NINT(PGYORG(PGID) + Y*PGYSCL(PGID))
      IREF = NINT(PGXORG(PGID) + XREF*PGXSCL(PGID))
      JREF = NINT(PGYORG(PGID) + YREF*PGYSCL(PGID))
      PGBAND = GRCURS(PGID,I,J,IREF,JREF,MODE,POSN,CH)
      X = (I - PGXORG(PGID))/PGXSCL(PGID)
      Y = (J - PGYORG(PGID))/PGYSCL(PGID)
      CALL GRTERM
      END

C*GRQUIT -- report a fatal error and abort execution
C+
      SUBROUTINE GRQUIT (TEXT)
      CHARACTER*(*) TEXT
C
C Report a fatal error (via GRWARN) and exit program.
C This routine should be called in the event of an unrecoverable 
C PGPLOT error.
C
C Argument:
C  TEXT (input): text of message to be sent to GRWARN.
C--
C 12-Nov-1994
C-----------------------------------------------------------------------
C
      CALL GRWARN(TEXT)
      CALL GRWARN('Fatal error in PGPLOT library: program terminating.')
      STOP 
      END

      PROGRAM PGDEM3
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT contouring routines.
C-----------------------------------------------------------------------
      INTEGER PGBEG
      WRITE (*,'(A)') ' Demonstration of PGPLOT contouring routines'
C
C Call PGBEG to initiate PGPLOT and open the output device; PGBEG
C will prompt the user to supply the device name and type.
C
      IF (PGBEG(0,'?',1,1) .NE. 1) STOP
C
C Call the demonstration subroutines.
C
      WRITE (*,'(A)') ' Routine PGCONT'
      CALL PGEX31
      WRITE (*,'(A)') ' Routine PGCONS'
      CALL PGEX32
      WRITE (*,'(A)') ' Routine PGCONT with PGCONL labels'
      CALL PGEX36
      WRITE (*,'(A)') ' Routine PGCONB'
      CALL PGEX33
      WRITE (*,'(A)') ' Routine PGCONX with arrow labels'
      CALL PGEX37
      WRITE (*,'(A)') ' Routine PGCONX'
      CALL PGEX34
      WRITE (*,'(A)') ' Routine PGCONF'
      CALL PGEXX1
C
C Finally, call PGEND to terminate things properly.
C
      CALL PGEND
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX31
C-----------------------------------------------------------------------
C Demonstration of contouring routine PGCONT.
C-----------------------------------------------------------------------
      INTEGER I,J
      REAL F(40,40),FMIN,FMAX,ALEV(1),TR(6)
      DATA TR/0.,1.,0.,0.,0.,1./
C
C Compute a suitable function.
C
      FMIN = 0.0
      FMAX = 0.0
      DO 20 I=1,40
          DO 10 J=1,40
              F(I,J) = COS(0.3*SQRT(I*2.)-0.4*J/3.)*COS(0.4*I/3)+
     1                     (I-J)/40.0
              FMIN = MIN(F(I,J),FMIN)
              FMAX = MAX(F(I,J),FMAX)
   10     CONTINUE
   20 CONTINUE
C
C Clear the screen. Set up window and viewport.
C
      CALL PGPAGE
      CALL PGSVP(0.05,0.95,0.05,0.95)
      CALL PGSWIN(1.0,40.0,1.0,40.0)
      CALL PGBOX('bcts',0.0,0,'bcts',0.0,0)
      CALL PGMTXT('t',1.0,0.0,0.0,'Contouring using PGCONT')
C
C Draw the map.  PGCONT is called once for each contour, using
C different line attributes to distinguish contour levels.
C
      CALL PGBBUF
      DO 30 I=1,21
          ALEV(1) = FMIN + (I-1)*(FMAX-FMIN)/20.0
          IF (MOD(I,5).EQ.0) THEN
              CALL PGSLW(3)
          ELSE
              CALL PGSLW(1)
          END IF
          IF (I.LT.10) THEN
              CALL PGSCI(2)
              CALL PGSLS(2)
          ELSE
              CALL PGSCI(3)
              CALL PGSLS(1)
          END IF
          CALL PGCONT(F,40,40,1,40,1,40,ALEV,-1,TR)
   30 CONTINUE
      CALL PGSLW(1)
      CALL PGSLS(1)
      CALL PGSCI(1)
      CALL PGEBUF
      END

      SUBROUTINE PGEX32
C-----------------------------------------------------------------------
C Demonstration of contouring routine PGCONS.
C-----------------------------------------------------------------------
      INTEGER I,J
      REAL F(40,40),FMIN,FMAX,ALEV(1),TR(6)
      DATA TR/0.,1.,0.,0.,0.,1./
C
C Compute a suitable function.
C
      FMIN = 0.0
      FMAX = 0.0
      DO 20 I=1,40
          DO 10 J=1,40
              F(I,J) = COS(0.3*SQRT(I*2.)-0.4*J/3.)*COS(0.4*I/3)+
     1                     (I-J)/40.0
              FMIN = MIN(F(I,J),FMIN)
              FMAX = MAX(F(I,J),FMAX)
   10     CONTINUE
   20 CONTINUE
C
C Clear the screen. Set up window and viewport.
C
      CALL PGPAGE
      CALL PGBOX('bcts',0.0,0,'bcts',0.0,0)
      CALL PGMTXT('t',1.0,0.0,0.0,'Contouring using PGCONS')
C
C Draw the map.  PGCONS is called once for each contour, using
C different line attributes to distinguish contour levels.
C
      CALL PGBBUF
      DO 40 I=1,21
          ALEV(1) = FMIN + (I-1)*(FMAX-FMIN)/20.0
          IF (MOD(I,5).EQ.0) THEN
              CALL PGSLW(3)
          ELSE
              CALL PGSLW(1)
          END IF
          IF (I.LT.10) THEN
              CALL PGSCI(2)
              CALL PGSLS(2)
          ELSE
              CALL PGSCI(3)
              CALL PGSLS(1)
          END IF
          CALL PGCONS(F,40,40,1,40,1,40,ALEV,-1,TR)
   40 CONTINUE
      CALL PGSLW(1)
      CALL PGSLS(1)
      CALL PGSCI(1)
      CALL PGEBUF
      END

      SUBROUTINE PGEX33
C-----------------------------------------------------------------------
C Demonstration of contouring routine PGCONB.
C-----------------------------------------------------------------------
      REAL BLANK
      PARAMETER (BLANK=-1.2E20)
      INTEGER I,J
      REAL F(40,40),FMIN,FMAX,ALEV(1),TR(6),X,Y,R
      DATA TR/0.,1.,0.,0.,0.,1./
C
C Compute a suitable function.
C
      FMIN = 0.0
      FMAX = 0.0
      DO 20 I=1,40
          DO 10 J=1,40
              F(I,J) = COS(0.3*SQRT(I*2.)-0.4*J/3.)*COS(0.4*I/3)+
     1                     (I-J)/40.0
              FMIN = MIN(F(I,J),FMIN)
              FMAX = MAX(F(I,J),FMAX)
   10     CONTINUE
   20 CONTINUE
C
C "Blank" the data outside an annulus.
C
      DO 60 I=1,40
          DO 50 J=1,40
              R = SQRT((I-20.5)**2 + (J-20.5)**2)
              IF (R.GT.20.0 .OR. R.LT.3.0) F(I,J) = BLANK
   50     CONTINUE
   60 CONTINUE
C
      CALL PGPAGE
      CALL PGBOX('bcts',0.0,0,'bcts',0.0,0)
      CALL PGMTXT('t',1.0,0.0,0.0,'Contouring using PGCONB')
      CALL PGBBUF
      DO 80 I=1,21
          ALEV(1) = FMIN + (I-1)*(FMAX-FMIN)/20.0
          IF (MOD(I,5).EQ.0) THEN
              CALL PGSLW(3)
          ELSE
              CALL PGSLW(1)
          END IF
          IF (I.LT.10) THEN
              CALL PGSCI(2)
              CALL PGSLS(2)
          ELSE
              CALL PGSCI(3)
              CALL PGSLS(1)
          END IF
          CALL PGCONB(F,40,40,1,40,1,40,ALEV,-1,TR,BLANK)
   80 CONTINUE
      CALL PGEBUF
C
C Mark the blanked points for easy identification.
C
      CALL PGBBUF
      CALL PGSCI(1)
      DO 100 I=1,40
          DO 90 J=1,40
              IF (F(I,J).EQ.BLANK) THEN
                  X = TR(1) + REAL(I)*TR(2) + REAL(J)*TR(3)
                  Y = TR(4) + REAL(I)*TR(5) + REAL(J)*TR(6)
                  CALL PGPT1(X, Y, -1)
              END IF
   90     CONTINUE
  100 CONTINUE
      CALL PGEBUF
      END

      SUBROUTINE PGEX34
C-----------------------------------------------------------------------
C This program is intended to demonstrate the use of the PGPLOT routine
C PGCONX. As an example, we take data defined on a sphere. We want to
C draw a contour map of the data on an equal-area projection of the
C surface of the sphere; we choose the Hammer-Aitoff equal-area
C projection centered on Declination (latitude) 0, Right Ascension
C (longitude) 0. The data are defined at 2-degree intervals in both
C coordinates. We thus need a data array dimensioned 181 by 91; the
C array index runs from -90 to +90 in declination (91 elements) and
C from -180 to +180 in right ascension (181 elements). The data at -180 
C and +180 must be identical, of course, but they need to be duplicated 
C in the array as these two longitudes appear on opposite sides of the
C map. 
C-----------------------------------------------------------------------
      REAL  PI, RPDEG
      PARAMETER (PI=3.14159265359)
      PARAMETER (RPDEG=PI/180.0)
      INTEGER I, J
      REAL RA, DEC, B, L, XC(181), YC(181)
      REAL Q(181,91), C(9)
      EXTERNAL PLCAIT
C
C Call PGENV to create a rectangular window of 4 x 2 units. This is 
C the bounding rectangle of the plot. The JUST argument is 1
C to get equal scales in x and y.  
C
      CALL PGBBUF
      CALL PGENV(-2.0, 2.0, -1.0, 1.0, 1, -2)
      CALL PGLAB('Right Ascension', 'Declination', ' ')
      CALL PGMTXT('t',2.0,0.0,0.0,
     1           'Contouring on a non-Cartesian grid using PGCONX')
      CALL PGSCH(0.6)
      CALL PGMTXT('b',8.0,0.0,0.0,
     1            'Hammer-Aitoff Equal-Area Projection of the Sphere')
      CALL PGSCH(1.0)
C
C Draw 7 lines of constant longitude at longitude 0, 60, 120, ..., 
C 360 degrees. Each line is made up of 90 straight-line segments.
C
      DO 20 J=1,7
          RA = (-180.+(J-1)*60.)*RPDEG
          DO 10 I=1,91
              DEC = 2*(I-46)*RPDEG
              CALL AITOFF(DEC,RA,XC(I),YC(I))
   10     CONTINUE
          CALL PGLINE(91,XC,YC)
   20 CONTINUE
C
C Draw 5 lines of constant latitude at latitudes -60, -30, 0, 30, 
C 60 degrees. Each line is made up of 360 straight-line segments.
C
      DO 40 J=1,5
          DEC = (-60.+(J-1)*30.)*RPDEG
          DO 30 I=1,181
              RA = 2*(I-91)*RPDEG
              CALL AITOFF(DEC,RA,XC(I),YC(I))
   30     CONTINUE
          CALL PGLINE(181,XC,YC)
   40 CONTINUE
      CALL PGEBUF
C
C Compute the data to be contoured. In practice the data might be read
C in from an external file. In this example the data are computed: they
C are the galactic latitudes of the points on the sphere. Thus the 
C contours will be lines of constant galactic latitude.
C
      DO 60 J=1,91
          DEC = 2*(J-46)*RPDEG
          DO 50 I=1,181
              RA = 2*(I-91)*RPDEG
              CALL GALACT(RA, DEC, B,L)
              Q(I,J) = B
   50     CONTINUE
   60 CONTINUE
C
C Draw the contour map using PGCONX. Contours at 0, 20, 40, 60, 80.
C
      DO 70 I=1,9
          C(I) = -100.0 +I*20.0
   70 CONTINUE
      CALL PGBBUF
      CALL PGSCI(2)
      CALL PGCONX(Q, 181, 91, 1, 181, 1, 91, C, 9, PLCAIT)
      CALL PGSCI(1)
      CALL PGEBUF
      END

      SUBROUTINE PLCAIT(VISBLE, X, Y, Z)
      INTEGER VISBLE
      REAL X,Y,Z
C-----------------------------------------------------------------------
C Plotting subroutine for PGCONX. This routine converts the input
C coordinates (latitude and longitude) into the projected coordinates
C (x and y), and moves or draws as requested by VISBLE.
C-----------------------------------------------------------------------
      REAL  PI, RPDEG
      PARAMETER (PI=3.14159265359)
      PARAMETER (RPDEG=PI/180.0)
      REAL B, L, XWORLD, YWORLD
      B = 2.0*(Y-46.0)*RPDEG
      L = 2.0*(X-91.0)*RPDEG
      CALL AITOFF(B, L, XWORLD, YWORLD)
      IF (VISBLE.EQ.0) THEN
          CALL PGMOVE(XWORLD, YWORLD)
      ELSE
          CALL PGDRAW(XWORLD, YWORLD)
      END IF
      END
 
      SUBROUTINE AITOFF(B,L,X,Y)
C-----------------------------------------------------------------------
C Hammer-Aitoff projection.
C
C       Input: latitude and longitude (B,L) in radians
C       Output: cartesian (X,Y) in range +/-2, +/-1
C-----------------------------------------------------------------------
      REAL L,B,X,Y,L2,DEN
C
      L2 = L/2.0
      DEN = SQRT(1.0+COS(B)*COS(L2))
      X = 2.0*COS(B)*SIN(L2)/DEN
      Y = SIN(B)/DEN
      END

      SUBROUTINE GALACT(RA,DEC,GLAT,GLONG)
C-----------------------------------------------------------------------
C Convert 1950.0 equatorial coordinates (RA, DEC) to galactic
C latitude and longitude (GLAT, GLONG).
C
C Arguments:
C  RA, DEC (input): 1950.0 RA and Dec (radians).
C  GLAT, GLONG (output): galactic latitude and longitude 
C      (degrees).
C
C Reference: e.g., D. R. H. Johnson and D. R. Soderblom, A. J. v93, 
C  p864 (1987).
C-----------------------------------------------------------------------
      REAL RA, RRA, DEC, RDEC, CDEC, R(3,3), E(3), G(3)
      REAL RADDEG, GLAT, GLONG
      INTEGER I, J
      DATA R/-.066988740D0, .492728466D0,-.867600811D0,-.872755766D0,
     $       -.450346958D0,-.188374601D0,-.483538915D0, .744584633D0,
     $        .460199785D0/
      DATA RADDEG/57.29577951D0/
C-----------------------------------------------------------------------
      RRA = RA
      RDEC = DEC
      CDEC = COS(RDEC)
      E(1) = CDEC*COS(RRA)
      E(2) = CDEC*SIN(RRA)
      E(3) = SIN(RDEC)
      DO 20 I=1,3
          G(I) = 0.0
          DO 10 J=1,3
              G(I) = G(I) + E(J)*R(I,J)
   10     CONTINUE
   20 CONTINUE
      GLAT  = ASIN(G(3))*RADDEG
      GLONG = ATAN2(G(2),G(1))*RADDEG
      IF (GLONG.LT.0.0) GLONG = GLONG+360.0
      RETURN
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX37
C-----------------------------------------------------------------------
C Demonstration of contouring routine PGCONX.
C-----------------------------------------------------------------------
      INTEGER I,J
      REAL F(40,40),FMIN,FMAX,ALEV(1)
      EXTERNAL PLCARO
C
C Compute a suitable function.
C
      FMIN = 0.0
      FMAX = 0.0
      DO 20 I=1,40
          DO 10 J=1,40
              F(I,J) = COS(0.3*SQRT(I*2.)-0.4*J/3.)*COS(0.4*I/3)+
     1                     (I-J)/40.0
              FMIN = MIN(F(I,J),FMIN)
              FMAX = MAX(F(I,J),FMAX)
   10     CONTINUE
   20 CONTINUE
C
C Clear the screen. Set up window and viewport.
C
      CALL PGPAGE
      CALL PGSVP(0.05,0.95,0.05,0.95)
      CALL PGSWIN(1.0,40.0,1.0,40.0)
      CALL PGBOX('bcts',0.0,0,'bcts',0.0,0)
      CALL PGMTXT('t',1.0,0.0,0.0,
     :            'Contouring using PGCONX with arrows')
C
C Draw the map.  PGCONX is called once for each contour, using
C different line attributes to distinguish contour levels.
C
      CALL PGBBUF
      DO 30 I=1,21
          ALEV(1) = FMIN + (I-1)*(FMAX-FMIN)/20.0
          IF (MOD(I,5).EQ.0) THEN
              CALL PGSLW(3)
          ELSE
              CALL PGSLW(1)
          END IF
          IF (I.LT.10) THEN
              CALL PGSCI(2)
              CALL PGSLS(2)
          ELSE
              CALL PGSCI(3)
              CALL PGSLS(1)
          END IF
          CALL PGCONX(F,40,40,1,40,1,40,ALEV,-1,PLCARO)
   30 CONTINUE
      CALL PGSLW(1)
      CALL PGSLS(1)
      CALL PGSCI(1)
      CALL PGEBUF
      END

      SUBROUTINE PGEX36
C-----------------------------------------------------------------------
C Demonstration of contouring routine PGCONT and PGCONL.
C-----------------------------------------------------------------------
      INTEGER I,J
      REAL F(40,40),FMIN,FMAX,ALEV(1),TR(6)
      CHARACTER*32 LABEL
      DATA TR /0.0, 1.0, 0.0, 0.0, 0.0, 1.0/
C
C Compute a suitable function.
C
      FMIN = 0.0
      FMAX = 0.0
      DO 20 I=1,40
          DO 10 J=1,40
              F(I,J) = COS(0.3*SQRT(I*2.)-0.4*J/3.)*COS(0.4*I/3)+
     1                     (I-J)/40.0
              FMIN = MIN(F(I,J),FMIN)
              FMAX = MAX(F(I,J),FMAX)
   10     CONTINUE
   20 CONTINUE
C
C Clear the screen. Set up window and viewport.
C
      CALL PGPAGE
      CALL PGBOX('bcts',0.0,0,'bcts',0.0,0)
      CALL PGMTXT('t',1.0,0.0,0.0,
     1            'Contouring using PGCONT and PGCONL labels')
C
C Draw the map.  PGCONT is called once for each contour, using
C different line attributes to distinguish contour levels.
C
      CALL PGBBUF
      DO 40 I=1,21
          ALEV(1) = FMIN + (I-1)*(FMAX-FMIN)/20.0
          IF (MOD(I,5).EQ.0) THEN
              CALL PGSLW(3)
          ELSE
              CALL PGSLW(1)
          END IF
          IF (I.LT.10) THEN
              CALL PGSCI(2)
              CALL PGSLS(2)
          ELSE
              CALL PGSCI(3)
              CALL PGSLS(1)
          END IF
          CALL PGCONT(F,40,40,1,40,1,40,ALEV,-1,TR)
   40 CONTINUE
      CALL PGSLW(1)
      CALL PGSLS(1)
      CALL PGEBUF
C
C Label the contours with PGCONL. Only even-numbered contours
C are labelled.
C
      CALL PGBBUF
      DO 50 I=2,21,2
          ALEV(1) = FMIN + (I-1)*(FMAX-FMIN)/20.0
          WRITE (LABEL,'(I2)') I
C         WRITE (LABEL,'(F8.2)') ALEV
          IF (I.LT.10) THEN
              CALL PGSCI(2)
          ELSE
              CALL PGSCI(3)
          END IF
          CALL PGCONL(F,40,40,1,40,1,40,ALEV,TR,LABEL,16,8)
 50   CONTINUE
      CALL PGSCI(1)
      CALL PGEBUF
      END

      SUBROUTINE PLCARO(VISBLE, X, Y, Z)
      INTEGER VISBLE
      REAL X,Y,Z
C-----------------------------------------------------------------------
C Plotting subroutine for PGCONX. This routine labels contours with
C arrows. Arrows point clockwise around minima, anticlockwise around
C maxima. Arrows are drawn on 1/16 of contour line segments.
C-----------------------------------------------------------------------
      REAL XP, YP
      INTEGER I
      SAVE I
      DATA I /0/
C
      I = MOD(I+1,16)
      IF (VISBLE.EQ.0) THEN
          I = 0
          CALL PGMOVE(X, Y)
      ELSE IF (I.EQ.8) THEN
C         -- Draw line segment with arrow at midpoint
          CALL PGQPOS(XP,YP)
          CALL PGARRO(XP, YP, (X+XP)*0.5, (Y+YP)*0.5)
          CALL PGDRAW(X, Y)
      ELSE
C         -- Draw plain line segment
          CALL PGDRAW(X, Y)
      END IF
      END

      SUBROUTINE PGEXX1
C-----------------------------------------------------------------------
C Demonstration of contouring routine PGCONF.
C-----------------------------------------------------------------------
      INTEGER NX, NY, NC
      PARAMETER (NX=51, NY=51, NC=9)
      INTEGER I, J
      REAL Z(NX,NY),TR(6), R
      REAL X, Y, XMIN, XMAX, YMIN, YMAX, DX, DY, MU, C(NC)
      DATA C /3.0, 3.2, 3.5, 3.6, 3.766413, 4.0 ,5.0, 10.0, 100.0/     
C
C Compute a suitable function. This is the test function used by
C W. V. Snyder, Algorithm 531, Contour Plotting, ACM Trans. Math.
C Softw. v.4, pp.290-294 (1978).
C
      XMIN = -2.0
      XMAX = 2.0
      YMIN =-2.0
      YMAX = 2.0
      MU = 0.3
      DX = (XMAX-XMIN)/FLOAT(NX-1)                                      
      DY = (YMAX-YMIN)/FLOAT(NY-1)
      TR(1) = XMIN - DX
      TR(2) = DX
      TR(3) = 0.0
      TR(4) = YMIN - DY
      TR(5) = 0.0
      TR(6) = DY
      DO 20 I=1,NX
         X = TR(1) + I*TR(2)
         DO 10 J=1,NY     
            Y = TR(4) + J*TR(6)
            Z(I,J) = (1.0-MU)*(2.0/SQRT((X-MU)**2+Y**2)+(X-MU)**2+Y**2)   
     *           + MU*(2.0/SQRT((X+1.0-MU)**2+Y**2)+(X+1.0-MU)**2+Y**2)      
 10      CONTINUE                                   
   20 CONTINUE                                                          
C
C Clear the screen. Set up window and viewport.
C
      CALL PGPAGE
      CALL PGVSTD(0.05,0.95,0.05,0.95)
      CALL PGWNAD(XMIN, XMAX, YMIN, YMAX)
C
C Fill contours with PGCONF.
C
      CALL PGSFS(1)
      DO 30 I=1, NC-1
         R = 0.5+0.5*REAL(I-1)/REAL(NC-1)
         CALL PGSCR(I+10, R, R, R)
         CALL PGSCI(I+10)
         CALL PGCONF(Z,NX,NY,1,NX,1,NY,C(I),C(I+1),TR)
 30   CONTINUE
C
C Draw the contour lines with PGCONT.
C
      CALL PGSCI(3)
      CALL PGCONT(Z,NX,NY,1,NX,1,NY,C,NC,TR)
C
C Labels and box.
C
      CALL PGSCI(1)
      CALL PGSCH(0.6)
      CALL PGBOX('bctsin',1.0,10,'bctsinv',1.0,10)
      CALL PGSCH(1.0)
      CALL PGMTXT('t',1.0,0.0,0.0,'Contour filling using PGCONF')
C
      END

C
      SUBROUTINE PGCP (K, X, Y, Z)
C
C PGPLOT (internal routine): Draw one contour segment (for use by
C PGCNSC).
C
C Arguments:
C
C K (input, integer): if K=0, move the pen to (X,Y); if K=1, draw
C       a line from the current position to (X,Y); otherwise
C       do nothing.
C X (input, real): X world-coordinate of end point.
C Y (input, real): Y world-coordinate of end point.
C Z (input, real): the value of the contour level, not used by PGCP at
C       the moment.
C
C (7-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      INTEGER  K
      REAL     X,XX,Y,YY,Z
C
      XX = TRANS(1) + TRANS(2)*X + TRANS(3)*Y
      YY = TRANS(4) + TRANS(5)*X + TRANS(6)*Y
      IF (K.EQ.1) THEN
          CALL GRLINA(XX,YY)
      ELSE IF (K.EQ.0) THEN
          CALL GRMOVA(XX,YY)
      END IF
      END

C*GRCHR0 -- support routine for GRCHAR and GRMARK
C+
      SUBROUTINE GRCHR0 (WINDOW,CENTER,ORIENT,ABSXY,X0,Y0,STRING)
C
C GRPCKG (internal routine): Support routine for GRCHAR and GRMARK.
C Draw a string of characters.
C
C Arguments:
C
C WINDOW (input, logical): if .TRUE., the plot is windowed in the
C      current window.
C CENTER (input, logical): if .TRUE., the first character of the string
C      is centered at (X0,Y0); otherwise the bottom left corner of the
C      first character is placed at (X0,Y0).
C ORIENT (input, real): the angle in degrees that the string is to make
C      with the horizontal, increasing anticlockwise.
C ABSXY (input, logical): if .TRUE., (X0,Y0) are absolute device
C      coordinates; otherwise they are world coordinates (the scaling
C      transformation is applied).
C X0, Y0 (input, real): position of first character (see CENTER).
C STRING (input, character): the string of ASCII characters; control
C      characters 0-20 have special representations; all other
C      non-graphic characters are plotted as blank spaces.
C
C (1-Mar-1983)
C-----------------------------------------------------------------------
      INTEGER  DOT, MOVE, VECSIZ
      REAL     PI
      PARAMETER (DOT = 3)
      PARAMETER (MOVE = 2)
      PARAMETER (VECSIZ = 30)
      PARAMETER (PI = 3.14159265359)
      INCLUDE 'grpckg1.inc'
      CHARACTER*(*) STRING
      CHARACTER*1   NEXT
      REAL     XMIN, XMAX, YMIN, YMAX
      INTEGER  MODE,LSTYLE,LEVEL
      INTEGER  I, J, L, CH, POINTS
      LOGICAL  ABSXY, CENTER, MORE, WINDOW
      REAL     ORIENT, X0, Y0
      REAL     ANGLE, FACTOR, BASE, FAC
      REAL     COSA, SINA
      REAL     DX, DY, XORG, YORG
      REAL     XC(VECSIZ), YC(VECSIZ), XT, YT
C
      IF (LEN(STRING).LE.0) RETURN
C
C Compute scaling and orientation.
C
      CALL GRQLS(LSTYLE)
      CALL GRSLS(1)
      ANGLE = (AMOD(ORIENT, 360.0) / 180.0) * PI
      FACTOR = GRCFAC(GRCIDE)
      COSA = FACTOR * COS(ANGLE)
      SINA = FACTOR * SIN(ANGLE)
      DX = 10.0 * COSA
      DY = 10.0 * SINA
      CALL GRTXY0(ABSXY, X0, Y0, XORG, YORG)
      IF (.NOT.WINDOW) THEN
          XMIN = GRXMIN(GRCIDE)
          XMAX = GRXMAX(GRCIDE)
          YMIN = GRYMIN(GRCIDE)
          YMAX = GRYMAX(GRCIDE)
          CALL GRAREA(GRCIDE, 0.0, 0.0, 0.0, 0.0)
      END IF
C
C Plot the string of characters.
C
      MODE = MOVE
      BASE = 0.0
      FAC = 1.0
      I = 1
      LEVEL = 0
      L = LEN(STRING)
C     -- DO WHILE (I.LE.L)
   10 IF (I.LE.L) THEN
        IF (I.LT.L .AND. STRING(I:I).EQ.CHAR(92)) THEN
            CALL GRTOUP(NEXT,STRING(I+1:I+1))
            IF (NEXT.EQ.'U') THEN
                LEVEL = LEVEL+1
                BASE = BASE + 4.0*FAC
                FAC = 0.6**IABS(LEVEL)
                I = I+2
            ELSE IF (NEXT.EQ.'D') THEN
                LEVEL = LEVEL-1
                FAC = 0.6**IABS(LEVEL)
                BASE = BASE - 4.0*FAC
                I = I+2
            ELSE
                I = I+1
            END IF
        ELSE
          CH = ICHAR(STRING(I:I))
          IF (CH.GT.127 .OR. CH.LT.0) CH = ICHAR(' ')
          MORE = .TRUE.
C         -- DO WHILE (MORE)
   20     IF (MORE) THEN
            CALL GRGTC0(CH, CENTER, POINTS, XC, YC, MORE)
            DO 30 J=1,POINTS
                    XT = XC(J)*FAC
                    YT = YC(J)*FAC + BASE
                    XC(J) = XORG + COSA * XT - SINA * YT
                    YC(J) = YORG + SINA * XT + COSA * YT
   30       CONTINUE
            IF (POINTS.EQ.1) MODE = DOT
            IF (POINTS.GT.0) CALL GRVCT0(MODE,.TRUE.,POINTS,XC,YC)
            IF (POINTS.EQ.1) MODE = MOVE
          GOTO 20
          END IF
C         -- end DO WHILE
          XORG = XORG + DX*FAC
          YORG = YORG + DY*FAC
          I = I+1
        END IF
      GOTO 10
      END IF
C     -- end DO WHILE
C
C Clean up and return.
C
      IF (.NOT.WINDOW) THEN
          GRXMIN(GRCIDE) = XMIN
          GRXMAX(GRCIDE) = XMAX
          GRYMIN(GRCIDE) = YMIN
          GRYMAX(GRCIDE) = YMAX
      END IF
      CALL GRSLS(LSTYLE)
      RETURN
      END

C*GRIMG0 -- color image of a 2D data array
C+
      SUBROUTINE GRIMG0 (A, IDIM, JDIM, I1, I2, J1, J2,
     1                   A1, A2, PA, MININD, MAXIND, MODE)
      INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE
      REAL    A(IDIM,JDIM), A1, A2, PA(6)
C
C This is a support routine for PGIMAG.
C
C Arguments:
C  A      (input)  : the array to be plotted.
C  IDIM   (input)  : the first dimension of array A.
C  JDIM   (input)  : the second dimension of array A.
C  I1, I2 (input)  : the inclusive range of the first index
C                    (I) to be plotted.
C  J1, J2 (input)  : the inclusive range of the second
C                    index (J) to be plotted.
C  A1     (input)  : the array value which is to appear in color
C                    index MININD.
C  A2     (input)  : the array value which is to appear in color
C                    index MAXIND.
C  PA     (input)  : transformation matrix between array grid and
C                    device coordinates.
C  MININD (input)  : minimum color index to use.
C  MAXIND (input)  : maximum color index to use.
C  MODE   (input)  : =0 for linear, =1 for logarithmic, =2 for
C                    square-root mapping of array values to color
C                    indices.
C--
C  7-Sep-1994 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      CHARACTER C
C-----------------------------------------------------------------------
C
C Switch on type of device support.
C
      C = GRGCAP(GRCIDE)(7:7)
      IF (C.EQ.'Q') THEN
C         -- Image-primitive devices
          CALL GRIMG1(A, IDIM, JDIM, I1, I2, J1, J2, A1, A2, PA,
     :                MININD, MAXIND, MODE)
      ELSE IF (C.EQ.'P') THEN
C         -- Pixel-primitive devices         
          CALL GRIMG2(A, IDIM, JDIM, I1, I2, J1, J2, A1, A2, PA,
     :                MININD, MAXIND, MODE)
      ELSE IF (C.EQ.'N') THEN
C         -- Other devices
          CALL GRWARN(
     :     'images cannot be displayed on the selected device')
      ELSE
C         -- Unknown device code
          CALL GRWARN('unexpected error in routine GRIMG0')
      END IF
C-----------------------------------------------------------------------
      END

C*LJDRIV -- PGPLOT Hewlett Packard LaserJet driver
C+
      SUBROUTINE LJDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Hewlett packard Laserjet device.
C
C Version 1.0  - 1989 Apr 09 - S. C. Allendorf
C                              Combined all drivers into one driver that
C                              uses a logical name to choose the format.
C TJP 1997-Jul-24: replaced ENCODE with WRITE, but still VMS-specific.
C=======================================================================
C
C Supported device: Hewlett Packard LaserJet, LaserJet+, or LaserJet II.
C
C Device type code: /LJnn where nn is a number 1 - NDEV inclusive.
C
C Default device name: PGPLOT.LJPLT.
C
C Default view surface dimensions: Depends on which version of the driver
C is chosen via the logical name PGPLOT_LJ_MODE.
C
C       Driver  Equivalence         Size (H x V)
C       ------  -----------     ---------------------
C        LJ01       LHOR        10.50 by  8.00 inches
C        LJ02       PHOR         8.00 by 10.50 inches
C        LJ03       PHOT         8.00 by 10.50 inches
C        LJ04       LHBR         6.54 by  4.91 inches
C        LJ05       PHBS         5.65 by  5.65 inches
C        LJ06       LMBR        10.50 by  8.00 inches
C        LJ07       PMBR         8.00 by 10.50 inches
C        LJ08       PMBS         4.48 by  4.48 inches
C        LJ09       PLBS         6.00 by  6.00 inches
C
C Resolution: Depends on which version of the driver is chosen via the
C logical name PGPLOT_LJ_MODE.
C
C       Driver  Equivalence     Resolution
C       ------  -----------     ----------
C        LJ01       LHOR          300 DPI
C        LJ02       PHOR          300 DPI
C        LJ03       PHOT          300 DPI
C        LJ04       LHBR          300 DPI
C        LJ05       PHBS          300 DPI
C        LJ06       LMBR          150 DPI
C        LJ07       PMBR          150 DPI
C        LJ08       PMBS          150 DPI
C        LJ09       PLBS          100 DPI
C
C Color capability: Color indices 0 (erase, white) and 1 (black) are
C supported. It is not possible to change color representation.
C
C Input capability: None.
C
C File format: See the LaserJet Printer Technical Reference Manual for 
C details of the file format.
C
C Obtaining hardcopy: Use the command PRINT/PASSALL.
C-----------------------------------------------------------------------
C 
C To choose one of the specific LaserJet drivers, you must execute a DCL
C command of the following form before executing your program:
C
C $ DEFINE PGPLOT_LJ_MODE LJnn
C
C where nn is a number 1 - NDEV inclusive.  You may also use one of the
C equivalent names listed above.  These equivalent names are an attempt
C to make the driver names make sense.  They are decoded as follows:
C
C    1st character: P for protrait orientation or
C                   L for landscape orientation.
C    2nd character: H for high resolution (300 dpi) or
C                   M for medium resolution (150 dpi) or
C                   L for low resolution (100 dpi).
C    3rd character: B for a straight bitmap dump (subroutine GRLJ01) or
C                   O for an optimized bitmap dump (subroutine GRLJ02).
C    4th character: R for a rectangular view surface or
C                   S for a square view surface.
C
C A few notes are in order.  First, not all of the possible combinations
C above are supported (currently).  The driver that goes by the name of
C PHOT is a driver that puts out bitmaps suitable for inclusion in TeX
C output if you are using the Arbortext DVIHP program.  The only drivers
C that will work with unexpanded LaserJet are LJ08 and LJ09.  The other
C seven drivers require a LaserJet Plus or LaserJet II.  Finally, do NOT
C attempt to send grayscale plots to the drivers that use the optimized 
C bitmap dumps.  Terrible things will happen.
C
C If you add a driver to this file, please try to use the naming
C convention outlined above and send me a copy of the revisions.  I may
C be reached at sca@iowa.physics.uiowa.edu on the Internet or IOWA::SCA 
C on SPAN.
C-----------------------------------------------------------------------
C                                       This is the number of currently
C                                       installed devices.
      INTEGER*4  NDEV
      PARAMETER  (NDEV = 9)
C
      BYTE       ESC, FF
      LOGICAL    BITMAP(NDEV), INIT, PORTRAIT(NDEV), TEX
      INTEGER    BUFFER, BX, BY, DEVICE, HC(NDEV), I, IC, IER
      INTEGER    GRFMEM, GRGMEM, LUN, NPICT
      INTEGER    VC(NDEV)
      REAL       MAXX(NDEV), MAXY(NDEV), RESOL(NDEV), XBUF(4)
      REAL       XMAX, YMAX
      CHARACTER  ALTTYP(NDEV)*3, DEFNAM*12, MODE*20, MSG*10
      CHARACTER  TYPE(NDEV)*4
      PARAMETER  (ESC = 27)
      PARAMETER  (FF = 12)
      PARAMETER  (DEFNAM = 'pgplot.ljplt')
      SAVE
      DATA INIT  /.TRUE./
C                                       These are the NDEV sets of 
C                                       device characteristics.
      DATA BITMAP   /.FALSE., .FALSE., .FALSE.,  .TRUE.,  .TRUE.,
     1                .TRUE.,  .TRUE.,  .TRUE.,  .TRUE./
      DATA PORTRAIT /.FALSE.,  .TRUE.,  .TRUE., .FALSE.,  .TRUE.,
     1               .FALSE.,  .TRUE.,  .TRUE.,  .TRUE./
      DATA HC       /      0,       0,       0,    1139,     878,
     1                     0,       0,    1300,     754/
      DATA VC       /      0,       0,       0,    1411,    1743,
     1                     0,       0,    2156,    1605/
      DATA MAXX     / 3149.0,  2399.0,  2399.0,  1962.0,  1695.0,
     1                1574.0,  1199.0,   671.0,   599.0/
      DATA MAXY     / 2399.0,  3149.0,  3149.0,  1471.0,  1695.0,
     1                1199.0,  1574.0,   671.0,   599.0/
      DATA RESOL    /  300.0,   300.0,   300.0,   300.0,   300.0,
     1                 150.0,   150.0,   150.0,   100.0/
C                                       These are around only for
C                                       (pre)historical reasons.
      DATA ALTTYP   /  'HPN',   'HPV',   'TEX',   'HPR',   'HPE',
     1                 'HPF',   'HPT',   'HPH',   'HPM'/
      DATA TYPE     / 'LHOR',  'PHOR',  'PHOT',  'LHBR',  'PHBS',
     1                'LMBR',  'PMBR',  'PMBS',  'PLBS'/
C-----------------------------------------------------------------------
C                                       First time, translate logical
C                                       name PGPLOT_LJ_MODE and set 
C                                       device accordingly.
      IF (INIT) THEN
         CALL GRGENV ('LJ_MODE', MODE, I)
         DO 1 I = 1, NDEV
            WRITE (MSG, '(A2, I2.2)') 'LJ', I
            IF (MODE(1:4) .EQ. TYPE(I) .OR. 
     1          MODE(1:3) .EQ. ALTTYP(I) .OR.
     2          MODE(1:4) .EQ. MSG(1:4)) THEN
               DEVICE = I
               GOTO 2
            END IF
    1    CONTINUE
C                                       If no match, choose LHBR
         DEVICE = 4
    2    INIT = .FALSE.
C                                       See if user has chosen the
C                                       TeX plotfile format.
         TEX = .FALSE.
         IF (DEVICE .EQ. 3) TEX = .TRUE.
      END IF
C                                       Branch on opcode.
      GOTO ( 10,  20,  30,  40,  50,  60,  70,  80,  90, 100,
     1      110, 120, 130, 140, 150, 160, 170, 180, 190, 200,
     2      210, 220, 230, 240, 250, 260), IFUNC
C                                       Signal an error.
  900 WRITE (MSG, '(I10)') IFUNC
      CALL GRWARN ('Unimplemented function in LaserJet device driver:' 
     1             // MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CONTINUE
      WRITE (MSG, '(I2.2)') DEVICE
      CHR = 'LJ' // MSG(1 : 2) // ' (' // TYPE(DEVICE) // ')'
      NBUF = 0
      LCHR = 11
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 CONTINUE
      RBUF(1) = 0.0
      RBUF(2) = MAXX(DEVICE)
      RBUF(3) = 0.0
      RBUF(4) = MAXY(DEVICE)
      RBUF(5) = 0.0
      RBUF(6) = 1.0
      NBUF = 6
      LCHR = 0
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 CONTINUE
      RBUF(1) = RESOL(DEVICE)
      RBUF(2) = RESOL(DEVICE)
      RBUF(3) = 1.0
      NBUF = 3
      LCHR = 0
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    no thick lines)
C
   40 CONTINUE
      CHR = 'HNNNNNNNNN'
      NBUF = 0
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CONTINUE
      CHR = DEFNAM
      NBUF = 0
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 CONTINUE
      RBUF(1) = 0.0
      RBUF(2) = MAXX(DEVICE)
      RBUF(3) = 0.0
      RBUF(4) = MAXY(DEVICE)
      NBUF = 4
      LCHR = 0
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 CONTINUE
      IF (RESOL(DEVICE) .EQ. 300.0) THEN
         RBUF(1) = 3.0
      ELSE IF (RESOL(DEVICE) .EQ. 150.0) THEN
         RBUF(1) = 2.0
      ELSE 
         RBUF(1) = 1.0
      END IF
      NBUF = 1
      LCHR = 0
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C                                       Assume success.
      RBUF(2) = 1.0
C                                       Obtain a logical unit number.
      CALL GRGLUN (LUN)
C                                       Check for an error.
      IF (LUN .EQ. -1) THEN
          CALL GRWARN ('Cannot allocate a logical unit.')
          RBUF(2) = 0
          RETURN
      ELSE
         RBUF(1) = LUN
      END IF
C                                       Open the output file.
      OPEN (UNIT = LUN, FILE = CHR(:LCHR), CARRIAGECONTROL = 'NONE',
     1      DEFAULTFILE = DEFNAM, STATUS = 'NEW',
     2      RECL = 128, FORM = 'UNFORMATTED', RECORDTYPE = 'VARIABLE', 
     3      IOSTAT = IER)
C                                       Check for an error and cleanup if
C                                       one occurred.
      IF (IER .NE. 0) THEN
          CALL GRWARN ('Cannot open output file for LaserJet plot: ' //
     1                 CHR(:LCHR))
          RBUF(2) = 0
          CALL GRFLUN (LUN)
          RETURN
      ELSE
C                                       Get the full file specification
C                                       and calculate the length of the 
C                                       string
          INQUIRE (UNIT = LUN, NAME = CHR)
          LCHR = LEN (CHR)
   91     IF (CHR (LCHR:LCHR) .EQ. ' ') THEN
              LCHR = LCHR - 1
              GOTO 91
          END IF
      END IF
C                                       Initialize the plot file.

      IF (.NOT. TEX) THEN
C                                       Choose portrait orientation
         WRITE (LUN) ESC, '&l0O'
C                                       Set horizontal and vertical 
C                                       spacing
         IF (BITMAP(DEVICE)) THEN
            WRITE (LUN) ESC, '&l6C'
            WRITE (LUN) ESC, '&k10H'
         ELSE
            WRITE (LUN) ESC, '&k.4H'
            WRITE (LUN) ESC, '&l.16C'
         END IF
         WRITE (LUN) ESC, '&l2E'
      END IF
C                                       Set the graphics resolution
      WRITE (MSG, '(I3)') INT (RESOL(DEVICE))
      WRITE (LUN) ESC, '*t', MSG(1:3), 'R'
C                                       Initialize the page counter.
      NPICT = 0
      RETURN
C
C--- IFUNC = 10, Close workstation -------------------------------------
C
  100 CONTINUE
      IF (BITMAP(DEVICE)) THEN
         WRITE (LUN) ESC, '&l8C'
      ELSE IF (.NOT. TEX) THEN
         WRITE (LUN) ESC, '&l6D'
         WRITE (LUN) ESC, '&k10H'
         WRITE (LUN) ESC, '&l2E'
      END IF
C                                       Close the file.
      CLOSE (LUN, STATUS = 'KEEP')
C                                       Deallocate the logical unit.
      CALL GRFLUN (LUN)
C
      RETURN
C
C--- IFUNC = 11, Begin picture -----------------------------------------
C
  110 CONTINUE
C                                       Set the bitmap size.
      XMAX = RBUF(1)
      YMAX = RBUF(2)
C                                       Calculate the dimensions of the
C                                       plot buffer.
      IF (PORTRAIT(DEVICE)) THEN
         BX = INT (XMAX) / 8 + 1
         BY = INT (YMAX) + 1
      ELSE
         BX = INT (YMAX) / 8 + 1
         BY = INT (XMAX) + 1
      END IF
C                                       Allocate a plot buffer.      
      IER = GRGMEM (BX * BY, BUFFER)
C                                       Check for error and clean up
C                                       if one was found.
      IF (IER .NE. 1) THEN
          CALL GRGMSG (IER)
          CALL GRQUIT ('Failed to allocate a plot buffer.')
      END IF
C                                       Increment the page number.
      NPICT = NPICT + 1
C                                       Eject the page from the printer.
      IF (NPICT .GT. 1) WRITE (LUN) FF
C                                       Set the cursor position and
C                                       start graphics mode.
      IF (BITMAP(DEVICE)) THEN
         WRITE (MSG(1:4), '(I4.4)') HC(DEVICE)
         WRITE (MSG(5:8), '(I4.4)') VC(DEVICE)
         WRITE (LUN) ESC, '&a', MSG(1:4), 'h', MSG(5:8), 'V'
      END IF
C                                       Zero out the plot buffer.
      CALL GRLJ04 (BX * BY, %VAL(BUFFER))
      RETURN
C
C--- IFUNC = 12, Draw line ---------------------------------------------
C
  120 CONTINUE
C                                       Apply any needed tranformation.
      IF (PORTRAIT(DEVICE)) THEN
         DO 125 I = 1, 4
            XBUF(I) = RBUF(I)
  125    CONTINUE
      ELSE      
         XBUF(1) = RBUF(2)
         XBUF(2) = XMAX - RBUF(1)
         XBUF(3) = RBUF(4)
         XBUF(4) = XMAX - RBUF(3)
      END IF
C                                       Draw the point into the bitmap.
      CALL GRLJ00 (1, XBUF, IC, BX, BY, %VAL (BUFFER))
      RETURN
C
C--- IFUNC = 13, Draw dot ----------------------------------------------
C
  130 CONTINUE
C                                       Apply any needed tranformation.
      IF (PORTRAIT(DEVICE)) THEN
         DO 135 I = 1, 2
            XBUF(I) = RBUF(I)
  135    CONTINUE
      ELSE
         XBUF(1) = RBUF(2)
         XBUF(2) = XMAX - RBUF(1)
      END IF
C                                       Draw the point into the bitmap.
      CALL GRLJ00 (0, XBUF, IC, BX, BY, %VAL(BUFFER))
      RETURN
C
C--- IFUNC = 14, End picture -------------------------------------------
C
  140 CONTINUE
C                                       Write out the bitmap.
      IF (BITMAP(DEVICE)) THEN
         CALL GRLJ01 (LUN, BX, BY, %VAL (BUFFER))
      ELSE
         CALL GRLJ02 (LUN, BX, BY, %VAL (BUFFER), TEX)
      END IF
C                                       Deallocate the plot buffer.
      IER = GRFMEM (BX * BY, BUFFER)
C                                       Check for an error.
      IF (IER .NE. 1) THEN
          CALL GRGMSG (IER)
          CALL GRWARN ('Failed to deallocate plot buffer.')
      END IF
      RETURN
C
C--- IFUNC = 15, Select color index ------------------------------------
C
  150 CONTINUE
C                                       Save the requested color index.
      IC = RBUF(1)
C                                       If out of range set to black.
      IF (IC .LT. 0 .OR. IC .GT. 1) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC = 16, Flush buffer. -----------------------------------------
C    (Not implemented: ignored.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC = 17, Read cursor. ------------------------------------------
C    (Not implemented: should not be called.)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC = 18, Erase alpha screen. -----------------------------------
C    (Not implemented: ignored.)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC = 19, Set line style. ---------------------------------------
C    (Not implemented: should not be called.)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC = 20, Polygon fill. -----------------------------------------
C    (Not implemented: should not be called.)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC = 21, Set color representation. -----------------------------
C    (Not implemented: ignored.)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC = 22, Set line width. ---------------------------------------
C    (Not implemented: should not be called.)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC = 23, Escape ------------------------------------------------
C    (Not implemented: ignored.)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC = 24, Rectangle fill. ---------------------------------------
C    (Not implemented: should not be called.)
C
  240 CONTINUE
      GOTO 900
C
C--- IFUNC = 25, -------------------------------------------------------
C    (Not implemented: should not be called.)
C
  250 CONTINUE
      GOTO 900
C
C--- IFUNC = 26, Line of pixels. ---------------------------------------
C    (Not implemented: should not be called.)
C
  260 CONTINUE
      GOTO 900
C-----------------------------------------------------------------------
      END

C*GRLJ00 -- PGPLOT Hewlett Packard LaserJet driver, draw line
C+
      SUBROUTINE GRLJ00 (LINE, RBUF, ICOL, BX, BY, BITMAP)
      INTEGER    BX, BY, ICOL, LINE
      BYTE       BITMAP(BX, BY)
      REAL       RBUF(4)
C
C Draw a straight line segment from absolute pixel coordinates (RBUF(1),
C RBUF(2)) to (RBUF(3), RBUF(4)).  The line either overwrites (sets to
C black) or erases (sets to white) the previous contents of the bitmap,
C depending on the current color index. Setting bits is accomplished
C with a VMS BISB2 instruction, expressed in Fortran as .OR.; clearing
C bits is accomplished with a VMS BICB2 instruction, expressed in
C Fortran as .AND. .NOT.. The line is generated with a Simple Digital
C Differential Analyser (ref: Newman & Sproull). 
C
C Arguments:
C
C LINE            I I      =0 for dot, =1 for line.
C RBUF(1),RBUF(2) I R      Starting point of line.
C RBUF(3),RBUF(4) I R      Ending point of line.
C ICOL            I I      =0 for erase, =1 for write.
C BITMAP        I/O B      (address of) the frame buffer.
C
C-----------------------------------------------------------------------
      BYTE       QMASK(0 : 7)
      INTEGER    K, KX, KY, LENGTH
      REAL       D, XINC, XP, YINC, YP
      DATA       QMASK /'80'X, '40'X, '20'X, '10'X, 
     1                  '08'X, '04'X, '02'X, '01'X/
C-----------------------------------------------------------------------
      IF (LINE .GT. 0) THEN
         D = MAX (ABS (RBUF(3) - RBUF(1)), ABS (RBUF(4) - RBUF(2)))
         LENGTH = D
         IF (LENGTH .EQ. 0) THEN
            XINC = 0.0
            YINC = 0.0
         ELSE
            XINC = (RBUF(3) - RBUF(1)) / D
            YINC = (RBUF(4) - RBUF(2)) / D
         END IF
      ELSE
         LENGTH = 0
         XINC = 0.0
         YINC = 0.0
      END IF
      XP = RBUF(1) + 0.5
      YP = RBUF(2) + 0.5
      IF (ICOL .NE. 0) THEN
         DO K = 0, LENGTH
            KX = XP
            KY = (BY - 1) - INT (YP)
            BITMAP(KX / 8 + 1, KY + 1) = BITMAP(KX / 8 + 1, KY + 1) .OR.
     1                                         QMASK(MOD (KX, 8))
            XP = XP + XINC
            YP = YP + YINC
         END DO
      ELSE
         DO K = 0,LENGTH
            KX = XP
            KY = (BY - 1) - INT (YP)
            BITMAP(KX / 8 + 1, KY + 1) = BITMAP(KX / 8 + 1, KY + 1) 
     1                                  .AND. (.NOT. QMASK(MOD (KX, 8)))
            XP = XP + XINC
            YP = YP + YINC
         END DO
      END IF
C-----------------------------------------------------------------------
      RETURN
      END

C*GRLJ01 -- PGPLOT LaserJet driver, copy bitmap to output file
C+
      SUBROUTINE GRLJ01 (LUN, BX, BY, BITMAP)
      INTEGER  BX, BY, LUN
      BYTE     BITMAP(BX, BY)
C
C Arguments:
C
C  LUN    (input)  Fortran unit number for output
C  BX, BY (input)  dimensions of BITMAP
C  BITMAP (input)  the bitmap array
C-----------------------------------------------------------------------
      BYTE      ESC
      INTEGER   I, J, K
      CHARACTER KSTR*3
      PARAMETER (ESC = 27)
C-----------------------------------------------------------------------
C                                       Start graphics mode
      WRITE (LUN) ESC, '*r1A'
C                                       Loop through bitmap
      DO J = 1, BY
C                                       Search for last non-NUL
         DO K = BX, 2, -1
            IF (BITMAP(K, J) .NE. '00'X) GO TO 10
         END DO
C                                       Guarantee that we know what K
C                                       is after loop. 
C                                       (Remember FORTRAN IV!?)
         K = 1
C                                       Encode length of line
   10    WRITE (KSTR, '(I3.3)') K
C                                       Write out the raster line
         WRITE (LUN) ESC, '*b', KSTR, 'W', (BITMAP(I, J), I = 1, K)
      END DO
C                                       Turn off graphics mode.
      WRITE (LUN) ESC, '*rB'
C-----------------------------------------------------------------------
      RETURN
      END

C*GRLJ02 -- PGPLOT LaserJet+ driver, dump bitmap to device
C+
      SUBROUTINE GRLJ02 (LUN, BX, BY, BITMAP, TEX)
      LOGICAL TEX
      INTEGER LUN, BX, BY
      BYTE BITMAP(BX, BY)
C
C Output raster for this page.  This routine has been optimised to 
C minimize the memory usage in the LaserJet.  This sometimes leads to a
C larger file than if a straight bitmap approach had been used.
C
C NOTE:  This subroutine is a kludge to make a 512K LaserJet produce 
C        full page plots at 300dpi.  It will not always produce the plot
C        on one page.  If you overrun the memory restrictions, two pages
C        will be printed, each containing parts of the plot.  One must 
C        then resort to cut and paste techniques to restore the plot.  
C        Most simple line graphs do not come close to the memory limit, 
C        but sometimes a messy contour plot will.  DON'T EVEN THINK
C        ABOUT SENDING A GREYSCALE TO THIS SUBROUTINE!
C
C Arguments:
C
C LUN             I I      Logical unit number of output file
C BX, BY          I I      Dimensions of frame buffer
C BITMAP        I/O B      (address of) the frame buffer.
C
C Version 1.0  03-Sep-1986  S. C. Allendorf
C Version 2.0  08-Dec-1986  S. C. Allendorf  Use relative positioning
C Version 2.1  28-Dec-1986  S. C. Allendorf  Optimize positioning code
C Version 3.0  02-Jan-1987  S. C. Allendorf  Add code for rules
C VERSION 3.1  10-FEB-1988  S. C. Allendorf  Attempt to speed up code
C-----------------------------------------------------------------------
      BYTE       ESC, N0
      LOGICAL    NOBIT
      INTEGER    CNUM, CONUM, CURCOL, CURROW, FB(35), FB2(25), I, IPOS
      INTEGER    IYOFF, J, K, L, M, N, NB(35), NBNUM, NBTOT, NBNUM2
      INTEGER    NB2(25), RNUM, RONUM, GRLJ03
      CHARACTER  ALLONE*300, COL*5, NBYTE*4, NULLS*(10), ROW*5, X*300
      PARAMETER  (N0 = 0)
      PARAMETER  (ESC = 27)
C-----------------------------------------------------------------------
C                                       Define some useful constants
      IF (TEX) THEN
         IYOFF = 0
      ELSE
         IYOFF = 75
      END IF
      DO J = 1, 10
         NULLS(J:J) = CHAR (0)
      END DO
      DO J = 1, 300
         ALLONE(J:J) = CHAR (255)
      END DO
C                                       Initialize some variables
      CURCOL = 0
      CURROW = 0
C                                       Position the cursor
      IF (.NOT. TEX) THEN
         WRITE (LUN) ESC, '*p0y0X'
      END IF
C                                       Set up vertical rule height
      WRITE (LUN) ESC, '*c1B'
C                                       Write out each line on page
      DO K = 1, BY
C                                       Copy raster to buffer and find
C                                       the beginning and end of the 
C                                       bitmap line
         NOBIT = .TRUE.
         NBTOT = 0
         FB(1) = BX
         DO J = 1, BX
            X(J:J) = CHAR (BITMAP(J,K))
            IF (X(J:J) .NE. NULLS(1:1)) THEN
               NOBIT = .FALSE.
               NBTOT = J
               FB(1) = MIN (FB(1), J)
            END IF
         END DO
C                                       Break line into pieces
         IF (.NOT. NOBIT) THEN
            L = 1
            GO TO 20
   10       NB(L) = FB(L) + IPOS - 2
            L = L + 1
C                                       Search for first non-null
            DO J = NB(L-1) + 11, NBTOT
               IF (X(J:J) .NE. NULLS(1:1)) THEN
                  FB(L) = J
                  GO TO 20
               END IF
            END DO
C                                       Search for a string of nulls
   20       IPOS = INDEX (X(FB(L):NBTOT), NULLS)
            IF (IPOS .EQ. 0) THEN
               NB(L) = NBTOT
               GO TO 30
            ELSE
               GO TO 10
            END IF
C                                       Loop through each substring
   30       DO J = 1, L
C                                       Search for rules
               M = 1
               FB2(1) = FB(J)
               GO TO 50
   40          IF (IPOS .NE. 1) THEN
                  NB2(M) = 0
                  DO I = FB2(M), FB2(M) + IPOS - 2
                     IF (X(I:I) .NE. NULLS(1:1)) THEN
                        NB2(M) = MAX (FB2(M), I)
                     END IF
                  END DO
                  M = M + 1
                  FB2(M) = FB2(M-1) + IPOS - 1
                  IF (NB2(M-1) .EQ. 0) THEN
                     FB2(M-1) = FB2(M)
                     M = M - 1
                  END IF
               END IF
C                                       Search for first non-<XFF>
               DO N = FB2(M) + 25, NB(J)
                  IF (X(N:N) .NE. ALLONE(1:1)) THEN
                     NB2(M) = N - 1
                     M = M + 1
                     FB2(M) = N
                     GO TO 50
                  END IF
               END DO
               NB2(M) = NB(J)
               GO TO 60
C                                       Search for a string of <XFF>s
   50          IPOS = INDEX (X(FB2(M):NB(J)), ALLONE(1:25))
               IF (IPOS .EQ. 0) THEN
                  NB2(M) = NB(J)
                  GO TO 60
               ELSE
                  GO TO 40
               END IF
C                                       Print each of the substrings
   60          DO I = 1, M
C                                       Get the number of bytes
                  NBNUM = NB2(I) - FB2(I) + 1
C                 ENCODE (4, 1000, NBYTE) NBNUM
                  WRITE (NBYTE, 1000) NBNUM
                  NBNUM2 = GRLJ03 (NBNUM)
C                                       Calculate the row and column
                  RONUM = K + IYOFF
                  CONUM = (FB2(I) - 1) * 8
C                                       Determine the positioning
C                                       sequence and write it out
                  IF (RONUM .NE. CURROW .AND. CONUM .NE. CURCOL) THEN
                     RNUM = RONUM - CURROW
                     CNUM = CONUM - CURCOL
C                    ENCODE (5, 1010, ROW) RNUM
C                    ENCODE (5, 1010, COL) CNUM
                     WRITE (ROW, 1010) RNUM
                     WRITE (COL, 1010) CNUM
                     RNUM = GRLJ03 (ABS (RNUM)) + 1
                     CNUM = GRLJ03 (ABS (CNUM)) + 1
                     WRITE (LUN) ESC, '*p', ROW(6-RNUM:5), 'y', 
     +                                              COL(6-CNUM:5), 'X'
                  ELSE IF (RONUM .NE. CURROW) THEN
                     RNUM = RONUM - CURROW
C                    ENCODE (5, 1010, ROW) RNUM
                     WRITE (ROW, 1010) RNUM
                     RNUM = GRLJ03 (ABS (RNUM)) + 1
                     WRITE (LUN) ESC, '*p', ROW(6-RNUM:5), 'Y'
                  ELSE IF (CONUM .NE. CURCOL) THEN
                     CNUM = CONUM - CURCOL
C                    ENCODE (5, 1010, COL) CNUM
                     WRITE (COL, 1010) CNUM
                     CNUM = GRLJ03 (ABS (CNUM)) + 1
                     WRITE (LUN) ESC, '*p', COL(6-CNUM:5), 'X'
                  END IF
C                                       Check for all bits set in
C                                       substring
                  IF ((INDEX (X(FB2(I):NB2(I)), ALLONE(1:NBNUM)) .EQ. 1)
     +                 .AND. NBNUM .GE. 5) THEN
                     NBNUM = NBNUM * 8
C                    ENCODE (4, 1000, NBYTE) NBNUM
                     WRITE (NBYTE, 1000) NBNUM
                     NBNUM2 = GRLJ03 (NBNUM)
                     WRITE (LUN) ESC, '*c', NBYTE(5-NBNUM2:4), 'A'
                     WRITE (LUN) ESC, '*c0P'
                     CURROW = RONUM
                     CURCOL = CONUM
                  ELSE
C                                       Write out raster line
                     WRITE (LUN) ESC, '*r1A'
                     WRITE (LUN) ESC, '*b', NBYTE(5-NBNUM2:4), 'W', 
     +                                                X(FB2(I):NB2(I))
                     WRITE (LUN) ESC, '*rB'
                     CURROW = RONUM + 1
                     CURCOL = CONUM
                  END IF
               END DO
            END DO
         END IF
      END DO
C-----------------------------------------------------------------------
 1000 FORMAT (I4.4)
 1010 FORMAT (SP,I5)
      RETURN
      END

C*GRLJ03 -- PGPLOT LaserJet+ driver, calculate length of an integer
C+
      INTEGER FUNCTION GRLJ03 (I)
      INTEGER I
C
C This function calculates the number of digits in a supplied integer.
C
C Arguments:
C
C I               I I      Integer value of number
C GRLJ03          O I      Length of printed representation of I
C
C Version 1.0  10-Feb-1988  S. C. Allendorf
C-----------------------------------------------------------------------
      IF (I .GE. 10) THEN
         IF (I .GE. 100) THEN
            IF (I .GE. 1000) THEN
               GRLJ03 = 4
            ELSE
               GRLJ03 = 3
            END IF
         ELSE
            GRLJ03 = 2
         END IF
      ELSE
         GRLJ03 = 1
      END IF
C-----------------------------------------------------------------------
      RETURN
      END

C*GRLJ04 -- zero fill buffer
C+
      SUBROUTINE GRLJ04 (BUFSIZ,BUFFER)
C
C Arguments:
C
C BUFFER (byte array, input): (address of) the buffer.
C BUFSIZ (integer, input): number of bytes in BUFFER.
C-----------------------------------------------------------------------
      INTEGER  BUFSIZ, I
      BYTE     BUFFER(BUFSIZ), FILL
      DATA     FILL /0/
C
      DO 10 I=1,BUFSIZ
          BUFFER(I) = FILL
   10 CONTINUE
      END

C*PGPTEXT -- non-standard alias for PGPTXT
C+
      SUBROUTINE PGPTEXT (X, Y, ANGLE, FJUST, TEXT)
      REAL X, Y, ANGLE, FJUST
      CHARACTER*(*) TEXT
C
C See description of PGPTXT.
C--
      CALL PGPTXT (X, Y, ANGLE, FJUST, TEXT)
      END

C*GRMKER -- draw graph markers
C+
      SUBROUTINE GRMKER (SYMBOL,ABSXY,N,X,Y)
C
C GRPCKG: Draw a graph marker at a set of points in the current
C window. Line attributes (color, intensity, and  thickness)
C apply to markers, but line-style is ignored. After the call to
C GRMKER, the current pen position will be the center of the last
C marker plotted.
C
C Arguments:
C
C SYMBOL (input, integer): the marker number to be drawn. Numbers
C       0-31 are special marker symbols; numbers 32-127 are the
C       corresponding ASCII characters (in the current font). If the
C       number is >127, it is taken to be a Hershey symbol number.
C       If -ve, a regular polygon is drawn.
C ABSXY (input, logical): if .TRUE., the input corrdinates (X,Y) are
C       taken to be absolute device coordinates; if .FALSE., they are
C       taken to be world coordinates.
C N (input, integer): the number of points to be plotted.
C X, Y (input, real arrays, dimensioned at least N): the (X,Y)
C       coordinates of the points to be plotted.
C--
C (19-Mar-1983)
C 20-Jun-1985 - revise to window markers whole [TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C  1-Aug-1988 - add direct use of Hershey number [TJP].
C 15-Dec-1988 - standardize [TJP].
C 17-Dec-1990 - add polygons [PAH/TJP].
C 12-Jun-1992 - [TJP]
C 22-Sep-1992 - add support for hardware markers [TJP].
C  1-Sep-1994 - suppress driver call [TJP].
C 15-Feb-1994 - fix bug (expanding viewport!) [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  SYMBOL
      INTEGER  C 
      LOGICAL  ABSXY, UNUSED, VISBLE
      INTEGER  I, K, LSTYLE, LX, LY, LXLAST, LYLAST, N, SYMNUM, NV
      INTEGER  XYGRID(300)
      REAL     ANGLE, COSA, SINA, FACTOR, RATIO, X(*), Y(*)
      REAL     XCUR, YCUR, XORG, YORG
      REAL     THETA, XOFF(40), YOFF(40), XP(40), YP(40)
      REAL     XMIN, XMAX, YMIN, YMAX
      REAL     XMINX, XMAXX, YMINX, YMAXX
      REAL     RBUF(4)
      INTEGER  NBUF,LCHR
      CHARACTER*32 CHR
C
C Check that there is something to be plotted.
C
      IF (N.LE.0) RETURN
C
C Check that a device is selected.
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRMKER - no graphics device is active.')
          RETURN
      END IF
C
      XMIN = GRXMIN(GRCIDE)
      XMAX = GRXMAX(GRCIDE)
      YMIN = GRYMIN(GRCIDE)
      YMAX = GRYMAX(GRCIDE)
      XMINX = XMIN-0.01
      XMAXX = XMAX+0.01
      YMINX = YMIN-0.01
      YMAXX = YMAX+0.01
C
C Does the device driver do markers (only markers 0-31 at present)?
C
      IF (GRGCAP(GRCIDE)(10:10).EQ.'M' .AND.
     :     SYMBOL.GE.0 .AND. SYMBOL.LE.31) THEN
          IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
C         -- symbol number
          RBUF(1) = SYMBOL
C          -- scale factor
          RBUF(4) = GRCFAC(GRCIDE)/2.5
          NBUF = 4
          LCHR = 0
          DO 10 K=1,N
C             -- convert to device coordinates
              CALL GRTXY0(ABSXY, X(K), Y(K), XORG, YORG)
C             -- is the marker visible?
              CALL GRCLIP(XORG, YORG, XMINX, XMAXX, YMINX, YMAXX, C)
              IF (C.EQ.0) THEN
                  RBUF(2) = XORG
                  RBUF(3) = YORG
                  CALL GREXEC(GRGTYP,28,RBUF,NBUF,CHR,LCHR)
              END IF
   10     CONTINUE
          RETURN
      END IF
C
C Otherwise, draw the markers here.
C
C Save current line-style, and set style "normal".
C
      CALL GRQLS(LSTYLE)
      CALL GRSLS(1)
C
C Save current viewport, and open the viewport to include the full
C view surface.
C
      CALL GRAREA(GRCIDE, 0.0, 0.0, 0.0, 0.0)
C
C Compute scaling and orientation.
C
      ANGLE = 0.0
      FACTOR = GRCFAC(GRCIDE)/2.5
      RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE)
      COSA = FACTOR * COS(ANGLE)
      SINA = FACTOR * SIN(ANGLE)
C
C Convert the supplied marker number SYMBOL to a symbol number and
C obtain the digitization.
C
      IF (SYMBOL.GE.0) THEN
          IF (SYMBOL.GT.127) THEN
              SYMNUM = SYMBOL
          ELSE
              CALL GRSYMK(SYMBOL,GRCFNT(GRCIDE),SYMNUM)
          END IF
          CALL GRSYXD(SYMNUM, XYGRID, UNUSED)
C
C Positive symbols.
C
      DO 380 I=1,N
          CALL GRTXY0(ABSXY, X(I), Y(I), XORG, YORG)
          CALL GRCLIP(XORG, YORG, XMINX, XMAXX, YMINX, YMAXX, C)
          IF (C.NE.0) GOTO 380
          VISBLE = .FALSE.
          K = 4
          LXLAST = -64
          LYLAST = -64
  320       K = K+2
            LX = XYGRID(K)
            LY = XYGRID(K+1)
            IF (LY.EQ.-64) GOTO 380
            IF (LX.EQ.-64) THEN
                VISBLE = .FALSE.
            ELSE
                IF ((LX.NE.LXLAST) .OR. (LY.NE.LYLAST)) THEN
                    XCUR = XORG + (COSA*LX - SINA*LY)*RATIO
                    YCUR = YORG + (SINA*LX + COSA*LY)
                    IF (VISBLE) THEN
                        CALL GRLIN0(XCUR,YCUR)
                    ELSE
                        GRXPRE(GRCIDE) = XCUR
                        GRYPRE(GRCIDE) = YCUR
                    END IF
                END IF
                VISBLE = .TRUE.
                LXLAST = LX
                LYLAST = LY
            END IF
            GOTO 320
  380 CONTINUE
C
C Negative symbols.
C
      ELSE
C         ! negative symbol: filled polygon of radius 8
          NV = MIN(31,MAX(3,ABS(SYMBOL)))
          DO 400 I=1,NV
              THETA = 3.14159265359*(REAL(2*(I-1))/REAL(NV)+0.5) - ANGLE
              XOFF(I) = COS(THETA)*FACTOR*RATIO/GRXSCL(GRCIDE)*8.0
              YOFF(I) = SIN(THETA)*FACTOR/GRYSCL(GRCIDE)*8.0
  400     CONTINUE
          DO 420 K=1,N
              CALL GRTXY0(ABSXY, X(K), Y(K), XORG, YORG)
              CALL GRCLIP(XORG, YORG, XMINX, XMAXX, YMINX, YMAXX, C)
              IF (C.EQ.0) THEN
                  DO 410 I=1,NV
                      XP(I) = X(K)+XOFF(I)
                      YP(I) = Y(K)+YOFF(I)
  410             CONTINUE
                  CALL GRFA(NV, XP, YP)
              END IF
  420     CONTINUE
      END IF
C
C Set current pen position.
C
      GRXPRE(GRCIDE) = XORG
      GRYPRE(GRCIDE) = YORG
C
C Restore the viewport and line-style, and return.
C
      GRXMIN(GRCIDE) = XMIN
      GRXMAX(GRCIDE) = XMAX
      GRYMIN(GRCIDE) = YMIN
      GRYMAX(GRCIDE) = YMAX
      CALL GRSLS(LSTYLE)
C
      END

C*PGQCI -- inquire color index
C%void cpgqci(int *ci);
C+
      SUBROUTINE PGQCI (CI)
      INTEGER  CI
C
C Query the Color Index attribute (set by routine PGSCI).
C
C Argument:
C  CI     (output) : the current color index (in range 0-max). This is
C                    the color index actually in use, and may differ
C                    from the color index last requested by PGSCI if
C                    that index is not available on the output device.
C--
C  5-Nov-1985 - new routine [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGQCI')) THEN
         CI = 1
      ELSE
         CALL GRQCI(CI)
      END IF
      END

C*PGCONX -- contour map of a 2D data array (non rectangular)
C+
      SUBROUTINE PGCONX (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, PLOT)
      INTEGER  IDIM, JDIM, I1, J1, I2, J2, NC
      REAL     A(IDIM,JDIM), C(*)
      EXTERNAL PLOT
C
C Draw a contour map of an array using a user-supplied plotting
C routine.  This routine should be used instead of PGCONT when the
C data are defined on a non-rectangular grid.  PGCONT permits only
C a linear transformation between the (I,J) grid of the array
C and the world coordinate system (x,y), but PGCONX permits any
C transformation to be used, the transformation being defined by a
C user-supplied subroutine. The nature of the contouring algorithm,
C however, dictates that the transformation should maintain the
C rectangular topology of the grid, although grid-points may be
C allowed to coalesce.  As an example of a deformed rectangular
C grid, consider data given on the polar grid theta=0.1n(pi/2),
C for n=0,1,...,10, and r=0.25m, for m=0,1,..,4. This grid
C contains 55 points, of which 11 are coincident at the origin.
C The input array for PGCONX should be dimensioned (11,5), and
C data values should be provided for all 55 elements.  PGCONX can
C also be used for special applications in which the height of the
C contour affects its appearance, e.g., stereoscopic views.
C
C The map is truncated if necessary at the boundaries of the viewport.
C Each contour line is drawn with the current line attributes (color
C index, style, and width); except that if argument NC is positive
C (see below), the line style is set by PGCONX to 1 (solid) for
C positive contours or 2 (dashed) for negative contours. Attributes
C for the contour lines can also be set in the user-supplied
C subroutine, if desired.
C
C Arguments:
C  A      (input) : data array.
C  IDIM   (input) : first dimension of A.
C  JDIM   (input) : second dimension of A.
C  I1, I2 (input) : range of first index to be contoured (inclusive).
C  J1, J2 (input) : range of second index to be contoured (inclusive).
C  C      (input) : array of NC contour levels; dimension at least NC.
C  NC     (input) : +/- number of contour levels (less than or equal
C                   to dimension of C). If NC is positive, it is the
C                   number of contour levels, and the line-style is
C                   chosen automatically as described above. If NC is
C                   negative, it is minus the number of contour
C                   levels, and the current setting of line-style is
C                   used for all the contours.
C  PLOT   (input) : the address (name) of a subroutine supplied by
C                   the user, which will be called by PGCONX to do
C                   the actual plotting. This must be declared
C                   EXTERNAL in the program unit calling PGCONX.
C
C The subroutine PLOT will be called with four arguments:
C      CALL PLOT(VISBLE,X,Y,Z)
C where X,Y (input) are real variables corresponding to
C I,J indices of the array A. If  VISBLE (input, integer) is 1,
C PLOT should draw a visible line from the current pen
C position to the world coordinate point corresponding to (X,Y);
C if it is 0, it should move the pen to (X,Y). Z is the value
C of the current contour level, and may be used by PLOT if desired.
C Example:
C       SUBROUTINE PLOT (VISBLE,X,Y,Z)
C       REAL X, Y, Z, XWORLD, YWORLD
C       INTEGER VISBLE
C       XWORLD = X*COS(Y) ! this is the user-defined
C       YWORLD = X*SIN(Y) ! transformation
C       IF (VISBLE.EQ.0) THEN
C           CALL PGMOVE (XWORLD, YWORLD)
C       ELSE
C           CALL PGDRAW (XWORLD, YWORLD)
C       END IF
C       END
C--
C 14-Nov-1985 - new routine [TJP].
C 12-Sep-1989 - correct documentation error [TJP].
C 22-Apr-1990 - corrected bug in panelling algorithm [TJP].
C 13-Dec-1990 - make errors non-fatal [TJP].
C-----------------------------------------------------------------------
      INTEGER  MAXEMX,MAXEMY
      PARAMETER (MAXEMX=100)
      PARAMETER (MAXEMY=100)
      INTEGER  I
      INTEGER  NNX,NNY, KX,KY, KI,KJ, IA,IB, JA,JB, LS, PX, PY
      LOGICAL  STYLE, PGNOTO
C
C Check arguments.
C
      IF (PGNOTO('PGCONX')) RETURN
      IF (I1.LT.1 .OR. I2.GT.IDIM .OR. I1.GE.I2 .OR.
     1    J1.LT.1 .OR. J2.GT.JDIM .OR. J1.GE.J2) THEN
          CALL GRWARN('PGCONX: invalid range I1:I2, J1:J2')
          RETURN
      END IF
      IF (NC.EQ.0) RETURN
      STYLE = NC.GT.0
      CALL PGQLS(LS)
      CALL PGBBUF
C
C Divide arrays into panels not exceeding MAXEMX by MAXEMY for
C contouring by PGCNSC.
C
CD    write (*,*) 'PGCONX window:',i1,i2,j1,j2
      NNX = I2-I1+1
      NNY = J2-J1+1
      KX = MAX(1,(NNX+MAXEMX-2)/(MAXEMX-1))
      KY = MAX(1,(NNY+MAXEMY-2)/(MAXEMY-1))
      PX = (NNX+KX-1)/KX
      PY = (NNY+KY-1)/KY
      DO 60 KI=1,KX
          IA = I1 + (KI-1)*PX
          IB = MIN(I2, IA + PX)
          DO 50 KJ=1,KY
              JA = J1 + (KJ-1)*PY
              JB = MIN(J2, JA + PY)
C
C             Draw the contours in one panel.
C
CD            write (*,*) 'PGCONX panel:',ia,ib,ja,jb
              IF (STYLE) CALL PGSLS(1)
              DO 40 I=1,ABS(NC)
                  IF (STYLE.AND.(C(I).LT.0.0)) CALL PGSLS(2)
                  CALL PGCNSC(A,IDIM,JDIM,IA,IB,JA,JB,C(I),PLOT)
                  IF (STYLE) CALL PGSLS(1)
   40         CONTINUE
   50     CONTINUE
   60 CONTINUE
C
      CALL PGSLS(LS)
      CALL PGEBUF
      END

C*GREXEC -- PGPLOT device handler dispatch routine
C+
      SUBROUTINE GREXEC(IDEV,IFUNC,RBUF,NBUF,CHR,LCHR)
      INTEGER IDEV, IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C DO NOT MODIFY THIS ROUTINE.
C You should always create a new version by re-executing
C the command file NEWEXEC.COM.
C---
      INTEGER NDEV
      PARAMETER (NDEV=6)
      CHARACTER*10 MSG
C---
      GOTO(1,2,3,4,5,6) IDEV
      IF (IDEV.EQ.0) THEN
          RBUF(1) = NDEV
          NBUF = 1
      ELSE
          WRITE (MSG,'(I10)') IDEV
          CALL GRQUIT('Unknown device code in GREXEC: '//MSG)
      END IF
      RETURN
C---
    1 CALL SSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      RETURN
    2 CALL NUDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      RETURN
    3 CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1)
      RETURN
    4 CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,2)
      RETURN
    5 CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,3)
      RETURN
    6 CALL GLDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1)
      RETURN
C
      END

C* W9DRIV -- PGPLOT device driver for Windows95 (or WindowsNT)
C+
      SUBROUTINE W9DRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      USE       DFLIB
      IMPLICIT  NONE
      INTEGER   IFUNC, NBUF, LCHR, MODE
      REAL      RBUF(*)
      CHARACTER CHR*(*)
C
C PGPLOT driver for IBM PC's and clones running DIGITAL Visual Fortran
C (5.0 or higher).  This driver will create a graphics window.
C PGEND will return control to the default (text) window, but the graphics
C window is not erased until <RETURN> is pressed.
C
C This routine must be compiled and linked with the Digital DFLIB graphics
C library.  Application must be compiled as a "QuickWin Graphics" project type,
C compiler command line option /MW.
C 
C 1989-Nov-03 - (MSDRIV) Started work [AFT]
C 1989-Apr-06 - Improved version [AFT]
C 1991-Mar-13 - Added cursor routine [JHT]
C 12/1993 C. T. Dum: Version for MS Fortran Power Station
C 1996-Apr-26 - W9DRIV (Windows95/PowerStation 4.0 version):
C               resolution modes; interrupt driven mouse (cursor band modes);  
C               rectangle fill; pixel lines [Phil Seeger, PASeeger@aol.com]
C 1996-Apr-30 - multiple devices; return color representation [PAS]
C 1996-May-03 - each window has its own resolution and palette [PAS]
C 1997-Dec-15 - change USE statement from Microsoft to Digital [PAS]
C 1998-May-04 - had only 7 windows instead of 8 [PAS]
C 1998-Jun-22 - moved window initialization to be after open [ACLarson]
C-----------------------------------------------------------------------
C
C Supported device: IBM PC's and compatibles with Windows95/NT;
C                   requires VGA or higher graphics adapter
C
C Device type code: /W95  (also /WV, /WS, /WX, or /WZ)
C
C Modes:   1, VGA,   640 x 480
C          2, SVGA,  800 x 600
C          3, XGA,  1024 x 768
C          4, ZGA,  1280 x 1024
C          0, from PGPLOT_VIDEO environment parameter, or SVGA
C    The Default mode is 800 x 640 pixels (SVGA). Other resolution
C    modes are accessed by entering SET PGPLOT_VIDEO=VGA (640x480), 
C    XGA (1024x768), or ZGA (1280x1024) in the AUTOEXEC.BAT file, or
C    by using alternate device type designations.  The maximum allowed 
C    mode is determined by the graphics card and the Windows95 driver.
C
C Color capability: Color indices 0-15 are set to the default values
C    of PGPLOT, and indices 16-235 default to a gray scale.  Palettes
C    of up to 235 colors are saved for each of 8 possible device 
C    windows. (20 colors are reserved for the system.)
C    NOTE: There are some peculiar graphics adapters out there, and
C          even more peculiar drivers.  The default colors have been 
C          tweeked to appear unique in either the upper 6 or the lower
C          6 bits of each byte.  If you don't like what you see, you
C          may modify the DATA statement for RGB16.  It may also be
C          necessary to change PARAMETER CNORM from 255 to 63.
C
C Default device name: None (the device name, if specified, is ignored).
C
C View surface dimensions: Depends on monitor, typical 7.5x10 inches
C
C Resolution: Depends on graphics card and Windows95 driver.
C
C Input capability: Mouse position, must be followed by a keyboard key.
C
C File format: None.
C
C Obtaining hardcopy: via Windows95, "File/Print" menu choice.
C-----------------------------------------------------------------------
C Notes:
C  Up to MAXDEV "devices" may be open at once. ACTIVE is the number
C  of the currently selected device (1 if no devices are open).
C  STATE(i) is 0 if device i is not open, 1 if it is open but with
C  no current picture, or 2 if it is open with a current picture.
C-----------------------------------------------------------------------
      EXTERNAL  GRW900, GRW901
      INTEGER   MAXDEV
      REAL*4    CNORM
      PARAMETER (MAXDEV=8, CNORM=255.)
      TYPE (xycoord) XY
C
      CHARACTER CMSG*10, WINTITLE*80
      INTEGER   MX(0:4), MY(0:4), MXX(MAXDEV), MXY(MAXDEV), MXC(MAXDEV),&
     &          I, ACTIVE,IUNIT(MAXDEV), STATE(0:MAXDEV), NPIC(MAXDEV)
      INTEGER*4 IRGB, RGB(0:235,MAXDEV), RGB16(0:15), RGB236(0:235)
      INTEGER*2 I2STAT, I2X0, I2Y0, I2X1, I2Y1, DASHLINE(5), ICOLOR,    &
     &          CBITS(MAXDEV), IX(1), IY(1), IC(1)
      INTEGER*4 I4STAT, I4X, I4Y, IXREF, IYREF, BAND, EVENT, IBUF
      LOGICAL   FIRST, QFIRST(MAXDEV), LPOS
      SAVE FIRST, QFIRST, ACTIVE, STATE, XY, MXX, MXY, MXC, IUNIT, RGB, &
     &     ICOLOR, NPIC, MX, MY, DASHLINE, CBITS, RGB16
      DATA FIRST,  QFIRST,        ACTIVE, STATE(0:MAXDEV)/              &
     &     .TRUE., MAXDEV*.TRUE., 1,      -1, MAXDEV*0/
      DATA MX, MY/ 0, 640, 800, 1024, 1280,                             &
     &             0, 480, 640,  768, 1024/
      DATA DASHLINE/#FFFF, #FF80, #FC30, #CCCC, #FCCC/
C
C     Following data statement provides unique colors on all tested adapters
      DATA RGB16(0:15)/0, #FFFFFF, #0000FF, #00FF00, #FF0000, #FFFF00,  &
     &  #FF00FF, #00FFFF, #005FFF, #00FFAA, #AAFF00, #FF9300, #FF0093,  &
     &  #5F00FF, #555555, #AAAAAA/
C
C---
C     Initialize first 16 RGB values and gray scale for all windows
      IF (FIRST) THEN
         FIRST = .FALSE.
         DO ICOLOR=0,15
            DO I=1,MAXDEV
               RGB(ICOLOR,I) = RGB16(ICOLOR)
            END DO
         END DO
         IRGB = #020202
         DO ICOLOR=16,235
            IRGB = IRGB + #010101
            DO I=1,MAXDEV
               RGB(ICOLOR,I) = IRGB
            END DO
         END DO
         ICOLOR = 1
         DO I=1,MAXDEV
            CBITS(I) = #0F
         END DO
      END IF
C
      SELECT CASE (IFUNC)
C
      CASE (1)
C--- IFUNC = 1, Return device name.-------------------------------------
         SELECT CASE (MODE)
         CASE (1)
            CHR = 'WV    (Windows95/NT, 640x480)'
         CASE (2)
            CHR = 'WS    (Windows95/NT, 800x600)'
         CASE (3)
            CHR = 'WX    (Windows95/NT, 1024x768)'
         CASE (4)
            CHR = 'WZ    (Windows95/NT, 1280x1024)'
         CASE DEFAULT
            CHR = 'W9    (Windows95/NT, mode from environment)' 
         END SELECT
         LCHR = LEN_TRIM(CHR)
C
      CASE (2)
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
         IF (QFIRST(ACTIVE)) THEN
            MXX(ACTIVE) = MX(MODE)
            MXY(ACTIVE) = MY(MODE)
            MXC(ACTIVE) = 236
            CALL GRW900(ACTIVE, MXX, MXY, MXC, QFIRST)
         END IF
         RBUF(1) = 0.
         RBUF(2) = MXX(ACTIVE)
         RBUF(3) = 0.
         RBUF(4) = MXY(ACTIVE)
         RBUF(5) = 0.
         RBUF(6) = MXC(ACTIVE)
         NBUF = 6
C
      CASE (3)
C--- IFUNC = 3, Return device resolution. ------------------------------
C Divide the number of pixels on screen by a typical screen size in
C inches.
         IF (QFIRST(ACTIVE)) THEN
            MXX(ACTIVE) = MX(MODE)
            MXY(ACTIVE) = MY(MODE)
            MXC(ACTIVE) = 236
            CALL GRW900(ACTIVE, MXX, MXY, MXC, QFIRST)
         END IF
         RBUF(1) = FLOAT(MXX(ACTIVE)+1)/10.
         RBUF(2) = FLOAT(MXY(ACTIVE)+1)/7.5
         RBUF(3) = 1.0
         NBUF = 3
C
      CASE (4)
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Interactive, Cursor, No dashed lines, No area fill,
C    No thick lines, Rectangle fill, Pixel primative, No ?, querY color
C    representation, No markers)
         CHR  = 'ICNNNRPNYN'
         LCHR = 10
C
      CASE (5)
C--- IFUNC = 5, Return default file name. ------------------------------
         CHR = 'PGPlot Graphics'
         LCHR = LEN_TRIM(CHR)
C
      CASE (6)
C--- IFUNC = 6, Return default physical size of plot. ------------------
         IF (QFIRST(ACTIVE)) THEN
            MXX(ACTIVE) = MX(MODE)
            MXY(ACTIVE) = MY(MODE)
            MXC(ACTIVE) = 236
            CALL GRW900(ACTIVE, MXX, MXY, MXC, QFIRST)
         END IF
         RBUF(1) = 0.
         RBUF(2) = MXX(ACTIVE)
         RBUF(3) = 0.
         RBUF(4) = MXY(ACTIVE)
         NBUF    = 4
C
      CASE (7)
C--- IFUNC = 7, Return misc defaults. ----------------------------------
         RBUF(1) = 1.
         NBUF    = 1
C
      CASE (8)
C--- IFUNC = 8, Select plot. -------------------------------------------
         I = NINT(RBUF(2))
         IF (I.GE.1 .AND. I.LE.MAXDEV .AND. STATE(I).GT.0) THEN 
            IF (I .NE. ACTIVE) THEN
               ACTIVE = I
               I4STAT = SETACTIVEQQ(IUNIT(ACTIVE))
               I4STAT = FOCUSQQ(IUNIT(ACTIVE))
               DO I=0,235
                  RGB236(I) = RGB(I,ACTIVE)
               END DO
               I4STAT = REMAPALLPALETTE(RGB236)
               I2STAT = SETCOLOR(ICOLOR)
            END IF
         ELSE
            CALL GRWARN('invalid or unopened graphics window in W9DRIV')
         END IF
C
      CASE (9)
C--- IFUNC = 9, Open workstation. --------------------------------------
         I = 0
         DO WHILE (I.LE.MAXDEV .AND. STATE(I).NE.0)
            I = I + 1
         END DO
         IF (I .GT. MAXDEV) THEN
            CALL GRWARN('maximum number of graphics windows exceeded')
            RBUF(1) = 0.
            RBUF(2) = 0.
         ELSE
            ACTIVE = I
            RBUF(1) = ACTIVE
            RBUF(2) = 1.
C           Initialize this window in requested mode, and open it
            MXX(ACTIVE) = MX(MODE)
            MXY(ACTIVE) = MY(MODE)
            MXC(ACTIVE) = 236
            CALL GRGLUN(IUNIT(ACTIVE))
            WRITE (WINTITLE, '(A,I2)') CHR(:LCHR)//', #', ACTIVE
            OPEN (IUNIT(ACTIVE), FILE='USER', TITLE=WINTITLE(:LCHR+5))
            CALL GRW900(ACTIVE, MXX, MXY, MXC, QFIRST)
            DO I=0,235
               RGB236(I) = RGB(I,ACTIVE)
            END DO
            I4STAT = REMAPALLPALETTE(RGB236)
            I2STAT = SETCOLOR(ICOLOR)
            STATE(ACTIVE) = 1
            NPIC(ACTIVE)  = 0
         END IF
         NBUF = 2
C
      CASE (10)
C--- IFUNC=10, Close workstation. --------------------------------------
         IF (STATE(ACTIVE) .GT. 0) THEN
            print ('(A,I2)'), ' Type <RETURN> to close graphics '//     &
     &                         'window #',active
            read * 
            CLOSE (IUNIT(ACTIVE))
            STATE(ACTIVE)  = 0
            QFIRST(ACTIVE) = .TRUE.
         END IF
C
      CASE (11)
C--- IFUNC=11, Begin picture. ------------------------------------------
         IF(NPIC(ACTIVE) .EQ. 0) THEN
            CALL CLEARSCREEN($GCLEARSCREEN)
         END IF
         STATE(ACTIVE) = 2
         NPIC(ACTIVE) = NPIC(ACTIVE) + 1
         I4STAT = SETACTIVEQQ(IUNIT(ACTIVE))
         I4STAT = FOCUSQQ(IUNIT(ACTIVE))
C
      CASE (12)
C--- IFUNC=12, Draw line. ----------------------------------------------
         I2X0   = NINT(RBUF(1))
         I2Y0   = MXY(ACTIVE) - NINT(RBUF(2))
         CALL     MOVETO(I2X0, I2Y0, XY)
         I2X1   = NINT(RBUF(3))
         I2Y1   = MXY(ACTIVE) - NINT(RBUF(4))
         I2STAT = LINETO(I2X1, I2Y1)
C
      CASE (13)
C--- IFUNC=13, Draw dot. -----------------------------------------------
         I2X0   = NINT(RBUF(1))
         I2Y0   = MXY(ACTIVE) - NINT(RBUF(2))
         I4STAT = SETPIXEL(I2X0, I2Y0)
C
      CASE (14)
C--- IFUNC=14, End picture. --------------------------------------------
         IF (STATE(ACTIVE) .GT. 0) STATE(ACTIVE) = 1
         NPIC(ACTIVE)  = 0
C
      CASE (15)
C--- IFUNC=15, Select color index. -------------------------------------
         ICOLOR = MIN(MXC(ACTIVE), MAX(0, NINT(RBUF(1))))
         I2STAT = SETCOLOR(ICOLOR)
C
      CASE (16)
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
      CASE (17)
C--- IFUNC=17, Read cursor (mouse) AND keystroke -----------------------
         I4X = NINT(RBUF(1))
         I4Y = MXY(ACTIVE) - NINT(RBUF(2))
         IF (NBUF .GE. 6) THEN
C           Support for multiple forms of cursor
            IXREF = NINT(RBUF(3))
            IYREF = MXY(ACTIVE) - NINT(RBUF(4))
            BAND  = NINT(RBUF(5))
            LPOS  = RBUF(6) .GT. 0.
         ELSE
C           Simple crosshair cursor
            IXREF = I4X
            IYREF = I4Y
            BAND  = 0
            LPOS  = .TRUE.
         END IF
C
C        Set color index, for exclusive-ORing
         ICOLOR   = SETCOLOR(CBITS(ACTIVE))
         I4STAT   = SETWRITEMODE($GXOR)
C        Initialize mouse routine by calling with fake arguments
         CALL GRW901(-BAND, MXX(ACTIVE), MXY(ACTIVE), IXREF, IYREF)
C        Initialize position of cursor by simulating mouse button click
         IF (LPOS) CALL GRW901(IUNIT(ACTIVE), MOUSE$MOVE, 0, I4X, I4Y)
C        Activate mouse callback routine
         EVENT    = MOUSE$MOVE
         I4STAT   = REGISTERMOUSEEVENT(IUNIT(ACTIVE), EVENT, GRW901)
C        Wait for a keystroke
         CHR(1:1) = GETCHARQQ()
C
C        A key has been struck; turn off mouse, get position, restore color
         I4STAT   = UNREGISTERMOUSEEVENT(IUNIT(ACTIVE), EVENT)
         CALL GRW901(0, 0, 0, I4X, I4Y)
         I4STAT   = SETWRITEMODE($GPSET)
         I2STAT   = SETCOLOR(ICOLOR)
C        Return results
         LCHR     = 1
         RBUF(1)  = I4X
         RBUF(2)  = MXY(ACTIVE) - I4Y
         NBUF     = 2
C
      CASE (18)
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C
      CASE (19)
C--- IFUNC=19, Set line style. -----------------------------------------
C Note: not likely to be called because IFUNC=4 returns "No dashed lines"
         I = MIN(5,  MAX(0, NINT(RBUF(1))))
         CALL SETLINESTYLE(DASHLINE(I))
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
      CASE (21)
C--- IFUNC=21, Set color representation. -------------------------------
         I = NINT(RBUF(1))
         IF (I.GE.0 .AND. I.LE.MXC(ACTIVE)) THEN
            ICOLOR = I
            IRGB =    NINT(RBUF(2)*CNORM)     .OR.                      &
     &          ISHFT(NINT(RBUF(3)*CNORM), 8) .OR.                      &
     &          ISHFT(NINT(RBUF(4)*CNORM),16)
            RGB(I,ACTIVE) = IRGB
            CBITS(ACTIVE) = CBITS(ACTIVE) .OR. ICOLOR
            I4STAT = REMAPPALETTERGB(I, IRGB)
         END IF
C
C--- IFUNC=22, Set line width. -----------------------------------------
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
      CASE (24)
C--- IFUNC=24, Rectangle fill. -----------------------------------------
         I2X0   = NINT(RBUF(1))
         I2Y0   = MXY(ACTIVE) - NINT(RBUF(2))
         I2X1   = NINT(RBUF(3))
         I2Y1   = MXY(ACTIVE) - NINT(RBUF(4))
         I2STAT = RECTANGLE($GFILLINTERIOR, I2X0, I2Y0, I2X1, I2Y1)
C
C--- IFUNC=25, Set fill pattern. ---------------------------------------
C
      CASE (26)
C--- IFUNC=26, Line of pixels. -----------------------------------------
         IY(1) = MXY(ACTIVE) - NINT(RBUF(2))
         IF (IY(1).GE.0 .AND. IY(1).LE.MXY(ACTIVE)) THEN
            IX(1) = NINT(RBUF(1))
            IBUF  = 3
            IF (IX(1) .LT. 0) THEN
               IBUF  = 3 - IX(1)
               IX(1) = 0
            END IF
            DO WHILE (IBUF.LE.NBUF .AND. I2X0.LE.MXX(ACTIVE))
               IC(1) = MIN(MXC(ACTIVE), MAX(0, NINT(RBUF(IBUF))))
               CALL SETPIXELS(1, IX, IY, IC)
               IBUF  = IBUF + 1
               IX(1) = IX(1) + 1
            END DO
         END IF
C
C--- IFUNC=27, Scaling info --------------------------------------------
C
C--- IFUNC=28, Draw marker ---------------------------------------------
C
      CASE (29)
C--- IFUNC=29, Query color representation.------------------------------
         I       = NINT(RBUF(1))
         IRGB    = RGB(I,ACTIVE)
         RBUF(2) = FLOAT(IAND(IRGB, #FF))/CNORM
         RBUF(3) = FLOAT(IAND(ISHFT(IRGB,-8), #FF))/CNORM
         RBUF(4) = FLOAT(IAND(ISHFT(IRGB,-16), #FF))/CNORM
         NBUF    = 4
C
      CASE DEFAULT
C--- Unimplemented Function
         WRITE (CMSG, '(I10)') IFUNC
         CALL GRWARN('Unimplemented function in Win95 device driver:'// &
     &               CMSG)
         NBUF = -1
      END SELECT
      RETURN
      END
C*********
      SUBROUTINE GRW900(I, MXX, MXY, MXC, QFIRST)
      USE       DFLIB
C  1998-May-04 - change from MSFLIB to DFLIB 
C  1998-Jun-22 - don't set WC.title to 'PGPLOT'
      IMPLICIT  NONE
      INTEGER   I, MXX(*), MXY(*), MXC(*)
      LOGICAL   QFIRST(*)
C---          
      TYPE (WINDOWCONFIG) WC
      INTEGER   TR$L
      LOGICAL   STATUS
      CHARACTER TR$VID*128
C---
C     Set default window configuration
C     Try to set to input values of MXX, MXY, default 800x600
      IF (MXX(I).LE.1 .OR. MXY(I).LE.1) THEN
         MXX(I) = 800
         MXY(I) = 600
         MXC(I) = 256
         CALL GRGENV('VIDEO', TR$VID, TR$L)
         IF (TR$L .GT. 0) THEN
C           There is a "PGPLOT_VIDEO" parameter in the Environment
            IF( TR$VID(1:1) .EQ. 'V') THEN
C              Set to VGA resolution
               MXX(I) = 640
               MXY(I) = 480
            ELSE IF (TR$VID(1:1) .EQ. 'X') THEN
               MXX(I) = 1024
               MXY(I) = 768
            ELSE IF (TR$VID(1:1) .EQ. 'Z') THEN
               MXX(I) = 1280
               MXY(I) = 1024
            END IF
         END IF
      END IF
C
      WC.numxpixels  = MXX(I)
      WC.numypixels  = MXY(I)
      WC.numcolors   = MXC(I)
      WC.numtextcols = -1
      WC.numtextrows = -1
      WC.fontsize    = -1
      STATUS = SETWINDOWCONFIG(WC)
      IF(.NOT.STATUS) STATUS = SETWINDOWCONFIG(WC)
C
      MXX(I) = WC.numxpixels - 1
      MXY(I) = WC.numypixels - 1
      MXC(I) = WC.numcolors - 1
      QFIRST(I) = .FALSE.
      RETURN
      END
C*********
      RECURSIVE SUBROUTINE GRW901(IUNIT,EVENT,KEYSTATE,XMOUSE,YMOUSE)
      USE      DFLIB
      IMPLICIT NONE
      INTEGER  IUNIT, EVENT, KEYSTATE, XMOUSE, YMOUSE
C
C  Callback routine for mouse events, specific to Windows95
C       Note: cursor band modes implemented in software
C
C  1996-Apr-26 - P.A.Seeger
C  1998-May-04 - change from MSFLIB to DFLIB 
C--
      RECORD /xycoord/ XY
      INTEGER*2 BAND, LENGTH, IX0, IY0, IX1, IY1, IX2, IY2, IXR, IYR
      INTEGER*4 DUMMY
      LOGICAL   INITIUS, FINIS
      DATA      INITIUS /.TRUE./
      SAVE      INITIUS,BAND,LENGTH,IX0,IY0,IX1,IY1,IX2,IY2,IXR,IYR
C
C     Disable mouse movement interrupts while in callback routine
      IF (IUNIT .GT. 0) DUMMY = UNREGISTERMOUSEEVENT(IUNIT, MOUSE$MOVE)
C
      FINIS = IUNIT.EQ.0 .AND. EVENT.EQ.0 .AND. KEYSTATE.EQ.0
      IF (IUNIT.LE.0 .AND. .NOT.FINIS) THEN
         INITIUS = .TRUE.
C        Get initialization parameters from callback calling sequence
         BAND = -IUNIT
         IXR  = XMOUSE
         IYR  = YMOUSE
         IX0  = IXR
         IY0  = IYR
C        Extract parameters for length of cursor lines
         IF (BAND .EQ. 0) THEN
C           Simple crosshair cursor
            LENGTH = MAX(EVENT, KEYSTATE)/80 + 3
         ELSE
            LENGTH = 0
            IX1 = 0
            IX2 = 0
            IY1 = 0
            IY2 = 0
C           Modes with full width horizontal line(s)
            IF (BAND.EQ.3 .OR. BAND.EQ.5 .OR. BAND.EQ.7) IX2 = EVENT
C           Modes with full height vertical line(s)
            IF (BAND.EQ.4 .OR. BAND.EQ.6 .OR. BAND.EQ.7) IY2 = KEYSTATE
            IF (BAND .EQ. 3) THEN
C              Draw fixed horizontal line at anchor
               CALL    MOVETO(IX1, IYR, XY)
               DUMMY = LINETO(IX2, IYR    )
            ELSE IF (BAND .EQ. 4) THEN
C              Draw fixed vertical line at anchor
               CALL    MOVETO(IXR, IY1, XY)
               DUMMY = LINETO(IXR, IY2    )
            END IF
         END IF
         GO TO 700
      END IF
C
      IF (.NOT. INITIUS) THEN
C        This is NOT an initial call, so need to erase previous cursor
C          by rewriting it in complementary color mode
         IF (BAND .EQ. 1) THEN
            CALL    MOVETO(IXR, IYR, XY)
            DUMMY = LINETO(IX0, IY0    )
         ELSE IF (BAND .EQ. 2) THEN
            DUMMY = RECTANGLE($GBORDER, IXR, IYR, IX0, IY0)
         ELSE
            IF (IY2 .NE. IY1) THEN
               CALL    MOVETO(IX0, IY1, XY)
               DUMMY = LINETO(IX0, IY2    )
            END IF
            IF (IX2 .NE. IX1) THEN
               CALL    MOVETO(IX1, IY0, XY)
               DUMMY = LINETO(IX2, IY0    )
            END IF
         END IF
      END IF
C
      IF (FINIS) THEN
C        Termination call, return latest mouse location
         XMOUSE = IX0
         YMOUSE = IY0
         IF (BAND .EQ. 3) THEN
C           Erase fixed horizontal line at anchor
            CALL    MOVETO(IX1, IYR, XY)
            DUMMY = LINETO(IX2, IYR    )
         ELSE IF (BAND .EQ. 4) THEN
C           Erase fixed vertical line at anchor
            CALL    MOVETO(IXR, IY1, XY)
            DUMMY = LINETO(IXR, IY2    )
         END IF
         INITIUS = .TRUE.
         GO TO 700
      END IF
C
C     Save new cursor location
      IX0 = XMOUSE
      IY0 = YMOUSE
      IF (BAND .EQ. 0) THEN
C        Find ends of cursor line segments
         IX1 = IX0 - LENGTH
         IX2 = IX0 + LENGTH
         IY1 = IY0 - LENGTH
         IY2 = IY0 + LENGTH      
      END IF
C 
C     Now draw line, box, or cursor in complementary color
      INITIUS = .FALSE.
      IF (BAND .EQ. 1) THEN
C        Line from anchor to cursor location
         CALL    MOVETO(IXR, IYR, XY)
         DUMMY = LINETO(IX0, IY0    )
      ELSE IF (BAND .EQ. 2) THEN
C        Box with vertices at anchor and cursor location
         DUMMY = RECTANGLE($GBORDER, IXR, IYR, IX0, IY0)
         ELSE
            IF (IY2 .NE. IY1) THEN
C           Draw a horizontal line (or segment)        
            CALL    MOVETO(IX0, IY1, XY)
            DUMMY = LINETO(IX0, IY2)
         END IF
            IF (IX2 .NE. IX1) THEN
C           Draw a vertical line (or segment)
            CALL    MOVETO(IX1, IY0, XY)
            DUMMY = LINETO(IX2, IY0)
         END IF
      END IF
C
700   CONTINUE
      IF (IUNIT.GT.0 .AND. .NOT.INITIUS)                                &
     &       DUMMY = REGISTERMOUSEEVENT(IUNIT, MOUSE$MOVE, GRW901)
      RETURN
      END

C*GRQCOL -- inquire color capability
C+
      SUBROUTINE GRQCOL (CI1, CI2)
      INTEGER  CI1, CI2
C
C Query the range of color indices available on the current device.
C
C Argument:
C  CI1    (output) : the minimum available color index. This will be
C                    either 0 if the device can write in the
C                    background color, or 1 if not.
C  CI2    (output) : the maximum available color index. This will be
C                    1 if the device has no color capability, or a
C                    larger number (e.g., 3, 7, 15, 255).
C--
C 31-May-1989 - new routine [TJP].
C  1-Sep-1994 - avoid driver call [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
C
C Error if no workstation is open.
C
      IF (GRCIDE.LT.1) THEN
          CI1 = 0
          CI2 = 0
      ELSE
          CI1 = GRMNCI(GRCIDE)
          CI2 = GRMXCI(GRCIDE)
      END IF
C
      END

C Date:     3-FEB-1988 15:08:32 GMT
C From:     AFT@AST-STAR.CAM.AC.UK
C To:       TJP@CITPHOBO
C Subject:  LIDRIVER.FOR

C*LIDRIV -- PGPLOT driver form Liacom device

	SUBROUTINE LIDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
C- GRPCKG driver for Liacom image device.
C---
C Supported device:  Liacom Graphic Video Display (GVD-02).
C
C Device type code:  /LIacom
C
C Default device name:  LIACOM_DEVICE (a logical name).
C
C Default view surface dimensions:  Depends on monitor.
C
C Resolution:  The full view surface is 512 by 512 pixels.
C
C Color capability:  Color indices 0-15 are supported.  The default
C   color representation is as listed in Chapter 5 of the PGPLOT
C   Manual.  The representation of all color indices can be changed.
C   Color indices 128-255 map into the second row of bit planes and
C   support 15 levels of grey scale.
C
C Input capability:  Cursor is a fat white cross.
C
C File format:  It is not possible to send Liacom plots to a disk file.
C
C Obtaining hardcopy:  Not possible.
C
C  5-Aug-1986 - [AFT].
C 16-Jan-1988 - Track PGPLOT [AFT].
C-----------------------------------------------------------------------
	INCLUDE '($IODEF)'
	INCLUDE '($SSDEF)'
	INTEGER   IFUNC,NBUF,LCHR,I0,J0,I1,J1
	REAL      RBUF(6)
	CHARACTER CHR*(*)
C
	INTEGER   GRGE00, SYS$DASSGN, GRGMEM, IER
	INTEGER*2 ITMP(10), ICHAN
	INTEGER   IREM, IWRT, IRD, LUN, MXCNT, ICNT, IBADR, ICOL
	SAVE      IREM, IWRT, IRD, LUN, MXCNT, ICNT, IBADR, ICOL
	LOGICAL   APPEND
	SAVE      APPEND
C---
	GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     &       110,120,130,140,150,160,170,999,999,999,
     &       210,999,230) IFUNC
	GOTO 999
C---
C- IFUNC= 1, Return device name.
10	CHR='LIACOM'
	LCHR=LEN(CHR)
	RETURN
C---
C- IFUNC= 2, Return Physical min and max for plot device.
20	RBUF(1)=0
	RBUF(2)=511
	RBUF(3)=0
	RBUF(4)=511
	RBUF(5)=0
	RBUF(6)=255
	NBUF=6
	RETURN
C---
C- IFUNC= 3, Return device (X and Y) resolution in pixels per inch as
C- formatted numbers in CHR.
30	RBUF(1)=50.0
	RBUF(2)=50.0
	RBUF(3)=1
	NBUF=3
	RETURN
C---
C- IFUNC= 4, Return misc device info.
40	CHR='ICNNNNNNNN'
	LCHR=10
	RETURN
C---
C- IFUNC= 5, Return default file name.
50	CHR='LIACOM_DEVICE'
	LCHR=LEN(CHR)
	NBUF=1
	RETURN
C---
C- IFUNC= 6, Return default physical size of plot.
60	RBUF(1)=0
	RBUF(2)=511
	RBUF(3)=0
	RBUF(4)=511
	RETURN
C---
C- IFUNC= 7, Return misc defaults.
70	RBUF(1)=1
	NBUF=1
	RETURN
C---
C- IFUNC= 8, Set active plot.
80	CALL INIT03(1,LUN,IWRT)
	RETURN
C---
C- IFUNC= 9, Open workstation.
90	APPEND = RBUF(3).NE.0.0
	RBUF(2)=GRGE00('Q2 ',LUN,CHR,LCHR)
	IF(RBUF(2).EQ.1) THEN
	    IREM=0
	    IWRT='000010A0'X
	    IRD ='000010A0'X
	ELSE IF(RBUF(2).EQ.3) THEN
	    IREM=1
	    IWRT=IO$_WRITEVBLK
	    IRD =IO$_READVBLK
	    RBUF(2)=1
	ELSE
	    IWRT=0
	END IF
	RBUF(1)=LUN
	IF(NINT(RBUF(2)).EQ.1) THEN
	    MXCNT=8192
	    IER=GRGMEM(MXCNT,IBADR)
	    IF(IER .NE. SS$_NORMAL) THEN
		CALL GRGMSG(IER)
		CALL GRWARN('Unable to allocate virtual memory.')
		RBUF(2)=0
		CALL SYS$DASSGN(%val(LUN))
		RETURN
	    END IF
	    CALL INIT03(1,LUN,IWRT)
	    IF(RBUF(3).EQ.0) CALL GRLI10(%val(IBADR),ICNT,MXCNT)
	END IF
	RETURN
C---
C- IFUNC=10, Close workstation.
100	IF(IREM.NE.0) CALL GRLI12(LUN)
	CALL SYS$DASSGN(%val(LUN))
	CALL GRFMEM(MXCNT,IBADR)
	RETURN
C---
C- IFUNC=11, Begin Picture.
110	ITMP(1)='1088'x		! Select cursor
	ITMP(2)='7000'x		! Cursor off
	ITMP(3)='103F'x		! Select all bit planes
	ITMP(4)='700F'x		! Set video blank to open (display on)
	ITMP(5)='1010'x+ICOL	! Select planes corresponding to color
	CALL GRGE02(ITMP,10,%val(IBADR),ICNT,MXCNT)
	CALL GRGE03(%val(IBADR),ICNT)
	IF(.NOT.APPEND) THEN
	  ITMP(1)='103F'x	! Select all bit planes
	  ITMP(2)='3000'x	! Erase
	  CALL GRGE02(ITMP, 4,%val(IBADR),ICNT,MXCNT)
	END IF
	APPEND=.FALSE.
	RETURN
C---
C- IFUNC=12, Draw line.
120	I0=NINT(RBUF(1))
	J0=NINT(RBUF(2))
	I1=NINT(RBUF(3))
	J1=NINT(RBUF(4))
	CALL GRLI01(I0,J0,I1,J1,%val(IBADR),ICNT,MXCNT,ICOL)
	RETURN
C---
C- IFUNC=13, Draw dot.
130	I0=NINT(RBUF(1))
	J0=NINT(RBUF(2))
	CALL GRLI01(I0,J0,I0,J0,%val(IBADR),ICNT,MXCNT,ICOL)
	RETURN
C---
C- IFUNC=14, End Picture.
140	RETURN
C---
C- IFUNC=15, Select color index.
150	ICOL=MAX(0,MIN(NINT(RBUF(1)),255))
	RBUF(1)=ICOL
155	IF(ICOL.GT.0) THEN
	    IF(ICOL.LT.128) THEN
C- Select bit planes in row 1.
	        ITMP(1)='1010'x+IAND(ICOL,15)
	    ELSE
C- Select bit planes in row 2 (must be in range 1-15).
	        ITMP(1)='1020'x+1+INT(15.*IAND((ICOL-128),127)/128.)
	    END IF
	ELSE
C- Select all planes in both rows.
	    ITMP(1)='103F'x
	END IF
	CALL GRGE02(ITMP,2,%val(IBADR),ICNT,MXCNT)
	RETURN
C---
C- IFUNC=16, Flush buffer.
160	CALL GRGE03(%val(IBADR),ICNT)
	RETURN
C---
C- IFUNC=17, Make cursor visible and read position.
170	I0=RBUF(1)
	J0=RBUF(2)
	CALL GRLI11(I0,J0,CHR,LUN,%val(IBADR),ICNT,MXCNT,ICOL,IRD)
	RBUF(1)=I0
	RBUF(2)=J0
	NBUF=2
	LCHR=1
	RETURN
C---
C- IFUNC=21, Set color representation.
210	ITMP( 1)='1084'x		! Select LUT.
	ICHAN=NINT(RBUF(1))
	IF(ICHAN.LT.128) THEN
C- Select bit planes in row 1.
	    ICHAN=IAND(ICHAN,15)
	ELSE
C- Select bit planes in row 2.
	    ICHAN=1+INT(15.*IAND((ICHAN-128),127)/128.)
	    ICHAN=16*ICHAN
	END IF
C
	ITMP( 2)='4300'x+ICHAN		! Load address
	ITMP( 3)='7001'x		! Enable channel 1 (red).
	I0=IAND(255,INT(RBUF(2)*255.999))
	ITMP( 4)='5000'x+I0		! Load data (color level).
C
	ITMP( 5)='4300'x+ICHAN		! Load address
	ITMP( 6)='7002'x		! Enable channel 2 (green).
	I0=IAND(255,INT(RBUF(3)*255.999))
	ITMP( 7)='5000'x+I0		! Load data (color level).
C
	ITMP( 8)='4300'x+ICHAN		! Load address
	ITMP( 9)='7004'x		! Enable channel 4 (blue).
	I0=IAND(255,INT(RBUF(4)*255.999))
	ITMP(10)='5000'x+I0		! Load data (color level).
C
	CALL GRGE02(ITMP,20,%val(IBADR),ICNT,MXCNT)
	GOTO 155
C---
C- IFUNC=23, Escape.
230	CALL GRGE02(%ref(CHR),LCHR,%val(IBADR),ICNT,MXCNT)
	RETURN
C---
C- Flag function not implemented.
999	NBUF=-1
	RETURN
	END
     
	SUBROUTINE GRLI01 (I0,J0,I1,J1,IBUF,ICNT,MXCNT,ICOL)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, Liacom): draw a line segment.  The VAX can
C send data to the Liacom faster than the Liacom can plot it, if lines
C are more than 255 pixels in length.  To avoid this problem, long
C lines must be broken into shorter segments.
C
C Arguments:
C
C I0,J0 (integer, input): the column and row numbers of the starting
C	point.
C I1,J1 (integer, input): the column and row numbers of the end point.
C
C 11-Apr-1983 - Original.
C 18-Jan-1988 - Break long lines into segments [AFT].
C-----------------------------------------------------------------------
	INTEGER   I0,J0,I1,J1,IBUF,ICNT,MXCNT,ICOL
C
	INTEGER   CLIP511,X
	INTEGER   IC0, JC0, IC1, JC1, IDXA, IDYA
	INTEGER   IDX, IDY, IDIST, ISX, ISY
	INTEGER*2 ITMP(11)
C---
	CLIP511(X) = X .AND. '1FF'X
C
	IC0 = CLIP511(I0)
	JC0 = CLIP511(J0)
	IC1 = CLIP511(I1)
	JC1 = CLIP511(J1)
	IDX= IC1-IC0
	IDY= JC1-JC0
	JC0= 511-JC0
	IDXA= ABS(IDX)
	IDYA= ABS(IDY)
	IF(IDX.LT.0) THEN
	    ISX='0200'x
	ELSE
	    ISX=0
	END IF
	IF(IDY.LT.0) THEN
	    ISY='0200'x
	ELSE
	    ISY=0
	END IF
	IDIST=IDXA*IDXA+IDYA*IDYA
C---
	ITMP(1) = '4000'x .OR. IC0	! LXA
	ITMP(2) = '5000'x .OR. JC0	! LYA
	IF(IDIST.EQ.0) THEN
	    IF(ICOL.GT.0) THEN
		ITMP(3)='8010'x
	    ELSE
		ITMP(3)='8000'x
	    END IF
	    CALL GRGE02(ITMP, 6,IBUF,ICNT,MXCNT)
	ELSE IF(IDIST.LE.255*255) THEN
C---
C- Short lines can be dones as a single vector.
C
	    IF(ICOL .GT. 0) THEN
C- FSV-positive.
		ITMP(3) = '2001'x
	    ELSE
C- FSV-negative
		ITMP(3) = '2000'x
	    ENDIF
C- Note reverse order.
	    ITMP(4) = IDYA .OR. ISY
	    ITMP(5) = IDXA .OR. ISX
	    CALL GRGE02(ITMP,10,IBUF,ICNT,MXCNT)
	ELSE IF(IDIST.LE.2*255*255) THEN
C---
C- Break vector into two segments.
	    IF(ICOL .GT. 0) THEN
C- FSV-positive.
		ITMP(3) = '2001'x
		ITMP(6) = '2001'x
	    ELSE
C- FSV-negative
		ITMP(3) = '2000'x
		ITMP(6) = '2000'x
	    ENDIF
C- Note reverse order.
	    IDY=IDYA/2
	    ITMP(4)=IDY .OR. ISY
	    IDX=IDXA/2
	    ITMP(5)=IDX .OR. ISX
	    ITMP(7)=(IDYA-IDY) .OR. ISY
	    ITMP(8)=(IDXA-IDX) .OR. ISX
	    CALL GRGE02(ITMP,16,IBUF,ICNT,MXCNT)
	ELSE
C---
C- Break vector into three segments. (The line must be diagonal.)
	    IF(ICOL .GT. 0) THEN
C- FSV-positive.
		ITMP(3) = '2001'x
		ITMP(6) = '2001'x
		ITMP(9) = '2001'x
	    ELSE
C- FSV-negative
		ITMP(3) = '2000'x
		ITMP(6) = '2000'x
		ITMP(9) = '2000'x
	    ENDIF
C- Note reverse order.
	    IDY=IDYA/3
	    ITMP(4)=IDY .OR. ISY
	    ITMP(7)=ITMP(4)
	    IDX=IDXA/3
	    ITMP(5)=IDX .OR. ISX
	    ITMP(8)=ITMP(5)
	    ITMP(10)=(IDYA-2*IDY) .OR. ISY
	    ITMP(11)=(IDXA-2*IDX) .OR. ISX
	    CALL GRGE02(ITMP,22,IBUF,ICNT,MXCNT)
	END IF
C
	RETURN
	END

	SUBROUTINE GRLI10(IBUF,ICNT,MXCNT)
C--------------------------------------------------------------------
C GRPCKG (Internal routine, Liacom)
C Loads standard PGPLOT look-up table.
C--------------------------------------------------------------------
	INTEGER IBUF(1),ICNT,MXCNT
	INTEGER*2 LIABUF(58)/'1084'X, 'C001'X, '0000'X,
     &	  '7001'x, '4300'x, '5000'x, '50FF'x, '50FF'x, '5000'x,
     &			    '5000'x, '5000'x, '50FF'x, '50FF'x,
     &			    '50FF'x, '508F'x, '5000'x, '5000'x,
     &			    '508F'x, '50FF'x, '5055'x, '50AA'x,
     &	  '7002'x, '4300'x, '5000'x, '50FF'x, '5000'x, '50FF'x,
     &			    '5000'x, '50FF'x, '5000'x, '50FF'x,
     &			    '508F'x, '50FF'x, '50FF'x, '508F'x,
     &			    '5000'x, '5000'x, '5055'x, '50AA'x,
     &	  '7004'x, '4300'x, '5000'x, '50FF'x, '5000'x, '5000'x,
     &			    '50FF'x, '50FF'x, '50FF'x, '5000'x,
     &			    '5000'x, '5000'x, '508F'x, '50FF'x,
     &			    '50FF'x, '508F'x, '5055'x, '50AA'x,
     &    '1010'x/
C---
C- Actions taken by LIABUF are:
C- Select lookup table, send block of zeros,
C- for each channel define bottom 8 colors,
C- Select bottom plane only (color 1).
C---
	CALL GRGE02(LIABUF,116, IBUF,ICNT,MXCNT)
	CALL GRGE03(IBUF,ICNT)
	RETURN
	END

	SUBROUTINE GRLI11(IX,IY,LETTER,LUN,IBUF,ICNT,MXCNT,ICOL,IRD)
C------------------------------------------------------------
C  GRLI11:  (Grpckg internal routine, Liacom)
C  Make cursor visible, then after reading a character
C  from the terminal, read the cursor position.
C
C  Arguments:
C
C  IX,IY (integer, input/output):  position of cursor.
C  LETTER (character, output):  character typed by user.
C
C  19-OCT-1983
C------------------------------------------------------------
	INCLUDE '($SSDEF)'
	INTEGER   IX, IY, LUN, IBUF(1), ICNT, MXCNT, ICOL, IRD
	CHARACTER LETTER
	INTEGER*2 X, Y, LIABUF(4), IOSB(5)
	INTEGER   SYS$QIOW, SYS$ASSIGN, SYS$DASSGN, GRGETC
	INTEGER   I
	INTEGER   ICHAN, IER
C---
	IF(IX .LT. 0) THEN
		X= 0
	ELSE IF(IX .GT. 511) THEN
		X= 511
	ELSE
		X= IX
	END IF
C
	IF(IY .LT. 0) THEN
		Y= 0
	ELSE IF(IY .GT. 511) THEN
		Y= 511
	ELSE
		Y= IY
	END IF
C
	IER = SYS$ASSIGN('TT', ICHAN, ,)
	IF(IER .NE. 1) THEN
		CALL GRGMSG(IER)
		CALL GRQUIT('Fatal error.')
	END IF
C
	LIABUF(1)= '1088'X		!  Select cursor.
	LIABUF(2)= '7003'X		!  Make visible, non-blinking.
	LIABUF(3)= '4000'X .OR. X	!  Load X address.
	LIABUF(4)= '5000'X .OR. (511-Y)	!  Load Y address.
	CALL GRGE02(LIABUF, 8, IBUF,ICNT,MXCNT)
	CALL GRGE03(IBUF,ICNT)
C
	LETTER= CHAR(GRGETC(ICHAN))
C
	LIABUF(1)= 'F002'X		! Initiate readback.
	CALL GRGE02(LIABUF, 2, IBUF,ICNT,MXCNT)
	CALL GRGE03(IBUF,ICNT)
C
	IER= SYS$QIOW(,%val(LUN), %val(IRD),IOSB,,,
     &		    LIABUF, %val(6), %val(5),,,)
	IF(IER .NE. SS$_NORMAL) THEN
		CALL GRGMSG(IER)
		CALL GRQUIT('Error reading from Liacom.')
	END IF
C
	DO I=1, 3
	END DO
C
	IX= LIABUF(2) .AND. '01FF'X
	IY= LIABUF(3) .AND. '01FF'X
	IY= 511-IY
C
	IER= SYS$DASSGN(%val(ICHAN))
C
	LIABUF(1)= '7000'X		!  Make cursor invisible.
	LIABUF(2)= '1010'X + ICOL	!  Back to vector graphics.
	CALL GRGE02(LIABUF, 4, IBUF,ICNT,MXCNT)
	CALL GRGE03(IBUF,ICNT)
C
	RETURN
	END

	SUBROUTINE GRLI12(LUN)
C-----------------------------------------------------------------------
	INCLUDE  '($IODEF)'
	INCLUDE  '($SSDEF)'
	INTEGER   SYS$QIOW
	INTEGER  LUN
	INTEGER  IER, LENGTH, ITEMP
	INTEGER*2 LIABUF, IREC, IOSB(4)
C---
	IREC='FFFF'X
C
C  For the Liacom across the network send an END request and wait to be told
C  that the Liacom has been deassigned - this avoids problems of trying
C  to reallocate it before it has been deassigned
C
	LIABUF='2002'X
	LENGTH=2
	IER=SYS$QIOW(,%val(LUN),%val(IO$_WRITEVBLK),IOSB,,,
     :			LIABUF,%val(LENGTH),,,,)
	IF(IOSB(1) .NE. SS$_NORMAL) THEN
	    CALL GRWARN ('Error sending disconnect request' //
     :                      ' to task on remote node')
	    ITEMP=IOSB(1)
	    CALL GRGMSG(ITEMP)
	END IF
	IER=SYS$QIOW(,%val(LUN),%val(IO$_READVBLK),IOSB,,,
     :			LIABUF,LENGTH,,,,)
	IF(IOSB(1) .NE. SS$_NORMAL) THEN
	    CALL GRWARN ('Unable to read Liacom free message' //
     :                      ' from task on remote node')
	    WRITE(6,*) IOSB(2), ' bytes read'
	    ITEMP=IOSB(1)
	    CALL GRGMSG(ITEMP)
	END IF
	IF(LIABUF .NE. IREC) THEN
	    WRITE(*,500) 'Wrong data read from remote task ',
     :		 IREC, ' expected, ',LIABUF,' read'
 500	    FORMAT(1X,A,Z6,A)
	END IF
	RETURN
	END

C*PGLAB -- write labels for x-axis, y-axis, and top of plot
C%void cpglab(const char *xlbl, const char *ylbl, const char *toplbl);
C+
      SUBROUTINE PGLAB (XLBL, YLBL, TOPLBL)
      CHARACTER*(*) XLBL, YLBL, TOPLBL
C
C Write labels outside the viewport. This routine is a simple
C interface to PGMTXT, which should be used if PGLAB is inadequate.
C
C Arguments:
C  XLBL   (input) : a label for the x-axis (centered below the
C                   viewport).
C  YLBL   (input) : a label for the y-axis (centered to the left
C                   of the viewport, drawn vertically).
C  TOPLBL (input) : a label for the entire plot (centered above the
C                   viewport).
C--
C 11-May-1990 - remove unnecessary include - TJP.
C-----------------------------------------------------------------------
      CALL PGBBUF
      CALL PGMTXT('T', 2.0, 0.5, 0.5, TOPLBL)
      CALL PGMTXT('B', 3.2, 0.5, 0.5, XLBL)
      CALL PGMTXT('L', 2.2, 0.5, 0.5, YLBL)
      CALL PGEBUF
      END

C*GRFLUN -- free a Fortran logical unit number (Sun/Convex-UNIX)
C+
      SUBROUTINE GRFLUN(LUN)
      INTEGER LUN
C
C Free a Fortran logical unit number allocated by GRGLUN. [This version
C does nothing.]
C
C Arguments:
C  LUN    : the logical unit number to free.
C--
C 25-Nov-1988
C-----------------------------------------------------------------------
      RETURN
      END

!!G Toolbox.finc
C  If you have a power mac version of LS fortran uncomment the
C next 5 lines and comment out "!!MP InLines.f"
C!!IFC NOT LSPOWERF
C!!MP 68KInlines
C!!ELSEC
C!!MP PPCInlines
C!!ENDC
C  If you have a 68K mac version of LS fortran comment out the 
C 5 lines above and uncomment the next line.
!!MP InLines.f
      SUBROUTINE MCDRIV (OPCODE, RBUF, NBUF, CHR, LCHR)
      Implicit None
      INTEGER OPCODE, NBUF, LCHR
      REAL RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Macintosh computers.
C
C-----------------------------------------------------------------------
C

!!SETC USINGINCLUDES = .FALSE.
      include    'globals.f'

c   Bounding rectangle for the window
      record /rect/ bounds, rectangle
      record /WindowPtr/ myWindow
      RECORD /Point/ MouseLoc            !Where it was clicked
      RECORD /KeyMap/ KeysTyped        !What was typed.
      RECORD /PolyHandle/ Polyhnd          !handle for a polygon region
      Record /PicHandle/ windowPic     !handle for picture
      string*255    title,text
      logical*2    visible,goAway, Update, Ignore
      integer*4 minus1,Lw,ndum,npolypts,countpoly,windhgt,I,J,ColArr(0:7)
      Integer*2 xpt,ypt
      parameter (minus1 = -1, visible = .true.,    goAway = .false., 
     +           Update = .True.)
      Character*120 MSG,ch*1,Picture*3
      Character*(*) MCTYPE
      Parameter (MCTYPE = 'MAC   (Macintosh Window)')
      Data ColArr/WhiteColor,BlackColor,RedColor,GreenColor,BlueColor,
     +     CyanColor,MagentaColor,YellowColor/

C  Variables to handle event record.

      RECORD /EventRecord/ theEvent
      LOGICAL*2 DONE
      LOGICAL*1 AN_EVENT
      INTEGER*2 EVENT_MASK

      Save bounds, Mywindow, polyhnd, lw, npolypts, countpoly,
     +      Windhgt,xpt, ypt, Ignore, QDG, ColArr, windowPic, Picture

      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,900,200,
     2     210,220,230,240,900,260,900,900,900), OPCODE
      GOTO 900
C
C--- OPCODE = 1, Return device name.-------------------------------------
C
   10 CHR = MCTYPE
      LCHR = LEN(MCTYPE)
C  Get the global values now since this is needed later on and opcode=1
C  is always called before the globals are needed.
      QDG = JQDGLOBALS()
      RETURN
C
C--- OPCODE = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
c    Set up the bounding rectangle for the window that is the largest
c    that will fit on the screen.
C   Note that the bottom left hand corner is 0,0 in pgplot, while the
C   top left hand corner is 0,0 on a Mac.  Leave about 40 pixels for the title
C   bar of the window.  See OPCODE = 9 for how we translate the y coordinate.

   20 RBUF(1) = 0.0
      RBUF(2) = float(QDG^.screenbits.bounds.right)
      RBUF(3) = 0.0
      RBUF(4) = float(QDG^.screenbits.bounds.bottom - 40)
      RBUF(5) = 0.0
      RBUF(6) = 7.0
      NBUF = 6
      RETURN
C
C--- OPCODE = 3, Return device resolution. ------------------------------
C
   30 RBUF(1) = 72.0
      RBUF(2) = 72.0
      RBUF(3) = 1.0
      NBUF = 3
      RETURN
C
C--- OPCODE = 4, Return misc device info. -------------------------------
C    (This device is Interactive, Cursor Control, No Hardware dashed lines,
C     Arbitary Polygons Fills, Pen Thickness support but ends are not
C     rounded, Rectangle Fills, Pixel Primitives Support, No Extra Prompt
C     before closing window, No color query support, No hardware symbol
C     support yet.
C
   40 CONTINUE
      CHR = 'ICNATRPNNN'
      RETURN
C
C--- OPCODE = 5, Return default name. ------------------------------
C
   50 CHR = 'PGPLOT Mac Window'
      LCHR = LEN(MCTYPE)
      RETURN
C
C--- OPCODE = 6, Return default physical size of plot. ------------------
C
   60 RBUF(1) = 0.0
      RBUF(2) = float(QDG^.screenbits.bounds.right)
      RBUF(3) = 0.0
      RBUF(4) = float(QDG^.screenbits.bounds.bottom - 40)
      NBUF = 4
      RETURN
C
C--- OPCODE = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 1
      NBUF = 1
      RETURN
C
C--- OPCODE = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- OPCODE = 9, Open workstation. --------------------------------------
C
   90 NBUF = 2
C   If the size of the window has not been set than set it to the 
C  default window size.
      If ((bounds.right .eq. 0) .or. (bounds.bottom .eq. 0)) Then
         bounds = QDG^.screenbits.bounds
         bounds.top = QDG^.screenbits.bounds.top + 40
         bounds.bottom = QDG^.screenbits.bounds.bottom
      End If
	  windhgt = bounds.bottom - bounds.top

C   Ignore RBUF(3) for now.  I'm not sure what it is used for.  
c    Call NewWindow with nil to create the window on the heap
      title = chr(:lchr)
      myWindow.P = NewWindow(nil,bounds,%ref(title),
     1        visible,int2(noGrowDocProc),minus1,
     2        goAway,nil)
      If (myWindow.P .EQ. 0) then
         RBUF(1) = 0.0
         RBUF(2) = 0.0
	  Else
	     Call Setport(myWindow.p)
         RBUF(1) = float(myWindow.P)
         RBUF(2) = 1.0
      End If
      RETURN
C
C--- OPCODE=10, Close workstation. --------------------------------------
C
  100 CONTINUE
      Call DisposeWindow(myWindow.P)
      RETURN
C
C--- OPCODE=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
C     Erase previous screen
      Call EraseRect(myWindow.P^.portRect)
	  
C     Resize Window
      bounds.right = int2(nint(Rbuf(1)))
      bounds.bottom = int2(nint(rbuf(2))+40)
      windhgt = bounds.bottom - bounds.top
      Call SizeWindow(myWindow.P,bounds.right,bounds.bottom,Update)
      If (MyWindow.p .eq. NiL) Then
         WRITE (MSG,'(''Could not resize window: '',I10)') OPCODE
         CALL GRWARN(MSG)
         Ignore = .TRUE.
      End If

C   Set the origin of the window to the lower, left hand corner to correspond
C   with PGPLOT.  Note that the y-coordinate increases downward on a mac
C   while it increases upward in PGPLOT.  So after setting the origin to
C   the bottom left hand corner, y-coordinate on mac equals the negative of the
C   y-coordinate from PGPLOT.
      call ClipRect(myWindow.P^.portRect)
      Call SetOrigin(int2(0),int2(0))

      Call grgenv('MACPICTURE',Picture,ndum)
	  If (picture(1:2) .eq. 'ON') Then
C        Open picture to record quick draw calls.
C         Write(0,*) 'Opening Picture'
         rectangle.top = 0
   	     rectangle.bottom = windhgt
   	     rectangle.left = 0
	     rectangle.right = bounds.right
         windowPic =  OpenPicture(rectangle)
         call ClipRect(rectangle)
	     Call ShowPen()
	  End If
C  Initialize constants.
      Ignore = .False.
      npolypts = 0
      Countpoly = 0
      RETURN
C
C--- OPCODE=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      If (Ignore) Return
      Call MoveTo(int2(nint(Rbuf(1))),int2(windhgt-nint(Rbuf(2))))
      Call LineTo(int2(nint(Rbuf(3))),int2(windhgt-nint(Rbuf(4))))
      Return
C
C--- OPCODE=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      If (Ignore) Return
      xpt = Nint(rbuf(1))
      ypt = windhgt-Nint(rbuf(2))
      ndum = Nint(float(LW)/2.)
      If (ndum .gt. 0) Then
         rectangle.left = int2(xpt-ndum)
         rectangle.right = int2(xpt + ndum)
         rectangle.top = int2(ypt-ndum)
         rectangle.bottom = int2(ypt+ndum)
         Call PaintOval(Rectangle)
      Else
         Call MoveTo(int2(xpt),int2(ypt))
         Call LineTo(int2(xpt),int2(ypt))
      End If
      Return
C
C--- OPCODE=14, End picture. --------------------------------------------
C
  140 CONTINUE
      If (Ignore) Return
	  If (Picture(1:2) .eq. 'ON') Then
         Call ClosePicture()
C	     Write(0,*)'Picture size = ',gethandlesize(windowpic)
	     Call HidePen()
	     Call Setport(mywindow.p)
	     Call SetWindowPic(myWindow.P,windowpic)
      End If
      call GetWTitle(myWindow.P,%ref(text))  ! save window title
      title = 'Type return to continue. Command . to quit program'
      Call SetWTitle(myWindow.p,title)       ! put up new instructions.
      EVENT_MASK = $FFFF      !ALL EVENTS
      DONE = .false.
      DO WHILE (DONE = .false.)
         AN_EVENT = GetNextEvent(EVENT_MASK,%REF(theEvent))
         IF (AN_EVENT) CALL EVENTHANDLER(theEvent,DONE,ch,MouseLoc,opcode)
      END DO
      Call SetWTitle(myWindow.p,text)        ! Restore original title
      If (Rbuf(1) .ne. 0.0)  Call EraseRect(myWindow.P^.portRect)
       Call KillPicture(Windowpic)
      RETURN
C
C--- OPCODE=15, Select color index. -------------------------------------
C
  150 CONTINUE
      Call ForeColor(ColArr(Nint(rbuf(1))))
      Return
C
C--- OPCODE=16, Flush Buffer. --------------------------------------------
C   Ignore
  160 Continue
      Return

C
C--- OPCODE=17, Read cursor. --------------------------------------------
C
  170 Continue
      If (Ignore) Return
      call GetWTitle(myWindow.P,%ref(text))  ! save window title
      title = 'Type any character or use mouse. Command . to quit program'
      Call SetWTitle(myWindow.p,title)       ! put up new instructions.
      EVENT_MASK = $FFFF      !ALL EVENTS
      DONE = .false.
      DO WHILE (DONE = .false.)
         AN_EVENT = GetNextEvent(EVENT_MASK,%REF(theEvent))
         IF (AN_EVENT) CALL EVENTHANDLER(theEvent,DONE,ch,MouseLoc,opcode)
      END DO
      chr(1:1) = ch
      Rbuf(1) = float(MouseLoc.h)
      Rbuf(2) = float(windhgt-MouseLoc.v)
      NBuf = 2
      Call SetWTitle(myWindow.p,text)        ! Restore original title
      Return
C
C--- OPCODE=18, Erase alpha screen. -------------------------------------
C    (Null operation: there is no alpha screen.)
C
  180 CONTINUE
      RETURN
C
C--- OPCODE=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      If (Ignore) Then
         Return
      else If (Npolypts .ne. 0) Then
         Countpoly = Countpoly + 1
         If (CountPoly .eq. 1) Then
            xpt = int2(Nint(Rbuf(1)))
            ypt = Int2(Nint(Windhgt-Rbuf(2)))
            Call MoveTo(xpt,ypt)
         Else If (CountPoly .lt. Npolypts) Then
            Call LineTo(int2(Nint(Rbuf(1))),Int2(Nint(Windhgt-Rbuf(2))))
         Else
            Call LineTo(int2(Nint(Rbuf(1))),Int2(Nint(Windhgt-Rbuf(2))))
            Call LineTo(xpt,ypt)
            Call ClosePoly()
            Call PaintPoly(Polyhnd)
            Call KillPoly(PolyHnd)
            Npolypts = 0
            CountPoly = 0
         End If
      Else
         Npolypts = Nint(Rbuf(1))
         Polyhnd = OpenPoly()
      End If
      Return
C
C--- OPCODE=21, Set color representation. -------------------------------
C
  210 CONTINUE
      RETURN
C
C--- OPCODE=22, Set line width. -----------------------------------------
C
  220 CONTINUE
       LW = NINT(max(RBUF(1)/2.,1.))
       Call PenSize(Int2(Lw),int2(Lw))
      Return
C
C--- OPCODE=23, Escape. -------------------------------------------------
C
C  The text in char is drawn directly on the screen at the current location
C  and font.
  230 CONTINUE
      If (ignore) Return
      text = chr(:LCHR)
      Call DrawString(text)
      RETURN
C
C--- OPCODE=24, Rectangle fill. -------------------------------------------
C
  240 CONTINUE
      If (ignore) Return
      rectangle.left = int2(nint(rbuf(1)))
      Rectangle.right = int2(nint(rbuf(3)))
      Rectangle.top = int2(Windhgt-nint(rbuf(4)))
      Rectangle.bottom = int2(Windhgt-nint(rbuf(2)))
      Call PaintRect(Rectangle)
      Return
C
C--- OPCODE=26, Image.---------------------------------------------------
C
  260 CONTINUE
      If (ignore) Return
      xpt = Nint(Rbuf(1))
      ypt = Windhgt - Nint(Rbuf(2))
      Call MoveTo(Int2(xpt),Int2(ypt))
      Call ForeColor(Colarr(Nint(Rbuf(3))))
      Do I = 4, Nbuf
         If (Rbuf(I) .ne. Rbuf(I-1)) Then
            Call LineTo(int2(Nint(Rbuf(I-1))),int2(ypt))
            Call ForeColor(Colarr(Nint(Rbuf(I))))
            Call MoveTo(Int2(Nint(Rbuf(I))),int2(ypt))
         End If
      End Do
      Call LineTo(Int2(Nint(Rbuf(I))),int2(ypt))
      Return
C-----------------------------------------------------------------------
C Error: unimplemented function.
C
  900 WRITE (MSG,
     1  '(''Unimplemented function in MC device driver: '',I10)') OPCODE
      CALL GRWARN(MSG)
      NBUF = -1
      RETURN
      End

      SUBROUTINE EVENTHANDLER(theEvent,DONE,ch,MouseLoc,opcode)
c      This routines figures out what kind of event has occurred and 
c      calls the appropriate routine to take action in response to the event.
c      It returns DONE as true when it is finished.
      implicit none

!!SETC USINGINCLUDES = .FALSE.
      include    'globals.f'

      RECORD /EventRecord/ theEvent
      RECORD /WindowPtr/ P, OLDPORT, CLWIN
      RECORD /Rect/ LIMITRECT
      RECORD /Point/ MouseLoc            !Where it was clicked
      LOGICAL*2 DONE
      LOGICAL*1 CLOSEIT
      INTEGER*2 WindowPart
      CHARACTER*1 CH
      INTEGER*4 OUTPUTWINDOW,opcode
      EXTERNAL OUTPUTWINDOW      !Routine to identify the default window
      
      QDG = JQDGLOBALS()
      DONE = .false.
      Select Case (theEvent.what)
         Case (mouseDown)      
            WindowPart = FindWindow(theEvent.where,%REF(P))
            Select Case (WindowPart)
               Case (inMenuBar)     !MENUBAR
C                  CALL DO_MENU(MenuSelect(theEvent.where),DONE)
               Case (inSysWindow)   !in Sys window
                  Call SystemClick(theEvent,P)
                              
               Case (inContent)   !CONTENT Region
                  IF (P.P .NE. FrontWindow) Then
                     CALL SelectWindow(P.P)
                  Else 
                     If (Opcode .eq. 17) Then
                        Call GetMouse(%ref(MouseLoc))
                        If (JIAND(theEvent. modifiers,OptionKey) .eq. 2048) Then
                           If (JIAND(theEvent. modifiers,ShiftKey) .eq. 512) Then
                              ch = 'X'  ! option-shift click means send X
                           Else 
                              ch = 'D'  ! option click means send D
                           End If
                        Else 
                           ch = 'A'  ! click means send A
                        End If
                        Done = .True.
                     End If
                  End If
                        
               Case (inDrag)   !DRAG Region
                  IF (P.P .NE. FrontWindow) Then
                     CALL SelectWindow(P.P)
                  else
                     LIMITRECT = QDG^.screenBits.bounds
                     Call InsetRect(LimitRect,int2(4),int2(4))
                     CALL DragWindow(P,theEvent.where,LIMITRECT)
                  End if
                              
               Case (inGrow)   !SIZE Region
                        
               Case (inGoAway)  !close box
C                 IF (P.P .NE. OUTPUTWINDOW()) THEN
C                    CLOSEIT = TrackGoAway(P,theEvent.where)
C                    IF (CLOSEIT) CALL CLOSE_A_WINDOW(P)
C                 End if
                              
               Case Default ! No other window parts to deal with.
                              
            End Select      ! End of mouseDown Event.
                  
         Case (mouseUp)      !MOUSE UP This program does nothing in response to this event.
            
         Case ( keyDown)    !key PRESS
            CH = char(JIAND(theEvent.message,charCodeMask))
            If ((JIAND(theEvent. modifiers,cmdKey) .eq. 256) .and. (ch .eq. '.')) then
               Stop 'Program stopped by command-.'
            End If 
            if (Opcode .eq. 17) Then
               Call GetMouse(%ref(MouseLoc))
               Done = .True.
            Else If (ch .eq. char(13))  Then
               Done = .True.
            End If 
            
         Case (keyUp)    !This program does nothing in response to this event.
            
         Case (autoKey)   !This program does nothing in response to this event.
            
         Case (updateEvt)             
			CALL REDRAW_WIN(theEvent.message)	! Redraw window connect to start 5 and 6	

         Case (diskEvt)   !This program does nothing in response to this event.
            
         Case (activateEvt) 
C           CALL SetPort(theEvent.message)
C           CALL DrawGrowIcon(theEvent.message)
            
         Case Default
      End Select
      
      RETURN

      ENTRY REDRAW_WIN(CLWIN)
      CALL GetPort(%REF(OLDPORT))	!Remember current port
      CALL SetPort(CLWIN)
      CALL BeginUpdate(CLWIN)
      IF (CLWIN.P .EQ. OUTPUTWINDOW()) THEN
         CALL F_DRAWOUTPWINDOW
         CALL DrawControls(CLWIN)
      END IF
      CALL DrawGrowIcon(CLWIN)
      CALL EndUpdate(CLWIN)
      CALL SetPort(OLDPORT)
10    RETURN
      END
 

      PROGRAM PGDE16
C
C Demonstration program for bar charts (subroutine PGBCHT).
C This subroutine may be included in the PGPLOT library in a future
C release of PGPLOT
C
      INTEGER PGOPEN
      INTEGER NCAT, NSET
      PARAMETER (NCAT=5, NSET=2)
      REAL VALS(NCAT, NSET)
      REAL VALS2(NCAT, 3)
      REAL VALS3(12)
      CHARACTER*12 LABS(NCAT), LABS3(12)
      REAL VMIN, VMAX
      DATA VALS /15, 2, 3, 45, 17,
     :           14, 1, 2, 44, 16/
      DATA VALS2/15, -20, -13, 45, 17,
     :           14, -11,  -8, 44, 16,
     :           12,   9, -10, 30, 12/
      DATA LABS /'Antelope', 'Bear', 'Cat', 'Dog', 'Elephant'/
      DATA VALS3/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
      DATA LABS3/'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
     :           'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'/
C
C Bar charts in PGPLOT
C
      IF (PGOPEN('?').LT.1) STOP
      CALL PGSUBP(2,2)

      VMIN = 0.0
      VMAX = 0.0
      CALL PGPAGE
      CALL PGVSTD
      CALL PGBCHT(NCAT, 1, VALS, LABS, VMIN, VMAX, ' ', 0.7, 2)
      CALL PGLAB(' ', ' ', 'Bar Chart')

      CALL PGPAGE
      CALL PGBCHT(NCAT, 2, VALS, LABS, VMIN, VMAX, 'GN', 0.7, 2)
      CALL PGLAB(' ', ' ', 'Grouped Bar Chart (no box)')

      CALL PGPAGE
      CALL PGBCHT(NCAT, 2, VALS, LABS, VMIN, VMAX, 'GS', 0.7, 11)
      CALL PGLAB(' ', ' ', 'Stacked Bar Chart')

      CALL PGPAGE
      CALL PGBCHT(NCAT, 3, VALS2, LABS, VMIN, VMAX, 'G', 0.8, 5)
      CALL PGLAB(' ', ' ', 'Grouped Bar Chart with Negative Values')
      
      CALL PGPAGE
      CALL PGBCHT(NCAT, 3, VALS2, LABS, VMIN, VMAX, 'GS', 0.7, 5)
      CALL PGLAB(' ', ' ', 'Stacked Bar Chart with Negative Values')
      
      CALL PGPAGE
      CALL PGVSTD
      CALL PGBCHT(NCAT, 1, VALS, LABS, VMIN, VMAX, 'H', 0.7, 2)
      CALL PGLAB(' ', ' ', 'Bar Chart')

      CALL PGPAGE
      CALL PGBCHT(NCAT, 2, VALS, LABS, VMIN, VMAX, 'HG', 0.7, 2)
      CALL PGLAB(' ', ' ', 'Grouped Bar Chart')

      CALL PGPAGE
      CALL PGBCHT(NCAT, 2, VALS, LABS, VMIN, VMAX, 'HGS', 0.7, 11)
      CALL PGLAB(' ', ' ', 'Stacked Bar Chart')

      CALL PGPAGE
      CALL PGBCHT(NCAT, 3, VALS2, LABS, VMIN, VMAX, 'HG', 0.8, 5)
      CALL PGLAB(' ', ' ', 'Grouped Bar Chart with Negative Values')
      
      CALL PGPAGE
      CALL PGBCHT(NCAT, 3, VALS2, LABS, VMIN, VMAX, 'HGS', 0.7, 5)
      CALL PGLAB(' ', ' ', 'Stacked Bar Chart with Negative Values')
      
      CALL PGPAGE
      CALL PGBCHT(NCAT, 3, VALS2, LABS, VMIN, VMAX, 'HGSF', 0.7, 7)
      CALL PGLAB(' ', ' ', 'Stacked Bar Chart (Hatched)')
      
      CALL PGPAGE
      CALL PGBCHT(NCAT, 3, VALS2, LABS, VMIN, VMAX, 'GF', 0.7, -1)
      CALL PGLAB(' ', ' ', 'Grouped Bar Chart (Hatched)')

      CALL PGPAGE
      CALL PGBCHT(12, 1, VALS3, LABS3, VMIN, VMAX, 'GF', 0.9, -1)
      CALL PGLAB(' ', ' ', 'Bar Chart (Hatched)')
      
      CALL PGPAGE
      CALL PGBCHT(12, 1, VALS3, LABS3, VMIN, VMAX, 'G', 0.5, 12)
      CALL PGLAB(' ', ' ', 'Bar Chart')
      
      CALL PGCLOS
      END

C*PGBCHT -- draw a bar or column chart
C+
      SUBROUTINE PGBCHT(NCAT, NSET, VALS, LABS, VMIN, VMAX, OPT,
     :                  WIDTH, CI)
      INTEGER NCAT, NSET
      REAL VALS(NCAT,NSET)
      CHARACTER*(*) LABS(NCAT)
      REAL VMIN, VMAX
      CHARACTER*(*) OPT
      REAL WIDTH
      INTEGER CI
C
C Description to be written.
C
C Arguments:
C  NCAT   (input)  : number of categories, and first dimension of VALS.
C  NSET   (input)  : number of data sets (i.e., number of values to be
C                    plotted for each category).
C  VALS   (input)  : data values: a 2-D array (a 1-D array may be used
C                    if NSET=1). Element VALS(I,J) gives the value in
C                    the Jth data set for category I. The first
C                    dimension of VALS must be equal to NCAT, and the
C                    second should equal or exceed NSET (only the first
C                    NSET elements are used).
C  LABS   (input)  : character array, dimension at least NCAT, giving
C                    names for the NCAT categories.
C  VMIN   (input)  : lower limit for the value axis (i.e., the vertical
C                    axis for a vertical column chart, or the
C                    horizontal axis for a horizontal bar chart).
C  VMAX   (input)  : upper limit for the value axis. If VMIN=VMAX=0.0,
C                    the subroutine chooses limits automatically.
C  OPT    (input)  : a character string containing a list of one-letter
C                    options (in any order, and case-insensitive):
C                     F : if present, the data sets are distinguished
C                         using different hatching styles; colors
C                         are also used unless CI=-1 (see below).
C                     G : if present, grid lines are drawn at major
C                         intervals of the value axis.
C                     H : if present, the subroutine draws a horizontal
C                         bar chart, with categories arranged from 
C                         top to bottom; otherwise it draws a vertical
C                         column chart, with categories arranged from
C                         left to right.
C                     L : if present, the value axis is labelled
C                         logarithmically. The end point of the
C                         bars is at value 1 (10**0) rather than zero.
C                         This is unsatisfactory if negative values
C                         are used.
C                     N : if present, the box around the viewport
C                         is omitted (but not the baseline).
C                     S : if present, the subroutine draws a stacked
C                         bar chart; otherwise it draws a grouped
C                         bar chart (there is no difference between
C                         these for a single data set, NSET=1).
C  WIDTH  (input)  : the fraction of the maximum width available for
C                    each category that is occupied by bars. If
C                    WIDTH=1.0, bars from adjacent categories abut.
C                    Recommended value: 0.7 to 0.8.
C  CI     (input)  : a color index. If CI=-1, all bars are colored
C                    using the current color index (i.e., color index
C                    1 unless PGSCI has been called). If CI is 0 or
C                    positive, bars for the first data set are colored
C                    using this color index, and bars for subsequent
C                    data sets are colored using CI+1, CI+2, etc.
C                    (Axes and labels always use the current color
C                    index.)
C--
C 27-Jan-97 [TJP]
C-----------------------------------------------------------------------
      INTEGER I, J, CCI
      LOGICAL GRID, STACK, HORIZ, LOGAX, HATCH, NOBOX
C      LOGICAL PGNOTO
      REAL DMIN, DMAX, CMIN, CMAX, XMIN, XMAX, YMIN, YMAX
      REAL W, MARG, BWID, V, V1, V2, YMINN, YMINP
      CHARACTER L*1, NB*2
      INTEGER FS(3)
      DATA FS/1, 3, 4/
C
C Check and decode arguments.
C
      IF (NCAT.LT.1 .OR. NSET.LT.1) RETURN
      W = WIDTH
      IF (WIDTH.GT.1.0 .OR. WIDTH.LE.0.0) THEN
C          CALL GRWARN('PGBCHT: WIDTH argument should be <= 1.0, > 0.0')
          W = 1.0
      END IF
C      IF (PGNOTO('PGBCHT')) RETURN
      GRID  = INDEX(OPT,'G').NE.0 .OR. INDEX(OPT,'g').NE.0
      STACK = INDEX(OPT,'S').NE.0 .OR. INDEX(OPT,'s').NE.0
      HORIZ = INDEX(OPT,'H').NE.0 .OR. INDEX(OPT,'h').NE.0
      LOGAX = INDEX(OPT,'L').NE.0 .OR. INDEX(OPT,'l').NE.0
      HATCH = INDEX(OPT,'F').NE.0 .OR. INDEX(OPT,'f').NE.0
      NOBOX = INDEX(OPT,'N').NE.0 .OR. INDEX(OPT,'n').NE.0
C
C Determine the data range if necessary.
C
      DMIN = VMIN
      DMAX = VMAX
      IF (DMIN.EQ.0.0 .AND. DMAX.EQ.0.0) THEN
         IF (.NOT.STACK) THEN
C        -- Grouped bar chart
            DO J=1,NSET
               DO I=1,NCAT
                  IF (VALS(I,J).GT.DMAX) DMAX = VALS(I,J)
                  IF (VALS(I,J).LT.DMIN) DMIN = VALS(I,J)
               END DO
            END DO
         ELSE
C        -- Stacked bar chart
C           (accumulate pos and neg separately)
            DO I=1,NCAT
               V1 = 0.0
               V2 = 0.0
               DO J=1,NSET
                  IF (VALS(I,J).GT.0.0) V1 = V1+VALS(I,J)
                  IF (VALS(I,J).LT.0.0) V2 = V2+VALS(I,J)
               END DO
               IF (V1.GT.DMAX) DMAX = V1
               IF (V2.LT.DMIN) DMIN = V2
            END DO
         END IF
         CALL PGRNGE(DMIN, DMAX, DMIN, DMAX)
      END IF
      CMIN = 0.0
      CMAX = NCAT
C
C Set the window.
C
      CALL PGBBUF
      IF (HORIZ) THEN
         CALL PGSWIN(DMIN, DMAX, CMAX, CMIN)
      ELSE
         CALL PGSWIN(CMIN, CMAX, DMIN, DMAX)
      END IF
C
C Draw a grid if requested.
C
      IF (GRID) THEN
         CALL PGSAVE
         CALL PGSCI(15)
         CALL PGSLW(1)
         CALL PGSLS(2)
         IF (HORIZ) THEN
            CALL PGBOX('G', 0.0, 0, ' ', 0.0, 0)
         ELSE
            CALL PGBOX(' ', 0.0, 0, 'G', 0.0, 0)
         END IF
         CALL PGUNSA
      END IF
      CALL PGSAVE
      CALL PGQCI(CCI)
C
C Draw the bars.
C
      MARG = (1.0-W)*0.5
      IF (.NOT.STACK) THEN
C        -- Grouped bar chart
         BWID = W/REAL(NSET)
         DO I=1,NCAT
            DO J=1,NSET
               V = VALS(I,J)
               IF (V.NE.0.0) THEN
                  IF (CI.GE.0) CALL PGSCI(CI+J-1)
                  CALL PGSFS(1)
                  IF (HATCH) CALL PGSFS(FS(1+MOD(J,3)))
                  XMIN = (I-1)+MARG+(J-1)*BWID
                  XMAX = XMIN+BWID
                  YMIN = 0.0
                  YMAX = V
                  IF (HORIZ) THEN
                     CALL PGRECT(YMIN, YMAX, XMIN, XMAX)
                  ELSE
                     CALL PGRECT(XMIN, XMAX, YMIN, YMAX)
                  END IF
                  CALL PGSCI(CCI)
                  CALL PGSFS(2)
                  IF (HORIZ) THEN
                     CALL PGRECT(YMIN, YMAX, XMIN, XMAX)
                  ELSE
                     CALL PGRECT(XMIN, XMAX, YMIN, YMAX)
                  END IF
               END IF
            END DO
         END DO
      ELSE
C        -- Stacked bar chart
         DO I=1,NCAT
            YMINP = 0.0
            YMINN = 0.0
            DO J=1,NSET
               V = VALS(I,J)
               IF (V.NE.0.0) THEN
                  IF (CI.GE.0) CALL PGSCI(CI+J-1)
                  CALL PGSFS(1)
                  IF (HATCH) CALL PGSFS(FS(1+MOD(J,3)))
                  XMIN = (I-1)+MARG
                  XMAX = XMIN+W
                  IF (V.LT.0.0) THEN
                     YMIN = YMINN
                     YMINN = YMINN+V
                  ELSE
                     YMIN = YMINP
                     YMINP = YMINP+V
                  END IF
                  YMAX = YMIN+V
                  IF (HORIZ) THEN
                     CALL PGRECT(YMIN, YMAX, XMIN, XMAX)
                  ELSE
                     CALL PGRECT(XMIN, XMAX, YMIN, YMAX)
                  END IF
                  CALL PGSCI(CCI)
                  CALL PGSFS(2)
                  IF (HORIZ) THEN
                     CALL PGRECT(YMIN, YMAX, XMIN, XMAX)
                  ELSE
                     CALL PGRECT(XMIN, XMAX, YMIN, YMAX)
                  END IF
               END IF
            END DO
         END DO
      END IF
C
C Draw the axes, and a baseline if necessary.
C
      CALL PGSCI(CCI)
      L = ' '
      IF (LOGAX) L= 'L'
      NB = 'BC'
      IF (NOBOX) NB = '  '
      IF (HORIZ) THEN
         CALL PGBOX('NST'//NB//L, 0.0, 0, 'ATP'//NB, 1.0, 1)
      ELSE
         CALL PGBOX('ATP'//NB, 1.0, 1, 'NSTV'//L//NB, 0.0, 0)
      END IF
C
C Label the categories.
C
      CALL PGUPDT
      DO I=1,NCAT
         IF (HORIZ) THEN
            CALL PGMTXT('LV', 0.5, 1.0-(I-0.5)/REAL(NCAT), 1.0, LABS(I))
         ELSE
            CALL PGMTXT('B', 1.2, (I-0.5)/REAL(NCAT), 0.5, LABS(I))
         END IF
      END DO
C
C Done.
C
      CALL PGUNSA
      CALL PGEBUF
      RETURN
      END

C
      SUBROUTINE PGCL (K, X, Y, Z)
      INTEGER K
      REAL X, Y, Z
C
C PGPLOT (internal routine): Label one contour segment (for use by
C PGCONX).
C
C Arguments:
C
C K (input, integer): if K=0, move the pen to (X,Y); if K=1, draw
C       a line from the current position to (X,Y); otherwise
C       do nothing.
C X (input, real): X world-coordinate of end point.
C Y (input, real): Y world-coordinate of end point.
C Z (input, real): the value of the contour level, not used by PGCL.
C--
C  5-May-1994 - new routine [TJP]
C  7-Mar-1995 - correct error in angle; do not draw labels outside
C               window [TJP].
C 28-Aug-1995 - check arguments of atan2 [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      REAL     XX, YY, XC, YC, XV1, XV2, YV1, YV2, XL, XR, YB, YT
      REAL     XN, YN
      REAL     ANGLE, XO, YO, XP, YP, DINDX, DINDY, XBOX(4), YBOX(4)
      INTEGER  I, TB
      SAVE     I
      DATA     I /0/
C
C     -- transform to world coordinates
      XX = TRANS(1) + TRANS(2)*X + TRANS(3)*Y
      YY = TRANS(4) + TRANS(5)*X + TRANS(6)*Y
C
      IF (K.EQ.0) THEN
C        -- start of contour: reset segment counter
         I = 0
      ELSE
C        -- increment segment counter and check whether this
C           segment should be labelled
         I = MOD(I+1,PGCINT)
         IF (I.EQ.PGCMIN) THEN
C           -- find center of this segment (XC, YC)
            CALL PGQPOS(XP, YP)
            XC = (XX+XP)*0.5
            YC = (YY+YP)*0.5
C            -- find slope of this segment (ANGLE)
            CALL PGQVP(1, XV1, XV2, YV1, YV2)
            CALL PGQWIN(XL, XR, YB, YT)
            ANGLE = 0.0
            IF (XR.NE.XL .AND. YT.NE.YB) THEN
               DINDX = (XV2 - XV1) / (XR - XL)
               DINDY = (YV2 - YV1) / (YT - YB)
               IF (YY-YP.NE.0.0 .OR. XX-XP.NE.0.0)
     :           ANGLE = 57.3*ATAN2((YY-YP)*DINDY, (XX-XP)*DINDX)
            END IF
C           -- check whether point is in window
            XN = (XC-XL)/(XR-XL)
            YN = (YC-YB)/(YT-YB)
            IF (XN.GE.0.0 .AND. XN.LE.1.0 .AND.
     :          YN.GE.0.0 .AND. YN.LE.1.0) THEN
C              -- save current text background and set to erase
               CALL PGQTBG(TB)
               CALL PGSTBG(0)
C              -- find bounding box of label
               CALL PGQTXT(XC, YC, ANGLE, 0.5, PGCLAB, XBOX, YBOX)
               XO = 0.5*(XBOX(1)+XBOX(3))
               YO = 0.5*(YBOX(1)+YBOX(3))
C              -- plot label with bounding box centered at (XC, YC)
               CALL PGPTXT(2.0*XC-XO, 2.0*YC-YO, ANGLE, 0.5, PGCLAB)
C              -- restore text background
               CALL PGSTBG(TB)
            END IF
         END IF
      END IF
      CALL PGMOVE(XX,YY)
      END

C*PGLEN -- find length of a string in a variety of units
C%void cpglen(int units, const char *string, float *xl, float *yl);
C+
      SUBROUTINE PGLEN (UNITS, STRING, XL, YL)
      REAL XL, YL
      INTEGER UNITS
      CHARACTER*(*) STRING
C
C Work out length of a string in x and y directions 
C
C Input
C  UNITS    :  0 => answer in normalized device coordinates
C              1 => answer in inches
C              2 => answer in mm
C              3 => answer in absolute device coordinates (dots)
C              4 => answer in world coordinates
C              5 => answer as a fraction of the current viewport size
C
C  STRING   :  String of interest
C Output
C  XL       :  Length of string in x direction
C  YL       :  Length of string in y direction
C
C--
C 15-Sep-1989 - new routine (Neil Killeen)
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
      REAL    D
C
      IF (PGNOTO('PGLEN')) RETURN
C
C   Work out length of a string in absolute device coordinates (dots)
C   and then convert
C
      CALL GRLEN (STRING, D)
C
      IF (UNITS.EQ.0) THEN
        XL = D / PGXSZ(PGID)
        YL = D / PGYSZ(PGID)
      ELSE IF (UNITS.EQ.1) THEN
        XL = D / PGXPIN(PGID)
        YL = D / PGYPIN(PGID)
      ELSE IF (UNITS.EQ.2) THEN
        XL = 25.4 * D / PGXPIN(PGID)
        YL = 25.4 * D / PGYPIN(PGID)
      ELSE IF (UNITS.EQ.3) THEN
        XL = D
        YL = D
      ELSE IF (UNITS.EQ.4) THEN
        XL = D / ABS(PGXSCL(PGID))
        YL = D / ABS(PGYSCL(PGID))
      ELSE IF (UNITS.EQ.5) THEN
        XL = D / PGXLEN(PGID)
        YL = D / PGYLEN(PGID)
      ELSE
        CALL GRWARN('Illegal value for UNITS in routine PGLEN')
      END IF
C
      RETURN
      END

C*GRXHLS -- convert RGB color to HLS color
C+
      SUBROUTINE GRXHLS (R,G,B,H,L,S)
C
C GRPCKG: Convert a color specified in the RGB color model to one in
C the HLS model.  This is a support routine: no graphics I/O occurs.
C The inverse transformation is accomplished with routine GRXRGB.
C Reference: SIGGRAPH Status Report of the Graphic Standards Planning
C Committee, Computer Graphics, Vol.13, No.3, Association for
C Computing Machinery, New York, NY, 1979.
C
C Arguments:
C
C R,G,B (real, input): red, green, blue color coordinates, each in the
C       range 0.0 to 1.0. Input outside this range causes HLS = (0,1,0)
C       [white] to be returned.
C H,L,S (real, output): hue (0 to 360), lightness (0 to 1.0), and
C       saturation (0 to 1.0).
C--
C  2-Jul-1984 - new routine [TJP].
C 29-Sep-1994 - force H to be in rnage 0-360 [Remko Scharroo; TJP].
C-----------------------------------------------------------------------
      REAL     R,G,B, H,L,S, MA, MI, RR, GG, BB, D
C
      H = 0.0
      L = 1.0
      S = 0.0
      MA = MAX(R,G,B)
      MI = MIN(R,G,B)
      IF (MA.GT.1.0 .OR. MI.LT.0.0) RETURN
      RR = (MA-R)
      GG = (MA-G)
      BB = (MA-B)
C
C Lightness
C
      L = 0.5*(MA+MI)
C
C Achromatic case (R=G=B)
C
      IF (MA.EQ.MI) THEN
          S = 0.0
          H = 0.0
C
C Chromatic case
C
      ELSE
C         -- Saturation
          D = MA-MI
          IF (L.LE.0.5) THEN
              S = D/(MA+MI)
          ELSE
              S = D/(2.0-MA-MI)
          END IF
C         -- Hue
          IF (R.EQ.MA) THEN
C             -- yellow to magenta
              H = (2.0*D+BB-GG)
          ELSE IF (G.EQ.MA) THEN
              H = (4.0*D+RR-BB)
          ELSE
C             ! (B.EQ.MA)
              H = (6.0*D+GG-RR)
          END IF
          H = MOD(H*60.0/D,360.0)
          IF (H.LT.0.0) H = H+360.0
      END IF
C
      END

C*PGSWIN -- set window
C%void cpgswin(float x1, float x2, float y1, float y2);
C+
      SUBROUTINE PGSWIN (X1, X2, Y1, Y2)
      REAL X1, X2, Y1, Y2
C
C Change the window in world coordinate space that is to be mapped on
C to the viewport.  Usually PGSWIN is called automatically by PGENV,
C but it may be called directly by the user.
C
C Arguments:
C  X1     (input)  : the x-coordinate of the bottom left corner
C                    of the viewport.
C  X2     (input)  : the x-coordinate of the top right corner
C                    of the viewport (note X2 may be less than X1).
C  Y1     (input)  : the y-coordinate of the bottom left corner
C                    of the viewport.
C  Y2     (input)  : the y-coordinate of the top right corner
C                    of the viewport (note Y2 may be less than Y1).
C--
C 15-Nov-95: check arguments to prevent divide-by-zero [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSWIN')) RETURN
C
C If invalid arguments are specified, issue warning and leave window
C unchanged.
C
      IF (X1.EQ.X2) THEN
         CALL GRWARN('invalid x limits in PGSWIN: X1 = X2.')
      ELSE IF (Y1.EQ.Y2) THEN
         CALL GRWARN('invalid y limits in PGSWIN: Y1 = Y2.')
      ELSE
         PGXBLC(PGID) = X1
         PGXTRC(PGID) = X2
         PGYBLC(PGID) = Y1
         PGYTRC(PGID) = Y2
         CALL PGVW
      END IF
      END

C*GRAREA -- define a clipping window
C+
      SUBROUTINE GRAREA (IDENT,X0,Y0,XSIZE,YSIZE)
C
C GRPCKG: Define a rectangular window in the current plotting area. All
C graphics (except characters written with GRCHAR) will be blanked
C outside this window.  The default window is the full plotting area
C defined by default or by GRSETS.
C
C Arguments:
C
C IDENT (input, integer): the plot identifier, returned by GROPEN.
C X0, Y0 (input, real): the lower left corner of the window, in absolute
C       device coordinates.
C XSIZE, YSIZE (input, real): width and height of the window in absolute
C       coordinates; if either is negative, the window will be reset to
C       the full plotting area.
C--
C  1-Feb-1983 - [TJP].
C 25-Nov-1994 - use floating-point [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER IDENT
      REAL X0, Y0, XSIZE, YSIZE
C
      CALL GRSLCT(IDENT)
C
      IF ((XSIZE.LE.0.0) .OR. (YSIZE.LE.0.0)) THEN
          GRXMIN(IDENT) = 0
          GRXMAX(IDENT) = GRXMXA(IDENT)
          GRYMIN(IDENT) = 0
          GRYMAX(IDENT) = GRYMXA(IDENT)
      ELSE
          GRXMIN(IDENT) = MAX(X0,0.0)
          GRYMIN(IDENT) = MAX(Y0,0.0)
          GRXMAX(IDENT) = MIN(XSIZE+X0,REAL(GRXMXA(IDENT)))
          GRYMAX(IDENT) = MIN(YSIZE+Y0,REAL(GRYMXA(IDENT)))
      END IF
C
      END

      PROGRAM PGDEM6
C-----------------------------------------------------------------------
C Test program for PGPLOT: test of Cursor
C-----------------------------------------------------------------------
      INTEGER PGBEG, PGBAND
      INTEGER JUNK, MODE
      CHARACTER*1 CH
      REAL X,Y
C
      WRITE(*,*) '   This program demonstrates the use of routine',
     :             ' PGBAND. It'
      WRITE(*,*) '   requires a graphics device with a cursor.',
     :             ' Position the cursor'
      WRITE(*,*) '   anywhere in the window. Press any key (or a mouse',
     :             ' button if'
      WRITE(*,*) '   the device has a mouse supported by PGPLOT); the',
     :             ' program'
      WRITE(*,*) '   draws a marker at the current cursor position and',
     :             ' reports the'
      WRITE(*,*) '   current cursor position [bottom left corner is',
     :             ' (0,0); top'
      WRITE(*,*) '   right is (1,1)] and the ASCII code of the key',
     :             ' that you'
      WRITE(*,*) '   pressed. To exit from the program, type a slash',
     :             ' (/), ctrl-D,'
      WRITE(*,*) '   or ctrl-Z. The + key toggles between normal',
     :             ' cursor, cross-hair,'
      WRITE(*,*) '   and other cursor modes (on supporting devices).'
C
C Open device for graphics.
C
      IF (PGBEG(0,'?',1,1) .NE. 1) STOP
C
C Clear the screen. Draw a frame at the physical extremities of the
C plot, using full-screen viewport and standard window.
C
      CALL PGPAGE
      CALL PGSVP(0.0,1.0,0.0,1.0)
      CALL PGSWIN(0.0,1.0,0.0,1.0)
      CALL PGBOX('bcts',0.1,5,'bcts',0.1,5)
C
C Loop to read and display cursor position. Initial position for cursor
C is center of viewport. 
C
      X = 0.5
      Y = 0.5
      MODE = 0
 10   CONTINUE
          JUNK = PGBAND(MODE, 1, X, Y, X,Y,CH)
          WRITE (*, '(2F8.3,I4)') X,Y,ICHAR(CH)
C         Check for exit
          IF (CH.EQ.'/' .OR. CH.EQ.CHAR(0) .OR. CH.EQ.CHAR(4) .OR.
     :        CH.EQ.CHAR(26)) GOTO 20
C         Check for switch of cursor type.
          IF (CH.EQ.'+') THEN
             MODE = MOD(MODE+1,8)
             WRITE (*,*) 'Cursor mode:', MODE
             GOTO 10
          END IF
          CALL PGPT1(X, Y, ICHAR(CH))
      GOTO 10
C
C Close the device and exit.
C
 20   CALL PGEND
      END

C*PGQLW -- inquire line width
C%void cpgqlw(int *lw);
C+
      SUBROUTINE PGQLW (LW)
      INTEGER  LW
C
C Query the current Line-Width attribute (set by routine PGSLW).
C
C Argument:
C  LW     (output)  : the line-width (in range 1-201).
C--
C  5-Nov-1985 - new routine [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C     
      IF (PGNOTO('PGQLW')) THEN
         LW = 1
      ELSE
         CALL GRQLW(LW)
      END IF
      END

* Date: Tue, 24 Nov 92 10:20:47 -0700
* From: seeger@gem.LANL.GOV

      SUBROUTINE PGPLOT10
C
C     Subroutines to implement high-level functions from the author's 
C       PLOT-10 library, and to interpret calls to PLOT-10 primatives 
C       as corresponding entries in the PGPLOT library.  When logarithmic
C       axes have been defined by calling GRAPH, the PLOT-10 move and draw
C       calls will automatically take logarithms before plotting.  Additional
C       high-level calls (CONTOUR, CURVE, ERRBAR) which duplicate existing 
C       PGPLOT functions (but which support logarithmic scaling) are included 
C       at the end of this file.
C
C     P. A. Seeger, Los Alamos National Laboratory, Oct. 6, 1992
C
C     Entries:
C     ANCHO     DASHA     DASHR     DRAWA     DRAWR     DRWABS    DRWREL    
C     DSHABS    DSHREL    DWINDO    ERASE     FINITT    GRAPH     HDCOPY    
C     HLABEL    INITT     MOVABS    MOVEA     MOVER     MOVREL    OSTRING   
C     PNTABS    PNTREL    POINTA    POINTR    RESET     SCURSR    SEEDW     
C     SEELOC    SEETW     SETCOLOR  SWINDO    SYMBOL    TERM      TWINDO    
C     VCURSR    VLABEL    VWINDO    
C
C     Auxiliary Externals:
C     CHECK_TEXT   LINAXIS   LOGAXIS   
C
C     PGPLOT Externals:
C     PGBEGIN   PGBOX     PGCURSE   PGDRAW    PGEND     PGETXT    PGMOVE    
C     PGMTEXT   PGNUMB    PGPOINT   PGQINF    PGQPOS    PGQVP     PGSCH     
C     PGSCI     PGSLS     PGSLW     PGVPORT   PGWINDOW  
C
      IMPLICIT NONE
C
C     Variables which may occur in calling sequences of entry points
      CHARACTER TITLE*(*),SUBTITLE*(*),XLABEL*(*),YLABEL*(*),CH*1
      REAL XMN,XMX,X,YMN,YMX,Y
      INTEGER LOGX,LOGY,L,IX,IY,LX,LY
C
C     Local temporary variables:
      CHARACTER XOPTION*7,YOPTION*8,XFORMAT*6,YFORMAT*6,STRING*12,
     1 NEWSTRING*255
      REAL XX,XMAJOR,XMINOR,YY,YMAJOR,YMINOR
      INTEGER I,J,IXMAJOR,IXTICK,IYMAJOR,IYTICK,NC,LL,IX2,IY2
      LOGICAL LPOINT
C
C     Local variables to be saved between entries:
      CHARACTER TERMTYPE*40,HDCPYTYPE*40
      REAL ASPECT,X1,X2,XMIN,XMAX,XPERPIX,X0,Y1,Y2,YMIN,YMAX,YPERPIX,Y0
      INTEGER LINE,ISYMB,ITERM,IHDCPY
      LOGICAL XLOG,YLOG,PLOT10
      SAVE PLOT10,TERMTYPE,HDCPYTYPE,ITERM,IHDCPY,ASPECT,LINE,ISYMB,
     1     X1,X2,XMIN,XMAX,XLOG,XPERPIX,X0,
     2     Y1,Y2,YMIN,YMAX,YLOG,YPERPIX,Y0
      DATA PLOT10, TERMTYPE,HDCPYTYPE,ITERM,IHDCPY,ASPECT,LINE,ISYMB
     1    /.FALSE.,'?',     '?',      1,    1,     0.75,  -1,  -1/
      DATA X1,X2,   XPERPIX,X0,Y1,Y2,  YPERPIX,Y0
     1    /0.,1023.,1.,     0.,0.,767.,1.,     0./
C
      ENTRY INITT(X)
C     Initialize graphics terminal device
      plot10 = .true.
      call pgbegin(0, termtype(1:iterm), 1, 1)
      if (termtype.eq.'?') then
         call pgqinf('dev/type',termtype,iterm)
         iterm = min0(iterm,index(termtype,'/')+3)
      end if
      return
C
      ENTRY HDCOPY
C     Initialize hardcopy output device
      call pgbegin(0, hdcpytype(1:ihdcpy), 1, 1)
      if (termtype.eq.'?') then
         call pgqinf('dev/type',hdcpytype,ihdcpy)
         ihdcpy = min0(ihdcpy,index(hdcpytype,'/')+3)
      end if
      return
C
      ENTRY ERASE
      ENTRY RESET
C     Erase the screen
      call pgpage
      ENTRY TERM(IX,IY)
      return
C
      ENTRY FINITT(X,Y)
C     Exit graphics
      call pgend
      return
C
C     Define graph area in world co-ordinates, to fill the available
C       viewport area.  Place two lines of titles at top, and axis labels
C       on bottom and left.  Draw box with tick marks and labels; logarithmic
C       if the corresponding LOGX or LOGY value is non-zero.  XMN, XMX, YMN,
C       and YMX will be changed to rounded values.
C
      ENTRY GRAPH(TITLE, SUBTITLE, XLABEL, YLABEL,
     1            XMN, XMX, LOGX,   YMN, YMX, LOGY)
      call pgetxt
      call pgqvp(3,x1,x2,y1,y2)
      aspect = (y2-y1+1.)/(x2-x1+1.)
      call pgvport(0.20*aspect, 1.0-0.05*aspect, 0.10, 0.85 )
C
      call pgsch(2.0)
      call pgslw(3)
      call check_text(title,newstring,j,plot10)
      call pgmtext('T', 2.0, 0.5, 0.5, newstring(1:j))
C
      call pgsch(1.5)
      call pgslw(2)
      call check_text(subtitle,newstring,j,plot10)
      call pgmtext('T', 1.2, 0.5, 0.5, newstring(1:j))
C
      call check_text(xlabel,newstring,j,plot10)
      call pgmtext('B', 2.16, 0.5, 0.5, newstring(1:j))
C
      call check_text(ylabel,newstring,j,plot10)
      call pgmtext('L', 4.0, 0.5, 0.5, newstring(1:j))
      call pgsch(1.0)
      call pgslw(1)
C
      xlog = logx.gt.0
      ylog = logy.gt.0
      if (xlog) then
         call logaxis(xmn, xmx, ixmajor, ixtick, xminor, xformat)
         xmin = alog10(xmn)
         xmax = alog10(xmx)
         xmajor = 1.
         ixtick = 9
         xoption = 'BCLNTS'
         if (.not.ylog) xoption = 'ABCLNTS'
      else
         call linaxis(xmn, xmx, ixmajor, ixtick, xformat)
         xmin = xmn
         xmax = xmx
         xmajor = (xmax-xmin)/float(ixmajor)
         xoption = 'BCNTS'
         if (.not.ylog) xoption = 'ABCNTS'
      end if
C
      if (ylog) then
         call logaxis(ymn, ymx, iymajor, iytick, yminor, yformat)
         ymin = alog10(ymn)
         ymax = alog10(ymx)
         ymajor = 1.
         iytick = 9
         yoption = 'BCLNTSV'
         if (.not.xlog) yoption = 'ABCLNTSV'
      else
         call linaxis(ymn, ymx, iymajor, iytick, yformat)
         ymin = ymn
         ymax = ymx
         ymajor = (ymax-ymin)/float(iymajor)
         yoption = 'BCNTSV'
         if (.not.xlog) yoption = 'ABCNTSV'
      end if
C
      call pgwindow(xmin, xmax, ymin, ymax)
      call pgbox(xoption, xmajor, ixtick, yoption, ymajor, iytick)
      xperpix = (xmax-xmin)/(x2-x1)/(1.-0.25*aspect)
      x0 = x1 + 0.20*aspect*(x2-x1)
      yperpix = (ymax-ymin)/(y2-y1)/0.75
      y0 = y1 + 0.10*(y2-y1)
C
      if (xlog) then
C        Make sure ends of X-axis are labeled
         if (amod(abs(xmin)+0.01,1.) .gt. 0.02) then
            i = nint(xmin-0.5)
            j = nint(xmn/10.**i)
            call pgnumb(j, i, 0, string, nc)
            call pgmtext('B', 1.25, 0., 0.5, string(1:nc))
         end if
         if (amod(abs(xmax)+0.01,1.) .gt. 0.02) then
            i = nint(xmax-0.5)
            j = nint(xmx/10.**i)
            call pgnumb(j, i, 0, string, nc)
            call pgmtext('B', 1.25, 1., 0.5, string(1:nc))
         end if
      end if
C
      if (ylog) then
C        Make sure ends of Y-axis are labeled
         if (amod(abs(ymin)+0.01,1.) .gt. 0.02) then
            i = nint(ymin-0.5)
            j = nint(ymn/10.**i)
            call pgnumb(j, i, 0, string, nc)
            call pgmtext('LV', aspect, 0., 1., string(1:nc))
         end if
         if (amod(abs(ymax)+0.01,1.) .gt. 0.02) then
            i = nint(ymax-0.5)
            j = nint(ymx/10.**i)
            call pgnumb(j, i, 0, string, nc)
            call pgmtext('LV', aspect, 1., 1., string(1:nc))
         end if
      end if
      return
C
C     Following entries either move to a new point without drawing, or
C       move to a new point and draw a single dot or a symbol, accounting 
C       for possibility of log scales.
C
      ENTRY MOVEA(X,Y)
      lpoint = .false.
      xx = x
      yy = y
      go to 100
C
      ENTRY MOVABS(IX,IY)
      lpoint = .false.
      xx = xmin + xperpix*(float(ix)-x0)
      yy = ymin + yperpix*(float(iy)-y0)
      go to 110
C
      ENTRY POINTA(X,Y)
      lpoint = .true.
      ll = -1
      xx = x
      yy = y
      go to 100
C
      ENTRY SYMBOL(X,Y,L)
      lpoint = .true.
      ll = l
      xx = x
      yy = y
      go to 100
C
      ENTRY ANCHO(L)
      lpoint = .true.
      ll = l
      call pgqpos(xx,yy)
      go to 110
C
      ENTRY PNTABS(IX,IY)
      lpoint = .true.
      ll = -1
      xx = xmin + xperpix*(float(ix)-x0)
      yy = ymin + yperpix*(float(iy)-y0)
      go to 110
C
      ENTRY MOVREL(IX,IY)
      lpoint = .false.
      go to 80
C
      ENTRY PNTREL(IX,IY)
      lpoint = .true.
      ll = -1
80    call pgqpos(xx,yy)
      xx = xx + xperpix*float(ix)
      yy = yy + yperpix*float(iy)
      go to 110
C
      ENTRY MOVER(X,Y)
      lpoint = .false.
      go to 90
C
      ENTRY POINTR(X,Y)
      lpoint = .true.
      ll = -1
90    continue
      call pgqpos(xx,yy)
      if (xlog) then
         xx = (10.**xx) + x
      else
         xx = xx + x
      end if
      if (ylog) then
         yy = (10.**yy) + y
      else
         yy = yy + y
      end if
100   continue
      if (xlog) then
         if (xx.le.0.) then
            xx = -38.
         else
            xx = alog10(xx)
         end if
      end if
      if (ylog) then
         if (yy.le.0.) then
            yy = -38.
         else
            yy = alog10(yy)
         end if
      end if
110   if (lpoint) then
         call pgpoint(1, xx, yy, ll)
      else
         call pgmove(xx,yy)
      end if
      return
C
C     Following entries draw a solid or dashed line from the current
C       location to a new point, accounting for possibility of log scales.
C
      ENTRY DRAWA(X,Y)
      ll = 0
      xx = x
      yy = y
      go to 200
C
      ENTRY DRWABS(IX,IY)
      ll = 0
      xx = xmin + xperpix*(float(ix)-x0)
      yy = ymin + yperpix*(float(iy)-y0)
      go to 210
C
      ENTRY DASHA(X,Y,L)
      ll = l
      xx = x
      yy = y
      go to 200
C
      ENTRY DSHABS(IX,IY,L)
      ll = l
      xx = xmin + xperpix*(float(ix)-x0)
      yy = ymin + yperpix*(float(iy)-y0)
      go to 210
C
      ENTRY DRWREL(IX,IY)
      ll = 0
      go to 180
C
      ENTRY DSHREL(IX,IY,L)
      ll = l
180   call pgqpos(xx,yy)
      xx = xx + xperpix*float(ix)
      yy = yy + yperpix*float(iy)
      go to 210
C
      ENTRY DRAWR(X,Y)
      ll = 0
      go to 190
C
      ENTRY DASHR(X,Y,L)
      ll = l
190   continue
      call pgqpos(xx,yy)
      if (xlog) then
         xx = (10.**xx) + x
      else
         xx = xx + x
      end if
      if (ylog) then
         yy = (10.**yy) + y
      else
         yy = yy + y
      end if
200   continue
      if (xlog) then
         if (xx.le.0.) then
            xx = -38.
         else
            xx = alog10(xx)
         end if
      end if
      if (ylog) then
         if (yy.le.0.) then
            yy = -38.
         else
            yy = alog10(yy)
         end if
      end if
210   if (ll.lt.0) then
         call pgmove(xx,yy)
      else
         if (ll.ne.line) then
            line = mod(ll,5)
            call pgsls(line+1)
         end if
         call pgdraw(xx,yy)
      end if
      return
C
C     Set boundaries of viewport or of world co-ordinate system
C
      ENTRY VWINDO(XMN, X, YMN, Y)
      xmax = xmn+x
      ymax = ymn+y
      go to 250
C
      ENTRY DWINDO(XMN, XMX, YMN, YMX)
      xmax = xmx
      ymax = ymx
250   xmin = xmn
      ymin = ymn
      call pgwindow(xmin, xmax, ymin, ymax)
      xperpix = (xmax-xmin)/(x2-x1+1.)
      x0 = x1
      yperpix = (ymax-ymin)/(y2-y1+1.)
      y0 = y1
      return
C
      ENTRY SWINDOW(IX, LX, IY, LY)
      ix2 = x+lx
      iy2 = y+ly
      go to 260
C
      ENTRY TWINDO(IX, LX, IY, LY)
      ix2 = lx
      iy2 = ly
260   call pgqvp(3, x1, x2, y1, y2)
      call pgvport(float(ix)/(x2-x1), float(ix2)/(x2-x1),
     1             float(iy)/(y2-y1), float(iy2)/(y2-y1))
      call pgqvp(3, x1, x2, y1, y2)
      xperpix = (xmax-xmin)/(x2-x1+1.)
      x0 = x1
      yperpix = (ymax-ymin)/(y2-y1+1.)
      y0 = y1
      return
C
C     Write horizontal or vertical text strings 
C
      ENTRY HLABEL(TITLE, IX, IY, LX, LY)
      string = 'B'
      xx = xperpix*(float(ix)-x0)/(xmax-xmin)
      ly = nint((y2-y1)/40.)
      lx = (3*ly)/4
      yy = -(float(iy)-y0)/((y2-y1)/40.)
      go to 300
C
      ENTRY OSTRING(TITLE,L)
      call pgqpos(xx,yy)
      if (l.eq.0) then
         string = 'B'
         xx = (xx-xmin)/(xmax-xmin)
         yy = (yy-ymin)/yperpix/(y2-y1)*40.
      else
         string = 'L'
         xx = (yy-ymin)/(ymax-ymin)
         yy = (xx-xmin)/yperpix/(y2-y1)*40.
      end if
      go to 300
C
      ENTRY VLABEL(TITLE, IX, IY, LX, LY)
      string = 'L'
      xx = yperpix*(float(iy)-y0)/(ymax-ymin)
      ly = nint((y2-y1)/40.)
      lx = (3*ly)/4
      yy = -(float(iy)-y0)/((y2-y1)/40.)
300   continue
      call check_text(title,newstring,j,plot10)
      call pgmtext(string, yy, xx, 0.5, newstring(1:j))
      return
C
C     Find ("see") various window parameters
C
      ENTRY SEETW(IX, LX, IY, LY)
      ix = x1
      lx = x2
      iy = y1
      ly = y2
      return
C
      ENTRY SEEDW(XMN,XMX,YMN,YMX)
      if (xlog) then
         xmn = 10.**xmin
         xmx = 10.**xmax
      else
         xmn = xmin
         xmx = xmax
      end if
      if (ylog) then
         ymn = 10.**ymin
         ymx = 10.**ymax
      else
         ymn = ymin
         ymx = ymax
      end if
      return
C
      ENTRY SEELOC(IX,IY)
      call pgqpos(xx,yy)
      ix = x0+(xx-xmin)/xperpix
      iy = y0+(yy-ymin)/yperpix
      return
C
      ENTRY SETCOLOR(L)
      call pgsci(l)
      return
C
      ENTRY SCURSR(L, IX, IY)
      xx = xmin+xperpix*(float(ix)-x0)
      yy = ymin+yperpix*(float(iy)-y0)
      call pgcurse(xx, yy, ch)
      l = ichar(ch)
      if (l.gt.0) then
         ix = x0+(xx-xmin)/xperpix
         iy = y0+(yy-ymin)/yperpix
      end if
      return
C
      ENTRY VCURSR(L, X, Y)
      if (xlog) then
         if (x.le.0.) then
            xx = xmin
         else
            xx = alog10(x)
         end if
      else
         xx = x
      end if
      if (ylog) then
         if (y.le.0.) then
            yy = ymin
         else
            yy = alog10(y)
         end if
      else
         yy = y
      end if
      call pgcurse(xx,yy,ch)
      l = ichar(ch)
      if (l.ne.0) then
         if (xlog) then
            x = 10.**xx
         else
            x = xx
         end if
         if (ylog) then
            y = 10.**yy
         else
            y = yy
         end if
      end if
      return
C
      END   
C
      SUBROUTINE CHECK_TEXT(IN,OUT,KOUT,PLOT10_FLAG)
C
C     Decode special characters in PLOT10 string to PGPLOT
C
      IMPLICIT NONE
      CHARACTER IN*(*),OUT*(*)
      INTEGER KOUT
      LOGICAL PLOT10_FLAG
C
      CHARACTER SPECIAL(5)*1,CH2*2,SYMBOL(8)*6
      INTEGER I,J,K,IIN,JIN,IOUT,MODE,KMAX
      DATA SPECIAL/'<', '>', '?', '#', '&'/
      DATA SYMBOL/'\(845)', '\(847)', '\(840)', '\(846)', '\(841)',
     1            '\(842)', '\(843)', '\(852)'/
C
C     Omit trailing blanks and nulls
      do 2 jin=len(in),3,-1
         if (in(jin:jin).ne.' ' .and. in(jin:jin).ne.char(0)) go to 3
2     continue
C     Omit terminal '$'
3     if (in(jin:jin).eq.'$') jin = jin-1
C
      kmax = len(out)
      j = 0
      k = 0
      mode = 2
10    continue
         j = j+1
         if (plot10_flag) then
C           Look for PLOT10 special characters
            do 80 i=1,5
               if (in(j:j).eq.special(i)) then
                  if ((i.eq.1.or.i.eq.2).and.(i.ne.mode)) then
                     k = k+3
                     out(k-2:k) = '\f1'
                  else if (i.eq.5) then
C                    Convert next 2 characters to lower case for testing
                     ch2(1:1) = char(ior(ichar(in(j+1:j+1)),32))
                     ch2(2:2) = char(ior(ichar(in(j+2:j+2)),32))
                     if (ch2.eq.'ex') then
C                       End of superscript
                        j = j+2
                        k = k+2
                        out(k-1:k) = '\d'
                     else if (ch2(1:1).eq.'e') then
C                       Beginning of superscript
                        j = j+1
                        k = k+2
                        out(k-1:k) = '\u'
                     else if (ch2.eq.'lx') then
C                       End of subscript
                        j = j+2
                        k = k+2
                        out(k-1:k) = '\u'
                     else if (ch2(1:1).eq.'l') then
C                       Beginning of subscript
                        j = j+1
                        k = k+2
                        out(k-1:k) = '\d'
                     end if
                  end if
                  mode = i
                  go to 100
               end if
80          continue
C           Not a special case, just keep the character
            if (mode.eq.3 .or. mode.eq.4) then
C              Character is Greek, must be preceded with flag
               k = k+2
               out(k-1:k) = '\g'
            end if
            k = k+1
            if (mode.eq.1 .or. mode.eq.4) then
C              Character must be lower case
               out(k:k) = char(ior(ichar(in(j:j)),32))
            else
C              No case modification
               out(k:k) = in(j:j)
            end if
         else
C
C           Look for PGPLOT symbol numbers
            if (in(j:j).eq.'\') then
               i = ichar(in(j+1:j+1)) - ichar('0')
               if (i.ge.1 .and. i.le.8) then
                  j = j+1
                  k = k+6
                  out(k-5:k) = symbol(i)
                  go to 100
               end if
            end if
C           Not symbol number, copy unmodified character to output
            k = k+1
            out(k:k) = in(j:j)
         end if
C
100   if (j.lt.jin .and. k.lt.kmax) go to 10
      kout = min0(k,kmax)
      return
      END
C
      SUBROUTINE LINAXIS(XONE,XTWO,MAJOR,MINOR,FORMAT)
C
C  SCALE ENDS OF LINEAR AXIS TO ROUNDED NUMBERS
C
C    An axis is defined to include XONE and XTWO, with each end rounded to   
C  be an integer number of units of the form (1, 2, or 5) x 10**n.  The
C  resulting number MAJOR of major divisions will be between 4 and 10, with
C  MINOR minor divisions in each step.  A character string (FORMAT = 'Fww.dd')
C  is generated to use as the format for labeling the axis.
C
C  P. A. Seeger, Los Alamos National Laboratory, May 24, 1986
C    Modified to prevent log of X=0., Aug. 31, 1986
C    Use E instead of F format if width > 10, Nov. 21, 1987
C    Guard against axis ends > 10**38, Feb. 5, 1990
C
C    No Externals
C
      IMPLICIT NONE
      REAL*4 XONE,XTWO,XMIN,XMAX,AXLEN,UNIT
      INTEGER MAJOR,MINOR,IPOWR,NN,IW,ID
      CHARACTER*6 FORMAT
C
      XMIN = AMAX1(-0.7E38,AMIN1(XONE,XTWO))
      XMAX = AMIN1( 0.7E38,AMAX1(XONE,XTWO))
      IF (XMAX.EQ.XMIN) THEN
         IF (XMAX.LT.0.) THEN
            XMAX = 0.
         ELSE IF (XMIN.GT.0.) THEN
            XMIN = 0.
         ELSE 
            XMAX = 0.001
         END IF
      END IF
      AXLEN = XMAX-XMIN
      IPOWR = NINT(ALOG10(AXLEN)-1.05)
      UNIT = 10.**IPOWR
      NN = AXLEN/UNIT
      IF (NN.GE.15) THEN
         UNIT=UNIT*5.
         MINOR=1
         IF (NN.LE.30) MINOR=5
      ELSE IF (NN.GE.7) THEN
         UNIT=UNIT*2.
         MINOR=2
         IF (NN.LE.10) MINOR=4
      ELSE
         MINOR=2
         IF (NN.LE.4) MINOR=5
      END IF
C
      IF (XMIN.GE.0.) THEN
         XMIN = UNIT*AINT((XMIN+0.01*AXLEN)/UNIT)
      ELSE
         XMIN = UNIT*AINT((XMIN+0.01*AXLEN)/UNIT-1.)
      END IF
      IF (XMAX.GE.0.) THEN
         XMAX = UNIT*AINT((XMAX-0.01*AXLEN)/UNIT+1.)
      ELSE
         XMAX = UNIT*AINT((XMAX-0.01*AXLEN)/UNIT)
      END IF
C
      MAJOR = NINT((XMAX-XMIN)/UNIT)
      IF (XTWO.GT.XONE) THEN
         XONE = XMIN
         XTWO = XMAX
      ELSE
         XONE = XMAX
         XTWO = XMIN
      END IF
C
      ID = MAX0(0,-IPOWR)
      IF (XMIN.LT.0.) XMIN=-10.*XMIN
      IF (XMAX.LT.0.) XMAX=-10.*XMAX
      IPOWR = ALOG10(AMAX1(XMIN,XMAX,1.))+0.001
      IW = IPOWR+ID+2
      IF (IW.LT.10) THEN
         WRITE (FORMAT,100) IW,ID
100      FORMAT ('F',I2,'.',I2)
      ELSE
         FORMAT = 'E 9. 2'
      END IF
C
      RETURN
      END
C
      SUBROUTINE LOGAXIS(XONE,XTWO,MAJOR,MINOR,UNIT,FORMAT)
C
C  SCALE ENDS OF LOGARITHMIC AXIS TO ROUNDED NUMBERS
C    
C    An axis is defined to include XONE and XTWO, with each end rounded to   
C  be (1, 2, 3, or 5) x some power of 10.  The resulting axis spans MAJOR
C  decades, including partial decades at one or both ends.  The lowest decade
C  on the axis has MINOR units of size UNIT; if it is a full decade, MINOR = 9
C  and UNIT = min(X).  A character string (FORMAT = 'Fww.dd') is generated to
C  use as the format for labeling the axis.
C
C  P. A. Seeger, Los Alamos National Laboratory, May 20, 1986
C      Modified to avoid log(X) when X.LE.0., June 17, 1986
C      Corrected FORMAT when XMAX<1., June 19, 1987
C      Use E instead of F format when width > 10, Nov. 21, 1987
C      Guard against axis ends > 10**38, Feb. 5, 1990
C
C    No Externals
C
      IMPLICIT NONE
      REAL*4 XONE,XTWO,UNIT,XMIN,XMAX,XLOG,LOG2,LOG3,LOG5,DELTA
      INTEGER MAJOR,MINOR,IMIN,IMAX,IW,ID
      CHARACTER*6 FORMAT
      PARAMETER (LOG2=0.3010300,LOG3=0.4771213,LOG5=0.6989700)
C
      XMIN = AMIN1(XONE,XTWO)
      XMAX = AMAX1(XONE,XTWO)
      IF (XMAX.LE.0.) XMAX = 1.
      IF (XMIN.LE.0.) THEN
         XMIN = XMAX/1000.
      ELSE IF (XMAX.GE.1.E38) THEN
         XMAX = XMIN*1.E6
      ELSE
         XMIN = AMAX1(XMIN,XMAX/1.E24)
      END IF
      IF (XMIN.EQ.XMAX) THEN
         XMAX = XMAX*2.
         XMIN = XMIN/2.
      END IF
      DELTA = 0.01*ALOG10(XMAX/XMIN)
C
C     Look at small end of axis first
      XLOG = ALOG10(XMIN)+DELTA
      IMIN = NINT(XLOG-0.5)
      XMIN = 10.**IMIN
      UNIT = XMIN
      XLOG = XLOG-FLOAT(IMIN)
      IF (XLOG.GT.LOG5) THEN
         XMIN = 5.*XMIN
         MINOR = 5
      ELSE IF (XLOG.GT.LOG3) THEN
         XMIN = 3.*XMIN
         MINOR = 7
      ELSE IF (XLOG.GT.LOG2) THEN
         XMIN = 2.*XMIN
         MINOR = 8
      ELSE
         MINOR = 9
      END IF
      ID = MAX0(0,-IMIN)
C
C     Now do "same" thing at larger end
      XLOG = ALOG10(XMAX)-DELTA
      IMAX = NINT(XLOG-0.5)
C     Compute total number of decades included
      MAJOR = IMAX-IMIN+1
      XMAX = 10.**IMAX
      XLOG = XLOG-FLOAT(IMAX)
      IF (XLOG.LT.LOG2) THEN
         XMAX = 2.*XMAX
      ELSE IF (XLOG.LT.LOG3) THEN
         XMAX = 3.*XMAX
      ELSE IF (XLOG.LT.LOG5) THEN
         XMAX = 5.*XMAX
      ELSE
         XMAX = 10.*XMAX
         IMAX = IMAX+1
      END IF
      IF (MAJOR.EQ.1) MINOR=NINT((XMAX-XMIN)/UNIT)
C
      IW = MAX0(0,IMAX)+ID+2
      IF (IW.LT.10) THEN
         WRITE (FORMAT,100) IW,ID
100      FORMAT ('F',I2,'.',I2)
      ELSE
         FORMAT = 'E 9. 2'
      END IF
      IF (XONE.LT.XTWO) THEN
         XONE = XMIN
         XTWO = XMAX
      ELSE
         XONE = XMAX
         XTWO = XMIN
      END IF
C
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE CONTOUR(Z,NRZ,X,NX,Y,NY,CV,NCV,LINE,ZMAX,BITMAP)
C
C  DRAW CONTOURS THROUGH EQUAL VALUES IN AN ARRAY
C
C  From Collected Algorithms from ACM #531 "Contour Plotting [J6]"
C   by: William V. Snyder, 1978
C  Copied from GSAS; transferred to IBM-PC, Dec. 8, 1987 (P.A.Seeger)
C  Added X, Y, and LINE to calling sequence, Dec. 9, 1987 (PAS) 
C  Restructured, closer to "standard", Dec. 11, 1987 (PAS)
C  Changed I and J to II and JJ in innermost loop, Dec. 13, 1987 (PAS)
C  Revised scan pattern from spiral to linear, Aug. 13, 1988 (PAS)
C
C  Externals
C    DASHA     FILL0     LGETMARK  MOVEA
C
C  Arguments in calling sequence:
C    Z         R(NRZ,*) Input    Array of values to be contoured; nodes must
C                                lie on a topologically rectangular grid.
C    NRZ       I        Input    Number of rows declared for array Z
C    X         R(*)     Input    Values of X at grid points of array Z
C    NX        I        Input    Limit for 1st subscript of Z and X
C    Y         R(*)     Input    Values of Y at grid points of array Z
C    NY        I        Input    Limit for 2nd subscript of Z and Y
C    CV        R(*)     Input    Values of contour levels
C    NCV       I        Input    No. of contour levels
C    LINE      I(*)     Input    Line style for each contour level
C    ZMAX      R        Input    Maximum Z to be considered; grid lines at
C                                a node with value above ZMAX are excluded
C    BITMAP    I(*)     Scratch  Work area of size (2*NX*NY*NCV+7)/8 bytes
C
      IMPLICIT NONE
      INTEGER NRZ,NX,NY,NCV,LINE(*)
      REAL*4 Z(NRZ,*),X(*),Y(*),CV(*),ZMAX
      INTEGER*4 BITMAP(*) 
C
      LOGICAL LGETMARK
C
C  Local variables in CONTOUR:
C    CVAL      R        Contour-line value being traced
C    DELZ      R        Change in Z when moving 1 cell right or up
C    IADD      I        Bit address in BITMAP, starting at zero
C    IBORDER   I        Edge of current cell which is on a border
C    ICV       I        Index of contour line being traced
C    IEDGE     I        Edge of new cell where contour line enters
C    IFLAG     I        1=continue, 2=start at boundary, 3=start in interior,
C                       4=end at boundary, 5=close contour, 6=none found yet
C    I,J       I        Subscripts for search
C    IJ        I(2)     Equivalent to I,J
C    IJMAX     I(2)     Local copies of NX and NY
C    I1(2),I2(2),I3(6)  Used for subscript computations
C    II,JJ     I        Cell with continuation of contour line being traced
C    INDEX     I        L-1 + 2*(I-1 + NX*(J-1))
C    K         I        Index of cell edges: 1=bottom, 2=left, 3=top, 4=right
C    KS        I        Next cell boundary to cross
C    L,LL      I        Orientation flags: 1 is horizontal line, 2 vertical
C    LBORDER   L        Flag to show that only border lines are to be done
C    NI        I        Number of edges of cell which contour crosses
C    XINT      R(4)     Intersections of contour with edges of cell,
C                          in order bottom, left, top, right
C    XX,YY     R        Plotting coordinates
C    Z1,Z2     R        Smaller and larger values at segment ends
C    Z3,Z4     R        Values at ends of segment for continuation of contour
C
      REAL*4 XINT(4),Z1,Z2,Z3,Z4,DELZ,CVAL,XX,YY
      INTEGER I1(2),I2(2),I3(6),I,J,IJ(2),IJMAX(2),K,L,LL,II,JJ,ICV,
     , IBORDER,IEDGE,IFLAG,NI,KS
      INTEGER*4 INDEX,MAXINDX,NBITS,IADD
      LOGICAL LBORDER
      EQUIVALENCE (IJ(1),I),(IJ(2),J)
      DATA I1/1,0/,  I2/1,-1/,  I3/1,0,0,1,1,0/
C
      IJMAX(1) = NX
      IJMAX(2) = NY
C  Clear bit map
      NBITS = 2*NX*NY*NCV
      CALL FILL0(BITMAP,NBITS)
      IFLAG = 6
C
C  Search every cell in rectangular array for a line segment such that:
C    1. the end points are not excluded because Z > ZMAX
C    2. current contour <= Z at one end and > Z at other end
C    3. no mark has been recorded for this contour on this segment
C
C  Set start at lower left corner of array; do borders first, then interior
C
      LBORDER = .TRUE.
      MAXINDX = 2*NX*NY-2
100   CONTINUE
      DO 500 INDEX=0,MAXINDX
         L = MOD(INDEX,2)+1
         I = MOD(INDEX/2,NX)+1
         J = (INDEX/2)/NX+1
         IF (Z(I,J).LE.ZMAX) THEN
C           Node itself is within non-excluded range
            II = I+I1(L)
            JJ = J+I1(3-L)
            IF (II.LE.NX .AND. JJ.LE.NY .AND. Z(II,JJ).LE.ZMAX) THEN
C              Both ends of grid line within range; test if "border" segment
               IBORDER = 0
               IF (IJ(3-L).EQ.1 .OR.
     1             Z(I-I1(3-L),J-I1(L)).GT.ZMAX .OR.
     2             Z(I+I2(L),J+I2(3-L)).GT.ZMAX)   IBORDER = 1
               IF (IJ(3-L).GE.IJMAX(3-L) .OR.
     1             Z(I+I1(3-L),J+I1(L)).GT.ZMAX .OR.
     2             Z(I+1,J+1).GT.ZMAX)     IBORDER = IBORDER+2 
C              1st time, do ONLY borders (including edges of exclusions)
               IF (IBORDER.NE.3 .AND. (LBORDER.EQV.(IBORDER.NE.0))) THEN
C                 Examine this line segment this pass
                  Z1 = AMIN1(Z(I,J),Z(II,JJ))
                  Z2 = AMAX1(Z(I,J),Z(II,JJ))
                  DELZ = Z(II,JJ)-Z(I,J)
                  DO 400 ICV=1,NCV
C                    Test for all possible contours crossing this grid line;
C                     first check if already done, and set bit to show done
                     IADD = ICV-1 + NCV*INDEX
                     IF (.NOT.LGETMARK(BITMAP,IADD) .AND. 
     1                   CV(ICV).GT.Z1 .AND. CV(ICV).LE.Z2) THEN
C                       Found one we haven't done yet!!!  Interpolate.
                        CVAL = CV(ICV)
C                       Decide which edge we are entering cell from
                        IEDGE = L
                        IF (IBORDER.EQ.2) IEDGE = IEDGE+2
                        XINT(IEDGE) = (CVAL-Z(I,J))/DELZ
C                       Move "pen" to starting point of contour
                        XX = X(I)+XINT(IEDGE)*(X(II)-X(I))
                        YY = Y(J)+XINT(IEDGE)*(Y(JJ)-Y(J))
                        IFLAG = 3
                        IF (LBORDER) IFLAG = 2
                        CALL MOVEA(XX,YY)
C
C  Follow this contour until it hits boundary or closes on itself
                        II = I
                        JJ = J
                        IFLAG = 1
C                       "DO WHILE (IFLAG.LT.4)"
200                     CONTINUE
C                          If haven't moved to next cell yet, do so
                           IF (IEDGE.EQ.3) JJ = JJ-1
                           IF (IEDGE.EQ.4) II = II-1
                           NI = 1
                           DO 300 K = 1,4
C                             Test interpolation on other 3 edges
                              IF (K.NE.IEDGE) THEN
                                 Z3 = Z(II+I3(K),JJ+I3(K+1))
                                 Z4 = Z(II+I3(K+1),JJ+I3(K+2))
                                 IF (CVAL.GT.AMIN1(Z3,Z4) .AND. 
     .                               CVAL.LE.AMAX1(Z3,Z4)) THEN
C                                   The contour also crosses this edge
                                    IF (K.EQ.1 .OR. K.EQ.4) THEN
                                       XINT(K) = (CVAL-Z4)/(Z3-Z4)
                                    ELSE
                                       XINT(K) = (CVAL-Z3)/(Z4-Z3)
                                    END IF
C                                   Count how many crossings
                                    NI = NI+1
                                    KS = K
                                 END IF
                              END IF
300                        CONTINUE
C
                           IF (NI.NE.2) THEN
C  The contour crosses all four edges of the cell being examined. Choose the 
C  lines top-to-left and bottom-to-right if the interpolation point on the top 
C  edge is less than the interpolation point on the bottom edge. Otherwise, 
C  choose the other pair. This method produces the same result if the axes are 
C  reversed. The contour may close at any edge, but must not cross itself 
C  inside any cell.
                              IF (XINT(3).GE.XINT(1)) THEN
                                 KS = 3-IEDGE
                                 IF (KS.LE.0) KS = KS+4
                              ELSE
                                 KS = 5-IEDGE
                              END IF
                           END IF
C
C  Determine if the contour will close or run into a boundary at edge KS of the 
C  current cell.
                           IF (KS.LE.2) THEN
                              LL = KS
                              IEDGE = KS+2
                           ELSE
C                             Must move to adjacent cell before test for closure
                              II = II+I3(KS)
                              JJ = JJ+I3(KS+2)
                              LL = KS-2
                              IEDGE = KS-2
                           END IF
                           IADD = ICV-1+NCV*(LL-1+2*(II-1+NX*(JJ-1)))
                           IF (LGETMARK(BITMAP,IADD)) THEN
C                             We've already been here; contour has closed 
                              IFLAG = 5
                           ELSE IF (LL.EQ.2.AND.(II.EQ.1.OR.II.GE.NX)
     1                     .OR. LL.EQ.1.AND.(JJ.EQ.1.OR.JJ.GE.NY)) THEN
C                             Segment is actual boundary of plot
                              IFLAG = 4
                           ELSE IF (Z(II-I1(3-LL),JJ-I1(LL)).GT.ZMAX 
     1                     .OR. Z(II+I2(LL),JJ+I2(3-LL)).GT.ZMAX
     2                     .OR. Z(II+I1(3-LL),JJ+I1(LL)).GT.ZMAX
     3                     .OR. Z(II+1,JJ+1).GT.ZMAX) THEN
C                             Segment is boundary of an excluded cell
                              IFLAG = 4
                           END IF
C
C                          Draw piece of contour
                           XINT(IEDGE) = XINT(KS)
                           IF (LL.EQ.1) THEN
                              XX = X(II)+XINT(IEDGE)*(X(II+1)-X(II))
                              YY = Y(JJ)
                           ELSE
                              XX = X(II)
                              YY = Y(JJ)+XINT(IEDGE)*(Y(JJ+1)-Y(JJ))
                           END IF
                           CALL DASHA(XX,YY,LINE(ICV))
C
                        IF (IFLAG.LT.4) GO TO 200
C                       Reset II and JJ before looking for next contour
                        II = I+I1(L)
                        JJ = J+I1(3-L)
                     END IF
400               CONTINUE
               END IF
            END IF
         END IF
500   CONTINUE
C
      IF (.NOT.LBORDER) RETURN
      LBORDER = .FALSE.
      GO TO 100
      END
C  
C  CONTOUR SUBROUTINES FOR BIT MANIPULATION
C
      SUBROUTINE FILL0(BITMAP,N)
C  Fills entire BITMAP with zeros
      IMPLICIT NONE
      INTEGER N,I,LOOP
      INTEGER*4 BITMAP(*)
C
      LOOP = (N-1)/32+1
      DO 10 I=1,LOOP
         BITMAP(I) = 0
10    CONTINUE
      RETURN
      END
C
      LOGICAL FUNCTION LGETMARK(BITMAP,N)
C  Tests bit in BITMAP, and then sets it to one
      IMPLICIT NONE
      INTEGER N,NWORD,NBIT
      INTEGER*4 BITMAP(*)
      LOGICAL BTEST
C                                        
      NWORD = N/32+1
      NBIT = MOD(N,32)
      LGETMARK = BTEST(BITMAP(NWORD),NBIT)
      IF (.NOT.LGETMARK) BITMAP(NWORD) = IBSET(BITMAP(NWORD),NBIT)
      RETURN
      END
C
C******************************************************************************
C
      SUBROUTINE CURVE(X,Y,N,LDASH,ISYM)
C
C  PLOT N POINTS AT (X(I),Y(I)), USING SYMBOL CORRESPONDING TO ISYM, AND
C    CONNECTING WITH LINE DESCRIBED BY LDASH.
C
C  P. A. Seeger, Los Alamos National Laboratory, May 24, 1986
C
      INTEGER N,LDASH,ISYM,I
      REAL*4 X(*),Y(*)
C
C  Externals
C     DASHA     MOVEA     SYMBOL
C
      CALL MOVEA(X(1),Y(1))
      DO 100 I=1,N
         CALL DASHA(X(I),Y(I),LDASH)
         CALL SYMBOL(X(I),Y(I),ISYM)
100   CONTINUE
C
      RETURN
      END
C
C******************************************************************************
C
      SUBROUTINE ERRBARS(X,Y,DY,N,INC,LOGY)
C
C  PLOT ERROR BARS ON EVERY INCth POINT OF AN ARRAY OF N POINTS 
C    (X(I),Y(I)+-DY(I)).  LOGY=1 IF ORDINATE IS LOGARITHMIC.
C
C  P. A. Seeger, Los Alamos National Laboratory, Nov. 24, 1987
C
      IMPLICIT NONE
      INTEGER N,INC,LOGY,I
      REAL*4 X(*),Y(*),DY(*),D,R,Y1,Y2
C
C  Externals
C     DRAWA     MOVEA     
C
      DO 100 I=1,N,INC
         D = ABS(DY(I))
         IF (LOGY.EQ.1) THEN
            IF (Y(I).LE.0.) THEN
               Y1 = 2.E-38
               Y2 = 2.E-38
            ELSE IF (D.LT.0.05*Y(I)) THEN
               Y1 = Y(I)-D
               Y2 = Y(I)+D
            ELSE IF (D.LT.88.*Y(I)) THEN
               R = EXP(D/Y(I))
               Y1 = Y(I)/R
               Y2 = Y(I)*R
            ELSE
               Y1 = 2.E-38
               Y2 = 1.E+38
            END IF
         ELSE
            Y1 = Y(I)-D
            Y2 = Y(I)+D
         END IF
         CALL MOVEA(X(I),Y1)
         CALL DRAWA(X(I),Y2)
100   CONTINUE
C
      RETURN
      END

C*GRDATE -- get date and time as character string (MS-DOS)
C+
      SUBROUTINE GRDATE(CDATE, LDATE)
      CHARACTER CDATE*(17)
      INTEGER   LDATE
C
C Return the current date and time, in format 'dd-Mmm-yyyy hh:mm'.
C To receive the whole string, the CDATE should be declared
C CHARACTER*17.
C
C Arguments:
C  CDATE : receives date and time, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in STRING, excluding
C           trailing blanks. This will always be 17, unless the length
C           of the string supplied is shorter.
C--
C 1989-Mar-17 - [AFT]
C-----------------------------------------------------------------------
      CHARACTER CMON(12)*3
      INTEGER*2 IHR, IMIN, ISEC, I100TH
      INTEGER*2 IYR, IMON, IDAY
      DATA CMON/'Jan','Feb','Mar','Apr','May','Jun',
     :          'Jul','Aug','Sep','Oct','Nov','Dec'/
C---
      CALL GETTIM(IHR, IMIN, ISEC, I100TH)
      CALL GETDAT(IYR, IMON, IDAY)
      WRITE(CDATE,111) IDAY,CMON(IMON),IYR,IHR,IMIN
  111 FORMAT(I2,'-',A3,'-',I4,' ',I2,':',I2)
      LDATE=17
      RETURN
      END

C*PGBBUF -- begin batch of output (buffer)
C%void cpgbbuf(void);
C+
      SUBROUTINE PGBBUF
C
C Begin saving graphical output commands in an internal buffer; the
C commands are held until a matching PGEBUF call (or until the buffer
C is emptied by PGUPDT). This can greatly improve the efficiency of
C PGPLOT.  PGBBUF increments an internal counter, while PGEBUF
C decrements this counter and flushes the buffer to the output
C device when the counter drops to zero.  PGBBUF and PGEBUF calls
C should always be paired.
C
C Arguments: none
C--
C 21-Nov-1985 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (.NOT.PGNOTO('PGBBUF')) THEN
          PGBLEV(PGID) = PGBLEV(PGID) + 1
      END IF
      END

      INCLUDE 'FLIB.FI'   !include if compiled separately
      INCLUDE 'FGRAPH.FI'
      INCLUDE 'MOUSE.FI'
      SUBROUTINE GRMS2M( IX, IY, CHR)
      INCLUDE 'FLIB.FD'
      INCLUDE 'FGRAPH.FD'
      INCLUDE 'MOUSE.FD'
C* pos and return mouse cursor, return key pressed
C C. T. Dum March 23,1995
c link with mouse.obj (FL32 distr.)
      RECORD /EVENT/ pEvent
      INTEGER*4 ichr
      INTEGER*2 IX, IY
      CHARACTER*(*) CHR
      ICHR = 0
c move mouse cursor, exit if key other than Function or Cursor is
c pressed
      DO WHILE(ICHR .EQ. 0)
         call setptrpos(int4(ix),int4(iy))
         call setptrvis(1)
         chr=getcharQQ()
         ichr=ichar(chr)
         if(ichr.eq.0) then
c function or cursor key was pressed
          chr=getcharQQ()
         endif
         call getptrpos(pEvent)
         ix=pEvent.x
         iy=pEvent.y
      ENDDO
      call setptrvis(2)
      RETURN
      END

C*GRPXPS -- pixel dump for color or grey PostScript.
C+
      SUBROUTINE GRPXPS (IA, IDIM, JDIM, I1, I2, J1, J2,
     :                   XMIN, XMAX, YMIN, YMAX)
      INTEGER IDIM, JDIM, I1, I2, J1, J2
      INTEGER IA(IDIM,JDIM)
      REAL XMIN, XMAX, YMIN, YMAX
C
C This routine is called by GRPIXL.
C--
C  4-Apr-93 - Created from GRGRAY by Remko Scharroo - DUT/SSRT
C  8-Apr-93 - Bugs fixed.
C  6-Jul-94 - Aligned with PGPLOT V4.9H
C  7-Sep-94 - updated for V5.0 [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  I, J, NXP, NYP, NBUF, LCHR, II
      REAL     DX,DY,RBUF(32)
      CHARACTER*32 CHR
C-----------------------------------------------------------------------
      NXP = I2 - I1 + 1
      NYP = J2 - J1 + 1
C
C Build an image transformation matrix.
C
      DX = (XMAX-XMIN)/NXP
      DY = (YMAX-YMIN)/NYP
      RBUF(1) = 0
      RBUF(2) = NXP
      RBUF(3) = NYP
      RBUF(4) = GRXMIN(GRCIDE)
      RBUF(5) = GRXMAX(GRCIDE)
      RBUF(6) = GRYMIN(GRCIDE)
      RBUF(7) = GRYMAX(GRCIDE)
      RBUF(8) = 1.0/DX
      RBUF(9) = 0.0
      RBUF(10) = 0.0
      RBUF(11) = 1.0/DY
      RBUF(12) = (-XMIN)/DX
      RBUF(13) = (-YMIN)/DY
C
C Send setup info to driver.
C
      IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
      CALL GRTERM
      NBUF = 13
      LCHR = 0
      CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
C
C Send the array of color indices to the driver.
C
      II = 0
      DO 20 J=J1,J2
         DO 10 I=I1,I2
            II = II + 1
            RBUF(II+1) = IA(I,J)
            IF (II.EQ.20) THEN
               NBUF = II+1
               RBUF(1) = II
               CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
               II = 0
            END IF
 10      CONTINUE
 20   CONTINUE
      IF (II.GT.0) THEN
         NBUF = II+1
         RBUF(1) = II
         CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
         II = 0
      END IF
C
C Send termination code to driver.
C
      NBUF = 1
      RBUF(1) = -1
      CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
C-----------------------------------------------------------------------
      END

C*GRESC -- escape routine
C+
      SUBROUTINE GRESC (TEXT)
C
C GRPCKG: "Escape" routine. The specified text is sent directly to the
C selected graphics device, with no interpretation by GRPCKG. This
C routine must be used with care; e.g., the programmer needs to know
C the device type of the currently selected device, and the instructions
C that that device can accept.
C
C Arguments: none.
C  TEXT (input, character*(*)):  text to be sent to the device.
C
C 15-May-1985 - new routine [TJP].
C 26-May-1987 - add GREXEC support [TJP].
C 19-Dec-1988 - start new page if necessary [TJP].
C  4-Feb-1997 - RBUF should be an array, not a scalar [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      CHARACTER*(*) TEXT
      REAL RBUF(1)
      INTEGER NBUF
C
C If no device is currently selected, do nothing.
C
      IF (GRCIDE.GT.0) THEN
          IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
          NBUF = 0
          CALL GREXEC(GRGTYP,23,RBUF,NBUF,TEXT,LEN(TEXT))
      END IF
      END

C*GRFAO - format character string containing integers
C+
      SUBROUTINE GRFAO (FORMAT, L, STR, V1, V2, V3, V4)
      CHARACTER*(*) FORMAT
      INTEGER L
      CHARACTER*(*) STR
      INTEGER V1, V2, V3, V4
C
C The input string FORMAT is copied to the output string STR with
C the first occurrence of '#' replaced by the value of V1, the second
C by the value of V2, etc.  The length of the resulting string is 
C returned in L.
C-----------------------------------------------------------------------
      INTEGER I,Q,VAL,GRITOC
C
      L = 0
      Q = 0
      DO 10 I=1,LEN(FORMAT)
          IF (L.GE.LEN(STR)) RETURN
          IF (FORMAT(I:I).NE.'#') THEN
              L = L+1
              STR(L:L) = FORMAT(I:I)
          ELSE
              Q = Q+1
              VAL = 0
              IF (Q.EQ.1) VAL = V1
              IF (Q.EQ.2) VAL = V2
              IF (Q.EQ.3) VAL = V3
              IF (Q.EQ.4) VAL = V4
              L = L + GRITOC(VAL, STR(L+1:))
          END IF
   10 CONTINUE
C-----------------------------------------------------------------------
      END

C*PGFUNT -- function defined by X = F(T), Y = G(T)
C+
      SUBROUTINE PGFUNT (FX, FY, N, TMIN, TMAX, PGFLAG)
      REAL FX, FY
      EXTERNAL FX, FY
      INTEGER N
      REAL TMIN, TMAX
      INTEGER PGFLAG
C
C Draw a curve defined by parametric equations X = FX(T), Y = FY(T).
C
C Arguments:
C  FX     (external real function): supplied by the user, evaluates
C                    X-coordinate.
C  FY     (external real function): supplied by the user, evaluates
C                    Y-coordinate.
C  N      (input)  : the number of points required to define the
C                    curve. The functions FX and FY will each be
C                    called N+1 times.
C  TMIN   (input)  : the minimum value for the parameter T.
C  TMAX   (input)  : the maximum value for the parameter T.
C  PGFLAG (input)  : if PGFLAG = 1, the curve is plotted in the
C                    current window and viewport; if PGFLAG = 0,
C                    PGENV is called automatically by PGFUNT to
C                    start a new plot with automatic scaling.
C
C Note: The functions FX and FY must be declared EXTERNAL in the
C Fortran program unit that calls PGFUNT.
C--
C  5-Oct-1983
C 11-May-1990 - remove unnecessary include [TJP].
C 13-Dec-1990 - make errors non-fatal [TJP].
C-----------------------------------------------------------------------
      INTEGER MAXP
      PARAMETER (MAXP=1000)
      INTEGER  I
      REAL     X(0:MAXP), Y(0:MAXP), DT
      REAL     XMIN, XMAX, YMIN, YMAX
C
      IF (N.LT.1 .OR. N.GT.MAXP) THEN
          CALL GRWARN('PGFUNT: invalid arguments')
          RETURN
      END IF
      CALL PGBBUF
C
C Evaluate function.
C
      DT = (TMAX-TMIN)/N
      X(0) = FX(TMIN)
      Y(0) = FY(TMIN)
      XMIN = X(0)
      XMAX = X(0)
      YMIN = Y(0)
      YMAX = Y(0)
      DO 10 I=1,N
          X(I) = FX(TMIN+DT*I)
          Y(I) = FY(TMIN+DT*I)
          XMIN = MIN(XMIN,X(I))
          XMAX = MAX(XMAX,X(I))
          YMIN = MIN(YMIN,Y(I))
          YMAX = MAX(YMAX,Y(I))
   10 CONTINUE
      DT = 0.05*(XMAX-XMIN)
      IF (DT.EQ.0.0) THEN
          XMIN = XMIN - 1.0
          XMAX = XMAX + 1.0
      ELSE
          XMIN = XMIN - DT
          XMAX = XMAX + DT
      END IF
      DT = 0.05*(YMAX-YMIN)
      IF (DT.EQ.0.0) THEN
          YMIN = YMIN - 1.0
          YMAX = YMAX + 1.0
      ELSE
          YMIN = YMIN - DT
          YMAX = YMAX + DT
      END IF
C
C Define environment if necessary.
C
      IF (PGFLAG.EQ.0) CALL PGENV(XMIN,XMAX,YMIN,YMAX,0,0)
C
C Draw curve.
C
      CALL PGMOVE(X(0),Y(0))
      DO 20 I=1,N
          CALL PGDRAW(X(I),Y(I))
   20 CONTINUE
C
      CALL PGEBUF
      END

C*PGVPORT -- non-standard alias for PGSVP
C+
      SUBROUTINE PGVPORT (XLEFT, XRIGHT, YBOT, YTOP)
      REAL XLEFT, XRIGHT, YBOT, YTOP
C
C See description of PGSVP.
C--
      CALL PGSVP (XLEFT, XRIGHT, YBOT, YTOP)
      END

C*GRPARS -- parse device specification string
C+
      INTEGER FUNCTION GRPARS (SPEC,DEV,TYPE,APPEND)
      CHARACTER*(*) SPEC, DEV
      INTEGER  TYPE
      LOGICAL  APPEND
C
C GRPCKG: decode a device-specification; called by GROPEN.
C
C Returns:
C  GRPARS (output): 1 if the device-specification is
C       acceptable; any other value indicates an error.
C
C Arguments:
C  SPEC (input): the device specification.
C  DEV  (output):  device name or file spec.
C  TYPE (output): device type (integer code); 0 if no device
C       type is specified.
C  APPEND (output): .TRUE. if /APPEND specified, .FALSE. otherwise.
C--
C 23-Jul-1984 - [TJP].
C 19-Feb-1988 - allow device part to be quoted [TJP].
C 30-Mar-1989 - remove logical translation of device and type [TJP].
C 17-Jun-1991 - ignore comments after ' (' [TJP].
C 19-Dec-1994 - rewritten to scan backwards [TJP].
C  6-Jun-1995 - correct a zero-length string problem [TJP].
C-----------------------------------------------------------------------
      CHARACTER*32  CTYPE, UPPER
      CHARACTER*6   APPSTR
      CHARACTER*256 DESCR
      INTEGER       GRDTYP, GRTRIM
      INTEGER       L, LC, LS
      DATA          APPSTR/'APPEND'/
C
C Default results.
C
      DEV = ' '
      TYPE = 0
      APPEND = .FALSE.
      GRPARS = 1
      CTYPE = ' '
C
C Null string is acceptable.
C
      IF (LEN(SPEC).LT.1) RETURN
      IF (SPEC.EQ.' ') RETURN
C
C On systems where it is possible, perform a "logical name" translation.
C
      DESCR = SPEC
      CALL GRLGTR(DESCR)
C
C Discard trailing blanks: L is length of remainder.
C
      L = GRTRIM(DESCR)
C
C Find last slash in string (position LS or 0).
C
      LS = L
 20   IF (DESCR(LS:LS).NE.'/') THEN
         LS = LS-1
         IF (LS.GT.0) GOTO 20
      END IF
C
C Check for /APPEND qualifier; if present, look again for type.
C
      IF (LS.GT.0) THEN
         CTYPE = DESCR(LS+1:L)
         CALL GRTOUP(UPPER,CTYPE)
         CTYPE = UPPER
         IF (CTYPE.EQ.APPSTR) THEN
            APPEND = .TRUE.
            L = LS-1
            LS = L
 30         IF (DESCR(LS:LS).NE.'/') THEN
               LS = LS-1
               IF (LS.GT.0) GOTO 30
            END IF
         ELSE
            APPEND = .FALSE.
         END IF
      END IF
C
C If LS=0 there is no type field: use PGPLOT_TYPE.
C
      IF (LS.EQ.0) THEN
         CALL GRGENV('TYPE', CTYPE, LC)
      ELSE
         CTYPE = DESCR(LS+1:L)
         LC = L-LS
         L = LS-1
      END IF
C
C Check for allowed type.
C
      IF (LC.GT.0) THEN
         CALL GRTOUP(UPPER,CTYPE)
         CTYPE = UPPER
         TYPE = GRDTYP(CTYPE)
         IF (TYPE.EQ.0) CALL GRWARN('Unrecognized device type')
         IF (TYPE.EQ.-1) CALL GRWARN('Device type is ambiguous')
      ELSE
         TYPE = 0
         CALL GRWARN('Device type omitted')
      END IF
      IF (TYPE.EQ.0) GRPARS = GRPARS+2
C
C Remove quotes from device if necessary.
C
      IF (L.GE.1) THEN
         IF (DESCR(1:1).EQ.'"' .AND. DESCR(L:L).EQ.'"') THEN
            DEV = DESCR(2:L-1)
            L = L-2
         ELSE
            DEV = DESCR(1:L)
         END IF
      END IF
C
C      write (*,*) 'Device = [', DEV(1:L), ']'
C      write (*,*) 'Type   = [', CTYPE, ']', TYPE
C      write (*,*) 'APPEND = ', APPEND
C
      END

C*PGQCLP -- inquire clipping status
C%void cpgqclp(int *state);
C+
      SUBROUTINE PGQCLP(STATE)
      INTEGER  STATE
C
C Query the current clipping status (set by routine PGSCLP).
C
C Argument:
C  STATE  (output) : receives the clipping status (0 => disabled,
C                    1 => enabled).
C--
C 25-Feb-1997 [TJP] - new routine.
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGQCLP')) THEN
         STATE = 1
      ELSE
         STATE = PGCLP(PGID)
      END IF
      END

C*GRSFNT -- set text font
C+
      SUBROUTINE GRSFNT (IF)
      INTEGER IF
C
C GRPCKG: Set the font for subsequent text plotting.
C The default font is 1 ("Normal" font); others available are 2
C ("Roman"), 3 ("Italic"), and 4 ("Script").
C
C Argument:
C  IF (input): the font number to be used for subsequent
C       text plotting on the current device (in range 1-4).
C--
C 19-Mar-1983 - [TJP].
C  4-Jun-1984 - add code for GMFILE device [TJP].
C 15-Dec-1988 - change name [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER    I
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRSFNT - no graphics device is active.')
          RETURN
      END IF
C
C Set software font index.
C
      IF (IF.LT.1 .OR. IF.GT.4) THEN
          CALL GRWARN('Illegal font selected: font 1 used.')
          I = 1
      ELSE
          I = IF
      END IF
C
C Ignore request if no change is to be made.
C
      IF (IF.EQ.GRCFNT(GRCIDE)) RETURN
C
C Save font setting.
C
      GRCFNT(GRCIDE) = I
C
      END

C*PGQTBG -- inquire text background color index
C%void cpgqtbg(int *tbci);
C+
      SUBROUTINE PGQTBG (TBCI)
      INTEGER  TBCI
C
C Query the current Text Background Color Index (set by routine
C PGSTBG).
C
C Argument:
C  TBCI   (output) : receives the current text background color index.
C--
C 16-Oct-1993 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGQTBG')) THEN
          TBCI = 0
      ELSE
          TBCI = PGTBCI(PGID)
      END IF
      END

C*PGSCH -- set character height
C%void cpgsch(float size);
C+
      SUBROUTINE PGSCH (SIZE)
      REAL SIZE
C
C Set the character size attribute. The size affects all text and graph
C markers drawn later in the program. The default character size is
C 1.0, corresponding to a character height about 1/40 the height of
C the view surface.  Changing the character size also scales the length
C of tick marks drawn by PGBOX and terminals drawn by PGERRX and PGERRY.
C
C Argument:
C  SIZE   (input)  : new character size (dimensionless multiple of
C                    the default size).
C--
C (1-Mar-1983)
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      LOGICAL  PGNOTO
      REAL     XC, XCNEW, YC, XS, YS
C
      IF (PGNOTO('PGSCH')) RETURN
C
      CALL GRCHSZ(PGID, XC, YC, XS, YS)
      IF (PGXSZ(PGID)/PGXPIN(PGID) .GT.
     1    PGYSZ(PGID)/PGYPIN(PGID)) THEN
          XCNEW = SIZE*XC*PGYSZ(PGID)/YS/40.0
      ELSE
          XCNEW = SIZE*XC*(PGXSZ(PGID)*PGYPIN(PGID)/PGXPIN(PGID))
     1            /YS/40.0
      END IF
      CALL GRSETC(PGID,XCNEW)
      PGXSP(PGID) = XS*XCNEW/XC
      PGYSP(PGID) = YS*XCNEW/XC
      PGCHSZ(PGID) = SIZE
      END

C*PGQCH -- inquire character height
C%void cpgqch(float *size);
C+
      SUBROUTINE PGQCH (SIZE)
      REAL SIZE
C
C Query the Character Size attribute (set by routine PGSCH).
C
C Argument:
C  SIZE   (output) : current character size (dimensionless multiple of
C                    the default size).
C--
C  5-Nov-1985 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      LOGICAL  PGNOTO
C
      IF (PGNOTO('PGQCH')) THEN
          SIZE = 1.0
      ELSE
          SIZE = PGCHSZ(PGID)
      END IF
      END

C*GRGCOM -- read with prompt from user's terminal (VMS)
C+
      INTEGER FUNCTION GRGCOM(STRING, PROMPT, L)
      CHARACTER*(*) STRING, PROMPT
      INTEGER L
C
C Issue prompt and read a line from the user's terminal; in VMS,
C this is equivalent to LIB$GET_COMMAND.
C
C Arguments:
C  STRING : (output) receives the string read from the terminal.
C  PROMPT : (input) prompt string.
C  L      : (output) length of STRING.
C
C Returns:
C  GRGCOM : 1 if successful, 0 if an error occurs (e.g., end of file).
C--
C  9-Feb-1988
C 12-May-1998: workaround for VMS bug, provided by Magnus Zolliker; the
C      extra CR//LF is sometimes required if the terminal is used as
C      a graphics device of type /TEK or similar.
C-----------------------------------------------------------------------
      INTEGER CR, LF
      PARAMETER (CR=13, LF=10)
      INTEGER LIB$GET_COMMAND
C
      GRGCOM = LIB$GET_COMMAND(STRING, CHAR(CR)//CHAR(LF)//PROMPT, L)
      IF (GRGCOM.NE.1) GRGCOM = 0
      END

C*CCDRIV -- PGPLOT DEC LJ250 Color Companion driver
C+
      SUBROUTINE CCDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      IMPLICIT NONE
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for DEC LJ250 Color Companion device.
C
C Version 1.0  - 1989 Jun 04 - S. C. Allendorf
C=======================================================================
C
C Supported device: DEC LJ250 Color Companion printer.
C
C Device type code: /CCP (portrait) or /CCL (landscape).
C
C Default device name: PGPLOT.CCPLT.
C
C Default view surface dimensions: 8.0 inches by 10.5 inches.
C
C Resolution: 90 dots/inch.
C
C Color capability: Color indices 0-15 are supported. It is not (yet)
C possible to change color representation.
C
C Input capability: None.
C
C File format: DEC color sixel format.
C
C Obtaining hardcopy: Use the VMS PRINT command.
C-----------------------------------------------------------------------
C 
C To choose portrait mode, you must execute a DCL command of the 
C following form before executing your program:
C
C $ DEFINE PGPLOT_CC_MODE PORTRAIT
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE
      PARAMETER (TYPE='CC (DEC LJ250 Color Companion printer)')
      BYTE       CTAB(3, 256), FF
      LOGICAL    HIRES, INIT, LANDSCAPE
      INTEGER*4  BUFFER, BX, BY, I, IC, IER, GRFMEM, GRGMEM
      INTEGER*4  LUN, MAXCOL, NPICT
      REAL*4     XBUF(4)
      CHARACTER  DEFNAM*12, MODE*20, MSG*10
      PARAMETER  (FF = 12)
      PARAMETER  (DEFNAM = 'PGPLOT.CCPLT')
      DATA INIT  /.TRUE./
      DATA CTAB  /100, 100, 100,      0,   0,   0,    100,   0,   0,
     1              0, 100,   0,      0,   0, 100,      0, 100, 100,
     2            100,   0, 100,    100, 100,   0,    100,  50,   0,
     3             50, 100,   0,      0, 100,  50,      0,  50, 100,
     4             50,   0, 100,    100,   0,  50,     33,  33,  33,
     5             67,  67,  67,    720 * 0/
C-----------------------------------------------------------------------
C                                       First time, do some one-time
C                                       initialization.
      IF (INIT) THEN
C                                       Make sure we only do this once.
         INIT = .FALSE.
C                                       Initialize the maximum color
C                                       index currently used.
         MAXCOL = 0
C                                       The default is low resolution,
C                                       landscape orientation.
         LANDSCAPE = .TRUE.
         HIRES = .FALSE.
C                                       Select mode based on logical.
         CALL GRGENV ('CC_MODE', MODE, I)
         IF (MODE(1:1) .EQ. 'P') LANDSCAPE = .FALSE.
         IF (MODE(2:2) .EQ. 'H') HIRES = .TRUE.
      END IF
C                                       Branch on opcode.
      GOTO ( 10,  20,  30,  40,  50,  60,  70,  80,  90, 100,
     1      110, 120, 130, 140, 150, 160, 170, 180, 190, 200,
     2      210, 220, 230, 240, 250, 260), IFUNC
C                                       Signal an error.
  900 WRITE (MSG, '(I10)') IFUNC
      CALL GRWARN ('Unimplemented function in LJ250 device driver:' 
     1             // MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CONTINUE
      CHR = TYPE
      NBUF = 0
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 CONTINUE
      RBUF(1) = 0.0
      IF (HIRES .AND. LANDSCAPE)             RBUF(2) = 1889.0
      IF (HIRES .AND. .NOT. LANDSCAPE)       RBUF(2) = 1439.0
      IF (.NOT. HIRES .AND. LANDSCAPE)       RBUF(2) = 944.0
      IF (.NOT. HIRES .AND. .NOT. LANDSCAPE) RBUF(2) = 719.0
      RBUF(3) = 0.0
      IF (HIRES .AND. LANDSCAPE)             RBUF(4) = 1439.0
      IF (HIRES .AND. .NOT. LANDSCAPE)       RBUF(4) = 1889.0
      IF (.NOT. HIRES .AND. LANDSCAPE)       RBUF(4) = 719.0
      IF (.NOT. HIRES .AND. .NOT. LANDSCAPE) RBUF(4) = 944.0
      RBUF(5) = 0.0
      IF (HIRES) THEN
         RBUF(6) = 7.0
      ELSE
         RBUF(6) = 255.0
      END IF
      NBUF = 6
      LCHR = 0
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 CONTINUE
      IF (HIRES) THEN
         RBUF(1) = 180.0
      ELSE
         RBUF(1) = 90.0
      END IF
      RBUF(2) = RBUF(1)
      RBUF(3) = 1.0
      NBUF = 3
      LCHR = 0
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    no thick lines)
C
   40 CONTINUE
      CHR = 'HNNNNNNNNN'
      NBUF = 0
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CONTINUE
      CHR = DEFNAM
      NBUF = 0
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 CONTINUE
      RBUF(1) = 0.0
      IF (HIRES .AND. LANDSCAPE)             RBUF(2) = 1889.0
      IF (HIRES .AND. .NOT. LANDSCAPE)       RBUF(2) = 1439.0
      IF (.NOT. HIRES .AND. LANDSCAPE)       RBUF(2) = 944.0
      IF (.NOT. HIRES .AND. .NOT. LANDSCAPE) RBUF(2) = 719.0
      RBUF(3) = 0.0
      IF (HIRES .AND. LANDSCAPE)             RBUF(4) = 1439.0
      IF (HIRES .AND. .NOT. LANDSCAPE)       RBUF(4) = 1889.0
      IF (.NOT. HIRES .AND. LANDSCAPE)       RBUF(4) = 719.0
      IF (.NOT. HIRES .AND. .NOT. LANDSCAPE) RBUF(4) = 944.0
      NBUF = 4
      LCHR = 0
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 CONTINUE
      RBUF(1) = 1.0
      NBUF = 1
      LCHR = 0
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C                                       Assume success.
      RBUF(2) = 1.0
C                                       Obtain a logical unit number.
      CALL GRGLUN (LUN)
C                                       Check for an error.
      IF (LUN .EQ. -1) THEN
          CALL GRWARN ('Cannot allocate a logical unit.')
          RBUF(2) = 0
          RETURN
      ELSE
         RBUF(1) = LUN
      END IF
C                                       Open the output file.
      OPEN (UNIT = LUN, FILE = CHR(:LCHR), CARRIAGECONTROL = 'NONE',
     1      DEFAULTFILE = DEFNAM, STATUS = 'NEW',
     2      RECL = 362, FORM = 'UNFORMATTED', RECORDTYPE = 'VARIABLE', 
     3      IOSTAT = IER)
C                                       Check for an error and cleanup if
C                                       one occurred.
      IF (IER .NE. 0) THEN
          CALL GRWARN ('Cannot open output file for LJ250 plot: ' //
     1                 CHR(:LCHR))
          RBUF(2) = 0
          CALL GRFLUN (LUN)
          RETURN
      ELSE
C                                       Get the full file specification
C                                       and calculate the length of the 
C                                       string
          INQUIRE (UNIT = LUN, NAME = CHR)
          LCHR = LEN (CHR)
   91     IF (CHR (LCHR:LCHR) .EQ. ' ') THEN
              LCHR = LCHR - 1
              GOTO 91
          END IF
      END IF
C                                       Initialize the page counter.
      NPICT = 0
      RETURN
C
C--- IFUNC = 10, Close workstation -------------------------------------
C
  100 CONTINUE
C                                       Close the file.
      CLOSE (LUN, STATUS = 'KEEP')
C                                       Deallocate the logical unit.
      CALL GRFLUN (LUN)
C
      RETURN
C
C--- IFUNC = 11, Begin picture -----------------------------------------
C
  110 CONTINUE
C                                       Calculate the dimensions of the
C                                       plot buffer.
      IF (LANDSCAPE) THEN
         XBUF(1) = RBUF(2)
         XBUF(2) = RBUF(1)
      ELSE
         XBUF(1) = RBUF(1)
         XBUF(2) = RBUF(2)
      END IF
      BX = INT (XBUF(1)) + 1
      BY = (INT (XBUF(2)) / 6 + 1) * 6
C                                       Allocate a plot buffer.      
      IER = GRGMEM (BX * BY, BUFFER)
C                                       Check for error and clean up
C                                       if one was found.
      IF (IER .NE. 1) THEN
          CALL GRGMSG (IER)
          CALL GRQUIT ('Failed to allocate a plot buffer.')
      END IF
C                                       Increment the page number.
      NPICT = NPICT + 1
C                                       Eject the page from the printer.
      IF (NPICT .GT. 1) WRITE (LUN) FF
C                                       Zero out the plot buffer.
      CALL GRCC04 (BX * BY, %VAL(BUFFER))
      RETURN
C
C--- IFUNC = 12, Draw line ---------------------------------------------
C
  120 CONTINUE
C                                       Apply any needed tranformation.
      IF (LANDSCAPE) THEN
         XBUF(1) = RBUF(2)
         XBUF(2) = (BY - 1) - RBUF(1)
         XBUF(3) = RBUF(4)
         XBUF(4) = (BY - 1) - RBUF(3)
      ELSE
         XBUF(1) = RBUF(1)
         XBUF(2) = RBUF(2)
         XBUF(3) = RBUF(3)
         XBUF(4) = RBUF(4)
      END IF
C                                       Draw the point into the bitmap.
      CALL GRCC00 (1, XBUF, IC, BX, BY, %VAL (BUFFER))
      RETURN
C
C--- IFUNC = 13, Draw dot ----------------------------------------------
C
  130 CONTINUE
C                                       Apply any needed tranformation.
      IF (LANDSCAPE) THEN
         XBUF(1) = RBUF(2)
         XBUF(2) = (BY - 1) - RBUF(1)
      ELSE
         XBUF(1) = RBUF(1)
         XBUF(2) = RBUF(2)
      END IF
C                                       Draw the point into the bitmap.
      CALL GRCC00 (0, XBUF, IC, BX, BY, %VAL(BUFFER))
      RETURN
C
C--- IFUNC = 14, End picture -------------------------------------------
C
  140 CONTINUE
C                                       Write out the bitmap.
      CALL GRCC01 (LUN, BX, BY, %VAL (BUFFER), MAXCOL, HIRES, CTAB)
C                                       Deallocate the plot buffer.
      IER = GRFMEM (BX * BY, BUFFER)
C                                       Check for an error.
      IF (IER .NE. 1) THEN
          CALL GRGMSG (IER)
          CALL GRWARN ('Failed to deallocate plot buffer.')
      END IF
      RETURN
C
C--- IFUNC = 15, Select color index ------------------------------------
C
  150 CONTINUE
C                                       Save the requested color index.
      IC = RBUF(1)
      MAXCOL = MAX (IC, MAXCOL)
      RETURN
C
C--- IFUNC = 16, Flush buffer. -----------------------------------------
C    (Not implemented: ignored.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC = 17, Read cursor. ------------------------------------------
C    (Not implemented: should not be called.)
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC = 18, Erase alpha screen. -----------------------------------
C    (Not implemented: ignored.)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC = 19, Set line style. ---------------------------------------
C    (Not implemented: should not be called.)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC = 20, Polygon fill. -----------------------------------------
C    (Not implemented: should not be called.)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC = 21, Set color representation. -----------------------------
C
  210 CONTINUE
      I = INT (RBUF(1) + 1.5)
      CTAB(1, I) = INT (RBUF(2) * 100.0 + 0.5)
      CTAB(2, I) = INT (RBUF(3) * 100.0 + 0.5)
      CTAB(3, I) = INT (RBUF(4) * 100.0 + 0.5)
      RETURN
C
C--- IFUNC = 22, Set line width. ---------------------------------------
C    (Not implemented: should not be called.)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC = 23, Escape ------------------------------------------------
C    (Not implemented: ignored.)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC = 24, Rectangle fill. ---------------------------------------
C    (Not implemented: should not be called.)
C
  240 CONTINUE
      GOTO 900
C
C--- IFUNC = 25, -------------------------------------------------------
C    (Not implemented: should not be called.)
C
  250 CONTINUE
      GOTO 900
C
C--- IFUNC = 26, Line of pixels. ---------------------------------------
C    (Not implemented: should not be called.)
C
  260 CONTINUE
      GOTO 900
C-----------------------------------------------------------------------
      END

C*GRCC00 -- PGPLOT LJ250 driver, draw a colored line
C+
      SUBROUTINE GRCC00 (LINE, RBUF, ICOL, BX, BY, BITMAP)
      IMPLICIT NONE
      INTEGER*4  BX, BY, ICOL, LINE
      BYTE       BITMAP(BX, BY)
      REAL*4     RBUF(4)
C
C Draw a straight line segment from absolute pixel coordinates (RBUF(1),
C RBUF(2)) to (RBUF(3), RBUF(4)).  The line overwrites the previous 
C contents of the bitmap with the current color index.  The line is 
C generated with a Simple Digital Differential Analyser (ref: Newman & 
C Sproull). 
C
C Arguments:
C
C LINE            I I      =0 for dot, =1 for line.
C RBUF(1),RBUF(2) I R      Starting point of line.
C RBUF(3),RBUF(4) I R      Ending point of line.
C ICOL            I I      Color index
C BITMAP        I/O B      (address of) the frame buffer.
C
C-----------------------------------------------------------------------
      INTEGER*4  K, KX, KY, LENGTH
      REAL*4     D, XINC, XP, YINC, YP
C-----------------------------------------------------------------------
      IF (LINE .GT. 0) THEN
         D = MAX (ABS (RBUF(3) - RBUF(1)), ABS (RBUF(4) - RBUF(2)))
         LENGTH = D
         IF (LENGTH .EQ. 0) THEN
            XINC = 0.0
            YINC = 0.0
         ELSE
            XINC = (RBUF(3) - RBUF(1)) / D
            YINC = (RBUF(4) - RBUF(2)) / D
         END IF
      ELSE
         LENGTH = 0
         XINC = 0.0
         YINC = 0.0
      END IF
      XP = RBUF(1) + 0.5
      YP = RBUF(2) + 0.5
      DO K = 0, LENGTH
         KX = XP
         KY = (BY - 1) - INT (YP)
         BITMAP(KX + 1, KY + 1) = ICOL
         XP = XP + XINC
         YP = YP + YINC
      END DO
C-----------------------------------------------------------------------
      RETURN
      END

C*GRCC01 -- PGPLOT LJ250 driver, copy bitmap to Sixel output file
C+
      SUBROUTINE GRCC01 (LUN, BX, BY, BITMAP, NC, HIRES, CTAB)
      IMPLICIT NONE
      LOGICAL  HIRES
      INTEGER  BX, BY, LUN, NC
      BYTE     BITMAP(BX, BY), CTAB(3, 256)
C
C Arguments:
C
C  LUN    (input)  Fortran unit number for output
C  BX, BY (input)  dimensions of BITMAP (BY MUST be a multiple of 6)
C  BITMAP (input)  the bitmap array
C  NC     (input)  the maximum color index used in the bitmap
C  CTAB   (input)  the color table
C-----------------------------------------------------------------------
      BYTE       ESC
      INTEGER*4  BUFF, GRCC03, I, IER, J, K, L, GRGMEM, M
      CHARACTER  BLUE*3, COL*3, GREEN*3, RED*3
      PARAMETER  (ESC = 27)
C-----------------------------------------------------------------------
C                                       Start Sixel graphics mode.
      IF (HIRES) THEN
         WRITE (LUN) ESC, 'P;1;;q"1;1;;-------'
      ELSE
         WRITE (LUN) ESC, 'P;1;8;q"1;1;;---'
      END IF
C                                       Write out the color table.
      DO I = 1, NC + 1
         J = GRCC03 (I - 1)
         K = CTAB(1, I)
         K = GRCC03 (K)
         L = CTAB(2, I)
         L = GRCC03 (L)
         M = CTAB(3, I)
         M = GRCC03 (M)
         WRITE (COL,   '(I3)') I - 1
         WRITE (RED,   '(I3)') CTAB(1, I)
         WRITE (GREEN, '(I3)') CTAB(2, I)
         WRITE (BLUE,  '(I3)') CTAB(3, I)
         WRITE (LUN) '#', COL(4 - J : 3), ';2;', RED(4 - K : 3), ';',
     1                    GREEN(4 - L : 3), ';', BLUE(4 - M : 3)
      END DO
C                                       Allocate a work array.
      IER = GRGMEM (BX * (NC + 1), BUFF)
C                                       Check for an error.
      IF (IER .NE. 1) THEN
         CALL GRGMSG (IER)
         CALL GRQUIT ('Failed to allocate temporary buffer.')
      END IF
C                                       Output the Sixel data.
      CALL GRCC02 (LUN, BX, BY, BITMAP, NC + 1, %VAL (BUFF))
C                                       Turn off Sixel graphics mode.
      WRITE (LUN) ESC, CHAR(92)
C-----------------------------------------------------------------------
      RETURN
      END

C*GRCC02 -- PGPLOT LJ250 driver, output the bitmap
C+
      SUBROUTINE GRCC02 (LUN, BX, BY, BITMAP, NC, SIXEL)
      IMPLICIT NONE
      INTEGER  BX, BY, LUN, NC
      BYTE     BITMAP(BX, BY), SIXEL(BX, NC)
C
C Version 1.0  18-Jun-1989  S. C. Allendorf
C-----------------------------------------------------------------------
      BYTE       CH, QMASK(6)
      LOGICAL    OUTPUT
      INTEGER*4  GRCC03, I, J, K, L, M, N, REPCNT
      CHARACTER  COL*3, OUTLINE*1445, REP*4
      DATA QMASK /'01'X, '02'X, '04'X, '08'X, '10'X, '20'X/
C-----------------------------------------------------------------------
C                                       Output the Sixel data.
      DO I = 1, BY / 6
C                                       Zero out the work array.
         CALL GRCC04 (BX * NC, SIXEL)
C                                       Create a Sixel line.
         DO J = 1, 6
            DO K = 1, BX
               L = BITMAP(K, (I - 1) * 6 + J) + 1
               SIXEL(K, L) = SIXEL(K, L) .OR. QMASK(J)
            END DO
         END DO
C                                       Loop through each color plane.
         DO J = 1, NC
C                                       Add the Sixel offset.
            DO K = 1, BX
               SIXEL(K, J) = SIXEL(K, J) + 63
            END DO
C                                       Initialize some variables for
C                                       run-length encoding.
            K = 1
            L = 1
            M = 1
            OUTPUT = .FALSE.
C                                       Stop if we are at the end of the
C                                       line.
   10       IF (K .LE. BX) THEN
C                                       Find the next character.
               CH = SIXEL(K, J)
C                                       Count the repeats.
   20          IF (M .LE. BX .AND. CH .EQ. SIXEL(M, J)) THEN
                  M = M + 1
                  GOTO 20
               END IF
C                                       Determine the length.
               REPCNT = M - K
C                                       See if there is any printable
C                                       data in this buffer.
               IF (REPCNT .NE. BX .OR. SIXEL(M - 1, J) .NE. 63) THEN
C                                       Mark the buffer as containing
C                                       printable data.
                  OUTPUT = .TRUE.
C                                       Fill the output buffer.               
                  IF (REPCNT .GE. 3) THEN
                     WRITE (REP, '(I4)') REPCNT
                     N = GRCC03 (REPCNT)
                     OUTLINE(L : L) = '!'
                     OUTLINE(L + 1 : L + N) = REP (5 - N : 4)
                     OUTLINE(L + N + 1 : L + N + 1) = 
     1                                            CHAR (SIXEL(M - 1, J))
                     L = L + N + 2
                  ELSE
                     DO N = 0, REPCNT - 1
                        OUTLINE(L + N : L + N) = CHAR (SIXEL(M - 1, J))
                     END DO
                     L = L + REPCNT
                  END IF
               END IF
C                                       Reinitialize the starting point
C                                       for the next string and jump to 
C                                       start of run length encoding. 
               K = M
               GOTO 10
            END IF
C                                       Write out the buffer if there is
C                                       any data in it.
            IF (OUTPUT) THEN
               WRITE (COL, '(I3)') J - 1
               N = GRCC03 (J - 1)
               WRITE (LUN) '#', COL(4 - N : 3), OUTLINE(1 : L - 1), '$'
            END IF
         END DO
C                                       Output a graphics linefeed.
         WRITE (LUN) '-'
      END DO
C------------------------------------------------------------------------
      RETURN
      END

C*GRCC03 -- PGPLOT LJ250 driver, calculate length of an integer
C+
      INTEGER FUNCTION GRCC03 (I)
      INTEGER I
C
C This function calculates the number of digits in a supplied integer.
C
C Arguments:
C
C I               I I      Integer value of number
C GRCC03          O I      Length of printed representation of I
C
C Version 1.0  10-Feb-1988  S. C. Allendorf
C-----------------------------------------------------------------------
      IF (I .GE. 10) THEN
         IF (I .GE. 100) THEN
            IF (I .GE. 1000) THEN
               GRCC03 = 4
            ELSE
               GRCC03 = 3
            END IF
         ELSE
            GRCC03 = 2
         END IF
      ELSE
         GRCC03 = 1
      END IF
C-----------------------------------------------------------------------
      RETURN
      END

C*GRCC04 -- zero fill buffer
C+
      SUBROUTINE GRCC04 (BUFSIZ,BUFFER)
C
C GRPCKG (internal routine): fill a buffer with a given character.
C
C Arguments:
C
C BUFFER (byte array, input): (address of) the buffer.
C BUFSIZ (integer, input): number of bytes in BUFFER.
C-----------------------------------------------------------------------
      INTEGER  BUFSIZ, I
      BYTE     BUFFER(BUFSIZ), FILL
      DATA     FILL /0/
C
      DO 10 I=1,BUFSIZ
          BUFFER(I) = FILL
   10 CONTINUE
      END

C*GRLINR -- draw a line (relative, world coordinates)
C+
      SUBROUTINE GRLINR (DX,DY)
C
C GRPCKG: draw a line from the current position by a specified
C relative displacement.
C
C Arguments:
C
C DX, DY (real, input): the displacement in world coordinates: the pen
C       position is incremented by DX in x and DY in y.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL     DX,DY
C
      IF (GRCIDE.GE.1) THEN
          CALL GRLIN0( DX * GRXSCL(GRCIDE) + GRXPRE(GRCIDE),
     1                 DY * GRYSCL(GRCIDE) + GRYPRE(GRCIDE) )
      END IF
      END

C*PGCURSE -- non-standard alias for PGCURS
C+
      INTEGER FUNCTION PGCURSE (X, Y, CH)
      REAL X, Y
      CHARACTER*1 CH
C
C See description of PGCURS.
C--
      INTEGER PGCURS
      PGCURSE = PGCURS (X, Y, CH)
      END

C*GRREC0 -- fill a rectangle (device coordinates)
C+
      SUBROUTINE GRREC0 (X0,Y0,X1,Y1)
      REAL X0, Y0, X1, Y1
C
C GRPCKG: Fill a rectangle with solid color.  The rectangle
C is defined by the (x,y) device coordinates of its lower left and
C upper right corners; the edges are parallel to the coordinate axes.
C X0 is guaranteed to be <= X1 and Y0 <= Y1. The rectangle possible
C extends beyond the clipping boundaries
C
C Arguments:
C
C X0, Y0 (input, real): device coordinates of one corner of the 
C       rectangle.
C X1, Y1 (input, real): device coordinates of the opposite corner of 
C       the rectangle.
C--
C 23-Mar-1988 - [TJP].
C 18-Jan-1991 - Code moved from GRRECT to GRREC0 so that it can also be
C               used by GRPXRE.
C  1-Sep-1994 - suppress driver call [TJP].
C  4-Dec-1995 - avoid use of real variable as do-loop index [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL    RBUF(6)
      INTEGER NBUF,LCHR
      CHARACTER*32 CHR
      REAL    XMIN, YMIN, XMAX, YMAX, Y, DY
      INTEGER LS, LW, I, NLINES
C
C Clip
C
      XMIN = X0
      XMAX = X1
      YMIN = Y0
      YMAX = Y1
      IF (XMIN .LT. GRXMIN(GRCIDE)) XMIN = GRXMIN(GRCIDE)
      IF (XMAX .GT. GRXMAX(GRCIDE)) XMAX = GRXMAX(GRCIDE)
      IF (YMIN .LT. GRYMIN(GRCIDE)) YMIN = GRYMIN(GRCIDE)
      IF (YMAX .GT. GRYMAX(GRCIDE)) YMAX = GRYMAX(GRCIDE)
      IF (XMIN .GT. XMAX) RETURN
      IF (YMIN .GT. YMAX) RETURN
C
C Use hardware rectangle fill if available.
C
      IF (GRGCAP(GRCIDE)(6:6).EQ.'R') THEN
          IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
          RBUF(1) = XMIN
          RBUF(2) = YMIN
          RBUF(3) = XMAX
          RBUF(4) = YMAX
          CALL GREXEC(GRGTYP,24,RBUF,NBUF,CHR,LCHR)
          RETURN
C
C Else use hardware polygon fill if available.
C
      ELSE IF (GRGCAP(GRCIDE)(4:4).EQ.'A') THEN
          IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
          RBUF(1) = 4
          CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
          RBUF(1) = XMIN
          RBUF(2) = YMIN
          CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
          RBUF(1) = XMAX
          RBUF(2) = YMIN
          CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
          RBUF(1) = XMAX
          RBUF(2) = YMAX
          CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
          RBUF(1) = XMIN
          RBUF(2) = YMAX
          CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
          RETURN
      END IF
C
C For other devices fill area is simulated.
C
C Save attributes.
C
      CALL GRQLS(LS)
      CALL GRQLW(LW)
      CALL GRSLS(1)
      CALL GRSLW(1)
      CALL GREXEC(GRGTYP, 3,RBUF,NBUF,CHR,LCHR)
      DY = RBUF(3)
C
C Draw horizontal raster lines.
C
      NLINES = ABS((YMAX-YMIN)/DY)
      Y = YMIN - DY/2.0
      DO 40 I=1,NLINES
         Y = Y + DY
         GRXPRE(GRCIDE) = XMIN
         GRYPRE(GRCIDE) = Y
         CALL GRLIN0(XMAX,Y)
   40 CONTINUE
C
C Restore attributes.
C
      CALL GRSLS(LS)
      CALL GRSLW(LW)
      END

        PROGRAM GMFPLOT
C-----------------------------------------------------------------------
C Translate a metafile.
C-----------------------------------------------------------------------
	CHARACTER*8   TYPE
	CHARACTER*128 DEVICE,FILE
	INTEGER       GROPEN
	integer*2 chunk,i,j
	real xcp,ycp
	logical prompt, debug, grchkt
	common /metafile_status/ xcp, ycp, prompt, debug
	common /pltid/ id
C
C		Find and open the metafile.
C
	IER = LIB$GET_FOREIGN(FILE,'Input file: ',L)
	IF (IER.NE.1) CALL EXIT(IER)
	IF (L.LT.1) CALL EXIT
	I = 1
	DO WHILE (I.LE.L .AND. FILE(I:I).LE.' ')
		I = I+1
	END DO
	FILE = FILE(I:)
	I = 1
	DO WHILE (I.LE.L .AND. FILE(I:I).NE.' ' .AND. FILE(I:I).NE.'/')
		I = I+1
	END DO
	DEVICE = FILE(I:)
	FILE = FILE(:I-1)
	OPEN (UNIT=1,NAME=FILE,READONLY,SHARED,STATUS='OLD',
     1	      DEFAULTFILE='GRAPHICS.GMF',
     2	      FORM='UNFORMATTED',RECORDTYPE='FIXED',RECL=180,
     3	      IOSTAT=IER)
	IF (IER.NE.0) THEN
		CALL ERRSNS(,IER,IES,,IET)
		IF (IES.NE.0) CALL EXIT(IES)
		IF (IER.NE.0) CALL EXIT(IER)
		CALL EXIT(IET)
	END IF
C
C 		Find and open the output plot device.
C
	IER = 1
	IF (DEVICE.EQ.' ') IER = LIB$GET_INPUT(
     1		DEVICE,'Graphics device/type: ',L)
	IF (IER.NE.1) CALL EXIT(IER)
	IER = GROPEN(0,0,DEVICE,ID)
	IF (IER.NE.1) CALL EXIT(IER)
C
C!	call grinqtyp(type,prompt)
	call grqtyp(type,prompt)
	prompt = prompt .and. grchkt('sys$command')
	debug = type(1:4).eq.'NULL'
C
C		Read and translate the metafile.
C
	chunk = 0
	do while (chunk.ne.'8100'X)
	    call getchunk(chunk)
	    if (chunk.lt.0) then
		call dochunk(chunk)
	    else
		i = chunk
		xcp = i
		call getchunk(j)
		if (j.ge.0) then
		    ycp = j
D		    type *,'  MOVE',i,j
		    call grmova(xcp,ycp)
		else
		    j = ibclr(j,15)
		    ycp = j
D		    type *,'  DRAW',i,j
		    call grlina(xcp,ycp)
		end if
	    end if
	end do
	call grclos
	end

	subroutine dochunk(chunk)
C-----------------------------------------------------------------------
C GMFPLOT: interpret a non-positioning Metafile command. All
C non-positioning commands consist of a command chunk and zero or more
C parameter chunks. A non-positioning command has a '1' in the 
C high-order bit (15) of the command chunk. Bits 14-12 indicate one
C of 8 classes of Metafile commands; bits 11-8 indicate one of 16
C commands within the class; and bits 7-0 give the number of 16-bit
C parameter chunks that follow. DOCHUNK interprets the command chunk
C and reads and interprets the following parameter chunks. 
C
C Argument:
C   CHUNK (input, integer*2): the command chunk.
C
C T. J. Pearson, 4-Jun-1984.
C-----------------------------------------------------------------------
	implicit none
	character*4 bells
	parameter (bells=char(7)//char(7)//char(7)//char(7))
	integer*2 dummy,chunk,ci,cr,cg,cb,ix,iy
	integer attrib,c,i,j,k,l
	logical file_open, picture_open
	integer picture_number, marker
	character*4 nerd,junk
	real xcp,ycp
	real px(512),py(512)
	logical prompt,debug
        integer id
        real xscale
	common /metafile_status/ xcp, ycp, prompt, debug
	common /pltid/ id,xscale
C
 1000	format (1X,Z4.4,1X,A,T40,5I6)
C
C		Separate chunk into command class (c), command-index 
C		(i), and number of parameter chunks (j).
C
	c = ibits(chunk,12,3)
	i = ibits(chunk,8,4)
	j = ibits(chunk,0,8)
D	type '(1X,Z4.4,3I6)',chunk,c,i,j
	goto (100,101,102,103,104), c+1
	goto 900
C
C		Control commands --- class 0.
C
  100	if (i.eq.0) then		! BEGIN_METAFILE
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'BEGIN_METAFILE',dummy
	    if (dummy.ne.1) then
		call lib$put_output('%GMFPLOT, "BEGIN_METAFILE" '//
     1		     'command does not request 15-bit precision')
		call exit(44)
	    end if
	    if (file_open) then
		call lib$put_output('%GMFPLOT, "BEGIN_METAFILE" '//
     1		     'command is misplaced')
		call exit(44)
	    end if
	    file_open = .true.
	    call scale(32767,32767)
	else if (i.eq.1) then		! END_METAFILE
	    if (debug) write (6,1000) chunk,'END_METAFILE'
	    file_open = .false.
	else if (i.eq.2) then		! DEFINE_NDC_SPACE
	    j = j-3
	    call getchunk(ix)
	    call getchunk(iy)
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'DEFINE_NDC_SPACE',
     1			ix,iy,dummy
	    call scale(ix,iy)
	else if (i.eq.4) then		! NO_OPERATION
	    continue
	else
	    goto 900
	end if
	goto 800
C
C		Metafile picture commands --- class 1.
C
  101	if (i.eq.0) then		! BEGIN_PICTURE
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'BEGIN_PICTURE',dummy
	    picture_number = dummy
	    picture_open = .true.
	    if (prompt.and.picture_number.gt.1) then
	        call lib$get_input(junk,bells,L)
	    end if
	    call grpage
	    xcp = 0.0
	    ycp = 0.0
	    marker = 1
	else if (i.eq.1) then		! END_PICTURE
	    if (debug) write (6,1000) chunk,'END_PICTURE'
	    picture_open = .false.
	    call grterm
	else
	    goto 900
	end if
	goto 800
C
C		Mode and marker commands --- class 2.
C
  102	if (i.eq.0) then		! SET_2D_MODE
	    if (debug) write (6,1000) chunk,'SET_2D_MODE'
	    continue
	else if (i.eq.1) then		! SET_3D_MODE
	    if (debug) write (6,1000) chunk,'SET_3D_MODE'
	    call lib$put_output(
     1		'%GMFPLOT, SET_3D_MODE command not allowed')
	    call exit(44)
	else if (i.eq.2) then		! SET_MARKER_SYMBOL
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'SET_MARKER_SYMBOL',dummy
	    marker = dummy
	else if (i.eq.3) then		! OUTPUT_SELECTED_MARKER
	    if (debug) write (6,1000) chunk,'OUTPUT_SELECTED_MARKER'
C!	    call grmarker(marker,.false.,1,xcp,ycp)
	    call grmker(marker,.false.,1,xcp,ycp)
	else if (i.eq.4) then		! OUTPUT_SPECIFIC_MARKER
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'OUTPUT_SPECIFIC_MARKER',dummy
            attrib = dummy
C!	    call grmarker(attrib,.false.,1,xcp,ycp)
	    call grmker(attrib,.false.,1,xcp,ycp)
	else if (i.eq.8) then		! SET_MARKER_SIZE
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'SET_MARKER_SIZE',dummy
            call grsetc(id,xscale*dummy)
	else if (i.eq.7) then		! DRAW_POLYGON
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'DRAW_POLYGON',dummy
	    if (dummy.gt.512) then
		call lib$put_output('%GMFPLOT, "DRAW_POLYGON" '//
     1		     'command has more than 512 vertices')
	    end if
	    k = min(dummy,512)
	    do i=1,k
	    	call getchunk(ix)
	    	call getchunk(iy)
	    	px(i) = ibclr(ix,15)
	    	py(i) = ibclr(iy,15)
	    end do
	    call grfa(k,px,py)
	else
	    goto 900
	end if
	goto 800
C
C		Text commands --- class 3.
C
  103	if (i.eq.1) then		! SET_CHARACTER_FONT
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'SET_CHARACTER_FONT',dummy
	    attrib = dummy
	    call grsfnt(attrib)	
	else
	    goto 900
	end if
	goto 800
C
C		Attribute commands --- class 4.
C
  104	if (i.eq.0) then		! DEFINE_COLOR_INDEX
	    j = j-4
	    call getchunk(ci)
	    call getchunk(cr)
	    call getchunk(cg)
	    call getchunk(cb)
	    if (debug) write (6,1000) chunk,
     1			'DEFINE_COLOR_INDEX',ci,cr,cg,cb
            attrib = ci
	    call grscr(attrib,cr/32767.,cg/32767.,cb/32767.)
	else if (i.eq.1) then		! SET_COLOR
	    j = j-1
	    call getchunk(dummy)
	    attrib = dummy
	    if (debug) write (6,1000) chunk,'SET_COLOR',dummy
C!	    call grsetcol(attrib)
	    call grsci(attrib)
	else if (i.eq.2) then		! SET_INTENSITY
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'SET_INTENSITY',dummy
	    attrib = dummy
	    call grsetli(attrib)
	else if (i.eq.3) then		! SET_LINESTYLE
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'SET_LINESTYLE',dummy
	    attrib = dummy
C!	    call grsetls(attrib)
	    call grsls(attrib)
	else if (i.eq.4) then		! SET_LINEWIDTH
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'SET_LINEWIDTH',dummy
	    attrib = dummy
C!	    call grsetlw(attrib)
	    call grslw(attrib)
	else if (i.eq.5) then		! SET_PEN
	    j = j-1
	    call getchunk(dummy)
	    if (debug) write (6,1000) chunk,'SET_PEN',dummy
	    attrib = dummy
	    call grsetpen(attrib)
	else
	    goto 900
	end if
	goto 800
C
C		Report illegal command.
C
  900	call grterm
	write (nerd,'(Z4.4)') chunk
	call lib$put_output('%GMFPLOT, unrecognized command '//nerd)
	goto 800
C
C		Skip any additional chunks which have not been
C		decoded while interpreting the command.
C
  800	do k=1,j
	    call getchunk(dummy)
	end do
	return
	end 

	subroutine getchunk(chunk)
	integer*2 chunk,buffer(360)
	integer i
	data i/360/
	if (i.eq.360) then
	    read(unit=1,end=10) buffer
	    i = 1
	else
	    i = i+1
	end if
	chunk = buffer(i)
	return
10	chunk = '8100'X	! END_METAFILE
	return
	end

	subroutine scale (ix,iy)
C-----------------------------------------------------------------------
C GMFPLOT: scale output device so that a rectangle with metafile
C coordinates (0...ix), (0...iy) is mapped onto the largest possible
C rectangle with the same aspect ratio on the output device.
C-----------------------------------------------------------------------
	implicit none
	integer*2 ix,iy
	integer id
	real xdef,ydef,xmax,ymax,xperin,yperin
	real xsize_inches,ysize_inches,s
	real xorg,yorg,xscale,yscale
	common /pltid/ id,xscale
C
C		Obtain output device parameters.
C
	call grsize(id,xdef,ydef,xmax,ymax,xperin,yperin)
C
C		Size of output view surface in inches.
C
	xsize_inches = xdef/xperin
	ysize_inches = ydef/yperin
C
C		's' is the scale in inches-per-metafile-unit
C		which produces the largest plot which fits on the
C		output view surface.
C
	s = min(xsize_inches/ix,ysize_inches/iy)
C
C		'xscale' and 'yscale' are the corresponding scales
C		in device-units-per-metafile-unit.
C
	xscale = s*xperin
	yscale = s*yperin
C
C		'xorg' and 'yorg' are offsets to center the
C		plot on the view surface. One of these will be zero.
C
	xorg = xperin*(xsize_inches - ix*s)/2.0
	yorg = yperin*(ysize_inches - iy*s)/2.0
C
C		Set the transform parameters.
C
	call grtran(id,xorg,yorg,xscale,yscale)
D	type *,'Max size:   ',xsize_inches,ysize_inches
D	type *,'Actual size:',ix*s,iy*s
D	TYPE *,xorg,yorg,xscale,yscale
	return
	end

C*PGBEGIN -- non-standard alias for PGBEG
C+
      INTEGER FUNCTION PGBEGIN (UNIT, FILE, NXSUB, NYSUB)
      INTEGER       UNIT
      CHARACTER*(*) FILE
      INTEGER       NXSUB, NYSUB
C
C See description of PGBEG.   
C--
      INTEGER       PGBEG
      PGBEGIN = PGBEG (UNIT, FILE, NXSUB, NYSUB)
      END

C*GRSLCT -- select active output device
C+
      SUBROUTINE GRSLCT (IDENT)
C
C GRPCKG: Check that IDENT is a valid plot identifier, and select the
C corresponding plot as the current plot. All subsequent plotting will
C be directed to this device until the assignment is changed by another
C call to GRSLCT.
C
C Argument:
C
C IDENT (input, integer): the identifier of the plot to be selected, as
C       returned by GROPEN.
C--
C (1-Feb-1983)
C  5-Aug-1986 - add GREXEC support [AFT].
C  4-Jun-1987 - skip action if no change in ID [TJP].
C 26-Nov-1990 - [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL     RBUF(6)
      INTEGER  IDENT, NBUF,LCHR
      CHARACTER CHR
C
      IF ((IDENT.LE.0) .OR. (IDENT.GT.GRIMAX) .OR.
     1     (GRSTAT(IDENT).EQ.0)) THEN
         CALL GRWARN('GRSLCT - invalid plot identifier.')
      ELSE IF (IDENT.EQ.GRCIDE) THEN
         GRGTYP = GRTYPE(IDENT)
         RETURN
      ELSE
         GRCIDE = IDENT
         GRGTYP = GRTYPE(IDENT)
         RBUF(1)= GRCIDE
         RBUF(2)= GRUNIT(GRCIDE)
         NBUF   = 2
         CALL GREXEC(GRGTYP, 8,RBUF,NBUF,CHR,LCHR)
      END IF
      END

C*GRTRML -- get name of user's terminal (UNIX)
C+
      SUBROUTINE GRTRML(STRING, L)
      CHARACTER*(*) STRING
      INTEGER L
C
C Return the device name of the user's terminal, if any. In Sun/Convex-UNIX,
C the name of the terminal is always /dev/tty.
C
C Arguments:
C  STRING : receives the terminal name, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in STRING, excluding
C           trailing blanks. If there is not attached terminal, 
C           zero is returned.
C--
C 19-Jan-1988
C-----------------------------------------------------------------------
      STRING = '/dev/tty'
      L = MIN(LEN(STRING),8)
      END

C*GRQFNT -- inquire current font
C+
      SUBROUTINE GRQFNT (IF)
C
C GRPCKG: obtain the font number of the current graphics device.
C
C Argument:
C
C IF (integer, output): receives the current font number (1-3).
C--
C (19-Mar-1983)
C 15-Dec-1988 - change name [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  IF
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRQFNT - no graphics device is active.')
          IF = 1
      ELSE
          IF = GRCFNT(GRCIDE)
      END IF
      END

C*GREXEC -- PGPLOT device handler dispatch routine
C 12/93 C. T. Dum: version for MS F32 Power Station
C  20-Apr-1996: "W9DRIV", use CASE structure [PAS]
C  10-Jul-1996: add GIF driver (already had PostScript, Null, LaTex) [PAS]
C+
      SUBROUTINE GREXEC(IDEV, IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IDEV, IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C---
      INTEGER NDEV
      PARAMETER (NDEV=13)
      CHARACTER*10 MSG
C---
      SELECT CASE (IDEV)
      CASE (0)
         RBUF(1) = NDEV
         NBUF = 1
         CHR = ' '
         LCHR = 0
      CASE (1)
         CALL W9DRIV(IFUNC,RBUF,NBUF,CHR,LCHR,0)
      CASE (2)
         CALL W9DRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1)
      CASE (3)
         CALL W9DRIV(IFUNC,RBUF,NBUF,CHR,LCHR,2)
      CASE (4)
         CALL W9DRIV(IFUNC,RBUF,NBUF,CHR,LCHR,3)
      CASE (5)
         CALL W9DRIV(IFUNC,RBUF,NBUF,CHR,LCHR,4)
      CASE (6)
         CALL NUDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      CASE (7)
         CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1)
      CASE (8)
         CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,2)
      CASE (9)
         CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,3)
      CASE (10)
         CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,4)
      CASE (11)
         CALL GIDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1)
      CASE (12)
         CALL GIDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,2)
      CASE (13)
         CALL LXDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      CASE DEFAULT
         WRITE (MSG,'(I10)') IDEV
         CALL GRQUIT('Unknown device code in GREXEC: '//MSG)
      END SELECT
      RETURN
      END

      INCLUDE 'FGRAPH.FI'
C*MSDRIV -- PGPLOT device driver for MS-DOS machines
C+
      SUBROUTINE MSDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      IMPLICIT NONE
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
      INCLUDE 'FGRAPH.FD'
C
C PGPLOT driver for IBM PC's and clones running Microsoft Fortran 5.0.
C This driver will put the display into graphics mode.  To avoid 'erasing'
C the screen when the program exits, the display will be left in graphics
C mode.  Therefore, you will need some other program to restore to the
C display to a (faster) text mode.
C
C This routine must be compiled and linked with the Microsoft graphics
C library supplied with Microsoft Fortran 5.0 or greater.
C
C LINK QDP,,NUL,\XANADU\PLOT\PGPLOT\PGPLOT+\FOR\LIB\GRAPHICS;
C
C where \XANADU\PLOT\PGPLOT\PGPLOT.LIB is the name of the PGPLOT library
C containing the PGPLOT code and \FOR\LIB\GRAPHICS.LIB is the graphics
C library supplied with Microsoft Fortran 5.0.
***********
C---  The call to the adapter type gives the HIGHEST resoltion, and
C---  within those the higest number of colors.
C---  The list is based on Fortran 5.1 manual advanced topics, table 13.5
C---  The selection for the Olivetti has not been tested.
C---
C---  It was noted that the calls to MICROSOFT FORTRAN V5.1 RGB colors were 
C---  were made as INTEGER*2. This gave too few colors for redefined palettes.
C---  The correct decleration is INTEGER*4.
***********
C
C 1989-Nov-03 - Started work [AFT]
C 1989-Apr-06 - Improved version [AFT]
C 1991-Mar-13 - Added cursor routine [JHT]
C 1994-Mar-30 - Improved the search for the optimum graphics card. [HJL]
C 1994-Jun-08 - Fixed bug in definition of RGB color variables. [HJL]
C 1994-Dec-03 - Added PC9801 NEC mode [YK]
C 1995-Jul-31 - concatnated YK and HJL versions [HJL]
C-----------------------------------------------------------------------
C
C Supported device: IBM PC's and compatibles
C
C Device type code: /MSOFT
C
C Default device name: None (the device name, if specified, is
C ignored).
C
C Default view surface dimensions: Depends on monitor, typical 7x10 inches
C
C Resolution: Depends on graphics card.  Tested with a 640x300 EGA card.
C    Driver should work with other graphics cards, however, expect to
C    tweak it a bit.
C
C Color capability: Color indices 0-15 are accepted.  This version maps
C    the PGPLOT color indices into the IBM color indices for with the
C    default color most closely corresponds to the PGPLOT default color.
C    Thus, PGPLOT index 2 (red) maps to IBM index 12 (light red).
C
C Input capability: None.
C
C File format: None.
C
C Obtaining hardcopy: Not possible.
C-----------------------------------------------------------------------
      RECORD /VIDEOCONFIG/ VID
      RECORD /XYCOORD/ XY
C
      CHARACTER CMSG*10
      INTEGER   LEVEL, MXX, MXY
      REAL A,B
      INTEGER*4 I2TAB(0:15)
      INTEGER*4 I2BLU, I2GRN, I2IND, I2PEND, I2RED
      INTEGER*4 I2STAT, I2TMP
      INTEGER*2 I2X0, I2Y0, I2X1, I2Y1
      LOGICAL   QFIRST
      SAVE      QFIRST, MXX, MXY
      DATA I2TAB/ 0,15,12,10, 9,11,13,14, 6, 2, 3, 1, 5, 4, 8, 7/
      DATA QFIRST/.TRUE./
C
C---
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260) IFUNC
  900 WRITE (CMSG, '(I10)') IFUNC
      CALL GRWARN('Unimplemented function in MSOFT device driver: '/
     :      /CMSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CHR = 'MSOFT'
      LCHR = 5
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 CONTINUE
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      RBUF(1) = 0
      RBUF(2) = FLOAT(MXX)
      RBUF(3) = 0
      RBUF(4) = FLOAT(MXY)
      RBUF(5) = 0
      RBUF(6) = 15
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C Divide the number of pixels on screen by a typical screen size in
C inches.
C
   30 continue
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      A = FLOAT(MXX)/10.0
      RBUF(1) = A
      B = FLOAT(MXY)/7.0
      RBUF(2) = B
      RBUF(3) = 1.0
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Interactive, cursor, No dashed lines, No area fill,
C    No thick lines, No rectangle fill)
C
   40 CHR = 'ICNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CHR = ' '
      LCHR = 1
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 CONTINUE
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      RBUF(1) = 0
      RBUF(2) = FLOAT(MXX)
      RBUF(3) = 0
      RBUF(4) = FLOAT(MXY)
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 1
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      RBUF(1) = 0
      RBUF(2) = 1
      NBUF = 2
      IF(RBUF(3).NE.0.) THEN
         I2PEND=1
      ELSE
         I2PEND=0
      END IF
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
C      I2STAT = SETVIDEOMODE( $DEFAULTMODE )
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      IF(I2PEND.EQ.0) THEN
         CALL CLEARSCREEN($GCLEARSCREEN)
      END IF
      I2PEND=0
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      I2X0=NINT(RBUF(1))
      I2Y0=MXY-NINT(RBUF(2))
      CALL MOVETO(I2X0, I2Y0, XY)
      I2X1=NINT(RBUF(3))
      I2Y1=MXY-NINT(RBUF(4))
      I2STAT=LINETO(I2X1, I2Y1)
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      I2X0=NINT(RBUF(1))
      I2Y0=MXY-NINT(RBUF(2))
      I2STAT=SETPIXEL(I2X0, I2Y0)
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
  150 CONTINUE
      I2TMP=MIN( MAX(0,NINT(RBUF(1))) ,15)
      I2IND=I2TAB(I2TMP)
      I2STAT=SETCOLOR(I2IND)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C
C
  170 CONTINUE
      I2X0 = NINT(RBUF(1))
      I2Y0 = MXY-NINT(RBUF(2))
      CALL GRMS01( I2X0, I2Y0, CHR, VID)
      RBUF(1) = FLOAT(I2X0)
      RBUF(2) = FLOAT(MXY-I2Y0)
      NBUF = 2
      LCHR = 1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C
  190 CONTINUE
      RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      I2TMP=MIN( MAX(0,NINT(RBUF(1))), 15)
      I2IND=I2TAB(I2TMP)
      IF(VID.NUMCOLORS.EQ.16) THEN
C EGA 16 color mode
         I2RED=INT(RBUF(2)*3.999)
         I2GRN=INT(RBUF(3)*3.999)
         I2BLU=INT(RBUF(4)*3.999)
         LEVEL=(#303030.AND.(ISHFT(I2BLU,20).OR.ISHFT(I2GRN,12).OR.
     :      ISHFT(I2RED,4)))
         I2STAT=REMAPPALETTE(I2IND,LEVEL)
      ELSE IF(VID.NUMCOLORS.EQ.256) THEN
C VGA 256 color mode
         I2RED=INT(RBUF(2)*63.999)
         I2GRN=INT(RBUF(3)*63.999)
         I2BLU=INT(RBUF(4)*63.999)
         LEVEL=(#3F3F3F.AND.(ISHFT(I2BLU,16).OR.ISHFT(I2GRN,8).OR.
     :      I2RED))
         I2STAT=REMAPPALETTE(I2IND,LEVEL)
      END IF
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C
  220 CONTINUE
      RETURN
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle fill. -----------------------------------------
C
  240 CONTINUE
      RETURN
C
C--- IFUNC=25, Set fill pattern. ---------------------------------------
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels. -----------------------------------------
C
  260 CONTINUE
      RETURN
C-----------------------------------------------------------------------
      END
C*********
      SUBROUTINE GRMS00(VID, MXX, MXY, QFIRST)
      INCLUDE 'FGRAPH.FD'
      RECORD /VIDEOCONFIG/ VID
      INTEGER   MXX, MXY ,TR$L
      LOGICAL   QFIRST
C---
      INTEGER*2 I2STAT
C added parameter override of default configuration... JHT 23-Feb-1991
C
C changed defaults to select the more sensible option maximum resolution.
C left in the over ride for compatibility with previous version.
C Option can be overridden by setting an enviroment variable PG_VIDEO
C to MAXCOL. Other options are MAXRES,VGA16,VGA2, EGA15, EGA4 etc.
C                                                      HJL 30-Mar-1994
      character*128 TR$VID
C---
      QFIRST=.FALSE.
      CALL GRGENV('VIDEO', TR$VID, TR$L)
      IF (TR$L.EQ.0. OR. 
     +   (TR$L.NE.0. AND. TR$VID(:TR$L).EQ.'MAXRES')) THEN
         CALL GETVIDEOCONFIG(VID)
         IF(VID.ADAPTER.EQ.$VGA .OR. VID.ADAPTER.EQ.$OVGA)THEN
            I2STAT=SETVIDEOMODE($VRES16COLOR)
         ELSE IF(VID.ADAPTER.EQ.$MCGA) THEN
            I2STAT=SETVIDEOMODE($VRES2COLOR)
         ELSE IF(VID.ADAPTER.EQ.$EGA) THEN
            IF(VID.MONITOR .EQ. $MONO) THEN
               I2STAT=SETVIDEOMODE($ERESNOCOLOR)
            ELSE
               I2STAT=SETVIDEOMODE($ERESCOLOR)
            END IF
         ELSE IF(VID.ADAPTER.EQ.$OEGA) THEN
            I2STAT=SETVIDEOMODE($ORESCOLOR)
         ELSE IF(VID.ADAPTER.EQ.$CGA) THEN
            I2STAT=SETVIDEOMODE($HRESBW)
         ELSE IF(VID.ADAPTER.EQ.$OCGA) THEN
            I2STAT=SETVIDEOMODE($ORESCOLOR)
         ELSE IF(VID.ADAPTER.EQ.$HGC) THEN
            I2STAT=SETVIDEOMODE($HERCMONO)
         ELSE IF(VID.ADAPTER.EQ.$98CGA .or. VID.ADAPTER.EQ.$98EGA) THEN
            I2STAT=SETVIDEOMODE($MAXRESMODE)
            two lines above are added for PC9801 NEC compatibles
         ELSE
            WRITE(*,*) 'Unknown graphics adapter.'
            STOP
         END IF
      ELSE
         IF(TR$VID(:TR$L) .EQ. 'EGA16') THEN
            I2STAT=SETVIDEOMODE($ERESCOLOR)
         ELSE IF(TR$VID(:TR$L) .EQ. 'VGA16') THEN
            I2STAT=SETVIDEOMODE($VRES16COLOR)
         ELSE 
         CALL GETVIDEOCONFIG(VID)
           IF(VID.ADAPTER.EQ.$VGA .OR. VID.ADAPTER.EQ.$OVGA. OR.
     +        VID.ADAPTER.EQ.$MCGA) THEN
              I2STAT=SETVIDEOMODE($MRES256COLOR)
           ELSE IF(VID.ADAPTER.EQ.$EGA) THEN
              IF(VID.MONITOR .EQ. $MONO) THEN
                 I2STAT=SETVIDEOMODE($ERESNOCOLOR)
              ELSE
                 IF(VID.NUMCOLORS.EQ.256) THEN
                     I2STAT=SETVIDEOMODE($ERESCOLOR)
                 ELSE
                     I2STAT=SETVIDEOMODE($HRES16COLOR)
                 END IF
              END IF
           ELSE IF(VID.ADAPTER.EQ.$OEGA) THEN
              I2STAT=SETVIDEOMODE($ERESCOLOR)
           ELSE IF(VID.ADAPTER.EQ.$CGA) THEN
              IF(VID.MONITOR.EQ.$MONO) THEN
                 I2STAT=SETVIDEOMODE($MRESNOCOLOR)
              ELSE
                 I2STAT=SETVIDEOMODE($MRES4COLOR)
              END IF
           ELSE IF(VID.ADAPTER.EQ.$OCGA) THEN
              I2STAT=SETVIDEOMODE($MRES4COLOR)
           ELSE IF(VID.ADAPTER.EQ.$HGC) THEN
              I2STAT=SETVIDEOMODE($HERCMONO)
           ELSE IF(VID.ADAPTER.EQ.$98CGA .or. VID.ADAPTER.EQ.$98EGA) THEN
              I2STAT=SETVIDEOMODE($MAXRESMODE)
c            two lines above are added for PC9801 NEC compatibles
           ELSE
              WRITE(*,*) 'Unknown graphics adapter.'
           STOP
           END IF
         END IF
      END IF
      CALL GETVIDEOCONFIG(VID)
      MXX=VID.NUMXPIXELS-1
      MXY=VID.NUMYPIXELS-1
      RETURN
      END
C*********
      SUBROUTINE GRMS01( IX, IY, CHR, VID)
      INCLUDE 'FGRAPH.FD'
      RECORD /xycoord/ XY
      RECORD /VIDEOCONFIG/ VID
      INTEGER*4 IMSIZE,INC,CNT(2),IHR,IMIN,ISEC,ITICK
      INTEGER*2 IX, IY, X0, Y0, X1, Y1, IERR, DUMMY
      INTEGER*2 ACTION
      INTEGER*1 SCAN
      INTEGER*1 BUFFER[ALLOCATABLE] (:)
      CHARACTER*(*) CHR
      INTEGER*1 ICHR
      DATA ACTION/ $GPSET /
C OVERKILL ON IMAGESIZE IN CASE THERE ARE BYTE ALLIGNMENT ISSUES
      IMSIZE = IMAGESIZE( 0,0,25,25 )
C
C COUNTER AND INCREMENT TO ADD CURSOR ACCELLERATION
      CNT(1) = 0
      INC = 1
      ALLOCATE( BUFFER( IMSIZE ), STAT = IERR )
      IF( IERR .NE. 0 ) THEN
           DUMMY = SETVIDEOMODE( $DEFAULTMODE )
           STOP 'Error: insufficient memory'
      ENDIF
      ICHR = 0
      DO WHILE(ICHR .EQ. 0)
         IX = MAX0( IX, 0)
         IY = MAX0( IY, 0)
         IX = MIN0( IX, (VID.NUMXPIXELS - 1))
C
         IY = MIN0( IY, (VID.NUMYPIXELS - 1))
C
         X0 = MAX0( (IX - 10), 0 )
         Y0 = MAX0( (IY - 10), 0 )
         X1 = MIN0( (IX + 10), (VID.NUMXPIXELS - 1))
         Y1 = MIN0( (IY + 10), (VID.NUMYPIXELS - 1))
C SAVE IMAGE BELOW WHERE CURSOR WILL BE
         CALL GETIMAGE( X0, Y0, X1, Y1, BUFFER )
C NOW DRAW CURSOR
         CALL MOVETO( X0, IY, XY)
         DUMMY = LINETO( X1, IY)
         CALL MOVETO( IX, Y0, XY)
         DUMMY = LINETO( IX, Y1)
         CALL GETCH(ICHR,SCAN)
C RESTORE IMAGE
         CALL PUTIMAGE( X0, Y0, BUFFER, ACTION )
C CALCULATE TIME PAST AND ACCELERATE IF NECESSARY
         CALL GETTIM(IHR,IMIN,ISEC,ITICK)
         CNT(2) = ITICK + 100*ISEC + 6000*IMIN
         IF ((CNT(2)-CNT(1)) .LT. 25) THEN
         INC = MIN0((INC + 1),30)
         CNT(1) = CNT(2)
         ELSE
         INC = 1
         CNT(1) = CNT(2)
         ENDIF
         IF(SCAN .EQ. #48) THEN
         IY = IY - INC
         ELSE IF (SCAN .EQ. #50) THEN
         IY = IY + INC
         ELSE IF(SCAN .EQ. #4D) THEN
         IX = IX + INC
         ELSE IF(SCAN .EQ. #4B) THEN
         IX = IX - INC
         ENDIF
      ENDDO
      DEALLOCATE( BUFFER )
      CHR = ICHR
      RETURN
      END
C---
C   These functions are discussed in Chapter 3 of the Advanced Topics
C       manual. The program DEMOEXEC.FOR illustrates how to use the include
C       file and the functions.
C   Function:   INTDOS
C
C   Purpose:   calls dos interrupt
C
C   Argument:   STRUCTURE - REGISTERS
C         STRUCTURE - RETURNED REGISTERS
C
C   Return:    INTEGER*2 - ax REGISTER
C
C   Example:   dummy2 = INTDOS(INREG,OUTREG)
C
C
      INTERFACE TO FUNCTION INTDOS [C] (INREG,OUTREG)
      INTEGER*2 INTDOS
      STRUCTURE/REGS/
      INTEGER*2 AX
      INTEGER*2 BX
      INTEGER*2 CX
      INTEGER*2 DX
      INTEGER*2 SI
      INTEGER*2 DI
      INTEGER*2 CFLAG
      END STRUCTURE
      RECORD/REGS/INREG [REFERENCE]
      RECORD/REGS/OUTREG [REFERENCE]
      END
CC       DEMOEXEC.FOR - Demonstration program for calling C system and
CC       spawnp library functions. These functions are included in the
CC       FORTRAN library. They are discussed in Chapter 3 of the Advanced
CC       Topics manual.
CC
CC       To compile and link DEMOEXEC.FOR type the command:
CC
CC      FL DEMOEXEC.FOR
      SUBROUTINE GETCH(CHR,SCAN)
      INTEGER*1 CHR,SCAN
C
C
C       Declare return types
C
      INTEGER*2 INTDOS
      STRUCTURE/REGS/
         INTEGER*1 AL, AH
         INTEGER*1 BL, BH
         INTEGER*1 CL, CH
         INTEGER*1 DL, DH
         INTEGER*1 SIL, SIH
         INTEGER*1 DIL, DIH
         INTEGER*1 CFL,CFH
      END STRUCTURE
      RECORD/REGS/INREGS
      RECORD/REGS/OUTREGS
C
      CHR= 0
      SCAN = 0
      INREGS.AH=#08
      INREGS.AL=0
      I = INTDOS( INREGS , OUTREGS )
      CHR = OUTREGS.AL
      IF(CHR .EQ. 0) THEN
         I = INTDOS( INREGS , OUTREGS )
         SCAN = OUTREGS.AL
      ENDIF
C   write(*,'(1x,z2)') OUTREGS.AL
      END

      PROGRAM PGDEM9
C-----------------------------------------------------------------------
C Test program for PGPLOT: test of imaging routine PGPIXL.
C-----------------------------------------------------------------------
      INTEGER PGBEG
      INTEGER N, NCOL, NLEV
      PARAMETER (N=64, NCOL=32, NLEV=9)
      INTEGER I,J,CI1,CI2
      REAL F(N,N),FMIN,FMAX,R,G,B,CLEV(NLEV),TR(6)
      INTEGER IA(N,N)
C
C Compute a suitable function.
C
      FMIN = F(1,1)
      FMAX = F(1,1)
      DO 20 I=1,N
          DO 10 J=1,N
              F(I,J) = COS(0.6*SQRT(I*2.)-0.4*J/3.)*COS(0.4*I/3)+
     1                     (I-J)/REAL(N)
              FMIN = MIN(F(I,J),FMIN)
              FMAX = MAX(F(I,J),FMAX)
   10     CONTINUE
   20 CONTINUE
      DO 25 I=1,N
          DO 24 J=1,N
              IA(I,J) = (F(I,J)-FMIN)/(FMAX-FMIN)*(NCOL-1)+16
   24     CONTINUE
   25 CONTINUE
C
C Open plot device and set up coordinate system. We will plot the
C image within a unit square.
C
      IF (PGBEG(0,'?',1,1) .NE. 1) STOP
      CALL PGQCOL(CI1, CI2)
      IF (CI2.LT. 15+NCOL) THEN
          WRITE (*,*) 'This program requires a device with at least',
     1                15+NCOL,' colors'
          STOP
      END IF
      CALL PGPAGE
      CALL PGSCR(0, 0.0, 0.3, 0.2)
      CALL PGSVP(0.05,0.95,0.05,0.95)
      CALL PGWNAD(0.0, 1.0, 0.0, 1.0)
C
C Set up a color palette using NCOL indices from 16 to 15+NCOL.
C
      DO 30 I=1,NCOL
          R = REAL(I-1)/REAL(NCOL-1)*0.8 + 0.2
          G = MAX(0.0, 2.0*REAL(I-1-NCOL/2)/REAL(NCOL-1))
          B = 0.2 + 0.4*REAL(NCOL-I)/REAL(NCOL)
          CALL PGSCR(I+15, R, G, B)
   30 CONTINUE
C
C Use PGPIXL to plot the image.
C
      CALL PGPIXL(IA,N,N, 1, N, 1, N, 0.0, 1.0, 0.0, 1.0)
C
C Annotation.
C
      CALL PGSCI(1)
      CALL PGMTXT('t',1.0,0.0,0.0,'Test of PGPIXL')
      CALL PGBOX('bcnts',0.0,0,'bcnts',0.0,0)
C
C Overlay a contour map.
C
      TR(1) = -1.0/REAL(N-1)
      TR(2) = 1.0/REAL(N-1)
      TR(3) = 0.0
      TR(4) = -1.0/REAL(N-1)
      TR(5) = 0.0
      TR(6) = 1.0/REAL(N-1)
      DO 40 I=1,NLEV
          CLEV(I) = FMIN + (FMAX-FMIN)*REAL(I)/REAL(NLEV)
   40 CONTINUE
      CALL PGCONT(F, N, N, 1, N, 1, N, CLEV, NLEV, TR)
C
C Done.
C
      CALL PGEND
      END

C*PGARRO -- draw an arrow
C%void cpgarro(float x1, float y1, float x2, float y2);
C+
      SUBROUTINE PGARRO (X1, Y1, X2, Y2)
      REAL X1, Y1, X2, Y2
C
C Draw an arrow from the point with world-coordinates (X1,Y1) to 
C (X2,Y2). The size of the arrowhead at (X2,Y2) is determined by 
C the current character size set by routine PGSCH. The default size 
C is 1/40th of the smaller of the width or height of the view surface.
C The appearance of the arrowhead (shape and solid or open) is
C controlled by routine PGSAH.
C
C Arguments:
C  X1, Y1 (input)  : world coordinates of the tail of the arrow.
C  X2, Y2 (input)  : world coordinates of the head of the arrow.
C--
C  7-Feb-92 Keith Horne @ STScI / TJP.
C 13-Oct-92 - use arrowhead attributes; scale (TJP).
C-----------------------------------------------------------------------
      INTEGER AHFS, FS
      REAL DX, DY, XV1, XV2, YV1, YV2, XL, XR, YB, YT, DINDX, DINDY
      REAL XINCH, YINCH, RINCH, CA, SA, SO, CO, YP, XP, YM, XM, DHX, DHY
      REAL PX(4), PY(4)
      REAL AHANGL, AHVENT, SEMANG, CH, DH, XS1, XS2, YS1, YS2
C
      CALL PGBBUF
      CALL PGQAH(AHFS, AHANGL, AHVENT)
      CALL PGQFS(FS)
      CALL PGSFS(AHFS)
      DX = X2 - X1
      DY = Y2 - Y1
      CALL PGQCH(CH)
      CALL PGQVSZ(1, XS1, XS2, YS1, YS2)
C     -- length of arrowhead: 1 40th of the smaller of the height or
C        width of the view surface, scaled by character height.
      DH = CH*MIN(ABS(XS2-XS1),ABS(YS2-YS1))/40.0
      CALL PGMOVE(X2, Y2)
C     -- Is there to be an arrowhead ?
      IF (DH.GT.0.) THEN
          IF (DX.NE.0. .OR. DY.NE.0.) THEN
C             -- Get x and y scales
              CALL PGQVP(1, XV1, XV2, YV1, YV2)
              CALL PGQWIN(XL, XR, YB, YT)
              IF (XR.NE.XL .AND. YT.NE.YB) THEN
                  DINDX = (XV2 - XV1) / (XR - XL)
                  DINDY = (YV2 - YV1) / (YT - YB)
                  DHX = DH / DINDX
                  DHY = DH / DINDY
C                 -- Unit vector in direction of the arrow
                  XINCH = DX * DINDX
                  YINCH = DY * DINDY
                  RINCH = SQRT(XINCH*XINCH + YINCH*YINCH)
                  CA = XINCH / RINCH
                  SA = YINCH / RINCH
C                 -- Semiangle in radians
                  SEMANG = AHANGL/2.0/57.296
                  SO = SIN(SEMANG)
                  CO = -COS(SEMANG)
C                 -- Vector back along one edge of the arrow
                  XP = DHX * (CA*CO - SA*SO)
                  YP = DHY * (SA*CO + CA*SO)
C                 -- Vector back along other edge of the arrow
                  XM = DHX * (CA*CO + SA*SO)
                  YM = DHY * (SA*CO - CA*SO)
C                 -- Draw the arrowhead
                  PX(1) = X2
                  PY(1) = Y2
                  PX(2) = X2 + XP
                  PY(2) = Y2 + YP
                  PX(3) = X2 + 0.5*(XP+XM)*(1.0-AHVENT)
                  PY(3) = Y2 + 0.5*(YP+YM)*(1.0-AHVENT)
                  PX(4) = X2 + XM
                  PY(4) = Y2 + YM
                  CALL PGPOLY(4, PX, PY)
                  CALL PGMOVE(PX(3), PY(3))
              END IF
          END IF
      END IF
      CALL PGDRAW(X1, Y1)
      CALL PGMOVE(X2,Y2)
      CALL PGSFS(FS)
      CALL PGEBUF
      RETURN
      END

      SUBROUTINE GLDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      INTEGER IFUNC, NBUF, LCHR, MODE
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C-----------------------------------------------------------------------
C PGPLOT driver for Hewlett Packard HPGL plotter(s).
C-----------------------------------------------------------------------
C Version 1.0  - 1988 Mar 14 - B. H. Toby
C                9/88 bull: added page eject to IFUNC 14
C Version 2.0  - 1994 Mar 16 - T. J. Pearson (dual mode, standard F77)
C Version 2.1  - 1994 Nov  6 - TJP: use PGPLOT_GL_TERMINAL.
C Version 3.0  - 1997 Jun 11 - TJP: add SC to specify page size.
C Version 3.1  - 1998 Oct 23 - TJP: correct failure to close file.
C Version 3.2  - 1998 Nov 9  - TJP: allow up to 8 pens.
C-----------------------------------------------------------------------
C     This routine has been written specifically for the HP7475A
C     Plotter, but should support most HPGL devices, perhaps with
C     minor modifications.
C
C     Color:
C       Color Index 1-8 are mapped to requests for pens 1-8, so
C        the actual color depends on what pen is installed. 
C       Color representation requests (PGSCR) are ignored.
C
C     If environment variable PGPLOT_GL_TERMINAL has value YES (or any
C     string beginning with Y or y), it is assumed that the
C     output device is a plotter connected BEFORE the terminal using
C     the Y-cable (HP part #17455A), in which case the plotter is
C     ``turned on'' using a "<ESC>.(" and xon/xoff handshaking is
C     enabled using "<ESC>.I81;;17:" and "<ESC>.N;19:". 
C     Otherwise, it is the user's responsibility to
C     add control codes, if needed.
C
C     If there is more than one plot and the plot is on a terminal,
C     a prompt will be generated, allowing the page to be advanced.
C
C     ref. HP 7475A Interfacing and Programming Manual P/N 7475-90001
C-----------------------------------------------------------------------
      CHARACTER*(*) LTYPE, PTYPE, DEFNAM
      PARAMETER (LTYPE=
     :  'HPGL  (Hewlett Packard HPGL plotter, landscape orientation)')
      PARAMETER (PTYPE=
     :  'VHPGL (Hewlett Packard HPGL plotter, portrait orientation)')
      PARAMETER (DEFNAM='pgplot.hpgl')
      CHARACTER*80 MSG
      CHARACTER*80 INSTR
      INTEGER LASTI, LASTJ, UNIT, IC, IER
      INTEGER I0, J0, I1, J1, L
      INTEGER I, PLOTNO
      LOGICAL ITERM
      INTEGER GRGCOM, GROPTX
      SAVE
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
      GOTO 900
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
10    IF (MODE.EQ.1) THEN
C         -- landscape (mode=1)
          CHR = LTYPE
          LCHR = LEN(LTYPE)
      ELSE
C         -- portrait (mode=2)
          CHR = PTYPE
          LCHR = LEN(PTYPE)
      END IF
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
20    RBUF(1) = 0
      RBUF(3) = 0
      RBUF(5) = 1
      RBUF(6) = 8
      NBUF = 6
      IF (MODE.EQ.1) THEN
C        -- landscape (mode=1)
          RBUF(2) = 16640
          RBUF(4) = 11040
      ELSE
C         -- portrait (mode=2)
          RBUF(2) = 11040
          RBUF(4) = 16640
      END IF
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
30    RBUF(1) = 1016.0
      RBUF(2) = 1016.0
      RBUF(3) = 20
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    No thick lines)
C
40    CHR = 'HNNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
50    CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
60    RBUF(1) = 0
      RBUF(3) = 0
      NBUF = 4
      IF (MODE.EQ.1) THEN
C         -- landscape (mode=1)
          RBUF(2) = 10365
          RBUF(4) =  7962
      ELSE
C         -- portrait (mode=2)
          RBUF(2) =  7962
          RBUF(4) = 10365
      END IF
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
70    RBUF(1) = 10
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
80    CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
90    CONTINUE
C Try to open the graphics device
      CALL GRGLUN(UNIT)
      IER = GROPTX(UNIT, CHR(1:LCHR), DEFNAM, 1)
      IF (IER.NE.0) THEN
        MSG='Cannot open graphics device '//CHR(1:LCHR)
        CALL GRWARN(MSG)
        RBUF(2) = 0
        RETURN
      END IF
C is the output device a terminal?
      CALL GRGENV('GL_TERMINAL', INSTR, L)
      ITERM = (INSTR(1:1).EQ.'Y' .OR. INSTR(1:1).EQ.'y')
      RBUF(1) = UNIT
      RBUF(2) = 1
      NBUF = 2
      LASTI = -1
      LASTJ = -1
      IF (ITERM) THEN
C this turns on the plotter
        WRITE (UNIT, '(A)') CHAR(27)//'.('
C this sets up Xon/Xoff protocol
        WRITE (UNIT, '(A)') CHAR(27)//'.I81;;17:'
        WRITE (UNIT, '(A)') CHAR(27)//'.N;19:'
      ENDIF
      IF (MODE.EQ.1) THEN
C         -- landscape (mode=1)
          WRITE (UNIT, '(A)') 'IN;'
      ELSE
C         -- portrait (mode=2)
          WRITE (UNIT, '(A)') 'IN;RO90;IP;IW;'
      END IF
      PLOTNO = 1
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
      WRITE (UNIT, '(A)') 'SP;'
      IF (ITERM) THEN
C this turns off the plotter
         WRITE (UNIT, '(A)') CHAR(27)//'.)'
      ENDIF
      CLOSE (UNIT)
      CALL GRFLUN(UNIT)
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
C if the plot is interactive, and we are starting a second or third (...)
C picture, allow a chance to change the paper.
      IF (ITERM .AND. PLOTNO .GT. 1) THEN
C turn off the plotter
        WRITE (UNIT, '(A)') CHAR(27)//'.)'
C send a prompt
        IER = GRGCOM(MSG, CHAR(7)//
     1            'Reload paper, then press <RETURN>: ', I)
C turn on the plotter
        WRITE (UNIT, '(A)') CHAR(27)//'.('
      ENDIF
      CALL GRFAO('SC0,#,0,#;SP1;', L, INSTR,
     :   NINT(RBUF(1)), NINT(RBUF(2)), 0, 0)
      WRITE (UNIT, '(A)') INSTR(:L)
      PLOTNO = PLOTNO + 1
      WRITE (UNIT, '(A)') 'PA;'
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
      IF ( (I0.NE.LASTI) .OR. (J0.NE.LASTJ) ) THEN
C -- move with pen up
C     -- Encode the coordinates into the command string
      CALL GRFAO('PU#,#;', L, INSTR, I0, J0, 0, 0)
C     -- Write the command string to the plot file
      WRITE (UNIT, '(A)') INSTR(:L)
      ENDIF
C -- move with pen down
C     -- Encode the coordinates into the command string
      CALL GRFAO('PD#,#;', L, INSTR, I1, J1, 0, 0)
C     -- Write the command string to the plot file
      WRITE (UNIT, '(A)') INSTR(:L)
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      IF ((I0.NE.LASTI) .OR. (J0.NE.LASTJ)) THEN
C -- move with pen up
C     -- Encode the coordinates into the command string
        CALL GRFAO('PU#,#;PD;', L, INSTR, I0, J0, 0, 0)
C     -- Write the command string to the plot file
        WRITE (UNIT, '(A)') INSTR(:L)
      ELSE
C -- no need to move, just lower the pen
        WRITE (UNIT, '(A)') 'PD;'
      ENDIF
      LASTI = I0
      LASTJ = J0
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
C  move the pen off the page
      WRITE (UNIT, '(A)') 'PU32000,32000;PG;'
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C
  150 CONTINUE
      IC = NINT(RBUF(1))
      IF (IC.LT.1) IC = 1
      WRITE (UNIT,'(A,I2,A)') 'SP',IC,';'
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Null operation: buffering is not implemented.)
C
160   CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called.)
C
170   GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Null operation: there is no alpha screen.)
C
180   CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called.)
C
190   GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called.)
C
200   GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C    IGnored.
C
210   CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called.)
C
220   GOTO 900
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
230   CONTINUE
      WRITE (UNIT, '(A)') CHR(:LCHR)
      LASTI = -1
      RETURN
C-----------------------------------------------------------------------
C Error: unimplemented function.
C
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in HPGL device driver: '//MSG)
      NBUF = -1
      RETURN
C-----------------------------------------------------------------------
      END

C*GRXRGB -- convert HLS color to RGB color
C+
      SUBROUTINE GRXRGB (H,L,S,R,G,B)
C
C GRPCKG: Convert a color specified in the HLS color model to one in
C the RGB model.  This is a support routine: no graphics I/O occurs.
C The inverse transformation is accomplished with routine GRXHLS.
C Reference: SIGGRAPH Status Report of the Graphic Standards Planning
C Committee, Computer Graphics, Vol.13, No.3, Association for
C Computing Machinery, New York, NY, 1979.
C
C Arguments:
C
C H,L,S (real, input): hue (0 to 360), lightness (0 to 1.0), and
C       saturation (0 to 1.0).
C R,G,B (real, output): red, green, blue color coordinates, each in the
C       range 0.0 to 1.0.
C--
C  2-Jul-1984 - new routine [TJP].
C 29-Sep-1994 - take H module 360 [TJP].
C 26-Nov-1996 - force results to be in range (avoid rounding error
C               problems on some machines) [TJP].
C-----------------------------------------------------------------------
      REAL     H,L,S, R,G,B, MA, MI, HM
C
      HM = MOD(H, 360.0)
      IF (HM.LT.0.0) HM = HM+360.0
      IF (L.LE.0.5) THEN
          MA = L*(1.0+S)
      ELSE
          MA = L + S - L*S
      END IF
      MI = 2.0*L-MA
C
C R component
C
      IF (HM.LT.60.0) THEN
          R = MI + (MA-MI)*HM/60.0
      ELSE IF (HM.LT.180.0) THEN
          R = MA
      ELSE IF (HM.LT.240.0) THEN
          R = MI + (MA-MI)*(240.0-HM)/60.0
      ELSE
          R = MI
      END IF
C
C G component
C
      IF (HM.LT.120.0) THEN
          G = MI
      ELSE IF (HM.LT.180.0) THEN
          G = MI + (MA-MI)*(HM-120.0)/60.0
      ELSE IF (HM.LT.300.0) THEN
          G = MA
      ELSE
          G = MI + (MA-MI)*(360.0-HM)/60.0
      END IF
C
C B component
C
      IF (HM.LT.60.0 .OR. HM.GE.300.0) THEN
          B = MA
      ELSE IF (HM.LT.120.0) THEN
          B = MI + (MA-MI)*(120.0-HM)/60.0
      ELSE IF (HM.LT.240.0) THEN
          B = MI
      ELSE
          B = MI + (MA-MI)*(HM-240.0)/60.0
      END IF
C
      R = MIN(1.0, MAX(0.0,R))
      G = MIN(1.0, MAX(0.0,G))
      B = MIN(1.0, MAX(0.0,B))
C
      END

C*PGCTAB -- install the color table to be used by PGIMAG
C%void cpgctab(const float *l, const float *r, const float *g, \
C% const float *b, int nc, float contra, float bright);
C+
      SUBROUTINE PGCTAB(L, R, G, B, NC, CONTRA, BRIGHT)
      INTEGER NC
      REAL    L(NC), R(NC), G(NC), B(NC), CONTRA, BRIGHT
C
C Use the given color table to change the color representations of
C all color indexes marked for use by PGIMAG. To change which
C color indexes are thus marked, call PGSCIR before calling PGCTAB
C or PGIMAG. On devices that can change the color representations
C of previously plotted graphics, PGCTAB will also change the colors
C of existing graphics that were plotted with the marked color
C indexes. This feature can then be combined with PGBAND to
C interactively manipulate the displayed colors of data previously
C plotted with PGIMAG.
C
C Limitations:
C  1. Some devices do not propagate color representation changes
C     to previously drawn graphics.
C  2. Some devices ignore requests to change color representations.
C  3. The appearance of specific color representations on grey-scale
C     devices is device-dependent.
C
C Notes:
C  To reverse the sense of a color table, change the chosen contrast
C  and brightness to -CONTRA and 1-BRIGHT.
C
C  In the following, the term 'color table' refers to the input
C  L,R,G,B arrays, whereas 'color ramp' refers to the resulting
C  ramp of colors that would be seen with PGWEDG.
C
C Arguments:
C  L      (input)  : An array of NC normalized ramp-intensity levels
C                    corresponding to the RGB primary color intensities
C                    in R(),G(),B(). Colors on the ramp are linearly
C                    interpolated from neighbouring levels.
C                    Levels must be sorted in increasing order.
C                     0.0 places a color at the beginning of the ramp.
C                     1.0 places a color at the end of the ramp.
C                    Colors outside these limits are legal, but will
C                    not be visible if CONTRA=1.0 and BRIGHT=0.5.
C  R      (input)  : An array of NC normalized red intensities.
C  G      (input)  : An array of NC normalized green intensities.
C  B      (input)  : An array of NC normalized blue intensities.
C  NC     (input)  : The number of color table entries.
C  CONTRA (input)  : The contrast of the color ramp (normally 1.0).
C                    Negative values reverse the direction of the ramp.
C  BRIGHT (input)  : The brightness of the color ramp. This is normally
C                    0.5, but can sensibly hold any value between 0.0
C                    and 1.0. Values at or beyond the latter two
C                    extremes, saturate the color ramp with the colors
C                    of the respective end of the color table.
C--
C  17-Sep-1994 - New routine [MCS].
C  14-Apr-1997 - Modified to implement a more conventional
C                interpretation of contrast and brightness [MCS].
C-----------------------------------------------------------------------
      INTEGER MININD, MAXIND, CI
      INTEGER NTOTAL, NSPAN
      INTEGER BELOW, ABOVE
      LOGICAL FORWRD
      REAL CA, CB, CIFRAC, SPAN
      REAL LEVEL
      REAL LDIFF, LFRAC
      REAL RED, GREEN, BLUE
C
C Set the minimum absolute contrast - this prevents a divide by zero.
C
      REAL MINCTR
      PARAMETER (MINCTR = 1.0/256)
C
C No colormap entries?
C
      IF(NC .EQ. 0) RETURN
C
C Determine the range of color indexes to be used.
C
      CALL PGQCIR(MININD, MAXIND)
C
C Count the total number of color indexes to be processed.
C
      NTOTAL = MAXIND - MININD + 1
C
C No definable colors?
C
      IF(NTOTAL .LT. 1 .OR. MININD .LT. 0) RETURN
C
C Prevent a divide by zero later by ensuring that CONTRA >= ABS(MINCTR).
C
      IF(ABS(CONTRA) .LT. MINCTR) THEN
        CONTRA = SIGN(MINCTR, CONTRA)
      END IF
C
C Convert contrast to the normalized stretch of the
C color table across the available color index range.
C
      SPAN = 1.0 / ABS(CONTRA)
C
C Translate from brightness and contrast to the normalized color index
C coordinates, CA and CB, at which to place the start and end of the
C color table.
C
      IF(CONTRA .GE. 0.0) THEN
        CA = 1.0 - BRIGHT * (1.0 + SPAN)
        CB = CA + SPAN
      ELSE
        CA = BRIGHT * (1.0 + SPAN)
        CB = CA - SPAN
      END IF
C
C Determine the number of color indexes spanned by the color table.
C
      NSPAN = INT(SPAN * NTOTAL)
C
C Determine the direction in which the color table should be traversed.
C
      FORWRD = CA .LE. CB
C
C Initialize the indexes at which to start searching the color table.
C
C Set the start index for traversing the table from NC to 1.
C
      BELOW = NC
C
C Set the start index for traversing the table from 1 to NC.
C
      ABOVE = 1
C
C Buffer PGPLOT commands until the color map has been completely
C installed.
C
      CALL PGBBUF
C
C Linearly interpolate the color table RGB values onto each color index.
C
      DO 1 CI=MININD, MAXIND
C
C Turn the color index into a fraction of the range MININD..MAXIND.
C
        CIFRAC = REAL(CI-MININD) / REAL(MAXIND-MININD)
C
C Determine the color table position that corresponds to color index,
C CI.
C
        IF(NSPAN .GT. 0) THEN
          LEVEL = (CIFRAC-CA) / (CB-CA)
        ELSE
          IF(CIFRAC .LE. CA) THEN
            LEVEL = 0.0
          ELSE
            LEVEL = 1.0
          END IF
        END IF
C
C Search for the indexes of the two color table entries that straddle
C LEVEL. The search algorithm assumes that values in L() are
C arranged in increasing order. This allows us to search the color table
C from the point at which the last search left off, rather than having
C to search the whole color table each time.
C
        IF(FORWRD) THEN
 2        IF(ABOVE.LE.NC .AND. L(ABOVE).LT.LEVEL) THEN
            ABOVE = ABOVE + 1
            GOTO 2
          END IF
          BELOW = ABOVE - 1
        ELSE
 3        IF(BELOW.GE.1 .AND. L(BELOW).GT.LEVEL) THEN
            BELOW = BELOW - 1
            GOTO 3
          END IF
          ABOVE = BELOW + 1
        END IF
C
C If the indexes lie outside the table, substitute the index of the
C nearest edge of the table.
C
        IF(BELOW .LT. 1) THEN
          LEVEL = 0.0
          BELOW = 1
          ABOVE = 1
        ELSE IF(ABOVE .GT. NC) THEN
          LEVEL = 1.0
          BELOW = NC
          ABOVE = NC
        END IF
C
C Linearly interpolate the primary color intensities from color table
C entries, BELOW and ABOVE.
C
        LDIFF = L(ABOVE) - L(BELOW)
        IF(LDIFF .GT. MINCTR) THEN
          LFRAC = (LEVEL - L(BELOW)) / LDIFF
        ELSE
          LFRAC = 0.0
        END IF
        RED   = R(BELOW) + (R(ABOVE) - R(BELOW)) * LFRAC
        GREEN = G(BELOW) + (G(ABOVE) - G(BELOW)) * LFRAC
        BLUE  = B(BELOW) + (B(ABOVE) - B(BELOW)) * LFRAC
C
C Intensities are only defined between 0 and 1.
C
        IF(RED   .LT. 0.0)   RED = 0.0
        IF(RED   .GT. 1.0)   RED = 1.0
        IF(GREEN .LT. 0.0) GREEN = 0.0
        IF(GREEN .GT. 1.0) GREEN = 1.0
        IF(BLUE  .LT. 0.0)  BLUE = 0.0
        IF(BLUE  .GT. 1.0)  BLUE = 1.0
C
C Install the new color representation.
C
        CALL PGSCR(CI, RED, GREEN, BLUE)
 1    CONTINUE
C
C Reveal the changed color map.
C
      CALL PGEBUF
      RETURN
      END

C*GRQDEV -- inquire current device
C+
      SUBROUTINE GRQDEV (DEVICE, L)
      CHARACTER*(*) DEVICE
      INTEGER L
C
C Obtain the name of the current graphics device or file.
C
C Argument:
C  DEVICE (output): receives the device name of the
C       currently active device.
C  L (output): number of characters in DEVICE, excluding trailing
C       blanks.
C--
C 19-Feb-1988
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
C
      IF (GRCIDE.LT.1) THEN
          DEVICE = '?'
          L = 1
      ELSE
          DEVICE = GRFILE(GRCIDE)
          L = GRFNLN(GRCIDE)
          IF (L.GT.LEN(DEVICE)) L = LEN(DEVICE)
      END IF
      END

C*PGBEG -- begin PGPLOT, open output device
C%int cpgbeg(int unit, char *file, int nxsub, int nysub);
C+
      INTEGER FUNCTION PGBEG (UNIT, FILE, NXSUB, NYSUB)
      INTEGER       UNIT
      CHARACTER*(*) FILE
      INTEGER       NXSUB, NYSUB
C
C Begin PGPLOT, open the plot file.  A call to PGBEG is
C required before any other calls to PGPLOT subroutines.  If a plot
C file is already open for PGPLOT output, it is closed before the new
C file is opened.
C
C Returns:
C  PGBEG         : a status return value. A value of 1 indicates
C                    successful completion, any other value indicates
C                    an error. In the event of error a message is
C                    written on the standard error unit.  
C                    To test the return value, call
C                    PGBEG as a function, eg IER=PGBEG(...); note
C                    that PGBEG must be declared INTEGER in the
C                    calling program.
C Arguments:
C  UNIT  (input)   : this argument is ignored by PGBEG (use zero).
C  FILE  (input)   : the "device specification" for the plot device.
C                    Device specifications are installation dependent,
C                    but usually have the form "device/type" or
C                    "file/type". If this argument is a
C                    question mark ('?'), PGBEG will prompt the user
C                    to supply a string. If the argument is a blank
C                    string (' '), PGBEG will use the value of
C                    environment variable PGPLOT_DEV.
C  NXSUB  (input)  : the number of subdivisions of the view surface in
C                    X (>0 or <0).
C  NYSUB  (input)  : the number of subdivisions of the view surface in
C                    Y (>0).
C                    PGPLOT puts NXSUB x NYSUB graphs on each plot
C                    page or screen; when the view surface is sub-
C                    divided in this way, PGPAGE moves to the next
C                    panel, not the  next physical page. If
C                    NXSUB > 0, PGPLOT uses the panels in row
C                    order; if <0, PGPLOT uses them in column order.
C--
C  1-Jan-1984 [TJP]
C  8-Aug-1985 [TJP] - add '?' prompting.
C 31-Dec-1985 [TJP] - fix '?' prompting in batch jobs.
C 11-Sep-1986 [TJP] - add PGLDEV call.
C  9-Feb-1988 [TJP] - replace VMS-specific code with GRGCOM.
C 13-Dec-1990 [TJP] - make error reading input non-fatal.
C 22-Jun-1992 [TJP] - background and foreground colors.
C  3-Sep-1992 [WD/TJP] - add PGPLOT_DEV environment variable and
C                     row/column ordering of panels.
C 13-Oct-1992 [TJP] - add arrow-head attributes.
C 21-Jan-1993 [TJP] - add default for '?' [TJP].
C 17-Mar-1994 [TJP] - initialize color index range [TJP].
C 15-Sep-1994 [TJP] - initialize transfer function [TJP].
C  6-Jun-1995 [TJP] - explicitly initialize PGOPEN [TJP].
C-----------------------------------------------------------------------
      INCLUDE       'pgplot.inc'
      INTEGER       DEFTYP,GRDTYP,GROPEN,L,LR,IC1
      INTEGER       GRGCOM, IER, LDEFDE
      REAL          DUMMY,DUMMY2,XCSZ
      CHARACTER*128 DEFDEV
      CHARACTER*20  DEFSTR
      CHARACTER*256 REQ
      LOGICAL JUNK
C
C  Move the initialization of pgopen to a block data subprogram in
C  pgblck file.  John S. Salmento 7/5/95
C

C
C Close the plot-file if it is already open.
C
      IF (PGOPEN.NE.0) CALL PGEND
C
C Get the default device/type (environment variable PGPLOT_DEV).
C
      CALL GRGENV('DEV', DEFDEV, LDEFDE)
      IF (LDEFDE.EQ.0) THEN
          DEFDEV = '/NULL'
          LDEFDE = 5
      END IF
C
C Open the plot file; default type is given by environment variable
C PGPLOT_TYPE.
C
      CALL GRGENV('TYPE', DEFSTR, L)
      IF (L.EQ.0) THEN
          DEFTYP = 0
      ELSE
          CALL GRTOUP(DEFSTR, DEFSTR)
          DEFTYP = GRDTYP(DEFSTR(1:L))
      END IF
      IF (FILE.EQ.' ') THEN
          PGBEG = GROPEN(DEFTYP,UNIT,DEFDEV(1:LDEFDE),IDENT)
      ELSE IF (FILE(1:1).EQ.'?') THEN
   10     IF (LDEFDE.EQ.0) THEN
              IER = GRGCOM(REQ,
     :           'Graphics device/type (? to see list): ',LR)
          ELSE
              IER = GRGCOM(REQ,
     :           'Graphics device/type (? to see list, default '//
     :           DEFDEV(1:LDEFDE)//'): ',LR)
          END IF
          IF (IER.NE.1) THEN
              CALL GRWARN('Error reading device specification')
              PGBEG = IER
              RETURN
          END IF
          IF (LR.LT.1 .OR. REQ.EQ.' ') THEN
              REQ = DEFDEV(1:LDEFDE)
          ELSE IF (REQ(1:1).EQ.'?') THEN
              CALL PGLDEV
              GOTO 10
          END IF
          PGBEG = GROPEN(DEFTYP,UNIT,REQ,IDENT)
          IF (PGBEG.NE.1) GOTO 10
      ELSE
          PGBEG = GROPEN(DEFTYP,UNIT,FILE,IDENT)
      END IF
C
C Failed to open plot file?
C
      IF (PGBEG.NE.1) RETURN
C
C Success: determine device characteristics.
C
      PGOPEN = 1
      ADVSET = 0
      PGPFIX = .FALSE.
      CALL GRSIZE(IDENT,XSZ,YSZ,DUMMY,DUMMY2,XPERIN,YPERIN)
      CALL GRCHSZ(IDENT,XCSZ,DUMMY,XSP,YSP)
      PGROWS = .TRUE.
      IF (NXSUB.LT.0) PGROWS = .FALSE.
      NX = MAX(ABS(NXSUB),1)
      NY = MAX(ABS(NYSUB),1)
      XSZ = XSZ/NX
      YSZ = YSZ/NY
      NXC = NX
      NYC = NY
      CALL GRQTYP(DEFSTR,JUNK)
C
C Set the prompt state to ON, so that terminal devices pause between
C pages; this can be changed with PGASK.
C
      CALL PGASK(.TRUE.)
C
C If environment variable PGPLOT_BUFFER is defined (any value),
C start buffering output.
C
      PGBLEV = 0
      CALL GRGENV('BUFFER', DEFSTR, L)
      IF (L.GT.0) CALL PGBBUF
C
C Set background and foreground colors if requested.
C
      CALL GRGENV('BACKGROUND', DEFSTR, L)
      IF (L.GT.0) CALL PGSCRN(0, DEFSTR(1:L), IER)
      CALL GRGENV('FOREGROUND', DEFSTR, L)
      IF (L.GT.0) CALL PGSCRN(1, DEFSTR(1:L), IER)
C
C Set default attributes.
C
      CALL PGSCI(1)
      CALL PGSLS(1)
      CALL PGSLW(1)
      CALL PGSCH(1.0)
      CALL PGSCF(1)
      CALL PGSFS(1)
      CALL PGSAH(1, 45.0, 0.3)
      CALL PGSTBG(-1)
      CALL PGSHS(45.0, 1.0, 0.0)
C
C Set the default range of color indices available for images (16 to
C device maximum, if device maximum >= 16; otherwise not possible).
C Select linear transfer function.
C
      CALL GRQCOL(IC1, PGMXCI)
      PGMNCI = 16
      IF (PGMXCI.LT.16) PGMXCI = 0
      PGITF = 0
C
C Set the default window (unit square).
C
      XBLC = 0.0
      XTRC = 1.0
      YBLC = 0.0
      YTRC = 1.0
C
C Set the default viewport.
C
      CALL PGVSTD
      END
	  

C*GROPEN -- open device for graphics
C+
      INTEGER FUNCTION GROPEN (TYPE,DUMMY,FILE,IDENT)
      INTEGER   TYPE, DUMMY, IDENT
      CHARACTER*(*) FILE
C
C GRPCKG: assign a device and prepare for plotting.  GROPEN must be
C called before all other calls to GRPCKG routines.
C
C Returns:
C
C GROPEN (output, integer): 1 => success, any other value
C       indicates a failure (usually the value returned will
C       be a VMS error code). In the event of an error, a
C       message will be sent to the standard error unit.
C
C Arguments:
C
C TYPE (input, integer): default device type (integer code).
C DUMMY (input, integer): not used at present.
C FILE (input, character): plot specifier, of form 'device/type'.
C IDENT (output, integer): plot identifier to be used in later
C       calls to GRPCKG.
C
C  1-Jun-1984 - [TJP].
C  2-Jul-1984 - change to call GRSLCT [TJP].
C 13-Jul-1984 - add device initialization [TJP].
C 23-Jul-1984 - add /APPEND qualifier.
C 19-Oct-1984 - add VV device [TJP].
C 26-Dec-1984 - obtain default file name from common [TJP].
C 29-Jan-1985 - add HP2648 device [KS/TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 12-Oct-1986 - fix bug causing GREXEC to erase screen [AFT].
C  3-Jun-1987 - remove declaration of exit handler [TJP].
C 15-Dec-1988 - standardize [TJP].
C 25-Jun-1989 - remove code that removes spaces from the device name 
C               [TJP].
C 26-Nov-1990 - [TJP].
C  5-Jan-1993 - [TJP].
C  1-Sep-1994 - store device capabilities in common for later use [TJP].
C 17-Apr-1995 - zero-length string fix [TJP].
C  6-Jun-1995 - explicitly initialize GRSTAT [TJP].
C 29-Apr-1996 - moved initialization into GRINIT [TJP].
C 12-Jul-1999 - fix bug [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER   IER, FTYPE, NBUF, LCHR
      INTEGER   GRPARS, GRTRIM
      REAL      RBUF(6)
      LOGICAL   APPEND
      CHARACTER*128 FFILE,CHR
C
C Initialize GRPCKG; read font file (if necessary).
C
      CALL GRINIT
C
C Allocate an identifier.
C
      IDENT = 1
   10 IF (GRSTAT(IDENT).NE.0) THEN
          IDENT = IDENT+1
          IF (IDENT.GT.GRIMAX) THEN
              CALL GRWARN('Too many active plots.')
              GROPEN = -1
              IDENT = 0
              RETURN
          END IF
      GOTO 10
      END IF
C
C Validate the device specification.
C
      IER = GRPARS(FILE,FFILE,FTYPE,APPEND)
      IF (IER.NE.1) THEN
          CHR = 'Invalid device specification: '
          CHR(31:) = FILE
          CALL GRWARN(CHR)
          GROPEN = -1
          RETURN
      END IF
      IF (FTYPE.EQ.0) FTYPE = TYPE
      IF (1.LE.FTYPE) THEN
          GRTYPE(IDENT) = FTYPE
      ELSE
          CHR = 'Device type omitted or invalid: '
          CHR(33:) = FILE
          CALL GRWARN(CHR)
          GROPEN = -1
          RETURN
      END IF
C
C Install the file name, or assign default.
C
      IF (FFILE.EQ.' ') THEN
          CALL GREXEC(GRTYPE(IDENT), 5,RBUF,NBUF,FFILE,LCHR)
      END IF
      GRFILE(IDENT) = FFILE
      GRFNLN(IDENT) = MAX(1,GRTRIM(GRFILE(IDENT)))
C
C Open workstation.
C
      RBUF(3)=0
      IF (APPEND) RBUF(3)=1
      NBUF=3
      CALL GREXEC(GRGTYP, 9,RBUF,NBUF, GRFILE(IDENT),GRFNLN(IDENT))
      GROPEN=RBUF(2)
      IF (GROPEN.NE.1) THEN
         IDENT = 0
         RETURN
      END IF
      GRGTYP = GRTYPE(IDENT)
      GRUNIT(IDENT)=RBUF(1)
      GRPLTD(IDENT) = .FALSE.
      GRSTAT(IDENT) = 1
      CALL GRSLCT(IDENT)
C
C Install the default plot parameters
C
C--- Inquire color-index range.
      CALL GREXEC(GRGTYP, 2,RBUF,NBUF,CHR,LCHR)
      GRMNCI(IDENT)=RBUF(5)
      GRMXCI(IDENT)=RBUF(6)
C--- Inquire resolution.
      CALL GREXEC(GRGTYP, 3,RBUF,NBUF,CHR,LCHR)
      GRPXPI(IDENT)=RBUF(1)
      GRPYPI(IDENT)=RBUF(2)
C--- Inquire default character size.
      CALL GREXEC(GRGTYP, 7,RBUF,NBUF,CHR,LCHR)
      GRCSCL(IDENT) = RBUF(1)
      GRCFAC(IDENT) = RBUF(1)
C--- Inquire default plot size.
      CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR)
      GRXMXA(IDENT) = RBUF(2)
      GRYMXA(IDENT) = RBUF(4)
      GRXMIN(IDENT) = RBUF(1)
      GRXMAX(IDENT) = RBUF(2)
      GRYMIN(IDENT) = RBUF(3)
      GRYMAX(IDENT) = RBUF(4)
C--- Inquire device capabilities.
      GRGCAP(IDENT) = 'NNNNNNNNNNN'
      CALL GREXEC(GRGTYP, 4,RBUF,NBUF,CHR,LCHR)
      IF (LCHR.GT.LEN(GRGCAP(IDENT))) LCHR = LEN(GRGCAP(IDENT))
      GRGCAP(IDENT)(1:LCHR) = CHR(:LCHR)
C--- Current pen position.
      GRXPRE(IDENT) = 0.0
      GRYPRE(IDENT) = 0.0
C--- GRSETS has not been called.
      GRADJU(IDENT) = .FALSE.
C---Default scaling.
      CALL GRTRN0(0.0, 0.0, 1.0, 1.0)
C
C Default attributes.
C  text font (normal)
C  color (white)
C  line-style (full)
C  line-width (minimum)
C  marker number (dot)
C
      GRCFNT(IDENT) = 1
      GRCCOL(IDENT) = 1
      GRSTYL(IDENT) = 1
      GRWIDT(IDENT) = 1
      GRCMRK(IDENT) = 1
      GRDASH(IDENT) = .FALSE.
C
      GROPEN = 1
C
      END

C*LNDRIV   PGPLOT DRIVER FOR DIGITAL LN03 (LANDSCAPE)
	SUBROUTINE LNDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
	INTEGER IFUNC, NBUF, LCHR
	REAL    RBUF(*)
	CHARACTER*(*) CHR
C-----------------------------------------------------------------------
C PGPLOT driver for Digital LN03 Laser Printer (landscape)
C File : LNDRIVER.FOR
C-----------------------------------------------------------------------
C Version 1.0  - 1989 Nov. Sid Penstone, Queen's University
C Last Revision Dec.1,1989, added direct code for vertical lines,
C now do dots as a case of a zero length vector
C-----------------------------------------------------------------------
C	This routine has been written specifically for the LN03-PLUS
C	Laser Printer
C
C	Name: '/LN03'
C 	In all case, the initialization sequences are written out,
C	whether or not the plotter is connected as a terminal,
C	or driven from an intermediate file.
C
C	If there is more than one plot 
C	the page is ejected before the next one
C	
C	ref: Digital LN03 Programmer Reference Manual, P/N EK-OLN03-002,
C	  and Digital LN03-Plus "      "          "    P/N EK-LN03S-001
C
C	We end up with a 9" by 7" display area.
C
C-----------------------------------------------------------------------
	CHARACTER*(*) TYPE
	PARAMETER (TYPE='LN03 (Digital LN03 Laser Printer, landscape)')
C
	INTEGER MARGIN, NXPIX, NYPIX, NSIXROWS, NSIXCOLS
	PARAMETER(MARGIN=150)
	PARAMETER(NXPIX=3000)
	PARAMETER(NYPIX=2400)
	PARAMETER(NSIXROWS=(NYPIX/6)+2)
	PARAMETER(NSIXCOLS=NXPIX)
	CHARACTER*10 MSG
	INTEGER WIDTH,XLEFT,XRIGHT,YBOT,YTOP, INTENS, XMAX, YMAX, XMIN
	INTEGER UNIT, IER
	INTEGER I0, J0, I1, J1
	INTEGER IK1, IK2, IK3, IK4, IK5, PLOTNO
	CHARACTER*1 ESC
	DATA XLEFT,XRIGHT,YTOP,YBOT/0,NXPIX,0,NYPIX/
	DATA ESC /27/
	DATA WIDTH /2/
	LOGICAL ACTIVE(0:NSIXROWS)
C Data for the allocation routines
	INTEGER GRGMEM, GRFMEM
	INTEGER BUFLEN, IPOINTS, IERR
	LOGICAL ALLOC
	SAVE BUFLEN, IPOINTS, ALLOC
	DATA ALLOC /.FALSE./
	DATA IPOINTS /-1/
C for debugging
	LOGICAL DEBUG
	DATA DEBUG/.FALSE./

C-----------------------------------------------------------------------
C
	GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
	GOTO 900
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
10	CHR = TYPE
	LCHR = LEN(TYPE)
	RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
20	RBUF(1) = 0
	RBUF(2) = NXPIX - 2*MARGIN
	RBUF(3) = 0
	RBUF(4) = NYPIX - 2*MARGIN
	RBUF(5) = 0
	RBUF(6) = 1
	NBUF = 6
	RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
30	RBUF(1) = 300.0
	RBUF(2) = 300.0
	RBUF(3) = WIDTH
	NBUF = 3
	RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    No thick lines)
C
40	CHR = 'HNNNNNNNNN'
	LCHR = 10
	RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
50	CHR = 'PGPLOT.LN3'
	LCHR = 11
	RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
60	RBUF(1) = 0
	RBUF(2) = NXPIX-2*MARGIN
	RBUF(3) = 0
	RBUF(4) = NYPIX-2*MARGIN
	NBUF = 4
	RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
70	RBUF(1) = 10
	NBUF = 1
	RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
80	CONTINUE
	RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
90	CONTINUE
C Try to open the graphics device
	CALL GRGLUN(UNIT)
	OPEN (UNIT=UNIT,FILE=CHR(:LCHR),STATUS='NEW',
	1		FORM='FORMATTED', CARRIAGECONTROL='LIST',
	1		RECL=512,IOSTAT=IER)
	IF (IER.NE.0) THEN
	  CALL ERRSNS(IK1,IK2,IK3,IK4,IK5)
	  CALL GRWARN('Cannot open graphics device '
	1				//CHR(1:LCHR))
	  IF (IK2.NE.0 .AND. IK2.NE.1) CALL GRGMSG(IK2)
	  IF (IK5.NE.0 .AND. IK5.NE.1) CALL GRGMSG(IK5)
	  RBUF(2) = 0 
	  RETURN
	ENDIF
	RBUF(1) = UNIT
	RBUF(2) = 1
	NBUF = 2
C Now allocate the bitmap buffers (Assume integer*2)
	IF (.NOT. ALLOC) THEN
	    BUFLEN = NSIXROWS * NSIXCOLS
	    IERR = GRGMEM(2*BUFLEN, IPOINTS)
	    IF (IERR .NE. 1 ) THEN
	        CALL GRGMSG(IERR)
	        CALL GRWARN('Memory allocation failure')
	        RETURN
	    ENDIF
	    ALLOC = .TRUE.
	ENDIF
C Digital says that the allocated memory may not be zeroed:
C Clear the row flags (and the bit map)
	CALL LN03_CLEAR(%VAL(IPOINTS),BUFLEN,ACTIVE,NSIXROWS)
C
C always write the preamble
C this resets the plotter
	WRITE (UNIT, '(A)') ESC//'c'
C this sets it for landscape, origin at corner 
	WRITE (UNIT, '(A)') ESC//'[?21 J'
	PLOTNO = 0
	RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
  100	CONTINUE
C always turn it off
	CLOSE (UNIT)
	CALL GRFLUN(UNIT)
C Deallocate the buffer
	IF (ALLOC .OR. IPOINTS .GE. 0) THEN
	    IERR = GRFMEM(2*BUFLEN, IPOINTS)
	    IF (IERR .NE. 1 ) THEN
	        CALL GRGMSG(IERR)
	        CALL GRWARN('Deallocation failure')
	        RETURN
	    ENDIF
	    ALLOC = .FALSE.
	    IPOINTS = -1
	ENDIF
	RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110	CONTINUE
C WE COULD GET THE VALUE OF XMAX AND YMAX HERE
	YMAX = YBOT - 2*MARGIN
	XMIN = XLEFT + MARGIN
	XMAX = XRIGHT - MARGIN
	PLOTNO = PLOTNO + 1
	RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120	CONTINUE
	I0 = XMIN + NINT(RBUF(1))
	J0 = YMAX - NINT(RBUF(2))
	I1 = XMIN + NINT(RBUF(3))
	J1 = YMAX - NINT(RBUF(4)) 
	CALL LN03_VECTOR(I0,J0,I1,J1,WIDTH,XLEFT,XRIGHT,
	1 YTOP,YBOT,%val(IPOINTS),ACTIVE,NSIXROWS,NSIXCOLS,INTENS)
	RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130	CONTINUE
	I0 = XMIN + NINT(RBUF(1))
	J0 = YMAX - NINT(RBUF(2))
	CALL LN03_VECTOR(I0,J0,I0,J0,WIDTH,XLEFT,XRIGHT,
	1 YTOP,YBOT,%VAL(IPOINTS),ACTIVE,NSIXROWS,NSIXCOLS,INTENS)
	RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140	CONTINUE
        CALL LN03_DUMP(UNIT,XLEFT,XMAX+WIDTH,YTOP+MARGIN,YMAX+WIDTH,
	1%val(IPOINTS),ACTIVE,NSIXROWS,NSIXCOLS)
C Clear the bitmap buffer
	IF (ALLOC) THEN
	    CALL LN03_CLEAR(%val(IPOINTS),BUFLEN,ACTIVE,NSIXROWS)
	ENDIF	    
C  Eject the paper with a form feed
C	WRITE (UNIT, '(A)') CHAR(12)
	RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C
  150	INTENS = NINT(RBUF(1))
	IF (INTENS .GT.1) INTENS = 1
	if (debug) write(0,'(A,G13.7,I6)')'Intens= ',RBUF(1),INTENS
	RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Null operation: buffering is not implemented.)
C
160	CONTINUE
	RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called.)
C
170	GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Null operation: there is no alpha screen.)
C
180	CONTINUE
	RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called.)
C
190	GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called.)
C
200	GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
210	RETURN
C	Other colors are not implemented
C
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called.)
C
220	GOTO 900
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
230	CONTINUE
	WRITE (UNIT, '(A)') CHR(:LCHR)
	RETURN
C-----------------------------------------------------------------------
C Error: unimplemented function.
C
  900	WRITE (MSG,'(I10)') IFUNC
	CALL GRWARN('Unimplemented function in LN03 device driver: '//MSG)
	NBUF = -1
	RETURN
C-----------------------------------------------------------------------
	END

C------------------- PRIMITIVE LN03 FUNCTIONS -------------------
C
C----------------------------------------------------------------
C       CLEAR THE BITMAP IF IT WAS USED BEFORE
C
	SUBROUTINE LN03_CLEAR(BUFF,N,BUSY,NR)
	INTEGER*2 BUFF(0:*)
	LOGICAL BUSY(0:*)
	INTEGER N, I , NR
	DO 1 I = 0, N-1
1	BUFF(I) = 0
	DO 2 I = 0, NR-1
2	BUSY(I) = .FALSE.
	RETURN
	END


C---------------------------------------------------------------------
	CHARACTER*10 FUNCTION LN03_PACK(IARG,IP)
C-----------------------------------------------------------------------
C       (Internal routine, LN): Identical to the grgl00() routine
C       This subroutine translates the argument IARG into a character 
C	string and then returns the position of the first non-blank
C	character in the string
C Arguments:    IARG
C               IP (returned) 
C-----------------------------------------------------------------------
	INTEGER IARG, IP
C
	LN03_PACK = ' '
	IP = 10
	WRITE(LN03_PACK,'(I10)') IARG
	DO IP=1,10
	  IF (LN03_PACK(IP:IP) .NE. ' ') RETURN
	ENDDO
	END


C---------------------------- VECTOR DRAWING --------------------------
	SUBROUTINE LN03_VECTOR(X1,Y1,X2,Y2,WIDTH,XLEFT,XRIGHT,
	1 YTOP,YBOT,POINTS,ACTIVE,NSIXROWS,NSIXCOLS,INTENS)
C----------------------------------------------------------------------
C
C	Based on Bresenham's algorithm, and a C version written by
C	Paul Demone, Canadian Microelectronics Corporation
C
C	 We enter with the values x,y converted to internal values
C	That is, we have reflected the direction of Y
C

	INTEGER X1,Y1,X2,Y2,WIDTH,XLEFT,XRIGHT,YBOT,YTOP,NSIXCOLS,
	1 NSIXROWS, INTENS
	INTEGER X, Y, DX, DY, ADX, ADY, E, DA, DB, D1X, D1Y, D2X, D2Y
	INTEGER XX, YY, INDX, ITEMP
	INTEGER*2 SHIFT
	INTEGER*2 POINTS(0:*)
	LOGICAL ACTIVE(0:*)
	logical debug
	data debug /.false./

C 	if (debug) write(0,'(A,I6,I6)')'INTENS= ',INTENS
C Start at X1, Y1 
	if(debug)write(0, '(A,4(I6),A,I3,A,2(I10))')'LINE: ',
	1x1,y1,x2,y2,'INTENS=',INTENS,' ROW,COL: ',
	1 (Y1/6),((Y1/6)*NSIXCOLS+X1)
C Note that we always try to move the X index inside the loops, since they
C are adjacent in the bitmap array
C If this is a horizontal line, then we can do it faster
	IF (Y2 .EQ. Y1) THEN
	    IF(X2 .LT. X1) THEN
		ITEMP = X1
		X1 = X2
		X2 = ITEMP
	    ENDIF
	    YY = Y1
	    DO WHILE (YY .LT. Y1 + WIDTH .AND. YY .LT. YBOT)
		INDX = (YY/6)*NSIXCOLS
		SHIFT = JMOD(YY, 6)		    
		XX = X1
		DO WHILE ( XX .LT. X2 + WIDTH .AND. XX .LT. XRIGHT)
		    IF (INTENS .EQ. 0) THEN
			POINTS(INDX + XX) = IIBCLR(POINTS(INDX +XX), SHIFT)
		    ELSE
			POINTS(INDX + XX) = IIBSET(POINTS(INDX +XX), SHIFT)
		ENDIF
		    XX = XX + 1
		ENDDO
	        IF (INTENS .NE. 0) ACTIVE(YY/6) = .TRUE.
	        YY = YY + 1
	    ENDDO
	    RETURN
C		Might be a vertical line:
	ELSEIF (X2. EQ. X1) THEN
	    IF (Y2 .LT. Y1) THEN
		ITEMP = Y1
		Y1 = Y2
		Y2 = ITEMP
	    ENDIF
	    YY = Y1
	    DO WHILE (YY .LT. Y2 + WIDTH .AND. YY .LT. YBOT)
		INDX = (YY/6)*NSIXCOLS
		SHIFT = JMOD(YY, 6)		    
		XX = X1
		DO WHILE ( XX .LT. X1 + WIDTH .AND. XX .LT. XRIGHT)
		    IF (INTENS .EQ. 0) THEN
			POINTS(INDX + XX) = IIBCLR(POINTS(INDX +XX), SHIFT)
		    ELSE
			POINTS(INDX + XX) = IIBSET(POINTS(INDX +XX), SHIFT)
		ENDIF
		    XX = XX + 1
		ENDDO
	        IF (INTENS .NE. 0) ACTIVE(YY/6) = .TRUE.
	        YY = YY + 1
	    ENDDO
	    RETURN
	ENDIF
C		 It is a vector : Use the algorithm

	DX = X2 - X1
	DY = Y2 - Y1
	D2X = ISIGN(1,DX)
	D2Y = ISIGN(1,DY)
	ADX = IABS(DX)
	ADY = IABS(DY)
C Check for the maximum number of steps: X or Y ?
	IF (ADX .GT. ADY) THEN
		DA = ADX
		DB = ADY
		D1Y = 0
		D1X = ISIGN(1,DX)
	ELSE
		DA = ADY
		DB = ADX
		D1X = 0
		D1Y = ISIGN(1,DY)
	ENDIF
	DB = 2*DB
	E = DB - DA
	DA = 2*DA 
	X = X1
	Y = Y1
C Here we will be using some VAX Fortran extensions .......
  800   CONTINUE
C	DO WHILE (.TRUE.)
	    IF (X .GE. XLEFT  .AND. Y .GE. YTOP .AND.
	1       X .LT. XRIGHT .AND. Y .LT. YBOT) THEN
C Don't come in here if we are already off scale !
C If it is ok, then add a cluster of pixels of size width by width
C	if(debug)write(0, '(4(I6))')x,y
		XX = X
		DO WHILE (XX .LT. X+WIDTH .AND. XX .LT. XRIGHT)
		    YY = Y
		    DO WHILE(YY .LT. Y+WIDTH .AND. YY .LT. YBOT)
			INDX = (YY/6)*NSIXCOLS + XX
			SHIFT = JMOD(YY,6)
C	IF(DEBUG)WRITE(UNIT,'(2(I6),I10,6(I6))')
C	1   XX,YY,INDX,POINTS(INDX),INTENS,SHIFT
			IF (INTENS .EQ. 0) THEN 
			    POINTS(INDX) = IIBCLR(POINTS(INDX),SHIFT) 
		        ELSE
			    POINTS(INDX) = IIBSET(POINTS(INDX),SHIFT) 
			    ACTIVE(YY/6) = .TRUE.
			ENDIF
		        YY = YY + 1
		    ENDDO
		    XX = XX +1
		ENDDO
	    ENDIF	
C  Are we finished ?
	    IF (X .EQ. X2 .AND. Y .EQ. Y2) RETURN
C  Else move to the next point
	    IF ( E .GT. 0) THEN
	        X = X + D2X
	        Y = Y + D2Y
	        E = E + DB - DA
	    ELSE
	        X = X + D1X
	        Y = Y + D1Y
	        E = E + DB
	    ENDIF
	GOTO 800
C	ENDDO
	END


C ------------------------------------------------------------
	SUBROUTINE LN03_DUMP(UNIT,XLEFT,XRIGHT,YTOP,YBOT,
	1 POINTS,ACTIVE,NSIXROWS,NSIXCOLS)
C-------------------------------------------------------------
C Dump the bitmap to the printer
C Only write active sixel rows, and do run length encoding, too
C
C
C Parameters:
C	XLEFT: starting column in map, and initial x position
C	XRIGHT: last active column in map
C	YTOP: starting row in map, and initial y position
C	YBOT: last active row in the map

	INTEGER XLEFT, XRIGHT, YTOP, YBOT, NSIXROWS, NSIXCOLS, UNIT
	LOGICAL ACTIVE(0:*)
	INTEGER*2 POINTS(0:*)

	INTEGER*2 SXL
	INTEGER IROW, JCOL, K, PTR, RPT, INDX, N, MAXLEN
	CHARACTER*10 RUN, LN03_PACK
	CHARACTER*256 BUFFER
	CHARACTER*1 PAT, ESC
	DATA ESC /27/
	DATA MAXLEN /75/
	LOGICAL DEBUG
	DATA DEBUG /.false./
	INTEGER IOFFSET
	PARAMETER(IOFFSET = 34)

	CHARACTER*10 NEWX,NEWY
	INTEGER N1,N2

	NEWX = LN03_PACK(XLEFT,N1)
	NEWY = LN03_PACK(YTOP+IOFFSET,N2)
C Start at the top of the paper, down one line plus offset
C The pixels start 70 decipoints above the first line
C Set up the sixel modes
	WRITE(UNIT, '(A)') ESC//'[7 I'//ESC//'[11h'
	WRITE (UNIT, '(A)') 
	1 ESC//'['//NEWX(N1:)//'`'//ESC//'['//NEWY(N2:)//'d'
	1//ESC//'P0;0;1q"100;100'
C Now scan the bitmap
	PTR = 1
	DO 1000 IROW = 0, NSIXROWS-2
	IF (ACTIVE(IROW)) THEN
	if(debug)write(0,'(a,4(i6))')'row = ',irow
	    JCOL = XLEFT
	    DO WHILE (JCOL .LT. XRIGHT)
		INDX = IROW*NSIXCOLS
		SXL = POINTS(INDX + JCOL)
	        PAT = CHAR(IIAND(SXL,63) + 63)
		RPT = 0
C Look for repeated values on the rest of the line
		K = JCOL + 1
		DO WHILE( K .LT. XRIGHT .AND.
	1	    SXL .EQ. POINTS(INDX + K))
		    RPT = RPT +1
		    K = K + 1
		ENDDO
C	    IF (DEBUG) WRITE(1, '(2I10,2I6,1X,A,I5,I5)')
C	1 indx,indx+jcol, IROW, JCOL, PAT,ICHAR(PAT),SXL
C	Now check if there were any repeats
		IF (RPT .GT. 0) THEN
	            RUN = LN03_PACK(RPT +1, N)
	            BUFFER(PTR:) = '!'//RUN(N:)//PAT
		    PTR = PTR + LEN(RUN(N:)) + 2
		    JCOL = JCOL + RPT + 1
	        ELSE
	            BUFFER(PTR:PTR) = PAT
		    PTR = PTR + 1
		    JCOL = JCOL + 1
	        ENDIF
	        IF (PTR .GE. MAXLEN) THEN
		    WRITE (UNIT, '(A)') BUFFER(:PTR-1)
	            PTR = 1
	        ENDIF
	    ENDDO
	ENDIF
C Terminate each scan with a graphic newline character
        BUFFER(PTR:PTR) = '-'
	IF (PTR .GE. MAXLEN) THEN
	    WRITE (UNIT, '(A)') BUFFER(:PTR)
	    PTR = 1
	ELSE
	    PTR = PTR + 1
        ENDIF
1000	CONTINUE
	IF(PTR .GT. 1) WRITE (UNIT, '(A)') BUFFER(:PTR-1)
	WRITE(UNIT, '(A)') ESC//CHAR(92)
	RETURN
	END

C*GRCHSZ -- inquire default character attributes
C+
      SUBROUTINE GRCHSZ (IDENT,XSIZE,YSIZE,XSPACE,YSPACE)
C
C GRPCKG: Obtain the default character attributes.
C
C Arguments:
C
C IDENT (input, integer): the plot identifier, returned by GROPEN.
C XSIZE, YSIZE (output, real): the default character size
C      (absolute device units).
C XSPACE, YSPACE (output, real): the default character spacing
C      (absolute units); XSPACE is the distance between the lower left
C      corners of adjacent characters in a plotted string; YSPACE
C      is the corresponding vertical spacing.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  IDENT
      REAL     FACTOR, XSIZE, YSIZE, XSPACE, YSPACE
C
      CALL GRSLCT(IDENT)
      FACTOR = GRCSCL(IDENT)
      XSIZE = GRCXSZ * FACTOR
      YSIZE = GRCYSZ * FACTOR
      XSPACE = 10.0 * FACTOR
      YSPACE = 13.0 * FACTOR
      END

C*PGPAGE -- advance to new page
C%void cpgpage(void);
C+
      SUBROUTINE PGPAGE
C
C Advance plotter to a new page or panel, clearing the screen if
C necessary. If the "prompt state" is ON (see PGASK), confirmation is
C requested from the user before clearing the screen. If the view
C surface has been subdivided into panels with PGBEG or PGSUBP, then
C PGPAGE advances to the next panel, and if the current panel is the
C last on the page, PGPAGE clears the screen or starts a new sheet of
C paper.  PGPAGE does not change the PGPLOT window or the viewport
C (in normalized device coordinates); but note that if the size of the
C view-surface is changed externally (e.g., by a workstation window
C manager) the size of the viewport is changed in proportion.
C
C Arguments: none
C--
C  7-Feb-1983
C 23-Sep-1984 - correct bug: call GRTERM at end (if flush mode set).
C 31-Jan-1985 - make closer to Fortran-77.
C 19-Nov-1987 - explicitly clear the screen if device is interactive;
C               this restores the behavior obtained with older versions
C               of GRPCKG.
C  9-Feb-1988 - move prompting into routine GRPROM.
C 11-Apr-1989 - change name to PGPAGE.
C 10-Sep-1990 - add identification labelling.
C 11-Feb-1992 - check if device size has changed.
C  3-Sep-1992 - allow column ordering of panels.
C 17-Nov-1994 - move identification to drivers.
C 23-Nov-1994 - fix bug: character size not getting reset.
C 23-Jan-1995 - rescale viewport if size of view surface  has changed.
C  4-Feb-1997 - bug fix; character size was not correctly indexed by
C               device ID.
C-----------------------------------------------------------------------
      INCLUDE      'pgplot.inc'
      CHARACTER*16 STR
      LOGICAL      INTER, PGNOTO
      REAL DUM1, DUM2, XS, YS, XVP1, XVP2, YVP1, YVP2
C
      IF (PGNOTO('PGPAGE')) RETURN
C
      IF (PGROWS(PGID)) THEN
        PGNXC(PGID) = PGNXC(PGID) + 1
        IF (PGNXC(PGID).GT.PGNX(PGID)) THEN
          PGNXC(PGID) = 1
          PGNYC(PGID) = PGNYC(PGID) + 1
          IF (PGNYC(PGID).GT.PGNY(PGID)) PGNYC(PGID) = 1
        END IF
      ELSE
        PGNYC(PGID) = PGNYC(PGID) + 1
        IF (PGNYC(PGID).GT.PGNY(PGID)) THEN
          PGNYC(PGID) = 1
          PGNXC(PGID) = PGNXC(PGID) + 1
          IF (PGNXC(PGID).GT.PGNX(PGID)) PGNXC(PGID) = 1
        END IF
      END IF
      IF (PGNXC(PGID).EQ.1 .AND. PGNYC(PGID).EQ.1) THEN
          IF (PGADVS(PGID).EQ.1 .AND. PGPRMP(PGID)) THEN
              CALL GRTERM
              CALL GRPROM
          END IF
          CALL GRPAGE
          IF (.NOT.PGPFIX(PGID)) THEN
C             -- Get current viewport in NDC.
              CALL PGQVP(0, XVP1, XVP2, YVP1, YVP2)
C             -- Reset view surface size if it has changed
              CALL GRSIZE(PGID, XS,YS, DUM1,DUM2,
     1                    PGXPIN(PGID), PGYPIN(PGID))
              PGXSZ(PGID) = XS/PGNX(PGID)
              PGYSZ(PGID) = YS/PGNY(PGID)
C             -- and character size
              CALL PGSCH(PGCHSZ(PGID))
C             -- and viewport
              CALL PGSVP(XVP1, XVP2, YVP1, YVP2)
          END IF
C
C If the device is interactive, call GRBPIC to clear the page.
C (If the device is not interactive, GRBPIC will be called
C automatically before the first output; omitting the call here
C ensures that a blank page is not output.)
C
          CALL GRQTYP(STR,INTER)
          IF (INTER) CALL GRBPIC
      END IF
      PGXOFF(PGID) = PGXVP(PGID) + (PGNXC(PGID)-1)*PGXSZ(PGID)
      PGYOFF(PGID) = PGYVP(PGID) + 
     1               (PGNY(PGID)-PGNYC(PGID))*PGYSZ(PGID)
C
C Window the plot in the new viewport.
C
      CALL PGVW
      PGADVS(PGID) = 1
      CALL GRTERM
      END

C*PGQLS -- inquire line style
C%void cpgqls(int *ls);
C+
      SUBROUTINE PGQLS (LS)
      INTEGER  LS
C
C Query the current Line Style attribute (set by routine PGSLS).
C
C Argument:
C  LS     (output) : the current line-style attribute (in range 1-5).
C--
C  5-Nov-1985 - new routine [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGQLS')) THEN
         LS = 1
      ELSE
         CALL GRQLS(LS)
      END IF
      END

      PROGRAM PGDEM1
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT. The main program opens the output
C device and calls a series of subroutines, one for each sample plot.
C-----------------------------------------------------------------------
      INTEGER PGOPEN
C
C Call PGOPEN to initiate PGPLOT and open the output device; PGOPEN
C will prompt the user to supply the device name and type. Always
C check the return code from PGOPEN.
C
      IF (PGOPEN('?') .LE. 0) STOP
C
C Print information about device.
C
      CALL PGEX0
C
C Call the demonstration subroutines (4,5 are put on one page)
C
      CALL PGEX1
      CALL PGEX2
      CALL PGEX3
      CALL PGSUBP(2,1)
      CALL PGEX4
      CALL PGEX5
      CALL PGSUBP(1,1)
      CALL PGEX6
      CALL PGEX7
      CALL PGEX8
      CALL PGEX9
      CALL PGEX10
      CALL PGEX11
      CALL PGEX12
      CALL PGEX13
      CALL PGEX14
      CALL PGEX15
C
C Finally, call PGCLOS to terminate things properly.
C
      CALL PGCLOS
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX0
C-----------------------------------------------------------------------
C This subroutine tests PGQINF and displays the information returned on
C the standard output.
C-----------------------------------------------------------------------
      CHARACTER*64 VALUE
      INTEGER LENGTH
      REAL X, Y, X1, X2, Y1, Y2
C
C Information available from PGQINF:
C
      CALL PGQINF('version',  VALUE, LENGTH)
      WRITE (*,*) 'version=', VALUE(:LENGTH)
      CALL PGQINF('state',    VALUE, LENGTH)
      WRITE (*,*) 'state=',   VALUE(:LENGTH)
      CALL PGQINF('user',     VALUE, LENGTH)
      WRITE (*,*) 'user=',    VALUE(:LENGTH)
      CALL PGQINF('now',      VALUE, LENGTH)
      WRITE (*,*) 'now=',     VALUE(:LENGTH)
      CALL PGQINF('device',   VALUE, LENGTH)
      WRITE (*,*) 'device=',  VALUE(:LENGTH)
      CALL PGQINF('file',     VALUE, LENGTH)
      WRITE (*,*) 'file=',    VALUE(:LENGTH)
      CALL PGQINF('type',     VALUE, LENGTH)
      WRITE (*,*) 'type=',    VALUE(:LENGTH)
      CALL PGQINF('dev/type', VALUE, LENGTH)
      WRITE (*,*) 'dev/type=',VALUE(:LENGTH)
      CALL PGQINF('hardcopy', VALUE, LENGTH)
      WRITE (*,*) 'hardcopy=',VALUE(:LENGTH)
      CALL PGQINF('terminal', VALUE, LENGTH)
      WRITE (*,*) 'terminal=',VALUE(:LENGTH)
      CALL PGQINF('cursor',   VALUE, LENGTH)
      WRITE (*,*) 'cursor=',  VALUE(:LENGTH)
C
C Get view surface dimensions:
C
      CALL PGQVSZ(1, X1, X2, Y1, Y2)
      X = X2-X1
      Y = Y2-Y1
      WRITE (*,100) X, Y, X*25.4, Y*25.4
  100 FORMAT (' Plot dimensions (x,y; inches): ',F9.2,', ',F9.2/
     1        '                          (mm): ',F9.2,', ',F9.2)
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX1
C-----------------------------------------------------------------------
C This example illustrates the use of PGENV, PGLAB, PGPT, PGLINE.
C-----------------------------------------------------------------------
      INTEGER I
      REAL XS(5),YS(5), XR(100), YR(100)
      DATA XS/1.,2.,3.,4.,5./
      DATA YS/1.,4.,9.,16.,25./
C
C Call PGENV to specify the range of the axes and to draw a box, and
C PGLAB to label it. The x-axis runs from 0 to 10, and y from 0 to 20.
C
      CALL PGENV(0.,10.,0.,20.,0,1)
      CALL PGLAB('(x)', '(y)', 'PGPLOT Example 1:  y = x\u2')
C
C Mark five points (coordinates in arrays XS and YS), using symbol
C number 9.
C
      CALL PGPT(5,XS,YS,9)
C
C Compute the function at 60 points, and use PGLINE to draw it.
C
      DO 10 I=1,60
          XR(I) = 0.1*I
          YR(I) = XR(I)**2
   10 CONTINUE
      CALL PGLINE(60,XR,YR)
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX2
C-----------------------------------------------------------------------
C Repeat the process for another graph. This one is a graph of the
C sinc (sin x over x) function.
C-----------------------------------------------------------------------
      INTEGER I
      REAL XR(100), YR(100)
C
      CALL PGENV(-2.,10.,-0.4,1.2,0,1)
      CALL PGLAB('(x)', 'sin(x)/x', 
     $             'PGPLOT Example 2:  Sinc Function')
      DO 20 I=1,100
          XR(I) = (I-20)/6.
          YR(I) = 1.0
          IF (XR(I).NE.0.0) YR(I) = SIN(XR(I))/XR(I)
   20 CONTINUE
      CALL PGLINE(100,XR,YR)
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX3
C----------------------------------------------------------------------
C This example illustrates the use of PGBOX and attribute routines to
C mix colors and line-styles.
C----------------------------------------------------------------------
      REAL PI
      PARAMETER (PI=3.14159265359)
      INTEGER I
      REAL XR(360), YR(360)
      REAL ARG
C
C Call PGENV to initialize the viewport and window; the
C AXIS argument is -2, so no frame or labels will be drawn.
C
      CALL PGENV(0.,720.,-2.0,2.0,0,-2)
      CALL PGSAVE
C
C Set the color index for the axes and grid (index 5 = cyan).
C Call PGBOX to draw first a grid at low brightness, and then a
C frame and axes at full brightness. Note that as the x-axis is
C to represent an angle in degrees, we request an explicit tick 
C interval of 90 deg with subdivisions at 30 deg, as multiples of
C 3 are a more natural division than the default.
C
      CALL PGSCI(14)
      CALL PGBOX('G',30.0,0,'G',0.2,0)
      CALL PGSCI(5)
      CALL PGBOX('ABCTSN',90.0,3,'ABCTSNV',0.0,0)
C
C Call PGLAB to label the graph in a different color (3=green).
C
      CALL PGSCI(3)
      CALL PGLAB('x (degrees)','f(x)','PGPLOT Example 3')
C
C Compute the function to be plotted: a trig function of an
C angle in degrees, computed every 2 degrees.
C
      DO 20 I=1,360
          XR(I) = 2.0*I
          ARG = XR(I)/180.0*PI
          YR(I) = SIN(ARG) + 0.5*COS(2.0*ARG) + 
     1                0.5*SIN(1.5*ARG+PI/3.0)
   20 CONTINUE
C
C Change the color (6=magenta), line-style (2=dashed), and line
C width and draw the function.
C
      CALL PGSCI(6)
      CALL PGSLS(2)
      CALL PGSLW(3)
      CALL PGLINE(360,XR,YR)
C
C Restore attributes to defaults.
C
      CALL PGUNSA
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX4
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT: draw histograms.
C-----------------------------------------------------------------------
      REAL PI
      PARAMETER (PI=3.14159265359)
      INTEGER  I, ISEED
      REAL     DATA(1000), X(620), Y(620)
      REAL     PGRNRM
C
C Call PGRNRM to obtain 1000 samples from a normal distribution.
C
      ISEED = -5678921
      DO 10 I=1,1000
          DATA(I) = PGRNRM(ISEED)
   10 CONTINUE
C
C Draw a histogram of these values.
C
      CALL PGSAVE
      CALL PGHIST(1000,DATA,-3.1,3.1,31,0)
C
C Samples from another normal distribution.
C
      DO 15 I=1,200
          DATA(I) = 1.0+0.5*PGRNRM(ISEED)
   15 CONTINUE
C
C Draw another histogram (filled) on same axes.
C
      CALL PGSCI(15)
      CALL PGHIST(200,DATA,-3.1,3.1,31,3)
      CALL PGSCI(0)
      CALL PGHIST(200,DATA,-3.1,3.1,31,1)
      CALL PGSCI(1)
C
C Redraw the box which may have been clobbered by the histogram.
C
      CALL PGBOX('BST', 0.0, 0, ' ', 0.0, 0)
C
C Label the plot.
C
      CALL PGLAB('Variate', ' ',
     $             'PGPLOT Example 4:  Histograms (Gaussian)')
C
C Superimpose the theoretical distribution.
C
      DO 20 I=1,620
          X(I) = -3.1 + 0.01*(I-1)
          Y(I) = 0.2*1000./SQRT(2.0*PI)*EXP(-0.5*X(I)*X(I))
   20 CONTINUE
      CALL PGLINE(620,X,Y)
      CALL PGUNSA
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX5
C----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package.  This example
C illustrates how to draw a log-log plot.
C PGPLOT subroutines demonstrated:
C    PGENV, PGERRY, PGLAB, PGLINE, PGPT, PGSCI.
C----------------------------------------------------------------------
      INTEGER   RED, GREEN, CYAN
      PARAMETER (RED=2)
      PARAMETER (GREEN=3)
      PARAMETER (CYAN=5)
      INTEGER   NP
      PARAMETER (NP=15)
      INTEGER   I
      REAL      X, YLO(NP), YHI(NP)
      REAL      FREQ(NP), FLUX(NP), XP(100), YP(100), ERR(NP)
      DATA FREQ / 26., 38., 80., 160., 178., 318.,
     1            365., 408., 750., 1400., 2695., 2700.,
     2            5000., 10695., 14900. /
      DATA FLUX / 38.0, 66.4, 89.0, 69.8, 55.9, 37.4,
     1            46.8, 42.4, 27.0, 15.8, 9.09, 9.17,
     2            5.35, 2.56, 1.73 /
      DATA ERR  / 6.0, 6.0, 13.0, 9.1, 2.9, 1.4,
     1            2.7, 3.0, 0.34, 0.8, 0.2, 0.46,
     2            0.15, 0.08, 0.01 /
C
C Call PGENV to initialize the viewport and window; the AXIS argument 
C is 30 so both axes will be logarithmic. The X-axis (frequency) runs 
C from 0.01 to 100 GHz, the Y-axis (flux density) runs from 0.3 to 300
C Jy. Note that it is necessary to specify the logarithms of these
C quantities in the call to PGENV. We request equal scales in x and y
C so that slopes will be correct.  Use PGLAB to label the graph.
C
      CALL PGSAVE
      CALL PGSCI(CYAN)
      CALL PGENV(-2.0,2.0,-0.5,2.5,1,30)
      CALL PGLAB('Frequency, \gn (GHz)',
     1             'Flux Density, S\d\gn\u (Jy)',
     2             'PGPLOT Example 5:  Log-Log plot')
C
C Draw a fit to the spectrum (don't ask how this was chosen). This 
C curve is drawn before the data points, so that the data will write 
C over the curve, rather than vice versa.
C
      DO 10 I=1,100
          X = 1.3 + I*0.03
          XP(I) = X-3.0
          YP(I) = 5.18 - 1.15*X -7.72*EXP(-X)
   10 CONTINUE
      CALL PGSCI(RED)
      CALL PGLINE(100,XP,YP)
C
C Plot the measured flux densities: here the data are installed with a
C DATA statement; in a more general program, they might be read from a
C file. We first have to take logarithms (the -3.0 converts MHz to GHz).
C
      DO 20 I=1,NP
          XP(I) = ALOG10(FREQ(I))-3.0
          YP(I) = ALOG10(FLUX(I))
   20 CONTINUE
      CALL PGSCI(GREEN)
      CALL PGPT(NP, XP, YP, 17)
C
C Draw +/- 2 sigma error bars: take logs of both limits.
C
      DO 30 I=1,NP
          YHI(I) = ALOG10(FLUX(I)+2.*ERR(I))
          YLO(I) = ALOG10(FLUX(I)-2.*ERR(I))
   30 CONTINUE
      CALL PGERRY(NP,XP,YLO,YHI,1.0)
      CALL PGUNSA
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX6
C----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package.  This example
C illustrates the use of PGPOLY, PGCIRC, and PGRECT using SOLID, 
C OUTLINE, HATCHED, and CROSS-HATCHED fill-area attributes.
C----------------------------------------------------------------------
      REAL PI, TWOPI
      PARAMETER (PI=3.14159265359)
      PARAMETER (TWOPI=2.0*PI)
      INTEGER NPOL
      PARAMETER (NPOL=6)
      INTEGER I, J, N1(NPOL), N2(NPOL), K
      REAL X(10), Y(10), Y0, ANGLE
      CHARACTER*32 LAB(4)
      DATA N1 / 3, 4, 5, 5, 6, 8 /
      DATA N2 / 1, 1, 1, 2, 1, 3 /
      DATA LAB(1) /'Fill style 1 (solid)'/
      DATA LAB(2) /'Fill style 2 (outline)'/
      DATA LAB(3) /'Fill style 3 (hatched)'/
      DATA LAB(4) /'Fill style 4 (cross-hatched)'/
C
C Initialize the viewport and window.
C
      CALL PGBBUF
      CALL PGSAVE
      CALL PGPAGE
      CALL PGSVP(0.0, 1.0, 0.0, 1.0)
      CALL PGWNAD(0.0, 10.0, 0.0, 10.0)
C
C Label the graph.
C
      CALL PGSCI(1)
      CALL PGMTXT('T', -2.0, 0.5, 0.5, 
     :     'PGPLOT fill area: routines PGPOLY, PGCIRC, PGRECT')
C
C Draw assorted polygons.
C
      DO 30 K=1,4
         CALL PGSCI(1)
         Y0 = 10.0 - 2.0*K
         CALL PGTEXT(0.2, Y0+0.6, LAB(K))
         CALL PGSFS(K)
         DO 20 I=1,NPOL
            CALL PGSCI(I)
            DO 10 J=1,N1(I)
               ANGLE = REAL(N2(I))*TWOPI*REAL(J-1)/REAL(N1(I))
               X(J) = I + 0.5*COS(ANGLE)
               Y(J) = Y0 + 0.5*SIN(ANGLE)
 10         CONTINUE
            CALL PGPOLY (N1(I),X,Y)
 20      CONTINUE
         CALL PGSCI(7)
         CALL PGCIRC(7.0, Y0, 0.5)
         CALL PGSCI(8)
         CALL PGRECT(7.8, 9.5, Y0-0.5, Y0+0.5)
 30   CONTINUE
C
      CALL PGUNSA
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX7
C-----------------------------------------------------------------------
C A plot with a large number of symbols; plus test of PGERR1.
C-----------------------------------------------------------------------
      INTEGER I, ISEED
      REAL XS(300),YS(300), XR(101), YR(101), XP, YP, XSIG, YSIG
      REAL PGRAND, PGRNRM
C
C Window and axes.
C
      CALL PGBBUF
      CALL PGSAVE
      CALL PGSCI(1)
      CALL PGENV(0.,5.,-0.3,0.6,0,1)
      CALL PGLAB('\fix', '\fiy', 'PGPLOT Example 7: scatter plot')
C
C Random data points.
C
      ISEED = -45678921
      DO 10 I=1,300
          XS(I) = 5.0*PGRAND(ISEED)
          YS(I) = XS(I)*EXP(-XS(I)) + 0.05*PGRNRM(ISEED)
   10 CONTINUE
      CALL PGSCI(3)
      CALL PGPT(100,XS,YS,3)
      CALL PGPT(100,XS(101),YS(101),17)
      CALL PGPT(100,XS(201),YS(201),21)
C
C Curve defining parent distribution.
C
      DO 20 I=1,101
          XR(I) = 0.05*(I-1)
          YR(I) = XR(I)*EXP(-XR(I))
   20 CONTINUE
      CALL PGSCI(2)
      CALL PGLINE(101,XR,YR)
C
C Test of PGERR1/PGPT1.
C
      XP = XS(101)
      YP = YS(101)
      XSIG = 0.2
      YSIG = 0.1
      CALL PGSCI(5)
      CALL PGSCH(3.0)
      CALL PGERR1(5, XP, YP, XSIG, 1.0)
      CALL PGERR1(6, XP, YP, YSIG, 1.0)
      CALL PGPT1(XP,YP,21)
C
      CALL PGUNSA
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX8
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT. This program shows some of the
C possibilities for overlapping windows and viewports.
C T. J. Pearson  1986 Nov 28
C-----------------------------------------------------------------------
      INTEGER I
      REAL XR(720), YR(720)
C-----------------------------------------------------------------------
C Color index:
      INTEGER BLACK, WHITE, RED, GREEN, BLUE, CYAN, MAGENT, YELLOW
      PARAMETER (BLACK=0)
      PARAMETER (WHITE=1)
      PARAMETER (RED=2)
      PARAMETER (GREEN=3)
      PARAMETER (BLUE=4)
      PARAMETER (CYAN=5)
      PARAMETER (MAGENT=6)
      PARAMETER (YELLOW=7)
C Line style:
      INTEGER FULL, DASHED, DOTDSH, DOTTED, FANCY
      PARAMETER (FULL=1)
      PARAMETER (DASHED=2)
      PARAMETER (DOTDSH=3)
      PARAMETER (DOTTED=4)
      PARAMETER (FANCY=5)
C Character font:
      INTEGER NORMAL, ROMAN, ITALIC, SCRIPT
      PARAMETER (NORMAL=1)
      PARAMETER (ROMAN=2)
      PARAMETER (ITALIC=3)
      PARAMETER (SCRIPT=4)
C Fill-area style:
      INTEGER SOLID, HOLLOW
      PARAMETER (SOLID=1)
      PARAMETER (HOLLOW=2)
C-----------------------------------------------------------------------
C
      CALL PGPAGE
      CALL PGBBUF
      CALL PGSAVE
C
C Define the Viewport
C
      CALL PGSVP(0.1,0.6,0.1,0.6)
C
C Define the Window
C
      CALL PGSWIN(0.0, 630.0, -2.0, 2.0)
C
C Draw a box
C
      CALL PGSCI(CYAN)
      CALL PGBOX ('ABCTS', 90.0, 3, 'ABCTSV', 0.0, 0)
C
C Draw labels
C
      CALL PGSCI (RED)
      CALL PGBOX ('N',90.0, 3, 'VN', 0.0, 0)
C
C Draw SIN line
C
      DO 10 I=1,360
          XR(I) = 2.0*I
          YR(I) = SIN(XR(I)/57.29577951)
   10 CONTINUE
      CALL PGSCI (MAGENT)
      CALL PGSLS (DASHED)
      CALL PGLINE (360,XR,YR)
C
C Draw COS line by redefining the window
C
      CALL PGSWIN (90.0, 720.0, -2.0, 2.0)
      CALL PGSCI (YELLOW)
      CALL PGSLS (DOTTED)
      CALL PGLINE (360,XR,YR)
      CALL PGSLS (FULL)
C
C Re-Define the Viewport
C
      CALL PGSVP(0.45,0.85,0.45,0.85)
C
C Define the Window, and erase it
C
      CALL PGSWIN(0.0, 180.0, -2.0, 2.0)
      CALL PGSCI(0)
      CALL PGRECT(0.0, 180., -2.0, 2.0)
C
C Draw a box
C
      CALL PGSCI(BLUE)
      CALL PGBOX ('ABCTSM', 60.0, 3, 'VABCTSM', 1.0, 2)
C
C Draw SIN line
C
      CALL PGSCI (WHITE)
      CALL PGSLS (DASHED)
      CALL PGLINE (360,XR,YR)
C
      CALL PGUNSA
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX9
C----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package.  This example
C illustrates curve drawing with PGFUNT; the parametric curve drawn is
C a simple Lissajous figure.
C                              T. J. Pearson  1983 Oct 5
C----------------------------------------------------------------------
      REAL PI, TWOPI
      PARAMETER (PI=3.14159265359)
      PARAMETER (TWOPI=2.0*PI)
      REAL     FX, FY
      EXTERNAL FX, FY
C
C Call PGFUNT to draw the function (autoscaling).
C
      CALL PGBBUF
      CALL PGSAVE
      CALL PGSCI(5)
      CALL PGFUNT(FX,FY,360,0.0,TWOPI,0)
C
C Call PGLAB to label the graph in a different color.
C
      CALL PGSCI(3)
      CALL PGLAB('x','y','PGPLOT Example 9:  routine PGFUNT')
      CALL PGUNSA
      CALL PGEBUF
C
      END

      REAL FUNCTION FX(T)
      REAL T
      FX = SIN(T*5.0)
      RETURN
      END

      REAL FUNCTION FY(T)
      REAL T
      FY = SIN(T*4.0)
      RETURN
      END

      SUBROUTINE PGEX10
C----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package.  This example
C illustrates curve drawing with PGFUNX.
C                              T. J. Pearson  1983 Oct 5
C----------------------------------------------------------------------
      REAL PI
      PARAMETER (PI=3.14159265359)
C The following define mnemonic names for the color indices and
C linestyle codes.
      INTEGER   BLACK, WHITE, RED, GREEN, BLUE, CYAN, MAGENT, YELLOW
      PARAMETER (BLACK=0)
      PARAMETER (WHITE=1)
      PARAMETER (RED=2)
      PARAMETER (GREEN=3)
      PARAMETER (BLUE=4)
      PARAMETER (CYAN=5)
      PARAMETER (MAGENT=6)
      PARAMETER (YELLOW=7)
      INTEGER   FULL, DASH, DOTD
      PARAMETER (FULL=1)
      PARAMETER (DASH=2)
      PARAMETER (DOTD=3)
C
C The Fortran functions to be plotted must be declared EXTERNAL.
C
      REAL     PGBSJ0, PGBSJ1
      EXTERNAL PGBSJ0, PGBSJ1
C
C Call PGFUNX twice to draw two functions (autoscaling the first time).
C
      CALL PGBBUF
      CALL PGSAVE
      CALL PGSCI(YELLOW)
      CALL PGFUNX(PGBSJ0,500,0.0,10.0*PI,0)
      CALL PGSCI(RED)
      CALL PGSLS(DASH)
      CALL PGFUNX(PGBSJ1,500,0.0,10.0*PI,1)
C
C Call PGLAB to label the graph in a different color. Note the
C use of "\f" to change font.  Use PGMTXT to write an additional
C legend inside the viewport.
C
      CALL PGSCI(GREEN)
      CALL PGSLS(FULL)
      CALL PGLAB('\fix', '\fiy',
     2           '\frPGPLOT Example 10: routine PGFUNX')
      CALL PGMTXT('T', -4.0, 0.5, 0.5,
     1     '\frBessel Functions')
C
C Call PGARRO to label the curves.
C
      CALL PGARRO(8.0, 0.7, 1.0, PGBSJ0(1.0))
      CALL PGARRO(12.0, 0.5, 9.0, PGBSJ1(9.0))
      CALL PGSTBG(GREEN)
      CALL PGSCI(0)
      CALL PGPTXT(8.0, 0.7, 0.0, 0.0, ' \fiy = J\d0\u(x)')
      CALL PGPTXT(12.0, 0.5, 0.0, 0.0, ' \fiy = J\d1\u(x)')
      CALL PGUNSA
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX11
C-----------------------------------------------------------------------
C Test routine for PGPLOT: draws a skeletal dodecahedron.
C-----------------------------------------------------------------------
      INTEGER NVERT
      REAL T, T1, T2, T3
      PARAMETER (NVERT=20)
      PARAMETER (T=1.618)
      PARAMETER (T1=1.0+T)
      PARAMETER (T2=-1.0*T)
      PARAMETER (T3=-1.0*T1)
      INTEGER I, J, K
      REAL VERT(3,NVERT), R, ZZ
      REAL X(2),Y(2)
C
C Cartesian coordinates of the 20 vertices.
C
      DATA VERT/ T, T, T,       T, T,T2,
     3           T,T2, T,       T,T2,T2,
     5          T2, T, T,      T2, T,T2,
     7          T2,T2, T,      T2,T2,T2,
     9          T1,1.0,0.0,    T1,-1.0,0.0,
     B          T3,1.0,0.0,    T3,-1.0,0.0,
     D          0.0,T1,1.0,    0.0,T1,-1.0,
     F          0.0,T3,1.0,    0.0,T3,-1.0,
     H          1.0,0.0,T1,    -1.0,0.0,T1,
     J          1.0,0.0,T3,   -1.0,0.0,T3 /
C
C Initialize the plot (no labels).
C
      CALL PGBBUF
      CALL PGSAVE
      CALL PGENV(-4.,4.,-4.,4.,1,-2)
      CALL PGSCI(2)
      CALL PGSLS(1)
      CALL PGSLW(1)
C
C Write a heading.
C
      CALL PGLAB(' ',' ','PGPLOT Example 11:  Dodecahedron')
C
C Mark the vertices.
C
      DO 2 I=1,NVERT
          ZZ = VERT(3,I)
          CALL PGPT1(VERT(1,I)+0.2*ZZ,VERT(2,I)+0.3*ZZ,9)
    2 CONTINUE
C
C Draw the edges - test all vertex pairs to find the edges of the 
C correct length.
C
      CALL PGSLW(3)
      DO 20 I=2,NVERT
          DO 10 J=1,I-1
              R = 0.
              DO 5 K=1,3
                  R = R + (VERT(K,I)-VERT(K,J))**2
    5         CONTINUE
              R = SQRT(R)
              IF(ABS(R-2.0).GT.0.1) GOTO 10
              ZZ = VERT(3,I)
              X(1) = VERT(1,I)+0.2*ZZ
              Y(1) = VERT(2,I)+0.3*ZZ
              ZZ = VERT(3,J)
              X(2) = VERT(1,J)+0.2*ZZ
              Y(2) = VERT(2,J)+0.3*ZZ
              CALL PGLINE(2,X,Y)
   10     CONTINUE
   20 CONTINUE
      CALL PGUNSA
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX12
C-----------------------------------------------------------------------
C Test routine for PGPLOT: draw arrows with PGARRO.
C-----------------------------------------------------------------------
      INTEGER NV, I, K
      REAL A, D, X, Y, XT, YT
C
C Number of arrows.
C
      NV =16
C
C Select a square viewport.
C
      CALL PGBBUF
      CALL PGSAVE
      CALL PGSCH(0.7)
      CALL PGSCI(2)
      CALL PGENV(-1.05,1.05,-1.05,1.05,1,-1)
      CALL PGLAB(' ', ' ', 'PGPLOT Example 12: PGARRO')
      CALL PGSCI(1)
C
C Draw the arrows
C
      K = 1
      D = 360.0/57.29577951/NV
      A = -D
      DO 20 I=1,NV
          A = A+D
          X = COS(A)
          Y = SIN(A)
          XT = 0.2*COS(A-D)
          YT = 0.2*SIN(A-D)
          CALL PGSAH(K, 80.0-3.0*I, 0.5*REAL(I)/REAL(NV))
          CALL PGSCH(0.25*I)
          CALL PGARRO(XT, YT, X, Y)
          K = K+1
          IF (K.GT.2) K=1
   20 CONTINUE
C
      CALL PGUNSA
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX13
C----------------------------------------------------------------------
C This example illustrates the use of PGTBOX.
C----------------------------------------------------------------------
      INTEGER N
      PARAMETER (N=10)
      INTEGER I
      REAL X1(N), X2(N)
      CHARACTER*20 XOPT(N), BSL*1
      DATA X1 /   4*0.0, -8000.0, 100.3, 205.3, -45000.0, 2*0.0/
      DATA X2 /4*8000.0,  8000.0, 101.3, 201.1, 3*-100000.0/
      DATA XOPT / 'BSTN', 'BSTNZ', 'BSTNZH', 'BSTNZD', 'BSNTZHFO', 
     :      'BSTNZD', 'BSTNZHI', 'BSTNZHP', 'BSTNZDY', 'BSNTZHFOY'/
C
      BSL = CHAR(92)
      CALL PGPAGE
      CALL PGSAVE
      CALL PGBBUF
      CALL PGSCH(0.7)
      DO 100 I=1,N
        CALL PGSVP(0.15, 0.85, (0.7+REAL(N-I))/REAL(N), 
     :                         (0.7+REAL(N-I+1))/REAL(N)) 
        CALL PGSWIN(X1(I), X2(I), 0.0, 1.0)
        CALL PGTBOX(XOPT(I),0.0,0,' ',0.0,0)
        CALL PGLAB('Option = '//XOPT(I), ' ', ' ')
        IF (I.EQ.1) THEN
           CALL PGMTXT('B', -1.0, 0.5, 0.5, 
     :                 BSL//'fiAxes drawn with PGTBOX')
        END IF
  100 CONTINUE
      CALL PGEBUF
      CALL PGUNSA
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX14
C-----------------------------------------------------------------------
C Test routine for PGPLOT: polygon fill and color representation.
C-----------------------------------------------------------------------
      INTEGER I, J, N, M
      REAL PI, THINC, R, G, B, THETA
      REAL XI(100),YI(100),XO(100),YO(100),XT(3),YT(3)
      PARAMETER (PI=3.14159265359)
C
      N = 33
      M = 8
      THINC=2.0*PI/N
      DO 10 I=1,N
        XI(I) = 0.0
        YI(I) = 0.0
   10 CONTINUE
      CALL PGBBUF
      CALL PGSAVE
      CALL PGENV(-1.,1.,-1.,1.,1,-2)
      CALL PGLAB(' ', ' ', 'PGPLOT Example 14: PGPOLY and PGSCR')
      DO 50 J=1,M
        R = 1.0
        G = 1.0 - REAL(J)/REAL(M)
        B = G
        CALL PGSCR(J, R, G, B)
        THETA = -REAL(J)*PI/REAL(N)
        R = REAL(J)/REAL(M)
        DO 20 I=1,N
          THETA = THETA+THINC
          XO(I) = R*COS(THETA)
          YO(I) = R*SIN(THETA)
   20   CONTINUE
        DO 30 I=1,N
          XT(1) = XO(I)
          YT(1) = YO(I)
          XT(2) = XO(MOD(I,N)+1)
          YT(2) = YO(MOD(I,N)+1)
          XT(3) = XI(I)
          YT(3) = YI(I)
          CALL PGSCI(J)
          CALL PGSFS(1)
          CALL PGPOLY(3,XT,YT)
          CALL PGSFS(2)
          CALL PGSCI(1)
          CALL PGPOLY(3,XT,YT)
   30   CONTINUE
        DO 40 I=1,N
          XI(I) = XO(I)
          YI(I) = YO(I)
   40   CONTINUE
   50 CONTINUE
      CALL PGUNSA
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX15
C----------------------------------------------------------------------
C This is a line-drawing test; it draws a regular n-gon joining
C each vertex to every other vertex. It is not optimized for pen
C plotters.
C----------------------------------------------------------------------
      INTEGER I, J, NV
      REAL A, D, X(100), Y(100)
C
C Set the number of vertices, and compute the 
C coordinates for unit circumradius.
C
      NV = 17
      D = 360.0/NV
      A = -D
      DO 20 I=1,NV
          A = A+D
          X(I) = COS(A/57.29577951)
          Y(I) = SIN(A/57.29577951)
   20 CONTINUE
C
C Select a square viewport.
C
      CALL PGBBUF
      CALL PGSAVE
      CALL PGSCH(0.5)
      CALL PGSCI(2)
      CALL PGENV(-1.05,1.05,-1.05,1.05,1,-1)
      CALL PGLAB(' ', ' ', 'PGPLOT Example 15: PGMOVE and PGDRAW')
      CALL PGSCR(0,0.2,0.3,0.3)
      CALL PGSCR(1,1.0,0.5,0.2)
      CALL PGSCR(2,0.2,0.5,1.0)
      CALL PGSCI(1)
C
C Draw the polygon.
C
      DO 40 I=1,NV-1
          DO 30 J=I+1,NV
            CALL PGMOVE(X(I),Y(I))
            CALL PGDRAW(X(J),Y(J))
   30     CONTINUE
   40 CONTINUE
C
C Flush the buffer.
C
      CALL PGUNSA
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      REAL FUNCTION PGBSJ0(XX)
      REAL XX
C-----------------------------------------------------------------------
C Bessel function of order 0 (approximate).
C Reference: Abramowitz and Stegun: Handbook of Mathematical Functions.
C-----------------------------------------------------------------------
      REAL X, XO3, T, F0, THETA0
C     
      X = ABS(XX)
      IF (X .LE. 3.0) THEN
         XO3 = X/3.0
         T   = XO3*XO3
         PGBSJ0 = 1.0 + T*(-2.2499997 +
     1                  T*( 1.2656208 +
     2                  T*(-0.3163866 +
     3                  T*( 0.0444479 +
     4                  T*(-0.0039444 +
     5                  T*( 0.0002100))))))
      ELSE
         T = 3.0/X
         F0 =     0.79788456 +
     1        T*(-0.00000077 + 
     2        T*(-0.00552740 +
     3        T*(-0.00009512 +
     4        T*( 0.00137237 +
     5        T*(-0.00072805 +
     6        T*( 0.00014476))))))
         THETA0 = X - 0.78539816 +
     1            T*(-0.04166397 +
     2            T*(-0.00003954 +
     3            T*( 0.00262573 +
     4            T*(-0.00054125 +
     5            T*(-0.00029333 +
     6            T*( 0.00013558))))))
         PGBSJ0 = F0*COS(THETA0)/SQRT(X)
      END IF
C-----------------------------------------------------------------------
      END

      REAL FUNCTION PGBSJ1(XX)
      REAL XX
C-----------------------------------------------------------------------
C Bessel function of order 1 (approximate).
C Reference: Abramowitz and Stegun: Handbook of Mathematical Functions.
C-----------------------------------------------------------------------
      REAL X, XO3, T, F1, THETA1
C
      X = ABS(XX)
      IF (X .LE. 3.0) THEN
         XO3 = X/3.0
         T = XO3*XO3
         PGBSJ1 = 0.5 + T*(-0.56249985 +
     1                  T*( 0.21093573 +
     2                  T*(-0.03954289 +
     3                  T*( 0.00443319 +
     4                  T*(-0.00031761 +
     5                  T*( 0.00001109))))))
         PGBSJ1 = PGBSJ1*XX
      ELSE
         T = 3.0/X
         F1 =    0.79788456 +
     1       T*( 0.00000156 +
     2       T*( 0.01659667 + 
     3       T*( 0.00017105 +
     4       T*(-0.00249511 +
     5       T*( 0.00113653 + 
     6       T*(-0.00020033))))))
         THETA1 = X   -2.35619449 + 
     1             T*( 0.12499612 +
     2             T*( 0.00005650 +
     3             T*(-0.00637879 +
     4             T*( 0.00074348 +
     5             T*( 0.00079824 +
     6             T*(-0.00029166))))))
         PGBSJ1 = F1*COS(THETA1)/SQRT(X)
      END IF
      IF (XX .LT. 0.0) PGBSJ1 = -PGBSJ1
C-----------------------------------------------------------------------
      END

      REAL FUNCTION PGRNRM (ISEED)
      INTEGER ISEED
C-----------------------------------------------------------------------
C Returns a normally distributed deviate with zero mean and unit 
C variance. The routine uses the Box-Muller transformation of uniform
C deviates. For a more efficient implementation of this algorithm,
C see Press et al., Numerical Recipes, Sec. 7.2.
C
C Arguments:
C  ISEED  (in/out) : seed used for PGRAND random-number generator.
C
C Subroutines required:
C  PGRAND -- return a uniform random deviate between 0 and 1.
C
C History:
C  1995 Dec 12 - TJP.
C-----------------------------------------------------------------------
      REAL R, X, Y, PGRAND
C
 10   X = 2.0*PGRAND(ISEED) - 1.0
      Y = 2.0*PGRAND(ISEED) - 1.0
      R = X**2 + Y**2
      IF (R.GE.1.0) GOTO 10
      PGRNRM = X*SQRT(-2.0*LOG(R)/R)
C-----------------------------------------------------------------------
      END

      REAL FUNCTION PGRAND(ISEED)
      INTEGER ISEED
C-----------------------------------------------------------------------
C Returns a uniform random deviate between 0.0 and 1.0.
C
C NOTE: this is not a good random-number generator; it is only
C intended for exercising the PGPLOT routines.
C
C Based on: Park and Miller's "Minimal Standard" random number
C   generator (Comm. ACM, 31, 1192, 1988)
C
C Arguments:
C  ISEED  (in/out) : seed.
C-----------------------------------------------------------------------
      INTEGER   IM, IA, IQ, IR
      PARAMETER (IM=2147483647)
      PARAMETER (IA=16807, IQ=127773, IR= 2836)
      REAL      AM
      PARAMETER (AM=128.0/IM)
      INTEGER   K
C-
      K = ISEED/IQ
      ISEED = IA*(ISEED-K*IQ) - IR*K
      IF (ISEED.LT.0) ISEED = ISEED+IM
      PGRAND = AM*(ISEED/128)
      RETURN
      END

C*GRLIN2 -- draw a normal line
C+
      SUBROUTINE GRLIN2 (X0,Y0,X1,Y1)
C
C GRPCKG : plot a visible line segment in absolute coords from
C (X0,Y0) to (X1,Y1).  The endpoints of the line segment are rounded
C to the nearest integer and passed to the appropriate device-specific
C routine. It is assumed that the entire line-segment lies within the
C view surface, and that the physical device coordinates are
C non-negative.
C--
C (1-Jun-1984)
C 19-Oct-1984 - rewritten for speed [TJP].
C 29-Jan-1985 - add HP2648 device [KS/TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 21-Feb-1987 - If needed, calls begin picture [AFT].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL    X0,Y0,X1,Y1
      REAL    RBUF(6)
      INTEGER NBUF,LCHR
      CHARACTER CHR
C
C- If this is first thing plotted then set something plotted flag
C- and for a GREXEC device call BEGIN_PICTURE.
C
      IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
C---
      RBUF(1)=X0
      RBUF(2)=Y0
      RBUF(3)=X1
      RBUF(4)=Y1
      NBUF=4
C     WRITE(*,'(A,4F10.5)') 'GRLIN2',RBUF(1), RBUF(2), RBUF(3), RBUF(4)
      CALL GREXEC(GRGTYP,12,RBUF,NBUF,CHR,LCHR)
C
      END

C*XEDRIV -- PGPLOT driver for VAX workstations with DECWindows software
C+
      SUBROUTINE XEDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      IMPLICIT NONE
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for VAX workstations running DECWindows.
C
C Version 1.0 - 1989 Apr 15 - S. C. Allendorf
C                             Initial try (DWDRIVER.FOR).
C Version 2.0 - 1990 Mar 25 - S. C. Allendorf
C                             Merge functionality with Al Fey's C
C                             version for XWindows (XWDRIVER.C).
C Version 2.1 - 1990 Apr 03 - S. C. Allendorf
C                             Add asynchronous event handler and add
C                             code to implement a backing store.
C Version 2.2 - 1990 Apr 05 - S. C. Allendorf
C                             Modify so that only the necessary portion
C                             of the display is redrawn when flushed and
C                             when we receive an expose event.
C Version 3.0 - 1990 Apr 15 - S. C. Allendorf
C                             Merge functionality with WEW Jr.'s
C                             XE driver (XEDRIVER.FOR).
C Version 3.1 - 1990 Oct  5 - T. J. Pearson
C                             Restore input focus after using cursor.
C                             Report interactive, not hardcopy.
C Version 3.2 - 1991 Dec  5 - T. J. Pearson
C                             Change name from X11 to XWINDOW
C=======================================================================
C
C Supported device: This driver should work with all VAX/VMS
C workstations running the DECWindows software.
C
C Device type code: /XWINDOW.
C
C Default device name: PGPLOT.  Output is always directed to device
C DECW$DISPLAY; the "device name" provided by the user is used to label
C the PGPLOT window.
C
C Default view surface dimensions: Depends on the monitor, but nominally
C 10.5 inches horizontally by 8.0 inches vertically.  If you prefer a
C vertical orientation, execute the following command before running the
C program:
C
C $ DEFINE PGPLOT_XWIN_ASPECT PORTRAIT
C
C Substitute LANDSCAPE for PORTRAIT to revert to a horizontal 
C orientation.
C
C Resolution: Nominally 75 dpi, but depends on the monitor.
C
C Color capability: This driver will use as many colors as the 
C DECWindows server will allow, up to a maximum of 145 colors.  This
C maximum comes from the maximum number of colors that PGPLOT will use
C internally, and a desire to avoid hogging the resources of the server.
C
C Input capability: The cursor is controlled by the mouse. The user
C positions the cursor, and then types any key on the controlling
C keyboard.  The buttons on the mouse are also defined to return the 
C following characters:
C
C      Button  Character
C      ------  ---------
C         1        A
C         2        D
C        >2        X
C
C File format: It is not possible to send workstation plots to a disk 
C file using PGPLOT, but this may be accomplished using the standard
C X Windows utility xwd.  The format of the resulting file is documented
C in the X Windows documentation.
C
C Obtaining hardcopy: Not possible using PGPLOT, but may be achieved 
C using the standard X Windows utilities xwd and xpr or the Print Screen
C menu in DECWindows.
C
C NOTE: There is a bug in the early versions of DECWindows that cause
C the OPEN_DISPLAY call to sometimes abort the calling program. This may
C happen if you have used SET DISPLAY to define a display using the 
C local transport mechanism and you do not have access to it.  The 
C routine should return 0 in such a case, but does not currently.  If 
C you are going to use the SET DISPLAY command, use /TRANSPORT = DECNET 
C instead of /TRANSPORT = LOCAL or make sure that you will be able to 
C write to the display.  This means that someone must be logged into the 
C workstation display and must have security set to allow you to write 
C to it.  This bug has existed in all versions of DECWindows up through
C the version shipped with VMS 5.3-1.
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE
      PARAMETER  (TYPE='XWINDOW (Xwindow display)')
      INCLUDE    'SYS$LIBRARY:DECW$XLIBDEF'
      LOGICAL    INIT, LANDSCAPE, LOPIX, MONO
      BYTE       IMAGE(1280), KBYTE(2), XLOGO(128)
      INTEGER*2  JWORD(2), KWORD
      INTEGER*4  ARGS(4), BACK, BUFLEN, CMAP, CONTIG, CURS, DC$_TERM
      INTEGER*4  DEFX, DEFY, DEPTH, DEVCLASS, DISPLAY, DVI$_DEVCLASS
      INTEGER*4  FORE, GC, GCB, HEIGHT, I, IC, ICON, IER, IMAX, IMIN
      INTEGER*4  ISTAT, I0, I1, JLONG, JMAX, JMIN, J0, J1, KEYSYM, L
      INTEGER*4  GRFMEM, LIB$GETDVI, LIB$GET_COMMAND, GRGMEM
      INTEGER*4  LWIN, MAXCOL, MAXX, MAXY, NPTS, PARENT
      INTEGER*4  PIXELS(145), PIXMAP, PLANE_MASKS(145), POINTS, REMCAL
      INTEGER*4  SCREEN, SS$_NORMAL, WIDTH, WINDOW, XMAX, XMIN, XMM
      INTEGER*4  XOFF, XPIX, YMAX, YMIN, YMM, YOFF, YPIX
      INTEGER*4  FWINDOW, FREVERT
      REAL*4     CTABLE(3, 16), FACTOR, RESOL(2)
      CHARACTER  ASPECT*20, BUFFER*10, ICON_NAME*13, MESS*4, MSG*3
      CHARACTER  WINNAME*80
      RECORD     /X$COLOR/              BLACK, COLOR, RED
      RECORD     /X$EVENT/              REPORT
      RECORD     /X$GC_VALUES/          VALUES
      RECORD     /X$IMAGE/              XI
      RECORD     /X$POINT/              POINT
      RECORD     /X$SET_WIN_ATTRIBUTES/ SETWINATTR
      RECORD     /X$SIZE_HINTS/         SIZE_HINTS
      RECORD     /X$VISUAL/             VISUAL
C                                       Declare the asynchronous expose
C                                       event handler.
      EXTERNAL GRXE03
C                                       Setup the arguments passed to
C                                       the asynchronous expose event
C                                       routine.
      EQUIVALENCE (DISPLAY, ARGS(1))
      EQUIVALENCE (PIXMAP,  ARGS(2))
      EQUIVALENCE (WINDOW,  ARGS(3))
      EQUIVALENCE (GC,      ARGS(4))
C                                       We need these because FORTRAN
C                                       does not have unsigned types.
      EQUIVALENCE (JWORD(1), JLONG), (KBYTE(1), KWORD)
C                                       Define some parameters to avoid
C                                       having to use include files.
      PARAMETER (DC$_TERM = 66)
      PARAMETER (DVI$_DEVCLASS = 4)
      PARAMETER (SS$_NORMAL = 1)
C                                       Initialize a couple of things.
      DATA ICON_NAME, INIT /'PGPLOT Window', .TRUE./
C                                       Define the PGPLOT color table.
      DATA CTABLE /0.0,0.0,0.0, 1.0,1.0,1.0, 1.0,0.0,0.0, 0.0,1.0,0.0,
     +             0.0,0.0,1.0, 0.0,1.0,1.0, 1.0,0.0,1.0, 1.0,1.0,0.0,
     +             1.0,0.5,0.0, 0.5,1.0,0.0, 0.0,1.0,0.5, 0.0,0.5,1.0,
     +             0.5,0.0,1.0, 1.0,0.0,0.5, 0.333,0.333,0.333,
     +             0.667,0.667,0.667/
C                                       Define the X Windows logo.
      DATA XLOGO /  -1,    0,    0,  -64,   -2,    1,    0,  -64,   -4,
     +         3,    0,   96,   -8,    7,    0,   48,   -8,    7,    0,
     +        24,  -16,   15,    0,   12,  -32,   31,    0,    6,  -64,
     +        63,    0,    6,  -64,   63,    0,    3, -128,  127, -128,
     +         1,    0,   -1,  -64,    0,    0,   -2,   97,    0,    0,
     +        -2,   49,    0,    0,   -4,   51,    0,    0,   -8,   27,
     +         0,    0,  -16,   13,    0,    0,  -16,   14,    0,    0,
     +        96,   31,    0,    0,  -80,   63,    0,    0, -104,  127,
     +         0,    0, -104,  127,    0,    0,   12,   -1,    0,    0,
     +         6,   -2,    1,    0,    3,   -4,    3, -128,    1,   -4,
     +         3,  -64,    0,   -8,    7,  -64,    0,  -16,   15,   96,
     +         0,  -32,   31,   48,    0,  -32,   31,   24,    0,  -64,
     +        63,   12,    0, -128,  127,    6,    0,    0,   -1/
C-----------------------------------------------------------------------
C                                       On the first call, find out what
C                                       sort of workstation we have.
      IF (INIT) THEN
         INIT = .FALSE.
C                                       Attempt to open a DECWindows
C                                       display.  See note above
C                                       about DECWindows bug.
         DISPLAY = X$OPEN_DISPLAY ()
C                                       Only do the following if we
C                                       actually have a DECWindows
C                                       display.
         IF (DISPLAY .NE. 0) THEN
C                                       Get the default screen that is
C                                       associated with the display.
            SCREEN = X$DEFAULT_SCREEN (DISPLAY)
C                                       Find the root window.
            PARENT = X$ROOT_WINDOW (DISPLAY, SCREEN)
C                                       Get the number of planes.
            DEPTH = X$DISPLAY_PLANES (DISPLAY, SCREEN)
C                                       Get the visual type.
            CALL X$DEFAULT_VISUAL (DISPLAY, SCREEN, VISUAL)
C                                       Classify the display.
            MONO = (VISUAL.X$L_VISU_CLASS .EQ. X$C_STATIC_GRAY) .OR.
     +             (VISUAL.X$L_VISU_CLASS .EQ. X$C_STATIC_COLOR) .OR.
     +             (DEPTH .EQ. 1)
C                                       Get the size of the display.
            XPIX = X$DISPLAY_WIDTH (DISPLAY, SCREEN)
            YPIX = X$DISPLAY_HEIGHT (DISPLAY, SCREEN)
            XMM = X$DISPLAY_WIDTH_MM (DISPLAY, SCREEN)
            YMM = X$DISPLAY_HEIGHT_MM (DISPLAY, SCREEN)
C                                       Calculate the resolution of the
C                                       display.
            RESOL(1) = 25.4 * REAL (XPIX) / REAL (XMM)
            RESOL(2) = 25.4 * REAL (YPIX) / REAL (YMM)
C                                       Set the aspect ratio of the
C                                       window.
            FACTOR = 8.5 / 11.0
C                                       See what orientation we want.
            CALL GRGENV ('XWIN_ASPECT', ASPECT, L)
C                                       Calculate the window size.
            IF (ASPECT(1:1) .EQ. 'P') THEN
C                                       Potrait mode (pixels).
               HEIGHT = 828 * YPIX / 1024
               WIDTH = NINT (FACTOR * HEIGHT)
               LANDSCAPE = .FALSE.
            ELSE
C                                       Landscape mode (pixels).
               WIDTH = 828 * XPIX / 1024
               HEIGHT = NINT (FACTOR * WIDTH)
               LANDSCAPE = .TRUE.
            END IF
C                                       Calculate the size of the border
C                                       around the plot.
            IMIN = NINT (0.25 * RESOL(1))
            JMIN = NINT (0.25 * RESOL(2))
C                                       Set the maximum coordinates.
            IMAX = WIDTH - IMIN - 1
            JMAX = HEIGHT - JMIN - 1
C                                       Define the maximum allowed plot
C                                       size.  This is a bit of a hack
C                                       to handle extra things that the
C                                       window manager might do to the
C                                       window.
            MAXX = XPIX - 2 * IMIN - 10
            MAXY = YPIX - 2 * JMIN - 30
C                                       Define the default width and
C                                       height of the plot.
            DEFX = IMAX - IMIN
            DEFY = JMAX - JMIN
C                                       Center the window in the
C                                       display.
            XOFF = (XPIX - WIDTH) / 2
            YOFF = (YPIX - HEIGHT) / 2
C                                       Find the default colormap.
            CMAP = X$DEFAULT_COLORMAP (DISPLAY, SCREEN)
C                                       See if we will be able to use
C                                       the colors.
            IF (MONO) THEN
C                                       On static displays and
C                                       monochrome displays we will only
C                                       be able to use two colors.
               MAXCOL = 1
            ELSE
C                                       Determine the maximum number of
C                                       colors available.  Make sure we
C                                       only grab a reasonable number.
               MAXCOL = MIN (X$DISPLAY_CELLS (DISPLAY, SCREEN), 145)
C                                       Grab as many color cells as we
C                                       need (or X will allow us).
               DO I = MAXCOL, 2, -1
                  ISTAT = X$ALLOC_COLOR_CELLS (DISPLAY, CMAP, CONTIG,
     +                                      PLANE_MASKS, 0, PIXELS, I)
                  MAXCOL = I
                  IF (ISTAT .EQ. 1) GOTO 5
               END DO
C                                       Set the value of the maximum
C                                       color index.  If we found two or
C                                       fewer colors, revert to 
C                                       monochrome.
C       
    5          MAXCOL = MAXCOL - 1
               IF (MAXCOL .EQ. 1) MONO = .TRUE.
            END IF
         ELSE
C                                       Deal with the error on the open
C                                       workstation call.
            MAXCOL = 1
            LANDSCAPE = .TRUE.
         END IF
C                                       Set the machine characteristics.
         LOPIX = .FALSE.
         IF (MAXCOL .GT. 33) LOPIX = .TRUE.
      END IF
C                                       Branch on opcode.
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     +     110,120,130,140,150,160,170,180,190,200,
     +     210,220,230,240,250,260), IFUNC
C
  900 WRITE (MSG, '(I10)') IFUNC
      CALL GRWARN ('Unimplemented function in DECWindows device driver:'
     +              // MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CONTINUE
      CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 CONTINUE
      RBUF(1) = 0.0
      RBUF(2) = REAL (MAXX)
      RBUF(3) = 0.0
      RBUF(4) = REAL (MAXY)
      RBUF(5) = 0.0
      RBUF(6) = REAL (MAXCOL)
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 CONTINUE
      RBUF(1) = RESOL(1)
      RBUF(2) = RESOL(2)
      RBUF(3) = 1.0                     ! Device coordinates per pixel
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is No Hardcopy, Cursor, No dashed lines, Area fill,
C    No thick lines, Rectangle fill, and possibly Line of pixels.)
C
   40 CONTINUE
      IF (LOPIX) THEN
         CHR = 'ICNANRPNNN'
      ELSE
         CHR = 'ICNANRNNNN'
      END IF
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CONTINUE
      CHR = 'PGPLOT'
      LCHR = 6
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 CONTINUE
      RBUF(1) = 0.0
      RBUF(2) = REAL (DEFX)
      RBUF(3) = 0.0
      RBUF(4) = REAL (DEFY)
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 CONTINUE
      RBUF(1) = 1.0
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C                                       Return an error if the display
C                                       couldn't be opened.  The display
C                                       should be set with the VMS SET
C                                       DISPLAY command.
      IF (DISPLAY .EQ. 0) THEN
         CALL GRWARN ('Cannot open the specified DECWindows display.')
         RBUF(2) = 0.0
         RETURN
      END IF
C                                       Stash away the passed window
C                                       name for later use.
      WINNAME = CHR(:LCHR)
      LWIN = LCHR
C                                       Define the foreground and
C                                       background colors to be black
C                                       and white respectively.
      FORE = X$BLACK_PIXEL (DISPLAY, SCREEN)
      BACK = X$WHITE_PIXEL (DISPLAY, SCREEN)
C                                       Create a window in the display.
      WINDOW = X$CREATE_WINDOW (DISPLAY, PARENT, XOFF, YOFF,
     +            WIDTH, HEIGHT, 0, DEPTH, X$C_INPUT_OUTPUT,
     +            VISUAL, 0, SETWINATTR)
C                                       Load the PGPLOT palette.
      IF (.NOT. MONO) THEN
C                                       Define color indices 0-15;
C                                       background (CI = 0) black,
C                                       write (CI = 1) in white.
         DO I = 0, MIN (15, MAXCOL)
            COLOR.X$L_COLR_PIXEL = PIXELS(I + 1)
            JLONG = NINT (CTABLE (1, I + 1) * 65535.0)
            COLOR.X$W_COLR_RED = JWORD(1)
            JLONG = NINT (CTABLE (2, I + 1) * 65535.0)
            COLOR.X$W_COLR_GREEN = JWORD(1)
            JLONG = NINT (CTABLE (3, I + 1) * 65535.0)
            COLOR.X$W_COLR_BLUE = JWORD(1)
            COLOR.X$B_COLR_FLAGS = X$M_DO_RED .OR.
     +                                    X$M_DO_GREEN .OR. X$M_DO_BLUE
C                                       Load our color table into the
C                                       color map.
            CALL X$STORE_COLOR (DISPLAY, CMAP, COLOR)
         END DO
C                                       Redefine the background and
C                                       foreground colors to point at
C                                       our definitions.
         BACK = PIXELS(1)
         FORE = PIXELS(2)
C                                       Get color structures for the
C                                       cursor colors.
         RED.X$L_COLR_PIXEL = PIXELS(3)
         BLACK.X$L_COLR_PIXEL = PIXELS(1)
         CALL X$QUERY_COLOR (DISPLAY, CMAP, BLACK)
         CALL X$QUERY_COLOR (DISPLAY, CMAP, RED)
      END IF
C                                       Set the window colors.
      CALL X$SET_WINDOW_BACKGROUND (DISPLAY, WINDOW, BACK)
      CALL X$SET_WINDOW_BORDER (DISPLAY, WINDOW, FORE)
C                                       Initialize size hint property
C                                       for the window manager.
      SIZE_HINTS.X$L_SZHN_FLAGS = X$M_P_POSITION .OR. X$M_P_SIZE .OR.
     +                            X$M_P_MIN_SIZE .OR. X$M_P_MAX_SIZE
      SIZE_HINTS.X$L_SZHN_X = XOFF
      SIZE_HINTS.X$L_SZHN_Y = YOFF
      SIZE_HINTS.X$L_SZHN_WIDTH = WIDTH
      SIZE_HINTS.X$L_SZHN_HEIGHT = HEIGHT
      SIZE_HINTS.X$L_SZHN_MIN_WIDTH = WIDTH
      SIZE_HINTS.X$L_SZHN_MIN_HEIGHT = HEIGHT
      SIZE_HINTS.X$L_SZHN_MAX_WIDTH = WIDTH
      SIZE_HINTS.X$L_SZHN_MAX_HEIGHT = HEIGHT
C                                       Create an icon.
      ICON = X$CREATE_BITMAP_FROM_DATA (DISPLAY, WINDOW, XLOGO, 32, 32)
C                                       Set the necessary properties.
      CALL X$SET_STANDARD_PROPERTIES (DISPLAY, WINDOW, WINNAME(:LWIN),
     +        ICON_NAME, ICON, 0, 0, SIZE_HINTS)
C                                       Create a pixmap.
      PIXMAP = X$CREATE_PIXMAP (DISPLAY, WINDOW, WIDTH, HEIGHT, DEPTH)
C                                       Create default graphics contexts
C                                       for foreground and background.
      GC  = X$CREATE_GC (DISPLAY, PIXMAP, 0, VALUES)
      GCB = X$CREATE_GC (DISPLAY, PIXMAP, 0, VALUES)
C                                       Set the foreground colors in the
C                                       graphics contexts.
      CALL X$SET_FOREGROUND (DISPLAY, GC, FORE)
      CALL X$SET_FOREGROUND (DISPLAY, GCB, BACK)
C                                       Ask for mapping notification.
      CALL X$SELECT_INPUT (DISPLAY, WINDOW, X$M_STRUCTURE_NOTIFY)
C                                       Display the window.
      CALL X$MAP_RAISED (DISPLAY, WINDOW)
C                                       Eat the mapping notification.
C                                       The loop is necessary because
C                                       the DECWindows window manager
C                                       reparents everything and sends
C                                       reparenting events before the
C                                       mapping event.
   95 CALL X$NEXT_EVENT (DISPLAY, REPORT)
      IF (REPORT.EVNT_TYPE .NE. X$C_MAP_NOTIFY) GOTO 95
C                                       Set up the asynchronous expose
C                                       event handler.
      CALL X$SELECT_ASYNC_EVENT (DISPLAY, WINDOW, X$C_EXPOSE,
     +                              GRXE03, %LOC (ARGS))
C                                       Turn on exposure events.
      CALL X$SELECT_INPUT (DISPLAY, WINDOW, X$M_EXPOSURE)
C                                       Initialize the damaged region.
      CALL GRXE02 (WIDTH, HEIGHT, XMIN, XMAX, YMIN, YMAX)
C                                       Successful-- return display
      RBUF(1) = DISPLAY
      RBUF(2) = 1.0
      NBUF = 2
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
C                                       See if we are attached to a
C                                       real terminal.
      IER = LIB$GETDVI (DVI$_DEVCLASS, , 'SYS$COMMAND', DEVCLASS)
C                                       Wait for user acknowledgement.
      IF (IER .EQ. 1 .AND. DEVCLASS .EQ. DC$_TERM)
     +    CALL LIB$GET_COMMAND (MESS,
     +       CHAR (7) // 'Type <RETURN> to remove PGPLOT window: ', L)
C                                       Clean up resources.
      CALL X$SELECT_INPUT (DISPLAY, WINDOW, 0)
      CALL X$SELECT_ASYNC_EVENT (DISPLAY, WINDOW, X$C_EXPOSE, 0, 0)
      CALL X$UNMAP_WINDOW (DISPLAY, WINDOW)
      CALL X$FREE_GC (DISPLAY, GC)
      CALL X$FREE_GC (DISPLAY, GCB)
      CALL X$DESTROY_WINDOW (DISPLAY, WINDOW)
      CALL X$FREE_PIXMAP (DISPLAY, PIXMAP)
      CALL X$CLOSE_DISPLAY (DISPLAY)
C                                       Reset the initialization
C                                       variable.
      INIT = .TRUE.
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
C                                       See if the user wants a
C                                       nonstandard size window.
      I0 = NINT (RBUF(1)) + 2 * IMIN + 1
      J0 = NINT (RBUF(2)) + 2 * JMIN + 1
C                                       See if it is different than what
C                                       we already have.
      IF (I0 .NE. WIDTH .OR. J0 .NE. HEIGHT) THEN
C                                       Recompute the size and position
C                                       parameters.
         WIDTH = I0
         HEIGHT = J0
         IMAX = WIDTH - IMIN - 1
         JMAX = HEIGHT - JMIN -1
         XOFF = (XPIX - WIDTH) / 2
         YOFF = (YPIX - HEIGHT) / 2
C                                       Turn off expose events to avoid
C                                       PIXMAP being invalid to the
C                                       asynchronous expose event
C                                       handler.
         CALL X$SELECT_INPUT (DISPLAY, WINDOW, 0)
C                                       Destroy the old pixmap.
         CALL X$FREE_PIXMAP (DISPLAY, PIXMAP)
C                                       Create a new pixmap.
         PIXMAP = X$CREATE_PIXMAP (DISPLAY, WINDOW, WIDTH, HEIGHT,
     +                             DEPTH)
C                                       Reset the size hints for the
C                                       window manager.
         SIZE_HINTS.X$L_SZHN_FLAGS = X$M_P_POSITION .OR. X$M_P_SIZE .OR.
     +                               X$M_P_MIN_SIZE .OR. X$M_P_MAX_SIZE
         SIZE_HINTS.X$L_SZHN_X = XOFF
         SIZE_HINTS.X$L_SZHN_Y = YOFF
         SIZE_HINTS.X$L_SZHN_WIDTH = WIDTH
         SIZE_HINTS.X$L_SZHN_HEIGHT = HEIGHT
         SIZE_HINTS.X$L_SZHN_MIN_WIDTH = WIDTH
         SIZE_HINTS.X$L_SZHN_MIN_HEIGHT = HEIGHT
         SIZE_HINTS.X$L_SZHN_MAX_WIDTH = WIDTH
         SIZE_HINTS.X$L_SZHN_MAX_HEIGHT = HEIGHT
C                                       Send the hints to the window
C                                       manager.
         CALL X$SET_STANDARD_PROPERTIES (DISPLAY, WINDOW,
     +           WINNAME(:LWIN), ICON_NAME, ICON, 0, 0, SIZE_HINTS)
C                                       Resize the window.
         CALL X$RESIZE_WINDOW (DISPLAY, WINDOW, WIDTH, HEIGHT)
C                                       Wait for the server to catch
C                                       up.
         CALL X$SYNC (DISPLAY, .FALSE.)
C                                       Turn on exposure events.
         CALL X$SELECT_INPUT (DISPLAY, WINDOW, X$M_EXPOSURE)
      END IF
C                                       Clear the pixmap.
      CALL X$FILL_RECTANGLE (DISPLAY, PIXMAP, GCB, 0, 0, WIDTH, HEIGHT)
C                                       Clear the window.
      CALL X$CLEAR_WINDOW (DISPLAY, WINDOW)
C                                       Reset the damaged region.
      CALL GRXE02 (WIDTH, HEIGHT, XMIN, XMAX, YMIN, YMAX)
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
C                                       Transform the input coordinates.
      I0 = NINT (RBUF(1)) + IMIN
      J0 = JMAX - NINT (RBUF(2))
      I1 = NINT (RBUF(3)) + IMIN
      J1 = JMAX - NINT (RBUF(4))
C                                       Draw the line.
      CALL X$DRAW_LINE (DISPLAY, PIXMAP, GC, I0, J0, I1, J1)
C                                       Update the damaged region.
      CALL GRXE01 (1, I0, J0, I1, J1, XMIN, XMAX, YMIN, YMAX)
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
C                                       Transform the input coordinates.
      I0 = NINT (RBUF(1)) + IMIN
      J0 = JMAX - NINT (RBUF(2))
C                                       Draw the point.
      CALL X$DRAW_POINT (DISPLAY, PIXMAP, GC, I0, J0)
C                                       Update the damaged region.
      CALL GRXE01 (0, I0, J0, I0, J0, XMIN, XMAX, YMIN, YMAX)
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
C                                       Make sure the server is caught 
C                                       up.
      CALL X$SYNC (DISPLAY, .FALSE.)
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = NINT (RBUF(1))
C                                       Handle monochrome displays
C                                       properly.
      IF (.NOT. MONO) THEN
         CALL X$SET_FOREGROUND (DISPLAY, GC, PIXELS(IC + 1))
      ELSE IF (IC .EQ. 1) THEN
         CALL X$SET_FOREGROUND (DISPLAY, GC, FORE)
      ELSE
         CALL X$SET_FOREGROUND (DISPLAY, GC, BACK)
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
C                                       Copy pixmap to server.
      IF (XMAX .NE. -1) CALL X$COPY_AREA (DISPLAY, PIXMAP, WINDOW, GC,
     +       XMIN, YMIN, XMAX - XMIN + 1, YMAX - YMIN + 1, XMIN, YMIN)
C                                       Make sure the server is caught 
C                                       up.
      CALL X$SYNC (DISPLAY, .FALSE.)
C                                       Reset damaged region.
      CALL GRXE02 (WIDTH, HEIGHT, XMIN, XMAX, YMIN, YMAX)
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C
  170 CONTINUE
C                                       Create and display the graphics
C                                       cursor.
      CURS = X$CREATE_FONT_CURSOR (DISPLAY, X$C_CROSS_HAIR_CURSOR)
      CALL X$DEFINE_CURSOR (DISPLAY, WINDOW, CURS)
      IF (.NOT. MONO) CALL X$RECOLOR_CURSOR (DISPLAY, CURS, RED, BLACK)
C                                       Convert input coordinates.
      I0 = NINT (RBUF(1)) + IMIN
      J0 = JMAX - NINT (RBUF(2))
C                                       Set input focus to avoid
C                                       unwanted data entry.
      CALL X$GET_INPUT_FOCUS (DISPLAY, FWINDOW, FREVERT)
      CALL X$SET_INPUT_FOCUS (DISPLAY, WINDOW, X$C_REVERT_TO_PARENT,
     +                           X$C_CURRENT_TIME)
C                                       Set cursor to the correct spot.
      CALL X$WARP_POINTER (DISPLAY, X$C_NONE, WINDOW,
     +                                        0, 0, 0, 0, I0, J0)
C                                       Turn on event processing.
      CALL X$SELECT_INPUT (DISPLAY, WINDOW, X$M_KEY_PRESS .OR.
     +        X$M_BUTTON_PRESS .OR. X$M_EXPOSURE)
C                                       Make sure the server is caught
C                                       up.
      CALL X$SYNC (DISPLAY, .FALSE.)
C                                       Loop until we get an entry from
C                                       the user.
      DO WHILE (.TRUE.)
C                                       Wait for an event to occur.  We
C                                       ignore no expose events and
C                                       graphics expose events.
         CALL X$NEXT_EVENT (DISPLAY, REPORT)
C                                       Process the window exposure.
         IF (REPORT.EVNT_TYPE .EQ. X$C_EXPOSE) THEN
             CALL X$COPY_AREA (DISPLAY, PIXMAP, WINDOW, GC,
     +               REPORT.EVNT_EXPOSE.X$L_EXEV_X,
     +               REPORT.EVNT_EXPOSE.X$L_EXEV_Y,
     +               REPORT.EVNT_EXPOSE.X$L_EXEV_WIDTH,
     +               REPORT.EVNT_EXPOSE.X$L_EXEV_HEIGHT,
     +               REPORT.EVNT_EXPOSE.X$L_EXEV_X,
     +               REPORT.EVNT_EXPOSE.X$L_EXEV_Y)
C                                       The user pressed a mouse button.
         ELSE IF (REPORT.EVNT_TYPE .EQ. X$C_BUTTON_PRESS) THEN
C                                       Record the position
            I0 = REPORT.EVNT_BUTTON.X$L_BTEV_X
            J0 = REPORT.EVNT_BUTTON.X$L_BTEV_Y
C                                       Translate the mouse buttons to
C                                       the common letters Add, Delete, 
C                                       and eXit.
            IF (REPORT.EVNT_BUTTON.X$L_BTEV_BUTTON .EQ.
     +                  X$C_BUTTON1) THEN
               BUFFER(1:1) = 'A'
            ELSE IF (REPORT.EVNT_BUTTON.X$L_BTEV_BUTTON .EQ.
     +                  X$C_BUTTON2) THEN
               BUFFER(1:1) = 'D'
            ELSE
               BUFFER(1:1) = 'X'
            END IF
C                                       Ignore this event if it is
C                                       outside the graphics boundaries.
            IF (I0 .GE. IMIN .AND. I0 .LE. IMAX .AND.
     +          J0 .GE. JMIN .AND. J0 .LE. JMAX) GOTO 175
            CALL X$BELL (DISPLAY, 0)
            CALL X$SYNC (DISPLAY, .FALSE.)
C                                       Translate the key pressed by the
C                                       user.
         ELSE IF (REPORT.EVNT_TYPE .EQ. X$C_KEY_PRESS) THEN
            I0 = REPORT.EVNT_KEY.X$L_KYEV_X
            J0 = REPORT.EVNT_KEY.X$L_KYEV_Y
            BUFLEN = X$LOOKUP_STRING (REPORT.EVNT_KEY,
     +                                    BUFFER, 10, KEYSYM, )
C                                       Ignore this event if it did not
C                                       produce a single character.
            IF (BUFLEN .EQ. 1) THEN
C                                       Ignore this event if it is
C                                       outside the graphics boundaries.
               IF (I0 .GE. IMIN .AND. I0 .LE. IMAX .AND.
     +             J0 .GE. JMIN .AND. J0 .LE. JMAX) GOTO 175
               CALL X$BELL (DISPLAY, 0)
               CALL X$SYNC (DISPLAY, .FALSE.)
            END IF
         END IF
      END DO
C                                       Reset event processing.
  175 CALL X$SELECT_INPUT (DISPLAY, WINDOW, X$M_EXPOSURE)
C                                       Return the cursor to its
C                                       original state.
      CALL X$UNDEFINE_CURSOR (DISPLAY, WINDOW)
      CALL X$FREE_CURSOR (DISPLAY, CURS)
      CALL X$SET_INPUT_FOCUS (DISPLAY, FWINDOW, FREVERT, 
     +                           X$C_CURRENT_TIME)
C                                       Make sure the server is caught
C                                       up.
      CALL X$SYNC (DISPLAY, .FALSE.)
C                                       Set the return values.
      CHR(1:1) = BUFFER(1:1)
      RBUF(1) = REAL (I0 - IMIN)
      RBUF(2) = REAL (JMAX - J0)
      NBUF = 2
      LCHR = 1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
C                                       First time, set number of points
C                                       in polygon and allocate the
C                                       memory for the array.
      IF (REMCAL .EQ. 0) THEN
         NPTS = NINT (RBUF(1))
         REMCAL = NPTS
         IER = GRGMEM (SIZEOF (POINT) * NPTS, POINTS)
         IF (IER .NE. SS$_NORMAL) THEN
            CALL GRGMSG (IER)
            CALL GRQUIT ('Failed to allocate temporary buffer.')
         END IF
      ELSE
C                                       Second and succeeding calls,
C                                       change counter and load arrays.
         REMCAL = REMCAL - 1
         I0 = NINT (RBUF(1)) + IMIN
         J0 = JMAX - NINT (RBUF(2))
         CALL GRXE00 (NPTS, %VAL (POINTS), REMCAL, I0, J0)
C                                       Calculate the damaged region.
         CALL GRXE01 (0, I0, J0, I0, J0, XMIN, XMAX, YMIN, YMAX)
C                                       If last call, fill the area and
C                                       deallocate the memory.
         IF (REMCAL .EQ. 0) THEN
            CALL X$FILL_POLYGON (DISPLAY, PIXMAP, GC, %VAL (POINTS),
     +              NPTS, X$C_POLYCOMPLEX, X$C_COORD_MODE_ORIGIN)
            IER = GRFMEM (SIZEOF (POINT) * NPTS, POINTS)
            IF (IER .NE. SS$_NORMAL) THEN
               CALL GRGMSG (IER)
               CALL GRQUIT ('Failed to deallocate temporary buffer.')
            END IF
         END IF
      END IF
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
C                                       Ignore for a static or 
C                                       monochrome device.
      IF (.NOT. MONO) THEN
C                                       Determine the color index.
         IC = NINT (RBUF(1))
C                                       Load the color structure.
         COLOR.X$L_COLR_PIXEL = PIXELS(IC + 1)
         JLONG = NINT (RBUF(2) * 65535.0)
         COLOR.X$W_COLR_RED = JWORD(1)
         JLONG = NINT (RBUF(3) * 65535.0)
         COLOR.X$W_COLR_GREEN = JWORD(1)
         JLONG = NINT (RBUF(4) * 65535.0)
         COLOR.X$W_COLR_BLUE = JWORD(1)
         COLOR.X$B_COLR_FLAGS = X$M_DO_RED .OR. X$M_DO_GREEN .OR.
     +                              X$M_DO_BLUE
C                                       Tell the server about the new
C                                       definition.
         CALL X$STORE_COLOR (DISPLAY, CMAP, COLOR)
      END IF
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle Fill. -----------------------------------------
C
  240 CONTINUE
C                                       Figure out the position of the
C                                       rectangle.
      I0 = NINT (RBUF(1)) + IMIN
      J0 = JMAX - NINT (RBUF(4))
C                                       Determine the size of the
C                                       rectangle.
      I1 = NINT (RBUF(3) - RBUF(1) + 1.0)
      J1 = NINT (RBUF(4) - RBUF(2) + 1.0)
C                                       Draw the rectangle into the
C                                       display.
      CALL X$FILL_RECTANGLE (DISPLAY, PIXMAP, GC, I0, J0, I1, J1)
C                                       Calculate the damaged region.
      CALL GRXE01 (1, I0, J0, I0 + I1 - 1, J0 + J1 - 1,
     +                XMIN, XMAX, YMIN, YMAX)
      RETURN
C
C--- IFUNC=25, ---------------------------------------------------------
C    (Not implemented: ignored)
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels ------------------------------------------
C
  260 CONTINUE
C                                       This should only be called if
C                                       there are more than four planes
C                                       present and the display can
C                                       handle defining colors.
      IF (.NOT. LOPIX) THEN
         GOTO 900
      ELSE
C                                       Calculate where to put the line.
         I0 = NINT (RBUF(1)) + IMIN
         J0 = JMAX - NINT (RBUF(2))
C                                       Load the image data into the
C                                       the array.
         DO 265 IC = 1, NBUF - 2
            KWORD = PIXELS (NINT (RBUF(IC + 2)) + 1)
            IMAGE(IC) = KBYTE(1)
  265    CONTINUE
C                                       Create an image structure.
         CALL X$CREATE_IMAGE (DISPLAY, VISUAL, DEPTH, X$C_Z_PIXMAP, 0,
     +           IMAGE, NBUF - 2, 1, 8, 0, XI)
C                                       Draw the line into the display.
         CALL X$PUT_IMAGE (DISPLAY, PIXMAP, GC, XI, 0, 0, I0, J0,
     +           NBUF - 2, 1)
C                                       Calculate the damaged region.
         CALL GRXE01 (1, I0, J0, I0 + NBUF - 3, J0,
     +                   XMIN, XMAX, YMIN, YMAX)
      END IF
      RETURN
C-----------------------------------------------------------------------
      END

C*GRXE00 -- PGPLOT XE driver, load polygon array
C+
      SUBROUTINE GRXE00 (N0, POINTS, N, X, Y)
      IMPLICIT NONE
      INCLUDE    'SYS$LIBRARY:DECW$XLIBDEF'
      INTEGER*4  N, N0, X, Y
      RECORD     /X$POINT/ POINTS(N0)
C-----------------------------------------------------------------------
C                                       Load the polygon array with the
C                                       passed vertex.
      POINTS(N0 - N).X$W_GPNT_X = X
      POINTS(N0 - N).X$W_GPNT_Y = Y
C-----------------------------------------------------------------------
      RETURN
      END

C*GRXE01 -- PGPLOT XE driver, calculate 'damaged' region.
C+
      SUBROUTINE GRXE01 (LINE, I0, J0, I1, J1, XMIN, XMAX, YMIN, YMAX)
      IMPLICIT NONE
      INTEGER*4  I0, I1, J0, J1, LINE, XMAX, XMIN, YMAX, YMIN
C-----------------------------------------------------------------------
C                                       Update the damaged region.
      IF (I0 .GT. XMAX) XMAX = I0
      IF (I0 .LT. XMIN) XMIN = I0
      IF (J0 .GT. YMAX) YMAX = J0
      IF (J0 .LT. YMIN) YMIN = J0
C                                       See if we were passed a
C                                       rectangle and update the
C                                       damaged region accordingly.
      IF (LINE .EQ. 1) THEN
         IF (I1 .GT. XMAX) XMAX = I1
         IF (I1 .LT. XMIN) XMIN = I1
         IF (J1 .GT. YMAX) YMAX = J1
         IF (J1 .LT. YMIN) YMIN = J1
      END IF
C-----------------------------------------------------------------------
      RETURN
      END

C*GRXE02 -- PGPLOT XE driver, reset 'damaged' region.
C+
      SUBROUTINE GRXE02 (WIDTH, HEIGHT, XMIN, XMAX, YMIN, YMAX)
      IMPLICIT NONE
      INTEGER*4  HEIGHT, WIDTH, XMAX, XMIN, YMAX, YMIN
C-----------------------------------------------------------------------
C                                       Reset the boundaries of the
C                                       damaged region.
      XMAX = -1
      YMAX = -1
      XMIN = WIDTH + 1
      YMIN = HEIGHT + 1
C-----------------------------------------------------------------------
      RETURN
      END

C*GRXE03 -- PGPLOT XE driver, aysynchronous redrawing routine.
C+
      SUBROUTINE GRXE03 (ARGS)
      IMPLICIT NONE
      INCLUDE    'SYS$LIBRARY:DECW$XLIBDEF'
      INTEGER*4  ARGS(4)
      RECORD     /X$EVENT/ EVENT
C-----------------------------------------------------------------------
C                                       Get all of the exposure events.
      DO WHILE (X$CHECK_WINDOW_EVENT (ARGS(1), ARGS(3),
     +              X$M_EXPOSURE, EVENT))
C                                       If part of the window has been
C                                       exposed, redraw that part.  We
C                                       ignore no expose events and 
C                                       graphics expose events.
         IF (EVENT.EVNT_TYPE .EQ. X$C_EXPOSE) THEN
             CALL X$COPY_AREA (ARGS(1), ARGS(2), ARGS(3), ARGS(4),
     +               EVENT.EVNT_EXPOSE.X$L_EXEV_X,
     +               EVENT.EVNT_EXPOSE.X$L_EXEV_Y,
     +               EVENT.EVNT_EXPOSE.X$L_EXEV_WIDTH,
     +               EVENT.EVNT_EXPOSE.X$L_EXEV_HEIGHT,
     +               EVENT.EVNT_EXPOSE.X$L_EXEV_X,
     +               EVENT.EVNT_EXPOSE.X$L_EXEV_Y)
         END IF
      END DO
C-----------------------------------------------------------------------
      RETURN
      END

C*GRQCR -- inquire color representation
C+
      SUBROUTINE GRQCR (CI, CR, CG, CB)
      INTEGER  CI
      REAL     CR, CG, CB
C
C Return the color representation (red, green, blue intensities) 
C currently associated with the specified color index. This may be
C different from that requested on some devices.
C
C Arguments:
C
C CI (integer, input): color index.
C CR, CG, CB (real, output): red, green, and blue intensities,
C       in range 0.0 to 1.0.
C--
C  7-Sep-1994 - rewrite [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER   NBUF, LCHR, K
      REAL      RBUF(6)
      CHARACTER CHR
C
      CR = 1.0
      CG = 1.0
      CB = 1.0
      K  = CI
      IF (GRCIDE.LT.1) THEN
C         -- no device open: return white
          CALL GRWARN('GRQCR: no plot device is open.')
      ELSE IF (GRGCAP(GRCIDE)(9:9).NE.'Y') THEN
C         -- devices that don't allow query color representation:
C            return black for ci 0, white for all others
          IF (K.EQ.0) THEN
             CR = 0.0
             CG = 0.0
             CB = 0.0
          END IF
      ELSE
C         -- query device driver; treat invalid ci as 1
          IF (K.LT.GRMNCI(GRCIDE) .OR. CI.GT.GRMXCI(GRCIDE)) THEN
             CALL GRWARN('GRQCR: invalid color index.')
             K = 1
          END IF
          RBUF(1) = K
          NBUF = 1
          LCHR = 0
          CALL GREXEC(GRGTYP,29,RBUF,NBUF,CHR,LCHR)
          IF (NBUF.LT.4) THEN
             CALL GRWARN('GRSCR: device driver error')
          ELSE
              CR = RBUF(2)
              CG = RBUF(3)
              CB = RBUF(4)
          END IF
      END IF
C
      END

C.PGHTCH -- hatch a polygonal area (internal routine)
C.
      SUBROUTINE PGHTCH(N, X, Y, DA)
      INTEGER N
      REAL X(*), Y(*), DA
C
C Hatch a polygonal area using equi-spaced parallel lines. The lines
C are drawn using the current line attributes: line style, line width,
C and color index. Cross-hatching can be achieved by calling this
C routine twice.
C
C Limitations: the hatching will not be done correctly if the
C polygon is so complex that a hatch line intersects more than
C 32 of its sides.
C
C Arguments:
C  N      (input)  : the number of vertices of the polygonal.
C  X,Y    (input)  : the (x,y) world-coordinates of the vertices
C                    (in order).
C  DA      (input) : 0.0 for normal hatching, 90.0 for perpendicular
C                    hatching.
C--
C Reference: I.O. Angel and G. Griffith "High-resolution computer
C graphics using Fortran 77", Halsted Press, 1987.
C
C 18-Feb-1995 [TJP].
C-----------------------------------------------------------------------
C
C MAXP is the maximum number of intersections any hatch line may make 
C with the sides of the polygon.
C
      INTEGER MAXP
      PARAMETER (MAXP=32)
      INTEGER NP(MAXP), I,J, II,JJ, NMIN,NMAX, NX, NI, NNP
      REAL ANGLE, SEPN, PHASE
      REAL RMU(MAXP), DX,DY, C, CMID,CMIN,CMAX, SX,SY, EX,EY, DELTA
      REAL QX,QY, R, RMU1, RMU2, XI,YI, BX,BY
      REAL DH, XS1, XS2, YS1, YS2, XL, XR, YT, YB, DINDX, DINDY
C
C Check arguments.
C
      IF (N.LT.3) RETURN
      CALL PGQHS(ANGLE, SEPN, PHASE)
      ANGLE = ANGLE + DA
      IF (SEPN.EQ.0.0) RETURN
C
C The unit spacing is 1 percent of the smaller of the height or
C width of the view surface. The line-spacing (DH), in inches, is
C obtained by multiplying this by argument SEPN.
C
      CALL PGQVSZ(1, XS1, XS2, YS1, YS2)
      DH = SEPN*MIN(ABS(XS2-XS1),ABS(YS2-YS1))/100.0
C
C DINDX and DINDY are the scales in inches per world-coordinate unit.
C
      CALL PGQVP(1, XS1, XS2, YS1, YS2)
      CALL PGQWIN(XL, XR, YB, YT)
      IF (XR.NE.XL .AND. YT.NE.YB) THEN
         DINDX = (XS2 - XS1) / (XR - XL)
         DINDY = (YS2 - YS1) / (YT - YB)
      ELSE
         RETURN
      END IF
C
C Initialize.
C
      CALL PGBBUF
C
C The vector (SX,SY) is a vector length DH perpendicular to
C the hatching lines, which have vector (DX,DY).
C
      DX = COS(ANGLE/57.29578)
      DY = SIN(ANGLE/57.29578)
      SX = (-DH)*DY
      SY = DH*DX
C
C The hatch lines are labelled by a parameter C, the distance from
C the coordinate origin. Calculate CMID, the C-value of the line
C that passes through the hatching reference point (BX,BY), and
C CMIN and CMAX, the range of C-values spanned by lines that intersect
C the polygon.
C
      BX = PHASE*SX
      BY = PHASE*SY
      CMID = DX*BY - DY*BX
      CMIN = DX*Y(1)*DINDY - DY*X(1)*DINDX
      CMAX = CMIN
      DO 10 I=2,N
         C = DX*Y(I)*DINDY - DY*X(I)*DINDX
         CMIN = MIN(C,CMIN)
         CMAX = MAX(C,CMAX)
 10   CONTINUE
C
C Compute integer labels for the hatch lines; N=0 is the line
C which passes through the reference point; NMIN and NMAX define
C the range of labels for lines that intersect the polygon.
C [Note that INT truncates towards zero; we need FLOOR and CEIL
C functions.]
C
      CMIN = (CMIN-CMID)/DH
      CMAX = (CMAX-CMID)/DH
      NMIN = INT(CMIN)
      IF (REAL(NMIN).LT.CMIN) NMIN = NMIN+1
      NMAX = INT(CMAX)
      IF (REAL(NMAX).GT.CMAX) NMAX = NMAX-1
C
C Each iteration of the following loop draws one hatch line.
C
      DO 60 J=NMIN,NMAX
C
C The parametric representation of this hatch line is
C (X,Y) = (QX,QY) + RMU*(DX,DY).
C
         QX = BX + REAL(J)*SX
         QY = BY + REAL(J)*SY
C
C Find the NX intersections of this line with the edges of the polygon.
C
         NX = 0
         NI = N
         DO 20 I=1,N
            EX = (X(I) - X(NI))*DINDX
            EY = (Y(I) - Y(NI))*DINDY
            DELTA = EX*DY - EY*DX
            IF (ABS(DELTA).LT.1E-5) THEN
C                 -- lines are parallel
            ELSE
C                 -- lines intersect in (XI,YI)
               R = ((QX-X(NI)*DINDX)*DY - (QY-Y(NI)*DINDY)*DX)/DELTA
               IF (R.GT.0.0 .AND. R.LE.1.0) THEN
                  IF (NX.LT.MAXP) NX = NX+1
                  NP(NX) = NX
                  IF (ABS(DX).GT.0.5) THEN
                     XI = X(NI)*DINDX + R*EX
                     RMU(NX) = (XI-QX)/DX
                  ELSE
                     YI = Y(NI)*DINDY + R*EY
                     RMU(NX) = (YI-QY)/DY
                  END IF
               END IF
            END IF
            NI = I
 20      CONTINUE
C     
C The RMU array now contains the intersections. Sort them into order.
C
         DO 40 II=1,NX-1
            DO 30 JJ=II+1,NX
               IF (RMU(NP(II)).LT.RMU(NP(JJ))) THEN
                  NNP = NP(II)
                  NP(II) = NP(JJ)
                  NP(JJ) = NNP
               END IF
 30         CONTINUE
 40      CONTINUE
C
C Join the intersections in pairs.
C
         NI = 1
C         -- do while NI < NX
 50      IF (NI .LT. NX) THEN
            RMU1 = RMU(NP(NI))
            RMU2 = RMU(NP(NI+1))
            CALL PGMOVE((QX+RMU1*DX)/DINDX, (QY+RMU1*DY)/DINDY)
            CALL PGDRAW((QX+RMU2*DX)/DINDX, (QY+RMU2*DY)/DINDY)
            NI = NI+2
            GOTO 50
         END IF
 60   CONTINUE
C
C Tidy up.
C
      CALL PGEBUF
C
      END

	  Block Data pgdaa
C
C Created block data subprogram to initialized variables in common blocks. 
C John S. Salmento 7/5/95
C
      INCLUDE       'pgplot.inc'
      INCLUDE 'grpckg1.inc'
      DATA          PGOPEN/0/
      DATA      GRSTAT/GRIMAX*0/
C	  DATA      prompt/.False./
      End

C*PGUPDT -- update display
C%void cpgupdt(void);
C+
      SUBROUTINE PGUPDT
C
C Update the graphics display: flush any pending commands to the
C output device. This routine empties the buffer created by PGBBUF,
C but it does not alter the PGBBUF/PGEBUF counter. The routine should
C be called when it is essential that the display be completely up to
C date (before interaction with the user, for example) but it is not
C known if output is being buffered.
C
C Arguments: none
C--
C 27-Nov-1986
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGUPDT')) RETURN
      CALL GRTERM
      END

C*GRGCOM -- read with prompt from user's terminal (MS-DOS)
C+
      INTEGER FUNCTION GRGCOM(CREAD, CPROM, LREAD)
      CHARACTER CREAD*(*), CPROM*(*)
      INTEGER   LREAD
C
C Issue prompt and read a line from the user's terminal; in VMS,
C this is equivalent to LIB$GET_COMMAND.
C
C Arguments:
C  CREAD : (output) receives the string read from the terminal.
C  CPROM : (input) prompt string.
C  LREAD : (output) length of CREAD.
C
C Returns:
C  GRGCOM : 1 if successful, 0 if an error occurs (e.g., end of file).
C--
C 1989-Mar-29
C-----------------------------------------------------------------------
      INTEGER IER
C---
   11 FORMAT(A)
C---
      GRGCOM = 0
      LREAD = 0
      WRITE (*, 101, IOSTAT=IER) CPROM
  101 FORMAT(1X,A,$)
      IF (IER.EQ.0) READ (*, 11, IOSTAT=IER) CREAD
      IF (IER.EQ.0) GRGCOM = 1
      LREAD = LEN(CREAD)
   10 IF (CREAD(LREAD:LREAD).NE.' ') GOTO 20
      LREAD = LREAD-1
      GOTO 10
   20 CONTINUE
      END

C*GREPIC -- end picture
C+
      SUBROUTINE GREPIC
C
C GRPCKG: End the current picture.
C
C Arguments: none.
C--
C 17-Nov-1994 - [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL    RBUF(6)
      INTEGER NBUF,LCHR
      CHARACTER CHR
C
C Check a plot is open.
C
      IF (GRCIDE.LT.1) RETURN
C
C End picture.
C
      IF (GRPLTD(GRCIDE)) THEN
            RBUF(1) = 1.
            NBUF = 1
            CALL GREXEC(GRGTYP,14,RBUF,NBUF,CHR,LCHR)
      END IF
      GRPLTD(GRCIDE) = .FALSE.
C
      END

      INCLUDE 'FGRAPH.FI'
      INCLUDE 'FLIB.FI'
      INCLUDE 'MOUSE.FI'
C*MSDRIV -- PGPLOT device driver for MS-DOS machines
C+
      SUBROUTINE MSDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
C     IMPLICIT NONE
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
      INCLUDE 'FGRAPH.FD'
C
C PGPLOT driver for IBM PC's and clones running Microsoft Fortran 32
C This driver will put the display into graphics mode. PGEND will
C return the monitor to the default (text) mode after pressing enter.
C
C This routine must be compiled and linked with the Microsoft graphics
C library supplied with Microsoft Fortran 32 or greater.
C The mouse routines grms1m, grms2m also require linking with mouse.obj
C 1989-Nov-03 - Started work [AFT]
C 1989-Apr-06 - Improved version [AFT]
C 1991-Mar-13 - Added cursor routine [JHT]
C 12/1993 C. T. Dum: Version for MS Fortran Power Station
C 3/95 C. T. Dum: mouse routine added
C-----------------------------------------------------------------------
C
C Supported device: IBM PC's and compatibles
C
C Device type code: /MSOFT
C
C Default device name: None (the device name, if specified, is
C ignored).
C
C Default view surface dimensions: Depends on monitor, typical 7x10 inches
C
C Resolution: Depends on graphics card.  Tested with a SVGA(TSENG
C ET4000, V7-Mercury P-64V)Card. The high resolution modes SRES
C (800*600), XRES(1024*768) and ZRES(1280*1024) require a VESA compliant
C SVGA card or an additional VESA TSR.

C Warning! Use the SRES, XRES, and ZRES modes only if they are
C supported by graphics card and monitor, else damage may result!

C Color capability: Color indices 0-15 are accepted.  This version maps
C    the PGPLOT color indices into the IBM color indices for with the
C    default color most closely corresponds to the PGPLOT default color.
C    Thus, PGPLOT index 2 (red) maps to IBM index 12 (light red).
C    The Default mode is VGA16 with 640*480 resolution. Higher resolution
C    modes are accessed by entering SET PGPLOT_VIDEO=SGA16, or XGA16, ZGA16
C    on the DOS command line, before starting programs.
C    No mapping is performed in the 256 color modes. These modes are accessed
C    by  SET PGPLOT_VIDEO=VGA25 or SGA25, XGA25, ZGA25.

C Input capability: None.
C File format: None.
C Obtaining hardcopy: Not possible.
C-----------------------------------------------------------------------
      RECORD /VIDEOCONFIG/ VID
      RECORD /XYCOORD/ XY
C
      CHARACTER CMSG*10
      INTEGER   LEVEL, MXX, MXY
      REAL A,B
      INTEGER*2 I2TAB(0:15)
      INTEGER*2 I2BLU, I2GRN, I2IND, I2PEND, I2RED
      INTEGER*2 I2STAT, I2TMP, I2X0, I2Y0, I2X1, I2Y1
      INTEGER*4 I4STAT
      LOGICAL   QFIRST
      SAVE      QFIRST, MXX, MXY
      DATA I2TAB/ 0,15,12,10, 9,11,13,14, 6, 2, 3, 1, 5, 4, 8, 7/
      DATA QFIRST/.TRUE./
C
C---
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260) IFUNC
  900 WRITE (CMSG, '(I10)') IFUNC
      CALL GRWARN('Unimplemented function in MSOFT device driver: '/
     :      /CMSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CHR = 'MSOFT'
      LCHR = 5
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 CONTINUE
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      RBUF(1) = 0.
      RBUF(2) = FLOAT(MXX)
      RBUF(3) = 0.
      RBUF(4) = FLOAT(MXY)
      RBUF(5) = 0.
      RBUF(6) = VID.NUMCOLORS-1
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C Divide the number of pixels on screen by a typical screen size in
C inches.
C
   30 continue
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      A = FLOAT(MXX)/10.0
      RBUF(1) = A
      B = FLOAT(MXY)/7.0
      RBUF(2) = B
      RBUF(3) = 1.0
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Interactive, cursor, No dashed lines, No area fill,
C    No thick lines, No rectangle fill)
C
   40 CHR = 'ICNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CHR = ' '
      LCHR = 1
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 CONTINUE
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      RBUF(1) = 0.
      RBUF(2) = FLOAT(MXX)
      RBUF(3) = 0.
      RBUF(4) = FLOAT(MXY)
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 1.
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      RBUF(1) = 0.
      RBUF(2) = 1.
      NBUF = 2
      IF(RBUF(3).NE.0.) THEN
         I2PEND=1
      ELSE
         I2PEND=0
      END IF
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
      read(*,*) ! press enter  to end graphics mode
      I2STAT = SETVIDEOMODE( $DEFAULTMODE )
      QFIRST=.TRUE.
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
      IF(QFIRST) CALL GRMS00(VID, MXX, MXY, QFIRST)
      IF(I2PEND.EQ.0) THEN
         CALL CLEARSCREEN($GCLEARSCREEN)
      END IF
      I2PEND=0
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      I2X0=NINT(RBUF(1))
      I2Y0=MXY-NINT(RBUF(2))
      CALL MOVETO(I2X0, I2Y0, XY)
      I2X1=NINT(RBUF(3))
      I2Y1=MXY-NINT(RBUF(4))
      I2STAT=LINETO(I2X1, I2Y1)
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      I2X0=NINT(RBUF(1))
      I2Y0=MXY-NINT(RBUF(2))
      I2STAT=SETPIXEL(I2X0, I2Y0)
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
  150 CONTINUE
      I2TMP=MAX(0,NINT(RBUF(1)))
      IF(I2TMP.LT.16)then
       I2IND=I2TAB(I2TMP)
      ELSE
       I2IND=I2TMP
      ENDIF
      I2STAT=SETCOLOR(I2IND)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor or mouse --------------------------------------------
C
C
  170 CONTINUE
      I2X0 = NINT(RBUF(1))
      I2Y0 = MXY-NINT(RBUF(2))
      IF(VID.MODE .EQ. $VRES16COLOR)THEN
ctd    CALL GRMS1M( I2X0, I2Y0, CHR)   ! mouse routine for VGA16, chars
ctd       assigned to buttons
       CALL GRMS2M( I2X0, I2Y0, CHR)   ! mouse routine for VGA16, waits
ctd       for keyboard input
      ELSE
       CALL GRMS1C( I2X0, I2Y0, CHR, VID)   ! cursor routine
      ENDIF
      RBUF(1) = FLOAT(I2X0)
      RBUF(2) = FLOAT(MXY-I2Y0)
      NBUF = 2
      LCHR = 1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C
  190 CONTINUE
      RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      I2TMP=MAX(0,NINT(RBUF(1)))
      IF(I2TMP.LT.16)then
       I2IND=I2TAB(I2TMP)
      ELSE
       I2IND=I2TMP
      ENDIF
      IF(VID.NUMCOLORS.EQ.16) THEN
C EGA 16 color mode
         I2RED=INT(RBUF(2)*3.999)
         I2GRN=INT(RBUF(3)*3.999)
         I2BLU=INT(RBUF(4)*3.999)
         LEVEL=(#303030.AND.(ISHFT(I2BLU,20).OR.ISHFT(I2GRN,12).OR.
     :      ISHFT(I2RED,4)))
         I4STAT=REMAPPALETTE(I2IND,LEVEL)
      ELSE IF(VID.NUMCOLORS.EQ.256) THEN
C VGA 256 color mode
         I2RED=INT(RBUF(2)*63.999)
         I2GRN=INT(RBUF(3)*63.999)
         I2BLU=INT(RBUF(4)*63.999)
         LEVEL=(#3F3F3F.AND.(ISHFT(I2BLU,16).OR.ISHFT(I2GRN,8).OR.
     :      I2RED))
         I4STAT=REMAPPALETTE(I2IND,LEVEL)
      END IF
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C
  220 CONTINUE
      RETURN
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle fill. -----------------------------------------
C
  240 CONTINUE
      RETURN
C
C--- IFUNC=25, Set fill pattern. ---------------------------------------
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels. -----------------------------------------
C
  260 CONTINUE
      RETURN
C-----------------------------------------------------------------------
      END
C*********
      SUBROUTINE GRMS00(VID, MXX, MXY, QFIRST)
      INCLUDE 'FGRAPH.FD'
      RECORD /VIDEOCONFIG/ VID
      INTEGER   MXX, MXY ,TR$L
      LOGICAL   QFIRST
C---
      INTEGER*2 I2STAT
C added parameter override of default configuration... JHT 23-Feb-1991
      character*128 TR$VID
C---
      QFIRST=.FALSE.
      CALL GRGENV('VIDEO', TR$VID, TR$L)
      IF (TR$L .EQ. 0) THEN
          CALL GETVIDEOCONFIG(VID)
ctd       IF(VID.ADAPTER.EQ.$CGA) THEN
ctd          I2STAT=SETVIDEOMODE($HRESBW)
ctd       ELSE IF(VID.ADAPTER.EQ.$OCGA) THEN
ctd          I2STAT=SETVIDEOMODE($ORESCOLOR)
          IF(VID.ADAPTER.EQ.$EGA .OR. VID.ADAPTER.EQ.$OEGA) THEN
             IF(VID.MONITOR .EQ. $MONO) THEN
                I2STAT=SETVIDEOMODE($ERESNOCOLOR)
             ELSE
                I2STAT=SETVIDEOMODE($ERESCOLOR)
             END IF
          ELSE IF(VID.ADAPTER.EQ.$VGA .OR. VID.ADAPTER.EQ.$OVGA) THEN
ctd    :         .OR. VID.ADAPTER.EQ.$MCGA) THEN
ctd no longer supported
             IF(VID.MONITOR .EQ. $MONO) THEN
                I2STAT=SETVIDEOMODE($VRES2COLOR)
             ELSE
                I2STAT=SETVIDEOMODE($VRES16COLOR)
             END IF
ctd       ELSE IF(VID.ADAPTER.EQ.$HGC) THEN
ctd          I2STAT=SETVIDEOMODE($HERCMONO)
          ELSE IF(VID.ADAPTER.EQ.$SVGA) THEN
             IF(VID.MONITOR .EQ. $MONO) THEN
                I2STAT=SETVIDEOMODE($VRES2COLOR)
             ELSE
                I2STAT=SETVIDEOMODE($VRES16COLOR)
             END IF
          ELSE
             WRITE(*,*) 'Unknown graphics adapter.'
             STOP
          END IF
      ELSE
          IF(TR$VID(:TR$L) .EQ. 'EGA16') THEN
                I2STAT=SETVIDEOMODE($ERESCOLOR)
          ELSE IF(TR$VID(:TR$L) .EQ. 'VGA16') THEN
                I2STAT=SETVIDEOMODE($VRES16COLOR)
ctd warning (MS): careful possibly monitor damage with S,X,Z modes
          ELSE IF(TR$VID(:TR$L) .EQ. 'VGA25') THEN
                I2STAT=SETVIDEOMODE($VRES256COLOR)
          ELSE IF(TR$VID(:TR$L) .EQ. 'SGA16') THEN
                I2STAT=SETVIDEOMODE($SRES16COLOR)
          ELSE IF(TR$VID(:TR$L) .EQ. 'SGA25') THEN
                I2STAT=SETVIDEOMODE($SRES256COLOR)
          ELSE IF(TR$VID(:TR$L) .EQ. 'XGA16') THEN
                I2STAT=SETVIDEOMODE($XRES16COLOR)
          ELSE IF(TR$VID(:TR$L) .EQ. 'XGA25') THEN
                I2STAT=SETVIDEOMODE($XRES256COLOR)
          ELSE IF(TR$VID(:TR$L) .EQ. 'ZGA16') THEN
                I2STAT=SETVIDEOMODE($ZRES16COLOR)
          ELSE IF(TR$VID(:TR$L) .EQ. 'ZGA25') THEN
                I2STAT=SETVIDEOMODE($ZRES256COLOR)
          else
             I2STAT=SETVIDEOMODE($MAXRESMODE)
          END IF
      END IF
      CALL GETVIDEOCONFIG(VID)
      MXX=VID.NUMXPIXELS-1
      MXY=VID.NUMYPIXELS-1
      RETURN
      END
C------
      SUBROUTINE GRMS1M( IX, IY, CHR)
      INCLUDE 'FLIB.FD'
      INCLUDE 'FGRAPH.FD'
      INCLUDE 'MOUSE.FD'
      INTEGER*2 IX, IY
      CHARACTER*(*) CHR
C* pos. and return mouse cursor
C  IX, IY coordinates (I/O)
C  CHR (O) A,X,D or CTRL-D (EOT)
C C. T. Dum, March 23,1995
C link with mouse.obj (FL32 distr.), works for vga16 only
C left button returns A for single click, X for 2 clicks within 1s
C right button returns D for single click CTRL D for 2 clicks within 1s
C link with mouse.obj (FL32 distr.), works for vga16 only
      RECORD /BTN_STS/ btns
      INTEGER*4 ip,ICHR
      ICHR = 0
      ip=0
c move mouse cursor, exit if button is pressed
      DO WHILE(ICHR .EQ. 0)
         call setptrpos(int4(ix),int4(iy))
         call setptrvis(1)
         do while(ip.eq.0)
          btns.Btn=1 ! right button
          ip=getbuttonpress(btns)
c could add middle button (btns.Btn=2) if exists, or left & right
          if(ip.gt.0)then
           ix=btns.x
           iy=btns.y
           chr='D'
           if(ip.eq.2) chr=char(4)
           ichr=ichar(chr)
          else
           btns.Btn=0 ! left button
           ip=getbuttonpress(btns)
           if(ip.gt.0)then
            ix=btns.x
            iy=btns.y
            chr='A'
            if(ip.eq.2) chr='X'
            ichr=ichar(chr)
           else
c wait 1sec
            call sleepqq(1000)
           endif
          endif
        enddo
      ENDDO
      call setptrvis(2)
      RETURN
      END

C*PGVSIZ -- set viewport (inches)
C%void cpgvsiz(float xleft, float xright, float ybot, float ytop);
C+
      SUBROUTINE PGVSIZ (XLEFT, XRIGHT, YBOT, YTOP)
      REAL XLEFT, XRIGHT, YBOT, YTOP
C
C Change the size and position of the viewport, specifying
C the viewport in physical device coordinates (inches).  The
C viewport is the rectangle on the view surface "through"
C which one views the graph.  All the PG routines which plot lines
C etc. plot them within the viewport, and lines are truncated at
C the edge of the viewport (except for axes, labels etc drawn with
C PGBOX or PGLAB).  The region of world space (the coordinate
C space of the graph) which is visible through the viewport is
C specified by a call to PGSWIN.  It is legal to request a
C viewport larger than the view surface; only the part which
C appears on the view surface will be plotted.
C
C Arguments:
C  XLEFT  (input)  : x-coordinate of left hand edge of viewport, in
C                    inches from left edge of view surface.
C  XRIGHT (input)  : x-coordinate of right hand edge of viewport, in
C                    inches from left edge of view surface.
C  YBOT   (input)  : y-coordinate of bottom edge of viewport, in
C                    inches from bottom of view surface.
C  YTOP   (input)  : y-coordinate of top  edge of viewport, in inches
C                    from bottom of view surface.
C--
C 13-Dec-1990  Make errors non-fatal [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      LOGICAL  PGNOTO
C
      IF (PGNOTO('PGVSIZ'))  RETURN
      IF (XLEFT.GE.XRIGHT .OR. YBOT.GE.YTOP) THEN
          CALL GRWARN('PGVSIZ ignored: invalid arguments')
          RETURN
      END IF
C
      PGXLEN(PGID) = (XRIGHT-XLEFT)*PGXPIN(PGID)
      PGYLEN(PGID) = (YTOP-YBOT)*PGYPIN(PGID)
      PGXVP(PGID)  = XLEFT*PGXPIN(PGID)
      PGYVP(PGID)  = YBOT*PGYPIN(PGID)
      PGXOFF(PGID) = PGXVP(PGID) + (PGNXC(PGID)-1)*PGXSZ(PGID)
      PGYOFF(PGID) = PGYVP(PGID) + 
     1                (PGNY(PGID)-PGNYC(PGID))*PGYSZ(PGID)
      CALL PGVW
      END

C*GRLEN -- inquire plotted length of character string
C+
      SUBROUTINE GRLEN (STRING, D)
C
C GRPCKG: length of text string (absolute units)
C--
C (3-Mar-1983)
C 19-Jan-1988 - remove unused label [TJP].
C  9-Sep-1989 - standardize [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      LOGICAL UNUSED
      INTEGER XYGRID(300)
      INTEGER LIST(256)
      CHARACTER*(*) STRING
      REAL FACTOR, COSA, SINA, DX, D, RATIO, FNTBAS, FNTFAC
      INTEGER I, IFNTLV, LX, NLIST
      INTRINSIC ABS, LEN
C
      D = 0.0
      IF (LEN(STRING).LE.0) RETURN
C-----------------------------------------------------------------------
C               Compute scaling and orientation
C-----------------------------------------------------------------------
      FACTOR = GRCFAC(GRCIDE)/2.5
      RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE)
      COSA = FACTOR
      SINA = 0.0
      FNTBAS = 0.0
      FNTFAC = 1.0
      IFNTLV = 0
C
C               Convert string to symbol numbers:
C               \u and \d escape sequences are converted to -1,-2
C
      CALL GRSYDS(LIST,NLIST,STRING,GRCFNT(GRCIDE))
C
C               Plot the string of characters
C
      DO 380 I = 1,NLIST
          IF (LIST(I).LT.0) THEN
              IF (LIST(I).EQ.-1) THEN
                  IFNTLV = IFNTLV+1
                  FNTBAS = FNTBAS + 16.0*FNTFAC
                  FNTFAC = 0.6**ABS(IFNTLV)
              ELSE IF (LIST(I).EQ.-2) THEN
                  IFNTLV = IFNTLV-1
                  FNTFAC = 0.6**ABS(IFNTLV)
                  FNTBAS = FNTBAS - 16.0*FNTFAC
              END IF
              GOTO 380
          END IF
          CALL GRSYXD(LIST(I),XYGRID,UNUSED)
          LX = XYGRID(5)-XYGRID(4)
          DX = COSA*LX*RATIO
          D = D + DX*FNTFAC
  380 CONTINUE
C
      END

C*GRPIXL -- solid-fill multiple rectangular areas
C+
      SUBROUTINE GRPIXL (IA, IDIM, JDIM, I1, I2, J1, J2, 
     1                   X1, X2, Y1, Y2)
      INTEGER IDIM, JDIM, I1, I2, J1, J2
      INTEGER IA(IDIM,JDIM)
      REAL    X1, X2, Y1, Y2
C
C Determine the size of each rectangular element. If it is equal
C to the device pen width and the device supports pixel primitives,
C use pixel primitives. Otherwise, if the size is smaller than the
C device pen width emulate pixel output by plotting points. If the
C size is larger than the device pen width, emulate by outputting
C solid-filled rectangles.
C
C Arguments:
C  IA     (input)  : the array to be plotted.
C  IDIM   (input)  : the first dimension of array A.
C  JDIM   (input)  : the second dimension of array A.
C  I1, I2 (input)  : the inclusive range of the first index
C                    (I) to be plotted.
C  J1, J2 (input)  : the inclusive range of the second
C                    index (J) to be plotted.
C  X1, Y1 (input)  : world coordinates of one corner of the output
C                    region
C  X2, Y2 (input)  : world coordinates of the opposite corner of the
C                    output region
C--
C 18-Jan-1991 - [Ge van Geldorp]
C 31-Mar-1993 - Include color PostScript GRPXPS [Remko Scharroo]
C  4-Apr-1993 - New version of GRPXPS incorporated
C  4-Aug-1993 - Debugging
C  7-Sep-1994 - Revised for v5.0 [TJP].
C 24-Jan-1996 - GRXMIN etc changed to REAL as required in grpckg1.inc [RS]
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL    RBUF(3)
      INTEGER NBUF, LCHR
      CHARACTER*32 CHR
      REAL    XLL, YLL, XUR, YUR
      REAL    XMIN, YMIN, XMAX, YMAX, XPIX, YPIX
      REAL    WIDTH, XSIZE, YSIZE
      INTEGER IL, IR, JB, JT
C
      IF (GRCIDE.LT.1) RETURN
C
C Convert to device coordinates
C
      CALL GRTXY0(.FALSE., X1, Y1, XLL, YLL)
      CALL GRTXY0(.FALSE., X2, Y2, XUR, YUR)
      XMIN = MIN(XLL,XUR)
      XMAX = MAX(XLL,XUR)
      YMIN = MIN(YLL,YUR)
      YMAX = MAX(YLL,YUR)
C
C Check if completely outside clipping region
C
      IF (XMAX .LT. GRXMIN(GRCIDE) .OR. GRXMAX(GRCIDE) .LT. XMIN .OR.
     1    YMAX .LT. GRYMIN(GRCIDE) .OR. GRYMAX(GRCIDE) .LT. YMIN)
     2   RETURN
C
C Don't paint "pixels" completely before left clipping boundary
C
      XPIX = XMAX - XMIN
      YPIX = YMAX - YMIN
      IF (XMIN .LT. GRXMIN(GRCIDE)) THEN
         IL = I1 + (GRXMIN(GRCIDE) - XMIN) * (I2 - I1 + 1) / XPIX
         XMIN = XMIN + (XPIX * (IL - I1)) / (I2 - I1 + 1)
      ELSE
         IL = I1
      ENDIF
C
C Don't paint "pixels" completely after right clipping boundary
C
      IF (GRXMAX(GRCIDE) .LT. XMAX) THEN
         IR = I2 - (XMAX - GRXMAX(GRCIDE)) * (I2 - I1 + 1) / XPIX + 1
         XMAX = XMIN + (XPIX * (IR - I1 + 1)) /
     1                 (I2 - I1 + 1)
      ELSE
         IR = I2
      ENDIF
C
C Don't paint "pixels" completely under bottom clipping boundary
C
      IF (YMIN .LT. GRYMIN(GRCIDE)) THEN
         JB = J1 + (GRYMIN(GRCIDE) - YMIN) * (J2 - J1 + 1) / YPIX
         YMIN = YMIN + (YPIX * (JB - J1)) / (J2 - J1 + 1)
      ELSE
         JB = J1
      ENDIF
C
C Don't paint "pixels" completely above top clipping boundary
C
      IF (GRYMAX(GRCIDE) .LT. YMAX) THEN
         JT = J2 - (YMAX - GRYMAX(GRCIDE)) * (J2 - J1 + 1) / YPIX + 1
         YMAX = YMIN + (YPIX * (JT - J1 + 1)) /
     1                 (J2 - J1 + 1)
      ELSE
         JT = J2
      ENDIF
C
C If device accepts image primitives, use GRPXPS
C
      IF (GRGCAP(GRCIDE)(7:7).EQ.'Q') THEN
         CALL GRPXPS(IA, IDIM, JDIM, IL, IR, JB, JT,
     1		     XMIN,XMAX,YMIN,YMAX)
         RETURN
      ENDIF
C
C Check against pen width
C
      CALL GREXEC(GRGTYP, 3, RBUF, NBUF, CHR, LCHR)
      WIDTH = RBUF(3)
      XSIZE = (I2 - I1 + 1) * WIDTH
      YSIZE = (J2 - J1 + 1) * WIDTH
      XPIX = XMAX - XMIN + 1
      YPIX = YMAX - YMIN + 1
C
C Use rectangles if "pixel" is too large
C
      IF (XPIX .GT. XSIZE + 0.5 * WIDTH .OR.
     1    YPIX .GT. YSIZE + 0.5 * WIDTH) THEN
*     write (6,*) 'GRPXRE'
         CALL GRPXRE(IA, IDIM, JDIM, IL, IR, JB, JT,
     1		     XMIN, XMAX, YMIN, YMAX)
C
C Use either pixel primitives or points
C
      ELSE
C
C Clip pixels lying more than 50% outside clipping boundaries
C
         IF (XMIN .LT. GRXMIN(GRCIDE) - 0.5 * WIDTH) THEN
            XMIN = XMIN + XPIX / (IR - IL + 1)
            IL = IL + 1
         ENDIF
         IF (GRXMAX(GRCIDE) + 0.5 * WIDTH .LT. XMAX) THEN
            XMAX = XMAX - XPIX / (IR - IL + 1)
            IR = IR - 1
         ENDIF
         IF (YMIN .LT. GRYMIN(GRCIDE) - 0.5 * WIDTH) THEN
            YMIN = YMIN + YPIX / (JT - JB + 1)
            JB = JB + 1
         ENDIF
         IF (GRYMAX(GRCIDE) + 0.5 * WIDTH .LT. YMAX) THEN
            YMAX = YMAX - YPIX / (JT - JB + 1)
            JT = JT - 1
         ENDIF
C
C Recalculate size
C
         XSIZE = (IR - IL + 1) * WIDTH
         YSIZE = (JT - JB + 1) * WIDTH
         XPIX = XMAX - XMIN + 1
         YPIX = YMAX - YMIN + 1
C
C Use pixel primitives if available and possible
C
         IF (GRGCAP(GRCIDE)(7:7) .EQ. 'P' .AND. 
     1       XSIZE - 0.5 * WIDTH .LE. XPIX .AND.
     2       YSIZE - 0.5 * WIDTH .LE. YPIX) THEN
*     write (6,*) 'GRPXPX'
            CALL GRPXPX(IA, IDIM, JDIM, IL, IR, JB, JT, XMIN, YMIN)
C
C Otherwise, use points
C
         ELSE
*     write (6,*) 'GRPXPO'
            CALL GRPXPO(IA, IDIM, JDIM, IL, IR, JB, JT,
     1		     XMIN, XMAX, YMIN, YMAX)
         ENDIF
      ENDIF
      END

C*PGFUNY -- function defined by X = F(Y)
C+
      SUBROUTINE PGFUNY (FX, N, YMIN, YMAX, PGFLAG)
      REAL    FX
      EXTERNAL FX
      INTEGER N
      REAL    YMIN, YMAX
      INTEGER PGFLAG
C
C Draw a curve defined by the equation X = FX(Y), where FY is a
C user-supplied subroutine.
C
C Arguments:
C  FX     (external real function): supplied by the user, evaluates
C                    X value at a given Y-coordinate.
C  N      (input)  : the number of points required to define the
C                    curve. The function FX will be called N+1 times.
C                    If PGFLAG=0 and N is greater than 1000, 1000
C                    will be used instead.  If N is less than 1,
C                    nothing will be drawn.
C  YMIN   (input)  : the minimum value of Y.
C  YMAX   (input)  : the maximum value of Y.
C  PGFLAG (input)  : if PGFLAG = 1, the curve is plotted in the
C                    current window and viewport; if PGFLAG = 0,
C                    PGENV is called automatically by PGFUNY to
C                    start a new plot with Y limits (YMIN, YMAX)
C                    and automatic scaling in X.
C
C Note: The function FX must be declared EXTERNAL in the Fortran
C program unit that calls PGFUNY.  It has one argument, the
C y-coordinate at which the x value is required, e.g.
C   REAL FUNCTION FX(Y)
C   REAL Y
C   FX = .....
C   END
C--
C  5-Oct-1983
C 11-May-1990 - remove unnecessary include [TJP].
C 13-DEc-1990 - make errors non-fatal [TJP].
C-----------------------------------------------------------------------
      INTEGER MAXP
      PARAMETER (MAXP=1000)
      INTEGER  I
      REAL     X(0:MAXP), Y(0:MAXP), DT
      REAL     XMIN, XMAX
C
      IF (N.LT.1 .OR. N.GT.MAXP) THEN
          CALL GRWARN('PGFUNY: invalid arguments')
          RETURN
      END IF
      CALL PGBBUF
C
C Evaluate function.
C
      DT = (YMAX-YMIN)/N
      X(0) = FX(YMIN)
      Y(0) = YMIN
      XMIN = X(0)
      XMAX = X(0)
      DO 10 I=1,N
          X(I) = FX(YMIN+DT*I)
          Y(I) = YMIN + DT*I
          XMIN = MIN(XMIN,X(I))
          XMAX = MAX(XMAX,X(I))
   10 CONTINUE
      DT = 0.05*(XMAX-XMIN)
      IF (DT.EQ.0.0) THEN
          XMIN = XMIN - 1.0
          XMAX = XMAX + 1.0
      ELSE
          XMIN = XMIN - DT
          XMAX = XMAX + DT
      END IF
C
C Define environment if necessary.
C
      IF (PGFLAG.EQ.0) CALL PGENV(XMIN,XMAX,YMIN,YMAX,0,0)
C
C Draw curve.
C
      CALL PGMOVE(X(0),Y(0))
      DO 20 I=1,N
          CALL PGDRAW(X(I),Y(I))
   20 CONTINUE
C
      CALL PGEBUF
      END

C*LHDRIV -- PGPLOT device driver for MS-DOS machines running Lahey F77
C 32-bit FORTRAN
C+
      SUBROUTINE LHDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      IMPLICIT NONE
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for IBM PC's and clones running Lahey F77 32-bit Fortran v5.0.
C This driver will put the display into graphics mode, and calls to 'close'
C the workstation will set it back into the previous mode (generally erasing
C the display, so don't do it until you are really finished).
C
C This routine must be compiled and linked with the Lahey graphics
C library GRAPH3 supplied with Lahey Fortran v4.0 or greater.
C
C Microsoft FORTRAN versions:
C 1989-Nov-03 - Started work [AFT]
C 1989-Apr-06 - Improved version [AFT]
C 1991-Mar-13 - Added cursor routine [JHT]
C Lahey FORTRAN versions:
C 1991-Dec-28 - derived from Microsoft version [PAH]
C-----------------------------------------------------------------------
C
C Supported device: IBM PC's and compatables
C
C Device type code: /LH
C
C Default device name: None (the device name, if specified, is
C ignored).
C
C Default view surface dimensions: Depends on monitor, typical 7x10 inches
C
C Resolution: Depends on graphics card.  Tested with a 640x480 VGA card.
C    Driver should work with other graphics cards, however, expect to
C    tweak it a bit.
C
C Color capability: Color indices 0-15 are accepted.  This version maps
C    the PGPLOT color indices into the IBM color indices for with the
C    default color most closely corresponds to the PGPLOT default color.
C    Thus, PGPLOT index 2 (red) maps to IBM index 12 (light red).
C
C Input capability: Graphics cursor implemented using Microsoft Mouse
C    or compatible, accessed through DOS calls.
C
C File format: None.
C
C Obtaining hardcopy: Not possible.
C-----------------------------------------------------------------------
      CHARACTER CMSG*10
      REAL A,B
      real       xfac, yfac
      parameter (xfac=11.0/640.0, yfac=8.5/480.0)
      integer    pencolour, pend, colourmap(0:15), ix, iy
      logical    got_mouse
      save       pencolour, pend

      DATA colourmap/ 0,15,12,10, 9,11,13,14, 6, 2, 3, 1, 5, 4, 8, 7/

C---
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260) IFUNC
  900 WRITE (CMSG, '(I10)') IFUNC
      CALL GRWARN('Unimplemented function in LAHEY device driver: '/
     :      /CMSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CHR = 'LH'
      LCHR = 2
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 CONTINUE
      RBUF(1) = 0
      RBUF(2) = 640.0
      RBUF(3) = 0
      RBUF(4) = 480.0
      RBUF(5) = 0
      RBUF(6) = 15.0
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C Divide the number of pixels on screen by a typical screen size in
C inches.
C
   30 continue
      A = 640.0/9.5
      RBUF(1) = A
      B = 480.0/7.5
      RBUF(2) = B
      RBUF(3) = 1.0
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Interactive, No cursor, No dashed lines, No area fill,
C    No thick lines, No rectangle fill, No pixel primitives,)
C
   40 continue
      if (got_mouse()) then
        CHR = 'ICNNNNNNNN'
      else
        CHR = 'INNNNNNNNN'
      endif
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CHR = ' '
      LCHR = 1
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 CONTINUE
      RBUF(1) = 0
      RBUF(2) = 640.0
      RBUF(3) = 0
      RBUF(4) = 480.0
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 1
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
      RBUF(1) = 0
      RBUF(2) = 1
      NBUF = 2
      IF(RBUF(3) .NE. 0.0) THEN
         PEND=1
      ELSE
         PEND=0
      END IF
      CALL PLOTS(0, 0, 18)
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
      CALL PLOT(0, 0, 999)
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
      IF(PEND.EQ.0) THEN
         CALL PLOT(0, 0, -999)
      ENDIF
      PEND=0
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      CALL PLOT(RBUF(1)*xfac, RBUF(2)*yfac, 3)
      CALL PLOT(RBUF(3)*xfac, RBUF(4)*yfac, 2)
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      CALL SETPIX(RBUF(1)*xfac, RBUF(2)*yfac, pencolour)
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
      IF (RBUF(1) .NE. 0.0) THEN
        CALL PLOT(0.0, 0.0, -999)
      ENDIF
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
  150 CONTINUE
      pencolour=MIN( MAX(0,NINT(RBUF(1))) ,15)
      pencolour=colourmap(pencolour)
      CALL NEWPEN(pencolour)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C
C
  170 CONTINUE
      ix = nint(rbuf(1))
      iy = 479-nint(rbuf(2))
      call show_mouse
      call put_mouse(ix,iy)
      call cursor_key(ix,iy,chr)
      rbuf(1) = ix
      rbuf(2) = 479-iy
      call hide_mouse
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C
  190 CONTINUE
      RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C
  220 CONTINUE
      RETURN
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle fill. -----------------------------------------
C
  240 CONTINUE
      RETURN
C
C--- IFUNC=25, Set fill pattern. ---------------------------------------
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels. -----------------------------------------
C
  260 CONTINUE
      RETURN
C-----------------------------------------------------------------------
      END



      logical function got_mouse()
      implicit none
      integer*2          ntrup
      integer            intary(9), eax
      equivalence        (eax,intary(1))
      eax = 0
      ntrup = 51
      call intrup(intary,ntrup)
      got_mouse = (eax .eq. 65535)
      return
      end

      subroutine show_mouse
      implicit none
      integer*2 ntrup
      integer            intary(9), eax
      equivalence        (eax,intary(1))
      eax = 1
      ntrup = 51
      call intrup(intary,ntrup)
      return
      end

      subroutine hide_mouse
      implicit none
      integer*2 ntrup
      integer            intary(9), eax
      equivalence        (eax,intary(1))
      eax = 2
      ntrup = 51
      call intrup(intary,ntrup)
      return
      end

      subroutine get_mouse(ix, iy, button)
      implicit none
      integer ix, iy, button
      integer*2 ntrup
      integer            intary(9), eax
      integer*2          bx, cx, dx
      equivalence        (eax,intary(1)),
     -                   (bx,intary(2)),
     -                   (cx,intary(3)),
     -                   (dx,intary(4))
      eax = 3
      ntrup = 51
      call intrup(intary,ntrup)
      ix = cx
      iy = dx
      button = bx
      return
      end

      subroutine put_mouse(ix, iy)
      implicit none
      integer ix, iy
      integer*2 ntrup
      integer            intary(9), eax
      integer*2          bx, cx, dx
      equivalence        (eax,intary(1)),
     -                   (bx,intary(2)),
     -                   (cx,intary(3)),
     -                   (dx,intary(4))
      eax = 4
      cx = ix
      dx = iy
      ntrup = 51
      call intrup(intary, ntrup)
      return
      end

      subroutine cursor_key(ix, iy, key)
      implicit none
      character*(*) key
      integer ix, iy, ikey, ib
      integer*2 ixkey
      ikey = ixkey()
      key = char(ikey)
      call get_mouse(ix, iy, ib)
      return
      end

C*GRCHKT -- determine whether a device is a terminal (VMS)
C+
      INTEGER FUNCTION GRCHKT (TERM)
      CHARACTER*(*) TERM
C
C Argument:
C  TERM (input): the name of the device according to VMS
C       conventions, ie a physical device name (_TTA4:) or a logical
C       name.
C
C Returns:
C  GRCHKT (integer): a TRUE value (odd) if TERM is a terminal device,
C       a FALSE value otherwise.
C--
C  1-Feb-1983
C 24-Jan-1986 - use LIB$GETDVI [TJP].
C-----------------------------------------------------------------------
      INTEGER   DC$_TERM, DVI$_DEVCLASS
      PARAMETER (DC$_TERM=66)
      PARAMETER (DVI$_DEVCLASS=4)
C
      INTEGER  DEVCLASS, IER, LIB$GETDVI
C
      IER = LIB$GETDVI(DVI$_DEVCLASS, , TERM, DEVCLASS)
      IF (IER.NE.1) THEN
          GRCHKT = IER
      ELSE IF (DEVCLASS.EQ.DC$_TERM) THEN
          GRCHKT = 1
      ELSE
          GRCHKT = 4828 ! "input device is not a terminal"
      END IF
C
      END

      SUBROUTINE PGCN01(Z, MX, MY, IA, IB, JA, JB, Z0, PLOT,
     1                  FLAGS, IS, JS, SDIR)
C
C Support routine for PGCNSC. This routine draws a continuous contour,
C starting at the specified point, until it either crosses the edge of
C the array or closes on itself.
C-----------------------------------------------------------------------
      INTEGER UP, DOWN, LEFT, RIGHT
      PARAMETER (UP=1, DOWN=2, LEFT=3, RIGHT=4)
      INTEGER  MAXEMX, MAXEMY
      PARAMETER (MAXEMX=100, MAXEMY=100)
      LOGICAL FLAGS(MAXEMX,MAXEMY,2)
      INTEGER MX, MY, IA, IB, JA, JB, IS, JS, I, J, II, JJ, DIR, SDIR
      REAL Z(MX,*)
      REAL Z0, X, Y, STARTX, STARTY
      EXTERNAL PLOT
C
      I = IS
      J = JS
      DIR = SDIR
      II = 1+I-IA
      JJ = 1+J-JA
      IF (DIR.EQ.UP .OR. DIR.EQ.DOWN) THEN
          X = REAL(I) + (Z0-Z(I,J))/(Z(I+1,J)-Z(I,J))
          Y = REAL(J)
      ELSE
          X = REAL(I)
          Y = REAL(J) + (Z0-Z(I,J))/(Z(I,J+1)-Z(I,J))
      END IF
CD    WRITE (*,*) 'SEGMENT'
C
C Move to start of contour and record starting point.
C
      CALL PLOT(0, X, Y, Z0)
      STARTX = X
      STARTY = Y
C
C We have reached grid-point (I,J) going in direction DIR (UP, DOWN,
C LEFT, or RIGHT). Look at the other three sides of the cell we are
C entering to decide where to go next. It is important to look to the
C two sides before looking straight ahead, in order to avoid self-
C intersecting contours. If all 3 sides have unused crossing-points,
C the cell is "degenerate" and we have to decide which of two possible 
C pairs of contour segments to draw; at present we make an arbitrary 
C choice. If we have reached the edge of the array, we have
C finished drawing an unclosed contour. If none of the other three
C sides of the cell have an unused crossing-point, we must have
C completed a closed contour, which requires a final segment back to
C the starting point.
C
  100 CONTINUE
CD    WRITE (*,*) I,J,DIR
      II = 1 + I - IA
      JJ = 1 + J - JA
      GOTO (110, 120, 130, 140), DIR
C
C DIR = UP
C
  110 CONTINUE
      FLAGS(II,JJ,1) = .FALSE.
      IF (J.EQ.JB) THEN
          RETURN
      ELSE IF (FLAGS(II,JJ,2)) THEN
          DIR = LEFT
          GOTO 200
      ELSE IF (FLAGS(II+1,JJ,2)) THEN
          DIR = RIGHT
          I = I+1
          GOTO 200
      ELSE IF (FLAGS(II,JJ+1,1)) THEN
C!        DIR = UP
          J = J+1
          GOTO 250
      ELSE
          GOTO 300
      END IF
C
C DIR = DOWN
C
  120 CONTINUE
      FLAGS(II,JJ,1) = .FALSE.
      IF (J.EQ.JA) THEN
          RETURN
      ELSE IF (FLAGS(II+1,JJ-1,2)) THEN
          DIR = RIGHT
          I = I+1
          J = J-1
          GOTO 200
      ELSE IF (FLAGS(II,JJ-1,2)) THEN
          DIR = LEFT
          J = J-1
          GOTO 200
      ELSE IF (FLAGS(II,JJ-1,1)) THEN
C!        DIR = DOWN
          J = J-1
          GOTO 250
      ELSE
          GOTO 300
      END IF
C
C DIR = LEFT
C
  130 CONTINUE
      FLAGS(II,JJ,2) = .FALSE.
      IF (I.EQ.IA) THEN
          RETURN
      ELSE IF (FLAGS(II-1,JJ,1)) THEN
          DIR = DOWN
          I = I-1
          GOTO 250
      ELSE IF (FLAGS(II-1,JJ+1,1)) THEN
          DIR = UP
          I = I-1
          J = J+1
          GOTO 250
      ELSE IF (FLAGS(II-1,JJ,2)) THEN
C!        DIR = LEFT
          I = I-1
          GOTO 200
      ELSE
          GOTO 300
      END IF
C
C DIR = RIGHT
C
  140 CONTINUE
      FLAGS(II,JJ,2) = .FALSE.
      IF (I.EQ.IB) THEN
          RETURN
      ELSE IF (FLAGS(II,JJ+1,1)) THEN
          DIR = UP
          J = J+1
          GOTO 250
      ELSE IF (FLAGS(II,JJ,1)) THEN
          DIR = DOWN
          GOTO 250
      ELSE IF (FLAGS(II+1,JJ,2)) THEN
C!        DIR = RIGHT
          I = I+1
          GOTO 200
      ELSE
          GOTO 300
      END IF
C
C Draw a segment of the contour.
C
  200 X = REAL(I)
      Y = REAL(J) + (Z0-Z(I,J))/(Z(I,J+1)-Z(I,J))
      CALL PLOT(1,X,Y,Z0)
      GOTO 100
  250 X = REAL(I) + (Z0-Z(I,J))/(Z(I+1,J)-Z(I,J))
      Y = REAL(J)
      CALL PLOT(1,X,Y,Z0)
      GOTO 100
C
C Close the contour and go look for another one.
C
  300 CALL PLOT(1,STARTX,STARTY,Z0)
      RETURN
C
      END

C*GRWARN -- issue warning message to user
C+
      SUBROUTINE GRWARN (TEXT)
      CHARACTER*(*) TEXT
C
C Report a warning message on standard output, with prefix "%PGPLOT, ".
C
C Argument:
C  TEXT (input): text of message to be printed (the string
C      may not be blank).
C--
C  8-Nov-1994 [TJP]
C-----------------------------------------------------------------------
      INTEGER   GRTRIM
C
      IF (TEXT.NE.' ') THEN
          WRITE (*, '(1X,2A)') '%PGPLOT, ', TEXT(1:GRTRIM(TEXT))
      END IF
      END

C*PGLCUR -- draw a line using the cursor
C%void cpglcur(int maxpt, int *npt, float *x, float *y);
C+
      SUBROUTINE PGLCUR (MAXPT, NPT, X, Y)
      INTEGER MAXPT, NPT
      REAL    X(*), Y(*)
C
C Interactive routine for user to enter a polyline by use of
C the cursor.  Routine allows user to Add and Delete vertices;
C vertices are joined by straight-line segments.
C
C Arguments:
C  MAXPT  (input)  : maximum number of points that may be accepted.
C  NPT    (in/out) : number of points entered; should be zero on
C                    first call.
C  X      (in/out) : array of x-coordinates (dimension at least MAXPT).
C  Y      (in/out) : array of y-coordinates (dimension at least MAXPT).
C
C Notes:
C
C (1) On return from the program, cursor points are returned in
C the order they were entered. Routine may be (re-)called with points
C already defined in X,Y (# in NPT), and they will be plotted
C first, before editing.
C
C (2) User commands: the user types single-character commands
C after positioning the cursor: the following are accepted:
C   A (Add)    - add point at current cursor location.
C   D (Delete) - delete last-entered point.
C   X (eXit)   - leave subroutine.
C--
C  5-Aug-1984 - new routine [TJP].
C 16-Jul-1988 - correct error in delete operation [TJP].
C 13-Dec-1990 - change warnings to messages [TJP].
C  3-Sep-1992 - fixed erase first point bug under Add option [JM/TJP].
C  7-Sep-1994 - use PGBAND [TJP].
C  2-Aug-1995 - remove dependence on common block [TJP].
C-----------------------------------------------------------------------
      LOGICAL  PGNOTO
      CHARACTER*1 LETTER
      INTEGER  PGBAND, I, SAVCOL, MODE
      REAL     XP, YP, XREF, YREF
      REAL     XBLC, XTRC, YBLC, YTRC
C
C Check that PGPLOT is in the correct state.
C
      IF (PGNOTO('PGLCUR')) RETURN
C
C Save current color.
C
      CALL GRQCI(SAVCOL)
C
C Put current line-segments on screen.
C
      IF (NPT.EQ.1) THEN
          CALL PGPT(1,X(1),Y(1),1)
      END IF
      IF (NPT.GT.0) THEN
          CALL GRMOVA(X(1),Y(1))
          DO 10 I=2,NPT
              CALL GRLINA(X(I),Y(I))
   10     CONTINUE
      END IF
C
C Start with the cursor in the middle of the box,
C unless lines have already been drawn.
C
      CALL PGQWIN(XBLC, XTRC, YBLC, YTRC)
      IF (NPT.GT.0) THEN
          XP = X(NPT)
          YP = Y(NPT)
      ELSE
          XP = 0.5*(XBLC+XTRC)
          YP = 0.5*(YBLC+YTRC)
      END IF
C
C Loop over cursor inputs.
C
      MODE = 0
  100 XREF = XP
      YREF = YP
      IF (PGBAND(MODE,1,XREF,YREF,XP,YP,LETTER).NE.1) RETURN
      CALL GRTOUP(LETTER,LETTER)
      MODE = 1
C
C A (ADD) command:
C
      IF (LETTER .EQ. 'A') THEN
          IF (NPT.GE.MAXPT) THEN
            CALL GRMSG('ADD ignored (too many points).')
              GOTO 100
          END IF
          NPT = NPT+1
          X(NPT) = XP
          Y(NPT) = YP
          IF (NPT.EQ.1) THEN
C           -- first point: draw a dot
            CALL GRMOVA(X(NPT),Y(NPT))
            CALL PGPT(1,X(NPT),Y(NPT),1)
          ELSE
C           -- nth point: draw from (n-1) to (n)
            CALL GRLINA(X(NPT),Y(NPT))
          END IF
          CALL GRTERM
C
C D (DELETE) command:
C
      ELSE IF (LETTER.EQ.'D') THEN
          IF (NPT.LE.0) THEN
            CALL GRMSG('DELETE ignored (there are no points left).')
            GOTO 100
          END IF
          IF (NPT.GT.1) THEN
C           -- delete nth point: erase from (n-1) to (n)
            CALL GRMOVA(X(NPT-1),Y(NPT-1))
            CALL GRSCI(0)
            CALL GRLINA(X(NPT),Y(NPT))
            CALL GRSCI(SAVCOL)
            CALL GRMOVA(X(NPT-1),Y(NPT-1))
            CALL GRTERM
          ELSE IF (NPT.EQ.1) THEN
C           -- delete first point: erase dot
            CALL GRSCI(0)
            CALL PGPT(1,X(NPT),Y(NPT),1)
            CALL GRSCI(SAVCOL)
          END IF
          NPT = NPT-1
          IF (NPT.EQ.0) THEN
            XP = 0.5*(XBLC+XTRC)
            YP = 0.5*(YBLC+YTRC)
          ELSE
            XP = X(NPT)
            YP = Y(NPT)
          END IF
          IF (NPT.EQ.1) THEN
C           -- delete 2nd point: redraw dot at first point
            CALL PGPT(1,X(1),Y(1),1)
          END IF
C
C X (EXIT) command:
C
      ELSE IF (LETTER.EQ.'X') THEN
          CALL GRETXT
          RETURN
C
C Illegal command:
C
      ELSE
          CALL GRMSG('Commands are A (add), D (delete), X (exit).')
      END IF
C
      GOTO 100
      END

C*GRTRN0 -- define scaling transformation
C+
      SUBROUTINE GRTRN0 (XORG,YORG,XSCALE,YSCALE)
C
C GRPCKG (internal routine): Define scaling transformation for current
C device (equivalent to GRTRAN without device selection).
C
C Arguments:
C
C XORG, YORG, XSCALE, YSCALE (input, real): parameters of the scaling
C       transformation. This is defined by:
C               XABS = XORG + XWORLD * XSCALE,
C               YABS = YORG + YWORLD * YSCALE,
C       where (XABS, YABS) are the absolute device coordinates
C       corresponding to world coordinates (XWORLD, YWORLD).
C--
C  1-Feb-83:
C 11-Feb-92: Add driver support (TJP).
C  1-Sep-94: Suppress driver call (TJP).
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL     XORG, YORG, XSCALE, YSCALE
      REAL           RBUF(6)
      INTEGER        NBUF,LCHR
      CHARACTER*16   CHR
C
      GRXORG(GRCIDE) = XORG
      GRXSCL(GRCIDE) = XSCALE
      GRYORG(GRCIDE) = YORG
      GRYSCL(GRCIDE) = YSCALE
C
C Pass info to device driver?
C
      IF (GRGCAP(GRCIDE)(2:2).EQ.'X') THEN
          RBUF(1) = XORG
          RBUF(2) = XSCALE
          RBUF(3) = YORG
          RBUF(4) = YSCALE
          NBUF = 4
          LCHR = 0
          CALL GREXEC(GRGTYP,27,RBUF,NBUF,CHR,LCHR)
      END IF
C
      END

C PGAXLG -- draw a logarithmic axis [internal routine]
C
      SUBROUTINE PGAXLG (OPT, X1, Y1, X2, Y2, V1, V2, STEP,
     :                   DMAJL, DMAJR, FMIN, DISP, ORIENT)
      CHARACTER*(*) OPT
      REAL X1, Y1, X2, Y2, V1, V2, STEP
      REAL DMAJL, DMAJR, FMIN, DISP, ORIENT
C
C Draw a labelled graph axis from world-coordinate position (X1,Y1)
C  to (X2,Y2). The quantity described by the axis runs from 10**V1 to
C 10**V2. A logarithmic axis always has major, labeled, tick marks 
C spaced by one or more decades. If the major tick marks are spaced
C by one decade (as specified by the STEP argument), then minor
C tick marks are placed at 2, 3, .., 9 times each power of 10;
C otherwise minor tick marks are spaced by one decade. If the axis
C spans less than two decades, numeric labels are placed at 1, 2, and
C 5 times each power of ten.
C
C It is not advisable to use this routine if the axis spans less than
C one decade, or if it spans many decades. In these cases it is
C preferable to use a linear axis labeled with the logarithm of the
C quantity of interest.
C
C Arguments:
C  OPT    (input)  : a string containing single-letter codes for
C                    various options. The options currently
C                    recognized are:
C                    N : write numeric labels
C                    1 : force decimal labelling, instead of automatic
C                        choice (see PGNUMB).
C                    2 : force exponential labelling, instead of
C                        automatic.
C  X1, Y1 (input)  : world coordinates of one endpoint of the axis.
C  X2, Y2 (input)  : world coordinates of the other endpoint of the axis.
C  V1     (input)  : logarithm of axis value at first endpoint.
C  V2     (input)  : logarithm of axis value at second endpoint.
C  STEP   (input)  : the number of decades between major (labeled) tick
C                    marks.
C  DMAJL  (input)  : length of major tick marks drawn to left of axis
C                    (as seen looking from first endpoint to second), in
C                    units of the character height.
C  DMAJR  (input)  : length of major tick marks drawn to right of axis,
C                    in units of the character height.
C  FMIN   (input)  : length of minor tick marks, as fraction of major.
C  DISP   (input)  : displacement of baseline of tick labels to
C                    right of axis, in units of the character height.
C  ORIENT (input)  : orientation of text label relative to axis (see
C                    PGTICK).
C--
C 25-Mar-1997 - new routine [TJP].
C-----------------------------------------------------------------------
      REAL V, VMIN, VMAX, DVMAJ, DVMIN, PGRND
      INTEGER I, K, K1, K2, LLAB, NSUBT, CLIP, FORM
      LOGICAL XLAB, OPTN
      CHARACTER*32 LABEL
      REAL TAB(9)
C
C Table of logarithms 1..9
C
      DATA TAB / 0.00000, 0.30103, 0.47712, 0.60206, 0.69897,
     :           0.77815, 0.84510, 0.90309, 0.95424 /
C
C Check arguments.
C
      IF (X1.EQ.X2 .AND. Y1.EQ.Y2) RETURN
      IF (V1.EQ.V2) RETURN
C
C Decode options.
C
      OPTN = INDEX(OPT,'N').NE.0 .OR. INDEX(OPT,'n').NE.0
      FORM =0
      IF (INDEX(OPT,'1').NE.0) FORM = 1
      IF (INDEX(OPT,'2').NE.0) FORM = 2
C
C Choose major interval (DVMAJ in the logarithm, with minimum value
C 1.0 = one decade). The minor interval is always 1.0.
C
      IF (STEP.GT.0.5) THEN
         DVMAJ = NINT(STEP)
      ELSE
         DVMAJ = PGRND(0.20*ABS(V1-V2),NSUBT)
         IF (DVMAJ.LT.1.0) DVMAJ = 1.0
      END IF
      DVMIN = 1.0
      NSUBT = DVMAJ/DVMIN
C
      CALL PGBBUF
      CALL PGQCLP(CLIP)
      CALL PGSCLP(0)
C
C Draw the axis.
C
      CALL PGMOVE(X1, Y1)
      CALL PGDRAW(X2, Y2)
C
C Draw the tick marks. Major ticks are drawn at V = K*DVMAJ.
C
      VMIN = MIN(V1, V2)
      VMAX = MAX(V1, V2)
      K1 = INT(VMIN/DVMIN)
      IF (DVMIN*K1.LT.VMIN) K1 = K1+1
      K2 = INT(VMAX/DVMIN)
      IF (DVMIN*K2.GT.VMAX) K2 = K2-1
      XLAB = (K2-K1) .LE. 2
      DO 20 K=K1,K2
         V = (K*DVMIN-V1)/(V2-V1)
         IF (MOD(K,NSUBT).EQ.0) THEN
C             -- major tick mark
            IF (OPTN) THEN
               CALL PGNUMB(1, NINT(K*DVMIN), FORM, LABEL, LLAB)
            ELSE
               LABEL = ' '
               LLAB = 1
            END IF
            CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL, DMAJR,
     :                  DISP, ORIENT, LABEL(:LLAB))
         ELSE
C             -- minor tick mark
            CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL*FMIN, DMAJR*FMIN,
     :                  0.0, ORIENT, ' ')
         END IF
 20   CONTINUE
C
C Draw intermediate tick marks if required. 
C Label them if axis spans less than 2 decades.
C
      IF (NSUBT.EQ.1) THEN
         DO 30 K=K1-1,K2+1
            DO 25 I=2,9
               V = (K*DVMIN + TAB(I) -V1)/(V2-V1)
               IF (V.GE.0.0 .AND. V.LE.1.0) THEN
                  IF (OPTN.AND.(XLAB .AND.(I.EQ.2 .OR. I.EQ.5))) THEN
C                    -- labeled minor tick mark
                     CALL PGNUMB(I, NINT(K*DVMIN), FORM, LABEL, LLAB)
                  ELSE
C                    -- unlabeled minor tick mark
                     LABEL = ' '
                     LLAB = 1
                  END IF
                  CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL*FMIN, DMAJR*FMIN,
     :                        DISP, ORIENT, LABEL(:LLAB))
               END IF
 25         CONTINUE
 30      CONTINUE
      END IF
C
      CALL PGSCLP(CLIP)
      CALL PGEBUF
      END

C*GRGE03
C+
      SUBROUTINE GRGE03(QBUF,ICNT)
C
C GRPCKG (Internal routine): Write ICNT bytes in QBUF onto logical
C unit LUN.  Reset ICNT to zero.
C Based on GRxx03 routines, this version does not contain a common
C block.
C ***NOTE*** INIT03 must be called before any calls to GRGE02 to
C set the LUN/Channel to which the buffer should be dumped.
C This subroutine contains the entry point INIT03 that defines
C the variables ITYPE, LUN and IFUNC.  If ITYPE=0 then LUN is
C the Fortran logical unit number to which the data should be
C written.  If ITYPE>0 then LUN is the Channel number for a QIO
C operation and IFUNC is the QIO write function.
C
C Arguments:
C
C QBUF            I/O Byte The output buffer.
C ICNT            I/O I    Current number of bytes used in QBUF.
C
C  5-Aug-1986 - [AFT].
C-----------------------------------------------------------------------
      IMPLICIT NONE
      INCLUDE '($SSDEF)'
      INTEGER SYS$QIOW
      INTEGER ICNT
      BYTE QBUF(*)
      INTEGER RESULT, N, I
      INTEGER*2 IOSB(4)
      INTEGER INTYPE,INLUN,INFUNC
      INTEGER ITYPE,LUN,IFUNC
      SAVE    ITYPE,LUN,IFUNC
C
      N = ICNT
      ICNT = 0
      IF (N.LT.1) RETURN
C
      IF(ITYPE.EQ.0) THEN
          WRITE(LUN,101, ERR=900) (QBUF(I),I=1,N)
  101     FORMAT(130A1)
      ELSE
          RESULT = SYS$QIOW(,%VAL(LUN),
     1            %VAL(IFUNC),IOSB,,,
     2            QBUF,%VAL(N),%VAL(5),,,)
          IF (RESULT.NE.SS$_NORMAL) THEN
            CALL GRGMSG(RESULT)
            CALL GRGMSG('SYS$QIOW error writing to device.  '//
     &            'Program continues.')
          END IF
          IF (IOSB(1).NE.SS$_NORMAL) THEN
            CALL GRGMSG(IOSB(1))
            CALL GRGMSG('SYS$QIOW (IOSB) status writing to device.  '//
     &            'Program continues.')
          END IF
      END IF
      RETURN
C---
  900 CONTINUE
      RETURN
C---
      ENTRY INIT03(INTYPE,INLUN,INFUNC)
C--- Save info needed to dump buffer.
      ITYPE=INTYPE
      LUN=INLUN
      IFUNC=INFUNC
      RETURN
      END

* Date: Tue, 27 Aug 1996 13:28:34 -0400
* From: Jerry Johnson 123 ROB/MRL/PSU <JOHNSON@vax1.mrl.psu.edu>

C*VTDRIV -- PGPLOT Regis (VT125) driver
C+
      SUBROUTINE VTDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Regis devices.
C
C Version 1.1 - 1987 Aug 17 - add cursor (TJP).
C Version 1.2 - 1988 Jan 11 - use SMG$ routines for cursor control.
C Version 1.3 - 1988 Mar 23 - add rectangle fill.
C Version 1.4 - 1988 Oct 27 - correct cursor bug.
C Version 1.5 - 1992 Sep 04 - whq - add support for 16 color DEC VT340
C
C Supported devices: Digital Equipment Corporation VT125, VT240, or
C VT241 terminal; other REGIS devices may also work. (VT330, VT340 - whq)
C
C Device type code: /VT125.
C
C Default file name: TT:PGPLOT.VTPLOT. This usually means the
C terminal you are logged in to (logical name TT), but the plot can be
C sent to another terminal by giving the device name, eg, TTC0:/VT, or
C it can be saved in a file by specifying a file name, eg,
C CITSCR:[TJP]XPLOT/VT (in this case a disk name must be included as
C part of the file name).
C
C Default view surface dimensions: Depends on monitor.
C
C Resolution: The default view surface is 768 (horizontal) x
C 460 (vertical) pixels.  On most Regis devices, the resolution is
C degraded in the vertical direction giving only 230 distinguishable
C raster lines. (There are actually 240 raster lines, but 10 are reserved
C for a line of text.)
C
C Color capability:  Color indices 0--3 are supported. By default,
C color index 0 is black (the background color). Color indices 1--3
C are white, red, and green on color monitors, or white, dark grey, and
C light grey on monochrome monitors.  The color representation of all
C the color indices can be changed, although only a finite number of
C different colors can be obtained (see the manual for the terminal).
c	whq - Color indices 0--15 are supported if the device is a VT340.
C
C Input capability: The graphics cursor is a blinking
C diamond-crosshair. The user positions the cursor using the arrow keys
C and PF1--PF4 keys on his keyboard (SYS$COMMAND) [Note: NOT the key-
C board of the terminal on which he is plotting, if that is different.]
C The arrow keys move the cursor in the appropriate direction; the size
C of the step for each keystroke is controlled by the PF1--PF4 keys: PF1
C -> 1 pixel, PF2 -> 4 pixels, PF3 -> 16 pixels, PF4 -> 64 pixels. [The
C VT240 terminal has a built-in capability to position the cursor, but
C PGPLOT does not use this as it is not available on the VT125.] The
C user indicates that the cursor has been positioned by typing any
C character other than an arrow or PF1-PF4 key [control characters, eg,
C control-C, and other special characters should be avoided, as they
C may be intercepted by the operating system].
C
C File format: A REGIS plot file is formatted in records of 80
C characters or less, and has no carriage-control attributes. The
C records are grouped into ``buffers,'' each of which begins with
C <esc>Pp to put the terminal into graphics mode and ends with <esc>\
C to put it back into text mode.  The terminal is in graphics mode only
C while a buffer is being transmitted, so a user's program can write to
C the terminal at any time (in text mode) without worrying if it might
C be in graphics mode. Everything between the escape sequences is
C REGIS: see the VT125 or VT240 manual for an explanation.  PGPLOT
C attempts to minimize the number of characters in the REGIS commands,
C but REGIS is not a very efficient format. It does have the great
C advantage, though, that it can easily be examined with an editor.
C The file may also contain characters outside the <esc>Pp ... <esc>\
C delimiters, eg, escape sequences to erase the text screen and home
C the cursor.
C
C The following escape sequences are used:
C
C [2J Erase entire screen (text)
C [H  Move cursor to home position
C Pp  Enter REGIS graphics mode
C \   Leave REGIS graphics mode
C
C PGPLOT uses a very limited subset of the REGIS commands supported
C by the VT125 and VT240. The following list summarizes the REGIS
C commands presently used.
C
C Initialization: the following standard commands are used to initialize
C the device every time a new frame is started; most of these restore a
C VT125 or VT240 to its default state, but the screen addressing mode is
C nonstandard.
C
C ;                         resynchronize
C W(R)                      replace mode writing
C W(I3)                     color index 1
C W(F3)                     both bit planes
C W(F15)                    all bit planes for VT340 (whq)
C W(M1)                     unit multiplier
C W(N0)                     negative off
C W(P1)                     pattern 1
C W(P(M2))                  pattern multiplier 2
C W(S0)                     shading off
C S(E)                      erase screen
C S(G1)                     select graphics plane [Rainbow REGIS]
C S(A[0,479][767,0])        screen addressing, origin at bottom left
C S(I0)                     background dark
C S(S1)                     scale 1
C S(M0(L0)(AL0))            output map section 0 (black)
C S(M1(L30)(AH120L50S100))  output map section 1 (red/dim grey)
C S(M2(L59)(AH240L50S100))  output map section 2 (green/light grey)
C S(M3(L100)(AL100))        output map section 3 (white)
c
c		whq - output map sections for VT340 - colors per PGPLOT manual
c S(M0(L0)(AL0))            output map section 0 (black)	! whq
c S(M3(L100)(AL100))        output map section 3 (white)	! whq
c S(M1(L27)(AH120L46S72))   output map section 1 (red)		! whq
c S(M2(L52)(AH240L50S60))   output map section 2 (green)	! whq
c S(M4(L6)(AH0L50S60))      output map section 4 (blue)		! whq
c S(M5(L86)(AH300L50S60))   output map section 5 (cyan)		! whq
c S(M6(L19)(AH60L50S60))    output map section 6 (magenta)	! whq
c S(M7(L59)(AH180L50S60))   output map section 7 (yellow)	! whq
c S(M8(L46)(AH150L50S60))   output map section 8 (red+yellow)	! whq
c S(M9(L72)(AH210L50S60))   output map section 9 (green+yellow)	! whq
c S(M10(L79)(AH270L50S60))  output map section 10 (green+cyan)	! whq
c S(M11(L92)(AH330L50S60))  output map section 11 (blue+cyan)	! whq
c S(M12(L12)(AH30L50S60))   output map section 12 (blue+magenta) ! whq
c S(M13(L39)(AH90L50S60))   output map section 13 (red+magenta)	! whq
c S(M14(L33)(AL33))         output map section 14 (dark gray)	! whq
c S(M15(L66)(AL66))         output map section 15 (light gray)	! whq
C
C Drawing lines: the P and V commands are used with absolute
C coordinates, relative coordinates, and pixel vectors. The (B)
C S), (E), and (W) modifiers are not used. Coordinates
C which do not change are omitted.
C
C P[x,y]                    move to position, eg P[499,0]
C V[x,y]                    draw vector to position, eg
C                           V[][767][,479][0][,0]
C
C Line attributes: the line style and line color attributes are
C specified with W commands, eg
C
C W(P2)                     line style 2
C W(I2)                     intensity (color index) 2
C
C and S commands are used to change the output map.  The PGPLOT color
C indices 0, 1, 2, 3 correspond to output map sections 0, 3, 1, 2.
C
C Obtaining hardcopy: A hardcopy of the plot can be obtained
C using a printer attached to the VT125/VT240 terminal (see the
C instruction manual for the terminal). A plot stored in disk file
C can be displayed by issuing a TYPE command (eg, TYPE PGPLOT.VTPLOT)
C on a VT125 or VT240.
C-----------------------------------------------------------------------

      CHARACTER*(*) TYPE, DEFNAM
      PARAMETER (TYPE='VT125')
      PARAMETER (DEFNAM='PGPLOT.VTPLOT')
C
      CHARACTER*(*) VTINIT
      PARAMETER (VTINIT=';W(RI3F3M1N0P1P(M2)S0)S(E)'//
     1                  'S(G1A[0,479][767,0]I0S1)'//
     2                  'S(M0(L0)(AL0))'//
     3                  'S(M3(L100)(AL100))'//
     4                  'S(M1(L30)(AH120L50S100))'//
     5                  'S(M2(L59)(AH240L50S100))')
      character*(*) vt340init					! whq
      parameter (vt340init=';W(RI3F15M1N0P1P(M2)S0)S(E)'//	! whq
     +                  'S(G1A[0,479][767,0]I0S1)'//		! whq
     +                  'S(M0(L0)(AL0))'//			! whq
     +                  'S(M3(L100)(AL100))'//			! whq
     +                  'S(M1(L27)(AH120L46S72))'//		! whq
     +                  'S(M2(L52)(AH240L50S60))'//		! whq
     +                  'S(M4(L6)(AH0L50S60))'//		! whq
     +                  'S(M5(L86)(AH300L50S60))'//		! whq
     +                  'S(M6(L19)(AH60L50S60))'//		! whq
     +                  'S(M7(L59)(AH180L50S60))'//		! whq
     +                  'S(M8(L46)(AH150L50S60))'//		! whq
     +                  'S(M9(L72)(AH210L50S60))'//		! whq
     +                  'S(M10(L79)(AH270L50S60))'//		! whq
     +                  'S(M11(L92)(AH330L50S60))'//		! whq
     +                  'S(M12(L12)(AH30L50S60))'//		! whq
     +                  'S(M13(L39)(AH90L50S60))'//		! whq
     +                  'S(M14(L33)(AL33))'//			! whq
     +                  'S(M15(L66)(AL66))')			! whq
      CHARACTER*(*) CURSOR, VTERAS
      PARAMETER (CURSOR=CHAR(27)//'[24;1f')
      PARAMETER (VTERAS=CHAR(27)//'[2J'//CHAR(27)//'[H')
      CHARACTER*10 MSG
      INTEGER  IER, I0, J0, I1, J1, L, LASTI, LASTJ, UNIT
      INTEGER  CI, LW, NPTS, L1, L2, BUFFER, BUFSIZ, BUFLEV
      INTEGER  MONO, IR, IG, IB, IX, IY, ICH
      REAl     CH, CL, CS
      PARAMETER (BUFSIZ=1024)
      INTEGER  LIB$GET_VM, LIB$FREE_VM
      INTEGER  SMG$CREATE_VIRTUAL_KEYBOARD
      INTEGER  SMG$DELETE_VIRTUAL_KEYBOARD
      INTEGER  SMG$SET_KEYPAD_MODE
      INTEGER  KBID
      LOGICAL  START, APPEND
      CHARACTER*64  INSTR
      CHARACTER*20  INSTR1,INSTR2
      CHARACTER*2   PIX(0:22)
      DATA PIX    /'V5','V4','V3',7*'  ','V6',' ','V2',7*' ','V7',
     1             'V0','V1'/
c      INTEGER VTCODE(0:3)		! whq - old vtcode array
c      DATA VTCODE/ 0, 3, 1, 2 /	! whq - maintain 1st 4 in new array

      integer vtcode(0:15)		! whq - new vtcode array
      data vtcode /0,3,1,2,4,5,6,7,8,9,10,11,12,13,14,15/	! whq

      logical lvt340 /.false./		! whq - true if vt340 terminal
      logical grvt340			! whq - function for vt340 testing
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     &     110,120,130,140,150,160,170,180,190,200,
     &     210,220,230,240), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in VT device driver: '//MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 767
      RBUF(3) = 0
      RBUF(4) = 479
      RBUF(5) = 0
      RBUF(6) = 3
      if (lvt340) RBUF(6) = 15		! whq - max index for VT340
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
   30 RBUF(1) = 100.0
      RBUF(2) = 100.0
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Interactive, Cursor, No dashed lines, No area fill,
C    No thick lines, Rectangle fill)
C
   40 CHR = 'ICNNNRNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CHR = 'TT:PGPLOT.VTPLOT'
      LCHR = 16
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 767
      RBUF(3) = 0
      RBUF(4) = 459
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 1
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
      APPEND = RBUF(3).NE.0.0
C     -- allocate buffer
      IER = LIB$GET_VM(BUFSIZ, BUFFER)
      IF (IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRWARN('Failed to allocate plot buffer.')
          RBUF(2) = IER
          RETURN
      END IF
      CALL GRGLUN(UNIT)
      RBUF(1) = UNIT
      OPEN (UNIT=UNIT, FILE=CHR(:LCHR), CARRIAGECONTROL='NONE',
     1      DEFAULTFILE=DEFNAM, DISPOSE='keep', STATUS='NEW',
     2      FORM='FORMATTED', RECORDTYPE='VARIABLE', IOSTAT=IER)
      IF (IER.NE.0) THEN
          CALL GRWARN('Cannot open output file for '//TYPE//' plot: '//
     1                CHR(:LCHR))
          RBUF(2) = 0
          CALL GRFLUN(UNIT)
          CALL LIB$FREE_VM(BUFSIZ, BUFFER)
	  return			! whq - return here if can't open
      endif				! whq - then endif
c      ELSE				! whq - so don't need else ... endif
          INQUIRE (UNIT=UNIT, NAME=CHR)
          LCHR = LEN(CHR)
   91     IF (CHR(LCHR:LCHR).EQ.' ') THEN
              LCHR = LCHR-1
              GOTO 91
          END IF
          RBUF(2) = 1
c      END IF				! whq

      lvt340 = grvt340(chr, lchr)	! whq - flag if device is a vt340

      BUFLEV = 0
      LASTI = -1
      LASTJ = - 1
      NPTS = 0
C     -- create a virtual keyboard for cursor control
      IER = SMG$CREATE_VIRTUAL_KEYBOARD(KBID, 'SYS$COMMAND')
      IER = SMG$SET_KEYPAD_MODE(KBID, 1)
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
C     -- reposition cursor
      WRITE (UNIT, '(A)') CURSOR
      CLOSE (UNIT, DISPOSE='KEEP')
      CALL GRFLUN(UNIT)
      IER = LIB$FREE_VM(BUFSIZ, BUFFER)
      IF (IER.NE.1) THEN
          CALL GRWARN('Error deallocating plot buffer.')
          CALL GRGMSG(IER)
      END IF
C     -- delete virtual keyboard
      IER = SMG$DELETE_VIRTUAL_KEYBOARD(KBID)
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
C     -- erase alpha screen and home cursor
      WRITE (UNIT, '(A)') VTERAS
C     -- erase and initialize graphics screen
      if (lvt340) then							! whq
       if (.not.append) call grvt02(vt340init,%val(buffer),buflev,unit) ! whq
      else								! whq
       IF (.NOT.APPEND) CALL GRVT02(VTINIT, %val(BUFFER), BUFLEV, UNIT)
      endif								! whq
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
      IF (I0.NE.LASTI .OR. J0.NE.LASTJ) THEN
          CALL SYS$FAO('P[!SL,!SL]',L,INSTR,%VAL(I0),%VAL(J0))
          CALL GRVT02(INSTR(1:L), %val(BUFFER), BUFLEV, UNIT)
          CALL GRVT02('V[]', %val(BUFFER), BUFLEV, UNIT)
      END IF
      IF (I1.EQ.I0 .AND. J1.EQ.J0) THEN
          CONTINUE
      ELSE IF (ABS(I1-I0).LE.1 .AND. ABS(J1-J0).LE.1) THEN
          L = 10*(I1-I0+1) + (J1-J0+1)
          CALL GRVT02(PIX(L), %val(BUFFER), BUFLEV, UNIT)
      ELSE
          IF (I1.EQ.I0) THEN
              INSTR1 = 'V['
              L1 = 2
          ELSE IF (ABS(I1-I0).GE.100) THEN
              CALL SYS$FAO('V[!SL',L1,INSTR1,%VAL(I1))
          ELSE IF (I1.GT.I0) THEN
              CALL SYS$FAO('V[+!SL',L1,INSTR1,%VAL(I1-I0))
          ELSE
              CALL SYS$FAO('V[!SL',L1,INSTR1,%VAL(I1-I0))
          END IF
          IF (J1.EQ.J0) THEN
              INSTR2 = ']'
              L2 = 1
          ELSE IF (ABS(J1-J0).GE.100) THEN
              CALL SYS$FAO(',!SL]',L2,INSTR2,%VAL(J1))
          ELSE IF (J1.GT.J0) THEN
              CALL SYS$FAO(',+!SL]',L2,INSTR2,%VAL(J1-J0))
          ELSE
              CALL SYS$FAO(',!SL]',L2,INSTR2,%VAL(J1-J0))
          END IF
          CALL GRVT02(INSTR1(1:L1)//INSTR2(1:L2), 
     1        %val(BUFFER), BUFLEV, UNIT)
      END IF
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      I1 = NINT(RBUF(1))
      J1 = NINT(RBUF(2))
      IF (I1.NE.LASTI .OR. J1.NE.LASTJ) THEN
          CALL SYS$FAO('P[!SL,!SL]V[]',L,INSTR,%VAL(I1),%VAL(J1))
          CALL GRVT02(INSTR(1:L), %val(BUFFER), BUFLEV, UNIT)
      END IF
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
C     -- flush
      CALL GRVT03(%val(BUFFER), UNIT, BUFLEV)
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C
  150 CONTINUE
      CI = NINT(RBUF(1))
      if (lvt340) then				! whq
        if (ci.gt.15 .or. ci.lt.0) ci = 1	! whq
      else					! whq
        IF (CI.GT.3 .OR. CI.LT.0) CI = 1
      endif					! whq
      CALL SYS$FAO('W(I!SL)',L,INSTR,%VAL(VTCODE(CI)))
      CALL GRVT02(INSTR(1:L), %val(BUFFER), BUFLEV, UNIT)
      LASTI = -1
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
C     -- flush
      CALL GRVT03(%val(BUFFER), UNIT, BUFLEV)
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C           RBUF(1)   in/out : cursor x coordinate.
C           RBUF(2)   in/out : cursor y coordinate.
C           CHR(1:1)  output : keystroke.
C
  170 CONTINUE
C     -- flush buffer
      CALL GRVT03(%val(BUFFER), UNIT, BUFLEV)
C     -- 
      IX = NINT(RBUF(1))
      IY = NINT(RBUF(2))
      CALL GRVT04(IX, IY, ICH, IER, UNIT, KBID)
      IF (IER.EQ.1) THEN
          RBUF(1) = IX
          RBUF(2) = IY
          CHR = CHAR(ICH)
      ELSE
          CHR = CHAR(0)
      END IF
      NBUF = 2
      LCHR = 1
      LASTI = -1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C
  180 CONTINUE
C     -- flush
      CALL GRVT03(%val(BUFFER), UNIT, BUFLEV)
C     -- erase alpha screen and home cursor
      WRITE (UNIT, '(A)') VTERAS
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called.)
C
  190 GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called.)
C
  200 GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      CI = RBUF(1)
      MONO = NINT(30.*RBUF(2) + 59.*RBUF(3) + 11.*RBUF(4))
      CALL GRXHLS(RBUF(2),RBUF(3),RBUF(4),CH,CL,CS)
      IR = NINT(CH)	! hue
      IG = NINT(100.*CL)	! lightness
      IB = NINT(100.*CS)	! saturation
      CALL SYS$FAO('S(M!SL(L!SL)(AH!SLL!SLS!SL))',L,INSTR,
     1	      %VAL(VTCODE(CI)),%VAL(MONO),%VAL(IR),%VAL(IG),%VAL(IB))
      CALL GRVT02(INSTR(1:L), %val(BUFFER), BUFLEV, UNIT)
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called.)
C
  220 GOTO 900
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
C     -- flush
      CALL GRVT03(%val(BUFFER), UNIT, BUFLEV)
C     -- write string
      WRITE (UNIT, '(A)') CHR(:LCHR)
      LASTI = -1
      RETURN
C
C--- IFUNC=24, Rectangle fill. -----------------------------------------
C
  240 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
C     -- move to top left and turn shading on
      CALL SYS$FAO('W(S1[,!SL])P[!SL,!SL]V[]',L,INSTR,%VAL(J0),
     1             %VAL(I0),%VAL(J1))
      CALL GRVT02(INSTR(1:L), %val(BUFFER), BUFLEV, UNIT)
C     -- draw to top right and turn shading off
      CALL SYS$FAO('V[!SL,!SL]W(S0)',L,INSTR,
     1             %VAL(I1),%VAL(J1))
      CALL GRVT02(INSTR(1:L), %val(BUFFER), BUFLEV, UNIT)
      LASTI = -1
      RETURN
C-----------------------------------------------------------------------
      END

C*GRVT02 -- PGPLOT Regis (VT125) driver, transfer data to buffer
C+
      SUBROUTINE GRVT02 (INSTR, BUFFER, HWM, UNIT)
      INTEGER   HWM, UNIT
      CHARACTER*(*) INSTR
      BYTE      BUFFER(*)
C
C Arguments:
C  INSTR  (input)  : text of instruction (bytes).
C  BUFFER (input)  : output buffer.
C  HWM    (in/out) : number of bytes used in BUFFER.
C  UNIT   (input)  : channel number for output (when buffer is full).
C
C Subroutines called:
C   GRVT03
C-----------------------------------------------------------------------
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=1024)
      INTEGER  I, N
C-----------------------------------------------------------------------
      N = LEN(INSTR)
      IF (HWM+N.GE.BUFSIZ) CALL GRVT03(BUFFER, UNIT, HWM)
      DO 10 I=1,N
          HWM = HWM + 1
          BUFFER(HWM) = ICHAR(INSTR(I:I))
   10 CONTINUE
C-----------------------------------------------------------------------
      END

C*GRVT03 -- PGPLOT Regis (VT125) driver, copy buffer to device
C+
      SUBROUTINE GRVT03 (BUFFER, UNIT, N)
      BYTE BUFFER(*)
      INTEGER UNIT, N
C
C Arguments:
C   BUFFER (input) address of buffer to be output
C   UNIT   (input) channel number for output
C   N      (input) number of bytes to transfer
C          (output) set to zero
C-----------------------------------------------------------------------
      INTEGER I
      BYTE PREFIX(3), SUFFIX(2)
      DATA PREFIX / 27, 'P', 'p' /
      DATA SUFFIX /27, '\' /
C-----------------------------------------------------------------------
      IF (N.GE.1) 
     1    WRITE (UNIT, '(130A1)') PREFIX, (BUFFER(I),I=1,N), SUFFIX
      N = 0
C-----------------------------------------------------------------------
      END

C*GRVT04 -- PGPLOT Regis (VT125) driver, cursor routine
C+
      SUBROUTINE GRVT04 (IX, IY, IC, IER, UNIT, KBID)
      INTEGER IX, IY, IC, IER, UNIT, KBID
C
C Arguments:
C   IX, IY (in/out) : initial/final coordinates of cursor (device 
C                     coordinates).
C   IC     (output) : character code.
C   IER    (output) : error status (1 => OK).
C   UNIT   (input)  : channel for output to device.
C   KBID   (input)  : SMG keyboard identifier for control.
C
C The cursor is moved by using the arrow keys on the
C terminal; the cursor "speed" (step size) is controlled by the
C PF1 (smallest step) to PF4 (largest step) keys. The numeric keys
C on the keypad can be used in place of the arrow keys, with the
C addition of diagonal motion:
C        ^
C      7 8 9
C    < 4   6 >
C      1 2 3
C        v
C
C The user indicates that the cursor has been positioned by
C typing any character on his keyboard (SYS$COMMAND), with the
C following exceptions: control characters (^C, ^O, ^Q, ^R, ^S,
C ^T, ^U, ^X, ^Y, DEL) are intercepted by the operating system
C and cannot be used; NUL, ESC (^[) and escape sequences (e.g., 
C arrow keys) are ignored by GRCURS.
C-----------------------------------------------------------------------
      INTEGER        IXG,IYG
      INTEGER        SMG$READ_KEYSTROKE
      INTEGER        STEP
      DATA           STEP/4/      ! initial step size
C-----------------------------------------------------------------------
   10 IXG = IX
      IYG = IY
C     -- position graphics cursor
      WRITE (UNIT,111) CHAR(27),IX,IY
  111 FORMAT(A,'PpP[', I4 ,',', I4 ,']')
      IER = SMG$READ_KEYSTROKE(KBID, IC)
      IF (IER.NE.1) RETURN
      IF (IC.EQ.274 .OR. IC.EQ.268) THEN
C         key UP or KP8
          IY = MIN(479,IY+STEP)
      ELSE IF (IC.EQ.275 .OR. IC.EQ.262) THEN
C         key DOWN or KP2
          IY = MAX(0,IY-STEP)
      ELSE IF (IC.EQ.276 .OR. IC.EQ.264) THEN
C         key LEFT or KP4
          IX = MAX(0,IX-STEP)
      ELSE IF (IC.EQ.277 .OR. IC.EQ.266) THEN
C         key RIGHT or KP6
          IX = MIN(767,IX+STEP)
      ELSE IF (IC.EQ.267) THEN
C         key KP7
          IX = MAX(0,IX-STEP)
          IY = MIN(479,IY+STEP)
      ELSE IF (IC.EQ.269) THEN
C         key KP9
          IX = MIN(767,IX+STEP)
          IY = MIN(479,IY+STEP)
      ELSE IF (IC.EQ.263) THEN
C         key KP3
          IX = MIN(767,IX+STEP)
          IY = MAX(0,IY-STEP)
      ELSE IF (IC.EQ.261) THEN
C         key KP1
          IX = MAX(0,IX-STEP)
          IY = MAX(0,IY-STEP)
      ELSE IF (IC.EQ.256) THEN
C         key PF1
          STEP = 1
      ELSE IF (IC.EQ.257) THEN
C         key PF2
          STEP = 4
      ELSE IF (IC.EQ.258) THEN
C         key PF3
          STEP = 16
      ELSE IF (IC.EQ.259) THEN
C         key PF4
          STEP = 64
      END IF
C     -- back to text mode
      WRITE (UNIT,112) CHAR(27)
  112 FORMAT(A,'\')
      IF (IC.LE.0 .OR. IC.GT.255) GOTO 10
C-----------------------------------------------------------------------
      END

C-----------------------------------------------------------------------
C*GRVT340 -- PGPLOT Regis (VT125) driver, check for DEC VT340 routine
C+
	logical function grvt340(chr, lchr)
	character*(*) chr
	integer lchr
C
C If device is a terminal, sends primary and secondary da (device attributes)
C to determine if it is a DEC VT340.  As implemented, the terminal must be
C set for 7 bit controls in order to be recognized as a VT340.
C
C Arguments:
C chr	 : (input) the name of the device (character)
C lchr	 : (input) the length of the device name (integer)
C
C Returns:
C  GRVT340 (logical) .TRUE. if device is a DEC VT340 terminal, .FALSE. if not.
C
C--
C  4-Sep-1992 [whq]
C-----------------------------------------------------------------------
	logical grchkt				! uses GRVMS grchkt
	logical testing, intime			! parse and timeout flags
	character*(*) primaryda, secondaryda	! da request strings
	character*(*) vt3xx, vt340		! da response strings
	parameter (primaryda=char(27)//'[c')	! primary da request
	parameter (secondaryda=char(27)//'[>c')	! secondary da request
	parameter (vt3xx=char(27)//'[?63')	! 5 bytes of vt3xx response
	parameter (vt340=char(27)//'[>19')	! 5 bytes of vt340 response
	integer i, ic				! counter and response char
	character image*40			! request buffer
	integer imi(1)				! request buffer 
	equivalence (image, imi)		! pass buffer as integer array

	grvt340 = .false.			! assume not vt340 initially
	if (grchkt(chr(1:lchr))) then		! if device is a terminal
c	  write(*, '(a,/)')' device is a terminal'	! debug
	  call grvtttopen			! open it for i/o

	  image = primaryda			! make primary da request
	  call grvtttout(imi, 3)
	  
	  testing = .true.			! test for vt3xx response
	  i = 1
	  image = vt3xx
	  do while (testing)
	    call grvtttin(ic, intime)			! get response
	    if (intime .and. (char(ic) .eq. image(i:i))) then
	      if (i .eq. 5) then			! got vt3xx response
	        do while (intime.and.(ic.ne.ichar('c')))
	          call grvtttin(ic, intime)		! eat until get 'c'
	        enddo
c	        write(*, '(a,/)')' got vt3xx response'		! debug

	        image = secondaryda		! make secondary da request
	        call grvtttout(imi, 4)
	        i = 1
	        image = vt340			! test for vt340 response
	        do while (testing)
	          call grvtttin(ic, intime)		! get response
	          if (intime .and. (char(ic) .eq. image(i:i))) then
	            if (i .eq. 5) then			! got vt340 response
	              do while (intime.and.(ic.ne.ichar('c')))
	                call grvtttin(ic, intime)	! eat until get 'c'
	              enddo
c	              write(*, '(a,/)')' got vt340 response'	! debug

	              grvt340 = .true.			! flag success!
	              testing = .false.

	            else
	              i = i + 1
	            endif
	          else 
	            if (i .ge. 3) then		! got a DEC escape response
	              do while (intime.and.(ic.ne.ichar('c')))
	                call grvtttin(ic,intime)	! eat until get 'c'
	              enddo
	            endif
	            testing = .false.
	          endif
	        enddo

	      else
	        i = i + 1			! matching OK, test next
	      endif
	    else 
	      if (i .ge. 3) then		! got a DEC escape response
	        do while (intime .and. (ic .ne. ichar('c')))
	          call grvtttin(ic,intime)	! eat until get 'c'
	        enddo
	      else if (intime) then		! got some kind of response
	        i = 1				! eat chars until time out or
	        do while (intime.and.(i.le.40))	! have eaten arbitrary 40
	          call grvtttin(ic,intime)
	          i = i + 1
	        enddo
	      endif
	      testing = .false.
	    endif
	  enddo

	  call grvtttclose 			! close the terminal

	endif

	return
	end

C-----------------------------------------------------------------------
C*GRVTTTOPEN -- PGPLOT Regis (VT125) driver, TT i/o routine for GRVT340
C+
	subroutine grvtttopen
C
C open TT for i/o
C
C--
C  4-Sep-1992 [whq]
C-----------------------------------------------------------------------
	include '($iodef)'
	include '($syssrvnam)'
	include '($ssdef)'

	integer ttchan, istat		! terminal channel and error status
	integer idata			! character data
	integer terminators(2) /0,0/	! i/o terminators - none
	integer*2 status(4)		! i/o status

	integer ians, irequest, inum
	logical lttintime

	istat = sys$assign('TT',ttchan,,)
	call sys$setef(%val(1))
	return

C-----------------------------------------------------------------------
C*GRVTTTIN -- PGPLOT Regis (VT125) driver, TT i/o routine for GRVT340
C+
	entry grvtttin(ians, lttintime)
C
C get character from TT - uses 8 s time out
C
C Arguments:
C  ians		: receives character
C  lttintime	: receives .true. unless time out occurs, then .false.
C--
C  4-Sep-1992 [whq]
C-----------------------------------------------------------------------
	lttintime = .true.

	istat = sys$qiow(,%val(ttchan),
     +          %val(IO$_TTYREADALL.or.IO$M_NOECHO.or.IO$M_TIMED),
     +          status,,,idata,%val(1),%val(8),terminators,,)

	if ((status(1) .eq. SS$_TIMEOUT) .or. (.not. istat))
     +    lttintime = .false.

	ians = idata
	return

C-----------------------------------------------------------------------
C*GRVTTTOUT -- PGPLOT Regis (VT125) driver, TT i/o routine for GRVT340
C+
	entry grvtttout(irequest, inum)
C
C send the character buffer irequest, of length inum, to TT
C
C Arguments:
C  irequest	: (input) the character buffer (integer array)
C  inum		: (input) number of characters in the buffer
C--
C  4-Sep-1992 [whq]
C-----------------------------------------------------------------------
	call sys$waitfr(%val(1))
	call sys$qio(%val(1),%val(ttchan),
     +               %val(IO$_WRITEVBLK.or.IO$M_NOFORMAT),
     +               ,,,irequest,%val(inum),,%val(0),,)
	call sys$waitfr(%val(1))
	return

C-----------------------------------------------------------------------
C*GRVTTTCLOSE -- PGPLOT Regis (VT125) driver, TT i/o routine for GRVT340
C+
	entry grvtttclose
C
C close the TT channel
C
C--
C  4-Sep-1992 [whq]
C-----------------------------------------------------------------------
	istat = sys$dassgn(ttchan)
	return

	end

C*PGQCR  -- inquire color representation
C%void cpgqcr(int ci, float *cr, float *cg, float *cb);
C+
      SUBROUTINE PGQCR (CI, CR, CG, CB)
      INTEGER CI
      REAL    CR, CG, CB
C
C Query the RGB colors associated with a color index.
C
C Arguments:
C  CI  (input)  : color index
C  CR  (output) : red, green and blue intensities
C  CG  (output)   in the range 0.0 to 1.0
C  CB  (output)
C--
C 7-Apr-1992 - new routine [DLT]
C-----------------------------------------------------------------------
      CALL GRQCR(CI, CR, CG, CB)
      END

C*GRDRIV -- PGPLOT Grinnell driver
C+
      SUBROUTINE GRDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Grinnell device.
C
C Version 1.0 - 1987 May 26 - T. J. Pearson.
C Version 1.1 - 1987 Jun 6  - dynamically allocate buffer (TJP).
C Version 1.2 - 1988 Jan 11 - use SMG$ routines for keyboard control
C                             of cursor (TJP).
C Version 1.3 - 1988 Mar 16 - test GR_TYPE environment variable (TJP).
C Version 1.4 - 1988 Mar 28 - correct bug in /APPEND (TJP).
C Version 1.5 - 1989 Feb 11 - add MONOCHROME option (TJP).
C
C
C Supported device: Grinnell GMR-270 Image Display System. 
C
C Device type code: /GRINNELL.
C
C Default device name: TV_DEVICE (a logical name, usually
C defined by the system manager).
C
C Default view surface dimensions: Depends on monitor.
C
C Resolution: The full view surface is 512 x 512 pixels. 
C
C Color capability: Color indices 0-255 are supported. The
C representation of all color indices can be changed. 
C
C Input capability: The graphics cursor is a white cross-hair. The 
C user positions the cursor using the arrow keys and PF1-PF4 keys on
C his terminal keyboard (SYS$COMMAND). The arrow keys move the cursor in
C the appropriate direction; the size of the step for each keystroke is
C controlled by the PF1-PF4 keys: PF1 -> 1 pixel, PF2 -> 4 pixels,
C PF3 -> 16 pixels, PF4 -> 64 pixels. The user indicates that the
C cursor has been positioned by typing any character other than an
C arrow or PF1-PF4 key [control characters, eg, ctrl-C, and other
C special characters should be avoided, as they may be intercepted by
C the operating system]. 
C
C File format: It is not possible to send Grinnell plots to a 
C disk file.
C
C Obtaining hardcopy: Not possible.
C-----------------------------------------------------------------------
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=8192)
      INTEGER BUFFER
      INTEGER BUFLEV
      INTEGER UNIT, IER, I0, I1, J0, J1, IX, IY, ICH, L
      INTEGER GRGR00, GRGMEM, GRFMEM, SYS$DASSGN
      INTEGER  SMG$CREATE_VIRTUAL_KEYBOARD
      INTEGER  SMG$SET_KEYPAD_MODE
      INTEGER  KBID
      LOGICAL APPEND, MONO
      CHARACTER*10 MSG
      INTEGER*2 GRNLBF(256), IC, IR, IG, IB, GCTABL(3,0:15), MONCOL
      INTEGER   NW, IW
      DATA GCTABL /000,000,000, 255,255,255, 255,000,000, 000,255,000,
     1             000,000,255, 000,255,255, 255,000,255, 255,255,000,
     2             255,128,000, 128,255,000, 000,255,128, 000,128,255,
     3             128,000,255, 255,000,128, 085,085,085, 170,170,170/
      LOGICAL NEW, INIT
      SAVE NEW, INIT, MONO
      DATA INIT /.TRUE./
C-----------------------------------------------------------------------
C
C First call: determine type of Grinnell.
C
      IF (INIT) THEN
          INIT = .FALSE.
          CALL GRGENV('GR_TYPE', MSG, L)
          NEW = (MSG(1:1).EQ.'P') 
C             -- Phobos-type Grinnell (GR273)
C             -- otherwise Deimos-type Grinnell (GR270)
          CALL GRGENV('MONITOR', MSG, L)
          MONO = (MSG(1:1).EQ.'M' .OR. MSG(1:1).EQ.'m') 
C             -- Monochrome monitor
C             -- otherwise color monitor
          IF (MONO) THEN
              DO IW=0,15
                  MONCOL = NINT(0.30*GCTABL(1,IW) + 0.59*GCTABL(2,IW) + 
     1                          0.11*GCTABL(3,IW))
                  GCTABL(1,IW) = MONCOL
                  GCTABL(2,IW) = MONCOL
                  GCTABL(3,IW) = MONCOL
              END DO
          END IF
      END IF
C
C Branch on opcode.
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in GRINNELL device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CHR = 'GRINNELL'
      LCHR = 8
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 511
      RBUF(3) = 0
      RBUF(4) = 511
      RBUF(5) = 0
      RBUF(6) = 255
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = 50.0
      RBUF(2) = 50.0
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Interactive, Cursor, No dashed lines, No area fill,
C    no thick lines)
C
   40 CHR = 'ICNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = 'TV_DEVICE'
      LCHR = 9
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 511
      RBUF(3) = 0
      RBUF(4) = 511
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
      APPEND = RBUF(3).NE.0.0
C     -- allocate buffer
      IER = GRGMEM(BUFSIZ, BUFFER)
      IF (IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRWARN('Failed to allocate plot buffer.')
          RBUF(2) = IER
          RETURN
      END IF
C     -- open device
      IER = GRGR00(CHR, LCHR, UNIT)
      RBUF(1) = UNIT
      RBUF(2) = IER
      NBUF = 2
      IF (IER.NE.1) THEN
          CALL GRFMEM(BUFSIZ, BUFFER)
          RETURN
      END IF
      IC = 1
C     -- create a virtual keyboard for cursor control
      IER = SMG$CREATE_VIRTUAL_KEYBOARD(KBID, 'SYS$COMMAND')
      IER = SMG$SET_KEYPAD_MODE(KBID, 1)
C     -- skip initialization if "APPEND" requested
      IF (APPEND) RETURN
C     -- initialize device
      DO IW=1,256
          GRNLBF(IW) = 'F000'X        ! NOP (cancel byte mode)
      END DO
      CALL GRGR02(GRNLBF,256,%val(BUFFER),BUFLEV,UNIT)
C
      IF (NEW) THEN
          GRNLBF(1) = 'A001'X            ! SPD   (image video driver)
          GRNLBF(2) = 'C000'X            ! LPR0  (split/togg/crop/intr)
          GRNLBF(3) = 'C20F'X            ! LPR1  (red overlays, cursors)
          GRNLBF(4) = 'C40F'X            ! LPR2  (grn overlays, cursors)
          GRNLBF(5) = 'C60F'X            ! LPR3  (blu overlays, cursors)
          GRNLBF(6) = 'C824'X            ! LPR4  (video routing)
          GRNLBF(7) = 'CA00'X            ! LPR5  (clamp, invert)
C
          GRNLBF(8) = 'A002'X            ! SPD  (image function memory)
          GRNLBF(9) = 'C000'X            ! LPR0 (split/toggle/retrace)
          GRNLBF(10) = 'C200'X           ! LPR1 (input bits 8,9)
          GRNLBF(11) = 'C8E4'X           ! LPR4 (lookup table routing)
          GRNLBF(12) = 'CA00'X           ! LPR5 (bypass)
          NW = 12
      ELSE
          GRNLBF(1) = 'A001'X            ! SPD 1 (image function video)
          GRNLBF(2) = 'C800'X            ! LPR4  (select ABC channels)
          GRNLBF(3) = 'CA00'X            ! LPR5  (no bypass or invert)
          NW = 3
      END IF
      CALL GRGR02(GRNLBF,NW,%val(BUFFER),BUFLEV,UNIT)
C
      GRNLBF(1) = 'B000'X            ! LPA (table A) (red)
      DO IW=0,15
            GRNLBF(IW+2)  = 'D000'X.OR.GCTABL(1,IW)
      END DO
      GRNLBF(18) = 'B400'X           ! LPA (table B) (green)
      DO IW=0,15
            GRNLBF(IW+19)  = 'D000'X.OR.GCTABL(2,IW)
      END DO
      GRNLBF(35) = 'B800'X           ! LPA (table C) (blue)
      DO IW=0,15
            GRNLBF(IW+36)  = 'D000'X.OR.GCTABL(3,IW)
      END DO
      NW = 51
      CALL GRGR02(GRNLBF,NW,%val(BUFFER),BUFLEV,UNIT)
C
      IF (NEW) THEN
          GRNLBF(1) = 'A100'X            ! SPD (load PCR)
          GRNLBF(2) = 'C005'X            ! LPR (PCR bits 0,2)
          GRNLBF(3) = 'A008'X            ! SPD (zoom/pan)
          GRNLBF(4) = 'C000'X            ! LPR
          GRNLBF(5) = 'B000'X            ! LPA
          GRNLBF(6) = 'D0FF'X            ! LPD
          GRNLBF(7) = 'D0FF'X            ! LPD
C
          GRNLBF(8) = 'A080'X            ! SPD (quad cursor)
          GRNLBF(9) = 'C000'X            ! LPR (all cursors off)
C
          GRNLBF(10) = 'A000'X           ! SPD (none)
          GRNLBF(11) = '800D'X           ! LDC (channels 0,2,3)
          GRNLBF(12) = '2830'X           ! LWM (R0,A0,Z1,V1,H0,W0)
          GRNLBF(13) = '1001'X           ! LSM (color=1)
          NW =13
      ELSE
          GRNLBF(1) = 'A008'X            ! SPD 8 (zoom/pan)
          GRNLBF(2) = 'B000'X
          GRNLBF(3) = 'B000'X
          GRNLBF(4) = 'D000'X
          GRNLBF(5) = 'C004'X
C
          GRNLBF(6) = 'A080'X            ! SPD (quad cursor)
          GRNLBF(7) = 'C000'X            ! LPR (all cursors off)
C
          GRNLBF(8) = 'A000'X            ! SPD (none)
          GRNLBF(9) = '8FFF'X            ! LDC FFF
          GRNLBF(10) = '2830'X           ! LWM (R0,A0,Z1,V1,H0,W0)
          GRNLBF(11) = '1001'X           ! LSM (color=1)
          NW = 11
      END IF
      GOTO 1000
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      IER = SYS$DASSGN(%val(UNIT))
      IF (IER.NE.1) THEN
          CALL GRWARN('Error closing graphics device.')
          CALL GRGMSG(IER)
      END IF
      IER = GRFMEM(BUFSIZ, BUFFER)
      IF (IER.NE.1) THEN
          CALL GRWARN('Error deallocating plot buffer.')
          CALL GRGMSG(IER)
      END IF
C     -- delete virtual keyboard
      IER = SMG$CREATE_VIRTUAL_KEYBOARD(KBID)
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
      GRNLBF(1) = 'A000'X            ! SPD 0
      GRNLBF(2) = '1FFF'X            ! LSM FFF
      GRNLBF(3) = '8FFF'X            ! LDC FFF
      GRNLBF(4) = '2830'X            ! LWM (R0,A0,Z1,V1,H0,W0)
      IF (APPEND) THEN
          GRNLBF(5) = '800D'X        ! dummy
      ELSE
          GRNLBF(5) = '3000'X        ! ERS
      END IF
      GRNLBF(6) = '800D'X            ! LDC (channels 0,2,3)
      GRNLBF(7) = '1000'X .OR. IC    ! LSM <color>
      NW = 7
      GOTO 1000
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
      CALL GRGR01(I0, J0, I1, J1, GRNLBF)
      NW = 4
      GOTO 1000
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      CALL GRGR01(I0, J0, I0, J0, GRNLBF)
      NW = 4
      GOTO 1000
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      IF (IC.LT.0 .OR. IC.GT.255) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      GRNLBF(1) = '1000'X .OR. IC
      NW = 1
      GOTO 1000
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      CALL GRGR03(%val(BUFFER), UNIT, BUFLEV)
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C           RBUF(1)   in/out : cursor x coordinate.
C           RBUF(2)   in/out : cursor y coordinate.
C           CHR(1:1)  output : keystroke.
C
  170 CONTINUE
C     -- flush buffer
      CALL GRGR03(%val(BUFFER), UNIT, BUFLEV)
C     -- 
      IX = NINT(RBUF(1))
      IY = NINT(RBUF(2))
      CALL GRGR04(IX, IY, ICH, IER, UNIT, KBID)
      IF (IER.EQ.1) THEN
          RBUF(1) = IX
          RBUF(2) = IY
          CHR = CHAR(ICH)
      ELSE
          CHR = CHAR(0)
      END IF
      NBUF = 2
      LCHR = 1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      IC = RBUF(1)
      IR = MIN(255.,MAX(RBUF(2)*255.,0.))
      IG = MIN(255.,MAX(RBUF(3)*255.,0.))
      IB = MIN(255.,MAX(RBUF(4)*255.,0.))
      IF (MONO) THEN
          MONCOL = NINT(0.30*IR + 0.59*IG + 0.11*IB)
          IR = MONCOL
          IG = MONCOL
          IB = MONCOL
      END IF
      IF (NEW) THEN
          GRNLBF(1) = 'A002'X          ! SPD 2 (image function video)
      ELSE
          GRNLBF(1) = 'A001'X          ! SPD 1 (image function video)
      END IF
      GRNLBF(2) = 'B000'X .OR. IC      ! LPA (table A) (red)
      GRNLBF(3) = 'D000'X .OR. IR
      GRNLBF(4) = 'B400'X .OR. IC      ! LPA (table B) (green)
      GRNLBF(5) = 'D000'X .OR. IG
      GRNLBF(6) = 'B800'X .OR. IC      ! LPA (table C) (blue)
      GRNLBF(7) = 'D000'X. OR. IB
      NW = 7
      GOTO 1000
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C
C--- Send the command. -------------------------------------------------
C
 1000 CALL GRGR02(GRNLBF,NW,%val(BUFFER),BUFLEV,UNIT)
C-----------------------------------------------------------------------
      END

C*GRGR00 -- PGPLOT Grinnell driver, open device
C+
      INTEGER FUNCTION GRGR00 (GRFILE, GRFNLN, GRUNIT)
      CHARACTER*(*) GRFILE
      INTEGER GRFNLN, GRUNIT
C
C Returns:
C   GRGR00         : 1 if the device was opened successfully. Any 
C                    other value indicates that an error occurred.
C                    Usually the value is the VMS error code.
C 
C Arguments:
C   GRFILE (in/out) : requested device name (input); actual
C                     device assigned (output).
C   GRFNLN (in/out) : length of device name.
C   GRUNIT (output) : channel assigned by VMS.
C
C Subroutines called:
C   GRWARN
C   GRGMSG
C   VMS system services
C-----------------------------------------------------------------------
      INTEGER  DVI$_DEVCLASS, DVI$_DEVNAM
      PARAMETER (DVI$_DEVCLASS=4)
      PARAMETER (DVI$_DEVNAM=32)
      INTEGER  DEVCLASS, ITMLIST(7), IOSB(2)
      INTEGER  IER, L, SYS$ASSIGN
      INTEGER  SYS$GETDVI, SYS$DASSGN, SYS$WAITFR
C
C Assign an i/o channel.
C
      L = GRFNLN
      IER = SYS$ASSIGN(GRFILE(1:L), GRUNIT,,)
      IF (.NOT.IER) GOTO 100
C
C Check that device has correct characteristics, and obtain true
C device name.
C
      ITMLIST(1) = DVI$_DEVCLASS*2**16 + 4
      ITMLIST(2) = %LOC(DEVCLASS)
      ITMLIST(3) = 0
      ITMLIST(4) = DVI$_DEVNAM*2**16 + LEN(GRFILE)
      ITMLIST(5) = %LOC(GRFILE)
      ITMLIST(6) = %LOC(GRFNLN)
      ITMLIST(7) = 0
      IER = SYS$GETDVI(%VAL(0),,GRFILE(1:GRFNLN), ITMLIST,IOSB,,,)
      IF (.NOT.IER) GOTO 100
      IER = SYS$WAITFR(%VAL(0))
      IF (.NOT.IER) GOTO 100
      IF (.NOT.IOSB(1)) THEN
          IER = IOSB(1)
          GOTO 100
      END IF
      IF (DEVCLASS.NE.32 .AND. DEVCLASS.NE.96) THEN
          CALL GRWARN( GRFILE(1:GRFNLN)//
     2            ' is the wrong sort of device for plot type GRINNELL')
          GRGR00 = 32767      ! indicate error
          IER = SYS$DASSGN(%VAL(GRUNIT))
          RETURN
      END IF
C
C Successful completion.
C
      GRGR00 = 1
      RETURN
C
C Error exit.
C
  100 CALL GRWARN('Cannot open graphics device '//GRFILE(1:L))
      CALL GRGMSG(IER)
      GRGR00 = IER
C-----------------------------------------------------------------------
      END

C*GRGR01 -- PGPLOT Grinnell driver, line segment
C+
      SUBROUTINE GRGR01 (I0, J0, I1, J1, GRNLBF)
      INTEGER*2 I0, J0, I1, J1
      INTEGER*2 GRNLBF(4)
C
C Arguments:
C   I0, J0 (input) : device coordinates of the starting point.
C   I1, J1 (input) : device coordinates of the end point.
C   GRNLBF (output) : buffer for instruction.
C 
C Subroutines called:
C   GRGR02
C-----------------------------------------------------------------------
      INTEGER*2 IC0, JC0, IC1, JC1, DX, DY, T
      INTEGER*2 X, CLIP511
C
      CLIP511(X) = X .AND. '1FF'X
C
      IC0 = CLIP511(I0)
      JC0 = CLIP511(J0)
      IC1 = CLIP511(I1)
      JC1 = CLIP511(J1)
      T   = IC1-IC0
      DX  = CLIP511(T)
      T   = JC1-JC0
      DY  = CLIP511(T)
C
C Assume Grinnell has already been initialized for vector drawing
C (LWM) and SPD 0 has been selected, and appropriate channels have
C been selected.
C
      GRNLBF(1) = '4800'X .OR. IC0      ! LEA
      GRNLBF(2) = '5000'X .OR. DX       ! LEB
      GRNLBF(3) = '6800'X .OR. JC0      ! LLA
      GRNLBF(4) = '7400'X .OR. DY       ! LLB (W=1)
C-----------------------------------------------------------------------
      END

C*GRGR02 -- PGPLOT Grinnell driver, transfer data to buffer
C+
      SUBROUTINE GRGR02 (INSTR, N, BUFFER, HWM, UNIT)
      INTEGER   N, HWM, UNIT
      INTEGER*2 INSTR(*), BUFFER(*)
C
C Arguments:
C  INSTR  (input)  : text of instruction (16-bit words).
C  N      (input)  : number of 16-bit words to transfer.
C  BUFFER (input)  : output buffer.
C  HWM    (in/out) : number of bytes used in BUFFER.
C  UNIT   (input)  : channel number for output (when buffer is full).
C
C Subroutines called:
C   GRGR03
C-----------------------------------------------------------------------
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=8192)
      INTEGER  I
C-----------------------------------------------------------------------
      DO 10 I=1,N
          IF (HWM.GE.BUFSIZ) CALL GRGR03(BUFFER, UNIT, HWM)
          HWM = HWM + 2
          BUFFER(HWM/2) = INSTR(I)
   10 CONTINUE
C-----------------------------------------------------------------------
      END

C*GRGR03 -- PGPLOT Grinnell driver, copy buffer to device
C+
      SUBROUTINE GRGR03 (BUFFER, UNIT, N)
      BYTE BUFFER(*)
      INTEGER UNIT, N
C
C Arguments:
C   BUFFER (input) address of buffer to be output
C   UNIT   (input) channel number for output
C   N      (input) number of bytes to transfer
C          (output) set to zero
C-----------------------------------------------------------------------
      INCLUDE '($IODEF)'
C
      INTEGER SYS$QIOW
C
      INTEGER RESULT
      INTEGER IOSB(2)
      INTEGER*2 STBC(2), STATUS, COUNT
      EQUIVALENCE (STBC, IOSB(1)), (STATUS, STBC(1)), (COUNT, STBC(2))
C-----------------------------------------------------------------------
      IF (N.LT.1) RETURN
      RESULT = SYS$QIOW(,%VAL(UNIT),
     1            %VAL(IO$_WRITEVBLK.OR.IO$M_SETFNCT),IOSB,,
     2            ,BUFFER,%VAL(N),,%VAL(0),,)
      IF (RESULT.NE.1) THEN
          CALL GRGMSG(RESULT)
          CALL GRQUIT('SYS$QIOW failure writing to Grinnell')
      END IF
      IF (STATUS.NE.1) THEN
          RESULT = STATUS
          CALL GRGMSG(RESULT)
          CALL GRQUIT('SYS$QIOW failure writing to Grinnell')
      END IF
      N = 0
C-----------------------------------------------------------------------
      END

C*GRGR04 -- PGPLOT Grinnell driver, cursor routine
C+
      SUBROUTINE GRGR04 (IX, IY, IC, IER, UNIT, KBID)
      INTEGER IX, IY, IC, IER, UNIT, KBID
C
C Arguments:
C   IX, IY (in/out) : initial/final coordinates of cursor (device 
C                     coordinates).
C   IC     (output) : character code.
C   IER    (output) : error status (1 => OK).
C   UNIT   (input)  : channel for output to device.
C   KBID   (input)  : SMG keyboard identifier for control.
C
C This version uses the cursor on the zoom-pan card (peripheral
C device bit 3). The cursor is moved by using the arrow keys on the
C terminal; the cursor "speed" (step size) is controlled by the
C PF1 (smallest step) to PF4 (largest step) keys. The numeric keys
C on the keypad can be used in place of the arrow keys, with the
C addition of diagonal motion:
C        ^
C      7 8 9
C    < 4   6 >
C      1 2 3
C        v
C
C The user indicates that the cursor has been positioned by
C typing any character on his keyboard (SYS$COMMAND), with the
C following exceptions: control characters (^C, ^O, ^Q, ^R, ^S,
C ^T, ^U, ^X, ^Y, DEL) are intercepted by the operating system
C and cannot be used; NUL, ESC (^[) and escape sequences (e.g., 
C arrow keys) are ignored by GRCURS.
C-----------------------------------------------------------------------
      INTEGER*2      GRNLBF(5),IXG,IYG
      INTEGER        SMG$READ_KEYSTROKE
      INTEGER        STEP, NBYTES
      DATA           STEP/4/      ! initial step size
C-----------------------------------------------------------------------
   10 IXG = IX
      IYG = IY
      GRNLBF(1) = 'A008'X            ! SPD ZOOM/PAN
      GRNLBF(2) = 'C020'X            ! enable cursor
      GRNLBF(3) = 'B000'X            ! LPA 0
      GRNLBF(4) = 'D000'X .OR. IXG      ! load X coord
      GRNLBF(5) = 'D000'X .OR. IYG      ! load Y coord
      NBYTES = 10
      CALL GRGR03(GRNLBF,UNIT,NBYTES)
      IER = SMG$READ_KEYSTROKE(KBID, IC)
      IF (IER.NE.1) RETURN
      IF (IC.EQ.274 .OR. IC.EQ.268) THEN
C         key UP or KP8
          IY = MIN(511,IY+STEP)
      ELSE IF (IC.EQ.275 .OR. IC.EQ.262) THEN
C         key DOWN or KP2
          IY = MAX(0,IY-STEP)
      ELSE IF (IC.EQ.276 .OR. IC.EQ.264) THEN
C         key LEFT or KP4
          IX = MAX(0,IX-STEP)
      ELSE IF (IC.EQ.277 .OR. IC.EQ.266) THEN
C         key RIGHT or KP6
          IX = MIN(511,IX+STEP)
      ELSE IF (IC.EQ.267) THEN
C         key KP7
          IX = MAX(0,IX-STEP)
          IY = MIN(511,IY+STEP)
      ELSE IF (IC.EQ.269) THEN
C         key KP9
          IX = MIN(511,IX+STEP)
          IY = MIN(511,IY+STEP)
      ELSE IF (IC.EQ.263) THEN
C         key KP3
          IX = MIN(511,IX+STEP)
          IY = MAX(0,IY-STEP)
      ELSE IF (IC.EQ.261) THEN
C         key KP1
          IX = MAX(0,IX-STEP)
          IY = MAX(0,IY-STEP)
      ELSE IF (IC.EQ.265) THEN
C         key KP5 ("home")
          IX = 255
          IY = 255
      ELSE IF (IC.EQ.256) THEN
C         key PF1 or KP4
          STEP = 1
      ELSE IF (IC.EQ.257) THEN
C         key PF2
          STEP = 4
      ELSE IF (IC.EQ.258) THEN
C         key PF3
          STEP = 16
      ELSE IF (IC.EQ.259) THEN
C         key PF4
          STEP = 64
      END IF
      IF (IC.LE.0 .OR. IC.GT.255) GOTO 10
      GRNLBF(1) = 'A008'X
      GRNLBF(2) = 'C000'X            ! disable all cursors
      GRNLBF(3) = 'A000'X
      NBYTES = 6
      CALL GRGR03(GRNLBF,UNIT,NBYTES)
C-----------------------------------------------------------------------
      END

C*PGQAH -- inquire arrow-head style
C%void cpgqah(int *fs, float *angle, float *barb);
C+
      SUBROUTINE PGQAH (FS, ANGLE, BARB)
      INTEGER  FS
      REAL ANGLE, BARB
C
C Query the style to be used for arrowheads drawn with routine PGARRO.
C
C Argument:
C  FS     (output) : FS = 1 => filled; FS = 2 => outline.
C  ANGLE  (output) : the acute angle of the arrow point, in degrees.
C  BARB   (output) : the fraction of the triangular arrow-head that
C                    is cut away from the back. 
C--
C 13-Oct-1992 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
C
      FS = PGAHS(PGID)
      ANGLE = PGAHA(PGID)
      BARB = PGAHV(PGID)
C
      END

C*EXDRIV -- PGPLOT Talaris/EXCL driver (landscape mode)
C+
      SUBROUTINE    EXDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      INTEGER       IFUNC, NBUF, LCHR, MODE
      REAL          RBUF(*)
      CHARACTER*(*) CHR
C-----------------------------------------------------------------------
C PGPLOT driver for EXCL devices (Talaris)
C-----------------------------------------------------------------------
C Version 1.0 - 1989 Nov 10 - A. L. Fey.
C         2.0 - 1994 Nov 08
C-----------------------------------------------------------------------
C
C Supported device: Any Talaris printer that accepts the EXCL
C                   page description language. 7-bit mode is used.
C
C Device type code: /EXCL  (landscape)
C                   /VEXCL (portrait)
C
C Default file name: pgplot.explot.
C
C Default view surface dimensions: 10.25 inches horizontal x 7.75 inches
C                                  vertical (landscape mode).
C Default view surface dimensions: 7.75 inches horizontal x 10.25 inches
C                                  vertical (portrait mode).
C
C Resolution: The driver uses coordinate increments of 1/1000 inch.
C             The true resolution is device-dependent; at time of
C             writing, it is typically 300 dots per inch.
C
C Color capability: Color indices 0 (erase), and 1 (black) are 
C                   supported. Requests for other color indices are
C                   converted to 1. It is not possible to change color
C                   representation. 
C
C Input capability: None.
C
C File format: Ascii, variable length records (max 80 bytes).
C-----------------------------------------------------------------------
C
      CHARACTER*(*) DEFNAM
      REAL WIDTH, HEIGHT, MARGIN
C--
      PARAMETER    (DEFNAM = 'pgplot.explot')
      PARAMETER    (WIDTH  = 11000.0)
      PARAMETER    (HEIGHT = 8500.0)
      PARAMETER    (MARGIN = 375)
C--
      CHARACTER*(*) ESC, SP, ESCP, ESCLB, ESCBS
      PARAMETER    (ESC    = CHAR (27))
      PARAMETER    (SP     = CHAR (32))
      PARAMETER    (ESCP   = CHAR (27)//CHAR (80))
      PARAMETER    (ESCLB  = CHAR (27)//CHAR (91))
      PARAMETER    (ESCBS  = CHAR (27)//CHAR (92))
C
      CHARACTER*80  BUFFER
      CHARACTER*80  INSTR
      CHARACTER*10  MSG
      INTEGER       UNIT, I0, J0, I1, J1, IC
      INTEGER       L, NPAGE, NPTS, PENWID
      REAL          EXSCAL, EYSCAL
      REAL          EXSIZE, EYSIZE
      REAL          XRESOL, YRESOL
      LOGICAL       NOTHIN
      INTEGER GRTRIM, GROPTX
C
C ---- BUFFER should not exceed 80 - this makes well formed EXCL files.
C ---- The E*SIZE parameters are the physical size of the plot (used
C ---- more than once here) in resolution units (1/1000 inch).  The
C ---- *OFF parameters are offsets from the physical origin of the
C ---- page assuming a page size of 8.5 x 11 inches. The E*SCAL
C ---- parameters are PGPLOT-modifiable scale factors.
C
      PARAMETER    (XRESOL = 1000.00,
     :              YRESOL = 1000.00,
     :              PENWID = 5)
      SAVE EXSIZE, EYSIZE
C
C=======================================================================
C
C ---- Do the best one can in F77 for a "case" statement. --------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
C
C ---- Unknown opcode/function; most likely a logic error somewhere ----
C
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in EXCL device driver:'//MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 IF(MODE .EQ. 1) THEN
        CHR = 'EXCL  (Talaris/EXCL printers, landscape)'
      ELSE
        CHR = 'VEXCL (Talaris/EXCL printers, portrait)'
      END IF
      LCHR = GRTRIM(CHR)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C               Units are in device co-ordinates (1/1000 inches)
C
   20 RBUF(1) = 0.0
      RBUF(3) = 0.0
      RBUF(5) = 0.0
      RBUF(6) = 1.0
      IF(MODE .EQ. 1) THEN
        RBUF(2) = WIDTH - 2*MARGIN
        RBUF(4) = HEIGHT - 2*MARGIN
      ELSE
        RBUF(2) = HEIGHT - 2*MARGIN
        RBUF(4) = WIDTH - 2*MARGIN
      END IF
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C    (Nominal values)
C
   30 RBUF(1) = XRESOL
      RBUF(2) = YRESOL
C
C      (multiple strokes are spaced by PENWID/*RESOL inches)
C
      RBUF(3) = PENWID
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (Hardcopy, No cursor, No Dashed lines, Area fill, No Thick lines) 
C
   40 CHR = 'HNNANNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR  = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C    (in device coordinates).
C
   60 RBUF(1) = 0.0
      RBUF(3) = 0.0
      IF(MODE .EQ. 1) THEN
        RBUF(2) = WIDTH - 2*MARGIN
        RBUF(4) = HEIGHT - 2*MARGIN
      ELSE
        RBUF(2) = HEIGHT - 2*MARGIN
        RBUF(4) = WIDTH - 2*MARGIN
      END IF
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1.0
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C    Future option, nothing done yet.  (Multiple devices open at one 
C    time will be allowed later; this opcode will select active device).
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C
C     -- Get a Unit number.
C
      CALL GRGLUN(UNIT)
C
C     -- Open the file.
C
      NBUF = 2
      RBUF(1) = UNIT
      IF(GROPTX(UNIT, CHR(1:LCHR), DEFNAM, 1) .NE. 0) THEN
          CALL GRWARN('Cannot open output file for EXCL plot')
          RBUF(2) = 0
          CALL GRFLUN(UNIT)
          RETURN
      ELSE
          INQUIRE (UNIT=UNIT, NAME=CHR)
          LCHR = GRTRIM(CHR)
          RBUF(2) = 1
      END IF
C
C     -- initialization
C
      EXSCAL = 1.0
      EYSCAL = 1.0
      IF(MODE .EQ. 1) THEN
        EXSIZE = WIDTH  - 2 * MARGIN
        EYSIZE = HEIGHT - 2 * MARGIN
      ELSE
        EXSIZE = HEIGHT - 2 * MARGIN
        EYSIZE = WIDTH  - 2 * MARGIN
      END IF
      NOTHIN = .TRUE.
      NPAGE = 0
      NPTS = 0
C
C     -- Start vector graphics mode.
C        Initialize EXCL, set ANSI mode to EXCL (TALAMS), reset the
C        printstation to power-up state (TALMOD), set copy count
C        to one (TALCCNT), set paper size to letter (TALFCTL),
C        turn on Absorb Forms Control (TALASF).
C
      BUFFER = ESCLB//'0*s'
     :       //ESCLB//'1;0r'
     :       //ESCLB//'1;0u'
     :       //ESCLB//';3x'
     :       //ESCLB//'1'//SP//'z'
      CALL GREX00 (UNIT, BUFFER, 27)
C
C     -- Comments; write user and date created to file.
C
      CALL GREX00 (UNIT,
     :   ESC//'Q ------------------------------ '//ESC//'R', 36)
      CALL GRUSER (INSTR, L)
      BUFFER =
     :   ESC//'Q -- EXCL plot created by '//INSTR(1:L)//' -- '//ESC//'R'
      CALL GREX00 (UNIT, BUFFER, 33+L)
      CALL GRDATE (INSTR, L)
      BUFFER =
     :   ESC//'Q -- EXCL plot created on '//INSTR(1:L)//' -- '//ESC//'R'
      CALL GREX00 (UNIT, BUFFER, 33+L)
      CALL GREX00 (UNIT,
     :     ESC//'Q ------------------------------ '//ESC//'R', 36)
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
C
      IF (NOTHIN) THEN
C
C        -- Nothing was plotted so no need to keep the file around.
C
         CLOSE (UNIT)
C
      ELSE
C
C        -- Don't need to formfeed; end picture will do that.
C           Reset printstation to its power-up state.
C
         BUFFER = ESC//'Q -- End of File -- '//ESC//'R'//ESC//'c'
         CALL GREX00 (UNIT, BUFFER, 25)
         CLOSE (UNIT)
      ENDIF
C
C     -- Return UNIT to free pool.
C
      CALL GRFLUN(UNIT)
      RETURN
C
C--- IFUNC=11, Begin picture and possibly rescale -----------------------
C
  110 CONTINUE
      NPAGE = NPAGE + 1
C
C     --  Define the unit of measure to be mils (TALPRM), define the page
C         orientation to be landscape or portrait (TALPGO), set page
C         clipping window to default page size (TALPCW), and set the
C         origin to the top left of the physical page at MARGIN,MARGIN 
C         (TALORG).
C
      BUFFER = ESCLB//'3y'
     :       //ESCLB//'0p'
     :       //ESCLB//'0;;;0*c'
      IF(MODE .EQ. 1) THEN
        BUFFER(7:7)='1'
      ELSE
        BUFFER(7:7)='0'
      END IF
      WRITE (BUFFER (18:31), 1000) ESCLB, MARGIN, MARGIN
 1000 FORMAT (A2, I5.5, ';', I5.5, 'o')
      CALL GREX00 (UNIT, BUFFER, 31)
C
C     --  Set the line defaults (TALGLP, TALGLT) and set fill
C         pattern (TALGRP).
C
      BUFFER = ESCLB//'  ;  ;8;1;112;5279;1*w'
     :       //ESCLB//'112;5279;0*r'
     :       //ESCLB//'*t'
      WRITE (BUFFER (3:4), '(I2.2)') PENWID
      WRITE (BUFFER (6:7), '(I2.2)') PENWID
      CALL GREX00 (UNIT, BUFFER, 42)
C
C     -- Rescale if needed. 
C
      EXSCAL = MIN (1.0, RBUF(1) / EXSIZE)
      EYSCAL = MIN (1.0, RBUF(2) / EYSIZE)
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
C     -- Move with TALGMV, draw with TALGDW.
C
  120 CONTINUE
      IF (NOTHIN) NOTHIN = .FALSE.
      I0 = NINT(RBUF(1) * EXSCAL)
      J0 = NINT((EYSIZE - RBUF(2)) * EYSCAL)
      I1 = NINT(RBUF(3) * EXSCAL)
      J1 = NINT((EYSIZE - RBUF(4)) * EYSCAL)
  125 CONTINUE
      IF(MODE.EQ.1) THEN
        WRITE (BUFFER( 1:15), 2000) ESCLB, I0, J0, '*m'
        WRITE (BUFFER(16:30), 2000) ESCLB, I1, J1, '*d'
      ELSE
        WRITE (BUFFER( 1:15), 2001) ESCLB, I0, J0, '*m'
        WRITE (BUFFER(16:30), 2001) ESCLB, I1, J1, '*d'
      ENDIF
 2000 FORMAT (A2, ';', I5.5, ';', I4.4, A2)
 2001 FORMAT (A2, ';', I4.4, ';', I5.5, A2)
      CALL GREX00 (UNIT, BUFFER, 30)
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C    EXCL takes care of dot size by the pen width command so we 
C    don't have to worry about it here.  Just draw to same point and
C    let the "draw line" code handle it.
C
  130 CONTINUE
      IF (NOTHIN) NOTHIN = .FALSE.
      I0 = NINT(RBUF(1) * EXSCAL)
      J0 = NINT((EYSIZE - RBUF(2)) * EYSCAL)
      I1 = I0
      J1 = J0
      GOTO 125
C
C--- IFUNC=14, End picture ---------------------------------------------
C
C     -- Eject page and clear bitmap (TALFPO).
C
  140 CONTINUE
C
      IF (.NOT. NOTHIN) THEN
         CALL GRFAO ('Q -- End Page: # ', L, INSTR, NPAGE, 0, 0, 0)
         BUFFER = ESCLB//'0*F'//ESC//INSTR(1:L)//' -- '//ESC//'R'
         CALL GREX00 (UNIT, BUFFER, 12+L)
      ENDIF
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
C        Use TALGLP.
C
  150 CONTINUE
      IC = RBUF(1)
C
      IF (IC .EQ. 0) THEN
C
C     -- Color index 0 is erase.
C
         BUFFER = ESCLB//'  ;  ;11;1;112;5279;1*w'
     :          //ESCLB//'112;5279;11*r'
     :          //ESCLB//'*t'
         WRITE (BUFFER (3:4), '(I2.2)') PENWID
         WRITE (BUFFER (6:7), '(I2.2)') PENWID
         CALL GREX00 (UNIT, BUFFER, 44)
      ELSE IF (IC .EQ. 1) THEN
C
C     -- Color index 1 is black.
C
         BUFFER = ESCLB//'  ;  ;8;1;112;5279;1*w'
     :          //ESCLB//'112;5279;0*r'
     :          //ESCLB//'*t'
         WRITE (BUFFER (3:4), '(I2.2)') PENWID
         WRITE (BUFFER (6:7), '(I2.2)') PENWID
         CALL GREX00 (UNIT, BUFFER, 42)
      ELSE
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    Hardcopy so ignore it
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C           Not implemented, hardcopy device.  Return error code.
C
  170 CONTINUE
      NBUF = -1
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen so ignore it).
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C
  190 CONTINUE
      RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
C     -- Use TALPFL to fill polygon.
C
  200 CONTINUE
C
C     -- Use NPTS as our indicator of whether this is first time or not.
C
      IF (NPTS .EQ. 0) THEN
C
C     -- First time so set number of points in polygon and start polygon
C        command.
C
         NPTS = RBUF (1)
         BUFFER = ESCP//'4;1;0;1}'
         CALL GREX00 (UNIT, BUFFER, 10)
      ELSE
C
C     -- Second or other time so decrement NPTS and draw to next vertex.
C
         IF (NOTHIN) NOTHIN = .FALSE.
         NPTS = NPTS - 1
         I0 = NINT(RBUF(1) * EXSCAL)
         J0 = NINT((EYSIZE - RBUF(2)) * EYSCAL)
         IF(MODE .EQ. 1) THEN
           WRITE (BUFFER, 3000) I0, J0
         ELSE
           WRITE (BUFFER, 3001) I0, J0
         END IF
 3000    FORMAT (I5.5, ':', I4.4, ';')
 3001    FORMAT (I4.4, ':', I5.5, ';')
         CALL GREX00 (UNIT, BUFFER, 11)
C
C     -- Give the polygon fill command on last call.
C
         IF (NPTS .EQ. 0) THEN
            BUFFER = ESCBS
            CALL GREX00 (UNIT, BUFFER, 2)
         END IF
      END IF
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C    (Not implemented: ignored.  Will we ever get color laser printers?)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C
  220 CONTINUE
      RETURN
C
C--- IFUNC=23, Escape --------------------------------------------------
C    Note that the NOTHIN flag which indicates if there is anything 
C    written on the paper is set here regardless of the content of
C    the escape characters.
C
  230 CONTINUE
      IF (NOTHIN) NOTHIN = .FALSE.
      RETURN
C-----------------------------------------------------------------------
      END

C*GREX00 -- PGPLOT Talaris/EXCL driver, flush buffer
C+
      SUBROUTINE GREX00 (LUN, BUF, SIZ)
      CHARACTER*(*) BUF
      INTEGER LUN, SIZ
C--
      WRITE (LUN, '(A)') BUF(1:SIZ)
      END

C*GRTTER -- test whether device is user's terminal (Sun/Convex-UNIX)
C+
      SUBROUTINE GRTTER(STRING, SAME)
      CHARACTER*(*) STRING
      LOGICAL SAME
C
C Return a logical flag indicating whether the supplied device
C name is a name for the user's controlling terminal or not.
C (Some PGPLOT programs wish to take special action if they are
C plotting on the user's terminal.)
C
C Arguments:
C  STRING : (input) the device name to be tested.
C  SAME   : (output) .TRUE. is STRING contains a valid name for the
C           user's terminal; .FALSE. otherwise.
C--
C 18-Feb-1988
C-----------------------------------------------------------------------
      CHARACTER*64 T
      INTEGER L
C
      CALL GRTRML(T, L)
      SAME = (STRING.EQ.T(:L))
      END

C*GRCLIP -- clip a point against clipping rectangle
C+
      SUBROUTINE GRCLIP (X,Y,XMIN,XMAX,YMIN,YMAX,C)
      REAL X,Y
      REAL XMIN,XMAX,YMIN,YMAX
      INTEGER C
C
C GRPCKG (internal routine): support routine for the clipping algorithm;
C called from GRLIN0 only. C is a 4 bit code indicating the relationship
C between point (X,Y) and the window boundaries; 0 implies the point is
C within the window.
C
C Arguments:
C--
C (11-Feb-1983)
C Revised 20-Jun-1985 (TJP); use floating arithmetic
C Revised 12-Jun-1992 (TJP); clip exactly on the boundary
C-----------------------------------------------------------------------
C
      C = 0
      IF (X.LT.XMIN) THEN
          C = 1
      ELSE IF (X.GT.XMAX) THEN
          C = 2
      END IF
      IF (Y.LT.YMIN) THEN
          C = C+4
      ELSE IF (Y.GT.YMAX) THEN
          C = C+8
      END IF
      END

C*PGLINE -- draw a polyline (curve defined by line-segments)
C%void cpgline(int n, const float *xpts, const float *ypts);
C+
      SUBROUTINE PGLINE (N, XPTS, YPTS)
      INTEGER  N
      REAL     XPTS(*), YPTS(*)
C
C Primitive routine to draw a Polyline. A polyline is one or more
C connected straight-line segments.  The polyline is drawn using
C the current setting of attributes color-index, line-style, and
C line-width. The polyline is clipped at the edge of the window.
C
C Arguments:
C  N      (input)  : number of points defining the line; the line
C                    consists of (N-1) straight-line segments.
C                    N should be greater than 1 (if it is 1 or less,
C                    nothing will be drawn).
C  XPTS   (input)  : world x-coordinates of the points.
C  YPTS   (input)  : world y-coordinates of the points.
C
C The dimension of arrays X and Y must be greater than or equal to N.
C The "pen position" is changed to (X(N),Y(N)) in world coordinates
C (if N > 1).
C--
C 27-Nov-1986
C-----------------------------------------------------------------------
      INTEGER  I
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGLINE')) RETURN
      IF (N.LT.2) RETURN
C
      CALL PGBBUF
      CALL GRMOVA(XPTS(1),YPTS(1))
      DO 10 I=2,N
         CALL GRLINA(XPTS(I),YPTS(I))
 10   CONTINUE
      CALL PGEBUF
      END

C*PGPAP -- change the size of the view surface 
C%void cpgpap(float width, float aspect);
C+
      SUBROUTINE PGPAP (WIDTH, ASPECT)
      REAL WIDTH, ASPECT
C
C This routine changes the size of the view surface ("paper size") to a
C specified width and aspect ratio (height/width), in so far as this is
C possible on the specific device. It is always possible to obtain a
C view surface smaller than the default size; on some devices (e.g.,
C printers that print on roll or fan-feed paper) it is possible to 
C obtain a view surface larger than the default.
C 
C This routine should be called either immediately after PGBEG or
C immediately before PGPAGE. The new size applies to all subsequent
C images until the next call to PGPAP.
C
C Arguments:
C  WIDTH  (input)  : the requested width of the view surface in inches;
C                    if WIDTH=0.0, PGPAP will obtain the largest view
C                    surface available consistent with argument ASPECT.
C                    (1 inch = 25.4 mm.)
C  ASPECT (input)  : the aspect ratio (height/width) of the view
C                    surface; e.g., ASPECT=1.0 gives a square view
C                    surface, ASPECT=0.618 gives a horizontal
C                    rectangle, ASPECT=1.618 gives a vertical rectangle.
C--
C (22-Apr-1983; bug fixed 7-Jun-1988)
C  6-Oct-1990 Modified to work correctly on interactive devices.
C 13-Dec-1990 Make errors non-fatal [TJP].
C 14-Sep-1994 Fix bug to do with drivers changing view surface size.
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      LOGICAL  PGNOTO
      REAL     HDEF, HMAX, HREQ, WDEF, WMAX, WREQ
      REAL     XSMAX, YSMAX, XSZ, YSZ
C
      IF (PGNOTO('PGPAP'))  RETURN
      IF (WIDTH.LT.0.0 .OR. ASPECT.LE.0.0) THEN
          CALL GRWARN('PGPAP ignored: invalid arguments')
          RETURN
      END IF
C
      PGPFIX(PGID) = .TRUE.
C     -- Find default size WDEF, HDEF and maximum size WMAX, HMAX
C        of view surface (inches)
      CALL GRSIZE(PGID,XSZ,YSZ,XSMAX,YSMAX,
     1            PGXPIN(PGID),PGYPIN(PGID))
      WDEF = XSZ/PGXPIN(PGID)
      HDEF = YSZ/PGYPIN(PGID)
      WMAX = XSMAX/PGXPIN(PGID)
      HMAX = YSMAX/PGYPIN(PGID)
C     -- Find desired size WREQ, HREQ of view surface (inches)
      IF (WIDTH.NE.0.0) THEN
          WREQ = WIDTH
          HREQ = WIDTH*ASPECT
      ELSE
          WREQ = WDEF
          HREQ = WDEF*ASPECT
          IF (HREQ.GT.HDEF) THEN
              WREQ = HDEF/ASPECT
              HREQ = HDEF
          END IF
      END IF
C     -- Scale the requested view surface to fit the maximum
C        dimensions
      IF (WMAX.GT.0.0 .AND. WREQ.GT.WMAX) THEN
          WREQ = WMAX
          HREQ = WMAX*ASPECT
      END IF
      IF (HMAX.GT.0.0 .AND. HREQ.GT.HMAX) THEN
          WREQ = HMAX/ASPECT
          HREQ = HMAX
      END IF
C     -- Establish the new view surface dimensions
      XSZ = WREQ*PGXPIN(PGID)
      YSZ = HREQ*PGYPIN(PGID)
      CALL GRSETS(PGID,XSZ,YSZ)
      PGXSZ(PGID) = XSZ/PGNX(PGID)
      PGYSZ(PGID) = YSZ/PGNY(PGID)
      PGNXC(PGID) = PGNX(PGID)
      PGNYC(PGID) = PGNY(PGID)
      CALL PGSCH(1.0)
      CALL PGVSTD
      END

C*GRIMG3 -- gray-scale map of a 2D data array, using dither
C+
      SUBROUTINE GRIMG3 (A, IDIM, JDIM, I1, I2, J1, J2,
     1                   BLACK, WHITE, PA, MODE)
      INTEGER IDIM, JDIM, I1, I2, J1, J2, MODE
      REAL    A(IDIM,JDIM)
      REAL    BLACK, WHITE
      REAL    PA(6)
C--
C 2-Sep-1994 - moved from GRGRAY [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  I,IX,IX1,IX2,IY,IY1,IY2,J
      REAL     DEN,VALUE,BW
      REAL     XXAA,XXBB,YYAA,YYBB,XYAA,XYBB,YXAA,YXBB,XYAAIY,YXAAIY
      INTEGER  M, IAA, ICC, JRAN, ILAST, JLAST, IXSTEP, IYSTEP
      REAL     RAND, RM, FAC, FACL
      PARAMETER (M=714025, IAA=1366, ICC=150889, RM=1.0/M)
      PARAMETER (FAC=65000.0)
      INTRINSIC MOD, NINT, REAL, LOG
C-----------------------------------------------------------------------
C
      IF (MODE.LT.0 .OR. MODE.GT.2) RETURN
C
C Initialize random-number generator (based on RAN2 of Press et al.,
C Numerical Recipes)
C
      JRAN = 76773
C
      IX1 = NINT(GRXMIN(GRCIDE))+1
      IX2 = NINT(GRXMAX(GRCIDE))-1
      IY1 = NINT(GRYMIN(GRCIDE))+1
      IY2 = NINT(GRYMAX(GRCIDE))-1
      DEN = PA(2)*PA(6)-PA(3)*PA(5)
C
C Calculate constants.
C
      BW   = ABS(BLACK-WHITE)
      FACL = LOG(1.0+FAC)
      XXAA = (-PA(6))*PA(1)/DEN
      XXBB = PA(6)/DEN
      XYAA = (-PA(3))*PA(4)/DEN
      XYBB = PA(3)/DEN
      YYAA = (-PA(2))*PA(4)/DEN
      YYBB = PA(2)/DEN
      YXAA = (-PA(5))*PA(1)/DEN
      YXBB = PA(5)/DEN
C
C Choose step size: at least 1/200 inch, assuming the line-width
C unit is 1/200 inch.
C
      IXSTEP = MAX(1,NINT(GRWIDT(GRCIDE)*GRPXPI(GRCIDE)/200.0))
      IYSTEP = MAX(1,NINT(GRWIDT(GRCIDE)*GRPYPI(GRCIDE)/200.0))
C
C Draw dots.
C
      ILAST = 0
      JLAST = 0
      DO 120 IY=IY1,IY2,IYSTEP
          XYAAIY = XXAA-XYAA-XYBB*IY
          YXAAIY = YYAA+YYBB*IY-YXAA
          DO 110 IX=IX1,IX2,IXSTEP
              I = NINT(XYAAIY+XXBB*IX)
              IF (I.LT.I1.OR.I.GT.I2) GOTO 110
              J = NINT(YXAAIY-YXBB*IX)
              IF (J.LT.J1.OR.J.GT.J2) GOTO 110
              IF (I.NE.ILAST .OR. J.NE.JLAST) THEN
                  ILAST = I
                  JLAST = J
                  VALUE = ABS(A(I,J)-WHITE)/BW
                  IF (MODE.EQ.0) THEN
C                     -- "linear"
                      CONTINUE
                  ELSE IF (MODE.EQ.1) THEN
C                     -- "logarithmic"
                      VALUE = LOG(1.0+FAC*VALUE)/FACL
                  ELSE IF (MODE.EQ.2) THEN
C                     -- "square root"
                      VALUE = SQRT(VALUE)
                  END IF
              END IF
              JRAN = MOD(JRAN*IAA+ICC, M)
              RAND = JRAN*RM
              IF (VALUE.GT.RAND) CALL GRDOT0(REAL(IX),REAL(IY))
  110     CONTINUE
  120  CONTINUE
C-----------------------------------------------------------------------
       END

*Date:     Fri, 4 May 90 09:15 EST
*From:     <GILL@QUCDNAST.BITNET>
*Subject:  Latest version of CurveFit for PGPlot packages - May 4, 1990
c-------------------------------------------------------------------------------
c
c                                   CurveFit
c
c         A general curve fitting routine using PGPLOT graphics for use on
c      VAX/uVAX systems, possibly any system capable of running PGPLOT
c      interactively.
c
c         CurveFit will plot up to 30 data sets (a maximum of 2000 points for
c      each data set, a maximum of 20000 points total for one graph), saved
c      as (xp,yp) in ascending {xp} order.  Different data sets in one file
c      must be separated by one non-numeric line.  CurveFit can also modify the
c      data set, by flipping the x and y axes and/or taking logarithms of
c      either or both of them.  Labels and title can be added to the plots.
c      In addition, CurveFit allows one to fit various types of curves to the
c      data sets.  These are:
c
c           (a)  straight line (connect the dots)
c           (b)  cubic spline
c           (c)  smoothing (Bezier) polynomial
c           (d)  low-pass Fourier transform filter
c           (e)  a best-fit polynomial of up to 10 terms
c
c         CurveFit is menu driven and allows one to display all intermediary
c      results.  The x,y plotting ranges are user determined, as is the
c      fitting range (over the x coordinate).  Each type of fit can only be
c      used once with each data set, though different fits may be used with
c      the same data set (however, one could load the data set in again and do
c      the same fit over a different range).  Different data sets can have
c      different symbols and line styles/widths associated with them, so they
c      can be differentiated.  The manner in which the line styles/widths is
c      determined can be changed if the user so desires, as can the symbols
c      used to plot the data points.  Plots can be made on any device that is
c      supported by PGPLOT.
c
c         The programme is fairly well documented.  A subsantial amount of
c      virtual memory is required (of the order of 7 Mb), but this can be
c      decreased by lowering the number of data points that may be plotted.
c      The following are pseudo-global variables that must be changed in each
c      subroutine in order for the programme to work.
c
c           MAXPOINTS    the maximum number of points allowed per graph
c           MAXPOINTSET  the maximum number of data points per data set
c           MAXDATASET   the maximum number of data sets per graph
c           NCOEFF       the maximum number of coefficients for polynomial
c                            fitting
c           S2           gives the extra number of points calculated by the
c                            curve fitting routines to make the curves look
c                            smooth, given as 4*MAXPOINTS or 8*MAXPOINTS
c
c         The Bezier polynomial fitting is taken from Borland's TURBO Graphix
c      Toolbox (translated into FORTRAN), while the cubic spline routines
c      are partially taken from there, and partially my own algorithm.  The
c      polynomial fitting and the fast Fourier transforms are taken from
c      the book Numerical Recipes by W.H. Press et al.  Except as noted below,
c      the routines all seem to do what they are supposed to.  Note that the
c      polynomial curve fitting gives the coefficients and their standard
c      deviation as well.  Take these values with a grain of salt!
c
c         Currently, everything seems to work fairly well, except for some
c      numerical difficulties with the fast Fourier transform that I am
c      unable to fathom.  The problem only becomes noticeable when the FFT
c      smoothing takes place over more than about 100 data points, when
c      anomalous step functions appear at intervals of powers of 2.  The
c      step functions get larger as more data points are being smoothed over.
c      I would appreciate a solution if anyone comes up with one.
c
c         One other minor difficulty discovered occurs when one is taking
c      logs of more than one data set.  It is possible that the endpoints
c      used for the plotting will not cover the full range of all of the
c      data sets plotted.  A fix would require several more variables, plus
c      thinking, of which I do not have time at the present.
c
c         Distribute and use this programme as you see fit.  If anyone comes
c      up with major changes or improvements, please send me a copy of the
c      source code.  If anyone wishes a current copy, send me a note, and
c      the current source code will be sent out to them.  I can be reached
c      at
c
c            BITNET:    gill@qucdnast
c            INTERNET:  gill@bill.phy.queensu.ca
c
c
c  October 27, 1987 -     Fix of subroutine Spline1.  It was able to crash
c                     with a particular spacing of {xp}.  It was also found
c                     to be incorrect.
c                         Fix to all calculation subroutines, so that the
c                     fit will be made over only the points INSIDE the
c                     given fit range, inclusively, i.e. no extrapolation.
c  October 28, 1987 -     Fix of Subroutine Spline2.  It gave discontinuous
c                     spikes at the endpoints.
c                         Add double precision calculations to Spline1 and
c                     Spline2 to allow accurate subtractions/additions.
c  November 6, 1987 -     Fix of calculation procedures that give the range
c                     of the plot.  These are now given to 2 digits accuracy.
c                         Add the option to plot or not plot the individual
c                     data points.
c  November 13, 1987 -    Fix the x,y plotting limits when new data sets are
c                     loaded.
c                         Each {xp,yp} pair must be on the same line.  Other
c                     information is now allowed on each line after {xp,yp}.
c  March 8, 1988 -        Add READDATA subroutine, that allows one to:
c                     a) skip lines at the beginning before data input,
c                     b) have up to 25 columns of data that can be accessed,
c                     c) read multiple data sets from the same file.
c  April 21, 1988 -       Fix of number of points associated with the data
c                     set number.
c                         The default video and hardcopy devices are now
c                     /VT and /IM, respectively.
c  May 30, 1988 -         Add the option of user inputed line styles/widths.
c  June 2, 1988 -         Correct the problem of bad standard deviations on the
c                     polynomial coefficients.
c                         Add REAL*8 and /G_FLOATING to all of the polynomial
c                     calculations.
c  June 13, 1988 -        Add some idiot-proofing (read `Error checking') of
c                     the curve-fitting routines.
c  July 27, 1988 -        Correct the assignments of the fitting range
c                     variables.
c  August 29, 1988 -      Add error-trapping of non-character data input.
c                         Add scaling (in x and/or y) of any data set.
c                         Add ability to toggle all line drawing and fits for
c                     any data set at any time.
c                         Add user chosen line style/line width combinations.
c                         Add user chosen data point plot symbols.  The size of
c                     these is regulated by the total number of points (more
c                     points gives smaller symbols).
c  Christmas, 1988 -      Rearrange the storage method for the data.  Now
c                     there is a maximum of 20000 points, or 30 data sets of
c                     2000 points apiece.  This should allow for more
c                     flexibility for the user.
c  June 21, 1989   -      Change the entrance into the routines to allow
c                     multiple changes to data sets without going to the
c                     main menu screen in between each change.
c                         Fix of the log routines.  Check that your machine
c                     will assign 0 to 10^-100.
c  June 22, 1989   -      Fix of number of points plotted for various fits.
c                     Now each fit may have a different number of data points.
c  July 4, 1989    -      Fix of spline calculation routines.  Splines of more
c                     than one dataset were not saved correctly or plotted.
c  July 6, 1989    -      The default line width, line style will now always
c                     be 1 and 1.
c  July 11, 1989   -      Updated the help file subroutine.
c  July 14, 1989   -      Correct the plot symbol choosing routine.
c                         More idiot-proofing.
c                         Add an UpCase function (works with ASCII only).
c  August 29, 1989 -      Change the order of commands so that the main menu
c                     will not automatically be drawn between commands.  To
c                     redraw menu, type in `R' or `M'.
c  August 31, 1989 -      Fix READDATA, so that any data read in will be from
c                     one line only.  Before, multiple lines were permitted.
c                     Also, an error message is given if the asked for column
c                     does not exist.  The column can then be chosen again.
c  November 23, 1989 -    Update dataset number entry, so that multiple sets
c                     may be included on the same line, including the 0 dataset
c                     (to quit asking).  User is informed of entry errors and
c                     reprompted.
c                         Programme will announce when a particular data file
c                     has been used up and closed.
c                         If one overshoots a data line, typing 'B' will go
c                     back one line.  Typing 'Bn' will go back n lines.
c                     CurveFit is never case-sensitive.  One can also go back
c                     n lines from the first lineskip prompt.
c                         More error checking added - it is much harder to get
c                     it to crash now.
c  January 5, 1990   -    The subroutine SCALEDATASET has been added.  It
c                     includes the expansion/contraction of before, as well as
c                     the ability to slide data sets around the graph, and to
c                     subtract or add one data set from/to another.
c  March 14, 1990    -    Using BACKSPACE to go backwards through a file is
c                     very bad programming, as BACKSPACE = REWIND + (n-1) READ,
c                     so keep track of line number in file, and do the
c                     REWIND/READ combo in software.
c  April 6, 1990     -    Add confirmation when leaving CurveFit.
c  May 4, 1990       -    Correct backspacing through a data file.
c
c      Last revision - May 4, 1990 - Arnold Gill
c      Last revision to Tim Pearson (tjp@deimos.caltech.edu) - May 4, 1990
c
c-------------------------------------------------------------------------------
      PROGRAM CurveFit
c
      INTEGER    maxpoints,s2,ncoeff,maxdataset,dataset,ierror,i,j,ma,
     *     totalpoints,cdataset,ChooseDataSet,ii,maxpointset,offset,m,n
      PARAMETER  (maxpoints=20000,s2=8*maxpoints,ncoeff=10,
     *     maxdataset=30,maxpointset=2000)
c
c -----   The PARAMETER statement exists in many SUBROUTINEs, as needed.
c      Any changes to MAXPOINTS, MAXPOINTSET, NCOEFF, MAXDATASET must be
c      done in all of them.
c
      REAL       xdata(maxpointset),ydata(maxpointset),x(maxpoints),
     *     y(maxpoints),zero,xbez(s2),ybez(s2),xspl(s2),yspl(s2),
     *     coeff(ncoeff,2),xfr(maxpoints),yfr(maxpoints),r1,r2,r3,r4,
     *     xpoly(s2),ypoly(s2),x1,x2,y1,y2,f1,f2,one,
     *     scale,xminmax(2,maxdataset),yminmax(2,maxdataset)
      INTEGER    power(ncoeff),xstart(maxdataset,2),styles(maxdataset,3)
     *     ,maxply(maxdataset),maxfr(maxdataset),maxbez(maxdataset),
     *     maxspl(maxdataset)
      CHARACTER  xlabel*80,ylabel*80,title*80,blank*40,video*3,
     *     hardcopy*3,ans*1,datain*80,outstring*80,UpCase*1
      LOGICAL    labels,xlog(maxdataset),ylog(maxdataset),f,t,flip,
     *     fits(5,maxdataset),points,fileopen,linestyle,quit,ok
c
      DATA  blank/'                                        '/
      DATA  f/.FALSE./,t/.TRUE./,one/1.0/,zero/0.0/
c
      COMMON  /PlyDat/xpoly,ypoly,coeff,power,maxply,ma
      COMMON  /SplDat/xspl,yspl,maxspl,/BezDat/xbez,ybez,maxbez
      COMMON  /FrDat/xfr,yfr,maxfr
      COMMON  /XYDat/x,y,xdata,ydata,xminmax,yminmax
c
c -----   Opening title
c
c      WRITE (*,'('1')')
c      WRITE (*,98) 'Display the general description  [n] ? '
c      READ (*,97) ans
c      ans=UpCase(ans)
c      IF (ans.EQ.'Y') CALL Description
c
c -----   Choose the display device to use.  Unless you have the latest
c      version of PGPLOT, comment out the next program line.
c
      WRITE (*,100)
100   FORMAT ('1'///10X,'Choose your video display terminal'///10X,
     *     '(Default device is /VT)'//)
      CALL PGLDEV
      WRITE (*,*)
      video='   '
      READ (*,97) video
      IF (video(1:1).NE.'/') video='/vt'
      y1=1E35
      y2=-y1
      x1=y1
      x2=-y1
      dataset=0
      xlabel=blank//blank
      ylabel=blank//blank
      title=blank//blank
      labels=f
      fileopen=f
      linestyle=f
      totalpoints=0
      ierror=0
c
c -----   Data input
c
      CALL ReadData (dataset,xstart,x1,y1,x2,y2,fileopen,totalpoints)
      f1=x1
      f2=x2
      points=f
      DO 112 i=1,maxdataset
        styles(i,1)=1
        styles(i,2)=1
        styles(i,3)=-1
        DO 111 j=1,5
          fits(j,i)=f
111     CONTINUE
        xlog(i)=f
        ylog(i)=f
112   CONTINUE
      fits(1,dataset)=t
1     CONTINUE
c
c -----   Main menu for data and plot manipulation
c
      CALL Menu (ans,fits,dataset,xlog,ylog,flip,labels,points,
     *     linestyle,x1,x2,y1,y2,f1,f2)
      GOTO 1112
1111  CONTINUE
      WRITE (*,*)
      WRITE (*,98) 'Input command  [`M'' for Menu, <RETURN> to plot'//
     *     ' graph]: '
      READ (*,97) ans
      ans=UpCase(ans)
      IF (ans.EQ.'M') GOTO 1
1112  CONTINUE
      IF (((ans.LT.'1').OR.(ans.GT.'9')).AND.
     *     (ans.NE.'H').AND.(ans.NE.'X').AND.(ans.NE.'Q').AND.
     *     (ans.NE.'E').AND.(ans.NE.'L').AND.(ans.NE.'F').AND.
     *     (ans.NE.'N').AND.(ans.NE.'T').AND.(ans.NE.'A').AND.
     *     (ans.NE.'D').AND.(ans.NE.'S').AND.(ans.NE.'V')) THEN
c
c -----   Plot data with current values for parameters
c
        CALL Plot (xstart,x1,x2,y1,y2,f1,f2,xlabel,ylabel,title,labels,
     *     points,video,fits,dataset,f,totalpoints,styles,linestyle)
        CALL Menu (ans,fits,dataset,xlog,ylog,flip,labels,points,
     *       linestyle,x1,x2,y1,y2,f1,f2)
        GOTO 1112
      ELSE IF (ans.EQ.'1') THEN
c
c -----   Toggle the straight line data connecting from PGPLOT from
c     chosen data set
c
2       CONTINUE
        WRITE (*,'((A),(A),I2)') '0(Dis)Connect the points of which ',
     *       'dataset(s) : 1 - ',dataset
        WRITE (*,*) '   0 to quit, <ENTER> = current dataset'
        datain=blank//blank
        READ (*,97) datain
        CALL ToggleDataSet (fits,xstart,f1,f2,ans,datain,dataset,
     *     maxdataset,quit)
        IF (.NOT.quit) GOTO 2
      ELSE IF (ans.EQ.'2') THEN
c
c -----   Toggle and calculate the cubic spline fitting routine for
c     the chosen data set
c
3       CONTINUE
        WRITE (*,'((A),(A),I2)') '0Fit Cubic splines to which ',
     *       'dataset(s) : 1 - ',dataset
        WRITE (*,*) '   0 to quit, <ENTER> = current dataset'
        datain=blank//blank
        READ (*,97) datain
        CALL ToggleDataSet (fits,xstart,f1,f2,ans,datain,dataset,
     *     maxdataset,quit)
        IF (.NOT.quit) GOTO 3
      ELSE IF (ans.EQ.'3') THEN
c
c -----   Toggle and calculate the Bezier polynomial data smoothing
c     for the chosen data set
c
4       CONTINUE
        WRITE (*,'((A),(A),I2)') '0Fit a Bezier polynomial to which',
     *       ' dataset(s) : 1 - ',dataset
        WRITE (*,*) '   0 to quit, <ENTER> = current dataset'
        datain=blank//blank
        READ (*,97) datain
        CALL ToggleDataSet (fits,xstart,f1,f2,ans,datain,dataset,
     *     maxdataset,quit)
        IF (.NOT.quit) GOTO 4
      ELSE IF (ans.EQ.'4') THEN
c
c -----   Toggle and calculate the Fourier transform data smoothing
c     for the chosen data set
c
5       CONTINUE
        WRITE (*,'((A),(A),I2)') '0Smooth using an FFT of which ',
     *       'dataset(s) : 1 - ',dataset
        WRITE (*,*) '   0 to quit, <ENTER> = current dataset'
        datain=blank//blank
        READ (*,97) datain
        CALL ToggleDataSet (fits,xstart,f1,f2,ans,datain,dataset,
     *     maxdataset,quit)
        IF (.NOT.quit) GOTO 5
      ELSE IF (ans.EQ.'5') THEN
c
c -----   Toggle and calculate the best fit polynomial of data for the
c     chosen data set
c
6       CONTINUE
        WRITE (*,'((A),(A),I2)') '0Fit a polynomial to which ',
     *       'dataset(s) : 1 - ',dataset
        WRITE (*,*) '   0 to quit, <ENTER> = current dataset, multiple'
     *       //' entries allowed'
        datain=blank//blank
        READ (*,97) datain
        CALL ToggleDataSet (fits,xstart,f1,f2,ans,datain,dataset,
     *     maxdataset,quit)
        IF (.NOT.quit) GOTO 6
      ELSE IF (ans.EQ.'6') THEN
c
c -----   Toggle and calculate the base 10 logs of the x,y data as requested
c     for the chosen data set
c
65      CONTINUE
        j=2
        outstring=blank//blank
        DO 7 i=1,dataset
          IF (xlog(i).OR.ylog(i)) THEN
            WRITE (outstring(j:j+1),'(I2)') i
            j=j+3
          ENDIF
7      CONTINUE
        IF (j.GT.2) THEN
          WRITE (*,97) '0Logs are already calculated for data sets # :'
          WRITE (*,97) outstring
        ENDIF
8       CONTINUE
        WRITE (*,'((A),I2)') '0Take logs of which dataset : 1 - ',
     *       dataset
        WRITE (*,*) '     0 to quit, <ENTER> = current dataset'
        READ (*,97) datain
        IF (datain(1:1).EQ.'0') GOTO 1006
        cdataset=ChooseDataSet(datain,dataset,ok)
        IF (.NOT.ok) GOTO 8
        IF ((cdataset.GT.dataset).OR.(cdataset.LT.1)) THEN
          WRITE (*,99) 7,7,'Error in input.  Reenter data set number'
          GOTO 8
        ENDIF
        offset=xstart(cdataset,1)-1
        WRITE (*,*)
        WRITE (*,98) 'Take logs of x data  [n]: '
        READ (*,97) ans
        IF (UpCase(ans).EQ.'Y') THEN
          IF (.NOT.xlog(cdataset)) THEN
            xlog(cdataset)=t
            x1=1.0E35
            x2=-1.0E35
            DO 9 i=1,xstart(cdataset,2)
              IF (x(offset+i).GT.zero) THEN
                x(offset+i)=LOG10(x(offset+i))
                x1=MIN(x(offset+i),x1)
                x2=MAX(x(offset+i),x2)
              ELSE
                WRITE (*,99) 7,7,'Error - log of a non-positive number'
                x(offset+i)=-100.0
              ENDIF
9           CONTINUE
            DO 10 i=2,5
              fits(i,cdataset)=f
10          CONTINUE
          ENDIF
        ELSE IF (xlog(cdataset)) THEN
          xlog(cdataset)=f
          x1=1.0E35
          x2=-1.0E35
          DO 11 i=1,xstart(cdataset,2)
            x(offset+i)=1.0D1**DBLE(x(offset+i))
            x1=MIN(x(offset+i),x1)
            x2=MAX(x(offset+i),x2)
11        CONTINUE
          DO 12 i=2,5
            fits(i,cdataset)=f
12        CONTINUE
        ENDIF
        WRITE (*,98) 'Take logs of y data  [n]: '
        READ (*,97) ans
        IF (UpCase(ans).EQ.'Y') THEN
          IF (.NOT.ylog(cdataset)) THEN
            ylog(cdataset)=t
            y1=1.0E35
            y2=-1.0E35
            DO 13 i=1,xstart(cdataset,2)
              IF (y(offset+i).GT.zero) THEN
                y(offset+i)=LOG10(y(offset+i))
                y1=MIN(y(offset+i),y1)
                y2=MAX(y(offset+i),y2)
              ELSE
                WRITE (*,99) 7,7,'Error - log of a non-positive number'
                y(offset+i)=-100.0
              ENDIF
13          CONTINUE
            DO 14 i=2,5
              fits(i,cdataset)=f
14          CONTINUE
          ENDIF
        ELSE IF (ylog(cdataset)) THEN
          ylog(cdataset)=f
          y1=1.0E35
          y2=-1.0E35
          DO 15 i=1,xstart(cdataset,2)
            y(offset+i)=1.0D1**DBLE(y(offset+i))
            y1=MIN(y(offset+i),y1)
            y2=MAX(y(offset+i),y2)
15        CONTINUE
          DO 16 i=2,5
            fits(i,cdataset)=f
16        CONTINUE
        ENDIF
        CALL SetLimits (x1,x2)
        CALL SetLimits (y1,y2)
        f1=x1
        f2=x2
        GOTO 65
1006    CONTINUE
      ELSE IF (ans.EQ.'7') THEN
c
c -----   Set the range of the x coordinate to plot
c
        ii=1
17      CONTINUE
        WRITE (*,96) '0Current plotting range of x-coordinate is [ ',
     *       x1,' to ',x2,' ]'
        WRITE (*,98) 'Enter new range: '
        READ (*,*,ERR=1000,IOSTAT=ierror) x1,x2
        IF (x1.EQ.x2) THEN
          x2=x2+one
        ELSE IF (x1.GT.x2) THEN
          CALL Swap (x1,x2)
        ENDIF
        f1=MIN(f1,x1)
        f2=MAX(f2,x2)
      ELSE IF (ans.EQ.'8') THEN
c
c -----   Set the range of the y coordinate to plot
c
        ii=2
18      CONTINUE
        WRITE (*,96) '0Current plotting range of y-coordinate is [ ',
     *       y1,' to ',y2,' ]'
        WRITE (*,98) 'Enter new range: '
        READ (*,*,ERR=1000,IOSTAT=ierror) y1,y2
        IF (y1.EQ.y2) THEN
          y2=y2+one
        ELSE IF (y1.GT.y2) THEN
          CALL Swap (y1,y2)
        ENDIF
      ELSE IF (ans.EQ.'9') THEN
c
c -----   Set the range of the x coordinate over which to use the
c      different fitting routines
c
        ii=3
19      CONTINUE
        WRITE (*,96) '0Current fitting range of x-coordinate is [ ',
     *       f1,' to ',f2,' ]'
        WRITE (*,98) 'Enter new range: '
        READ (*,*,ERR=1000,IOSTAT=ierror) f1,f2
        IF (f1.EQ.f2) THEN
          f2=f2+one
        ELSE IF (f1.GT.f2) THEN
          CALL Swap (f1,f2)
        ENDIF
      ELSE IF (ans.EQ.'V') THEN
c
c -----   Choose the display device to use.  Unless you have the latest
c      version of PGPLOT, comment out the next program line.
c
        WRITE (*,1900)
1900    FORMAT ('0',10X,'Choose your video display terminal'//10X,
     *       '(Default device is /VT)'//)
        CALL PGLDEV
        WRITE (*,*)
        video='   '
        READ (*,97) video
        IF (video(1:1).NE.'/') video='/vt'
      ELSE IF (ans.EQ.'N') THEN
c
c -----   Get a new data file to analyse and start a new plot
c
        WRITE (*,98) 'This will erase the current plot.  Proceed'//
     *     '  [n]  ? '
        READ (*,97) ans
        IF (UpCase(ans).EQ.'Y') THEN
          y1=1E35
          y2=-y1
          x1=y1
          x2=-y1
          dataset=0
          xlabel=blank//blank
          ylabel=blank//blank
          title=blank//blank
          labels=f
          DO 205 i=1,maxdataset
            styles(i,1)=1
            styles(i,2)=1
            styles(i,3)=-1
            DO 20 j=1,5
              fits(j,i)=f
20          CONTINUE
            xlog(i)=f
            ylog(i)=f
205       CONTINUE
          fits(1,1)=t
          points=f
          linestyle=f
          CALL ReadData (dataset,xstart,x1,y1,x2,y2,fileopen,
     *         totalpoints)
          f1=x1
          f2=x2
        ENDIF
      ELSE IF (ans.EQ.'A') THEN
c
c -----   Add a new data file to current plot.  MAXDATASET data sets are
c      permitted.
c
        IF (dataset.EQ.maxdataset) THEN
          WRITE (*,99) 7,7,'No more room for additional data sets'
        ELSE
          Call ReadData (dataset,xstart,x1,y1,x2,y2,fileopen,
     *         totalpoints)
          xlog(dataset)=f
          ylog(dataset)=f
          fits(1,dataset)=t
          DO 21 i=2,5
            fits(i,dataset)=f
21        CONTINUE
          f1=x1
          f2=x2
        ENDIF
      ELSE IF (ans.EQ.'F') THEN
c
c -----   Exchange the x and y axes, with the various fits being set to
c      false (i.e. they need to be redone)
c
22      CONTINUE
        WRITE (*,'((A),(A),I2)') '0Flip the X-Y axes of which ',
     *       'dataset : 1 - ',dataset
        WRITE (*,*) '     0 to quit,  <ENTER> = current dataset'
        READ (*,97) datain
        IF (datain(1:1).EQ.'0') GOTO 1007
        cdataset=ChooseDataSet(datain,dataset,ok)
        IF (.NOT.ok) GOTO 22
        IF ((cdataset.GT.dataset).OR.(cdataset.LT.1)) THEN
          WRITE (*,99) 7,7,'Error in input.  Reenter data set number'
          GOTO 22
        ENDIF
        DO 23 i=1,xstart(cdataset,2)
          CALL Swap (x(offset+i),y(offset+i))
23      CONTINUE
        fits(1,cdataset)=t
        DO 24 i=2,5
          fits(i,cdataset)=f
24      CONTINUE
        flip=.NOT.flip
        CALL Swap (x1,y1)
        CALL Swap (x2,y2)
        f1=x1
        f2=x2
        GOTO 22
1007    CONTINUE
      ELSE IF (ans.EQ.'H') THEN
c
c -----   Choose the hardcopy device, and send it
c
        WRITE (*,101)
101     FORMAT ('1'///10X,'Choose your hardcopy device:'///10X,
     *     '(Default device is /IM)'//)
        CALL PGLDEV
        WRITE (*,*)
        hardcopy='   '
        READ (*,97) hardcopy
        IF (hardcopy(1:1).NE.'/') hardcopy='/im'
        CALL Plot (xstart,x1,x2,y1,y2,f1,f2,xlabel,ylabel,title,labels,
     *     points,hardcopy,fits,dataset,t,totalpoints,styles,
     *     linestyle)
      ELSE IF (ans.EQ.'S') THEN
        CALL ScaleDataSet (x1,x2,y1,y2,fits,xstart,dataset)
      ELSE IF (ans.EQ.'T') THEN
c
c -----   Place and toggle labels and title on the plot
c
        IF (labels) THEN
          WRITE (*,*)
          WRITE (*,98) 'Remove the title/labels  [n] ? '
          READ (*,97) ans
          IF (UpCase(ans).NE.'Y') THEN
            WRITE (*,*)
            WRITE (*,98) 'Change the title/labels  [y] ? '
            READ (*,97) ans
            IF (UpCase(ans).NE.'N') THEN
              WRITE (*,*)
              WRITE (*,98) 'Change the x-axis label  [n] ? '
              READ (*,97) ans
              IF (UpCase(ans).EQ.'Y') THEN
                WRITE (*,*) xlabel
                WRITE (*,*) 'Enter the new x-axis label :'
                READ (*,97) xlabel
              ENDIF
              WRITE (*,*)
              WRITE (*,98) 'Change the y-axis label  [n] ? '
              READ (*,97) ans
              IF (UpCase(ans).EQ.'Y') THEN
                WRITE (*,*) ylabel
                WRITE (*,*) 'Enter the new y-axis label :'
                READ (*,97) ylabel
              ENDIF
              WRITE (*,*)
              WRITE (*,98) 'Change the title  [n] ? '
              READ (*,97) ans
              IF (UpCase(ans).EQ.'Y') THEN
                WRITE (*,*) title
                WRITE (*,*) 'Enter the new title of the plot :'
                READ (*,97) title
              ENDIF
            ENDIF
          ELSE
            labels=f
          ENDIF
        ELSE
          labels=t
          WRITE (*,*) 'Enter the x-axis label :'
          READ (*,97) xlabel
          WRITE (*,*) 'Enter the y-axis label :'
          READ (*,97) ylabel
          WRITE (*,*) 'Enter the title of the plot :'
          READ (*,97) title
        ENDIF
      ELSE IF (ans.EQ.'D') THEN
c
c -----   Toggle the plotting of the data points
c
        points=.NOT.points
        IF (points) THEN
          WRITE (*,3200) dataset
3200      FORMAT ('0There is/are currently ',I2,
     *         ' different set(s) of data plotted.'//,4X,
     *         'Choose the symbol for graphing of data points from the',
     *         ' table below'//,19X,
     *         '(-1)  do not plot this dataset'//,12X,
     *         '(2)  plus sign',13X,'(12) open star'/,12X
     *         '(3)  asterisk',14X,'(13) filled triangle'/,12X,
     *         '(4)  open circle',11X,'(14) open cross'/,12X,
     *         '(5)  times sign',12X,'(15) star of david'/,12X,
     *         '(6)  open square',11X,'(16) filled square'/,12X,
     *         '(7)  open triangle',9X,'(17) filled circle'/,12X,
     *         '(10) hyperbolic square',5X,'(18) filled star'/,12X,
     *         '(11) open diamond'//)
          WRITE (*,*)
          ii=4
          DO 36 i=1,dataset
34          CONTINUE
            WRITE (*,'((A),I2,(A),$)') ' Choice for data set #',i,': '
            READ (*,*,ERR=1000,IOSTAT=ierror) m
            IF (.NOT.(((m.GE.2).AND.(m.LE.7)).OR.
     *          ((m.GE.10).AND.(m.LE.18)).OR.(m.EQ.-1))) GOTO 1000
            styles(i,3)=m
36        CONTINUE
        ELSE
          DO 37 i=1,maxdataset
            styles(i,3)=-1
37        CONTINUE
        ENDIF
      ELSE IF (ans.EQ.'L') THEN
c
c -----   Toggle the choice of linestyle to and from USER / SYSTEM, and
c     set the user's choice of linestyle.
c
        linestyle=.NOT.linestyle
        IF (linestyle) THEN
          WRITE (*,3700) dataset
3700      FORMAT ('0There is/are currently ',I2,
     *         ' different set(s) of data plotted.'//,4X,
     *         'Choose the line style and the line width from'/,2X,
     *         'the table below and enter as  ls,lw  (ex 1,9)'//,5X,
     *         'Line style:     1)  solid line'/,21X,
     *         '2)  long dashes'/,21X,'3)  dash-dot-dash'/,21X,
     *         '4)  dotted'/,21X,'5)  dash-dot-dot-dot'//,5X,
     *         'Line width:     1 through 21'//)
          ii=5
          DO 40 i=1,dataset
38          CONTINUE
            WRITE (*,'((A),I2,(A),$)') ' Choice for data set #',i,': '
            READ (*,*,ERR=1000,IOSTAT=ierror) m,n
            IF ((m.LT.1).OR.(m.GT.5).OR.(n.LT.1).OR.(n.GT.21)) GOTO 1000
            styles(i,1)=m
            styles(i,2)=n
40        CONTINUE
        ELSE
          DO 41 i=1,dataset
            styles(i,1)=1
            styles(i,2)=1
41        CONTINUE
        ENDIF
      ELSE
        WRITE (*,*)
        WRITE (*,'(2A1,(A))') 7,7,'Confirm exit from CurveFit - enter'//
     *            ' a capital `C'': '
        READ (*,97) ans
c
c -----   Quit the programme CurveFit - requires an upper-case `C'
c
        IF (ans.EQ.'C') STOP
      ENDIF
      GOTO 1111
c
c -----   Error checking/error flag resetting routine.
c
1000  CONTINUE
      WRITE (*,99) 7,7,'***  Error in input - redo!  ***'
      IF (ierror.GT.0) CALL ERRTST (ierror,m)
      GOTO (17,18,19,34,38),ii
96    FORMAT ((A),E10.3,A4,E10.3,A2)
97    FORMAT ((A))
98    FORMAT (1X,(A),$)
99    FORMAT ('0',2(A1),(A))
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE ToggleDataSet (fits,xstart,f1,f2,ans,datain,dataset,
     *     maxdataset,quit)
c
c -----   Takes an input string of dataset numbers, separates them and
c     operates on the valid values.  Errors are detected and the user is
c     notified.  This allows more than one data set number to be included
c     on each input line, including the 0 data set which quits entry.  All
c     numbers after 0 on the entry line are ignored.
c
      REAL       f1,f2
      INTEGER    dataset,maxdataset,xstart(maxdataset,2),ind,last,ians,
     *     cdataset,ierror,j
      LOGICAL    quit,fits(5,maxdataset),ok
      CHARACTER  ans*1,datain*80,ch*1
c
      ians=ICHAR(ans)-ICHAR('0')
      last=80
      ind=1
c
c -----   Determine the length of the input string.  If zero, default is used.
c
      DO 1 last=80,1,-1
        ch=datain(last:last)
        IF ((ch.GE.'0').AND.(ch.LE.'9')) GOTO 2
1     CONTINUE
      last=0
      GOTO 3
2     CONTINUE
      last=last+1
3     CONTINUE
      IF (last.EQ.0) THEN
        cdataset=dataset
        GOTO 5
      ENDIF
4     CONTINUE
c
c -----   Read the dataset number from the given passed substring
c
      READ (datain(ind:last),*,IOSTAT=ierror) cdataset
      IF (ierror.NE.0) THEN
c
c -----   Bad, non-integer, input
c
        IF (ierror.GT.0) CALL ERRTST (ierror,j)
        WRITE (*,400) 7,7
400     FORMAT (1X,2A1,'***  Error in input.  ***')
      ELSEIF ((cdataset.GT.dataset).OR.(cdataset.LT.0)) THEN
c
c -----   Invalid integer input
c
        WRITE (*,401) 7,7,cdataset
401     FORMAT (1X,2A1,'***  Error in input. ',I4,' is not valid.  ***')
        GOTO 6
      ENDIF
5     CONTINUE
c
c -----   Toggle the dataset logical and do the appropriate action
c
      IF (cdataset.EQ.0) GOTO 8
      fits(ians,cdataset)=.NOT.fits(ians,cdataset)
      IF (fits(ians,cdataset)) THEN
        IF (ians.EQ.1) THEN
          ok=.TRUE.
        ELSEIF (ians.EQ.2) THEN
          CALL SplineCalc (xstart(cdataset,1)-1,xstart(cdataset,2),
     *         f1,f2,cdataset,ok)
        ELSEIF (ians.EQ.3) THEN
          CALL BezierCalc (xstart(cdataset,1)-1,xstart(cdataset,2),f1,
     *         f2,cdataset,ok)
        ELSEIF (ians.EQ.4) THEN
          CALL FourierCalc (xstart(cdataset,1)-1,xstart(cdataset,2),f1,
     *         f2,cdataset,ok)
        ELSEIF (ians.EQ.5) THEN
          CALL PolynomialCalc (xstart(cdataset,1)-1,xstart(cdataset,2),
     *         f1,f2,cdataset,ok)
        ENDIF
        fits(ians,cdataset)=ok
      ENDIF
c
c -----   Inform user of result
c
      IF (fits(ians,cdataset)) THEN
        WRITE (*,500) cdataset,' is now ON'
      ELSE
        WRITE (*,500) cdataset,' is now OFF'
      ENDIF
500   FORMAT (' Dataset #',I2,(A))
6     CONTINUE
c
c -----   Find first numeric character in input string from current position
c
      ch=datain(ind:ind)
      IF ((ch.GE.'0').AND.(ch.LE.'9')) GOTO 7
      ind=ind+1
      IF (ind.GE.last) GOTO 8
      GOTO 6
7     CONTINUE
c
c -----   When first numeric character is found, look for a non-numeric
c     character (a delimiter - i.e. NOT one of 0..9,+,-)
c
      ind=ind+1
      IF (ind.GE.last) GOTO 8
      ch=datain(ind:ind)
      IF (((ch.GE.'0').AND.(ch.LE.'9')).OR.(ch.EQ.'-').OR.(ch.EQ.'+'))
     *     GOTO 7
      ind=ind+1
      IF (ind.GE.last) GOTO 8
      GOTO 4
8     CONTINUE
      quit=cdataset.EQ.0
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      FUNCTION ChooseDataSet (datain,dataset,ok)
c
      INTEGER    ChooseDataSet,dataset,ierror,idummy
      CHARACTER  datain*2
      LOGICAL    ok
c
      READ (datain,*,IOSTAT=ierror) idummy
      ok=ierror.LE.0
      IF (.NOT.ok) THEN
        WRITE (*,'(1X,2A1,(A))') 7,7,'***  Error in input ***'
        RETURN
      ENDIF
      IF (idummy.EQ.0) THEN
        ChooseDataSet=dataset
      ELSE
        ChooseDataSet=idummy
      ENDIF
      RETURN
      END
c
c ----------------------------------------------------------------------
c
      FUNCTION UpCase (ch)
c
c -----   This function works on ASCII machines.  EBCDIC is a ?
c
      CHARACTER*1  UpCase,ch
c
      IF ((ch.GE.'a').AND.(ch.LE.'z')) THEN
        Upcase=CHAR(ICHAR(ch)-ICHAR('a')+ICHAR('A'))
      ELSE
        UpCase=ch
      ENDIF
      RETURN
      END
c
c ------------------------------------------------------------------------------
c
      FUNCTION StrLen (string)
c
c -----   Returns the real length of the string, not the amount of memory set
c     aside for it.
c
      INTEGER    StrLen,i,ilength
      CHARACTER  string*(*)
c
      ilength=LEN(string)
      StrLen=0
      DO i=ilength,1,-1
        IF (string(i:i).NE.' ') THEN
          StrLen=i
          RETURN
        ENDIF
      ENDDO
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE Menu (ans,fits,dataset,xlog,ylog,flip,labels,points,
     *     linestyle,x1,x2,y1,y2,f1,f2)
c
c -----   The main menu screen with all of the current plot settings for
c      the current data
c
      INTEGER       maxpoints,spoly,ncoeff,maxdataset,dataset,ma,i,j
      PARAMETER     (maxpoints=20000,ncoeff=10,maxdataset=30,
     *     spoly=8*maxpoints)
      REAL          xp(spoly),yp(spoly),coeff(ncoeff,2),x1,x2,y1,y2,
     *     f1,f2
      INTEGER       power(ncoeff),maxply(maxdataset)
      CHARACTER*1   ans,UpCase
      CHARACTER*34  plotted(5),dummy
      LOGICAL       fits(5,maxdataset),xlog,ylog,flip,labels,points,
     *     linestyle
c
      COMMON  /PlyDat/xp,yp,coeff,power,maxply,ma
c
      WRITE (*,100)
100   FORMAT ('0',24X,'CurveFit - Main Menu'/)
      DO 2 i=1,5
        dummy='[                                ]'
        DO 1 j=1,dataset
          dummy(j+2:j+2)='-'
          IF (fits(i,j)) dummy(j+2:j+2)='+'
1       CONTINUE
        plotted(i)=dummy
2     CONTINUE
      WRITE (*,93) '(1)  Connect points with straight line ',plotted(1)
      WRITE (*,93) '(2)  Connect points with cubic spline  ',plotted(2)
      WRITE (*,93) '(3)  Smooth data with Bezier polynomial',plotted(3)
      WRITE (*,93) '(4)  Smooth data with Fourier transform',plotted(4)
      WRITE (*,93) '(5)  Best fit polynomial               ',plotted(5)
      IF (xlog.AND.ylog) THEN
        WRITE (*,97) '(6)  Logarithms of x or y data','[ XY ]'
      ELSE IF (xlog) THEN
        WRITE (*,97) '(6)  Logarithms of x or y data','[ X ]'
      ELSE IF (ylog) THEN
        WRITE (*,97) '(6)  Logarithms of x or y data','[ Y ]'
      ELSE
        WRITE (*,97) '(6)  Logarithms of x or y data','[ NONE ]'
      ENDIF
      WRITE (*,94) '(7)  Plotting range of x coordinate           [',
     *     x1,' to ',x2,' ]'
      WRITE (*,94) '(8)  Plotting range of y coordinate           [',
     *     y1,' to ',y2,' ]'
      WRITE (*,94) '(9)  Fitting range of x coordinate            [',
     *     f1,' to ',f2,' ]'
      IF (flip) THEN
        WRITE (*,95) '(F)  Flip the x and y axes','[ ON ]'
      ELSE
        WRITE (*,95) '(F)  Flip the x and y axes','[ OFF ]'
      ENDIF
      IF (points) THEN
        WRITE (*,98) '(D)  Data points are plotted','[ ON ]'
      ELSE
        WRITE (*,98) '(D)  Data points are plotted','[ OFF ]'
      ENDIF
      IF (labels) THEN
        WRITE (*,99) '(T)  Labels and title placed on the plot','[ ON ]'
      ELSE
        WRITE (*,99) '(T)  Labels and title placed on the plot',
     *       '[ OFF ]'
      ENDIF
      WRITE (*,92) '(A)  Add a data file to existing plot','[ ',dataset,
     *     ' ]'
      IF (linestyle) THEN
        WRITE (*,96) '(L)  User/System defined plotted line styles',
     *     '[ USER ]'
      ELSE
        WRITE (*,96) '(L)  User/System defined plotted line styles',
     *     '[ SYSTEM ]'
      ENDIF
      WRITE (*,101)
101   FORMAT (1X,'(S)  Scale/Slide/Subtract a particular dataset'/1X,
     *     '(H)  Send plot to disk for hardcopy'/1X,
     *     '(V)  Select a new video display device'/1X,
     *     '(N)  New data file and plot'/1X,'(E,Q,X)  Exit CurveFit',
     *     //10X,'Choose one of the above     [Plot to screen]:  ',$)
      READ (*,'(A)') ans
      ans=UpCase(ans)
92    FORMAT (1X,(A),17X,(A),I<INT(LOG10(FLOAT(dataset)))+1>,(A))
93    FORMAT (1X,(A),3X,(A))
94    FORMAT (1X,(A),E10.3,A4,E10.3,A2)
95    FORMAT (1X,(A),28X,(A))
96    FORMAT (1X,(A),10X,(A))
97    FORMAT (1X,(A),24X,(A))
98    FORMAT (1X,(A),26X,(A))
99    FORMAT (1X,(A),14X,(A))
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE Plot (xstart,x1,x2,y1,y2,f1,f2,xlabel,ylabel,title,
     *     labels,points,device,fits,dataset,hard,totalpoints,styles,
     *     linestyle)
c
c -----   The general plotting subroutine
c
      INTEGER    maxpoints,s2,ncoeff,maxdataset,dataset,i,j,ma,
     *     totalpoints,symbol,offset
      PARAMETER  (maxpoints=20000,s2=8*maxpoints,ncoeff=10,
     *     maxdataset=30)
      REAL       x(maxpoints),y(maxpoints),coeff(ncoeff,2),
     *     xbez(s2),ybez(s2),xspl(s2),x1,x2,y1,y2,
     *     yspl(s2),xfr(maxpoints),xplot(s2),yplot(s2),f1,f2,
     *     yfr(maxpoints),xpoly(s2),ypoly(s2)
      INTEGER    power(ncoeff),plotsym(maxdataset),xstart(maxdataset,2),
     *     styles(maxdataset,3),maxply(maxdataset),maxbez(maxdataset),
     *     maxfr(maxdataset),maxspl(maxdataset)
      CHARACTER  xlabel*(*),ylabel*(*),title*(*),device*3,ans*1,
     *     plotname*25,UpCase*1,blank*40
      LOGICAL    fits(5,maxdataset),labels,hard,points,linestyle
c
      DATA  plotsym/3,11,6,7,12,4,16,17,2,5,13,14,15,18,10,3,11,6,7,12,
     *     4,16,17,2,5,13,14,15,18,10/
      DATA  blank/'+                                       '/
c
c -----   These are the PGPlot plot symbols, appearing in the following
c      (default) order (twice to cover the 30 possible data sets):
c           asterisk, diamond, square, triangle, star, circle,
c           filled square, filled circle, plus, times, filled triangle,
c           open cross, star of David, filled star, rounded square
c
      COMMON  /XYDat/x,y,/SplDat/xspl,yspl,maxspl
      COMMON  /BezDat/xbez,ybez,maxbez,/FrDat/xfr,yfr,maxfr
      COMMON  /PlyDat/xpoly,ypoly,coeff,power,maxply,ma
c
      IF (hard) THEN
        WRITE (*,'((A),$)') '0Enter plot file name : '
        READ (*,'((A))') plotname
        CALL PGBegin (0,plotname//device,1,1)
      ELSE
        CALL PGBegin (0,device,1,1)
      ENDIF
      CALL PGSCH (1.0)
      CALL PGSCF (2)
      IF (hard) CALL PGSLW (2)
      CALL PGEnv (x1,x2,y1,y2,0,1)
      DO 8 i=1,dataset
        offset=xstart(i,1)-1
        symbol=styles(i,3)
        IF (symbol.EQ.-1) GOTO 2
        IF (symbol.EQ.0) symbol=plotsym(i)
        DO 1 j=1,xstart(i,2)
          xplot(j)=x(offset+j)
          yplot(j)=y(offset+j)
1       CONTINUE
        CALL PGSCH (MAX(0.5,1.0-0.1*(totalpoints/200)))
        IF (hard) THEN
          CALL PGSLW (2)
          IF (points) CALL PGPoint (xstart(i,2),xplot,yplot,symbol)
          IF (i.EQ.1) THEN
            CALL PGSLW (1)
            CALL PGSCH (1.0)
c            CALL PGIden
          ENDIF
        ELSE
          CALL PGSLW (1)
          CALL PGSCH (MAX(0.5,1.0-0.1*(totalpoints/200)))
          IF (points) CALL PGPoint (xstart(i,2),xplot,yplot,symbol)
        ENDIF
2       CONTINUE
        CALL PGSCH (1.0)
        CALL PGSLS (styles(i,1))
        CALL PGSLW (styles(i,2))
        IF (fits(1,i)) THEN
          DO 3 j=1,xstart(i,2)
            xplot(j)=x(offset+j)
            yplot(j)=y(offset+j)
3         CONTINUE
          CALL PGLine (xstart(i,2),xplot,yplot)
        ENDIF
        IF (fits(2,i)) THEN
          DO 4 j=1,maxspl(i)
            xplot(j)=xspl(8*offset+j)
            yplot(j)=yspl(8*offset+j)
4         CONTINUE
          CALL PGLine (maxspl(i),xplot,yplot)
        ENDIF
        IF (fits(3,i)) THEN
          DO 5 j=1,maxbez(i)
            xplot(j)=xbez(8*offset+j)
            yplot(j)=ybez(8*offset+j)
5         CONTINUE
          CALL PGLine (maxbez(i),xplot,yplot)
        ENDIF
        IF (fits(4,i)) THEN
          DO 6 j=1,maxfr(i)
            xplot(j)=xfr(offset+j)
            yplot(j)=yfr(offset+j)
6         CONTINUE
          CALL PGLine (maxfr(i),xplot,yplot)
        ENDIF
        IF (fits(5,i)) THEN
          DO 7 j=1,maxply(i)
            xplot(j)=xpoly(8*offset+j)
            yplot(j)=ypoly(8*offset+j)
7         CONTINUE
          CALL PGLine (maxply(i),xplot,yplot)
        ENDIF
8     CONTINUE
      IF (.NOT.hard) THEN
        WRITE (*,800) 7,'Press T for titles, <ENTER> to quit: '
800     FORMAT (1X,A1,(A),$)
        READ (*,'((A))') ans
        IF (UpCase(ans).NE.'T') GOTO 9
      ENDIF
      WRITE (*,'((A))') blank
      CALL PGSCH (1.0)
      CALL PGSCF (2)
      IF (hard) CALL PGSLW (2)
      IF (labels) CALL PGLabel (xlabel,ylabel,title)
      IF (.NOT.hard) THEN
        WRITE (*,800) 7,'Finished plotting - press <ENTER> to '//
     *       'continue: '
        READ (*,'((A))') ans
c
c -----   The following is done to clear the screen after the plot is
c      finished, i.e. when the main menu appears again, on some strange
c      terminals, like the LANPAR Vision II (VT240 clone).
c
9       CONTINUE
        CALL PGAsk (.FALSE.)
        CALL PGAdvance
      ENDIF
      CALL PGEnd
c
c -----   For Tektronics emulators, recall plot routines to return to text mode
c
      IF (device.EQ.'/te') THEN
        ans=CHAR(27)
        WRITE (*,'(A6)') ans//'[?38l'
      ENDIF
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      OPTIONS /G_FLOATING
c
c -----   The above options statement allows the use of this routine with
c      more than 140 data points, due to N! problems just before label 3.
c
      SUBROUTINE BezierCalc (offset,numpt,f1,f2,dataset,ok)
c
c -----   The routine for calculating the Bezier polynomial over the
c      x-coordinate range from F1 to F2.  The routine is translated exactly
c      from Borland's TURBO Graphix Toolbox.  The polynomial will space an
c      additional 7 points {xp,yp} between every two data points {x,y},
c      i.e. 8 times as dense.
c
      INTEGER    maxpoints,s2,maxdataset,dataset,numpt,i,j,maxcpt,
     *     intpt,n,maxpointset,offset,maxnum
      PARAMETER  (maxpoints=20000,s2=8*maxpoints,maxdataset=30,
     *     maxpointset=2000)
      INTEGER    maxbez(maxdataset)
      REAL       x(maxpoints),y(maxpoints),xp(s2),yp(s2),t,quot,f1,f2,
     *     one,deltat
      REAL*8     c(0:maxpointset),sumx,sumy,done,prod
      LOGICAL    ok
c
      DATA  one,done/1.0,1.0D0/
c
      COMMON  /XYDat/x,y,/BezDat/xp,yp,maxbez
c
      ok=.FALSE.
      i=0
1     CONTINUE
        i=i+1
      IF (x(offset+i).LT.f1) GOTO 1
      j=i
2     CONTINUE
      IF (j+1.LE.numpt.AND.x(offset+j+1).LE.f2) THEN
        j=j+1
        GOTO 2
      ENDIF
      maxcpt=j-i
      maxnum=(j-i+1)*8
      maxbez(dataset)=maxnum
      IF (maxcpt.LT.2) THEN
        WRITE (*,'(1X,A1,(A))') 7,'Error in Bezier Calculation routine!'
        RETURN
      ENDIF
      f1=x(offset+i)
      f2=x(offset+j)
      IF (f1.GT.f2) CALL Swap (f1,f2)
      deltat=one/(maxnum-1)
      c(0)=done
      c(maxcpt)=done
      DO 3 n=0,maxcpt-2
        c(n+1)=c(n)*(maxcpt-n)/(n+1)
3     CONTINUE
      DO 8 intpt=1,maxnum
        t=(intpt-1)*deltat
        IF (t.LE.0.5) THEN
          quot=one-t
          prod=quot
          DO 4 n=1,maxcpt-1
            prod=prod*quot
4         CONTINUE
          quot=t/quot
          sumx=x(offset+j)
          sumy=y(offset+j)
          DO 5 n=maxcpt,1,-1
            sumx=c(n-1)*x(offset+i+n-1)+quot*sumx
            sumy=c(n-1)*y(offset+i+n-1)+quot*sumy
5         CONTINUE
        ELSE
          quot=t
          prod=quot
          DO 6 n=1,maxcpt-1
            prod=prod*quot
6         CONTINUE
          quot=(one-t)/quot
          sumx=x(offset+i)
          sumy=y(offset+i)
          DO 7 n=1,maxcpt
            sumx=c(n)*x(offset+i+n)+quot*sumx
            sumy=c(n)*y(offset+i+n)+quot*sumy
7         CONTINUE
        ENDIF
        xp(8*offset+intpt)=SNGL(sumx*prod)
        yp(8*offset+intpt)=SNGL(sumy*prod)
8     CONTINUE
      ok=.TRUE.
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      OPTIONS /G_FLOATING
c
      SUBROUTINE PolynomialCalc (offset,numpt,f1,f2,dataset,ok)
c
c -----   Calculate the best fit polynomial over the x-coordinate range
c      F1 to F2.  The routine used is called Singular Value Decomposition
c      (SVDFIT), taken from the book Numerical Recipes by W.H. Press et al.
c      It is slower than normal solving of the matrices involved, but will
c      never give an infinite coefficient.  Coefficients that tend toward
c      infinity while cancelling another are set to zero with this method.
c      Other negligible coefficients are also set to zero (determined by
c      the size of TOL*WMAX).  The best fit is done with a polynomial of
c      user specified order, though the number of non-zero coefficients must
c      be less than 10.  This routine also returns the error in the
c      coefficients and data points to plot.  It is assumed that no
c      uncertainties exist in the input data.
c
      INTEGER    maxpoints,s2,ncoeff,maxdataset,dataset,ma,i,j,k,
     *     numpt,maxpointset,offset,maxnum,ierror
      CHARACTER  ans*1
      PARAMETER  (maxpoints=20000,s2=8*maxpoints,maxdataset=30,
     *     ncoeff=10,maxpointset=2000)
      REAL       x(maxpoints),y(maxpoints),coeff(ncoeff,2),
     *     xpoly(s2),ypoly(s2),tol,zero,f1,f2,const,xp,FPoly
      REAL*8     v(ncoeff,ncoeff),u(maxpointset,ncoeff),w(ncoeff),
     *     wmax,thresh
      INTEGER    power(ncoeff),maxply(maxdataset)
      LOGICAL    ok
c
      COMMON  /XYDat/x,y,/PlyDat/xpoly,ypoly,coeff,power,maxply,ma
c
      DATA  tol,zero/1.0E-10,0.0/
c
      ok=.FALSE.
      i=0
1     CONTINUE
        i=i+1
      IF (x(offset+i).LT.f1) GOTO 1
      j=i
2     CONTINUE
      IF (j+1.LE.numpt.AND.x(offset+j+1).LE.f2) THEN
        j=j+1
        GOTO 2
      ENDIF
      maxnum=j-i+1
      IF (maxnum.LT.2) THEN
        WRITE (*,'(1X,A1,(A),(A))') 7,'Error in Polynomial Calculation',
     *       ' routine!'
        RETURN
      ENDIF
      f1=x(offset+i)
      f2=x(offset+j)
      IF (f1.GT.f2) CALL Swap (f1,f2)
c
c -----   Enter the user chosen non-zero coefficients.  The data will
c      be fit only to these powers of the polynomial.
c
      WRITE (*,100)
100   FORMAT (' Enter the power of any coefficient that is to be ',
     *     'included in the fit.'/'          (^Z to finish)'//2X,
     *     'ex.  Best-fit to a cubic, enter'/5X,'0 1 2 3^Z'//)
      ma=0
      DO 3 j=1,ncoeff
        coeff(j,1)=zero
        coeff(j,2)=zero
        power(j)=1000
3     CONTINUE
      WRITE (*,'(1X,(A),$)') 'Power(s) : '
      READ (*,*,ERR=1000,END=4,IOSTAT=ierror) (power(k),k=1,ncoeff)
4     CONTINUE
      CALL PowerSort (power,k,ma,ncoeff)
      DO 6 j=1,maxnum
        xp=x(offset+i+j-1)
        DO 5 k=1,ma
          IF (xp.EQ.zero) THEN
            u(j,k)=zero
          ELSE
            u(j,k)=xp**power(k)
          ENDIF
5       CONTINUE
        ypoly(8*offset+j)=y(offset+i+j-1)
6     CONTINUE
      CALL SVDCMP (u,maxnum,ma,ncoeff,w,v)
      wmax=zero
      DO 7 j=1,ma
        wmax=MAX(wmax,w(j))
7     CONTINUE
      thresh=tol*wmax
      DO 8 j=1,ma
        IF (w(j).LT.thresh) w(j)=zero
8     CONTINUE
      CALL SVBKSB (u,w,v,maxnum,ma,ncoeff,ypoly,dataset,coeff,8*offset)
      CALL SVDVar (v,ma,ncoeff,w,coeff)
      maxply(dataset)=10*maxnum
      const=(f2-f1)/(maxply(dataset)-1)
      DO 9 j=1,maxply(dataset)
        xpoly(8*offset+j)=const*(j-1)+f1
        ypoly(8*offset+j)=FPoly(xpoly(8*offset+j),coeff,power,ma)
9     CONTINUE
      ok=.TRUE.
      WRITE (*,101)
101   FORMAT ('0The calculated coefficients are : '//)
      DO 10 i=1,ma,2
        IF (i+1.LE.ma) THEN
          WRITE (*,102) power(i),coeff(i,1),coeff(i,2),
     *         power(i+1),coeff(i+1,1),abs(coeff(i+1,2))
102       FORMAT (2(7X,'x^',I3,4X,E12.5,' +- ',E9.3))
        ELSE
          WRITE (*,103) power(i),coeff(i,1),abs(coeff(i,2))
103       FORMAT (7X,'x^',I3,4X,E12.5,' +- ',E9.3)
        ENDIF
10    CONTINUE
      WRITE (*,104)
104   FORMAT ('0Press <return> to continue ',$)
11    CONTINUE
      READ (*,'((A))') ans
      RETURN
c
c -----   Error checking/error flag resetting routine.
c
1000  CONTINUE
      IF (ierror.GT.0) CALL ERRTST (ierror,j)
      WRITE (*,105) 7,7,'***  Error in input - redo!  ***'
105   FORMAT ('0',2A1,(A))
      GOTO 3
      END
c
c-------------------------------------------------------------------------------
c
      OPTIONS /G_FLOATING
c
c -----   This was added to help reduce problems with large powers and x
c      very small or very large.
c
      FUNCTION FPoly (x,coeff,power,ma)
c
c -----   This calculates the polynomial at a point x.  If x=0, then the
c      polynomial is set to the constant, coeff(0), instead of to a
c      possible infinity.  This is needed by the routine PolynomialCalc.
c
      INTEGER    ncoeff,m,ma,i
      REAL*8     sum,zero,xp
      PARAMETER  (ncoeff=10)
      REAL       coeff(ncoeff,2),FPoly,x
      INTEGER    power(ncoeff)
c
      DATA  zero/0.0D0/
c
      xp=DBLE(x)
      IF (xp.NE.zero) THEN
        sum=zero
        DO 1 i=1,ma
          sum=sum+DBLE(coeff(i,1))*(xp**power(i))
1       CONTINUE
c
c -----   The following idiot-proofing is made to avoid over- and
c      underflows.  Of course, it could still happen in the previous
c      step if x is too large or too small.
c
        IF (sum.EQ.zero) THEN
          FPoly=0.0
        ELSE IF (DLOG10(DABS(sum)).GT.38) THEN
          FPoly=1.0E30
        ELSE IF (DLOG10(DABS(sum)).LT.-38) THEN
          FPoly=0.0
        ELSE
          FPoly=SNGL(sum)
        ENDIF
      ELSE
        m=0
2       CONTINUE
          m=m+1
          IF ((power(m).NE.0).AND.(m.LE.ma)) GOTO 2
        IF (m.GT.ma) THEN
          FPoly=0.0
        ELSE
          FPoly=coeff(m,1)
        ENDIF
      ENDIF
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE PowerSort (power,k,ma,ncoeff)
c
c -----   This routine is a simple insertion sort.  It sorts the vector
c      POWER into ascending order, counting the number of distinct powers
c      while eliminating any doubled powers.
c
      INTEGER  ncoeff,ma,i,j,k,power(ncoeff),ip
c
      DO 3 i=2,ncoeff
        ip=power(i)
        DO 1 j=i-1,1,-1
          IF (power(j).LE.ip) GOTO 2
          power(j+1)=power(j)
1       CONTINUE
        j=0
2       CONTINUE
        power(j+1)=ip
3     CONTINUE
      DO 6 i=1,ncoeff-1
        IF (power(i+1).EQ.1000) GOTO 7
4       CONTINUE
          IF (power(i).EQ.power(i+1)) THEN
            DO 5 j=i+1,ncoeff-1
              power(j)=power(j+1)
5           CONTINUE
            GOTO 4
          ENDIF
6     CONTINUE
7     CONTINUE
      ma=i
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      OPTIONS /G_FLOATING
c
      SUBROUTINE SVDCMP (a,m,n,np,w,v)
c
c -----   This subroutine is taken exactly from the book Numerical Recipes
c      by W.H. Press et al., and is used by the routine PolynomialCalc to
c      do the singular value decomposition (SVD) of the input data matrix.
c      The results of the SVD can have certain values zeroed to eliminate
c      them from the resultant coefficients.
c
      INTEGER    i,j,k,l,m,n,its,nm,maxpointset,np
      PARAMETER  (maxpointset=2000)
      REAL*8     a(maxpointset,np),w(np),v(np,np),rv1(maxpointset),
     *     x,y,z,h,c,s,f,g,scale,anorm,zero,one
c
      DATA  zero,one/0.0D0,1.0D0/
c
      g=zero
      scale=zero
      anorm=zero
      DO 25 i=1,n
        l=i+1
        rv1(i)=scale*g
        g=zero
        s=zero
        scale=zero
        IF (i.LE.m) THEN
          DO 11 k=i,m
            scale=scale+ABS(a(k,i))
11        CONTINUE
          IF (scale.NE.zero) THEN
            DO 12 k=i,m
              a(k,i)=a(k,i)/scale
              s=s+a(k,i)*a(k,i)
12          CONTINUE
            f=a(i,i)
            g=-SIGN(SQRT(s),f)
            h=f*g-s
            a(i,i)=f-g
            IF (i.NE.n) THEN
              DO 15 j=l,n
                s=zero
                DO 13 k=i,m
                  s=s+a(k,i)*a(k,j)
13              CONTINUE
                f=s/h
                DO 14 k=i,m
                  a(k,j)=a(k,j)+f*a(k,i)
14              CONTINUE
15            CONTINUE
            ENDIF
            DO 16 k=i,m
              a(k,i)=scale*a(k,i)
16          CONTINUE
          ENDIF
        ENDIF
        w(i)=scale*g
        g=zero
        s=zero
        scale=zero
        IF ((i.LE.m).AND.(i.NE.n)) THEN
          DO 17 k=l,n
            scale=scale+ABS(a(i,k))
17        CONTINUE
          IF (scale.NE.zero) THEN
            DO 18 k=l,n
              a(i,k)=a(i,k)/scale
              s=s+a(i,k)*a(i,k)
18          CONTINUE
            f=a(i,l)
            g=-SIGN(SQRT(s),f)
            h=f*g-s
            a(i,l)=f-g
            DO 19 k=l,n
              rv1(k)=a(i,k)/h
19          CONTINUE
            IF (i.NE.m) THEN
              DO 23 j=l,m
                s=zero
                DO 21 k=l,n
                  s=s+a(j,k)*a(i,k)
21              CONTINUE
                DO 22 k=l,n
                  a(j,k)=a(j,k)+s*rv1(k)
22              CONTINUE
23            CONTINUE
            ENDIF
            DO 24 k=l,n
              a(i,k)=scale*a(i,k)
24          CONTINUE
          ENDIF
        ENDIF
        anorm=MAX(anorm,(ABS(w(i))+ABS(rv1(i))))
25    CONTINUE
      DO 32 i=n,1,-1
        IF (i.LT.n) THEN
          IF (g.NE.zero) THEN
            DO 26 j=l,n
              v(j,i)=(a(i,j)/a(i,l))/g
26          CONTINUE
            DO 29 j=l,n
              s=zero
              DO 27 k=l,n
                s=s+a(i,k)*v(k,j)
27            CONTINUE
              DO 28 k=l,n
                v(k,j)=v(k,j)+s*v(k,i)
28            CONTINUE
29          CONTINUE
          ENDIF
          DO 31 j=l,n
            v(i,j)=zero
            v(j,i)=zero
31        CONTINUE
        ENDIF
        v(i,i)=one
        g=rv1(i)
        l=i
32    CONTINUE
      DO 39 i=n,1,-1
        l=i+1
        g=w(i)
        IF (i.LT.n) THEN
          DO 33 j=l,n
            a(i,j)=zero
33        CONTINUE
        ENDIF
        IF (g.NE.zero) THEN
          g=one/g
          IF (i.NE.n) THEN
            DO 36 j=l,n
              s=zero
              DO 34 k=l,m
                s=s+a(k,i)*a(k,j)
34            CONTINUE
              f=s*g/a(i,i)
              DO 35 k=i,m
                a(k,j)=a(k,j)+f*a(k,i)
35            CONTINUE
36          CONTINUE
          ENDIF
          DO 37 j=i,m
            a(j,i)=a(j,i)*g
37        CONTINUE
        ELSE
          DO 38 j=i,m
            a(j,i)=zero
38        CONTINUE
        ENDIF
        a(i,i)=a(i,i)+one
39    CONTINUE
      DO 49 k=n,1,-1
        DO 48 its=1,30
          DO 41 l=k,1,-1
            nm=l-1
            IF ((ABS(rv1(l))+anorm).EQ.anorm) GOTO 2
            IF ((ABS(w(nm))+anorm).EQ.anorm) GOTO 1
41        CONTINUE
1         c=zero
          s=one
          DO 43 i=l,k
            f=s*rv1(i)
            IF ((ABS(f)+anorm).NE.anorm) THEN
              g=w(i)
              h=SQRT(f*f+g*g)
              w(i)=h
              h=one/h
              c=g*h
              s=-f*h
              DO 42 j=1,m
                y=a(j,nm)
                z=a(j,i)
                a(j,nm)=y*c+z*s
                a(j,i)=-y*s+z*c
42            CONTINUE
            ENDIF
43        CONTINUE
2         z=w(k)
          IF (l.EQ.k) THEN
            IF (z.LT.zero) THEN
              w(k)=-z
              DO 44 j=1,n
                v(j,k)=-v(j,k)
44            CONTINUE
            ENDIF
            GOTO 3
          ENDIF
          IF (its.EQ.30) PAUSE 'No convergence in 30 iterations'
          x=w(l)
          nm=k-1
          y=w(nm)
          g=rv1(nm)
          h=rv1(k)
          f=((y-z)*(y+z)+(g-h)*(g+h))/(2.0*h*y)
          g=SQRT(f*f+one)
          f=((x-z)*(x+z)+h*(y/(f+SIGN(g,f))-h))/x
          c=one
          s=one
          DO 47 j=l,nm
            i=j+1
            g=rv1(i)
            y=w(i)
            h=s*g
            g=c*g
            z=SQRT(f*f+h*h)
            rv1(j)=z
            c=f/z
            s=h/z
            f=x*c+g*s
            g=-x*s+g*c
            h=y*s
            y=y*c
            DO 45 nm=1,n
              x=v(nm,j)
              z=v(nm,i)
              v(nm,j)=x*c+z*s
              v(nm,i)=-x*s+z*c
45          CONTINUE
            z=SQRT(f*f+h*h)
            w(j)=z
            IF (z.NE.zero) THEN
              z=one/z
              c=f*z
              s=h*z
            ENDIF
            f=c*g+s*y
            x=-s*g+c*y
            DO 46 nm=1,m
              y=a(nm,j)
              z=a(nm,i)
              a(nm,j)=y*c+z*s
              a(nm,i)=-y*s+z*c
46          CONTINUE
47        CONTINUE
          rv1(l)=zero
          rv1(k)=f
          w(k)=x
48      CONTINUE
3       CONTINUE
49    CONTINUE
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      OPTIONS /G_FLOATING
c
      SUBROUTINE SVBKSB (u,w,v,m,n,np,b,dataset,coeff,offset)
c
c -----   This subroutine is taken from the book Numerical Recipes by
c      W.H. Press et al., and is used by the routine PolynomialCalc to
c      calculate the final solution of the least-squares fit coefficients,
c      after negligible coefficients have been zeroed.
c
      INTEGER    i,j,n,m,np,jj,dataset,maxpointset,s2,maxdataset,
     *     maxpoints,offset
      PARAMETER  (maxpoints=20000,s2=8*maxpoints,maxdataset=30,
     *     maxpointset=2000)
      REAL*8     u(maxpointset,np),w(np),v(np,np),tmp(maxpointset),zero,
     *     s
      REAL       b(s2),coeff(np,2)
c
      DATA  zero/0.0D0/
c
      DO 2 j=1,n
        s=zero
        IF (w(j).NE.zero) THEN
          DO 1 i=1,m
            s=s+u(i,j)*b(offset+i)
1         CONTINUE
          s=s/w(j)
        ENDIF
        tmp(j)=s
2     CONTINUE
      DO 4 j=1,n
        s=zero
        DO 3 jj=1,n
          s=s+v(j,jj)*tmp(jj)
3       CONTINUE
        coeff(j,1)=s
4     CONTINUE
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      OPTIONS /G_FLOATING
c
      SUBROUTINE SVDVar (v,m,np,w,stdev)
c
c -----   A subroutine taken from the book Numerical Recipes by W.H. Press
c      et al., required by the routine PolynomialCalc to obtain standard
c      deviations of the least-squares fit coefficients.
c
      INTEGER    i,m,np,k,ncoeff
      PARAMETER  (ncoeff=10)
      REAL*8     v(np,np),w(np),wti(ncoeff),zero,sum
      REAL       stdev(np,2)
c
      DATA  zero/0.0D0/
c
      DO 1 i=1,m
        wti(i)=zero
        IF (w(i).NE.zero) wti(i)=1.0/w(i)/w(i)
1     CONTINUE
      DO 3 i=1,m
        sum=zero
        DO 2 k=1,m
          sum=sum+v(i,k)*v(i,k)*wti(k)
2       CONTINUE
        stdev(i,2)=SQRT(sum)
3     CONTINUE
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE FourierCalc (offset,numpt,f1,f2,dataset,ok)
c
c -----   Calculate the Fourier transform smoothed data from x-coordinate
c      F1 to F2.  The method is paraphrased from the book Numerical Recipes
c      by W.H. Press et al.  The extra size for YFOUR is due to zero padding
c      out to the next largest power of 2.  For larger values for the number
c      of smoothing points (PTS), the resultant curve will become less
c      featureless as more high frequency 'noise' is removed.
c
      INTEGER    dataset,i,j,k,m,nmin,maxpoints,maxdataset,offset,
     *     numpt,maxnum,ierror,maxpointset
      PARAMETER  (maxpoints=20000,maxpointset=2000,maxdataset=30)
      INTEGER    maxfr(maxdataset)
      REAL       x(maxpoints),y(maxpoints),xfr(maxpoints),
     *     yfr(maxpoints),zero,one,pts,f1,f2,rn1,const,window,yn,y1,
     *     yfour(4*maxpointset)
      LOGICAL    ok
c
      COMMON  /XYDat/x,y,/FrDat/xfr,yfr,maxfr
c
      DATA    zero,one/0.0,1.0/
c
      ok=.FALSE.
      i=0
1     CONTINUE
        i=i+1
      IF (x(offset+i).LT.f1) GOTO 1
      j=i
2     CONTINUE
      IF (j+1.LE.numpt.AND.x(offset+j+1).LE.f2) THEN
        j=j+1
        GOTO 2
      ENDIF
      maxnum=j-i+1
      maxfr(dataset)=maxnum
      IF (maxnum.LT.2) THEN
        WRITE (*,'(1X,A1,(A),(A))') 7,'Error in Fourier Calculation',
     *       ' routine!'
        RETURN
      ENDIF
      f1=x(offset+i)
      f2=x(offset+j)
      IF (f1.GT.f2) CALL Swap (f1,f2)
      DO 3 k=0,maxnum-1
        yfour(2*k+1)=y(offset+i+k)
        yfour(2*k+2)=zero
        xfr(offset+k+1)=x(offset+i+k)
3     CONTINUE
      WRITE (*,'(''0'',(A),I4,(A),I3,(A),$)') 'Number of smoothing '//
     *     'points to use [ n <',maxnum,' - ',maxnum/10,' is good ]: '
      READ (*,*,ERR=1000,IOSTAT=ierror) pts
      IF (pts.GE.maxnum) THEN
        WRITE (*,'(1X,A1,(A),(A),I3)') 7,'Error in input - number of ',
     *       'points must be less than ',maxnum
        GOTO 3
      ENDIF
      nmin=maxnum+2.0*pts
      m=2
4     IF (m.LE.nmin) THEN
        m=2*m
        GOTO 4
      ENDIF
      const=pts/m*pts/m
      y1=yfour(1)
      yn=yfour(2*maxnum-1)
      rn1=one/(maxnum-one)
      DO 5 j=1,maxnum
        yfour(2*j-1)=yfour(2*j-1)-rn1*(y1*(maxnum-j)+yn*(j-1))
5     CONTINUE
      DO 6 j=2*maxnum+1,2*m
        yfour(j)=zero
6     CONTINUE
      CALL Four1 (yfour,2*m,1)
c
c -----   The FFT is multiplied by a low band pass filter of characteristic
c      size PTS.  PTS > 2 will eliminate some high frequencies completely.
c
      DO 7 j=1,m/2-1
        window=AMAX1(zero,one-const*j*j)
        k=2*j+1
        yfour(k)=yfour(k)*window
        yfour(k+1)=yfour(k+1)*window
        k=2*(m-j)+1
        yfour(k)=yfour(k)*window
        yfour(k+1)=yfour(k+1)*window
7     CONTINUE
      yfour(m+1)=zero
      yfour(m+2)=zero
      CALL Four1 (yfour,2*m,-1)
      DO 8 j=1,maxnum
        yfr(offset+j)=yfour(2*j-1)/m+rn1*(y1*(maxnum-j)+yn*(j-1))
8     CONTINUE
      ok=.TRUE.
      RETURN
c
c -----   Error checking/error flag resetting routine.
c
1000  CONTINUE
      IF (ierror.GT.0) CALL ERRTST (ierror,j)
      WRITE (*,100) 7,7,'***  Error in input - redo!  ***'
100   FORMAT ('0',2A1,(A))
      GOTO 3
      END
c
c-------------------------------------------------------------------------------
c
      OPTIONS /G_FLOATING
c
      SUBROUTINE Four1 (data,nn,isign)
c
c -----   A FFT subroutine needed for the subroutine FourierCalc.  This
c      routine is taken exactly from the book Numerical Recipes by
c      W.H. Press et al.
c
      REAL*8     wr,wi,wpr,wpi,wtemp,theta,twopi,two
      INTEGER    nn,isign,j,n,i,istep,mmax,m
      REAL       data(nn),tempi,tempr
c
      DATA  two,twopi/2.0D0,6.28318530717958647692D0/
c
      n=nn
      j=1
      DO 2 i=1,n,2
        IF (j.GT.i) THEN
          tempr=data(j)
          tempi=data(j+1)
          data(j)=data(i)
          data(j+1)=data(i+1)
          data(i)=tempr
          data(i+1)=tempi
        ENDIF
        m=n/2
1       IF ((m.ge.2).AND.(j.GT.m)) THEN
          j=j-m
          m=m/2
          GOTO 1
        ENDIF
        j=j+m
2     CONTINUE
      mmax=2
3     IF (n.GT.mmax) THEN
        istep=2*mmax
        theta=twopi*isign*mmax
        wpr=-two*DSIN(theta/two)**2
        wpi=DSIN(theta)
        wr=1.0D0
        wi=0.0D0
        DO 5 m=1,mmax,2
          DO 4 i=m,n,istep
            j=i+mmax
            tempr=SNGL(wr)*data(j)-SNGL(wi)*data(j+1)
            tempi=SNGL(wr)*data(j+1)+SNGL(wi)*data(j)
            data(j)=data(i)-tempr
            data(j+1)=data(i+1)-tempi
            data(i)=data(i)+tempr
            data(i+1)=data(i+1)+tempi
4         CONTINUE
          wtemp=wr
          wr=wr*wpr-wi*wpi+wr
          wi=wi*wpr+wtemp*wpi+wi
5       CONTINUE
        mmax=istep
      GOTO 3
      ENDIF
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE SplineCalc (offset,numpt,f1,f2,dataset,ok)
c
c -----   Calculates the cubic spline fit from x-coordinates F1 to F2.
c      The routine algorithm is derived from Borland's TURBO Graphix
c      Toolbox along with the equations given in Numerical Recipes by
c      W.H. Press et al.
c
      INTEGER    dataset,n,j,i,k,maxpoints,s2,maxdataset,offset,numpt,
     *     maxnum,maxpointset
      PARAMETER  (maxpoints=20000,s2=8*maxpoints,maxdataset=30,
     *     maxpointset=2000)
      INTEGER    maxspl(maxdataset)
      REAL       x(maxpoints),y(maxpoints),xp(maxpointset),Spline2,
     *     yp(maxpointset),y2prime(maxpoints),xspl(s2),yspl(s2),f1,f2,
     *     deltax
      LOGICAL    ok
c
      COMMON  /XYDat/x,y,/SplDat/xspl,yspl,maxspl
c
      ok=.TRUE.
      i=0
1     CONTINUE
        i=i+1
      IF (x(offset+i).LT.f1) GOTO 1
      j=i
2     CONTINUE
      IF (j+1.LE.numpt.AND.x(offset+j+1).LE.f2) THEN
        j=j+1
        GOTO 2
      ENDIF
      n=j-i+1
      IF (n.LT.2) THEN
        WRITE (*,'(1X,A1,(A))') 7,'Error in Spline Calculation routine!'
        ok=.FALSE.
        RETURN
      ENDIF
      f1=x(offset+i)
      f2=x(offset+j)
      IF (f1.GT.f2) CALL Swap (f1,f2)
      maxnum=8*n
      maxspl(dataset)=maxnum
      DO 3 k=1,n
        xp(k)=x(offset+i+k-1)
        yp(k)=y(offset+i+k-1)
3     CONTINUE
      CALL Spline1 (xp,yp,y2prime,n)
      deltax=(f2-f1)/(maxnum-1)
      DO 4 k=1,maxnum-1
        xspl(8*offset+k)=f1+(k-1)*deltax
4     CONTINUE
      xspl(8*offset+maxnum)=f2
      DO 5 k=1,maxnum
        yspl(8*offset+k)=Spline2(xspl(8*offset+k),xp,yp,y2prime,n)
5     CONTINUE
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      OPTIONS /G_FLOATING
c
      SUBROUTINE Spline1 (x,y,y2prime,n)
c
c -----   A subroutine needed for the cubic spline calculations.  It is
c      an algorithm derived from the cubic spline equations given in
c      Numerical Recipes by W.H. Press et al.  The boundary condition
c      of zero first derivative at the endpoints is assumed here.
c
      INTEGER    n,i,maxpointset
      PARAMETER  (maxpointset=2000)
      REAL       x(n),y(n),y2prime(n)
      REAL*8     a(2:maxpointset),b(2:maxpointset-1),dummy(maxpointset)
c
      a(2)=DBLE(x(2))-x(1)
      a(3)=DBLE(x(3))-x(2)
      b(2)=2.0D0*(DBLE(x(3))-x(1))+a(2)/2.0D0
      dummy(2)=6.0D0*(DBLE(y(3))-y(2))/a(3)-3.0D0*(DBLE(y(2))-y(1))/a(2)
      DO 1 i=3,n-1
        a(i+1)=DBLE(x(i+1))-x(i)
        b(i)=2.0D0*(DBLE(x(i+1))-x(i-1))-a(i)*a(i)/b(i-1)
        dummy(i)=6.0D0*((DBLE(y(i+1))-y(i))/a(i+1)-
     *     (DBLE(y(i))-y(i-1))/a(i))-a(i)*dummy(i-1)/b(i-1)
1     CONTINUE
      dummy(n)=(dummy(n-1)/b(n-1)-6.0D0*(DBLE(y(n))-y(n-1))/a(n)/a(n))/
     *         (2.0D0+a(n)/b(n-1))
      DO 2 i=n-1,2,-1
        dummy(i)=(dummy(i)-a(i+1)*dummy(i+1))/b(i)
2     CONTINUE
      dummy(1)=dummy(2)*0.5D0-3.0D0*(DBLE(y(2))-y(1))/a(2)/a(2)
      DO 3 i=1,n
        y2prime(i)=SNGL(dummy(i))
3     CONTINUE
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      OPTIONS /G_FLOATING
c
      FUNCTION Spline2 (x,xp,yp,y2prime,n)
c
c -----   A subroutine needed for the cubic spline calculations.  It is
c      an algorithm derived from the eqautions given in Numerical Recipes
c      by W.H. Press et al.
c
      INTEGER  n,j
      REAL     xp(n),yp(n),y2prime(n),x,Spline2
      REAL*8   dx,a,b,c,d
c
      IF (x.LE.xp(1)) THEN
        Spline2=yp(1)
      ELSE IF (x.GE.xp(n)) THEN
        Spline2=yp(n)
      ELSE
        j=1
1       CONTINUE
        IF ((x.GT.xp(j)).AND.(x.LE.xp(j+1))) GOTO 2
          j=j+1
          GOTO 1
2       CONTINUE
        dx=DBLE(xp(j+1))-xp(j)
        a=(DBLE(xp(j+1))-x)/dx
        b=1.0D0-a
        c=(a*a*a-a)*dx*dx/6.0D0
        d=(b*b*b-b)*dx*dx/6.0D0
        Spline2=a*yp(j)+b*yp(j+1)+c*y2prime(j)+d*y2prime(j+1)
      ENDIF
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE ReadData (dataset,xstart,x1,y1,x2,y2,fileopen,
     *     totalpoints)
c
c -----   This subroutine reads in all data files, sets the plotting limits,
c     and counts the number of points read in.  ReadData asks if more data is
c     to be read from the current open data file.  If not, it will prompt for
c     a filename until a correct one is entered.  ReadData then prompts for the
c     number of lines to skip from the current position in the file,
c     where N >= 0 simply skips that number of lines and reads the data,
c           N = -1 reads a line, prints it, and confirms the skip,
c           N < -1 skips ABS(N) lines and prompts again for lines to skip,
c           'Bn' backs up n line(s) (not case-sensitive!).
c     Finally, the data is read in, after prompting for the columns for the
c     (x,y) input.  Up to 25 columns are accessible from a single data file.
c     A data set ends when a non-numeric line is run into, or the file ends.
c
      INTEGER    maxpoints,maxdataset,dataset,ierror,i,j,xcol,ycol,
     *     lineskip,totalpoints,maxcolumn,ii,offset,maxcol,maxpointset,
     *     linesread,StrLen
      PARAMETER  (maxpoints=20000,maxdataset=30,maxpointset=2000,
     *     maxcolumn=25)
      REAL       xdata(maxpointset),ydata(maxpointset),x(maxpoints),
     *     y(maxpoints),x1,x2,y1,y2,one,zero,data(maxcolumn),
     *     xminmax(2,maxdataset),yminmax(2,maxdataset)
      INTEGER    xstart(maxdataset,2)
      CHARACTER  fname*40,blank*40,ans*1,linein*500,UpCase*1,longans*6
      LOGICAL    fileopen
c
      DATA    blank/'                                        '/
      DATA    zero,one/0.0,1.0/
      SAVE    fname,linesread
      COMMON  /XYDat/x,y,xdata,ydata,xminmax,yminmax
c
1     CONTINUE
      IF (fileopen) THEN
        WRITE (*,*)
        WRITE (*,98) 'More data from the same file [y] ? '
        READ (*,97) ans
        IF (UpCase(ans).EQ.'N') THEN
          CLOSE (10)
          fileopen=.FALSE.
          linesread=0
        ENDIF
      ENDIF
      IF (.NOT.fileopen) THEN
        WRITE (*,*)
        WRITE (*,98) 'Input the full name of the data file '//
     *       '(^Z to quit): '
2       CONTINUE
        fname=blank
        READ (*,97,END=11) fname
        OPEN (UNIT=10,FILE=fname,STATUS='old',IOSTAT=ierror)
        IF (ierror.NE.0) THEN
          WRITE (*,'(A1,A20,(A))') 7,' Error opening file ',fname
          WRITE (*,*)
          WRITE (*,98) 'Input the correct data file name: '
          GOTO 2
        ENDIF
        fileopen=.TRUE.
        linesread=0
      ENDIF
      ii=1
3     CONTINUE
      WRITE (*,300)
300   FORMAT ('0Skip n lines before data is read'/,'  (n=-1, show ',
     *     'each line and confirm skip  --  n<-1, skip ABS(n) lines ',
     *     'and prompt)'/,'  (Bn, go backwards n lines and prompt --',
     *     ' otherwise skip n lines and continue on)')
      WRITE (*,98) 'Skip how many lines ? '
      READ (*,97) longans
      ans=UpCase(longans(1:1))
      IF (ans.EQ.'B') THEN
        READ (longans(2:6),*,ERR=1000,END=33,IOSTAT=ierror) lineskip
        IF (lineskip.LE.1) lineskip=1
33      CONTINUE
        REWIND (10,ERR=3)
        linesread=MAX(linesread-lineskip-1,0)
        DO 34 i=1,linesread
          READ (10,*)
34      CONTINUE
        GOTO 3
      ELSE
        IF (ans.EQ.' ') GOTO 3
        READ (longans,*,ERR=1000,IOSTAT=ierror) lineskip
      ENDIF
      IF (lineskip.EQ.-1) THEN
4       CONTINUE
        READ (10,97,END=55) linein
        linesread=linesread+1
        WRITE (*,*) linein(1:StrLen(linein))
        WRITE (*,98) 'Skip line (Bn = n lines backwards)  [y] ? '
        READ (*,97) longans
        ans=UpCase(longans)
        IF (ans.EQ.'B') THEN
          READ (longans(2:6),*,ERR=465,END=465,IOSTAT=ierror) lineskip
          IF (lineskip.LE.1) lineskip=1
465       CONTINUE
          IF (ierror.GT.0) CALL ERRTST (ierror,j)
          linesread=MAX(linesread-lineskip-1,0)
          REWIND (10)
          DO 47 i=1,linesread
            READ (10,*)
47        CONTINUE
48        CONTINUE
          GOTO 4
        ENDIF
        IF (ans.NE.'N') GOTO 4
        BACKSPACE 10
        linesread=linesread-1
      ELSE
        DO 5 i=1,ABS(lineskip)
          READ (10,*,END=55)
5       CONTINUE
        linesread=linesread+ABS(lineskip)
        IF (lineskip.LT.0) GOTO 3
        GOTO 6
55      CONTINUE
        i=0
        GOTO 8
      ENDIF
6     CONTINUE
      ii=2
      WRITE (*,*)
      WRITE (*,98) 'Choose the columns for the x,y data (1 - 25): '
      READ (*,*,ERR=1000,IOSTAT=ierror) xcol,ycol
      maxcol=MAX(xcol,ycol)
      IF ((maxcol.GT.maxcolumn).OR.(xcol.EQ.ycol)) GOTO 6
      ii=3
      DO 7 i=1,MIN(maxpoints-totalpoints,maxpointset)
        linesread=linesread+1
        READ (10,97,ERR=1000,END=8,IOSTAT=ierror) linein
        READ (linein,*,ERR=1000,END=65,IOSTAT=ierror)
     *       (data(j),j=1,maxcol)
        xdata(i)=data(xcol)
        ydata(i)=data(ycol)
        GOTO 7
65      CONTINUE
        WRITE (*,96) 7,7,'***  ERROR  -  Incorrect number of '//
     *       'columns  -  Re-enter requested columns  ***'
        IF (i.EQ.1) GOTO 66
        WRITE (*,*) 'Input line number: ',linesread
        WRITE (*,*) linein
        WRITE (*,98) 'Ignore error - continue on  [n] ?: '
        READ (*,97) ans
        IF (UpCase(ans).EQ.'Y') GOTO 7
66      CONTINUE
        BACKSPACE (10)
        linesread=linesread-1
        GOTO 6
7     CONTINUE
8     CONTINUE
      CLOSE (10)
      fileopen=.FALSE.
      linesread=0
9     CONTINUE
c
c -----   General initialization routines
c
      IF (i-1.LE.0) THEN
        WRITE (*,96) 7,7,'*** ERROR  -  No points read from data '//
     *       'file  ***'
        GOTO 1
      ENDIF
      dataset=dataset+1
      IF (dataset.EQ.1) THEN
        xstart(dataset,1)=1
      ELSE
        xstart(dataset,1)=xstart(dataset-1,1)+xstart(dataset-1,2)
      ENDIF
      xstart(dataset,2)=i-1
      totalpoints=totalpoints+i-1
      WRITE (*,*) i-1,' data points read'
      xminmax(1,dataset)=1E35
      xminmax(2,dataset)=-1E35
      yminmax(1,dataset)=1E35
      yminmax(2,dataset)=-1E35
      offset=xstart(dataset,1)-1
      DO 10 i=1,xstart(dataset,2)
        x(i+offset)=xdata(i)
        xminmax(1,dataset)=MIN(xminmax(1,dataset),xdata(i))
        xminmax(2,dataset)=MAX(xminmax(2,dataset),xdata(i))
        x1=MIN(x1,xdata(i))
        x2=MAX(x2,xdata(i))
        y(i+offset)=ydata(i)
        yminmax(1,dataset)=MIN(yminmax(1,dataset),ydata(i))
        yminmax(2,dataset)=MAX(yminmax(2,dataset),ydata(i))
        y1=MIN(y1,ydata(i))
        y2=MAX(y2,ydata(i))
10    CONTINUE
      CALL SetLimits (x1,x2)
      CALL SetLimits (y1,y2)
11    CONTINUE
      IF (.NOT.fileopen) WRITE (*,96) 7,7,'***  No more data in '
     *     //fname(1:StrLen(fname))//' - file is closed  ***'
      IF (dataset.NE.0) RETURN
      WRITE (*,98) 'No datasets have been entered.  Try [a]gain or'//
     *     ' [s]top  [A]: '
      READ (*,97) ans
      IF (UpCase(ans).NE.'S') GOTO 1
      STOP
96    FORMAT ('0',2A1,(A))
97    FORMAT ((A))
98    FORMAT (1X,(A),$)
c
c -----   Error checking/error flag resetting routine.
c
1000  CONTINUE
      IF (ierror.GT.0) CALL ERRTST (ierror,j)
      IF (ii.EQ.3) THEN
        GOTO 9
      ELSE
        WRITE (*,97) 7,7,'***  Error in input - redo!  ***'
        GOTO (3,6),ii
      ENDIF
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE SetLimits (lo,hi)
c
c -----   This subroutine sets the X-Y plotting limits anytime that new
c     data is input or logs/antilogs are calculated from the data.  It
c     is meant to be accurate to 2 significant figures.
c
      REAL       oldlo,oldhi,lo,hi,flo,fhi,zero,one,loglo,loghi,
     *     mantlo,manthi
      INTEGER    ordlo,ordhi
      LOGICAL    neglo,neghi
c
      DATA  zero/0.0/,one/1.0/
c
      oldlo=lo
      oldhi=hi
      neglo=(oldlo.LT.zero)
      neghi=(oldhi.LT.zero)
      loglo=zero
      loghi=zero
      IF (oldlo.NE.zero) THEN
        loglo=LOG10(ABS(oldlo))
        ordlo=INT(loglo)
        mantlo=loglo-ordlo+one
        IF (mantlo.LT.one) THEN
          mantlo=mantlo+one
          ordlo=ordlo-one
        ENDIF
        flo=10.0**mantlo
        IF (ABS(flo-NINT(flo)).GT.0.1) THEN
          flo=INT(flo)
          IF (neglo) flo=flo+one
        ENDIF
        lo=SIGN(flo*10.0**(ordlo-1),lo)
      ENDIF
      IF (oldhi.NE.zero) THEN
        loghi=LOG10(ABS(oldhi))
        ordhi=INT(loghi)
        manthi=loghi-ordhi+one
        IF (manthi.LT.one) THEN
          manthi=manthi+one
          ordhi=ordhi-one
        ENDIF
        fhi=10.0**manthi
        IF (ABS(fhi-NINT(fhi)).GT.0.1) THEN
          fhi=INT(fhi)
          IF (.NOT.neghi) fhi=fhi+one
        ENDIF
        hi=SIGN(fhi*10.0**(ordhi-1),hi)
      ENDIF
      IF ((loglo-loghi.GE.2.0).AND.(oldlo.NE.zero)) THEN
        hi=zero
      ELSE IF ((loghi-loglo.GE.2.0).AND.(oldhi.NE.zero)) THEN
        lo=zero
      ENDIF
      IF (ABS(lo-hi).LT.1.E-4*lo) THEN
        lo=lo*.999
        hi=hi*1.001
      ENDIF
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE Swap (f1,f2)
c
c -----     Swaps the values F1 and F2.
c
      REAL  f1,f2,temp
c
      temp=f1
      f1=f2
      f2=temp
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE ScaleDataSet (x1,x2,y1,y2,fits,xstart,dataset)
c
c -----   Slide/Expand/Difference the chosen data sets.  This only acts on
c     the raw data, NOT on the various possible fits.  The fits are turned
c     off for the data set affected.
c
      INTEGER    maxpoints,maxpointset,maxdataset,ii,i,ChooseDataSet,
     *     offset,cdataset,dataset,ierror,m,ds1,ds2,start1,start2,
     *     finish1,finish2,less,more,point
      PARAMETER  (maxpoints=20000,maxdataset=30,maxpointset=2000)
      REAL       x(maxpoints),y(maxpoints),xdata(maxpointset),
     *     ydata(maxpointset),xminmax(2,maxdataset),x1,x2,y1,y2,
     *     yminmax(2,maxdataset),r1,r2,r3,r4,slide,scale,diff,value
      INTEGER    xstart(maxdataset,2)
      CHARACTER  dset*2,UpCase*1,ans*2
      LOGICAL    ok,fits(5,maxdataset),f,add
c
      DATA  f/.FALSE./
c
      COMMON  /XYDat/x,y,xdata,ydata,xminmax,yminmax
c
1     CONTINUE
      WRITE (*,100)
100   FORMAT ('0Choose one of the following actions:'//10X,'[S]lide ',
     *     'a data set'/10X,'[E]xpand/shrink a data set'/10X,
     *     '[A]dd/subtract one data set from another'/10X,
     *     '[Q]uit and return to main menu'//' Choice  [q]: ',$)
      READ (*,97) ans
      IF (UpCase(ans).EQ.'S') GOTO 10
      IF (UpCase(ans).EQ.'E') GOTO 20
      IF (UpCase(ans).EQ.'A') GOTO 30
      RETURN
c
c -----   Slide the data set up/down and/or left/right
c
10    CONTINUE
      WRITE (*,'((A),I2)') '0Slide which dataset : 1 - ',dataset
      WRITE (*,98) '     0 to quit,  <ENTER> = current dataset: '
      READ (*,97,END=1) dset
      IF (dset(1:1).EQ.'0') GOTO 1
      cdataset=ChooseDataSet(dset,dataset,ok)
      IF (.NOT.ok) GOTO 10
      IF ((cdataset.GT.dataset).OR.(cdataset.LT.1)) THEN
        WRITE (*,99) 7,7,'Error in input.  Reenter data set number'
        GOTO 10
      ENDIF
      offset=xstart(cdataset,1)-1
      WRITE (*,*)
      WRITE (*,98) 'Do you wish to slide the data set horzontally  '//
     *     '[n]  ? '
      READ (*,97,END=1) ans
      IF (UpCase(ans).EQ.'Y') THEN
        WRITE (*,10000) xminmax(1,cdataset),xminmax(2,cdataset),x1,x2
        ii=1
12      CONTINUE
        WRITE (*,98) 'Enter the amount to slide (+ve = right, -ve'//
     *       ' = left): '
        READ (*,*,ERR=1000,IOSTAT=ierror,END=1) slide
        DO 13 i=1,xstart(cdataset,2)
          x(offset+i)=x(offset+i)+slide
13      CONTINUE
        xminmax(1,cdataset)=xminmax(1,cdataset)+slide
        xminmax(2,cdataset)=xminmax(2,cdataset)+slide
        DO 14 i=2,5
          fits(i,cdataset)=f
14      CONTINUE
      ENDIF
      WRITE (*,*)
      WRITE (*,98) 'Do you wish to slide the data set vertically  '//
     *     '[n]  ? '
      READ (*,97,END=1) ans
      IF (UpCase(ans).EQ.'Y') THEN
        WRITE (*,10001) yminmax(1,cdataset),yminmax(2,cdataset),y1,y2
        ii=2
15      CONTINUE
        WRITE (*,98) 'Enter the amount to slide (+ve = up, -ve'//
     *       ' = down): '
        READ (*,*,ERR=1000,IOSTAT=ierror,END=1) slide
        DO 16 i=1,xstart(cdataset,2)
          y(offset+i)=y(offset+i)+slide
16      CONTINUE
        yminmax(1,cdataset)=yminmax(1,cdataset)+slide
        yminmax(2,cdataset)=yminmax(2,cdataset)+slide
        DO 17 i=2,5
          fits(i,cdataset)=f
17      CONTINUE
      ENDIF
      GOTO 10
c
c -----   Expand/contract the data set in the x/y directions
c
20    CONTINUE
      WRITE (*,'((A),I2)') '0Scale which dataset : 1 - ',dataset
      WRITE (*,98) '     0 to quit,  <ENTER> = current dataset: '
      READ (*,97,END=1) dset
      IF (dset(1:1).EQ.'0') GOTO 1
      cdataset=ChooseDataSet(dset,dataset,ok)
      IF (.NOT.ok) GOTO 20
      IF ((cdataset.GT.dataset).OR.(cdataset.LT.1)) THEN
        WRITE (*,99) 7,7,'Error in input.  Reenter data set number'
        GOTO 20
      ENDIF
      offset=xstart(cdataset,1)-1
      WRITE (*,*)
      WRITE (*,98) 'Do you wish to scale the X range  [n]  ? '
      READ (*,97,END=1) ans
      IF (UpCase(ans).EQ.'Y') THEN
        WRITE (*,10000) xminmax(1,cdataset),xminmax(2,cdataset),x1,x2
        WRITE (*,10002)
        ii=3
21      CONTINUE
        WRITE (*,98) 'Conversion: '
        READ (*,*,ERR=1000,IOSTAT=ierror,END=1) r1,r2,r3,r4
        IF ((r1.EQ.r2).OR.(r3.EQ.r4)) GOTO 1000
        scale=(r4-r3)/(r2-r1)
        DO 22 i=1,xstart(cdataset,2)
          x(offset+i)=x(offset+i)*scale
22      CONTINUE
        xminmax(1,cdataset)=xminmax(1,cdataset)*scale
        xminmax(2,cdataset)=xminmax(2,cdataset)*scale
        DO 23 i=2,5
          fits(i,cdataset)=f
23      CONTINUE
      ENDIF
      WRITE (*,*)
      WRITE (*,98) 'Do you wish to scale the Y range  [n]  ? '
      READ (*,97,END=1) ans
      IF (UpCase(ans).EQ.'Y') THEN
        WRITE (*,10001) yminmax(1,cdataset),yminmax(2,cdataset),y1,y2
        WRITE (*,10002)
        ii=4
24      CONTINUE
        WRITE (*,98) 'Conversion: '
        READ (*,*,ERR=1000,IOSTAT=ierror,END=1) r1,r2,r3,r4
        IF ((r1.EQ.r2).OR.(r3.EQ.r4)) GOTO 1000
        scale=(r4-r3)/(r2-r1)
        DO 25 i=1,xstart(cdataset,2)
          y(offset+i)=y(offset+i)*scale
25      CONTINUE
        yminmax(1,cdataset)=yminmax(1,cdataset)*scale
        yminmax(2,cdataset)=yminmax(2,cdataset)*scale
        DO 26 i=2,5
          fits(i,cdataset)=f
26      CONTINUE
      ENDIF
      GOTO 20
c
c -----   Subtract/add one data set from/to another
c
30    CONTINUE
      WRITE (*,*)
      WRITE (*,98) '[A]dd, [S]ubtract, or [Q]uit  [q]: '
      READ (*,97,END=1) ans
      IF (ans.EQ.'qq') RETURN
      ans=UpCase(ans)
      IF (ans.EQ.'Q') GOTO 1
      add=(ans.EQ.'A')
      ii=5
31    CONTINUE
      WRITE (*,3100) dataset
3100  FORMAT (' Enter the dataset numbers (first +- second = newfirst)',
     *     '  [ 1 - ',I<INT(LOG10(FLOAT(dataset)))+1>,']: ',$)
      READ (*,*,ERR=1000,IOSTAT=ierror,END=1) ds1,ds2
      IF ((ds1.GT.dataset).OR.(ds2.GT.dataset).OR.(ds1.LT.1).OR.
     *     (ds2.LT.1).OR.(ds1.EQ.ds2)) GOTO 1000
      start1=xstart(ds1,1)
      start2=xstart(ds2,1)
      finish1=start1-1+xstart(ds1,2)
      finish2=start2-1+xstart(ds2,2)
32    CONTINUE
      IF (x(start1).LT.x(start2)) THEN
        start1=start1+1
        IF (start1.GT.finish1) GOTO 37
        GOTO 32
      ENDIF
33    CONTINUE
      IF (x(finish1).GT.x(finish2)) THEN
        finish1=finish1-1
        IF (start1.GT.finish1) GOTO 37
        GOTO 33
      ENDIF
c
c -----   Now, data set 1 is bracketed inside data set 2.  A linear
c     interpolation is used between two points from data set 2 to
c     correspond to the point in question from data set 1.
c
      more=start2+1
      DO 35 point=start1,finish1
34      CONTINUE
        IF (x(more).LT.x(point)) THEN
          more=more+1
          IF (more.GT.finish2) GOTO 38
          GOTO 34
        ENDIF
        less=more-1
        diff=x(more)-x(less)
        value=y(more)
        IF (diff.GT.0.0) value=value-(value-y(less))*(x(more)-x(point))/
     *       diff
        IF (add) value=-value
        y(point)=y(point)-value
35    CONTINUE
      DO 36 i=2,5
        fits(i,ds1)=f
36    CONTINUE
      GOTO 30
37    CONTINUE
      WRITE (*,'(''0'',2A1,(A),I3,A2,I3,(A))') 7,7,
     *     '***  Error.  Datasets',ds1,',',ds2,' do not overlap.  ***'
      GOTO 30
c
c -----   Should never actually get here
c
38    CONTINUE
      WRITE (*,99) 7,7,'***  Program error in adding/subtracting.  ***'
      GOTO 30
c
c -----   Error checking/error flag resetting routine
c
1000  CONTINUE
      WRITE (*,99) 7,7,'***  Error in input - redo!  ***'
      IF (ierror.GT.0) CALL ERRTST (ierror,m)
      GOTO (12,15,21,24,31),ii
97    FORMAT ((A))
98    FORMAT (1X,(A),$)
99    FORMAT ('0',2(A1),(A))
10000 FORMAT ('0Range of x-coordinate for this dataset is [ ',E10.3,
     *     ' to ',E10.3,' ]'/' Current plotting range of x-coordinate',
     *     ' is [ ',E10.3,' to ',E10.3,' ]'/)
10001 FORMAT ('0Range of y-coordinate for this dataset is [ ',E10.3,
     *     ' to ',E10.3,' ]'/' Current plotting range of y-coordinate',
     *     ' is [ ',E10.3,' to ',E10.3,' ]'/)
10002 FORMAT ('0Enter the value to be scaled by specifying a range ',
     *     'conversion:'//3X,'ex.  0 1 0 35.7'/8X,'converts the ',
     *     'old range from 0 to 1 to a new range from 0 to 35.7'/)
      END
c
c-------------------------------------------------------------------------------
c
c      SUBROUTINE Description
cc
cc -----   A short description of the programme CurveFit
cc
c      CHARACTER  ans*1
cc
c      WRITE (*,100)
c100   FORMAT ('0',32X,'CurveFit'//7X,'A general curve fitting routin',
c     *    'e with graphics for systems with PGPlot.'//5X,
c     *    'CurveFit will plot up to 30 data sets of up to 2000 points',
c     *    ' each,'/1X,'(to a maximum of 20000 points), saved as (xp,',
c     *    'yp) in ascending {xp}'/1X,'order.  It can also modify the ',
c     *    'data set, by flipping the x and/or y'/1X,
c     *    'axes, taking logarithms of any x and/or y data, and/or ',
c     *    'scaling any'/1X,'data set in the x and/or y directions.'//5X,
c     *    'In addition, CurveFit allows one to fit ',
c     *    'various types of curves to'/1X,'the data sets.  These ',
c     *    'include:'/7X,'(a)  straight line (connect the dots)'/7X,
c     *    '(b)  cubic spline'/7X,'(c)  smoothing (Bezier) polynomial',
c     *    /7X,'(d)  low-pass Fourier transform filter'/7X,'(e)  a ',
c     *    'best-fit polynomial of up to 10 terms'//5X,'CurveFit is ',
c     *    'menu driven and allows one to display any intermediary'/1X,
c     *    'results.  The x,y plotting ranges are user determined, as',
c     *    ' is the fitting'/1X,'range (over the x coordinate).  Plots',
c     *    ' can be made on any device that is'/1X,'supported by PG',
c     *    'Plot.'////1X,'Press <return> to continue',$)
c      READ (*,'((A))') ans
c      WRITE (*,'(''1'')')
c      RETURN
c      END

C*PGRND -- find the smallest `round' number greater than x
C%float cpgrnd(float x, int *nsub);
C+
      REAL FUNCTION PGRND (X, NSUB)
      REAL X
      INTEGER NSUB
C
C Routine to find the smallest "round" number larger than x, a
C "round" number being 1, 2 or 5 times a power of 10. If X is negative,
C PGRND(X) = -PGRND(ABS(X)). eg PGRND(8.7) = 10.0,
C PGRND(-0.4) = -0.5.  If X is zero, the value returned is zero.
C This routine is used by PGBOX for choosing  tick intervals.
C
C Returns:
C  PGRND         : the "round" number.
C Arguments:
C  X      (input)  : the number to be rounded.
C  NSUB   (output) : a suitable number of subdivisions for
C                    subdividing the "nice" number: 2 or 5.
C--
C  6-Sep-1989 - Changes for standard Fortran-77 [TJP].
C  2-Dec-1991 - Fix for bug found on Fujitsu [TJP].
C-----------------------------------------------------------------------
      INTEGER  I,ILOG
      REAL     FRAC,NICE(3),PWR,XLOG,XX
      INTRINSIC ABS, LOG10, SIGN
      DATA     NICE/2.0,5.0,10.0/
C
      IF (X.EQ.0.0) THEN
          PGRND = 0.0
          NSUB = 2
          RETURN
      END IF
      XX   = ABS(X)
      XLOG = LOG10(XX)
      ILOG = XLOG
      IF (XLOG.LT.0) ILOG=ILOG-1
      PWR  = 10.0**ILOG
      FRAC = XX/PWR
      I = 3
      IF (FRAC.LE.NICE(2)) I = 2
      IF (FRAC.LE.NICE(1)) I = 1
      PGRND = SIGN(PWR*NICE(I),X)
      NSUB = 5
      IF (I.EQ.1) NSUB = 2
      END

C*GRLINA -- draw a line (absolute, world coordinates)
C+
      SUBROUTINE GRLINA (X,Y)
C
C GRPCKG: draw line from current position to a specified position.
C
C Arguments:
C
C X, Y (real, input): world coordinates of the end-point of the line.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL     X,Y
C
      IF (GRCIDE.GE.1) THEN
C         WRITE (*,'(A,2F10.5)') 'GRLINA', X, Y
          CALL GRLIN0( X * GRXSCL(GRCIDE) + GRXORG(GRCIDE),
     1                 Y * GRYSCL(GRCIDE) + GRYORG(GRCIDE) )
      END IF
      END

C*GRTRAN -- define scaling transformation
C+
      SUBROUTINE GRTRAN (IDENT,XORG,YORG,XSCALE,YSCALE)
C
C GRPCKG (internal routine): Define scaling transformation.
C
C Arguments:
C
C IDENT (input, integer): plot identifier, as returned by GROPEN.
C XORG, YORG, XSCALE, YSCALE (input, real): parameters of the scaling
C       transformation. This is defined by:
C               XABS = XORG + XWORLD * XSCALE,
C               YABS = YORG + YWORLD * YSCALE,
C       where (XABS, YABS) are the absolute device coordinates
C       corresponding to world coordinates (XWORLD, YWORLD).
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INTEGER  IDENT
      REAL     XORG, YORG, XSCALE, YSCALE
C
      CALL GRSLCT(IDENT)
      CALL GRTRN0(XORG, YORG, XSCALE, YSCALE)
C
      END

C*GRGMSG -- print system message (Sun/Convex-UNIX)
C+
      SUBROUTINE GRGMSG (STATUS)
      INTEGER STATUS
C
C This routine obtains the text of the VMS system message corresponding
C to code STATUS, and displays it using routine GRWARN. On non-VMS
C systems, it just displays the error number.
C
C Argument:
C  STATUS (input): 32-bit system message code.
C--
C 18-Feb-1988
C-----------------------------------------------------------------------
      CHARACTER*10 BUFFER
C
      WRITE (BUFFER, '(I10)') STATUS
      CALL GRWARN('system message number: '//BUFFER)
      END

C*PGCONT -- contour map of a 2D data array (contour-following)
C%void cpgcont(const float *a, int idim, int jdim, int i1, int i2, \
C% int j1, int j2, const float *c, int nc, const float *tr);
C+
      SUBROUTINE PGCONT (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, TR)
      INTEGER IDIM, JDIM, I1, J1, I2, J2, NC
      REAL A(IDIM,JDIM), C(*), TR(6)
C
C Draw a contour map of an array.  The map is truncated if
C necessary at the boundaries of the viewport.  Each contour line
C is drawn with the current line attributes (color index, style, and
C width); except that if argument NC is positive (see below), the line
C style is set by PGCONT to 1 (solid) for positive contours or 2
C (dashed) for negative contours.
C
C Arguments:
C  A      (input) : data array.
C  IDIM   (input) : first dimension of A.
C  JDIM   (input) : second dimension of A.
C  I1, I2 (input) : range of first index to be contoured (inclusive).
C  J1, J2 (input) : range of second index to be contoured (inclusive).
C  C      (input) : array of NC contour levels; dimension at least NC.
C  NC     (input) : +/- number of contour levels (less than or equal
C                   to dimension of C). If NC is positive, it is the
C                   number of contour levels, and the line-style is
C                   chosen automatically as described above. If NC is
C                   negative, it is minus the number of contour
C                   levels, and the current setting of line-style is
C                   used for all the contours.
C  TR     (input) : array defining a transformation between the I,J
C                   grid of the array and the world coordinates.
C                   The world coordinates of the array point A(I,J)
C                   are given by:
C                     X = TR(1) + TR(2)*I + TR(3)*J
C                     Y = TR(4) + TR(5)*I + TR(6)*J
C                   Usually TR(3) and TR(5) are zero - unless the
C                   coordinate transformation involves a rotation or
C                   shear.
C--
C (7-Feb-1983)
C (24-Aug-1984) Revised to add the option of not automatically
C       setting the line-style. Sorry about the ugly way this is
C       done (negative NC); this is the least incompatible way of doing
C       it (TJP).
C (21-Sep-1989) Changed to call PGCONX instead of duplicating the code
C       [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      INTEGER  I
      LOGICAL  PGNOTO
      EXTERNAL PGCP
C
      IF (PGNOTO('PGCONT')) RETURN
C
C Save TRANS matrix.
C
      DO 10 I=1,6
          TRANS(I) = TR(I)
   10 CONTINUE
C
C Use PGCONX with external function PGCP, which applies the TRANS
C scaling.
C
      CALL PGCONX (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, PGCP)
C
      END

C*GRETXT -- erase text from graphics screen
C+
      SUBROUTINE GRETXT
C
C GRPCKG: Erase the text screen.  Some graphics devices have
C two superimposed view surfaces, of which one is used for graphics and
C the other for alphanumeric text.  This routine erases the text
C view surface without affecting the graphics view surface. It does
C nothing if there is no text view surface associated with the device.
C
C Arguments: none.
C--
C (1-Feb-1983)
C 16-Oct-1984 - add ID100 device [RSS/TJP].
C 29-Jan-1985 - add HP2648 device [KS/TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 11-Jun-1987 - remove built-in devices [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      CHARACTER*1   CHR
      REAL    RBUF(6)
      INTEGER NBUF,LCHR
C
      IF (GRCIDE.GE.1) THEN
          CALL GREXEC(GRGTYP,18,RBUF,NBUF,CHR,LCHR)
      END IF
C
      END

C*PGGRAY -- gray-scale map of a 2D data array
C%void cpggray(const float *a, int idim, int jdim, int i1, int i2, \
C% int j1, int j2, float fg, float bg, const float *tr);
C+
      SUBROUTINE PGGRAY (A, IDIM, JDIM, I1, I2, J1, J2,
     1                   FG, BG, TR)
      INTEGER IDIM, JDIM, I1, I2, J1, J2
      REAL    A(IDIM,JDIM), FG, BG, TR(6)
C
C Draw gray-scale map of an array in current window. The subsection
C of the array A defined by indices (I1:I2, J1:J2) is mapped onto
C the view surface world-coordinate system by the transformation
C matrix TR. The resulting quadrilateral region is clipped at the edge
C of the window and shaded with the shade at each point determined
C by the corresponding array value.  The shade is a number in the
C range 0 to 1 obtained by linear interpolation between the background
C level (BG) and the foreground level (FG), i.e.,
C
C   shade = [A(i,j) - BG] / [FG - BG]
C
C The background level BG can be either less than or greater than the
C foreground level FG.  Points in the array that are outside the range
C BG to FG are assigned shade 0 or 1 as appropriate.
C
C PGGRAY uses two different algorithms, depending how many color
C indices are available in the color index range specified for images.
C (This range is set with routine PGSCIR, and the current or default
C range can be queried by calling routine PGQCIR).
C
C If 16 or more color indices are available, PGGRAY first assigns
C color representations to these color indices to give a linear ramp
C between the background color (color index 0) and the foreground color
C (color index 1), and then calls PGIMAG to draw the image using these
C color indices. In this mode, the shaded region is "opaque": every
C pixel is assigned a color.
C
C If less than 16 color indices are available, PGGRAY uses only
C color index 1, and uses  a "dithering" algorithm to fill in pixels,
C with the shade (computed as above) determining the faction of pixels
C that are filled. In this mode the shaded region is "transparent" and
C allows previously-drawn graphics to show through.
C
C The transformation matrix TR is used to calculate the world
C coordinates of the center of the "cell" that represents each
C array element. The world coordinates of the center of the cell
C corresponding to array element A(I,J) are given by:
C
C          X = TR(1) + TR(2)*I + TR(3)*J
C          Y = TR(4) + TR(5)*I + TR(6)*J
C
C Usually TR(3) and TR(5) are zero -- unless the coordinate
C transformation involves a rotation or shear.  The corners of the
C quadrilateral region that is shaded by PGGRAY are given by
C applying this transformation to (I1-0.5,J1-0.5), (I2+0.5, J2+0.5).
C
C Arguments:
C  A      (input)  : the array to be plotted.
C  IDIM   (input)  : the first dimension of array A.
C  JDIM   (input)  : the second dimension of array A.
C  I1, I2 (input)  : the inclusive range of the first index
C                    (I) to be plotted.
C  J1, J2 (input)  : the inclusive range of the second
C                    index (J) to be plotted.
C  FG     (input)  : the array value which is to appear with the
C                    foreground color (corresponding to color index 1).
C  BG     (input)  : the array value which is to appear with the
C                    background color (corresponding to color index 0).
C  TR     (input)  : transformation matrix between array grid and
C                    world coordinates.
C--
C  2-Sep-1987: remove device-dependent code to routine GRGRAY (TJP).
C  7-Jun-1988: change documentation and argument names (TJP).
C 31-May-1989: allow 1-pixel wide arrays to be plotted (TJP).
C 17-Mar-1994: pass PG scaling info to lower routines (TJP).
C 15-Sep-1994: use PGITF attribute (TJP).
C  8-Feb-1995: use color ramp based on current foreground and background
C              colors (TJP).
C  6-May-1996: allow multiple devives (TJP).
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      REAL PA(6)
      LOGICAL PGNOTO
C
C Check inputs.
C
      IF (PGNOTO('PGGRAY')) RETURN
      IF (I1.LT.1 .OR. I2.GT.IDIM .OR. I1.GT.I2 .OR.
     1    J1.LT.1 .OR. J2.GT.JDIM .OR. J1.GT.J2) THEN
          CALL GRWARN('PGGRAY: invalid range I1:I2, J1:J2')
      ELSE IF (FG.EQ.BG) THEN
          CALL GRWARN('PGGRAY: foreground level = background level')
      ELSE
C
C Call lower-level routine to do the work.
C
          CALL PGBBUF
          CALL PGSAVE
          CALL PGSCI(1)
          PA(1) = TR(1)*PGXSCL(PGID) + PGXORG(PGID)
          PA(2) = TR(2)*PGXSCL(PGID)
          PA(3) = TR(3)*PGXSCL(PGID)
          PA(4) = TR(4)*PGYSCL(PGID) + PGYORG(PGID)
          PA(5) = TR(5)*PGYSCL(PGID)
          PA(6) = TR(6)*PGYSCL(PGID)
          CALL GRGRAY(A, IDIM, JDIM, I1, I2, J1, J2, FG, BG, PA,
     :                PGMNCI(PGID), PGMXCI(PGID), PGITF(PGID))
          CALL PGEBUF
          CALL PGUNSA
      END IF
C-----------------------------------------------------------------------
      END

C*GRSETC -- set character size
C+
      SUBROUTINE GRSETC (IDENT,XSIZE)
C
C GRPCKG : change the character size (user-callable routine).
C
C Input:   IDENT : plot identifier
C          XSIZE : the new character width. The character height
C                  and spacing will be scaled by the same factor.
C                  If XSIZE is negative or zero, the character size
C                  will be set to the default size.
C--
C (1-Feb-1983)
C 16-Sep-1985 - add code for metafile output (TJP).
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER IDENT
      REAL XSIZE
C
C Record the new size (GRCFAC).
C
      CALL GRSLCT(IDENT)
      IF (XSIZE.LE.0.0) THEN
          GRCFAC(IDENT) = 1.0
      ELSE
          GRCFAC(IDENT) = XSIZE / GRCXSZ
      END IF
C
      END

C*PGSCR -- set color representation
C%void cpgscr(int ci, float cr, float cg, float cb);
C+
      SUBROUTINE PGSCR (CI, CR, CG, CB)
      INTEGER CI
      REAL    CR, CG, CB
C
C Set color representation: i.e., define the color to be
C associated with a color index.  Ignored for devices which do not
C support variable color or intensity.  Color indices 0-15
C have predefined color representations (see the PGPLOT manual), but
C these may be changed with PGSCR.  Color indices 16-maximum have no
C predefined representations: if these indices are used, PGSCR must
C be called to define the representation. On monochrome output
C devices (e.g. VT125 terminals with monochrome monitors), the
C monochrome intensity is computed from the specified Red, Green, Blue
C intensities as 0.30*R + 0.59*G + 0.11*B, as in US color television
C systems, NTSC encoding.  Note that most devices do not have an
C infinite range of colors or monochrome intensities available;
C the nearest available color is used.  Examples: for black,
C set CR=CG=CB=0.0; for white, set CR=CG=CB=1.0; for medium gray,
C set CR=CG=CB=0.5; for medium yellow, set CR=CG=0.5, CB=0.0.
C
C Argument:
C  CI     (input)  : the color index to be defined, in the range 0-max.
C                    If the color index greater than the device
C                    maximum is specified, the call is ignored. Color
C                    index 0 applies to the background color.
C  CR     (input)  : red, green, and blue intensities,
C  CG     (input)    in range 0.0 to 1.0.
C  CB     (input)
C--
C 5-Nov-1985 - new routine [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSCR')) RETURN
      CALL GRSCR(CI,CR,CG,CB)
      END

C*PGETXT -- erase text from graphics display
C%void cpgetxt(void);
C+
      SUBROUTINE PGETXT
C
C Some graphics terminals display text (the normal interactive dialog)
C on the same screen as graphics. This routine erases the text from the
C view surface without affecting the graphics. It does nothing on
C devices which do not display text on the graphics screen, and on
C devices which do not have this capability.
C
C Arguments:
C  None
C--
C 18-Feb-1988
C-----------------------------------------------------------------------
      CALL GRETXT
      END

C*GRQTYP -- inquire current device type
C+
      SUBROUTINE GRQTYP (TYPE,INTER)
      CHARACTER*(*) TYPE
      LOGICAL INTER
C
C GRPCKG: obtain the device type of the currently selected graphics
C device, and determine whether or not it is an interactive device.
C
C Arguments:
C
C TYPE (output, CHARACTER*(*)): receives the device type, as a
C       character string, eg 'PRINTRONIX', 'TRILOG', 'VERSATEC',
C       'TEK4010', 'TEK4014', 'GRINNELL', or 'VT125'.  The character
C       string should have a length of at least 8 to ensure that the
C       type is unique.
C INTER (output, LOGICAL): receives the value .TRUE. if the device is
C       interactive, .FALSE. otherwise.
C--
C (23-May-1983)
C  5-Aug-1986 - add GREXEC support [AFT].
C 18-Jan-1993 - return type only, not description [TJP].
C  1-Sep-1994 - get capabilities from common [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL    RBUF(6)
      INTEGER NBUF,LCHR
      CHARACTER*32 CHR
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRQTYP - no graphics device is active.')
          TYPE = 'NULL'
          INTER = .FALSE.
      ELSE
          CALL GREXEC(GRGTYP, 1,RBUF,NBUF,CHR,LCHR)
          LCHR = INDEX(CHR,' ')
          TYPE = CHR(:LCHR)
          INTER = (GRGCAP(GRCIDE)(1:1).EQ.'I')
      END IF
C
      END

C*PGFUNX -- function defined by Y = F(X)
C+
      SUBROUTINE PGFUNX (FY, N, XMIN, XMAX, PGFLAG)
      REAL FY
      EXTERNAL FY
      INTEGER N
      REAL XMIN, XMAX
      INTEGER PGFLAG
C
C Draw a curve defined by the equation Y = FY(X), where FY is a
C user-supplied subroutine.
C
C Arguments:
C  FY     (external real function): supplied by the user, evaluates
C                    Y value at a given X-coordinate.
C  N      (input)  : the number of points required to define the
C                    curve. The function FY will be called N+1 times.
C                    If PGFLAG=0 and N is greater than 1000, 1000
C                    will be used instead.  If N is less than 1,
C                    nothing will be drawn.
C  XMIN   (input)  : the minimum value of X.
C  XMAX   (input)  : the maximum value of X.
C  PGFLAG (input)  : if PGFLAG = 1, the curve is plotted in the
C                    current window and viewport; if PGFLAG = 0,
C                    PGENV is called automatically by PGFUNX to
C                    start a new plot with X limits (XMIN, XMAX)
C                    and automatic scaling in Y.
C
C Note: The function FY must be declared EXTERNAL in the Fortran
C program unit that calls PGFUNX.  It has one argument, the
C x-coordinate at which the y value is required, e.g.
C   REAL FUNCTION FY(X)
C   REAL X
C   FY = .....
C   END
C--
C  6-Oct-1983 - TJP.
C  6-May-1985 - fix Y(0) bug - TJP.
C 11-May-1990 - remove unnecessary include - TJP.
C-----------------------------------------------------------------------
      INTEGER MAXP
      PARAMETER (MAXP=1000)
      INTEGER  I, NN
      REAL     Y(0:MAXP), DT, DY
      REAL     YMIN, YMAX
C
C Check N > 1, and find parameter increment.
C
      IF (N.LT.1) RETURN
      DT = (XMAX-XMIN)/N
      CALL PGBBUF
C
C Case 1: we do not have to find limits.
C
      IF (PGFLAG.NE.0) THEN
          CALL PGMOVE(XMIN,FY(XMIN))
          DO 10 I=1,N
              CALL PGDRAW(XMIN+I*DT,FY(XMIN+I*DT))
   10     CONTINUE
C
C Case 2: find limits and scale plot; function values must be stored
C in an array.
C
      ELSE
          NN = MIN(N,MAXP)
          Y(0) = FY(XMIN)
          YMIN = Y(0)
          YMAX = Y(0)
          DO 20 I=1,NN
              Y(I) = FY(XMIN+DT*I)
              YMIN = MIN(YMIN,Y(I))
              YMAX = MAX(YMAX,Y(I))
   20     CONTINUE
          DY = 0.05*(YMAX-YMIN)
          IF (DY.EQ.0.0) THEN
              YMIN = YMIN - 1.0
              YMAX = YMAX + 1.0
          ELSE
              YMIN = YMIN - DY
              YMAX = YMAX + DY
          END IF
          CALL PGENV(XMIN,XMAX,YMIN,YMAX,0,0)
          CALL PGMOVE(XMIN,Y(0))
          DO 30 I=1,NN
              CALL PGDRAW(XMIN+DT*I,Y(I))
   30     CONTINUE
      END IF
C
      CALL PGEBUF
      END

C*GRGE00 -- open output device; device handler routine (VMS)
C+
      INTEGER FUNCTION GRGE00(CTYP,LUN,CHR,LCHR)
C
C General routine to open plot device.  This version can open
C 1) A file with of any FORM and CARRIAGECONTROL,
C 2) Any local device for QIO operations,
C 3) A remote device over a network using a network task on the
C    remote node.
C If an error occurs, a message is sent to SYS$OUTPUT via GRWARN.
C
C Arguments:
C- CTYP(1:1)='F' I/O will use standard Fortran I/O and
C-       CTYP(2:2)      ='F' for formatted, ='U' for unformatted.
C-      CTYP(3:3)      ='L' for LIST, ='N' for 'NONE carriagecontrol
C-      LUN            return, logical unit number of file.
C-       CHR(:LCHR)      input, name of file to open.
C- CTYP(1:1)='Q' for DEC QIO and
C-      CTYP(2:2)      ='1' for device type 66 expected.
C-      CTYP(2:2)      ='2' for device type 96 expected.
C-      LUN            return, channel number of opened channel,
C-       CHR(:LCHR)      input, name of device to open.
C
C GRGE00 (returns integer): 0 if the device/channel could
C      not be opened, 1 if the file/channel was opened
C      successfully on a local device, 3 for a successful open
C      of a channel over a network (the remote status of the
C      device must be flagged since, the QIO functions codes are
C      different when writting to a physical device or to the
C      network).
C--
C  5-Aug-1986 - [AFT].
C-----------------------------------------------------------------------
      INCLUDE  '($IODEF)'
      INCLUDE  '($SSDEF)'
      INTEGER  DVI$_DEVCLASS, DVI$_DEVNAM
      PARAMETER (DVI$_DEVCLASS=4)
      PARAMETER (DVI$_DEVNAM=32)
      INTEGER LUN,LCHR
      CHARACTER*(*) CTYP,CHR
      CHARACTER*16 CFORM,CONTRL
      INTEGER  GRCHKT, I, IER, IK1, IK2, IK3, IK4, IK5, ITEMP
      INTEGER  DEVCLASS, ITMLIST(7), MOSB(2), ISTAT, LENGTH
      INTEGER  SYS$ASSIGN, SYS$QIOW
      INTEGER  SYS$GETDVI, SYS$DASSGN, SYS$WAITFR
      INTEGER*2 IOSB(4)
      LOGICAL  WRONG
C
      IF(CTYP(1:1).EQ.'F') THEN
          CALL GRGLUN(LUN)
          CFORM=' '
          IF(CTYP(2:2).EQ.'F') CFORM='FORMATTED'
          IF(CTYP(2:2).EQ.'U') CFORM='UNFORMATTED'
          CONTRL=' '
          IF(CTYP(3:3).EQ.'N') CONTRL='NONE'
          IF(CTYP(3:3).EQ.'L') CONTRL='LIST'
          OPEN (UNIT=LUN,FILE=CHR(:LCHR),STATUS='NEW',
     &            FORM=CFORM, CARRIAGECONTROL=CONTRL,
     &            RECL=512,IOSTAT=IER)
          IF (IER.NE.0) THEN
            CALL ERRSNS(IK1,IK2,IK3,IK4,IK5)
            CALL GRWARN('Cannot open graphics device '
     1                        //CHR(1:LCHR))
            IF (IK2.NE.0 .AND. IK2.NE.1) CALL GRGMSG(IK2)
            IF (IK5.NE.0 .AND. IK5.NE.1) CALL GRGMSG(IK5)
            GRGE00 = 0
          ELSE
            INQUIRE (UNIT=LUN, NAME=CHR)
            I = LEN(CHR)
            DO WHILE (CHR(I:I).EQ.' ')
                I = I-1
            END DO
            LCHR= I
            IF (GRCHKT(CHR(1:I))) THEN
                CALL GRWARN('Cannot send printer plot to terminal.')
                GRGE00 = 0
            ELSE
                GRGE00 = 1
            END IF
          END IF
      ELSE IF(CTYP(1:1).EQ.'Q') THEN
C
C Assign an i/o channel.
C
          IER = SYS$ASSIGN(CHR(:LCHR), LUN,,)
          IF(IER.NE.SS$_NORMAL .AND. IER.NE.SS$_REMOTE) GOTO 100
          IF (IER .EQ. SS$_REMOTE) THEN
C
C Cannot check device characteristics easily if network device being used
C so just check whether we opened the device successfully and return
C Read back the status from assign to plotting device over network
C
            IER=SYS$QIOW(,%VAL(LUN),%VAL(IO$_READVBLK),
     :                   IOSB,,,ISTAT,LENGTH,,,,)
            IF (IOSB(1) .NE. SS$_NORMAL) THEN
                CALL GRWARN ('Unable to read status from ASSIGN to' //
     :                      ' graphics device on remote node')
                WRITE(6,*) IOSB(2), ' bytes read'
                ITEMP=IOSB(1)
                CALL GRGMSG(ITEMP)
                GRGE00=0
                RETURN
            END IF
            IF (ISTAT .NE. SS$_NORMAL) THEN
                IER=ISTAT
                GOTO 100
            ELSE
                GRGE00=3
                RETURN
            END IF
          END IF
C---
C            Check that device has correct characteristics,
C            and obtain true device name.
C
          ITMLIST(1) = DVI$_DEVCLASS*2**16 + 4
          ITMLIST(2) = %LOC(DEVCLASS)
          ITMLIST(3) = 0
          ITMLIST(4) = DVI$_DEVNAM*2**16 + LEN(CHR)
          ITMLIST(5) = %LOC(CHR)
          ITMLIST(6) = %LOC(LCHR)
          ITMLIST(7) = 0
          IER = SYS$GETDVI(%VAL(0),,CHR(:LCHR),
     1                 ITMLIST,MOSB,,,)
          IF (.NOT.IER) GOTO 100
          IER = SYS$WAITFR(%VAL(0))
          IF (.NOT.IER) GOTO 100
          IF (.NOT.MOSB(1)) THEN
            IER = MOSB(1)
            GOTO 100
          END IF
          IF (CTYP(2:2).EQ.'1') THEN
            WRONG = DEVCLASS.NE.66
          ELSE IF(CTYP(2:2).EQ.'2') THEN
            WRONG = DEVCLASS.NE.96
          ELSE
            TYPE *,'DEVCLASS=',DEVCLASS
          END IF
          IF (WRONG) THEN
            CALL GRWARN( CHR(:LCHR)//
     2            ' is the wrong sort of device for plot type.')
            GRGE00 = 0            ! indicate error
            IER = SYS$DASSGN(%VAL(LUN))
            RETURN
          END IF
C
C Successful completion.
C
          GRGE00 = 1
      END IF
      RETURN
C
C Error exit.
C
  100 CALL GRWARN('Cannot open graphics device '//CHR(:LCHR))
      CALL GRGMSG(IER)
      GRGE00 = 0
      END

C*PGSLCT -- select an open graphics device
C%void cpgslct(int id);
C+
      SUBROUTINE PGSLCT(ID)
      INTEGER ID
C
C Select one of the open graphics devices and direct subsequent
C plotting to it. The argument is the device identifier returned by
C PGOPEN when the device was opened. If the supplied argument is not a
C valid identifier of an open graphics device, a warning message is
C issued and the current selection is unchanged.
C
C [This routine was added to PGPLOT in Version 5.1.0.]
C
C Arguments:
C
C ID (input, integer): identifier of the device to be selected.
C--
C 22-Dec-1995 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
C
      IF (ID.LT.1 .OR. ID.GT.PGMAXD) THEN
         CALL GRWARN('PGSLCT: invalid argument')
      ELSE IF (PGDEVS(ID).NE.1) THEN
         CALL GRWARN('PGSLCT: requested device is not open')
      ELSE
C        -- Select the new device
         PGID = ID
         CALL GRSLCT(PGID)
      END IF
C
      END

C*TTDRIV -- PGPLOT Tektronix terminal drivers
C+
      SUBROUTINE TTDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
      INTEGER IFUNC, NBUF, LCHR, MODE
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Tektronix terminals and emulators.
C
C 1993 Jan 18 - T. J. Pearson.
C 1993 Jun 24 - L. Staveley-Smith, minor alteration of 
C               flush-buffer for better /tek
C               compatibility. Also added MODE 7 for
C               Visual 603's and MODE 8 for IBM-PCs 
C               running as remote terminals using
C               Kermit version 3 (for DOS).
C 1994 Dec 19 - TJP: better XTERM support.
C 1994 Dec 29 - TJP: and Tek4100 support (MODE 9).
C 1996 Apr 18 - TJP: prevent concurrent access.
C 1998 Mar 09 - M. Zolliker: new MODE 10 for VersaTerm-PRO for Macintosh
C
C Supported device:
C 1. Tektronix 4006/4010 storage-tube terminal; can be used with
C   emulators, but the options below take advantage of features not
C   present in the basic Tektronix terminal.
C 2. GraphOn Corporation 200-series terminals. These emulate a
C   Tektronix-4010 with enhancements (selective erase, rectangle fill,
C   switch between Tek and VT100 modes).
C 3. Digital Engineering, Inc., Retrographics modified VT100
C   terminal (VT640). 
C 4. IRAF GTERM Tektronix terminal emulator, with color extensions.
C 5. Xterm window on an X-window server. Emulates a Tektronix-4014,
C   with extensions (switch between Tek and VT100 windows).
C 6. ZSTEM 240 and ZSTEM 4014 terminal emulators for the IBM PC and
C   clones. ZSTEM supports Tektronix 4014 emulation and the 4105 color
C   escape sequences. ZSTEM can be obtained from: KEA Systems Ltd.,
C   2150 West Broadway, Suite 412, Vancouver, British Columbia, Canada,
C   V6K 4L9.
C 7.Visual-603 and 630 terminals. These are VT100/220 compatible
C   terminals with Tektronix 4010/4014 emulation (Visual Technology
C   Incorporated, 1703 Middlesex Street, Lowell, Mass 01851). The 
C   Visual 630 has the capability of displaying dual text and graphics.
C   This feature is not used in this driver. Graphics mode is entered 
C   automatically when the graph is drawn but only exited when PGPAGE 
C   or PGEND is called. Therefore, for multiple plots interspersed
C   with text I/O, use PGPAGE at the end of each plot. This will prompt
C   for a carriage return before switching. If this is not done,
C   intervening text will appear on the graphics screen. Graphics mode
C   can be entered and exited from the setup menu, or by SHIFT-PF1.
C   Graphics extensions include rectangle fill, selective erase and 
C   switch between Tek and VT100 modes.
C 8.IBM PC's and compatibles running MS-Kermit 3 as a terminal emulator.
C   The video board is assumed to have sufficient memory to retain the 
C   graphics image in memory when switched to text. This will be true 
C   for VGA and EGA, but some early PCs might not be able to do this. 
C   If Kermit is using full VGA resolution (ie SET TERMINAL GRAPHICS 
C   VGA), there is not usually enough memory to store the full 480 
C   vertical lines, so the bottom few lines may disappear. Tektronix 
C   enhancements include selective erase, colours, rectangle fill, and
C   switching between text and graphics mode. The cursor may be
C   operated with the mouse. Tested with Kermit version 3.1.
C 9.Tektronix 4100 series color terminals (and emulators)
C 10.Versaterm-PRO for Macintosh (Tek 4105 emulation).
C
C Device type codes:
C 1.  /TEK4010 Tektronix-4010 terminal
C 2.  /GF      GraphOn terminal
C 3.  /RETRO   Retrographics VT640 terminal
C 4.  /GTERM   GTERM terminal emulator
C 5.  /XTERM   XTERM terminal emulator
C 6.  /ZSTEM   ZSTEM terminal emulator
C 7.  /V603    Visual V603 terminal
C 8.  /KRM3    Kermit 3 on IBM-PC
C 9.  /TK4100  Tektronix 4100 series terminals
C 10. /VMAC    VersaTerm-PRO for Macintosh
C
C Default device name: the logged-in terminal
C   /dev/tty (UNIX)
C   TT: (VMS)
C
C Default view surface dimensions:
C   Depends on monitor; nominally 8in (horizontal) by 6in (vertical).
C
C Resolution:
C   A standard Tektronix terminal displays a screen of 1024 pixels
C   (horizontal) by 780 pixels (vertical), with a nominal resolution
C   of 130 pixels per inch. The actual resolution may be less.
C
C Color capability:
C   /TEK4010, /XTERM: none; only color index 1 is available; selective
C       erase is not possible. Requests to draw in color index 0 are
C       ignored.
C   /GF, /RETRO, /V603: color indices 0 (erase, black) and 1 (bright:
C       usually white, green or amber) are supported. It is not 
C       possible to change color representation.
C   /GTERM:  color indices 0 to 15 are available and default to the
C       standard PGPLOT colors. The color representation can be changed.
C   /ZSTEM: color indices 0 to 7 are available and default to the
C       indicated in the ZSTEM setup menu (which default to the standard
C       PGPLOT colors).  The color representation cannot be changed.
C   /KRM3: color indices 0 to 7 are the standard PGPLOT colors. Indices
C       8 to 14 are also available, but are BRIGHT versions of 1 to 7,
C       and thus non-standard. Color representation can't be changed.
C   /TK4100: color indices 0-15.
C   /VMAC: color indices 0 to 15 are available and default to the
C       standard PGPLOT colors. The color representation can be changed.
C       Caution: this does not work reliably, owing to bugs (?) in
C       Versaterm.
C
C Input capability:
C   Depending on the emulation, the graphics cursor may be a pointer,
C   a small cross, or a crosshair across the entire screen. The user
C   positions the cursor using thumbwheels, mouse, trackball, or the
C   arrow keys on the keyboard. The user indicates that the cursor has
C   been positioned by typing any printable ASCII character on the 
C   keyboard. Most control characters (eg, ^C) are intercepted by the
C   operating system and cannot be used. 
C
C File format: 
C   Binary byte stream. Under Unix, the output may be directed to
C   a file; under VMS, this is not possible: the output device must
C   be a terminal.
C
C Obtaining hardcopy:
C
C Environment variables:
C   None.
C--
C Implementation Notes:
C
C Standard Tektronix codes:
C   graph mode: [GS]=char(29)
C   alpha mode: [US]=char(31)
C The emulators provide various extensions to basic Tektronix
C operation, using the following codes:
C    [SOH]=char(1),  [STX]=char(2),  [ETX]=char(3),
C    [DLE]=char(16), [CAN]=char(24), [ESC]=char(27)
C
C Enter Tektronix mode (from VT100 mode):
C   graphon: automatic on receipt of [GS]
C   gterm:   [GS]
C   tek:     not available
C   retro:   automatic on receipt of [GS]
C   xterm:   [ESC][?38h
C   zstem:   [ESC][?38h
C   v603:    [GS]
C   krm3:    [ESC][?38h
C Return to VT100 mode (from Tektronix mode):
C   graphon: [CAN]
C   gterm:   [CAN]
C   tek:     not available
C   xterm:   [ESC][ETX]
C   zstem:   [CAN]
C   v603:    [CAN][ESC][?38l
C   krm3:    [ESC][?38l
C Rectangle fill:
C   graphon: draw the diagonal in special rectangle mode, 
C     entered with [ESC][STX], exit with [ESC][ETX]
C   v603: bottom corner and rectangle width
C   krm3: bottom corner and rectangle width
C   vmac: use panel boundary commands [ESC]LP and [ESC]LE
C Color index zero (erase):
C   graphon select erase:        [ESC][DLE]
C   graphon unselect erase:      [ESC][SOH]
C   retro,v603 select erase:     [ESC]/1d
C   retro,v603 unselect erase:   [ESC]/0d
C   krm3, select erase:          [ESC][0;30m
C   krm3, unselect erase:        [ESC][0;37m
C-----------------------------------------------------------------------
      INTEGER NDEVS
      PARAMETER (NDEVS=10)
      INTEGER CAN, ESC, GS, US
      PARAMETER (CAN=24, ESC=27, GS=29, US=31)
C
      CHARACTER*48 DEVICE(NDEVS)
      SAVE         DEVICE
      CHARACTER*80 TEXT
      CHARACTER*32 CTMP, CADD, CSCR(4)*4
      CHARACTER*500 CBUF
      SAVE          CBUF
      INTEGER I, J, INTEN, I0, J0, I1, J1, LADD, LTMP, ICH, IER
      INTEGER XSIZE(NDEVS), YSIZE(NDEVS), MAXCI(NDEVS), I4014(NDEVS)
      SAVE    XSIZE,        YSIZE,        MAXCI,        I4014
      INTEGER ICHAN, LASTI, LASTJ, NPAGE, ICI, LBUF, STATE
      SAVE    ICHAN, LASTI, LASTJ, NPAGE, ICI, LBUF, STATE
      INTEGER GROTER
      INTEGER IBUF(4), ITOT
      LOGICAL APPEND
      SAVE    APPEND
      REAL    XRESLN(NDEVS), YRESLN(NDEVS)
      SAVE    XRESLN,        YRESLN
      REAL    HUE,SAT,LIG
      LOGICAL SEFCOL
      SAVE    SEFCOL
C
      INTEGER IRGB(3,0:15), TKRGB(3,0:15)
C
      DATA DEVICE(1) /'TEK4010 (Tektronix 4010 terminal)'/
      DATA DEVICE(2) /'GF    (GraphOn Tek terminal emulator)'/
      DATA DEVICE(3) /'RETRO (Retrographics VT640 Tek emulator)'/
      DATA DEVICE(4) /'GTERM (Color gterm terminal emulator)'/
      DATA DEVICE(5) /'XTERM (XTERM Tek terminal emulator)'/
      DATA DEVICE(6) /'ZSTEM (ZSTEM Tek terminal emulator)'/
      DATA DEVICE(7) /'V603  (Visual 603 terminal)'/
      DATA DEVICE(8) /'KRM3  (Kermit 3 IBM-PC terminal emulator)'/
      DATA DEVICE(9) /'TK4100 (Tektronix 4100 terminals)'/
      DATA DEVICE(10) /'VMAC  (VersaTerm-PRO for Mac, Tek 4105)'/
C                 TEK  GF   RET  GTER XTER ZSTE V603 KRM3 TK41 VMAC
      DATA XSIZE /1023,1023,1023,1023,1023,1023,1023,1023,1023,1023/
      DATA YSIZE / 779, 779, 779, 779, 779, 779, 779, 779, 779, 779/
      DATA MAXCI /   1,   1,   1,  15,   1,   7,   1,  14,  15,  15/
      DATA XRESLN/130.,128.,128.,130.,128.,130.,115.,110.,100.,128./
      DATA YRESLN/130.,130.,130.,130.,130.,130.,115.,110.,100.,128./
      DATA I4014/    0,   0,   0,   0,   1,   1,   0,   0,   1,   1/
      DATA IRGB /  0,  0,  0, 255,255,255, 255,  0,  0,   0,255,  0,
     1             0,  0,255,   0,255,255, 255,  0,255, 255,255,  0,
     2           255,128,  0, 128,255,  0,   0,255,128,   0,128,255,
     3           128,  0,255, 255,  0,128, 085,085,085, 170,170,170/
      DATA TKRGB/  0,  0,  0, 100,100,100, 100,  0,  0,   0,100,  0,
     1             0,  0,100,   0,100,100, 100,  0,100, 100,100,  0,
     2           100, 50,  0,  50,100,  0,   0,100, 50,   0, 50,100,
     3            50,  0,100, 100,  0, 50,  33, 33, 33,  67, 67, 67/
      DATA STATE/0/
C-----------------------------------------------------------------------
C
      IF (MODE.LT.1 .OR. MODE.GT.NDEVS) CALL GRWARN('Error in GRTT00')
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,900,900,
     2     210,900,900,240), IFUNC
C     -- Ignore unimplemented function
  900 RETURN
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CONTINUE
      CHR  = DEVICE(MODE)
      LCHR = LEN(DEVICE(MODE))
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 CONTINUE
      RBUF(1) = 0
      RBUF(2) = XSIZE(MODE)
      RBUF(3) = 0
      RBUF(4) = YSIZE(MODE)
      RBUF(5) = 0
      RBUF(6) = MAXCI(MODE)
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
   30 CONTINUE
      RBUF(1) = XRESLN(MODE)
      RBUF(2) = YRESLN(MODE)
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Interactive, Cursor, No dashed lines, No areafill, 
C    No thick lines, No markers; some varieties have rectangle fill)
C
   40 CONTINUE
      CHR = 'ICNNNNNNNN'
      IF (MODE.EQ.2 .OR. MODE.EQ.7 .OR. MODE.EQ.8) CHR(6:6) = 'R'
      IF (MODE.EQ.10) THEN
C       -- VMAC: rect. fill and wait before closing graph window
        CHR(6:6) = 'R'
        CHR(8:8) = 'V'
      ENDIF
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CONTINUE
      CALL GRTRML(CHR,LCHR)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 CONTINUE
      RBUF(1) = 0
      RBUF(2) = XSIZE(MODE)
      RBUF(3) = 0
      RBUF(4) = YSIZE(MODE)
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 CONTINUE
      RBUF(1) = 2.0
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
C     -- do nothing
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
C     -- check for concurrent access
      IF (STATE.EQ.1) THEN
         CALL GRWARN('a PGPLOT Tektronix device is already open')
         RBUF(1) = 0
         RBUF(2) = 0
         RETURN
      END IF
      APPEND = RBUF(3) .NE. 0.0
      RBUF(1) = 0.0
      NBUF = 2
      ICHAN = GROTER(CHR, LCHR)
      IF (ICHAN .LT. 0) THEN
          TEXT = 'Cannot open output device for plot type '//
     :           DEVICE(MODE)
          CALL GRWARN(TEXT)
          RBUF(2) = 0.0
          RETURN
      ELSE
          STATE = 1
          RBUF(2) = 1.0
      END IF
      LASTI = -1
      LASTJ = -1
      ICI = 1
      NPAGE = 0
      LBUF = 0
      IF (.NOT.APPEND) THEN
         IF ( MODE.EQ.4 ) THEN
C           -- load gterm default color table.
            DO 91 I=0,15
               CTMP(1:6) = CHAR(GS)//CHAR(ESC)//'TG14'
               LTMP = 6
               CALL GRTT05(I,         CADD, LADD)
               CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
               LTMP = LTMP + LADD
C              -- red
               CALL GRTT05(IRGB(1,I), CADD, LADD)
               CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
               LTMP = LTMP + LADD
C              -- green
               CALL GRTT05(IRGB(2,I), CADD, LADD)
               CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
               LTMP = LTMP + LADD
C              -- blue
               CALL GRTT05(IRGB(3,I), CADD, LADD)
               CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
               LTMP = LTMP + LADD
               CTMP(LTMP+1:LTMP+1) = CHAR(US)
               LTMP = LTMP + 1
               CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
 91         CONTINUE
            CALL GRTT02(ICHAN, MODE, CHAR(CAN), 1, CBUF, LBUF)
         ELSE IF (MODE.EQ.10) THEN
C           -- VMAC: put into Tek 4105 mode
            CTMP(1:5)=CHAR(ESC)//'%!1'//CHAR(GS)
            CALL GRTT02(ICHAN, MODE, CTMP, 5, CBUF, LBUF)
            SEFCOL = .TRUE.
C           -- set default color representation
            DO 92,I=0,15
              CALL GRXHLS(IRGB(1,I)/255.,IRGB(2,I)/255.,IRGB(3,I)/255.
     :              ,HUE,LIG,SAT)
              CALL GRTT06(I, NINT(HUE), NINT(LIG*100), NINT(SAT*100)
     :              , CTMP, LTMP)
              CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
92          CONTINUE
         END IF
      END IF
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
      IF ( MODE.EQ.6 ) THEN
C         -- For zstem switch back to alpha mode at the last possible
C            moment.
          LTMP = 1
          CALL GRWTER(ICHAN, CHAR(CAN), LTMP)
      ELSE IF ( MODE.EQ.7 ) THEN
C         -- For v603 switch back to alpha mode at the last possible
C            moment.
          CTMP(1:7) = CHAR(CAN)//CHAR(ESC)//CHAR(91)//CHAR(63)//
     :                CHAR(51)//CHAR(56)//CHAR(108)
          LTMP=7
          CALL GRWTER(ICHAN, CTMP, LTMP)
      ELSE IF (MODE.EQ.10) THEN
C         -- VMAC: put into VT100 Mode without window resize
          CTMP(1:5)=CHAR(GS)//CHAR(ESC)//'%!7'
          LTMP=5
          CALL GRWTER(ICHAN, CTMP, LTMP)
      END IF
      CALL GRCTER(ICHAN)
      STATE = 0
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
      NPAGE = NPAGE+1
      LASTI = -1
      IF (.NOT.APPEND) THEN
         IF (MODE.EQ.5 .OR. MODE.EQ.6 .OR. MODE. EQ.8) THEN
C           -- xterm, zstem, krm3: select Tek mode, erase screen
            CTMP(1:1) = CHAR(ESC)
            CTMP(2:2) = CHAR(12)
            CALL GRTT02(ICHAN, MODE, CTMP, 2, CBUF, LBUF)
         ELSE IF (MODE.EQ.7) THEN
C           -- V603: select Tek mode
            CTMP(1:1) = CHAR(GS)
            CTMP(2:2) = CHAR(ESC)
            CTMP(3:3) = CHAR(12)
            CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF)
         ELSE
C           -- erase graphics screen
            CTMP(1:1) = CHAR(GS)
            CTMP(2:2) = CHAR(ESC)
            CTMP(3:3) = CHAR(12)
            CTMP(4:4) = CHAR(CAN)
            CALL GRTT02(ICHAN, MODE, CTMP, 4, CBUF, LBUF)
         END IF
      ELSE IF (MODE.EQ.8) THEN
C        -- krm3: enter graph mode without deleting screen
         CTMP(1:1) = CHAR(ESC)
         CTMP(2:2) = CHAR(91)
         CTMP(3:3) = CHAR(63)
         CTMP(4:4) = CHAR(51)
         CTMP(5:5) = CHAR(56)
         CTMP(6:6) = CHAR(104)
         CALL GRTT02(ICHAN, MODE, CTMP, 6, CBUF, LBUF)
      ELSE IF (MODE.EQ.9) THEN
C        -- TK4100: put device in graphics mode, erase screen
         CTMP(1:1) = CHAR(ESC)
         CTMP(2:4) = '%!0'
         CTMP(5:5) = CHAR(ESC)
         CTMP(6:6) = CHAR(12)
         CALL GRTT02(ICHAN, MODE, CTMP, 6, CBUF, LBUF)
         CTMP(1:1) = CHAR(ESC)
         CTMP(2:6) = 'RU1;4'
         CALL GRTT02(ICHAN, MODE, CTMP, 6, CBUF, LBUF)
C        -- set default color representation
         DO 111 I=0,15
            CTMP(1:5) = CHAR(ESC)//'TG14'
            LTMP = 5
            CALL GRTT05(I,         CADD, LADD)
            CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
            LTMP = LTMP + LADD
C           -- red
            CALL GRTT05(TKRGB(1,I), CADD, LADD)
            CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
            LTMP = LTMP + LADD
C           -- green
            CALL GRTT05(TKRGB(2,I), CADD, LADD)
            CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
            LTMP = LTMP + LADD
C           -- blue
            CALL GRTT05(TKRGB(3,I), CADD, LADD)
            CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
            LTMP = LTMP + LADD
            CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
 111     CONTINUE
C         -- set color index 1
         CTMP(1:1) = CHAR(ESC)
         CTMP(2:4) = 'ML1'
         CALL GRTT02(ICHAN, MODE, CTMP, 4, CBUF, LBUF)
      END IF
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C     (omitted for color 0 on devices without selective erase)
C
  120 CONTINUE
      IF (ICI.EQ.0 .AND. (MODE.EQ.1 .OR. MODE.EQ.5)) RETURN
      IF ( I4014(MODE).EQ.0 ) THEN
         I0 = NINT(RBUF(1))
         J0 = NINT(RBUF(2))
         I1 = NINT(RBUF(3))
         J1 = NINT(RBUF(4))
      ELSE
         I0 = NINT(4.*RBUF(1))
         J0 = NINT(4.*RBUF(2))
         I1 = NINT(4.*RBUF(3))
         J1 = NINT(4.*RBUF(4))
      END IF
      CALL GRTT01(ICHAN, MODE, I4014(MODE), LASTI, LASTJ,
     :      I0, J0, I1, J1, CBUF, LBUF)
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C     (omitted for color 0 on devices without selective erase)
C
  130 CONTINUE
      IF (ICI.EQ.0 .AND. (MODE.EQ.1 .OR. MODE.EQ.5)) RETURN
      IF ( I4014(MODE).EQ.0 ) THEN
         I0 = NINT(RBUF(1))
         J0 = NINT(RBUF(2))
      ELSE
         I0 = NINT(4.*RBUF(1))
         J0 = NINT(4.*RBUF(2))
      END IF
      CALL GRTT01(ICHAN, MODE, I4014(MODE), LASTI, LASTJ,
     :      I0, J0, I0, J0, CBUF, LBUF)
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
      IF (MODE.EQ.7) THEN
C        -- V603: enter alphanumerics and unset graphics
         CTMP(1:7) = CHAR(CAN)//CHAR(ESC)//CHAR(91)//CHAR(63)//
     :               CHAR(51)//CHAR(56)//CHAR(108)
         LTMP=7
         CALL GRWTER(ICHAN, CTMP, LTMP)
      ELSE IF (MODE.EQ.8) THEN
C         -- krm3: enter alphanumerics and unset graphics
         CTMP(1:6) = CHAR(ESC)//CHAR(91)//CHAR(63)//
     :               CHAR(51)//CHAR(56)//CHAR(108)
         LTMP=6
         CALL GRWTER(ICHAN, CTMP, LTMP)
      ELSE IF (MODE.EQ.9 .OR. MODE.EQ.10) THEN
C        -- TK4100, VMAC: return to text mode
         CTMP(1:1) = CHAR(ESC)
         CTMP(2:4) = '%!1'
         LTMP=4
         CALL GRWTER(ICHAN, CTMP, LTMP)
      END IF
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C
  150 CONTINUE
      ICI = RBUF(1)
      IF (ICI.LT.0 .OR. ICI.GT.MAXCI(MODE)) THEN
          ICI = 1
          RBUF(1) = ICI
      END IF
      LASTI = -1
      IF (MODE.EQ.2) THEN
C         -- GraphOn
          CTMP(1:1) = CHAR(GS)
          CTMP(2:2) = CHAR(ESC)
          CTMP(3:3) = CHAR(1)
          IF (ICI.EQ.0) CTMP(3:3) = CHAR(16)
          CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF)
      ELSE IF (MODE.EQ.3 .OR. MODE.EQ.7) THEN
C         -- Retrographics, V603
          CTMP(1:1) = CHAR(GS)
          CTMP(2:2) = CHAR(ESC)
          CTMP(3:3) = CHAR(47)
          CTMP(4:4) = CHAR(49-ICI)
          CTMP(5:5) = CHAR(100)
          CALL GRTT02(ICHAN, MODE, CTMP, 5, CBUF, LBUF)
      ELSE IF ( MODE.EQ.4 .OR. MODE.EQ.6 .OR. MODE.EQ.10) THEN
C         -- gterm and zstem, VMAC
          CTMP(1:4) = CHAR(GS)//CHAR(ESC)//'ML'
          CALL GRTT02(ICHAN, MODE, CTMP, 4, CBUF, LBUF)
          CALL GRTT05(ICI, CTMP, LTMP)
          CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
          SEFCOL=.TRUE.
      ELSE IF (MODE.EQ.9) THEN
C         -- TK4100
          CTMP(1:3) = CHAR(ESC)//'ML'
          CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF)
          CALL GRTT05(ICI, CTMP, LTMP)
          CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
      ELSE IF( MODE.EQ.8) THEN
C         -- krm3: all attributes off
          CTMP(1:1) = CHAR(27)
          CTMP(2:2) = CHAR(91)
          CTMP(3:3) = CHAR(48)
          CTMP(4:4) = CHAR(59)
C
C  Load color definitions (8-14 are bold versions of 1-7, so are not the
C  standard PGPLOT ones)
C
          IF ( ICI.EQ.0 ) I=0
          IF ( ICI.EQ.1 .OR. ICI.EQ.8)  I=7
          IF ( ICI.EQ.2 .OR. ICI.EQ.9)  I=1
          IF ( ICI.EQ.3 .OR. ICI.EQ.10) I=2
          IF ( ICI.EQ.4 .OR. ICI.EQ.11) I=4
          IF ( ICI.EQ.5 .OR. ICI.EQ.12) I=6
          IF ( ICI.EQ.6 .OR. ICI.EQ.13) I=5
          IF ( ICI.EQ.7 .OR. ICI.EQ.14) I=3
          CTMP(5:5) = CHAR(51)
          CTMP(6:6) = CHAR(48+I)
          IF (ICI.GT.7) THEN
              CTMP(7:7) = CHAR(59)
              CTMP(8:8) = CHAR(49)
              CTMP(9:9) = CHAR(109)
              CALL GRTT02(ICHAN, MODE, CTMP, 9, CBUF, LBUF)
          ELSE
              CTMP(7:7) = CHAR(109)
              CALL GRTT02(ICHAN, MODE, CTMP, 7, CBUF, LBUF)
          END IF
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      IF (MODE.EQ.1 .OR. MODE.GT.5) THEN
C         -- tek4010, zstem, v603, krm3, or tk4100
          CTMP(1:6) = CHAR(GS)//CHAR(55)//CHAR(127)//CHAR(32)//
     :                CHAR(64)//CHAR(US)
          CALL GRTT02(ICHAN, MODE, CTMP, 6, CBUF, LBUF)
      ELSE IF (MODE.EQ.5) THEN
C         -- xterm
          CTMP(1:3) = CHAR(US)//CHAR(ESC)//CHAR(3)
          CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF)
      ELSE
          CTMP(1:8) = CHAR(GS)//CHAR(55)//CHAR(127)//CHAR(32)//
     :                CHAR(64)//CHAR(3)//CHAR(CAN)//CHAR(US)
          CALL GRTT02(ICHAN, MODE, CTMP, 8, CBUF, LBUF)
      END IF
      CALL GRWTER(ICHAN, CBUF, LBUF)
      LASTI = -1
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C
  170 CONTINUE
C     -- flush buffer
      CALL GRWTER(ICHAN, CBUF, LBUF)
      LASTI = -1
      IF ( MODE.EQ.5 .OR. MODE.EQ.6 ) THEN
C         -- xterm and zstem make sure terminal is in Tektronix mode.
          LTMP = 6
          CALL GRWTER(ICHAN, CHAR(ESC)//'[?38h', LTMP)
      END IF
C     -- initial cursor position
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
C     -- read cursor
      CALL GRTT03(ICHAN, I0, J0, ICH, IER)
C     -- on XTERM, map mouse button clicks onto A, D, X.
      IF (MODE.EQ.5) THEN
         IF (ICH.EQ.236) THEN
            ICH = ICHAR('a')
         ELSE IF (ICH.EQ.237) THEN
            ICH = ICHAR('d')
         ELSE IF (ICH.EQ.242) THEN
            ICH = ICHAR('x')
         ELSE IF (ICH.EQ.204) THEN
            ICH = ICHAR('A')
         ELSE IF (ICH.EQ.205) THEN
            ICH = ICHAR('D')
         ELSE IF (ICH.EQ.210) THEN
            ICH = ICHAR('X')
         END IF
      END IF
C     -- return result
      IF (IER.EQ.0) THEN
          RBUF(1) = I0
          RBUF(2) = J0
          CHR(1:1) = CHAR(ICH)
      ELSE
          CHR(1:1) = CHAR(0)
      END IF
      NBUF = 2
      LCHR = 1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C
  180 CONTINUE
      IF (MODE.EQ.2 .OR. MODE.EQ.3) THEN
C         -- GraphOn, Retrographics: return to VT100 mode and
C            issue VT100 erase-screen command
          CTMP(1:8) = CHAR(GS)//CHAR(55)//CHAR(127)//CHAR(32)//
     :                CHAR(64)//CHAR(3)//CHAR(CAN)//CHAR(US)
          CALL GRTT02(ICHAN, MODE, CTMP, 8, CBUF, LBUF)
          CTMP(1:7) = CHAR(ESC)//'[2J'//CHAR(ESC)//'[H'
          CALL GRTT02(ICHAN, MODE, CTMP, 7, CBUF, LBUF)
          LASTI = -1
      END IF
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      IF (MODE.EQ.4) THEN
C        -- gterm
         I = RBUF(1)
         CTMP(1:6) = CHAR(GS)//CHAR(ESC)//'TG14'
         LTMP = 6
         CALL GRTT05(I,     CADD, LADD)
         CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
         LTMP = LTMP + LADD
C        -- red
         INTEN = RBUF(2)*255.0
         CALL GRTT05(INTEN, CADD, LADD)
         CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
         LTMP = LTMP + LADD
C        -- green
         INTEN = RBUF(3)*255.0
         CALL GRTT05(INTEN, CADD, LADD)
         CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
         LTMP = LTMP + LADD
C        -- blue
         INTEN = RBUF(4)*255.0
         CALL GRTT05(INTEN, CADD, LADD)
         CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
         LTMP = LTMP + LADD
C
         CTMP(LTMP+1:LTMP+2) = CHAR(US)//CHAR(CAN)
         LTMP = LTMP + 2
         CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
         CALL GRWTER(ICHAN, CBUF, LBUF)
         LASTI = -1
      ELSE IF (MODE.EQ.9) THEN
C        -- TK4100
         I = RBUF(1)
         CTMP(1:5) = CHAR(ESC)//'TG14'
         LTMP = 5
         CALL GRTT05(I,     CADD, LADD)
         CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
         LTMP = LTMP + LADD
C        -- red
         INTEN = RBUF(2)*100.0
         CALL GRTT05(INTEN, CADD, LADD)
         CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
         LTMP = LTMP + LADD
C        -- green
         INTEN = RBUF(3)*100.0
         CALL GRTT05(INTEN, CADD, LADD)
         CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
         LTMP = LTMP + LADD
C        -- blue
         INTEN = RBUF(4)*100.0
         CALL GRTT05(INTEN, CADD, LADD)
         CTMP(LTMP+1:LTMP+LADD) = CADD(:LADD)
         LTMP = LTMP + LADD
         CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
         CALL GRWTER(ICHAN, CBUF, LBUF)
         LASTI = -1
      ELSE IF (MODE.EQ.10) THEN
C        -- VersaTerm
         CTMP(1:1)=CHAR(GS)
         CALL GRTT02(ICHAN, MODE, CTMP, 1, CBUF, LBUF)
         CALL GRXHLS(RBUF(2), RBUF(3), RBUF(4), HUE, LIG, SAT)
         CALL GRTT06(NINT(RBUF(1))
     :     , NINT(HUE), NINT(LIG*100), NINT(SAT*100), CTMP, LTMP)
         CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
         CALL GRWTER(ICHAN, CBUF, LBUF)
         LASTI = -1
      END IF
      RETURN
C
C--- IFUNC=24, Rectangle fill. -----------------------------------------
C
  240 CONTINUE
      IF ( I4014(MODE).EQ.0 ) THEN
         I0 = NINT(RBUF(1))
         J0 = NINT(RBUF(2))
         I1 = NINT(RBUF(3))
         J1 = NINT(RBUF(4))
      ELSE
         I0 = NINT(4.*RBUF(1))
         J0 = NINT(4.*RBUF(2))
         I1 = NINT(4.*RBUF(3))
         J1 = NINT(4.*RBUF(4))
      END IF
      IF (MODE.EQ.2) THEN
C         -- GraphOn
C         -- enter rectangle mode
          CALL GRTT02(ICHAN, MODE, CHAR(GS)//CHAR(ESC)//CHAR(2), 3,
     :         CBUF, LBUF)
C         -- draw rectangle
          CALL GRTT01(ICHAN, MODE, I4014(MODE), LASTI, LASTJ,
     :      I0, J0, I1, J1, CBUF, LBUF)
C         -- exit rectangle mode
          CALL GRTT02(ICHAN, MODE, CHAR(ESC)//CHAR(3), 2, CBUF, LBUF)
      ELSE IF (MODE.EQ.7 .OR. MODE.EQ.8) THEN
C         -- v603, krm3: needs bottom left corner and rectangle
C            dimensions
          IBUF(1)=I0+1
          IBUF(2)=J0+1
          IBUF(3)=I1+1
          IBUF(4)=J1+1
          DO 241 I=1,4
             IF (IBUF(I) .LT. 1)    IBUF(I)=1
             IF (IBUF(I) .GT. 1056) IBUF(I)=1056
  241     CONTINUE
          IBUF(3)=IBUF(3)-IBUF(1)
          IBUF(4)=IBUF(4)-IBUF(2)
          ITOT=0
          DO 244 I=1,4
             WRITE (CSCR(I)(1:4), '(I4)') IBUF(I)
             IBUF(I)=1
             DO 242 J=1,4
                IF (CSCR(I)(J:J) .NE. ' ') THEN
                   GOTO 243
                END IF
                IBUF(I)=IBUF(I)+1
  242        CONTINUE
  243        CONTINUE
             ITOT=ITOT+5-IBUF(I)
  244     CONTINUE
          CTMP(1:8+ITOT)=
     :         CHAR(ESC)//CHAR(47)//CSCR(1)(IBUF(1):4)//CHAR(59)//
     :         CSCR(2)(IBUF(2):4)//CHAR(59)//CSCR(3)(IBUF(3):4)//
     :         CHAR(59)//CSCR(4)(IBUF(4):4)//CHAR(59)//CHAR(49)//
     :         CHAR(121)
          CALL GRTT02(ICHAN, MODE, CTMP, 8+ITOT, CBUF, LBUF)
      ELSE IF (MODE.EQ.10) THEN
C         -- VMAC: use polygon fill commands
          IF (SEFCOL) THEN
C set fill color
            SEFCOL=.FALSE.
            CTMP(1:3) = CHAR(ESC)//'MP'
            CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF)
            CALL GRTT05(-ICI, CTMP, LTMP)
            CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
          ENDIF
C send "start polygon fill"
          CTMP(1:3) = CHAR(ESC)//'LP'
          LTMP=3
C make lasti,lastj different from i0,j0 in each bit
          LASTI=4095-I0
          LASTJ=4095-J0
C send first coordinate
          CALL GRTT04(I4014(MODE), LASTI, LASTJ, I0, J0, CTMP, LTMP)
          LASTI=I0
          LASTJ=J0
C '0' means: boundary has the same the color as fill area
          CTMP(LTMP+1:LTMP+1)='0'
          LTMP=LTMP+1
          CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
C further edges:
          CALL GRTT01(ICHAN, MODE, I4014(MODE), LASTI, LASTJ,
     :      I0, J1, I1, J1, CBUF, LBUF)
          CALL GRTT01(ICHAN, MODE, I4014(MODE), LASTI, LASTJ,
     :      I1, J1, I1, J0, CBUF, LBUF)
C send "end polygon fill"
          CTMP(1:3)=CHAR(ESC)//'LE'
          CALL GRTT02(ICHAN, MODE, CTMP, 3, CBUF, LBUF)
      END IF
      RETURN
C-----------------------------------------------------------------------
      END
C*GRTT01 -- PGPLOT Tektronix driver, draw line segment
C+
      SUBROUTINE GRTT01(ICHAN, MODE, I4014, LASTI, LASTJ, I0, J0,
     :         I1, J1, CBUF, LBUF)
      INTEGER   ICHAN, MODE, I4014, LASTI, LASTJ, I0, J0, I1, J1, LBUF
      CHARACTER CBUF*(*)
C
C This routine draws a line from (I0, J0) to (I1, J1).  If LASTI>=0
C assume that the cursor is at the position is at (LASTI, LASTJ).
C For this case, a minimum length move is done from (LASTI, LASTJ) to
C the nearer point.  Of course, if (LASTI, LASTJ) and the nearer point
C are the same, then no bytes of positioning data are generated and
C sent to the terminal.  If LASTI<0 then a move is done with the
C coordinate fully specified.  In both cases the line end point
C is specified using the fewest number of bytes allowed by the protocol.
C Upon return, LASTI,LASTJ will contain the current cursor position. 
C If I4014=0 then 10 bit (4010) coordinates are generated, for I4014=1,
C full 12 bit Tektronix (4014 and higher) coordinates are generated.
C Note:  The 'delete' character (127) can occur in LOY or EXTRA byte;
C it can be replaced by escape-? if desired.
C
C Arguments:
C   ICHAN       (in)     : passed to GRTT02 if called.
C   MODE        (in)     : passed to GRTT02 if called.
C   I4014       (in)     : =0 generate 4010 coords, =1 generate 4014.
C   LASTI,LASTJ (in/out) : current position
C   I0, J0      (in/out) : device coordinates of the starting point.
C   I1, J1      (in/out) : device coordinates of the end point.
C   CBUF        (in/out) : buffer for instruction.
C   LBUF        (in/out) : Number of valid characters in CBUF.
C
C 1993-Feb-02 - Created from GRZS01 - [AFT]
C-----------------------------------------------------------------------
      INTEGER    GS
      PARAMETER (GS = 29)
      INTEGER    MASKLX, MASKHX
      PARAMETER (MASKLX = 64, MASKHX = 32)
      INTEGER   MASKLY, MASKHY
      PARAMETER (MASKLY = 96, MASKHY = 32)
      INTEGER   MASKEX
      PARAMETER (MASKEX = 96)
C
      CHARACTER CTMP*12
      INTEGER ID0, ID1, IFLUSH, ITMP
      INTEGER IEX, ILOX, IHIX, ILOY, IHIY, LTMP
C
C If it is possible for this routine to generate enough data to fill
C the buffer, and thus cause it to be flushed to the terminal, then we
C force the write to take place now.  This will ensure that terminal
C is in the correct state for the following commands.
      IF ( LBUF+11.GE.LEN(CBUF) ) THEN
          CALL GRWTER(ICHAN, CBUF, LBUF)
          IFLUSH = 1
      ELSE
          IFLUSH = 0
      END IF
C
      LTMP = 0
      IF(LASTI.LT.0) THEN
C Last position is invalid, therefore do a dark vector move with all
C coordinates specified.
          LTMP=LTMP+1
          CTMP(LTMP:LTMP)=CHAR(GS)
          IF ( I4014.EQ.0 ) THEN
              IHIY = J0/32
              ILOY = MOD(J0, 32)
              IHIX = I0/32
              ILOX = MOD(I0, 32)
              CTMP(LTMP+1:LTMP+4) =
     :            CHAR( MASKHY + IHIY )//
     :            CHAR( MASKLY + ILOY )//
     :            CHAR( MASKHX + IHIX )//
     :            CHAR( MASKLX + ILOX )
              LTMP = LTMP + 4
          ELSE
              IHIY = J0/128
              ILOY = MOD(J0/4, 32)
              IHIX = I0/128
              ILOX = MOD(I0/4, 32)
              IEX  = 4*MOD(J0, 4) + MOD(I0, 4)
              CTMP(LTMP+1:LTMP+5) =
     :            CHAR( MASKHY + IHIY )//
     :            CHAR( MASKEX + IEX )//
     :            CHAR( MASKLY + ILOY )//
     :            CHAR( MASKHX + IHIX )//
     :            CHAR( MASKLX + ILOX )
              LTMP = LTMP + 5
          END IF
      ELSE
C Last position is valid, move pen to nearest end point of line.
          ID0=ABS(LASTI-I0)+ABS(LASTJ-J0)
          ID1=ABS(LASTI-I1)+ABS(LASTJ-J1)
          IF(ID1.LT.ID0) THEN
C Swap coordinates to minimize 'pen motion'.  For optimized coordinates
C this can reduce the amount of I/O to the the terminal.
              ITMP=I0
              I0=I1
              I1=ITMP
              ITMP=J0
              J0=J1
              J1=ITMP
              ITMP=ID0
              ID0=ID1
              ID1=ITMP
          END IF
          IF(ID0.NE.0 .OR. ID1.NE.0) THEN
C Position has changed, so do a move operation.
              LTMP=LTMP+1
              CTMP(LTMP:LTMP)=CHAR(GS)
              CALL GRTT04(I4014,LASTI,LASTJ,I0,J0,CTMP,LTMP)
          ELSE
              IF(IFLUSH.NE.0) THEN
C The position is valid, but the buffer was flushed, so terminal may
C no longer be in graph mode.  Therefore, send GS and followed by a
C zero length dark move (i.e., just resend LOX coordinate).
                  IF ( I4014.EQ.0 ) THEN
                      ILOX = MOD(I0, 32)
                  ELSE
                      ILOX = MOD(I0/4, 32)
                  END IF
                  CTMP(LTMP+1:LTMP+2)=CHAR(GS)//CHAR(MASKLX+ILOX)
                  LTMP=LTMP+2
              END IF
          END IF
      END IF
C
C Terminal is now in graph mode, and the `pen' has been positioned.
C Do an optimized draw.
      CALL GRTT04(I4014,I0,J0,I1,J1,CTMP,LTMP)
      CALL GRTT02(ICHAN, MODE, CTMP, LTMP, CBUF, LBUF)
C
C Remember current position.
      LASTI=I1
      LASTJ=J1
      RETURN
C
      END
C*GRTT02 -- PGPLOT Tektronix driver, transfer data to buffer
C+
      SUBROUTINE GRTT02 (ICHAN, MODE, CADD, LADD, CBUF, LBUF)
      INTEGER   ICHAN, MODE, LADD, LBUF
      CHARACTER CADD*(*), CBUF*(*)
C
C Arguments:
C   ICHAN  (input)  : channel number for output (when buffer is full).
C   MODE   (input)  : emulation type.
C   CADD   (input)  : text to add to buffer.
C   LADD   (input)  : number of characters to transfer.
C   CBUF   (input)  : output buffer.
C   LBUF   (in/out) : number of valid characters in CBUF.
C
C Subroutines called:
C   GRWTER
C-----------------------------------------------------------------------
      IF (LBUF+LADD.GE.LEN(CBUF) ) THEN
          CALL GRWTER(ICHAN, CBUF, LBUF)
      END IF
C
      IF ( LADD.GT.0 ) THEN
          IF ( LBUF.EQ.0 ) THEN
              IF ( MODE.EQ.5 .OR. MODE.EQ.6 ) THEN
                  CBUF(1:6) = CHAR(27)//'[?38h'
                  LBUF = 6
              END IF
          END IF
          CBUF(LBUF+1:LBUF+LADD) = CADD(1:LADD)
          LBUF = LBUF + LADD
      END IF
C-----------------------------------------------------------------------
      END
C*GRTT03 -- PGPLOT Tektronix driver, cursor routine
C+
      SUBROUTINE GRTT03 (ICHAN, IX, IY, IC, IER)
      INTEGER   ICHAN, IX, IY, IC, IER
C
C Arguments:
C   ICHAN  (input)  : channel for output to device.
C   IX, IY (in/out) : initial/final coordinates of cursor (device 
C                     coordinates).
C   IC     (output) : character code.
C   IER    (output) : error status (0 is OK).
C
C-----------------------------------------------------------------------
      CHARACTER CBUF*8, CPROM*10
      INTEGER   I1, I2, LBUF
C
C Position cursor (by drawing a dark vector).
C
      CPROM(1:1) = CHAR(29)
      CPROM(2:2) = CHAR(32+(IY/32))
      CPROM(3:3) = CHAR(96+MOD(IY,32))
      CPROM(4:4) = CHAR(32+(IX/32))
      CPROM(5:5) = CHAR(64+MOD(IX,32))
      CPROM(6:6) = CHAR(27)
      CPROM(7:7) = CHAR(47)
      CPROM(8:8) = CHAR(102)
      CPROM(9:9) = CHAR(27)
      CPROM(10:10) = CHAR(26)
C
C Do a read with prompt.
C
      LBUF = 5
      CALL GRPTER(ICHAN, CPROM, 10, CBUF, LBUF)
C
C Must read at least 5 characters.
C
      IF( LBUF.LT.5) THEN
         IER = 1
      ELSE
C
C Decode coordinates.
C
         IC = ICHAR( CBUF(1:1) )
         I1 = MOD( ICHAR(CBUF(2:2)), 32 )
         I2 = MOD( ICHAR(CBUF(3:3)), 32 )
         IX = I1*32 + I2
         I1 = MOD( ICHAR(CBUF(4:4)), 32 )
         I2 = MOD( ICHAR(CBUF(5:5)), 32 )
         IY = I1*32 + I2
         IER = 0
      END IF
      RETURN
C-----------------------------------------------------------------------
      END
C*GRTT04 -- PGPLOT Tektronix driver, encode coordinate pair, optimize
C+
      SUBROUTINE GRTT04(I4014, LASTI, LASTJ, I0, J0, CTMP, LTMP)
      INTEGER   I4014, LASTI, LASTJ, I0, J0, LTMP
      CHARACTER CTMP*(*)
C
C Assume cursor is at position LASTI, LASTJ and that the light or
C dark vector condition has been correctly set.  Add up to 5 characters
C to CTMP to draw a vector to I0, J0.  The minimum number of characters
C are encoded to obtain the motion.
C-----------------------------------------------------------------------
      INTEGER    MASKLX, MASKHX
      PARAMETER (MASKLX = 64, MASKHX = 32)
      INTEGER   MASKLY, MASKHY
      PARAMETER (MASKLY = 96, MASKHY = 32)
      INTEGER   MASKEX
      PARAMETER (MASKEX=96)
C
      INTEGER IEX, ILOX, IHIX, ILOY, IHIY
      INTEGER LEX, LLOX, LHIX, LLOY, LHIY
C
      IF ( I4014.EQ.0 ) THEN
          LHIY = LASTJ/32
          LLOY = MOD(LASTJ, 32)
          LHIX = LASTI/32
          LLOX = MOD(LASTI, 32)
          LEX = 0
          IHIY = J0/32
          ILOY = MOD(J0, 32)
          IHIX = I0/32
          ILOX = MOD(I0, 32)
          IEX = 0
      ELSE
          LHIY = LASTJ/128
          LLOY = MOD(LASTJ/4, 32)
          LHIX = LASTI/128
          LLOX = MOD(LASTI/4, 32)
          LEX = 4*MOD(LASTJ, 4) + MOD(LASTI, 4)
          IHIY = J0/128
          ILOY = MOD(J0/4, 32)
          IHIX = I0/128
          ILOX = MOD(I0/4, 32)
          IEX = 4*MOD(J0, 4) + MOD(I0, 4)
      END IF
C
      IF(IHIY.NE.LHIY) THEN
          LTMP=LTMP+1
          CTMP(LTMP:LTMP) = CHAR(32+IHIY)
      END IF
C Note, for 4010 mode, IEX=LEX (by definition)
      IF(IEX.NE.LEX) THEN
          LTMP=LTMP+1
          CTMP(LTMP:LTMP) = CHAR(96+IEX)
      END IF
      IF(IEX.NE.LEX .OR. ILOY.NE.LLOY .OR. IHIX.NE.LHIX) THEN
          LTMP=LTMP+1
          CTMP(LTMP:LTMP) = CHAR(96+ILOY)
      END IF
      IF(IHIX.NE.LHIX) THEN
          LTMP=LTMP+1
          CTMP(LTMP:LTMP) = CHAR(32+IHIX)
      END IF
      LTMP=LTMP+1
      CTMP(LTMP:LTMP) = CHAR(64+ILOX)
      RETURN
      END
C*GRTT05 -- PGPLOT Tektronix 4100 driver, encode integer
C+
      SUBROUTINE GRTT05(I, C, NC)
      INTEGER I
      CHARACTER*(*) C
      INTEGER NC
C
C Encode integer in host syntax. Input integer I; output encoded string
C C, containing NC characters (1, 2, or 3).  This version encodes
C integers up to 1023, which fit in two characters.
C-----------------------------------------------------------------------
      INTEGER J
C
      J = IABS(I)
      IF (J.LT.16) THEN
          IF (I.LT.0) THEN
              C(1:1) = CHAR(J+32)
          ELSE
              C(1:1) = CHAR(J+48)
          END IF
          NC = 1
      ELSE
          C(1:1) = CHAR(J/16+64)
          IF (I.LT.0) THEN
              C(2:2) = CHAR(MOD(J,16)+32)
          ELSE
              C(2:2) = CHAR(MOD(J,16)+48)
          END IF
          NC = 2
      END IF
C
      END
C*GRTT06 -- PGPLOT Tektronix 4100 driver, encode color definition
C+
      SUBROUTINE GRTT06(IDX, I1, I2, I3, C, NC)
      INTEGER ESC, GS, US
      PARAMETER (ESC=27, GS=29, US=31)
      INTEGER IDX, I1, I2, I3
      CHARACTER*(*) C
      INTEGER NC
C
C Encode color definition, Color index IDX, I1,I2,I3 are the 3 integer
C color components (definiton is device-dependent).
C output encoded string containing NC characters (max 20).
C-----------------------------------------------------------------------
      INTEGER L
C
      C(1:5) = CHAR(ESC)//'TG14'
      NC=5
      CALL GRTT05(IDX, C(NC+1:NC+3), L)
      NC=NC+L
      CALL GRTT05(I1, C(NC+1:NC+3), L)
      NC=NC+L
      CALL GRTT05(I2, C(NC+1:NC+3), L)
      NC=NC+L
      CALL GRTT05(I3, C(NC+1:NC+3), L)
      NC=NC+L
      END

C*PGQWIN -- inquire window boundary coordinates
C%void cpgqwin(float *x1, float *x2, float *y1, float *y2);
C+
      SUBROUTINE PGQWIN (X1, X2, Y1, Y2)
      REAL X1, X2, Y1, Y2
C
C Inquiry routine to determine the current window setting.
C The values returned are world coordinates.
C
C Arguments:
C  X1     (output) : the x-coordinate of the bottom left corner
C                    of the window.
C  X2     (output) : the x-coordinate of the top right corner
C                    of the window.
C  Y1     (output) : the y-coordinate of the bottom left corner
C                    of the window.
C  Y2     (output) : the y-coordinate of the top right corner
C                    of the window.
C--
C 26-Sep-1985 - new routine (TJP).
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
C
      X1 = PGXBLC(PGID)
      X2 = PGXTRC(PGID)
      Y1 = PGYBLC(PGID)
      Y2 = PGYTRC(PGID)
      END

C*PGSLS -- set line style
C%void cpgsls(int ls);
C+
      SUBROUTINE PGSLS (LS)
      INTEGER  LS
C
C Set the line style attribute for subsequent plotting. This
C attribute affects line primitives only; it does not affect graph
C markers, text, or area fill.
C Five different line styles are available, with the following codes:
C 1 (full line), 2 (dashed), 3 (dot-dash-dot-dash), 4 (dotted),
C 5 (dash-dot-dot-dot). The default is 1 (normal full line).
C
C Argument:
C  LS     (input)  : the line-style code for subsequent plotting
C                    (in range 1-5).
C--
C  8-Aug-1985 - new routine, equivalent to GRSLS [TJP].
C  3-Jun-1984 - add GMFILE device [TJP].
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSLS')) RETURN
      CALL GRSLS(LS)
      END

      PROGRAM PGDEM4
C-----------------------------------------------------------------------
C Test program for PGPLOT: test of imaging routine PGIMAG and associated
C routines PGWEDG and PGCTAB.
C-----------------------------------------------------------------------
      INTEGER PGOPEN
      INTEGER   MXI, MXJ
      PARAMETER (MXI=64, MXJ=64)
      INTEGER I, L, C1, C2, NC
      REAL F(MXI,MXJ)
      REAL FMIN,FMAX,TR(6), CONTRA, BRIGHT, ANGLE, C, S, ALEV(1)
      CHARACTER*16 VAL
C
C Introduction.
C
      WRITE(*,*)'Demonstration of PGIMAG and associated routines.'
      WRITE(*,*)'This program requires a device with color capability.'
      WRITE(*,*)'On an interactive device, you can modify the color map'
      WRITE(*,*)'used for the image.'
      WRITE(*,*)
C
C Open device for graphics.
C
      IF (PGOPEN('?') .LT. 1) STOP
      CALL PGQINF('TYPE', VAL, L)
      WRITE (*,*) 'PGPLOT device type: ', VAL(1:L)
      CALL PGQCIR(C1, C2)
      NC = MAX(0, C2-C1+1)
      WRITE (*,*) 'Number of color indices used for image: ', NC
      IF (NC .LT.8) THEN 
         WRITE (*,*) 'Not enough colors available on this device'
         STOP
      ELSE
         WRITE (*,*)
      END IF
C
C Compute a suitable function in array F.
C
      CALL FUNC(F, MXI, MXJ, FMIN, FMAX)
C
C-----------------------------------------------------------------------
C Example 1: simple transformation matrix
C-----------------------------------------------------------------------
C
C Set the coordinate transformation matrix: 
C world coordinate = pixel number.
C
      TR(1) = 0.0
      TR(2) = 1.0
      TR(3) = 0.0
      TR(4) = 0.0
      TR(5) = 0.0
      TR(6) = 1.0
C
C Clear the screen. Set up window and viewport.
C
      CALL PGPAGE
      CALL SETVP
      CALL PGWNAD(0.0, 1.0+MXI, 0.0, 1.0+MXJ)
C
C Set up the color map.
C
      BRIGHT = 0.5
      CONTRA  = 1.0
      CALL PALETT(2, CONTRA, BRIGHT)
C
C Draw the map with PGIMAG.  
C
      CALL PGIMAG(F,MXI,MXJ,1,MXI,1,MXJ,FMIN,FMAX,TR)
C
C Annotate the plot.
C
      CALL PGMTXT('t',1.0,0.0,0.0,'PGIMAG, PGWEDG, and PGCTAB')
      CALL PGSCH(0.6)
      CALL PGBOX('bcntsi',0.0,0,'bcntsiv',0.0,0)
      CALL PGMTXT('b',3.0,1.0,1.0,'pixel number')
C
C Draw a wedge.
C
      CALL PGWEDG('BI', 4.0, 5.0, FMIN, FMAX, 'pixel value')
      CALL PGSCH(1.0)
C
C If the device has a cursor, allow user to fiddle with color table.
C
      CALL PGQINF('CURSOR', VAL, L)
      IF (VAL(:L).EQ.'YES') THEN
         CALL FIDDLE
         CALL PGASK(.FALSE.)
      END IF
C
C-----------------------------------------------------------------------
C Example 2: rotation, overlay contours.
C-----------------------------------------------------------------------
C
C Compute the coordinate transformation matrix. The matrix is chosen
C to put array element (MXI/2, MXJ/2) at (X,Y)=(0,0), and map the
C entire array onto a square of side 2, rotated through angle ANGLE
C radians.
C
      ANGLE = 120.0/57.29578
      C = COS(ANGLE)
      S = SIN(ANGLE)
      TR(1) = -C - S
      TR(2) = 2.0*C/REAL(MXI)
      TR(3) = 2.0*S/REAL(MXJ)
      TR(4) = -C + S
      TR(5) = (-2.0)*S/REAL(MXI)
      TR(6) = 2.0*C/REAL(MXJ)
C
C Clear the screen. Set up window and viewport.
C
      CALL PGPAGE
      CALL SETVP
      CALL PGWNAD(-1.0, 1.0, -1.0, 1.0)
      CALL PGSCI(1)
C
C Set up the color map.
C
      BRIGHT = 0.5
      CONTRA  = 1.0
      CALL PALETT(2, CONTRA, BRIGHT)
C
C Draw the map with PGIMAG.  
C
      CALL PGIMAG(F,MXI,MXJ,1,MXI,1,MXJ,FMIN,FMAX,TR)
C
C Overlay contours in white.
C
      CALL PGSCI(1)
      DO 40 I=1,21
          ALEV(1) = FMIN + (I-1)*(FMAX-FMIN)/20.0
          IF (MOD(I,5).EQ.0) THEN
              CALL PGSLW(3)
          ELSE
              CALL PGSLW(1)
          END IF
          IF (I.LT.10) THEN
              CALL PGSLS(2)
          ELSE
              CALL PGSLS(1)
          END IF
          CALL PGCONT(F,MXI,MXJ,1,MXI,1,MXJ,ALEV,-1,TR)
   40 CONTINUE
      CALL PGSLS(1)
      CALL PGSLW(1)
C
C Annotate the plot.
C
      CALL PGSCI(1)
      CALL OUTLIN(1,MXI,1,MXJ,TR)
      CALL PGMTXT('t',1.0,0.0,0.0,'PGIMAG, PGCONT and PGWEDG')
      CALL PGSCH(0.6)
      CALL PGBOX('bctsn',0.0,0,'bctsn',0.0,0)
C
C Draw a wedge.
C
      CALL PGWEDG('BI', 4.0, 5.0, FMIN, FMAX, 'pixel value')
      CALL PGSCH(1.0)
C
C If the device has a cursor, allow user to fiddle with color table.
C
      CALL PGQINF('CURSOR', VAL, L)
      IF (VAL(:L).EQ.'YES') THEN
         CALL FIDDLE
      END IF
C
C Close the device and exit.
C
      CALL PGEND
C-----------------------------------------------------------------------
      END

      SUBROUTINE PALETT(TYPE, CONTRA, BRIGHT)
C-----------------------------------------------------------------------
C Set a "palette" of colors in the range of color indices used by
C PGIMAG.
C-----------------------------------------------------------------------
      INTEGER TYPE
      REAL CONTRA, BRIGHT
C
      REAL GL(2), GR(2), GG(2), GB(2)
      REAL RL(9), RR(9), RG(9), RB(9)
      REAL HL(5), HR(5), HG(5), HB(5)
      REAL WL(10), WR(10), WG(10), WB(10)
      REAL AL(20), AR(20), AG(20), AB(20)
C
      DATA GL /0.0, 1.0/
      DATA GR /0.0, 1.0/
      DATA GG /0.0, 1.0/
      DATA GB /0.0, 1.0/
C
      DATA RL /-0.5, 0.0, 0.17, 0.33, 0.50, 0.67, 0.83, 1.0, 1.7/
      DATA RR / 0.0, 0.0,  0.0,  0.0,  0.6,  1.0,  1.0, 1.0, 1.0/
      DATA RG / 0.0, 0.0,  0.0,  1.0,  1.0,  1.0,  0.6, 0.0, 1.0/
      DATA RB / 0.0, 0.3,  0.8,  1.0,  0.3,  0.0,  0.0, 0.0, 1.0/
C
      DATA HL /0.0, 0.2, 0.4, 0.6, 1.0/
      DATA HR /0.0, 0.5, 1.0, 1.0, 1.0/
      DATA HG /0.0, 0.0, 0.5, 1.0, 1.0/
      DATA HB /0.0, 0.0, 0.0, 0.3, 1.0/
C
      DATA WL /0.0, 0.5, 0.5, 0.7, 0.7, 0.85, 0.85, 0.95, 0.95, 1.0/
      DATA WR /0.0, 1.0, 0.0, 0.0, 0.3,  0.8,  0.3,  1.0,  1.0, 1.0/
      DATA WG /0.0, 0.5, 0.4, 1.0, 0.0,  0.0,  0.2,  0.7,  1.0, 1.0/
      DATA WB /0.0, 0.0, 0.0, 0.0, 0.4,  1.0,  0.0,  0.0, 0.95, 1.0/
C
      DATA AL /0.0, 0.1, 0.1, 0.2, 0.2, 0.3, 0.3, 0.4, 0.4, 0.5,
     :         0.5, 0.6, 0.6, 0.7, 0.7, 0.8, 0.8, 0.9, 0.9, 1.0/
      DATA AR /0.0, 0.0, 0.3, 0.3, 0.5, 0.5, 0.0, 0.0, 0.0, 0.0,
     :         0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0/
      DATA AG /0.0, 0.0, 0.3, 0.3, 0.0, 0.0, 0.0, 0.0, 0.8, 0.8,
     :         0.6, 0.6, 1.0, 1.0, 1.0, 1.0, 0.8, 0.8, 0.0, 0.0/
      DATA AB /0.0, 0.0, 0.3, 0.3, 0.7, 0.7, 0.7, 0.7, 0.9, 0.9,
     :         0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/
C
      IF (TYPE.EQ.1) THEN
C        -- gray scale
         CALL PGCTAB(GL, GR, GG, GB, 2, CONTRA, BRIGHT)
      ELSE IF (TYPE.EQ.2) THEN
C        -- rainbow
         CALL PGCTAB(RL, RR, RG, RB, 9, CONTRA, BRIGHT)
      ELSE IF (TYPE.EQ.3) THEN
C        -- heat
         CALL PGCTAB(HL, HR, HG, HB, 5, CONTRA, BRIGHT)
      ELSE IF (TYPE.EQ.4) THEN
C        -- weird IRAF
         CALL PGCTAB(WL, WR, WG, WB, 10, CONTRA, BRIGHT)
      ELSE IF (TYPE.EQ.5) THEN
C        -- AIPS
         CALL PGCTAB(AL, AR, AG, AB, 20, CONTRA, BRIGHT)
      END IF
      END

      SUBROUTINE SETVP
C-----------------------------------------------------------------------
C Set the viewport, allowing margins around the edge for annotation.
C (This is similar in effect to PGVSTD, but has different margins.)
C The routine determines the view-surface size and allocates margins
C as fractions of the minimum of width and height.
C-----------------------------------------------------------------------
      REAL D, VPX1, VPX2, VPY1, VPY2
C
      CALL PGSVP(0.0, 1.0, 0.0, 1.0)
      CALL PGQVP(1, VPX1, VPX2, VPY1, VPY2)
      D = MIN(VPX2-VPX1, VPY2-VPY1)/40.0
      VPX1 = VPX1 + 5.0*D
      VPX2 = VPX2 - 2.0*D
      VPY1 = VPY1 + 8.0*D
      VPY2 = VPY2 - 2.0*D
      CALL PGVSIZ(VPX1, VPX2, VPY1, VPY2)
      END

      SUBROUTINE FIDDLE
C
      INTEGER P, IER, PGCURS
      REAL CONTRA, BRIGHT, X, Y, SIGN
      REAL X1, Y1, X2, Y2, B1, B2, C1, C2
      CHARACTER CH
C
      WRITE (*,*) 'Use cursor to adjust color table:'
      WRITE (*,*) ' Keys 1,2,3,4,5 select different palettes'
      WRITE (*,*) ' Key P cycles through available palettes'
      WRITE (*,*) ' Key F adjusts contrast and brightness, with'
      WRITE (*,*) '  cursor x position setting brightness [0.0 - 1.0]'
      WRITE (*,*) '   and y position setting contrast [0.0 - 10.0]'
      WRITE (*,*) '  (Hold down F key while moving cursor to change'
      WRITE (*,*) '  contrast and brightness continuously)'
      WRITE (*,*) ' Key C resets contrast=1.0, brightness=0.5'
      WRITE (*,*) ' Key - reverses color palette'
      WRITE (*,*) ' Key X or right mouse button exits program' 
C
      P = 2
      CONTRA = 1.0
      BRIGHT = 0.5
      X = 0.5
      Y = 1.0
      SIGN = +1.0
C
      CALL PGQWIN(X1, X2, Y1, Y2)
      B1 = 0.0
      B2 = 1.0
      C1 = 0.0
      C2 = 10.0
      CALL PGSWIN(B1, B2, C1, C2)
 10   IER = PGCURS(X, Y, CH)
      IF (CH.EQ.CHAR(0) .OR. CH.EQ.'x' .OR. CH.EQ.'X') THEN
         CALL PGSWIN(X1, X2, Y1, Y2)
         RETURN
      ELSE IF (CH.EQ.'F' .OR. CH.EQ.'f') THEN
         BRIGHT = MAX(B1, MIN(B2,X))
         CONTRA = MAX(C1, MIN(C2,Y))
      ELSE IF (CH.EQ.'C' .OR. CH.EQ.'c') THEN
         CONTRA = 1.0
         Y = 1.0
         BRIGHT = 0.5
         X = 0.5
      ELSE IF (CH.EQ.'-') THEN
         SIGN = -SIGN
      ELSE IF (CH.EQ.'1') THEN
         P = 1
      ELSE IF (CH.EQ.'2') THEN
         P = 2
      ELSE IF (CH.EQ.'3') THEN
         P = 3
      ELSE IF (CH.EQ.'4') THEN
         P = 4
      ELSE IF (CH.EQ.'5') THEN
         P = 5
      ELSE IF (CH.EQ.'P' .OR. CH.EQ.'p') THEN
         P = 1 + MOD(P,5)
      END IF
      CALL PALETT(P, SIGN*CONTRA, BRIGHT)
      GOTO 10
      END

      SUBROUTINE FUNC(F, M, N, FMIN, FMAX)
      INTEGER M,N
      REAL F(M,N), FMIN, FMAX
C
      INTEGER I, J
      REAL R
C
      FMIN = 1E30
      FMAX = -1E30
      DO 20 I=1,M
         DO 10 J=1,N
            R = SQRT(REAL(I)**2 + REAL(J)**2)
            F(I,J) = COS(0.6*SQRT(I*80./M)-16.0*J/(3.*N))*
     :           COS(16.0*I/(3.*M))+(I/REAL(M)-J/REAL(N)) + 
     :           0.05*SIN(R)
            FMIN = MIN(F(I,J),FMIN)
            FMAX = MAX(F(I,J),FMAX)
 10      CONTINUE
 20   CONTINUE
      END

      SUBROUTINE OUTLIN(I1,I2,J1,J2,TR)
      INTEGER I1,I2,J1,J2
      REAL TR(6)
C-----------------------------------------------------------------------
C Draw the enclosing rectangle of the subarray to be contoured,
C applying the transformation TR.
C
C For a contour map, the corners are (I1,J1) and (I2,J2); for
C a gray-scale map, they are (I1-0.5,J1-0.5), (I2+0.5, J2+0.5).
C-----------------------------------------------------------------------
      INTEGER K
      REAL XW(5), YW(5), T
C
      XW(1) = I1
      YW(1) = J1
      XW(2) = I1
      YW(2) = J2
      XW(3) = I2
      YW(3) = J2
      XW(4) = I2
      YW(4) = J1
      XW(5) = I1
      YW(5) = J1
      DO 10 K=1,5
          T = XW(K)
          XW(K) = TR(1) + TR(2)*T + TR(3)*YW(K)
          YW(K) = TR(4) + TR(5)*T + TR(6)*YW(K)
   10 CONTINUE
      CALL PGLINE(5,XW,YW)
      END

C*GRQCI -- inquire current color index
C+
      SUBROUTINE GRQCI (C)
C
C GRPCKG: obtain the color index of the current graphics device.
C
C Argument:
C
C C (integer, output): receives the current color index (0-255).
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  C
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRQCI - no graphics device is active.')
          C = 1
      ELSE
          C = GRCCOL(GRCIDE)
      END IF
      END

C*PGSCIR -- set color index range
C%void cpgscir(int icilo, int icihi);
C+
      SUBROUTINE PGSCIR(ICILO, ICIHI)
      INTEGER   ICILO, ICIHI
C
C Set the color index range to be used for producing images with
C PGGRAY or PGIMAG. If the range is not all within the range supported
C by the device, a smaller range will be used. The number of
C different colors available for images is ICIHI-ICILO+1.
C
C Arguments:
C  ICILO  (input)  : the lowest color index to use for images
C  ICIHI  (input)  : the highest color index to use for images
C--
C 1994-Mar-17 : new routine [AFT/TJP].
C---
      INCLUDE 'pgplot.inc'
      INTEGER IC1, IC2
C---
      CALL GRQCOL(IC1,IC2)
      PGMNCI(PGID) = MIN(IC2,MAX(IC1,ICILO))
      PGMXCI(PGID) = MIN(IC2,MAX(IC1,ICIHI))
C
      END

C*PGEBUF -- end batch of output (buffer)
C%void cpgebuf(void);
C+
      SUBROUTINE PGEBUF
C
C A call to PGEBUF marks the end of a batch of graphical output begun
C with the last call of PGBBUF.  PGBBUF and PGEBUF calls should always
C be paired. Each call to PGBBUF increments a counter, while each call
C to PGEBUF decrements the counter. When the counter reaches 0, the
C batch of output is written on the output device.
C
C Arguments: none
C--
C 21-Nov-1985 - new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (.NOT.PGNOTO('PGEBUF')) THEN
          PGBLEV(PGID) = MAX(0, PGBLEV(PGID) - 1)
          IF (PGBLEV(PGID).EQ.0) CALL GRTERM
      END IF
      END

C GRSCRL -- scroll pixels in viewport
C+
      SUBROUTINE GRSCRL (DX, DY)
      INTEGER DX, DY
C
C Shift the pixels in the viewport by DX and DY in device coordinates.
C--
C 24-Feb-97: new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER NBUF, LCHR
      REAL RBUF(6)
      CHARACTER*8 CHR
C
C Do nothing if device is not open or not in appropriate state.
C
      IF (GRCIDE.LT.1) RETURN
      IF (.NOT.GRPLTD(GRCIDE)) RETURN
C
C If device has scroll capability, use it. The arguments in
C RBUF are: (1..4) current viewport in device coordinates; 
C (5..6) scroll displacement in world coordinates.
C
      IF (GRGCAP(GRCIDE)(11:11).EQ.'S') THEN
         RBUF(1) = NINT(GRXMIN(GRCIDE))
         RBUF(2) = NINT(GRYMIN(GRCIDE))
         RBUF(3) = NINT(GRXMAX(GRCIDE))
         RBUF(4) = NINT(GRYMAX(GRCIDE))
         RBUF(5) = DX
         RBUF(6) = DY
         NBUF = 6
         LCHR = 0
         CALL GREXEC(GRGTYP,30,RBUF,NBUF,CHR,LCHR)
C
C Otherwise, report an error.
C
      ELSE
         CALL GRWARN('Device does not support scrolling')
      END IF
      END

C*PGERAS -- erase all graphics from current page
C%void cpgeras(void);
C+
      SUBROUTINE PGERAS
C
C Erase all graphics from the current page (or current panel, if
C the view surface has been divided into panels with PGSUBP).
C
C Arguments: none
C--
C 24-Jun-1994
C-----------------------------------------------------------------------
      INTEGER CI, FS
      REAL XV1, XV2, YV1, YV2, XW1, XW2, YW1, YW2
      CALL PGBBUF
      CALL PGQCI(CI)
      CALL PGQFS(FS)
      CALL PGSCI(0)
      CALL PGSFS(1)
      CALL PGQWIN(XW1, XW2, YW1, YW2)
      CALL PGQVP(0, XV1, XV2, YV1, YV2)
      CALL PGSVP(0.0, 1.0, 0.0, 1.0)
      CALL PGRECT(XW1, XW2, YW1, YW2)
      CALL PGSVP(XV1, XV2, YV1, YV2)
      CALL PGSCI(CI)
      CALL PGSFS(FS)
      CALL PGEBUF
      END

C*PGERRX -- horizontal error bar
C%void cpgerrx(int n, const float *x1, const float *x2, \
C% const float *y, float t);
C+
      SUBROUTINE PGERRX (N, X1, X2, Y, T)
      INTEGER N
      REAL X1(*), X2(*), Y(*)
      REAL T
C
C Plot horizontal error bars.
C This routine draws an error bar only; to mark the data point in
C the middle of the error bar, an additional call to PGPT or
C PGERRY is required.
C
C Arguments:
C  N      (input)  : number of error bars to plot.
C  X1     (input)  : world x-coordinates of lower end of the
C                    error bars.
C  X2     (input)  : world x-coordinates of upper end of the
C                    error bars.
C  Y      (input)  : world y-coordinates of the data.
C  T      (input)  : length of terminals to be drawn at the ends
C                    of the error bar, as a multiple of the default
C                    length; if T = 0.0, no terminals will be drawn.
C
C Note: the dimension of arrays X1, X2, and Y must be greater
C than or equal to N. If N is 1, X1, X2, and Y may be scalar
C variables, or expressions, eg:
C       CALL PGERRX(1,X-SIGMA,X+SIGMA,Y)
C--
C (6-Oct-1983)
C 31-Mar-1997 - use pgtikl [TJP[.
C-----------------------------------------------------------------------
      INTEGER  I
      LOGICAL  PGNOTO
      REAL     XTIK, YTIK
C
      IF (PGNOTO('PGERRX')) RETURN
      IF (N.LT.1) RETURN
      CALL PGBBUF
C
      CALL PGTIKL(T, XTIK, YTIK)
      DO 10 I=1,N
          IF (T.NE.0.0) THEN
              CALL GRMOVA(X1(I),Y(I)-YTIK)
              CALL GRLINA(X1(I),Y(I)+YTIK)
          END IF
          CALL GRMOVA(X1(I),Y(I))
          CALL GRLINA(X2(I),Y(I))
          IF (T.NE.0.0) THEN
              CALL GRMOVA(X2(I),Y(I)-YTIK)
              CALL GRLINA(X2(I),Y(I)+YTIK)
          END IF
   10 CONTINUE
      CALL PGEBUF
      END

C*GRGLUN -- get a Fortran logical unit number (MS-DOS)
C+
      SUBROUTINE GRGLUN(LUN)
      INTEGER LUN
C
C Get an unused Fortran logical unit number.
C Returns a Logical Unit Number that is not currently opened.
C After GRGLUN is called, the unit should be opened to reserve
C the unit number for future calls.  Once a unit is closed, it
C becomes free and another call to GRGLUN could return the same
C number.  Also, GRGLUN will not return a number in the range 1-9
C as older software will often use these units without warning.
C
C Arguments:
C  LUN    : receives the logical unit number, or -1 on error.
C--
C 12-Feb-1989 [AFT/TJP].
C-----------------------------------------------------------------------
      INTEGER I
      LOGICAL QOPEN
C---
      DO 10 I=99,10,-1
          INQUIRE (UNIT=I,  OPENED=QOPEN)
          IF (.NOT.QOPEN) THEN
              LUN = I
              RETURN
          END IF
   10 CONTINUE
      CALL GRWARN('GRGLUN: out of units.')
      LUN = -1
      RETURN
      END

C*GRLIN0 -- draw a line
C+
      SUBROUTINE GRLIN0 (XP,YP)
C
C GRPCKG (internal routine): draw a line from the current position to a
C specified position, which becomes the new current position. This
C routine takes care of clipping at the viewport boundary, dashed and
C thick lines.
C
C Arguments:
C
C XP, YP (input, real): absolute device coordinates of the end-point of
C       the line.
C--
C 13-Jul-1984
C  7-May-1985 - add MIN/MAX kluge to prevent integer overflow [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      LOGICAL  VIS
      REAL     XP,YP, X0,Y0, X1,Y1
C
C End-points of line are (X0,Y0), (X1,Y1).
C
      X0 = GRXPRE(GRCIDE)
      Y0 = GRYPRE(GRCIDE)
      X1 = MIN(2E9,MAX(-2E9,XP))
      Y1 = MIN(2E9,MAX(-2E9,YP))
      GRXPRE(GRCIDE) = X1
      GRYPRE(GRCIDE) = Y1
C
C Change the end-points of the line (X0,Y0) - (X1,Y1)
C to clip the line at the window boundary.
C
      CALL GRCLPL(X0,Y0,X1,Y1,VIS)
      IF (.NOT.VIS) RETURN
C
C Draw the line in the appropriate style.
C
      IF (GRDASH(GRCIDE)) THEN
C         ! dashed line
         CALL GRLIN1(X0,Y0,X1,Y1,.FALSE.)
      ELSE IF (GRWIDT(GRCIDE).GT.1) THEN
C         ! heavy line
         CALL GRLIN3(X0,Y0,X1,Y1)
      ELSE
C         ! full line
         CALL GRLIN2(X0,Y0,X1,Y1)
      END IF
      END

C*PGSCRN -- set color representation by name
C%void cpgscrn(int ci, const char *name, int *ier);
C+
      SUBROUTINE PGSCRN(CI, NAME, IER)
      INTEGER CI
      CHARACTER*(*) NAME
      INTEGER IER
C
C Set color representation: i.e., define the color to be
C associated with a color index.  Ignored for devices which do not
C support variable color or intensity.  This is an alternative to
C routine PGSCR. The color representation is defined by name instead
C of (R,G,B) components.
C
C Color names are defined in an external file which is read the first
C time that PGSCRN is called. The name of the external file is
C found as follows:
C 1. if environment variable (logical name) PGPLOT_RGB is defined,
C    its value is used as the file name;
C 2. otherwise, if environment variable PGPLOT_DIR is defined, a
C    file "rgb.txt" in the directory named by this environment
C    variable is used;
C 3. otherwise, file "rgb.txt" in the current directory is used.
C If all of these fail to find a file, an error is reported and
C the routine does nothing.
C
C Each line of the file
C defines one color, with four blank- or tab-separated fields per
C line. The first three fields are the R, G, B components, which
C are integers in the range 0 (zero intensity) to 255 (maximum
C intensity). The fourth field is the color name. The color name
C may include embedded blanks. Example:
C
C 255   0   0 red
C 255 105 180 hot pink
C 255 255 255 white
C   0   0   0 black
C
C Arguments:
C  CI     (input)  : the color index to be defined, in the range 0-max.
C                    If the color index greater than the device
C                    maximum is specified, the call is ignored. Color
C                    index 0 applies to the background color.
C  NAME   (input)  : the name of the color to be associated with
C                    this color index. This name must be in the
C                    external file. The names are not case-sensitive.
C                    If the color is not listed in the file, the
C                    color representation is not changed.
C  IER    (output) : returns 0 if the routine was successful, 1
C                    if an error occurred (either the external file
C                    could not be read, or the requested color was
C                    not defined in the file).
C--
C 12-Oct-1992 [TJP]
C 31-May-1993 [TJP] use GROPTX to open file.
C  7-Nov-1994 [TJP] better error messages.
C-----------------------------------------------------------------------
      INTEGER MAXCOL
      PARAMETER (MAXCOL=1000)
      INTEGER I, IR, IG, IB, J, L, NCOL, UNIT, IOS
      INTEGER GRCTOI, GROPTX, GRTRIM
      REAL RR(MAXCOL), RG(MAXCOL), RB(MAXCOL)
      CHARACTER*20 CREQ, CNAME(MAXCOL)
      CHARACTER*255 TEXT
      SAVE NCOL, CNAME, RR, RG, RB
      DATA NCOL/0/
C
C On first call, read the database.
C
      IF (NCOL.EQ.0) THEN
          CALL GRGFIL('RGB', TEXT)
          L = GRTRIM(TEXT)
          IF (L.LT.1) L = 1
          CALL GRGLUN(UNIT)
          IOS = GROPTX(UNIT, TEXT(1:L), 'rgb.txt', 0)
          IF (IOS.NE.0) GOTO 40
          DO 10 I=1,MAXCOL
              READ (UNIT, '(A)', ERR=15, END=15) TEXT
              J = 1
              CALL GRSKPB(TEXT, J)
              IR = GRCTOI(TEXT, J)
              CALL GRSKPB(TEXT, J)
              IG = GRCTOI(TEXT, J)
              CALL GRSKPB(TEXT, J)
              IB = GRCTOI(TEXT, J)
              CALL GRSKPB(TEXT, J)
              NCOL = NCOL+1
              CALL GRTOUP(CNAME(NCOL), TEXT(J:))
              RR(NCOL) = IR/255.0
              RG(NCOL) = IG/255.0
              RB(NCOL) = IB/255.0
   10     CONTINUE
   15     CLOSE (UNIT)
          CALL GRFLUN(UNIT)
      END IF
C
C Look up requested color and set color representation if found.
C
      CALL GRTOUP(CREQ, NAME)
      DO 20 I=1,NCOL
          IF (CREQ.EQ.CNAME(I)) THEN
              CALL PGSCR(CI, RR(I), RG(I), RB(I))
              IER = 0
              RETURN
          END IF
   20 CONTINUE
C
C Color not found.
C
      IER = 1
      TEXT = 'Color not found: '//NAME
      CALL GRWARN(TEXT)
      RETURN
C
C Database not found.
C
   40 IER = 1
      NCOL = -1
      CALL GRFLUN(UNIT)
      CALL GRWARN('Unable to read color file: '//TEXT(1:L))
      CALL GRWARN('Use environment variable PGPLOT_RGB to specify '//
     :            'the location of the PGPLOT rgb.txt file.')
      RETURN
      END

C*GRTTER -- test whether device is user's terminal (VMS)
C+
      SUBROUTINE GRTTER(STRING, SAME)
      CHARACTER*(*) STRING
      LOGICAL SAME
C
C Return a logical flag indicating whether the supplied device
C name is a name for the user's controlling terminal or not.
C (Some PGPLOT programs wish to take special action if they are
C plotting on the user's terminal.)
C
C Arguments:
C  STRING : (input) the device name to be tested.
C  SAME   : (output) .TRUE. is STRING contains a valid name for the
C           user's terminal; .FALSE. otherwise.
C--
C 9-Feb-1988
C-----------------------------------------------------------------------
      INTEGER LIB$GETDVI
      INTEGER IER1, IER2, L1, L2
      CHARACTER*255 DEV1, DEV2
      EXTERNAL DVI$_FULLDEVNAM
C
      IER1 = LIB$GETDVI(%LOC(DVI$_FULLDEVNAM), , STRING, ,
     1                  DEV1, L1)
      IER2 = LIB$GETDVI(%LOC(DVI$_FULLDEVNAM), , 'TT:', ,
     1                  DEV2, L2)
      SAME = (IER1.EQ.1) .AND. (IER2.EQ.1) .AND.
     1       (L1.EQ.L2) .AND. (DEV1(:L1).EQ.DEV2(:L2))
      END

      PROGRAM DCHAR
C----------------------------------------------------------------------
C Display construction of Hershey character.
C This program uses the PGPLOT internal routine GRSYXD and must
C therefore be linked with the non-shareable library.
C                              T. J. Pearson  1983 Feb 12
C----------------------------------------------------------------------
      INTEGER PGBEG, HEIGHT, DEPTH, WIDTH
      INTEGER          XYGRID(300),I,N,M
      REAL             XC,YC,X(5),BASE
      LOGICAL          UNUSED,MOVE
      CHARACTER*4      TEXT
C-----------------------------------------------------------------------
      IF (PGBEG(0,'?',1,1).NE.1) STOP
      CALL PGASK(.FALSE.)
   20 WRITE (*,'(A,$)') ' Symbol number: '
      M = N
      READ (*,*,END=30) N
      IF (N.EQ.0) N = M+1
      CALL GRSYXD(N,XYGRID,UNUSED)
      IF (UNUSED) THEN
          WRITE (*,'(A)') ' Symbol not defined'
          GOTO 20
      END IF
C
C Call PGENV to initialize the viewport and window; the
C AXIS argument is -2, so no frame or labels will be drawn.
C
      CALL PGBBUF
      CALL PGENV(-50.,50.,-50.,50.0,1,-2)
C
C Call PGBOX to draw a grid at low brightness.
C
      CALL PGSCI(15)
      CALL PGSLW(1)
      CALL PGBOX('G',10.0,0,'G',10.0,0)
      CALL PGSCI(5)
C
      DO 15 I=1,5
         X(I) = XYGRID(I)
   15 CONTINUE
C
C Shift coordinates so baseline is y=0; center is (0,-BASE)
C
      BASE = X(2)
      X(1) = X(1)-BASE
      X(3) = X(3)-BASE
      HEIGHT=X(3)
      DEPTH = X(1)
      WIDTH =X(5)-X(4)
      WRITE(*,*) N, HEIGHT, DEPTH, WIDTH
C
C Draw the `bounding box'.
C
      CALL PGMOVE(X(4),X(1))
      CALL PGDRAW(X(5),X(1))
      CALL PGDRAW(X(5),X(3))
      CALL PGDRAW(X(4),X(3))
      CALL PGDRAW(X(4),X(1))
C
C Draw the baseline.
C
      CALL PGMOVE(-50.0, 0.0)
      CALL PGDRAW(50.0, 0.0)
C
C Mark the `center' of the character.
C
      CALL PGPT(1, 0.0, -BASE, 9)
C
C Write the Hershey number in lower left corner.
C
      WRITE (TEXT,'(I4)') N
      CALL PGTEXT(-49.0, -49.0, TEXT)
C
      CALL PGSCI(3)
      CALL PGSLW(3)
      I = 6
      MOVE = .TRUE.
   26 XC = XYGRID(I)
      I = I+1
      IF (XYGRID(I).EQ.-64) THEN
          CALL PGEBUF
          GOTO 20
      END IF
      YC = XYGRID(I)-BASE
      I = I+1
      IF (XYGRID(I-2).EQ.-64) THEN
          MOVE = .TRUE.
          GOTO 26
      END IF
      IF (MOVE) THEN
          CALL PGMOVE(XC,YC)
          MOVE = .FALSE.
      ELSE
          CALL PGDRAW(XC,YC)
      END IF
      GOTO 26
C
C Don't forget to call PGEND!
C
   30 CALL PGEND
      END

C*GRDTYP -- decode graphics device type string
C+
      INTEGER FUNCTION GRDTYP (TEXT)
C
C GRPCKG (internal routine): determine graphics device type code from
C type name. It compares the argument with the table of known device
C types in common.
C
C Argument:
C
C TEXT (input, character): device type name, eg 'PRINTRONIX'; the name
C       may be abbreviated to uniqueness.
C
C Returns:
C
C GRDTYP (integer): the device type code, in the range 1 to
C       GRTMAX, zero if the type name is not recognised, or -1
C       if the type name is ambiguous.
C--
C 27-Dec-1984 - rewrite so that is doesn't have to be modified for
C               new devices [TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 10-Nov-1995 - ignore drivers that report no device type [TJP].
C 30-Aug-1996 - check for an exact match; indicate if type is
C               ambiguous [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      CHARACTER*(*) TEXT
      INTEGER  CODE, I, L, MATCH
      REAL     RBUF(6)
      INTEGER NDEV,NBUF,LCHR
      INTEGER GRTRIM
      CHARACTER*32 CHR
C
      GRDTYP = 0
      L = GRTRIM(TEXT)
      IF (L.LT.1) RETURN
      MATCH = 0
      CODE = 0
      CALL GREXEC(0,0,RBUF,NBUF,CHR,LCHR)
      NDEV=NINT(RBUF(1))
      DO 30 I=1,NDEV
         CALL GREXEC(I, 1,RBUF,NBUF,CHR,LCHR)
         IF (LCHR.GT.0) THEN
            IF(TEXT(1:L).EQ.CHR(1:L)) THEN
               IF (CHR(L+1:L+1).EQ.' ') THEN
C                 -- exact match
                  GRDTYP = I
                  GRGTYP = GRDTYP
                  RETURN
               ELSE
                  MATCH = MATCH+1
                  CODE = I
               END IF
            END IF
         END IF
   30 CONTINUE
      IF (MATCH.EQ.0) THEN
C        -- no match
         GRDTYP = 0
      ELSE IF (MATCH.EQ.1) THEN
         GRDTYP = CODE
         GRGTYP = GRDTYP
      ELSE
         GRDTYP = -1
      END IF
C
      END

C*TFDRIV -- PGPLOT Tektronix file driver
C+
      SUBROUTINE TFDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Tektronix disk file. This version uses 
C the extended (12-bit) addressing of the Tektronix-4014.
C
C Version 1.0 - 1987 Aug 18 - T. J. Pearson.
C Version 1.1 - 1995 Mar 20 - David R. Chang (chang@firm.drea.dnd.ca):
C                             Optimized coordinate output.
C                             Implemented escape function.
C
C
C Supported device:  disk file which may be printable on a
C Tektronix-compatible device.
C
C Device type code: /TFILE. 
C
C Default device name: PGPLOT.TFPLOT.
C
C Default view surface dimension: Depends on printer; nominally
C 400 pixels/inch giving 10.24 in (horizontal) x 7.80 in (vertical).
C
C Resolution: The coordinate system used for Tektronix emulation is
C 4096 x 3120 pixels.
C
C Color capability: Only color index 1 is supported. Primitives drawn 
C in "erase" mode (color index 0) are ignored (not erased). It is not 
C possible to change color representation. 
C
C Input capability: None.
C 
C File format: Binary, variable length records (maximum 1024 bytes);
C no carriage-control attribute.
C 
C Obtaining hardcopy: depends on the available printer. e.g., for an
C Imagen printer with IMPRINT software,
C    $ IMPRINT/STYLE=TEKTRONIX file.type
C
C Note: the file cannot easily be displayed on a Tektronix-compatible
C *terminal* because it contains control characters which will be
C interpreted by the operating system. The terminal must be set to
C "Passall" mode before the file can be displayed.
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE, DEFNAM
      PARAMETER (DEFNAM='PGPLOT.TFPLOT')
      PARAMETER (TYPE='TFILE (disk file in Tektronix format)')
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=1024)
      INTEGER BUFFER
      INTEGER BUFLEV
      INTEGER UNIT, IER, I0, I1, J0, J1
      INTEGER I, LASTI, LASTJ
      INTEGER GRGMEM, GRFMEM
      CHARACTER*10 MSG
      INTEGER IC
      BYTE    TKBUF(12)
      INTEGER NW
      BYTE    TKTERM(6)
      DATA    TKTERM/29, 55, 127, 32, 64, 31/
      SAVE BUFFER, BUFLEV, IC, LASTI, LASTJ, TKTERM, UNIT
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in TFILE device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 4095
      RBUF(3) = 0
      RBUF(4) = 3119
      RBUF(5) = 0
      RBUF(6) = 1
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C    (Nominal values)
C
   30 RBUF(1) = 400.0
      RBUF(2) = 400.0
C      (multiple strokes are spaced by 2 pixels, or 1/200 inch; ideally
C       the printer `pen' width should be 1/200 inch)
      RBUF(3) = 2
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (Non-interactive, No cursor, No dashed lines, No area fill,
C    no thick lines)
C
   40 CHR = 'NNNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 4095
      RBUF(3) = 0
      RBUF(4) = 3119
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 8.0
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C     -- allocate buffer
      IER = GRGMEM(BUFSIZ, BUFFER)
      IF (IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRWARN('Failed to allocate plot buffer.')
          RBUF(2) = IER
          RETURN
      END IF
C     -- open device
      CALL GRGLUN(UNIT)
      NBUF = 2
      RBUF(1) = UNIT
      OPEN (UNIT=UNIT, FILE=CHR(:LCHR), CARRIAGECONTROL='NONE',
     1      DEFAULTFILE=DEFNAM, DISPOSE='DELETE', STATUS='NEW',
     2      FORM='UNFORMATTED', RECORDTYPE='VARIABLE', IOSTAT=IER,
     3      RECL=256)
      IF (IER.NE.0) THEN
          CALL GRWARN('Cannot open output file for '//TYPE//' plot: '//
     1                CHR(:LCHR))
          RBUF(2) = 0
          CALL GRFLUN(UNIT)
          IER = GRFMEM(BUFSIZ, BUFFER)
          RETURN
      ELSE
          INQUIRE (UNIT=UNIT, NAME=CHR)
          LCHR = LEN(CHR)
   91     IF (CHR(LCHR:LCHR).EQ.' ') THEN
              LCHR = LCHR-1
              GOTO 91
          END IF
          RBUF(2) = 1
      END IF
      IC = 1
      LASTI = -1
      LASTJ = -1
      BUFLEV=0
C     -- no device initialization required
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      CLOSE (UNIT, DISPOSE='KEEP')
      CALL GRFLUN(UNIT)
      IER = GRFMEM(BUFSIZ, BUFFER)
      IF (IER.NE.1) THEN
          CALL GRWARN('Error deallocating plot buffer.')
          CALL GRGMSG(IER)
      END IF
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
C     -- erase screen; no wait required
      TKBUF(1) = 29
      TKBUF(2) = 27
      TKBUF(3) = 12
      TKBUF(4) = 24
      NW = 4
      LASTI = -1
      GOTO 1000
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      IF (IC.EQ.0) RETURN
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
      CALL GRTF01(LASTI, LASTJ, I0, J0, I1, J1, TKBUF, NW)
      GOTO 1000
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      IF (IC.EQ.0) RETURN
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      CALL GRTF01(LASTI, LASTJ, I0, J0, I0, J0, TKBUF, NW)
      GOTO 1000
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      IF (IC.LT.0 .OR. IC.GT.1) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      CALL GRTF02(TKTERM,6,%val(BUFFER),BUFLEV,UNIT)
      CALL GRTF03(%val(BUFFER), UNIT, BUFLEV)
      LASTI = -1
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C           Not implemented.
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C    (Not implemented: ignored)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C
  230 CONTINUE
      IF (LCHR.LE.BUFSIZ) THEN
        LASTI = -1
        CALL GRTF02(%ref(CHR),LCHR,%val(BUFFER),BUFLEV,UNIT)
      ENDIF
      RETURN
C
C--- IFUNC=24, Rectangle fill. -----------------------------------------
C    (Not implemented: should not be called)
C
  240 CONTINUE
      GOTO 900
C
C--- Send the command. -------------------------------------------------
C
 1000 CALL GRTF02(TKBUF,NW,%val(BUFFER),BUFLEV,UNIT)
      RETURN
C-----------------------------------------------------------------------
      END

C*GRTF01 -- PGPLOT Tektronix file driver, draw line segment
C+
      SUBROUTINE GRTF01(LASTI, LASTJ, I0, J0, I1, J1, TKBUF, NW)
      INTEGER   LASTI, LASTJ, I0, J0, I1, J1, NW
      BYTE TKBUF(*)
C
C This routine draws a line from (I0, J0) to (I1, J1).  If LASTI>=0
C assume that the cursor is at the position is at (LASTI, LASTJ).
C For this case, a minimum length move is done from (LASTI, LASTJ) to
C the nearer point.  Of course, if (LASTI, LASTJ) and the nearer point
C are the same, then no bytes of positioning data are generated and
C sent to the file.  If LASTI<0 then a move is done with the
C coordinate fully specified.  In both cases the line end point
C is specified using the fewest number of bytes allowed by the protocol.
C Upon return, LASTI,LASTJ will contain the current cursor position. 
C Note:  The 'delete' character (127) can occur in LOY or EXTRA byte;
C it can be replaced by escape-? if desired.
C
C Arguments:
C   LASTI,LASTJ (in/out) : current position
C   I0, J0      (in/out) : device coordinates of the starting point.
C   I1, J1      (in/out) : device coordinates of the end point.
C   TKBUF       (out)    : buffer for instruction.
C   NW          (out)    : Number of valid characters in TKBUF.
C
C 1995-Mar-17 - Created from GRTT01 - [DRC]
C-----------------------------------------------------------------------
      INTEGER    GS
      PARAMETER (GS = 29)
      INTEGER    MASKLX, MASKHX
      PARAMETER (MASKLX = 64, MASKHX = 32)
      INTEGER   MASKLY, MASKHY
      PARAMETER (MASKLY = 96, MASKHY = 32)
      INTEGER   MASKEX
      PARAMETER (MASKEX = 96)
C
      INTEGER ID0, ID1, ITMP
      INTEGER IEX, ILOX, IHIX, ILOY, IHIY
C
      NW = 0
      IF(LASTI.LT.0) THEN
C Last position is invalid, therefore do a dark vector move with all
C coordinates specified.
          NW=NW+1
          TKBUF(NW) = GS
          IHIY = J0/128
          ILOY = MOD(J0/4, 32)
          IHIX = I0/128
          ILOX = MOD(I0/4, 32)
          IEX  = 4*MOD(J0, 4) + MOD(I0, 4)
          TKBUF(NW+1) = MASKHY + IHIY
          TKBUF(NW+2) = MASKEX + IEX
          TKBUF(NW+3) = MASKLY + ILOY
          TKBUF(NW+4) = MASKHX + IHIX
          TKBUF(NW+5) = MASKLX + ILOX
          NW = NW + 5
      ELSE
C Last position is valid, move pen to nearest end point of line.
          ID0=ABS(LASTI-I0)+ABS(LASTJ-J0)
          ID1=ABS(LASTI-I1)+ABS(LASTJ-J1)
          IF(ID1.LT.ID0) THEN
C Swap coordinates to minimize 'pen motion'.  For optimized coordinates
C this can reduce the amount of I/O to the file.
              ITMP=I0
              I0=I1
              I1=ITMP
              ITMP=J0
              J0=J1
              J1=ITMP
              ITMP=ID0
              ID0=ID1
              ID1=ITMP
          END IF
          IF(ID0.NE.0 .OR. ID1.NE.0) THEN
C Position has changed, so do a move operation.
              NW=NW+1
              TKBUF(NW)=GS
              CALL GRTF04(LASTI,LASTJ,I0,J0,TKBUF,NW)
          END IF
      END IF
C
C File is now in graph mode, and the `pen' has been positioned.
C Do an optimized draw.
      CALL GRTF04(I0,J0,I1,J1,TKBUF,NW)
C
C Remember current position.
      LASTI=I1
      LASTJ=J1
      RETURN
C-----------------------------------------------------------------------
      END

C*GRTF02 -- PGPLOT Tektronix file driver, transfer data to buffer
C+
      SUBROUTINE GRTF02 (INSTR, N, BUFFER, HWM, UNIT)
      INTEGER   N, HWM, UNIT
      BYTE      INSTR(*), BUFFER(*)
C
C Arguments:
C  INSTR  (input)  : text of instruction (bytes).
C  N      (input)  : number of bytes to transfer.
C  BUFFER (input)  : output buffer.
C  HWM    (in/out) : number of bytes used in BUFFER.
C  UNIT   (input)  : channel number for output (when buffer is full).
C
C Subroutines called:
C   GRTF03
C-----------------------------------------------------------------------
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=1024)
      INTEGER  I
C-----------------------------------------------------------------------
      IF (HWM+N.GE.BUFSIZ) CALL GRTF03(BUFFER, UNIT, HWM)
      DO 10 I=1,N
          HWM = HWM + 1
          BUFFER(HWM) = INSTR(I)
   10 CONTINUE
      RETURN
C-----------------------------------------------------------------------
      END

C*GRTF03 -- PGPLOT Tektronix file driver, copy buffer to file
C+
      SUBROUTINE GRTF03 (BUFFER, UNIT, N)
      BYTE BUFFER(*)
      INTEGER UNIT, N
C
C Arguments:
C   BUFFER (input) address of buffer to be output
C   UNIT   (input) unit number for output
C   N      (input) number of bytes to transfer
C          (output) set to zero
C-----------------------------------------------------------------------
      INTEGER J
C-----------------------------------------------------------------------
      IF (N.GT.0) WRITE (UNIT) (BUFFER(J),J=1,N)
      N = 0
      RETURN
C-----------------------------------------------------------------------
      END

C*GRTF04 -- PGPLOT Tektronix file driver, encode coordinate pair
C+
      SUBROUTINE GRTF04(LASTI, LASTJ, I0, J0, TKBUF, NW)
      INTEGER   LASTI, LASTJ, I0, J0, NW
      BYTE TKBUF(*)
C
C Assume cursor is at position LASTI, LASTJ and that the light or
C dark vector condition has been correctly set.  Add up to 5 characters
C to TKBUF to draw a vector to I0, J0.  The minimum number of characters
C are encoded to obtain the motion.
C
C 1995-Mar-17 - Created from GRTT04 - [DRC]
C-----------------------------------------------------------------------
      INTEGER    MASKLX, MASKHX
      PARAMETER (MASKLX = 64, MASKHX = 32)
      INTEGER   MASKLY, MASKHY
      PARAMETER (MASKLY = 96, MASKHY = 32)
      INTEGER   MASKEX
      PARAMETER (MASKEX=96)
C
      INTEGER IEX, ILOX, IHIX, ILOY, IHIY
      INTEGER LEX, LLOX, LHIX, LLOY, LHIY
C
      LHIY = LASTJ/128
      LLOY = MOD(LASTJ/4, 32)
      LHIX = LASTI/128
      LLOX = MOD(LASTI/4, 32)
      LEX = 4*MOD(LASTJ, 4) + MOD(LASTI, 4)
      IHIY = J0/128
      ILOY = MOD(J0/4, 32)
      IHIX = I0/128
      ILOX = MOD(I0/4, 32)
      IEX = 4*MOD(J0, 4) + MOD(I0, 4)
C
      IF(IHIY.NE.LHIY) THEN
          NW=NW+1
          TKBUF(NW) = 32+IHIY
      END IF
      IF(IEX.NE.LEX) THEN
          NW=NW+1
          TKBUF(NW) = 96+IEX
      END IF
      IF(IEX.NE.LEX .OR. ILOY.NE.LLOY .OR. IHIX.NE.LHIX) THEN
          NW=NW+1
          TKBUF(NW) = 96+ILOY
      END IF
      IF(IHIX.NE.LHIX) THEN
          NW=NW+1
          TKBUF(NW) = 32+IHIX
      END IF
      NW=NW+1
      TKBUF(NW) = 64+ILOX
      RETURN
      END

C*GRMSG -- issue message to user
C+
      SUBROUTINE GRMSG (TEXT)
      CHARACTER*(*) TEXT
C
C Display a message on standard output.
C
C Argument:
C  TEXT (input): text of message to be printed (the string
C      may not be blank).
C--
C  8-Nov-1994 [TJP].
C-----------------------------------------------------------------------
      INTEGER   GRTRIM
C
      IF (TEXT.NE.' ') THEN
          WRITE (*, '(1X,A)') TEXT(1:GRTRIM(TEXT))
      END IF
      END

C*DOCUMENT
C+
      PROGRAM DOCUME
C
C DOCUMENT extracts documentation from Fortran source code files. 
C Documentation information is flagged by special characters in
C columns 1--3:
C
C C+    Start of documentation block (this line
C       is not part of the block)
C
C C--   End of documentation block (this line
C       is not part of the block)
C
C C*    Start of a new module; the rest of line 
C       (up to first blank) is the module name. If no such delimiter
C       is encountered, the module name is the file name (excluding
C       disk, directory, type, version, etc.)
C
C Usage: 
C  DOCUMENT uses three control parameters:
C   INPUT:    the name of the input disk file(s), which may include
C             VMS wild-cards; must be specified.
C   LISTFILE: the name for the output listing; default |SYS$OUTPUT|.
C   TYPE:     specify the format for the output file as
C             `LIST' (default)
C             `INDEX' for index of modules only
C             `HELP' for a VMS help file
C             `TEX' for TeX code.
C
C History:
C  1.0:  1985 May 21 -- (T. J. Pearson, VAX-11 Fortran).
C  1.1:  1985 Oct  8 -- change delimiters to VLBA standard.
C  1.2:  1985 Oct  8 -- add TYPE parameter.
C  1.4:  1987 May 19 -- add TeX option.
C  1.5:  1987 Nov 12 -- add INDEX option.
C  2.0:  1992 Jun 16 -- remove use of Keyin.
C 
C Subroutines required:
C  |LIB$FIND_FILE|    (VMS) wild-card expansion.
C  |LIB$SYS_GETMSG|   (VMS) system error message.
C----------------------------------------------------------------------
C
C Constants.
C
      CHARACTER*(*) VERSN
      INTEGER    INC,OUTC,INDAT,PR
      INTEGER    RMS$_NMF
      PARAMETER  (VERSN='2.0 - 1992 Jun 16')
      PARAMETER  (INC=5,OUTC=6,INDAT=1,PR=2) 
C            ! I/O unit numbers
      PARAMETER  (RMS$_NMF = '000182CA'X)
C            ! VMS code <no more files found> 
C
C Variables.
C
      CHARACTER  INPFIL*128, INDSN*128, LISFIL*128
      CHARACTER  TEXT*128, TYPE*16, DEFNAM*32
      CHARACTER  LFMT*16
      INTEGER    L1, LINP, LLIS, NFIL
      INTEGER    CONTXT, I, IER, J, L, LDSN, MODE, NREC
      LOGICAL    PROPEN, COPY, HELP, TEX, INDX
C
C External functions.
C
      INTEGER    LIB$FIND_FILE, LEN1
      LOGICAL    ISTERM
C
C Formats.
C
  600 FORMAT(' DOCUMENT extracts documentation from source code'/
     1       ' (Version ',A,')'/)
  605 FORMAT(' Control parameters (INPUT, LISTFILE, TYPE;',
     1       ' end with /):')
  610 FORMAT(1X,A,T20,A)
  620 FORMAT(72('-'))
  650 FORMAT(' ++WARNING++ No documentation found in input file(s).')
C-----------------------------------------------------------------------
C
C Introduction.
C
      WRITE (OUTC,600) VERSN
C
C Control parameters.
C
      WRITE (OUTC, '('' Input file:  '',$)')
      READ (INC, '(A)', ERR=80, END=80) INPFIL
      LINP = LEN1(INPFIL)
      WRITE (OUTC, '('' Output file: '',$)')
      READ (INC, '(A)', ERR=80, END=80) LISFIL
      LLIS = LEN1(LISFIL)
      WRITE (OUTC, '('' Type (LIST, INDEX, HELP, TEX): '',$)')
      READ (INC, '(A)', ERR=80, END=80) TYPE
      HELP = TYPE(1:1).EQ.'H' .OR. TYPE(1:1).EQ.'h'
      TEX  = TYPE(1:1).EQ.'T' .OR. TYPE(1:1).EQ.'t'
      INDX = TYPE(1:1).EQ.'I' .OR. TYPE(1:1).EQ.'i'
      IF (HELP) THEN
          DEFNAM = 'DOCUMENT.HLP'
          LFMT = '(2X,A)'
      ELSE IF (TEX) THEN
          DEFNAM = 'DOCUMENT.TEX'
          LFMT = '(A)'
      ELSE
          DEFNAM = 'DOCUMENT.DOC'
          LFMT = '(A)'
      END IF
C
C Expand wild cards and open input file.
C
      PROPEN = .FALSE.
      CONTXT = 0
      NFIL = 0
   20 NFIL = NFIL+1
      IER = LIB$FIND_FILE(INPFIL(1:LINP),INDSN,CONTXT)
      IF (IER.EQ.RMS$_NMF) GOTO 80
      IF (MOD(IER,2).NE.1) THEN
          CALL LIB$SYS_GETMSG(IER,L,TEXT)
          WRITE (OUTC,'(1X,A)') TEXT(1:L)
          GOTO 80
      END IF
      OPEN (UNIT=INDAT, FILE=INDSN, STATUS='OLD', READONLY, 
     1      FORM='FORMATTED', ERR=80)
      INQUIRE (UNIT=INDAT, NAME=INDSN)
      LDSN = MIN(132,LEN1(INDSN))
C
C Open output file (first time only).
C
      IF (.NOT.PROPEN) THEN
          OPEN (UNIT=PR, FILE=LISFIL(1:LLIS), STATUS='NEW',
     1          CARRIAGECONTROL='LIST', IOSTAT=IER,
     2          DEFAULTFILE=DEFNAM, FORM='FORMATTED')
          IF (IER.NE.0) THEN
            WRITE (OUTC,'(1X,2A)') 'Cannot open LISTFILE, ',
     1                  LISFIL(1:LLIS)
            CLOSE (UNIT=INDAT)
            GOTO 80
          END IF
          PROPEN = .TRUE.
      END IF
C
C Write out file name.
C
      IF (INDX) THEN
          WRITE (PR, '(/A/)') INDSN(1:LDSN)
      END IF
C
C Read input file and look for flags.
C
      NREC = 0
      COPY = .FALSE.
   30 READ (INDAT,END=70,ERR=70, FMT='(Q,A)') L,TEXT
      IF (L.GE.3 .AND. TEXT(1:3).EQ.'C--') THEN
          IF (COPY.AND.TEX) WRITE (UNIT=PR, FMT='(A)') '\endtt}'
          COPY = .FALSE.
      END IF
      IF (COPY) THEN
          L1 = 1
          IF (TEXT(1:2).EQ.'C ') L1 = 3
          IF (L1.GT.L) L = L1
          WRITE (UNIT=PR, FMT=LFMT) TEXT(L1:L)
      END IF
      IF (L.GE.2 .AND. TEXT(1:2).EQ.'C+') THEN
          IF ((.NOT.COPY).AND.TEX) 
     1        WRITE (UNIT=PR, FMT='(A)') '{\eightpoint\begintt'
          COPY = .TRUE. .AND. (.NOT.INDX)
      END IF
      IF (L.GT.2 .AND. TEXT(1:2).EQ.'C*') THEN
           IF (HELP) THEN
               WRITE (UNIT=PR, FMT='(I1,1X,A)') 2,TEXT(3:L)
           ELSE IF (TEX) THEN
               WRITE (UNIT=PR, FMT='(/3A)') '\module{',TEXT(3:L),'}'
           ELSE IF (INDX) THEN
               WRITE (UNIT=PR, FMT='(A)') TEXT(3:L)
           ELSE
               WRITE (UNIT=PR, FMT='(/)')
               WRITE (UNIT=PR, FMT=620)
               WRITE (UNIT=PR, FMT='(2A)') 'Module: ',TEXT(3:L)
*              WRITE (UNIT=PR, FMT='(2A)') 'File:   ',INDSN(1:LDSN)
               WRITE (UNIT=PR, FMT=620)
               WRITE (UNIT=PR, FMT='(:)')
           END IF
      END IF
      NREC = NREC+1
      GOTO 30
C
C End of file: go and find another one.
C
   70 CLOSE (UNIT=INDAT)
      GOTO 20
C
C End of job: close output file if open, else give message.
C
   80 IF (PROPEN) THEN
          CLOSE (UNIT=PR)
      ELSE
          WRITE (UNIT=OUTC,FMT=650)
      END IF
C
      END

C*LEN1 -- length of string excluding trailing blanks
C+
      INTEGER FUNCTION LEN1(S)
      CHARACTER*(*) S
C
C Find the length of a character string excluding trailing blanks.
C A blank string returns a value of 0.
C
C Argument:
C  S      (input)  : character string.
C
C Returns:
C  LEN1            : number of characters in S, excluding trailing
C                    blanks, in range 0...LEN(S). A blank string
C                    returns a value of 0.
C
C Subroutines required:
C  None
C
C Fortran 77 extensions:
C  None
C
C History:
C  1987 Nov 12 - TJP.
C-----------------------------------------------------------------------
      INTEGER  I
C
      IF (S.EQ.' ') THEN
          LEN1 = 0
      ELSE
          DO 10 I=LEN(S),1,-1
              LEN1 = I
              IF (S(I:I).NE.' ') GOTO 20
   10     CONTINUE
          LEN1 = 0
   20     CONTINUE
      END IF
      END

      PROGRAM PGDE10
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT. 
C This program shows how the default colors can be 
C overridden with PGSCRN (or PGSCR). On some devices (those with a color
C lookup table), changing the background color (color index 0) takes 
C effect immediately, but on others it only affects elements that are
C explicitly drawn in the background color. Thus it is necessary to fill
C the page with the background color, which is here done with PGERAS,
C before drawing anything else (this means that PGENV cannot be used).
C-----------------------------------------------------------------------
      INTEGER PGBEG, I, IER
      REAL XS(9),YS(9), XR(101), YR(101)
C
C Start a new page.
C
      WRITE (*,*) 'This program is intended for use with color displays'
      IF (PGBEG(0,'?',1,1) .NE. 1) STOP
      CALL PGPAGE
C
C Override default colors.
C
      CALL PGSCRN(0, 'DarkSlateGray', IER)
      CALL PGSCRN(1, 'White', IER)
      CALL PGSCRN(2, 'Yellow', IER)
      CALL PGSCRN(3, 'Cyan', IER)
      CALL PGSCRN(4, 'SlateGray', IER)
C
C "Erase" the screen to fill with background color.
C
      CALL PGERAS
C
C Set up window and viewport.
C
      CALL PGSCH(1.5)
      CALL PGVSTD
      CALL PGSWIN(0.,10.,0.,0.65)
C
C Fill the viewport in a different color.
C
      CALL PGSCI(4)
      CALL PGRECT(0., 10., 0., 0.65)
C
C Annotation.
C
      CALL PGSCI(0)
      CALL PGBOX('G', 0.0, 0, 'G', 0.0, 0)
      CALL PGSCI(1)
      CALL PGSLW(3)
      CALL PGSCF(2)
      CALL PGBOX('BCNST', 0.0, 0, 'BCNSTV', 0.0, 0)
      CALL PGLAB('\fix', ' ', 
     :           '\frPGPLOT Graph: \fi y = x\u\fr2\de\u-\fix\d')
C
C Plot the graph.
C
      DO 10 I=1,101
          XR(I) = 0.1*(I-1)
          YR(I) = XR(I)**2*EXP(-XR(I))
 10   CONTINUE
      DO 20 I=1,9
          XS(I) = I
          YS(I) = XS(I)**2*EXP(-XS(I))
 20   CONTINUE
      CALL PGSCI(2)
      CALL PGSLW(4)
      CALL PGLINE(101,XR,YR)
      CALL PGSCI(3)
      CALL PGSCH(3.0)
      CALL PGPT(9,XS,YS,18)
C
C Done.
C
      CALL PGEND
C
      END

C*GRDATE -- get date and time as character string (Alliant-UNIX)
C+
      SUBROUTINE GRDATE(STRING, L)
      CHARACTER*(*) STRING
      INTEGER L
C
C Return the current date and time, in format 'dd-Mmm-yyyy hh:mm'.
C To receive the whole string, the STRING should be declared
C CHARACTER*17.
C
C Arguments:
C  STRING : receives date and time, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in STRING, excluding
C           trailing blanks. This will always be 17, unless the length
C           of the string supplied is shorter.
C--
C 28-Jul-1988
C 23-Oct-1989 ALF. Conforms to Alliant use of FDATE.
C-----------------------------------------------------------------------
      CHARACTER*24 UTIME, FDATE
      CHARACTER*17 VTIME
C
      UTIME = FDATE()
      VTIME(1:2) = UTIME(9:10)
      VTIME(3:3) = '-'
      VTIME(4:6) = UTIME(5:7)
      VTIME(7:7) = '-'
      VTIME(8:11) = UTIME(21:24)
      VTIME(12:12) = ' '
      VTIME(13:17) = UTIME(12:16)
      STRING = VTIME
      L = MIN(17, LEN(STRING))
      END

* Date:     27-MAR-1987 11:28:46
* From:     AFT%UK.AC.CAM.AST-STAR@AC.UK
* To:       TJP@CITPHOBO
* Subject:  ZEDRIVER.FOR (3)

C*ZEDRIV -- PGPLOT Zeta Plotter driver
     
      SUBROUTINE ZEDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
C--- GRPCKG driver for ZETA plotter.
C----
C Supported device:  Zeta 8 Digital Plotter.
C Device type code:  /ZEta
C Default file name:  PGPLOT.ZET
C Default view surface dimensions:  11 inches by 11 inches.  Current
C   version does not allow larger plots although the manual indicates
C   plots up to 144 feet are possible.
C Resolution:  This version is written for the case where the resolution
C   switch is set to .025 mm.  Actual resolution depends on thickness
C   of pen tip.
C Color capability:  Color indices 1 to 8 are supported corresponding
C   to pens 1-8.  It is not possible to erase lines.
C Input capability:  None.
C File format:  Variable length records with Carriage control of LIST.
C Obtaining hardcopy:  On Starlink print the file on the queue associated
C   with the Zeta plotter.  If the Plotter is attached to a terminal
C   line, then TYPEing the file at the terminal will produce a plot.
C   On Starlink:
C   $ PRINT/NOFEED/QUE=ZETA PGPLOT.ZET
C
C   To stop a Zeta plot job, once it has been started, use the buttons
C   on the plotter.  Press PAUSE, NEXT PLOT and CLEAR.  Only after
C   this sequence is it safe to delete the job from the ZETA Queue.
C   Failing to press the NEXT PLOT button will not correctly advance
C   the paper.  Failing to press CLEAR but, deleteing the current
C   job can prevent the following plot from being plotted.
C
C  5-Aug-1986 - [AFT].
C-----------------------------------------------------------------------
C     IMPLICIT NONE
      CHARACTER*(*) TYPE
      PARAMETER (TYPE='ZETA (Zeta 8 Digital Plotter)')
      INTEGER   IFUNC,NBUF,LCHR,I0,J0,I1,J1
      REAL      RBUF(6)
      CHARACTER CHR*(*)
      INTEGER   GRGE00
      CHARACTER COL(0:7)*2
      INTEGER   LUN,MXCNT,ICNT,IBADR
      SAVE      LUN,MXCNT,ICNT,IBADR
      DATA COL/'6A','61','62','63','64','65','66','67'/
C---
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     :     110,120,130,140,150,160) IFUNC
      GOTO 999
C---
C--- IFUNC= 1, Return device name.
 10   CHR=TYPE
      LCHR=LEN(TYPE)
      RETURN
C---
C--- IFUNC= 2, Return Physical min and max for plot device.
 20   RBUF(1)=0
      RBUF(2)=11175
      RBUF(3)=0
      RBUF(4)=11175
      RBUF(5)=1
      RBUF(6)=8
      NBUF=4
      RETURN
C---
C--- IFUNC= 3, Return device resolution.
 30   RBUF(1)=1007.0
      RBUF(2)=1007.0
      RBUF(3)=10
      NBUF=3
      RETURN
C---
C--- IFUNC= 4, Return misc device info.
 40   CHR='HNNNNNNNNN'
      LCHR=10
      RETURN
C---
C--- IFUNC= 5, Return default file name.
 50   CHR='PGPLOT.ZET'
      LCHR=LEN(CHR)
      RETURN
C---
C--- IFUNC= 6, Return default physical size of plot.
 60   RBUF(1)=0
      RBUF(2)=11175
      RBUF(3)=0
      RBUF(4)=11175
      RETURN
C---
C--- IFUNC= 7, Return misc defaults.
 70   RBUF(1)=15
      NBUF=1
      RETURN
C---
C--- IFUNC= 8, Set active plot.
 80   CALL INIT03(0,LUN,0)
      RETURN
C---
C--- IFUNC= 9, Open workstation.
 90   RBUF(2)=GRGE00('FFL',LUN,CHR,LCHR)
      RBUF(1)=LUN
      IF(RBUF(2).EQ.1) THEN
         MXCNT=130
         CALL GRGMEM(MXCNT,IBADR)
         ICNT=0
         CALL INIT03(0,LUN,0)
      END IF
      RETURN
C---
C--- IFUNC=10, Close workstation.
 100  CLOSE(UNIT=LUN)
      CALL GRFLUN(LUN)
      CALL GRFMEM(MXCNT,IBADR)
      RETURN
C---
C--- IFUNC=11, Begin Picture.
 110  CALL GRGE02(%ref('ZZZZZZZZZZ'), 10, %val(IBADR),ICNT,MXCNT)
      CALL GRGE02(%ref('0000000000CIII'), 14, %val(IBADR),ICNT,MXCNT)
      CALL INZE01
      RETURN
C---
C--- IFUNC=12, Draw line.
 120  I0=NINT(RBUF(1))
      J0=NINT(RBUF(2))
      I1=NINT(RBUF(3))
      J1=NINT(RBUF(4))
      CALL GRZE01(I0,J0,I1,J1,%val(IBADR),ICNT,MXCNT)
      RETURN
C---
C--- IFUNC=13, Draw dot.
 130  I0=NINT(RBUF(1))
      J0=NINT(RBUF(2))
      CALL GRZE01(I0,J0,I0,J0,%val(IBADR),ICNT,MXCNT)
      RETURN
C---
C--- IFUNC=14, End picture.
C--- Move pen to origin,
C--- Advance paper by 15 inches,
C--- Reset.
 140  CALL GRZE01(0,0,0,0,%val(IBADR),ICNT,MXCNT)
      CALL GRGE02(%ref('1OGUE'),5,%val(IBADR),ICNT,MXCNT)
      CALL GRGE02(%ref('70Z')  ,3,%val(IBADR),ICNT,MXCNT)
      RETURN
C---
C--- IFUNC=15, Select pen.
 150  I0=MAX(0,MIN(NINT(RBUF(1)),7))
      RBUF(1)=I0
      CALL GRGE02(%ref(COL(I0)),2,%val(IBADR),ICNT,MXCNT)
      RETURN
C---
C--- IFUNC=16, Flush buffer.
 160  CALL GRGE03(%val(IBADR),ICNT)
      RETURN
C---
C--- Flag function not implemented.
 999  NBUF=-1
      RETURN
C---
      END

C*GRZE01 -- PGPLOT Zeta Plotter driver, line segment

      SUBROUTINE GRZE01 (I0,J0,I1,J1,IBUF,ICNT,MXCNT)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, ZETA): draw a line segment.
C
C Arguments:
C
C I0,J0 (integer, input): the column and row numbers of the starting
C       point.
C I1,J1 (integer, input): the column and row numbers of the end point.
C
C 15-NOV-83
C-----------------------------------------------------------------------
C     IMPLICIT NONE
      INTEGER    ISIZE
      PARAMETER (ISIZE=11176)
      INTEGER   I0, I1, J0, J1, IBUF(*), ICNT, MXCNT
      CHARACTER CPEN(2), CSTR*8
      INTEGER   II0, II1, JJ0, JJ1, I
      INTEGER   IDX(2), IDY(2), LASTX, LASTY
      SAVE      LASTX,LASTY
      DATA CSTR(2:2)/'R'/, CPEN/'1','2'/
C---
      II0= MOD(I0, ISIZE)
      II1= MOD(I1, ISIZE)
      JJ0= MOD(J0, ISIZE)
      JJ1= MOD(J1, ISIZE)
C
      IDX(1)= II0-LASTX
      IDY(1)= JJ0-LASTY
      IDX(2)= II1-II0
      IDY(2)= JJ1-JJ0
C
C  First iteration moves to starting point, second draws line.
C
      DO 100 I= 1, 2
         CSTR(1:1)= CPEN(I)
         IF(IDX(I).NE.0  .OR. IDY(I).NE.0) THEN
            CALL GRZE04(IDX(I), CSTR, 3)
            CALL GRZE04(IDY(I), CSTR, 6)
            CALL GRGE02(%ref(CSTR), 8, IBUF,ICNT,MXCNT)
         ELSE IF(I .EQ. 2) THEN
            CALL GRGE02(%ref(CSTR), 1, IBUF,ICNT,MXCNT)
         END IF
 100  CONTINUE
C
      LASTX= II1
      LASTY= JJ1
      RETURN
C---
      ENTRY INZE01
C
C  This entry is called by to initialize a new plot.
C
      LASTX= 0
      LASTY= 0
      RETURN
      END

C*GRZE04 -- PGPLOT Zeta Plotter driver, string generation

      SUBROUTINE GRZE04(NUM, CSTR, NC)
C-----------------------------------------------------------------
C  Generate strings for sending to Zeta plotter.
C
C- NUM          I   I   Number to be converted.
C- CSTR         I/O C   Output character array.
C- NC           I/O I   Start location in CSTR
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     IMPLICIT NONE
      INTEGER   NUM,NC
      CHARACTER CSTR*(*)
      INTEGER   ITMP, I, IDIV, IND
      CHARACTER CFIG(0:31)
C
      DATA CFIG/'0','1','2','3','4','5','6','7','A',
     :    'B','C','D','E','F','G','H','I','J','K','L','M','N','O',
     :    'P','Q','R','S','T','U','V','W','X'/
C
      ITMP=NUM
      IF(NUM .LT. 0) ITMP= NUM+32768
      IDIV= 1
      DO 100 I=NC+2,NC,-1
         IND= MOD(ITMP/IDIV, 32)
         IF(IND .LT. 0) IND= 32+IND
         CSTR(I:I)= CFIG(IND)
         IDIV= IDIV*32
 100  CONTINUE
      END

C*PGPNTS -- draw several graph markers, not all the same
C%void cpgpnts(int n, const float *x, const float *y, \
C% const int *symbol, int ns);
C+
      SUBROUTINE PGPNTS (N, X, Y, SYMBOL, NS)
      INTEGER N, NS
      REAL X(*), Y(*)
      INTEGER SYMBOL(*)
C
C Draw Graph Markers. Unlike PGPT, this routine can draw a different
C symbol at each point. The markers are drawn using the current values
C of attributes color-index, line-width, and character-height
C (character-font applies if the symbol number is >31).  If the point
C to be marked lies outside the window, no marker is drawn.  The "pen 
C position" is changed to (XPTS(N),YPTS(N)) in world coordinates
C (if N > 0).
C
C Arguments:
C  N      (input)  : number of points to mark.
C  X      (input)  : world x-coordinate of the points.
C  Y      (input)  : world y-coordinate of the points.
C  SYMBOL (input)  : code number of the symbol to be plotted at each
C                    point (see PGPT).
C  NS     (input)  : number of values in the SYMBOL array.  If NS <= N,
C                    then the first NS points are drawn using the value
C                    of SYMBOL(I) at (X(I), Y(I)) and SYMBOL(1) for all
C                    the values of (X(I), Y(I)) where I > NS.
C
C Note: the dimension of arrays X and Y must be greater than or equal
C to N and the dimension of the array SYMBOL must be greater than or
C equal to NS.  If N is 1, X and Y may be scalars (constants or
C variables).  If NS is 1, then SYMBOL may be a scalar.  If N is
C less than 1, nothing is drawn.
C--
C 11-Mar-1991 - new routine [JM].
C 26-Feb-1997 - revised to use PGPT1 [TJP].
C-----------------------------------------------------------------------
      INTEGER I, SYMB
C
      IF (N.LT.1) RETURN
      CALL PGBBUF
      DO 10 I=1,N
          IF (I .LE. NS) THEN
              SYMB = SYMBOL(I)
          ELSE
              SYMB = SYMBOL(1)
          END IF
          CALL PGPT1(X(I), Y(I), SYMB)
   10 CONTINUE
      CALL PGEBUF
      END

C*LSDRIV -- PGPLOT driver for Canon LaserShot

      SUBROUTINE LSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,MODE)
      INTEGER   IFUNC, NBUF, LCHR, MODE
      REAL      RBUF(*)
      CHARACTER CHR*(*)
C
C PGPLOT driver for Canon LaserShot printer (LIPS2/2+).
C
C Supported device:  Canon LaserShot (LIPS2/2+).
C   Conforms to ISO646,2022,2375 and 6429 specifications.
C   VDM (graphics) conforms to proposed American National
C   Standard VDM mode.
C
C Device type code:  /LIPS2 (landscape, mode 1)
C                    /VLIPS2 (portrait, mode 2).
C
C Default file name:  PGPLOT.LPS
C
C Default view surface dimensions:
C                    23 cm by 18 cm (landcsape)
C                    18 cm by 23 cm (portrait)
C
C Resolution:  240 pixels per inch in both directions.
C
C Color capability:  Color indices 0 (erase) and 1 (black) are
C   supported.  Note, hardware polygon fill is used and colors
C   0-11 control the fill pattern.
C
C Input capability:  None.
C
C File format:  Variable length text records.
C
C Obtaining hardcopy:  use lpr (unix) or print (dos) command.
C
C 17-Aug-1994 - [M.Hamabe] modified from cadriver.f
C 18-Aug-1994 - [T.Pearson] merge landscape and portrait drivers
C-----------------------------------------------------------------------
      CHARACTER*(*) DEFNAM
      PARAMETER (DEFNAM='PGPLOT.LPS')
      INTEGER    IS2,    IVESC
      PARAMETER (IS2=30, IVESC=125)
C- The maximum physical size of the plot in units of 0.1 mm.
      INTEGER    MXLEN,      MXWID
      PARAMETER (MXLEN=2870, MXWID=1900)
C- Default size of plot.
      INTEGER    IDEFL,      IDEFW
      PARAMETER (IDEFL=2300, IDEFW=1800)
C
      CHARACTER CBUF*256
      CHARACTER MSG*10
      CHARACTER CDASH(5),CFILL(0:11)
      INTEGER   GROPTX
      INTEGER   I0, J0, I1, J1, IER
      INTEGER   LUN, ICOL, NPTS, LBUF, LASX, LASY
      SAVE      LUN, ICOL, NPTS, LBUF, LASX, LASY
C---
C- Patterns defined with 2 and " appear the same on our Canon
C- so only one is used.  Pattern 0 causes the polygon not to
C- be filled.  Pattern ) erases interior of polygon is the
C- last character in list as all colors > max are set to
C- this pattern.
      DATA CFILL/')','1','(','''','&','%',
     :          '$','2','#','!','0',')'/
      DATA CDASH/'0','1','3','"','4'/
C---
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     :     110,120,130,140,150,160,900,180,190,200,
     :     210) IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in LS device driver: '//MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC= 1, Return device name. -------------------------------------
10      IF (MODE.EQ.1) THEN
            CHR='LIPS2 (Canon LIPS2 file, landscape orientation)'
        ELSE
            CHR='VLIPS2 (Canon LIPS2 file, portrait orientation)'
        END IF
        LCHR=48
        RETURN
C
C--- IFUNC= 2, Return Physical min and max for plot device. ------------
20      IF (MODE.EQ.1) THEN
            RBUF(2)=MXLEN
            RBUF(4)=MXWID
        ELSE
            RBUF(2)=MXWID
            RBUF(4)=MXLEN
        END IF
        RBUF(1)=0
        RBUF(3)=0
        RBUF(5)=0
        RBUF(6)=11
        NBUF=6
        RETURN
C
C--- IFUNC= 3, Return device resolution. -------------------------------
30      RBUF(1)=254.0
        RBUF(2)=254.0
        RBUF(3)=1
        NBUF=3
        RETURN
C
C--- IFUNC= 4, Return misc device info. --------------------------------
40      CHR='HNNANNNNNN'
        LCHR=10
        RETURN
C
C--- IFUNC= 5, Return default file name. -------------------------------
50      CHR=DEFNAM
        LCHR=LEN(DEFNAM)
        RETURN
C
C--- IFUNC= 6, Return default physical size of plot. -------------------
60      IF (MODE.EQ.1) THEN
            RBUF(2)=IDEFL
            RBUF(4)=IDEFW
        ELSE
            RBUF(2)=IDEFW
            RBUF(4)=IDEFL
        ENDIF
        RBUF(1)=0
        RBUF(3)=0
        NBUF=4
        RETURN
C
C--- IFUNC= 7, Return misc defaults. -----------------------------------
70      RBUF(1)=1
        NBUF=1
        RETURN
C
C--- IFUNC= 8, Select plot. --------------------------------------------
80      RETURN
C
C--- IFUNC= 9, Open workstation. ---------------------------------------
90      CALL GRGLUN (LUN)
        IER = GROPTX(LUN, CHR(1:LCHR), DEFNAM, 1)
        IF (IER.EQ.0) THEN
          RBUF(2)=1
        ELSE
          CALL GRWARN('Cannot open output file for LPS plot')
          RBUF(2) = 0
          CALL GRFLUN(LUN)
        ENDIF
        RBUF(1)=LUN
        RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
100     CLOSE(UNIT=LUN)
        CALL GRFLUN (LUN)
        RETURN
C
C--- IFUNC=11, Begin Picture. ------------------------------------------
110     CALL GRLS03(LUN,1,MODE)
C- Use the origin transfer command to ensure that the picture is
C- centered on the page.
        IF (MODE.EQ.1) THEN
            I0=(MXLEN-NINT(RBUF(1)))/2
            J0=(MXWID-NINT(RBUF(2)))/2
        ELSE
            I0=(MXWID-NINT(RBUF(1)))/2
            J0=(MXLEN-NINT(RBUF(2)))/2
        END IF
        CBUF(1:2)=CHAR(IVESC)//'"'
        LBUF=2
        CALL GRLS04(J0,CBUF,LBUF)
        CALL GRLS04(I0,CBUF,LBUF)
        LBUF=LBUF+1
        CBUF(LBUF:LBUF)=CHAR(IS2)
        WRITE(LUN,11) CBUF(:LBUF)
        RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
120     I0=NINT(RBUF(1))
        J0=NINT(RBUF(2))
        I1=NINT(RBUF(3))
        J1=NINT(RBUF(4))
        CALL GRLS01(LUN,I0,J0,I1,J1)
        RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
130     I0=NINT(RBUF(1))
        J0=NINT(RBUF(2))
        CALL GRLS01(LUN,I0,J0,I0,J0)
        RETURN
C
C--- IFUNC=14, End Picture. --------------------------------------------
140     CALL GRLS03(LUN,2,MODE)
        RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C- Save pen number (up to 11) for possible use in pattern interior.
150     ICOL=MAX(0,MIN(NINT(RBUF(1)),11))
        RBUF(1)=MAX(0,MIN(ICOL,1))
        IF(ICOL.EQ.0) THEN
          CBUF(1:4)=CHAR(IVESC)//'G2'//CHAR(IS2)
        ELSE
          CBUF(1:4)=CHAR(IVESC)//'G0'//CHAR(IS2)
        END IF
        WRITE(LUN,11) CBUF(:4)
        RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
160     RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
180     RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C- Currently turned off, since pattern is reset at beginning of
C- every new line segment.  Note, if GRLS01 was modified to
C- properly use polylines then dash pattern may work better.
190     CBUF(1:4)='E1'//CDASH(NINT(RBUF(1)))//CHAR(IS2)
        WRITE(LUN,11) CBUF(:4)
        RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
200     IF(NPTS.EQ.0) THEN
            NPTS=RBUF(1)
            CBUF(1:5)='I'//CFILL(ICOL)//'0'//CHAR(IS2)//'2'
            LBUF=5
            LASX=0
            LASY=0
        ELSE
            NPTS=NPTS-1
            I0=NINT(RBUF(1))
            J0=NINT(RBUF(2))
            CALL GRLS04(J0-LASY,CBUF,LBUF)
            CALL GRLS04(I0-LASX,CBUF,LBUF)
            LASX=I0
            LASY=J0
            IF(NPTS.EQ.0) THEN
                LBUF=LBUF+1
                CBUF(LBUF:LBUF)=CHAR(IS2)
                WRITE(LUN,11) CBUF(:LBUF)
11              FORMAT(A)
                LBUF=0
            END IF
        END IF
        RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C- (not possible but can be called).
210     RETURN
C-----------------------------------------------------------------------
        END

C*GRLS01 -- PGPLOT driver for Canon LaserShot, line segment

      SUBROUTINE GRLS01 (LUN,I0,J0,I1,J1)
C-----------------------------------------------------------------------
C Canon device driver support routine.  Draws a line segment.
C Current routine plots end line segment as a separate polyline.
C This can be improved.
C
C I0,J0         I  I    The coordinate of the start point.
C I1,J1         I  I    The coordinate of the end point.
C
C 26-JUN-86 - [AFT]
C-----------------------------------------------------------------------
      INTEGER    IS2
      PARAMETER (IS2=30)
      INTEGER   LUN, I0, J0, I1, J1
      INTEGER   LBUF, IX, IY
      CHARACTER CBUF*64
C---
      CBUF(1:1)='1'
      LBUF=1
      CALL GRLS04(J0,CBUF,LBUF)
      CALL GRLS04(I0,CBUF,LBUF)
      IX=I1-I0
      IY=J1-J0
      CALL GRLS04(IY,CBUF,LBUF)
      CALL GRLS04(IX,CBUF,LBUF)
      LBUF=LBUF+1
      CBUF(LBUF:LBUF)=CHAR(IS2)
      WRITE(LUN,11) CBUF(1:LBUF)
 11   FORMAT(A)
      RETURN
      END

C*GRLS03 -- PGPLOT driver for Canon LaserShot, begin/end picture

      SUBROUTINE GRLS03(LUN,ICMD,MODE)
C-----------------------------------------------------------------------
C Canon LIPS2 device driver support routine.  Outputs to LUN the string
C that begins a new picture (ICMD=1) or ends the current picture (ICMD=2).
C
C- LUN          I  I    Logical unit of output file.
C- ICMD         I  I    =1 to begin plot, =2 to terminate plot.
C- MODE         I  I    =1 for landcsape, =2 for portrait.
C
C 19-Aug-1994 - [M.Hamabe, Inst.of Astron., U.Tokyo, Japan]
C               Modified version of grca03.f (for LIPS2 command)
C-----------------------------------------------------------------------
      INTEGER    IESC,    IS2
      PARAMETER (IESC=27, IS2=30)
      INTEGER   LUN,ICMD,MODE
      CHARACTER CBUF*35
C---
      IF(ICMD.EQ.1) THEN
C           - Go to ISO mode (ignored if in ISO mode already), Hard reset,
C           - and then go to ISO again (in case dip switches set to Diablo).
         CBUF( 1: 4)=CHAR(IESC)//';'//CHAR(IESC)//'c'
         CBUF( 5: 6)=CHAR(IESC)//';'
C           - Define paper orientation
         IF (MODE.EQ.1) THEN
            CBUF( 7:11)=CHAR(IESC)//CHAR(91)//'14p'
         ELSE
            CBUF( 7:11)=CHAR(IESC)//CHAR(91)//'15p'
         END IF
C           - Enable full paint mode.
         CBUF(12:16)=CHAR(IESC)//CHAR(91)//'2&z'
C           - Go to vector mode.
         CBUF(17:20)=CHAR(IESC)//CHAR(91)//'&'//CHAR(125)
C           - Begin picture
         CBUF(21:28)='#PGPLOT'//CHAR(IS2)
C           - Scaling mode 1 pixel, Begin picture body.
         CBUF(29:35)='!0#1'//CHAR(IS2)//'$'//CHAR(IS2)
         WRITE(LUN,'(A)') CBUF(1:35)
      ELSE IF(ICMD.EQ.2) THEN
C           - End picture, Return to text (0,0)
         CBUF(1:7)='%'//CHAR(IS2)//CHAR(125)//'p00'//CHAR(IS2)
         WRITE(LUN,'(A)') CBUF(1: 7)
      END IF
      RETURN
      END

C*GRLS04 -- PGPLOT driver for Canon LaserShot, convert integer

      SUBROUTINE GRLS04(NUM,CBUF,LBUF)
C-----------------------------------------------------------------------
C Canon device driver support routine.  Converts an integer into
C the form used by the Canon Laser printer.
C
C- NUM          I   I   Integer to be converted.
C- CBUF         I/O C*  Buffer string
C- LBUF         I/O I   Number of characters used in CBUF.
C
C 26-Jun-86 - [AFT]
C-----------------------------------------------------------------------
      CHARACTER CBUF*(*)
      INTEGER   NUM, LBUF
      INTEGER   ITMP, IS, IC
      CHARACTER CTMP*5
C---
      ITMP=NUM
C     - Bit 4(=16) is set for positive numbers and clear for negative.
      IS=16
      IF(ITMP.LT.0) THEN
         IS=0
         ITMP=-ITMP
      END IF
C     - Bits 6+7(=64,128) clear and Bit 5(=32) set, flags that this
C     - is the last byte in the number.
      CTMP(5:5)=CHAR(32+IS+IAND(ITMP,15))
      ITMP=ITMP/16
      IC=1
      IF(ITMP.EQ.0) THEN
C     - Numbers in the range -15 to +15 can be sent in one byte.
         CBUF(LBUF+1:LBUF+1)=CTMP(5:5)
      ELSE
C     - Larger numbers require more bytes and are recorded 6 bits
C     - per byte with bit 7=(128) clear and bit 6(=64) set.
 150     CTMP(5-IC:5-IC)=CHAR(64+IAND(ITMP,63))
         IC=IC+1
         ITMP=ITMP/64
         IF(ITMP.NE.0) GOTO 150
         CBUF(LBUF+1:LBUF+IC)=CTMP(6-IC:5)
      END IF
      LBUF=LBUF+IC
      RETURN
      END

C*GREXEC -- PGPLOT device handler dispatch routine
C 12/93 C. T. Dum: version for MS F32 Power Station
C+
      SUBROUTINE GREXEC(IDEV,IFUNC,RBUF,NBUF,CHR,LCHR)
      INTEGER IDEV, IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C---
      INTEGER NDEV
      PARAMETER (NDEV=7)
      CHARACTER*10 MSG
C---
      GOTO(1,2,3,4,5,6,7) IDEV
      IF (IDEV.EQ.0) THEN
          RBUF(1) = NDEV
          NBUF = 1
      ELSE
          WRITE (MSG,'(I10)') IDEV
          CALL GRQUIT('Unknown device code in GREXEC: '//MSG)
      END IF
      RETURN
C---
    1 CALL NUDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      RETURN
    2 CALL MSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      RETURN
    3 CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1)
      RETURN
    4 CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,2)
      RETURN
    5 CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,3)
      RETURN
    6 CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,4)
      RETURN
    7 CALL LXDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      RETURN
C    8 CALL HJDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
C      RETURN
      END

C*GRCURS -- read cursor position
C+
      INTEGER FUNCTION GRCURS (IDENT,IX,IY,IXREF,IYREF,MODE,POSN,CH)
      INTEGER IDENT, IX, IY, IXREF, IYREF, MODE, POSN
      CHARACTER*(*) CH
C
C GRPCKG: Read the cursor position and a character typed by the user.
C The position is returned in absolute device coordinates (pixels).
C GRCURS positions the cursor at the position specified, and
C allows the user to move the cursor using the joystick or
C arrow keys or whatever is available on the device. When he has
C positioned the cursor, the user types a single character on his
C keyboard; GRCURS then returns this character and the new cursor
C position.
C
C "Rubber band" feedback of cursor movement can be requested (although
C it may not be supported on some devices). If MODE=1, a line from
C the anchor point to the current cursor position is displayed as
C the cursor is moved. If MODE=2, a rectangle with vertical and
C horizontal sides and one vertex at the anchor point and the opposite
C vertex at the current cursor position is displayed as the cursor is
C moved.
C
C Returns:
C
C GRCURS (integer): 1 if the call was successful; 0 if the device
C      has no cursor or some other error occurs. 
C
C Arguments:
C
C IDENT (integer, input):  GRPCKG plot identifier (from GROPEN).
C IX    (integer, in/out): the device x-coordinate of the cursor.
C IY    (integer, in/out): the device y-coordinate of the cursor.
C IXREF (integer, input):  x-coordinate of anchor point.
C IYREF (integer, input):  y-coordinate of anchor point.
C MODE  (integer, input):  type of rubber-band feedback.
C CH    (char,    output): the character typed by the user; if the device
C      has no cursor or if some other error occurs, the value CHAR(0)
C      [ASCII NUL character] is returned.
C--
C  1-Aug-1984 - extensively revised [TJP].
C 29-Jan-1985 - add ARGS and HP2648 devices (?) [KS/TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 11-Jun-1987 - remove built-ins [TJP].
C 15-Feb-1988 - remove test for batch jobs; leave this to the device
C               handler [TJP].
C 13-Dec-1990 - remove code to abort after 10 cursor errors [TJP].
C  7-Sep-1994 - add support for rubber-band modes [TJP].
C 17-Jan-1995 - start picture if necessary [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      REAL           RBUF(6)
      INTEGER        NBUF, LCHR, ICURS, ERRCNT
      CHARACTER*16   CHR
      CHARACTER      C
      SAVE           ERRCNT
      DATA           ERRCNT/0/
C
C Validate identifier, and select device.
C
      CALL GRSLCT(IDENT)
      CALL GRTERM
C
C Begin picture if necessary.
C
      IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
C
C Make sure cursor is on view surface. (It does not
C have to be in the viewport.)
C
      IX = MAX(0,MIN(GRXMXA(GRCIDE),IX))
      IY = MAX(0,MIN(GRYMXA(GRCIDE),IY))
C
C Does the device have a cursor?
C
      C = GRGCAP(GRCIDE)(2:2)
      ICURS = 0
      IF (C.EQ.'C' .OR. C.EQ.'X') ICURS=1
C
C Device does have a cursor.
C
      IF (ICURS.GT.0) THEN
C         -- initial position of cursor
          RBUF(1) = IX
          RBUF(2) = IY
C         -- reference point for rubber band
          RBUF(3) = IXREF
          RBUF(4) = IYREF
C         -- rubber band mode
          RBUF(5) = MODE
C         -- position cursor?
          RBUF(6) = POSN
          NBUF = 6
          LCHR = 0
          CALL GREXEC(GRGTYP,17,RBUF,NBUF,CHR,LCHR)
          IX = RBUF(1)
          IY = RBUF(2)
          CH = CHR(1:1)
          GRCURS = 1
C         -- error if driver returns NUL
          IF (ICHAR(CHR(1:1)).EQ.0) GRCURS = 0
C
C Other devices are illegal.
C
      ELSE
          CALL GREXEC(GRGTYP, 1,RBUF,NBUF,CHR,LCHR)
          LCHR = INDEX(CHR,' ')
          IF (ERRCNT.LE.10) CALL 
     1        GRWARN('output device has no cursor: '//CHR(:LCHR))
          CH = CHAR(0)
          GRCURS = 0
          ERRCNT = ERRCNT+1
      END IF
C
      END

C*PGSHLS -- set color representation using HLS system
C%void cpgshls(int ci, float ch, float cl, float cs);
C+
      SUBROUTINE PGSHLS (CI, CH, CL, CS)
      INTEGER CI
      REAL    CH, CL, CS
C
C Set color representation: i.e., define the color to be
C associated with a color index.  This routine is equivalent to
C PGSCR, but the color is defined in the Hue-Lightness-Saturation
C model instead of the Red-Green-Blue model. Hue is represented
C by an angle in degrees, with red at 120, green at 240,
C and blue at 0 (or 360). Lightness ranges from 0.0 to 1.0, with black
C at lightness 0.0 and white at lightness 1.0. Saturation ranges from
C 0.0 (gray) to 1.0 (pure color). Hue is irrelevant when saturation
C is 0.0.
C
C Examples:           H     L     S        R     G     B
C     black          any   0.0   0.0      0.0   0.0   0.0
C     white          any   1.0   0.0      1.0   1.0   1.0
C     medium gray    any   0.5   0.0      0.5   0.5   0.5
C     red            120   0.5   1.0      1.0   0.0   0.0
C     yellow         180   0.5   1.0      1.0   1.0   0.0
C     pink           120   0.7   0.8      0.94  0.46  0.46
C
C Reference: SIGGRAPH Status Report of the Graphic Standards Planning
C Committee, Computer Graphics, Vol.13, No.3, Association for
C Computing Machinery, New York, NY, 1979. See also: J. D. Foley et al,
C ``Computer Graphics: Principles and Practice'', second edition,
C Addison-Wesley, 1990, section 13.3.5.
C
C Argument:
C  CI     (input)  : the color index to be defined, in the range 0-max.
C                    If the color index greater than the device
C                    maximum is specified, the call is ignored. Color
C                    index 0 applies to the background color.
C  CH     (input)  : hue, in range 0.0 to 360.0.
C  CL     (input)  : lightness, in range 0.0 to 1.0.
C  CS     (input)  : saturation, in range 0.0 to 1.0.
C--
C 9-May-1988 - new routine [TJP].
C-----------------------------------------------------------------------
      REAL CR, CG, CB
      CALL GRXRGB (CH,CL,CS,CR,CG,CB)
      CALL GRSCR(CI,CR,CG,CB)
      END

C*PGERRY -- vertical error bar
C%void cpgerry(int n, const float *x, const float *y1, \
C% const float *y2, float t);
C+
      SUBROUTINE PGERRY (N, X, Y1, Y2, T)
      INTEGER N
      REAL X(*), Y1(*), Y2(*)
      REAL T
C
C Plot vertical error bars.
C This routine draws an error bar only; to mark the data point in
C the middle of the error bar, an additional call to PGPT or
C PGERRX is required.
C
C Arguments:
C  N      (input)  : number of error bars to plot.
C  X      (input)  : world x-coordinates of the data.
C  Y1     (input)  : world y-coordinates of top end of the
C                    error bars.
C  Y2     (input)  : world y-coordinates of bottom end of the
C                    error bars.
C  T      (input)  : length of terminals to be drawn at the ends
C                    of the error bar, as a multiple of the default
C                    length; if T = 0.0, no terminals will be drawn.
C
C Note: the dimension of arrays X, Y1, and Y2 must be greater
C than or equal to N. If N is 1, X, Y1, and Y2 may be scalar
C variables or expressions, eg:
C       CALL PGERRY(1,X,Y+SIGMA,Y-SIGMA)
C--
C (6-Oct-1983)
C 31-Mar-1997 - use pgtikl [TJP].
C-----------------------------------------------------------------------
      INTEGER  I
      LOGICAL  PGNOTO
      REAL     XTIK, YTIK
C
      IF (PGNOTO('PGERRY')) RETURN
      IF (N.LT.1) RETURN
      CALL PGBBUF
C
      CALL PGTIKL(T, XTIK, YTIK)
      DO 10 I=1,N
          IF (T.NE.0.0) THEN
              CALL GRMOVA(X(I)-XTIK,Y1(I))
              CALL GRLINA(X(I)+XTIK,Y1(I))
          END IF
          CALL GRMOVA(X(I),Y1(I))
          CALL GRLINA(X(I),Y2(I))
          IF (T.NE.0.0) THEN
              CALL GRMOVA(X(I)-XTIK,Y2(I))
              CALL GRLINA(X(I)+XTIK,Y2(I))
          END IF
   10 CONTINUE
      CALL PGEBUF
      END

C*PGVSIZE -- non-standard alias for PGVSIZ
C+
      SUBROUTINE PGVSIZE (XLEFT, XRIGHT, YBOT, YTOP)
      REAL XLEFT, XRIGHT, YBOT, YTOP
C
C See description of PGVSIZ.
C--
      CALL PGVSIZ (XLEFT, XRIGHT, YBOT, YTOP)
      END

C*GRDOT0 -- draw a dot
C+
      SUBROUTINE GRDOT0 (X,Y)
C
C GRPCKG (internal routine): Draw a single dot (pixel) at a specified
C location.
C
C Arguments:
C
C X, Y (real, input): absolute device coordinates of the dot (these
C       are rounded to the nearest integer by GRDOT0).
C--
C (1-Jun-1984)
C 22-Oct-1984 - rewrite [TJP].
C 29-Jan-1985 - add HP2648 device [KS/TJP].
C  5-Aug-1986 - add GREXEC support [AFT].
C 21-Feb-1987 - If needed, calls begin picture [AFT].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  NBUF, LCHR
      REAL     X, Y, RBUF(6)
      CHARACTER CHR
C
C (X,Y) is the new current position.
C
      GRXPRE(GRCIDE) = X
      GRYPRE(GRCIDE) = Y
C
C Check window.
C
      IF (X .LT. GRXMIN(GRCIDE)) RETURN
      IF (X .GT. GRXMAX(GRCIDE)) RETURN
      IF (Y .LT. GRYMIN(GRCIDE)) RETURN
      IF (Y .GT. GRYMAX(GRCIDE)) RETURN
C
C Begin picture if necessary.
C
      IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
C
C If a "thick pen" is to be simulated, use the line-drawing routines
C instead.
C
      IF (GRWIDT(GRCIDE).GT.1) THEN
          CALL GRLIN3(X,Y,X,Y)
      ELSE
          RBUF(1)=X
          RBUF(2)=Y
          NBUF=2
          CALL GREXEC(GRGTYP,13,RBUF,NBUF,CHR,LCHR)
      END IF
      END

      SUBROUTINE GRMCUR (ICH, ICX, ICY)
      INTEGER ICH, ICX, ICY
C
C Cursor movement:
C Input: ICH character code
C In/Out: ICX, ICY cursor position
C-----------------------------------------------------------------------
      INTEGER STEP
      SAVE STEP
      DATA STEP /4/
C
C     Up arrow or keypad 8:
      IF (ICH.EQ.-1 .OR. ICH.EQ.-28) THEN
          ICY = ICY+STEP
C     Down arrow or keypad 2:
      ELSE IF (ICH.EQ.-2 .OR. ICH.EQ.-22) THEN
          ICY = ICY-STEP
C     Right arrow or keypad 6:
      ELSE IF (ICH.EQ.-3 .OR. ICH.EQ.-26) THEN
          ICX = ICX+STEP
C     Left arrow or keypad 4:
      ELSE IF (ICH.EQ.-4 .OR. ICH.EQ.-24) THEN
          ICX = ICX-STEP
C     Keypad 7 (left and up):
      ELSE IF (ICH.EQ.-27) THEN
          ICX = ICX-STEP
          ICY = ICY+STEP
C     Keypad 9 (right and up):
      ELSE IF (ICH.EQ.-29) THEN
          ICX = ICX+STEP
          ICY = ICY+STEP
C     Keypad 3 (right and down):
      ELSE IF (ICH.EQ.-23) THEN
          ICX = ICX+STEP
          ICY = ICY-STEP
C     Keypad 1 (left and down):
      ELSE IF (ICH.EQ.-21) THEN
          ICX = ICX-STEP
          ICY = ICY-STEP
C     PF1:
      ELSE IF (ICH.EQ.-11) THEN
          STEP = 1
C     PF2:
      ELSE IF (ICH.EQ.-12) THEN
          STEP = 4
C     PF3:
      ELSE IF (ICH.EQ.-13) THEN
          STEP = 16
C     PF4:
      ELSE IF (ICH.EQ.-14) THEN
          STEP = 64
      END IF
      END

C*PGVSTD -- set standard (default) viewport
C%void cpgvstd(void);
C+
      SUBROUTINE PGVSTD
C
C Define the viewport to be the standard viewport.  The standard
C viewport is the full area of the view surface (or panel),
C less a margin of 4 character heights all round for labelling.
C It thus depends on the current character size, set by PGSCH.
C
C Arguments: none.
C--
C 22-Apr-1983: [TJP].
C  2-Aug-1995: [TJP].
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      LOGICAL  PGNOTO
      REAL     XLEFT, XRIGHT, YBOT, YTOP, R
C
      IF (PGNOTO('PGVSIZ')) RETURN
C
      R = 4.0*PGYSP(PGID)
      XLEFT  = R/PGXPIN(PGID)
      XRIGHT = XLEFT + (PGXSZ(PGID)-2.0*R)/PGXPIN(PGID)
      YBOT   = R/PGYPIN(PGID)
      YTOP   = YBOT + (PGYSZ(PGID)-2.0*R)/PGYPIN(PGID)
      CALL PGVSIZ(XLEFT, XRIGHT, YBOT, YTOP)
      END

      SUBROUTINE CADRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      INTEGER   IFUNC, NBUF, LCHR
      REAL      RBUF(*)
      CHARACTER CHR*(*)
C
C PGPLOT driver for Canon Laser printer.
C
C Supported device:  Canon LBP-8/A2 Laser printer.
C   Conforms to ISO646,2022,2375 and 6429 specifications.
C   VDM (graphics) conforms to proposed American National
C   Standard VDM mode.
C
C Device type code:  /CAnon (landscape mode only).
C
C Default file name:  PGPLOT.CAN
C
C Default view surface dimensions:  24 cm by 19 cm.
C
C Resolution:  300 pixels per inch in both directions.
C
C Color capability:  Color indices 0 (erase) and 1 (black) are
C   supported.  Note, hardware polygon fill is used and colors
C   0-11 control the fill pattern.
C
C Input capability:  None.
C
C File format:  Variable length records with Carriage control
C   of LIST.
C
C Obtaining hardcopy:  If printer is connected to a terminal
C   line (RS-232 option) then printing the file on the corresponding
C   queue should suffice.  If the printer is connected using
C   the Centronics interface, which appears the to VAX as an
C   LP device, then it is important to ensure that (1) all 8 bit
C   characters are passed to the printer (2) lines longer than
C   132 bytes are not truncated, and (3) no extra formatting
C   commands (e.g. form-feeds) are sent to the printer.
C   This can be done with the VMS command:
C   $ SET PRINT/PASSALL/LOWER/CR <device>
C   Note, some interface boards have a option to append a carriage
C   return after a formfeed or LF character, it is suggested
C   that this be disabled.
C   The file should be printed with the /PASSALL qualifier i.e.,
C   $ PRINT/PASSALL <filename>
C   Note, SET PRINT/PASSALL and PRINT/PASSALL do not do the
C   same things and hence PASSALL is required in both locations.
C
C 27-Jan-1988 - Version can be sent over BITNET (I hope) [AFT].
C 27-Sep-1986 - Add color index 0 (erase) [AFT].
C  5-Aug-1986 - [AFT].
C 13-Nov-1991 - [MCS] Having corrected unit scale factor to be one dot
C               instead of 0.8mm in GRCA03, changed viewport dimensions
C               to appear the same as before.
C 14-Nov-1991 - [MCS] 11 colour indexes are already implemented as fill
C               patterns - however device info on this said there were
C               only 0 and 1 - corrected IFUNC 2 now reports 11 colours
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE
      PARAMETER (TYPE='CANON (Canon LBP-8/A2 Laser printer, landscape)')
      INTEGER    IS2,    IVESC
      PARAMETER (IS2=30, IVESC=125)
C- The maximum physical size of the plot in units of 1/300 inch.
      INTEGER    MXLEN,      MXWID
      PARAMETER (MXLEN=3366, MXWID=2362)
C- Default size of plot.
      INTEGER    IDEFL,      IDEFW
      PARAMETER (IDEFL=2835, IDEFW=2244)
C
      CHARACTER CBUF*256
      CHARACTER MSG*10
      CHARACTER CDASH(5),CFILL(0:11)
      INTEGER   I0, J0, I1, J1, IER
      INTEGER   LUN, ICOL, NPTS, LBUF, LASX, LASY
      SAVE      LUN, ICOL, NPTS, LBUF, LASX, LASY
C---
C- Patterns defined with 2 and " appear the same on our Canon
C- so only one is used.  Pattern 0 causes the polygon not to
C- be filled.  Pattern ) erases interior of polygon is the
C- last character in list as all colors > max are set to
C- this pattern.
      DATA CFILL/')','1','(','''','&','%',
     :     '$','2','#','!','0',')'/
      DATA CDASH/'0','1','3','"','4'/
C---
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     :     110,120,130,140,150,160,900,180,190,200,
     :     210) IFUNC
 900  WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in CA device driver: '//MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC= 1, Return device name. -------------------------------------
10      CHR=TYPE
        LCHR=LEN(TYPE)
        RETURN
C
C--- IFUNC= 2, Return Physical min and max for plot device. ------------
20      RBUF(1)=0
        RBUF(2)=MXLEN
        RBUF(3)=0
        RBUF(4)=MXWID
        RBUF(5)=0
        RBUF(6)=11
        NBUF=6
        RETURN
C
C--- IFUNC= 3, Return device resolution. -------------------------------
30      RBUF(1)=300.0
        RBUF(2)=300.0
        RBUF(3)=1
        NBUF=3
        RETURN
C
C--- IFUNC= 4, Return misc device info. --------------------------------
40      CHR='HNNANNNNNN'
        LCHR=10
        RETURN
C
C--- IFUNC= 5, Return default file name. -------------------------------
50      CHR='PGPLOT.CAN'
        LCHR=10
        RETURN
C
C--- IFUNC= 6, Return default physical size of plot. -------------------
60      RBUF(1)=0
        RBUF(2)=IDEFL
        RBUF(3)=0
        RBUF(4)=IDEFW
        RETURN
C
C--- IFUNC= 7, Return misc defaults. -----------------------------------
70      RBUF(1)=1
        NBUF=1
        RETURN
C
C--- IFUNC= 8, Select plot. --------------------------------------------
80      RETURN
C
C--- IFUNC= 9, Open workstation. ---------------------------------------
90      CALL GRGLUN (LUN)
        OPEN (UNIT=LUN, FILE=CHR(:LCHR), STATUS='NEW',
     :        FORM='FORMATTED',
     :        RECL=512, IOSTAT=IER)
        IF (IER.EQ.0) THEN
          RBUF(2)=1
        ELSE
          RBUF(2) = IER
        ENDIF
        RBUF(1)=LUN
        RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
100     CLOSE(UNIT=LUN)
        CALL GRFLUN (LUN)
        RETURN
C
C--- IFUNC=11, Begin Picture. ------------------------------------------
110     CALL GRCA03(LUN,1)
C- Use the origin transfer command to ensure that the picture is
C- centered on the page.
        I0=(MXLEN-NINT(RBUF(1)))/2
        J0=(MXWID-NINT(RBUF(2)))/2
        CBUF(1:2)=CHAR(IVESC)//'"'
        LBUF=2
        CALL GRCA04(J0,CBUF,LBUF)
        CALL GRCA04(I0,CBUF,LBUF)
        LBUF=LBUF+1
        CBUF(LBUF:LBUF)=CHAR(IS2)
        WRITE(LUN,11) CBUF(:LBUF)
        RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
120     I0=NINT(RBUF(1))
        J0=NINT(RBUF(2))
        I1=NINT(RBUF(3))
        J1=NINT(RBUF(4))
        CALL GRCA01(LUN,I0,J0,I1,J1)
        RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
130     I0=NINT(RBUF(1))
        J0=NINT(RBUF(2))
        CALL GRCA01(LUN,I0,J0,I0,J0)
        RETURN
C
C--- IFUNC=14, End Picture. --------------------------------------------
140     CALL GRCA03(LUN,2)
        RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C- Save pen number (up to 11) for possible use in pattern interior.
150     ICOL=MAX(0,MIN(NINT(RBUF(1)),11))
        RBUF(1)=MAX(0,MIN(ICOL,1))
        IF(ICOL.EQ.0) THEN
          CBUF(1:4)=CHAR(IVESC)//'G2'//CHAR(IS2)
        ELSE
          CBUF(1:4)=CHAR(IVESC)//'G0'//CHAR(IS2)
        END IF
        WRITE(LUN,11) CBUF(:4)
        RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
160     RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
180     RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C- Currently turned off, since pattern is reset at beginning of
C- every new line segment.  Note, if GRCA01 was modified to
C- properly use polylines then dash pattern may work better.
190     CBUF(1:4)='E1'//CDASH(NINT(RBUF(1)))//CHAR(IS2)
        WRITE(LUN,11) CBUF(:4)
        RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
200     IF(NPTS.EQ.0) THEN
            NPTS=RBUF(1)
            CBUF(1:5)='I'//CFILL(ICOL)//'0'//CHAR(IS2)//'2'
            LBUF=5
            LASX=0
            LASY=0
        ELSE
            NPTS=NPTS-1
            I0=NINT(RBUF(1))
            J0=NINT(RBUF(2))
            CALL GRCA04(J0-LASY,CBUF,LBUF)
            CALL GRCA04(I0-LASX,CBUF,LBUF)
            LASX=I0
            LASY=J0
            IF(NPTS.EQ.0) THEN
                LBUF=LBUF+1
                CBUF(LBUF:LBUF)=CHAR(IS2)
                WRITE(LUN,11) CBUF(:LBUF)
11              FORMAT(A)
                LBUF=0
            END IF
        END IF
        RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C- (not possible but can be called).
210     RETURN
C-----------------------------------------------------------------------
        END

        SUBROUTINE GRCA01 (LUN,I0,J0,I1,J1)
C-----------------------------------------------------------------------
C Canon device driver support routine.  Draws a line segment.
C Current routine plots end line segment as a separate polyline.
C This can be improved.
C
C I0,J0         I  I    The coordinate of the start point.
C I1,J1         I  I    The coordinate of the end point.
C
C 26-JUN-86 - [AFT]
C-----------------------------------------------------------------------
        INTEGER    IS2
        PARAMETER (IS2=30)
        INTEGER   LUN, I0, J0, I1, J1
        INTEGER   LBUF, IX, IY
        CHARACTER CBUF*64
C---
        CBUF(1:1)='1'
        LBUF=1
        CALL GRCA04(J0,CBUF,LBUF)
        CALL GRCA04(I0,CBUF,LBUF)
        IX=I1-I0
        IY=J1-J0
        CALL GRCA04(IY,CBUF,LBUF)
        CALL GRCA04(IX,CBUF,LBUF)
        LBUF=LBUF+1
        CBUF(LBUF:LBUF)=CHAR(IS2)
        WRITE(LUN,11) CBUF(1:LBUF)
11      FORMAT(A)
        RETURN
        END
C*********
        SUBROUTINE GRCA03(LUN,ICMD)
C-----------------------------------------------------------------------
C Canon device driver support routine.  Outputs to LUN the string
C that begins a new picture (ICMD=1) or ends the current picture (ICMD=2).
C
C- LUN          I  I    Logical unit of output file.
C- ICMD         I  I    =1 to begin plot, =2 to terminate plot.
C
C 26-Jun-1986 - [AFT]
C 18-Jan-1988 - Change close brace to CHAR(125) [AFT]
C 13-Nov-1991 - [MCS, Jodrell Bank, England] Noticed aliasing when
C               modified PGGRAY stipple pattern to be sinusoidal.
C               Error traced to scale factor set at 0.8mm
C               instead of 1 dot => 1/300 = 0.84667mm corrected by
C               specifying scale factor in integral dots.
C-----------------------------------------------------------------------
        INTEGER    IESC,    IS2
        PARAMETER (IESC=27, IS2=30)
        INTEGER   LUN,ICMD
        CHARACTER CBUF*32
C---
11      FORMAT(A)
C---
        IF(ICMD.EQ.1) THEN
C- Go to ISO mode (ignored if in ISO mode already), Hard reset,
C- and then go to ISO again (in case dip switches set to Diablo).
            CBUF( 1: 4)=CHAR(IESC)//';'//CHAR(IESC)//'c'
            CBUF( 5: 6)=CHAR(IESC)//';'
C- Enable full paint mode.
            CBUF( 7:10)=CHAR(155)//'2&z'
C- Go to vector mode.
            CBUF(11:13)=CHAR(155)//'&'//CHAR(125)
C- Begin picture
            CBUF(14:21)='#PGPLOT'//CHAR(IS2)
C- Scaling mode 1 pixel, Begin picture body.
            CBUF(22:28)='!0#1'//CHAR(IS2)//'$'//CHAR(IS2)
            WRITE(LUN,11) CBUF(1:28)
        ELSE IF(ICMD.EQ.2) THEN
C- End picture, Return to text (0,0)
            CBUF(1:7)='%'//CHAR(IS2)//CHAR(125)//'p00'//CHAR(IS2)
            WRITE(LUN,11) CBUF(1: 7)
        END IF
        RETURN
        END
C*********
        SUBROUTINE GRCA04(NUM,CBUF,LBUF)
C-----------------------------------------------------------------------
C Canon device driver support routine.  Converts an integer into
C the form used by the Canon Laser printer.
C
C- NUM          I   I   Integer to be converted.
C- CBUF         I/O C*  Buffer string
C- LBUF         I/O I   Number of characters used in CBUF.
C
C 26-Jun-86 - [AFT]
C-----------------------------------------------------------------------
        CHARACTER CBUF*(*)
        INTEGER   NUM, LBUF
        INTEGER   ITMP, IS, IC
        CHARACTER CTMP*5
C---
        ITMP=NUM
C- Bit 4(=16) is set for positive numbers and clear for negative.
        IS=16
        IF(ITMP.LT.0) THEN
            IS=0
            ITMP=-ITMP
        END IF
C- Bits 6+7(=64,128) clear and Bit 5(=32) set, flags that this
C- is the last byte in the number.
        CTMP(5:5)=CHAR(32+IS+IAND(ITMP,15))
        ITMP=ITMP/16
        IC=1
        IF(ITMP.EQ.0) THEN
C- Numbers in the range -15 to +15 can be sent in one byte.
            CBUF(LBUF+1:LBUF+1)=CTMP(5:5)
        ELSE
C- Larger numbers require more bytes and are recorded 6 bits
C- per byte with bit 7=(128) clear and bit 6(=64) set.
150         CTMP(5-IC:5-IC)=CHAR(64+IAND(ITMP,63))
            IC=IC+1
            ITMP=ITMP/64
            IF(ITMP.NE.0) GOTO 150
            CBUF(LBUF+1:LBUF+IC)=CTMP(6-IC:5)
        END IF
        LBUF=LBUF+IC
        RETURN
        END

C*GRTOUP -- convert character string to upper case
C+
      SUBROUTINE GRTOUP (DST, SRC)
      CHARACTER*(*) DST, SRC
C
C GRPCKG (internal routine): convert character string to upper case.
C
C Arguments:
C  DST    (output) : output string (upper case).
C  SRC    (input)  : input string to be converted.
C--
C 1988-Jan-18 (TJP)
C-----------------------------------------------------------------------
      INTEGER I, N, NCHI, NCHO, NCH
      NCHI = LEN(SRC)
      NCHO = LEN(DST)
      NCH = MIN(NCHI, NCHO)
      DO 10 I=1,NCH
          N = ICHAR(SRC(I:I))
          IF ((N .GE. 97) .AND. (N .LE. 122)) THEN
              DST(I:I) = CHAR(N - 32)
          ELSE
              DST(I:I) = CHAR(N)
          END IF
   10 CONTINUE
      IF (NCHO .GT. NCHI) DST(NCHI+1:NCHO) = ' '
      END

C*PGWNAD -- set window and adjust viewport to same aspect ratio
C%void cpgwnad(float x1, float x2, float y1, float y2);
C+
      SUBROUTINE PGWNAD (X1, X2, Y1, Y2)
      REAL X1, X2, Y1, Y2
C
C Change the window in world coordinate space that is to be mapped on
C to the viewport, and simultaneously adjust the viewport so that the
C world-coordinate scales are equal in x and y. The new viewport is
C the largest one that can fit within the previously set viewport
C while retaining the required aspect ratio.
C
C Arguments:
C  X1     (input)  : the x-coordinate of the bottom left corner
C                    of the viewport.
C  X2     (input)  : the x-coordinate of the top right corner
C                    of the viewport (note X2 may be less than X1).
C  Y1     (input)  : the y-coordinate of the bottom left corner
C                    of the viewport.
C  Y2     (input)  : the y-coordinate of the top right corner of the
C                    viewport (note Y2 may be less than Y1).
C--
C 25-Sep-1985 - new routine (TJP).
C 31-May-1989 - correct error: XVP and YVP not set (TJP).
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
      REAL SCALE,OXLEN,OYLEN
C
      IF (PGNOTO('PGWNAD')) RETURN
C
C If invalid arguments are specified, issue warning and leave window
C unchanged.
C
      IF (X1.EQ.X2) THEN
         CALL GRWARN('invalid x limits in PGWNAD: X1 = X2.')
      ELSE IF (Y1.EQ.Y2) THEN
         CALL GRWARN('invalid y limits in PGWNAD: Y1 = Y2.')
      ELSE
         SCALE = MIN(PGXLEN(PGID)/ABS(X2-X1)/PGXPIN(PGID), 
     1               PGYLEN(PGID)/ABS(Y2-Y1)/PGYPIN(PGID))
         PGXSCL(PGID) = SCALE*PGXPIN(PGID)
         PGYSCL(PGID) = SCALE*PGYPIN(PGID)
         OXLEN = PGXLEN(PGID)
         OYLEN = PGYLEN(PGID)
         PGXLEN(PGID) = PGXSCL(PGID)*ABS(X2-X1)
         PGYLEN(PGID) = PGYSCL(PGID)*ABS(Y2-Y1)
         PGXVP(PGID)  = PGXVP(PGID) + 0.5*(OXLEN-PGXLEN(PGID))
         PGYVP(PGID)  = PGYVP(PGID) + 0.5*(OYLEN-PGYLEN(PGID))
         PGXOFF(PGID) = PGXVP(PGID) + (PGNXC(PGID)-1)*PGXSZ(PGID)
         PGYOFF(PGID) = PGYVP(PGID) +
     1                   (PGNY(PGID)-PGNYC(PGID))*PGYSZ(PGID)
         CALL PGSWIN(X1, X2, Y1, Y2)
      END IF
      END

C*PGCONB -- contour map of a 2D data array, with blanking
C%void cpgconb(const float *a, int idim, int jdim, int i1, int i2, \
C% int j1, int j2, const float *c, int nc, const float *tr, \
C% float blank);
C+
      SUBROUTINE PGCONB (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, TR, 
     1                   BLANK)
      INTEGER IDIM, JDIM, I1, I2, J1, J2, NC
      REAL    A(IDIM,JDIM), C(*), TR(6), BLANK
C
C Draw a contour map of an array. This routine is the same as PGCONS,
C except that array elements that have the "magic value" defined by
C argument BLANK are ignored, making gaps in the contour map. The
C routine may be useful for data measured on most but not all of the
C points of a grid.
C
C Arguments:
C  A      (input)  : data array.
C  IDIM   (input)  : first dimension of A.
C  JDIM   (input)  : second dimension of A.
C  I1,I2  (input)  : range of first index to be contoured (inclusive).
C  J1,J2  (input)  : range of second index to be contoured (inclusive).
C  C      (input)  : array of contour levels (in the same units as the
C                    data in array A); dimension at least NC.
C  NC     (input)  : number of contour levels (less than or equal to
C                    dimension of C). The absolute value of this
C                    argument is used (for compatibility with PGCONT,
C                    where the sign of NC is significant).
C  TR     (input)  : array defining a transformation between the I,J
C                    grid of the array and the world coordinates. The
C                    world coordinates of the array point A(I,J) are
C                    given by:
C                      X = TR(1) + TR(2)*I + TR(3)*J
C                      Y = TR(4) + TR(5)*I + TR(6)*J
C                    Usually TR(3) and TR(5) are zero - unless the
C                    coordinate transformation involves a rotation
C                    or shear.
C  BLANK   (input) : elements of array A that are exactly equal to
C                    this value are ignored (blanked).
C--
C 21-Sep-1989 - Derived from PGCONS [TJP].
C-----------------------------------------------------------------------
      INTEGER  I, IC, ICORN, IDELT(6), J, K, NPT
      INTEGER  IOFF(8), JOFF(8), IENC, ITMP, JTMP, ILO, ITOT
      LOGICAL  PGNOTO
      REAL     CTR, DELTA, DVAL(5), XX, YY, X(4), Y(4)
      INTRINSIC ABS
      DATA     IDELT/0,-1,-1,0,0,-1/
      DATA     IOFF/-2,-2,-1,-1, 0, 0, 1, 1/
      DATA     JOFF/ 0,-1,-2, 1,-2, 1,-1, 0/
C
C Check arguments.
C
      IF (PGNOTO('PGCONB')) RETURN
      IF (I1.LT.1 .OR. I2.GT.IDIM .OR. I1.GE.I2 .OR.
     1    J1.LT.1 .OR. J2.GT.JDIM .OR. J1.GE.J2) RETURN
      IF (NC.EQ.0) RETURN
      CALL PGBBUF
C
      DO 130 J=J1+1,J2
      DO 130 I=I1+1,I2
          DVAL(1) = A(I-1,J)
          DVAL(2) = A(I-1,J-1)
          DVAL(3) = A(I,J-1)
          DVAL(4) = A(I,J)
          DVAL(5) = DVAL(1)
          IF (DVAL(1).EQ.BLANK .OR. DVAL(2).EQ.BLANK .OR.
     1        DVAL(3).EQ.BLANK .OR. DVAL(4).EQ.BLANK) GOTO 130
      DO 110 IC=1,ABS(NC)
          CTR = C(IC)
          NPT = 0
          DO 120 ICORN=1,4
          IF( (DVAL(ICORN).LT.CTR .AND. DVAL(ICORN+1).LT.CTR)
     1    .OR.(DVAL(ICORN).GE.CTR .AND. DVAL(ICORN+1).GE.CTR) ) GOTO 120
            NPT=NPT+1
            DELTA = (CTR-DVAL(ICORN))/(DVAL(ICORN+1)-DVAL(ICORN))
            GOTO (60,70,60,70), ICORN
C
   60       XX = I+IDELT(ICORN+1)
            YY = REAL(J+IDELT(ICORN)) + 
     1           DELTA*REAL(IDELT(ICORN+1)-IDELT(ICORN))
            GOTO 80
C
   70       XX = REAL(I+IDELT(ICORN+1)) +
     1           DELTA*REAL(IDELT(ICORN+2)-IDELT(ICORN+1))
            YY  = J+IDELT(ICORN)
C
   80       X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY
            Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY
C
  120     CONTINUE
          IF (NPT.EQ.2) THEN
C             -- Contour crosses two sides of cell. Draw line-segment.
              CALL PGMOVE(X(1),Y(1))
              CALL PGDRAW(X(2),Y(2))
          ELSE IF (NPT.EQ.4) THEN
C             -- The 'ambiguous' case.  The routine must draw two line
C             segments here and there are two ways to do so.  The
C             following 4 lines would implement the original PGPLOT
C             method:
C            CALL PGCP(0,X(1),Y(1),CTR)
C            CALL PGCP(1,X(2),Y(2),CTR)
C            CALL PGCP(0,X(3),Y(3),CTR)
C            CALL PGCP(1,X(4),Y(4),CTR)
C            -- Choose between \\ and // based on the 8 points just
C            outside the current box.  If half or more of these points
C            lie below the contour level, then draw the lines such that
C            the high corners lie between the lines, otherwise, draw
C            the lines such that the low corners are enclosed.  Care is
C            taken to avoid going off the edge.
            ITOT=0
            ILO=0
            DO 140 K=1,8
               ITMP=I+IOFF(K)
               JTMP=J+JOFF(K)
               IF(ITMP.LT.I1 .OR. ITMP.GT.I2) GOTO 140
               IF(JTMP.LT.J1 .OR. JTMP.GT.J2) GOTO 140
               IF(A(ITMP,JTMP).EQ.BLANK) GOTO 140
               ITOT=ITOT+1
               IF(A(ITMP,JTMP).LT.CTR) ILO=ILO+1
  140       CONTINUE
            IENC=+1
            IF(ILO.LT.ITOT/2) IENC=-1
            IF(IENC.LT.0 .AND. DVAL(1).LT.CTR .OR.
     :         IENC.GT.0 .AND. DVAL(1).GE.CTR) THEN
               CALL PGMOVE(X(1),Y(1))
               CALL PGDRAW(X(2),Y(2))
               CALL PGMOVE(X(3),Y(3))
               CALL PGDRAW(X(4),Y(4))
            ELSE
               CALL PGMOVE(X(1),Y(1))
               CALL PGDRAW(X(4),Y(4))
               CALL PGMOVE(X(3),Y(3))
               CALL PGDRAW(X(2),Y(2))
            END IF
          END IF
  110     CONTINUE
  130 CONTINUE
C
      CALL PGEBUF
      END

C*GRPXPO -- Emulate pixel operations using points
C+
      SUBROUTINE GRPXPO (IA, IDIM, JDIM, I1, I2, J1, J2, 
     1                   X1, X2, Y1, Y2)
      INTEGER IDIM, JDIM, I1, I2, J1, J2
      INTEGER IA(IDIM,JDIM)
      REAL    X1, X2, Y1, Y2
C
C Arguments:
C  IA     (input)  : the array to be plotted.
C  IDIM   (input)  : the first dimension of array A.
C  JDIM   (input)  : the second dimension of array A.
C  I1, I2 (input)  : the inclusive range of the first index
C                    (I) to be plotted.
C  J1, J2 (input)  : the inclusive range of the second
C                    index (J) to be plotted.
C  X1, X2 (input)  : the horizontal range of the output region
C  Y1, Y2 (input)  : the vertical range of the output region
C--
C 16-Jan-1991 - [GvG]
C 28-Jun-1991
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER LW
      INTEGER I, J
      INTEGER ICOL, LSTCOL
C
C Save attributes
C
      CALL GRQLW(LW)
      CALL GRQCI(ICOL)
      CALL GRSLW(1)
      LSTCOL = ICOL
      DO 20 J = J1, J2
         DO 10 I = I1, I2
C
C Color changed?
C
            IF (IA(I, J) .NE. LSTCOL) THEN
               CALL GRSCI(IA(I, J))
               LSTCOL = IA(I, J)
            ENDIF
C
C Output dot
C
            CALL GRDOT0(X1 + (X2 - X1) * (I - I1 + 0.5) / (I2 - I1 + 1),
     1                  Y1 + (Y2 - Y1) * (J - J1 + 0.5) / (J2 - J1 + 1))
  10     CONTINUE
  20  CONTINUE
C
C Restore attributes
C
      CALL GRSCI(ICOL)
      CALL GRSLW(LW)
      END

C*CWDRIV -- PGPLOT driver for Colorwriter 6320 plotter
C+
      SUBROUTINE CWDRIV (OPCODE, RBUF, NBUF, CHR, LCHR)
      INTEGER       OPCODE,NBUF,LCHR
      REAL          RBUF(*)
      CHARACTER*(*)   CHR
C
C Supported device: Gould (now Bryans) Colourwriter 6320 or any
C device obeying Gould Plotter Language. [This appears to be very
C similar to HP-GL, Hewlett-Packard Graphics Language.]
C
C Device type code: /CW6320
C
C Default file name: pgplot.cwpl
C
C Default view surface dimensions: 280mm by 360mm (A3)
C
C Resolution: 0.025mm
C
C Colour Capability: Up to 10 pens. Default is pen 1 which is picked up
C on initialization without a call to PGSCI. Calls to PGSCI are
C interpreted as the pen number and colours therefore depend on how the
C pens have been loaded into the stalls. If a call is made for a pen
C higher than 10 the selected pen defaults to 1.
C
C Input Capability: Possible but not supported.
C
C File format: Ascii character strings.It is possible to send the
C data to a file which can then be copied to the plotter or
C on a terminal.
C--
C Version dated 880314.  Written by Len Pointon (Jodrell Bank).
C Revised 941201 by T. Pearson (standard Fortran-77).
C-----------------------------------------------------------------------
      INTEGER       LUN, IER, IC
      INTEGER       X1,Y1,X2,Y2,XOLD,YOLD
      INTEGER       GROPTX
      CHARACTER*10    MSG
      CHARACTER*(*)   DEVTYP,DEFNAM
      PARAMETER       (DEVTYP = 'CW6320 (Colorwriter 6320 plotter)')
      PARAMETER       (DEFNAM = 'pgplot.cwpl')
 
*             Go to the function specified by OPCODE
 
      GOTO (10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), OPCODE
 
*               Error return ,unrecognised value for OPCODE
 
      WRITE (MSG,'(I10)') OPCODE
      CALL GRWARN('Unknown opcode in '//DEVTYP//' device driver:'//MSG)
      NBUF = -1
      RETURN
 
*               OPCODE = 1, Return device name
 
  10  CHR = DEVTYP
      LCHR = LEN(DEVTYP)
      RETURN
 
*               OPCODE = 2, Return physical max & min for plot device and
*                           range of colour indices.
 
  20  RBUF(1) = 0.0
      RBUF(2) = 14400.0
      RBUF(3) = 0.0
      RBUF(4) = 11200.0
      RBUF(5) = 0.0
      RBUF(6) = 10.0
      NBUF = 6
      RETURN
 
*               OPCODE = 3, Return device resolution
 
  30  RBUF(1) = 1016.0
      RBUF(2) = 1016.0
      RBUF(3) = 12.0
      NBUF = 3
      RETURN

*               OPCODE = 4, Return misc. device information
*               (hardcopy,No cursor,No dashed lines,No area fill,
*                No thick lines)
 
  40  CHR = 'HNNNNNNNNN'
      LCHR = 10
      RETURN
 
*               OPCODE = 5, Return default file name
 
  50  CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
 
*               OPCODE = 6, Return default physical size of plot
 
  60  RBUF(1) = 0.0
      RBUF(2) = 14400.0
      RBUF(3) = 0.0
      RBUF(4) = 11200.0
      NBUF = 4
      RETURN
 
*               OPCODE = 7, Return misc. defaults
*               (Character scale factor,not sure what to put here so
*                try value pinched from QMDRIVER)
 
  70  RBUF(1) = 8.0
      NBUF = 1
      RETURN
 
*               OPCODE = 8, Select plot
*               (Code set aside for future option,ignore it now)
 
  80  CONTINUE
      RETURN
 
*               OPCODE = 9, Open workstation
 
*               Get a logical unit number
 
  90  CALL GRGLUN(LUN)
      IF (LUN.EQ.-1) THEN
          CALL GRWARN('Failed to allocate I/O unit')
          RBUF(2) = 0.0
          NBUF = 2
          RETURN
      END IF
 
*               Open the file 
 
      NBUF = 2
      RBUF(1) = LUN

      IER = GROPTX(LUN, CHR(1:LCHR), DEFNAM, 1)
      IF (IER .NE. 0) THEN
          CALL GRWARN('Cannot open graphics device '//DEVTYP)
          RBUF(2) = 0.0
          CALL GRFLUN(LUN)
          RETURN
      ELSE
*         -- Initialize and select pen 1
          WRITE (LUN,*) 'IN;SP1;'
          RBUF(2) = 1.0
      END IF
      RETURN
 
*               OPCODE = 10, Close workstation
 
 100  CLOSE (LUN)
      CALL GRFLUN (LUN)
      RETURN
 
*               OPCODE = 11, Begin picture
*               (make sure pen is up and we are at the origin)
 
110   WRITE (LUN,*) 'PU;PA0,0'
      RETURN
 
*               OPCODE = 12, Draw line
 
 120  X1 = NINT(RBUF(1))
      Y1 = NINT(RBUF(2))
      X2 = NINT(RBUF(3))
      Y2 = NINT(RBUF(4))
 
*               Decide if move is to be with pen up or down.
*               If first new x,y is same as old x,y move with pen down.
*               If not, move to first x,y with pen up then to second
*               x,y with pen down.
      IF (X1 .EQ. XOLD .AND. Y1 .EQ. YOLD) THEN
          WRITE (LUN,'(A,I5,A,I5,A)') 'PD;PA',X2,',',Y2,';'
      ELSE
          WRITE (LUN,'(A,I5,A,I5,A)') 'PU;PA',X1,',',Y1,';'
          WRITE (LUN,'(A,I5,A,I5,A)') 'PD;PA',X2,',',Y2,';'
      END IF
 
*               Save last position
 
      XOLD=X2
      YOLD=Y2
      RETURN
 
*               OPCODE = 13, Draw dot
 
 130  X1 = NINT(RBUF(1))
      Y1 = NINT(RBUF(2))
      WRITE (LUN,'(A,I5,A,I5,A)') 'PU;PA',X1,',',Y1,';PD;PU;'
      RETURN
 
*               OPCODE = 14, End picture
*               (Advances the page one complete page)
 
 140  WRITE (LUN,*) 'AF;'
      RETURN
 
*               OPCODE = 15, Select colour index
 
 150  IC = NINT(RBUF(1))
      IF (IC .LT. 1) IC = 1
      IF (IC .GT. 10) IC = 1
      WRITE (LUN,'(A,I5,A)')  'SP',IC,';'
      RETURN
 
*               OPCODE = 16, Flush buffer
*               (Not applicable to hard copy device)
 
 160  CONTINUE
      RETURN
 
*               OPCODE = 17, Read cursor
*               (If we get here it must be an error)
 
 170  NBUF = -1
      LCHR = 0
      RETURN
 
*               OPCODE = 18, Erase alpha screen
*               (Not applicable)
 
 180  CONTINUE
      RETURN
 
*               OPCODE = 19, Set line style
*               (Ignore this)
 
 190  CONTINUE
      RETURN
 
*               OPCODE = 20, Polygon fill
*               (Ignore this)
 
 200  CONTINUE
      RETURN
 
*               OPCODE = 21, Set colour representation
*               (Ignore this)
 
 210  CONTINUE
      RETURN
 
*               OPCODE = 22, Set line width
*               (Ignore this)
 
 220  CONTINUE
      RETURN
 
*               OPCODE =23, Escape
*               (Ignore this)
 
 230  CONTINUE
      RETURN
 
      END

C*SSDRIV -- PGPLOT device driver for MS-DOS /Salford Software
C+
      SUBROUTINE SSDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      IMPLICIT NONE
      INTRINSIC NINT
      INTEGER NINT
      INTEGER IFUNC, NBUF, LCHR,ICOL
      INTEGER*2 IRESH,IRESV,IH1,IV1,IH2,IV2,IER
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C This driver will put the display into graphics mode, and calls to 'close'
C the workstation will set it back into the previous mode (generally erasing
C the display, so don't do it until you are really finished).
C
C This routine must be compiled and linked with the Lahey graphics
C library GRAPH3 supplied with Lahey Fortran v4.0 or greater.
C
C Microsoft FORTRAN versions:
C 1989-Nov-03 - Started work [AFT]
C 1989-Apr-06 - Improved version [AFT]
C 1991-Mar-13 - Added cursor routine [JHT]
C Lahey FORTRAN versions:
C 1991-Dec-28 - derived from Microsoft version [PAH]
C 1995-Mar-21 - derived from LH-version [mlm]
C 1995-June-1 - variable ICOL  SAVED  [mlm]
C-----------------------------------------------------------------------
C
C     ATTEMPTED PORT TO SALFORD SOFTWARE/MLM
C
C
C
C Supported device: IBM PC's and compatables
C
C Device type code: /LH
C
C Default device name: None (the device name, if specified, is
C ignored).
C
C Default view surface dimensions: Depends on monitor, typical 7x10 inches
C
C Resolution: Depends on graphics card.  Tested with a 640x480 VGA card.
C    Driver should work with other graphics cards, however, expect to
C    tweak it a bit.
C
C Color capability: Color indices 0-15 are accepted.  This version maps
C    the PGPLOT color indices into the IBM color indices for with the
C    default color most closely corresponds to the PGPLOT default color.
C    Thus, PGPLOT index 2 (red) maps to IBM index 12 (light red).
C
C Input capability: Graphics cursor implemented using Microsoft Mouse
C    or compatible, accessed through DOS calls.
C
C File format: None.
C
C Obtaining hardcopy: Not possible.
C-----------------------------------------------------------------------
      CHARACTER CMSG*10
      REAL A,B
      INTEGER ICOL
      INTEGER    PENCOLOUR, PEND, COLOURMAP(0:15), IX, IY
      LOGICAL    GOT_MOUSE
      CHARACTER*30 CVALUE
      INTEGER LVALUE
      SAVE       PENCOLOUR, PEND,IRESH,IRESV,ICOL

      DATA colourmap/ 0,15,12,10, 9,11,13,14, 6, 2, 3, 1, 5, 4, 8, 7/

C---
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,240,250,260) IFUNC
  900 WRITE (CMSG, '(I10)') IFUNC
      CALL GRWARN('Unimplemented function in FTN77 device driver: '/
     :      /CMSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CHR = 'SS  (SALFORD SOFTWARE FTN77 SCREEN DRIVER)'
      LCHR =42
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 CONTINUE
      RBUF(1) = 0
      RBUF(2) = IRESH-1
      RBUF(3) = 0
      RBUF(4) = IRESV-1
      RBUF(5) = 0
      RBUF(6) = ICOL-1
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C Divide the number of pixels on screen by a typical screen size in
C inches.
C
   30 continue
      A = IRESH/9.5
      RBUF(1) = A
      B = IRESV/7.5
      RBUF(2) = B
      RBUF(3) = 1.0
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Interactive, No cursor, No dashed lines, No area fill,
C    No thick lines, No rectangle fill, No pixel primitives,)
C
   40 continue
      if (got_mouse()) then
        CHR = 'ICNNNRNNNN'
      else
        CHR = 'ICNNNRNNNN'
      endif
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CHR = ' '
      LCHR = 1
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 CONTINUE
      RBUF(1) = 0
      RBUF(2) = IRESH-1
      RBUF(3) = 0
      RBUF(4) = IRESV-1
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 1
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
      RBUF(1) = 0
      RBUF(2) = 1
      NBUF = 2
      IF(RBUF(3) .NE. 0.0) THEN
C        PEND=1
      ELSE
         CALL GRGENV('RESO', CVALUE, LVALUE)
C
C     READ HORIZONTAL, VERTICAL RESOLUTION AND COLOURS FROM INTERNAL FILE
C
         READ (CVALUE,*,ERR=91) IRESH,IRESV,ICOL
         IER = 0
         CALL GRAPHICS_MODE_SET@(IRESH,IRESV,ICOL,IER)
         IF (IER .NE. 0) GOTO 91
      END IF
      RETURN
C
C     PATCH FOR FAILURE TO RUN IN SPECIFIED MODE; TRY STANDARD VGA
C
  91  CONTINUE
C     CALL TEXT_MODE@
C     WRITE(*,*) ' FAILURE TO INITIALIZE  '
C     PAUSE
      IRESH = 640
      IRESV = 480
      ICOL = 16
      CALL GRAPHICS_MODE_SET@(IRESH,IRESV,ICOL,IER)
C     CALL LOAD_STANDARD_COLOURS@
C     CALL VGA@
      IF (IER .NE. 0) THEN
C
C        STILL INOPERATIVE
C
         CALL TEXT_MODE@
         WRITE(*,*) 'Failure to initialize VGA '
         STOP  ' Exiting program  '
      ENDIF
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
C
C     WAIT FOR KEYSTROKE
C
      CALL GET_KEY@(IX)
      CALL TEXT_MODE@
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
      CALL CLEAR_SCREEN@
C     IF(PEND.EQ.0) THEN
C        CALL PLOT(0, 0, -999)
C     ENDIF
C     PEND=0
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
C
C     SALFORD SOFTWARE DRAW-LINE ROUTINE
C
      IH1 = NINT(RBUF(1))
      IV1 = NINT(IRESV-1-RBUF(2))
      IH2 = NINT(RBUF(3))
      IV2 = NINT(IRESV-1-RBUF(4))
      CALL DRAW_LINE@(IH1,IV1,IH2,IV2,PENCOLOUR)
C
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
C
C     SALFORD SOFTWARE PIXEL
C
      IH1 = NINT(RBUF(1))
      IV1 = NINT(IRESV-1-RBUF(2))
      CALL SET_PIXEL@(IH1,IV1,PENCOLOUR)
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
      IF (RBUF(1) .NE. 0.0) THEN
c       call clear_screen@
      ENDIF
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
  150 CONTINUE
      PENCOLOUR=MIN( MAX(0,NINT(RBUF(1))) ,15)
      PENCOLOUR=COLOURMAP(PENCOLOUR)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C
C
  170 CONTINUE
      IX = NINT(RBUF(1))
      IY = IRESV-1-NINT(RBUF(2))
      CALL SHOW_MOUSE
      CALL PUT_MOUSE(IX,IY)
      CALL CURSOR_KEY(IX,IY,CHR)
      RBUF(1) = IX
      RBUF(2) = IRESV-1-IY
      CALL HIDE_MOUSE
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C
  190 CONTINUE
      RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C
  220 CONTINUE
      RETURN
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
      RETURN
C
C--- IFUNC=24, Rectangle fill. -----------------------------------------
C
  240 CONTINUE
      IH1 = NINT(RBUF(1))
      IV1 = NINT(IRESV-1-RBUF(2))
      IH2 = NINT(RBUF(3))
      IV2 = NINT(IRESV-1-RBUF(4))
      CALL FILL_RECTANGLE@(IH1,IV1,IH2,IV2,PENCOLOUR)
      RETURN
C
C--- IFUNC=25, Set fill pattern. ---------------------------------------
C
  250 CONTINUE
      RETURN
C
C--- IFUNC=26, Line of pixels. -----------------------------------------
C
  260 CONTINUE
      RETURN
C-----------------------------------------------------------------------
      END
      LOGICAL FUNCTION GOT_MOUSE()
      IMPLICIT NONE
      INTEGER*2          NTRUP
      INTEGER*2          INTARY(10), EAX
      EQUIVALENCE        (EAX,INTARY(1))
      EAX = 0
      NTRUP = 51
      CALL REAL_MODE_INTERRUPT@(INTARY,NTRUP)
      GOT_MOUSE = (EAX .EQ. -1)
      RETURN
      END

      SUBROUTINE SHOW_MOUSE
      IMPLICIT NONE
      CALL DISPLAY_MOUSE_CURSOR@
      RETURN
      END

      SUBROUTINE HIDE_MOUSE
      IMPLICIT NONE
      CALL HIDE_MOUSE_CURSOR@
      RETURN
      END

      SUBROUTINE GET_MOUSE(IX, IY, BUTTON)
      IMPLICIT NONE
      INTEGER*2 IX, IY, BUTTON
      CALL GET_MOUSE_POSITION@(IX,IY,BUTTON)
      RETURN
      END

      SUBROUTINE PUT_MOUSE(IX, IY)
      IMPLICIT NONE
      INTEGER*2 IX, IY
      CALL SET_MOUSE_POSITION@(IX,IY)
      RETURN
      END

      SUBROUTINE CURSOR_KEY(IX, IY, KEY)
      IMPLICIT NONE
      CHARACTER*(*) KEY
      INTEGER IX, IY, IKEY, IB
      INTEGER*2 IXKEY
      CALL GET_KEY@(IKEY)
      KEY = CHAR(IKEY)
      IX = 0
      IY = 0
      CALL GET_MOUSE(IX, IY, IB)
      RETURN
      END

C*PZDRIV -- PGPLOT Peritek driver
C+
      SUBROUTINE PZDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for Peritek Corp. VCH-Q display
C
C Version 1.0  - 1987 May 26 - T. J. Pearson.
C Version 1.1  - 1987 Jun  4 - add cursor support (TJP).
C Version 1.2  - 1987 Jul  1 - larger cursor (TJP).
C
C
C Supported device: Peritek Corp. VCH-Q frame-buffer video 
C interface with HD6845 CRTC, using a custom VMS device driver.
C (Peritek Corp., 5550 Redwood Rd., Oakland, CA 94619, 415-531-6500)
C
C Device type code: /PERITEK.
C
C Default device name: TV_DEVICE (a logical name, usually
C defined by the system manager).
C
C Default view surface dimensions: Depends on monitor.
C
C Resolution: The full view surface is 512 x 512 pixels. 
C
C Color capability: Color indices 0-255 are supported. The
C representation of all color indices can be changed. As the
C device is normally connected to a monochrome monitor, all
C colors are converted to grayscale by averaging the R, G, B
C components.
C
C Input capability: Not implemented.
C
C File format: It is not possible to send plots to a disk file.
C
C Obtaining hardcopy: Not possible.
C
C-----------------------------------------------------------------------
C The driver makes use of the following PGPLOT support routines:
C    GRGETC
C    GRGMSG
C    GRQUIT
C    GRWARN
C-----------------------------------------------------------------------
* The following notes describe the VMS device-driver interface used
* with this device. The QIO functions supported are: 
* 
*       IO$_WRITEVBLK  -  write virtual block,
*       IO$_READVBLK   -  read virtual block,
*       IO$_MODIFY     -  set display mode,
*       IO$_ACCESS     -  write block of x,y,z values.
* 
* IO$_WRITEVBLK: Consecutive bytes (8 bits) of data are transferred
* from a user specified buffer to consecutively addressed elements in
* either the graphics display memory or the color map memory of the
* VCH-Q, starting at a specified element.  The required device
* specific QIO parameters are: 
* 
*       P1 - the address of the data buffer;
*       P2 - the number of bytes of data to be transferred;
*       P3 - a longword containing the initial line number in
*            its least significant word and the initial element
*            number in its most significant word.
* 
* A write operation to the graphics display memory is signalled by an
* initial line number that is non-negative.  In this case the effective
* initial line number and the effective initial element number are 
* calculated from the values, line0 and elem0, in P3 as follows:
* 
*       initial line = (line0 + (elem0 / 512)) modulo 512, and
*       initial element = elem0 modulo 512.
* 
* Line number 0 refers to the bottom line of the display and line
* number 511 refers to the top line. Element number 0 corresponds to
* the leftmost element of the line and element number 511, the
* rightmost.  The data are written to memory elements consecutively
* addressed by incrementing the element number modulo 512 with
* wrap-around to element 0 of the next higher line number modulo 512. 
* 
* A write operation to the color map memory is signalled by an initial
* line number that is negative.  The value of the initial line number
* selects which of the color maps are to be written: 
* 
*       - 1:  bottom red,
*       - 2:  bottom green,
*       - 4:  bottom blue,
*       - 8:  top red,
*       -16:  top green, and
*       -32:  top blue.
* 
* Several of the color maps may be selected in a write operation by
* giving an initial line number which is the sum of the values, above,
* for the individual desired maps.  The elements of a color map are
* numbered from 0 to 255 and the given initial element number and the
* value of the P2 parameter must not be such as to write past the end
* of the map (element 255). 
* 
* IO$_READVBLK: Except that the direction of data transfer is
* reversed, the same description applies as is given above for the
* write function but with one other difference:  only one color map
* may be selected at a time in a read. 
* 
* IO$_MODIFY: The required device specific QIO parameter is:
* 
*       P1 - a longword parameter consisting of two packed word-
*            length booleans:  bit 0, use the top mapbit 16,
*            interpixellate the display.  The bit values are
*            0: false, 1: true.
* 
* IO$_ACCESS: used to modify individual bits in individual pixels in
* the image memory. The required device specific QIO parameters are: 
* 
*       P1 - a longword that is the start of a data buffer
*       P2 - the length of the data buffer in bytes
* 
* The data buffer is organized in groups of 8 byte records. Each 8
* byte record specifies one location in the VCH-Q image memory that is
* to be modified. It also specifies which of the 8 bits to modify in
* that location. The format of a record is 4 16-bit integers organized
* in the following way: 
* 
*       _________
*       |       |  element within a line, modulo 512 ( x )
*       ---------
*       |       |  line number, modulo 512 ( y )
*       ---------
*       |       |  bit pattern to use, modulo 256 ( z )
*       ---------
*       |       |  bit pattern modification mask, modulo 256
*       ---------
* 
* The bit modification mask determines which bits are to be changed in
* the specified location of the image memory. A 1 in a bit in the mask
* indicates that the final value of a bit in memory should be taken
* from the value in bit pattern word of the record. A 0 in a bit in
* the mask indicates that the final value of a bit in memory should be
* the value already in memory. For example, a modification mask of all
* 1's tells the driver to replace the value in memory with the bit
* pattern in the record, whereas a mask of all 0's tells the driver to
* leave the memory alone. 
C-----------------------------------------------------------------------
      INTEGER   UNIT, IER, I0, I1, J0, J1, IX, IY, ICH
      LOGICAL   APPEND
      CHARACTER*10 MSG
      INTEGER*2 IC, IR, IG, IB
      INTEGER   GRPZ00, SYS$DASSGN
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in PERITEK device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CHR = 'PERITEK'
      LCHR = 7
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 511
      RBUF(3) = 0
      RBUF(4) = 511
      RBUF(5) = 0
      RBUF(6) = 255
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C
   30 RBUF(1) = 50.0
      RBUF(2) = 50.0
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (This device is Interactive, Cursor, No dashed lines, No area 
C    fill, No thick lines)
C
   40 CHR = 'ICNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = 'TV_DEVICE'
      LCHR = 9
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 511
      RBUF(3) = 0
      RBUF(4) = 511
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 1
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
      APPEND = RBUF(3).NE.0.0
      IER = GRPZ00(CHR, LCHR, UNIT)
      RBUF(1) = UNIT
      RBUF(2) = IER
      NBUF = 2
      IC = 1
C     -- skip initialization if "APPEND" requested
      IF (APPEND) RETURN
      CALL GRPZ05(UNIT)
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      IER = SYS$DASSGN(%val(UNIT))
      IF (IER.NE.1) THEN
          CALL GRWARN('Error closing graphics device')
          CALL GRGMSG(IER)
      END IF
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
      IF (.NOT.APPEND) CALL GRPZ04(UNIT)
      RETURN
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
      CALL GRPZ01 (I0, J0, I1, J1, IC, UNIT)
      RETURN
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      CALL GRPZ01 (I0, J0, I0, J0, IC, UNIT)
      RETURN
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      RETURN
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      IF (IC.LT.0 .OR. IC.GT.255) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C           RBUF(1)   in/out : cursor x coordinate.
C           RBUF(2)   in/out : cursor y coordinate.
C           CHR(1:1)  output : keystroke.
C
  170 CONTINUE
      IX = NINT(RBUF(1))
      IY = NINT(RBUF(2))
      CALL GRPZ06(IX, IY, ICH, IER, UNIT)
      IF (IER.EQ.1) THEN
          RBUF(1) = IX
          RBUF(2) = IY
          CHR = CHAR(ICH)
      ELSE
          CHR = CHAR(0)
      END IF
      NBUF = 2
      LCHR = 1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called)
C
  200 CONTINUE
      GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      ICH = RBUF(1)
      IR = MIN(255.,MAX(RBUF(2)*255.,0.))
      IG = MIN(255.,MAX(RBUF(3)*255.,0.))
      IB = MIN(255.,MAX(RBUF(4)*255.,0.))
      CALL GRPZ03 (ICH,IR,IG,IB,UNIT)
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C-----------------------------------------------------------------------
      END

C*GRPZ00 -- PGPLOT Peritek driver, open device
C+
      INTEGER FUNCTION GRPZ00 (GRFILE, GRFNLN, GRUNIT)
      CHARACTER*(*) GRFILE
      INTEGER GRFNLN, GRUNIT
C
C Returns:
C   GRPZ00         : 1 if the device was opened successfully. Any 
C                    other value indicates that an error occurred.
C                    Usually the value is the VMS error code.
C 
C Arguments:
C   GRFILE (in/out) : requested device name (input); actual
C                     device assigned (output).
C   GRFNLN (in/out) : length of device name.
C   GRUNIT (output) : channel assigned by VMS.
C
C Subroutines called:
C   GRWARN
C   GRGMSG
C   VMS system services
C-----------------------------------------------------------------------
      INTEGER  DVI$_DEVCLASS, DVI$_DEVNAM
      PARAMETER (DVI$_DEVCLASS=4)
      PARAMETER (DVI$_DEVNAM=32)
      INTEGER  DEVCLASS, ITMLIST(7), IOSB(2)
      INTEGER  IER, L, SYS$ASSIGN
      INTEGER  SYS$GETDVI, SYS$DASSGN, SYS$WAITFR
C
C Assign an i/o channel.
C
      L = GRFNLN
      IER = SYS$ASSIGN(GRFILE(1:L), GRUNIT,,)
      IF (.NOT.IER) GOTO 100
C
C Check that device has correct characteristics, and obtain true
C device name.
C
      ITMLIST(1) = DVI$_DEVCLASS*2**16 + 4
      ITMLIST(2) = %LOC(DEVCLASS)
      ITMLIST(3) = 0
      ITMLIST(4) = DVI$_DEVNAM*2**16 + LEN(GRFILE)
      ITMLIST(5) = %LOC(GRFILE)
      ITMLIST(6) = %LOC(GRFNLN)
      ITMLIST(7) = 0
      IER = SYS$GETDVI(%VAL(0),,GRFILE(1:GRFNLN), ITMLIST,IOSB,,,)
      IF (.NOT.IER) GOTO 100
      IER = SYS$WAITFR(%VAL(0))
      IF (.NOT.IER) GOTO 100
      IF (.NOT.IOSB(1)) THEN
          IER = IOSB(1)
          GOTO 100
      END IF
      IF (DEVCLASS.NE.32 .AND. DEVCLASS.NE.96) THEN
          CALL GRWARN( GRFILE(1:GRFNLN)//
     2            ' is the wrong sort of device for plot type PERITEK')
          GRPZ00 = 32767      ! indicate error
          IER = SYS$DASSGN(%VAL(GRUNIT))
          RETURN
      END IF
C
C Successful completion.
C
      GRPZ00 = 1
      RETURN
C
C Error exit.
C
  100 CALL GRWARN('Cannot open graphics device '//GRFILE(1:L))
      CALL GRGMSG(IER)
      GRPZ00 = IER
C-----------------------------------------------------------------------
      END

C*GRPZ01 -- PGPLOT Peritek driver, draw line segment
C+
      SUBROUTINE GRPZ01 (ELEM1,LINE1,ELEM2,LINE2,CI,UNIT)
      INTEGER*2      ELEM1, ELEM2, LINE1, LINE2, CI
      INTEGER*4      UNIT
C
C ELEM1   I*4      start element 
C LINE1   I*4      start line
C ELEM2   I*4      stop element 
C LINE2   I*4      stop line
C CI      I*2      color index to be used
C UNIT    I*4      unit number for output
C
C Note: the arguments are specified as integer*2, but (on the VAX at
C least) integer*4 values may be used. The values should be in the
C range defined by the hardware: (0...511).
C
C (28-May-1987)
C-----------------------------------------------------------------------
      BYTE           DATA
      REAL*4         SLOPE, DELEM, DLINE
      INTEGER*2      LOC(2)
      INTEGER*2     I1, J1, I2, J2, STEP
      INTEGER       I, J, N
      BYTE          BUF(512)
C
      DATA = CI
      I1 = ELEM1
      J1 = LINE1
      I2 = ELEM2
      J2 = LINE2
      DLINE = J2-J1
      DELEM = I2-I1
      SLOPE = 1.0E10
C
      IF (DELEM .NE. 0) SLOPE = DLINE/DELEM
      IF (DLINE.EQ.0) THEN
          LOC(2) = MIN(I1,I2)
          LOC(1) = J1
          N = ABS(I1-I2)+1
          DO 5 I=1,N
              BUF(I) = DATA
    5     CONTINUE
          CALL GRPZ02(1,N,BUF,LOC,UNIT)
      ELSE IF (ABS(SLOPE) .LT. 1.0) THEN
          STEP = IISIGN(1,(I2-I1))
          DO 10 I = I1, I2, STEP
              LOC(2) = I
              LOC(1) = (LOC(2)-I1)*SLOPE + J1      
              CALL GRPZ02(1,1,DATA,LOC,UNIT)
   10     CONTINUE
C
      ELSE IF (DLINE .NE. 0) THEN
          SLOPE = DELEM/DLINE
          STEP = IISIGN(1,(J2-J1))
          DO 20 J = J1, J2, STEP
              LOC(1) = J
              LOC(2) = (LOC(1) - J1)*SLOPE + I1
              CALL GRPZ02(1,1,DATA,LOC,UNIT)
   20     CONTINUE
C
      ELSE
          LOC(1) = J1
          LOC(2) = I1
          CALL GRPZ02(1,1,DATA,LOC,UNIT)
      END IF
      END

C*GRPZ02 -- PGPLOT Peritek driver, input/output data
C+
      SUBROUTINE GRPZ02 (INOUT,N,BUFFER,LOC,UNIT)
      INTEGER INOUT, N, UNIT
      BYTE BUFFER(*)
      INTEGER*4 LOC
C
C Arguments:
C
C INOUT (input) : 1 => write, 0 => read
C N (integer, input): the number of bytes to transfer.
C BUFFER (byte array, dimension at least N, input): the data
C      bytes to be put in the output buffer.
C LOC (integer*2 array, dimension 2): location of the beginning 
C      of the string of N data points.  (I,J)
C UNIT (input): channel number for output
C
C (28-May-1987)
C-----------------------------------------------------------------------
      INCLUDE '($IODEF)'
C
      INTEGER SYS$QIOW, RESULT, IOSB(2)
      INTEGER*2 STBC(2), STATUS, COUNT
      EQUIVALENCE (STBC, IOSB(1)), (STATUS, STBC(1)), (COUNT, STBC(2))
C
      IF (N.LT.1) RETURN
      IF (INOUT.EQ.1) THEN
          RESULT = SYS$QIOW(,%VAL(UNIT),
     1                 %VAL(IO$_WRITEVBLK),IOSB,,,
     2                 BUFFER,%VAL(N),%VAL(LOC),,,)
      ELSE
          RESULT = SYS$QIOW(,%VAL(UNIT),
     1                 %VAL(IO$_READVBLK),IOSB,,,
     2                 BUFFER,%VAL(N),%VAL(LOC),,,)
      END IF
      IF (RESULT.NE.1) THEN
          CALL GRGMSG(RESULT)
          CALL GRQUIT('SYS$QIO failure writing to TV')
      END IF
      IF (STATUS.NE.1) THEN
          RESULT = STATUS
          CALL GRGMSG(RESULT)
          CALL GRQUIT('SYS$QIO failure writing to TV')
      END IF
      END

C*GRPZ03 -- PGPLOT Peritek driver, set color representation
C+
      SUBROUTINE GRPZ03 (CIN,R,G,B,UNIT)
      INTEGER*2 CIN, R, G, B
      INTEGER UNIT
C
C Arguments:
C   CIN      I*2     LUT index 0 to 255
C   R,G,B    I*2     Color component 0 to 255
C   UNIT     I*4     Channel number for output
C
C *** NB *** This converts requested color index to monochrome shade
C as all known installations of this device have monochrome monitors
C
C (28-May-1987)
C-----------------------------------------------------------------------
      INTEGER*2      LOC2(2), MONO
C
      MONO = NINT((R+G+B)/3.0)
C
      LOC2(2) = CIN
      LOC2(1) = -1
      CALL GRPZ02(1,1,MONO,LOC2,UNIT)
C
      LOC2(1) = -2
      CALL GRPZ02(1,1,MONO,LOC2,UNIT)
C
      LOC2(1) = -4
      CALL GRPZ02(1,1,MONO,LOC2,UNIT)
C
      END

C*GRPZ04 -- PGPLOT Peritek driver, clear screen
C+
      SUBROUTINE GRPZ04(UNIT)
      INTEGER UNIT
C
C Clears the tv by setting all pixel values to 0.
C
C (7-Jun-1987)
C-----------------------------------------------------------------------
      INTEGER*4      BUF(128), J
      INTEGER*2      LOC(2)
      DATA BUF/128*0/
C
      LOC(2) = 0
C
C Zero array.
C
      DO 20 J=0,511
          LOC(1) = J
          CALL GRPZ02(1,512,BUF,LOC,UNIT)
   20 CONTINUE
      END

C*GRPZ05 -- PGPLOT Peritek driver, initialize display
C+
      SUBROUTINE GRPZ05 (UNIT)
      INTEGER UNIT
C
C Initialize the display. Note that the screen is
C NOT erased. The color tables are initialized as follows:
C
C Index      Name                     (H,L,S)               (R,G,B)
C
C  0      Black                    0, 0.0, 0.0            0.0, 0.0, 0.0
C  1      White                    0, 1.0, 0.0            1.0, 1.0, 1.0
C  2      Red                    120, 0.5, 1.0            1.0, 0.0, 0.0
C  3      Green                  240, 0.5, 1.0            0.0, 1.0, 0.0
C  4      Blue                     0, 0.5, 1.0            0.0, 0.0, 1.0
C  5      Cyan    (Green+Blue)   300, 0.5, 1.0            0.0, 1.0, 1.0
C  6      Magenta (Red+Blue)      60, 0.5, 1.0            1.0, 0.0, 1.0
C  7      Yellow  (Red+Green)    180, 0.5, 1.0            1.0, 1.0, 0.0
C  8      Red+Yellow (Orange)    150, 0.5, 1.0            1.0, 0.5, 0.0
C  9      Green+Yellow           210, 0.5, 1.0            0.5, 1.0, 0.0
C 10      Green+Cyan             270, 0.5, 1.0            0.0, 1.0, 0.5
C 11      Blue+Cyan              330, 0.5, 1.0            0.0, 0.5, 1.0
C 12      Blue+Magenta            30, 0.5, 1.0            0.5, 0.0, 1.0
C 13      Red+Magenta             90, 0.5, 1.0            1.0, 0.0, 0.5
C 14      Dark Gray                0, .33, 0.0            .33, .33, .33
C 15      Light Gray               0, .66, 0.0            .66, .66, .66
C
C (28-May-1987)
C-----------------------------------------------------------------------
      BYTE           LUT(256), LUT1
      INTEGER*2      LUT2, LOC2(2), GCTABL(3,16)
      INTEGER*4      I
C      
      EQUIVALENCE      (LUT1,LUT2)
      DATA GCTABL /000,000,000, 255,255,255, 255,000,000, 000,255,000,
     1             000,000,255, 000,255,255, 255,000,255, 255,255,000,
     2             255,128,000, 128,255,000, 000,255,128, 000,128,255,
     3             128,000,255, 255,000,128, 085,085,085, 170,170,170/
C
C                              INITIALIZE RED TABLE TO ABOVE
      LOC2(1) = -9
      LOC2(2) = 0
      DO 20 I=1,16
          LUT2 = (GCTABL(1,I)+GCTABL(2,I)+GCTABL(3,I))/3
          LUT(I) = LUT1
20    CONTINUE
      CALL GRPZ02(1,16,LUT,LOC2,UNIT)
C                              INITIALIZE GREEN TABLE TO ABOVE
      LOC2(1) = -18
      LOC2(2) = 0
      DO 30 I=1,16
          LUT2 = (GCTABL(1,I)+GCTABL(2,I)+GCTABL(3,I))/3
          LUT(I) = LUT1
30    CONTINUE
      CALL GRPZ02(1,16,LUT,LOC2,UNIT)
C                              INITIALIZE BLUE TABLE TO ABOVE
      LOC2(1) = -36
      LOC2(2) = 0
      DO 40 I=1,16
          LUT2 = (GCTABL(1,I)+GCTABL(2,I)+GCTABL(3,I))/3
          LUT(I) = LUT1
40    CONTINUE
      CALL GRPZ02(1,16,LUT,LOC2,UNIT)
C
      END

C*GRPZ06 -- PGPLOT Peritek driver, cursor routine
C+
      SUBROUTINE GRPZ06 (IX, IY, IC, IER, UNIT)
      INTEGER IX, IY, IC, IER, UNIT
C
C Arguments:
C   IX, IY (in/out) : initial/final coordinates of cursor (device 
C                     coordinates).
C   IC     (output) : character code.
C   IER    (output) : error status (1 => OK).
C   UNIT   (input)  : channel for output to device.
C
C The Peritek device has no hardware cursor. The cursor has to be
C emulated by writing into the image array, and to delete it the 
C former contents must be restored. The cursor is a 5x5 pixel array;
C to avoid edge effects, it cannot be moved within 2 pixels of the 
C edge of the screen.
C
C The cursor is moved by using the arrow keys on the
C terminal; the cursor "speed" (step size) is controlled by the
C PF1 (smallest step) to PF4 (largest step) keys.
C
C The user indicates that the cursor has been positioned by
C typing any character on his keyboard (SYS$COMMAND), with the
C following exceptions: control characters (^C, ^O, ^Q, ^R, ^S,
C ^T, ^U, ^X, ^Y, DEL) are intercepted by the operating system
C and cannot be used; NUL, ESC (^[) and escape sequences (e.g., 
C arrow keys) are ignored.
C 
C (1-Jul-1987)
C-----------------------------------------------------------------------
C CURSIZ is the size of the cursor array: must be odd
      INTEGER        CURSIZ, CURCEN
      PARAMETER      (CURSIZ=9, CURCEN=(CURSIZ+1)/2)
      INTEGER*2      IXG,IYG, LOC2(2)
      INTEGER        GRGETC, SYS$ASSIGN, SYS$DASSGN
      INTEGER        STEP, ICHAN, I, J
      DATA           STEP/4/      ! initial step size
      BYTE           CU1(CURSIZ,CURSIZ), CU2(CURSIZ,CURSIZ)
C-----------------------------------------------------------------------
      IER = SYS$ASSIGN('SYS$COMMAND',ICHAN,,)
      IF (IER.NE.1) RETURN
      IX = MAX(CURCEN-1,MIN(IX,511-CURCEN+1))
      IY = MAX(CURCEN-1,MIN(IY,511-CURCEN+1))
   10 IXG = IX
      IYG = IY
C     -- Make cursor visible
      LOC2(2) = IXG-CURCEN+1
      DO J=1,CURSIZ
          LOC2(1) = IYG-CURCEN+J
          CALL GRPZ02(0,CURSIZ,CU1(1,J),LOC2,UNIT)
      END DO
      DO I=1,CURSIZ
         DO J=1,CURSIZ
           CU2(I,J) = CU1(I,J)
         END DO
      END DO
      DO I=1,CURSIZ
          CU2(I,CURCEN) = 1
          CU2(CURCEN,I) = 1
          CU2(I,I) = 0
          CU2(I,CURSIZ+1-I) = 0
      END DO
      DO J=1,CURSIZ
          LOC2(1) = IYG-CURCEN+J
          CALL GRPZ02(1,CURSIZ,CU2(1,J),LOC2,UNIT)
      END DO
      IC = GRGETC(ICHAN)
      IF (IC.EQ.-1) THEN
          IY = MIN(511-CURCEN+1,IY+STEP)
      ELSE IF (IC.EQ.-2) THEN
          IY = MAX(CURCEN-1,IY-STEP)
      ELSE IF (IC.EQ.-3) THEN
          IX = MIN(511-CURCEN+1,IX+STEP)
      ELSE IF (IC.EQ.-4) THEN
          IX = MAX(CURCEN-1,IX-STEP)
      ELSE IF (IC.EQ.-11) THEN
          STEP = 1
      ELSE IF (IC.EQ.-12) THEN
          STEP = 4
      ELSE IF (IC.EQ.-13) THEN
          STEP = 16
      ELSE IF (IC.EQ.-14) THEN
          STEP = 64
      END IF
C     --- Erase cursor by restoring former image contents
      DO J=1,CURSIZ
          LOC2(1) = IYG-CURCEN+J
          CALL GRPZ02(1,CURSIZ,CU1(1,J),LOC2,UNIT)
      END DO
      IF (IC.LE.0 .OR. IC.GT.255) GOTO 10
      IER = SYS$DASSGN(%VAL(ICHAN))
C-----------------------------------------------------------------------
      END

C*GRMARK -- mark points with specified symbol
C+
      SUBROUTINE GRMARK (IDENT,CENTER,SYMBOL,ABSXY,POINTS,X,Y)
C
C GRPCKG: mark a sequence of points with a specified symbol. The
C plot is windowed in the current subarea.
C
C Arguments:
C
C IDENT (integer, input): plot identifier from GROPEN.
C CENTER (input, logical): if .TRUE. the symbol is centered on the point,
C      otherwise the bottom left corner is placed at the point.
C SYMBOL (byte or integer, input): code number of symbol in range 0-127
C      (ASCII character or special symbol); if SYMBOL is outside this
C      range, nothing is plotted.
C ABSXY (logical, input): if .TRUE. (X,Y) are absolute (device)
C      coordinates; otherwise they are world coordinates and the
C      scaling transformation is applied.
C POINTS (integer, input): the number of points; if POINTS is less than
C      or equal to 0, nothing is plotted.
C X,Y (real arrays, dimension at least POINTS, input): the coordinate
C      pairs; if POINTS=1, these may be scalars instead of arrays.
C
C (9-Mar-1983)
C-----------------------------------------------------------------------
      INTEGER  SYMBOL
      CHARACTER*1 MARK
      INTEGER  I, IDENT, POINTS
      LOGICAL  ABSXY, CENTER
      REAL     X(*), Y(*)
C-----------------------------------------------------------------------
      IF (POINTS.LE.0 .OR. SYMBOL.LT.0 .OR. SYMBOL.GT.127) RETURN
      CALL GRSLCT(IDENT)
      MARK = CHAR(SYMBOL)
      DO 10 I=1,POINTS
          CALL GRCHR0(.TRUE., CENTER, 0.0, ABSXY, X(I), Y(I), MARK)
   10 CONTINUE
C-----------------------------------------------------------------------
      END

C*GRDATE -- get date and time as character string (VMS)
C+
      SUBROUTINE GRDATE(STRING, L)
      CHARACTER*(*) STRING
      INTEGER L
C
C Return the current date and time, in format 'dd-Mmm-yyyy hh:mm'.
C To receive the whole string, the STRING should be declared
C CHARACTER*17.
C
C Arguments:
C  STRING : receives date and time, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in STRING, excluding
C           trailing blanks. This will always be 17, unless the length
C           of the string supplied is shorter.
C--
C 19-Jan-1988
C-----------------------------------------------------------------------
      INTEGER LIB$DATE_TIME
      INTEGER IER
C
      STRING = ' '
      L = MIN(17,LEN(STRING))
      IER = LIB$DATE_TIME(STRING(:L))
      END

      PROGRAM PGDEM2
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT. The main program opens the output
C device and calls a series of subroutines, one for each sample plot.
C-----------------------------------------------------------------------
      INTEGER PGOPEN
C
C Call PGOPEN to initiate PGPLOT and open the output device; PGOPEN
C will prompt the user to supply the device name and type.
C
      IF (PGOPEN('?') .LE. 0) STOP
C
C Call the demonstration subroutines.
C
      CALL PGEX21
      CALL PGEX22
      CALL PGEX23
      CALL PGEX24
      CALL PGEX25
      CALL PGEX26
C
C Finally, call PGCLOS to terminate things properly.
C
      CALL PGCLOS
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX21
C-----------------------------------------------------------------------
C Test subroutine for PGPLOT: screen alignment and color palette.
C-----------------------------------------------------------------------
      INTEGER I, L1, L2
      REAL X1, X2, Y1, Y2
      CHARACTER*80 GTYPE, GVER
C
C Get PGPLOT information.
C
      CALL PGQINF('VERSION', GVER, L1)
      CALL PGQINF('TYPE', GTYPE, L2)
      CALL PGBBUF
C
C Alignment test: clear the screen, and draw a box and grid using
C three monochrome intensities (color indices 1, 14, and 15).  The
C plot uses the largest available square viewport and and unit window.
C
      CALL PGPAGE
      CALL PGSVP(0.0,1.0,0.0,1.0)
      CALL PGWNAD(0.0,1.0,0.0,1.0)
      CALL PGSCI(14)
      CALL PGBOX('g',0.02,1,'g',0.02,1)
      CALL PGSCI(15)
      CALL PGBOX('g',0.1,5,'g',0.1,5)
      CALL PGSCI(1)
      CALL PGBOX('bc',0.1,5,'bc',0.1,5)
C
C Color palette test.
C
      DO 20 I=0,15
          CALL PGSCI(I)
          X1 = 0.31 + MOD(I,4)*0.1
          Y1 = 0.61 - (I/4)*0.1
          X2 = X1 + 0.08
          Y2 = Y1 + 0.08
          CALL PGRECT(X1, X2, Y1, Y2)
   20 CONTINUE
C
C Write the device type on the plot.
C
      CALL PGSCI(0)
      CALL PGRECT(0.31, 1.0-0.31, 0.85, 0.97)
      CALL PGSCI(1)
      CALL PGSFS(2)
      CALL PGRECT(0.31, 1.0-0.31, 0.85, 0.97)
      CALL PGPTXT(0.5, 0.91, 0.0, 0.5, 'PGPLOT '//GVER(1:L1))
      CALL PGPTXT(0.5, 0.87, 0.0, 0.5, 'Device '//GTYPE(1:L2))
C
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX22
C-----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package.
C Plot a table of the standard PGPLOT graph marker symbols. This
C program also illustrates how windows and viewports may be manipulated.
C-----------------------------------------------------------------------
      CHARACTER*2 LABEL
      INTEGER NX, NY, N, IX, JY, LW
      REAL X, X1, X2, XOFF, Y, Y1, Y2, YOFF, DX, DY
      REAL XPIX1, XPIX2, YPIX1, YPIX2, RES
C
C Determine size of view surface.
C Lower left corner is (X1,Y1), upper right (X2, Y2) [inches].
C
      CALL PGPAGE
      CALL PGSVP(0.0, 1.0, 0.0, 1.0)
      CALL PGQVP(1, X1, X2, Y1, Y2)
      X = X2-X1
      Y = Y2-Y1
C
C Determine device resolution (pixels/inch), and use it to choose
C line width.
C
      CALL PGQVP(3, XPIX1, XPIX2, YPIX1, YPIX2)
      RES = ABS(XPIX2-XPIX1)/ABS(X)
      LW = 1
      IF (RES.GT.166.0) LW = 2
C
C Choose horizontal or vertical arrangement depending on
C device aspect ratio.
C
      IF (X.GT.Y) THEN
          NX = 8
          NY = 5
      ELSE
          NX = 5
          NY = 8
      END IF
      DX = MIN(X/NX, 0.95*Y/NY)
      DY = DX
      IX = NX
      JY = 1
      XOFF = X1 + (X-NX*DX)*0.5
      YOFF = Y1 + (0.95*Y-NY*DY)*0.5
      CALL PGBBUF
C
C Each symbol will be drawn in a standard window; the window is moved
C by manipulating the viewport.
C
      CALL PGSWIN(-1.,1.,-1.,1.)
C
C Loop through all known symbols (N=0-31 and -1 to -8). 
C
      DO 10 N=0,39
          IF (N.LE.31) WRITE (LABEL,'(I2)') N
          IF (N.GT.31) WRITE (LABEL,'(I2)') 31-N
C
C Define window and viewport. The loop allows the plot to extend over
C more than one page if necessary; each page is labelled at the top.
C
          IX = IX+1
          IF (IX.GT.NX) THEN
            IX = 1
            JY = JY-1
          END IF
          IF (JY.LT.1) THEN
            JY = NY
            IF (N.NE.0) CALL PGPAGE
            CALL PGSCH(1.2)
            CALL PGVSIZ(XOFF, XOFF+NX*DX, YOFF, YOFF+NY*DY)
            CALL PGSLW(LW)
            CALL PGMTXT('T', 1.0, 0.5, 0.5,
     1                   '\fiPGPLOT \frMarker Symbols')
          END IF
          CALL PGVSIZ(XOFF+(IX-1)*DX, XOFF+IX*DX,
     1                 YOFF+(JY-1)*DY, YOFF+JY*DY)
C
C Call PGBOX to draw a box and PGMTXT to label it.
C
          CALL PGSLW(1)
          CALL PGBOX('BC',10.0,0,'BC',10.0,0)
          CALL PGSCH(0.5)
          CALL PGMTXT('T',-1.5,0.05,0.0,LABEL)
C
C Call PGPT1 to draw the symbol.
C
          CALL PGSLW(LW)
          CALL PGSCH(1.5)
          IF (N.LE.31) CALL PGPT1(0.0,0.0,N)
          IF (N.GT.31) CALL PGPT1(0.0,0.0,31-N)
   10 CONTINUE
C
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX23
C-----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package. 
C-----------------------------------------------------------------------
      INTEGER N
      PARAMETER (N=9)
      INTEGER I
      REAL X1, Y1
      CHARACTER*80 SAMPLE(N)
      DATA SAMPLE/
     1 'Normal:  \fnABCDQ efgh 1234 \ga\gb\gg\gd \gL\gH\gD\gW',
     2 'Roman:  \frABCDQ efgh 1234 \ga\gb\gg\gd \gL\gH\gD\gW',
     3 'Italic:  \fiABCDQ efgh 1234 \ga\gb\gg\gd \gL\gH\gD\gW',
     4 'Script:  \fsABCDQ efgh 1234 \ga\gb\gg\gd \gL\gH\gD\gW',
     5 '\fif\fr(\fix\fr) = \fix\fr\u2\dcos(2\gp\fix\fr)e\u\fix\fr\u2',
     6 '\fiH\d0\u \fr= 75 \(2233) 25 km s\u-1\d Mpc\u-1\d',
     7 '\fsL/L\d\(2281)\u\fr = 5\.6 \x 10\u6\d (\gl1216\A)',
     8 'Markers: 3=\m3, 8=\m8, 12=\m12, 28=\m28.',
     9 'Cyrillic: \(2830)\(2912)\(2906)\(2911)\(2919)\(2917)\(2915).'/
C
C Call PGENV to initialize the viewport and window.
C Call PGLAB to label the graph.
C
      CALL PGENV(0.,20.,REAL(N),0.,0,-2)
      CALL PGLAB(' ',' ','\fiPGPLOT \frFonts')
C
C Use PGTEXT to write the sample character strings.
C
      CALL PGSCH(1.6)
      DO 10 I=1,N
         X1 = 0.0
         Y1 = REAL(I)-0.5
         CALL PGTEXT(X1, Y1, SAMPLE(I))
 10    CONTINUE
      CALL PGSCH(1.0)
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX24
C-----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package. This example
C illustrates the different line widths.
C                              T. J. Pearson  1982 Dec 28
C----------------------------------------------------------------------
      INTEGER IW
      REAL X(2), Y(2)
C
C Call PGENV to initialize the viewport and window.
C
      CALL PGBBUF
      CALL PGENV(0.,15.,0.,15.,0,0)
C
C Call PGLAB to label the graph.
C
      CALL PGLAB('Line Width',' ','\fiPGPLOT \frLine Widths')
C
C Draw 14 oblique lines in different thicknesses.
C
      DO 10 IW=1,14
          X(1) = IW
          Y(1) = 0.0
          X(2) = 0.0
          Y(2) = IW
          CALL PGSLW(IW)
          CALL PGLINE(2,X,Y)
   10 CONTINUE
C
C Draw another set of lines, dashed instead of solid.
C
      CALL PGSLS(2)
      DO 20 IW=1,14
          X(1) = IW
          Y(1) = 15.0
          X(2) = 15.0
          Y(2) = IW
          CALL PGSLW(IW)
          CALL PGLINE(2,X,Y)
   20 CONTINUE
C
      CALL PGSLS(1)
      CALL PGSLW(1)
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX25
C-----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package. This program
C tests polygon clipping on polygons and circles, and tests that
C markers are clipped correctly. Note that markers exactly on the edge
C of the window are supposed to be visible.
C                              T. J. Pearson  1994 Nov 25
C-----------------------------------------------------------------------
      INTEGER I, J
      REAL PX(43), PY(43), SX(5), SY(5), RX(3), RY(3)
      DATA PX / 0.0,2.0,4.0,6.0,8.0,10.0,12.0,14.0,16.4,17.0,17.3,
     1          17.8, 18.5, 20.0, 22.0, 24.0, 26.0, 28.0, 29.0,
     2          28.8,27.2,25.0,23.0,21.5,21.1,21.5,22.8, 24.1, 25.1,
     3          25.2, 24.2, 22.1, 20.0, 18.0, 16.0, 14.0, 12.0,
     4          10.0,  8.0,  6.1,  4.2,  3.0,  1.3 /
      DATA PY / 8.8, 7.6, 7.1, 7.4, 8.0, 8.9, 9.6, 9.9, 9.4,
     1          9.7, 12.0, 14.0, 16.1, 17.0, 17.0, 16.0, 13.9,
     2          13.1, 13.2, 12.3, 11.5, 11.5, 11.5, 11.2, 10.5,
     3          9.0, 8.0, 7.0, 5.1, 3.6, 1.9, 1.1, 0.9, 0.7,
     4          0.8, 1.0, 1.0, 1.2, 1.8, 2.1, 2.9, 4.1, 6.0 /
      DATA SX / 10.0, 10.0, 20.0, 30.0, 15.0 /
      DATA SY /  0.0, -6.0, -6.0,  5.0, -3.5 /
      DATA RX / 26.0, 27.0, 26.0 /
      DATA RY / -4.0, -3.0, -3.0 /
C
      CALL PGPAGE
      CALL PGVSTD
      CALL PGBBUF
      CALL PGSAVE
C
C Set window.
C
      CALL PGWNAD(5.0, 25.0, -5.0, 15.0)
      CALL PGSCI(1)
      CALL PGSLW(1)
      CALL PGBOX('BCNST', 0.0, 0, 'BCNST', 0.0, 0)
C
C Test clipping of polygons and circles
C
      CALL PGSFS(1)
      CALL PGSCI(2)
      CALL PGPOLY(43, PX, PY)
      CALL PGSCI(0)
      CALL PGSFS(3)
      CALL PGSHS(30.0, 2.0, 0.0)
      CALL PGPOLY(43, PX, PY)
      CALL PGSCI(1)
      CALL PGSHS(30.0, 4.0, 0.25)
      CALL PGPOLY(43, PX, PY)
      CALL PGSCI(1)
      CALL PGSFS(2)
      CALL PGPOLY(43, PX, PY)
C
      CALL PGSFS(1)
      CALL PGSCI(4)
      CALL PGPOLY(5, SX, SY)
      CALL PGSCI(0)
      CALL PGSFS(4)
      CALL PGSHS(0.0, 1.6, 0.0)
      CALL PGPOLY(5, SX, SY)
      CALL PGSCI(1)
      CALL PGSFS(2)
      CALL PGPOLY(5, SX, SY)
C     
C       The next polygon should be invisible.
      CALL PGSFS(1)
      CALL PGSCI(4)
      CALL PGPOLY(3, RX, RY)
      CALL PGSCI(1)
      CALL PGSFS(2)
      CALL PGPOLY(3, RX, RY)
C
      CALL PGSFS(1)
      CALL PGSCI(3)
      CALL PGCIRC(8.0, 12.0, 3.5)
      CALL PGSFS(2)
      CALL PGSCI(1)
      CALL PGCIRC(8.0, 12.0, 3.5)
C
C Test clipping of markers: all should be visible.
C
      CALL PGSCI(1)
      CALL PGSLW(1)
      DO 20 I=0,30,5
         DO 10 J=-5,25,5
            CALL PGPT1(REAL(I),REAL(J),9)
 10      CONTINUE
 20   CONTINUE
C
C Draw box.
C
      CALL PGBOX('BCNST', 0.0, 0, 'BCNST', 0.0, 0)
      CALL PGLAB(' ', ' ', 'PGPLOT: clipping polygons and markers')
C
      CALL PGUNSA
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGEX26
C-----------------------------------------------------------------------
      CHARACTER*128 DEVICE
      CHARACTER*80 GTYPE, GVER
      INTEGER I, J, L, L1, L2
      REAL X, X1, X2, Y, Y1, Y2, R, XI, XP, YP
      REAL PX(43), PY(43)
      DATA PX / 0.0,2.0,4.0,6.0,8.0,10.0,12.0,14.0,16.4,17.0,17.3,
     1          17.8, 18.5, 20.0, 22.0, 24.0, 26.0, 28.0, 29.0,
     2          28.8,27.2,25.0,23.0,21.5,21.1,21.5,22.8, 24.1, 25.1,
     3          25.2, 24.2, 22.1, 20.0, 18.0, 16.0, 14.0, 12.0,
     4          10.0,  8.0,  6.1,  4.2,  3.0,  1.3 /
      DATA PY / 8.8, 7.6, 7.1, 7.4, 8.0, 8.9, 9.6, 9.9, 9.4,
     1          9.7, 12.0, 14.0, 16.1, 17.0, 17.0, 16.0, 13.9,
     2          13.1, 13.2, 12.3, 11.5, 11.5, 11.5, 11.2, 10.5,
     3          9.0, 8.0, 7.0, 5.1, 3.6, 1.9, 1.1, 0.9, 0.7,
     4          0.8, 1.0, 1.0, 1.2, 1.8, 2.1, 2.9, 4.1, 6.0 /
C
      CALL PGQINF('DEV/TYPE', DEVICE, L)
      CALL PGQINF('VERSION', GVER, L1)
      CALL PGQINF('TYPE', GTYPE, L2)
      CALL PGBBUF
C
C Clear the screen; set background and foreground colors.
C
      CALL PGPAGE
      CALL PGSCR(0,0.0,0.0,0.35)
      CALL PGSCR(1,1.0,1.0,1.0)
      CALL PGERAS
C
C Draw a frame at the physical extremities of the plot.
C Dimensions are X by Y (inches).
C
      CALL PGSVP(0.0, 1.0, 0.0, 1.0)
      CALL PGQVP(1, X1, X2, Y1, Y2)
      X = X2-X1
      Y = Y2-Y1
      CALL PGSWIN(0.0, X, 0.0, Y)
      CALL PGSFS(2)
      CALL PGRECT(0.0, X, 0.0, Y)
      CALL PGMOVE(0.5*X, 0.0)
      CALL PGDRAW(0.5*X, Y)
      CALL PGMOVE(0.0, 0.5*Y)
      CALL PGDRAW(X, 0.5*Y)
C
C Draw a circle of diameter 0.5 x min(x,y)
C
      R = 0.25*MIN(X,Y)
      CALL PGCIRC(X*0.5, Y*0.5, R)
C
C Draw some more circles with different line-styles; this tests
C the dashing algorithm on curved lines.
C
      CALL PGSLS(2)
      CALL PGCIRC(X*0.5, Y*0.5, R*1.1)
      CALL PGSLS(3)
      CALL PGCIRC(X*0.5, Y*0.5, R*1.2)
      CALL PGSLS(2)
      CALL PGSLW(3)
      CALL PGCIRC(X*0.5, Y*0.5, R*1.3)
      CALL PGSLS(1)
      CALL PGSLW(1)      
C
C Demonstrate different line-styles
C
      DO 10 I=1,5
          CALL PGSLS(I)
          CALL PGMOVE(I*(X/20.0),0.0)
          CALL PGDRAW(I*(X/20.0),Y)
   10 CONTINUE
      CALL PGSLS(1)
C
C Demonstrate different line-widths
C
      DO 20 I=1,5
          CALL PGSLW(I)
          CALL PGMOVE(0.0, I*(Y/20.0))
          CALL PGDRAW(X, I*(Y/20.0))
   20 CONTINUE
      CALL PGSLW(1)
C
C Demonstrate different line-colors
C
      CALL PGSLW(4)
      DO 40 I=0,15
          CALL PGSCI(I)
          XI = (I+20)*(X/40.0)
          CALL PGMOVE(XI,0.0)
          CALL PGDRAW(XI,Y)
   40 CONTINUE
      CALL PGSCI(1)
      CALL PGSLW(1)
C
C Draw dots in different thicknesses.
C
      XP = (14+20)*(X/40.0)
      DO 30 I=1,21
          YP = I*Y/22.0
          CALL PGSLW(I)
          CALL PGPT1(XP,YP,-1)
   30 CONTINUE
      CALL PGSLW(1)
C
C Demonstrate fill area
C
      DO 50 J=1,43
         PX(J) = (PX(J)+50.0)/100.0*X
         PY(J) = (PY(J)+75.0)/100.0*Y
   50 CONTINUE
      DO 70 I=0,3
          CALL PGSCI(I)
          CALL PGSFS(1)
          CALL PGPOLY(43,PX,PY)
          CALL PGSCI(1)
          CALL PGSFS(2)
          CALL PGPOLY(43,PX,PY)
          DO 60 J=1,43
             PY(J) = PY(J)-0.25*Y
   60     CONTINUE
   70 CONTINUE
C
C Write the device type on the plot.
C
      CALL PGSWIN(0.0, 1.0, 0.0, 1.0)
      CALL PGSFS(1)
      CALL PGSCI(0)
      CALL PGRECT(0.31, 1.0-0.31, 0.85, 0.97)
      CALL PGSCI(1)
      CALL PGSFS(2)
      CALL PGRECT(0.31, 1.0-0.31, 0.85, 0.97)
      CALL PGPTXT(0.5, 0.91, 0.0, 0.5, 'PGPLOT '//GVER(1:L1))
      CALL PGPTXT(0.5, 0.87, 0.0, 0.5, 'Device '//GTYPE(1:L2))
C
      CALL PGEBUF
C-----------------------------------------------------------------------
      END

	SUBROUTINE IKDRIV(IFUNC, RBUF, NBUF, CHR, LCHR)
	INTEGER   IFUNC, NBUF, LCHR
	REAL      RBUF(*)
	CHARACTER CHR*(*)
C
C PGPLOT driver for Ikon devices.
C---
C Supported device:  Digisolve Ikon Pixel Engine
C
C Device type code:  /IKon.
C
C Default device name:  IKON_DEFAULT (a logical name).
C
C Default view surface dimensions:  Depends on monitor.
C
C Resolution:  The full view surface is 1024 by 780 pixels.
C
C Color capability: Color indices 0-255 are supported.  The default
C   representation is listed in Chapter 5 of the PGPLOT manual.  The
C   representation of all color indices can be changed.
C
C Input capability:  
C
C File format:  It is not possible to send IKON plots to a disk file.
C
C Obtaining hardcopy:  Not possible.
C---
C 30-Jan-1988 - [AFT].
C-----------------------------------------------------------------------
	INCLUDE '($IODEF)'
C
	CHARACTER MSG*10
	INTEGER   GRIK00, SYS$DASSGN, GRGMEM, SYS$QIOW
	INTEGER   I0, J0, ISTAT
	INTEGER*2 ITMP(9), INIT(51), IOSB(4)
	INTEGER   IREM, ICHAN, MXCNT, ICNT, IBADR, ICOL, NPTS, INEWP
	SAVE      IREM, ICHAN, MXCNT, ICNT, IBADR, ICOL, NPTS, INEWP
	LOGICAL   APPEND
	SAVE      APPEND
	DATA INIT/82,15,0,     0,  0,  0, 255,255,255, 255,  0,  0,
     :		  0,255,  0,   0,  0,255,   0,255,255, 255,  0,255,
     :		255,255,  0, 255,127,  0, 127,255, 0,    0,255,127,
     :		  0,127,255, 127,  0,255, 255,  0,127,  85, 85, 85,
     :		170,170,170/
C---
	GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     &       110,120,130,140,150,160,170,180,900,200,
     &       210,900,230) IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
	CALL GRWARN('Unimplemented function in IK device driver: '//MSG)
	NBUF = -1
	RETURN
C
C--- IFUNC= 1, Return device name. -------------------------------------
10	CHR='IKON'
	LCHR=LEN(CHR)
	RETURN
C
C--- IFUNC= 2, Return Physical min and max for plot device. ------------
20	RBUF(1)=0
	RBUF(2)=1023
	RBUF(3)=0
	RBUF(4)=779
	RBUF(5)=0
	RBUF(6)=255
	NBUF=6
	RETURN
C
C--- IFUNC= 3, Return device resolution. -------------------------------
30	RBUF(1)=50.0
	RBUF(2)=50.0
	RBUF(3)=1
	NBUF=3
	RETURN
C
C--- IFUNC= 4, Return misc device info. --------------------------------
C I= Interactive device
C C= Cursor
C N= No hard dash
C A= Area fill
C N= No hard thick lines
40	CHR='ICNANNNNNN'
	LCHR=10
	RETURN
C
C--- IFUNC= 5, Return default file name. -------------------------------
50	CHR='IKON_DEFAULT'
	LCHR=LEN(CHR)
	NBUF=1
	RETURN
C
C--- IFUNC= 6, Return default physical size of plot. -------------------
60	RBUF(1)=0
	RBUF(2)=1023
	RBUF(3)=0
	RBUF(4)=779
	RETURN
C
C--- IFUNC= 7, Return misc defaults. -----------------------------------
70	RBUF(1)=1
	NBUF=1
	RETURN
C
C--- IFUNC= 8, Select plot. --------------------------------------------
80	CALL INIK03(NINT(RBUF(2)))
	RETURN
C
C--- IFUNC= 9, Open workstation. ---------------------------------------
90	APPEND=RBUF(3).NE.0.0
	RBUF(2)=GRIK00(ICHAN,CHR,LCHR)
	RBUF(1)=ICHAN
C---
C- Allocate a buffer.
	MXCNT=8192
	ISTAT=GRGMEM(MXCNT,IBADR)
	IF(ISTAT.NE.1) THEN
	    CALL GRWARN('Unable to allocate virtual memory.')
C- Error return
92	    CALL GRGMSG(ISTAT)
	    RBUF(2)=0
	    CALL SYS$DASSGN(%val(ICHAN))
	    RETURN
	END IF
C- MXCNT is the number of INTEGER*2
	MXCNT=MXCNT/2
	ICNT=0
C- Define channel for use by GRIK03.
	CALL INIK03(ICHAN)
C---
C- If device opened remotely, set remote flag.  Note, current
C- driver does not support remote access.
C---
	IF(NINT(RBUF(2)).EQ.1) THEN
	    IREM=0
	ELSE IF(NINT(RBUF(2)).EQ.3) THEN
	    IREM=1
	    RBUF(2)=1
	ELSE
C- Error condition.
	    RETURN
	END IF
C- Set last (x,y) to be invalid
	CALL INIK01
C---
C- Reset.
	IF(.NOT.APPEND) THEN
C- Reset interface.
	    ISTAT=SYS$QIOW(,%val(ICHAN),
     :                    %val(IO$_WRITEVBLK.OR.IO$M_RESET),
     :                    ,,,%val(0),%val(0),,,,)
C- Wait for status line A to go low (about 2.2 sec)
94	    ISTAT=SYS$QIOW(,%VAL(ICHAN),
     :                    %val(IO$_WRITEVBLK),IOSB,
     :                    ,,%val(0),%val(0),,,,)
	    IF(ISTAT.NE.1) GOTO 92
	    IF((IOSB(3).AND.'800'x) .NE. 0) THEN
		CALL LIB$WAIT(0.25)
		GOTO 94
	    END IF
	END IF
C- Set 8-bit register $3F (set mode) to 32 (non-buffered mode)
	ITMP(1)=96*256+63
	ITMP(2)=32
	CALL GRIK02(ITMP,2,%val(IBADR),ICNT,MXCNT)
	CALL GRIK03(%val(IBADR),ICNT)
C- Set 8-bit register $00 (Background color) to 0.
	ITMP(1)=96*256+0
	ITMP(2)=0
	CALL GRIK02(ITMP,2,%val(IBADR),ICNT,MXCNT)
C- Select frame buffer 0 to write
	ITMP(1)=125*256+0
C- Select frame buffer 0 to read
	ITMP(2)=124*256+0
C- Load reg. 74=xA4, AUX port setup (0 trans, rel. mouse, 19200 baud).
	ITMP(3)=96*256+74
	ITMP(4)=227
C- Disable clipping (useful if APPENDing to a GKS plot).
	ITMP(5)=203
	CALL GRIK02(ITMP,5,%val(IBADR),ICNT,MXCNT)
	IF(.NOT.APPEND) THEN
C- Load default lookup table (if not appending).
	    CALL GRIK02(INIT,51,%val(IBADR),ICNT,MXCNT)
	END IF
	RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
100	CALL SYS$DASSGN(%val(ICHAN))
	CALL GRFMEM(MXCNT,IBADR)
	RETURN
C
C--- IFUNC=11, Begin Picture. ------------------------------------------
110	IF(.NOT.APPEND) THEN
C- Set frame buffer to background color.
	    ITMP(1)=161
	    CALL GRIK02(ITMP,1,%val(IBADR),ICNT,MXCNT)
	END IF
	APPEND=.FALSE.
	RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
120	CALL GRIK01(RBUF,%val(IBADR),ICNT,MXCNT)
	RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
130	CALL GRIK05(RBUF,%val(IBADR),ICNT,MXCNT)
	RETURN
C
C--- IFUNC=14, End Picture. --------------------------------------------
140	RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
150	ICOL=MAX(0,MIN(NINT(RBUF(1)),255))
	RBUF(1)=ICOL
	ITMP(1)=65*256+ICOL
	CALL GRIK02(ITMP,1,%val(IBADR),ICNT,MXCNT)
	RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
160	CALL GRIK03(%val(IBADR),ICNT)
	RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
170	I0=RBUF(1)
	J0=RBUF(2)
	CALL GRIK04(ICHAN,I0,J0,CHR,%val(IBADR),ICNT,MXCNT)
	RBUF(1)=I0
	RBUF(2)=J0
	NBUF=2
	LCHR=1
	RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
180	RETURN
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C- Requires Ikon firmware revision V1.2 (or greater)
200	IF(NPTS.EQ.0) THEN
	    NPTS=RBUF(1)
C- Set fill drawing color register (p. 59)
	    ITMP(1)=69*256+ICOL
C- Set fill area style to solid (p. 186)
	    ITMP(2)=97*256+52
	    ITMP(3)=0
	    CALL GRIK02(ITMP,3,%val(IBADR),ICNT,MXCNT)
	    INEWP=1
	ELSE
	    NPTS=NPTS-1
	    IF(INEWP.NE.0) THEN
		INEWP=0
C- Draw filled polygon
		ITMP(1)=188
		ITMP(2)=0
		ITMP(3)=NPTS
		ITMP(4)=RBUF(1)
		ITMP(5)=RBUF(2)
		CALL GRIK02(ITMP,5,%val(IBADR),ICNT,MXCNT)
	    ELSE
		ITMP(1)=RBUF(1)
		ITMP(2)=RBUF(2)
		CALL GRIK02(ITMP,2,%val(IBADR),ICNT,MXCNT)
	    END IF
	END IF
	RETURN
C
C--- IFUNC=21, Set color representation. -------------------------------
210	ITMP(1)=81
	ITMP(2)=NINT(RBUF(1))
	ITMP(3)=IAND(255,INT(RBUF(2)*255.999))
	ITMP(4)=IAND(255,INT(RBUF(3)*255.999))
	ITMP(5)=IAND(255,INT(RBUF(4)*255.999))
	CALL GRIK02(ITMP,5,%val(IBADR),ICNT,MXCNT)
	RETURN
C
C--- IFUNC=23, Escape. -------------------------------------------------
C- Send CHR array directly to Ikon (user better know what he is doing!)
230	CALL GRIK02(%ref(CHR),LCHR/2,%val(IBADR),ICNT,MXCNT)
	RETURN
C-----------------------------------------------------------------------
	END

	INTEGER FUNCTION GRIK00(LUN,CHR,LCHR)
C-----------------------------------------------------------------------
C Open a channel to the IKON device.
C
C GRIK00 (returns integer): Opens a channel to the IKON device.
C
C  9-Dec-1987 - [AFT].
C-----------------------------------------------------------------------
        INCLUDE  '($IODEF)'
        INCLUDE  '($SSDEF)'
	INTEGER   LUN, LCHR
	CHARACTER CHR*(*)
	INTEGER   IER, ITEMP, ISTAT, LENGTH
	INTEGER   SYS$ASSIGN, SYS$QIOW
	INTEGER*2 IOSB(4)
C---
C- Assign an i/o channel
C---
	IER = SYS$ASSIGN(CHR(:LCHR), LUN,,)
	IF(IER.NE.SS$_NORMAL .AND. IER.NE.SS$_REMOTE) GOTO 800
C---
C- Poll the interface waiting for status line A to go low.
C---
100	CALL LIB$WAIT(0.5)
	ISTAT = SYS$QIOW(,%val(LUN),
     :                    %val(IO$_WRITEVBLK),IOSB,
     :                    ,,%val(0),%val(0),,,,)
 	IF( (IOSB(3).AND.'800'X) .NE. 0) GOTO 100
C---
	IF(IER .EQ. SS$_REMOTE) THEN
C---
C Cannot check device characteristics easily if network device being used
C so just check whether we opened the device successfully and return
C Read back the status from assign to plotting device over network
C---
	    IER=SYS$QIOW(,%VAL(LUN),%VAL(IO$_READVBLK),
     :                   IOSB,,,ISTAT,LENGTH,,,,)
	    IF(IOSB(1) .NE. SS$_NORMAL) THEN
	        CALL GRWARN ('Unable to read status from ASSIGN to' //
     :                      ' graphics device on remote node')
	        WRITE(6,*) IOSB(2), ' bytes read'
	        ITEMP=IOSB(1)
	        CALL GRGMSG(ITEMP)
	        GRIK00=0
	        RETURN
	    END IF
	    IF(ISTAT .NE. SS$_NORMAL) THEN
	        IER=ISTAT
	        GOTO 800
	    ELSE
	        GRIK00=3
	        RETURN
	    END IF
	END IF
C---
C- Successful completion
C---
	GRIK00 = 1
	RETURN
C---
C- Error exit
C---
  800	CALL GRWARN('Cannot open graphics device '//CHR(:LCHR))
	CALL GRGMSG(IER)
	GRIK00 = 0
	END

	SUBROUTINE GRIK01(RBUF,IBUF,ICNT,MXCNT)
	REAL      RBUF(4)
	INTEGER   ICNT, MXCNT
	INTEGER*2 IBUF
C-----------------------------------------------------------------------
C Part of PGPLOT device driver for IKON
C Draw a line segment.
C
C Arguments:
C RBUF(*) (input)  Draw line from (RBUF(1),RBUF(2)) to (RBUF(3),RBUF(4))
C IBUF    (input)  Address of a buffer area
C ICNT    (in/out) Number of bytes in use in buffer
C MXCNT   (input)  Maximum size of buffer in bytes
C
C 30-Jan-1988 - [AFT]
C-----------------------------------------------------------------------
	INTEGER   IPTR
	INTEGER*2 ITMP(4)
	INTEGER*2 I0, J0, I1, J1
	INTEGER*2 LASTI, LASTJ
	SAVE      LASTI, LASTJ
C
	I0=NINT(RBUF(1))
	J0=NINT(RBUF(2))
	I1=NINT(RBUF(3))
	J1=NINT(RBUF(4))
	IF(I0.NE.LASTI .OR. J0.NE.LASTJ) THEN
	    ITMP(1)=164
	    ITMP(2)=I0
	    ITMP(3)=J0
            IPTR=3
	ELSE
	    IPTR=0
	END IF
	ITMP(IPTR+1)=178*256
	ITMP(IPTR+2)=I1
	ITMP(IPTR+3)=J1
	IPTR=IPTR+3
	LASTI=I1
	LASTJ=J1
	CALL GRIK02(ITMP,IPTR,IBUF,ICNT,MXCNT)
	RETURN
C
	ENTRY INIK01
	LASTI=-1
	LASTJ=-1
	RETURN
	END

	SUBROUTINE GRIK02(ITMP, N, IBUF, ICNT, MXCNT)
C-----------------------------------------------------------------------
C GRPCKG (internal routine for IKON driver): Transfer N words to
C the output buffer, flushing the buffer as necessary with the
C GRIK03 routine.  If the N bytes will not fit into the current
C buffer, then the buffer is first dumped.  This is to to cause
C STR to be transferred as a complete unit.
C Based on early versions of GRxx02 routines, this version does not
C use any common blocks.
C ***NOTE*** INIK03 must be called before any calls to GRIK02 to
C set the LUN/Channel to which the buffer should be dumped.
C
C Arguments:
C
C ITMP(N)	I   I*2	Data to be written.
C N		I   I	The number of words to transfer.
C IBUF		I/O I*2 The output buffer.
C ICNT		I/O I	Current number of words used in QBUF.
C MXCNT		I/O I	Maximum number of words that can be stored
C			-in IBUF.
C
C  9-Dec-1987 - [AFT].
C-----------------------------------------------------------------------
	INTEGER   N, ICNT, MXCNT, I
	INTEGER*2 ITMP(N), IBUF(MXCNT)
C---
	IF(ICNT+N.GE.MXCNT) CALL GRIK03(IBUF,ICNT)
	DO I=1,N
	    IF(ICNT.GE.MXCNT) CALL GRIK03(IBUF,ICNT)
	    ICNT=ICNT+1
	    IBUF(ICNT)=ITMP(I)
	END DO
	RETURN
	END

	SUBROUTINE GRIK03(IBUF,ICNT)
	INTEGER   ICNT
	INTEGER*2 IBUF(*)
C-----------------------------------------------------------------------
C GRPCKG(internal routine, IKON):
C set the channal to which the buffer should be dumped.
C This subroutine contains the entry point INIK03 that defines
C the variables ICHAN.
C
C Arguments:
C
C IBUF		I/O I*2 The output buffer.
C ICNT		I/O I	Current number of words used in QBUF.
C
C  9-Dec-1987 - [AFT].
C-----------------------------------------------------------------------
	INCLUDE '($IODEF)'
	INTEGER   SYS$QIOW
	INTEGER   ISTAT
	INTEGER*2 IOSB(4)
	INTEGER   INCHAN
	INTEGER   ICHAN
	SAVE      ICHAN
C
	IF(ICNT.GT.0) THEN
            ISTAT = sys$qiow(,%val(ICHAN),
     :          %val(IO$_WRITEVBLK.OR.IO$M_SETFNCT.OR.IO$M_TIMED),
     :          IOSB,,,IBUF,%val(2*ICNT),%val(15),%val(0),,)
	END IF
	ICNT=0
	RETURN
C---
	ENTRY INIK03(INCHAN)
C- Save info needed to dump buffer.
	ICHAN=INCHAN
	RETURN
	END

      SUBROUTINE GRIK04(ICHAN,IX,IY,CHR,IBUF,ICNT,MXCNT)
C
      INTEGER   ICHAN, IX, IY, IBUF, ICNT, MXCNT
      CHARACTER CHR
C
C Arguments
C ICHAN  (input)  QIO channel assigned to Args
C IX,IY  (in/out) The cursor position
C CHR    (output) The keyboard character pressed
C IBUF   (input)  Address of a buffer area
C ICNT   (in/out) Number of bytes in use in buffer
C MXCNT  (input)  Maximum size of buffer in bytes
C---
C Read the cursor position on the Ikon.  The cursor can be moved
C by either rolling the tracker ball.
C The cursor can also be moved by using the cursor keys on the
C terminal associated with SYS$COMMAND in which case the cursor
C "speed" (step size) is controlled by the PF1 (smallest step) to
C PF4 (largest step) keys. The numeric keys on the keypad can be
C used in place of the arrow keys, with the addition of diagonal
C motion:
C         UP
C      7  8  9
C LEFT 4     6 RIGHT
C      1  2  3
C        DOWN
C---
C- 21-Jan-1988 - Based on ARDRIVER [AFT].
C---
      INCLUDE '($IODEF)'
C-
      INTEGER   SYS$QIOW
      INTEGER   SMG$CREATE_VIRTUAL_KEYBOARD, SMG$READ_KEYSTROKE
      INTEGER   ISTAT, IDSMG
      INTEGER   ISTEP, IXWAS, IYWAS, IVAL
      INTEGER*2 ITMP(9), IOSB(4), ICURS(9)
      LOGICAL   QKEY
C---
      ISTAT=SMG$CREATE_VIRTUAL_KEYBOARD(IDSMG,'SYS$COMMAND')
      IF(ISTAT.NE.1) THEN
          CALL GRGMSG(ISTAT)
          CALL GRQUIT('Fatal error.')
      END IF
C---
C- Load 32-bit reg. 26=x1A GID max position
      ITMP(1)=99*256+26
      ITMP(2)= 779
      ITMP(3)=1023
C- Load 32-bit reg. 28=x1C GID size.
      ITMP(4)=99*256+28
      ITMP(5)= 779
      ITMP(6)=1023
      CALL GRIK02(ITMP,6,IBUF,ICNT,MXCNT)
C- Load reg. 74=xA4, AUX port setup (0 trans, rel. mouse, 19200 baud).
      ITMP(1)=96*256+74
      ITMP(2)=227
C- Set up zone to constrain cursor
      ITMP(3)=99*256+44
      ITMP(4)= 779
      ITMP(5)=1023
      CALL GRIK02(ITMP,5,IBUF,ICNT,MXCNT)
C---
C- Cursor on.
      ITMP(1)=193
C- Load 8-bit reg. 24=x18 with Enable GID
      ITMP(2)=96*256+24
      ITMP(3)=128
      CALL GRIK02(ITMP,3,IBUF,ICNT,MXCNT)
C- Defaults.
      ISTEP=2
      QKEY=.FALSE.
C---
C- Position cursor.
200       ITMP(1)=164
          ITMP(2)=IX
          ITMP(3)=IY
C- Anchor GID to current position (i.e., keep cursor on screen).
          ITMP(4)=86
          CALL GRIK02(ITMP,4,IBUF,ICNT,MXCNT)
          CALL GRIK03(IBUF,ICNT)
          IXWAS=IX
          IYWAS=IY
C- See if user has typed something at keyboard.
          ISTAT=SMG$READ_KEYSTROKE(IDSMG,IVAL,,0)
          IF(ISTAT.NE.1) IVAL=0
          IF(IVAL.EQ.259) THEN
C- PF4=large step
              ISTEP=64
          ELSE IF(IVAL.EQ.258) THEN
              ISTEP=8
          ELSE IF(IVAL.EQ.257) THEN
              ISTEP=4
          ELSE IF(IVAL.EQ.256) THEN
C- PF1=small step
              ISTEP=1
          ELSE IF(IVAL.EQ.49 .OR. IVAL.EQ.261) THEN
C- key 1 or KP1
              IX=IX-ISTEP
              IY=IY-ISTEP
          ELSE IF(IVAL.EQ.50 .OR. IVAL.EQ.262 .OR. IVAL.EQ.275) THEN
C- key 2, KP2 or DOWN
              IY=IY-ISTEP
          ELSE IF(IVAL.EQ.51 .OR. IVAL.EQ.263) THEN
C- key 3 or KP3
              IX=IX+ISTEP
              IY=IY-ISTEP
          ELSE IF(IVAL.EQ.52 .OR. IVAL.EQ.264 .OR. IVAL.EQ.276) THEN
C- key 4, KP4 or LEFT
              IX=IX-ISTEP
          ELSE IF(IVAL.EQ.54 .OR. IVAL.EQ.266 .OR. IVAL.EQ.277) THEN
C- key 6, KP6 or RIGHT
              IX=IX+ISTEP
          ELSE IF(IVAL.EQ.55 .OR. IVAL.EQ.267) THEN
C- key 7 or KP7
              IX=IX-ISTEP
              IY=IY+ISTEP
          ELSE IF(IVAL.EQ.56 .OR. IVAL.EQ.268 .OR. IVAL.EQ.274) THEN
C- key 8, KP8 or UP
              IY=IY+ISTEP
          ELSE IF(IVAL.EQ.57 .OR. IVAL.EQ.269) THEN
C- key 9 or KP9
              IX=IX+ISTEP
              IY=IY+ISTEP
          ELSE IF((IVAL.GT.0 .AND. IVAL.LT.48) .OR. 
     &		(IVAL.GT.57 .AND. IVAL.LT.255)) THEN
              QKEY=.TRUE.
          END IF
C---
C- Read current cursor position
C**** Due to possible hardware fault the following code will
C**** sometimes reset the IKON.
          ITMP(1)=165
          CALL GRIK02(ITMP,1,IBUF,ICNT,MXCNT)
          CALL GRIK03(IBUF,ICNT)
C- Read 4 bytes, timing out in 2 sec.
          ISTAT = sys$qiow(,%val(ICHAN),
     :          %val(IO$_READVBLK.OR.IO$M_SETFNCT.OR.IO$M_TIMED),
     :          IOSB,,,ICURS,%val(4),%val(2),%val(1),,)
          IF(ISTAT.EQ.1 .AND. IOSB(1).EQ.1) THEN
              IX=IX+ICURS(1)-IXWAS
              IY=IY+ICURS(2)-IYWAS
          END IF
          IX=MAX(IX,   0)
          IX=MIN(IX,1023)
          IY=MAX(IY,   0)
          IY=MIN(IY, 779)
          IF(IX.EQ.IXWAS .AND. IY.EQ.IYWAS) THEN
              CALL LIB$WAIT(0.05)
          END IF
      IF(.NOT.QKEY) GOTO 200
      CHR=CHAR(IVAL)
C---
C- Turn cursor off
      ITMP(1)=192
      CALL GRIK02(ITMP,1,IBUF,ICNT,MXCNT)
      CALL GRIK03(IBUF,ICNT)
C---
C- Free resources.
      CALL SMG$DELETE_VIRTUAL_KEYBOARD(IDSMG)
      RETURN
      END

	SUBROUTINE GRIK05(RBUF,IBUF,ICNT,MXCNT)
	REAL      RBUF(2)
	INTEGER   ICNT, MXCNT
	INTEGER*2 IBUF
C-----------------------------------------------------------------------
C Part of PGPLOT device driver for IKON
C Draw a dot.
C
C Arguments:
C RBUF(*) (input)  (RBUF(1),RBUF(2)) is the (x,y) position of the dot.
C IBUF    (input)  Address of a buffer area
C ICNT    (in/out) Number of bytes in use in buffer
C MXCNT   (input)  Maximum size of buffer in bytes
C
C 30-Jan-1988 - [AFT]
C-----------------------------------------------------------------------
	INTEGER*2 ITMP(3)
C
C- Move and draw pixel.
	ITMP(1)=166
	ITMP(2)=RBUF(1)
	ITMP(3)=RBUF(2)
	CALL GRIK02(ITMP,3,IBUF,ICNT,MXCNT)
	CALL INIK01
	RETURN
	END

C*NEDRIV -- PGPLOT NeXTstep driver
C+
      SUBROUTINE NEDRIV(IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C
C PGPLOT driver for NeXT computers.
C
C 1992-Feb-16 - Copied from psdriv.f - [AFT]
C
C Supported device:
C   Any computer running NeXTstep.
C
C Device type code:
C   /NEXT
C
C Default file name:
C   none
C
C Default view surface dimensions:
C   The default screen size is 720 by 535 pixels (about 8 by 6 inches
C   on a 19 inch monitor).  The aspect ratio was selected to match
C   the /PS device.  The window can be resized larger or smaller.
C
C Resolution:
C   The screen resolution is 92 dpi.  The driver generates PostScript
C   commands with a resolution 10 times greater than the screen resolution.
C   This allows the window to be resized and/or a hardcopy to be made with
C   no loss of resolution.
C
C Color capability:
C   On all devices, color indices 0-15 are supported.  The default colors
C   are 0 is white, 1 is black, 14 is light gray, 15 dark gray.  On
C   monochrome devices, color indices 2-13 default to black.  If the
C   driver detects a color server, then color indices 0-255 are allowed
C   and color indices 2-13 default to the standard PGPLOT colors.
C
C Input capability:
C   The PGPLOT cursor is supported.  When a cursor read is requested the
C   the viewer becomes the active application and the active plot window
C   becomes the key window.  This allows the user to terminate the cursor
C   read by either a mouse click (which generates an 'A' character) or
C   by pressing a key on the keyboard.
C
C File format:
C   By using the print command, in the main menu, you can send the
C   contents of the current window to a file.  This file can then be
C   printed on any PostScript printer.
C
C Obtaining hardcopy:
C   If you click on the print item in the main menu, then the standard
C   NeXT print panel comes up.  This allows the contents of the current
C   window to be sent to a printer, disk file or previewer.
C
C References:
C
C (1) Adobe Systems, Inc.: PostScript Language Reference Manual.
C Addison-Wesley, Reading, Massachusetts, 1985.
C (2) Adobe Systems, Inc.: PostScript Language Tutorial and Cookbook.
C Addison-Wesley, Reading, Massachusetts, 1985.
C (3) Adobe Systems, Inc.: PostScript Language Reference Manual, Second
C Edition. Addison-Wesley, Reading, Massachusetts, 1990.
C (4) Adobe Systems, Inc.: Programming the Display PostScript System
C with NeXTstep. Addison-Wesley, Reading, Massachusetts, 1992.
C-----------------------------------------------------------------------
      CHARACTER*(*) DTYPE
      PARAMETER (DTYPE= 'NEXT  (Display on NeXT console)')
      CHARACTER*120 INSTR, MSG
      CHARACTER CBUF*4
      REAL      RTMP(4)
      INTEGER   HEIGHT, RESOL, WIDTH
      SAVE      HEIGHT, RESOL, WIDTH
      INTEGER   LASTI, LASTJ, NPTS
      SAVE      LASTI, LASTJ, NPTS
      INTEGER   CI, LW
      INTEGER   I0, J0, I1, J1, L
      INTEGER   NXP, NYP, XORG, YORG, XLEN, YLEN, N, RGB(3)
      INTEGER   HIGH, LOW, I, K, KMAX
      LOGICAL   START, COLOR
      SAVE      START, COLOR
      REAL RVALUE(0:255), GVALUE(0:255), BVALUE(0:255)
      SAVE RVALUE,        GVALUE,        BVALUE
C
      REAL          SHADE(0:15), RINIT(0:15), GINIT(0:15), BINIT(0:15)
      SAVE          SHADE,       RINIT,       GINIT,       BINIT
      CHARACTER*1   HEXDIG(0:15)
      DATA HEXDIG/'0','1','2','3','4','5','6','7',
     1            '8','9','A','B','C','D','E','F'/
      DATA SHADE /1.00, 13*0.00, 0.33, 0.67/
      DATA RINIT
     1     / 1.00, 0.00, 1.00, 0.00, 0.00, 0.00, 1.00, 1.00,
     2       1.00, 0.50, 0.00, 0.00, 0.50, 1.00, 0.33, 0.67/
      DATA GINIT
     1     / 1.00, 0.00, 0.00, 1.00, 0.00, 1.00, 0.00, 1.00,
     2       0.50, 1.00, 1.00, 0.50, 0.00, 0.00, 0.33, 0.67/
      DATA BINIT
     1     / 1.00, 0.00, 0.00, 0.00, 1.00, 1.00, 1.00, 0.00,
     2       0.00, 0.00, 0.50, 1.00, 1.00, 0.50, 0.33, 0.67/
      DATA WIDTH,HEIGHT/0.,0./
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230,900,900,260,900,900,290), IFUNC
      GOTO 900
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CONTINUE
      CHR = DTYPE
      LCHR = LEN(DTYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 CONTINUE
      IF(HEIGHT.EQ.0.) THEN
         CALL NEXSUP(1,CBUF,RTMP)
         HEIGHT = RTMP(1)
         WIDTH  = RTMP(2)
         RESOL  = RTMP(3)
      END IF
      RBUF(1) = 0
      RBUF(3) = 0
      RBUF(5) = 0
      RBUF(2) = HEIGHT-1
      RBUF(4) = WIDTH-1
      RBUF(6) = 255
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
   30 CONTINUE
      IF(HEIGHT.EQ.0.) THEN
         CALL NEXSUP(1,CBUF,RTMP)
         HEIGHT = RTMP(1)
         WIDTH  = RTMP(2)
         RESOL  = RTMP(3)
      END IF
      RBUF(1) = RESOL*92.0
      RBUF(2) = RESOL*92.0
      RBUF(3) = 5
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Interactive, Cursor, No dashed lines, Area fill,
C    Thick lines, No Rectangle fill, Array images.)
C
   40 CHR = 'ICNATNQNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CONTINUE
      CHR  = ' '
      LCHR = 0
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 CONTINUE
      IF(HEIGHT.EQ.0.) THEN
         CALL NEXSUP(1,CBUF,RTMP)
         HEIGHT = RTMP(1)
         WIDTH  = RTMP(2)
         RESOL  = RTMP(3)
      END IF
      RBUF(1) = 0
      RBUF(3) = 0
      RBUF(2) = HEIGHT-1
      RBUF(4) = WIDTH-1
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 8
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
      CALL NEXSUP(1,CBUF,RTMP)
      COLOR =  RTMP(4).NE.0.0
      IF (COLOR) THEN
         DO 91 CI=0,15
            RVALUE(CI) = RINIT(CI)
            GVALUE(CI) = GINIT(CI)
            BVALUE(CI) = BINIT(CI)
 91      CONTINUE
      ELSE
         DO 92 CI=0,15
            RVALUE(CI) = SHADE(CI)
            GVALUE(CI) = SHADE(CI)
            BVALUE(CI) = SHADE(CI)
 92      CONTINUE
      END IF
      DO 93 CI=16,255
         RVALUE(CI) = 0.0
         GVALUE(CI) = 0.0
         BVALUE(CI) = 0.0
 93   CONTINUE
C
      LASTI = -1
      LASTJ = -1
      NPTS = 0
C
      RBUF(1) = 1
      RBUF(2) = 1
      NBUF = 2
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
      CALL NEXSUP(7,CBUF,RTMP)
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
C If user has deleted window, create a new one now.
      CALL NEXSUP(1,CBUF,RTMP)
      HEIGHT = RTMP(1)
      WIDTH  = RTMP(2)
      RESOL  = RTMP(3)
      COLOR =  RTMP(4).NE.0.0
C Send begin picture message.
      CALL NEXSUP(2,CBUF,RTMP)
C The following line clears the screen.
      CALL GRFAO('1.0 setgray 0 0 # # rectfill', L, INSTR,
     :         HEIGHT, WIDTH, 0, 0)
      CALL GRNE02(0, INSTR(:L), 0)
      CALL GRNE02(0, '1 setlinejoin 1 setlinecap 1 SLW', 0)
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
      IF (I0.EQ.LASTI .AND. J0.EQ.LASTJ) THEN
          CALL GRFAO('# # c', L, INSTR, (I1-I0), (J1-J0), 0, 0)
      ELSE
          CALL GRFAO('# # # # l', L, INSTR, (I1-I0), (J1-J0), I0, J0)
      END IF
      LASTI = I1
      LASTJ = J1
      CALL GRNE02(0, INSTR(:L), 0)
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      I1 = NINT(RBUF(1))
      J1 = NINT(RBUF(2))
      CALL GRFAO('# # d', L, INSTR, I1, J1, 0, 0)
      LASTI = I1
      LASTJ = J1
      CALL GRNE02(0, INSTR(:L), 0)
      RETURN
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
      CALL GRNE02(0, ' ', 1)
      CALL NEXSUP(6, CBUF, RTMP)
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C
  150 CONTINUE
      CI = NINT(RBUF(1))
      IF (COLOR) THEN
          WRITE(INSTR,151) RVALUE(CI), GVALUE(CI), BVALUE(CI)
  151     FORMAT(3(F5.3,1X),'setrgbcolor')
          L = 29
      ELSE
          WRITE(INSTR,'(F5.3,1X,''setgray'')') RVALUE(CI)
          L = 13
      END IF
      LASTI = -1
      CALL GRNE02(0, INSTR(:L), 0)
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      CALL GRNE02(0, ' ', 1)
      CALL NEXSUP(5, CBUF, RTMP)
      LASTI=-1
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C
  170 CONTINUE
      CALL NEXSUP(4, CBUF, RTMP)
      RBUF(1)=RTMP(1)
      RBUF(2)=RTMP(2)
      NBUF=2
      CHR(1:1)=CHAR(NINT(RTMP(3)))
      LCHR=1
      RETURN
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Null operation: there is no alpha screen.)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called.)
C
  190 GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      IF (NPTS.EQ.0) THEN
          NPTS = RBUF(1)
          START = .TRUE.
          RETURN
      ELSE
          NPTS = NPTS-1
          I0 = NINT(RBUF(1))
          J0 = NINT(RBUF(2))
          IF (START) THEN
              CALL GRFAO('# # BP', L, INSTR, I0, J0, 0, 0)
              START = .FALSE.
              LASTI = I0
              LASTJ = J0
          ELSE IF (NPTS.EQ.0) THEN
              CALL GRFAO('# # EP', L, INSTR, (I0-LASTI),
     1                     (J0-LASTJ), 0, 0)
              LASTI = -1
              LASTJ = -1
          ELSE
              CALL GRFAO('# # LP', L, INSTR, (I0-LASTI),
     1                     (J0-LASTJ), 0, 0)
              LASTI = I0
              LASTJ = J0
          END IF
          CALL GRNE02(0, INSTR(:L), 0)
          RETURN
      END IF
C
C--- IFUNC=21, Set color representation. -------------------------------
C
  210 CONTINUE
      IF (COLOR) THEN
          CI = RBUF(1)
          RVALUE(CI) = RBUF(2)
          GVALUE(CI) = RBUF(3)
          BVALUE(CI) = RBUF(4)
      ELSE
          CI = RBUF(1)
          RVALUE(CI) = 0.30*RBUF(2) + 0.59*RBUF(3) + 0.11*RBUF(4)
          GVALUE(CI) = RVALUE(CI)
          BVALUE(CI) = RVALUE(CI)
      END IF
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C
  220 CONTINUE
      LW = NINT(RBUF(1))
      CALL GRFAO('# SLW', L, INSTR, LW, 0, 0, 0)
      LASTI = -1
      CALL GRNE02(0, INSTR(:L), 0)
      RETURN
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
      CALL GRNE02(0, CHR(:LCHR), 1)
      LASTI = -1
      RETURN
C
C--- IFUNC=26, Image.---------------------------------------------------
C
  260 CONTINUE
      N = RBUF(1)
      IF (N.EQ.0) THEN
C         -- First: setup for image
C         -- Set clipping region (RBUF(2...5))
          NXP = RBUF(2)
          NYP = RBUF(3)
          XORG = RBUF(4)
          XLEN = RBUF(5) - RBUF(4)
          YLEN = RBUF(7) - RBUF(6)
          YORG = RBUF(6)
          CALL GRNE02(0, 'gsave newpath', 0)
          CALL GRFAO('# # moveto # 0 rlineto 0 # rlineto', L, INSTR,
     :               XORG, YORG, XLEN, YLEN)
          CALL GRNE02(0, INSTR(:L), 0)
          CALL GRFAO('# 0 rlineto closepath clip', L, INSTR, -XLEN,
     :                0, 0, 0)
          CALL GRNE02(0, INSTR(:L), 0)
C         --
          CALL GRFAO('/picstr # string def', L, INSTR, NXP, 0, 0, 0)
          CALL GRNE02(0, INSTR(:L), 0)
          CALL GRFAO('# # 8 [', L, INSTR, NXP, NYP, 0, 0)
          CALL GRNE02(0, INSTR(:L), 0)
          WRITE (INSTR, '(6(1PE10.3, 1X), '']'')') (RBUF(I),I=8,13)
          CALL GRNE02(0, INSTR(:67), 0)
          IF (COLOR) THEN
              CALL GRNE02(0,
     :   '{currentfile picstr readhexstring pop} false 3 colorimage',0)
          ELSE
              CALL GRNE02(0,
     :      '{currentfile picstr readhexstring pop} image',0)
          END IF
      ELSE IF (N.EQ.-1) THEN
C         -- Last: terminate image
          CALL GRNE02(0, 'grestore', 0)
      ELSE
C         -- Middle: write N image pixels; each pixel uses 6 chars
C            in INSTR, so N must be <= 20.
          L = 0
          KMAX = 1
          IF (COLOR) KMAX = 3
          DO 262 I=1,N
              CI = RBUF(I+1)
              RGB(1) = NINT(255.0*RVALUE(CI))
              RGB(2) = NINT(255.0*GVALUE(CI))
              RGB(3) = NINT(255.0*BVALUE(CI))
              DO 261 K=1,KMAX
                  HIGH = RGB(K)/16
                  LOW  = RGB(K)-16*HIGH
                  L = L+1
                  INSTR(L:L) = HEXDIG(HIGH)
                  L = L+1
                  INSTR(L:L) = HEXDIG(LOW)
 261          CONTINUE
 262      CONTINUE
          CALL GRNE02(0, INSTR(1:L), 1)
      END IF
      RETURN
C
C--- IFUNC=29, Query color representation.------------------------------
C
 290  CONTINUE
      CI = NINT(RBUF(1))
      NBUF = 4
      RBUF(2) = RVALUE(CI)
      RBUF(3) = GVALUE(CI)
      RBUF(4) = BVALUE(CI)
      RETURN
C
C-----------------------------------------------------------------------
C Error: unimplemented function.
C
  900 WRITE (MSG, 901) IFUNC
  901 FORMAT('Unimplemented function in PS device driver: ',I10)
      CALL GRWARN(MSG)
      NBUF = -1
      RETURN
C-----------------------------------------------------------------------
      END

C*GRNE02 -- PGPLOT NeXT driver, buffer routine.
C+
      SUBROUTINE GRNE02(UNIT, CIN, IFLUSH)
      CHARACTER CIN*(*)
      INTEGER   UNIT, IFLUSH
C
C Support routine for NEdriver: Add string to buffer,
C flushing if needed.  If IFLUSH>0 flush buffer.
C-----------------------------------------------------------------------
      CHARACTER CBUF*132
      INTEGER   LBUF, LIN
      SAVE      CBUF, LBUF
      REAL      RTMP
      DATA      LBUF/0/
C
      LIN = LEN(CIN)
      IF(LIN.GT.0) THEN
         IF(LBUF+LIN+1.GE.LEN(CBUF)) THEN
            CBUF(LBUF+1:LBUF+1)=CHAR(0)
            CALL NEXSUP(3, CBUF, RTMP)
            LBUF=0
         END IF
         IF(LBUF.GT.0) THEN
            CBUF(LBUF+1:LBUF+1)=' '
            LBUF=LBUF+1
         END IF
         CBUF(LBUF+1:LBUF+LIN)=CIN
         LBUF=LBUF+LIN
      END IF
      IF(IFLUSH.GT.0) THEN
         IF(LBUF.GT.0) THEN
            CBUF(LBUF+1:LBUF+1)=CHAR(0)
            CALL NEXSUP(3, CBUF, RTMP)
            LBUF=0
         END IF
      END IF
C-----------------------------------------------------------------------
      END

C*GRUSER -- get user name (MS-DOS)
C+
      SUBROUTINE GRUSER(CUSER, LUSER)
      CHARACTER CUSER*(*)
      INTEGER   LUSER
C
C Return the name of the user running the program.
C
C Arguments:
C  CUSER  : receives user name, truncated or extended with
C           blanks as necessary.
C  LUSER  : receives the number of characters in VALUE, excluding
C           trailing blanks.
C--
C 1989-Mar-19 - [AFT]
C-----------------------------------------------------------------------
C
      CALL GRGENV('USER', CUSER, LUSER)
      RETURN
      END

C*GRSKPB -- skip blanks in character string
C+
      SUBROUTINE GRSKPB (S, I)
      CHARACTER*(*) S
      INTEGER I
C
C GRSKPB: increment I so that it points to the next non-blank
C character in string S.  'Blank' characters are space and tab (ASCII 
C character value 9).
C
C Arguments:
C  S      (input)  : character string to be parsed.
C  I      (in/out) : on input, I is the index of the first character
C                    in S to be examined; on output, either it points
C                    to the next non-blank character, or it is equal
C                    to LEN(S)+1 (if all the rest of the string is 
C                    blank).
C--
C  1985 Oct 8 - New routine, based on SKIPBL (T. J. Pearson).
C-----------------------------------------------------------------------
C
   10 IF (I.GT.LEN(S)) RETURN
      IF (S(I:I).NE.' ' .AND. S(I:I).NE.CHAR(9)) RETURN
      I = I+1
      GOTO 10
      END

      SUBROUTINE HPDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C-----------------------------------------------------------------------
C PGPLOT driver for Hewlett Packard HP 7221 pen plotter.
C-----------------------------------------------------------------------
C Version 1.0  - 1987 May 26 - T. J. Pearson.
C Version 1.1  - 1994 Dec 01 - TJP (revised for standard Fortran-77).
C
C-----------------------------------------------------------------------
      CHARACTER*(*) DEVICE, DEFNAM
      PARAMETER (DEVICE='HP7221 (Hewlett-Packard HP7221 pen plotter')
      PARAMETER (DEFNAM='pgplot.hpplot')
      CHARACTER*10 MSG
      CHARACTER*11 GRHPLI
      CHARACTER*5  GRHPCP
      CHARACTER*1  HPCOL(7)
      INTEGER      IER, I0, J0, I1, J1, LASTI, LASTJ, UNIT, N1, N2, IC
      INTEGER      GRHPNC
      INTEGER      GROPTX
      DATA  HPCOL /'A', 'B', 'C', 'D', 'D', 'B', 'C'/
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
      GOTO 900
C
C--- IFUNC = 1, Return device name.-------------------------------------
C
   10 CHR = DEVICE
      LCHR = LEN(DEVICE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices.---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = 16000
      RBUF(3) = 0
      RBUF(4) = 11400
      RBUF(5) = 1
      RBUF(6) = 7
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution. ------------------------------
C
   30 RBUF(1) = 1016.0
      RBUF(2) = 1016.0
      RBUF(3) = 2
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info. -------------------------------
C    (This device is Hardcopy, No cursor, No dashed lines, No area fill,
C    No thick lines)
C
   40 CHR = 'HNNNNNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name. ------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot. ------------------
C
   60 RBUF(1) = 0
      RBUF(2) = 13208
      RBUF(3) = 0
      RBUF(4) = 10160
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults. ----------------------------------
C
   70 RBUF(1) = 10
      NBUF = 1
      RETURN
C
C--- IFUNC = 8, Select plot. -------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation. --------------------------------------
C
   90 CONTINUE
      CALL GRGLUN(UNIT)
      IER = GROPTX(UNIT, CHR(1:LCHR), DEFNAM, 1)
      RBUF(1) = UNIT
      NBUF = 2
      IF (IER.NE.0) THEN
          CALL GRWARN('Cannot open file for HP7221 plot')
          RBUF(2) = 0
          RETURN
      END IF
      RBUF(2) = 1
      LASTI = -1
      LASTJ = -1
      WRITE (UNIT, '(A)') CHAR(27)//'.(~W`o(B2H}vA}~So(B2H}p`}'
      WRITE (UNIT, '(A)') CHAR(27)//'.N0;19:'
      WRITE (UNIT, '(A)') CHAR(27)//'.I128;5;17:'
      RETURN
C
C--- IFUNC=10, Close workstation. --------------------------------------
C
  100 CONTINUE
      WRITE (UNIT, '(A)') 'po(B2H}v@'//CHAR(27)//'.)}'
      CLOSE (UNIT)
      CALL GRFLUN(UNIT)
      RETURN
C
C--- IFUNC=11, Begin picture. ------------------------------------------
C
  110 CONTINUE
      WRITE (UNIT,'(A)') 'po(B2H}v@'//CHAR(27)//'.)}'
      WRITE (UNIT,'(A)') CHAR(12)
      WRITE (UNIT,'(A)') CHAR(27)//'.(~W`o(B2H}~So(B2H}p`}'
      WRITE (UNIT,'(A)') CHAR(27)//'.N0;19:'
      WRITE (UNIT,'(A)') CHAR(27)//'.I128;5;17:'
      RETURN
C
C--- IFUNC=12, Draw line. ----------------------------------------------
C
  120 CONTINUE
      I0 = NINT(RBUF(1))
      J0 = NINT(RBUF(2))
      I1 = NINT(RBUF(3))
      J1 = NINT(RBUF(4))
  121 CONTINUE
      IF ( (I0.EQ.LASTI) .AND. (J0.EQ.LASTJ) ) THEN
C         -- pen down
          GRHPLI(1:1) = 'q'
      ELSE
C         -- pen up
          GRHPLI(1:1) = 'p'
      END IF
C     -- Encode the coordinate into the command string
      CALL GRHP02(I0,J0,GRHPCP,GRHPNC)
      N1 = GRHPNC + 1
      IF  (GRHPNC .GT. 0) GRHPLI(2:N1) = GRHPCP(1:GRHPNC)
      CALL GRHP02(I1,J1,GRHPCP,GRHPNC)
      N2 = GRHPNC + N1
      IF  (GRHPNC .GT. 0) GRHPLI(N1+1:N2) = GRHPCP(1:GRHPNC)
C     -- Write the command string to the plot file
      WRITE (UNIT,'(A)') CHAR(5)//GRHPLI(1:N2)//'}'
      LASTI = I1
      LASTJ = J1
      RETURN
C
C--- IFUNC=13, Draw dot. -----------------------------------------------
C
  130 CONTINUE
      I1 = NINT(RBUF(1))
      J1 = NINT(RBUF(2))
      I0 = I1
      J0 = J1
      GOTO 121
C
C--- IFUNC=14, End picture. --------------------------------------------
C
  140 CONTINUE
      RETURN
C
C--- IFUNC=15, Select color index. -------------------------------------
C
  150 CONTINUE
      IC = NINT(RBUF(1))
      IF (IC.LT.1) IC = 1
      IF (IC.GT.7) IC = 1
      WRITE (UNIT,'(A)') 'v'//HPCOL(IC)//'}'
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C    (Null operation: buffering is not implemented.)
C
  160 CONTINUE
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C    (Not implemented: should not be called.)
C
  170 GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Null operation: there is no alpha screen.)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called.)
C
  190 GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C    (Not implemented: should not be called.)
C
  200 GOTO 900
C
C--- IFUNC=21, Set color representation. -------------------------------
C    (Not implemented)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called.)
C
  220 GOTO 900
C
C--- IFUNC=23, Escape. -------------------------------------------------
C
  230 CONTINUE
      WRITE (UNIT, '(A)') CHR(:LCHR)
      LASTI = -1
      RETURN
C-----------------------------------------------------------------------
C Error: unimplemented function.
C
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in HP device driver: '//MSG)
      NBUF = -1
      RETURN
C-----------------------------------------------------------------------
      END

      SUBROUTINE GRHP02(GRHPNX,GRHPNY,GRHPCP,GRHPNC)
C-----------------------------------------------------------------------
C GRPCKG (internal routine, HP7221):
C       This subroutine translates the INTEGER coordinates into the
C       appropriate HP MBP format, and returns them as a single
C       character*5 string.
C       Reference: HP 7221B Graphics Plotter Operating and
C                  Programming Manual, HP Part # 07221-90014
C
C Arguments:    GRHPNX : X coord of point in plotter units (<= 16383)
C               GRHPNY : ditto Y
C               GRHPCP : output character string with coded position
C               GRHPNC : number of bytes used in GRHPNC
C
C (18-July-1983, R. S. Simon)
C-----------------------------------------------------------------------
      INTEGER GRHPNX, GRHPNY, GRHPNC, N, NX1, NX2, NX3, NXR
      INTEGER NY2, NY3, NY4, NY5, NYR, NP1, NP2, NP3, NP4, NP5
      CHARACTER*5 GRHPCP
C
      GRHPNC = 0
      NP1 = 0
      NP2 = 0
      NP3 = 0
      NP4 = 0
      NP5 = 0
C
      IF (GRHPNX.LT.0.OR.GRHPNY.LT.0) THEN
          CALL GRWARN('GRHPNX and/or GRHPNY is <0.  Point not coded.')
          RETURN
      END IF
C
      N = MAX(GRHPNX,GRHPNY)
C
      IF (N.GT.16383) THEN
          CALL GRWARN('GRHPNX and/or GRHPNY too big.  Point not coded.')
          RETURN
      ELSE IF (N .GT. 2047) THEN
          GRHPNC = 5
          NX1 = GRHPNX/1024
          NXR = GRHPNX - 1024 * NX1
          NX2 = NXR/16
          NX3 = NXR - 16 * NX2
          NY3 = GRHPNY/4096
          NYR = GRHPNY - 4096 * NY3
          NY4 = NYR/64
          NY5 = NYR - 64 * NY4
          NP1 = NX1 + 96
          NP2 = NX2
          IF (NP2.LE.31) NP2 = NP2 + 64
          NP3 = NY3 + 4 * NX3
          IF (NP3.LE.31) NP3 = NP3 + 64
          NP4 = NY4
          IF (NP4.LE.31) NP4 = NP4 + 64
          NP5 = NY5
          IF (NP5.LE.31) NP5 = NP5 + 64
      ELSE IF (N .GT. 255) THEN
          GRHPNC = 4
          NX1 = GRHPNX/128
          NXR = GRHPNX - 128 * NX1
          NX2 = NXR/2
          NX3 = NXR - 2 * NX2
          NY3 = GRHPNY/64
          NY4 = GRHPNY - 64 * NY3
          NP1 = NX1 + 96
          NP2 = NX2
          IF (NP2.LE.31) NP2 = NP2 + 64
          NP3 = NY3 + 32 * NX3
          IF (NP3.LE.31) NP3 = NP3 + 64
          NP4 = NY4
          IF (NP4.LE.31) NP4 = NP4 + 64
      ELSE IF (N .GT. 31) THEN
         GRHPNC = 3
          NX1 = GRHPNX/16
          NX2 = GRHPNX - 16 * NX1
          NY2 = GRHPNY/64
          NY3 = GRHPNY - 64 * NY2
          NP1 = NX1 + 96
          NP2 = NY2 + 4 * NX2
          IF (NP2.LE.31) NP2 = NP2 + 64
          NP3 = NY3
          IF (NP3.LE.31) NP3 = NP3 + 64
      ELSE IF (N .GT. 3) THEN
          GRHPNC = 2
          NX1 = GRHPNX/2
          NX2 = GRHPNX - 2 *NX1
          NP1 = NX1 + 96
          NP2 = GRHPNY + 32 * NX2
          IF (NP2.LE.31) NP2 = NP2 + 64
      ELSE IF (N .GE. 0) THEN
          GRHPNC = 1
          NP1 = GRHPNY + 96 + 4 * GRHPNX
      END IF
C
      GRHPCP = CHAR(NP1)//CHAR(NP2)//CHAR(NP3)//CHAR(NP4)//CHAR(NP5)
      RETURN
      END

C*PGAXIS -- draw an axis
C%void cpgaxis(const char *opt, float x1, float y1, float x2, float y2, \
C%             float v1, float v2, float step, int nsub, float dmajl, \
C%             float dmajr, float fmin, float disp, float orient);
C+
      SUBROUTINE PGAXIS (OPT, X1, Y1, X2, Y2, V1, V2, STEP, NSUB,
     :                   DMAJL, DMAJR, FMIN, DISP, ORIENT)
      CHARACTER*(*) OPT
      REAL X1, Y1, X2, Y2, V1, V2, STEP, DMAJL, DMAJR, FMIN, DISP
      REAL ORIENT
      INTEGER NSUB
C
C Draw a labelled graph axis from world-coordinate position (X1,Y1) to
C (X2,Y2).
C
C Normally, this routine draws a standard LINEAR axis with equal
C subdivisions.   The quantity described by the axis runs from V1 to V2;
C this may be, but need not be, the same as X or Y. 
C
C If the 'L' option is specified, the routine draws a LOGARITHMIC axis.
C In this case, the quantity described by the axis runs from 10**V1 to
C 10**V2. A logarithmic axis always has major, labeled, tick marks 
C spaced by one or more decades. If the major tick marks are spaced
C by one decade (as specified by the STEP argument), then minor
C tick marks are placed at 2, 3, .., 9 times each power of 10;
C otherwise minor tick marks are spaced by one decade. If the axis
C spans less than two decades, numeric labels are placed at 1, 2, and
C 5 times each power of ten.
C
C If the axis spans less than one decade, or if it spans many decades,
C it is preferable to use a linear axis labeled with the logarithm of
C the quantity of interest.
C
C Arguments:
C  OPT    (input)  : a string containing single-letter codes for
C                    various options. The options currently
C                    recognized are:
C                    L : draw a logarithmic axis
C                    N : write numeric labels
C                    1 : force decimal labelling, instead of automatic
C                        choice (see PGNUMB).
C                    2 : force exponential labelling, instead of
C                        automatic.
C  X1, Y1 (input)  : world coordinates of one endpoint of the axis.
C  X2, Y2 (input)  : world coordinates of the other endpoint of the axis.
C  V1     (input)  : axis value at first endpoint.
C  V2     (input)  : axis value at second endpoint.
C  STEP   (input)  : major tick marks are drawn at axis value 0.0 plus
C                    or minus integer multiples of STEP. If STEP=0.0,
C                    a value is chosen automatically.
C  NSUB   (input)  : minor tick marks are drawn to divide the major
C                    divisions into NSUB equal subdivisions (ignored if
C                    STEP=0.0). If NSUB <= 1, no minor tick marks are
C                    drawn. NSUB is ignored for a logarithmic axis.
C  DMAJL  (input)  : length of major tick marks drawn to left of axis
C                    (as seen looking from first endpoint to second), in
C                    units of the character height.
C  DMAJR  (input)  : length of major tick marks drawn to right of axis,
C                    in units of the character height.
C  FMIN   (input)  : length of minor tick marks, as fraction of major.
C  DISP   (input)  : displacement of baseline of tick labels to
C                    right of axis, in units of the character height.
C  ORIENT (input)  : orientation of label text, in degrees; angle between
C                    baseline of text and direction of axis (0-360°).
C--
C 25-Mar-1997 - new routine [TJP].
C-----------------------------------------------------------------------
      REAL V, VMIN, VMAX, DVMAJ, DVMIN
      REAL PGRND
      INTEGER I, K, K1, K2, NSUBT, NV, NP, LLAB, CLIP, FORM
      LOGICAL OPTN, PGNOTO
      CHARACTER CH, LABEL*32
C
C Check arguments.
C
      IF (PGNOTO('PGAXIS')) RETURN
      IF (X1.EQ.X2 .AND. Y1.EQ.Y2) RETURN
      IF (V1.EQ.V2) RETURN
C
C Decode options.
C
      FORM = 0
      OPTN = .FALSE.
      DO 10 I=1,LEN(OPT)
         CH = OPT(I:I)
         CALL GRTOUP(CH, CH)
         IF (CH.EQ.'N') THEN
C           -- numeric labels requested
            OPTN = .TRUE.
         ELSE IF (CH.EQ.'L') THEN
C           -- logarithmic axis requested
            CALL PGAXLG(OPT, X1, Y1, X2, Y2, V1, V2, STEP,
     :                  DMAJL, DMAJR, FMIN, DISP, ORIENT)
            RETURN
         ELSE IF (CH.EQ.'1') THEN
C           -- decimal labels requested
            FORM = 1
         ELSE IF (CH.EQ.'2') THEN
C           -- exponential labels requested
            FORM = 2
         END IF
 10   CONTINUE
C
C Choose major interval if defaulted. Requested interval = STEP,
C with NSUB subdivisions. We will use interval = DVMAJ with NSUBT
C subdivisions of size DVMIN. Note that DVMAJ is always positive.
C
      IF (STEP.EQ.0.0) THEN
          DVMAJ = PGRND(0.20*ABS(V1-V2),NSUBT)
      ELSE
          DVMAJ = ABS(STEP)
          NSUBT = MAX(NSUB,1)
      END IF
      DVMIN = DVMAJ/NSUBT
C
C For labelling, we need to express DVMIN as an integer times a
C power of 10, NV*(10**NP).
C
      NP = INT(LOG10(ABS(DVMIN)))-4
      NV = NINT(DVMIN/10.0**NP)
      DVMIN = REAL(NV)*(10.0**NP)
C
      CALL PGBBUF
      CALL PGQCLP(CLIP)
      CALL PGSCLP(0)
C
C Draw the axis.
C
      CALL PGMOVE(X1, Y1)
      CALL PGDRAW(X2, Y2)
C
C Draw the tick marks. Minor ticks are drawn at V = K*DVMIN, 
C major (labelled) ticks where K is a multiple of NSUBT.
C
      VMIN = MIN(V1, V2)
      VMAX = MAX(V1, V2)
      K1 = INT(VMIN/DVMIN)
      IF (DVMIN*K1.LT.VMIN) K1 = K1+1
      K2 = INT(VMAX/DVMIN)
      IF (DVMIN*K2.GT.VMAX) K2 = K2-1
      DO 20 K=K1,K2
         V = (K*DVMIN-V1)/(V2-V1)
         IF (MOD(K,NSUBT).EQ.0) THEN
C             -- major tick mark
            IF (OPTN) THEN
               CALL PGNUMB(K*NV, NP, FORM, LABEL, LLAB)
            ELSE
               LABEL = ' '
               LLAB = 1
            END IF
            CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL, DMAJR,
     :                  DISP, ORIENT, LABEL(:LLAB))
         ELSE
C             -- minor tick mark
            CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL*FMIN, DMAJR*FMIN,
     :                  0.0, ORIENT, ' ')
         END IF
 20   CONTINUE
C
      CALL PGSCLP(CLIP)
      CALL PGEBUF
      END

C*PGSUBP -- subdivide view surface into panels
C%void cpgsubp(int nxsub, int nysub);
C+
      SUBROUTINE PGSUBP (NXSUB, NYSUB)
      INTEGER NXSUB, NYSUB
C
C PGPLOT divides the physical surface of the plotting device (screen,
C window, or sheet of paper) into NXSUB x NYSUB `panels'. When the 
C view surface is sub-divided in this way, PGPAGE moves to the next
C panel, not the next physical page. The initial subdivision of the
C view surface is set in the call to PGBEG. When PGSUBP is called,
C it forces the next call to PGPAGE to start a new physical page,
C subdivided in the manner indicated. No plotting should be done
C between a call of PGSUBP and a call of PGPAGE (or PGENV, which calls
C PGPAGE).
C
C If NXSUB > 0, PGPLOT uses the panels in row order; if <0, 
C PGPLOT uses them in column order, e.g.,
C      
C  NXSUB=3, NYSUB=2            NXSUB=-3, NYSUB=2   
C                                                
C +-----+-----+-----+         +-----+-----+-----+
C |  1  |  2  |  3  |         |  1  |  3  |  5  |
C +-----+-----+-----+         +-----+-----+-----+
C |  4  |  5  |  6  |         |  2  |  4  |  6  |
C +-----+-----+-----+         +-----+-----+-----+
C
C PGPLOT advances from one panels to the next when PGPAGE is called,
C clearing the screen or starting a new page when the last panel has
C been used. It is also possible to jump from one panel to another
C in random order by calling PGPANL.
C 
C Arguments:
C  NXSUB  (input)  : the number of subdivisions of the view surface in
C                    X (>0 or <0).
C  NYSUB  (input)  : the number of subdivisions of the view surface in
C                    Y (>0).
C--
C 15-Nov-1993 [TJP] - new routine.
C 19-Feb-1994 [TJP] - rescale viewport when panel size changes.
C 23-Sep-1996 [TJP] - correct bug in assignment of PGROWS.
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      REAL     CH, XFSZ, YFSZ
      LOGICAL  PGNOTO
      REAL     XVP1, XVP2, YVP1, YVP2

C
      IF (PGNOTO('PGSUBP')) RETURN
C
C Find current character size and viewport (NDC).
C
      CALL PGQCH(CH)
      CALL PGQVP(0, XVP1, XVP2, YVP1, YVP2)
C
C Set the subdivisions.
C
      XFSZ = PGNX(PGID)*PGXSZ(PGID)
      YFSZ = PGNY(PGID)*PGYSZ(PGID)
      PGROWS(PGID) = (NXSUB.GE.0)
      PGNX(PGID) = MAX(ABS(NXSUB),1)
      PGNY(PGID) = MAX(ABS(NYSUB),1)
      PGXSZ(PGID) = XFSZ/PGNX(PGID)
      PGYSZ(PGID) = YFSZ/PGNY(PGID)
C
C The current panel is the last on the physical page, to force
C a new physical page at next PGPAGE.
C
      PGNXC(PGID) = PGNX(PGID)
      PGNYC(PGID) = PGNY(PGID)
C
C Rescale the character size and viewport to the new panel size.
C
      CALL PGSCH(CH)
      CALL PGSVP(XVP1, XVP2, YVP1, YVP2)
C
      END

C*GRGETC -- read a single character from keyboard (VMS)
C+
      INTEGER FUNCTION GRGETC (CHAN)
C
C Read a single character from the controlling keyboard, no echo.
C Normal ASCII characters are returned as the corresponding integer
C codes. Escape sequences generated by the VT100 are recognised and
C returned as negative integer codes.  Some characters (eg control-U,
C control-R, delete, control-C, control-Y) are normally intercepted
C by the operating system and cannot be read with GRGETC.
C
C Argument:
C
C CHAN (input, integer): the channel number assigned to the terminal;
C      this must have been previously assigned by SYS$ASSIGN.
C
C Returns:
C
C GRGETC (integer): either a positive number (0-127) equal to
C      the ASCII code of the character read, or a negative number, as
C      follows, if one of the VT100 escape sequences has been read:
C       UP ARROW, DOWN ARROW, RIGHT ARROW, LEFT ARROW: -1,-2,-3,-4;
C       PF1, PF2, PF3, PF4: -11,-12,-13,-14.
C      If the terminal is in "alternate keypad mode", the following
C      codes are generated by typing the keypad keys:
C       Keypad digits 0 through 9: -20 through -29;
C       Keypad ENTER: -8;
C       Keypad comma, minus, period: -16,-17,-18.
C      If an unrecognized escape sequence is received, GRGETC is set
C       to zero.
C--
C (7-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE '($IODEF)'
      INCLUDE '($SSDEF)'
      INTEGER   IOFUNC
      PARAMETER (IOFUNC=IO$_READVBLK.OR.IO$M_NOECHO.OR.IO$M_ESCAPE)
      INTEGER   CHAN, IER, SYS$QIOW, TERMSK(2), J
      INTEGER*2 IOSB(4), CODE_TABLE(22)
      BYTE      TERMCH(32),BUFFER(20), VALID_TABLE(22)
      DATA      TERMCH/32*'FF'X/
      DATA      TERMSK(1) / 32 /
C
C               Valid escape sequences are <esc> O or <esc> [
C               followed by one of the characters in VALID_TABLE;
C               CODE_TABLE contains the corresponding integer codes
C               returned by GRGETC.
C
      DATA VALID_TABLE/ 'A','B','C','D',  'P','Q','R','S',
     1          'p','q','r','s','t','u','v','w','x','y',
     2          'm','l','n', 'M'/
      DATA CODE_TABLE/ -1,-2,-3,-4, -11,-12,-13,-14,
     1          -20,-21,-22,-23,-24,-25,-26,-27,-28,-29,
     2          -17,-16,-18, -8/
C
C               Read a single character; all characters are
C               terminators, and escape sequences are recognised.
C
      TERMSK(2) = %LOC(TERMCH)
      IER = SYS$QIOW(, %VAL(CHAN), %VAL(IOFUNC), IOSB, , ,
     1                BUFFER,   ! P1 (buffer address)
     2                %VAL(20), ! P2 (buffer size)
     3                ,         ! P3 (timeout count)
     4                TERMSK,   ! P4 (read terminator descr.block)
     5                ,         ! P5 (prompt buffer address)
     6                )         ! P6 (prompt buffer size)
      IF (IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRQUIT('Fatal error in PGPLOT routine GRGETC')
      END IF
C
C               If terminator is a single character, return it.
C
      IF (IOSB(4).EQ.1) THEN
          GRGETC = BUFFER(1)
          RETURN
C
C               If terminator is an escape sequence, interpret it.
C
      ELSE IF ((BUFFER(1).EQ.27) .AND.
     1         (BUFFER(2).EQ.79 .OR. BUFFER(2).EQ.91)) THEN
          DO J=1,22
              IF (BUFFER(3).EQ.VALID_TABLE(J)) THEN
                  GRGETC = CODE_TABLE(J)
                  RETURN
              END IF
          END DO
      END IF
C
C               Otherwise, return zero.
C
      GRGETC = 0
      RETURN
      END

C*PGBEG -- open a graphics device
C%int cpgbeg(int unit, const char *file, int nxsub, int nysub);
C+
      INTEGER FUNCTION PGBEG (UNIT, FILE, NXSUB, NYSUB)
      INTEGER       UNIT
      CHARACTER*(*) FILE
      INTEGER       NXSUB, NYSUB
C
C Note: new programs should use PGOPEN rather than PGBEG. PGOPEN
C is retained for compatibility with existing programs. Unlike PGOPEN,
C PGBEG closes any graphics devices that are already open, so it 
C cannot be used to open devices to be used in parallel.
C
C PGBEG opens a graphical device or file and prepares it for
C subsequent plotting. A device must be opened with PGBEG or PGOPEN
C before any other calls to PGPLOT subroutines for the device.
C
C If any device  is already open for PGPLOT output, it is closed before
C the new device is opened.
C
C Returns:
C  PGBEG         : a status return value. A value of 1 indicates
C                    successful completion, any other value indicates
C                    an error. In the event of error a message is
C                    written on the standard error unit.  
C                    To test the return value, call
C                    PGBEG as a function, eg IER=PGBEG(...); note
C                    that PGBEG must be declared INTEGER in the
C                    calling program. Some Fortran compilers allow
C                    you to use CALL PGBEG(...) and discard the
C                    return value, but this is not standard Fortran.
C Arguments:
C  UNIT  (input)   : this argument is ignored by PGBEG (use zero).
C  FILE  (input)   : the "device specification" for the plot device.
C                    (For explanation, see description of PGOPEN.)
C  NXSUB  (input)  : the number of subdivisions of the view surface in
C                    X (>0 or <0).
C  NYSUB  (input)  : the number of subdivisions of the view surface in
C                    Y (>0).
C                    PGPLOT puts NXSUB x NYSUB graphs on each plot
C                    page or screen; when the view surface is sub-
C                    divided in this way, PGPAGE moves to the next
C                    panel, not the  next physical page. If
C                    NXSUB > 0, PGPLOT uses the panels in row
C                    order; if <0, PGPLOT uses them in column order.
C--
C 21-Dec-1995 [TJP] - changed for multiple devices; call PGOPEN.
C 27-Feb-1997 [TJP] - updated description.
C-----------------------------------------------------------------------
      INTEGER       IER
      INTEGER       PGOPEN
C
C Initialize PGPLOT if necessary.
C
      CALL PGINIT
C
C Close the plot-file if it is already open.
C
      CALL PGEND
C
C Call PGOPEN to open the device.
C
      IER = PGOPEN(FILE)
      IF (IER.GT.0) THEN
         CALL PGSUBP(NXSUB, NYSUB)
         PGBEG = 1
      ELSE
         PGBEG = IER
      END IF
C
      RETURN
      END

      PROGRAM PGDEM5
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT. This programs shows the use of
C routine PGOLIN to allow the user to draw polygons on the screen.
C As each polygon is completed, it is filled in using routine PGPOLY.
C The user positions the cursor to define the vertices of the polygon.
C He types 'A' to add a vertex at the current cursor position, 'D' to
C delete the nearest vertex, or 'X' to signal that the polygon is 
C complete. Two 'X's in succession terminates the program.
C-----------------------------------------------------------------------
      INTEGER PGBEG
      INTEGER MAXPT, NPT, COL
      PARAMETER (MAXPT=50)
      REAL X(MAXPT),Y(MAXPT)
      INTEGER WHICH
C
  100 FORMAT(' Demonstration of PGPLOT cursor routines',
     1       ' PGLCUR and PGOLIN.'/
     2       ' These routines allow you to draw polygons on the',
     3       ' screen, using the'/
     4       ' cursor to mark the vertices.'/)
  110 FORMAT(/' PGLCUR outlines the polygon as you draw it, PGOLIN',
     1       ' just marks the'/
     2       ' vertices. Which routine do you want to use? Type 1',
     3       ' for PGLCUR, 2 for'/
     4       ' PGOLIN:')
  120 FORMAT(' Use the cursor to choose the vertices of the polygon'/
     1       '   Type A to add a vertex at the cursor position'/
     2       '   Type D to delete the last vertex'/
     3       '   Type X to close the polygon and shade it'/
     4       '   (Type X again to exit from the program)')
C
      WRITE (6, 100)
      WRITE (6, 110)
      READ (5, *, ERR=10, END=10) WHICH
 10   IF (WHICH.LT.1 .OR. WHICH.GT.2) WHICH = 1
      WRITE (6, 120)
C
C Open device for graphics.
C
      IF (PGBEG(0,'?',1,1) .NE. 1) STOP
C
C Clear the screen. Draw a frame at the physical extremities of the
C view surface using full-screen viewport and standard window.
C
      CALL PGPAGE
      CALL PGSVP(0.0,1.0,0.0,1.0)
      CALL PGSWIN(0.0,1.0,0.0,1.0)
      CALL PGBOX('BC',0.1,5,'BC',0.1,5)
      COL = 0
C
C Increment the color index and then call PGOLIN to allow the user
C to draw a polygon.
C
   20 COL = COL+1
      CALL PGSCI(COL)
      NPT = 0
      IF (WHICH.EQ.1) CALL PGLCUR(MAXPT,NPT,X,Y)
      IF (WHICH.EQ.2) CALL PGOLIN(MAXPT,NPT,X,Y,-1)
C
C Fill the interior of the polygon in the current color. If less
C than three vertices were supplied, that is a signal to terminate
C the program.  Otherwise, go back and draw another polygon.
C
      IF (NPT.GE.3) THEN
           CALL PGPOLY(NPT,X,Y)
           GOTO 20
       END IF 
C
C Close the device and exit.
C
      CALL PGEND
      END

!!G Toolbox.finc
C  If you have a power mac version of LS fortran uncomment the
C next 5 lines and comment out "!!MP InLines.f"
C!!IFC NOT LSPOWERF
C!!MP 68KInlines
C!!ELSEC
C!!MP PPCInlines
C!!ENDC
C  If you have a 68K mac version of LS fortran comment out the 
C 5 lines above and uncomment the next line.
!!MP InLines.f
C  Fortran callable memory allocator

C  Called as :
C	ier = grgmem (size,pointer)

C  where : size is an integer size of memory to allocate
C	  pointer is an integer to return the pointer into

      Integer Function GRGMEM(size, pointer)
      Integer*4 size, pointer
      
      pointer = NewPtr(Size)
	  If (pointer .eq. 0) Then
	     grgmem = 0
	  Else
	     grgmem = 1
	  End if
      Return
	  End
	  
C  Fortran callable memory deallocator

C  Called as :
C	ier = grfmem (size,pointer)

C  where : size is an integer size of memory to deallocate (not used)
C	  pointer is an integer that contains the pointer


      Integer Function GRFMEM(size, pointer)
      Integer*4 size, pointer

      Call DisposPtr(Pointer)
	  grfmem = 1
	  Return
      End

C*GRQDT -- inquire current device and type
C+
      SUBROUTINE GRQDT (DEVICE)
C
C GRPCKG: obtain the name and type of the current graphics device.
C
C Argument:
C
C DEVICE (output, character): receives the device name and type of the
C       currently active device in the form 'device/type'; this is a
C       valid string for input to GROPEN.
C--
C  1-Feb-1983
C 19-Feb-1988 - add quotes if necessary.
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      CHARACTER*(*) DEVICE
      CHARACTER*14 TYPE
      LOGICAL   JUNK
      INTEGER   L
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRQDT - no graphics device is active.')
          DEVICE = '/NULL'
      ELSE
          CALL GRQTYP(TYPE,JUNK)
          L = GRFNLN(GRCIDE)
          IF (L.LE.0) THEN
              DEVICE = '/'//TYPE
          ELSE IF (INDEX(GRFILE(GRCIDE)(1:L), '/').EQ.0) THEN
              DEVICE = GRFILE(GRCIDE)(1:L)//'/'//TYPE
          ELSE
              DEVICE = '"'//GRFILE(GRCIDE)(1:L)//'"/'//TYPE
          END IF
      END IF
      END

C*GRINQPEN -- *obsolete routine*
C+
      SUBROUTINE GRINQPEN (IP)
C
C GRPCKG: obtain the pen number of the current graphics device.
C Obsolete routine.
C Argument:
C
C IP (integer, output): always receives 1.
C--
C 16-Aug-1987 - [TJP].
C-----------------------------------------------------------------------
      INTEGER  IP
C
      IP = 1
      END

      SUBROUTINE IMDRIV (IFUNC, RBUF, NBUF, CHR, LCHR)
      INTEGER IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
C-----------------------------------------------------------------------
C PGPLOT driver for Impress (Imagen) device. 
C-----------------------------------------------------------------------
C Version 0.9  - 1987 Aug 19 - T. J. Pearson.
C Modifications:
C REW -- 23 MAY 1988 -- Orientation from x axis, not h axis
C REW -- 25 MAY 1988 -- Change physical min/max
C			 from 3074/2324 to 3150/2400  10.5 x 8)
C REW -- 31 MAY 1988 -- Include x and y offsets to improve centering
C
C Note: this is a preliminary release. The driver has the following
C problems: (a) does not use hardware thick lines; (b) white lines do
C not to erase background as they should; (c) lines are handled as
C separate segments, instead of combining connected segments into paths,
C which should be more efficient.
C-----------------------------------------------------------------------
C
C Supported device: any Imagen printer that accepts the Impress page 
C description language.
C
C Device type code: /IMPRESS (landscape mode).
C
C Default file name: PGPLOT.IMPLOT.
C
C Default view surface dimensions:
C 10.5 inches horizontal x  8 inches vertical (landscape mode).
C Note that the Imagen laser printer prints from the bottom edge
C  of the sheet and cannot print on the top half inch of the sheet.
C
C Resolution: the driver uses coordinate increments of 1/300 inch.
C The true resolution is device-dependent.
C
C Color capability: color indices 0 (erase), and 1 (black)
C are supported. Requests for other color indices are
C converted to 1. It is not possible to change color representation. 
C
C Input capability: none.
C
C File format: binary, variable length records (max 1024 bytes); no
C carriage control.
C
C Obtaining hardcopy:  $ IMPRINT/IMPRESS file.type
C-----------------------------------------------------------------------
      CHARACTER*(*) TYPE, DEFNAM
      PARAMETER (DEFNAM='PGPLOT.IMPLOT')
      PARAMETER (TYPE='IMPRESS')
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=1024)
      INTEGER BUFFER
      INTEGER BUFLEV
      INTEGER UNIT, IER
      INTEGER*2 I0, I1, J0, J1, NPTS
      INTEGER GRGMEM, GRFMEM
      CHARACTER*10 MSG
      INTEGER IC
      BYTE    BUF(100), COLOR
      INTEGER NW
	INTEGER SIZEX, SIZEY			! REW -- 26MAY88
	PARAMETER (SIZEX=3150 ,SIZEY=2400)	! REW -- 26MAY88
	INTEGER OFFSETX, OFFSETY		! REW -- 31MAY88
	PARAMETER (OFFSETX=75, OFFSETY=15)      ! REW -- 31MAY88
C-----------------------------------------------------------------------
C
      GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1     110,120,130,140,150,160,170,180,190,200,
     2     210,220,230), IFUNC
  900 WRITE (MSG,'(I10)') IFUNC
      CALL GRWARN('Unimplemented function in IMPRESS device driver:'
     1    //MSG)
      NBUF = -1
      RETURN
C
C--- IFUNC = 1, Return device name -------------------------------------
C
   10 CHR = TYPE
      LCHR = LEN(TYPE)
      RETURN
C
C--- IFUNC = 2, Return physical min and max for plot device, and range
C               of color indices ---------------------------------------
C
   20 RBUF(1) = 0
      RBUF(2) = SIZEX			! rew -- 25 may 1988
      RBUF(3) = 0
      RBUF(4) = SIZEY			! rew -- 25 may 1988
      RBUF(5) = 0
      RBUF(6) = 1
      NBUF = 6
      RETURN
C
C--- IFUNC = 3, Return device resolution -------------------------------
C    (Nominal values)
C
   30 RBUF(1) = 300.0
      RBUF(2) = 300.0
C      (multiple strokes are spaced by 1 pixels, or 1/300 inch)
      RBUF(3) = 1
      NBUF = 3
      RETURN
C
C--- IFUNC = 4, Return misc device info --------------------------------
C    (Hardcopy, No cursor, No dashed lines, Area fill,
C    no thick lines)
C
   40 CHR = 'HNNANNNNNN'
      LCHR = 10
      RETURN
C
C--- IFUNC = 5, Return default file name -------------------------------
C
   50 CHR = DEFNAM
      LCHR = LEN(DEFNAM)
      RETURN
C
C--- IFUNC = 6, Return default physical size of plot -------------------
C
   60 RBUF(1) = 0
      RBUF(2) = SIZEX				! rew -- 25 May 1988
      RBUF(3) = 0
      RBUF(4) = SIZEY				! rew -- 25 May 1988
      NBUF = 4
      RETURN
C
C--- IFUNC = 7, Return misc defaults -----------------------------------
C
   70 RBUF(1) = 8.0
      NBUF=1
      RETURN
C
C--- IFUNC = 8, Select plot --------------------------------------------
C
   80 CONTINUE
      RETURN
C
C--- IFUNC = 9, Open workstation ---------------------------------------
C
   90 CONTINUE
C     -- allocate buffer
      IER = GRGMEM(BUFSIZ, BUFFER)
      IF (IER.NE.1) THEN
          CALL GRGMSG(IER)
          CALL GRWARN('Failed to allocate plot buffer.')
          RBUF(2) = IER
          RETURN
      END IF
C     -- open device
      CALL GRGLUN(UNIT)
      NBUF = 2
      RBUF(1) = UNIT
      OPEN (UNIT=UNIT, FILE=CHR(:LCHR), CARRIAGECONTROL='NONE',
     1      DEFAULTFILE=DEFNAM, DISPOSE='DELETE', STATUS='NEW',
     2      FORM='UNFORMATTED', RECORDTYPE='VARIABLE', IOSTAT=IER,
     3      RECL=256)
      IF (IER.NE.0) THEN
          CALL GRWARN('Cannot open output file for '//TYPE//' plot: '//
     1                CHR(:LCHR))
          RBUF(2) = 0
          CALL GRFLUN(UNIT)
          IER = GRFMEM(BUFSIZ, BUFFER)
          RETURN
      ELSE
          INQUIRE (UNIT=UNIT, NAME=CHR)
          LCHR = LEN(CHR)
   91     IF (CHR(LCHR:LCHR).EQ.' ') THEN
              LCHR = LCHR-1
              GOTO 91
          END IF
          RBUF(2) = 1
      END IF
      IC = 1
C     -- initialization
      NPTS = 0
      COLOR = 15
      RETURN
C
C--- IFUNC=10, Close workstation ---------------------------------------
C
  100 CONTINUE
      CLOSE (UNIT, DISPOSE='KEEP')
      CALL GRFLUN(UNIT)
      IER = GRFMEM(BUFSIZ, BUFFER)
      IF (IER.NE.1) THEN
          CALL GRWARN('Error deallocating plot buffer.')
          CALL GRGMSG(IER)
      END IF
      RETURN
C
C--- IFUNC=11, Begin picture -------------------------------------------
C
  110 CONTINUE
C     -- set coordinate system
      BUF(1) = 205 ! SET_HV_SYSTEM
      BUF(2) = 29  ! 0 0 3 5			! REW -- 23 MAY 1988
      BUF(3) = 135 ! SET_ABS_H
      BUF(4) = 0
      BUF(5) = 0
      BUF(6) = 137 ! SET_ABS_V
      BUF(7) = 0
      BUF(8) = 0
      NW = 8
      GOTO 1000
C
C--- IFUNC=12, Draw line -----------------------------------------------
C
  120 CONTINUE
      IF (IC.EQ.0) RETURN
      I0 = OFFSETX + NINT(RBUF(1))
      J0 = OFFSETY + NINT(RBUF(2))
      I1 = OFFSETX + NINT(RBUF(3))
      J1 = OFFSETY + NINT(RBUF(4))
  125 CONTINUE
      BUF(1) = 230 ! CREATE_PATH
      CALL GRIM00(BUF(2), 2) ! 2 vertices
      CALL GRIM00(BUF(4), I0) ! coordinates of vertices
      CALL GRIM00(BUF(6), J0)
      CALL GRIM00(BUF(8), I1)
      CALL GRIM00(BUF(10), J1)
      BUF(12) = 234 ! DRAW_PATH
      BUF(13) = COLOR	! black or white
      NW = 13
      GOTO 1000
C
C--- IFUNC=13, Draw dot ------------------------------------------------
C
  130 CONTINUE
      IF (IC.EQ.0) RETURN
      I0 = OFFSETX + NINT(RBUF(1))
      J0 = OFFSETY + NINT(RBUF(2))
      I1 = I0
      J1 = J0
      GOTO 125
C
C--- IFUNC=14, End picture ---------------------------------------------
C
  140 CONTINUE
      BUF(1) = 219 ! ENDPAGE
      NW = 1
      GOTO 1000
C
C--- IFUNC=15, Select color index --------------------------------------
C
  150 CONTINUE
      IC = RBUF(1)
      IF (IC.LT.0 .OR. IC.GT.1) THEN
          IC = 1
          RBUF(1) = IC
      END IF
      COLOR = 15
      IF (IC.EQ.0) COLOR = 0
      RETURN
C
C--- IFUNC=16, Flush buffer. -------------------------------------------
C
  160 CONTINUE
      CALL GRIM03(%val(BUFFER), UNIT, BUFLEV)
      RETURN
C
C--- IFUNC=17, Read cursor. --------------------------------------------
C           Not implemented.
C
  170 CONTINUE
      GOTO 900
C
C--- IFUNC=18, Erase alpha screen. -------------------------------------
C    (Not implemented: no alpha screen)
C
  180 CONTINUE
      RETURN
C
C--- IFUNC=19, Set line style. -----------------------------------------
C    (Not implemented: should not be called)
C
  190 CONTINUE
      GOTO 900
C
C--- IFUNC=20, Polygon fill. -------------------------------------------
C
  200 CONTINUE
      IF (NPTS.EQ.0) THEN
          NPTS = RBUF(1)
          BUF(1) = 230 ! CREATE_PATH
          CALL GRIM00(BUF(2), NPTS) ! # vertices
          NW = 3
      ELSE
          NPTS = NPTS-1
	  I0 = OFFSETX + NINT(RBUF(1))
	  J0 = OFFSETY + NINT(RBUF(2))
          CALL GRIM00(BUF(1), I0) ! coordinates of vertex
          CALL GRIM00(BUF(3), J0)
          NW = 4
	  IF (NPTS.EQ.0) THEN
              BUF(5) = 233 ! FILL_PATH
              BUF(6) = COLOR	! black or white
              NW = 6
	  END IF
      END IF
      GOTO 1000
C
C--- IFUNC=21, Set color representation. -------------------------------
C    (Not implemented: ignored)
C
  210 CONTINUE
      RETURN
C
C--- IFUNC=22, Set line width. -----------------------------------------
C    (Not implemented: should not be called)
C
  220 CONTINUE
      GOTO 900
C
C--- IFUNC=23, Escape --------------------------------------------------
C    (Not implemented: ignored)
C
  230 CONTINUE
      RETURN
C
C--- Send the command. -------------------------------------------------
C
 1000 CALL GRIM02(BUF,NW,%val(BUFFER),BUFLEV,UNIT)
C-----------------------------------------------------------------------
      END

C*GRIM00 -- PGPLOT Impress driver, write word
C+
      SUBROUTINE GRIM00(BUF,WORD)
      BYTE BUF(2), WORD(2)
C--
      BUF(1) = WORD(2)
      BUF(2) = WORD(1)
      END

C*GRIM02 -- PGPLOT Impress driver, transfer data to buffer
C+
      SUBROUTINE GRIM02 (INSTR, N, BUFFER, HWM, UNIT)
      INTEGER   N, HWM, UNIT
      BYTE      INSTR(*), BUFFER(*)
C
C Arguments:
C  INSTR  (input)  : text of instruction (bytes).
C  N      (input)  : number of bytes to transfer.
C  BUFFER (input)  : output buffer.
C  HWM    (in/out) : number of bytes used in BUFFER.
C  UNIT   (input)  : channel number for output (when buffer is full).
C
C Subroutines called:
C   GRIM03
C-----------------------------------------------------------------------
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=1024)
      INTEGER  I
C-----------------------------------------------------------------------
      IF (HWM+N.GE.BUFSIZ) CALL GRIM03(BUFFER, UNIT, HWM)
      DO 10 I=1,N
          HWM = HWM + 1
          BUFFER(HWM) = INSTR(I)
   10 CONTINUE
C-----------------------------------------------------------------------
      END

C*GRIM03 -- PGPLOT Impress driver, copy buffer to file
C+
      SUBROUTINE GRIM03 (BUFFER, UNIT, N)
      BYTE BUFFER(*)
      INTEGER UNIT, N
C
C Arguments:
C   BUFFER (input) address of buffer to be output
C   UNIT   (input) unit number for output
C   N      (input) number of bytes to transfer
C          (output) set to zero
C-----------------------------------------------------------------------
      INTEGER J
C-----------------------------------------------------------------------
      IF (N.GT.0) WRITE (UNIT) (BUFFER(J),J=1,N)
      N = 0
C-----------------------------------------------------------------------
      END

C*GRGLUN -- get a Fortran logical unit number (VMS)
C+
      SUBROUTINE GRGLUN(LUN)
      INTEGER LUN
C
C Return an unused Fortran logical unit number. 
C
C Arguments:
C  LUN    : receives the logical unit number, or -1 on error.
C--
C 25-Nov-1988
C-----------------------------------------------------------------------
      INTEGER IER, LIB$GET_LUN
C
      IER = LIB$GET_LUN(LUN)
      IF (IER.NE.1) LUN = -1
      RETURN
      END

C*GRSETLI -- *obsolete routine*
C+
      SUBROUTINE GRSETLI (IN)
C
C GRPCKG: Set the line intensity for subsequent plotting on the current
C device. *** OBSOLETE ROUTINE *** Intensity is now set with GRSCI
C and GRSCR. For compatibility, GRSETLI now sets color zero if its
C argument is 0, and resets the previous color if its argument is
C non-zero.
C
C Argument:
C
C IN (integer, input): the intensity to be used for subsequent
C       plotting on the current device (in range 0-3).
C--
C 11-Apr-1983 - [TJP].
C 12-Jul-1984 - modify to call GRSCI [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      INTEGER  IN, OLDCOL(GRIMAX)
      DATA     OLDCOL /GRIMAX*1/
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRSETLI - no graphics device is active.')
      ELSE IF (IN.EQ.0) THEN
          OLDCOL(GRCIDE) = GRCCOL(GRCIDE)
          CALL GRSCI(0)
      ELSE
          CALL GRSCI(OLDCOL(GRCIDE))
      END IF
      END

C*PGHI2D -- cross-sections through a 2D data array
C%void cpghi2d(const float *data, int nxv, int nyv, int ix1, \
C% int ix2, int iy1, int iy2, const float *x, int ioff, float bias, \
C% Logical center, float *ylims);
C+
      SUBROUTINE PGHI2D (DATA, NXV, NYV, IX1, IX2, IY1, IY2, X, IOFF,
     1                   BIAS, CENTER, YLIMS)
      INTEGER NXV, NYV, IX1, IX2, IY1, IY2
      REAL    DATA(NXV,NYV)
      REAL    X(IX2-IX1+1), YLIMS(IX2-IX1+1)
      INTEGER IOFF
      REAL    BIAS
      LOGICAL CENTER
C
C Plot a series of cross-sections through a 2D data array.
C Each cross-section is plotted as a hidden line histogram.  The plot
C can be slanted to give a pseudo-3D effect - if this is done, the
C call to PGENV may have to be changed to allow for the increased X
C range that will be needed.
C
C Arguments:
C  DATA   (input)  : the data array to be plotted.
C  NXV    (input)  : the first dimension of DATA.
C  NYV    (input)  : the second dimension of DATA.
C  IX1    (input)
C  IX2    (input)
C  IY1    (input)
C  IY2    (input)  : PGHI2D plots a subset of the input array DATA.
C                    This subset is delimited in the first (x)
C                    dimension by IX1 and IX2 and the 2nd (y) by IY1
C                    and IY2, inclusively. Note: IY2 < IY1 is
C                    permitted, resulting in a plot with the
C                    cross-sections plotted in reverse Y order.
C                    However, IX2 must be => IX1.
C  X      (input)  : the abscissae of the bins to be plotted. That is,
C                    X(1) should be the X value for DATA(IX1,IY1), and
C                    X should have (IX2-IX1+1) elements.  The program
C                    has to assume that the X value for DATA(x,y) is
C                    the same for all y.
C  IOFF   (input)  : an offset in array elements applied to successive
C                    cross-sections to produce a slanted effect.  A
C                    plot with IOFF > 0 slants to the right, one with
C                    IOFF < 0 slants left.
C  BIAS   (input)  : a bias value applied to each successive cross-
C                    section in order to raise it above the previous
C                    cross-section.  This is in the same units as the
C                    data.
C  CENTER (input)  : if .true., the X values denote the center of the
C                    bins; if .false. the X values denote the lower
C                    edges (in X) of the bins.
C  YLIMS  (input)  : workspace.  Should be an array of at least
C                    (IX2-IX1+1) elements.
C--
C 21-Feb-1984 - Keith Shortridge.
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL FIRST,PENDOW,HPLOT,VPLOT
      INTEGER IY,INC,IX,NELMX,IXPT,NOFF
      REAL CBIAS,YNWAS,XNWAS,YN,XN,VTO,VFROM,YLIMWS,YLIM
      REAL PGHIS1
      LOGICAL PGNOTO
C
C Check arguments.
C
      IF (IX1.GT.IX2) RETURN
      IF (PGNOTO('PGHI2D')) RETURN
      CALL PGBBUF
C
C Check Y order.
C
      IF (IY1.GT.IY2) THEN
         INC = -1
      ELSE
         INC = 1
      END IF
C
C Clear limits array.
C
      NELMX = IX2 - IX1 + 1
      DO 10 IX=1,NELMX
         YLIMS(IX) = PGYBLC(PGID)
 10   CONTINUE
C
C Loop through Y values.
C
      NOFF = 0
      CBIAS = 0.
      DO 200 IY=IY1,IY2,INC
         YNWAS = CBIAS
         YLIMWS = YNWAS
         XNWAS = PGHIS1(X,NELMX,CENTER,1+NOFF)
         PENDOW = .FALSE.
         FIRST = .TRUE.
         IXPT = 1
C
C Draw histogram for this Y value.
C
         DO 100 IX=IX1,IX2
            YN = DATA(IX,IY) + CBIAS
            XN = PGHIS1(X,NELMX,CENTER,IXPT+NOFF+1)
            YLIM = YLIMS(IXPT)
C
C Given X and Y old and new values, and limits, see which parts of the
C lines are to be drawn.
C
            IF (YN.GT.YLIM) THEN
               YLIMS(IXPT) = YN
               HPLOT = .TRUE.
               VPLOT = .TRUE.
               VTO = YN
               VFROM = YLIM
               IF (YNWAS.GT.YLIMWS) VFROM = YNWAS
            ELSE
               HPLOT = .FALSE.
               IF (YNWAS.GT.YLIMWS) THEN
                  VPLOT = .TRUE.
                  VFROM = YNWAS
                  VTO = YLIM
               ELSE
                  VPLOT = .FALSE.
               END IF
            END IF
C
C Plot the bin.
C
            IF (VPLOT) THEN
               IF (.NOT.PENDOW) THEN
                  IF (FIRST) THEN
                     CALL GRMOVA(XNWAS,MAX(VTO,CBIAS))
                     FIRST = .FALSE.
                  ELSE
                     CALL GRMOVA(XNWAS,VFROM)
                  END IF
               END IF
               CALL GRLINA(XNWAS,VTO)
               IF (HPLOT) THEN
                  CALL GRLINA(XN,YN)
               END IF
            END IF
            PENDOW = HPLOT
            YLIMWS = YLIM
            YNWAS = YN
            XNWAS = XN
            IXPT = IXPT + 1
 100     CONTINUE
         IF (PENDOW) CALL GRLINA(XN,MAX(YLIM,CBIAS))
C
C If any offset in operation, shift limits array to compensate for it.
C
         IF (IOFF.GT.0) THEN
            DO 110 IX=1,NELMX-IOFF
               YLIMS(IX) = YLIMS(IX+IOFF)
 110        CONTINUE
            DO 120 IX=NELMX-IOFF+1,NELMX
               YLIMS(IX) = PGYBLC(PGID)
 120        CONTINUE
         ELSE IF (IOFF.LT.0) THEN
            DO 130 IX=NELMX,1-IOFF,-1
               YLIMS(IX) = YLIMS(IX+IOFF)
 130        CONTINUE
            DO 140 IX=1,-IOFF
               YLIMS(IX) = PGYBLC(PGID)
 140        CONTINUE
         END IF
         CBIAS = CBIAS + BIAS
         NOFF = NOFF + IOFF
 200  CONTINUE
C
      CALL PGEBUF
      END

C*PGSCLP -- enable or disable clipping at edge of viewport
C%void cpgsclp(int state);
C+
      SUBROUTINE PGSCLP(STATE)
      INTEGER STATE
C
C Normally all PGPLOT primitives except text are ``clipped'' at the
C edge of the viewport: parts of the primitives that lie outside
C the viewport are not drawn. If clipping is disabled by calling this
C routine, primitives are visible wherever they lie on the view
C surface. The default (clipping enabled) is appropriate for almost
C all applications.
C
C Argument:
C  STATE  (input)  : 0 to disable clipping, or 1 to enable clipping.
C 
C 25-Feb-1997 [TJP] - new routine.
C-----------------------------------------------------------------------
      INCLUDE  'pgplot.inc'
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGSCLP')) RETURN
C
C Disable clipping.
C
      IF (STATE.EQ.0) THEN
         CALL GRAREA(PGID,0.,0.,-1.,-1.)
         PGCLP(PGID) = 0
C
C Enable clipping.
C
      ELSE
         CALL GRAREA(PGID,PGXOFF(PGID),PGYOFF(PGID),
     :               PGXLEN(PGID),PGYLEN(PGID))
         PGCLP(PGID) = 1
      END IF
      END

C*PGPIXL -- draw pixels
C%void cpgpixl(const int *ia, int idim, int jdim, int i1, int i2, \
C% int j1, int j2, float x1, float x2, float y1, float y2);
C+
      SUBROUTINE PGPIXL (IA, IDIM, JDIM, I1, I2, J1, J2, 
     1                   X1, X2, Y1, Y2)
      INTEGER IDIM, JDIM, I1, I2, J1, J2
      INTEGER IA(IDIM,JDIM)
      REAL    X1, X2, Y1, Y2
C
C Draw lots of solid-filled (tiny) rectangles aligned with the
C coordinate axes. Best performance is achieved when output is
C directed to a pixel-oriented device and the rectangles coincide
C with the pixels on the device. In other cases, pixel output is
C emulated.
C
C The subsection of the array IA defined by indices (I1:I2, J1:J2)
C is mapped onto world-coordinate rectangle defined by X1, X2, Y1
C and Y2. This rectangle is divided into (I2 - I1 + 1) * (J2 - J1 + 1)
C small rectangles. Each of these small rectangles is solid-filled
C with the color index specified by the corresponding element of 
C IA.
C
C On most devices, the output region is "opaque", i.e., it obscures
C all graphical elements previously drawn in the region. But on
C devices that do not have erase capability, the background shade
C is "transparent" and allows previously-drawn graphics to show
C through.
C
C Arguments:
C  IA     (input)  : the array to be plotted.
C  IDIM   (input)  : the first dimension of array A.
C  JDIM   (input)  : the second dimension of array A.
C  I1, I2 (input)  : the inclusive range of the first index
C                    (I) to be plotted.
C  J1, J2 (input)  : the inclusive range of the second
C                    index (J) to be plotted.
C  X1, Y1 (input)  : world coordinates of one corner of the output
C                    region
C  X2, Y2 (input)  : world coordinates of the opposite corner of the
C                    output region
C--
C 16-Jan-1991 - [GvG]
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C
C Check inputs.
C
      IF (PGNOTO('PGPIXL')) RETURN
      IF (I1.LT.1 .OR. I2.GT.IDIM .OR. I1.GT.I2 .OR.
     1    J1.LT.1 .OR. J2.GT.JDIM .OR. J1.GT.J2) THEN
         CALL GRWARN('PGPIXL: invalid range I1:I2, J1:J2')
      ELSE
C
C Call lower-level routine to do the work.
C
         CALL PGBBUF
         CALL GRPIXL(IA, IDIM, JDIM, I1, I2, J1, J2, X1, X2, Y1, Y2)
         CALL PGEBUF
      END IF
C-----------------------------------------------------------------------
      END

C*GRGMSG -- print system message (MS-DOS)
C+
      SUBROUTINE GRGMSG (ISTAT)
      INTEGER   ISTAT
C
C This routine obtains the text of the VMS system message corresponding
C to code ISTAT, and displays it using routine GRWARN. On non-VMS
C systems, it just displays the error number.
C
C Argument:
C  ISTAT (input): 32-bit system message code.
C--
C 1989-Mar-29
C-----------------------------------------------------------------------
      CHARACTER CBUF*10
C
      WRITE (CBUF, 101) ISTAT
  101 FORMAT(I10)
      CALL GRWARN('system message number: '//CBUF)
      END

C*********
      INTERFACE TO CHARACTER FUNCTION GETENV [C]
     +   (CBUF[REFERENCE])
C---
C Allow MS-Fortran to call the GETENV function built into the
C Fortran 5.0 library.
C---
      CHARACTER*1 CBUF
      END
C*********

C*GRGENV -- get value of PGPLOT environment parameter (MS-DOS)
C+
      SUBROUTINE GRGENV(CNAME, CVALUE, LVALUE)
      CHARACTER CNAME*(*), CVALUE*(*)
      INTEGER   LVALUE
C
C Return the value of a PGPLOT environment parameter.
C
C Arguments:
C CNAME   : (input) the name of the parameter to evaluate.
C CVALUE  : receives the value of the parameter, truncated or extended
C           with blanks as necessary. If the parameter is undefined,
C           a blank string is returned.
C LVALUE  : receives the number of characters in CVALUE, excluding
C           trailing blanks. If the parameter is undefined, zero is
C           returned.
C--
C 1990-Mar-19 - [AFT]
C-----------------------------------------------------------------------
      CHARACTER GETENV*64
C
      CHARACTER CTMP*64
      INTEGER   I, LTMP
C
      CTMP = 'PGPLOT_'//CNAME
      LTMP = INDEX(CTMP,' ')
      IF(LTMP.EQ.0) LTMP=LEN(CTMP)-1
      CTMP(LTMP:LTMP)=CHAR(0)
      CTMP=GETENV(CTMP(:LTMP))
      CVALUE = ' '
      LVALUE = 0
C---
C MS-Fortran Kludge, if the environment variable is undefined, then
C GETENV points to NULL (memory location zero).  I see no easy way to
C detect this condition in Fortran, therefore, I compare with an
C environment variable that noone would ever define and hence should
C always point at NULL.
      IF(GETENV('#$%^'//CHAR(0)).EQ.CTMP) GOTO 140
      DO 130 I=1,LEN(CTMP)
         IF(CTMP(I:I).EQ.CHAR(0)) GOTO 140
         LVALUE=LVALUE+1
         CVALUE(LVALUE:LVALUE)=CTMP(I:I)
  130 CONTINUE
  140 CONTINUE
      RETURN
      END

C PGBOX1 -- support routine for PGBOX
C
      SUBROUTINE PGBOX1 (XA, XB, XD, I1, I2)
      REAL XA, XB, XD
      INTEGER I1, I2
C
C This routine is used to determine where to draw the tick marks on
C an axis. The input arguments XA and XB are the world-coordinate
C end points of the axis; XD is the tick interval. PGBOX1 returns
C two integers, I1 and I2, such that the required tick marks are
C to be placed at world-coordinates (I*XD), for I=I1,...,I2.
C Normally I2 is greater than or equal to I1, but if there are no
C values of I such that I*XD lies in the inclusive range (XA, XB),
C then I2 will be 1 less than I1.
C
C Arguments:
C  XA, XB (input)  : world-coordinate end points of the axis. XA must
C                    not be equal to XB; otherwise, there are no
C                    restrictions.
C  XD     (input)  : world-coordinate tick interval. XD may be positive
C                    or negative, but may not be zero.
C  I1, I2 (output) : tick marks should be drawn at world
C                    coordinates I*XD for I in the inclusive range
C                    I1...I2 (see above).
C
C 14-Jan-1986 - new routine [TJP].
C 13-Dec-1990 - remove rror check [TJP].
C-----------------------------------------------------------------------
      REAL XLO, XHI
C
      XLO = MIN(XA/XD, XB/XD)
      XHI = MAX(XA/XD, XB/XD)
      I1 = NINT(XLO)
      IF (I1.LT.XLO) I1 = I1+1
      I2 = NINT(XHI)
      IF (I2.GT.XHI) I2 = I2-1
      END

!!G Toolbox.finc
C  If you have a power mac version of LS fortran uncomment the
C next 5 lines and comment out "!!MP InLines.f"
C!!IFC NOT LSPOWERF
C!!MP 68KInlines
C!!ELSEC
C!!MP PPCInlines
C!!ENDC
C  If you have a 68K mac version of LS fortran comment out the 
C 5 lines above and uncomment the next line.
!!MP InLines.f
C*GRUSER -- get user name (Macintosh)
C+
      SUBROUTINE GRUSER(STRING, L)
      CHARACTER*(*) STRING
      INTEGER L
C
C Return the name of the user running the program.
C On Macintosh get user name in from resource -16096.  This is set
C with the Sharing Setup control panel.
C
C Arguments:
C  STRING : receives user name, truncated or extended with
C           blanks as necessary.
C  L      : receives the number of characters in VALUE, excluding
C           trailing blanks.
C--
C-----------------------------------------------------------------------
	  Record /StringHandle/ UserName
	  
      UserName = GetString(int2(-16096))
      STRING = UserName.h^.P^
      L = len(trim(string))
      END

C*PGQCS  -- inquire character height in a variety of units
C%void cpgqcs(int units, float *xch, float *ych);
C+
      SUBROUTINE PGQCS(UNITS, XCH, YCH)
      INTEGER UNITS
      REAL XCH, YCH
C
C Return the current PGPLOT character height in a variety of units.
C This routine provides facilities that are not available via PGQCH.
C Use PGQCS if the character height is required in units other than
C those used in PGSCH.
C
C The PGPLOT "character height" is a dimension that scales with the
C size of the view surface and with the scale-factor specified with
C routine PGSCH. The default value is 1/40th of the height or width
C of the view surface (whichever is less); this value is then
C multiplied by the scale-factor supplied with PGSCH. Note that it
C is a nominal height only; the actual character size depends on the
C font and is usually somewhat smaller.
C
C Arguments:
C  UNITS  (input)  : Used to specify the units of the output value:
C                    UNITS = 0 : normalized device coordinates
C                    UNITS = 1 : inches
C                    UNITS = 2 : millimeters
C                    UNITS = 3 : pixels
C                    UNITS = 4 : world coordinates
C                    Other values give an error message, and are
C                    treated as 0.
C  XCH    (output) : The character height for text written with a
C                    vertical baseline.
C  YCH    (output) : The character height for text written with
C                    a horizontal baseline (the usual case).
C
C The character height is returned in both XCH and YCH.
C
C If UNITS=1 or UNITS=2, XCH and YCH both receive the same value.
C
C If UNITS=3, XCH receives the height in horizontal pixel units, and YCH
C receives the height in vertical pixel units; on devices for which the
C pixels are not square, XCH and YCH will be different.
C
C If UNITS=4, XCH receives the height in horizontal world coordinates
C (as used for the x-axis), and YCH receives the height in vertical
C world coordinates (as used for the y-axis). Unless special care has
C been taken to achive equal world-coordinate scales on both axes, the
C values of XCH and YCH will be different.
C
C If UNITS=0, XCH receives the character height as a fraction of the
C horizontal dimension of the view surface, and YCH receives the
C character height as a fraction of the vertical dimension of the view
C surface.
C--
C 15-Oct-1992 - new routine [MCS].
C  4-Dec-1992 - added more explanation [TJP].
C  5-Sep-1995 - add UNITS=4; correct error for non-square pixels [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
      REAL RATIO
C                                        Conversion factor inches -> mm
      REAL INTOMM
      PARAMETER (INTOMM=25.4)
C-----------------------------------------------------------------------
      IF (PGNOTO('PGQCS')) RETURN
      RATIO = PGYPIN(PGID)/PGXPIN(PGID)
C
C Return the character height in the required units.
C
C                                        Inches.
      IF (UNITS.EQ.1) THEN
        XCH = PGYSP(PGID)/PGXPIN(PGID)
        YCH = XCH
C                                        Millimeters.
      ELSE IF (UNITS.EQ.2) THEN
        XCH = PGYSP(PGID)/PGXPIN(PGID) * INTOMM
        YCH = XCH
C                                        Pixels.
      ELSE IF (UNITS.EQ.3) THEN
        XCH = PGYSP(PGID)
        YCH = PGYSP(PGID)*RATIO
C                                        World coordinates.
      ELSE IF (UNITS.EQ.4) THEN
         XCH = PGYSP(PGID)/PGXSCL(PGID)
         YCH = PGYSP(PGID)*RATIO/PGYSCL(PGID)
C                                        Normalized device coords, or
C                                        unknown.
      ELSE
        XCH = PGYSP(PGID)/PGXSZ(PGID)
        YCH = PGYSP(PGID)*RATIO/PGYSZ(PGID)
        IF (UNITS.NE.0)
     :       CALL GRWARN('Invalid "UNITS" argument in PGQCS.')
      END IF
      END

C*PGCLOS -- close the selected graphics device
C%void cpgclos(void);
C+
      SUBROUTINE PGCLOS
C
C Close the currently selected graphics device. After the device has
C been closed, either another open device must be selected with PGSLCT
C or another device must be opened with PGOPEN before any further
C plotting can be done. If the call to PGCLOS is omitted, some or all 
C of the plot may be lost.
C
C [This routine was added to PGPLOT in Version 5.1.0. Older programs
C use PGEND instead.]
C
C Arguments: none
C--
C 22-Dec-1995 - new routine, derived from the old PGEND.
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      CHARACTER*16 DEFSTR
      LOGICAL PGNOTO
C
      IF (.NOT.PGNOTO('PGCLOS')) THEN
         CALL GRTERM
         IF (PGPRMP(PGID)) THEN
            CALL GRQCAP(DEFSTR)
            IF (DEFSTR(8:8).EQ.'V') CALL GRPROM
         END IF
         CALL GRCLOS
         PGDEVS(PGID) = 0
         PGID = 0
      END IF
C     WRITE (*,*) 'PGCLOS', PGID, ':', PGDEVS
      END

C*GRPROM -- prompt user before clearing screen
C+
      SUBROUTINE GRPROM
C
C If the program is running under control of a terminal, display
C message and wait for the user to type <CR> before proceeding.
C
C Arguments:
C  none
C--
C 18-Aug-1994
C-----------------------------------------------------------------------
      INTEGER IER, L, GRGCOM
      CHARACTER*16 JUNK
C
      IER = GRGCOM(JUNK, 'Type <RETURN> for next page: ', L)
      END

C*PGPTXT -- write text at arbitrary position and angle
C%void cpgptxt(float x, float y, float angle, float fjust, \
C% const char *text);
C+
      SUBROUTINE PGPTXT (X, Y, ANGLE, FJUST, TEXT)
      REAL X, Y, ANGLE, FJUST
      CHARACTER*(*) TEXT
C
C Primitive routine for drawing text. The text may be drawn at any
C angle with the horizontal, and may be centered or left- or right-
C justified at a specified position.  Routine PGTEXT provides a
C simple interface to PGPTXT for horizontal strings. Text is drawn
C using the current values of attributes color-index, line-width,
C character-height, and character-font.  Text is NOT subject to
C clipping at the edge of the window.
C
C Arguments:
C  X      (input)  : world x-coordinate.
C  Y      (input)  : world y-coordinate. The string is drawn with the
C                    baseline of all the characters passing through
C                    point (X,Y); the positioning of the string along
C                    this line is controlled by argument FJUST.
C  ANGLE  (input)  : angle, in degrees, that the baseline is to make
C                    with the horizontal, increasing counter-clockwise
C                    (0.0 is horizontal).
C  FJUST  (input)  : controls horizontal justification of the string.
C                    If FJUST = 0.0, the string will be left-justified
C                    at the point (X,Y); if FJUST = 0.5, it will be
C                    centered, and if FJUST = 1.0, it will be right
C                    justified. [Other values of FJUST give other
C                    justifications.]
C  TEXT   (input)  : the character string to be plotted.
C--
C (2-May-1983)
C 31-Jan-1985 - convert to Fortran-77 standard...
C 13-Feb-1988 - correct a PGBBUF/PGEBUF mismatch if string is blank.
C 16-Oct-1993 - erase background of opaque text.
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      INTEGER CI, I, L, GRTRIM
      REAL D, XP, YP
      REAL XBOX(4), YBOX(4)
      LOGICAL PGNOTO
C
      IF (PGNOTO('PGPTXT')) RETURN
      CALL PGBBUF
C
      L = GRTRIM(TEXT)
      D = 0.0
      IF (FJUST.NE.0.0) CALL GRLEN(TEXT(1:L),D)
      XP = PGXORG(PGID)+X*PGXSCL(PGID) - D*FJUST*COS(ANGLE/57.29578)
      YP = PGYORG(PGID)+Y*PGYSCL(PGID) - D*FJUST*SIN(ANGLE/57.29578)
      IF (PGTBCI(PGID).GE.0) THEN
          CALL GRQTXT (ANGLE, XP, YP, TEXT(1:L), XBOX, YBOX)
          DO 25 I=1,4
              XBOX(I) = (XBOX(I)-PGXORG(PGID))/PGXSCL(PGID)
              YBOX(I) = (YBOX(I)-PGYORG(PGID))/PGYSCL(PGID)
   25     CONTINUE
          CALL PGQCI(CI)
          CALL PGSCI(PGTBCI(PGID))
          CALL GRFA(4, XBOX, YBOX)
          CALL PGSCI(CI)
      END IF
      CALL GRTEXT(.TRUE. ,ANGLE, .TRUE., XP, YP, TEXT(1:L))
   30 CALL PGEBUF
      END

C*GRTEXT -- draw text
C+
      SUBROUTINE GRTEXT (CENTER,ORIENT,ABSXY,X0,Y0,STRING)
C
C GRPCKG: Write a text string using the high-quality character set.
C The text is NOT windowed in the current viewport, but may extend over
C the whole view surface.  Line attributes (color, intensity thickness)
C apply to text, but line-style is ignored.  The current pen position
C after a call to GRTEXT is undefined.
C
C Arguments:
C
C STRING (input, character): the character string to be plotted. This
C       may include standard escape-sequences to represent non-ASCII
C       characters and special commands. The number of characters in
C       STRING (i.e., LEN(STRING)) should not exceed 256.
C--
C (3-May-1983)
C  5-Aug-1986 - add GREXEC support [AFT].
C  6-Sep-1989 - standardize [TJP].
C 20-Apr-1995 - Verbose PS file support.  If PGPLOT_PS_VERBOSE_TEXT is
C               defined, text strings in PS files are preceded by a 
C               comment with the text of the string plotted as vectors
C               [TJP after D.S.Briggs].
C  4-Feb-1997 - grexec requires an RBUF array, not a scalar [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
      LOGICAL ABSXY,UNUSED,VISBLE,CENTER
      INTEGER XYGRID(300)
      INTEGER LIST(256)
      CHARACTER*(*) STRING
      REAL ANGLE, FACTOR, FNTBAS, FNTFAC, COSA, SINA, DX, DY, XORG, YORG
      REAL XCUR, YCUR, ORIENT, RATIO, X0, Y0, RLX, RLY
      REAL XMIN, XMAX, YMIN, YMAX
      REAL RBUF(6)
      INTEGER I, IFNTLV,NLIST,LX,LY, K, LXLAST,LYLAST, LSTYLE
      INTEGER SLEN, GRTRIM
      INTRINSIC ABS, COS, LEN, MIN, SIN
      CHARACTER DEVTYP*14, STEMP*258
      LOGICAL DEVINT, VTEXT
C
C Check that there is something to be plotted.
C
      IF (LEN(STRING).LE.0) RETURN
C
C Check that a device is selected.
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRTEXT - no graphics device is active.')
          RETURN
      END IF
C
C Save current line-style, and set style "normal".
C
      CALL GRQLS(LSTYLE)
      CALL GRSLS(1)
C
C Put device dependent code here or at end
C
      VTEXT = .FALSE.
      CALL GRQTYP (DEVTYP, DEVINT)
      IF ((DEVTYP.EQ.'PS').OR.(DEVTYP.EQ.'VPS').OR.
     1    (DEVTYP.EQ.'CPS').OR.(DEVTYP.EQ.'VCPS')) THEN
         CALL GRGENV ('PS_VERBOSE_TEXT', STEMP, I)
         VTEXT = (I.GT.0)
         IF (VTEXT) THEN
            SLEN = GRTRIM(STRING)
            STEMP = '% Start "' // STRING(1:SLEN) // '"'
            CALL GREXEC (GRGTYP, 23, RBUF, 0, STEMP, SLEN+10)
         END IF
      END IF
C
C Save current viewport, and open the viewport to include the full
C view surface.
C
      XORG = GRXPRE(GRCIDE)
      YORG = GRYPRE(GRCIDE)
      XMIN = GRXMIN(GRCIDE)
      XMAX = GRXMAX(GRCIDE)
      YMIN = GRYMIN(GRCIDE)
      YMAX = GRYMAX(GRCIDE)
      CALL GRAREA(GRCIDE, 0.0, 0.0, 0.0, 0.0)
C
C Compute scaling and orientation.
C
      ANGLE = ORIENT*(3.14159265359/180.)
      FACTOR = GRCFAC(GRCIDE)/2.5
      RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE)
      COSA = FACTOR * COS(ANGLE)
      SINA = FACTOR * SIN(ANGLE)
      CALL GRTXY0(ABSXY, X0, Y0, XORG, YORG)
      FNTBAS = 0.0
      FNTFAC = 1.0
      IFNTLV = 0
      DX = 0.0
      DY = 0.0
C
C Convert the string to a list of symbol numbers; to prevent overflow
C of array LIST, the length of STRING is limited to 256 characters.
C
      CALL GRSYDS(LIST,NLIST,STRING(1:MIN(256,LEN(STRING))),
     1             GRCFNT(GRCIDE))
C
C Plot the string of characters
C
      DO 380 I = 1,NLIST
          IF (LIST(I).LT.0) THEN
              IF (LIST(I).EQ.-1) THEN
C                 ! up
                  IFNTLV = IFNTLV+1
                  FNTBAS = FNTBAS + 16.0*FNTFAC
                  FNTFAC = 0.75**ABS(IFNTLV)
              ELSE IF (LIST(I).EQ.-2) THEN
C                 ! down
                  IFNTLV = IFNTLV-1
                  FNTFAC = 0.75**ABS(IFNTLV)
                  FNTBAS = FNTBAS - 16.0*FNTFAC
              ELSE IF (LIST(I).EQ.-3) THEN
C                 ! backspace
                  XORG = XORG - DX*FNTFAC
                  YORG = YORG - DY*FNTFAC
              END IF
              GOTO 380
          END IF
          CALL GRSYXD(LIST(I),XYGRID,UNUSED)
          VISBLE = .FALSE.
          LX = XYGRID(5)-XYGRID(4)
          DX = COSA*LX*RATIO
          DY = SINA*LX
          K = 4
          LXLAST = -64
          LYLAST = -64
  320     K = K+2
          LX = XYGRID(K)
          LY = XYGRID(K+1)
          IF (LY.EQ.-64) GOTO 330
          IF (LX.EQ.-64) THEN
              VISBLE = .FALSE.
          ELSE
              RLX = (LX - XYGRID(4))*FNTFAC
              RLY = (LY - XYGRID(2))*FNTFAC + FNTBAS
              IF ((LX.NE.LXLAST) .OR. (LY.NE.LYLAST)) THEN
                  XCUR = XORG + (COSA*RLX - SINA*RLY)*RATIO
                  YCUR = YORG + (SINA*RLX + COSA*RLY)
                  IF (VISBLE) THEN
                      CALL GRLIN0(XCUR,YCUR)
                  ELSE
                      GRXPRE(GRCIDE) = XCUR
                      GRYPRE(GRCIDE) = YCUR
                  END IF
              END IF
              VISBLE = .TRUE.
              LXLAST = LX
              LYLAST = LY
          END IF
          GOTO 320
  330     XORG = XORG + DX*FNTFAC
          YORG = YORG + DY*FNTFAC
  380 CONTINUE
C
C Set pen position ready for next character.
C
      GRXPRE(GRCIDE) = XORG
      GRYPRE(GRCIDE) = YORG
C
C Another possible device dependent section
C
      IF (VTEXT) THEN
         STEMP = '% End "' // STRING(1:SLEN) // '"'
         CALL GREXEC(GRGTYP, 23, RBUF, 0, STEMP, SLEN+8)
      END IF
C
C Restore the viewport and line-style, and return.
C
      GRXMIN(GRCIDE) = XMIN
      GRXMAX(GRCIDE) = XMAX
      GRYMIN(GRCIDE) = YMIN
      GRYMAX(GRCIDE) = YMAX
      CALL GRSLS(LSTYLE)
C
      END

C*PGWEDG -- annotate an image plot with a wedge
C%void cpgwedg(const char *side, float disp, float width, \
C% float fg, float bg, const char *label);
C+
      SUBROUTINE PGWEDG(SIDE, DISP, WIDTH, FG, BG, LABEL)
      CHARACTER *(*) SIDE,LABEL
      REAL DISP, WIDTH, FG, BG
C
C Plot an annotated grey-scale or color wedge parallel to a given axis
C of the the current viewport. This routine is designed to provide a
C brightness/color scale for an image drawn with PGIMAG or PGGRAY.
C The wedge will be drawn with the transfer function set by PGSITF
C and using the color index range set by PGSCIR.
C
C Arguments:
C  SIDE   (input)  : The first character must be one of the characters
C                    'B', 'L', 'T', or 'R' signifying the Bottom, Left,
C                    Top, or Right edge of the viewport.
C                    The second character should be 'I' to use PGIMAG
C                    to draw the wedge, or 'G' to use PGGRAY.
C  DISP   (input)  : the displacement of the wedge from the specified
C                    edge of the viewport, measured outwards from the
C                    viewport in units of the character height. Use a
C                    negative value to write inside the viewport, a
C                    positive value to write outside.
C  WIDTH  (input)  : The total width of the wedge including annotation,
C                    in units of the character height.
C  FG     (input)  : The value which is to appear with shade
C                    1 ("foreground"). Use the values of FG and BG
C                    that were supplied to PGGRAY or PGIMAG.
C  BG     (input)  : the value which is to appear with shade
C                    0 ("background").
C  LABEL  (input)  : Optional units label. If no label is required
C                    use ' '.
C--
C  15-Oct-1992: New routine (MCS)
C   2-Aug-1995: no longer needs common (TJP).
C-----------------------------------------------------------------------
      LOGICAL PGNOTO
C                                        Temporary window coord storage.
      REAL WXA,WXB,WYA,WYB, XA,XB,YA,YB
C                                        Viewport coords of wedge.
      REAL VXA,VXB,VYA,VYB
C                          Original and anotation character heights.
      REAL OLDCH, NEWCH
C                          Size of unit character height (NDC units).
      REAL NDCSIZ
C                          True if wedge plotted horizontally.
      LOGICAL HORIZ
C                          Use PGIMAG (T) or PGGRAY (F).
      LOGICAL IMAGE
C                          Symbolic version of SIDE.
      INTEGER NSIDE,BOT,TOP,LFT,RGT
      PARAMETER (BOT=1,TOP=2,LFT=3,RGT=4)
      INTEGER I
      REAL WEDWID, WDGINC, VWIDTH, VDISP, XCH, YCH, LABWID, FG1, BG1
C                          Set the fraction of WIDTH used for anotation.
      REAL TXTFRC
      PARAMETER (TXTFRC=0.6)
C                          Char separation between numbers and LABEL.
      REAL TXTSEP
      PARAMETER (TXTSEP=2.2)
C                          Array to draw wedge in.
      INTEGER WDGPIX
      PARAMETER (WDGPIX=100)
      REAL WDGARR(WDGPIX)
C                          Define the coordinate-mapping function.
      REAL TR(6)
      SAVE TR
      DATA TR /0.0,1.0,0.0,0.0,0.0,1.0/
C-----------------------------------------------------------------------
      IF(PGNOTO('PGWEDG')) RETURN
C
C Get a numeric version of SIDE.
C
      IF(SIDE(1:1).EQ.'B' .OR. SIDE(1:1).EQ.'b') THEN
        NSIDE = BOT
        HORIZ = .TRUE.
      ELSE IF(SIDE(1:1).EQ.'T' .OR. SIDE(1:1).EQ.'t') THEN
        NSIDE = TOP
        HORIZ = .TRUE.
      ELSE IF(SIDE(1:1).EQ.'L' .OR. SIDE(1:1).EQ.'l') THEN
        NSIDE = LFT
        HORIZ = .FALSE.
      ELSE IF(SIDE(1:1).EQ.'R' .OR. SIDE(1:1).EQ.'r') THEN
        NSIDE = RGT
        HORIZ = .FALSE.
      ELSE
        CALL GRWARN('Invalid "SIDE" argument in PGWEDG.')
        RETURN
      END IF
C
C Determine which routine to use.
C
      IF (LEN(SIDE).LT.2) THEN
         IMAGE = .FALSE.
      ELSE IF(SIDE(2:2).EQ.'I' .OR. SIDE(2:2).EQ.'i') THEN
         IMAGE = .TRUE.
      ELSE IF(SIDE(2:2).EQ.'G' .OR. SIDE(2:2).EQ.'g') THEN
         IMAGE = .FALSE.
      ELSE
         CALL GRWARN('Invalid "SIDE" argument in PGWEDG.')
      END IF
C
      CALL PGBBUF
C
C Store the current world and viewport coords and the character height.
C
      CALL PGQWIN(WXA, WXB, WYA, WYB)
      CALL PGQVP(0, XA, XB, YA, YB)
      CALL PGQCH(OLDCH)
C
C Determine the unit character height in NDC coords.
C
      CALL PGSCH(1.0)
      CALL PGQCS(0, XCH, YCH)
      IF(HORIZ) THEN
        NDCSIZ = YCH
      ELSE
        NDCSIZ = XCH
      END IF
C
C Convert 'WIDTH' and 'DISP' into viewport units.
C
      VWIDTH = WIDTH * NDCSIZ * OLDCH
      VDISP  = DISP * NDCSIZ * OLDCH
C
C Determine the number of character heights required under the wedge.
C
      LABWID = TXTSEP
      IF(LABEL.NE.' ') LABWID = LABWID + 1.0
C
C Determine and set the character height required to fit the wedge
C anotation text within the area allowed for it.
C
      NEWCH = TXTFRC*VWIDTH / (LABWID*NDCSIZ)
      CALL PGSCH(NEWCH)
C
C Determine the width of the wedge part of the plot minus the anotation.
C (NDC units).
C
      WEDWID = VWIDTH * (1.0-TXTFRC)
C
C Use these to determine viewport coordinates for the wedge + annotation.
C
      VXA = XA
      VXB = XB
      VYA = YA
      VYB = YB
      IF(NSIDE.EQ.BOT) THEN
        VYB = YA - VDISP
        VYA = VYB - WEDWID
      ELSE IF(NSIDE.EQ.TOP) THEN
        VYA = YB + VDISP
        VYB = VYA + WEDWID
      ELSE IF(NSIDE.EQ.LFT) THEN
        VXB = XA - VDISP
        VXA = VXB - WEDWID
      ELSE IF(NSIDE.EQ.RGT) THEN
        VXA = XB + VDISP
        VXB = VXA + WEDWID
      END IF
C
C Set the viewport for the wedge.
C
      CALL PGSVP(VXA, VXB, VYA, VYB)
C
C Swap FG/BG if necessary to get axis direction right.
C
      FG1 = MAX(FG,BG)
      BG1 = MIN(FG,BG)
C
C Create a dummy wedge array to be plotted.
C
      WDGINC = (FG1-BG1)/(WDGPIX-1)
      DO 1 I=1,WDGPIX
        WDGARR(I) = BG1 + (I-1) * WDGINC
 1    CONTINUE
C
C Draw the wedge then change the world coordinates for labelling.
C
      IF (HORIZ) THEN
        CALL PGSWIN(1.0, REAL(WDGPIX), 0.9, 1.1)
        IF (IMAGE) THEN
           CALL PGIMAG(WDGARR, WDGPIX,1, 1,WDGPIX, 1,1, FG,BG, TR)
        ELSE
           CALL PGGRAY(WDGARR, WDGPIX,1, 1,WDGPIX, 1,1, FG,BG, TR)
        END IF
        CALL PGSWIN(BG1,FG1,0.0,1.0)
      ELSE
        CALL PGSWIN(0.9, 1.1, 1.0, REAL(WDGPIX))
        IF (IMAGE) THEN
           CALL PGIMAG(WDGARR, 1,WDGPIX, 1,1, 1,WDGPIX, FG,BG, TR)
        ELSE
           CALL PGGRAY(WDGARR, 1,WDGPIX, 1,1, 1,WDGPIX, FG,BG, TR)
        END IF
        CALL PGSWIN(0.0, 1.0, BG1, FG1)
      ENDIF
C
C Draw a labelled frame around the wedge.
C
      IF(NSIDE.EQ.BOT) THEN
        CALL PGBOX('BCNST',0.0,0,'BC',0.0,0)
      ELSE IF(NSIDE.EQ.TOP) THEN
        CALL PGBOX('BCMST',0.0,0,'BC',0.0,0)
      ELSE IF(NSIDE.EQ.LFT) THEN
        CALL PGBOX('BC',0.0,0,'BCNST',0.0,0)
      ELSE IF(NSIDE.EQ.RGT) THEN
        CALL PGBOX('BC',0.0,0,'BCMST',0.0,0)
      ENDIF
C
C Write the units label.
C
      IF(LABEL.NE.' ') THEN
        CALL PGMTXT(SIDE,TXTSEP,1.0,1.0,LABEL)
      END IF
C
C Reset the original viewport and world coordinates.
C
      CALL PGSVP(XA,XB,YA,YB)
      CALL PGSWIN(WXA,WXB,WYA,WYB)
      CALL PGSCH(OLDCH)
      CALL PGEBUF
      RETURN
      END

C*PGOLIN -- mark a set of points using the cursor
C%void cpgolin(int maxpt, int *npt, float *x, float *y, int symbol);
C+
      SUBROUTINE PGOLIN (MAXPT, NPT, X, Y, SYMBOL)
      INTEGER MAXPT, NPT
      REAL    X(*), Y(*)
      INTEGER SYMBOL
C
C Interactive routine for user to enter data points by use of
C the cursor.  Routine allows user to Add and Delete points.  The
C points are returned in the order that they were entered (unlike
C PGNCUR).
C
C Arguments:
C  MAXPT  (input)  : maximum number of points that may be accepted.
C  NPT    (in/out) : number of points entered; should be zero on
C                    first call.
C  X      (in/out) : array of x-coordinates.
C  Y      (in/out) : array of y-coordinates.
C  SYMBOL (input)  : code number of symbol to use for marking
C                    entered points (see PGPT).
C
C Note (1): The dimension of arrays X and Y must be greater than or
C equal to MAXPT.
C
C Note (2): On return from the program, cursor points are returned in
C the order they were entered. Routine may be (re-)called with points
C already defined in X,Y (number in NPT), and they will be plotted
C first, before editing.
C
C Note (3): User commands: the user types single-character commands
C after positioning the cursor: the following are accepted:
C A (Add)    - add point at current cursor location.
C D (Delete) - delete the last point entered.
C X (eXit)   - leave subroutine.
C--
C  4-Nov-1985 - new routine (adapted from PGNCUR) - TJP.
C 13-Dec-1990 - change warnings to messages [TJP].
C  7-Sep-1994 - use PGBAND [TJP].
C  2-Aug-1995 - remove dependence on common block [TJP].
C-----------------------------------------------------------------------
      LOGICAL  PGNOTO
      CHARACTER*1 LETTER
      INTEGER  PGBAND, SAVCOL
      REAL     XP, YP, XREF, YREF
      REAL     XBLC, XTRC, YBLC, YTRC
C
C Check that PGPLOT is in the correct state.
C
      IF (PGNOTO('PGOLIN')) RETURN
C
C Save current color.
C
      CALL GRQCI(SAVCOL)
C
C Put current points on screen.  Position cursor on last point,
C or in middle viewport if there are no current points.
C
      CALL PGQWIN(XBLC, XTRC, YBLC, YTRC)
      IF (NPT.NE.0) THEN
          CALL PGPT(NPT,X,Y,SYMBOL)
          XP = X(NPT)
          YP = Y(NPT)
      ELSE
          XP = 0.5*(XBLC+XTRC)
          YP = 0.5*(YBLC+YTRC)
      END IF
C
C Loop over cursor inputs.
C
  100 XREF = XP
      YREF = YP
      IF (PGBAND(0,1,XREF,YREF,XP,YP,LETTER).NE.1) RETURN
      IF (LETTER.EQ.CHAR(0)) RETURN
      CALL GRTOUP(LETTER,LETTER)
C
C A (ADD) command:
C
      IF (LETTER .EQ. 'A') THEN
          IF (NPT.GE.MAXPT) THEN
              CALL GRMSG('ADD ignored (too many points).')
          ELSE
              NPT = NPT + 1
              X(NPT) = XP
              Y(NPT) = YP
              CALL PGPT(1,X(NPT),Y(NPT),SYMBOL)
              CALL GRTERM
          END IF
C
C D (DELETE) command:
C
      ELSE IF (LETTER.EQ.'D') THEN
          IF (NPT.LE.0) THEN
              CALL GRMSG('DELETE ignored (there are no points left).')
          ELSE
              CALL GRSCI(0)
              CALL PGPT(1,X(NPT),Y(NPT),SYMBOL)
              XP = X(NPT)
              YP = Y(NPT)
              CALL GRSCI(SAVCOL)
              CALL GRTERM
              NPT = NPT-1
          END IF
C
C X (EXIT) command:
C
      ELSE IF (LETTER.EQ.'X') THEN
          CALL GRETXT
          RETURN
C
C Illegal command:
C
      ELSE
          CALL GRMSG('Commands are A (add), D (delete), X (exit).')
      END IF
C
      GOTO 100
      END

C*PGSCRL -- scroll window
C%void cpgscrl(float dx, float dy);
C+
      SUBROUTINE PGSCRL (DX, DY)
      REAL DX, DY
C
C This routine moves the window in world-coordinate space while
C leaving the viewport unchanged. On devices that have the
C capability, the pixels within the viewport are scrolled
C horizontally, vertically or both in such a way that graphics
C previously drawn in the window are shifted so that their world
C coordinates are unchanged.
C
C If the old window coordinate range was (X1, X2, Y1, Y2), the new
C coordinate range will be approximately (X1+DX, X2+DX, Y1+DY, Y2+DY).
C The size and scale of the window are unchanged.
C
C Thee window can only be shifted by a whole number of pixels
C (device coordinates). If DX and DY do not correspond to integral
C numbers of pixels, the shift will be slightly different from that
C requested. The new window-coordinate range, and hence the exact
C amount of the shift, can be determined by calling PGQWIN after this
C routine.
C
C Pixels that are moved out of the viewport by this operation are
C lost completely; they cannot be recovered by scrolling back.
C Pixels that are ``scrolled into'' the viewport are filled with
C the background color (color index 0).
C
C If the absolute value of DX is bigger than the width of the window,
C or the aboslute value of DY is bigger than the height of the window,
C the effect will be the same as zeroing all the pixels in the
C viewport.
C
C Not all devices have the capability to support this routine.
C It is only available on some interactive devices that have discrete
C pixels. To determine whether the current device has scroll capability,
C call PGQINF.
C
C Arguments:
C  DX     (input)  : distance (in world coordinates) to shift the
C                    window horizontally (positive shifts window to the
C                    right and scrolls to the left).
C  DY     (input)  : distance (in world coordinates) to shift the
C                    window vertically (positive shifts window up and
C                    scrolls down).
C--
C 25-Feb-97: new routine [TJP].
C-----------------------------------------------------------------------
      INCLUDE 'pgplot.inc'
      LOGICAL PGNOTO
      REAL X1, X2, Y1, Y2, DDX, DDY
      INTEGER NDX, NDY
C
      IF (PGNOTO('PGSCRL')) RETURN
C
C Shift must be a whole number of pixels.
C
      NDX = NINT(DX*PGXSCL(PGID))
      NDY = NINT(DY*PGYSCL(PGID))
C
      IF (NDX.NE.0 .OR. NDY.NE.0) THEN
         CALL PGBBUF
         DDX = NDX/PGXSCL(PGID)
         DDY = NDY/PGYSCL(PGID)
C
C        -- Set new world-ccordinate window.
C
         X1 = PGXBLC(PGID)
         X2 = PGXTRC(PGID)
         Y1 = PGYBLC(PGID)
         Y2 = PGYTRC(PGID)
         PGXBLC(PGID) = X1+DDX
         PGXTRC(PGID) = X2+DDX
         PGYBLC(PGID) = Y1+DDY
         PGYTRC(PGID) = Y2+DDY
         CALL PGVW
C
C        -- Do hardware scroll.
C
         CALL GRSCRL(NDX, NDY)
         CALL PGEBUF
      END IF
      END

C+
***********************************************************************
*                                                                     *
*  PGPLOT Fortran Graphics Subroutine Library                         *
*                                                                     *
*  T. J. Pearson, California Institute of Technology,                 *
*  Pasadena, California 91125.                                        *
*                                                                     *
*  Routines for handling the obsolete character set                   *
*  ------------------------------------------------                   *
*  These routines are not called by PGPLOT but are called by some     *
*  old user-written programs.                                         *
***********************************************************************

******* Index of Modules **********************************************

* GRCHAR -- draw a string of characters
* GRCHR0 -- support routine for GRCHAR and GRMARK
* GRDAT2 -- character set definition (block data)
* GRGTC0 -- obtain character digitization
* GRMARK -- mark points with specified symbol

***********************************************************************
C--

C*GRCHAR -- draw a string of characters
C+
      SUBROUTINE GRCHAR (IDENT,CENTER,ORIENT,ABSXY,X0,Y0,STRING)
C
C GRPCKG: Draw a string of characters. The plot is not windowed
C in the current subarea, but in the full plotting area.
C
C Arguments:
C
C IDENT (input, integer): plot identifier, as returned by GROPEN.
C CENTER (input, logical): if .TRUE., the first character of the string
C      is centered at (X0,Y0); otherwise the bottom left corner of the
C      first character is placed at (X0,Y0).
C ORIENT (input, real): the angle in degrees that the string is to make
C      with the horizontal, increasing anticlockwise.
C ABSXY (input, logical): if .TRUE., (X0,Y0) are absolute device
C      coordinates; otherwise they are world coordinates (the scaling
C      transformation is applied).
C X0, Y0 (input, real): position of first character (see CENTER).
C STRING (input, character): the string of ASCII characters; control
C      characters 0-20 have special representations; all other
C      non-graphic characters are plotted as blank spaces.
C
C (1-Feb-1983)
C-----------------------------------------------------------------------
      CHARACTER*(*) STRING
      INTEGER  IDENT
      LOGICAL  ABSXY, CENTER
      REAL     ORIENT, X0, Y0
C
      CALL GRSLCT(IDENT)
      CALL GRCHR0(.FALSE., CENTER, ORIENT, ABSXY, X0, Y0, STRING)
      RETURN
      END

C*GRGENV -- get value of PGPLOT environment parameter (MAC)
C+
      SUBROUTINE GRGENV(NAME, VALUE, L)
      CHARACTER*(*) NAME, VALUE
      INTEGER L
C
C Return the value of a PGPLOT environment parameter. In Sun/Convex-UNIX,
C environment parameters are UNIX environment variables; e.g. parameter
C ENVOPT is environment variable PGPLOT_ENVOPT. Translation is not
C recursive and is case-sensitive.
C
C Arguments:
C  NAME   : (input) the name of the parameter to evaluate.
C  VALUE  : receives the value of the parameter, truncated or extended
C           with blanks as necessary. If the parameter is undefined,
C           a blank string is returned.
C  L      : receives the number of characters in VALUE, excluding
C           trailing blanks. If the parameter is undefined, zero is
C           returned.
C
C On Macintosh, the environment variables are stored in file.  This subroutine
C first looks for the file PGPLOTENVNAMES, in the application directory.
C If it can't be found, a standard file dialog box will be displayed,
C so that you can find the file.  Once it is found, the name and location are 
C stored so that you will not be prompted again.  
C-- 
C 19-Jan-1988
C 25-Sep-1995  Modified to work on mac with MPW Fortran 2.1.  All environment 
C              parameters are stored in the file.  The file can have any name 
C              but best thing to do is to put a file called pgplotenvnames
C              in the application directory. See Tech. Note 35 for more information
C              about Macintosh file system.  Note: this subroutine
C              needs to be compiled with the -u switch to initialize volrefnum 
C              to zero, since a value less than zero specifies a folder.
C-----------------------------------------------------------------------       
      INTEGER LIN, LUN,LStart,VolRefNum, JVRefNum
      CHARACTER*32 TEST, Line*120, FilNam*120
	  External JVRefNum
	  Save FileName,VolRefNum
	  
C
      TEST = 'PGPLOT_'//NAME
      LIN = INDEX(TEST, ' ')-1
	  Value = ' '
	  L = 0
	  Call GrgLun(LUN)

C  If volume reference number has been set, switch to that volume.  The
C  first time grgenv is called, volrefnum will not be set and the current
C  directory is the application directory.  The volume reference number will
C  be set after pgplotenvnames is found.
	  If (VolRefNum .lt. 0) Then
	     Call  F_SETVOLUME(VolRefNum)
	  End If

C  Try to open FilNam.  The first time that Grgenv is called Filnam will
C  be empty and the open will fail.  So try to open pgplotenvnames in the
C  current directory.  If that fails put up a standard file dialog box to
C  find pgplotenvnames.  If FilNam has been set then after assigning a 
C  unit number to the file reset the volume reference number to the application
C  directory.  
	  Open(Unit = lun,File=FilNam,Status='OLD',Err = 10,Readonly)
	  Call F_SETVOLUME(JVREFNUM(-1))
	  Go to 1
	  
10    Open(Unit = lun,File='pgplotenvnames',Status='OLD',Err = 20,Readonly)
      FilNam = 'pgplotenvnames'
	  VolRefNum = JVREFNUM(Lun)
      Go to 1

C Put up standard file dialog box.  Once found store the file name and volume
C reference number.
20    CALL GRWARN('Could not find file PGPLOTENVNAMES in current directory.')
      CALL GRWARN('A dialog box will come up allowing you to find the file with the')
      CALL GRWARN('environment variables. Hit return for the dialog box to appear.')
      Pause
      Open(Unit=lun,File=*,STATUS='OLD',err=100,Readonly)
      Inquire(Unit=LUN,Name=FilNam)
	  VolRefNum = JVREFNUM(Lun)

C File has been found, so search for environmental variable and extract value.
1     Continue
	     Read(Lun,'(A512)',End=2) Line 
	     If (Test(:Lin) .EQ. Line(:Lin)) Then
	        Lstart = index(Line,"'")+1
	        L = index(Line(Lstart:),"'")-1
	        Value = Line(LStart:LStart+L-1)
			Close(Lun)
	        Go to 2
	     End If
	  Go to 1
2     Close(LUN)
      Return
	     

C     Could not find PGPLOTENVNAMES.
100   Close(LUN)
      CALL GRWARN('Cancelled dialog box to find PGPLOTENVNAMES')
      Return
      END

C*GRQLW -- inquire current line width
C+
      SUBROUTINE GRQLW (IWIDTH)
      INTEGER  IWIDTH
C
C GRPCKG: obtain the line-width of the current graphics device.
C
C Argument:
C  IWIDTH (output): receives the current line-width.
C--
C (1-Feb-1983)
C-----------------------------------------------------------------------
      INCLUDE 'grpckg1.inc'
C
      IF (GRCIDE.LT.1) THEN
          CALL GRWARN('GRQLW - no graphics device is active.')
          IWIDTH = 1
      ELSE
          IWIDTH = ABS(GRWIDT(GRCIDE))
      END IF
      END

#!/bin/csh
#
# Move BoundingBox statement in PostScript files from epilogue to
# prologue. This is useful for use with some applications which don't
# fully implement the Adobe DSC for Encapsulated PostScript (eg. they
# don't support a deferred bounding box specification using
# %%BoundingBox: (atend)
#
# Version 1.0: RGW 12-Apr-1994
# Version 1.1: RGW 29-Jan-1995
#
# Usage: pscaps <list of files>
#
#
set version="1.1"
set tmpfile=pscaps.tempfile
unalias mv
echo "PSCaps Version $version (rgw 29-Jan-1995)"
foreach file ($*)
  if ( -e $file ) then
    echo "Processing file $file..."
    set truebox=`fgrep '%%BoundingBox:' $file|fgrep -v atend`
    set atline=`fgrep -n '%%BoundingBox: (atend)' $file|awk -F':' '{print $1}'`
    if ($atline == "" ) then
      echo "File '$file' does not contain %%BoundingBox: (atend) construct"
      echo "Not a PGPLOT file, or already pscaps'ed"
    else
      @ prologue = $atline - 1
      @ restoffile = $atline + 1
      head -$prologue $file >! $tmpfile
      echo $truebox >> $tmpfile
      tail +${restoffile}l $file >> $tmpfile
      mv $tmpfile $file
    endif
  else
    echo "File '$file' does not exist"
  endif
end
exit

#!/bin/awk -f

BEGIN {
  printf("C*GREXEC -- PGPLOT device handler dispatch routine\n");
  printf("C+\n");
  printf("      SUBROUTINE GREXEC(IDEV,IFUNC,RBUF,NBUF,CHR,LCHR)\n");
  printf("      INTEGER IDEV, IFUNC, NBUF, LCHR\n");
  printf("      REAL    RBUF(*)\n");
  printf("      CHARACTER*(*) CHR\n");
  printf("C---\n");
  printf("      INTEGER NDEV\n");
}

/^[^!]/ {
  drivpos = index($1,"DRIV");
  if(drivpos > 0) {
    ndev++;
    driver[ndev] = substr($1,1,drivpos-1);
    mode[ndev] = $2;
  }
}

END {
  printf("      PARAMETER (NDEV=%d)\n", ndev);
  printf("      CHARACTER*10 MSG\n");
  printf("C---\n");
  printf("      GOTO(");
  for(i=1; i<=ndev; i++) {
    if(i%15 == 0)
      printf("\n     +     ");
    printf("%d", i);
    if(i<ndev)
      printf(",");
  };
  printf(") IDEV\n");
  printf("      IF (IDEV.EQ.0) THEN\n");
  printf("          RBUF(1) = NDEV\n");
  printf("          NBUF = 1\n");
  printf("      ELSE\n");
  printf("          WRITE (MSG,'(I10)') IDEV\n");
  printf("          CALL GRWARN('Unknown device code in GREXEC: '//MSG)\n");
  printf("      END IF\n");
  printf("      RETURN\n");
  printf("C---\n");
  for(i=1; i<=ndev; i++) {
    printf("%-5d CALL %sDRIV(IFUNC,RBUF,NBUF,CHR,LCHR", i, driver[i]);
    if(mode[i] != 0)
      printf(",%d)\n", mode[i]);
    else
      printf(")\n");
    printf("      RETURN\n");
  };
  printf("C\n");
  printf("      END\n");
}

#!/bin/sh

# Create a dummy C file.

echo 'int main() {return 0;}' > dummy.c

# Compile and link the dummy file with verbose mode turned on and
# capture -L* library paths.

gcc -v -o dummy dummy.c 2>&1 | tr ' ' '\012' | egrep '^-L'

\rm -f dummy dummy.o dummy.c
